﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Collections.Generic;
using KSProgram.Exceptions;
using KSProgram.Security;
using System.Text.RegularExpressions;
using KSProgram.Personal;
using System.Web.UI.HtmlControls;

namespace KSPortal.Controls
{
    public partial class DanProhl_KS_2021 : UserControlPozadavek
    {
        public override string Typ
        {
            get { return "danprohl"; }
        }

        private List<string> _povinnePrilohy = new List<string>();
        //private List<string> _povinnePrilohyStr2 = new List<string>();
        private bool _manzelkaBylaVyplnena
        {
            set
            {
                ViewState["manzelkaBylaVyplnena"] = value;
            }
            get
            {
                object o = ViewState["manzelkaBylaVyplnena"];
                if (o == null)
                    return false;
                else
                    return (bool)o;
            }
        }
        protected FormViewMode FakeMode
        {
            get
            {
                object o = ViewState["FakeMode"];
                if (o == null)
                    return FormViewMode.ReadOnly;
                else
                    return (FormViewMode)o;
            }
            set
            {
                ViewState["FakeMode"] = value;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            RadWindowManager mng = Page.Master.FindControl("RadWindowManager1") as RadWindowManager;
            mng.Localization.OK = ReadGlobalResource.ZmenaTextu("[%Ano%]");
            mng.Localization.Cancel = ReadGlobalResource.ZmenaTextu("[%Zrušit%]");
        }

        protected void Page_PreRender()
        {
            RadRadioButtonList H_vyz_jin_popl = (RadRadioButtonList)FormView1.FindControl("H_vyz_jin_popl");
            TextBox H_vyz_jin_upl_file = (TextBox)FormView1.FindControl("H_vyz_jin_upl_file");
            H_vyz_jin_upl_file.Style[HtmlTextWriterStyle.Display] = H_vyz_jin_popl.SelectedValue == "X" ? "normal" : "none";// Visible = H_vyz_jin_popl.SelectedValue == "X";
            HtmlInputButton B_vyz_jin_upl = (HtmlInputButton)FormView1.FindControl("B_vyz_jin_upl");
            B_vyz_jin_upl.Style[HtmlTextWriterStyle.Display] = H_vyz_jin_popl.SelectedValue == "X" ? "normal" : "none";//Visible = H_vyz_jin_popl.SelectedValue == "X";

            //PR 03.01.2022 Schovat tabulku pro uložení a změnu stavu, musí nejdříve kliknout na tlačítko "Přejít k podpisu"  
            //Control c = WebControlHelper.FindControl(Page, "UC_ZmenaStavu");
            //c.Visible = false;
            //c = WebControlHelper.FindControl(Page, "PanelCommand");
            //c.Visible = false;
            //nefungovalo v 1. kroku, kdy to prenastavi PozadavekDetail.Nacist, dano primo do pozadavekDetail.Nacist
        }

        public ObjectDataSource ObjectDataSource1
        {
            get { return (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1"); }
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            //ObjectDataSource ObjectDataSource1 = (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1");
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();

            if (val == "insert" || val == "edit")
            {
                if (PozId == 0)
                    FakeMode = FormViewMode.Insert;//FormView1.ChangeMode(FormViewMode.Insert);
                else
                    FakeMode = FormViewMode.Edit;//FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
                FakeMode = FormViewMode.ReadOnly;//FormView1.ChangeMode(FormViewMode.ReadOnly);


            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

            //PR 04.05.2020 nastavení proměnné, říkající, zda před změnou byla manželka vyplněna. (pokud byla, tak již její údaje nelze přepisovat)
            if (zmeny)
                _manzelkaBylaVyplnena = !string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_jmeno"));
            else
                _manzelkaBylaVyplnena = false;

            //PR 12.12.2018 kód přesunut do následující funkce
            NastavEditovatelnostKontrolek(wf);

            if (FakeMode != FormViewMode.ReadOnly)
            {
                RadDropDownList DDL_manzelka = (RadDropDownList)FormView1.FindControl("DDL_manzelka");
                //if (zmeny)
                if (zmeny && _manzelkaBylaVyplnena) //PR 04.05.2020 
                    DDL_manzelka.Visible = false; //PR 22.11.2019 musí zadat nové prohlášení
                else
                {
                    ODS_manzelky.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_manzelky.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();
                    DDL_manzelka.DataSourceID = "ODS_manzelky";
                    DDL_manzelka.DataBind();
                    //DDL_manzelka.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_rc");
                    DDL_manzelka.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_id");//PR 10.12.2021 
                }
            }

            if (PozId == 0 || wf.FazePosl == 0)
            {
                Page.Validate(ValidPre.ValidationGroup);
            }
        }

        private void NastavEditovatelnostKontrolek(WorkflowMaster wf)
        {
            if (wf == null)
                wf = new WorkflowMaster(PozId, "danprohl", null);
            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";

            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne_prohlaseni = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";
            //PR 27.09.2019 u dodatečného prohlášení nelze dělat změny, u změn dětí chybí sloupce "dodatečně za kalendářní měsíce"
            if (dodatecne_prohlaseni)
                zmeny = false;

            DataTable dtsloupce = Pozadavekdanprohl.GetDataTable();
            foreach (DataColumn dc in dtsloupce.Columns)
            {
                string col = dc.ColumnName;
                bool disabled = (FakeMode == FormViewMode.ReadOnly)
                        // "pro zdaňovací období" a "Prohlášení k dani činím / dodatečně činím" //PR 26.09.2019
                        || (zmeny && (col == "H_obd_mes" || col == "H_obd_rok" || col == "H_dod_priz"))
                        //----------------------------------------------
                        // Plátce - zaměstnavatel
                        //----------------------------------------------
                        || col == "H_nazev_pl"
                        || col == "H_obec_pl"
                        || col == "H_ulice_pl"
                        || col == "H_c_pop_pl"
                        || col == "H_c_orient_pl"
                        || col == "H_psc_pl"
                        //----------------------------------------------
                        // Identifikace poplatníka
                        //----------------------------------------------
                        || col == "H_prijmeni_pop"
                        || col == "H_jmeno_pop"
                        || col == "H_rc_pop"
                        || col == "H_obec_pop"
                        || col == "H_ulice_pop"
                        || col == "H_c_pop_pop"
                        || col == "H_c_orient_pop"
                        || col == "H_psc_pop"
                        //----------------------------------------------
                        // Daňový nerezident
                        //----------------------------------------------
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                            (col == "H_datNar_pop"
                            || col == "H_c_pasu_pop"
                            || col == "H_typ_dokl_pop"
                            || col == "H_stat_pop"
                            || col == "H_cis_dident"
                            || col == "H_typ_dident"
                            || col == "H_stat_dident")
                           )
                        //----------------------------------------------                        
                        // Slevy 
                        //----------------------------------------------
                        //PR 17.09.2019 needitace pokud je režim změn (konce a začátek slev je nyní ve změnové části(druh změny jako číselník))
                        || (zmeny && col.StartsWith("H_upl_"))
                        /*dodatečně uplatněné slevy za měsíce*/
                        || ((dodatecne_prohlaseni == false) && (col.StartsWith("H_upl_")) && (col.EndsWith("_mes")))
                        //----------------------------------------------
                        // Zvýhodnění
                        //----------------------------------------------
                        /*Dodatečně uplatňuji daňové zvýhodnění*/
                        || ((dodatecne_prohlaseni == false) && (col == "H_dod_upl"))
                        /*Děti - zvýhodnění - uzamknuto pokud je režim změn*/
                        || (zmeny && col.StartsWith("D"))
                        /*dodatečně uplatněné zvýhodnění u dětí za měsíce*/
                        || ((dodatecne_prohlaseni == false) && (col.StartsWith("D")) && (col.EndsWith("_mes")))
                        //PR 11.12.2018 HID=44351 needitace osobních údajů dětí
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                                ((col.StartsWith("D") || col.StartsWith("X")) && (col.EndsWith("_jmeno") || col.EndsWith("_prijmeni") || col.EndsWith("_rc")))
                           )
                        //----------------------------------------------
                        // Manželka
                        //----------------------------------------------
                        //PR 11.12.2018 HID=44351 needitace osobních údajů manželky
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                            (col == "H_vyz_jin_jmeno"
                            || col == "H_vyz_jin_prijmeni"
                            || col == "H_vyz_jin_rc"
                            || col == "H_obec_vyz_jin"
                            || col == "H_ulice_vyz_jin"
                            || col == "H_c_pop_vyz_jin"
                            || col == "H_c_orient_vyz_jin"
                            || col == "H_psc_vyz_jin")
                           )
                        // needitace všech údajů manželky, pokud je režim změn
                        //|| (zmeny && col.Contains("_vyz_jin"))
                        //PR 04.05.2020 HID=51253 - možnost vyplnit bod c při změnách, pokud dříve zvýhodnění neuplatňoval a nyní uplatňuje.
                        || (zmeny && col.Contains("_vyz_jin") && _manzelkaBylaVyplnena)
                        //----------------------------------------------
                        // Změnová část - uzamknuta pokud není režim změn
                        //----------------------------------------------
                        || (!zmeny && (col.StartsWith("X") || col.StartsWith("Z")))
                        ;

                Control c = FormView1.FindControl(col);
                if (c == null) continue;
                if (c is TextBox)
                    (c as TextBox).Enabled = !disabled; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                else if (c is CheckBox)
                    (c as CheckBox).Enabled = !disabled;
                else if (c is RadDropDownList)
                    (c as RadDropDownList).Enabled = !disabled;
            }
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FakeMode != FormViewMode.ReadOnly)
                    {
                        if (FakeMode == FormViewMode.Insert)
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            //ObjectDataSource ObjectDataSource1 = (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1");
                            int id_poz = 0;
                            decimal adresat = 0;
                            try
                            {
                                adresat = Convert.ToDecimal(ObjectDataSource1.InsertParameters["adresat"].DefaultValue);
                            }
                            catch (FormatException) { }
                            string novy_stav = ObjectDataSource1.InsertParameters["novy_stav"].DefaultValue;
                            string duvod = ObjectDataSource1.InsertParameters["duvod"].DefaultValue;
                            Pozadavekdanprohl.Insert(ref id_poz, Vydavatel, adresat, novy_stav, duvod, values);
                            PozId = id_poz;
                            OnItemInserted(new EventArgs());
                        }
                        else
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            if (values.Count == 0) //PR 02.02.2021 
                            {
                                is_valid = false;
                                throw new NoticeException("Nepodařilo se získat data z formuláře!");
                            }
                            Pozadavekdanprohl.Update(PozId, values);
                            OnItemUpdated(new EventArgs());
                        }

                    }
                }
            }
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());

        }

        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }

        //přesunuto do ZadostOdanprohl.ascx.cs
        //protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        //{
        //    PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        //}

        public override void ChangeMode(FormViewMode mode)
        {
            //FormView1.ChangeMode(mode);
            FakeMode = mode;
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FakeMode;//FormView1.CurrentMode;
            }
        }

        protected void ValidPre_ServerValidate(object source, ServerValidateEventArgs args)
        {
            ValidPre.ErrorMessage = "";
            if (FakeMode == FormViewMode.ReadOnly) return;

            int? H_obd_rok = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_rok");
            int? H_obd_mes = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_mes");

            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";

            //PR 08.02.2021 HID=54589 uživatel s nástupem až v novém roce, si zadal dodatečné prohlášení a následně i žádost o RZ.
            if (H_obd_rok != null)
            {
                int mes = 1;
                if (H_obd_mes != null) mes = H_obd_mes.Value;
                //DateTime platiOd = new DateTime(H_obd_rok.Value, H_obd_mes.Value, 1);
                DateTime platiOd = new DateTime(H_obd_rok.Value, mes, 1);//PR 01.03.2021 null u nově nastoupivších
                DateTime datNast; DateTime? datVyst;
                Pracovnik.GetDatumNastupVystup(Vydavatel, out datNast, out datVyst);
                if (datNast.PrvniDen() > platiOd)
                {
                    //může to být opakovaná evidence, kdy přepsali datum nástupu
                    //a zároveň může podávat dodatečné prohlášení za minulý rok, takže ještě zkontroluji, zda neměl PP
                    List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, platiOd, platiOd.PosledniDen());
                    if (pomery.Count == 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", platiOd.ToString("MM/yyyy")) + "<br/>";
                    }
                }
                else if (datVyst.HasValue && datVyst.Value < platiOd)
                {
                    //V případě, že by při opakovaném nástupu měli kvůli něčemu ještě původní datumy v evidenci, zkontroluji i PP
                    List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, platiOd, platiOd.PosledniDen());
                    if (pomery.Count == 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", platiOd.ToString("MM/yyyy")) + "<br/>";
                    }
                }
            }

            if (PozId == 0)
            {
                if (H_obd_rok != null && H_obd_mes != null)
                {
                    //nepodal již prohlášení na stejný rok a období? Stornované je ignorováno.
                    int idP = Pozadavekdanprohl.ExistujeSeStejnouPlatnosti(Vydavatel, H_obd_rok.Value, H_obd_mes.Value);
                    if (idP > 0)
                    {
                        //PR 14.01.2021 HID=54325 pokud je prohlášení dodatečné, tak nevadí, že má podané běžné prohlášení
                        if (!(dodatecne && !Pozadavekdanprohl.JeDodatecne(idP)))
                            ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Prohlášení s platností od měsíce {0} již máte podané, nové nelze podat!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit prohlášení k opravě!%]<br/>", H_obd_mes + "/" + H_obd_rok);
                    }
                    idP = Pozadavekdanprohl.ExistujeNeuzavrenyProRok(Vydavatel, H_obd_rok.Value);
                    if (idP > 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Prohlášení pro rok {0} již máte podané, nové nelze podat, dokud nebude existující schváleno nebo zamítnuto!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit prohlášení k opravě!%]<br/>", H_obd_rok);
                    }
                }
            }

            if (ValidPre.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPre.Text = ValidPre.ErrorMessage;
            }
        }

        protected void ValidPg1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator Valid1 = (CustomValidator)FormView1.FindControl("ValidPg1");
            Valid1.ErrorMessage = "";
            Valid1.Text = "";

            CustomValidator Val_obdobi = (CustomValidator)FormView1.FindControl("Val_obdobi");
            Val_obdobi.ErrorMessage = "";
            Val_obdobi.Text = "";

            CustomValidator Val_slevy = (CustomValidator)FormView1.FindControl("Val_slevy");
            Val_slevy.ErrorMessage = "";
            Val_slevy.Text = "";

            CustomValidator Val_deti = (CustomValidator)FormView1.FindControl("Val_deti");
            Val_deti.ErrorMessage = "";
            Val_deti.Text = "";

            CustomValidator Val_manzelka = (CustomValidator)FormView1.FindControl("Val_manzelka");
            Val_manzelka.ErrorMessage = "";
            Val_manzelka.Text = "";

            
            _povinnePrilohy.Clear();//PR 09.12.2019 kontrola počtu příloh
            if (FakeMode == FormViewMode.ReadOnly) return;

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            
            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            ////PR 08.12.2021 z H_dod_priz udelan radiobutton s hodnotami "-" pro aktalni rok, "XD" - dodatecne za minuly rok
            //if (string.IsNullOrEmpty(H_dod_priz))
            //{
            //    Val_obdobi.ErrorMessage += "[%Zdaňovací období%] - [%pro aktuální rok/dodatečně pro minulý rok%] - [%Není vyplněna povinná položka%]<br/>";
            //}
            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";
            
            
            string H_obd_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_mes");
            if (string.IsNullOrEmpty(H_obd_mes))
                Val_obdobi.ErrorMessage += "[%Zdaňovací období%] - [%měsíc%] - [%Není vyplněna povinná položka%]<br/>";
            string H_obd_rok = "";
            try
            {
                H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok", true, "Zdaňovací období - rok", "^(20[12][0-9])$");
            }
            catch (NoticeException ex1)
            { Val_obdobi.ErrorMessage += ex1.Message + "<br/>"; }

            //---------------------------------------------------------------------------------------------------
            DateTime ld_AktObdobi = ViceIco.ObdobiPodnikuPodleZamestnance(Vydavatel);//PR 14.01.2020 HID=49553

            //if (H_obd_rok != DateTime.Today.Year.ToString())
            if (!string.IsNullOrEmpty(H_obd_rok))//PR 09.11.2018 //PR 08.12.2021 
            {
                if (dodatecne)
                {
                    if (H_obd_rok == (ld_AktObdobi.Year - 1).ToString() && ld_AktObdobi.Month > 3)
                        Val_obdobi.ErrorMessage += "[%Dodatečné prohlášení za minulý rok lze podat pouze v období leden až březen%]<br/>";
                    else if (H_obd_rok != (ld_AktObdobi.Year - 1).ToString())
                        Val_obdobi.ErrorMessage += "[%Dodatečné prohlášení lze podat pouze za minulý rok%]<br/>";
                }
                else if (H_obd_rok != ld_AktObdobi.Year.ToString())
                    Val_obdobi.ErrorMessage += "[%Zdaňovací období%] - [%rok%] - [%Běžné (nedodatečné) prohlášení lze podat pouze pro aktuální rok%]<br/>";
            }

            DateTime platiOd = new DateTime(DateTime.Today.Year, 1, 1);
            if (!string.IsNullOrEmpty(H_obd_rok) && !string.IsNullOrEmpty(H_obd_mes))
                platiOd = new DateTime(int.Parse(H_obd_rok), int.Parse(H_obd_mes), 1);
            else if (!string.IsNullOrEmpty(H_obd_rok))
                platiOd = new DateTime(int.Parse(H_obd_rok), 1, 1);

            string rc_pop = WebControlHelper.SubCtrlGetValueString(FormView1, "H_rc_pop");
            int vek_pop = 0;
            if (!string.IsNullOrEmpty(rc_pop))
                vek_pop = F_RodneCislo.Vek(rc_pop, platiOd);

            //H_datNar_pop vyplňuje pouze daňový nerezident
            //try
            //{
            //    DateTime? H_datNar_pop = WebControlHelper.SubCtrlGetValueDate(FormView1, "H_datNar_pop", true, "Datum narození");
            //}
            //catch (NoticeException ex1)
            //{ ValidPg1.ErrorMessage = ex1.Message; }

            //------------------
            //SLEVY
            //------------------

            string H_upl_sleva = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_sleva");
            //string H_upl_sleva_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_sleva_mes"); //položka neexistuje
            //PR 03.09.2019 HID=47474 ...jestli zaměstnanec skutečně nechce uplatňovat základní slevu?
            if (string.IsNullOrEmpty(H_upl_sleva) && WebControlHelper.SubCtrlGetValueString(FormView1, "HF_sleva_opravdu_ne") == "0")
            {
                Val_slevy.ErrorMessage += "[%Základní sleva na poplatníka%] - [%Opravdu neuplatňujete základní slevu na poplatníka?%]<br/>";
                //V Page_Load mám přenastavené názvy tlačítek
                MessageBox.Confirm(this.Page, ReadGlobalResource.ZmenaTextu("[%Opravdu neuplatňujete základní slevu na poplatníka?%]"), ReadGlobalResource.ZmenaTextu("[%Dotaz%]"), null, null, "confirm_upl_sleva_ne");
            }

            string H_upl_inv = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv").ToUpper();//x-I.st., X-II.st.
            if (H_upl_inv.StartsWith("X"))
            {
                string H_upl_inv_stupen = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_stupen");
                if (string.IsNullOrEmpty(H_upl_inv_stupen))
                    Val_slevy.ErrorMessage += "[%Základní sleva na invaliditu%] - [%stupeň%] - [%Není vyplněna povinná položka%]<br/>";
                else if (H_upl_inv_stupen == "x")
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_upl_inv", H_upl_inv.ToLower());
                else //if (H_upl_inv_stupen == "X")
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_upl_inv", H_upl_inv.ToUpper());
            }

            string H_upl_inv_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_mes");

            
            string H_upl_inv_roz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_roz");
            string H_upl_inv_roz_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_roz_mes");

            string H_upl_inv_ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_ztp");
            string H_upl_inv_ztp_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_ztp_mes");

            string H_upl_stud = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_stud");
            string H_upl_stud_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_stud_mes");

            if (!dodatecne && (H_upl_sleva == "XD" || H_upl_inv == "XD" || H_upl_inv_roz == "XD" || H_upl_inv_ztp == "XD" || H_upl_stud == "XD"))
            {
                Val_slevy.ErrorMessage += "[%Slevy - Dodatečné uplatnění u slev lze použít pouze pokud činíte prohlášení dodatečně%]<br/>";
            }

            //TODO: Daňový nerezident ČR může měsíčně u zaměstnavatele uplatňovat pouze slevu na poplatníka a slevu na studenta.
            if (!string.IsNullOrEmpty(H_upl_inv) )
            {
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_file")))
                    _povinnePrilohy.Add("- potvrzení o rozhodnutí z správy sociálního zabezpečení nebo doklad o výplatě invalidního důchodu - složenka nebo výpis z účtu");
            }
            if (!string.IsNullOrEmpty(H_upl_inv_roz))
            {
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_roz_file")))
                    _povinnePrilohy.Add("- potvrzení o rozhodnutí z správy sociálního zabezpečení nebo doklad o výplatě invalidního důchodu - složenka nebo výpis z účtu");
            }

            if (!string.IsNullOrEmpty(H_upl_inv_ztp))
            {
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_ztp_file")))
                    _povinnePrilohy.Add("- kopie průkazu ZTP/P");
            }
            if (!string.IsNullOrEmpty(H_upl_stud))
            {
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_stud_file")))
                    _povinnePrilohy.Add("- potvrzení vysoké školy o zapsání ke studiu");
                if (vek_pop >= 28)
                    Val_slevy.ErrorMessage += "[%Slevu na studenta lze uplatňovat pouze do 28 let věku%]<br/>";
            }
                        
            if (!dodatecne && (H_upl_inv_mes != "" || H_upl_inv_roz_mes != "" || H_upl_inv_ztp_mes != "" || H_upl_stud_mes != ""))
            {
                Val_slevy.ErrorMessage += "[%Měsíce je možno vyplnit u slev pouze pokud činíte prohlášení dodatečně%]<br/>";
            }
            if (dodatecne)
            {
                if (!string.IsNullOrEmpty(H_upl_inv) && string.IsNullOrEmpty(H_upl_inv_mes))
                    Val_slevy.ErrorMessage += "[%Základní sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                if (!string.IsNullOrEmpty(H_upl_inv_roz) && string.IsNullOrEmpty(H_upl_inv_roz_mes))
                    Val_slevy.ErrorMessage += "[%Rozšířená sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                if (!string.IsNullOrEmpty(H_upl_inv_ztp) && string.IsNullOrEmpty(H_upl_inv_ztp_mes))
                    Val_slevy.ErrorMessage += "[%Sleva na držitele průkazu ZTP/P%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                if (!string.IsNullOrEmpty(H_upl_stud) && string.IsNullOrEmpty(H_upl_stud_mes))
                    Val_slevy.ErrorMessage += "[%Sleva na studenta%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
            }
            //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
            string parseError;
            if (!string.IsNullOrEmpty(H_upl_inv_mes))
            {
                if (new MesiceRozsah(H_upl_inv_mes).IsValid(out parseError) == false)
                    Val_slevy.ErrorMessage += "[%Základní sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
            }
            if (!string.IsNullOrEmpty(H_upl_inv_roz_mes))
            {
                if (new MesiceRozsah(H_upl_inv_roz_mes).IsValid(out parseError) == false)
                    Val_slevy.ErrorMessage += "[%Rozšířená sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
            }
            if (!string.IsNullOrEmpty(H_upl_inv_ztp_mes))
            {
                if (new MesiceRozsah(H_upl_inv_ztp_mes).IsValid(out parseError) == false)
                    Val_slevy.ErrorMessage += "[%Sleva na držitele průkazu ZTP/P%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
            }
            if (!string.IsNullOrEmpty(H_upl_stud_mes))
            {
                if (new MesiceRozsah(H_upl_stud_mes).IsValid(out parseError) == false)
                    Val_slevy.ErrorMessage += "[%Sleva na studenta%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
            }

            //Děti - daňové zvýhodnění
            string H_dod_upl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_upl");
            //PR 08.12.2021 z H_dod_upl jsem udelal RadioButtonList: "-"=Neuplatnuji, "X"-Uplatnuji, "XD"-uplatnuji dodatecne
            if (string.IsNullOrEmpty(H_dod_upl))
                Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Označte jednu z voleb%]: [%Neuplatňuji%], [%Uplatňuji%], [%Dodatečně uplatňuji%]<br/>";
            if (!dodatecne && (H_dod_upl == "XD"))
            {
                Val_deti.ErrorMessage += "[%Dodatečné uplatnění daňového zvýhodnění je možno použít pouze pokud činíte prohlášení dodatečně%]<br/>";
            }
            int dodat_zvyh_count = 0;

            for (int i = 1; i <= 5; i++)
            {
                string jm = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_jmeno");
                string pr = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_prijmeni");
                string rcOrDatNar = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_rc");

                if (jm != "" || pr != "" || rcOrDatNar != "")
                {
                    //PR 27.05.2020 HID=51345 dětem bez RČ i dat. nar. se nepočítá sleva, v protokolu výpočtu je chybně uvedeno, že přesáhl věkovou hranici
                    //if (rcOrDatNar == "") Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Rodné číslo%] - [%řádek%] " + i + "- [%Není vyplněna povinná položka%] - [%Doplňte RČ dítěte přes požadavek na změnu osobních údajů%]<br/>";
                    //PR 09.05.2022
                    if (rcOrDatNar == "")
                    { 
                        Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Rodné číslo%] - [%řádek%] " + i + "- [%Není vyplněna povinná položka%] - [%Doplňte RČ dítěte přes požadavek na změnu osobních údajů%] ([%u cizince zadejte aspoň datum narození%)<br/>";
                        continue;
                    }
                    //PR 04.05.2022 zkontroluji, zda dítě s daným RČ nezmizelo z databáze, jinak se pri zapsat ukončí sleva dětem, které systém nenalezl.
                    //              použita stejná funkce jako v Pozadavekdanprohl.zapsat(), aby byla jistota, že to funguje jednotně.
                    int? id_rod_prisl;
                    int vek_d;
                    DateTime? dn_d;
                    string rc;
                    id_rod_prisl = Pozadavekdanprohl.NajdiDite(Vydavatel, rcOrDatNar, jm, out rc, out dn_d);
                    if (id_rod_prisl == null)
                    {
                        if (rcOrDatNar.Contains(".")) //PR 06.05.2022 v položce je datum, protože se jedná o cizince bez RČ (doposud museli zadávat fiktivní RČ)
                            Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Dítě s daným datem narození nebylo nalezeno v evidenci%]<br/>";
                        else
                            Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Dítě s daným RČ nebylo nalezeno v evidenci%]<br/>";
                        continue;
                    }
                    if (dn_d == null)
                    {
                        Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%řádek%] " + i + " - [%Dítě nemá zadáno datum narození v evidenci%]<br/>";
                        continue;
                    }
                    vek_d = F_DateTime.YearsAfter(dn_d.Value, platiOd);


                    string por = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_upl_por");
                    if (por == "") Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Uplatňuji/neuplatňuji nárok ve výši na%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                    string ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_ztp");
                    if (por == "N" && ztp == "1")
                        Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%ZTP/P%] - [%řádek%] " + i + " - [%Položka může být vyplněna pouze u uplatňovaných dětí%]<br/>";
                    string zl = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_zletile");
                    if (por == "N" && zl == "1")
                        Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Zletilé dítě%] - [%řádek%] " + i + " - [%Položka může být vyplněna pouze u uplatňovaných dětí%]<br/>";
                    //Dodatečně za kalendářní měsíce
                    string mes = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_dod_mes");
                    if (!dodatecne && !string.IsNullOrEmpty(mes))
                        Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Položka se vyplňuje pouze u dodatečného prohlášení%]<br/>";
                    //PR 02.02.2021 zapoznámkováno, u některých dětí mohl již uplatňovat během roku, budu kontrolovat, zda vyplnil aspoň u jednoho
                    //if (dodatecne)
                    //    if (por == "1" || por == "2" || por == "3")
                    //        if (string.IsNullOrEmpty(mes))
                    //            ValidPg1.ErrorMessage += "[%Daňové zvýhodnění%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                    if (dodatecne)
                        if (por == "1" || por == "2" || por == "3")
                            if (!string.IsNullOrEmpty(mes))
                                dodat_zvyh_count++;
                    //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
                    if (!string.IsNullOrEmpty(mes))
                    {
                        if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                            Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Neplatný formát%] (" + parseError + ")<br/>";
                    }
                    if (por == "1" || por == "2" || por == "3")
                    {
                        if (dn_d >= platiOd && dn_d <= new DateTime(platiOd.Year, 12, 31))
                        {
                            if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "D"+ i + "_file")))
                                _povinnePrilohy.Add("- kopii rodného listu dítěte s RČ " + rc);
                        }
                        else if (vek_d >= 18)
                        {
                            //PR 04.01.2021 HID=54129 Když bude platné daňové zvýhodnění u dítěte v rodinných příslušnících C/S aplikace, 
                            //tak nevyžadovat přílohu s potvrzením o studiu dítěte.
                            bool vyzadovat = true;
                            //PotvrzOStudDitete - Vyžadovat přílohu s potvrzením o studiu dítěte: 
                            //v - vždy, 
                            //p - nevyžadovat u dítěte s platným zvýhodněním v rodinných příslušnících, 
                            //m - nevyžadovat u dítěte s platným zvýhodněním se začátkem max. měsíc před platností prohlášení
                            string par = Parametry.ParametrCti("PotvrzOStudDitete");
                            if (par != "v")
                            {
                                StrRodPrislSleva slevaOld = KSProgram.Personal.RodPrisl.SlevaNacti(id_rod_prisl.Value, platiOd);
                                if (slevaOld.sleva != null && (slevaOld.sleva == "a" || slevaOld.sleva == "z"))
                                {
                                    if (par == "p")
                                    {
                                        vyzadovat = false;
                                    }
                                    else if (par == "m")
                                    {
                                        if (slevaOld.sleva_od != null && slevaOld.sleva_od >= platiOd.AddMonths(-1))
                                            vyzadovat = false;
                                    }
                                }
                            }
                            if (vyzadovat)
                            {
                                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_file")))
                                    _povinnePrilohy.Add("- potvrzení o studiu dítěte s RČ " + rc);
                            }
                        }
                        //PR 09.10.2020 přinutím je to zatrhnout, jinak akce zapsat slevu ukonci k 18. narozeninam.
                        if (vek_d >= 18 && zl != "1")
                        {
                            Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Zletilé dítě%] - [%řádek%] " + i + " - [%Zatrhněte, zároveň tím potvrzujete, že dítěti není přiznán invalidní důchod 3. stupně a že se soustavně připravuje na budoucí povolání!%]<br/>";
                        }
                    }
                }
            }//end for
            if (dodatecne && H_dod_upl == "XD" && dodat_zvyh_count == 0)
                Val_deti.ErrorMessage += "[%Daňové zvýhodnění na děti%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněno ani u 1 dítěte%]<br/>";

            //----------------
            //Osoby ... (manželka)
            //----------------
            //PR 09.01.2019 pokud neuplatnuje na zadne dite zvyhodneni, tak nemusi byt vyplneno c) ani tabulka
            bool uplatnuje_deti = false;
            for (int i = 1; i <= 5; i++)
            {
                string por = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_upl_por");
                if (!string.IsNullOrEmpty(por) && por != "N" /*tzn. aktualne 1,2,3*/) //PR 15.01.2020 
                    uplatnuje_deti = true;
            }

            //bod c) vyživuje tytéž mnou vyživované děti i jiný poplatník ANO/NE
            string H_vyz_jin_popl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_popl"); //X-ANO,"-"-NE
            //string H_vyz_jin_popl_ne = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_popl_ne"); //NE
            if (uplatnuje_deti && H_vyz_jin_popl == "" /*&& H_vyz_jin_popl_ne == ""*/)
            {                
                Val_manzelka.ErrorMessage += "[%Osoby vyživující děti ve stejné domácnosti%] - [%V téže společně hospodařící domácnosti vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Není vyplněna povinná položka%]<br/>";
            }

            if (H_vyz_jin_popl == "X")
            {
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_jmeno") == "")
                    Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Jméno%] - [%Není vyplněna povinná položka%]<br/>";
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_prijmeni") == "")
                    Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Příjmení%] - [%Není vyplněna povinná položka%]<br/>";

                //adresa manzelky:
                //------------------
                //string H_obec_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obec_vyz_jin");
                ////string H_ulice_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_ulice_vyz_jin"); v malé obci nemusí být ulice
                //string H_c_pop_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_pop_vyz_jin");
                ////string H_c_orient_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_orient_vyz_jin"); č. orientační nemusí být vyplněno
                //string H_psc_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_psc_vyz_jin");
                //------------------
                
                string H_vyz_jin_upl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_upl");//manželka uplatňuje
                if (string.IsNullOrEmpty(H_vyz_jin_upl)) //PR 20.01.2020 HID=49784
                    Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Uplatňuje daňové zvýhodnění ANO/NE%] - [%Není vyplněna povinná položka%]<br/>";
                string H_vyz_jin_zam = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_zam");//manželka je zaměstnaná
                if (string.IsNullOrEmpty(H_vyz_jin_zam))//PR 20.01.2020 HID=49784
                    Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Zaměstnání ANO/NE%] - [%Není vyplněna povinná položka%]<br/>";
                if (H_vyz_jin_zam == "1")
                {
                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_naz_platce") == "")
                        Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Název plátce daně%] - [%Není vyplněna povinná položka%]<br/>";
                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_obec_vyz_jin_pl") == "")
                        Val_manzelka.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Adresa plátce daně%] - [%Obec%] - [%Není vyplněna povinná položka%]<br/>";
                    //string H_ulice_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_ulice_vyz_jin_pl"); v malé obci nemusí být ulice
                    //string H_c_pop_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_pop_vyz_jin_pl");
                    //string H_c_orien_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_orien_vyz_jin_pl"); č. orientační nemusí být vyplněno
                    //string H_psc_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_psc_vyz_jin_pl");
                }
                if (uplatnuje_deti)
                {
                    if (H_vyz_jin_zam == "1")
                    {
                        if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_upl_file")))
                            _povinnePrilohy.Add("- potvrzení zaměstnavatele manžela/manželky/partnera/partnerky, že daňové zvýhodnění neuplatňuje");
                    }
                    else
                    {
                        if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_upl_file")))
                            _povinnePrilohy.Add("- čestné prohlášení, že manžel/manželka/partner/partnerka daňové zvýhodnění neuplatňuje");
                    }
                }
            }

            //PR 09.12.2019 kontrola počtu příloh
            if (Parametry.ParametrCti("DanPocetPriloh") == "a") //PR 15.01.2020 
            {
                PrilohyManager prilohy = (PrilohyManager)WebControlHelper.FindControl(Page, "uc_prilohy");
                if (prilohy.Mode != FormViewMode.ReadOnly /*&& !overeni*/)
                {
                    //if (prilohy.PocetNahranychPriloh < _povinnePrilohy.Count)
                    //{
                    //    Valid1.ErrorMessage += "Nedostatečný počet příloh: nahráno " + prilohy.PocetNahranychPriloh + ", požadováno " + _povinnePrilohy.Count + ", požadované přílohy:<br/>";
                    //    Valid1.ErrorMessage += string.Join("<br/>", _povinnePrilohy) + "<br/>";
                    //}
                    //PR 14.12.2021 list _povinnePrilohy nyní obsahují pouze přílohy, které uživatel nepřiložil
                    if (_povinnePrilohy.Count > 0)
                    {
                        Valid1.ErrorMessage += "Doplňte tyto potvrzení:<br/>";
                        Valid1.ErrorMessage += string.Join("<br/>", _povinnePrilohy) + "<br/>";
                    }
                }
            }

            if (Valid1.ErrorMessage != "" || Val_obdobi.ErrorMessage != "" || Val_slevy.ErrorMessage != "" || Val_deti.ErrorMessage != "" || Val_manzelka.ErrorMessage != "")
            {
                args.IsValid = false;
                Valid1.ErrorMessage = "Souhrn chyb: <br/>" + Valid1.ErrorMessage + Val_obdobi.ErrorMessage + Val_slevy.ErrorMessage + Val_deti.ErrorMessage + Val_manzelka.ErrorMessage;
                Valid1.Text = Valid1.ErrorMessage;

                if (Val_obdobi.ErrorMessage != "")
                {
                    Val_obdobi.IsValid = false;
                    Val_obdobi.Text = Val_obdobi.ErrorMessage;
                }
                if (Val_slevy.ErrorMessage != "")
                {
                    Val_slevy.IsValid = false;
                    Val_slevy.Text = Val_slevy.ErrorMessage;
                }
                if (Val_deti.ErrorMessage != "")
                {
                    Val_deti.IsValid = false;
                    Val_deti.Text = Val_deti.ErrorMessage;
                }
                if (Val_manzelka.ErrorMessage != "")
                {
                    Val_manzelka.IsValid = false;
                    Val_manzelka.Text = Val_obdobi.ErrorMessage;
                }
            }
        }


        protected void DDL_manzelka_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            DataView dv = ODS_manzelky.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                //PR 10.12.2021 id_rod_prisl (RC muze byt z historickych duvodu null)
                if (dv[i]["id_rod_prisl"].Equals(DBNull.Value))
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_id", "");
                else
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_id", (int)dv[i]["id_rod_prisl"]); 
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_rc", (string)dv[i]["rc"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_ulice_vyz_jin", (string)dv[i]["ulice"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_c_pop_vyz_jin", (string)dv[i]["c_pop"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_obec_vyz_jin", (string)dv[i]["obec"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_psc_vyz_jin", (string)dv[i]["psc"]);
                //break;
            }
            //}

            //schovani H_vyz_jin_upl_file je v Page_PreRender
        }

        protected void H_dod_priz_SelectedIndexChanged(object sender, EventArgs e)
        {
            RadRadioButtonList H_dod_priz = (RadRadioButtonList)FormView1.FindControl("H_dod_priz");
            if (H_dod_priz.SelectedValue == "XD")
                WebControlHelper.SubCtrlSetValue(FormView1, "H_obd_rok", (DateTime.Today.Year - 1).ToString());
            else
                WebControlHelper.SubCtrlSetValue(FormView1, "H_obd_rok", DateTime.Today.Year.ToString());

            NastavEditovatelnostKontrolek(null);

            //PR 14.01.2021 aby při XD zmizela kontrola na podané prohlášení v běžném roce
            if (PozId == 0 || WF.FazePosl == 0)
            {
                Page.Validate(ValidPre.ValidationGroup);
            }
        }

        /// <summary>
        /// RadioButtonList: uplatňuji / dodatečně uplatňuji / neuplatňuji
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void H_dod_upl_SelectedIndexChanged(object sender, EventArgs e)
        {
            //string prefix = (e.CommandName == "z_deti") ? "X" : "D";
            string prefix = "D";
            int i = 0;
            List<StrRodPrisl> deti = new List<StrRodPrisl>();
            string H_dod_upl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_upl");
            if (H_dod_upl == "X" || H_dod_upl == "XD")
            {
                int pocetDeti = Pozadavekdanprohl.GetDeti(Vydavatel, new DateTime(DateTime.Today.Year, 1, 1), ref deti);
                foreach (StrRodPrisl dite in deti)
                {
                    i++;
                    int vek = F_RodneCislo.Vek(dite.rodne_cislo, DateTime.Today);
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_jmeno", dite.jmeno);
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_prijmeni", dite.prijmeni);
                    //WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", dite.rodne_cislo);
                    //PR 09.05.2022 dítě cizinec - uvádí se datum narození
                    if ((string.IsNullOrEmpty(dite.rodne_cislo) || dite.rodne_cislo.EndsWith("000")) && dite.datum_narozeni.HasValue)
                        WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", dite.datum_narozeni.Value.ToString("d.M.yyyy", System.Globalization.CultureInfo.InvariantCulture));
                    else
                        WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", dite.rodne_cislo);

                    StrRodPrislSleva dite_sleva = KSProgram.Personal.RodPrisl.SlevaNacti(dite.id_rod_prisl, DateTime.Today);
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_upl_por", (dite_sleva.poradi == null || dite_sleva.poradi == 0) ? "N" : dite_sleva.poradi.Value.ToString());
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_ztp", (dite_sleva.sleva != null && dite_sleva.sleva == "z") ? "1" : "0");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_zletile", ((dite_sleva.poradi != null && dite_sleva.poradi.Value > 0) && (vek >= 18 && vek < 26)) ? "1" : "0"); //má navedenu slevu a zároveň je zletilé

                    if (i == 5) break;
                }
                if (pocetDeti == 0)
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Chybí dítě?%] [%Požádej o doplnění přes požadavek žádost o změnu osobních údajů.%]"));
            }
            else if (H_dod_upl == "-")
            {
                for(i=1; i <=5; i++)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_jmeno", "");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_prijmeni", "");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", "");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_upl_por", "");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_ztp", "");
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_zletile", ""); 

                }
            }
        }

        protected void RB_k_podpisu_Click(object sender, EventArgs e)
        {
            OnButtonClicked(sender, e);//informování parent controlky (ZadostOdanprohl) o kliknutí na tlačítko RB_k_podpisu (aby mohla vymenit sub controlku KS za MF)
        }
    }
}