﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Collections.Generic;
using KSProgram.Exceptions;
using KSProgram.Security;
using System.Text.RegularExpressions;
using KSProgram.Personal;
using System.Linq;
using System.Threading;

namespace KSPortal.Controls
{
    public partial class DanProhl_MF_2018 : UserControlPozadavek
    {
        public override string Typ
        {
            get { return "danprohl"; }
        }

        private List<string> _povinnePrilohyStr1 = new List<string>();
        private List<string> _povinnePrilohyStr2 = new List<string>();
        private bool _manzelkaBylaVyplnena
        {
            set
            {
                ViewState["manzelkaBylaVyplnena"] = value;
            }
            get
            {
                object o = ViewState["manzelkaBylaVyplnena"];
                if (o == null)
                    return false;
                else
                    return (bool)o;
            }
        }
        protected FormViewMode FakeMode
        {
            get
            {
                object o = ViewState["FakeMode"];
                if (o == null)
                    return FormViewMode.ReadOnly;
                else
                    return (FormViewMode)o;
            }
            set
            {
                ViewState["FakeMode"] = value;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            RadWindowManager mng = Page.Master.FindControl("RadWindowManager1") as RadWindowManager;
            mng.Localization.OK = ReadGlobalResource.ZmenaTextu("[%Ano%]");
            mng.Localization.Cancel = ReadGlobalResource.ZmenaTextu("[%Zrušit%]");
        }


        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource ObjectDataSource1 = (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1");
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();

            if (val == "insert" || val == "edit")
            {
                if (PozId == 0)
                    FakeMode = FormViewMode.Insert;//FormView1.ChangeMode(FormViewMode.Insert);
                else
                    FakeMode = FormViewMode.Edit;//FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
                FakeMode = FormViewMode.ReadOnly;//FormView1.ChangeMode(FormViewMode.ReadOnly);


            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

            //PR 04.05.2020 nastavení proměnné, říkající, zda před změnou byla manželka vyplněna. (pokud byla, tak již její údaje nelze přepisovat)
            if (zmeny)
                _manzelkaBylaVyplnena = !string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_jmeno"));
            else
                _manzelkaBylaVyplnena = false;

            //PR 12.12.2018 kód přesunut do následující funkce
            NastavEditovatelnostKontrolek(wf);
            FormView1.FindControl("btn_deti").Visible = (FakeMode != FormViewMode.ReadOnly) && !zmeny; //PR 20.01.2020 
            //PR 21.02.2019 pro změny v průběhu roku jsem skryl tlačítka v podpisové části
            FormView1.FindControl("btn_podepsat").Visible = (FakeMode != FormViewMode.ReadOnly) && !zmeny;
            FormView1.FindControl("btn_overeno").Visible = (FakeMode != FormViewMode.ReadOnly) && overeni && !zmeny;
            FormView1.FindControl("btn_podepsat_dodat").Visible = (FakeMode != FormViewMode.ReadOnly) && !zmeny;
            FormView1.FindControl("btn_overeno_dodat").Visible = (FakeMode != FormViewMode.ReadOnly) && overeni && !zmeny;
            //změnová část
            for (int i = 1; i <= 5; i++)
            {
                if (FakeMode != FormViewMode.ReadOnly) //Edit
                {
                    //string old_druh_zmeny = ((TextBox)FormView1.FindControl("Z" + i + "_dr_zmeny_old")).Text;
                    //FormView1.FindControl("Z" + i + "_dr_zmeny_old").Visible = false;
                    //FormView1.FindControl("Z" + i + "_dr_zmeny").Visible = true;
                    RadDropDownList ddl = (RadDropDownList)FormView1.FindControl("Z" + i + "_dr_zmeny");
                    ddl.ToolTip = "[%V případě jiných změn vytvořte nové prohlášení%]";
                    ddl.Items.Add(new DropDownListItem("")); //prázdný řádek 
                    ddl.Items.Add(new DropDownListItem("Ruším podpis - od", "Ruším podpis - od"));//PR 05.12.2019                   
                    //slevy
                    ddl.Items.Add(new DropDownListItem("Sleva na poplatníka - od", "Sleva na poplatníka - od"));//neměl odpočet a nyní chce (v měsíci nástupu uplatňoval u předchozího zaměstnavatele)
                    ddl.Items.Add(new DropDownListItem("Sleva na poplatníka - do", "Sleva na poplatníka - do"));//ukončí si odpočet, prohlášení zůstává podepsané (když podepíše u jiné firmy, tak se nic neděje, protože neuplatňuje současně u více firem)
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. I. st. - od", "Sleva na inv. I. st. - od"));
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. I. st. - do", "Sleva na inv. I. st. - do"));
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. II. st. - od", "Sleva na inv. II. st. - od"));
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. II. st. - do", "Sleva na inv. II. st. - do"));
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. III. st. - od", "Sleva na inv. III. st. - od"));
                    ddl.Items.Add(new DropDownListItem("Sleva na inv. III. st. - do", "Sleva na inv. III. st. - do"));
                    ddl.Items.Add(new DropDownListItem("Sleva na ZTP/P - od", "Sleva na ZTP/P - od"));
                    ddl.Items.Add(new DropDownListItem("Sleva na ZTP/P - do", "Sleva na ZTP/P - do"));
                    ddl.Items.Add(new DropDownListItem("Sleva na studenta - od", "Sleva na studenta - od"));
                    ddl.Items.Add(new DropDownListItem("Sleva na studenta - do", "Sleva na studenta - do"));
                    //zvýhodnění
                    //string sql = "SELECT rod_prisl.jmeno, rod_prisl.prijmeni, rod_prisl.rodne_cislo, rod_prisl_slevy.sleva, rod_prisl_slevy.poradi, rod_prisl_slevy.sleva_od, rod_prisl_slevy.sleva_do "
                    //+ " FROM rod_prisl LEFT OUTER JOIN rod_prisl_slevy ON rod_prisl.id_rod_prisl = rod_prisl_slevy.id_rod_prisl  "
                    //+ " WHERE rod_prisl.os_cislo = @osc AND rod_prisl.vztah IN ('syn','dcera','dítě','vnuk','vnučka','v péči') "
                    //+ " AND ((rod_prisl_slevy.sleva IS NULL) OR ((rod_prisl_slevy.sleva_od IS NULL OR rod_prisl_slevy.sleva_od <= @dat1) AND (rod_prisl_slevy.sleva_do IS NULL OR rod_prisl_slevy.sleva_do >= @dat2)))"
                    //+ " ORDER BY rod_prisl_slevy.poradi";
                    //ParametryPrikazu par = new ParametryPrikazu() { new KSParameter("osc", Vydavatel), new KSParameter("dat1", DateTime.Today), new KSParameter("dat2", DateTime.Today) };
                    //using (IDataReader reader = SqlPrikaz.ExecuteReader(sql, ref par))
                    //{

                    //    while (reader.Read())
                    //    {
                    //        string jmeno = GetNullOrData.GetString(reader, 0, "", true);
                    //        string prijmeni = GetNullOrData.GetString(reader, 1, "", true);
                    //        //string rc = GetNullOrData.GetString(reader, 2, "", true);                            
                    //        //int vek = F_RodneCislo.Vek(rc, DateTime.Today);
                    //        //string sleva = GetNullOrData.GetString(reader, 3, "", true);//Ne	n/  Ano	a/  ZTP-P	z;
                    //        //int poradi = GetNullOrData.GetInt32(reader, 4, 0);
                    //        //if (poradi > 0 && vek >= 26) poradi = 0; //jeste nezrusili slevu
                    //        //string upl_por = poradi == 0 ? "N" : poradi.ToString();
                    //        //bool ztpp = (sleva == "z") ? true : false;
                    //        //bool zletile = ((poradi > 0) && (vek >= 18 && vek < 26)) ? true : false; //má navedenu slevu a zároveň je zletilé
                    //        ddl.Items.Add(new DropDownListItem("Zvýhodnění na "+ jmeno + " - od", "Zvýhodnění na " + jmeno + " - od"));
                    //        ddl.Items.Add(new DropDownListItem("Zvýhodnění na "+ jmeno + " - do", "Zvýhodnění na " + jmeno + " - do"));
                    //    }
                    //}
                    //PR 09.11.2020 HID=52724 nenabízeli se děti s ukončenou slevou a dám to k začátku roku, ať to neoflitruje děti, které dovršili 26l během roku
                    List<StrRodPrisl> deti = new List<StrRodPrisl>();
                    int pocetDeti = Pozadavekdanprohl.GetDeti(Vydavatel, new DateTime(DateTime.Today.Year, 1, 1), ref deti);
                    foreach (StrRodPrisl dite in deti)
                    {
                        ddl.Items.Add(new DropDownListItem("Zvýhodnění na " + dite.jmeno + " - od", "Zvýhodnění na " + dite.jmeno + " - od"));
                        ddl.Items.Add(new DropDownListItem("Zvýhodnění na " + dite.jmeno + " - do", "Zvýhodnění na " + dite.jmeno + " - do"));
                    }
                    ddl.Items.Add(new DropDownListItem("Zvýhodnění - změna pořadí od", "Zvýhodnění - změna pořadí od"));
                    //PR 09.10.2020 prodložení zvýhodnění není změnou, proto vkládám následující řádek, pokud chtějí dodávat potvrzení o studiu na letní semestr
                    ddl.Items.Add(new DropDownListItem("Beze změny - přidání přílohy", "Beze změny - přidání přílohy"));
                    //pokud je hodnota vyplněna z doby, kdy to ještě byl TextBox, přidám hodnotu do nabídky
                    string old_value = ((DataRowView)FormView1.DataItem)["Z" + i + "_dr_zmeny"].ToString();
                    if (ddl.Items.FindChildByValue<DropDownListItem>(old_value, false) == null)
                        ddl.Items.Add(new DropDownListItem(old_value, old_value));
                    if (!string.IsNullOrEmpty(old_value))
                    {
                        ddl.SelectedValue = old_value;
                    }
                }
                else //ReadOnly
                {
                    RadDropDownList ddl = (RadDropDownList)FormView1.FindControl("Z" + i + "_dr_zmeny");
                    string old_value = ((DataRowView)FormView1.DataItem)["Z" + i + "_dr_zmeny"].ToString();
                    if (!string.IsNullOrEmpty(old_value))
                    {
                        ddl.Items.Add(new DropDownListItem(old_value, old_value));
                        ddl.SelectedValue = old_value;
                    }
                }
                FormView1.FindControl("btn_Z" + i + "_podp").Visible = (FakeMode != FormViewMode.ReadOnly) && zmeny && string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + i + "_d_zmeny"));
                FormView1.FindControl("btn_Z" + i + "_podp_over").Visible = (FakeMode != FormViewMode.ReadOnly) && zmeny && overeni && string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + i + "_d_over_zmeny"));
            }
            FormView1.FindControl("btn_Zdeti").Visible = (FakeMode != FormViewMode.ReadOnly) && zmeny;

            if (FakeMode != FormViewMode.ReadOnly)
            {
                RadDropDownList DDL_manzelka = (RadDropDownList)FormView1.FindControl("DDL_manzelka");
                //if (zmeny)
                if (zmeny && _manzelkaBylaVyplnena) //PR 04.05.2020 
                    DDL_manzelka.Visible = false; //PR 22.11.2019 musí zadat nové prohlášení
                else
                {
                    ODS_manzelky.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_manzelky.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();
                    DDL_manzelka.DataSourceID = "ODS_manzelky";
                    DDL_manzelka.DataBind();
                    //DDL_manzelka.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_rc");
                    DDL_manzelka.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_id");//PR 10.12.2021
                }
            }

            if (PozId == 0 || wf.FazePosl == 0)
            {
                Page.Validate(ValidPre.ValidationGroup);
            }
        }

        private void NastavEditovatelnostKontrolek(WorkflowMaster wf)
        {
            if (wf == null)
                wf = new WorkflowMaster(PozId, "danprohl", null);
            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";

            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne_prohlaseni = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";
            //PR 27.09.2019 u dodatečného prohlášení nelze dělat změny, u změn dětí chybí sloupce "dodatečně za kalendářní měsíce"
            if (dodatecne_prohlaseni)
                zmeny = false;

            DataTable dtsloupce = Pozadavekdanprohl.GetDataTable();
            foreach (DataColumn dc in dtsloupce.Columns)
            {
                string col = dc.ColumnName;
                bool disabled = (FakeMode == FormViewMode.ReadOnly)
                        // "pro zdaňovací období" a "Prohlášení k dani činím / dodatečně činím" //PR 26.09.2019
                        || (zmeny && (col == "H_obd_mes" || col == "H_obd_rok" || col == "H_dod_priz"))
                        //----------------------------------------------
                        // Plátce - zaměstnavatel
                        //----------------------------------------------
                        || col == "H_nazev_pl"
                        || col == "H_obec_pl"
                        || col == "H_ulice_pl"
                        || col == "H_c_pop_pl"
                        || col == "H_c_orient_pl"
                        || col == "H_psc_pl"
                        //----------------------------------------------
                        // Identifikace poplatníka
                        //----------------------------------------------
                        || col == "H_prijmeni_pop"
                        || col == "H_jmeno_pop"
                        || col == "H_rc_pop"
                        || col == "H_obec_pop"
                        || col == "H_ulice_pop"
                        || col == "H_c_pop_pop"
                        || col == "H_c_orient_pop"
                        || col == "H_psc_pop"
                        //----------------------------------------------
                        // Daňový nerezident
                        //----------------------------------------------
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                            (col == "H_datNar_pop"
                            || col == "H_c_pasu_pop"
                            || col == "H_typ_dokl_pop"
                            || col == "H_stat_pop"
                            || col == "H_cis_dident"
                            || col == "H_typ_dident"
                            || col == "H_stat_dident")
                           )
                        //----------------------------------------------                        
                        // Slevy 
                        //----------------------------------------------
                        //PR 17.09.2019 needitace pokud je režim změn (konce a začátek slev je nyní ve změnové části(druh změny jako číselník))
                        || (zmeny && col.StartsWith("H_upl_"))
                        /*dodatečně uplatněné slevy za měsíce*/
                        || ((dodatecne_prohlaseni == false) && (col.StartsWith("H_upl_")) && (col.EndsWith("_mes")))
                        //----------------------------------------------
                        // Zvýhodnění
                        //----------------------------------------------
                        /*Dodatečně uplatňuji daňové zvýhodnění*/
                        || ((dodatecne_prohlaseni == false) && (col == "H_dod_upl"))
                        /*Děti - zvýhodnění - uzamknuto pokud je režim změn*/
                        || (zmeny && col.StartsWith("D"))
                        /*dodatečně uplatněné zvýhodnění u dětí za měsíce*/
                        || ((dodatecne_prohlaseni == false) && (col.StartsWith("D")) && (col.EndsWith("_mes")))
                        //PR 11.12.2018 HID=44351 needitace osobních údajů dětí
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                                ((col.StartsWith("D") || col.StartsWith("X")) && (col.EndsWith("_jmeno") || col.EndsWith("_prijmeni") || col.EndsWith("_rc")))
                           )
                        //----------------------------------------------
                        // Manželka
                        //----------------------------------------------
                        //PR 11.12.2018 HID=44351 needitace osobních údajů manželky
                        || (!Pozadavekdanprohl.RodPrislEditable &&
                            (col == "H_vyz_jin_jmeno"
                            || col == "H_vyz_jin_prijmeni"
                            || col == "H_vyz_jin_rc"
                            || col == "H_obec_vyz_jin"
                            || col == "H_ulice_vyz_jin"
                            || col == "H_c_pop_vyz_jin"
                            || col == "H_c_orient_vyz_jin"
                            || col == "H_psc_vyz_jin")
                           )
                        // needitace všech údajů manželky, pokud je režim změn
                        //|| (zmeny && col.Contains("_vyz_jin"))
                        //PR 04.05.2020 HID=51253 - možnost vyplnit bod c při změnách, pokud dříve zvýhodnění neuplatňoval a nyní uplatňuje.
                        || (zmeny && col.Contains("_vyz_jin") && _manzelkaBylaVyplnena)
                        //----------------------------------------------
                        // Změnová část - uzamknuta pokud není režim změn
                        //----------------------------------------------
                        || (!zmeny && (col.StartsWith("X") || col.StartsWith("Z")))
                        ;

                Control c = FormView1.FindControl(col);
                if (c == null) continue;
                if (c is TextBox)
                    (c as TextBox).Enabled = !disabled; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                else if (c is CheckBox)
                    (c as CheckBox).Enabled = !disabled;
                else if (c is RadDropDownList)
                    (c as RadDropDownList).Enabled = !disabled;
            }
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FakeMode != FormViewMode.ReadOnly)
                    {
                        if (FakeMode == FormViewMode.Insert)
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            ObjectDataSource ObjectDataSource1 = (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1");
                            int id_poz = 0;
                            decimal adresat = 0;
                            try
                            {
                                adresat = Convert.ToDecimal(ObjectDataSource1.InsertParameters["adresat"].DefaultValue);
                            }
                            catch (FormatException) { }
                            string novy_stav = ObjectDataSource1.InsertParameters["novy_stav"].DefaultValue;
                            string duvod = ObjectDataSource1.InsertParameters["duvod"].DefaultValue;
                            Pozadavekdanprohl.Insert(ref id_poz, Vydavatel, adresat, novy_stav, duvod, values);
                            PozId = id_poz;
                            OnItemInserted(new EventArgs());
                        }
                        else
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            if (values.Count == 0) //PR 02.02.2021 
                            {
                                is_valid = false;
                                throw new NoticeException("Nepodařilo se získat data z formuláře!");
                            }
                            Pozadavekdanprohl.Update(PozId, values);
                            OnItemUpdated(new EventArgs());
                        }

                    }
                }
            }
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());

        }

        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }

        //přesunuto do ZadostOdanprohl.ascx.cs
        //protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        //{
        //    PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        //}

        public override void ChangeMode(FormViewMode mode)
        {
            //FormView1.ChangeMode(mode);
            FakeMode = mode;
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FakeMode;//FormView1.CurrentMode;
            }
        }

        protected int Rok()
        {
            string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok");
            int rok;
            if (int.TryParse(H_obd_rok, out rok))
                return rok;
            else
                return DateTime.Today.Year;
        }

        /// <summary>
        /// Od kdy platí zadané údaje, v případě změny, od kdy platí změna
        /// </summary>
        /// <returns></returns>
        protected DateTime PlatiOd()
        {
            string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok");
            string H_obd_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_mes");

            DateTime platiOd = new DateTime(DateTime.Today.Year, 1, 1);
            if (!string.IsNullOrEmpty(H_obd_rok) && !string.IsNullOrEmpty(H_obd_mes))
                platiOd = new DateTime(int.Parse(H_obd_rok), int.Parse(H_obd_mes), 1);
            else if (!string.IsNullOrEmpty(H_obd_rok))
                platiOd = new DateTime(int.Parse(H_obd_rok), 1, 1);

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            if (zmeny)
            {
                int k = 1;
                string polozka = "Z" + k + "_mes_zmeny";
                while (FormView1.FindControl(polozka) != null)
                {
                    string druh_zmeny = WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + k + "_dr_zmeny");
                    int? mesicZmeny = WebControlHelper.SubCtrlGetValueNumber(FormView1, polozka);
                    DateTime? datOvereni = WebControlHelper.SubCtrlGetValueDate(FormView1, "Z" + k + "_d_over_zmeny");
                    if (mesicZmeny.HasValue && (!datOvereni.HasValue || datOvereni == DateTime.Today)) //1.změna, která ještě není ověřena
                    {
                        platiOd = new DateTime(platiOd.Year, mesicZmeny.Value, 1);
                        if (druh_zmeny != null && druh_zmeny.EndsWith(" do")) //PR 10.06.2022 
                            platiOd = platiOd.PosledniDen().AddDays(1); //pokud slevu ukoncim ke 31.8. tak zmena je od 1.9.
                        break;
                    }
                    k++;
                    polozka = "Z" + k + "_mes_zmeny";
                }
                    
            }

            return platiOd;
        }


        protected void ValidPre_ServerValidate(object source, ServerValidateEventArgs args)
        {
            ValidPre.ErrorMessage = "";
            if (FakeMode == FormViewMode.ReadOnly) return;

            int? H_obd_rok = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_rok");
            int? H_obd_mes = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_mes");

            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";

            //PR 08.02.2021 HID=54589 uživatel s nástupem až v novém roce, si zadal dodatečné prohlášení a následně i žádost o RZ.
            if (H_obd_rok != null)
            {
                int mes = 1;
                if (H_obd_mes != null) mes = H_obd_mes.Value;
                //DateTime platiOd = new DateTime(H_obd_rok.Value, H_obd_mes.Value, 1);
                DateTime platiOd = new DateTime(H_obd_rok.Value, mes, 1);//PR 01.03.2021 null u nově nastoupivších
                DateTime datNast; DateTime? datVyst;
                Pracovnik.GetDatumNastupVystup(Vydavatel, out datNast, out datVyst);
                if (datNast.PrvniDen() > platiOd)
                {
                    //může to být opakovaná evidence, kdy přepsali datum nástupu
                    //a zároveň může podávat dodatečné prohlášení za minulý rok, takže ještě zkontroluji, zda neměl PP
                    List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, platiOd, platiOd.PosledniDen());
                    if (pomery.Count == 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", platiOd.ToString("MM/yyyy")) + "<br/>";
                    }
                }
                else if (datVyst.HasValue && datVyst.Value < platiOd)
                {
                    //V případě, že by při opakovaném nástupu měli kvůli něčemu ještě původní datumy v evidenci, zkontroluji i PP
                    List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, platiOd, platiOd.PosledniDen());
                    if (pomery.Count == 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", platiOd.ToString("MM/yyyy")) + "<br/>";
                    }
                }
            }

            if (PozId == 0)
            {
                if (H_obd_rok != null && H_obd_mes != null)
                {
                    //nepodal již prohlášení na stejný rok a období? Stornované je ignorováno.
                    int idP = Pozadavekdanprohl.ExistujeSeStejnouPlatnosti(Vydavatel, H_obd_rok.Value, H_obd_mes.Value);
                    if (idP > 0)
                    {
                        //PR 14.01.2021 HID=54325 pokud je prohlášení dodatečné, tak nevadí, že má podané běžné prohlášení
                        if (!(dodatecne && !Pozadavekdanprohl.JeDodatecne(idP)))
                            ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Prohlášení s platností od měsíce {0} již máte podané, nové nelze podat!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit prohlášení k opravě!%]<br/>", H_obd_mes + "/" + H_obd_rok);
                    }
                    idP = Pozadavekdanprohl.ExistujeNeuzavrenyProRok(Vydavatel, H_obd_rok.Value);
                    if (idP > 0)
                    {
                        ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Prohlášení pro rok {0} již máte podané, nové nelze podat, dokud nebude existující schváleno nebo zamítnuto!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit prohlášení k opravě!%]<br/>", H_obd_rok);
                    }
                }
            }

            if (ValidPre.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPre.Text = ValidPre.ErrorMessage;
            }
        }

        protected void ValidPg1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator ValidPg1 = (CustomValidator)FormView1.FindControl("ValidPg1");
            ValidPg1.ErrorMessage = "";
            ValidPg1.Text = "";
            _povinnePrilohyStr1.Clear();//PR 09.12.2019 kontrola počtu příloh
            if (FakeMode == FormViewMode.ReadOnly) return;

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";
            //PR 27.09.2019 u dodatečného prohlášení nelze dělat změny, u změn dětí chybí sloupce "dodatečně za kalendářní měsíce"
            if (dodatecne)
                zmeny = false;
            //PR 13.12.2018 -------------------------------------------------------------------------------------
            string H_obd_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_mes");
            if (string.IsNullOrEmpty(H_obd_mes))
                ValidPg1.ErrorMessage += "[%Zdaňovací období%] - [%měsíc%] - [%Není vyplněna povinná položka%]<br/>";
            string H_obd_rok = "";
            try
            {
                H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok", true, "Zdaňovací období - rok", "^(20[12][0-9])$");
            }
            catch (NoticeException ex1)
            { ValidPg1.ErrorMessage += ex1.Message + "<br/>"; }

            //---------------------------------------------------------------------------------------------------
            DateTime ld_AktObdobi = ViceIco.ObdobiPodnikuPodleZamestnance(Vydavatel);//PR 14.01.2020 HID=49553

            //if (H_obd_rok != DateTime.Today.Year.ToString())
            //if (H_obd_rok != ld_AktObdobi.Year.ToString() && !string.IsNullOrEmpty(H_obd_rok))//PR 09.11.2018 
            if (!string.IsNullOrEmpty(H_obd_rok)) //PR 08.12.2021 
            {
                if (dodatecne)
                {
                    if (H_obd_rok == (ld_AktObdobi.Year - 1).ToString() && ld_AktObdobi.Month > 3)
                        ValidPg1.ErrorMessage += "[%Dodatečné prohlášení za minulý rok lze podat pouze v období leden až březen%]<br/>";
                    else if (H_obd_rok != (ld_AktObdobi.Year - 1).ToString())
                        ValidPg1.ErrorMessage += "[%Dodatečné prohlášení lze podat pouze za minulý rok%]<br/>";
                }
                else if (H_obd_rok != ld_AktObdobi.Year.ToString()) //PR 08.12.2021 
                    ValidPg1.ErrorMessage += "[%Zdaňovací období%] - [%rok%] - [%Běžné (nedodatečné) prohlášení lze podat pouze pro aktuální rok%]<br/>";
            }

            //DateTime platiOd = new DateTime(DateTime.Today.Year, 1, 1);
            //if (!string.IsNullOrEmpty(H_obd_rok) && !string.IsNullOrEmpty(H_obd_mes))
            //    platiOd = new DateTime(int.Parse(H_obd_rok), int.Parse(H_obd_mes), 1);
            //else if (!string.IsNullOrEmpty(H_obd_rok))
            //    platiOd = new DateTime(int.Parse(H_obd_rok), 1, 1);
            DateTime platiOd = PlatiOd(); //PR 06.05.2022 

            string rc_pop = WebControlHelper.SubCtrlGetValueString(FormView1, "H_rc_pop");
            int vek_pop = 0;
            if (!string.IsNullOrEmpty(rc_pop))
                vek_pop = F_RodneCislo.Vek(rc_pop, platiOd);

            //H_datNar_pop vyplňuje pouze daňový nerezident
            try
            {
                DateTime? H_datNar_pop = WebControlHelper.SubCtrlGetValueDate(FormView1, "H_datNar_pop", true, "Datum narození");
            }
            catch (NoticeException ex1)
            { ValidPg1.ErrorMessage = ex1.Message; }

            if (!zmeny) //PR 06.05.2022 pokud jsem v režimu změn, tak vůbec nebudu kontrolovat slevy a zvýhodnění na 1. stránce
            {

                string H_upl_sleva = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_sleva");
                //PR 03.09.2019 HID=47474 ...jestli zaměstnanec skutečně nechce uplatňovat základní slevu?
                if (string.IsNullOrEmpty(H_upl_sleva) && WebControlHelper.SubCtrlGetValueString(FormView1, "HF_sleva_opravdu_ne") == "0")
                {
                    ValidPg1.ErrorMessage += "[%Základní sleva na poplatníka%] - [%Opravdu neuplatňujete základní slevu na poplatníka?%]<br/>";
                    //V Page_Load mám přenastavené názvy tlačítek
                    MessageBox.Confirm(this.Page, ReadGlobalResource.ZmenaTextu("[%Opravdu neuplatňujete základní slevu na poplatníka?%]"), ReadGlobalResource.ZmenaTextu("[%Dotaz%]"), null, null, "confirm_upl_sleva_ne");
                }

                string H_upl_inv = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv").ToUpper();//x-I.st., X-II.st.
                string H_upl_inv_roz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_roz");
                string H_upl_inv_ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_ztp");
                string H_upl_stud = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_stud");

                if (!dodatecne && (H_upl_sleva == "XD" || H_upl_inv == "XD" || H_upl_inv_roz == "XD" || H_upl_inv_ztp == "XD" || H_upl_stud == "XD"))
                {
                    ValidPg1.ErrorMessage += "[%XD - Dodatečné uplatnění u slev lze použít pouze pokud činíte prohlášení dodatečně%]<br/>";
                }

                //TODO: Daňový nerezident ČR může měsíčně u zaměstnavatele uplatňovat pouze slevu na poplatníka a slevu na studenta.
                if (!string.IsNullOrEmpty(H_upl_inv) || !string.IsNullOrEmpty(H_upl_inv_roz))
                    _povinnePrilohyStr1.Add("- potvrzení o rozhodnutí z správy sociálního zabezpečení nebo doklad o výplatě invalidního důchodu - složenka nebo výpis z účtu");
                if (!string.IsNullOrEmpty(H_upl_inv_ztp))
                    _povinnePrilohyStr1.Add("- kopie průkazu ZTP/P");
                if (!string.IsNullOrEmpty(H_upl_stud))
                {
                    _povinnePrilohyStr1.Add("- potvrzení vysoké školy o zapsání ke studiu");
                    if (vek_pop >= 28)
                        ValidPg1.ErrorMessage += "[%Slevu na studenta lze uplatňovat pouze do 28 let věku%]<br/>";
                }

                //string H_upl_sleva_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_sleva_mes"); //položka neexistuje
                string H_upl_inv_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_mes");
                string H_upl_inv_roz_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_roz_mes");
                string H_upl_inv_ztp_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_inv_ztp_mes");
                string H_upl_stud_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_upl_stud_mes");
                if (!dodatecne && (H_upl_inv_mes != "" || H_upl_inv_roz_mes != "" || H_upl_inv_ztp_mes != "" || H_upl_stud_mes != ""))
                {
                    ValidPg1.ErrorMessage += "[%Měsíce je možno vyplnit u slev pouze pokud činíte prohlášení dodatečně%]<br/>";
                }
                if (dodatecne)
                {
                    if (!string.IsNullOrEmpty(H_upl_inv) && string.IsNullOrEmpty(H_upl_inv_mes))
                        ValidPg1.ErrorMessage += "[%Základní sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                    if (!string.IsNullOrEmpty(H_upl_inv_roz) && string.IsNullOrEmpty(H_upl_inv_roz_mes))
                        ValidPg1.ErrorMessage += "[%Rozšířená sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                    if (!string.IsNullOrEmpty(H_upl_inv_ztp) && string.IsNullOrEmpty(H_upl_inv_ztp_mes))
                        ValidPg1.ErrorMessage += "[%Sleva na držitele průkazu ZTP/P%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                    if (!string.IsNullOrEmpty(H_upl_stud) && string.IsNullOrEmpty(H_upl_stud_mes))
                        ValidPg1.ErrorMessage += "[%Sleva na studenta%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněna povinná položka%]<br/>";
                }
                //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
                string parseError;
                if (!string.IsNullOrEmpty(H_upl_inv_mes))
                {
                    if (new MesiceRozsah(H_upl_inv_mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%Základní sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
                }
                if (!string.IsNullOrEmpty(H_upl_inv_roz_mes))
                {
                    if (new MesiceRozsah(H_upl_inv_roz_mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%Rozšířená sleva na invaliditu%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
                }
                if (!string.IsNullOrEmpty(H_upl_inv_ztp_mes))
                {
                    if (new MesiceRozsah(H_upl_inv_ztp_mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%Sleva na držitele průkazu ZTP/P%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
                }
                if (!string.IsNullOrEmpty(H_upl_stud_mes))
                {
                    if (new MesiceRozsah(H_upl_stud_mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%Sleva na studenta%] - [%Dodatečně za kalendářní měsíce%] - [%Neplatný formát%] (" + parseError + ")<br/>";
                }
            
                //Děti - daňové zvýhodnění
                ValidaceZvyhodneni("D", platiOd, ValidPg1, _povinnePrilohyStr1); //PR 06.05.2022 kód dán do funkce
            }

            if (ValidPg1.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPg1.Text = ValidPg1.ErrorMessage;
            }
        }

        protected void ValidaceZvyhodneni(string prefix, DateTime platiOd, CustomValidator val, List<string> povinnePrilohy)
        {
            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");
            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";

            string H_dod_upl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_upl");
            if (prefix == "D")
            {
                if (!dodatecne && (H_dod_upl == "XD"))
                {
                    val.ErrorMessage += "[%Dodatečné uplatnění daňového zvýhodnění je možno použít pouze pokud činíte prohlášení dodatečně%]<br/>";
                }
            }
            int dodat_zvyh_count = 0;

            for (int i = 1; i <= 5; i++)
            {
                string jm = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_jmeno");
                string pr = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_prijmeni");
                string rcOrDatNar = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_rc");

                if (jm != "" || pr != "" || rcOrDatNar != "")
                {
                    //if (Pozadavekdanprohl.RodPrislEditable) //<-----nyní je to nastaveno, že položky nejsou editační (děti se načtou automaticky, pokud již uplatňoval, jinak na tlačítko)
                    //{
                    //    if (jm == "") val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Jméno%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                    //    if (pr == "") val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Příjmení%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                    //    if (rc == "") val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";

                    //    if (!string.IsNullOrEmpty(rc))
                    //    {
                    //        Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
                    //        MatchCollection m = r.Matches(rc);
                    //        if (m.Count != 1)
                    //            val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatný formát%]<br/>";
                    //        else
                    //        {
                    //            int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
                    //            int month = Int16.Parse(m[0].Groups[2].Value);
                    //            int day = Int16.Parse(m[0].Groups[3].Value);
                    //            int ext = Int16.Parse(m[0].Groups[4].Value);
                    //            int mod = (year + month + day + ext) % 11;
                    //            if (mod != 0)
                    //                val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatné rodné číslo%]<br/>";
                    //        }
                    //    }
                    //}
                    //else
                    //{
                    //PR 27.05.2020 HID=51345 dětem bez RČ i dat. nar. se nepočítá sleva, v protokolu výpočtu je chybně uvedeno, že přesáhl věkovou hranici
                    if (rcOrDatNar == "")
                    {
                        //val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + "- [%Není vyplněna povinná položka%] - [%Doplňte RČ dítěte přes požadavek na změnu osobních údajů%]<br/>";
                        //PR 09.05.2022 
                        val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + "- [%Není vyplněna povinná položka%] - [%Doplňte RČ dítěte přes požadavek na změnu osobních údajů%] ([%u cizince zadejte aspoň datum narození%)<br/>";
                        continue;
                    }
                    //PR 04.05.2022 zkontroluji, zda dítě s daným RČ nezmizelo z databáze, jinak se pri zapsat ukončí sleva dětem, které systém nenalezl.
                    //              použita stejná funkce jako v Pozadavekdanprohl.zapsat(), aby byla jistota, že to funguje jednotně.
                    int? id_rod_prisl;
                    int vek_d;
                    DateTime? dn_d;
                    string rc;
                    id_rod_prisl = Pozadavekdanprohl.NajdiDite(Vydavatel, rcOrDatNar, jm, out rc, out dn_d);
                    if (id_rod_prisl == null)
                    {
                        if (rcOrDatNar.Contains('.')) //PR 06.05.2022 v položce je datum, protože se jedná o cizince bez RČ (doposud museli zadávat fiktivní RČ)
                            val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Dítě s daným datem narození nebylo nalezeno v evidenci%]<br/>";
                        else
                            val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Dítě s daným RČ nebylo nalezeno v evidenci%]<br/>";
                        continue;
                    }
                    if (dn_d == null)
                    {
                        val.ErrorMessage += "[%Daňové zvýhodnění%] - [%řádek%] " + i + " - [%Dítě nemá zadáno datum narození v evidenci%]<br/>";
                        continue;
                    }
                    vek_d = F_DateTime.YearsAfter(dn_d.Value, platiOd);
                    //}
                    string por = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_upl_por");
                    if (por == "") val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Uplatňuji/neuplatňuji nárok ve výši na%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                    string ztp = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_ztp");
                    if (por == "N" && ztp == "1")
                        val.ErrorMessage += "[%Daňové zvýhodnění%] - [%ZTP/P%] - [%řádek%] " + i + " - [%Položka může být vyplněna pouze u uplatňovaných dětí%]<br/>";
                    string zl = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_zletile");
                    if (por == "N" && zl == "1")
                        val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Zletilé dítě%] - [%řádek%] " + i + " - [%Položka může být vyplněna pouze u uplatňovaných dětí%]<br/>";

                    //Dodatečně za kalendářní měsíce
                    if (prefix == "D")
                    {
                        string mes = WebControlHelper.SubCtrlGetValueString(FormView1, prefix + i + "_dod_mes");
                        if (!dodatecne && !string.IsNullOrEmpty(mes))
                            val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Položka se vyplňuje pouze u dodatečného prohlášení%]<br/>";
                        //PR 02.02.2021 zapoznámkováno, u některých dětí mohl již uplatňovat během roku, budu kontrolovat, zda vyplnil aspoň u jednoho
                        //if (dodatecne)
                        //    if (por == "1" || por == "2" || por == "3")
                        //        if (string.IsNullOrEmpty(mes))
                        //            ValidPg1.ErrorMessage += "[%Daňové zvýhodnění%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Není vyplněna povinná položka%]<br/>";
                        if (dodatecne)
                            if (por == "1" || por == "2" || por == "3")
                                if (!string.IsNullOrEmpty(mes))
                                    dodat_zvyh_count++;
                        //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
                        if (!string.IsNullOrEmpty(mes))
                        {
                            string parseError;
                            if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                                val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Dodatečně za kalendářní měsíce%] - [%řádek%] " + i + " - [%Neplatný formát%] (" + parseError + ")<br/>";
                        }
                    }

                    if (por == "1" || por == "2" || por == "3")
                    {
                        if (dn_d >= platiOd && dn_d <= new DateTime(platiOd.Year, 12, 31))
                            povinnePrilohy.Add("- kopii rodného listu dítěte s RČ " + rcOrDatNar);
                        else if (vek_d >= 18)
                        {
                            //PR 04.01.2021 HID=54129 Když bude platné daňové zvýhodnění u dítěte v rodinných příslušnících C/S aplikace, 
                            //tak nevyžadovat přílohu s potvrzením o studiu dítěte.
                            bool vyzadovat = true;
                            //PotvrzOStudDitete - Vyžadovat přílohu s potvrzením o studiu dítěte: 
                            //v - vždy, 
                            //p - nevyžadovat u dítěte s platným zvýhodněním v rodinných příslušnících, 
                            //m - nevyžadovat u dítěte s platným zvýhodněním se začátkem max. měsíc před platností prohlášení
                            string par = Parametry.ParametrCti("PotvrzOStudDitete");
                            if (par != "v")
                            {
                                StrRodPrislSleva slevaOld = KSProgram.Personal.RodPrisl.SlevaNacti(id_rod_prisl.Value, platiOd);
                                if (slevaOld.sleva != null && (slevaOld.sleva == "a" || slevaOld.sleva == "z"))
                                {
                                    if (par == "p")
                                    {
                                        vyzadovat = false;
                                    }
                                    else if (par == "m")
                                    {
                                        if (slevaOld.sleva_od != null && slevaOld.sleva_od >= platiOd.AddMonths(-1))
                                            vyzadovat = false;
                                    }
                                }
                            }
                            if (vyzadovat)
                                povinnePrilohy.Add("- potvrzení o studiu dítěte s RČ " + rcOrDatNar);
                        }
                        //PR 09.10.2020 přinutím je to zatrhnout, jinak akce zapsat slevu ukonci k 18. narozeninam.
                        if (vek_d >= 18 && zl != "1")
                        {
                            val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Zletilé dítě%] - [%řádek%] " + i + " - [%Zatrhněte, zároveň tím potvrzujete, že dítěti není přiznán invalidní důchod 3. stupně a že se soustavně připravuje na budoucí povolání!%]<br/>";
                        }
                    }
                }
            }//end for

            if (prefix == "D")
            {
                if (dodatecne && H_dod_upl == "XD" && dodat_zvyh_count == 0)
                    val.ErrorMessage += "[%Daňové zvýhodnění%] - [%Dodatečně za kalendářní měsíce%] - [%Není vyplněno ani u 1 dítěte%]<br/>";
            }
        }

        protected void ValidPg2_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator ValidPg2 = (CustomValidator)FormView1.FindControl("ValidPg2");
            ValidPg2.ErrorMessage = "";
            ValidPg2.Text = "";
            _povinnePrilohyStr2.Clear();//PR 14.01.2020 
            if (FakeMode == FormViewMode.ReadOnly) return;

            //string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok");
            //string H_obd_mes = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_mes");
            string H_dod_priz = WebControlHelper.SubCtrlGetValueString(FormView1, "H_dod_priz");

            //DateTime platiOd = new DateTime(DateTime.Today.Year, 1, 1);
            //if (!string.IsNullOrEmpty(H_obd_rok) && !string.IsNullOrEmpty(H_obd_mes))
            //    platiOd = new DateTime(int.Parse(H_obd_rok), int.Parse(H_obd_mes), 1);
            //else if (!string.IsNullOrEmpty(H_obd_rok))
            //    platiOd = new DateTime(int.Parse(H_obd_rok), 1, 1);
            DateTime platiOd = PlatiOd(); //PR 06.05.2022 

            string rc_pop = WebControlHelper.SubCtrlGetValueString(FormView1, "H_rc_pop");
            int vek_pop = 0;
            if (!string.IsNullOrEmpty(rc_pop))
                vek_pop = F_RodneCislo.Vek(rc_pop, platiOd);

            bool dodatecne = !string.IsNullOrEmpty(H_dod_priz) && H_dod_priz == "XD";

            WorkflowMaster wf = new WorkflowMaster(PozId, "danprohl", null);
            bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

            //PR 27.09.2019 u dodatečného prohlášení nelze dělat změny, u změn dětí chybí sloupce "dodatečně za kalendářní měsíce"
            if (dodatecne)
                zmeny = false;

            //PR 23.10.2018 pokud vracím požadavek k přepracování, tak musím vypnout kontrolu přítomnosti podpisu
            bool podpis_vyzadovan = true;
            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    WorkflowMaster m = new WorkflowMaster(PozId, "danprohl", null);//zjištění akt. fáze
                    Str_workfl_stavy str_stav_new = m.GetParamStavu(stav_new);
                    if (str_stav_new.sys_stav == "s" || (str_stav_new.next_faze != null && str_stav_new.next_faze.Value < m.FazeZprac))
                        podpis_vyzadovan = false;
                }
            }

            //PR 09.01.2019 pokud neuplatnuje na zadne dite zvyhodneni, tak nemusi byt vyplneno c) ani tabulka
            bool uplatnuje_deti = false;
            for (int i = 1; i <= 5; i++)
            {
                string por;
                if (!zmeny)
                    por = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_upl_por");
                else
                    por = WebControlHelper.SubCtrlGetValueString(FormView1, "X" + i + "_upl_por");
                //if (por != null && por != "N" /*tzn. aktualne 1,2,3*/)
                if (!string.IsNullOrEmpty(por) && por != "N" /*tzn. aktualne 1,2,3*/) //PR 15.01.2020 
                    uplatnuje_deti = true;
            }
            bool uplatnoval_deti_pred_zmenou = false;
            if (zmeny)
            {
                for (int i = 1; i <= 5; i++)
                {
                    string por = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_upl_por");
                    if (!string.IsNullOrEmpty(por) && por != "N" )//tzn. aktualne 1,2,3
                        uplatnoval_deti_pred_zmenou = true;
                }
            }
            /*
            //PR 04.05.2020 HID=51253 - možnost vyplnit bod c při změnách, pokud dříve zvýhodnění neuplatňoval a nyní uplatňuje.
            Toto tu bylo pro to, protože při změně byla zamknuta editace všech polí nad změnami a když "začíná uplatňovat zvýhodnění na děti", tak nešlo vyplnit bod c)
            //přesto kontrola hlásila - Vyživuje tytéž mnou vyživované děti i jiný poplatník - Není vyplněna povinná položka.
            //Nyní povolím editaci bodu c a údaje o manželce v případě, že nebyla vyplněna, takže tato kontrola již tu být nemusí.
            if (zmeny && uplatnoval_deti_pred_zmenou == false && uplatnuje_deti)
            {
                ValidPg2.ErrorMessage += "[%Pokud začínáte uplatňovat zvýhodnění na děti a doposud jste žádné neuplatňoval, nelze použít Změnovou část, neboť ta neumožňuje zadat údaje o manželce/manželovi.%] [%Vytvořte si nové prohlášení s platností od měsíce změny!%]<br/>";
                args.IsValid = false;
                ValidPg2.Text = ValidPg2.ErrorMessage;
            }*/

            //bod c) vyživuje tytéž mnou vyživované děti i jiný poplatník ANO/NE
            string H_vyz_jin_popl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_popl"); //ANO
            string H_vyz_jin_popl_ne = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_popl_ne"); //NE
            if (uplatnuje_deti && H_vyz_jin_popl == "" && H_vyz_jin_popl_ne == "")
            {
                //if (!string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "D1_jmeno")) || !string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "X1_jmeno")))
                //{   
                //    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Není vyplněna povinná položka%]<br/>";                    
                //}
                ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Není vyplněna povinná položka%]<br/>";
            }

            if (H_vyz_jin_popl == "X")
            {
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_jmeno") == "")
                    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Jméno%] - [%Není vyplněna povinná položka%]<br/>";
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_prijmeni") == "")
                    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Příjmení%] - [%Není vyplněna povinná položka%]<br/>";

                //if (Pozadavekdanprohl.RodPrislEditable) //<---- nyní je nastaveno, že není editační, vybírá se z rozbalovátka
                //{
                //    string H_vyz_jin_rc = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_rc");
                //    if (H_vyz_jin_rc == "")
                //        ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Rodné číslo%] - [%Není vyplněna povinná položka%]<br/>";
                //    if (!string.IsNullOrEmpty(H_vyz_jin_rc))
                //    {
                //        if (H_vyz_jin_rc.Length != 9) //9-ti místná RČ nebudu kontrolovat
                //        {
                //            Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
                //            MatchCollection m = r.Matches(H_vyz_jin_rc);
                //            if (m.Count != 1)
                //                ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Rodné číslo%] - [%Neplatný formát%]<br/>";
                //            else
                //            {
                //                int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
                //                int month = Int16.Parse(m[0].Groups[2].Value);
                //                int day = Int16.Parse(m[0].Groups[3].Value);
                //                int ext = Int16.Parse(m[0].Groups[4].Value);
                //                int mod = (year + month + day + ext) % 11;
                //                if (mod != 0)
                //                    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Rodné číslo%] - [%Neplatné rodné číslo%]<br/>";
                //            }
                //        }
                //    }

                //    //adresa manzelky:
                //    //------------------
                //    //string H_obec_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obec_vyz_jin");
                //    ////string H_ulice_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_ulice_vyz_jin"); v malé obci nemusí být ulice
                //    //string H_c_pop_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_pop_vyz_jin");
                //    ////string H_c_orient_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_orient_vyz_jin"); č. orientační nemusí být vyplněno
                //    //string H_psc_vyz_jin = WebControlHelper.SubCtrlGetValueString(FormView1, "H_psc_vyz_jin");
                //    //------------------
                //}
                string H_vyz_jin_upl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_upl");//manželka uplatňuje
                if (string.IsNullOrEmpty(H_vyz_jin_upl)) //PR 20.01.2020 HID=49784
                    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Uplatňuje daňové zvýhodnění ANO/NE%] - [%Není vyplněna povinná položka%]<br/>";
                string H_vyz_jin_zam = WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_zam");//manželka je zaměstnaná
                if (string.IsNullOrEmpty(H_vyz_jin_zam))//PR 20.01.2020 HID=49784
                    ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Zaměstnání ANO/NE%] - [%Není vyplněna povinná položka%]<br/>";
                if (H_vyz_jin_zam == "1")
                {

                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_vyz_jin_naz_platce") == "")
                        ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Název plátce daně%] - [%Není vyplněna povinná položka%]<br/>";
                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "H_obec_vyz_jin_pl") == "")
                        ValidPg2.ErrorMessage += "[%Vyživuje tytéž mnou vyživované děti i jiný poplatník%] - [%Adresa plátce daně%] - [%Obec%] - [%Není vyplněna povinná položka%]<br/>";
                    //string H_ulice_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_ulice_vyz_jin_pl"); v malé obci nemusí být ulice
                    //string H_c_pop_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_pop_vyz_jin_pl");
                    //string H_c_orien_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_c_orien_vyz_jin_pl"); č. orientační nemusí být vyplněno
                    //string H_psc_vyz_jin_pl = WebControlHelper.SubCtrlGetValueString(FormView1, "H_psc_vyz_jin_pl");
                }
                
                if (uplatnuje_deti)
                {
                    if (!zmeny || !(uplatnoval_deti_pred_zmenou && _manzelkaBylaVyplnena)) //PR 13.06.2022 pri zmene pokud jiz drive uplatnoval a mel manzelku nepozaduji znovu potvrzeni
                    {
                        if (H_vyz_jin_zam == "1") //manzelka je zamestnana
                            _povinnePrilohyStr2.Add("- potvrzení zaměstnavatele manžela/manželky/partnera/partnerky, že daňové zvýhodnění neuplatňuje");
                        else
                            _povinnePrilohyStr2.Add("- čestné prohlášení, že manžel/manželka/partner/partnerka daňové zvýhodnění neuplatňuje");
                    }
                }

            }

            //PODPISOVÁ ČÁST
            if (podpis_vyzadovan)
            {
                if (!zmeny && Vydavatel == Globals.OsCisloAktUserNeboZastupovany)
                {
                    if (dodatecne)
                    {
                        if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_prohl_dod") == "")
                            ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Dodatečně za uvedené zdaňovací období%] - [%sloupec%] [%Prokazatelně učiněné prohlášení poplatníkem%] - [%Chybí podpis%]<br/>";
                    }
                    else
                    {
                        if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_prohl") == "")
                            ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Na uvedené zdaňovací období%] - [%sloupec%] [%Prokazatelně učiněné prohlášení poplatníkem%] - [%Chybí podpis%]<br/>";
                    }
                }
                if (!zmeny && overeni)
                {
                    if (dodatecne)
                    {
                        if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_over_dod") == "")
                            ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Dodatečně za uvedené zdaňovací období%] - [%sloupec%] [%Ověření plátcem daně%] - [%Chybí podpis%]<br/>";
                    }
                    else
                    {
                        if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_over") == "")
                            ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Na uvedené zdaňovací období%] - [%sloupec%] [%Ověření plátcem daně%] - [%Chybí podpis%]<br/>";
                    }
                }
            }

            //ZMĚNOVÁ ČÁST
            bool zmena_zvyhodneni = false; //PR 03.05.2022 
            DateTime? datumNoveZmeny = null; 
            if (zmeny)
            {
                //DRUHY ZMĚN S PODPISY
                if (podpis_vyzadovan)
                {
                    int k = 1;
                    int pocetNovychZmen = 0; //bool dnesni = false;
                    string polozka = "Z" + k + "_d_zmeny";
                    //while (FindControl(polozka) != null)
                    while (FormView1.FindControl(polozka) != null)//PR 21.02.2019 chyba HID=45358
                    {
                        string druh_zmeny = WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + k + "_dr_zmeny");
                        int? mesic_zmeny = WebControlHelper.SubCtrlGetValueNumber(FormView1, "Z" + k + "_mes_zmeny");                        
                        DateTime? datZmeny = WebControlHelper.SubCtrlGetValueDate(FormView1, polozka);
                        DateTime? datOvereni = WebControlHelper.SubCtrlGetValueDate(FormView1, "Z" + k + "_d_over_zmeny");

                        bool aspon1SloupVyplnen = !string.IsNullOrEmpty(druh_zmeny) || mesic_zmeny != null || datZmeny != null;
                        //nova zmena to je pokud ma dnesni datum nebo pokud jeste neni overena nebo pokud je overena dnes (ucetni prave overuje)
                        bool novaZmena = aspon1SloupVyplnen && (datZmeny == DateTime.Today || datOvereni == null || (datOvereni != null && datOvereni == DateTime.Today));

                        if (novaZmena)
                        {
                            pocetNovychZmen++;
                            if (pocetNovychZmen == 1)
                                datumNoveZmeny = datZmeny;

                            if (string.IsNullOrEmpty(druh_zmeny)) //PR 16.09.2019 druh změny není vyplněn
                                ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Druh změny%] - [%Není vyplněna povinná položka%]<br/>";
                            else
                            {
                                if (druh_zmeny == "Sleva na inv. I. st. - od" || druh_zmeny == "Sleva na inv. II. st. - od" || druh_zmeny == "Sleva na inv. III. st. - od")
                                    _povinnePrilohyStr2.Add("- potvrzení o rozhodnutí z správy sociálního zabezpečení nebo doklad o výplatě invalidního důchodu - složenka nebo výpis z účtu");
                                else if (druh_zmeny == "Sleva na ZTP/P - od")
                                    _povinnePrilohyStr2.Add("- kopie průkazu ZTP/P");
                                else if (druh_zmeny == "Sleva na studenta - od")
                                {
                                    _povinnePrilohyStr2.Add("- potvrzení vysoké školy o zapsání ke studiu");
                                    if (vek_pop >= 28)
                                        ValidPg2.ErrorMessage += "[%Slevu na studenta lze uplatňovat pouze do 28 let věku%]<br/>";
                                }
                                else if (druh_zmeny.StartsWith("Zvýhodnění")) //PR 03.05.2022  
                                {
                                    zmena_zvyhodneni = true;
                                    //povinne prilohy se urci dle tabulky deti

                                    //PR 14.06.2022 zkontroluji, zda je (nově narozené) dítě uvedeno v tabulce dětí, jinak se změna při ověření nepropíše.
                                    //Tabulka totiž může být vyplněna z předchozí změny (asi není dobře, že tabulku dětí mohou přepisovat a není tak zachována historie pořadí, ale).
                                    if (druh_zmeny.StartsWith("Zvýhodnění na ") && (druh_zmeny.EndsWith(" - od") || druh_zmeny.EndsWith(" - do")))
                                    {
                                        string jm = druh_zmeny.Substring(14, druh_zmeny.Length - 19);
                                        bool diteVyplneno = false;
                                        for (int i = 1; i <= 5; i++)
                                        {
                                            if (jm == WebControlHelper.SubCtrlGetValueString(FormView1, "X" + i + "_jmeno"))
                                            {
                                                diteVyplneno = true;
                                                //Zároveň zkontroluji, pokud zadal "od", zda uvedl pořadí
                                                string por = WebControlHelper.SubCtrlGetValueString(FormView1, "X" + i + "_upl_por");
                                                if (druh_zmeny.EndsWith(" - od") && (por == "N"))
                                                {
                                                    string msg = ReadGlobalResource.ZmenaTextu("[%Zadali jste změnu „{0}“, ale v tabulce vyživovaných dětí je u něj uvedeno „N“, tj. bez zvýhodnění!%]", druh_zmeny);
                                                    ValidPg2.ErrorMessage += $"[%Změnová část%] - [%Daňové zvýhodnění%] - {msg}<br/>";
                                                }
                                                break;
                                            }
                                        }
                                        if (!diteVyplneno)
                                        {
                                            string msg = ReadGlobalResource.ZmenaTextu("[%Zadali jste změnu „{0}“, ale v tabulce vyživovaných dětí toto dítě chybí, použijte tlačítko „Předvyplnit“!%]", druh_zmeny);
                                            ValidPg2.ErrorMessage += $"[%Změnová část%] - [%Daňové zvýhodnění%] - {msg}<br/>";
                                        }
                                    }
                                }

                                //PR 10.06.2022 kontrola zda měsíc změny nezasahuje do uzavřeného období
                                //PR 14.06.2022 vyměkl jsem - co když už mu účetní slevy navedla a nyní opožděně vyplňuje formulář?
                                //if (mesic_zmeny != null && druh_zmeny != null && druh_zmeny != "Beze změny - přidání přílohy")
                                //{
                                //    DateTime aktObd = ViceIco.ObdobiPodnikuPodleZamestnance(Vydavatel);
                                //    DateTime? zmena_od = null;
                                //    if (druh_zmeny.EndsWith(" do"))
                                //    {
                                //        zmena_od = new DateTime(Rok(), mesic_zmeny.Value, 1).PosledniDen().AddDays(1);//pokud slevu ukoncim k poslednimu, tak zmena je od nasl. mesice
                                //        if (zmena_od.Value < aktObd)
                                //            ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Kalendářní měsíc%] - [%Slevu lze ukončit pouze k minulému období%]<br/>";
                                //    }
                                //    else if (druh_zmeny.EndsWith(" od"))
                                //    {
                                //        zmena_od = new DateTime(Rok(), mesic_zmeny.Value, 1);
                                //        if (zmena_od.Value < aktObd)
                                //            ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Kalendářní měsíc%] - [%Slevu lze začít uplatňovat až od aktuálního období.%] [%Slevy, které jste si nestihli uplatnit ve mzdě, si můžete uplatnit až dodatečně při ročním zúčtování%]<br/>";
                                //    }
                                //}

                            }

                            if (mesic_zmeny == null) //PR 16.09.2019 měsíc změny není vyplněn
                                ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Kalendářní měsíc%] - [%Není vyplněna povinná položka%]<br/>";

                            if (overeni && datOvereni == null)
                                ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Ověření plátcem daně%] - [%Chybí řádek s podpisem dnešního data%]<br/>";
                        }
                        k++;
                        polozka = "Z" + k + "_d_zmeny";//PR 30.11.2018 
                    }
                    if (pocetNovychZmen == 0 && !overeni) //nezadal zadnou novou zmenu - musi nejakou zadat
                        ValidPg2.ErrorMessage += "[%Změnová část%] - [%sloupec%] [%Změna oznámena poplatníkem%] - [%Chybí řádek s podpisem dnešního data%]<br/>";                    
                }

                //DĚTI
                ValidaceZvyhodneni("X", platiOd, ValidPg2, _povinnePrilohyStr2); //PR 06.05.2022 kód dán do funkce

                //PR 03.05.2022 pokud vyplnil druh změny "Zvýhodnění*", tak musí vyplnit tabulku dětí
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "X1_prijmeni") == "" && zmena_zvyhodneni) 
                {
                    ValidPg2.ErrorMessage += "[%Změnová část%] - [%Daňové zvýhodnění%] - [%Tabulku vyživovaných dětí je nutno vyplnit, neboť jste zadali druh změny „Zvýhodnění ...“!%]<br/>";
                }
                
            }//zmeny

            //PR 09.12.2019 kontrola počtu příloh
            if (Parametry.ParametrCti("DanPocetPriloh") == "a") //PR 15.01.2020 
            {
                PrilohyManager prilohy = (PrilohyManager)WebControlHelper.FindControl(Page, "uc_prilohy");
                if (prilohy.Mode != FormViewMode.ReadOnly && !overeni)
                {
                    int pocetNahranychPriloh;
                    if (zmeny)
                    {
                        if (datumNoveZmeny.HasValue)
                            pocetNahranychPriloh = prilohy.PocetNahranychPrilohOdData(datumNoveZmeny.Value);
                        else
                            pocetNahranychPriloh = prilohy.PocetNahranychPrilohOdData(DateTime.Today);
                    }
                    else
                        pocetNahranychPriloh = prilohy.PocetNahranychPriloh;
                    if (pocetNahranychPriloh < _povinnePrilohyStr1.Count + _povinnePrilohyStr2.Count)
                    {
                        ValidPg2.ErrorMessage += "Nedostatečný počet příloh: nahráno " + pocetNahranychPriloh + ", požadováno " + (_povinnePrilohyStr1.Count + _povinnePrilohyStr2.Count) + ", požadované přílohy:<br/>";
                        if (_povinnePrilohyStr1.Count > 0)
                            ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohyStr1) + "<br/>";
                        if (_povinnePrilohyStr2.Count > 0)
                            ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohyStr2);
                    }
                }
            }

            if (ValidPg2.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPg2.Text = ValidPg2.ErrorMessage;
            }
        }


        protected void FormView1_ItemCommand(object sender, FormViewCommandEventArgs e)
        {
            switch (e.CommandName)
            {
                case "podp_bezne_popl":
                    if (Globals.OsCisloAktUserNeboZastupovany == Vydavatel)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_prohl_kod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "P_prohl_kod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_prohl_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_d_prohl", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "podp_dodat_popl":
                    if (Globals.OsCisloAktUserNeboZastupovany == Vydavatel)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_prohl_kod_dod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "P_prohl_kod_dod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_prohl_kod_dod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_d_prohl_dod", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "podp_bezne_over":
                    if (Globals.OsCisloAktUserNeboZastupovany != Vydavatel || Globals.SuperUser)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_over_kod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "P_over_kod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_over_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_d_over", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "podp_dodat_over":
                    if (Globals.OsCisloAktUserNeboZastupovany != Vydavatel || Globals.SuperUser)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_over_kod_dod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "P_over_kod_dod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_over_kod_dod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_d_over_dod", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "podp_zm":
                    if (Globals.OsCisloAktUserNeboZastupovany == Vydavatel)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + e.CommandArgument + "_zmena_kod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_zmena_kod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_zmena_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_d_zmeny", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "podp_zm_over":
                    if (Globals.OsCisloAktUserNeboZastupovany != Vydavatel || Globals.SuperUser)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + e.CommandArgument + "_zmena_over_kod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_zmena_over_kod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_zmena_over_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "Z" + e.CommandArgument + "_d_over_zmeny", empty ? DateTime.Today.ToShortDateString() : "");
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;
                case "z_deti":
                case "deti":
                    //  string sql = "SELECT rod_prisl.jmeno, rod_prisl.prijmeni, rod_prisl.rodne_cislo, rod_prisl_slevy.sleva, rod_prisl_slevy.poradi, rod_prisl_slevy.sleva_od, rod_prisl_slevy.sleva_do "
                    //+ " FROM rod_prisl LEFT OUTER JOIN rod_prisl_slevy ON rod_prisl.id_rod_prisl = rod_prisl_slevy.id_rod_prisl  "
                    //+ " WHERE rod_prisl.os_cislo = @osc AND rod_prisl.vztah IN ('syn','dcera','dítě','vnuk','vnučka','v péči') "
                    //+ " AND ((rod_prisl_slevy.sleva IS NULL) OR ((rod_prisl_slevy.sleva_od IS NULL OR rod_prisl_slevy.sleva_od <= @dat1) AND (rod_prisl_slevy.sleva_do IS NULL OR rod_prisl_slevy.sleva_do >= @dat2)))"
                    //+ " ORDER BY rod_prisl_slevy.poradi";
                    //  ParametryPrikazu par = new ParametryPrikazu() { new KSParameter("osc", Vydavatel), new KSParameter("dat1", DateTime.Today), new KSParameter("dat2", DateTime.Today) };
                    //  using (IDataReader reader = SqlPrikaz.ExecuteReader(sql, ref par))
                    //  {
                    //      int i = 0;
                    //      while (reader.Read())
                    //      {
                    //          i++;
                    //          if (i > 5) break;

                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_jmeno", GetNullOrData.GetString(reader, 0, "", true));
                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_prijmeni", GetNullOrData.GetString(reader, 1, "", true));
                    //          string rc = GetNullOrData.GetString(reader, 2, "", true);
                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_rc", rc);
                    //          int vek = F_RodneCislo.Vek(rc, DateTime.Today);
                    //          string sleva = GetNullOrData.GetString(reader, 3, "", true);//Ne	n/  Ano	a/  ZTP-P	z;
                    //          int poradi = GetNullOrData.GetInt32(reader, 4, 0);
                    //          if (poradi > 0 && vek >= 26) poradi = 0; //jeste nezrusili slevu
                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_upl_por", poradi == 0 ? "N" : poradi.ToString());
                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_ztp", (sleva == "z") ? "1" : "0");
                    //          WebControlHelper.SubCtrlSetValue(FormView1, "X" + i + "_zletile", ((poradi > 0) && (vek >= 18 && vek < 26)) ? "1" : "0" ); //má navedenu slevu a zároveň je zletilé
                    //      }
                    //  }
                    //PR 09.10.2020 pokud ve změnové části nevyplnil druh změny "Zvýhodnění..", tak mu znemožním předvyplnit děti                    
                    if (e.CommandName == "z_deti")
                    {
                        bool zmena_zvyhodneni = false;
                        int k = 1;
                        while (WebControlHelper.FindControl(FormView1, "Z" + k + "_dr_zmeny") != null)
                        {
                            //může být více změn v průběhu roku, takže vezmu jen změny ověřené dnes                            
                            DateTime? datPosledniZmeny = WebControlHelper.SubCtrlGetValueDate(FormView1, "Z" + k + "_d_zmeny");
                            if (datPosledniZmeny == null || datPosledniZmeny == DateTime.Today) //ještě nepodepsal nebo podepsal dne               
                            {
                                string druh_zmeny = WebControlHelper.SubCtrlGetValueString(FormView1, "Z" + k + "_dr_zmeny");
                                if (druh_zmeny.StartsWith("Zvýhodnění")) //PR 09.10.2020 
                                {
                                    zmena_zvyhodneni = true;
                                }
                            }
                            k++;
                        }
                        if (!zmena_zvyhodneni)
                        {
                            MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nejprve v tabulce výše vyberte jeden z druhů změn začínajících slovem Zvýhodnění%]"));
                            break;
                        }
                    }
                    string prefix = (e.CommandName == "z_deti") ? "X" : "D";
                    PredvyplnDeti(prefix);//PR 06.05.2022 dáno do funkce
                    break;
            }
        }

        protected void PredvyplnDeti(string prefix)
        {
            int i = 0;
            List<StrRodPrisl> deti = new List<StrRodPrisl>();
            //int pocetDeti = Pozadavekdanprohl.GetDeti(Vydavatel, DateTime.Today, ref deti);
            //PR 09.11.2020 načtu děti k začátku roku, ať to neoflitruje děti, které dovršili 26l během roku (můžou to vyplňovat zpětně)
            int pocetDeti = Pozadavekdanprohl.GetDeti(Vydavatel, new DateTime(DateTime.Today.Year, 1, 1), ref deti);
            //PR 06.05.2022 ale věk a slevy načtu ke dni změny
            DateTime keDni = PlatiOd();
            foreach (StrRodPrisl dite in deti)
            {
                i++;
                int vek = 0;//F_RodneCislo.Vek(dite.rodne_cislo, keDni); 
                if (dite.datum_narozeni != null)
                    vek = F_DateTime.YearsAfter(dite.datum_narozeni.Value, keDni);//PR 02.01.2020
                WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_jmeno", dite.jmeno);
                WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_prijmeni", dite.prijmeni);
                //PR 06.05.2022 dítě cizinec - uvádí se datum narození
                if ((string.IsNullOrEmpty(dite.rodne_cislo) || dite.rodne_cislo.EndsWith("000")) && dite.datum_narozeni.HasValue)
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", dite.datum_narozeni.Value.ToString("d.M.yyyy", System.Globalization.CultureInfo.InvariantCulture));
                else
                    WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_rc", dite.rodne_cislo);

                StrRodPrislSleva dite_sleva = KSProgram.Personal.RodPrisl.SlevaNacti(dite.id_rod_prisl, keDni);
                WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_upl_por", (dite_sleva.poradi == null || dite_sleva.poradi == 0) ? "N" : dite_sleva.poradi.Value.ToString());
                WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_ztp", (dite_sleva.sleva != null && dite_sleva.sleva == "z") ? "1" : "0");
                WebControlHelper.SubCtrlSetValue(FormView1, prefix + i + "_zletile", ((dite_sleva.poradi != null && dite_sleva.poradi.Value > 0) && (vek >= 18 && vek < 26)) ? "1" : "0"); //má navedenu slevu a zároveň je zletilé

                if (i == 5) break;
            }
            if (pocetDeti == 0)
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Chybí dítě?%] [%Požádej o doplnění přes požadavek žádost o změnu osobních údajů.%]"));
        }

        protected void DDL_manzelka_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            DataView dv = ODS_manzelky.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                //PR 10.12.2021 id_rod_prisl (RC muze byt z historickych duvodu null)
                if (dv[i]["id_rod_prisl"].Equals(DBNull.Value))
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_id", "");
                else
                    WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_id", (int)dv[i]["id_rod_prisl"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_vyz_jin_rc", (string)dv[i]["rc"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_ulice_vyz_jin", (string)dv[i]["ulice"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_c_pop_vyz_jin", (string)dv[i]["c_pop"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_obec_vyz_jin", (string)dv[i]["obec"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "H_psc_vyz_jin", (string)dv[i]["psc"]);
                //break;
            }
            //}
        }

        protected void H_dod_priz_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            NastavEditovatelnostKontrolek(null);

            //PR 14.01.2021 aby při XD zmizela kontrola na podané prohlášení v běžném roce
            if (PozId == 0 || WF.FazePosl == 0)
            {
                Page.Validate(ValidPre.ValidationGroup);
            }
        }


        protected void Page_PreRender(object sender, EventArgs e)
        {
            if (Thread.CurrentThread.CurrentCulture.Name == "en-US")
            {
                //staticka promenna - obsah tam zustava
                if (preklady.Count == 0)
                {
                    preklady.Add("PROHLÁŠENÍ", "DECLARATION");
                    preklady.Add("poplatníka daně z příjmů fyzických osob ze závislé činnosti", "of the taxpayer liable to personal income tax from dependent activity for tax");
                    preklady.Add("pro zdaňovací období (pro část zdaňovacího období)", "period (for part of the taxable period)");

                    preklady.Add("Prohlášení k dani činím / dodatečně činím", "The declaration is made / is additionally made");
                    preklady.Add("podle § 38k zákona č. 586/1992 Sb., o daních z příjmů, ve znění pozdějších předpisů", "pursuant to Section 38k of Act No. 586/1992 Coll., on Income Taxes, as amended");
                    preklady.Add("(dále jen „zákon“) pro plátce daně (zaměstnavatele)", "(hereinafter the “Act“) for the taxpayer (the employer)");
                    
                    preklady.Add("Název plátce daně", "Employer name");
                    preklady.Add("Ulice / část obce", "Street / part of village");
                    preklady.Add("Číslo popisné / orientační", "Descriptive / reference number");
                    preklady.Add("Obec", "Village");
                    preklady.Add("PSČ", "ZIP code");

                    preklady.Add("Identifikace poplatníka", "Taxpayer’s identification");//Identification of the taxpayer (employee)
                    preklady.Add("Příjmení", "Surname");
                    preklady.Add("Jméno(-a)", "Given name(s)");//First name(s)
                    preklady.Add("Rodné číslo", "PIN");
                    
                    preklady.Add("Adresa bydliště  (místo trvalého pobytu)", "Permanent stay");
                    preklady.Add("Číslo pop./orient.", "Descrip./ref. number");

                    preklady.Add("Daňový nerezident ČR dále vyplní:", "Following fi elds will be fi lled by tax non-resident of the Czech Republic:");
                    preklady.Add("Datum narození", "Date of birth");

                    preklady.Add("Číslo a typ dokladu prokazující totožnost poplatníka", "Number and type of document proving taxpayer’s identification");
                    
                    preklady.Add("Stát, který tento doklad vydal", "State, which issued the document");
                    preklady.Add("Identifikace pro daňové účely ve státu daňové rezidence", "Tax purpose identifi cation in the state of tax residence");
                    preklady.Add("Stát, jehož jste daňovým rezidentem", "State of your tax residence");

                    preklady.Add("použijte např. při dalším nástupu ke stejnému plátci daně v průběhu uvedeného zdaňovacího období (např „od září RRRR“)", "use, for example, at the next taking up employment of the same tax payer during the tax period, (eg “from September YYYY“)");
                    preklady.Add("označte „<b>XD</b>“, pokud činíte prohlášení k dani dodatečně podle § 38k odst. 7 zákona v rámci žádosti o roční zúčtování záloh a daňového zvýhodnění", "please mark <b>“XD“</b> if you make a tax return additionally pursuant to Section 38k subsection 7 of the Act as part of the application for annual settlement of advances and tax benefits");
                    
                    preklady.Add("Podle § 35ba odst. 1 zákona uplatňuji", "According to Section 35ba subsection 1 of the Act, I apply");
                    preklady.Add("<b>Základní slevu na poplatníka</b> (písm. a)", "<b>Personal tax allowance</b> (letter a)");
                    
                    preklady.Add("<b>Základní slevu na invaliditu</b> (písm. c)", "<b>Basic personal tax allowance for a disabled person</b> (letter C)");
                    preklady.Add("a prohlašuji, že mi byl přiznán invalidní důchod pro invaliditu I. nebo II. stupně z důchodového pojištění podle zákona o důchodovém", "and declare that I was granted an invalidity pension for disability I or II");
                    preklady.Add("pojištění nebo že mi zanikl nárok na invalidní důchod pro invaliditu I. nebo II. stupně z důvodu souběhu nároku na výplatu tohoto", "degree of pension insurance under the Act on Pension Insurance or that my entitlement to invalidity pension for invalidity I or II degree");
                    preklady.Add("invalidního důchodu a starobního důchodu", "has expired due to the concurrence of entitlement to the payment of this disability pension and old-age pension");
                    
                    preklady.Add("<b>Rozšířenou slevu na invaliditu</b> (písm. d)", "<b>Extended personal tax allowance for a disabled person</b> (letter d)");
                    preklady.Add("a prohlašuji, že mi byl přiznán invalidní důchod pro invaliditu III. stupně nebo jiný důchod z důchodového pojištění podle zákona", "and I declare that I was granted an invalidity pension for III degree invalidity or other pension insurance pension under the Retirement");
                    preklady.Add("o důchodovém pojištění, u něhož jednou z podmínek přiznání je, že jsem invalidní ve III. stupni, zanikl mi nárok na invalidní důchod", "Insurance Act, for which one of the conditions of the admission is that I am a III degree invalid, invalidated my invalidity pension for");
                    preklady.Add("pro invaliditu III. stupně z důvodu souběhu nároku na výplatu invalidního důchodu pro invaliditu III. stupně a starobního důchodu nebo", "III degree due to the concurrence of the entitlement to disability pension for disability III degree and old-age pension, or that I am invalid");
                    preklady.Add("že jsem podle zvláštních předpisů invalidní ve III. stupni, avšak žádost o invalidní důchod pro invaliditu III. stupně mi byla zamítnuta", "in III degree according to special regulations but the invalidity claim for degree III invalidity was refused for reasons other than because");
                    preklady.Add("z jiných důvodů než proto, že nejsem invalidní ve III. stupni", "I am not disable in III degree");
                    
                    preklady.Add("<b>Slevu na držitele průkazu ZTP/P</b> (písm. e)", "<b>Personal tax allowance to ZTP/P card holder</b> (letter e)");
                    preklady.Add("a prohlašuji, že mi byl přiznán nárok na průkaz ZTP/P", "and I declare that I was eligible for a ZTP/P card");
                    
                    preklady.Add("<b>Slevu na studenta</b> (písm. f)", "<b>Personal tax allowance for the student</b> (letter f)");
                    preklady.Add("a prohlašuji, že se soustavně připravuji na budoucí povolání studiem nebo předepsaným výcvikem (do 26 let) nebo po dobu prezenční", "and I declare that I am constantly preparing for future vocation by studying or");
                    preklady.Add("formy studia v doktorském studijním programu, který poskytuje vysokoškolské vzdělání (do 28 let)", "prescribed training (up to 26 years of age) or for a full-time study in a doctoral study program that provides higher education (up to 28 years of age)");
                    
                    preklady.Add("označte „<b>X</b>“ slevu na dani, kterou uplatňujete. Uplatňujete-li slevu na dani až dodatečně, tj. v rámci ročního zúčtování záloh a daňového zvýhodnění, označte", "mark “<b>X</b>“ the tax credit you apply. Applying the tax credit additionally, i.e. in the context of the annual settlement of advances and tax benefits, indicate the tax credit");
                    preklady.Add("předmětnou slevu na dani „<b>XD</b>“a do stejného políčka uveďte i kalendářní měsíce, za které příslušnou slevu na dani dodatečně uplatňujete (např. „XD 9–12“)", "“<b>XD</b>“ and in the same box fi ll the calendar months for which you apply the relevant tax credit (eg “XD 9–12“)");
                    
                    preklady.Add("Podle § 35c a § 35d zákona uplatňuji", "Pursuant to Section 35c and Section 35d of the Act, I apply");
                    preklady.Add("dodatečně uplatňuji<sup>5)</sup> daňové zvýhodnění<sup>3)</sup>", "additionally apply <sup>5)</sup> a tax benefits<sup>3)</sup>");

                    preklady.Add("na mnou vyživované dítě/děti podle § 35c odst. 6 zákona a podle § 38k odst. 4 písm. c) zákona uvádím v níže uvedené tabulce, <b>jaký je počet těchto</b>", "on the child that I maintained pursuant to Section 35c subsection 6 of the Act and pursuant to section 38k subsection 4 letter c) of the Act). I mentionin");
                    preklady.Add("<b>vyživovaných dětí</b> žijících v mé společně hospodařící domácnosti na území členského státu EU nebo EHP a současně uvádím, <b>na které děti uplatňuji/</b>", "table below, <b>what is the number of maintained children</b> living with me in the household situated in the territory of a member state of the EU or member");
                    preklady.Add("<b>neuplatňuji</b> daňové zvýhodnění ve výši náležející podle § 35c odst. 1 zákona", "state of the EEA, and I also mention <b>on which children I apply / I don’t apply</b> the tax benefit in the amount pursuant to Section 35c subsection 1 of the Act");
                    
                    preklady.Add("Uplatňuji/neuplatňuji<br />nárok ve výši na", "I apply/I don’t apply the claim in the amount set for");
                    preklady.Add("ZTP/P<sup>4)</sup>", "Severely disabled <sup>4)</sup>");
                    preklady.Add("Zletilé <br />dítě", "Adult child");
                    preklady.Add("Dodatečně <br />za kalendářní<br /> měsíce", "Additionally in <br />calendar months");
                    
                    //3)
                    preklady.Add("tabulku vyplňte pouze v případě, že uplatňujete daňové zvýhodnění. Do tabulky vyplňte všechny Vámi vyživované děti žijící ve Vaší společně hospodařící", "The table is filled only if you apply tax benefit. If you apply the tax benefit than fill in all maintained children living in your jointly-owned household into the table");
                    preklady.Add("domácnosti, a to bez ohledu na jejich další uplatnění. Dále děti, na které uplatňujete daňové zvýhodnění označte podle výše nároku: na jedno dítě označte „<b>1.</b>“,", "regardless of their further application. In column “I apply the claim in the amount set for” one child – mark “<b>1</b>”, the second child – mark „<b>2</b>“, the third and each");
                    preklady.Add("na druhé dítě označte „<b>2.</b>“, na třetí a každé další vyživované dítě označte „<b>3.</b>“, a děti, na které daňové zvýhodnění neuplatňujete, označte „<b>N</b>“", "subsequent maintained child - mark „<b>3</b>“, I don’t apply – mark „<b>N</b>“.");
                    //4)
                    preklady.Add("dále u jednotlivých uplatňovaných dětí označte „<b>X</b>“ splněnou podmínku – tzn. u sloupce ZTP/P vyznačte, kterému z dětí byl přiznán nárok na průkaz ZTP/P", "The fulfilled condition is marked “<b>X</b>” for each child that is applied – i.e. in column “severely disabled mark which of children has a claim to card of severe disability.");
                    preklady.Add("a u sloupce „Zletilé dítě“ označte „<b>X</b>“, které z dětí je zletilé (do 26 let) a není mu přiznán invalidní důchod pro invaliditu III. stupně a splňuje další podmínky uvedené", "In column “Adult Child” mark which of children is adult (till 26 years) and does not receive the claim to 3rd degree disability pension and fulfils conditions listed in");
                    preklady.Add("v § 35c odst. 6 písm. b) bod 1. až 3. zákona", "the Section 35c subsection 6 letter b) point 1 to 3 of the Act");
                    //5)
                    preklady.Add("pokud uplatňujete daňové zvýhodnění až dodatečně v rámci žádosti o roční zúčtování záloh a daňového zvýhodnění, pak v nadpisu této části označte „<b>XD</b>“,", "if you apply a tax benefit additionally in the application for the annual settlement of advances and tax benefits, then mark “<b>XD</b>“ in the title of this part, and fill in the");
                    preklady.Add("a zároveň vyplňte v posledním sloupci tabulky kalendářní měsíce, za které dodatečně uplatňujete daňové zvýhodnění ( např. 9–12)", "last column of the table of the calendar month for which you additionally apply a tax benefit (eg 9-12)");
                    
                    preklady.Add("25 5457 &nbsp; MFin 5457 - vzor č. 26", "25 5457/AJ &nbsp; MFin 5457/AJ - model no. 26");
                    //2.strana
                    preklady.Add("Podle § 38k odst. 4 zákona prohlašuji, že:", "Pursuant to Section 38k subsection 4 of the Act, I declare that:");
                    //a)
                    preklady.Add("současně <b>neuplatňuji</b> za stejné zdaňovací období ani za stejný kalendářní měsíc zdaňovacího období <b>nárok na slevy na dani podle § 35ba</b>", "<b>I do not</b> continuously <b>apply</b> for the same taxable period nor even for the same calendar month of the taxable period <b>claim on a tax relief pursuant</b>");
                    preklady.Add("zákona u jiného plátce daně a že současně na stejné období kalendářního roku jsem neučinil(-a) u jiného plátce daně prohlášení k dani,", "<b>Section 35ba of the Act</b> by another taxable person and that I currently did not signe the tax declaration by another taxable person for the same taxable period");
                    //b)
                    preklady.Add("současně za stejné zdaňovací období ani za stejný kalendářní měsíc zdaňovacího období <b>neuplatňuji daňové zvýhodnění</b> na mnou vyživované", "I do not continuosly apply for the <b>tax benefit</b> for the maintained child by another taxable person and that another person do not apply the tax benefit");
                    preklady.Add("dítě u jiného plátce daně a že daňové zvýhodnění na to samé vyživované dítě neuplatňuje jiná osoba,", "for the same maintained child for the same taxable period nor even for the same calendar month of the taxable period");
                    //c)
                    preklady.Add("v rámci téže společně hospodařící domácnosti <b>vyživuje tytéž mnou vyživované děti i jiný poplatník ANO</b>", "The taxpayer below <b>maintains the same children as me within household YES</b>");
                    preklady.Add("<b> NE </b>", "<b> NO </b>");
                    
                    preklady.Add("Rodné   číslo", "Personal identification number");
                    preklady.Add("Uplatňuje daňové<br/>zvýhodnění ANO/NE", "Applies a tax benefit YES/NO");
                    preklady.Add("Zaměstnání ANO/NE", "Employment YES/NO");
                    preklady.Add("Adresa bydliště<br/>(místo trvalého pobytu)", "Residence address <br/>(Address of permanent stay)");
                    preklady.Add("Ulice", "Street");
                    preklady.Add("Adresa plátce daně", "Adress of the Employer");
                    //6)
                    preklady.Add("pokud daňové zvýhodnění neuplatňujete, bod c) ani tabulku nevyplňujte", "if you do not apply the tax benefit, point c) do not fill in the table");
                    //6a)
                    preklady.Add("za předpokladu, že ve společně hospodařící domácnosti vyživuje děti pouze jeden poplatník, který zároveň uplatňuje daňové zvýhodnění, označte křížkem", "If children are maintained by one taxpayer within household who applies tax benefit, marks “<b>X</b>“ variant <b>NO and do not fill in the table</b>. Fill in the table if you");
                    preklady.Add("variantu <b>NE a tabulku nevyplňujte</b>. Tabulku vyplňte vždy, pokud křížkem označíte variantu <b>ANO</b>, tzn., že v téže společně hospodařící domácnosti vyživuje děti", "marked “<b>X</b>“ variant <b>YES</b>, if you apply tax benefit and children are also maintained by another taxpayer within the household. Fill in the identification data of second ");
                    preklady.Add("i jiný poplatník. Uveďte identifikační údaje druhého poplatníka a vyberte zvolenou variantu – zda druhý z poplatníků uplatňuje či neuplatňuje daňové zvýhodnění", "taxpayer and choose the variant – whether the second taxpayer also applies tax benefit.");
                    //7)
                    preklady.Add("pokud je druhý z poplatníků také zaměstnán (ve sloupci „Zaměstnání“ je uvedeno „ANO“), pak bez ohledu na skutečnost, zda tento poplatník u svého plátce daně", "If the second taxpayer is employed, into column “Employment” fill in “<b>YES</b>”, regardless the fact whether the taxpayer applies or does not apply tax benefit - fill in");
                    preklady.Add("(zaměstnavatele) uplatňuje či neuplatňuje daňové zvýhodnění – uveďte vždy název a adresu tohoto plátce daně", "Taxpayer name and Address of the taxpayer.");
                    
                    preklady.Add("<b>Dojde-li během zdaňovacího období ke změně skutečností</b> rozhodných pro výpočet záloh na daň a daně nebo ke změně podmínek pro poskytnutí", "<b>If there will be during the taxable period any change of facts</b> important for the tax advance calculation and for tax or if there will be any change of condition");
                    preklady.Add("slev na dani, nebo daňového zvýhodnění, oznámím v souladu s § 38k odst. 8 zákona tuto změnu plátci daně (použijte např. změnové tabulky) nejpozději", "for providing tax exemptions pursuant Section 38k subsection 8 of the act or tax benefit I will literally notify it to the taxable person (e.g. by change in the");
                    preklady.Add("poslední den kalendářního měsíce, v němž změna nastala nebo v němž bylo o změně rozhodnuto.", "change table) on the last day of the calendar month at the least, in which the change occurred or in which the change was decided.");
                    
                    preklady.Add("Jsem <b>si vědom(-a)</b> následků nepravdivého prohlášení, a jsem si vědom(-a) toho, že vzniklý rozdíl z nesprávně sražené zálohy na daň z příjmů fyzických", "I am aware of the consequences of a false statement, and I am aware that the difference between the improperly deducted advance on the personal");
                    preklady.Add("osob ze závislé činnosti a neoprávněně vyplaceného daňového bonusu, který vznikl mým zaviněním, bude v plné výši spolu s úrokem z prodlení sražen", "income tax on dependent activity and the unjustifiably paid tax bonus resulting from my fault will be the full amount, together with interest on late payment,");
                    preklady.Add("z mé mzdy.", "is deducted from my wages.");
                    
                    preklady.Add("Podpisová část", "Signature part");
                    preklady.Add("Potvrzuji pravdivost a úplnost údajů uvedených v tomto prohlášení a prokazuji je příslušnými doklady podle § 38l zákona", "I confirm the truthfulness and completeness of the information filled in this declaration and certify them by the relevant documents pursuant to Section 38l of the Act");

                    preklady.Add("Prokazatelně<br/>učiněné prohlášení poplatníkem<sup>8)</sup><br/>(písemně, elektronicky) a datum", "Provably made declaration by the taxpayer<sup>8)</sup><br/>(in writing, electronically)<br/>and the date");
                    preklady.Add("Ověření plátcem daně<sup>9)</sup><br/>(písemně, elektronicky) a datum", "Verification by the taxpayer<sup>9)</sup><br/>(in writing, electronically) and the date");
                    preklady.Add("Na uvedené zdaňovací období", "For the tax period mentioned");
                    preklady.Add("Dodatečně za uvedené zdaňovací období<br />(podle § 38k odst. 7 zákona)", "Additionally for the tax period (pursuant to<br />Section 38k subsection 7 of the Act)");
                    //8)
                    preklady.Add("rozumí se projev vůle poplatníka, buď písemně (podpis) nebo elektronicky", "is the expression of the will of the taxpayer, either in writing (signature) or electronically");
                    //9)
                    preklady.Add("plátce daně ověřil nárok na slevy na dani podle § 35ba zákona a nárok na daňové zvýhodnění podle § 35c a § 35d zákona", "the taxpayer verified the entitlement to tax allowance under Section 35ba of the Act and the claim to a tax benefit under Section 35c and Section 35d of the Act");
                    
                    preklady.Add("Změnová část", "The change part");
                    preklady.Add("Podle § 38k odst. 8 zákona oznamuji změny v již uvedených skutečnostech pro uvedené zdaňovací období", "Under Section 38k subsection 8 of the Act, I am announcing changes in the above mentioned facts for the mentioned tax period");
                    preklady.Add("Druh změny", "Type of change");
                    preklady.Add("Kalendářní měsíc,<br />v  němž změna nastala<br />nebo v němž bylo<br />o  změně rozhodnuto", "Calendar month,<br />in which the change<br />occured or in which the<br />change was decided");
                    preklady.Add("Změna oznámena poplatníkem<sup>10)</sup><br />(písemně, elektronicky) a datum", "Change notified by taxpayer<sup>10)</sup><br />(in writing, electronically) and the date");
                    preklady.Add("Ověření plátcem daně<sup>9) 10)</sup><br />(písemně, elektronicky) a datum", "Verification by the taxpayer<sup>9) 10)</sup><br />(in writing, electronically) and the date");
                    //10)
                    preklady.Add("rozumí se podpis včetně datumu podpisu a vztahuje se i ke změnové tabulce na daňové zvýhodnění", "means the signature, including the date of signature, and also applies to the change table for a tax benefit");
                    
                    preklady.Add("V případě, že <b>u daňového zvýhodnění</b> dochází v průběhu roku ke změně ve vztahu k nároku na „jedno dítě, druhé dítě, třetí a každé další vyživované", "During the year if there is a change in relation to one child, second child, third and every other maintained child“, fill in together the table above and below");
                    preklady.Add("dítě“, vyplňte současně s oznámenou změnou i níže uvedenou změnovou tabulku a aktualizujte výčet všech Vámi vyživovaných dětí (ze strany 1) podle", "and update the list (from page 1) of all maintained children within the household by taxpayer pursuant to Section 35c subsection 6 of the Act.");
                    preklady.Add("§ 35c odst. 6 zákona žijících ve Vaší společně hospodařící domácnosti", " ");
                    //11)
                    preklady.Add("výši Vámi uplatňovaného nového nároku na daňové zvýhodnění označte: na jedno dítě „<b>1.</b>“, na druhé dítě „<b>2.</b>“, na třetí a každé další vyživované dítě „<b>3.</b>“, a dítě,", "Mark the amount of the new claim for a tax benefi t: one child “<b>1</b>“, second child “<b>2</b>“, third child and any other dependent child “<b>3</b>“ and the child for whom you do not");
                    preklady.Add("na které daňové zvýhodnění neuplatňujete, označte „<b>N</b>“", "apply the tax benefit “<b>N</b>“");
                    
                    preklady.Add("<b>Upozornění:</b> V případě, že v souladu s § 38k odst. 7 zákona uplatňujete slevy na dani podle § 35ba odst. 1 písm. a, c, d, e, f) příp. daňové zvýhodnění", "<b>Warning</b>: If, in accordance with Section 38k subsection 7 of the Act, you apply tax credits under Section 35ba subsection 1 letter a, c, d, e, f; tax deduction");
                    preklady.Add("dodatečně v rámci žádosti o roční zúčtování záloh a daňového zvýhodnění, pak označte dodatečně uplatněnou slevu na dani (případně daňové", "additionally as part of the application for annual settlement of advances and tax benefi ts, then mark the additional tax deduction (“tax deductible“) “XD“ plus");
                    preklady.Add("zvýhodnění) „XD“ a zároveň uveďte kalendářní měsíce, za které dodatečně uplatňujete (např. 9–12). Kalendářní měsíce neuvádějte u slevy na poplatníka.", "the calendar months for which you apply retrospectively (e.g. 9-12). Do not include calendar months for a personal tax allowance. Additional MFin 5457");
                    preklady.Add("Pro účely dodatečného uplatnění lze použít i nový tiskopis MFin 5457. Nepoužívejte změnovou část, která je určena pouze pro změny, které nastaly", "may also be used for the purposes of the additional application. Do not use the change part that is intended only for changes that occurred during the tax");
                    preklady.Add("v průběhu zdaňovacího období, tzn. před žádostí o roční zúčtování záloh a daňového zvýhodnění.", "period, before requesting an annual settlement of advances and tax benefits.");
                    
                }
                for (int prekladIdx = 0; prekladIdx < preklady.Count; prekladIdx++)
                {
                    WebControlHelper.ProjdiControls(FormView1, prekladIdx, ZmenaTextu);
                }

            }
        }

        public static void ZmenaTextu(object ctrl, object prekladIdx)
        {

            if (ctrl is LiteralControl || ctrl is Label)
            {
                string prop = "Text";
                object obj = WebControlHelper.GetPropertyValue(ctrl, prop);
                if (obj != null)
                {
                    string text = Convert.ToString(obj);
                    if (text != "")
                    {
                        //části html, např. několik div-ů, které nemají runat=server jsou spojeny do 1 LiteralControl, takže musím hledat uvnitř
                        string prelozeno = text.Replace(preklady.ElementAt((int)prekladIdx).Key, preklady.ElementAt((int)prekladIdx).Value);
                        if (!text.Equals(prelozeno))
                            WebControlHelper.SetPropertyValue(ctrl, prop, prelozeno);
                    }
                }
            }

        }

        private static System.Collections.Generic.Dictionary<string, string> preklady = new System.Collections.Generic.Dictionary<string, string>();


    }
}