﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class ExportGridButtonC : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// 
        /// </summary>
        public string TargetControl
        {
            get
            {
                Object val = ViewState["ExportGridButton_target"];
                return val == null ? null : (string)val;
            }
            set
            {
                ViewState["ExportGridButton_target"] = value;
            }
        }
        protected void RCM_ExportGridButtonC_ItemClick(object sender, Telerik.Web.UI.RadMenuEventArgs e)
        {
            RadGrid grid = (RadGrid)get_TargetControl(this);
            if (grid != null)
            {
                switch (e.Item.Value)
                {
                    case "exel_html":
                        {
                            grid.ExportSettings.IgnorePaging = true;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;

                            grid.ExportSettings.Excel.Format = GridExcelExportFormat.Html;
                            grid.MasterTableView.ExportToExcel();
                        } break;
                    case "exel_ml":
                        {
                            grid.ExportSettings.IgnorePaging = true;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;

                            grid.ExportSettings.Excel.Format = GridExcelExportFormat.ExcelML;
                            grid.MasterTableView.ExportToExcel();
                        } break;
                    case "exel_biff":
                        {
                            grid.ExportSettings.IgnorePaging = true;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;

                            grid.ExportSettings.Excel.Format = GridExcelExportFormat.Biff;
                            grid.MasterTableView.ExportToExcel();
                        } break;
                    case "word":
                        {
                            grid.ExportSettings.IgnorePaging = true;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;

                            grid.MasterTableView.ExportToWord();
                        } break;
                    case "csv":
                        {
                            grid.ExportSettings.IgnorePaging = true;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;

                            grid.MasterTableView.ExportToCSV();
                        } break;
                    case "pdf":
                        {
                            grid.ExportSettings.IgnorePaging = false;
                            grid.ExportSettings.ExportOnlyData = true;
                            grid.ExportSettings.OpenInNewWindow = true;
                            grid.ExportSettings.Pdf.PaperSize = GridPaperSize.A4;
                            grid.ExportSettings.Pdf.AllowPrinting = true;

                            grid.MasterTableView.ExportToPdf();
                        } break;
                }
            }
        }
        private RadGrid get_TargetControl(Control ctrl)
        {
            if (string.IsNullOrEmpty(this.TargetControl))
            {
                Control c = ctrl.Parent;
                if (c != null)
                    if (isExportable(c))
                        return (RadGrid)c;
                    else
                        return get_TargetControl(c);
                else
                    return null;
            }
            else
            {
                Control c = ctrl.Parent.FindControl(this.TargetControl);
                if (c != null)
                    if (isExportable(c))
                        return (RadGrid)c;
                    else
                        throw new Exception("Control \"" + this.TargetControl + "\" není exportovatelný.");
                else
                    if (ctrl.Parent == null)
                        return null;
                    else
                        return get_TargetControl(ctrl.Parent);
            }
        }
        /// <summary>
        /// Případně přepsat pokud se množství rozšíří
        /// </summary>
        /// <param name="c"></param>
        /// <returns></returns>
        private bool isExportable(Control c)
        {
            return c is RadGrid;
        }
    }
}