﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Web.Security;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram.Reminder;
using System.Web.Services;
using System.Text;
using KSProgram.Extensions;
using Newtonsoft.Json;
using System.Text.RegularExpressions;
using KSProgram.Exceptions;

namespace KSPortal.Controls
{
    public partial class KalendarControl : System.Web.UI.UserControl
    {

        private List<DateTime> _svatky
        {
            get
            {
                //object o = ViewState["Kalendarcontrol_svatky"];
                //if (o == null)
                //{
                //    o = KSProgram.Funkce.PlanovaciKalendar.GetSvatky(DateTime.Now.Date.AddYears(-5), DateTime.Now.Date.AddYears(5));
                //    ViewState["Kalendarcontrol_svatky"] = o;
                //}
                //return (List<DateTime>)o;

                if(string.IsNullOrEmpty(HF_svatky.Value))
                {
                    HF_svatky.Value = serializeSvatky(KSProgram.Funkce.PlanovaciKalendar.GetSvatky(DateTime.Now.Date.AddYears(-5), DateTime.Now.Date.AddYears(5)));
                }

                return deserializaceSvatky(HF_svatky.Value);
            }
        }

        private string serializeSvatky(List<DateTime> list)
        {
            List<List<int>> ret = new List<List<int>>() { };

            list.ForEach(x => ret.Add(x.ToList()));

            return JsonConvert.SerializeObject(ret);
        }

        private List<DateTime> deserializaceSvatky(string str)
        {
            List<List<int>> list = JsonConvert.DeserializeObject<List<List<int>>>(str);

            List<DateTime> ret = new List<DateTime>();

            list.ForEach(x => ret.Add(new DateTime(x[0], x[1], x[2], x[3], x[4], x[5])));

            return ret;
        }

        /// <summary>
        /// Zda je kontrolka v módu 0 - nový záznam nebo 1 - změna záznamu
        /// </summary>
        public short SelectedPanIndex
        {
            get
            {
                return (ViewState["CalendarSelectedPanIndex"] == null ? (short)0 : Convert.ToInt16(ViewState["CalendarSelectedPanIndex"]));
            }
            set
            {
                ViewState["CalendarSelectedPanIndex"] = value;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            System.Threading.Thread.CurrentThread.CurrentCulture = System.Threading.Thread.CurrentThread.CurrentUICulture;

            //export do ico poze pro VARROC
            P_export.Visible = Zakaznik.IsCurrent("VARROC_LIGHTING_SYSTEMS") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");

            //TRG_kalendar.MasterTableView.GetColumn("cis_pracmist").Visible = Zakaznik.IsCurrent("PTACEK") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
            //TRG_kalendar.MasterTableView.GetColumn("naz_pracmist").Visible = Zakaznik.IsCurrent("PTACEK") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");

            RCEM_manager.PdfSettings.Fonts.Add("Arial", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/arial.ttf");
            RCEM_manager.PdfSettings.Fonts.Add("Arial Black", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/ariblk.ttf");

            if (SelectedPanIndex != 0)
            {
                RadTabStrip1.SelectedIndex = SelectedPanIndex;
                RadMultiPage1.SelectedIndex = SelectedPanIndex;

                RPV_Sheduler.Selected = false;
                RPV_Grid.Selected = true;
            }

            List<DateTime> svatky = _svatky; //naplnění HF_Svatky

            //RadScheduler1.TimeZoneID = TimeZoneInfo.Local.Id;

            string export_param = Parametry.ParametrCti("KalendarASSync");
            if(export_param=="a")
            {
               
                checkExportMailks.Visible = true;
                checkExportICS.Visible = true;
                checkExportICS.Checked = false;
                if (ZamKalendar.isAdresatICS(Globals.OsCisloAktUser))
                {
                    checkExportICS.Checked = true;
                }
            }
            else
            {
                checkExportMailks.Visible = false;
                checkExportICS.Visible = false;
            }

        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
        }
        protected void RadScheduler1_ResourcesPopulating(object sender, Telerik.Web.UI.ResourcesPopulatingEventArgs e)
        {
            HttpCookie cookie = FormsAuthentication.GetAuthCookie(Globals.User, false);
            string cookieHeader = string.Format("{0}={1}", cookie.Name, cookie.Value);
            e.Headers.Add(HttpRequestHeader.Cookie, cookieHeader);

            Uri uri = HttpContext.Current.Request.Url;
            ICredentials credentials = CredentialCache.DefaultCredentials;
            e.Credentials = credentials.GetCredential(uri, "Basic");
        }

        protected void RadScheduler1_DataBound(object sender, EventArgs e)
        {
            //if (!IsPostBack)
            //{
                RadScheduler shed = (RadScheduler)sender;
                shed.ResourceStyles.Clear();
                foreach (ZamKalendar.KalentarItem item in ZamKalendar.TypyKalendaru())
                {
                    ResourceStyleMapping style = new ResourceStyleMapping("Kalendare", item.Value, "");
                    style.BackColor = item.BColor;
                    shed.ResourceStyles.Add(style);
                }
                foreach (ZamKalendar.KalentarItem item in ZamKalendar.TypyPozadavku())
                {
                    ResourceStyleMapping style = new ResourceStyleMapping("Kalendare", item.Value, "");
                    style.BackColor = item.BColor;
                    shed.ResourceStyles.Add(style);
                }
            //}
        }

        //protected void TRG_zamci_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        //{
        //    TRadGrid table = (TRadGrid)sender;
        //    table.DataSource = KSProgram.Funkce.Pracovnici.SeznamZam("p", "p", true);
        //}

        private List<string> getKalendare()
        {
            List<string> ret = new List<string>() { };
            foreach (RepeaterItem item in R_kal.Items)
            {
                Panel panel = (Panel)item.FindControl("P_kal");
                string literal = ((System.Web.UI.DataBoundLiteralControl)(panel.Controls[0])).Text;

                _addCrit(literal, ref ret);
            }

            return ret;
        }

        private List<string> getPozadavky()
        {
            List<string> ret = new List<string>() { };
            foreach (RepeaterItem item in R_poz.Items)
            {
                Panel panel = (Panel)item.FindControl("P_poz");
                string literal = ((System.Web.UI.DataBoundLiteralControl)(panel.Controls[0])).Text;

                _addCrit(literal, ref ret);
            }
            return ret;
        }

        private List<string> getStavy()
        {
            List<string> ret = new List<string>() { };

            string litn = ((System.Web.UI.HtmlControls.HtmlContainerControl)(RPB_typy_kal.Items[1].FindControl("P_stav_n"))).InnerText;
            _addCrit(litn, ref ret);

            string litr = ((System.Web.UI.HtmlControls.HtmlContainerControl)(RPB_typy_kal.Items[1].FindControl("P_stav_r"))).InnerText;
            _addCrit(litr, ref ret);

            string lits = ((System.Web.UI.HtmlControls.HtmlContainerControl)(RPB_typy_kal.Items[1].FindControl("P_stav_s"))).InnerText;
            _addCrit(lits, ref ret);

            string lito = ((System.Web.UI.HtmlControls.HtmlContainerControl)(RPB_typy_kal.Items[1].FindControl("P_stav_o"))).InnerText;
            _addCrit(lito, ref ret);

            return ret;
        }
        private void _addCrit(string literal, ref List<string> ret)
        {
            if (literal.Contains("checked=\"checked\""))
            {
                int starti = literal.IndexOf("value='") + 7;
                int endi = literal.IndexOf("'", starti);
                string val = literal.Substring(starti, endi - starti);

                ret.Add(val);
            }
        }
        private DateTime _getPondeli(DateTime date)
        {
            while (date.DayOfWeek != DayOfWeek.Monday)
            {
                date = date.AddDays(-1);
            }
            return date;
        }

        protected void TRB_export_OnCommand(object sender, CommandEventArgs e)
        {
            int year = DateTime.Now.Year;
            int month = DateTime.Now.Month;
            int day = DateTime.Now.Day;

            string val = HF_sel_date.Value;
            Int32.TryParse(val.Substring(1, 4), out year);
            Int32.TryParse(val.Substring(6, 2), out month);
            Int32.TryParse(val.Substring(9, 2), out day);

            DateTime datum_od = new DateTime(year, month, day);
            DateTime datum_do = new DateTime();
            switch (TRCB_export_delka_obdobi.SelectedValue)
            {
                case "t":
                    datum_od = _getPondeli(datum_od);
                    datum_do = datum_od.AddDays(6);
                    break;
                case "r":
                    datum_od = new DateTime(datum_od.Year, 1, 1);
                    datum_do = new DateTime(datum_od.Year, 12, 31);
                    break;
                default:
                    datum_od = datum_od.PrvniDen();
                    datum_do = datum_od.PosledniDen();
                    break;
            }

            List<ZamKalendar.KSAppointment> list = ZamKalendar.GetUdalosti(datum_od, datum_do, getKalendare(), getPozadavky(), getStavy(), Globals.OsCisloPomerSeznam.OsCisla);

            string data = RadScheduler.ExportToICalendar(list);
            
            data = data.Replace("END:VEVENT","X-MICROSOFT-CDO-BUSYSTATUS:FREE\r\nEND:VEVENT");

            HttpResponse response = this.Page.Response;

            response.Clear();
            response.Buffer = true;

            response.ContentType = "text/calendar";
            response.ContentEncoding = Encoding.UTF8;
            response.Charset = "utf-8";

            response.AddHeader("Content-Disposition", "attachment;filename=\"KsKalendar.ics\"");

            response.Write(data);
            response.End();
        }
        //protected void TRB_export_OnClick(object sender, EventArgs e)
        //{
            

        //}

        protected void TRG_kalendar_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            //e.Cell.BorderColor = System.Drawing.Color.Black;
            //e.Cell.BorderWidth = Unit.Point(1);
            //e.Cell.BorderStyle = BorderStyle.Solid;

            if (e.FormattedColumn.UniqueName == "OsCislo")
            {
                e.Cell.Style["mso-number-format"] = @"0";
            }

            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                string dataField = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField;
                KSProgram.Reminder.ZamKalendar.KalendarZamestnance dataItem = (KSProgram.Reminder.ZamKalendar.KalendarZamestnance)(((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem;

                if (string.IsNullOrEmpty(TRG_kalendar.MasterTableView.Caption))
                    TRG_kalendar.MasterTableView.Caption = "<span><br/><b>" + WebControlHelper.ZmenaTextu("Kalendář") + " " + dataItem.obdobi.ToString("MMMM yyyy") + "</b></span>";

                e.Cell.Width = Unit.Pixel(240);

                DateTime cellDay = new DateTime();

                try
                {
                    cellDay = new DateTime(dataItem.obdobi.Year, dataItem.obdobi.Month, Convert.ToInt32(dataField.Substring(1, dataField.Length - 1)));
                }
                catch (Exception )
                {
                    return;
                }
                if (cellDay.DayOfWeek == DayOfWeek.Saturday || cellDay.DayOfWeek == DayOfWeek.Sunday || _svatky.Contains(cellDay))
                {
                    e.Cell.Style["background-color"] = "#E0E0E0";
                }

                List<ZamKalendar.UdalostData> dayData = dataItem.RowData.FindAll(x => (x.DStart <= cellDay || x.DStart.Date == cellDay.Date) && cellDay < x.DEnd);

                if (dayData.Count > 0)
                {
                    e.Cell.Text = "<table width=\"100%\">";
                    foreach (ZamKalendar.UdalostData udalost in dayData)
                    {
                        DateTime pod = new DateTime();
                        DateTime pdo = new DateTime();
                        string text = "";
                        if (KSProgram.Funkce.F_DateTime.PrunikCasovychIntervalu(udalost.DStart, udalost.DEnd, cellDay, cellDay.AddDays(1), out pod, out pdo))
                        {
                            bool allDay = pod == cellDay && pdo == cellDay.AddDays(1);

                            //string hodin = udalost.DelkaUdalosti == new TimeSpan() ?
                            //    (KSProgram.Funkce.F_DateTime.DobaDecNaDobaString(KSProgram.Funkce.F_DateTime.TimeSpanToDecimal(pdo.Subtract(pod), "h"))) :
                            //    (KSProgram.Funkce.F_DateTime.DobaDecNaDobaString(KSProgram.Funkce.F_DateTime.TimeSpanToDecimal(udalost.DelkaUdalosti, "h")));

                            //string hodin = KSProgram.Funkce.F_DateTime.DobaDecNaDobaString(KSProgram.Funkce.F_DateTime.TimeSpanToDecimal(pdo.Subtract(pod), "h"));
                            //hodin = hodin.Contains(":00") ? hodin.Substring(0, hodin.IndexOf(':')) : hodin;

                            string type = udalost.Resources.AsEnumerable().FirstOrDefault(x => x.Type == "Kalendare")?.Key.ToString();
                            text = ZamKalendar.GetKalendarZkratka(type);// + (allDay ? "" : (" " + hodin));
                        }
                        e.Cell.Text += "<tr><td align=\"center\" width=\"100%\" style=\"background-color: " + udalost.BColor + "; font-size: xx-small;\">" + text + "</td></tr>";//KSProgram.Funkce.F_DateTime.TimeSpanToDecimal(udalost.Time, "d")
                        e.Cell.ToolTip += udalost.Description;
                    }
                    e.Cell.Text += "</table>";
                }
            }
        }
        protected void TRG_kalendar_HTMLExporting(object sender, Telerik.Web.UI.GridHTMLExportingEventArgs e)
        {
//            e.XmlOptions = @"<xml>
//                    <x:ExcelWorkbook> 
//                      <x:ExcelWorksheets>
//                        <x:ExcelWorksheet>
//                          <x:WorksheetOptions>
//                            <x:Print>
//                              <x:ValidPrinterInfo/> 
//                              <x:Gridlines/>
//                              <x:RowColHeadings/> 
//                            </x:Print>
//                          </x:WorksheetOptions>
//                        </x:ExcelWorksheet>
//                      </x:ExcelWorksheets>
//                    </x:ExcelWorkbook>
//                 </xml>";

            e.Styles.Append("br { mso-data-placement: same-cell; }");
        }
        protected void TRG_kalendar_InfrastructureExporting(object sender, GridInfrastructureExportingEventArgs e)
        {

        }

        protected void ExportToState_Click(object sender, EventArgs args)
        {
            var rpm = RadPersistenceManager.GetCurrent(this.Page);
            rpm.SaveState();
        }

        protected void TRG_kalendar_GridExporting(object sender, GridExportingArgs e)
        {
            DateTime obdobi = RC_obdobi.FocusedDate.PrvniDen();
            for (DateTime day = obdobi.PosledniDen(); day >= obdobi; day = day.AddDays(-1))
            {
                e.ExportOutput = e.ExportOutput.Replace(" " + day.Day.ToString() + "\r\n                                    <br />", " <b>" + day.Day.ToString() + "\r\n                                    <br /><span style=\"white-space: nowrap; " + ((day.DayOfWeek == DayOfWeek.Sunday || day.DayOfWeek == DayOfWeek.Saturday) ? ("color: #FF0000; ") : "") + "\">" + System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetShortestDayName(day.DayOfWeek) + "</span></b>");
            }

            // po třech dnech hledání se mi nepodařilo vypátrat, kdy a kde se někdy nastaví skrytí řádků, proto odstraním tady.
            Regex r = new Regex("<\\s*tr\\s+style\\s*=\\s*\"\\s*display:\\s*none\\s*;*\\s*\"\\s*>", RegexOptions.Singleline | RegexOptions.IgnoreCase); // "<tr style="display:none;">  nahradi na <tr>"
            e.ExportOutput = r.Replace(e.ExportOutput, "<tr>");
        }

        protected void TRG_kalendar_ItemDataBound(object sender, GridItemEventArgs e)
        {

        }

        protected void checkExportMailks_CheckedChanged(object sender, EventArgs e)
        {
            string vysledek = ZamKalendar.ZmenaStavuExportuICS(Globals.OsCisloAktUser);
            
            if (vysledek.Count()>0){
                throw new NoticeException(vysledek);

            }else
            {
                bool stav = checkExportICS.Checked;
                checkExportICS.Checked = !stav;
            }
        }

        //protected void RadScheduler1_TimeSlotCreated(object sender, TimeSlotCreatedEventArgs e)
        //{
        //    if (e.TimeSlot.Start.Date.DayOfWeek == DayOfWeek.Saturday)
        //    {
        //        e.TimeSlot.CssClass = "ksSobota";
        //    }
        //    if (e.TimeSlot.Start.Date.DayOfWeek == DayOfWeek.Sunday)
        //    {
        //        e.TimeSlot.CssClass = "ksNedele";
        //    }
        //}
    }
}