﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System.Linq;
using System.Linq.Dynamic.Core;

public partial class KvalifikacniKartaControl :UserControl
{
    private decimal _dnu = 0;
    /// <summary>
    /// 
    /// </summary>
    public void RebindOsvedceni()
    {
        RadAjaxManager manager = RadAjaxManager.GetCurrent(Page);
        manager.ResponseScripts.Add("$find('" + TRG_ziskana_osvedceni.ClientID + "').get_masterTableView().rebind();");
        TRG_ziskana_osvedceni.Rebind();
    }

    /// <summary>
    /// Seznam získaných požadavků
    /// </summary>
    private List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> _list
    {
        get
        {
            List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> lst = SessionInfo.GetVariable("KvalifikacniKartaControl_list") as List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>;
            if (lst == null)
            {
                KSProgram.Vzdelavani.KvalifikacniKarta obj = new KSProgram.Vzdelavani.KvalifikacniKarta();
                lst = obj.ZiskanePozadavky(cbVazbaNaIndPlan.Checked);
                SessionInfo.SetVariable("KvalifikacniKartaControl_list", lst);
            }
            return lst;
        }
        set
        {
            SessionInfo.SetVariable("KvalifikacniKartaControl_list", value);
        }
    }
    private List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> _listMaster
    {
        get
        {
            List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> lst = new List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>() { };
            string last_cislo = "";
            foreach (KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem item in _list)
            {
                if (last_cislo != item.cis_osve)
                {
                    KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem i = new KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem();
                    i.CopyFrom(item);

                    KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem platny = _list.Find(x => x.cis_osve == item.cis_osve && x.platne);

                    if (platny == null)
                    {
                        //i.p_cislo = null;
                        //i.nazev_akce = null;
                        //i.dnu = null;
                        //i.typ = null;
                        //i.typ_nazev = null;
                        //i.platne = false;
                        //i.platne_od = null;
                        //i.platne_do = null;
                        //i.akreditace = null;
                        //i.sekundarni = null;
                    }
                    else
                    {
                        i.CopyFrom(platny);
                    }

                    lst.Add(i);
                }
                last_cislo = item.cis_osve;
            }

            return lst;
        }
    }
    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);
        ODS_ZiskanaOsvedceni.SelectParameters.Clear();
        bool urad = KSProgram.Zakaznik.HasModul(KSProgram.AppModul.Urad);
        if (urad)
        {
            cbVazbaNaIndPlan.Visible = true;
            ControlParameter parameter = new ControlParameter("vazbaNaIndPlan", "cbVazbaNaIndPlan", "Checked");
            ODS_ZiskanaOsvedceni.SelectParameters.Add(parameter);
        }

        //MD 18.5.2015
        string akreditace = KSProgram.Funkce.Parametr_cti.Get("akreditace_osv");
        TRG_ziskana_osvedceni.Columns.FindByUniqueName("dnu").Visible = (akreditace == "a");
        TRG_ziskana_osvedceni.MasterTableView.DetailTables[0].Columns.FindByUniqueName("ddnu").Visible = (akreditace == "a");
        TRG_ziskana_osvedceni.Columns.FindByUniqueName("akreditace").Visible = (akreditace == "a");
        TRG_ziskana_osvedceni.MasterTableView.DetailTables[0].Columns.FindByUniqueName("dakreditace").Visible = (akreditace == "a");
    }

    protected void TGridView2_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        //sumace údajů
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            string val = DataBinder.Eval(e.Row.DataItem, "dnu").ToString();
            int sekundarni = (int)DataBinder.Eval(e.Row.DataItem, "sekundarni"); //MD 14.4.2014
            if (sekundarni == 0)
            {
                if (!string.IsNullOrEmpty(val))
                    _dnu += Convert.ToDecimal(val);
            }
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[0].Font.Bold = true;
            e.Row.Cells[0].Text = "[%Celkem%]";
            e.Row.Cells[3].Text = _dnu.ToString();
        }
    }

    protected void TRG_ziskana_osvedceni_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        if (!e.IsFromDetailTable)
        {
            TRG_ziskana_osvedceni.DataSource = _listMaster;
        }
    }

    protected void TRG_ziskana_osvedceni_DetailTableDataBind(object sender, Telerik.Web.UI.GridDetailTableDataBindEventArgs e)
    {
        GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
        switch (e.DetailTableView.Name)
        {
            case "detail":
                {
                    int id = (Int32)dataItem.GetDataKeyValue("id");
                    string cis_osve = dataItem.GetDataKeyValue("cis_osve").ToString();
                    e.DetailTableView.DataSource = getDetail(id, cis_osve);
                    break;
                }
        }
    }
    private List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> getDetail(Int32 id, string cis_osve)
    {
        List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> ret = _list.FindAll(x => x.cis_osve == cis_osve && x.id != id);
        return ret == null ? new List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>() { } : ret;
    }

    protected void TRG_ziskana_osvedceni_PreRender(object sender, EventArgs e)
    {
        RemoveExpandIconWhenNoRecords(TRG_ziskana_osvedceni.MasterTableView);
        if (cbVazbaNaIndPlan.Checked)
        {
            //sumace hodin
            List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> _filtered = string.IsNullOrEmpty(TRG_ziskana_osvedceni.MasterTableView.FilterExpression) ? _list : _list.AsQueryable().Where(TRG_ziskana_osvedceni.MasterTableView.FilterExpression).Cast<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>().ToList();
            GridFooterItem footeritem = TRG_ziskana_osvedceni.MasterTableView.GetItems(GridItemType.Footer)[0] as GridFooterItem;
            footeritem["text_osve"].Text = WebControlHelper.ZmenaTextu("[%Celkem%]: ");
            var hodin =_filtered.Sum(i => i.dnu).Value;
            footeritem["dnu"].Text = hodin.ToString();
            hodin = _filtered.Sum(i => i.dnu_akreditovanych).Value;
            footeritem["dnu_akreditovanych"].Text = hodin.ToString();
        }
    }
    protected void RemoveExpandIconWhenNoRecords(GridTableView view)
    {
        if (view.Controls.Count > 0)
        {
            foreach (GridItem item in view.Controls[0].Controls)
            {
                if (item is GridNestedViewItem)
                {
                    GridNestedViewItem nestedViewItem = (GridNestedViewItem)item;
                    if (nestedViewItem.NestedTableViews[0].Items.Count == 0)
                    {
                        TableCell cell = nestedViewItem.NestedTableViews[0].ParentItem["ExpandColumn"];
                        if (cell.Controls.Count > 0)
                        {
                            cell.Controls[0].Visible = false;
                            cell.Text = " ";
                            nestedViewItem.Visible = false;
                        }
                    }
                    else
                    {
                        RemoveExpandIconWhenNoRecords(nestedViewItem.NestedTableViews[0]);
                    }
                }
            }
        }
    }
    protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
    {
        TRadButton TRB_ch = (TRadButton)sender;
        if (TRB_ch.Checked)
        {
            TRG_ziskana_osvedceni.MasterTableView.AllowFilteringByColumn = true;
        }
        else
        {
            TRG_ziskana_osvedceni.MasterTableView.AllowFilteringByColumn = false;
            TRG_ziskana_osvedceni.MasterTableView.FilterExpression = "";
        }
        TRG_ziskana_osvedceni.Rebind();
    }

    protected void TRG_ziskana_osvedceni_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item.ItemType == GridItemType.CommandItem)
        {
            TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
            but.Checked = ((TRadGrid)sender).MasterTableView.AllowFilteringByColumn;
        }
    }

    protected void TRG_ziskana_osvedceni_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            //Get the instance of the right type
            GridDataItem dataBoundItem = e.Item as GridDataItem;
            //if(dataBoundItem.GetDataKeyValue("ID").ToString() == "you Compared Text") // you can also use datakey also
            if (e.Item.OwnerTableView.Name == "")
            {
                if (((CheckBox)dataBoundItem["je_pozadavek"].Controls[0]).Checked && !((CheckBox)dataBoundItem["platne"].Controls[0]).Checked && !((CheckBox)dataBoundItem["vyjimka"].Controls[0]).Checked)
                {
                    dataBoundItem["text_osve"].ForeColor = System.Drawing.Color.Red; // chanmge particuler cell
                    //e.Item.BackColor = System.Drawing.Color.LightGoldenrodYellow; // for whole row
                    //dataItem.CssClass = "MyMexicoRowClass";
                }
            }
        }
    }

    protected void cbVazbaNaIndPlan_CheckedChanged(object sender, EventArgs e)
    {
        SessionInfo.RemoveVariable("KvalifikacniKartaControl_list");
        TRG_ziskana_osvedceni.Rebind();
    }

    protected void TRG_ziskana_osvedceni_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.RebindGridCommandName)
        {
            SessionInfo.RemoveVariable("KvalifikacniKartaControl_list");
        }
    }

}
