﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Personal;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Drawing;
using KSProgram.Extensions;

namespace KSPortal.Controls
{
    public partial class LimityControl : System.Web.UI.UserControl
    {
        public int? IdPravaProhlizeni { get; set; }
        public TypKontrolkyLimity TypKontrolky { get; set; }
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                HF_obdobi.Text = Globals.AktObdobi.AddMonths(-1).ToString();
            }

            RG_lim.Visible = false;
            RLV_limity.Visible = false;

            if (TypKontrolky == TypKontrolkyLimity.Grid)
            {
                RG_lim.Visible = true;
            }
            else
            {
                RLV_limity.Visible = true;
            }

            if (IdPravaProhlizeni != null && !KSProgram.Prava.PravaAkce.PristupPovolen((int)IdPravaProhlizeni))
            {
                RG_lim.Visible = false;
                RLV_limity.Visible = false;
            }
        }
        private List<Limity.LimitStav> getData()
        {
            DateTime? date = String.IsNullOrEmpty(HF_obdobi.Text) ? (DateTime?)null : Convert.ToDateTime(HF_obdobi.Text);
            if (date == null)
                date = Globals.AktObdobi.AddMonths(-1);
            Limity lim = new Limity();
            return lim.Sestava((DateTime)date, Globals.OsCislo);
        }
        protected void RG_lim_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            RadGrid table = (RadGrid)sender;
            if (table.Visible)
            {
                table.DataSource = getData();
            }
        }
        private static string tvar(string jednotka, short t)
        {
            switch (jednotka)
            {
                case "dny":
                    {
                        switch (t)
                        {
                            case 1: return "[%den%]";
                            case 2: return "[%dny%]";
                            case 3: return "[%dnů%]";
                            default: return string.Empty;
                        }
                    }
                case "hodiny":
                    {
                        switch (t)
                        {
                            case 1: return "[%hodinu%]";
                            case 2: return "[%hodiny%]";
                            case 3: return "[%hodin%]";
                            default: return string.Empty;
                        }
                    }
                default: return "Kč";
            }
        }
        protected void RLV_limity_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            RadListView rlv = (RadListView)sender;
            if (rlv.Visible)
            {
                var data = getData().Select(x => new
                {
                    nazev = x.nazev,
                    limita_veta =
                        KSProgram.Obecne.ReadGlobalResource.ZmenaTextu(
                            (x.splneno
                                ? (x.min.HasValue ? "[%Hodnota {4} přesahuje minimum {0} o%] <b>{3}</b>." : string.Empty)
                                  + (x.max.HasValue ? "[%Hodnota {4} nedosahuje maxima {1} o%] <b>{6}</b>." : string.Empty)
                                : (x.cerpano > x.max ? "[%Hodnota {4} přesahuje maximum {1} o%] <label style=\"color:red\"><b>{2}</b></label>."
                                                     : "[%Hodnota {4} nedosahuje minima {0} o%] <label style=\"color:red\"><b>{5}</b></label>."))
                        , x.min?.ToString("### ### ##0.##")
                        , x.max?.ToString("### ### ##0.##")
                        , (x.cerpano - x.max)?.ToString("### ### ##0.##").SkloneniPodleCisla(tvar(x.jednotka, 1), tvar(x.jednotka, 2), tvar(x.jednotka, 3))
                        , (x.cerpano - x.min)?.ToString("### ### ##0.##").SkloneniPodleCisla(tvar(x.jednotka, 1), tvar(x.jednotka, 2), tvar(x.jednotka, 3))
                        , x.cerpano?.ToString("### ### ##0.##")
                        , x.zbyva_do_min?.ToString("### ### ##0.##").SkloneniPodleCisla(tvar(x.jednotka, 1), tvar(x.jednotka, 2), tvar(x.jednotka, 3))
                        , x.zbyva_do_max?.ToString("### ### ##0.##").SkloneniPodleCisla(tvar(x.jednotka, 1), tvar(x.jednotka, 2), tvar(x.jednotka, 3)))
                });
                rlv.DataSource = data;
                rlv.Visible = data.Count() > 0;
            }
        }
        protected void RadMonthYearPicker1_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            RadMonthYearPicker rmyp = (RadMonthYearPicker)sender;
            HF_obdobi.Text = rmyp.SelectedDate.ToString();
            RG_lim.Rebind();
        }
        protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_ch = (TRadButton)sender;
            if (TRB_ch.Checked)
            {
                RG_lim.AllowFilteringByColumn = true;
            }
            else
            {
                RG_lim.AllowFilteringByColumn = false;
            }
            RG_lim.Rebind();
        }
        protected void RG_lim_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                RadMonthYearPicker rmyp = (RadMonthYearPicker)e.Item.FindControl("RadMonthYearPicker1");
                //km 23.5.2016 pokud je HF_obdobi.Text spatně tak se nastaví aktuální období -1 tak jako u nastavení data pri NeedDataSource
                DateTime? date = String.IsNullOrEmpty(HF_obdobi.Text) ? (DateTime?)null : Convert.ToDateTime(HF_obdobi.Text);
                if (date == null)
                    date = Globals.AktObdobi.AddMonths(-1);
                rmyp.SelectedDate = date;
                //rmyp.SelectedDate = Convert.ToDateTime(HF_obdobi.Text);

                TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
                but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;
            }
            if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
            {
                //PR 15.2.2017 Limit.Sestava nyní vraci objekty typu LimitStav, kde je jednotka, min, max a cerpano.
                bool splneno = (bool)DataBinder.Eval(e.Item.DataItem, "splneno");
                if (!splneno)
                {
                    GridDataItem dataBoundItem = e.Item as GridDataItem;
                    dataBoundItem["cerpano"].ForeColor = Color.Red;
                    dataBoundItem["cerpano"].Font.Bold = true;
                }
            }
        }

        protected void RG_lim_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                RadMonthYearPicker RMP = (RadMonthYearPicker)e.Item.FindControl("RadMonthYearPicker1");
                RMP.Culture = System.Threading.Thread.CurrentThread.CurrentUICulture;
            }
        }
        public enum TypKontrolkyLimity
        {
            Grid = 0,
            BindTable = 1
        }
    }
}