﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram;
using KSProgram.Data;
using System.Drawing;
using KSProgram.WebControls;
using System.Collections.Generic;
using KSProgram.Funkce;

public partial class Controls_PrMistoControl : System.Web.UI.UserControl
{
    string _nazevSkup = "-1";
    TableCell _cell = null;
    int citac = 0;
    DataTable table = new DataTable();

    public Controls_PrMistoControl()
    {
        table.Columns.Add("skupina", typeof(int));
        table.Columns.Add("skupina_poradi", typeof(int));
        table.Columns.Add("skupina_nazev", typeof(string));
        table.Columns.Add("vlastnost", typeof(string));
        table.Columns.Add("hodnota", typeof(string));
        table.Columns.Add("cis_atributu", typeof(int));
        table.Columns.Add("vypracoval", typeof(string));
        table.Columns.Add("vypracoval_dne", typeof(string));
        table.Columns.Add("schvalil", typeof(string));
        table.Columns.Add("schvalil_dne", typeof(string));
        table.Columns.Add("platnost_od", typeof(string));
        table.Columns.Add("poradi_sestava", typeof(short));
    }
    /// <summary>
    /// 
    /// </summary>
    public string SelectedGroups
    {
        get
        {
            string ret = "";
            List<string> groups = new List<string>();
            foreach (GridViewRow r in TGridView1.Rows)
            {
                TCheckBox tchb_tisk = (TCheckBox)r.FindControl("TCheckBox1");
                if (tchb_tisk.Visible)
                {
                    if (tchb_tisk.Checked)
                    {
                        Label L_no = (Label)r.FindControl("Label5");
                        if (!groups.Contains(L_no.Text.Trim()))
                        {
                            groups.Add(L_no.Text.Trim());
                        }
                    }
                }
            }
            foreach (string _no in groups)
                ret += _no + ",";
            ret = ret == "" ? "" : ret.Substring(0, ret.Length - 1);
            return ret;
        }
    }

    DataTable SourceTable
    {
        get
        {
            return (DataTable)ViewState["SourcceDataTable"];
        }
        set
        {
            ViewState["SourcceDataTable"] = value;
        }

    }

    public int IDPracmist
    {
        get
        {
            return (ViewState["IDPracmist"] == null ? -1 : (int)ViewState["IDPracmist"]);
        }
        set
        {
            ViewState["IDPracmist"] = value;
        }
    }

    /// <summary>
    /// Zda je povoleno (přístupovými právy) zobrazení alespoň jedné skupiny parametrů.
    /// Jinak není co zobrazovat!
    /// </summary>
    /// <returns>true/false</returns>
    private bool PovolenoZobrazeniDat()
    {
        DataTable skupiny = SqlPrikaz.ExecuteCommand("select cis_skup_atr from atrib_skup order by cis_skup_atr");
        foreach (DataRow row in skupiny.Rows)
        {
            short skupina = GetNullOrData.GetInt16(row[0], -1);
            int id_prava_prohlizeni, id_prava_editace, id_prava_editacevl, id_prava_sestava;
            if (KSProgram.Personal.PopisPM.IdPravaSkupinyAtributu(skupina, out id_prava_prohlizeni, out id_prava_editace, out id_prava_editacevl, out id_prava_sestava))
            {
                if (KSProgram.Prava.PravaAkce.PristupPovolen(id_prava_sestava))
                {
                    return true;
                }
            }
        }
        return false;
    }

    public virtual void SpustiSestavu()
    {
        bool povolenoZobrazenDat = PovolenoZobrazeniDat();
        if (!povolenoZobrazenDat)
        {
            string message = WebControlHelper.ZmenaTextu("[%Přístup nebyl povolen%].");
            TemplateBuilder tb = new TemplateBuilder();
            tb.AppendLiteralString(message);
            TGridView1.EmptyDataTemplate = tb;
            TGridView1.ShowEmptyTable = false;
            TGridView1.DataSource = null;
            TGridView1.DataBind();
            return;
        }

        DateTime datum;
        if (tx_datum.SelectedDate == null)
            datum = DateTime.Today.Date;
        else
            datum = Convert.ToDateTime(tx_datum.SelectedDate);

        if (IDPracmist > 0)
        {
            Control ctrl = FindControl("HlavickaSestavy");
            //ctrl.Visible = false;
            DropDownList1.Visible = true;


            _naplnDropDown(IDPracmist, datum);

            string dop_oc;
            if (DropDownList1.Enabled && DropDownList1.Items.Count > 0)
                dop_oc = DropDownList1.SelectedValue;
            else
                dop_oc = "0";

            ds_sestava.SelectParameters["adc_dopln_os_cislo"].DefaultValue = dop_oc;
            ds_sestava.SelectParameters["idPracmista"].DefaultValue = IDPracmist.ToString();
            ds_sestava.SelectParameters["keDni"].DefaultValue = datum.ToString();
            //ds_sestava.SelectParameters["systemiz"].DefaultValue = CheckBox1.Checked.ToString();
            ds_sestava.SelectParameters["systemiz"].DefaultValue = CheckBox.Checked.ToString();

            TGridView1.DataSourceID = "ds_sestava";
            TGridView1.DataBind();

            return;
        }

        decimal os_cislo = 0;
        short cislo_pom = -1;
        int id_pracmist = 0;

        object obj_os_cislo = Request.QueryString["oc"];
        object obj_prac_misto = Request.QueryString["pm"];
        if (obj_os_cislo != null)
        {
            os_cislo = Convert.ToDecimal(obj_os_cislo);
            if (!(Globals.RadkovePrava.OsCislo(os_cislo)))
                os_cislo = 0;
        }
        else if (obj_prac_misto != null)
        {
            id_pracmist = Convert.ToInt32(obj_prac_misto);
        }
        else
        {
            os_cislo = Globals.OsCisloPomer.OsCislo;
            cislo_pom = Globals.OsCisloPomer.CisloPom;
        }
        if (os_cislo > 0)
        {
            DropDownList1.Enabled = false;
        }

        _naplnDropDown(id_pracmist, datum);

        string dopl_oc;
        if (DropDownList1.Enabled && DropDownList1.Items.Count > 0)
            dopl_oc = DropDownList1.SelectedValue;
        else
            dopl_oc = "0";

        ds_sestava.SelectParameters["adc_os_cislo"].DefaultValue = os_cislo.ToString();
        ds_sestava.SelectParameters["cislo_pomeru"].DefaultValue = cislo_pom.ToString(); //PH 27.5.2015 přidal jsem číslo poměru
        ds_sestava.SelectParameters["adc_dopln_os_cislo"].DefaultValue = dopl_oc;
        ds_sestava.SelectParameters["idPracmista"].DefaultValue = id_pracmist.ToString();
        ds_sestava.SelectParameters["keDni"].DefaultValue = datum.ToString();
        //ds_sestava.SelectParameters["systemiz"].DefaultValue = CheckBox1.Checked.ToString();
        ds_sestava.SelectParameters["systemiz"].DefaultValue = CheckBox.Checked.ToString();

        TGridView1.DataSourceID = "ds_sestava";
        TGridView1.DataBind();
    }
    private void _naplnDropDown(int id_pracmist, DateTime datum)
    {
        if (id_pracmist > 0)
        {
            if (DropDownList1.Items.Count == 0 || id_pracmist != Convert.ToInt32(TLabel2.Text == "" ? "-1" : TLabel2.Text))
            {
                DropDownList1.Items.Clear();

                ListItem item = new ListItem("Bez zaměstnance", "0");
                DropDownList1.Items.Add(item);

                string sql = "";
                if (KSProgram.Funkce.Prac_postup.JeAktivovan)
                {
                    DataTable postup = KSProgram.Funkce.Prac_postup.Get(id_pracmist, datum, true);

                    foreach (DataRow row in postup.Rows)
                    {
                        decimal osc_pom = GetNullOrData.GetDecimal(row["os_cislo"], 0);
                        short cislo_pom = GetNullOrData.GetInt16(row["cislo_pom"], 0);

                        if (Globals.RadkovePrava.OsCislo(osc_pom, cislo_pom))
                        {
                            item = new ListItem(Pracovnik.CeleJmeno(osc_pom, "{os_cislo} - {prijmeni} {jmeno}"), osc_pom.ToString());
                            DropDownList1.Items.Add(item);
                        }
                    }
                    if (DropDownList1.Items.Count > 1) DropDownList1.SelectedIndex = 1;
                }
                else
                {
                    sql = "select pracovnici.os_cislo, " +
                                             " pracovnici.jmeno, " +
                                             " pracovnici.prijmeni, " +
                                             " prac_pom.cislo_pom " +
                                             " from prac_pom,pracovnici where id_pracmist = " + id_pracmist.ToString() +
                                             " and prac_pom.os_cislo=pracovnici.os_cislo " +
                                             " and prac_pom.datum_nastupu <= " + SqlPrikaz.DateTimeToString(datum) +
                                             " and (prac_pom.datum_ukonc >= " + SqlPrikaz.DateTimeToString(datum) + " or prac_pom.datum_ukonc is null)";
                    IDataReader reader = SqlPrikaz.ExecuteReader(sql);
                    while (reader.Read())
                    {
                        decimal osc_pom = reader.GetDecimal(0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 3, -1);
                        //if (Globals.RadkovePrava.OsCislo(osc_pom))
                        //PH 27.5.2015
                        if (Globals.RadkovePrava.OsCislo(osc_pom, cislo_pom))
                        {
                            item = new ListItem(osc_pom.ToString() + " - " + reader.GetString(1).Trim() + " " + reader.GetString(2).Trim(), osc_pom.ToString());
                            DropDownList1.Items.Add(item);
                        }
                    }
                    reader.Close();
                    if (DropDownList1.Items.Count > 1) DropDownList1.SelectedIndex = 1;
                }

                TLabel2.Text = id_pracmist.ToString();
            }
        }
    }
    protected void Page_Load(object sender, EventArgs e)
    {
        // base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            tx_datum.SelectedDate = DateTime.Now.Date;
            //MD 1.11.2016 na základě požadavku HD 33954
            if (Zakaznik.IsCurrent("UJV_REZ_GROUP"))
            {
                //CheckBox1.Checked = true;
                //CheckBox1.Enabled = false;
                CheckBox.Checked = true;
                CheckBox.Enabled = false;
            }
        }
    }
    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {
        SpustiSestavu();
    }

    protected void TGridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            TLabel l_nazev = (TLabel)e.Row.FindControl("TLabel1");
            TCheckBox tchb = (TCheckBox)e.Row.FindControl("TCheckBox1");
            string skup = l_nazev.Text;

            if (skup == _nazevSkup)
            {
                citac++;
                l_nazev.Text = "";
                e.Row.Cells[0].Visible = false;
                tchb.Visible = false;
                _cell.Attributes.Add("rowspan", Convert.ToString(citac + 1));
            }
            else
            {
                _cell = e.Row.Cells[0];
                tchb.Visible = true;
                string nazev_skup = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "skupina_nazev"));
                if (nazev_skup == "[%Zaměstnanec%]" && DropDownList1.Items.Count == 1)
                    tchb.Checked = false;
                citac = 0;
            }

            //_cell.Style.Add("border-top-color", Color.Black.ToString());
            //_cell.Style.Add("border-top-style", "solid");
            //_cell.Style.Add("border-top-width", "1px");

            _cell.Attributes.Add("valign", "top");
            _cell.Style.Add(HtmlTextWriterStyle.BackgroundColor, "white");

            _nazevSkup = skup;

            int atr = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "cis_atributu"));
            if (atr == -3)
            {
                //e.Row.Cells[1].Attributes.Add("colspan", "2");
                e.Row.Cells[2].Style.Add(HtmlTextWriterStyle.FontSize, "1.2em");
                e.Row.Cells[2].Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
                //e.Row.Cells[2].Style.Add(HtmlTextWriterStyle.PaddingLeft, "20px");
                //e.Row.Cells[2].Visible = false;
            }

            DataRow r = table.NewRow();
            r["skupina"] = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "skupina"));
            r["skupina_poradi"] = Convert.ToInt16(DataBinder.Eval(e.Row.DataItem, "skupina_poradi"));
            r["skupina_nazev"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "skupina_nazev"));
            r["vlastnost"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "vlastnost"));
            r["hodnota"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "hodnota"));
            r["cis_atributu"] = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "cis_atributu"));
            r["vypracoval"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "vypracoval"));
            r["vypracoval_dne"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "vypracoval_dne"));
            r["schvalil"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "schvalil"));
            r["schvalil_dne"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "schvalil_dne"));
            r["platnost_od"] = Convert.ToString(DataBinder.Eval(e.Row.DataItem, "platnost_od"));
            r["poradi_sestava"] = DataBinder.Eval(e.Row.DataItem, "poradi_sestava");
            table.Rows.Add(r);
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.BackColor = Color.White;
            e.Row.ForeColor = Color.Black;
            e.Row.Cells[0].Visible = false;
            e.Row.Cells[1].Visible = false;
            e.Row.Cells[2].Attributes.Add("colspan", "3");

            FormView frm = (FormView)e.Row.Cells[2].FindControl("FormView1");
            frm.DataSourceID = "ds_sestava";

            frm.DataBind();

        }
        else if (e.Row.RowType == DataControlRowType.Header)
        {
            e.Row.BackColor = Color.White;
            e.Row.ForeColor = Color.Black;
            //e.Row.Cells[0].Visible = false;
            //e.Row.Cells[1].Visible = false;
            //e.Row.Cells[2].Attributes.Add("colspan", "3");
            //e.Row.Cells[2].Attributes.Add("align", "left");
        }
    }

    //nahrazeno za telerik button 
    //protected void TImageButton1_Click(object sender, ImageClickEventArgs e)
    //{
    //    Session["id_pracmist"] = IDPracmist;
    //    Session["sourcedatatable"] = string.IsNullOrEmpty(SelectedGroups) ? SourceTable : SourceTable.Select("skupina in (" + SelectedGroups + ")").CopyToDataTable();
    //    Session["selectedgroups"] = SelectedGroups;
    //    String Title = "Popis Pracovního Místa";
    //    String Url = "/Sestavy/PopisPracMist.aspx";

    //    if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
    //    {
    //        Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
    //    }
    //    else
    //    {
    //        string path = HttpContext.Current.Request.RawUrl;
    //        Url = path.Substring(0, path.Length - 30) + Url;
    //    }

    //    PopupParam popup = new PopupParam(this.Page, Title, Url);
    //    popup.Status = true;
    //    popup.Toolbar = false;
    //    popup.Location = true;
    //    popup.Menubar = true;
    //    popup.Titulek = Title;
    //    popup.Height = 700;
    //    popup.Width = 670;
    //    //PopupParam popup = new PopupParam(this, "Rozdělení přesčasů", @"../sestava.aspx");
    //    popup.Show();
    //    //tisk.Print(prListy, false);
    //}
    protected void TGridView1_DataBound(object sender, EventArgs e)
    {
        SourceTable = table;
    }

    protected void PrintButton_Click(object sender, EventArgs e)
    {
        Session["id_pracmist"] = IDPracmist;
        Session["sourcedatatable"] = string.IsNullOrEmpty(SelectedGroups) ? SourceTable : SourceTable.Select("skupina in (" + SelectedGroups + ")").CopyToDataTable();
        Session["selectedgroups"] = SelectedGroups;
        String Title = "Popis Pracovního Místa";
        String Url = "/Sestavy/PopisPracMist.aspx";

        if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
        {
            Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
        }
        else
        {
            string path = HttpContext.Current.Request.RawUrl;
            Url = path.Substring(0, path.Length - 30) + Url;
        }

        PopupParam popup = new PopupParam(this.Page, Title, Url);
        popup.Status = true;
        popup.Toolbar = false;
        popup.Location = true;
        popup.Menubar = true;
        popup.Titulek = Title;
        popup.Height = 700;
        popup.Width = 670;
        popup.Show();
    }

    protected void CheckBox_CheckedChanged(object sender, EventArgs e)
    {
        SpustiSestavu();
    }

    protected void tx_datum_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        DropDownList1.Items.Clear();
        SpustiSestavu();
    }
}
