﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.Premie;
using KSProgram.Systemizace;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class PremieCerpaniSchvalovani : System.Web.UI.UserControl
    {
        decimal zustatek = 0;

        public TRadGrid TRG_grid
        {
            get
            {
                return TRG_premie;
            }
        }
        public bool IsPozadavek { get; set; }
        public int? IdPozadavku
        {
            get
            {
                object o = ViewState["IdPozadavkuC"];
                if (o == null) return null;
                else return (int?)o;
            }
            set
            {
                ViewState["IdPozadavkuC"] = value;
            }
        }
        public DateTime? ObdobiPozadavku
        {
            get
            {
                object o = ViewState["ObdobiPozadavkuC"];
                if (o == null) return null;
                else return (DateTime?)o;
            }
            set
            {
                ViewState["ObdobiPozadavkuC"] = value;
            }
        }


        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

            if (IsPozadavek)
            {
                TRG_premie.MasterTableView.GetColumn("zustatek").Visible = true;
                TRG_premie.MasterTableView.GetColumn("stav_pozadavku").Visible = false;
                TRG_premie.MasterTableView.GetColumn("sys_stav_t").Visible = false;
                TRG_premie.MasterTableView.GetColumn("faze_pozadavku").Visible = false;
                TRG_premie.MasterTableView.GetColumn("id_pozadavku").Visible = false;
                TRG_premie.MasterTableView.GetColumn("editable").Visible = false;

                TRG_premie.GroupingEnabled = false;
                TRG_premie.ShowGroupPanel = false;
                TRG_premie.ClientSettings.AllowDragToGroup = false;
                TRG_premie.MasterTableView.Caption = "Odměna";
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                TRG_premie.Datum.SelectedObdobi = Globals.AktObdobi;
            }
        }

        protected void TRG_premie_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                RadNumericTextBox RNTB_zustatek = e.Item.FindControlRecursive<RadNumericTextBox>("RNTB_zustatek");
                RNTB_zustatek.DbValue = zustatek;

                if(IsPozadavek)
                {
                    TRadButton TRB_InsertPozadavky = e.Item.FindControlRecursive<TRadButton>("TRB_InsertPozadavky");
                    TRB_InsertPozadavky.Visible = false;

                    GridCommandItemControl gcic = TRG_premie.GetGridCommandItemControl;
                    if (gcic != null)
                    {
                        gcic.FilterButton.Visible = false;
                        gcic.DateControl = GridCommandItemControl.ControlsDate.None;
                        gcic.TRadObdobi.Visible = false;
                    }
                }
            }
        }

        protected void TRG_premie_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DateTime? obdobi = TRG_premie.Datum.SelectedObdobi;

            if (IsPozadavek && IdPozadavku != null && ObdobiPozadavku != null)
            {
                TRG_premie.DataSource = FondOdmen.GetOdmeny((DateTime)ObdobiPozadavku, IdPozadavku);

                zustatek = Premie.Prostredky(null, null, FondOdmen.getBudgetObdobi((DateTime)obdobi), null, 0)
                    .FindAll(x => x.TypOj == 2
                    && FondOdmen.getSysStromFromCache((DateTime)ObdobiPozadavku).GetMistoVSystemizaci(Globals.OsCisloAktUserNeboZastupovany).GetMista().Select(y => y.ToString()).Contains(x.Oj))
                    .Sum(z => z.Zustatek);
            }
            else if (!IsPozadavek && obdobi != null)
            {
                TRG_premie.DataSource = FondOdmen.GetOdmeny((DateTime)obdobi);
                zustatek = Premie.Prostredky(null, null, FondOdmen.getBudgetObdobi((DateTime)obdobi), null, 0)
                    .FindAll(x => x.TypOj == 2
                    && FondOdmen.getSysStromFromCache((DateTime)obdobi).GetMistoVSystemizaci(Globals.OsCisloAktUserNeboZastupovany).GetMista().Select(y => y.ToString()).Contains(x.Oj))
                    .Sum(z => z.Zustatek);
            }
            else
            {
                TRG_premie.DataSource = null;
            }
        }

        protected void TRG_premie_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            DateTime? obdobi = TRG_premie.Datum.SelectedObdobi;
            if (obdobi != null)
            {
                SystemizacePodniku sys = new SystemizacePodniku();
                SystemizacniStrom strom = sys.SystemizaceStrom(SystemizacePodniku.IdPlatneSystemizace((DateTime)obdobi), (DateTime)obdobi, new StavStromu() { Zamestnanci = true });

                //List<Premie.Radek> rozpocty = Premie.Prostredky(null, null, FondOdmen.getBudgetObdobi((DateTime)obdobi), null, 0);
                string error = null;
                foreach (Telerik.Web.UI.GridBatchEditingCommand command in e.Commands)
                {
                    if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Update)
                    {
                        int? id_zdroj = GetNullOrData.GetInt32(command.OldValues["id_zdroj"]);
                        if (id_zdroj != null)
                        {
                            Premie.Radek rozpocet = Premie.Prostredky(id_zdroj, null, null, null, 0).FirstOrDefault();
                            decimal castka = ((command.NewValues["castka"] is string && string.IsNullOrEmpty(command.NewValues["castka"].ToString())) ? 0 : GetNullOrData.GetDecimal(command.NewValues["castka"])) ?? 0;
                            decimal castka_old = GetNullOrData.GetDecimal(command.OldValues["castka"]) ?? 0;
                            if ((castka - castka_old) > rozpocet.Zustatek)
                            {
                                if (rozpocet.Zustatek == 0)
                                {
                                    error = ReadGlobalResource.ZmenaTextu("[%Rozpočet je vyčerpán%]");
                                    break;
                                }
                                else
                                {
                                    castka = rozpocet.Zustatek + castka_old;
                                }
                            }
                            string popis = GetNullOrData.GetString(command.NewValues["popis"]);
                            popis = popis?.Length > 100 ? popis.Substring(0, 100) : popis;
                            decimal? os_cislo = GetNullOrData.GetDecimal(command.OldValues["os_cislo"]);
                            short? cislo_pom = GetNullOrData.GetInt16(command.OldValues["cislo_pom"]);
                            int? id = GetNullOrData.GetInt32(command.OldValues["id"]);

                            if (os_cislo != null && cislo_pom != null)
                            {
                                if (id == null)
                                {
                                    if (castka > 0)
                                    {
                                        short mzd_kod = Parametry.PovinnyParametrCti<short>("FO_MzdPol");
                                        Premie.InsertCerpani(100, id_zdroj, null, obdobi, os_cislo, cislo_pom, 1, os_cislo.ToString(), null, castka, popis, mzd_kod, true, ref error);
                                        if (!string.IsNullOrEmpty(error))
                                            break;

                                    }
                                }
                                else
                                {
                                    if (castka > 0)
                                    {
                                        Premie.UpdateCerpani((int)id, id_zdroj, castka, popis, true, ref error);
                                        if (!string.IsNullOrEmpty(error))
                                            break;
                                    }
                                    else
                                    {
                                        int? id_pozadavku = GetNullOrData.GetInt32(command.OldValues["id_pozadavku"]);
                                        if (id_pozadavku != null)
                                        {
                                            Pozadavekpremiefo pfo = new Pozadavekpremiefo();
                                            pfo.DeleteBase((long)id_pozadavku);
                                        }
                                        else
                                        {
                                            Premie.DeletePremie(id, null, null, null, null);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                if (!string.IsNullOrEmpty(error))
                {
                    MessageBox.Alert(this.Page, error, ReadGlobalResource.ZmenaTextu("[%Chyba při ukládání%]"));
                }
            }
        }

        protected void TRB_InsertPozadavky_Click(object sender, EventArgs e)
        {
            DateTime? obdobi = TRG_premie.Datum.SelectedObdobi;
            if (obdobi != null)
            {
                List<Int32> odmeny = (from o in FondOdmen.GetOdmeny((DateTime)obdobi).AsEnumerable()
                                      where GetNullOrData.GetInt32(o["id_pozadavku"]) == null
                                         && GetNullOrData.GetInt32(o["id"], 0) > 0
                                         && GetNullOrData.GetDecimal(o["castka"], 0) > 0
                                      select GetNullOrData.GetInt32(o["id"], 0)).ToList();

                foreach (int o in odmeny)
                {
                    int id_poz = 0;
                    KSProgram.Pozadavky.Pozadavekpremiefo.Insert(ref id_poz, ((DateTime)obdobi).PosledniDen(), (DateTime)obdobi, new List<int>() { o }, null);
                }

                TRG_premie.Rebind();
            }
        }

        protected void TRG_premie_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;
                bool? visible = GetNullOrData.GetBool(((DataRowView)dataItem.DataItem).Row["visible"]);
                bool? editable = GetNullOrData.GetBool(((DataRowView)dataItem.DataItem).Row["editable"]);
                int? id_poz = GetNullOrData.GetInt32(((DataRowView)dataItem.DataItem).Row["id_pozadavku"]);

                if ((visible != null && visible == false))
                {
                    dataItem.Display = false;
                }

                if (id_poz == null)
                {
                    RadComboBox RCB_zmena_stavu = dataItem.FindControlRecursive<RadComboBox>("RCB_zmena_stavu");
                    if (RCB_zmena_stavu != null)
                        RCB_zmena_stavu.Visible = false;

                    TRadButton TRB_pozadavek = dataItem.FindControlRecursive<TRadButton>("TRB_pozadavek");
                    if (TRB_pozadavek != null)
                        TRB_pozadavek.Visible = false;
                }
            }
        }

        protected void RCB_zmena_stavu_ItemsRequested(object sender, RadComboBoxItemsRequestedEventArgs e)
        {
            RadComboBox RCB_zmena_stavu = sender as RadComboBox;
            RCB_zmena_stavu.Items.Clear();
            object o_id_poz = e.Context["id_pozadavku"];
            int id_poz;
            if (o_id_poz != null && o_id_poz is string && (string)o_id_poz != "" && int.TryParse((string)o_id_poz, out id_poz))
            {
                WorkflowMaster wf = new KSProgram.Pozadavky.WorkflowMaster(id_poz, "premiefo", 27);
                if (wf.StavyAkt.Stavy.Count == 0)
                    e.Message = "Není následný stav";
                else
                {
                    foreach (Str_workfl_stavy wfstav in wf.StavyAktPristupne) //stavy přístupné přihlášenému uživateli
                    {
                        if (wf.isAdresat())
                        {
                            RCB_zmena_stavu.Items.Add(new RadComboBoxItem(wfstav.popis, wfstav.stav));
                        }
                        else if (wf.isSpravce()) //jsem správcem a nejsem všude adresátem, takže musím vzít jen stavy, na které má přístup správce (odfiltrování těch které mají přístup jen pro adresáta)
                        {
                            if (wfstav.pristup != null && wfstav.pristup.Contains("s"))
                                RCB_zmena_stavu.Items.Add(new RadComboBoxItem(wfstav.popis, wfstav.stav));
                        }
                    }
                    if (RCB_zmena_stavu.Items.Count == 0)
                    {
                        e.Message = "Nejste adresátem";
                    }
                }
            }
        }

        protected void TRG_premie_ItemCommand(object sender, GridCommandEventArgs e)
        {
            int id_pozadavku;
            if (e.CommandName == "pozadavek" && int.TryParse(e.CommandArgument.ToString(), out id_pozadavku))
            {
                //Response.Redirect(Pozadavek.BuildURLPozadavkuDetail(id_pozadavku));
                //PH 29.6.2020 HID:51506
                Response.Redirect(Pozadavek.BuildURLPozadavkuDetailInterni(id_pozadavku));
            }
        }
    }
}