﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Funkce;
using System.Drawing;
using KSProgram.WebControls;
using KSProgram.Dochazka;
using Telerik.Web.UI;
using KSProgram.InfoBlob;
using KSProgram.Data;
using System.Data;

namespace KSPortal.Controls
{
    public partial class RozdeleniPrescasu : System.Web.UI.UserControl
    {
        //DateTime obdobi = new DateTime();
        //decimal os_cislo = 0;
        //short cislo_pom = 0;
        int hodinyCelkem = 0;
        int proplatitCelkem = 0;
        bool prac = false;
        bool svat = false;

        protected void Page_Load(object sender, EventArgs e)
        {
            panel_pozn.Visible = ParametryDochazky.ROZD_PRESC_POZNAMKA;
        }

        public void Vytvorit()
        {
            ObjectDataSource ds_rozdelenePrescasy = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdelenePrescasy");
            ObjectDataSource ds_rozdeleniPrescasu = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdeleniPrescasu");
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");

            ds_rozdelenePrescasy.SelectParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdelenePrescasy.SelectParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdelenePrescasy.SelectParameters["obd"].DefaultValue = Obdobi.ToString();

            ds_rozdeleniPrescasu.SelectParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdeleniPrescasu.SelectParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdeleniPrescasu.SelectParameters["obd"].DefaultValue = Obdobi.ToString();

            GridView1.DataSourceID = "ds_rozdeleniPrescasu";
            GridView1.DataBind();

            if (Obdobi < KSProgram.Globals.AktObdobiDochazka)
            {
                Panel pan_skryt = (Panel)WebControlHelperProxy.FindControl(this, "pan_skryt");
                pan_skryt.Visible = false;

                TRadButton but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_rozpocist");
                but.Visible = false;

                but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_Ulozit");
                but.Visible = false;

                prescasy_pozn.Enabled = false;
            }
            else
            {
                Panel pan_skryt = (Panel)WebControlHelperProxy.FindControl(this, "pan_skryt");
                pan_skryt.Visible = true;

                TRadButton but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_rozpocist");
                but.Visible = true;

                but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_Ulozit");
                but.Visible = true;

                prescasy_pozn.Enabled = true;
            }

            //if (ParametryDochazky.PRESCASY_MIMO_PLAN_SMENU)
            //PH 30.10.2017
            if (ParametryDochazky.PRESCASY_MIMO_PLAN_SMENU!=PrescasyMimoPlanSmenuType.Neaplikovat)
            {
                GridView1.Columns[0].HeaderText = "[%Vyšší sazba%]";
                Label1.Text = "K proplacení nižší sazbou";
                Label4.Text = "K proplacení vyšší sazbou";
            }

            

            //string script = "function f(){$find(\"" + RadWindow1.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
            //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "modalPopup", script, true);
        }

        /// <summary>
        /// 
        /// </summary>
        public decimal OsCislo
        {
            get
            {
                return (ViewState["OsCislo"] == null ? -1 : (decimal)ViewState["OsCislo"]);
            }
            set
            {
                ViewState["OsCislo"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int CisloPom
        {
            get
            {
                return (ViewState["CisloPom"] == null ? -1 : (int)ViewState["CisloPom"]);
            }
            set
            {
                ViewState["CisloPom"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi"] == null ? new DateTime() : (DateTime)ViewState["Obdobi"]);
            }
            set
            {
                ViewState["Obdobi"] = value;
            }
        }



        /*
    public Dochazka_RozdeleniPrescasu()
    {
        LoginRequired = false;
        UserTheme = UserThemes.Dochazka;
        EnableChangeLanguage = false; //PH 9.7.2010
    }

    protected override void Page_PreLoad(object sender, EventArgs e)
    {
        base.Page_PreLoad(sender, e);

        obdobi = Convert.ToDateTime(Session["prescasy_obdobi"]);
        os_cislo = Convert.ToDecimal(Session["prescasy_os_cislo"]);
        cislo_pom = Convert.ToInt16(Session["prescasy_cislo_pom"]);
    }

         * */
        protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType==DataControlRowType.Header)
            {
                hodinyCelkem = 0;
                proplatitCelkem = 0;
            }
            else if (e.Row.RowType == DataControlRowType.DataRow)
            {
                DateTime dat = Convert.ToDateTime(DataBinder.Eval(e.Row.DataItem, "datum"));
                e.Row.Cells[2].Text = dat.ToString("d.M.yyyy");

                int pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "hodiny"));
                e.Row.Cells[4].Text = Cas_na_min.GetCas(pom);
                hodinyCelkem += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "proplatit"));
                e.Row.Cells[5].Text = Cas_na_min.GetCas(pom);
                proplatitCelkem += pom;

                object objsv = DataBinder.Eval(e.Row.DataItem, "svatek");
                bool svatek = false;
                if (objsv != DBNull.Value)
                {
                    svatek = Convert.ToBoolean(DataBinder.Eval(e.Row.DataItem, "svatek"));
                }

                if (svatek)
                {
                    e.Row.Cells[1].ForeColor = Color.Red;
                    e.Row.Cells[2].ForeColor = e.Row.Cells[1].ForeColor;
                }
                else if ((e.Row.Cells[1].Text == "So") || (e.Row.Cells[1].Text == "Ne"))
                {
                    e.Row.Cells[1].ForeColor = Color.Blue;
                    e.Row.Cells[2].ForeColor = e.Row.Cells[1].ForeColor;
                }
                if (svatek)
                {
                    svat = true;
                }
                else
                {
                    prac = true;
                }
            }
            else if (e.Row.RowType == DataControlRowType.Footer)
            {
                e.Row.Cells[4].Text = Cas_na_min.GetCas(hodinyCelkem);
                e.Row.Cells[5].Text = Cas_na_min.GetCas(proplatitCelkem);
            }
        }
        protected void LB_rozpocist_Command(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            //GridView1.DataSourceID = "ds_rozdeleniPrescasu";
            GridView1.DataSourceID = "ds_rozdelenePrescasy";
            GridView1.DataBind();
        }

        
        protected void LB_Ulozit_Command(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            ObjectDataSource ds_rozdelenePrescasy = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdelenePrescasy");
            ds_rozdelenePrescasy.UpdateParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdelenePrescasy.UpdateParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdelenePrescasy.UpdateParameters["obd"].DefaultValue = Obdobi.ToString();

            //GridView1.DataSourceID = "ds_rozdelenePrescasy";
            //GridView1.DataBind();
            if (panel_pozn.Visible)
            {
                //int? id = null;
                string informace = prescasy_pozn.Text;
                /*
                ParametryPrikazu par = new ParametryPrikazu()
                {
                    new KSParameter("os_cislo", DbType.Decimal, OsCislo),
                    new KSParameter("cislo_pom", DbType.Int16, CisloPom),
                    new KSParameter("datum", DbType.DateTime, Obdobi)
                };
                SqlPrikaz.ExecuteNonQuery("delete from info_blob where os_cislo=@os_cislo and cislo_pom=@cislo_pom and datum_od=@datum", true, par);
                if (!string.IsNullOrEmpty(informace))
                {
                    SqlPrikaz.SaveTextToInfoBlob(ref id, OsCislo, (short)CisloPom, info_blob_pouziti, Obdobi, Obdobi, informace, false, null, null, "");
                }
                */
                //PH 21.6.2019
                KSProgram.Dochazka.RozdeleniPrescasu.SmazatPoznamkuKPrescasu(OsCislo, (short)CisloPom, Obdobi);
                KSProgram.Dochazka.RozdeleniPrescasu.UlozitPoznamkuKPrescasu(OsCislo, (short)CisloPom, Obdobi, informace);
            }
            ds_rozdelenePrescasy.Update();
            GridView1.DataBind();

        }
        protected void GridView1_DataBound(object sender, EventArgs e)
        {
            RadNumericTextBox TB_k_proplac_hodin = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_hodin");
            RadNumericTextBox TB_k_proplac_minut = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_minut");

            RadNumericTextBox TB_k_proplac_minut_svatek = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_minut_svatek");
            RadNumericTextBox TB_k_proplac_hodin_svatek = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_hodin_svatek");

            TB_k_proplac_hodin.Enabled = prac;
            TB_k_proplac_minut.Enabled = TB_k_proplac_hodin.Enabled;

            TB_k_proplac_minut_svatek.Enabled = svat;
            TB_k_proplac_hodin_svatek.Enabled = TB_k_proplac_minut_svatek.Enabled;

            if ((panel_pozn.Visible) &&(!IsPostBack))
            {
                /*
                string sql = "select informace from info_blob where os_cislo=@os_cislo and cislo_pom=@cislo_pom and datum_od=@datum and pouziti=@pouziti";
                ParametryPrikazu par = new ParametryPrikazu()
                {
                    new KSParameter("os_cislo", DbType.Decimal, OsCislo),
                    new KSParameter("cislo_pom", DbType.Int16, CisloPom),
                    new KSParameter("datum", DbType.Date, Obdobi),
                    new KSParameter("pouziti", DbType.Int32, info_blob_pouziti),
                };
                string text = SqlPrikaz.ExecuteScalarBlobString(sql, par);
                */
                //PH 20.6.2019
                string text=KSProgram.Dochazka.RozdeleniPrescasu.NactiPoznamku(OsCislo, (short)CisloPom, Obdobi);
                prescasy_pozn.Text = text;
            }
        }
        protected void LB_zavrit(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            GridView1.DataSourceID = "";

            ScriptManager.RegisterStartupScript(this, typeof(Page), "ZobrazEditPanel", "zobr=false;", true);
        }
    }
}