﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Controls_TextProperties : System.Web.UI.UserControl
{

    public string BackColor
    {
        get
        {
            //return (ViewState["BackColor"] == null ? "" : (String)ViewState["BackColor"]);
            return txt_dummy_back.Text;
        }
        set
        {
            txt_dummy_back.Text=value;
        }
    }

    public string ForeColor
    {
        get
        {
            //return (ViewState["ForeColor"] == null ? "" : (String)ViewState["ForeColor"]);
            return txt_dumy_fore.Text;
        }
        set
        {
            //ViewState["ForeColor"] = value;
            txt_dumy_fore.Text = value;
        }
    }

    /// <summary>
    /// Font
    /// </summary>
    public String Font
    {
        get
        {
            string val = ddl_fonty.SelectedValue;
            if (val != "default") return val; else return "";
        }
        set
        {
            ddl_fonty.SelectedValue = value;
        }
    }

    /// <summary>
    /// Font
    /// </summary>
    public int FontSize
    {
        get
        {
            string val =ddl_size.SelectedValue;
            if (val == "default")
                return 0;
            else
            {
                val=val.Replace("px", "");
            }
            return Convert.ToInt32(val);
        }
        set
        {
            ddl_size.SelectedValue = value.ToString();
        }
    }

    /// <summary>
    /// Tučné písmo
    /// </summary>
    public bool Bold
    {
        get
        {
            return (ViewState["Bold"] == null ? false : (bool)ViewState["Bold"]);
        }
        set
        {
            ViewState["Bold"] = value;
            nastavObrazky();
        }
    }

    /// <summary>
    /// Kurzíva
    /// </summary>
    public bool Italic
    {
        get
        {
            return (ViewState["Italic"] == null ? false : (bool)ViewState["Italic"]);
        }
        set
        {
            ViewState["Italic"] = value;
            nastavObrazky();
        }
    }

    /// <summary>
    /// Podtržení
    /// </summary>
    public bool Underline
    {
        get
        {
            return (ViewState["Underline"] == null ? false : (bool)ViewState["Underline"]);
        }
        set
        {
            ViewState["Underline"] = value;
            nastavObrazky();
        }
    }

    /// <summary>
    /// Horizontální zarovnání
    /// </summary>
    public HorizontalAlign HorAlign
    {
        get
        {
            return (ViewState["HorAlign"] == null ? HorizontalAlign.NotSet : (HorizontalAlign)ViewState["HorAlign"]);
        }
        set
        {
            ViewState["HorAlign"] = value;
        }
    }

    protected void _nastavZarovnani(object sender, CommandEventArgs e)
    {
        ImageButton c=(ImageButton) sender;
        if (c.ID == "img_justify_left")
        {
            if (c.ImageUrl.Contains("selected"))
            {
                HorAlign = HorizontalAlign.NotSet;
            }
            else
            {
                HorAlign = HorizontalAlign.Left;
            }
               
        }

        if (c.ID == "img_justify_right")
        {
            if (c.ImageUrl.Contains("selected"))
            {
                HorAlign = HorizontalAlign.NotSet;
            }
            else
            {
                HorAlign = HorizontalAlign.Right;
            }
        }

        if (c.ID == "img_justify_center")
        {
            if (c.ImageUrl.Contains("selected"))
            {
                HorAlign = HorizontalAlign.NotSet;
            }
            else
            {
                HorAlign = HorizontalAlign.Center;
            }
        }
        _nastavIkonyZarovnani();
    }

    private void _nastavIkonyZarovnani()
    {      
        if (HorAlign == HorizontalAlign.Left)
        {
            img_justify_left.ImageUrl = "~/Images/justify_left_selected.png";
            img_justify_right.ImageUrl = "~/Images/justify_right.png";
            img_justify_center.ImageUrl = "~/Images/justify_center.png";
        }
        else if (HorAlign == HorizontalAlign.Right)
        {
            img_justify_left.ImageUrl = "~/Images/justify_left.png";
            img_justify_right.ImageUrl = "~/Images/justify_right_selected.png";
            img_justify_center.ImageUrl = "~/Images/justify_center.png";
        }
        else if (HorAlign == HorizontalAlign.Center)
        {
            img_justify_left.ImageUrl = "~/Images/justify_left.png";
            img_justify_right.ImageUrl = "~/Images/justify_right.png";
            img_justify_center.ImageUrl = "~/Images/justify_center_selected.png";
        }
        else if (HorAlign == HorizontalAlign.NotSet)
        {
            img_justify_left.ImageUrl = "~/Images/justify_left.png";
            img_justify_right.ImageUrl = "~/Images/justify_right.png";
            img_justify_center.ImageUrl = "~/Images/justify_center.png";
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        /*
        if (Bold)
            img_bold.ImageUrl = "~/Images/bold_selected.png";
        else
            img_bold.ImageUrl = "~/Images/bold.png";

        if (Italic)
            img_italic.ImageUrl = "~/Images/italic_selected.png";
        else
            img_italic.ImageUrl = "~/Images/italic.png";

        if (Underline)
            img_underline.ImageUrl = "~/Images/underline_selected.png";
        else
            img_underline.ImageUrl = "~/Images/underline.png";
         * */
        nastavObrazky();

        _nastavIkonyZarovnani();
    }

    protected void nastavObrazky()
    {
        if (Bold)
            img_bold.ImageUrl = "~/Images/bold_selected.png";
        else
            img_bold.ImageUrl = "~/Images/bold.png";

        if (Italic)
            img_italic.ImageUrl = "~/Images/italic_selected.png";
        else
            img_italic.ImageUrl = "~/Images/italic.png";

        if (Underline)
            img_underline.ImageUrl = "~/Images/underline_selected.png";
        else
            img_underline.ImageUrl = "~/Images/underline.png";
    }

    protected void img_bold_Command(object sender, CommandEventArgs e)
    {
        Bold = !((ImageButton)sender).ImageUrl.Contains("selected");
        if (Bold)
            ((ImageButton)sender).ImageUrl="~/Images/bold_selected.png";
        else
             ((ImageButton)sender).ImageUrl="~/Images/bold.png";

    }

    protected void img_underline_Command(object sender, CommandEventArgs e)
    {
        Underline = !((ImageButton)sender).ImageUrl.Contains("selected");
        if (Underline)
            ((ImageButton)sender).ImageUrl = "~/Images/underline_selected.png";
        else
            ((ImageButton)sender).ImageUrl = "~/Images/underline.png";
    }

    protected void img_italic_Command(object sender, CommandEventArgs e)
    {
        Italic = !((ImageButton)sender).ImageUrl.Contains("selected");
        if (Italic)
            ((ImageButton)sender).ImageUrl = "~/Images/italic_selected.png";
        else
            ((ImageButton)sender).ImageUrl = "~/Images/italic.png";
    }
}