﻿using KSProgram;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Data;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using static KSProgram.Pozadavky.Pozadavekodmenysl;

namespace KSPortal.Controls
{
    public partial class WfOdmeny : System.Web.UI.UserControl
    {
        private TRadButton _ButtPoznamka
        {
            get
            {
                TRadButton button = null;
                button = (TRadButton)TRGrid.GetGridCommandItem("butt_poznamka", typeof(TRadButton));
                if (button != null)
                    return button;
                else
                    return null;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
           
        }
        protected void TRGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            if (IsPostBack)
            {
                DateTime date = (DateTime)TRGrid.Datum.SelectedObdobi;               
                _ButtPoznamka.Checked = _getCheckedFromViewState();
                table = new KSProgram.Sestavy.SestavaWFOdmeny().Retrieve(date, _ButtPoznamka.Checked);
                TRGrid.DataSource = table;              
            }
            _prepniColumnPoznamka();

            //PH 8.11.2021
            _generujExtraSloupce();

            TRGrid.DataSource = table;           
        }
      
        protected void butt_poznamka_CheckedChanged(object sender, EventArgs e)
        {
           
            ViewState.Add("PoznamkaColumn", _ButtPoznamka.Checked);
        }

        private void _prepniColumnPoznamka()
        {
            if (_ButtPoznamka != null)
                TRGrid.MasterTableView.GetColumn("poznamka").Visible = _ButtPoznamka.Checked;
            
        }

        private void _generujExtraSloupce()
        {
            foreach(OdmenySlExtraPolozka it in Pozadavekodmenysl.ExtraPolozky )
            {
                if (TRGrid.MasterTableView.Columns.FindByDataFieldSafe(it.CollName) != null)
                    return;

                GridBoundColumn boundColumn = new GridBoundColumn();
                TRGrid.MasterTableView.Columns.Add(boundColumn);
                boundColumn.DataField = it.CollName;
                boundColumn.HeaderText = "[%" + it.Nazev + "%]";
                if (it.Typ == typeof(decimal))
                    boundColumn.DataFormatString = "{0:F2}";
                boundColumn.UniqueName = it.CollName;
                boundColumn.ItemStyle.Width = it.Sirka;
                boundColumn.HeaderStyle.Width = it.Sirka;
                boundColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                boundColumn.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                boundColumn.DataType = it.Typ;
                boundColumn.FooterText = "";
                boundColumn.AllowFiltering = true;
                boundColumn.EnableHeaderContextMenu = false;
            }
        }

        private bool _getCheckedFromViewState()
        {
            object o = ViewState["PoznamkaColumn"];

            return (o != null ? Convert.ToBoolean(o) : false);

        }

        protected void butt_poznamka_PreRender(object sender, EventArgs e)
        {
           _ButtPoznamka.Checked= _getCheckedFromViewState();
        }

        protected void TRGrid_Load(object sender, EventArgs e)
        {
            GridBoundColumn col_sazba = (GridBoundColumn) TRGrid.MasterTableView.GetColumn("col_sazba");
            GridBoundColumn col_castka = (GridBoundColumn) TRGrid.MasterTableView.GetColumn("col_castka");
            if (Globals.KodMeny == "CZK")
                col_sazba.DataFormatString = "{0:###,##0}";                
            else
                col_sazba.DataFormatString = "{0:###,##0.00}";

            col_castka.DataFormatString = col_sazba.DataFormatString;
        }
    }
}