﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Collections.Generic;
using KSProgram.Exceptions;
using KSProgram.Security;
using System.Text.RegularExpressions;
using KSProgram.Ciselniky;

namespace KSPortal.Controls
{
    public partial class ZRZ_KS_2021 : UserControlPozadavek
    {
        public override string Typ
        {
            get { return "zroczuct"; }
        }

        private List<string> _povinnePrilohy = new List<string>();
        //private List<string> _povinnePrilohyStr2 = new List<string>();
        protected FormViewMode FakeMode
        {
            get
            {
                object o = ViewState["FakeMode"];
                if (o == null)
                    return FormViewMode.ReadOnly;
                else
                    return (FormViewMode)o;
            }
            set
            {
                ViewState["FakeMode"] = value;
            }
        }

        public ObjectDataSource ObjectDataSource1
        {
            get { return (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1"); }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Page_PreRender()
        {
            string firma = "Tieto";
            if (!Zakaznik.IsCurrent("TIETO")) //PR 17.10.2022 HID=63090
                CisPodniky.Nazev(IdPodniku); 
            Label Lab_prijmy_predch = (Label)FormView1.FindControl("Lab_prijmy_predch") ;
            Lab_prijmy_predch.Text = ReadGlobalResource.ZmenaTextu("([%Vyplňte pouze v případě, že jste měl předchozí zaměstnání v roce {0} před nástupem do {1}%])", WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok"), firma);

            //PR 03.01.2022 Schovat tabulku pro uložení a změnu stavu, musí nejdříve kliknout na tlačítko "Přejít k podpisu"  
            //Control c = WebControlHelper.FindControl(Page, "UC_ZmenaStavu");
            //c.Visible = false;
            //c = WebControlHelper.FindControl(Page, "PanelCommand");
            //c.Visible = false;
            //nefungovalo v 1. kroku, kdy to prenastavi PozadavekDetail.Nacist, dano primo do pozadavekDetail.Nacist
        }

        protected string ZmenaTextu1(string text, string arg)
        {
            if (arg == null) arg = "";
            return ReadGlobalResource.ZmenaTextu(text, arg);
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert" || val == "edit")
            {
                if (PozId == 0)
                    FakeMode = FormViewMode.Insert;//FormView1.ChangeMode(FormViewMode.Insert);
                else
                    FakeMode = FormViewMode.Edit;//FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
                FakeMode = FormViewMode.ReadOnly;//FormView1.ChangeMode(FormViewMode.ReadOnly);

            if (wf.Get_UN("", "Form1", "Visible") == "false")
                FormView1.Visible = false;
            else
            {
                FormView1.DataSourceID = "ObjectDataSource1";
                FormView1.DataBind();

                if (FakeMode != FormViewMode.ReadOnly)//PR 09.01.2019 
                {
                    ODS_manzelky.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_manzelky.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();

                    RadDropDownList DDL = (RadDropDownList)FormView1.FindControl("DDL_manzelka");
                    DDL.DataSourceID = "ODS_manzelky";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "M_rc");
                    //------------------------------------------------------------------------------------
                    ODS_deti.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_deti.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_dite1");
                    DDL.DataSourceID = "ODS_deti";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "D1_rc");

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_dite2");
                    DDL.DataSourceID = "ODS_deti";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "D2_rc");
                    //------------------------------------------------------------------------------------
                    ODS_rodprisl.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_rodprisl.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();
                    DDL = (RadDropDownList)FormView1.FindControl("DDL_rodprisl1");
                    DDL.DataSourceID = "ODS_rodprisl";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "U1_rc");

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_rodprisl2");
                    DDL.DataSourceID = "ODS_rodprisl";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "U2_rc");

                }

                //bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
                bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

                DataTable dtsloupce = Pozadavekzroczuct.GetDataTable();
                foreach (DataColumn dc in dtsloupce.Columns)
                {
                    string col = dc.ColumnName;
                    //bool readOnly = (FakeMode == FormViewMode.ReadOnly);
                    //Control c = FormView1.FindControl(col);
                    //if (c == null) continue;
                    //if (c is TextBox)
                    //    (c as TextBox).Enabled = !readOnly; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                    //else if (c is CheckBox)
                    //    (c as CheckBox).Enabled = !readOnly;
                    //else if (c is RadDropDownList)
                    //    (c as RadDropDownList).Enabled = !readOnly;
                    Control c = FormView1.FindControl(col);
                    if (c == null) continue;
                    bool disabled = (FakeMode == FormViewMode.ReadOnly) || (c is TTextBox && (c as TTextBox).ReadOnly);
                    if (c is TextBox)
                        (c as TextBox).Enabled = !disabled; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                    else if (c is CheckBox)
                        (c as CheckBox).Enabled = !disabled;
                    else if (c is RadDropDownList)
                        (c as RadDropDownList).Enabled = !disabled;
                }

            }
            bool neniPodepsan = true;//WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_zadosti") == ""; 
            if (PozId == 0 || wf.FazePosl == 0 || neniPodepsan)
            {
                //ServerValidateEventArgs args = new ServerValidateEventArgs("", false);
                //ValidPre_ServerValidate(this, args);//aby vyběhla prevalidace
                Page.Validate(ValidPre.ValidationGroup);
            }
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FakeMode != FormViewMode.ReadOnly)
                    {
                        if (FakeMode == FormViewMode.Insert)
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            if (FormView1.Visible) //PR 11.12.2020 v 1. kroku může být skryt pro volbu RZ ano/ne skrze volbou WF stavu
                            {
                                foreach (DataColumn c in Pozadavekzroczuct.GetDataTable().Columns)
                                {
                                    values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                                }
                            }
                            int id_poz = 0;
                            decimal adresat = 0;
                            try
                            {
                                adresat = Convert.ToDecimal(ObjectDataSource1.InsertParameters["adresat"].DefaultValue);
                            }
                            catch (FormatException) { }
                            string novy_stav = ObjectDataSource1.InsertParameters["novy_stav"].DefaultValue;
                            string duvod = ObjectDataSource1.InsertParameters["duvod"].DefaultValue;
                            Pozadavekzroczuct.Insert(ref id_poz, Vydavatel, adresat, novy_stav, duvod, values);
                            PozId = id_poz;
                            OnItemInserted(new EventArgs());
                        }
                        else
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekzroczuct.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            if (values.Count == 0 || string.IsNullOrWhiteSpace(values["H_obd_rok"])) //PR 02.02.2021 //PR 09.02.2021 
                            {
                                is_valid = false;
                                throw new NoticeException("Nepodařilo se získat data z formuláře!");
                            }
                            Pozadavekzroczuct.Update(PozId, values);
                            OnItemUpdated(new EventArgs());
                        }

                    }
                }
            }
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());

        }

        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }


        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            //FormView1.ChangeMode(mode);
            FakeMode = mode;
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FakeMode;//FormView1.CurrentMode;
            }
        }

        private bool FazeOvereni
        {
            get
            {
                return this.WF.Get_UN("", "Overeni", "Mode") == "edit";
            }
        }
        private bool JeVybranStornoStav()
        {
            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    //WorkflowMaster m = new WorkflowMaster(PozId, "zroczuct", null);//zjištění akt. fáze
                    Str_workfl_stavy str_stav_new = WF.GetParamStavu(stav_new);
                    if (str_stav_new.sys_stav == "s")
                        return true;
                }
            }
            return false;
        }

        /// <summary>
        /// Zda vybrany stav v 1. kroku vede do faze se skrytym formularem
        /// </summary>
        /// <returns></returns>
        private bool VybranStavNechciRZ()
        {
            if (PozId > 0)
                return false;

            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    Str_workfl_stavy str_stav_new = WF.GetParamStavu(stav_new);
                    if (str_stav_new.next_faze != null)
                    {
                        workfl_faze f = new workfl_faze(WF.IdMaster, str_stav_new.next_faze.Value);
                        //if (f.UN_Vydav != null)
                        //    if (f.UN_Vydav.Contains("[Form1:Visible=false]"))
                        //        return true;
                        //PR 19.11.2021 
                        if (f.UN_Vydavat.Count > 0)
                            if (WorkflUISettings.GetValue(f.UN_Vydavat, "", "Form1", "Visible").ToLower() == "false")
                                return true;
                    }

                }
            }
            return false;
        }

        protected void ValidPre_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //CustomValidator ValidPre = (CustomValidator)FormView1.FindControl("ValidPre");
            ValidPre.ErrorMessage = "";
            if (FakeMode == FormViewMode.ReadOnly) return;
            //PR 05.02.2021 zakomentovavam nasledujici, protoze musi byt zabraneno, aby nevytvarel vice pozadavku,
            //              nebo nezadaval pozadavek v dubnu.
            //if (!FormView1.Visible) return; //PR 11.12.2020 
            string error;
            int? H_obd_rok = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_rok");

            DateTime ld_AktObdobi = ViceIco.ObdobiPodnikuPodleZamestnance(Vydavatel);//PR 14.01.2020 HID=49553

            bool lb_VybranStornoStav = JeVybranStornoStav();
            //bool lb_chciNechciRZ = FormView1.Visible == false;
            bool lb_nechciRZ = VybranStavNechciRZ();

            //if (PozId == 0)            
            if (PozId == 0 || (PozId > 0 && !lb_VybranStornoStav))//PR 09.02.2021 
            {
                //(PozId == 0): V 1. kroku proběhnou kontroly bez ohledu na storno stav, protože i "Nechci RZ" nelze učinit mimo vymezený časový úsek, atd.
                //(PozId > 0 && !lb_storno): Z důvodu "chci/nechci" nebo možnost opravy probíhá kontrola i po vytvoření požadavku, pokud to není storno stav.
                //-------------------------------------------------------------------------------------------------------------------------------------------

                if (FazeOvereni == false)//PR 05.02.2021 kdyz to neni faze overeni a je to v editaci, tak je to ve fazi vyplnovani
                {
                    if (H_obd_rok != null)
                    {
                        //----------------------------------------------------------------------------------------------------------
                        // Časově omezená možnost vytvářet požadavek
                        //----------------------------------------------------------------------------------------------------------

                        DateTime aktObdobi = (ld_AktObdobi.Year < DateTime.Today.Year) ? DateTime.Today.PrvniDen() : ld_AktObdobi;
                        //if (aktObdobi.Month > 2)
                        //    ValidPre.ErrorMessage += "[%Žádost lze podat pouze v období leden až únor!%]<br/>";
                        //PR 08.01.2021 
                        if (PozId == 0) //PR 02.03.2021 HID=55491 nekontrolovat při opravě, jen při vytváření požadavku
                        {
                            string par = Parametry.ParametrCti("ZadostORZDo");
                            Int16 den;
                            if (par != "0" && Int16.TryParse(par, out den))
                                if (DateTime.Today > new DateTime(aktObdobi.Year, 2, den))
                                    ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Žádost lze podat pouze do {0}. února!%]", den) + "<br/>";
                        }
                        if (H_obd_rok != (aktObdobi.Year - 1))
                            ValidPre.ErrorMessage += "[%Zdaňovací období - rok%] - [%Žádost lze podat pouze pro minulý rok!%]<br/>";

                        //----------------------------------------------------------------------------------------------------------
                        // Podmínky, které musí splnit, aby mohl vytvořit požadavek (i když chce jen prohlásit, že nechce RZ)
                        //----------------------------------------------------------------------------------------------------------
                        //nepodal již žádost?
                        //if (Pozadavekzroczuct.ExistujeNestornovanyProRok(Vydavatel, H_obd_rok.Value) > 0) //PR 05.02.2021 zakomentovano
                        int idp_exist = Pozadavekzroczuct.ExistujeNestornovanyProRok(Vydavatel, H_obd_rok.Value); //PR 05.02.2021 
                        if (idp_exist > 0 && idp_exist != PozId) //PR 05.02.2021 
                            ValidPre.ErrorMessage += "[%Žádost již máte podánu, novou nelze podat!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit žádost k opravě!%]<br/>";

                        //Účetní tam již dala příznak, že se má provést RZ
                        //Sice bych kontrolu mohl zrušit, jenže když to účetní udělala a zamec teď dá, že nechce RZ, tak nemám exe:akci, která by zapsala provest=n. 
                        if (Pozadavekzroczuct.MaJizNavedenoVrzdane(Vydavatel, H_obd_rok.Value))
                            ValidPre.ErrorMessage += "[%Žádost nelze podat, údaje již byly zadány přes agendu roční zúčtování!%]<br/>";

                        //Pokud má již RZ v TK provedeno, tak už nemůže dát ani "nechci RZ"
                        if (null != Pozadavekzroczuct.DatumProvedeniRZ(Vydavatel, H_obd_rok.Value))//PR 26.11.2018 
                            ValidPre.ErrorMessage += "[%Roční zúčtování je již provedeno!%]<br/>";

                        //PR 08.02.2021 HID=54589 uživatel s nástupem až v novém roce, si zadal dodatečné prohlášení a následně i žádost o RZ.
                        //Protože se datum nástupu může při opakovaném nástupu přepsat, kontroluji zde platný PP.
                        List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, new DateTime(H_obd_rok.Value, 1, 1), new DateTime(H_obd_rok.Value, 12, 31));
                        if (pomery.Count == 0)
                        {
                            ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", H_obd_rok.Value) + "<br/>";
                        }

                        //----------------------------------------------------------------------------------------------------------
                        // Podmínky, které musí splnit, když chce RZ
                        //----------------------------------------------------------------------------------------------------------
                        if (!lb_nechciRZ && FormView1.Visible) //PR 01.02.2023 HID=65190 pokud je form skryty a neni kam vyplnit predchozi zamestnavatele, tak nemuzu volat kontrolu
                        {
                            //if (Pozadavekzroczuct.PrijmyNadSolDanPrijmy(Vydavatel, H_obd_rok.Value))
                            //    ValidPre.ErrorMessage += "[%Žádost nelze podat, vaše příjmy přesáhly hranici pro solidární daň!%]<br/>";

                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") == "p" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVpozadavcich(Vydavatel, H_obd_rok.Value, out error))
                            //    ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok, nejprve vyplňte požadavek „prohlášení daně“ s volbou „dodatečně činím“=XD!%] ("+error+")<br/>";
                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") == "m" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVmzdovychUdajich(Vydavatel, H_obd_rok.Value, out error))
                            //        ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok!%] (" + error + ")<br/>";
                            //PR 04.12.2019 zrušil jsem parametr, nyní se kontroluje ze mzdových údajů + dodatečné z požadavků. Tj. ze schválených běžných prohlášení se to dostalo do mzdových údajů.

                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n") //PR 14.01.2020 HID=49624
                            //    if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, out error))
                            //        ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok, nejprve vyplňte požadavek „prohlášení daně“ s volbou „dodatečně činím“=XD!%] (" + error + ")<br/>";
                            //------------------------------------------------------------------------------------------------------------
                            //PR 10.02.2021 HID=55047 nemá podepsán měsíc nástupu, protože měl podepsané u předchozího zaměstnavatele
                            //int ignoruj_mesic = 0;
                            //PR 14.02.2023 pro případ více poměrů v daném roce, předám do funkce všechny měsíce,
                            List<int> ignoruj_mesice = new List<int>();
                            string parseError, mes;
                            //projdu tabulku PŘEDCHOZÍ PLÁTCI pro zjištění posledního měsíce u předchozího zaměstnavatele, 
                            //ten pošlu do funkce a pokud bude chybět a bude to datum nástupu, tak jej funkce bude ignorovat.
                            for (int i = 1; i <= 4; i++)
                            {
                                mes = WebControlHelper.SubCtrlGetValueString(FormView1, "P" + i + "_mes");
                                if (!string.IsNullOrEmpty(mes))
                                {
                                    MesiceRozsah mr = new MesiceRozsah(mes);
                                    if (mr.IsValid(out parseError))
                                    {
                                        //ignoruj_mesic = mr.PosledniMesic();
                                        ignoruj_mesice.AddRange(mr.SeznamMesicu());
                                    }
                                }
                            }
                            if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n")
                                if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, ignoruj_mesice, out error))
                                    ValidPre.ErrorMessage += error + "<br/>";
                            //------------------------------------------------------------------------------------------------------------
                        }
                    }
                }
            }

            //if (PozId > 0)
            //{
            //WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            //bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";
            //if (overeni)
            if (FazeOvereni)
            {
                //Při zápisu do rzdane musí být udělána uzávěrka prosince, kdy vzniká záznam v rzdane, který se updatuje
                if (ld_AktObdobi.Month > 3)
                    ValidPre.ErrorMessage += "[%Žádost lze ověřovat pouze ve mzdovém období leden až březen!%]<br/>";

                if (Pozadavekdanprohl.MaNeschvaleneDodatecneProhlaseni(Vydavatel, H_obd_rok.Value))
                    ValidPre.ErrorMessage += "[%Nejprve schvalte dodatečné prohlášení daně!%]<br/>";

                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") == "p" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVpozadavcich(Vydavatel, H_obd_rok.Value, out error))
                //    ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") == "m" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVmzdovychUdajich(Vydavatel, H_obd_rok.Value, out error))
                //    ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
                //PR 04.12.2019 zrušil jsem parametr, nyní se kontroluje ze mzdových údajů + dodatečné z požadavků. Tj. ze schválených běžných prohlášení se to dostalo do mzdových údajů.
                //PR 10.02.2021 zakomentovávám, stačí kontrola při vyplňování žadatelem
                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n") //PR 14.01.2020 HID=49624
                //    if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, out error))
                //        ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
            }
            //}

            //PR 06.12.2018
            if (ValidPre.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPre.Text = ValidPre.ErrorMessage;
            }
        }

        protected void ValidPg1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator ValidPg1 = (CustomValidator)FormView1.FindControl("ValidPg1");
            ValidPg1.ErrorMessage = "";
            ValidPg1.Text = "";
            _povinnePrilohy.Clear();

            if (FakeMode == FormViewMode.ReadOnly) return;
            if (!FormView1.Visible) return; //PR 11.12.2020 Chci/nechci RZ se schovaným formulářem v 1. kroku
            if (JeVybranStornoStav()) //PR 09.02.2021 stornování v libovolném kroku nebo "Nechci RZ" v kroku 1 se zviditelněným formulářem
                return;
            if (VybranStavNechciRZ()) //PR 09.02.2021 "Nechci RZ" v kroku 1 se zviditelněným formulářem, kdy stav nemá systémový stav storno
                return;

            //WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            //bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok");

            //Validace roku je již ve validátoru výše, navíc je H_obd_rok READONLY
            //if (H_obd_rok != (DateTime.Today.Year - 1).ToString())
            //{
            //   ValidPg1.ErrorMessage += "[%Zdaňovací období - rok%] - [%Žádost lze podat pouze pro minulý rok%]<br/>";
            //}

            string parseError, mes, ztp, mes_ztp;

            //PŘEDCHOZÍ PLÁTCI 
            for (int i = 1; i <= 4; i++) //PR 18.11.2020 ze 2.řádků na 4 a udělán cyklus
            {
                mes = WebControlHelper.SubCtrlGetValueString(FormView1, "P" + i + "_mes");
                //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
                if (!string.IsNullOrEmpty(mes))
                {
                    if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%V kalendářních měsících%] - [%řádek%] " + i + " - [%Neplatný formát%] (" + parseError + ")<br/>";
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "P" + i + "_file")))
                        _povinnePrilohy.Add("- potvrzení o zdanitelných příjmech od předchozího zaměstnavatele č. " + i); //PR 06.12.2019
                }
            }

            //PR 03.01.2023 sleva za zastavenou exekuci
            if (H_obd_rok == "2022")
            {
                try
                {
                    decimal? E_castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "E_castka", true);
                    if (E_castka.HasValue && E_castka.Value < 0) ValidPg1.ErrorMessage += "[%Sleva za zastavenou exekuci%] - [%Částka musí být kladná%]<br/>";
                    if (E_castka.HasValue)
                        if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "E_file")))
                            _povinnePrilohy.Add("- potvrzení o zastavené exekuci");
                }
                catch (Exception)
                {
                    ValidPg1.ErrorMessage += "[%Sleva za zastavenou exekuci%] - [%Neplatný formát%]<br/>";
                }
            }

            //SLEVA NA MANŽELKU
            string jm, prij, rc;
            jm = WebControlHelper.SubCtrlGetValueString(FormView1, "M_jmeno");
            prij = WebControlHelper.SubCtrlGetValueString(FormView1, "M_prijmeni");
            rc = WebControlHelper.SubCtrlGetValueString(FormView1, "M_rc");
            mes = WebControlHelper.SubCtrlGetValueString(FormView1, "M_mes");
            ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "M_ztp");
            mes_ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "M_ztp_mes");

            //PR 31.01.2020 HID=49994 vypínám kontrolu na RC:
            //- nepočítá s 9-ti místným RČ,
            //- je zbytečná, protože se při zápise do RZ nikam nezapisuje,
            //- pole je stejně needitační, protože se tam později udělalo rozbalovátko a jde vybrat pouze manželka již navedená v rod. přisl.
            //if (!string.IsNullOrEmpty(rc))
            //{
            //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
            //    MatchCollection m = r.Matches(rc);
            //    if (m.Count != 1)
            //        ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Neplatný formát%]<br/>";
            //    else
            //    {
            //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
            //        int month = Int16.Parse(m[0].Groups[2].Value);
            //        int day = Int16.Parse(m[0].Groups[3].Value);
            //        int ext = Int16.Parse(m[0].Groups[4].Value);
            //        int mod = (year + month + day + ext) % 11;
            //        if (mod != 0)
            //            ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Neplatné rodné číslo%]<br/>";
            //    }
            //    _povinnePrilohy.Add("- čestné prohlášení manžela(manželky)"); //PR 06.12.2019
            //}
            if (!string.IsNullOrEmpty(prij)) //PR 31.01.2020 
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "M_file")))
                    _povinnePrilohy.Add("- čestné prohlášení manžela(manželky)");

            //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
            if (!string.IsNullOrEmpty(mes))
            {
                if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                    ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 2) - [%Neplatný formát%] (" + parseError + ")<br/>";
            }
            else if (!string.IsNullOrEmpty(jm) || !string.IsNullOrEmpty(prij) || !string.IsNullOrEmpty(rc)) //M_mes je nevyplneno a jmeno nebo prijmeni nebo rc je vyplneno
            {
                ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 2) - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
            }

            //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
            if (!string.IsNullOrEmpty(mes_ztp))
            {
                if (new MesiceRozsah(mes_ztp).IsValid(out parseError) == false)
                    ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 3a) - [%Neplatný formát%] (" + parseError + ")<br/>";
                if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "M_ztp_file")))
                    _povinnePrilohy.Add("- průkaz ZTP/P manžela(manželky)");//PR 06.12.2019
            }
            else if (ztp == "X") //mes_ztp je nevyplneno a pritom je vyplneno ZTP=X
                ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 3a) - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";

            if (string.IsNullOrEmpty(rc) && (!string.IsNullOrEmpty(mes) || !string.IsNullOrEmpty(mes_ztp)))
            {
                //rodne cislo je v agende rodinnych prislusniku nepovinny udaj
                //ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";
            }

            //SLEVA ZA UMÍSTĚNÍ DÍTĚTE
            decimal? castka = null;
            for (int i = 1; i < 3; i++)
            {
                //1.dite:
                jm = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_jmeno");
                prij = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_prijmeni");
                rc = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_rc");

                try
                {
                    castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "D" + i + "_castka", true);
                    if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Částka musí být kladná%]<br/>";
                    if (castka.HasValue)
                        if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_file")))
                            _povinnePrilohy.Add("- potvrzení ze školky o zaplaceném školkovném - " + i + ". dítě"); //PR 06.12.2019
                }
                catch (Exception)
                {
                    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Neplatný formát%]<br/>";
                }

                //PR 31.01.2020 vypínám kontrolu na RČ - stejné důvody jako u manželky výše
                //if (string.IsNullOrEmpty(rc))
                //{
                //    //rodne cislo je v agende rodinnych prislusniku nepovinny udaj
                //    //if (castka.HasValue && castka.Value > 0)
                //    //    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";
                //}
                //else
                //{
                //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
                //    MatchCollection m = r.Matches(rc);
                //    if (m.Count != 1)
                //        ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatný formát%]<br/>";
                //    else
                //    {
                //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
                //        int month = Int16.Parse(m[0].Groups[2].Value);
                //        int day = Int16.Parse(m[0].Groups[3].Value);
                //        int ext = Int16.Parse(m[0].Groups[4].Value);
                //        int mod = (year + month + day + ext) % 11;
                //        if (mod != 0)
                //            ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatné rodné číslo%]<br/>";
                //    }
                //}
                if (castka == null && (!string.IsNullOrEmpty(jm) || !string.IsNullOrEmpty(prij) || !string.IsNullOrEmpty(rc)))
                    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
            }

            //NČZD
            string x = "";
            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_dar_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_dar_c", true);
                if ( x == "X" && !castka.HasValue )
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 1 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_dar_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 1 - [%Částka musí být kladná%]<br/>";
                }
                
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_dar_file")))
                        _povinnePrilohy.Add("- potvrzení o převzetí daru, odběru krve, kostní dřeně");//PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 1 - [%Neplatný formát%]<br/>";
            }

            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_uroky_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_uroky_c", true);
                if (x == "X" && !castka.HasValue)
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 2 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_uroky_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 2 - [%Částka musí být kladná%]<br/>";
                }
                
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_uroky_file")))
                        _povinnePrilohy.Add("- potvrzení o poskytnutém úvěru a výši zaplacených úroků");//PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 2 - [%Neplatný formát%]<br/>";
            }

            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_penz_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_penz_c", true);
                if (x == "X" && !castka.HasValue)
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 3 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_penz_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 3 - [%Částka musí být kladná%]<br/>";
                }
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_penz_file")))
                        _povinnePrilohy.Add("- potvrzení o zaplacených částkách na penzijní připojištění nebo penzijní pojištění"); //PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 3 - [%Neplatný formát%]<br/>";
            }

            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_zivp_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_zivp_c", true);
                if (x == "X" && !castka.HasValue)
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 4 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_zivp_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 4 - [%Částka musí být kladná%]<br/>";
                }
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_zivp_file")))
                        _povinnePrilohy.Add("- potvrzení o zaplacených částkách na životní pojištění"); //PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 4 - [%Neplatný formát%]<br/>";
            }

            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_odbp_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_odbp_c", true);
                if (x == "X" && !castka.HasValue)
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 5 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_odbp_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 5 - [%Částka musí být kladná%]<br/>";
                }
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_odbp_file")))
                        _povinnePrilohy.Add("- potvrzení odborové organizace o zaplacených příspěvcích"); //PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 5 - [%Neplatný formát%]<br/>";
            }

            try
            {
                x = WebControlHelper.SubCtrlGetValueString(FormView1, "N_zkouska_x");
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_zkouska_c", true);
                if (x == "X" && !castka.HasValue)
                    ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 6 - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
                if (castka.HasValue)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_zkouska_x", "X");
                    if (castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 6 - [%Částka musí být kladná%]<br/>";
                }
                if (castka.HasValue || x == "X")
                    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FormView1, "N_zkouska_file")))
                        _povinnePrilohy.Add("- potvrzení o zaplacené úhradě za zkoušky ověřující výsledky dalšího vzdělávání"); //PR 06.12.2019
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 6 - [%Neplatný formát%]<br/>";
            }

            //PR 12.01.2022 
            decimal? uroky = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_uroky_c");
            if (uroky.HasValue)
            {
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_pred2021") == "" && WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_po2021") == "")
                    ValidPg1.ErrorMessage += "[%Bytová potřeba, na kterou byl úvěr poskytnut, byla obstarána%] - [%Označte odpovídající variantu%]<br/>";
                //PR 12.01.2022 adresa
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_adresa") == "")
                    ValidPg1.ErrorMessage += "[%Adresa bytové potřeby, na který byl úvěr poskytnut%] - [%Není vyplněna povinná položka%]<br/>";
            }

            //PR 06.12.2019 kontrola počtu příloh
            if (Parametry.ParametrCti("DanPocetPriloh") == "a") //PR 15.01.2020 
            {
                PrilohyManager prilohy = (PrilohyManager)WebControlHelper.FindControl(Page, "uc_prilohy");
                if (prilohy.Mode != FormViewMode.ReadOnly && !FazeOvereni)
                {
                    //if (prilohy.PocetNahranychPriloh < _povinnePrilohy.Count + _povinnePrilohyStr2.Count)
                    //{
                    //    ValidPg2.ErrorMessage += "Nedostatečný počet příloh: nahráno " + prilohy.PocetNahranychPriloh + ", požadováno " + (_povinnePrilohy.Count + _povinnePrilohyStr2.Count) + ", požadované přílohy:<br/>";
                    //    if (_povinnePrilohy.Count > 0)
                    //        ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohy) + "<br/>";
                    //    if (_povinnePrilohyStr2.Count > 0)
                    //        ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohyStr2);
                    //}
                    //PR 14.12.2021 list _povinnePrilohy nyní obsahují pouze přílohy, které uživatel nepřiložil
                    if (_povinnePrilohy.Count > 0)
                    {
                        ValidPg1.ErrorMessage += "Doplňte tyto potvrzení:<br/>";
                        ValidPg1.ErrorMessage += string.Join("<br/>", _povinnePrilohy) + "<br/>";
                    }
                }
            }

            if (ValidPg1.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPg1.Text = ValidPg1.ErrorMessage;
            }
        }             

        protected void DDL_manzelka_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            DataView dv = ODS_manzelky.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "M_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "M_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "M_rc", (string)dv[i]["rc"]);
                //break;
            }
            //}
        }

        protected void DDL_dite_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            string k = (sender as Control).ID.Right(1); //DDL_dite2
            DataView dv = ODS_deti.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_rc", (string)dv[i]["rc"]);
                //break;
            }
            //}
        }

        protected void DDL_rodprisl_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            string k = (sender as Control).ID.Right(1); //DDL_rodprisl2
            DataView dv = ODS_rodprisl.Select() as DataView;

            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_rc", (string)dv[i]["rc"]);
                string adr = "";
                if (string.IsNullOrEmpty((string)dv[i]["ulice"]))
                { //obec + cislo domu
                    if (!string.IsNullOrEmpty((string)dv[i]["obec"])) adr += (string)dv[i]["obec"] + " ";
                    if (!string.IsNullOrEmpty((string)dv[i]["c_pop"])) adr += (string)dv[i]["c_pop"];
                }
                else //ulice + cislo domu + obec
                {
                    if (!string.IsNullOrEmpty((string)dv[i]["ulice"])) adr += (string)dv[i]["ulice"] + " ";
                    if (!string.IsNullOrEmpty((string)dv[i]["c_pop"])) adr += (string)dv[i]["c_pop"];
                    if (!string.IsNullOrEmpty((string)dv[i]["obec"])) adr += ", " + (string)dv[i]["obec"];
                }
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_adresa", adr);

            }

        }

        protected void FormView1_ItemCommand(object sender, FormViewCommandEventArgs e)
        {
            //switch (e.CommandName)
            //{
            //    case "X":
                    
            //        break;
            //}
        }

        protected void RB_k_podpisu_Click(object sender, EventArgs e)
        {
            CustomValidator ValidPg1 = (CustomValidator)FormView1.FindControl("ValidPg1");
            if (ValidPg1.IsValid)
                OnButtonClicked(sender, e);//informování parent controlky (ZadostOdanprohl) o kliknutí na tlačítko RB_k_podpisu (aby mohla vymenit sub controlku KS za MF)
        }

    }
}