﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Collections.Generic;
using KSProgram.Exceptions;
using KSProgram.Security;
using System.Text.RegularExpressions;
using System.Threading;
using System.Linq;

namespace KSPortal.Controls
{
    public partial class ZRZ_MF_2021 : UserControlPozadavek
    {
        public override string Typ
        {
            get { return "zroczuct"; }
        }

        private List<string> _povinnePrilohyStr1 = new List<string>();
        private List<string> _povinnePrilohyStr2 = new List<string>();
        protected FormViewMode FakeMode
        {
            get
            {
                object o = ViewState["FakeMode"];
                if (o == null)
                    return FormViewMode.ReadOnly;
                else
                    return (FormViewMode)o;
            }
            set
            {
                ViewState["FakeMode"] = value;
            }
        }

        public ObjectDataSource ObjectDataSource1
        {
            get { return (ObjectDataSource)this.Parent.Parent.FindControl("ObjectDataSource1"); }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }
        
        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert" || val == "edit")
            {
                if (PozId == 0)
                    FakeMode = FormViewMode.Insert;//FormView1.ChangeMode(FormViewMode.Insert);
                else
                    FakeMode = FormViewMode.Edit;//FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
                FakeMode = FormViewMode.ReadOnly;//FormView1.ChangeMode(FormViewMode.ReadOnly);

            if (wf.Get_UN("", "Form1", "Visible") == "false")
                FormView1.Visible = false;
            else
            {
                FormView1.DataSourceID = "ObjectDataSource1";
                FormView1.DataBind();

                if (FakeMode != FormViewMode.ReadOnly)//PR 09.01.2019 
                {
                    ODS_manzelky.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_manzelky.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();

                    RadDropDownList DDL = (RadDropDownList)FormView1.FindControl("DDL_manzelka");
                    DDL.DataSourceID = "ODS_manzelky";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "M_rc");
                    //------------------------------------------------------------------------------------
                    ODS_deti.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_deti.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_dite1");
                    DDL.DataSourceID = "ODS_deti";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "D1_rc");

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_dite2");
                    DDL.DataSourceID = "ODS_deti";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "D2_rc");
                    //------------------------------------------------------------------------------------
                    ODS_rodprisl.SelectParameters["osc"].DefaultValue = Vydavatel.ToString();
                    ODS_rodprisl.SelectParameters["keDni"].DefaultValue = DateTime.Today.ToShortDateString();
                    DDL = (RadDropDownList)FormView1.FindControl("DDL_rodprisl1");
                    DDL.DataSourceID = "ODS_rodprisl";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "U1_rc");

                    DDL = (RadDropDownList)FormView1.FindControl("DDL_rodprisl2");
                    DDL.DataSourceID = "ODS_rodprisl";
                    DDL.DataBind();
                    DDL.SelectedValue = WebControlHelper.SubCtrlGetValueString(FormView1, "U2_rc");

                }

                //bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
                bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

                DataTable dtsloupce = Pozadavekzroczuct.GetDataTable();
                foreach (DataColumn dc in dtsloupce.Columns)
                {
                    string col = dc.ColumnName;
                    //bool readOnly = (FakeMode == FormViewMode.ReadOnly);
                    //Control c = FormView1.FindControl(col);
                    //if (c == null) continue;
                    //if (c is TextBox)
                    //    (c as TextBox).Enabled = !readOnly; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                    //else if (c is CheckBox)
                    //    (c as CheckBox).Enabled = !readOnly;
                    //else if (c is RadDropDownList)
                    //    (c as RadDropDownList).Enabled = !readOnly;
                    Control c = FormView1.FindControl(col);
                    if (c == null) continue;
                    bool disabled = (FakeMode == FormViewMode.ReadOnly) || (c is TTextBox && (c as TTextBox).ReadOnly);
                    if (c is TextBox)
                        (c as TextBox).Enabled = !disabled; //přes enabled se aspon vyhnu nechtěnému zrušení readonly
                    else if (c is CheckBox)
                        (c as CheckBox).Enabled = !disabled;
                    else if (c is RadDropDownList)
                        (c as RadDropDownList).Enabled = !disabled;
                }

                FormView1.FindControl("btn_podepsat").Visible = (FakeMode != FormViewMode.ReadOnly) && Vydavatel == Globals.OsCisloAktUserNeboZastupovany && ((TTextBox)FormView1.FindControl("P_d_zadosti")).Text == "";
                FormView1.FindControl("P_d_zadosti").Visible = ((TTextBox)FormView1.FindControl("P_d_zadosti")).Text != "";//aby se to vše vlezlo do šířky sloupce
                FormView1.FindControl("btn_overeno").Visible = (FakeMode != FormViewMode.ReadOnly) && overeni && ((TTextBox)FormView1.FindControl("P_d_over")).Text == "";
                FormView1.FindControl("P_d_over").Visible = ((TTextBox)FormView1.FindControl("P_d_over")).Text != "";//aby se to vše vlezlo do šířky sloupce
            }
            bool neniPodepsan = WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_zadosti") == "";//PR 11.12.2020 
            if (PozId == 0 || wf.FazePosl == 0 || neniPodepsan)
            {
                //ServerValidateEventArgs args = new ServerValidateEventArgs("", false);
                //ValidPre_ServerValidate(this, args);//aby vyběhla prevalidace
                Page.Validate(ValidPre.ValidationGroup);
            }

            //PR 17.12.2021 vybrani stavu pokud je tam jen jeden (kvuli Tietu, i kdyz v tom navrhu to neni)
            DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(Page, "RCM_ZmenaStavu");
            if (RCM_ZmenaStavu.Visible)
                if (RCM_ZmenaStavu.SelectedValue == "" && RCM_ZmenaStavu.Items.Count == 2)
                    RCM_ZmenaStavu.Text = RCM_ZmenaStavu.Items[1].Value;
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FakeMode != FormViewMode.ReadOnly)
                    {
                        if (FakeMode == FormViewMode.Insert)
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            if (FormView1.Visible) //PR 11.12.2020 v 1. kroku může být skryt pro volbu RZ ano/ne skrze volbou WF stavu
                            {
                                foreach (DataColumn c in Pozadavekzroczuct.GetDataTable().Columns)
                                {
                                    values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                                }
                            }
                            int id_poz = 0;
                            decimal adresat = 0;
                            try
                            {
                                adresat = Convert.ToDecimal(ObjectDataSource1.InsertParameters["adresat"].DefaultValue);
                            }
                            catch (FormatException) { }
                            string novy_stav = ObjectDataSource1.InsertParameters["novy_stav"].DefaultValue;
                            string duvod = ObjectDataSource1.InsertParameters["duvod"].DefaultValue;
                            Pozadavekzroczuct.Insert(ref id_poz, Vydavatel, adresat, novy_stav, duvod, values);
                            PozId = id_poz;
                            OnItemInserted(new EventArgs());
                        }
                        else
                        {
                            System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                            foreach (DataColumn c in Pozadavekzroczuct.GetDataTable().Columns)
                            {
                                values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(FormView1, c.ColumnName, true, c.ColumnName);
                            }
                            if (values.Count == 0 || string.IsNullOrWhiteSpace(values["H_obd_rok"])) //PR 02.02.2021 //PR 09.02.2021 
                            {
                                is_valid = false;
                                throw new NoticeException("Nepodařilo se získat data z formuláře!");
                            }
                            Pozadavekzroczuct.Update(PozId, values);
                            OnItemUpdated(new EventArgs());
                        }

                    }
                }
            }
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());

        }

        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }


        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            //FormView1.ChangeMode(mode);
            FakeMode = mode;
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FakeMode;//FormView1.CurrentMode;
            }
        }

        private bool FazeOvereni
        {
            get
            {
                return this.WF.Get_UN("", "Overeni", "Mode") == "edit";
            }
        }
        private bool JeVybranStornoStav()
        {
            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    //WorkflowMaster m = new WorkflowMaster(PozId, "zroczuct", null);//zjištění akt. fáze
                    Str_workfl_stavy str_stav_new = WF.GetParamStavu(stav_new);
                    if (str_stav_new.sys_stav == "s")
                        return true;
                }
            }
            return false;
        }

        /// <summary>
        /// Zda vybrany stav v 1. kroku vede do faze se skrytym formularem
        /// </summary>
        /// <returns></returns>
        private bool VybranStavNechciRZ()
        {
            if (PozId > 0)
                return false;

            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    Str_workfl_stavy str_stav_new = WF.GetParamStavu(stav_new);
                    if (str_stav_new.next_faze != null)
                    {
                        workfl_faze f = new workfl_faze(WF.IdMaster, str_stav_new.next_faze.Value);
                        //if (f.UN_Vydav != null)
                        //    if (f.UN_Vydav.Contains("[Form1:Visible=false]"))
                        //        return true;
                        //PR 19.11.2021 
                        if (f.UN_Vydavat.Count > 0)
                            if (WorkflUISettings.GetValue(f.UN_Vydavat, "", "Form1", "Visible").ToLower() == "false")
                                return true;
                    }

                }
            }
            return false;
        }

        protected void ValidPre_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //CustomValidator ValidPre = (CustomValidator)FormView1.FindControl("ValidPre");
            ValidPre.ErrorMessage = "";
            if (FakeMode == FormViewMode.ReadOnly) return;
            //PR 05.02.2021 zakomentovavam nasledujici, protoze musi byt zabraneno, aby nevytvarel vice pozadavku,
            //              nebo nezadaval pozadavek v dubnu.
            //if (!FormView1.Visible) return; //PR 11.12.2020 
            string error;
            int? H_obd_rok = WebControlHelper.SubCtrlGetValueNumber(FormView1, "H_obd_rok");

            DateTime ld_AktObdobi = ViceIco.ObdobiPodnikuPodleZamestnance(Vydavatel);//PR 14.01.2020 HID=49553

            bool lb_VybranStornoStav = JeVybranStornoStav();
            //bool lb_chciNechciRZ = FormView1.Visible == false;
            bool lb_nechciRZ = VybranStavNechciRZ();

            //if (PozId == 0)            
            if (PozId == 0 || (PozId > 0 && !lb_VybranStornoStav))//PR 09.02.2021 
            {
                //(PozId == 0): V 1. kroku proběhnou kontroly bez ohledu na storno stav, protože i "Nechci RZ" nelze učinit mimo vymezený časový úsek, atd.
                //(PozId > 0 && !lb_storno): Z důvodu "chci/nechci" nebo možnost opravy probíhá kontrola i po vytvoření požadavku, pokud to není storno stav.
                //-------------------------------------------------------------------------------------------------------------------------------------------

                if (FazeOvereni == false)//PR 05.02.2021 kdyz to neni faze overeni a je to v editaci, tak je to ve fazi vyplnovani
                {
                    if (H_obd_rok != null)
                    {
                        //----------------------------------------------------------------------------------------------------------
                        // Časově omezená možnost vytvářet požadavek
                        //----------------------------------------------------------------------------------------------------------

                        DateTime aktObdobi = (ld_AktObdobi.Year < DateTime.Today.Year) ? DateTime.Today.PrvniDen() : ld_AktObdobi;
                        //if (aktObdobi.Month > 2)
                        //    ValidPre.ErrorMessage += "[%Žádost lze podat pouze v období leden až únor!%]<br/>";
                        //PR 08.01.2021 
                        if (PozId == 0) //PR 02.03.2021 HID=55491 nekontrolovat při opravě, jen při vytváření požadavku
                        {
                            string par = Parametry.ParametrCti("ZadostORZDo");
                            Int16 den;
                            if (par != "0" && Int16.TryParse(par, out den))
                                if (DateTime.Today > new DateTime(aktObdobi.Year, 2, den))
                                    ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%Žádost lze podat pouze do {0}. února!%]", den) + "<br/>";
                        }
                        if (H_obd_rok != (aktObdobi.Year - 1))
                            ValidPre.ErrorMessage += "[%Zdaňovací období - rok%] - [%Žádost lze podat pouze pro minulý rok!%]<br/>";

                        //----------------------------------------------------------------------------------------------------------
                        // Podmínky, které musí splnit, aby mohl vytvořit požadavek (i když chce jen prohlásit, že nechce RZ)
                        //----------------------------------------------------------------------------------------------------------
                        //nepodal již žádost?
                        //if (Pozadavekzroczuct.ExistujeNestornovanyProRok(Vydavatel, H_obd_rok.Value) > 0) //PR 05.02.2021 zakomentovano
                        int idp_exist = Pozadavekzroczuct.ExistujeNestornovanyProRok(Vydavatel, H_obd_rok.Value); //PR 05.02.2021 
                        if (idp_exist > 0 && idp_exist != PozId) //PR 05.02.2021 
                            ValidPre.ErrorMessage += "[%Žádost již máte podánu, novou nelze podat!%] [%Pokud chcete údaje opravit, musí vám účetní vrátit žádost k opravě!%]<br/>";

                        //Účetní tam již dala příznak, že se má provést RZ
                        //Sice bych kontrolu mohl zrušit, jenže když to účetní udělala a zamec teď dá, že nechce RZ, tak nemám exe:akci, která by zapsala provest=n. 
                        if (Pozadavekzroczuct.MaJizNavedenoVrzdane(Vydavatel, H_obd_rok.Value))
                            ValidPre.ErrorMessage += "[%Žádost nelze podat, údaje již byly zadány přes agendu roční zúčtování!%]<br/>";

                        //Pokud má již RZ v TK provedeno, tak už nemůže dát ani "nechci RZ"
                        if (null != Pozadavekzroczuct.DatumProvedeniRZ(Vydavatel, H_obd_rok.Value))//PR 26.11.2018 
                            ValidPre.ErrorMessage += "[%Roční zúčtování je již provedeno!%]<br/>";

                        //PR 08.02.2021 HID=54589 uživatel s nástupem až v novém roce, si zadal dodatečné prohlášení a následně i žádost o RZ.
                        //Protože se datum nástupu může při opakovaném nástupu přepsat, kontroluji zde platný PP.
                        List<OSC_POMER> pomery = Prac_pom.GetPomeryVObdobi(Vydavatel, new DateTime(H_obd_rok.Value, 1, 1), new DateTime(H_obd_rok.Value, 12, 31));
                        if (pomery.Count == 0)
                        {
                            ValidPre.ErrorMessage += ReadGlobalResource.ZmenaTextu("[%V období {0} jste neměl(a) žádný pracovněprávní vztah u tohoto zaměstnavatele!%]", H_obd_rok.Value) + "<br/>";
                        }

                        //----------------------------------------------------------------------------------------------------------
                        // Podmínky, které musí splnit, když chce RZ
                        //----------------------------------------------------------------------------------------------------------
                        if (!lb_nechciRZ)
                        {
                            //PR 13.01.2022 zruseno
                            //if (Pozadavekzroczuct.PrijmyNadSolDanPrijmy(Vydavatel, H_obd_rok.Value))
                            //    ValidPre.ErrorMessage += "[%Žádost nelze podat, vaše příjmy přesáhly hranici pro solidární daň!%]<br/>";

                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") == "p" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVpozadavcich(Vydavatel, H_obd_rok.Value, out error))
                            //    ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok, nejprve vyplňte požadavek „prohlášení daně“ s volbou „dodatečně činím“=XD!%] ("+error+")<br/>";
                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") == "m" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVmzdovychUdajich(Vydavatel, H_obd_rok.Value, out error))
                            //        ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok!%] (" + error + ")<br/>";
                            //PR 04.12.2019 zrušil jsem parametr, nyní se kontroluje ze mzdových údajů + dodatečné z požadavků. Tj. ze schválených běžných prohlášení se to dostalo do mzdových údajů.

                            //if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n") //PR 14.01.2020 HID=49624
                            //    if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, out error))
                            //        ValidPre.ErrorMessage += "[%Nemáte podepsáno prohlášení daně na minulý rok, nejprve vyplňte požadavek „prohlášení daně“ s volbou „dodatečně činím“=XD!%] (" + error + ")<br/>";
                            //------------------------------------------------------------------------------------------------------------
                            //PR 10.02.2021 HID=55047 nemá podepsán měsíc nástupu, protože měl podepsané u předchozího zaměstnavatele
                            //int ignoruj_mesic = 0;
                            //PR 14.02.2023 pro případ více poměrů v daném roce, předám do funkce všechny měsíce,
                            List<int> ignoruj_mesice = new List<int>();
                            string parseError, mes;
                            //projdu tabulku PŘEDCHOZÍ PLÁTCI pro zjištění posledního měsíce u předchozího zaměstnavatele, 
                            //ten pošlu do funkce a pokud bude chybět a bude to datum nástupu, tak jej funkce bude ignorovat.
                            for (int i = 1; i <= 4; i++)
                            {
                                mes = WebControlHelper.SubCtrlGetValueString(FormView1, "P" + i + "_mes");
                                if (!string.IsNullOrEmpty(mes))
                                {
                                    MesiceRozsah mr = new MesiceRozsah(mes);
                                    if (mr.IsValid(out parseError))
                                    {
                                        //ignoruj_mesic = mr.PosledniMesic();
                                        ignoruj_mesice.AddRange(mr.SeznamMesicu());
                                    }
                                }
                            }
                            if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n")
                                if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, ignoruj_mesice, out error))
                                    ValidPre.ErrorMessage += error + "<br/>";
                            //------------------------------------------------------------------------------------------------------------
                        }
                    }
                }
            }

            //if (PozId > 0)
            //{
            //WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            //bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";
            //if (overeni)
            if (FazeOvereni)
            {
                //Při zápisu do rzdane musí být udělána uzávěrka prosince, kdy vzniká záznam v rzdane, který se updatuje
                if (ld_AktObdobi.Month > 3)
                    ValidPre.ErrorMessage += "[%Žádost lze ověřovat pouze ve mzdovém období leden až březen!%]<br/>";

                if (Pozadavekdanprohl.MaNeschvaleneDodatecneProhlaseni(Vydavatel, H_obd_rok.Value))
                    ValidPre.ErrorMessage += "[%Nejprve schvalte dodatečné prohlášení daně!%]<br/>";

                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") == "p" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVpozadavcich(Vydavatel, H_obd_rok.Value, out error))
                //    ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") == "m" && !Pozadavekdanprohl.MaPodepsaneProhlaseniVmzdovychUdajich(Vydavatel, H_obd_rok.Value, out error))
                //    ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
                //PR 04.12.2019 zrušil jsem parametr, nyní se kontroluje ze mzdových údajů + dodatečné z požadavků. Tj. ze schválených běžných prohlášení se to dostalo do mzdových údajů.
                //PR 10.02.2021 zakomentovávám, stačí kontrola při vyplňování žadatelem
                //else if (Parametry.ParametrCti("PodepsaneProhlaseni") != "n") //PR 14.01.2020 HID=49624
                //    if (!Pozadavekdanprohl.MaPodepsaneProhlaseni(Vydavatel, H_obd_rok.Value, out error))
                //        ValidPre.ErrorMessage += "[%Zaměstnanec nemá podepsané prohlášení daně!%] (" + error + ")<br/>";
            }
            //}

            //PR 06.12.2018
            if (ValidPre.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPre.Text = ValidPre.ErrorMessage;
            }
        }

        protected void ValidPg1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator ValidPg1 = (CustomValidator)FormView1.FindControl("ValidPg1");
            ValidPg1.ErrorMessage = "";
            ValidPg1.Text = "";
            _povinnePrilohyStr1.Clear();

            if (FakeMode == FormViewMode.ReadOnly) return;
            if (!FormView1.Visible) return; //PR 11.12.2020 Chci/nechci RZ se schovaným formulářem v 1. kroku
            if (JeVybranStornoStav()) //PR 09.02.2021 stornování v libovolném kroku nebo "Nechci RZ" v kroku 1 se zviditelněným formulářem
                return;
            if (VybranStavNechciRZ()) //PR 09.02.2021 "Nechci RZ" v kroku 1 se zviditelněným formulářem, kdy stav nemá systémový stav storno
                return;

            //WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);
            //bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";
            string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok");

            //Validace roku je již ve validátoru výše, navíc je H_obd_rok READONLY
            //if (H_obd_rok != (DateTime.Today.Year - 1).ToString())
            //{
            //   ValidPg1.ErrorMessage += "[%Zdaňovací období - rok%] - [%Žádost lze podat pouze pro minulý rok%]<br/>";
            //}

            string parseError, mes, ztp, mes_ztp;

            //PŘEDCHOZÍ PLÁTCI 
            for (int i = 1; i <= 4; i++) //PR 18.11.2020 ze 2.řádků na 4 a udělán cyklus
            {
                mes = WebControlHelper.SubCtrlGetValueString(FormView1, "P" + i + "_mes");
                //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
                if (!string.IsNullOrEmpty(mes))
                {
                    if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                        ValidPg1.ErrorMessage += "[%V kalendářních měsících%] - [%řádek%] " + i + " - [%Neplatný formát%] (" + parseError + ")<br/>";
                    _povinnePrilohyStr1.Add("- potvrzení o zdanitelných příjmech od předchozího zaměstnavatele č. " + i); //PR 06.12.2019
                }
            }

            //SLEVA NA MANŽELKU
            string jm, prij, rc;
            jm = WebControlHelper.SubCtrlGetValueString(FormView1, "M_jmeno");
            prij = WebControlHelper.SubCtrlGetValueString(FormView1, "M_prijmeni");
            rc = WebControlHelper.SubCtrlGetValueString(FormView1, "M_rc");
            mes = WebControlHelper.SubCtrlGetValueString(FormView1, "M_mes");
            ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "M_ztp");
            mes_ztp = WebControlHelper.SubCtrlGetValueString(FormView1, "M_ztp_mes");

            //PR 31.01.2020 HID=49994 vypínám kontrolu na RC:
            //- nepočítá s 9-ti místným RČ,
            //- je zbytečná, protože se při zápise do RZ nikam nezapisuje,
            //- pole je stejně needitační, protože se tam později udělalo rozbalovátko a jde vybrat pouze manželka již navedená v rod. přisl.
            //if (!string.IsNullOrEmpty(rc))
            //{
            //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
            //    MatchCollection m = r.Matches(rc);
            //    if (m.Count != 1)
            //        ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Neplatný formát%]<br/>";
            //    else
            //    {
            //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
            //        int month = Int16.Parse(m[0].Groups[2].Value);
            //        int day = Int16.Parse(m[0].Groups[3].Value);
            //        int ext = Int16.Parse(m[0].Groups[4].Value);
            //        int mod = (year + month + day + ext) % 11;
            //        if (mod != 0)
            //            ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Neplatné rodné číslo%]<br/>";
            //    }
            //    _povinnePrilohyStr1.Add("- čestné prohlášení manžela(manželky)"); //PR 06.12.2019
            //}
            if (!string.IsNullOrEmpty(prij)) //PR 31.01.2020 
                _povinnePrilohyStr1.Add("- čestné prohlášení manžela(manželky)");

            //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
            if (!string.IsNullOrEmpty(mes))
            {
                if (new MesiceRozsah(mes).IsValid(out parseError) == false)
                    ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 2) - [%Neplatný formát%] (" + parseError + ")<br/>";
            }
            else if (!string.IsNullOrEmpty(jm) || !string.IsNullOrEmpty(prij) || !string.IsNullOrEmpty(rc)) //M_mes je nevyplneno a jmeno nebo prijmeni nebo rc je vyplneno
            {
                ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 2) - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
            }

            //Kontrola rozsahu mesicu 1 nebo 9-12 nebo 1-6,10-12 nebo 1,12
            if (!string.IsNullOrEmpty(mes_ztp))
            {
                if (new MesiceRozsah(mes_ztp).IsValid(out parseError) == false)
                    ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 3a) - [%Neplatný formát%] (" + parseError + ")<br/>";
                _povinnePrilohyStr1.Add("- průkaz ZTP/P manžela(manželky)");//PR 06.12.2019
            }
            else if (ztp == "X") //mes_ztp je nevyplneno a pritom je vyplneno ZTP=X
                ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Nárok splněn za%] 3a) - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";

            if (string.IsNullOrEmpty(rc) && (!string.IsNullOrEmpty(mes) || !string.IsNullOrEmpty(mes_ztp)))
            {
                //rodne cislo je v agende rodinnych prislusniku nepovinny udaj
                //ValidPg1.ErrorMessage += "[%Slevy na dani%] - [%Sleva na manžela (manželku)%] - [%Rodné číslo%] - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";
            }

            //SLEVA ZA UMÍSTĚNÍ DÍTĚTE
            decimal? castka = null;
            for (int i = 1; i < 3; i++)
            {
                //1.dite:
                jm = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_jmeno");
                prij = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_prijmeni");
                rc = WebControlHelper.SubCtrlGetValueString(FormView1, "D" + i + "_rc");

                try
                {
                    castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "D" + i + "_castka", true);
                    if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Částka musí být kladná%]<br/>";
                    if (castka.HasValue)
                        _povinnePrilohyStr1.Add("- potvrzení ze školky o zaplaceném školkovném - " + i + ". dítě"); //PR 06.12.2019
                }
                catch (Exception)
                {
                    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Neplatný formát%]<br/>";
                }

                //PR 31.01.2020 vypínám kontrolu na RČ - stejné důvody jako u manželky výše
                //if (string.IsNullOrEmpty(rc))
                //{
                //    //rodne cislo je v agende rodinnych prislusniku nepovinny udaj
                //    //if (castka.HasValue && castka.Value > 0)
                //    //    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Položka je povinná při vyplnění sloupce napravo%]<br/>";
                //}
                //else
                //{
                //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
                //    MatchCollection m = r.Matches(rc);
                //    if (m.Count != 1)
                //        ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatný formát%]<br/>";
                //    else
                //    {
                //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
                //        int month = Int16.Parse(m[0].Groups[2].Value);
                //        int day = Int16.Parse(m[0].Groups[3].Value);
                //        int ext = Int16.Parse(m[0].Groups[4].Value);
                //        int mod = (year + month + day + ext) % 11;
                //        if (mod != 0)
                //            ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Rodné číslo%] - [%řádek%] " + i + " - [%Neplatné rodné číslo%]<br/>";
                //    }
                //}
                if (castka == null && (!string.IsNullOrEmpty(jm) || !string.IsNullOrEmpty(prij) || !string.IsNullOrEmpty(rc)))
                    ValidPg1.ErrorMessage += "[%Sleva za umístění dítěte%] - [%Vynaložená částka%] - [%řádek%] " + i + " - [%Položka je povinná při vyplnění sloupců nalevo%]<br/>";
            }

            //NČZD
            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_dar_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_dar_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení o převzetí daru, odběru krve, kostní dřeně");//PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 1 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 1 - [%Neplatný formát%]<br/>";
            }

            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_uroky_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_uroky_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení o poskytnutém úvěru a výši zaplacených úroků");//PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 2 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 2 - [%Neplatný formát%]<br/>";
            }

            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_penz_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_penz_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení o zaplacených částkách na penzijní připojištění nebo penzijní pojištění"); //PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 3 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 3 - [%Neplatný formát%]<br/>";
            }

            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_zivp_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_zivp_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení o zaplacených částkách na životní pojištění"); //PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 4 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 4 - [%Neplatný formát%]<br/>";
            }

            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_odbp_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_odbp_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení odborové organizace o zaplacených příspěvcích"); //PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 5 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 5 - [%Neplatný formát%]<br/>";
            }

            try
            {
                castka = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_zkouska_c", true);
                if (castka.HasValue && castka.Value > 0)
                {
                    WebControlHelper.SubCtrlSetValue(FormView1, "N_zkouska_x", "X");
                    _povinnePrilohyStr1.Add("- potvrzení o zaplacené úhradě za zkoušky ověřující výsledky dalšího vzdělávání"); //PR 06.12.2019
                }
                if (castka.HasValue && castka.Value < 0) ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 6 - [%Částka musí být kladná%]<br/>";
            }
            catch (Exception)
            {
                ValidPg1.ErrorMessage += "[%Nezdanitelné části základu daně%] - [%Uplatňovaná částka%] - [%řádek%] 6 - [%Neplatný formát%]<br/>";
            }

            if (ValidPg1.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPg1.Text = ValidPg1.ErrorMessage;
            }
        }

        protected void ValidPg2_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator ValidPg2 = (CustomValidator)FormView1.FindControl("ValidPg2");
            ValidPg2.ErrorMessage = "";
            ValidPg2.Text = "";
            _povinnePrilohyStr2.Clear();

            if (FakeMode == FormViewMode.ReadOnly) return;
            if (!FormView1.Visible) return; //PR 11.12.2020 Chci/nechci RZ se schovaným formulářem v 1. kroku
            if (JeVybranStornoStav()) //PR 09.02.2021 stornování v libovolném kroku nebo "Nechci RZ" v kroku 1 se zviditelněným formulářem
                return;
            if (VybranStavNechciRZ()) //PR 09.02.2021 "Nechci RZ" v kroku 1 se zviditelněným formulářem, kdy stav nemá systémový stav storno
                return;

            //WorkflowMaster wf = new WorkflowMaster(PozId, "zroczuct", null);//PR 05.02.2021 
            //bool zmeny = wf.Get_UN("", "Zmeny", "Mode") == "edit";//PR 05.02.2021 
            //bool overeni = wf.Get_UN("", "Overeni", "Mode") == "edit";//(FakeMode == FormViewMode.Edit) && (Vydavatel != Globals.OsCisloAktUserNeboZastupovany || Globals.SuperUser);

            //PR 23.10.2018 pokud vracím požadavek k přepracování, tak musím vypnout kontrolu přítomnosti podpisu
            bool podpis_vyzadovan = true;
            string stav_new = "";
            DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
            if (list2 != null)
            {
                stav_new = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(stav_new)) || (stav_new == "")))
                {
                    WorkflowMaster m = new WorkflowMaster(PozId, "zroczuct", null);//zjištění akt. fáze
                    Str_workfl_stavy str_stav_new = m.GetParamStavu(stav_new);
                    if (str_stav_new.sys_stav == "s" || (str_stav_new.next_faze != null && str_stav_new.next_faze.Value < m.FazeZprac))
                        podpis_vyzadovan = false;
                    if ((Zakaznik.IsCurrent("TIETO") || Globals.RAActive("DANOVKA_2")))
                    {
                        //PR 07.02.2022 Tieto ma overeni v kroku 3 a vyplneni RZ v kroku 3 (no jo, nastaveni od Reznicka)
                        if (!FazeOvereni && str_stav_new.sys_stav != "s" && str_stav_new.next_faze != null && str_stav_new.next_faze.Value < m.FazeZprac)
                        {
                            //jsem vydavatel a v nasledujicim stavu nejsem adresatem
                            if (Vydavatel == Globals.OsCisloAktUserNeboZastupovany && (string.IsNullOrEmpty(str_stav_new.adresat) || str_stav_new.adresat != "[vyd]"))
                                podpis_vyzadovan = true;
                        }
                    }
                }
            }

            //string H_obd_rok = WebControlHelper.SubCtrlGetValueString(FormView1, "H_obd_rok"); 

            //Úroky uplatňují tyto osoby
            //PR 31.01.2020 vypínám kontroly RČ - stejný důvod jako u manželky
            //string rc = WebControlHelper.SubCtrlGetValueString(FormView1, "U1_rc");
            //if (!string.IsNullOrEmpty(rc))
            //{
            //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
            //    MatchCollection m = r.Matches(rc);
            //    if (m.Count != 1)
            //        ValidPg2.ErrorMessage += "[%Rodné číslo%] - [%řádek%] 1 - [%Neplatný formát%]<br/>";
            //    else
            //    {
            //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
            //        int month = Int16.Parse(m[0].Groups[2].Value);
            //        int day = Int16.Parse(m[0].Groups[3].Value);
            //        int ext = Int16.Parse(m[0].Groups[4].Value);
            //        int mod = (year + month + day + ext) % 11;
            //        if (mod != 0)
            //            ValidPg2.ErrorMessage += "[%Rodné číslo%] - [%řádek%] 1 - [%Neplatné rodné číslo%]<br/>";
            //    }
            //}
            //rc = WebControlHelper.SubCtrlGetValueString(FormView1, "U2_rc");
            //if (!string.IsNullOrEmpty(rc))
            //{
            //    Regex r = new Regex(@"^(\d\d)(\d\d)(\d\d)(\d\d\d\d)$");
            //    MatchCollection m = r.Matches(rc);
            //    if (m.Count != 1)
            //        ValidPg2.ErrorMessage += "[%Rodné číslo%] - [%řádek%] 2 - [%Neplatný formát%]<br/>";
            //    else
            //    {
            //        int year = Int16.Parse(m[0].Groups[1].Value); //grupa[0] je celý výraz
            //        int month = Int16.Parse(m[0].Groups[2].Value);
            //        int day = Int16.Parse(m[0].Groups[3].Value);
            //        int ext = Int16.Parse(m[0].Groups[4].Value);
            //        int mod = (year + month + day + ext) % 11;
            //        if (mod != 0)
            //            ValidPg2.ErrorMessage += "[%Rodné číslo%] - [%řádek%] 2 - [%Neplatné rodné číslo%]<br/>";
            //    }
            //}

            decimal? uroky = WebControlHelper.SubCtrlGetValueDecimal(FormView1, "N_uroky_c");
            if (uroky.HasValue)
            {
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_pred2021") == "" && WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_po2021") == "")
                    ValidPg2.ErrorMessage += "[%Pro úroky z úvěrů ..%] - [%Označte odpovídající variantu%]<br/>";
                //PR 12.01.2022 adresa
                if (WebControlHelper.SubCtrlGetValueString(FormView1, "U_byt_adresa") == "")
                    ValidPg2.ErrorMessage += "[%Adresa bytové potřeby, na který byl úvěr poskytnut%] - [%Není vyplněna povinná položka%]<br/>";
            }

            //PODPISOVÁ ČÁST
            if (podpis_vyzadovan)
            {
                if (Vydavatel == Globals.OsCisloAktUserNeboZastupovany)
                {
                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_zadosti") == "")
                        ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Za uvedené zdaňovací období%] - [%sloupec%] [%Žádost o roční zúčtování%]... - [%Chybí podpis%]<br/>";
                }
                if (FazeOvereni)
                {
                    if (WebControlHelper.SubCtrlGetValueString(FormView1, "P_d_over") == "")
                        ValidPg2.ErrorMessage += "[%Podpisová část%] - [%řádek%] [%Za uvedené zdaňovací období%] - [%sloupec%] [%Ověření plátcem daně%] - [%Chybí podpis%]<br/>";
                }
            }

            //PR 06.12.2019 kontrola počtu příloh
            if (Parametry.ParametrCti("DanPocetPriloh") == "a") //PR 15.01.2020 
            {
                PrilohyManager prilohy = (PrilohyManager)WebControlHelper.FindControl(Page, "uc_prilohy");
                if (prilohy.Mode != FormViewMode.ReadOnly && !FazeOvereni)
                {
                    if (prilohy.PocetNahranychPriloh < _povinnePrilohyStr1.Count + _povinnePrilohyStr2.Count)
                    {
                        ValidPg2.ErrorMessage += "Nedostatečný počet příloh: nahráno " + prilohy.PocetNahranychPriloh + ", požadováno " + (_povinnePrilohyStr1.Count + _povinnePrilohyStr2.Count) + ", požadované přílohy:<br/>";
                        if (_povinnePrilohyStr1.Count > 0)
                            ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohyStr1) + "<br/>";
                        if (_povinnePrilohyStr2.Count > 0)
                            ValidPg2.ErrorMessage += string.Join("<br/>", _povinnePrilohyStr2);
                    }
                }
            }

            if (ValidPg2.ErrorMessage != "")
            {
                args.IsValid = false;
                ValidPg2.Text = ValidPg2.ErrorMessage;
            }
        }

        protected void DDL_manzelka_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            DataView dv = ODS_manzelky.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "M_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "M_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "M_rc", (string)dv[i]["rc"]);
                //break;
            }
            //}
        }

        protected void DDL_dite_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            string k = (sender as Control).ID.Right(1); //DDL_dite2
            DataView dv = ODS_deti.Select() as DataView;
            //for (int i = 0; i < dv.Count; i++)
            //{
            //if (e.Value.Equals((string)dv[i]["rc"]))
            //RC je v DB nepovinne
            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "D" + k + "_rc", (string)dv[i]["rc"]);
                //break;
            }
            //}
        }

        protected void DDL_rodprisl_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            string k = (sender as Control).ID.Right(1); //DDL_rodprisl2
            DataView dv = ODS_rodprisl.Select() as DataView;

            int i = e.Index;
            if (i < dv.Count)
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_jmeno", (string)dv[i]["jmeno"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_prijmeni", (string)dv[i]["prijmeni"]);
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_rc", (string)dv[i]["rc"]);
                string adr = "";
                if (string.IsNullOrEmpty((string)dv[i]["ulice"]))
                { //obec + cislo domu
                    if (!string.IsNullOrEmpty((string)dv[i]["obec"])) adr += (string)dv[i]["obec"] + " ";
                    if (!string.IsNullOrEmpty((string)dv[i]["c_pop"])) adr += (string)dv[i]["c_pop"];
                }
                else //ulice + cislo domu + obec
                {
                    if (!string.IsNullOrEmpty((string)dv[i]["ulice"])) adr += (string)dv[i]["ulice"] + " ";
                    if (!string.IsNullOrEmpty((string)dv[i]["c_pop"])) adr += (string)dv[i]["c_pop"];
                    if (!string.IsNullOrEmpty((string)dv[i]["obec"])) adr += ", " + (string)dv[i]["obec"];
                }
                WebControlHelper.SubCtrlSetValue(FormView1, "U" + k + "_adresa", adr);

            }

        }

        protected void FormView1_ItemCommand(object sender, FormViewCommandEventArgs e)
        {
            switch (e.CommandName)
            {
                case "podp_bezne_popl":
                    if (Globals.OsCisloAktUserNeboZastupovany == Vydavatel)
                    {
                        bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_zad_kod") == "");
                        //WebControlHelper.SubCtrlSetValue(FormView1, "P_zad_kod", empty ? Pracovnik.PrijmeniJmeno(Vydavatel) : "");
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_zad_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                        WebControlHelper.SubCtrlSetValue(FormView1, "P_d_zadosti", empty ? DateTime.Today.ToShortDateString() : "");
                        empty = !empty;
                        FormView1.FindControl("P_d_zadosti").Visible = !empty;
                        FormView1.FindControl("btn_podepsat").Visible = empty;
                        if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                            ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis
                    }
                    break;

                case "podp_bezne_over":
                    if (Globals.OsCisloAktUserNeboZastupovany != Vydavatel || Globals.SuperUser)
                    {
                        if (DateTime.Today >= new DateTime(2023, 1, 1))
                            MessageBox.Alert(Page, "Ověřování žádosti o RZ za rok 2022 v této verzi KS portálu ještě nelze, neboť zatím nebylo upraveno dle nové legislativy.");
                        else
                        {
                            bool empty = (WebControlHelper.SubCtrlGetValueString(FormView1, "P_over_kod") == "");
                            WebControlHelper.SubCtrlSetValue(FormView1, "P_over_kod", empty ? Pracovnik.PrijmeniJmeno(Globals.OsCisloAktUserNeboZastupovany) : "");//PR 19.11.2018 
                            WebControlHelper.SubCtrlSetValue(FormView1, "P_d_over", empty ? DateTime.Today.ToShortDateString() : "");
                            empty = !empty;
                            FormView1.FindControl("P_d_over").Visible = !empty;
                            FormView1.FindControl("btn_overeno").Visible = empty;
                            if (((CustomValidator)FormView1.FindControl("ValidPg2")).ErrorMessage.Length > 0)
                                ValidPg2_ServerValidate(this, new ServerValidateEventArgs("", false));//aby zmizela validace na podpis*/
                        }
                    }
                    break;

            }
        }


        protected void Page_PreRender(object sender, EventArgs e)
        {
            if (Thread.CurrentThread.CurrentCulture.Name == "en-US")
            {
                //staticka promenna - obsah tam zustava
                if (preklady.Count == 0)
                {
                    preklady.Add("ŽÁDOST", "REQUEST");
                    preklady.Add("o roční zúčtování záloh a daňového zvýhodnění", "for annual account of prepayments and tax benefits");
                    preklady.Add("za zdaňovací období", "for tax period");
                    preklady.Add("Identifikace poplatníka", "Identification of the taxpayer (employee)");
                    preklady.Add("Příjmení", "Surname");
                    preklady.Add("Jméno(-a)", "First name(s)");
                    preklady.Add("Rodné číslo", "Personal identification number");
                    preklady.Add("příp. datum narození", "or the date of birth");
                    preklady.Add("Identifikace plátce daně (název)", "Identification of the payer of tax – the name (employer)");
                    preklady.Add("V souladu s § 38ch a § 35d zákona č. 586/1992 Sb., o daních z příjmů, ve znění pozdějších předpisů (dále jen „zákon“) žádám o pro-", "Pursuant to § 38ch and § 35d of Act no. 586/1992 Coll., on Income Tax, as amended, (hereinafter “the Act“), I apply for an annual");
                    preklady.Add("vedení ročního zúčtování záloh na daň a daňového zvýhodnění za uvedené zdaňovací období a současně prohlašuji, <b>že za uvedené</b>", "account of prepayments and tax benefits for the above mentioned tax period, and at the same time I declare <b>I am not required to");
                    preklady.Add("<b>zdaňovací období nejsem povinen(-na) podat přiznání k dani z příjmů fyzických osob.</b>", "submit the personal income tax return for the mentioned tax period.</b>");
                    preklady.Add("<b>Uvádím, že jsem v uvedeném zdaňovacím období pobíral(-a) příjmy ze závislé činnosti od těchto předchozích plátců daně <sup>1)</sup></b>", "<b>I state that in the above mentioned tax period I received income from dependent activity from these previous payers of tax <sup>1)</sup></b>");
                    preklady.Add("V kalendářních<br/> měsících", "In calendar months");
                    preklady.Add("Identifikace předchozích plátců daně", "Identification of previous payers of tax");
                    preklady.Add("vyplňuje se pouze v případě, že poplatník pobíral od předchozích plátců daně (u kterých učinil prohlášení k dani) postupně příjmy, které vstupují", "it is filled in only if the taxpayer received from the previous payers of tax (at which he filed the Tax Declaration) income that is included in annual");
                    preklady.Add("do ročního zúčtování záloh a daňového zvýhodnění, včetně mezd zúčtovaných nebo vyplacených poplatníkovi těmito plátci dodatečně v době, kdy", "account of prepayments and tax benefits, including salaries cleared and paid by these payers subsequently in the time when the taxpayer already did");
                    preklady.Add("poplatník pro ně již nevykonával činnost, kromě příjmů zdanitelných srážkou podle zvláštní sazby daně a kromě příjmů, které nejsou předmětem daně", "not perform acivity for them, with the exception of income withheld at a special tax rate and with the exception of income that is not subject to tax or");
                    preklady.Add("nebo jsou od daně osvobozeny (§ 38ch odst. 4 zákona)", "is tax exempt (Section 38ch, subsection 4 of the Act)");
                    preklady.Add("Kromě nároku na slevy na dani a nároku na daňové zvýhodnění uplatněného v Prohlášení poplatníka daně z příjmů fyzických", "Besides the claim for tax allowances and tax benefits applied for in the Declaration of the taxpayer liable to personal income");
                    preklady.Add("osob ze závislé činnosti učiněného podle § 38k odst. 4, případně odst. 7 zákona, uplatňuji za výše uvedené zdaňovací období", "tax from dependent activity in accordance with § 38k, subsection 4 or subsection 7 of the Act, I claim the following allowances");
                    preklady.Add("nárok na:", "for the above mentioned tax period:");
                    preklady.Add("SLEVY NA DANI", "TAX ALLOWANCES");
                    preklady.Add("<b>Slevu na manžela (manželku)</b> podle § 35ba odst. 1 písm. b) zákona, který (která) se mnou žil (žila) v uvedeném zdaňovacím období ve", "Tax allowance for a spouse pursuant to Section 35ba, subsection 1, letter b) of the Act, who lived in the household and does not have");
                    preklady.Add("společně hospodařící domácnosti a neměl (neměla) v tomto zdaňovacím období vlastní příjem přesahující 68 000 Kč", "own income exceeding CZK 68 000 in the mentioned tax period");
                    preklady.Add("(manžela/manželky)", "(of the spouse)");
                    preklady.Add("Nárok <br/>splněn za", "Criteria met for");
                    preklady.Add("ZTP/P<sup>3)</sup>", "Severe disability/disability<sup>3)</sup>");
                    preklady.Add("u cizích státních příslušníků uveďte datum narození", "in the case of foreign nationals, state the date of birth");
                    preklady.Add("uveďte kalendářní měsíce, ve kterých byly splněny podmínky pro uplatnění této slevy na dani, např. 9 - 12", "give the calendar months in which the conditions for the tax allowance were met, e.g. 9–12");
                    preklady.Add("označte „X“ pokud byl manželovi (manželce) přiznán nárok na průkaz ZTP/P", "give letter “X“ if your spouse is entitled to hold a severe disability/disability card");
                    preklady.Add("uveďte kalendářní měsíce, ve kterých jsou splněny podmínky pro dvojnásobnou výši této slevy na dani (z titulu průkazu ZTP/P), např. 9 - 12", "give the calendar months in which the conditions for doubled amount of the tax allowance were met (a severe disability/disability card), e.g. 9–12");
                    preklady.Add("<b>Slevu za umístění dítěte</b> v předškolním zařízení podle § 35ba odst. 1 písm. g) zákona, na dítě (děti) které se mnou žilo (žily) v uvedeném", "Tax allowance for child placement in the organization of preschool age children care pursuant to Section 35ba, subsection 1, letter g) of");
                    preklady.Add("zdaňovacím období v mé společně hospodařící domácnosti", "the Act, for child(ren) who lived in the household in the mentioned tax period");
                    preklady.Add("(dítěte)", "(of the child)");
                    preklady.Add("Vynaložená částka (v Kč)", "Amount spent (in CZK)");
                    preklady.Add("<b>Zároveň prohlašuji</b>, že na výše uvedené dítě (děti) neuplatňuje tuto slevu jiný poplatník žijící v téže společně hospodařící domácnosti", "At the same time I declare that this tax allowance is not applied for by another taxpayer living in the same household.");
                    preklady.Add("NEZDANITELNÉ ČÁSTI ZÁKLADU DANĚ", "NON-TAXABLE AMOUNTS OF THE TAX BASE");
                    preklady.Add("Uplatňuji<sup>4)</sup>", "I claim<sup>4)</sup>");
                    preklady.Add("Nezdanitelné části základu daně podle § 15 zákona", "Non-taxable amounts of the tax base pursuant to section 15 of the Act");
                    preklady.Add("Uplatňovaná částka<br/> (v Kč)", "Amount claimed<br/> (in CZK)");
                    preklady.Add("Bezúplatná plnění - dary (odst. 1)", "Gratuitous transactions – donation(s) (subsection 1)");
                    preklady.Add("Úroky z úvěru na financování bytových potřeb (odst. 3 a 4)", "Interests from credit/loans for financing housing needs (subsections 3 and 4)");
                    preklady.Add("Penzijní připojištění nebo penzijní pojištění nebo doplňkové penzijní spoření (odst. 5)", "Pension insurance or supplementary pension insurance scheme or additional pension savings (subsection 5)");
                    preklady.Add("Pojistné na soukromé životní pojištění (odst. 6)", "Insurance premium for private life insurance (subsection 6)");
                    preklady.Add("Členské příspěvky člena odborové organizace (odst. 7)", "Trade union contributions of a trade union member (subsection 7)");
                    preklady.Add("Úhrada za zkoušky ověřující výsledky dalšího vzdělávání (odst. 8)", "Payments for examinations verifying the results of further education (subsection 8)");
                    preklady.Add("označte „X“ nezdanitelnou část základu daně, kterou uplatňujete", "non-taxable amount of the tax base you claim mark with letter “X“");
                    preklady.Add("podle zákona č. 179/2006 Sb., o ověřování a uznávání výsledků dalšího vzdělávání a o změně některých zákonů", "pursuant to the act No. 179/2006 Coll. on verifying and recognition of results of further education and on amendments to some laws");
                    preklady.Add("vzor č. 2", "model no. 2");

                    preklady.Add("Prohlášení poplatníka podle § 38k odst. 5 písm. e) zákona k nezdanitelné části základu daně podle § 15 odst. 3 a 4 zákona:", "Declaration of the taxpayer pursuant to Sect. 38k, subsect. 5 letter e) of the Act related to non-taxable amount of the tax base pursuant to Sect. 15, subsect. 3 and 4 of the Act:");

                    preklady.Add("odpočet úroků ze základu daně, na které uplatňuji nárok z důvodu zaplacených úroků z úvěru použitého na financování bytových potřeb ze", "deduction of interest from the tax base that I claim due to interest paid on loan used for financing housing needs under building savings");
                    preklady.Add("stavebního spoření, úroků z hypotečního úvěru anebo z jiného úvěru poskytnutého v souvislosti s těmito úvěry, poskytovatelem stavebního", "programme, interest from mortgage credit line or other loan/credit granted in connection with these loans by the building savings programme");
                    preklady.Add("spoření, bankou, za uvedené zdaňovací období <b>neuplatňuje</b> jiná osoba / <b>uplatňují</b> tyto osoby:", "provider, bank, for mentioned tax period <b>is not claimed</b> by other person / <b>is claimed</b> by the following persons:");
                    preklady.Add("Adresa bydliště (místo trvalého pobytu)", "Home address (place of permanent residence)");
                    preklady.Add("tabulku vyplňte pouze v případě, že úroky uplatňuje i jiná osoba/osoby", "fill in the table only if the interest is claimed also by another person/other persons");

                    preklady.Add("Pro úroky z úvěrů použitých na financování bytových potřeb obstaraných před 1. lednem 2021 a refinancování těchto úvěrů", "For interest on loans used to finance housing needs acquired before 1 January 2021 and to refinance these loans");

                    preklady.Add("Prohlašuji, že předmět bytové potřeby podle § 15 odst. 3 zákona, ve znění zákona před 1. lednem 2021,", "I declare that the subject of housing needs pursuant to Section 15, subsection 3 of the Act, as amended by the Act before 1 January 2021,");
                    preklady.Add("na který uplatňuji odpočet úroků z poskytnutého úvěru, byl užíván v souladu s § 15 odst. 4 zákona ve znění zákona před 1. lednem 2021,", "for which I claim the interest deduction from the loan provided was used in accordance with Section 15 subsection 4 of the Act as amended by the law before 1 January 2021,");
                    preklady.Add("a že částka úroků, o kterou se snižuje základ daně podle § 15 odst. 3 a 4 zákona ve znění zákona před 1. lednem 2021", "and the amount of interest that decreases the tax base pursuant to Section 15 subsection 3 and 4 of the Act as amended by the Act before 1 January 2021");
                    preklady.Add("v úhrnu u všech účastníků smluv o úvěrech žijících se mnou ve společně hospodařící domácnosti, nepřekročila v uplynulém zdaňovacím období částku 300 000 Kč.", "in total for all persons participating in the loan/credit agreements living with me in the household did not exceed the amount of 300 000 CZK in the last tax period.");
                    preklady.Add("Při placení úroků jen po část roku uplatňovaná částka nepřekročila jednu dvanáctinu této maximální částky za každý měsíc placení úroků.", "If the interest was paid only during a part of the year, the claimed amount did not exceed one twelfth of the above mentioned maximum amount for each months when the interest was paid.");

                    preklady.Add("Pro úroky z úvěrů použitých na financování bytových potřeb obstaraných po 1. lednu 2021 a refinancování těchto úvěrů", "For interest on loans used to finance housing needs acquired after 1 January 2021 and to refinance these loans");

                    preklady.Add("Prohlašuji, že předmět bytové potřeby podle § 4b odst. 1 zákona, na který uplatňuji odpočet úroků z poskytnutého úvěru, byl užíván v souladu s § 15 odst. 3 a 4 zákona,", "I declare that the subject of housing needs pursuant to Section 4b, subsection 1 of the Act, for which I claim the interest deduction from the loan provided was used in accordance with Section 15, subsection 3 and 4 of the Act,");
                    preklady.Add("a že částka úroků, o kterou se snižuje základ daně podle § 15 odst. 4 zákona", "and the amount of interest that decreases the tax base pursuant to Section 15, subsections 4");
                    preklady.Add("v úhrnu u všech účastníků smluv o úvěrech žijících se mnou ve společně hospodařící domácnosti, nepřekročila v uplynulém zdaňovacím období částku 150 000 Kč.", "in total for all persons participating in the loan/credit agreements living with me in the household did not exceed the amount of 150 000 CZK in the last tax period.");

                    preklady.Add("označte „X“ odpovídající variantu (úvěry)", "give letter “X“ to coresponding variant (loans)");
                    preklady.Add("Upozornění:", "Note:");
                    preklady.Add("Při kombinaci výše uvedených úvěrů nelze překročit maximální zákonem stanovený limit, který v součtu činí 300 000 Kč.", "When combining the above loans, the maximum statutory limit, which totals CZK 300,000, cannot be exceeded.");
                    preklady.Add("Uveďte adresu(-y), kde se nachází bytová potřeba, na kterou byl(-y) úvěr(-y) poskytnut(-y):", "Give the address(es), where the housing need(s) for which was/are the loan(s)/credit(s) granted is situated:");

                    preklady.Add("Podpisová část", "Signature part");
                    preklady.Add("Potvrzuji pravdivost a úplnost údajů uvedených v této žádosti o roční zúčtování záloh a daňového zvýhodnění a prokazuji je příslušnými doklady podle § 38l zákona.", "I confirm the truthfulness and completeness of the information filled in this request for annual account of prepayments and tax benefits and certify them with relevant documents pursuant to Section 38l of the Act");

                    preklady.Add("Prohlašuji, že jsem si vědom(-a) skutečnosti, že případný rozdíl z nesprávně sražené daně z příjmů fyzických osob ze závislé činnosti,", "I declare that I am aware of the fact, that any differences arising from incorrectly withheld personal income tax from dependent activity,");
                    preklady.Add("případně neoprávněně vyplacená částka na daňovém bonusu z poskytnutého daňového zvýhodnění, který(-á) vznikl(-a) mým zaviněním,", "any unjustified paid amount of tax bonus from tax benefits granted, that arose due to my fault, will be withheld at full amount including");
                    preklady.Add("mi bude v plné výši včetně úroku z prodlení sražen(-a) na základě dohody s plátcem daně (§ 38i odst. 5 písm. a) zákona). V případě,", "default interest based on agreement with the payer of tax (Section 38i, subsection 5 letter a) of the Act). If the agreement with the payer");
                    preklady.Add("že k dohodě s plátcem daně o sražení dlužné částky nedojde, bude vzniklý rozdíl v souladu s § 38i odst. 5 písm. b) zákona vybrán", "of tax on the withholding of the amount owed is not concluded, the difference occured would be in accordance with Section 38i,");
                    preklady.Add("správcem daně prostřednictvím daňového přiznání podle § 38g odst. 5 zákona.", "subsection 5 letter b) of the Act collected by the tax administrator by means of tax return pursuant to Section 38g, subsection 5 of the Act.");

                    preklady.Add("Současně žádám v souladu s § 38k odst. 7 zákona o dodatečné uplatnění slev na dani / daňového zvýhodnění", "Pursuant to Section 38k, subsection 7 of the Act, at the same time I ask for additional tax allowances/tax benefits");
                    preklady.Add("Žádost o roční zúčtování záloh a daňového<br />zvýhodnění učiněná<sup>6)</sup><br />(písemně, elektronicky) a datum", "Request for annual account<br /> of prepayments and tax benefits made<sup>6)</sup><br />(in writing, electronically) and the date");
                    preklady.Add("Ověření plátcem daně<sup>7)</sup><br />(písemně, elektronicky) a datum", "Verification of the payer of tax<sup>7)</sup><br /> (in writing, electronically) and the date");
                    preklady.Add("Za uvedené zdaňovací období", "For the mentioned tax period");

                    preklady.Add("v případě, že v souladu s § 38k odst. 7 zákona uplatňujete slevy na dani podle § 35ba odst. 1 písm. a,c,d,e,f) příp. daňové zvýhodnění dodatečně", "if you pursuant to section 38k, subsection 7 of the Act apply the tax allowances in accordance with section 35ba, subsection 1 letter a, c, d, e, f) or tax");
                    preklady.Add("v rámci žádosti o roční zúčtování záloh a daňového zvýhodnění, pak označte „X“ a pro uplatnění použijte tiskopis Prohlášení poplatníka daně z příjmů", "benefits additionally within the frame of your request for annual account of prepayments and tax benefits then give “X“ and use the form Declaration of");
                    preklady.Add("fyzických osob ze závislé činnosti na příslušné zdaňovací období a postupujte při vyplnění dle „upozornění“ na str. 2 tohoto tiskopisu MFin 5457", "the taxpayer liable to personal income tax from dependent activity for tax period considered and follow the “warning“ on page 2 of the form MFin 5457");
                    preklady.Add("rozumí se projev vůle poplatníka, buď písemně (podpis) nebo elektronicky", "we understand that it is a declaration of intention of the taxpayer, either in writing (signature) or electronically");
                    preklady.Add("plátce daně ověřil nárok na slevy na dani podle § 35ba zákona, nárok na nezdanitelné části základu daně podle § 15 zákona", "the payer of tax verified the claim for tax allowances pursuant to Section 35ba of the Act, the claim for non-taxable amounts of the tax base pursuant to Section 15 of the Act");
                    preklady.Add("Další záznamy", "Further Records");

                }
                for (int prekladIdx = 0; prekladIdx < preklady.Count; prekladIdx++)
                {
                    WebControlHelper.ProjdiControls(FormView1, prekladIdx, ZmenaTextu);
                }

            }
        }

        public static void ZmenaTextu(object ctrl, object prekladIdx)
        {

            if (ctrl is LiteralControl || ctrl is Label)
            {
                string prop = "Text";
                object obj = WebControlHelper.GetPropertyValue(ctrl, prop);
                if (obj != null)
                {
                    string text = Convert.ToString(obj);
                    if (text != "")
                    {
                        //části html, např. několik div-ů, které nemají runat=server jsou spojeny do 1 LiteralControl, takže musím hledat uvnitř
                        string prelozeno = text.Replace(preklady.ElementAt((int)prekladIdx).Key, preklady.ElementAt((int)prekladIdx).Value);
                        if (!text.Equals(prelozeno))
                            WebControlHelper.SetPropertyValue(ctrl, prop, prelozeno);
                    }
                }
            }

        }

        private static System.Collections.Generic.Dictionary<string, string> preklady = new System.Collections.Generic.Dictionary<string, string>();



    }
}