﻿using KSProgram;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class Controls_ZadostOannual : UserControlPozadavek
{
    bool saving = false;

    private bool _langCS
    {
        get
        {
            return System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "cs-CZ";
        }
    }

    protected int Rok
    {
        set
        {
            ViewState["Rok"] = value;
        }
        get
        {
            return (ViewState["Rok"] == null ? 0 : Convert.ToInt32(ViewState["Rok"]));
        }
    }

    protected string Mode
    {
        set
        {
            ViewState["Mode"] = value;
        }

        get
        {
            return (ViewState["Mode"] == null ? "" : Convert.ToString(ViewState["Mode"]));
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {

    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "annual", null);
        Mode = wf.Get_UN("", "Form1", "Mode");
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        
        //vždy je mode edit, zpřístupňování nebo zakazování se dělá až na úrovni formuláře v edittemplate
        FormView1.ChangeMode(FormViewMode.Edit);

        Rok = (Int32)workfl_hodnoty.GetInt32N(PozId, "rok");

        List<Tuple<string, string, string>> check_names = Pozadavekannual.GetControlsNames();
        if (Mode == "edit")
        {
            DataTable dt_dary = Pozadavekannual.GetDary(PozId, "dary");
            SessionInfo.SetVariable("dary", dt_dary);

            DataTable dt_prace = Pozadavekannual.GetPrace(PozId, "prace");
            SessionInfo.SetVariable("prace", dt_prace);

            DataTable dt_cinnost = Pozadavekannual.GetCinnost(PozId, "cinnost");
            SessionInfo.SetVariable("cinnost", dt_cinnost);

            DataTable dt_osoby = Pozadavekannual.GetOsoby(PozId, "osoby");
            SessionInfo.SetVariable("osoby", dt_osoby);

            DataTable dt_politika = Pozadavekannual.GetPolitika(PozId, "politika");
            SessionInfo.SetVariable("politika", dt_politika);

            DataTable dt_vyslechy = Pozadavekannual.GetVyslechy(PozId, "vyslechy");
            SessionInfo.SetVariable("vyslechy", dt_vyslechy);
        }
       
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

      
        foreach (Tuple<string, string, string> s in check_names)
        {
            CheckBox check_ano = WebControlHelper.FindControl(FormView1, s.Item1 + "_ano") as CheckBox;
            CheckBox check_ne = WebControlHelper.FindControl(FormView1, s.Item1 + "_ne") as CheckBox;
            CheckBox b = (check_ano.Checked ? check_ano : check_ne);
            _nastavZobr(b, s.Item1+"_ano", s.Item1+"_ne", s.Item2, true);

            if (Mode=="readonly")
            {
                check_ano.Enabled = false;
                check_ne.Enabled = false;
                if (!string.IsNullOrEmpty(s.Item2)&&(check_ano.Checked))
                {
                    RadGrid grid = WebControlHelper.FindControl(FormView1, s.Item2) as RadGrid;
                    GridCommandItem cmd = (GridCommandItem)grid.MasterTableView.GetItems(GridItemType.CommandItem)[0];
                    cmd.Visible = false;

                    grid.MasterTableView.Columns[0].Visible = false;
                    grid.MasterTableView.Columns[1].Visible = false;
                }
            }
        }
        if (Mode == "readonly")
        {
            CheckBox check_souhlas = WebControlHelper.FindControl(FormView1, "CheckBox_souhlas") as CheckBox;
            check_souhlas.Enabled = false;
        }
    }

    protected string lab_page_dary()
    {
        if (_langCS)
            return $"Přijal/a jste v roce {Rok} v souvislosti s vašim pracovním zařazením v RBCZ nějaké dary, výhody či pozvání (na oběd, kulturní, sportovní nebo společenskou akci) apod., jejichž hodnota převýšila částku 500 Kč? Pokud ano, uveďte prosím od koho (jméno fyzické osoby nebo název či firmu právnické osoby), kdy, jakého charakteru byl dar, výhoda nebo pozvání a v jaké hodnotě.";
        else
            return "Have you received any gifts, invitations or any other advantages in close relation with your job or position within the bank in 2021 (dinner, social or sport event, or similar) which was of a value of 20 Euro or higher? If so, please provide the name of the person that provided gift or invitation and other relevant information as described below.";
    }

    protected string lab_page_dary_ne()
    {
        if (_langCS)
            return $"Ne, v roce {Rok} jsem nepřijal/a žádné takové dary, výhody ani pozvání.";
        else
            return "No, I did not receive any gift or invitation described above in 2021.";
    }

    protected string lab_page_dary_ano()
    {
        if (_langCS)
            return "Ano, šlo o následující dary, výhody nebo pozvání:";
        else
            return "Yes, the gift(s) / invitation(s) is /are listed below:";
    }

    protected string lab_vedl_cin()
    {
        if (_langCS)
            return "Vykonával/a jste vedle své činnosti v RBCZ jinou výdělečnou činnost? Jakého druhu byla tato činnost (obor činnosti), jaké intenzity (realizovaný obrat nebo přijaté plnění) a jaké bylo Vaše právní postavení při této výdělečné činnosti (zaměstnanec, živnostník, podílník právnické osoby, statutární nebo dozorčí orgán atp.)? Uveďte identifikaci subjektu, v jehož rámci jste takovou činnost vykonával/a.";
        else
            return "Besides your activities for RBCZ, have you performed any other activity for money? What sort of activity has it be (industry)? How often? What was the income from that activity? What was your legal status /relation with the company /person you have acted for (employee, enterpreneuer, other). Please describe details as stated below:";
    }

    protected string lab_page_vedl_cin_ne()
    {
        if (_langCS)
            return $"Ne, žádnou takovou činnost jsem v roce {Rok} nevykonával/a.";
        else
            return $"No, no such activity was performed by me in {Rok}";
    }

    protected string lab_page_vedl_cin_ano()
    {
        if (_langCS)
            return "Ano, šlo o tuto činnost nebo aktivitu:";
        else
            return "Yes, details are provided below:";
    }

    protected string lab_page_obch_spol()
    {
        if (_langCS)
            return "Byl/a jste společníkem (např. podílníkem, akcionářem, tichým společníkem) či jednatelem, členem představenstva, prokuristou, členem dozorčího orgánu nebo v jiné obdobné funkci obchodní společnosti nebo jiné právnické osoby (např. družstva, občanského sdružení, obecně prospěšné společnosti atp.)? Uveďte identifikaci takové osoby, včetně uvedení způsobu vaší angažovanosti.";
        else
            return "Have you own any participations in a company / a legal person? Do you act as member of management board or supervisory board, or in any other way as a person on behalf of any legal entity? Please provide details:";
    }

    protected string lab_page_obch_spol_ano()
    {
        if (_langCS)
            return "Ano, šlo o tuto činnost nebo postavení:";
        else
            return "Yes, details are provided below:";
    }

    protected string lab_page_obch_spol_ne()
    {
        if (_langCS)
            return $"Ne, žádnou takovou činnost jsem v roce {Rok} nevykonával/a a nebyl/a jsem v uvedeném nebo obdobném postavení.";
        else
            return $"No, no such activity was performed by me in {Rok}";
    }

    protected string lab_page_vztahy()
    {
        if (_langCS)
            return "Máte s některým zaměstnancem RBCZ, případně s osobou spjatou s některým dodavatelem či subjektem spolupracujícím s RBCZ (zaměstnancem, podílníkem atp. takové osoby), příbuzenský či blízký osobní vztah? Za blízký osobní vztah se považuje takový vztah, ve kterém jsou dvě nebo více osob navzájem si blízké ve smyslu příslušné definice podle občanského zákoníku (příbuzní a osoby v poměru rodinném nebo obdobném, pokud by újmu, kterou utrpěla jedna z nich, druhá důvodně pociťovala jako újmu vlastní). Uveďte s kým a konkretizujte vztah.";
        else
            return "Do you have a close personal relationship with any employee or with a person connected to a RBCZ supplier or anyone else cooperating with RBCZ (employee, share holders, or any such person)?";
    }

    protected string lab_page_vztahy_ne()
    {
        if (_langCS)
            return "Ne, nemám žádný z výše uvedených vztahů.";
        else
            return "No, I do not know any such person.";
    }

    protected string lab_page_vztahy_ano()
    {
        if (_langCS)
            return "Ano, jedná se o tyto osoby:";
        else
            return "Yes, please see below:";
    }

    protected string lab_page_politika()
    {
        if (_langCS)
            return "Mimo zaměstnání v Bance se politicky angažuji.";
        else
            return "Besides your activities for RBCZ, are you politically involved?";
    }

    protected string lab_page_politika_ne()
    {
        if (_langCS)
            return "Ne";
        else
            return "No";
    }

    protected string lab_page_politika_ano()
    {
        if (_langCS)
            return "Ano, uveďte prosím bližší podrobnosti:";
        else
            return "Yes, please provide further details below:";
    }

    protected string lab_page_predvolani()
    {
        if (_langCS)
            return $"Byl/a jsem v roce {Rok} předvolán/a orgány činnými v trestním řízení (Policie ČR, státní zastupitelství, soud) k výslechu nebo k podání vysvětlení ve věci týkající se pracovněprávních povinností v rámci Raiffeisenbank a.s.";
        else
            return $"Were you in {Rok} called up by prosecutor / police / court for questioning or to give explanation in case related to your job responsibilities within the bank?";
    }

    protected string lab_page_predvolani_ne()
    {
        if (_langCS)
            return "Ne";
        else
            return "No";
    }

    protected string lab_page_predvolani_ano()
    {
        if (_langCS)
            return "Ano (přiložte prosím kopii předvolání a výslechu)";
        else
            return "Yes  ( please supply a copy of questioning)";
    }

    protected string prohlaseni()
    {
        if (_langCS)
            return "Prohlašuji, že jsem se seznámil/a s interními normami Compliance manuál a Systém vnitřních zásad (norma AML) a porozuměl/a jsem jejich obsahu. Údaje, které jsem výše uvedl/a, jsou pravdivé a úplné.";
        else
            return "I hereby declare that I have been acquainted with internal norms Compliance manual and System of internal principles (AML rule) " +
                    "and that I understand their content.Data I have stated are true and full.";
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        saving = (Mode=="edit");
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    Pozadavekannual.Save(PozId, this.Page);                   
                }
            }
        }
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
        //FormView1.DataBind();
        Nacist();

    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
    }
    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    private void _removeRow(string klic, GridCommandEventArgs e)
    {
        if (e.CommandName == "Delete")
        {
            DataTable table = SessionInfo.GetVariable(klic) as DataTable;
            if (table != null)
                table.Rows.RemoveAt(e.Item.ItemIndex);
        }
    }

    protected void grid_dary_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("dary", e);
    }
    protected void grid_prace_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("prace", e);
    }
    protected void grid_cinnost_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("cinnost", e);
    }

    protected void grid_osoby_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("osoby", e);
    }

    protected void grid_politika_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("politika", e);
    }
    protected void grid_predvolani_ItemCommand(object sender, GridCommandEventArgs e)
    {
        _removeRow("vyslechy", e);
    }

    protected string _DateTimeNull(object value)
    {
        if ((value == null) || (value == DBNull.Value)) return "";

        return DateTime.Parse(value.ToString()).ToString("d");
    }

    protected void check_2a_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "check_2b", "check_2a", "grid_dary", false);
    }

    protected void check_2b_CheckedChanged(object sender, EventArgs e)
    {       
        _nastavZobr(sender, "check_2b", "check_2a", "grid_dary", false);
    }

    private void _nastavZobr(object sender, string checkIdAno, string checkIdNe, string grid, bool readOnly)
    {
        CheckBox box_sender = sender as CheckBox;

        CheckBox box_ano = WebControlHelper.FindControl(this, checkIdAno) as CheckBox;
        CheckBox box_ne = WebControlHelper.FindControl(this, checkIdNe) as CheckBox;

        if (box_sender.Checked)
        {
            if (box_sender == box_ano) box_ne.Checked = false; else  box_ano.Checked = false;
        }
        
        if (!string.IsNullOrEmpty(grid))
        {
            RadGrid gr = WebControlHelper.FindControl(this, grid) as RadGrid;
            gr.Visible = box_ano.Checked;
            if (gr.Visible && !readOnly)
            {
                gr.MasterTableView.InsertItem();
                gr.MasterTableView.IsItemInserted = true;
            }
        }       
    }

    protected void check_dary_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "Check_dary_ano", "Check_dary_ne", "grid_dary", false);
    }

    protected void Check_vedl_cin_CheckedChanged(object sender, EventArgs e)
    {
         _nastavZobr(sender, "Check_vedl_cin_ano", "Check_vedl_cin_ne", "grid_prace", false);
    }
   
    protected void Check_obch_spol_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "Check_obch_spol_ano", "Check_obch_spol_ne", "grid_cinnost", false);
    }
   
    protected void Check_vztahy_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "Check_vztahy_ano", "Check_vztahy_ne", "grid_osoby", false);
    }
  
    protected void Check_politika_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "Check_politika_ano", "Check_politika_ne", "grid_politika", false);
    }
   
    protected void Check_predvolani_CheckedChanged(object sender, EventArgs e)
    {
        _nastavZobr(sender, "Check_predvolani_ano", "Check_predvolani_ne", "grid_predvolani", false);
    }
 

    protected void val_form_ServerValidator(object sender, ServerValidateEventArgs args)
    {
        if (saving)
        {
            string error = "";
            List<string> pole = Pozadavekannual.GetControlsNames().Select(aa=>aa.Item1).ToList();

            for (int i = 0; i < pole.Count; i++)
            {
                CheckBox box_n = WebControlHelperProxy.FindControl(this, pole[i]+"_ne") as CheckBox;
                CheckBox box_a = WebControlHelperProxy.FindControl(this, pole[i]+"_ano") as CheckBox;
                string hodnota = "";
                if (box_n.Checked) hodnota = "n"; else if (box_a.Checked) hodnota = "a";
                if (string.IsNullOrEmpty(hodnota))
                {
                    //"Check_dary", "Check_vedl_cin","Check_obch_spol", "Check_vztahy", "Check_politika", "Check_predvolani"
                    if (pole[i]== "Check_dary")
                        error += "[%Dary, výhody, pozvání%],";
                    else if (pole[i] == "Check_vedl_cin")
                        error += "[%Výkon vedlejší činnosti%],";
                    else if (pole[i] == "Check_obch_spol")
                        error += "[%Účast v jiné obchodní společnosti%],";
                    else if (pole[i] == "Check_vztahy")                       
                        error += "[%Příbuzenské vztahy%],";
                    else if (pole[i] == "Check_politika")
                        error += "[%Politická angažovanost%],";
                    else if (pole[i] == "Check_predvolani")
                        error += "[%Předvolání orgány činnými v trestním řízení%],";
                }
                else if (hodnota == "a")
                {
                    DataTable table = null;
                    if (pole[i] == "Check_dary")
                    {
                        table = SessionInfo.GetVariable("dary") as DataTable;
                    }
                    else if (pole[i] == "Check_vedl_cin")
                    {
                        table = SessionInfo.GetVariable("prace") as DataTable;
                    }
                    else if (pole[i] == "Check_obch_spol")
                    {
                        table = SessionInfo.GetVariable("cinnost") as DataTable;
                    }                   
                    else if (pole[i] == "Check_vztahy")
                    {
                        table = SessionInfo.GetVariable("osoby") as DataTable;
                    }
                    else if (pole[i] == "Check_politika")
                    {
                        table = SessionInfo.GetVariable("politika") as DataTable;
                    }
                    else if (pole[i] == "Check_predvolani")
                    {
                        table = SessionInfo.GetVariable("vyslechy") as DataTable;
                    }
                    if ((table == null) || (table.Rows.Count == 0))
                    {
                        if (pole[i] == "Check_dary")
                            error += "[%Dary, výhody, pozvání%],";
                        else if (pole[i] == "Check_vedl_cin")
                            error += "[%Výkon vedlejší činnosti%],";
                        else if (pole[i] == "Check_obch_spol")
                            error += "[%Účast v jiné obchodní společnosti%],";
                        else if (pole[i] == "Check_vztahy")
                            error += "[%Příbuzenské vztahy%],";
                        else if (pole[i] == "Check_politika")
                            error += "[%Politická angažovanost%],";
                        else if (pole[i] == "Check_predvolani")
                            error += "[%Předvolání orgány činnými v trestním řízení%],";
                    }
                }
            }
            if (!string.IsNullOrEmpty(error))
            {
                args.IsValid = false;
                ((CustomValidator)sender).ErrorMessage = "[%Nedostatečně vyplněny části%]: " + error;
                return;
            }
            CheckBox box = WebControlHelperProxy.FindControl(this, "CheckBox_souhlas") as CheckBox;
            if (!box.Checked)
            {
                args.IsValid = false;
                ((CustomValidator)sender).ErrorMessage = "[%Nevyplněn souhlas%]";
                return;
            }
       
            if (SessionInfo.GetVariable("annual_podpis")==null)
            {
                args.IsValid = false;
                ((CustomValidator)sender).ErrorMessage = "[%Dokument není podepsán%]";
                return;
            }
        }
        args.IsValid = true;
    }

    protected void TRB_overeniProhlizec_Click(object sender, EventArgs e)
    {
        workfl_hl hl = new workfl_hl();
        hl.NaplnStrukturu(PozId);
        decimal os_cislo = hl.NaplnStrukturu(PozId).os_cislo;// Convert.ToDecimal(text_osCislo.Text);
        string jmeno = Pracovnik.PrijmeniJmeno(os_cislo);
        string prijmeni = jmeno.Split(' ')[0].Trim();
        jmeno = jmeno.Split(' ')[1].Trim();

        DateTime datum_narozeni = Pracovnik.DatumNarozeni(os_cislo);

        string dat_nar = datum_narozeni.Date.ToString("dd.MM.yyyy"); // datum_narozeni.Date.ToString("d");
        dat_nar = Regex.Replace(dat_nar, @"\s+", "");


        //rejstřík 1 - Insolvenční rejstřík
        string insolvencni_rejstrik = "https://isir.justice.cz/isir/ueu/vysledek_lustrace.do?nazev_osoby=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&jmeno_osoby=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&ic=&datum_narozeni=" + dat_nar + "&rc=&mesto=&cislo_senatu=&bc_vec=&rocnik=&id_osoby_puvodce=&druh_stav_konkursu=&datum_stav_od=&datum_stav_do=&aktualnost=AKTUALNI_I_UKONCENA&druh_kod_udalost=&datum_akce_od=&datum_akce_do=&nazev_osoby_f=&cislo_senatu_vsns=&druh_vec_vsns=&bc_vec_vsns=&rocnik_vsns=&cislo_senatu_icm=&bc_vec_icm=&rocnik_icm=&rowsAtOnce=50&captcha_answer=&spis_znacky_datum=&spis_znacky_obdobi=14DNI";

        //rejstřík 2 - Obchodní rejstřík 
        //  string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?jenPlatne=PLATNE&nazev="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "+"+ HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&polozek=50&typHledani=STARTS_WITH";
        string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?p%3A%3Asubmit=x&.%2Frejstrik-%24osoba=&prijmeni=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&jmeno=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&narozeni=" + dat_nar + "&obec=&angazma=&soud=&polozek=50&jenPlatne=PLATNE";


        //rejstřík 3 - Živnostenský rejstřík
        //string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&NAROZENI="+dat_nar+"&ROLE=&VYPIS=1";
        string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO=" + HttpUtility.UrlEncode(jmeno, Encoding.GetEncoding(28592)) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, Encoding.GetEncoding(28592)) + "&NAROZENI=" + dat_nar + "&ROLE=&VYPIS=1";


        //rejstřík 4 - ČNB
        string cnb_rejstrik = "https://apl.cnb.cz/apljerrsdad/JERRS.WEB09.DIRECT_FIND_RESPONSE?p_lang=cz&p_DATUM_NAROZENI=&p_RODNE_CISLO=&p_IDENTIFIKACNI_CISLO_HODNOTA=&p_NAZEV_PLNY=&p_JMENO=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&p_PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&p_REG_CIS=&p_ADRESA=&p_DATUM=" + DateTime.Now.ToString("d") + "&p_rec_per_page=25";

        ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", "showWindow('" + insolvencni_rejstrik + "','" + obchodni_rejstrik + "','" + zivnostensky_rejstrik + "','" + cnb_rejstrik + "')", true);
    }

    protected void button_podpis_Click(object sender, EventArgs e)
    {
        var pdp = new AnnualPodpis { OsCisloPodepsaneho = Globals.OsCisloAktUser, Datum = DateTime.Now.Date };
        SessionInfo.SetVariable("annual_podpis", pdp);

        Label dat_podpisu= WebControlHelper.FindControl(this, "lab_dat_podpisu") as Label;
        Label podpis = WebControlHelper.FindControl(this, "lab_podpis") as Label;

        dat_podpisu.Text = pdp.Datum.ToString("d");
        podpis.Text = Pracovnik.PrijmeniJmeno(pdp.OsCisloPodepsaneho);       

        ((RadButton)sender).Visible = false;
    }

    protected bool _zobrazTlacitkoPodpis(object o)
    {
        if (Mode == "readonly")
            return false;
        else if (Mode == "edit")
        {
            if (((o == null) || (o == DBNull.Value))&&(SessionInfo.GetVariable("annual_podpis")==null)) return true;
        }

        //if ((SessionInfo.GetVariable("annual_podpis") != null) && (Mode=="edit")) return true;

        return false;
    }

    protected string _zobrazPodpis(object o)
    {
        if ((o == null) || (o == DBNull.Value)) return "";

        return Pracovnik.PrijmeniJmeno(Convert.ToDecimal(o));        
    }

    protected void ds_dary_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    protected void ds_prace_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    protected void ds_cinnost_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    protected void ds_osoby_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    protected void ds_politika_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    protected void ds_predvolani_DataBinding(object sender, EventArgs e)
    {
        _nastavDs(sender);
    }

    private void _nastavDs(object sender)
    {
        if (Mode == "readonly")
        {
            ((ObjectDataSource)sender).SelectParameters[1].DefaultValue = PozId.ToString();
            ((ObjectDataSource)sender).SelectParameters[2].DefaultValue ="true";
        }
    }
}
