﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Personal;
using KSProgram.Exceptions;
using System.Linq;
using System.Collections.Generic;


public partial class Controls_ZadostObudget : UserControlPozadavek
{
    protected void Page_Load(object sender, EventArgs e)
    {

        ((TPage)this.Page).VisibleVyberSeznamuOsobnichCisel = false;
        ((TPage)this.Page).UpdateHlavniOblastOnOsCisloChanged = false;
    }

    protected bool _pomer_visible
    {
        get
        {
            return Convert.ToBoolean(ViewState["pomer_visible"]);
        }
        set
        {
            ViewState["pomer_visible"] = value;
        }
    }

    protected decimal OsCislo
    {
        get
        {
            return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
        }
        set
        {
            ViewState["OsCislo"] = value;
        }
    }

    protected Int16 CisloPom
    {
        get
        {
            if (ViewState["CisloPom"] == null)
                return 0;
            else
                return Convert.ToInt16(ViewState["CisloPom"]);
        }
        set
        {
            ViewState["CisloPom"] = value;
        }
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "budget", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        string pomer_visible = wf.Get_UN("", "VyberPomeru", "Visible");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
        {
            FormView1.ChangeMode(FormViewMode.Insert);
            if (pomer_visible == "true")
            {
                ds_pomery.SelectParameters["os_cislo"].DefaultValue = PozadavekZpracovaniAbstract.VydavatelProNovyPoz().ToString();
            }
        }
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);


        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
            r.Visible = (pomer_visible == "true");

        if (val == "insert")
        {
            OsCislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
            var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(OsCislo);

            if (r.Visible)
            {
                Int16 parsed_pomer;
                if (Int16.TryParse(((DropDownList)WebControlHelper.FindControl(FormView1, "ddl_pomery")).SelectedValue, out parsed_pomer))
                    CisloPom = parsed_pomer;
            }
            else
                CisloPom = Prac_pom.Platny_Pomer(OsCislo, DateTime.Now.Date);
        }
        else
        {
            DataRowView drv = (DataRowView)FormView1?.DataItem;

            DataTable table = drv.DataView.Table;
            if (table.Rows.Count > 0)
            {
                OsCislo = Convert.ToDecimal(table.Rows[0]["os_cislo"]);
                CisloPom = Convert.ToInt16(table.Rows[0]["cislo_pom"]);
            }
        }

        Label druh = (Label)WebControlHelper.FindControl(this, "Label17");
        if (druh != null)
        {
            if (druh.Text.Trim() == "Rozpad do podřízených budgetů")
            {
                Table tab = (Table)WebControlHelper.FindControl(this, "TableItem");
                addRows(nactiRozpad(), tab);
            }
        }

        naplRoky();
        naplnMesice();
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }

    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvodx");
        e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);

        e.InputParameters["id_poz"] = this.PozId;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
        {
            if (r.Visible)
            {
                DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddl_pomery");
                e.InputParameters["cislo_pom"] = list.SelectedValue;
            }
        }

        DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
        e.InputParameters["id_budgetu"] = (budget.SelectedValue == "" ? String.Empty : budget.SelectedValue);

        RadTextBox box3 = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxCastka");
        e.InputParameters["castka"] = (box3.Text == "" ? String.Empty : box3.Text);

        DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this, "Dropdown_druhy");
        e.InputParameters["druh_pohybu"] = (list2.SelectedValue == "" ? String.Empty : list2.SelectedValue);

        DropDownList proti = (DropDownList)WebControlHelper.FindControl(this, "DropDownProti");
        if (list2.SelectedValue == "1" || list2.SelectedValue == "2" || list2.SelectedValue == "101") proti.SelectedValue = "";
        e.InputParameters["id_protibudgetu"] = (proti.SelectedValue == "" ? "-1" : proti.SelectedValue);

        RadTextBox box4 = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
        e.InputParameters["duvod"] = (box4.Text == "" ? String.Empty : box4.Text);

        TRadDatePicker box5 = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box5.SelectedDate == null ? new DateTime() : box5.SelectedDate);

        DropDownList mesic = (DropDownList)WebControlHelper.FindControl(this, "DropDownMesic");
        DropDownList rok = (DropDownList)WebControlHelper.FindControl(this, "DropDownRok");
        e.InputParameters["obdobi"] = new DateTime(int.Parse(rok.SelectedValue), int.Parse(mesic.SelectedValue), 1);

        if (list2.SelectedValue == "111")
        {
            DataTable budgety = Pozadavekbudget.getPodrizeneBudgety(int.Parse(budget.SelectedValue));
            DataTable store = new DataTable();
            store.Columns.Add("id", typeof(Int32));
            store.Columns.Add("castka", typeof(decimal));
            decimal suma = 0;
            foreach (DataRow row in budgety.Rows)
            {
                Table tab = (Table)WebControlHelper.FindControl(this, "TableInsert");
                RadTextBox castka = (RadTextBox)WebControlHelper.FindControl(tab, "RadTextBoxPodriz" + row["id"].ToString());
                if (castka != null)
                {
                    DataRow rowPod = store.NewRow();
                    rowPod["id"] = row["id"];
                    rowPod["castka"] = castka.Text.Trim();
                    store.Rows.Add(rowPod);
                    suma += decimal.Parse(castka.Text.Trim());
                }
            }
            e.InputParameters["rozpad"] = store;
            e.InputParameters["castka"] = suma;
        }
        else
        {
            e.InputParameters["rozpad"] = new DataTable();
        }

    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;

            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void ddl_pomery_SelectedIndexChanged(object sender, EventArgs e)
    {
        string val = ((DropDownList)sender).SelectedValue;
        DateTime? ld_datum_od = null;
        if (!string.IsNullOrEmpty(val))
        {
            RadDatePicker picker_dat = (RadDatePicker)WebControlHelper.FindControl(this.Page, "TextBoxOdInsert");
            ld_datum_od = picker_dat.SelectedDate;
            CisloPom = Convert.ToInt16(val);
        }
    }

    protected void TextBoxOdEdit_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        TRadDatePicker trdp_od = (TRadDatePicker)sender;
        TRadDatePicker trdp_do =
            trdp_od
                .FindParentControl<TableRow>()?
                .FindControlRecursive<TRadDatePicker>()?
                .FirstOrDefault(x => x.ID != trdp_od.ID);
        if (trdp_do != null && !trdp_do.SelectedDate.HasValue)
        {
            trdp_do.SelectedDate = trdp_od.SelectedDate;
        }
    }

    public void ValidateInput(object sender, ServerValidateEventArgs e)
    {
        CustomValidator cust = (CustomValidator)sender;

        if (this.CurrentMode == FormViewMode.Insert)
        {
            DropDownList id_budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
            DropDownList druh = (DropDownList)WebControlHelper.FindControl(this, "Dropdown_druhy");
            RadTextBox castka = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxCastka");
            RadTextBox zust = (RadTextBox)WebControlHelper.FindControl(this, "Zustatek");
            DropDownList id_proti = (DropDownList)WebControlHelper.FindControl(this, "DropDownProti");
            TRadDatePicker dat = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
            if (id_budget.Text == "" || id_budget.Text == null)
            {
                cust.Text = "[%Vyberte prosím budget%]";
                e.IsValid = false;
                return;
            }
            if ((id_proti.Text == "" || id_proti.Text == null) && (druh.SelectedValue == "110"))
            {
                cust.Text = "[%ID protibudgetu musí být zadáno%]";
                e.IsValid = false;
                return;
            }
            if (castka.Text == "" || castka.Text == null)
            {
                cust.Text = "[%Částka musí být zadána%]";
                e.IsValid = false;
                return;
            }
            //MiKo oprava pro compiler
            decimal pom;
            if (!decimal.TryParse(castka.Text.Trim(), out pom))
            {
                cust.Text = "[%Částka musí být číslo%]";
                e.IsValid = false;
                return;
            }
            if(pom < 1)
            {
                cust.Text = "[%Částka musí být větší než 0%]";
                e.IsValid = false;
                return;
            }
            if ((decimal.Parse(castka.Text.Trim()) > decimal.Parse(zust.Text.Trim())) && (druh.SelectedValue != "1" && druh.SelectedValue != "2"))
            {
                cust.Text = "[%Částka nemůže být větší než zůstatek%]";
                e.IsValid = false;
                return;
            }
            if (dat.SelectedDate == null)
            {
                cust.Text = "[%Vyberte prosím datum vyřízení%]";
                e.IsValid = false;
                return;
            }
            if (druh.SelectedValue == "111")
            {
                DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
                DataTable budgety = Pozadavekbudget.getPodrizeneBudgety(int.Parse(budget.SelectedValue));
                decimal suma = 0;
                if (budgety.Rows.Count > 0)
                {
                    foreach (DataRow row in budgety.Rows)
                    {
                        RadTextBox box = (RadTextBox)WebControlHelper.FindControl(this, "RadTextBoxPodriz" + row["id"].ToString());
                        suma += decimal.Parse(box.Text.Trim());
                    }

                    if (suma > decimal.Parse(zust.Text.Trim()))
                    {
                        cust.Text = "[%Nelze rozdělit více prostředků než je v budgetu k dispozici%]";
                        e.IsValid = false;
                        return;
                    }
                }
            }
        }
    }

    protected void druhSelected(object sender, EventArgs e)
    {
        DropDownList druh = (DropDownList)WebControlHelper.FindControl(this, "Dropdown_druhy");
        DropDownList id_proti = (DropDownList)WebControlHelper.FindControl(this, "DropDownProti");
        DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
        DropDownList zam = (DropDownList)WebControlHelper.FindControl(this, "DropDownZam");
        Label proti = (Label)WebControlHelper.FindControl(this, "Label5");
        TRadButton recount = (TRadButton)WebControlHelper.FindControl(this, "TRB_Recount");
        RadTextBox castka = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxCastka");
        Table tab = (Table)WebControlHelper.FindControl(this, "TableInsert");
        if (budget.SelectedIndex != 0)
        {
            DataTable podriz = Pozadavekbudget.getPodrizeneBudgety(int.Parse(budget.SelectedValue.ToString()));
            foreach (DataRow row in podriz.Rows)
            {
                TableRow podRow = (TableRow)WebControlHelper.FindControl(this, "TableRowPodriz" + row["id"].ToString());
                if (podRow != null) podRow.Visible = false;
            }

            TableRow head = (TableRow)WebControlHelper.FindControl(this, "podriz_head"); 
            if (head != null) head.Visible = false;

            TableRow foot = (TableRow)WebControlHelper.FindControl(this, "footRow");
            if (foot != null) tab.Controls.Remove(foot);
            
            recount.Visible = false;
            proti.Text = "[%ID protibudgetu%]:";
            id_proti.Visible = true;
            proti.Visible = true;
            zam.Visible = false;
            if (druh.SelectedValue == "1" || druh.SelectedValue == "2") castka.Text = "";
            if (druh.SelectedValue == "1" || druh.SelectedValue == "2" || druh.SelectedValue == "111")
            {
                id_proti.Text = "";
                id_proti.Visible = false;
                proti.Visible = false;
            }

            if (druh.SelectedValue == "101") // cerpani
            {
                id_proti.Text = "";
                id_proti.Visible = false;
                proti.Text = "[%ID Zaměstnance%]:";
                zam.Visible = true;
                zam.Items.Clear();
            }

            if (druh.SelectedValue == "110") //prevod do jineho budgetu
            {
                id_proti.Visible = true;
                proti.Visible = true;
                id_proti.Items.Clear();
                DataTable budgety = KSProgram.Pozadavky.Pozadavekbudget.getBudgetyBezJednoho(int.Parse(budget.SelectedValue));
                foreach (DataRow row in budgety.Rows)
                {
                    id_proti.Items.Add(new ListItem(row["popis"].ToString().Trim(), row["id"].ToString().Trim()));
                }
            }

            if (druh.SelectedValue == "111") // rozpocitani do podrizenych
            {
                recount.Visible = true;
                if (!String.IsNullOrEmpty(castka.Text))
                {
                    if (!Zakaznik.IsCurrent("CERTICON")) //zpusob podle poctu osob
                    {
                        DataTable budgety = Pozadavekbudget.getPodrizeneBudgetySPoctem(int.Parse(budget.SelectedValue));
                        decimal zbytek = decimal.Parse(castka.Text.Trim());
                        int celkem = 0;
                        foreach (DataRow row in budgety.Rows)
                        {
                            celkem += int.Parse(row["poc_zam"].ToString());
                        }
                        decimal naOsobu = 0;
                        if (celkem > 0) naOsobu = zbytek / celkem; //dělení nulou
                        naOsobu = Math.Ceiling(naOsobu);
                        int podil = 0;
                        decimal[] pole = new decimal[budgety.Rows.Count * 2];

                        int i = 0;
                        foreach (DataRow row in budgety.Rows)
                        {
                            pole[i] = int.Parse(row["id"].ToString());
                            podil = (int)naOsobu * int.Parse(row["poc_zam"].ToString());
                            if (podil <= zbytek)
                            {
                                pole[i + 1] = podil;
                                zbytek = zbytek - podil;
                            }
                            else
                            {
                                pole[i + 1] = (int)zbytek;
                                zbytek = 0;
                            }
                            i += 2;
                        }
                        addRows(pole, tab); //sorry za pole
                        ViewState["budget"] = pole;
                    }
                    else // podle tarifu pro CERTICON
                    {
                        int id_bud = int.Parse(budget.SelectedValue);
                        DataTable rozpad = Pozadavekbudget.RozpadBudgetuPodleTarifu(id_bud);
                        decimal celkem = 0;
                        if (rozpad == null || rozpad.Rows.Count < 1) return;
                        foreach (DataRow row in rozpad.Rows)
                        {
                            celkem += decimal.Parse(row["tarif"].ToString());
                        }

                        DataTable podrizene = Pozadavekbudget.getPodrizeneBudgety(id_bud);
                        DataTable rozpadPodriz = new DataTable();
                        rozpadPodriz.Columns.Add("id_budgetu", typeof(Int32));
                        rozpadPodriz.Columns.Add("castka", typeof(decimal));

                        foreach (DataRow row in podrizene.Rows)
                        {
                            DataRow nova = rozpadPodriz.NewRow();
                            nova["castka"] = 0;
                            nova["id_budgetu"] = row["id"];
                            int typ = int.Parse(row["typ"].ToString().Trim());
                            int kod = int.Parse(row["kod"].ToString().Trim());
                            if (typ == 4 && celkem != 0) // divize
                            {
                                foreach(DataRow rozpad_row in rozpad.Rows)
                                {
                                    if(rozpad_row["divize"].ToString().Trim() == kod.ToString().Trim())
                                    {
                                        nova["castka"] = decimal.Parse(nova["castka"].ToString()) + Math.Ceiling(decimal.Parse(rozpad_row["tarif"].ToString()));
                                    }
                                }
                                decimal cast = decimal.Parse(nova["castka"].ToString()) / celkem;
                                nova["castka"] = Math.Floor(decimal.Parse(castka.Text.Trim()) * cast);
                            }
                            else if(typ == 2 && celkem != 0) //stredisko
                            {
                                foreach (DataRow rozpad_row in rozpad.Rows)
                                {
                                    if (rozpad_row["prac_str"].ToString().Trim() == kod.ToString())
                                    {
                                        nova["castka"] = decimal.Parse(nova["castka"].ToString()) + Math.Ceiling(decimal.Parse(rozpad_row["tarif"].ToString()));
                                    }
                                }
                                decimal cast = decimal.Parse(nova["castka"].ToString()) / celkem;
                                nova["castka"] = Math.Floor(int.Parse(castka.Text.Trim()) * cast);
                            }
                            else if(typ == 1 && celkem != 0) //osoba
                            {
                                foreach (DataRow rozpad_row in rozpad.Rows)
                                {
                                    if (rozpad_row["os_cislo"].ToString().Trim() == kod.ToString())
                                    {
                                        nova["castka"] = int.Parse(nova["castka"].ToString()) + Math.Ceiling(double.Parse(rozpad_row["tarif"].ToString()));
                                    }
                                }
                                decimal cast = decimal.Parse(castka.Text.Trim()) * decimal.Parse(nova["castka"].ToString()) / celkem;
                                nova["castka"] = Math.Floor(cast);
                            }
                            else
                            {
                                nova["castka"] = 0;
                            }
                            rozpadPodriz.Rows.Add(nova);
                        }
                        decimal[] pole = new decimal[rozpadPodriz.Rows.Count * 2];

                        int counter = 0;
                        foreach(DataRow row in rozpadPodriz.Rows)
                        {
                            pole[counter] = int.Parse(row["id_budgetu"].ToString());
                            pole[counter+1] = decimal.Parse(row["castka"].ToString());
                            counter += 2;
                        }
                        addRows(pole, tab); //sorry za pole
                        ViewState["budget"] = pole;
                    }                    
                }
                suma_prepocet(sender, e);
            }
        }
    }

    protected void addRows(decimal[] pole, Table tab) // prida radky do formview
    {
        DropDownList druhInsert = (DropDownList)WebControlHelper.FindControl(this, "Dropdown_druhy");
        if (druhInsert != null)
        {
            if (druhInsert.SelectedValue != "111") return;
        }

        Label druhView = (Label)WebControlHelper.FindControl(this, "Label17");
        if (druhView != null)
        {
            if (druhView.Text.Trim() != "Rozpad do podřízených budgetů") return;
        }

        DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
        DataTable budgety;
        bool edit = true;
        if (budget != null)
        {
            budgety = Pozadavekbudget.getPodrizeneBudgety(int.Parse(budget.SelectedValue));
        }
        else
        {
            Label id_bud = (Label)WebControlHelper.FindControl(this, "Label2");
            budgety = Pozadavekbudget.getPodrizeneBudgety(int.Parse(id_bud.Text.Trim()));
            edit = false;
        }


        TableRow headRow = (TableRow)WebControlHelper.FindControl(this, "podriz_head");
        TableCell headCell = new TableCell();
        Label text1 = new Label();
        Label text2 = new Label();
        Label text3 = new Label();

        if (headRow == null)
        {
            headRow = new TableRow();
            headCell.Style.Add("border", "lightgray 1px solid");
            headCell.Style.Add("background", "#E5E5E5");
            headCell.HorizontalAlign = HorizontalAlign.Right;
            text1.Text = "Id";
            headCell.ID = "ID_pod_budgetu";
            headCell.Controls.Add(text1);
            headRow.Cells.Add(headCell);

            headCell = new TableCell();
            headCell.Style.Add("border", "lightgray 1px solid");
            headCell.Style.Add("background", "#E5E5E5");
            text2.Text = "Název budgetu";
            headCell.ID = "Nazev_pod_budgetu";
            headCell.Controls.Add(text2);
            headRow.Cells.Add(headCell);

            headCell = new TableCell();
            headCell.Style.Add("border", "lightgray 1px solid");
            headCell.Style.Add("background", "#E5E5E5");
            headCell.ColumnSpan = 2;
            text3.Text = "Přidělená částka";
            headCell.ID = "Castka_pod_budgetu";
            headCell.Controls.Add(text3);
            headRow.Cells.Add(headCell);

            headRow.ID = "podriz_head";

            tab.Rows.Add(headRow);
        }
        else
        {
            headRow.Visible = true;
        }

        foreach (DataRow row in budgety.Rows)
        {
            TableRow tr = new TableRow();
            TableCell tc = new TableCell();

            Label nazev = new Label();
            Label id = new Label();
            id.Text = row["id"].ToString();
            nazev.Text = row["popis"].ToString().Trim();

            tc.HorizontalAlign = HorizontalAlign.Right;
            tc.Controls.Add(id);
            tc.Style.Add("border-top", "lightgray 1px solid");
            tr.Controls.Add(tc);

            tc = new TableCell();
            tc.Controls.Add(nazev);
            tc.Style.Add("border-top", "lightgray 1px solid");
            tr.Controls.Add(tc);

            tc = new TableCell();
            tc.ColumnSpan = 2;
            RadTextBox input = new RadTextBox();
            RadTextBox stary = (RadTextBox)WebControlHelper.FindControl(this, "RadTextBoxPodriz" + row["id"].ToString());
            if (stary == null)
            {
                input.ID = "RadTextBoxPodriz" + row["id"].ToString();
                input.TextChanged += suma_prepocet;
            }
            else
            {
                input = stary;
                TableRow podRow = (TableRow)WebControlHelper.FindControl(this, "TableRowPodriz" + row["id"].ToString());
                podRow.Visible = true;
            }

            for (int i = 0; i < pole.Length; i += 2)
            {
                if (pole[i] == int.Parse(row["id"].ToString()))
                {
                    input.Text = pole[i + 1].ToString();
                }
            }
            input.Enabled = edit;
            input.AutoPostBack = true;
            if (stary == null)
            {
                tc.Controls.Add(input);
                tc.Style.Add("border-top", "lightgray 1px solid");
                tc.ID = "TableCellPodriz" + row["id"].ToString();
                tr.Controls.Add(tc);
                tr.ID = "TableRowPodriz" + row["id"].ToString();

                tab.Controls.Add(tr);
            }
        }

        TableRow foot = (TableRow)WebControlHelper.FindControl(this, "footRow");
        if (foot == null)
        {
            TableRow footRow = new TableRow();
            TableCell footCell = new TableCell();
            Label suma = new Label();
            suma.Text = "Suma:";
            footCell.ColumnSpan = 2;
            footCell.Style.Add("border", "lightgray 1px solid");
            footCell.Style.Add("background", "#E5E5E5");
            footCell.HorizontalAlign = HorizontalAlign.Right;
            text1.Text = "Id";
            footCell.ID = "Suma_cell";
            footCell.Controls.Add(suma);
            footRow.Controls.Add(footCell);
            footRow.ID = "footRow";

            RadTextBox sum = new RadTextBox();
            sum.Enabled = false;
            sum.ID = "Suma";

            footCell = new TableCell();
            footCell.Style.Add("border", "lightgray 1px solid");
            footCell.Style.Add("background", "#E5E5E5");
            footCell.ColumnSpan = 2;
            footCell.Controls.Add(sum);
            footRow.Controls.Add(footCell);
            tab.Controls.Add(footRow);
        }
    }

    private void suma_prepocet(object sender, EventArgs e)
    {
        RadTextBox sumText = (RadTextBox)WebControlHelper.FindControl(this, "Suma");
        DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
        DataTable budgety = Pozadavekbudget.getPodrizeneBudgety(int.Parse(budget.SelectedValue));
        DataTable store = new DataTable();
        store.Columns.Add("id", typeof(Int32));
        store.Columns.Add("castka", typeof(decimal));
        decimal suma = 0;
        foreach (DataRow row in budgety.Rows)
        {
            Table tab = (Table)WebControlHelper.FindControl(this, "TableInsert");
            RadTextBox castka = (RadTextBox)WebControlHelper.FindControl(tab, "RadTextBoxPodriz" + row["id"].ToString());
            if (castka != null)
            {
                DataRow rowPod = store.NewRow();
                rowPod["id"] = row["id"];
                rowPod["castka"] = castka.Text.Trim();
                store.Rows.Add(rowPod);
                suma += decimal.Parse(castka.Text.Trim());
            }
        }
        if (sumText != null)
        {
            sumText.Text = suma.ToString();
        }


    }

    protected void DropDownBudgety_SelectedIndexChanged(object sender, EventArgs e)
    {
        RadTextBox zust = (RadTextBox)WebControlHelper.FindControl(this, "Zustatek");
        RadTextBox castka = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxCastka");
        DropDownList budget = (DropDownList)WebControlHelper.FindControl(this, "DropDownBudgety");
        Table tab = (Table)WebControlHelper.FindControl(this, "TableInsert");
        zust.Text = "";
        castka.Text = "";

        DataTable budgety = Pozadavekbudget.getNazvyBudgetu();
        foreach (DataRow row in budgety.Rows)
        {
            TableRow box = (TableRow)WebControlHelper.FindControl(this, "TableRowPodriz" + row["id"].ToString());
            if (box != null)
            {
                tab.Rows.Remove(box);
            }
        }

        if (!String.IsNullOrEmpty(budget.SelectedValue))
        {
            zust.Text = Pozadavekbudget.zustBudgetu(int.Parse(budget.SelectedValue)).ToString();
            castka.Text = zust.Text;
            druhSelected(sender, e);
        }
    }

    protected void FormView1_Load(object sender, EventArgs e)
    {
        if (ViewState["budget"] != null)
        {
            Table tabInsert = (Table)WebControlHelper.FindControl(this, "TableInsert");
            Table tabItem = (Table)WebControlHelper.FindControl(this, "TableItem");
            addRows((decimal[])ViewState["budget"], tabInsert);
            addRows((decimal[])ViewState["budget"], tabItem);
        }
    }

    protected decimal[] nactiRozpad()
    {
        ParametryPrikazu pars = new ParametryPrikazu()
                            {
                                new KSParameter("id_poz", DbType.Int32, PozId),
                                 new KSParameter("id_bud", DbType.Int32, workfl_hodnoty.GetDbInt32(PozId, "id_budgetu")),
                            };
        DataTable podriz = SqlPrikaz.ExecuteCommand(
                        "select bud.id_budgetu as id, castka, bud.nazev_budgetu as nazev from budgety_pohyby poh join budgety bud on bud.id_budgetu = poh.id_budgetu where id_pozadavku = @id_poz and poh.id_budgetu <> @id_bud", ref pars);
        decimal[] pole = new decimal[podriz.Rows.Count * 2];
        int i = 0;
        foreach (DataRow row in podriz.Rows)
        {
            pole[i] = int.Parse(row["id"].ToString().Trim());
            decimal num = decimal.Parse(row["castka"].ToString().Trim());
            pole[i + 1] = (int)num;
            i += 2;
        }
        return pole;
    }

    protected void naplRoky()
    {
        DateTime akt = KSProgram.Globals.AktObdobi;
        DropDownList rok = (DropDownList)WebControlHelper.FindControl(this, "DropDownRok");

        if (rok != null)
        {
            rok.Items.Add(akt.Year.ToString());
            rok.Items.Add((akt.Year + 1).ToString());
            rok.Items.Add((akt.Year + 2).ToString());
            rok.Items.Add((akt.Year + 3).ToString());
            rok.Items.Add((akt.Year + 4).ToString());
        }
    }

    protected void naplnMesice(object sender, EventArgs e)
    {
        naplnMesice();
    }

    protected void naplnMesice()
    {
        DateTime akt = KSProgram.Globals.AktObdobi;
        DropDownList mesic = (DropDownList)WebControlHelper.FindControl(this, "DropDownMesic");
        DropDownList rok = (DropDownList)WebControlHelper.FindControl(this, "DropDownRok");

        if (rok != null)
        {
            string index = mesic.SelectedValue;

            mesic.Items.Clear();
            for (int i = 1; i <= 12; i++)
            {
                if (akt.Year.ToString() != rok.SelectedValue || akt.Month <= i)
                {
                    mesic.Items.Add(i.ToString());
                }
            }

            foreach (ListItem item in mesic.Items)
            {
                if (item.Value == index)
                {
                    item.Selected = true;
                }
            }
        }
    }

}
