﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Dochazka;
using System.Drawing;
using KSProgram.Funkce;
using KSProgram.Obecne;
using System.Collections.Specialized;

public partial class Controls_ZadostOdochazka : UserControlPozadavek
{
    decimal _dny;
    decimal _hodiny;
    decimal _dny_vyk;
    decimal _hod_vyk;
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    /// <summary>
    /// Načtení
    /// </summary>
    public override void Nacist()
    {
        base.Nacist();

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        DetailsView1.DataSourceID = "ObjectDataSource1";
        DetailsView1.DataBind();
    }

    public override void ChangeMode(FormViewMode mode)
    {
        //throw new NotImplementedException();
    }

    protected void TGridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.Header)
        {
            _hodiny = 0;
            _dny = 0;
            _hod_vyk = 0;
            _dny_vyk = 0;
        }
        else if (e.Row.RowType == DataControlRowType.DataRow)
        {
            int kod = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "kod"));
            ParametryDochazky pd = new ParametryDochazky();
            if (ParametryDochazky.POZADAVAEK_FOND_BEZ_NAHRADNIHO_VOLNA && pd.IsKodNV(kod)) return; //PH 18.3.2016 

            _hodiny += Convert.ToDecimal(DataBinder.Eval(e.Row.DataItem, "hodiny"));
            _dny += Convert.ToDecimal(DataBinder.Eval(e.Row.DataItem, "dny"));

            if ((pd.IsKodAbs(kod) || pd.IsKodPrac(kod)))
            {
                //PH 13.7.2015 HELPDESK ID 29398
                //if (ParametryDochazky.POZADAVAEK_FOND_BEZ_NAHRADNIHO_VOLNA && pd.IsKodNV(kod)) return; //PH 18.3.2016 přemístěno výše

                _hod_vyk += Convert.ToDecimal(DataBinder.Eval(e.Row.DataItem, "hodiny"));
                _dny_vyk += Convert.ToDecimal(DataBinder.Eval(e.Row.DataItem, "dny"));

            }
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            //e.Row.Cells[2].Text = _dny.ToString("N1");
            //e.Row.Cells[3].Text = _hodiny.ToString("N2");
            e.Row.Cells[1].Text = WebControlHelper.ZmenaTextu("[%Suma položek zahrnovaných do fondu%]");
            e.Row.Cells[2].Text = _dny_vyk.ToString("N1");
            e.Row.Cells[3].Text = _hod_vyk.ToString("N2");

        }
    }


    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
    }

    protected void DetailsView1_DataBound(object sender, EventArgs e)
    {
        Label lab = (Label)WebControlHelper.FindControl(this, "LabelRozdilDnu");
        Label lab2 = (Label)WebControlHelper.FindControl(this, "LabelRozdilHodin");

        Label lab3 = (Label)WebControlHelper.FindControl(this, "LabelFondDnu");
        Label lab4 = (Label)WebControlHelper.FindControl(this, "LabelFondHodin");

        decimal fond_dny = 0;
        decimal fond_hod = 0;
        if (lab3 != null)
            if (!string.IsNullOrEmpty(lab3.Text))
                fond_dny = Convert.ToDecimal(lab3.Text);

        if (lab4 != null)
            if (!string.IsNullOrEmpty(lab4.Text))
                fond_hod = Convert.ToDecimal(lab4.Text);

        //decimal rozdil_hod=(fond_hod - _hod_vyk);
        //decimal rozdil_dny=(fond_dny - _dny_vyk);
        //PH 12.6.2013
        if (fond_hod != 0)
        {
            decimal rozdil_hod = (_hod_vyk - fond_hod);
            decimal rozdil_dny = (_dny_vyk - fond_dny);

            if (rozdil_hod == 0) //PH 9.5.2019 HID:9.5.2019
                rozdil_dny = 0;

            lab.Text = rozdil_dny.ToString("N1");
            lab2.Text = rozdil_hod.ToString("N2");
            if (rozdil_hod != 0)
            {
                lab2.Font.Bold = true;
                lab2.BackColor = Color.Red;
            }           

            if (rozdil_dny != 0)
            {
                lab.Font.Bold = true;
                lab.BackColor = Color.Red;
            }
        }

        DetailsView1.Fields[5].Visible = ShowPracListRow;//PH 17.7.2013
    }

    protected void img_1praclist_Command(object sender, CommandEventArgs e)
    {
        string lsComm = e.CommandArgument.ToString();
        string[] lasArr = lsComm.Split(new char[] { '|' });
        //decimal ldcOsCislo = Convert.ToDecimal(lasArr[0]);
        //DateTime ldtObdobi = Convert.ToDateTime(lasArr[1]);
        //PH 2.3.2016
        decimal ldcOsCislo = Convert.ToDecimal(lasArr[0]);
        short cislo_pom = Convert.ToInt16(lasArr[1]);
        DateTime ldtObdobi = Convert.ToDateTime(lasArr[2]);
        PracList list = null;
        if (cislo_pom > -1)
            list = new PracList(ldcOsCislo, cislo_pom, ldtObdobi);
        else
            list = new PracList(ldcOsCislo, ldtObdobi);
        PracListCollection prListy = new PracListCollection();
        prListy.AddItem(list);
        TiskParam tisk = new TiskParam(this.Page, "Pracovní list");
        tisk.Print(prListy, false);
    }

    protected void DetailsView1_ItemCreated(object sender, EventArgs e)
    {
        if (DetailsView1.DataItem != null)
        {
            ImageButton but = (ImageButton)WebControlHelper.FindControl(DetailsView1, "img_1praclist");
            DateTime ldtObdobi = (DateTime)DataBinder.Eval(DetailsView1.DataItem, "obdobi");
            Decimal ldcOsCislo = (decimal)DataBinder.Eval(DetailsView1.DataItem, "os_cislo");
            object o = DataBinder.Eval(DetailsView1.DataItem, "cislo_pom");
            short cislo_pom = -1;
            if (o != null)
                if (o != DBNull.Value)
                    cislo_pom = (short)o;
            but.CommandArgument = ldcOsCislo.ToString() + "|" + cislo_pom.ToString() + "|" + ldtObdobi.ToString();

            ImageButton but2 = (ImageButton)WebControlHelper.FindControl(DetailsView1, "img_mes_sumace");
            but2.CommandArgument = but.CommandArgument;
        }
    }

    /// <summary>
    /// Skryje nebo zobrazí řádek se zobrazením pracovního listu
    /// </summary>
    public static bool ShowPracListRow
    {
        get
        {
            return (!Zakaznik.IsCurrent("EUNET"));
        }
    }

    public override void ZmenaStavu_ServerValidate(CustomValidator validator, ServerValidateEventArgs e)
    {
        //PR 14.3.2017 tato funkce přesunuta z PozadavekDetail.ascx.cs->cv_dochazka_validate

        //tohle se může provádět jen pro typ docházka
        workfl_hl hl1 = new workfl_hl();
        Str_workfl_hl st = hl1.NaplnStrukturu(PozId);
        if (st.typ != "dochazka")
        {
            e.IsValid = true;
            return;
        }
        if (e.Value == "potvrzeny")
        {
            if (Parametry.ParametrCti("PotvrzFondOK").ToLower().Trim() == "a")
            {
                decimal prac = 0, svat = 0, prhod = 0, svhod = 0, celkemHod = 0, celkemDny = 0;
                //int id_poz = Convert.ToInt32(((DetailsView)this.FindControlRecursive("DetailsViewZmenaStavu")).SelectedValue);
                //PH 15.6.2016 předchozí řádek přestal fungovat, tak zjišťuju id jinak
                workfl_hl whl = new workfl_hl();
                workfl_body wbody = new workfl_body();
                Str_workfl_hl hl = whl.NaplnStrukturu(PozId);
                Str_workfl_body body = wbody.NaplnStrukturu(PozId);
                DSFond f = new DSFond();
                //Prac_pom pr = new Prac_pom();
                //short cislo_pom = Prac_pom.Platny_Pomer(hl.os_cislo, body.datum);
                //f.Retrieve(hl.os_cislo, cislo_pom, body.obdobi, ref prac, ref svat, ref prhod, ref svhod, ref celkemHod, ref celkemDny);
                //PH 15.6.2016
                short cislo_pom = -1;
                if (hl.cislo_pom != null)
                    cislo_pom = (short)hl.cislo_pom;
                else
                    cislo_pom = Prac_pom.Platny_Pomer(hl.os_cislo, body.datum);

                f.Retrieve(hl.os_cislo, cislo_pom, body.obdobi, ref prac, ref svat, ref prhod, ref svhod, ref celkemHod, ref celkemDny);
                SesumujMesic ss = new SesumujMesic();

                decimal ss_hod = 0;
                decimal ss_dny = 0;
                ss.Retrieve(hl.os_cislo, body.obdobi, ref ss_hod, ref ss_dny);
                e.IsValid = (ss_hod == celkemHod);
                if (!e.IsValid)
                    validator.Text = "[%Nesouhlasí plánovaný fond s vykázaným%]";
                return;
            }
        }
        e.IsValid = true;
    }

    /// <summary>
    /// Vrací true pokud jsou všechny požadavky na absence schváleny jinak false
    /// </summary>
    [WFProperty]
    public bool AbsenceSchvaleny
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.AbsenceSchvaleny;
        }
    }

    /// <summary>
    /// Vrací true pokud je vyplněna poznámka v rozdělení přesčasů
    /// </summary>
    [WFProperty]
    public bool RozdPrescPoznamka
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.RozdPrescPoznamka;
        }
    }

    /// <summary>
    /// Vrací true pokud byly rozděleny přesčasy, alespoň 0 hodin
    /// </summary>
    [WFProperty]
    public bool RozdelenePrescasy
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.RozdelenePrescasy;
        }
    }

    /// <summary>
    /// Ověřuje zda se plánovaný fond rovná vykázaným dobám
    /// </summary>
    [WFProperty]
    public bool PotvrzFondOK
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.PotvrzFondOK;
        }
    }

    /// <summary>
    /// Ověřuje se zda je plánovaný fond menší nebo roven vykázané době
    /// </summary>
    [WFProperty]
    public bool VykazanoSPrescVetsiNeboRovnoFondu
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.VykazanoSPrescVetsiNeboRovnoFondu;
        }
    }

    /// <summary>
    /// atribut který nabude true, pokud bude chyba v docházce, napři. chyba párování příchod->odchod
    /// </summary>
    [WFProperty]
    public bool PruchodyOK
    {
        get
        {
            Pozadavekdochazka poz = new Pozadavekdochazka(PozId);
            return poz.PruchodyOK;
        }
    }

    protected void img_mes_sumace_Command(object sender, CommandEventArgs e)
    {
        string lsComm = e.CommandArgument.ToString();
        string[] lasArr = lsComm.Split(new char[] { '|' });       
        decimal ldcOsCislo = Convert.ToDecimal(lasArr[0]);
        short cislo_pom = Convert.ToInt16(lasArr[1]);
        DateTime ldtObdobi = Convert.ToDateTime(lasArr[2]);

        NameValueCollection args = new NameValueCollection();        
        args.Add("oc", ldcOsCislo.ToString());
        args.Add("cp", cislo_pom.ToString());
        args.Add("obdobi", ldtObdobi.ToString("yyyyMM"));
        KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();
        //PR 29.1.2015 mohlo dojít ke zdvojení ?encq - opraveno
        string url = "~/Dochazka/d3.aspx";
        url = qsc.AddEncryptQuery(url, args);
        HttpContext.Current.Response.Redirect(url);

        /*
          NameValueCollection args = new NameValueCollection();
                if (PozId>0) args.Add("idpoz", PozId.ToString());
                args.Add("getDokl", idblobu.ToString());
                args.Add("DoklName", HttpContext.Current.Server.UrlEncode((string)DoklName));
                KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();
                //PR 29.1.2015 mohlo dojít ke zdvojení ?encq - opraveno
                string url = HttpContext.Current.Request.Url.GetLeftPart(UriPartial.Path);
                url = qsc.AddEncryptQuery(url, args);
                return url;
         * */
    }
}
