﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;

namespace KSPortal.Controls
{
    public partial class ZadostOdokument : UserControlPozadavek
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }


        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "dokument", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            //string pomer_visible = wf.Get_UN("", "VyberPomeru", "Visible");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Insert);
                //if (pomer_visible == "true")
                //    ds_pomery.SelectParameters["os_cislo"].DefaultValue = PozadavekZpracovaniAbstract.VydavatelProNovyPoz().ToString();

            }
            else if (val == "edit")
                FormView1.ChangeMode(FormViewMode.Edit);
            else
                FormView1.ChangeMode(FormViewMode.ReadOnly);


            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            //TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
            //if (r != null)
            //    r.Visible = (pomer_visible == "true");

            
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            FormView1.InsertItem(false);//ObjectDataSource1.Insert();
                        else
                            FormView1.UpdateItem(false);//ObjectDataSource1.Update();

                    }
                }
            }
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());

        }

        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {            
            RadDropDownList list = (RadDropDownList)WebControlHelper.FindControl(this, "ddl_pomery");
            if (string.IsNullOrEmpty(list.SelectedValue))
                e.InputParameters["koho_cislo_pom"] = null; //PR 30.11.2017 null místo empty string, který nejde convertovat na int16
            else
                e.InputParameters["koho_cislo_pom"] = list.SelectedValue;
        }
        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }

        protected void cv_platne_os_cislo_validate(object sender, ServerValidateEventArgs e)
        {
            if (string.IsNullOrEmpty(e.Value))
            {
                e.IsValid = true;
                return;
            }

            decimal ldc_os_cislo;
            if (!decimal.TryParse(e.Value, out ldc_os_cislo))
            {
                e.IsValid = false;
                return;
            }

            e.IsValid = Pracovnici.PlatneOsCislo(ldc_os_cislo, DateTime.Now);
        }

        protected void TRCB_Jmeno_TextChanged(object sender, EventArgs e)
        {
            TRadComboBox box = (TRadComboBox)sender;            
            RadTextBox text_osc = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxOsCislo");
            if (box.Text == "")
                text_osc.Text = "";
            else
            {
                string[] arr = box.Text.Split(new char[1] { ',' });
                if (arr.Length == 2)
                {
                    decimal os_cislo = Pracovnici.NajdiOsCislo(arr[0], arr[1]);
                    if (os_cislo > 0)
                    {
                        text_osc.Text = os_cislo.ToString();
                    }
                }
            }
        }
        protected void TextBoxOsCislo_TextChanged(object sender, EventArgs e)
        {            
            RadTextBox box = (RadTextBox)sender;
            decimal os_cislo = 0;
            if (!Decimal.TryParse(box.Text, out os_cislo)) return;

            TRadComboBox c = (TRadComboBox)WebControlHelper.FindControl(this, "TRCB_Jmeno");
            if (c != null)
            {
                c.Text = Pracovnik.PrijmeniJmeno(os_cislo, ",");
            }
        }

        /// <summary>
        /// Id druhu dokumentu
        /// </summary>
        [WFProperty]
        public string DruhDokId
        {
            get
            {
                string lsDruh = "";
                if (FormView1.CurrentMode == FormViewMode.ReadOnly)
                    lsDruh = SqlPrikaz.ExecuteScalarString("select popis2 from workfl_body where id_poz=" + PozId + " and (archiv is null or archiv<>'a')", "").Trim();                
                else
                    lsDruh = ((RadDropDownList)WebControlHelper.FindControl(this, "ddl_druh_dok")).SelectedValue.Trim();
                return lsDruh;
            }
        }
    }
}