﻿using KSProgram;
using System.Linq;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.Prava;
using KSProgram.WebControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using static KSProgram.Pozadavky.Pozadavekodmenysl;
using Telerik.Web.Design;
using ImageButton = System.Web.UI.WebControls.ImageButton;
using System.Web.Services;
using System.Data;
using KSProgram.Odmenysl;
using System.Globalization;

namespace KSPortal.Controls
{
    public partial class ZadostOodmenysl : UserControlPozadavek
    {

        bool _nacitani = false;
        private int pocet_datovych_sloupcu
        {
            get
            {
                return (ViewState["pocet_datovych_sloupcu"] == null ? 0 : Convert.ToInt32(ViewState["pocet_datovych_sloupcu"]));
            }
            set
            {
                ViewState["pocet_datovych_sloupcu"] = value;
            }
        }

        private int pocet_poznamka_sloupcu
        {
            get
            {
                return (ViewState["pocet_poznamka_sloupcu"] == null ? 0 : Convert.ToInt32(ViewState["pocet_poznamka_sloupcu"]));
            }
            set
            {
                ViewState["pocet_poznamka_sloupcu"] = value;
            }
        }

        private int pocet_kod_info_sloupcu
        {
            get
            {
                return (ViewState["pocet_kod_info_sloupcu"] == null ? 0 : Convert.ToInt32(ViewState["pocet_kod_info_sloupcu"]));
            }
            set
            {
                ViewState["pocet_kod_info_sloupcu"] = value;
            }
        }


        private int pocet_budget_sloupcu
        {
            get
            {
                return (ViewState["pocet_budget_sloupcu"] == null ? 0 : Convert.ToInt32(ViewState["pocet_budget_sloupcu"]));
            }
            set
            {
                ViewState["pocet_budget_sloupcu"] = value;
            }
        }

        private int extra_sloupce_sirka
        {
            get
            {
                return (ViewState["extra_sloupce_sirka"] == null ? 0 : Convert.ToInt32(ViewState["extra_sloupce_sirka"]));
            }
            set
            {
                ViewState["extra_sloupce_sirka"] = value;
            }
        }

        private bool vlozeni_zamestnance
        {
            get
            {
                return (ViewState["vlozeni_zamestnance"] == null ? false : Convert.ToBoolean(ViewState["vlozeni_zamestnance"]));
            }
            set
            {
                ViewState["vlozeni_zamestnance"] = value;
            }
        }

        private DateTime Obdobi
        {
            get
            {
                return (ViewState["obdobi"] == null ? new DateTime() : Convert.ToDateTime(ViewState["obdobi"]));
            }
            set
            {
                ViewState["obdobi"] = value;
            }
        }

        private bool PoznamkaVPrehledu
        {
            get
            {
                return (ViewState["PoznamkaVPrehledu"] == null ? false : Convert.ToBoolean(ViewState["PoznamkaVPrehledu"]));
            }
            set
            {
                ViewState["PoznamkaVPrehledu"] = value;
            }
        }

        public override void Nacist()
        {
            _nacitani = true;
            base.Nacist();

            string script = string.Empty;
            string val_zakaz_editace = string.Empty;

            bool zamceno = ZamykaniAgend.Zamceno(Agenda.Portál__Požadavky_na_odměny);

            WorkflowMaster wf = new WorkflowMaster(PozId, Typ, null);
            string val = wf.Get_UN("", "Form1", "Mode");

            if (val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Insert);
                val_zakaz_editace = "false";
            }
            else if (val == "edit")
            {
                FormView1.ChangeMode(FormViewMode.Edit);
                val_zakaz_editace = "false";
            }
            else
            {
                FormView1.ChangeMode(FormViewMode.ReadOnly);
                val_zakaz_editace = "true";
            }

            string val2 = wf.Get_UN("", "Form1", "Vložení zaměstnance");
            vlozeni_zamestnance = (val2 == "true");

            if (zamceno)
            {
                val_zakaz_editace = "true";
            }

            PoznamkaVPrehledu = (wf.Get_UN("", "Poznámka v přehledu", "Visible") == "true");

            _nacist_Obdobi();
           
            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId);
            odmenyslref.ZakazEditaceSet(val_zakaz_editace == "true");
            if (val_zakaz_editace == "true")
                cv_val_zakazy.Enabled = false;
           
            string dny = WebControlHelper.ZmenaTextu("[%Dny%]");
            string hodiny = WebControlHelper.ZmenaTextu("[%Hodiny%]");
            string sazba = WebControlHelper.ZmenaTextu("[%Sazba%]");
            string castka = WebControlHelper.ZmenaTextu("[%Částka%]");

            bool budgety = false;
            _generateColumns(RadGrid1, ref budgety);

            ObjectDataSource1.SelectParameters[0].DefaultValue = PozId.ToString();
            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();
            RadGrid1.Rebind();

            if (PozId == 0)
            {
                Label lab = (Label)WebControlHelper.FindControlRecursive(FormView1, "label_os_cislo", typeof(Label));
                if (lab != null)
                    lab.Text = KSProgram.Funkce.Pracovnik.CeleJmeno(Pozadavekodmenysl.VydavatelProNovyPoz());

                lab = (Label)WebControlHelper.FindControlRecursive(FormView1, "label_typ_popisek", typeof(Label));
                if (lab != null)
                    lab.Text = odmenyslref.GetPopisek(true);

                lab = (Label)WebControlHelper.FindControlRecursive(FormView1, "label_obdobi", typeof(Label));
                if (lab != null)
                    lab.Text = Obdobi.ToString("MM-yyyy");


            }
            if (zamceno)
            {
                lab_zamek_info.Visible = true;
                lab_zamek_info.Text = WebControlHelper.ZmenaTextu("[%Agenda je zamčena, nelze pokračovat%]");
            }
            else
            {
                lab_zamek_info.Visible = false;
                lab_zamek_info.Text = "";
            }

            RadWindow rw = (RadWindow)WebControlHelper.FindControlRecursive(this, "rw_sestava_odmeny", typeof(RadWindow));
            //rw.NavigateUrl = Pozadavek.UrlBase() + "/sestavy/WfOdmenysc.aspx";
            //PH 29.6.2020 HID:51506
            rw.NavigateUrl = "~/sestavy/WfOdmenysc.aspx";

            rw = (RadWindow)WebControlHelper.FindControlRecursive(this, "rw_odmeny_poznamka", typeof(RadWindow));
            //rw.NavigateUrl = Pozadavek.UrlBase() + "/Pozadavky/OdmenyPoznamka.aspx";
            //PH 29.6.2020 HID:51506
            rw.NavigateUrl = "~/Pozadavky/OdmenyPoznamka.aspx";

            OdmenyslCache cache = OdmenyslCache.GetCache();

            //Unit sirka = pocet_vygener_sloupcu * 75 + 400 + 50 + 175 + (PoznamkaVPrehledu ? pocet_vygener_sloupcu * 90 : 0)+(cache.Kody.Count() * 10);
            //PH 13.10.2022
            Unit sirka = SirkySloupcu.os_cislo + SirkySloupcu.cislo_pom + SirkySloupcu.jmeno + SirkySloupcu.stred +
                (pocet_datovych_sloupcu * SirkySloupcu.datovy_sloupec) +
                (PoznamkaVPrehledu ? pocet_poznamka_sloupcu * SirkySloupcu.poznamka_text : pocet_poznamka_sloupcu * SirkySloupcu.poznamka_ikona) /*sloupce s poznámkou buď text a nebo jen ikona*/ +
                (pocet_kod_info_sloupcu * SirkySloupcu.poznamka_ikona) + extra_sloupce_sirka+
                ((pocet_datovych_sloupcu + pocet_poznamka_sloupcu + pocet_kod_info_sloupcu + 4/*pevné sloupce os. č., jmeno...*/ + Pozadavekodmenysl.ExtraPolozky.Count()) * 10)/*padding a margin*/;

            //if (sirka.Value < new Unit(800).Value) sirka = new Unit(800);
            RadGrid1.Width = sirka;

            RadGrid1.Height = 800;

            string budgety_zapni = string.Empty;
            if (budgety)
                budgety_zapni = "useBudgety=true;";

            script = $"zakazEditace={val_zakaz_editace};idPozadavku={PozId};castka_text='{castka}';dny_text='{dny}';hodiny_text='{hodiny}';sazba_text='{sazba}';typ='{Typ}';obdobi='" + Obdobi.ToString("MMyyyy") + "';" + budgety_zapni;
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "zakaz_editace", script, true);
        }

        private void _nacist_Obdobi()
        {
            if (PozId > 0)
            {
                workfl_body b = new workfl_body();
                Str_workfl_body str_body = b.NaplnStrukturu(PozId);
                Obdobi = str_body.obdobi;
            }
            else
                Obdobi = Globals.AktObdobi;
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            Page.PreRenderComplete += Page_PreRenderComplete;
            //Page.Init += Page_Init;

            if (!_nacitani) return;

            //bool rebind_needed = false;
            string req_target = Request["__EVENTTARGET"];
            string req_argument = Request["__EVENTARGUMENT"];

            if ((req_target != null) && (req_target.EndsWith("RCM_new_typy")))
            {
                SessionInfo.RemoveVariable(Pozadavekodmenysl.SessionConstanta + PozId);
                SessionInfo.RemoveVariable("sort_" + PozId);
                SessionInfo.RemoveVariable("filter_" + PozId);
                //rebind_needed = true;
                PozId = 0;
            }

            /*
            _generateColumns(RadGrid1);
            
            if ((FormView1.CurrentMode == FormViewMode.Edit) || (FormView1.CurrentMode == FormViewMode.Insert) || rebind_needed)
                RadGrid1.Rebind();
            */

            /*
            RadGrid1.MasterTableView.Width = pocet_vygener_sloupcu * 75 + 400 + 50;
            if (RadGrid1.MasterTableView.Width.Value < new Unit(700).Value) RadGrid1.MasterTableView.Width = new Unit(700);
            RadGrid1.Width = new Unit(RadGrid1.MasterTableView.Width.Value + new Unit(20).Value);

            if (RadGrid1.Width.Value > new Unit(1500).Value) RadGrid1.Width = 1500; 
            */
            //PH 2.4.2019
            /* přemístěno do Nacist
             Unit sirka = pocet_vygener_sloupcu * 75 + 400 + 50 + 175;
            
            Unit sirka = pocet_vygener_sloupcu * 75 + 400 + 50 + 175 + (PoznamkaVPrehledu ? pocet_vygener_sloupcu * 90 : 0);
            if (sirka.Value < new Unit(800).Value) sirka = new Unit(800);
            RadGrid1.Width = sirka; // new Unit(RadGrid1.MasterTableView.Width.Value + new Unit(20).Value);
            if (sirka.Value > 1500) RadGrid1.Width = 1500;

            RadGrid1.Height = 800;
            */
        }       

        public bool _add_new_Visible()
        {
            return Convert.ToBoolean(ViewState["vlozeni_zamestnance"]);
        }

        private void _generateColumns(TRadGrid grid, ref bool budgety)
        {
            OdmenyslCache cache = OdmenyslCache.GetCache();

            pocet_datovych_sloupcu = 0;
            pocet_poznamka_sloupcu = 0;
            pocet_kod_info_sloupcu = 0;
            pocet_budget_sloupcu = 0;
            extra_sloupce_sirka = 0;

            //PH 8.11.2021 generuju extra položky pro zákazníka            
            for (int i = 0; i < Pozadavekodmenysl.ExtraPolozky.Count; i++)
            {
                OdmenySlExtraPolozka it = Pozadavekodmenysl.ExtraPolozky[i];
                _generateColumn(grid, it.CollName, it.Nazev, it.Typ, it.Sirka);
            }           

            List<StrPolozka> all_kody = new List<StrPolozka>();
            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId);
            odmenyslref.GetPovolPolozky(Obdobi, ref all_kody);          

            bool dny = false, hodiny = false, castka = false;
            budgety = false;
            foreach (StrPolozka p in all_kody.OrderBy(aa => aa.Kod))
            {
                if (p.Dny)
                {
                    _generateColumn(grid, p.Kod, p.CelyNazev, "dny", "Dny");
                    dny = true;
                }

                if (p.Hodiny)
                {
                    _generateColumn(grid, p.Kod, p.CelyNazev, "hodiny", "Hodiny");
                    hodiny = true;
                }

                if (p.Sazba)
                {
                    _generateColumn(grid, p.Kod, p.CelyNazev, "sazba", "Sazba");
                    //sazba = true;
                }

                if (p.Castka)
                {
                    //vygeneruju sloupec pro budget                  
                    if (p.Budget)
                    {                        
                        _generateColumnBudgetId(grid, p.Kod, p.CelyNazev, "budget", "");
                        _generateColumn(grid, p.Kod, "", "budget_count", "");
                        budgety = true;
                    }

                    _generateColumn(grid, p.Kod, p.CelyNazev, "castka", "Částka");
                    castka = true;
                }              

                _generateColumnPozn(grid, p.Kod, p.CelyNazev, "pozn", "");

                if (cache.Kody.Exists(aa => aa.Kod == p.Kod))
                {
                    _generateColumnKodInfo(grid, p.Kod, p.CelyNazev, "info_text" /*, "~/Images/info.png"*/);
                }

            }

            if (dny)
                _generateColumn(grid, -1, "Celkem", "dny", "Dny");
            if (hodiny)
                _generateColumn(grid, -1, "Celkem", "hodiny", "Hodiny");           
            if (castka)
                _generateColumn(grid, -1, "Celkem", "castka", "Částka");

        }

        private void _generateColumnBudgetId(TRadGrid grid, short kod, string celyNazev, string co, string hlavicka)
        {
            string uniqueName = kod.ToString() + "_" + co;
            if (grid.MasterTableView.Columns.FindByUniqueNameSafe(uniqueName) == null)
            {
                pocet_budget_sloupcu++;
               
                GridBoundColumn coll = new GridBoundColumn();              

                grid.MasterTableView.Columns.Add(coll);
                coll.HeaderText = "[%Budget%]";
                coll.UniqueName = uniqueName;
                coll.ItemStyle.Width = SirkySloupcu.budget_id;
                coll.HeaderStyle.Width = SirkySloupcu.budget_id;
                coll.ItemStyle.HorizontalAlign = HorizontalAlign.Left;
                coll.HeaderStyle.HorizontalAlign = HorizontalAlign.Left;
                coll.DataField = uniqueName;
                coll.ColumnGroupName = kod.ToString();
                coll.DataType = typeof(int);
                coll.ReadOnly = true;
                coll.EnableHeaderContextMenu = false;

                //coll.ReadOnly = true;
                coll.DataField = coll.UniqueName;
                coll.AllowFiltering = false;                

                if (grid.MasterTableView.ColumnGroups.FindGroupByName(kod.ToString()) == null)
                {
                    GridColumnGroup col_gr = new GridColumnGroup();
                    grid.MasterTableView.ColumnGroups.Add(col_gr);
                    col_gr.Name = kod.ToString();
                    col_gr.HeaderText = celyNazev;
                    col_gr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                }

                List<string> dk_names = grid.MasterTableView.ClientDataKeyNames.ToList();
                dk_names.AddRange(new string[2] { kod.ToString() + "_budget_count", kod.ToString() + "_budgety_all" });
                grid.MasterTableView.ClientDataKeyNames = dk_names.ToArray();
            }
        }

        private void _generateColumn(TRadGrid grid, string coll_name, string hlavicka, Type typ, int sirka)
        {
            if (grid.MasterTableView.Columns.FindByDataFieldSafe(coll_name) != null)
                return;

            extra_sloupce_sirka += sirka;

             GridBoundColumn boundColumn = new GridBoundColumn();
            grid.MasterTableView.Columns.Add(boundColumn);
            boundColumn.DataField = coll_name;
            boundColumn.HeaderText = "[%" + hlavicka + "%]";
            if (typ == typeof(decimal))
                boundColumn.DataFormatString = "{0:F2}";
            boundColumn.UniqueName = coll_name;
            boundColumn.ItemStyle.Width = sirka;
            boundColumn.HeaderStyle.Width = sirka;
            boundColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
            boundColumn.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            boundColumn.DataType = typ;
            boundColumn.FooterText = "";
            boundColumn.AllowFiltering = true;
            boundColumn.EnableHeaderContextMenu = false;
        }

        private void _generateColumn(TRadGrid grid, int kod, string cely_nazev, string co, string hlavicka)
        {
            if (grid.MasterTableView.Columns.FindByDataFieldSafe(kod.ToString() + "_" + co) == null)
            {
                pocet_datovych_sloupcu++;
                GridNumericColumn boundColumn = new GridNumericColumn();
                if (co == "dny")
                {
                    boundColumn.DataFormatString = "{0:F1}";
                    boundColumn.MaxLength = 3;
                    boundColumn.MaxValue = 99;
                }
                else if (co == "castka")
                {
                    /*
                    if (Globals.KodMeny == "CZK")
                        boundColumn.DataFormatString = "{0:###,##0}";
                    else
                        boundColumn.DataFormatString = "{0:###,##0.00}";   
                    */
                    //PH 16.12.2022
                    boundColumn.DataFormatString = "{0:" + Globals.CastkaFormat + "}";

                    // boundColumn.MaxValue = 9000000;
                    boundColumn.MaxLength = 16;
                }
                else if (co == "hodiny")
                {
                    boundColumn.DataFormatString = "{0:F2}";
                    boundColumn.MaxLength = 5;
                    boundColumn.MaxValue = 999;
                }


                grid.MasterTableView.Columns.Add(boundColumn);

                boundColumn.DataField = kod.ToString() + "_" + co;
                boundColumn.HeaderText = "[%" + hlavicka + "%]";

                boundColumn.UniqueName = kod.ToString() + "_" + co;
                if (co == "budget_count")
                {
                    boundColumn.ItemStyle.Width = SirkySloupcu.pocet;
                    boundColumn.HeaderStyle.Width = SirkySloupcu.pocet;                   
                }
                else
                {
                    boundColumn.ItemStyle.Width = SirkySloupcu.datovy_sloupec;
                    boundColumn.HeaderStyle.Width = SirkySloupcu.datovy_sloupec;
                }
                //boundColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                //PH 17.5.2022 zarovnám doprava je to hezčí
                boundColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Right;
                boundColumn.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                boundColumn.ColumnGroupName = kod.ToString();
                if (co == "budget_count")
                {
                    boundColumn.DataType = typeof(int);
                    boundColumn.ReadOnly = true;
                }
                else
                {
                    boundColumn.DataType = typeof(decimal);
                    boundColumn.Aggregate = GridAggregateFunction.Sum;
                    boundColumn.FooterAggregateFormatString = boundColumn.DataFormatString;
                }
                boundColumn.FooterText = "";
                boundColumn.AllowFiltering = false;
                boundColumn.EnableHeaderContextMenu = (kod > 0 && co!= "budget_count");
                
                if (grid.MasterTableView.ColumnGroups.FindGroupByName(kod.ToString()) == null)
                {
                    GridColumnGroup col_gr = new GridColumnGroup();
                    grid.MasterTableView.ColumnGroups.Add(col_gr);
                    col_gr.Name = kod.ToString();
                    col_gr.HeaderText = cely_nazev;
                    col_gr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                }                
            }
        }

        private void _generateColumnPozn(TRadGrid grid, int kod, string cely_nazev, string co, string hlavicka)
        {
            string uniqueName = kod.ToString() + "_" + co;
            if (grid.MasterTableView.Columns.FindByUniqueNameSafe(uniqueName) == null)
            {
                pocet_poznamka_sloupcu++;

                if (PoznamkaVPrehledu)
                {
                    GridBoundColumn coll = new GridBoundColumn();
                    grid.MasterTableView.Columns.Add(coll);
                    coll.HeaderText = "[%Poznámka%]";
                    coll.UniqueName = uniqueName;
                    coll.ItemStyle.Width = SirkySloupcu.poznamka_text;
                    coll.HeaderStyle.Width = SirkySloupcu.poznamka_text;
                    coll.ItemStyle.HorizontalAlign = HorizontalAlign.Left;
                    coll.HeaderStyle.HorizontalAlign = HorizontalAlign.Left;
                    coll.ColumnGroupName = kod.ToString();
                    coll.DataType = typeof(string);
                    coll.ReadOnly = true;
                    coll.DataField = coll.UniqueName;
                    coll.AllowFiltering = false;

                    coll.FooterText = "";
                    coll.EnableHeaderContextMenu = false;
                    coll.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                }
                else
                {
                    GridButtonColumn buttonColumn = new GridButtonColumn();

                    grid.MasterTableView.Columns.Add(buttonColumn);

                    buttonColumn.ButtonCssClass = "pznColl";

                    buttonColumn.HeaderText = "";
                    buttonColumn.UniqueName = uniqueName;
                    buttonColumn.ItemStyle.Width = SirkySloupcu.poznamka_ikona;
                    buttonColumn.HeaderStyle.Width = SirkySloupcu.poznamka_ikona;
                    buttonColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                    buttonColumn.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    buttonColumn.ColumnGroupName = kod.ToString();
                    buttonColumn.DataType = typeof(string);
                    buttonColumn.FooterText = "";
                    buttonColumn.EnableHeaderContextMenu = false;
                    buttonColumn.ButtonType = GridButtonColumnType.ImageButton;
                    buttonColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                    buttonColumn.ImageUrl = "~/Images/info.png";

                    buttonColumn.HeaderText = "";
                }
                
                if (grid.MasterTableView.ColumnGroups.FindGroupByName(kod.ToString()) == null)
                {
                    GridColumnGroup col_gr = new GridColumnGroup();
                    grid.MasterTableView.ColumnGroups.Add(col_gr);
                    col_gr.Name = kod.ToString();
                    col_gr.HeaderText = cely_nazev;
                    col_gr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                }
                
            }


        }

        private void _generateColumnKodInfo(TRadGrid grid, int kod, string cely_nazev, string co/*, string image_url*/)
        {
            string uniqueName = kod.ToString() + "_" + co;
            if (grid.MasterTableView.Columns.FindByUniqueNameSafe(uniqueName) == null)
            {
                pocet_kod_info_sloupcu++;

                GridButtonColumn buttonColumn = new GridButtonColumn();
                grid.MasterTableView.Columns.Add(buttonColumn);

                buttonColumn.ButtonCssClass = "pznColl";

                buttonColumn.HeaderText = "";
                buttonColumn.UniqueName = uniqueName;
                buttonColumn.ItemStyle.Width = SirkySloupcu.poznamka_ikona;
                buttonColumn.HeaderStyle.Width = SirkySloupcu.poznamka_ikona;
                buttonColumn.HeaderStyle.CssClass = "pznCollHeader";
                buttonColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;
                buttonColumn.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                buttonColumn.ColumnGroupName = kod.ToString();
                buttonColumn.DataType = typeof(string);
                buttonColumn.FooterText = "";
                buttonColumn.EnableHeaderContextMenu = false;
                buttonColumn.ButtonType = GridButtonColumnType.ImageButton;
                buttonColumn.ItemStyle.HorizontalAlign = HorizontalAlign.Center;

                buttonColumn.HeaderText = "";
                
                if (grid.MasterTableView.ColumnGroups.FindGroupByName(kod.ToString()) == null)
                {
                    GridColumnGroup col_gr = new GridColumnGroup();
                    grid.MasterTableView.ColumnGroups.Add(col_gr);
                    col_gr.Name = kod.ToString();
                    col_gr.HeaderText = cely_nazev;
                    col_gr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                }                
            }
        }

        protected void RadGrid1_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            List<Str_porizovak> lst_poriz;
            object o = SessionInfo.GetVariable(Pozadavekodmenysl.SessionConstanta + PozId);
            if (o == null)
                lst_poriz = new List<Str_porizovak>();
            else
                lst_poriz = (List<Str_porizovak>)o;


            foreach (Telerik.Web.UI.GridBatchEditingCommand command in e.Commands)
                if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Update)
                {
                    decimal os_cislo = Convert.ToDecimal(RadGrid1.MasterTableView.DataKeyValues[command.Item.DataSetIndex]["os_cislo"]);
                    short cislo_pom = Convert.ToInt16(RadGrid1.MasterTableView.DataKeyValues[command.Item.DataSetIndex]["cislo_pom"]);
                    string prac_str = Prac_pom.Get_prac_str(os_cislo, cislo_pom);
                    Str_porizovak poriz = new Str_porizovak();
                    poriz.Os_cislo = os_cislo;
                    poriz.Cislo_pom = cislo_pom;
                    poriz.Items = new List<Str_porizovak_polozky>();

                    lst_poriz.Add(poriz);

                    List<Str_porizovak_polozky> lst_zmeny = poriz.Items;

                    Hashtable oldValues = command.OldValues;
                    Hashtable newValues = command.NewValues;

                    foreach (DictionaryEntry en in newValues)
                    {
                        if (en.Value == null) continue;
                        string key = en.Key.ToString();

                        string val = en.Value.ToString();
                        if ((key.Contains("dny")) || (key.Contains("hodiny")) || (key.Contains("sazba")) || (key.Contains("castka")))
                        {
                            string[] las_arr = key.Split('_');
                            _vlozit(ref lst_zmeny, prac_str, las_arr[0], las_arr[1], val);
                        }
                    }
                }

            SessionInfo.SetVariable(Pozadavekodmenysl.SessionConstanta + PozId, lst_poriz);
        }

        private void _vlozit(ref List<Str_porizovak_polozky> astr, string prac_str, string kod, string co, string hodnota)
        {
            if (string.IsNullOrEmpty(hodnota)) return;
            decimal val;
            if (!decimal.TryParse(hodnota, out val))
                return;

            Str_porizovak_polozky it = new Str_porizovak_polozky();

            if (co == "dny")
                it.Dny = val;
            else if (co == "hodiny")
                it.Hodiny = val;
            else if (co == "sazba")
                it.Sazba = val;
            else if (co == "castka")
                it.Castka = val;

            it.Prac_str = prac_str;

            it.Kod = Convert.ToInt32(kod);
            astr.Add(it);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            string duvod = string.Empty;
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;

                // Slouží pro analýzu který validátor ve stránce blokuje uložení
                //System.Web.UI.ValidatorCollection validators = this.Page.Validators;
                //int count = validators.Count;
                //for (int i = 0; i < count; i++)
                //{
                //    if (!validators[i].IsValid)
                //    {
                //        string va = ((System.Web.UI.Control)validators[i]).ClientID;
                //    }
                //}

                if (is_valid)
                {

                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                        {

                            RadTextBox text_box = ((RadTextBox)WebControlHelper.FindControl(this, "LabelDuvod"));
                            duvod = text_box.Text;

                            DateTime? dat_poz_vyrizeni = null;
                            TRadDatePicker dt = ((TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert"));
                            if (dt != null)
                            {
                                dat_poz_vyrizeni = dt.SelectedDate;
                            }
                            int pozadavek = 0;
                            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId);
                            odmenyslref.Insert(ref pozadavek, dat_poz_vyrizeni, duvod);
                            PozId = pozadavek;
                        }
                        else
                        {
                            RadTextBox text_box = ((RadTextBox)WebControlHelper.FindControl(this, "LabelDuvodEdit"));
                            duvod = text_box.Text;

                            DateTime? dat_poz_vyrizeni = null;
                            TRadDatePicker dt = ((TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit"));
                            if (dt != null)
                            {
                                dat_poz_vyrizeni = dt.SelectedDate;
                            }
                            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId);
                            odmenyslref.Update(duvod, dat_poz_vyrizeni);
                        }
                    }

                }
            }
        }

        protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if ((PozId > 0) || (FormView1.CurrentMode == FormViewMode.Insert))
            {
                TRadComboBox box = WebControlHelper.FindControl(this, "rcb_editovani") as TRadComboBox;
                IPozadavekodmenysl odmenyslref = Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId) as IPozadavekodmenysl;
                RadGrid1.DataSource = odmenyslref.RetrieveData(box?.SelectedValue == "edit");
                SessionInfo.SetVariable("filter_" + PozId.ToString(), RadGrid1.MasterTableView.FilterExpression);
            }
        }

        public DataTable Retrieve(int id_pozadavku)
        {
            if (id_pozadavku > 0)
            {
                PozadavekTyp typ = Pozadavek.TypPodleIdPoz(id_pozadavku);
                IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(typ.ToString(), PozId);
                return odmenyslref.Retrieve(id_pozadavku);
            }
            else return new DataTable();
        }

        protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            int pozadavek = 0;
            //Pozadavekodmenysl.Insert(ref pozadavek, new DateTime(), "");
            //PH 27.9.2022
            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(Typ, PozId);
            odmenyslref.Insert(ref pozadavek, new DateTime(), "");
            PozId = pozadavek;
        }
        protected override void OnItemInserted(EventArgs e)
        {
            base.OnItemInserted(e);
            SessionInfo.RemoveVariable(Pozadavekodmenysl.SessionConstanta + PozId);
        }

        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;              

                object o = dataItem.GetDataKeyValue("povolene_sloupce");
                if (o != null)
                {
                    string ret = o.ToString();
                    string[] arr = ret.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries);
                    foreach (string s in arr)
                        dataItem[s].CssClass = "oznBorder";
                }

                foreach (GridColumn col in RadGrid1.MasterTableView.Columns)
                {
                    if (col.UniqueName.EndsWith("_pozn"))
                    {
                        if (dataItem[col.UniqueName].Controls.Count > 0)
                        {
                            dataItem[col.UniqueName].CssClass += "pznColl";
                            if (!PoznamkaVPrehledu)
                            {
                                ImageButton btn = (ImageButton)dataItem[col.UniqueName].Controls[0];
                                object o1 = DataBinder.Eval(e.Item.DataItem, col.UniqueName);
                                if (o1 != null && o1 != DBNull.Value)
                                {
                                    btn.ToolTip = o1.ToString();
                                    btn.Enabled = false;
                                }
                                else
                                    btn.Visible = false;
                            }
                        }
                    }
                    else if (col.UniqueName.EndsWith("_info_text"))
                    {
                        if (dataItem[col.UniqueName].Controls.Count > 0)
                        {
                            dataItem[col.UniqueName].CssClass += "pznColl";
                            ImageButton btn = (ImageButton)dataItem[col.UniqueName].Controls[0];
                            object o1 = DataBinder.Eval(e.Item.DataItem, col.UniqueName);
                            if (o1 != null && o1 != DBNull.Value)
                            {
                                btn.ToolTip = o1.ToString();
                                object o2 = DataBinder.Eval(e.Item.DataItem, col.UniqueName + "_url");
                                if (o2 != null && o2 != DBNull.Value)
                                {
                                    btn.ImageUrl = o2.ToString();
                                    btn.Enabled = false;
                                }
                            }
                            else
                                btn.Visible = false;
                        }
                    }
                    //počet budgetů u mzdové složky zobrazuju jen když je větší než 1
                    else if (col.UniqueName.Contains("budget_count"))
                    {
                        int pocet;
                        if (Int32.TryParse(dataItem[col.UniqueName].Text, out pocet))
                        {
                            if (pocet <= 1)
                                dataItem[col.UniqueName].Text = "";
                        }

                    }
                    else if (col.UniqueName.Contains("budget"))
                    {
                        dataItem[col.UniqueName].Attributes.Add("id", col.UniqueName + "_" + dataItem.ItemIndex);
                        dataItem[col.UniqueName].Attributes.Add("onclick", "CellClick('" + dataItem.ItemIndex + "','" + col.UniqueName + "');");
                    }
                    else if (col.UniqueName.Contains("castka"))
                    {
                        string text = dataItem[col.UniqueName].Text;
                        decimal p;
                        if (decimal.TryParse(text, out p))                        
                            dataItem[col.UniqueName].Text = string.Format("{0:"+Globals.CastkaFormat+"}", p); 
                    }
                }
            }
        }

        protected void FormView1_DataBinding(object sender, EventArgs e)
        {
            ObjectDataSource1.SelectParameters[0].DefaultValue = PozId.ToString();
        }

        protected void ObjectDataSource1_DataBinding(object sender, EventArgs e)
        {
            ObjectDataSource1.SelectParameters[0].DefaultValue = PozId.ToString();
        }

        private void Page_PreRenderComplete(object sender, EventArgs e)
        {
            gridFilterExpression.Value = RadGrid1.MasterTableView.FilterExpression;

            RadContextMenu menu = RadGrid1.HeaderContextMenu;
            menu.OnClientItemClicked = "onMenuClicked";
            menu.Items.Clear();
            RadMenuItem item = new RadMenuItem();
            item.Text = WebControlHelper.ZmenaTextu("[%Hromadné zadání%]");
            item.Attributes["Co"] = "hrom";
            item.PostBack = false;
            menu.Items.Add(item);

            item = new RadMenuItem();
            item.Text = WebControlHelper.ZmenaTextu("[%Zadání s poznámkou%]");
            item.Attributes["Co"] = "pozn";
            item.PostBack = false;
            menu.Items.Add(item);

            if (ZamykaniAgend.Zamceno(Agenda.Portál__Požadavky_na_odměny))
            {
                Panel panCommand = (Panel)WebControlHelper.FindControl(this.Page, "PanelCommand");
                if (panCommand != null)
                    panCommand.Visible = false;

                Control c = (Control)WebControlHelper.FindControl(this.Page, "UC_ZmenaStavu");
                if (c != null)
                    c.Visible = false;

                c = (Control)WebControlHelper.FindControl(this.Page, "img_save");
                if (c != null)
                    c.Visible = false;

            }
        }

        private void BuildColumnsMenu(IRadMenuItemContainer columnsParentItem, GridTableView tableView)
        {
            if (tableView.EnableHeaderContextMenu)
            {
                foreach (GridColumn gridColumn in tableView.RenderColumns)
                {
                    if (gridColumn is GridGroupSplitterColumn || gridColumn is GridExpandColumn || gridColumn is GridRowIndicatorColumn || !gridColumn.Visible)
                        continue;
                    PrepareItem(gridColumn, columnsParentItem);
                }
            }
        }
        private void PrepareItem(GridColumn column, IRadMenuItemContainer columnsParentItem)
        {
        }

        protected void RadComboBox_zam_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            RadGrid1.Rebind();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="castka"></param>
        /// <returns></returns>
        [WFProperty]
        public bool CastkaVetsiNez(decimal castka)
        {
            return _vyhodnotCastku(castka, ">");
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="castka"></param>
        /// <returns></returns>
        [WFProperty]
        public bool CastkaMensiNez(decimal castka)
        {
            return _vyhodnotCastku(castka, "<");
        }

        private bool _vyhodnotCastku(decimal castka, string oper)
        {
            List<Str_porizovak> lst_poriz;
            object o = SessionInfo.GetVariable(Pozadavekodmenysl.SessionConstanta + PozId);
            if (o != null)
            {
                lst_poriz = new List<Str_porizovak>();
                foreach (Str_porizovak p in lst_poriz)
                {
                    if (oper == "<")
                    {
                        if (p.Items.FindIndex(aa => aa.Castka < castka) > -1) return true;
                    }
                    else if (oper == ">")
                    {
                        if (p.Items.FindIndex(aa => aa.Castka > castka) > -1) return true;
                    }
                }
            }
            return false;
        }

        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem filteringItem = e.Item as GridFilteringItem;
                //set dimensions for the filter textbox  
                foreach (OdmenySlExtraPolozka it in Pozadavekodmenysl.ExtraPolozky)
                {
                    TextBox box = filteringItem[it.CollName].Controls[0] as TextBox;
                    box.Width = Unit.Pixel(it.Sirka - 35);
                }

                TextBox box2 = filteringItem["os_cislo"].Controls[0] as TextBox;
                box2.Width = Unit.Pixel(SirkySloupcu.os_cislo - 35);
            }            
        }  
        

        protected void RadGrid1_SortCommand(object sender, GridSortCommandEventArgs e)
        {
            if (e.CommandName == "Sort")
            {
                //do okna s poznámkami předávám jen ty sortovací výrazy, které mají odpovídající sloupce v 
                if (e.SortExpression == "os_cislo" || e.SortExpression == "cislo_pom" || e.SortExpression == "jmeno" || e.SortExpression == "prac_str")
                {
                    GridSortExpression sort = new GridSortExpression();
                    sort.FieldName = e.SortExpression;
                    sort.SortOrder = e.NewSortOrder;

                    SessionInfo.SetVariable("sort_" + PozId.ToString(), sort);
                }
            }
        }       
        static class SirkySloupcu
        {
            public static int os_cislo = 90;
            public static int cislo_pom = 20;
            public static int jmeno = 125;
            public static int stred = 125;
            public static int datovy_sloupec = 50;
            public static int poznamka_ikona = 19;
            public static int poznamka_text = 150;
            public static int budget_id = 160;
            public static int pocet = 20;
        }


        protected void RadGrid1_Load(object sender, EventArgs e)
        {
            GridColumn coll = RadGrid1.MasterTableView.GetColumn("os_cislo");
            if (coll!=null)
            {
                coll.ItemStyle.Width = SirkySloupcu.os_cislo;
                coll.HeaderStyle.Width = coll.ItemStyle.Width;
            }
            coll = RadGrid1.MasterTableView.GetColumn("cislo_pom");
            if (coll != null)
            {
                coll.ItemStyle.Width = SirkySloupcu.cislo_pom;
                coll.HeaderStyle.Width = coll.ItemStyle.Width;
            }
            coll = RadGrid1.MasterTableView.GetColumn("jmeno");
            if (coll != null)
            {
                coll.ItemStyle.Width = SirkySloupcu.jmeno;
                coll.HeaderStyle.Width = coll.ItemStyle.Width;
            }
            coll = RadGrid1.MasterTableView.GetColumn("prac_str");
            if (coll != null)
            {
                coll.ItemStyle.Width = SirkySloupcu.stred;
                coll.HeaderStyle.Width = coll.ItemStyle.Width;
            }           
        }

        private class MyBudgetEditTemplate : ITemplate
        {
            private string id;
            public MyBudgetEditTemplate(string cName)
            {
                id = cName;               
            }
            void ITemplate.InstantiateIn(Control container)
            {
                TextBox box=new TextBox{Text= "edit"};
                container.Controls.Add(box);
            }
        }

        private class MyBudgetItemTemplate : ITemplate
        {
            private string id;
            public MyBudgetItemTemplate(string cName)
            {
                id = cName;
            }

            void ITemplate.InstantiateIn(Control container)
            {

                Label lab = new Label() { Text="item"};
                container.Controls.Add(lab);               
            }
        }
    }
}