﻿using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class ZadostOpracmisto : UserControlPozadavek
    {
        private Int32? IdPracmist
        {
            get
            {
                switch (FormView1.CurrentMode)
                {
                    case FormViewMode.Insert:
                        {
                            RadComboBox RCB = (RadComboBox)FormView1.FindControl("TRCB_navrh_mist_i");

                            if(RCB.Items.Count==0)
                            {
                                Label L_err = (Label)FormView1.FindControl("L_err");
                                L_err.Visible = true;
                            }

                            Int32 idpm;
                            if (Int32.TryParse(RCB.SelectedValue, out idpm))
                            {
                                return idpm;
                            }
                            else return null;
                        }
                    default:
                        {
                            DateTime cas = DateTime.Now;
                            return workfl_hodnoty.GetInt32N(PozId, "id_pracmist", ref cas);
                        }
                }
            }
            set
            {
                workfl_hodnoty.Save(PozId, "id_pracmist", value);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "pracmisto", null);

            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Insert);
                if (this.IdPracmist != null)
                {
                    PracMistoControl.IDPracmist = (int)this.IdPracmist;
                }
            }
            else if (val == "edit")
            {
                FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
            {
                FormView1.ChangeMode(FormViewMode.ReadOnly);
            }

            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            if(FormView1.CurrentMode== FormViewMode.Insert)
            {
                RadDatePicker TRDP_insert_vyriz_datum = (RadDatePicker)FormView1.FindControl("TRDP_insert_vyriz_datum");
                if (TRDP_insert_vyriz_datum != null)
                    TRDP_insert_vyriz_datum.DbSelectedDate = DateTime.Now.Date.AddMonths(1).PosledniDen();
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }



        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                    }
                }
            }
        }

        protected void ObjectDataSource1_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {

        }

        protected void TRCB_navrh_mist_i_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            if (this.IdPracmist != null)
            {
                PracMistoControl.IDPracmist = (int)this.IdPracmist;
                PracMistoControl.SpustiSestavu();
            }
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            if (this.IdPracmist != null)
            {
                PracMistoControl.IDPracmist = (int)this.IdPracmist;
                PracMistoControl.SpustiSestavu();
            }
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            if(this.IdPracmist == null)
            {
                e.Cancel = true;
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Je nutné vybrat Návrh pracovního místo, který chcete schvalovat. Ukládání požadavku bylo zastaveno%]"), ReadGlobalResource.ZmenaTextu("[%Chyba při ukládání%]"));
                return;
            }

            KSProgram.Pozadavky.PozadavekSeznam pozsez = new KSProgram.Pozadavky.PozadavekSeznam();
            DataTable table = pozsez.Retrieve(0, "vse", "pracmisto", "vse", DateTime.MinValue, DateTime.MaxValue, DateTime.MinValue, DateTime.MaxValue, null, "vsebp", "n,r,o");

            if (table.Rows.Count > 0)
            {
                foreach (DataRow row in table.Rows)
                {
                    KSProgram.Pozadavky.PozadavekSeznam.Pozad poz = new KSProgram.Pozadavky.PozadavekSeznam.Pozad(row);

                    DateTime cas = DateTime.Now;
                    int? idpm =  workfl_hodnoty.GetInt32N((int)poz.id_poz, "id_pracmist", ref cas);
                    if(idpm != null && idpm == this.IdPracmist)
                    {
                        e.Cancel = true;
                        MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Již existuje požadavek pro schválení této Šablony návrhu. Ukládání požadavku bylo zastaveno%]"), ReadGlobalResource.ZmenaTextu("[%Chyba při ukládání%]"));
                        return;
                    }
                }
            }

            TRadDatePicker box2 = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_insert_vyriz_datum");
            e.InputParameters["vyridit_do"] = (box2.DateInput.SelectedDate == null ? new DateTime() : box2.DateInput.SelectedDate);

            e.InputParameters["id_pracmist"] = this.IdPracmist;
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["id_poz"] = PozId;

            TRadDatePicker box2 = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_edit_vyriz_datum");
            e.InputParameters["vyridit_do"] = (box2.DateInput.SelectedDate == null ? new DateTime() : box2.DateInput.SelectedDate);
        }

        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            Nacist();
        }
    }
}