﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Premie;
using KSProgram.Extensions;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class ZadostOpremiegum : UserControlPozadavek
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi_poz"] == null ? Globals.AktObdobi : Convert.ToDateTime(ViewState["Obdobi_poz"]));
            }
            set
            {
                ViewState["Obdobi_poz"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "premiegum", null);
            string val = wf.Get_UN("", "Form1", "Mode");
            string vals = wf.Get_UN("", "SeznamOdmen", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                TFormView1.ChangeMode(FormViewMode.Insert);
                TRG_odmeny.EditaceZakazana = true;
                TRG_odmeny.Visible = false;
            }
            else if (val == "edit")
            {
                TFormView1.ChangeMode(FormViewMode.Edit);
                if (vals == "hidden")
                {
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = false;
                }
                else if (vals == "readonly")
                {
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = true;
                }
                else
                {
                    TRG_odmeny.EditaceZakazana = false;
                    TRG_odmeny.Visible = true;
                }
            }
            else
            {
                TFormView1.ChangeMode(FormViewMode.ReadOnly);
                if (vals == "hidden")
                {
                    TRG_odmeny.Visible = false;
                    TRG_odmeny.EditaceZakazana = true;
                }
                else if (vals == "readonly")
                {
                    TRG_odmeny.Visible = true;
                    TRG_odmeny.EditaceZakazana = true;
                }
                else
                {
                    TRG_odmeny.Visible = true;
                    TRG_odmeny.EditaceZakazana = false;
                }
            }

            TFormView1.DataSourceID = "ObjectDataSource1";
            TFormView1.DataBind();

            TRG_odmeny.Rebind();
        }

        protected void ObjectDataSource1_Selected(object sender, ObjectDataSourceStatusEventArgs e)
        {
            Obdobi = Convert.ToDateTime(e.OutputParameters["obdobi"]);
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadMonthYearPicker box = (TRadMonthYearPicker)WebControlHelper.FindControl(this, "TRMYP_insert_obdobi");
            e.InputParameters["obdobi"] = (box.DateInput.SelectedDate == null ? new DateTime() : box.DateInput.SelectedDate);

            TRadDatePicker box2 = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_insert_vyriz_datum");
            e.InputParameters["vyridit_do"] = (box2.DateInput.SelectedDate == null ? new DateTime() : box2.DateInput.SelectedDate);

        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadDatePicker box2 = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_edit_vyriz_datum");
            e.InputParameters["vyridit_do"] = (box2.DateInput.SelectedDate == null ? new DateTime() : box2.DateInput.SelectedDate);

            e.InputParameters["id_poz"] = this.PozId;
        }

        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            TFormView1.DataBind();
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool pagIsValid)
        {
            pagIsValid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                pagIsValid = this.Page.IsValid;
                if (pagIsValid)
                {
                    if (TFormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (TFormView1.CurrentMode == FormViewMode.Insert)
                        {
                            ObjectDataSource1.Insert();
                        }
                        else
                        {
                            ObjectDataSource1.Update();
                        }
                    }
                }
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            TFormView1.ChangeMode(mode);
            switch (mode)
            {
                case FormViewMode.Insert:
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = false; break;
                case FormViewMode.Edit:
                    TRG_odmeny.EditaceZakazana = false;
                    TRG_odmeny.Visible = true; break;
                case FormViewMode.ReadOnly:
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = true; break;
            }
        }

        private bool is_D = true;
        private bool is_THP = false;
        private bool is_Rocni_Thp = false;
        private bool is_Rocni_Vykon = false;
        private bool is_Bonus_Dov = false;
        private bool is_Bonus_Vanoce = false;
        private bool is_Bonus_VanoceRok = false;

        private void _setIdentifikatory(List<PremieGumotex.RadekGumotex> list)
        {
            List<Int16?> kody = list.Select(x => x.Kod).Distinct().ToList();
            is_D = kody.Contains(311) || kody.Contains(312);
            is_THP = kody.Contains(314) || kody.Contains(315);
            is_Rocni_Vykon = kody.Contains(420);
            is_Rocni_Thp = kody.Contains(413);
            is_Bonus_Dov = kody.Contains(430);
            is_Bonus_Vanoce = kody.Contains(431);
            is_Bonus_VanoceRok = kody.Contains(432);
        }

        protected void TRG_odmeny_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (PozId == 0)
            {
                TRG_odmeny.DataSource = null; // new List<KSProgram.Premie.PremieGumotex.RadekGumotex>() { };
            }
            else
            {
                List<PremieGumotex.RadekGumotex> list = PremieGumotex.Premie(null, null, PozId, null, null, null, false, "100", null, false, null, null, 0).OrderBy(x => x.Jmeno).ToList();
                foreach (PremieGumotex.RadekGumotex row in list)
                {
                    row.Narok = -row.Narok;
                    row.ZtohoZad = -row.ZtohoZad;
                    row.Castka = -row.Castka;
                    row.VyplatitZad = -row.VyplatitZad;
                    row.VyplatitZad_V = -row.VyplatitZad_V;
                    row.VyplatitZad_A = -row.VyplatitZad_A;
                    row.VyplatitZad_K = -row.VyplatitZad_K;
                }

                _setIdentifikatory(list);

                TRG_odmeny.DataSource = list;
            }
        }

        protected void TRG_odmeny_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            foreach (GridBatchEditingCommand command in e.Commands)
            {
                if (command.Type == GridBatchEditingCommandType.Update)
                {
                    DateTime p_obdobi = (DateTime)command.OldValues["Obdobi"];
                    Decimal p_os_cislo = (Decimal)command.OldValues["OsCislo"];
                    short p_cislo_pom = (short)command.OldValues["CisloPom"];
                    Int32 p_id = (Int32)command.OldValues["Id"];
                    Int32? p_id_zdroj = (Int32?)command.OldValues["IdZdroj"];
                    short p_kod = (short)command.OldValues["Kod"];
                    string p_popis_old = (string)command.OldValues["Popis"];
                    short p_typ_oj = (short)command.OldValues["TypOj"];
                    string p_oj = (string)command.OldValues["Oj"];

                    decimal p_castka = command.NewValues["Castka"] is decimal ? (decimal)command.NewValues["Castka"] : 0;
                    decimal p_zadrzet = command.NewValues["Zadrzet"] is decimal ? (decimal)command.NewValues["Zadrzet"] : 0;

                    decimal p_vyplatit_zadr = command.NewValues["VyplatitZad"] is decimal ? (decimal)command.NewValues["VyplatitZad"] : 0;
                    decimal p_vyplatit_zadr_v = command.NewValues["VyplatitZad_V"] is decimal ? (decimal)command.NewValues["VyplatitZad_V"] : 0;
                    decimal p_vyplatit_zadr_a = command.NewValues["VyplatitZad_A"] is decimal ? (decimal)command.NewValues["VyplatitZad_A"] : 0;
                    decimal p_vyplatit_zadr_k = command.NewValues["VyplatitZad_K"] is decimal ? (decimal)command.NewValues["VyplatitZad_K"] : 0;

                    string p_popis = (string)command.NewValues["Popis"];

                    short p_zadrzet_vp = command.NewValues["Zadrzet_VP"] is decimal ? Convert.ToInt16(command.NewValues["Zadrzet_VP"]) : (short)0;
                    short p_zadrzet_ap = command.NewValues["Zadrzet_AP"] is decimal ? Convert.ToInt16(command.NewValues["Zadrzet_AP"]) : (short)0;
                    short p_zadrzet_kp = command.NewValues["Zadrzet_KP"] is decimal ? Convert.ToInt16(command.NewValues["Zadrzet_KP"]) : (short)0;
                    decimal p_zadrzet_v = 0;
                    decimal p_zadrzet_a = 0;
                    decimal p_zadrzet_k = 0;

                    List<KSProgram.Premie.PremieGumotex.RadekGumotex> list = PremieGumotex.Premie(null, null, PozId, null, null, null, false, "100", null, false, null, null, 0);
                    _setIdentifikatory(list);

                    if (is_THP)
                    {
                        p_castka = (Decimal)command.OldValues["Castka"];

                        p_zadrzet_vp = (p_zadrzet_vp) > 100 ? ((short)(100)) : (p_zadrzet_vp);
                        p_zadrzet_ap = (p_zadrzet_vp + p_zadrzet_ap) > 100 ? ((short)(100 - p_zadrzet_vp)) : (p_zadrzet_ap);
                        p_zadrzet_kp = (p_zadrzet_vp + p_zadrzet_ap + p_zadrzet_kp) > 100 ? ((short)(100 - p_zadrzet_vp - p_zadrzet_ap)) : (p_zadrzet_kp);

                        p_zadrzet_v = (p_zadrzet_vp / (decimal)100) * p_castka;
                        p_zadrzet_a = (p_zadrzet_ap / (decimal)100) * p_castka;
                        p_zadrzet_k = (p_zadrzet_kp / (decimal)100) * p_castka;
                    }
                    string error = "";

                    //update Castka
                    if (is_D || is_Rocni_Vykon || is_Rocni_Thp || is_Bonus_Dov || is_Bonus_Vanoce || is_Bonus_VanoceRok)
                    {
                        Premie.UpdateCerpani(p_id, p_id_zdroj, p_castka, p_popis_old, ref error);
                        p_zadrzet = p_zadrzet > p_castka ? p_castka : p_zadrzet;
                    }

                    //update Popis
                    if (p_popis != p_popis_old)
                    {
                        Premie.UpdatePopis(p_id, p_popis);
                    }

                    //update Zadrzet
                    if (is_D)
                    {
                        //List<Premie.Radek> zadrzet = Premie.Prostredky(null, null, null, p_obdobi, null, null, false, "6", null, false, p_typ_oj, p_oj, 0)
                        //    .FindAll(x => x.OsCislo == p_os_cislo && x.CisloPom == p_cislo_pom && x.Kod == p_kod);

                        //if (zadrzet.Count == 0)
                        //{
                        //    Premie.InsertProstredky(6, null, p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, null, p_zadrzet, p_os_cislo.ToString() + " Zadržené prémie", p_kod, false, ref error);
                        //}
                        //else
                        //{
                        //    if (p_zadrzet == 0)
                        //    {
                        //        Premie.DeletePremie(zadrzet[0].Id, null, null, null, null);
                        //    }
                        //    else
                        //    {
                        //        Premie.UpdateProstredky(zadrzet[0].Id, null, null, p_zadrzet, p_os_cislo.ToString() + " Zadržené prémie", ref error);
                        //    }
                        //}
                        _updateZadrzet(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, null, p_zadrzet, ref error, 6);
                    }

                    //update Zadrzet_VAK
                    if (is_THP)
                    {
                        _updateZadrzet(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_zadrzet_vp, p_zadrzet_v, ref error, 10);
                        _updateZadrzet(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_zadrzet_ap, p_zadrzet_a, ref error, 12);
                        _updateZadrzet(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_zadrzet_kp, p_zadrzet_k, ref error, 14);
                    }


                    //update Vyplatit Zádržné
                    if (is_D)
                    {
                        _updateVyplZadr(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_vyplatit_zadr, ref error, 104, 6);
                    }
                    //update Vyplatit Zádržné V
                    if (is_THP)
                    {
                        _updateVyplZadr(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_vyplatit_zadr_v, ref error, 110, 10);
                        _updateVyplZadr(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_vyplatit_zadr_a, ref error, 112, 12);
                        _updateVyplZadr(p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_kod, p_vyplatit_zadr_k, ref error, 114, 14);
                    }
                }
            }
        }

        private void _updateZadrzet(DateTime p_obdobi, short p_typ_oj, string p_oj, decimal p_os_cislo, short p_cislo_pom, short p_kod,short? p_zadrzet_p, decimal p_zadrzet, ref string error, Int16 kod_zad)
        {
            List<Premie.Radek> zadrzet = Premie.Prostredky(null, null, null, p_obdobi, null, null, false, kod_zad.ToString(), null, false, p_typ_oj, p_oj, 0)
                            .FindAll(x => x.OsCislo == p_os_cislo && x.CisloPom == p_cislo_pom && x.Kod == p_kod);

            if (zadrzet.Count == 0)
            {
                Premie.InsertProstredky(kod_zad, null, p_obdobi, p_typ_oj, p_oj, p_os_cislo, p_cislo_pom, p_zadrzet_p, p_zadrzet, p_os_cislo.ToString() + " Zadržené prémie", p_kod, false, ref error);
            }
            else
            {
                if (p_zadrzet == 0)
                {
                    Premie.DeletePremie(zadrzet[0].Id, null, null, null, null);
                }
                else
                {
                    Premie.UpdateProstredky(zadrzet[0].Id, null, p_zadrzet_p, p_zadrzet, p_os_cislo.ToString() + " Zadržené prémie", ref error);
                }
            }
        }
        private void _updateVyplZadr(DateTime p_obdobi, short p_typ_oj, string p_oj, decimal p_os_cislo, short p_cislo_pom, short p_kod, decimal p_vyplatit_zadr, ref string error, Int16 kod_vypl_zad, Int16 kod_zad)
        {
            List<Premie.Radek> vypl_zadr = Premie.Prostredky(null, null, null, p_obdobi, null, null, false, kod_vypl_zad.ToString(), null, false, p_typ_oj, p_oj, 0)
                            .FindAll(x => x.OsCislo == p_os_cislo && x.CisloPom == p_cislo_pom && x.Kod == p_kod);
            decimal suma_zadr = -vypl_zadr.Sum(x => x.Castka);
            if (suma_zadr != p_vyplatit_zadr)
            {
                foreach (Premie.Radek vyplzadr in vypl_zadr)
                {
                    Premie.DeletePremie(vyplzadr.Id, null, null, null, null);
                }
                List<Premie.Radek> zadrzet_hist = Premie.Prostredky(null, null, null, null, null, p_obdobi.PrvniDen().AddDays(-1), false, kod_zad.ToString(), null, false, null, null, 0)
                    .FindAll(x => x.OsCislo == p_os_cislo && x.CisloPom == p_cislo_pom && x.Kod == p_kod && x.Zustatek > 0).OrderBy(x => x.Obdobi).ToList();
                foreach (Premie.Radek hist6 in zadrzet_hist)
                    if (p_vyplatit_zadr > 0)
                    {
                        decimal castka = hist6.Zustatek < p_vyplatit_zadr ? hist6.Zustatek : p_vyplatit_zadr;
                        Premie.InsertCerpani(kod_vypl_zad, hist6.Id, PozId, p_obdobi, p_os_cislo, p_cislo_pom, p_typ_oj, p_oj, null, castka, p_os_cislo.ToString() + " Vyplatit zádržné", p_kod, ref error);
                        p_vyplatit_zadr = p_vyplatit_zadr - castka;
                    }
                    else break;
            }
        }

        protected void TRG_odmeny_PreRender(object sender, EventArgs e)
        {
            //((RadNumericTextBox)((RadGrid)sender).MasterTableView.GetBatchColumnEditor("Zadrzet").ContainerControl.Controls[0]).Width = new Unit(100);
            //((RadNumericTextBox)((RadGrid)sender).MasterTableView.GetBatchColumnEditor("Vyplatit").ContainerControl.Controls[0]).Width = new Unit(100);
        }

        protected void TRG_odmeny_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
            {
                System.Drawing.Color back = e.Item.ItemType == GridItemType.Item ? System.Drawing.Color.FromArgb(246, 246, 246) : System.Drawing.Color.FromArgb(237, 237, 237);

                decimal d_Castka = (decimal)DataBinder.Eval(e.Item.DataItem, "Castka");
                decimal d_Narok = (decimal)DataBinder.Eval(e.Item.DataItem, "Narok");
                DateTime? d_DatumUkonc = (DateTime?)DataBinder.Eval(e.Item.DataItem, "DatumUkoncPom");
                DateTime d_Obdobi = (DateTime)DataBinder.Eval(e.Item.DataItem, "Obdobi");
                RadLabel lbCastka = (RadLabel)e.Item.FindControl("RL_Castka");

                if (d_Castka > d_Narok && lbCastka != null)
                {
                    lbCastka.CssClass += " myGreen";
                }
                else if (d_Castka < d_Narok && lbCastka != null)
                {
                    lbCastka.CssClass += " myRed";
                }

                if (d_DatumUkonc != null && (DateTime)d_DatumUkonc < d_Obdobi)
                {
                    ((GridDataItem)e.Item)["OsCislo"].CssClass = "myRed";
                    ((GridDataItem)e.Item)["Jmeno"].CssClass = "myRed";
                }

                ((GridDataItem)e.Item)["Celkem"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);

                ((GridDataItem)e.Item)["Narok"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.LightGreen, back);
                ((GridDataItem)e.Item)["ZtohoZad"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.LightGreen, back);
                ((GridDataItem)e.Item)["Castka"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.LightGreen, back);
                ((GridDataItem)e.Item)["Zadrzet"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.LightGreen, back);

                ((GridDataItem)e.Item)["Zadrzeno"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["Zadrzeno_V"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["Zadrzeno_A"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["Zadrzeno_K"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["VyplatitZad"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["VyplatitZad_V"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["VyplatitZad_A"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);
                ((GridDataItem)e.Item)["VyplatitZad_K"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Blue, back);

                ((GridDataItem)e.Item)["Zadrzet_VP"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                ((GridDataItem)e.Item)["Zadrzet_AP"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                ((GridDataItem)e.Item)["Zadrzet_KP"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                ((GridDataItem)e.Item)["Zadrzet_V"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                ((GridDataItem)e.Item)["Zadrzet_A"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                ((GridDataItem)e.Item)["Zadrzet_K"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
            }
        }

        protected void TRG_odmeny_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                string dataField = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField;
                dynamic dataItem = (((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem;

                if (dataField == "Castka")
                    e.Cell.Text = dataItem.Castka.ToString();

                if (dataField == "Zadrzet")
                    e.Cell.Text = dataItem.Zadrzet.ToString();

                if (dataField == "Zadrzet_VP")
                    e.Cell.Text = dataItem.Zadrzet_VP.ToString();
                if (dataField == "Zadrzet_AP")
                    e.Cell.Text = dataItem.Zadrzet_AP.ToString();
                if (dataField == "Zadrzet_KP")
                    e.Cell.Text = dataItem.Zadrzet_KP.ToString();

                if (dataField == "VyplatitZad")
                    e.Cell.Text = dataItem.VyplatitZad.ToString();

                if (dataField == "VyplatitZad_V")
                    e.Cell.Text = dataItem.VyplatitZad_V.ToString();
                if (dataField == "VyplatitZad_A")
                    e.Cell.Text = dataItem.VyplatitZad_A.ToString();
                if (dataField == "VyplatitZad_K")
                    e.Cell.Text = dataItem.VyplatitZad_K.ToString();
            }
        }

 
        protected void TRG_odmeny_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        {
            
        }

        protected void TRG_odmeny_DataBound(object sender, EventArgs e)
        {
            foreach (GridColumn col in ((RadGrid)sender).Columns)
            {
                switch (col.UniqueName)
                {
                    case "PracStrNazev": col.Display = is_D; break;
                    case "Narok": col.Display = is_D || is_Rocni_Vykon || is_Rocni_Thp || is_Bonus_Dov || is_Bonus_Vanoce || is_Bonus_VanoceRok; break;
                    case "ZtohoZad": col.Display = is_Rocni_Thp; break;
                    case "Castka": ((GridEditableColumn)col).ReadOnly = !is_D && !is_Rocni_Vykon && !is_Rocni_Thp && !is_Bonus_Dov && !is_Bonus_Vanoce && !is_Bonus_VanoceRok; break;
                    case "Zadrzet": col.Display = is_D; break;
                    case "Zadrzet_V": col.Display = is_THP; break;
                    case "Zadrzet_A": col.Display = is_THP; break;
                    case "Zadrzet_K": col.Display = is_THP; break;
                    case "Zadrzet_VP": col.Display = is_THP; break;
                    case "Zadrzet_AP": col.Display = is_THP; break;
                    case "Zadrzet_KP": col.Display = is_THP; break;
                    case "Zadrzeno": col.Display = is_D; break;
                    case "Zadrzeno_V": col.Display = is_THP; break;
                    case "Zadrzeno_A": col.Display = is_THP; break;
                    case "Zadrzeno_K": col.Display = is_THP; break;
                    case "VyplatitZad": col.Display = is_D; break;
                    case "VyplatitZad_V": col.Display = is_THP; break;
                    case "VyplatitZad_A": col.Display = is_THP; break;
                    case "VyplatitZad_K": col.Display = is_THP; break;
                    case "Celkem": col.Display = !is_Rocni_Vykon && !is_Rocni_Thp && !is_Bonus_Dov && !is_Bonus_Vanoce && !is_Bonus_VanoceRok; break;
                }
            }
        }


    }
}