﻿using KSProgram;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class ZadostOprevdov : UserControlPozadavek
    {
        protected decimal OsCislo
        {
            get
            {
                return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
            }
            set
            {
                ViewState["OsCislo"] = value;
            }
        }

        protected Int16 CisloPom
        {
            get
            {
                if (ViewState["CisloPom"] == null)
                    return 0;
                else
                    return Convert.ToInt16(ViewState["CisloPom"]);
            }
            set
            {
                ViewState["CisloPom"] = value;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public static string TextZadosti(DateTime aObdobi)
        {
            /*
            int year= aObdobi.Year;
            if (aObdobi.Month > 2)               
                year = aObdobi.Year + 1;
                */
            int year = Pozadavekprevdov.PrevodDoRoku(aObdobi);
            return ReadGlobalResource.ZmenaTextu($"[%Žádám o převod zůstatku dovolené do následujícího roku%]: {year}");
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["os_cislo"] = OsCislo;

            TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
            if (box.SelectedDate != null)
                e.InputParameters["vyridit_do"] = box.SelectedDate;

            RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
            e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);
        }
        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
            e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

            RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvodEdit");
            e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);

            e.InputParameters["id_poz"] = this.PozId;
        }
        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            FormView1.ChangeMode(FormViewMode.ReadOnly);
            FormView1.DataBind();
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "prevdov", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Insert);
            }
            else if (val == "edit")
                FormView1.ChangeMode(FormViewMode.Edit);
            else
                FormView1.ChangeMode(FormViewMode.ReadOnly);


            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();


            //PH 16.12.2015 doplněno zobrazování žadatele při vytváření nového požadavku
            if (val == "insert")
            {
                OsCislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
                if (lab_zam != null)
                    lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(OsCislo);


                CisloPom = Prac_pom.Platny_Pomer(OsCislo, DateTime.Now.Date);
                var lab_text = WebControlHelper.FindControl(this.FormView1, "label_text") as Label;
                if (lab_text != null)
                    //lab_text.Text = ZadostOprevdov.TextZadosti(Globals.AktObdobi.AddYears(1));
                    lab_text.Text = ZadostOprevdov.TextZadosti(Globals.AktObdobi);

            }
            else
            {
                /*
                DataRowView drv = (DataRowView)FormView1?.DataItem;

                DataTable table = drv.DataView.Table;
                if (table.Rows.Count > 0)
                {
                    ZbytekHodin = table.Rows[0]["zbytek_hodin"].SafeDecimal();
                    OsCislo = Convert.ToDecimal(table.Rows[0]["os_cislo"]);
                    CisloPom = Convert.ToInt16(table.Rows[0]["cislo_pom"]);
                }
                */
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;

                // Slouží pro analýzu který validátor ve stránce blokuje uložení
                //System.Web.UI.ValidatorCollection validators = this.Page.Validators;
                //int count = validators.Count;
                //for (int i = 0; i < count; i++)
                //{
                //    if (!validators[i].IsValid)
                //    {
                //        string va = ((System.Web.UI.Control)validators[i]).ClientID;
                //    }
                //}

                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                    }
                }
            }
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }
        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());
        }
    }
}