﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Sluzebky;
using KSProgram.Extensions;
using KSProgram.Obecne;

public partial class Controls_ZadostOsluzc : UserControlPozadavek
{
    public KSPortal.Controls.CestovniPrikaz CestPrikaz
    {
        get { return CP; }
    }
    protected void Page_Load(object sender, EventArgs e)
    {
        if (CP != null)
        {
            CP.HlavickaInserted += new EventHandler(CP_HlavickaInserted);
            CP.HlavickaUpdated += new EventHandler(CP_HlavickaUpdated);
        }
    }

    public override void Nacist()
    {
        base.Nacist();

        //WorkflowMaster wf = new WorkflowMaster(PozId, "sluzc", null);
        WorkflowMaster wf = WF;//PR 17.04.2020 Pokud jsem na strance PozadavekDetail, tak tam se WorkflowMaster předá z něj

        string Form1Mode = wf.Get_UN("", "Form1", "Mode");
        string HlavMode = wf.Get_UN("", "Hlavicka", "Mode");

        if (wf.FazeZprac > 1 && Form1Mode == "insert") throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Form1.mode=Insert !");
        if ((Form1Mode == "readonly" || Form1Mode == "") && HlavMode == "editable") throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Pokud je Hlavicka.Mode=Editable, pak nemůže být Form1.Mode=ReadOnly !");

        //if ((Form1Mode == "insert") || (PozId == 0))
        //    FormView1.ChangeMode(FormViewMode.Insert);
        //else if (Form1Mode == "edit")
        //    FormView1.ChangeMode(FormViewMode.Edit);
        //PR 30.4.2018 novým požadavkům, které neprošli validací stavu, nastavuji stav "koncept" a ponechávám fázi č.1
        if (Form1Mode == "insert" || Form1Mode == "edit")  
        {
            if (PozId == 0)
                FormView1.ChangeMode(FormViewMode.Insert);
            else
                FormView1.ChangeMode(FormViewMode.Edit);
        }
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue =PozId.ToString();
        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        string tabulka = "workfl_sluz_cesty";
        int ev_cislo = 0;
        DataRowView rowView = (DataRowView)FormView1.DataItem;
        if (FormView1.DataItem != null)
        {            
            object t = rowView["tabulka"];
            tabulka = (t == null || (string)t == "") ? "workfl_sluz_cesty" : (string)t;
            object e = rowView["ev_cislo"];
            ev_cislo = (e == null) ? 0 : (int)e;
        }        

        CP.EvCislo = ev_cislo;
        CP.tabulka = tabulka;//workfl_sluz_cesty nebo primo sluz_cesty po exe:zapis
        CP.PozId = PozId;
        CP.wf = WF; //PR 17.04.2020 
        //PR 10.3.2017  je to nyní řízeno EvCislo>0        CP.ShowNewButton = false; // ShowUpdateButtons false;
        if ((PozId > 0) && (ev_cislo == 0)) //požadavek vytvořen ve staré verzi, schovám CP
        {
            CP.Visible = false;
        }
        else
        {
            if (ev_cislo == 0)
                CP.Novy(); //k pozadavku neexistuje CP
            else
            {
                CP.Nacist();
                //RequireFullPostBack = true; //PR 2.12.2013 kvůli LV_Nahrady FileUpload //PR 10.7.2018 zakomentováno
            }
        }        
    }

    public void UnBind()
    {
        FormView1.DataSourceID = null;
        FormView1.DataBind();
        CP.UnBind();
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }
    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }   
    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        OnItemRetrieved(new EventArgs());
        
    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["id_poz"] = this.PozId;
        
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        e.InputParameters["ev_cislo"] = CP.EvCislo;
        e.InputParameters["tabulka"] = CP.tabulka;
        e.InputParameters["datum_od"] = CP.Dat_od;
        e.InputParameters["datum_do"] = CP.Dat_do;
        e.InputParameters["cil"] = CP.Cil;
        e.InputParameters["ucel"] = CP.Ucel;
        e.InputParameters["druh_dopr"] = CP.Druh_dopr;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
        //FormView1.DataBind();
    }
   
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {        
        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

        e.InputParameters["ev_cislo"] = CP.EvCislo;
        e.InputParameters["tabulka"] = CP.tabulka;
        //toto se taky plní v CP_HlavickaInserted        
        e.InputParameters["datum_od"] = CP.Dat_od;
        e.InputParameters["datum_do"] = CP.Dat_do;
        e.InputParameters["cil"] = CP.Cil;
        e.InputParameters["ucel"] = CP.Ucel;
        e.InputParameters["druh_dopr"] = CP.Druh_dopr;
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    private bool _SaveCommandIsProcessed { get; set; }

    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            _SaveCommandIsProcessed = true; //PR 6.12.2013 

            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (CP.Uloz())
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                        {
                            try
                            {
                                ObjectDataSource1.Insert();
                            }
                            catch
                            {   //PR 16.4.2015 pokud se nepodarilo ulozit novy pozadavek, tak smazu zaznam z workfl_sluz_cesty a workfl_slc_zalohy
                                if ((CP.PozId == null || CP.PozId == 0) && CP.EvCislo > 0)
                                {
                                    //PR 23.4.2015 vznikala nějaká chyba, díky které se nepředalo PozId a smazalo se tedy workfl_sluz_cesty
                                    if (Pozadaveksluzc.EvCisloToIdPozadavku(CP.EvCislo)==null)
                                    {
                                        SlcZalohy.DeleteAll(CP.EvCislo, false);
                                        SlcHlavicka.Delete(CP.EvCislo);
                                    }
                                }
                                throw;
                            }
                        }
                        else
                            ObjectDataSource1.Update();
                    }
                }
                else is_valid = false;
            }
            _SaveCommandIsProcessed = false;
        }
    }

    public void PrekrytiIntervaluValidator_validate(object sender, ServerValidateEventArgs e)
    {
        CustomValidator cust = (CustomValidator)sender;
        DateTime dat_od = new DateTime();
        DateTime dat_do = new DateTime();

        if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            e.IsValid = true;
            return;
        }
        
        if (CP.Dat_od != null)
            dat_od = (DateTime)CP.Dat_od;
        else //PR 20.02.2020 
        {
            e.IsValid = true; //nevyplněné datum zarazí validátor v hlaviččce CP
            return;
        }
        if (CP.Dat_do != null)
            dat_do = (DateTime)CP.Dat_do;
        else //PR 20.02.2020 
        {
            e.IsValid = true;
            return;
        }

        //int pocet = Pozadavek.PrekrivajiciPozadavky(this.PozId, dat_od, dat_do);
        //PH 28.4.2014 
        //-----------------------------------------
        short cislo_pom = -1;
        //Prac_pom pp = new Prac_pom();
        //Prac_pom.Platny_Pomer_Den(Globals.OsCisloNeboZastupovany, dat_od, out cislo_pom);
        Prac_pom.Platny_Pomer_Den(CP.OsCislo, dat_od, out cislo_pom); //PR 9.11.2015 kontrolovalo se chybné os.číslo (např. schvalovatele), pokud měl požadavek editable
        if (cislo_pom < 0) //PR 9.11.2015 
        {
            cust.Text = "[%Zaměstnanec nemá platný pracovní poměr%]";
            e.IsValid = false;
            return;
        }
        
        if (!Pozadavek.PlanovaciKalendarExists(dat_od.Year, CP.OsCislo))
        {
            e.IsValid = false;
            cust.Text = "[%Nelze pokračovat. Kontaktujte mzdovou účetní. Nevyplněn plánovací kalendář pro následující rok%]";
            return;
        }

        //PR 9.11.2015 zkontroluji fond, jestli to vyhučí, tak nejpíš nemá zadán správný kalendář
        try
        {
            StrPracdnySvatky str_fond = PracdnySvatky.Get(CP.OsCislo, cislo_pom, dat_od, dat_do, dat_od.PrvniDen());
        }
        catch (Exception err)
        {
            cust.Text = err.Message; //
            e.IsValid = false;
            return;
        }

        int? min_od=null;
        int? min_do=null;
        string s_cas=((TextBox)WebControlHelper.FindControl(this, "cas_od_TB")).Text;
        if (!string.IsNullOrEmpty(s_cas))
            min_od=Cas_na_min.Get(s_cas);
        s_cas=((TextBox)WebControlHelper.FindControl(this, "cas_do_TB")).Text;
        if (!string.IsNullOrEmpty(s_cas))
            min_do=Cas_na_min.Get(s_cas);

        int pocet = 0;
        
        if (!Pozadavek.PrekrivajiciPozadavky(this.PozId,0, "sluzc", CP.OsCislo, cislo_pom, dat_od, dat_do, null, min_od, min_do))
            pocet = 1;
        //---------------------------------------

        //e.IsValid = (pocet == 0);
        //PH 5.1.2010
        CheckBox cbx_IgnorujPrekryti = cust.Parent.FindControl("cbx_IgnorujPrekryti") as CheckBox; //PR 8.1.2014 
        if (pocet > 0)
        {            
            if (cbx_IgnorujPrekryti.Visible == false) cbx_IgnorujPrekryti.Visible = true;

            if (cbx_IgnorujPrekryti.Checked == false)
            {
                e.IsValid = false;
                cust.Text = "[%Překrývající požadavky, nelze pokračovat%]";
                return;
            }
        }
        if (cbx_IgnorujPrekryti.Visible) cbx_IgnorujPrekryti.Visible = false;

        e.IsValid = true;
    }
    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        if (PozId > 0) //PR 16.4.2015 
        {
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }
    }
    
    void CP_HlavickaInserted(object sender, EventArgs e)
    {
        ObjectDataSource1.InsertParameters["ev_cislo"].DefaultValue = CP.EvCislo.ToString();
        ObjectDataSource1.InsertParameters["tabulka"].DefaultValue = CP.tabulka;
        ObjectDataSource1.InsertParameters["datum_od"].DefaultValue = CP.Dat_od.ToString();
        ObjectDataSource1.InsertParameters["datum_do"].DefaultValue = CP.Dat_do.ToString();
        ObjectDataSource1.InsertParameters["cil"].DefaultValue = CP.Cil;
        ObjectDataSource1.InsertParameters["ucel"].DefaultValue = CP.Ucel;
        ObjectDataSource1.InsertParameters["druh_dopr"].DefaultValue = CP.Druh_dopr;

        if (_SaveCommandIsProcessed == false) //PR 6.12.2013 uzivatel zmackl tlacitko Ulozit umistene v CP (ne img_save)
        {       
            ObjectDataSource1.Insert();            
        }
    }
        
    void CP_HlavickaUpdated(object sender, EventArgs e)
    {
        ObjectDataSource1.UpdateParameters["ev_cislo"].DefaultValue = CP.EvCislo.ToString();
        ObjectDataSource1.UpdateParameters["tabulka"].DefaultValue = CP.tabulka;
        ObjectDataSource1.UpdateParameters["datum_od"].DefaultValue = CP.Dat_od.ToString();
        ObjectDataSource1.UpdateParameters["datum_do"].DefaultValue = CP.Dat_do.ToString();
        ObjectDataSource1.UpdateParameters["cil"].DefaultValue = CP.Cil;
        ObjectDataSource1.UpdateParameters["ucel"].DefaultValue = CP.Ucel;
        ObjectDataSource1.UpdateParameters["druh_dopr"].DefaultValue = CP.Druh_dopr;

        if (_SaveCommandIsProcessed == false) //PR 6.12.2013 uzivatel zmackl tlacitko Ulozit umistene v CP (ne img_save)
        {
            ObjectDataSource1.Update();
        }
    }

    public override void ZmenaStavu_ServerValidate(CustomValidator validator, ServerValidateEventArgs e)
    {
        //if (e.Value == "xxxxxx") //PR 14.3.2017 test
        //{
        //    e.IsValid = false;
        //    if (!e.IsValid)
        //        validator.Text = "[%Bla bla je to spatne%]";
        //    return;
        //}

        //PR 07.05.2019 pridal jsem event i do CP, at tam muzu blokovat zmenu stavu, kdyz nejsou nejaka data OK.
        if (CP != null)
        {
            CP.ZmenaStavu_ServerValidate(validator, e);
            if (e.IsValid == false)
                return;
        }

        //PR 30.4.2018 
        if (!string.IsNullOrEmpty(e.Value))
        {
            string stav = e.Value;
            WorkflowMaster master = new WorkflowMaster(PozId, "sluzc", null);
            int? next_faze;
            string sys_stav, vyraz, adresat, oznam, validace, akce;
            if (WorkflowProces.GetNextFaze(master, stav, this, out sys_stav, out vyraz, out next_faze, out adresat, out oznam, out validace, out akce))
            {
                string errText;
                if (!WorkflowProces.ProvedValidaci(master, this, validace, out errText))
                {
                    e.IsValid = false;
                    validator.Text = errText;
                }
            }
        }

    }

    /// <summary>
    /// Vrací počet dnů cesty
    /// </summary>
    [WFProperty]
    public int Dnu
    {
        get
        {
            int p = 0;
            
            if (CP != null && CP.Dat_od.HasValue && CP.Dat_do.HasValue)
                p = 1 + (int)F_DateTime.DaysAfter(CP.Dat_od.Value, CP.Dat_do.Value);
                
            return p;
        }
    }

    /// <summary>
    /// Datum počátku cesty (pro validaci např. "pozadavek.DatumOd menší nebo rovno DateTime.Today|Cesta ještě nezačala")
    /// </summary>
    [WFProperty]
    public DateTime DatumOd
    {
        get
        {
            if (CP != null && CP.Dat_od.HasValue)
                return CP.Dat_od.Value;
            else
                return new DateTime(1900, 01, 01);
        }
    }

    /// <summary>
    /// Datum konce cesty (pro validaci např. "pozadavek.DatumDo menší nebo rovno DateTime.Today|Cesta ještě neproběhla")
    /// </summary>
    [WFProperty]
    public DateTime DatumDo
    {
        get
        {
            if (CP != null && CP.Dat_do.HasValue)
                return CP.Dat_do.Value;
            else
                return new DateTime(1900, 01, 01);
        }
    }

    /// <summary>
    /// Vrací druh dopravy (více druhů je odděleno čárkou bez mezery)
    /// </summary>
    [WFProperty]
    public string DruhDopr //PR 23.8.2017 
    {
        get
        {
            string d = "";
            if (CP != null)
                d = CP.Druh_dopr;
            return d;
        }
    }

    /// <summary>
    /// Vrací zda je cesta zahraniční
    /// </summary>
    [WFProperty]
    public bool Zahranicni
    {
        get
        {
            bool b = false;
            if (CP != null)
                b = CP.Typ.Equals("z");
            return b;
        }
    }

    /// <summary>
    /// Vrací počet záloh
    /// </summary>
    [WFProperty]
    public int ZalohyPocet
    {
        get
        {
            int p = 0;
            if (CP != null && CP.ZalohyIsInEditMode)
                p = CP.ZalohyPocet;
            else
            {
                Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
                p = poz.ZalohyPocet;
            }
            return p;
        }
    }

    /// <summary>
    /// Vrací sumu záloh přepočítaných na tuzemskou měnu
    /// </summary>
    [WFProperty]
    public decimal ZalohySuma
    {
        get
        {
            decimal z = 0;
            if (CP != null && CP.ZalohyIsInEditMode)
                z = CP.ZalohySuma;
            else
            {
                Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
                z = poz.ZalohySuma;
            }
            return z;
        }
    }

    /// <summary>
    /// Vrací true pokud existuje záloha s daným způsobem vyplacení (i ještě nevyplacená, tj. ve stavu žádosti)
    /// </summary>
    [WFProperty]
    public bool ZalohaZpVyplExist(string kod)
    {
        //PR 29.09.2022 HID=62686
        bool b = false;
        if (CP != null && CP.ZalohyIsInEditMode)
            b = CP.ZalohaZpVyplExist(kod);
        else
        {
            Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
            b = poz.ZalohaZpVyplExist(kod);
        }
        return b;
        
    }

    /// <summary>
    /// Vraci sumu nákladů v tuzemské měně
    /// </summary>
    [WFProperty]
    public decimal Naklady
    {
        get
        {
            decimal c = 0;
            if (CP != null && CP.NahradyIsInEditMode)
                c = CP.Naklady;
            else
            {
                Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
                c = poz.Naklady;
            }
            return c;
        }
    }

    /// <summary>
    /// Vraci sumu předpokládaných nákladů v tuzemské měně
    /// </summary>
    [WFProperty]
    public decimal PredpNakl
    {
        get
        {
            //PR 9.12.2016 
            decimal c = 0;
            if (CP != null)
                c = CP.PredpNakl;
            return c;
        }
    }

    /// <summary>
    /// Vrací počet scanů dokladů již uložených i teprve přichystaných k uložení
    /// //PR 01.07.2019 
    /// </summary>
    [WFProperty]
    public int ScanyPocet
    {
        get
        {
            int p = 0;
            if (CP != null && CP.NahradyIsInEditMode)
                p = CP.ScanyPocet();
            else
            {
                Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
                p = poz.ScanyPocet;
            }
            return p;
        }
    }

    /// <summary>
    /// Vrací počet vyplněných řádků průběhu i teprve přichystaných k uložení
    /// //PR 18.11.2019 HID=48856 
    /// </summary>
    [WFProperty]
    public int PrubehPocet
    {
        get
        {
            int p = 0;
            if (CP != null)
                p = CP.PrubehPocet();
            else
            {
                Pozadaveksluzc poz = new Pozadaveksluzc(PozId);
                p = poz.PrubehPocet;
            }
            return p;
        }
    }

    /// <summary>
    /// Do kdy má žadatel platné školení řidičů //PR 01.09.2021 HID=56188 
    /// </summary>
    [WFProperty]
    public DateTime SkolRidicDo
    {
        get
        {
            DateTime? plati_do = SqlPrikaz.ExecuteScalarDateTime("select MAX(s.plati_do) from sko_sezn s, sko_cisl c where s.cis_osve=c.cislo and c.sys_vyuziti=11 and s.os_cislo="+ Vydavatel);
            if (plati_do == null)
                return DateTime.MinValue;
            else
                return plati_do.Value;
        }
    }
}
