﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;

public partial class Controls_ZadostOstabs : UserControlPozadavek
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "dovol", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
            FormView1.ChangeMode(FormViewMode.Insert);
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        if (val == "insert")
        {
            var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(PozadavekZpracovaniAbstract.VydavatelProNovyPoz());
        }
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public void PrekrytiIntervaluValidator_validate(object sender, ServerValidateEventArgs e)
    {
        CustomValidator cust = (CustomValidator)sender;
        DateTime dat_od = new DateTime();
        DateTime dat_do = new DateTime();
        short cislo_pom = -1;
        TextBox textOd = null;
        TextBox textDo = null;
        CheckBox b = new CheckBox();

        if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            e.IsValid = true;
            return;
        }


        if (this.CurrentMode == FormViewMode.Insert)
        {
            textOd = (TextBox)WebControlHelper.FindControl(FormView1, "TextBoxOdInsert");
            textDo = (TextBox)WebControlHelper.FindControl(FormView1, "TextBoxDoInsert");
            b = (CheckBox)WebControlHelper.FindControl(FormView1, "CheckBoxPuldenInsert");
        }
        else if (this.CurrentMode == FormViewMode.Edit)
        {
            textOd = (TextBox)WebControlHelper.FindControl(FormView1, "TextBoxOdEdit");
            textDo = (TextBox)WebControlHelper.FindControl(FormView1, "TextBoxDoEdit");
            b = (CheckBox)WebControlHelper.FindControl(FormView1, "CheckBoxPuldenEdit");
        }

        if (!string.IsNullOrEmpty(textOd.Text))
        {
            dat_od = Convert.ToDateTime(textOd.Text);
            dat_do = dat_od; //MD 17.2.2012 pokud není vyplněn datum do, je shodný s datumem od
        }

        if (!string.IsNullOrEmpty(textDo.Text))
            dat_do = Convert.ToDateTime(textDo.Text);

        //kontrola datumů
        //-----------------------------
        if (dat_od == new DateTime())
        {
            cust.Text = "Datum od musí být zadán";
            e.IsValid = false;
            return;
        }
        else if (dat_od < Globals.AktObdobi)
        {
            cust.Text = "Záznam nelze zadat do uzavřeného období";
            e.IsValid = false;
            return;
        }
        else if (dat_od > dat_do)
        {
            cust.Text = "Datum od je větší než datum do, nelze pokračovat";
            e.IsValid = false;
            return;
        }
        else if (dat_od.Month != dat_do.Month)//PH 7.5.2010
        {
            cust.Text = "O dovolenou lze žádat jen v rámci jednoho měsíce. Dovolenou na další měsíc zadejte dalším požadavkem.";
            e.IsValid = false;
            return;
        }

        //dovolená po výstupu
        //Prac_pom pp = new Prac_pom();
        Prac_pom.Platny_Pomer_Den(Globals.OsCislo, dat_od, out cislo_pom);
        if (cislo_pom < 0)
        {
            cust.Text = "Dovolená po výstupu, nelze pokračovat";
            e.IsValid = false;
            return;
        }
        if (dat_do > new DateTime())
        {
            Prac_pom.Platny_Pomer_Den(Globals.OsCislo, dat_do, out cislo_pom);
            if (cislo_pom < 0)
            {
                cust.Text = "Konec dovolené po konci prac. poměru, nelze pokračovat";
                e.IsValid = false;
                return;
            }
        }
        //-----------------------------


        //string sql = "select count(*) from workfl_hl, workfl_body, workfl_proc " +
        //           " where workfl_hl.id_poz=workfl_body.id_poz " +
        //           " and workfl_proc.id_poz=workfl_hl.id_poz " +
        //           " and (workfl_proc.archiv IS NULL or workfl_proc.archiv='') " +
        //           " and (workfl_body.archiv IS NULL or workfl_body.archiv='') " +
        //           " and typ='dovol' " +
        //           " and stav<>'diskuse'and stav<>'zamitnuty'" +
        //           " and workfl_hl.os_cislo=" + Globals.OsCislo.ToString();

        string sql = "select count(*) from workfl_hl, workfl_body, workfl_proc " +
                  " where workfl_hl.id_poz=workfl_body.id_poz " +
                  " and workfl_proc.id_poz=workfl_hl.id_poz " +
                  " and (workfl_proc.archiv IS NULL or workfl_proc.archiv='') " +
                  " and (workfl_body.archiv IS NULL or workfl_body.archiv='') " +
                  " and typ='dovol' " +
                  " and stav<>'diskuse' and stav<>'zamitnuty' " /*PH 5.3.2012 přidal jsem and stav<>'zamitnuty'*/ +
                  " and workfl_hl.id_poz<>" + this.PozId.ToString() +
                  " and workfl_hl.os_cislo=" + Globals.OsCislo.ToString();

        if ((dat_od > new DateTime()) && (dat_do > new DateTime()))
        {
            sql += " and (workfl_body.datum_od between " + SqlPrikaz.ValueToString(dat_od) + " and " + SqlPrikaz.ValueToString(dat_do) +
                " or workfl_body.datum_do between " + SqlPrikaz.ValueToString(dat_od) + " and " + SqlPrikaz.ValueToString(dat_do) + ")";
        }
        else if (dat_od > new DateTime())
        {
            sql += " and ((workfl_body.datum_od <= " + SqlPrikaz.ValueToString(dat_od) + " and datum_do >=" + SqlPrikaz.ValueToString(dat_od) + ")" +
                " or workfl_body.datum_od =" + SqlPrikaz.ValueToString(dat_od) + ")";
        }

        int pocet = KSProgram.Data.SqlPrikaz.ExecuteScalarInt32(sql, 0);
        //e.IsValid = (pocet == 0);
        //PH 5.1.2010
        if (pocet > 0)
        {
            e.IsValid = false;
            cust.Text = "Překrývající požadavky, nelze pokračovat";
            return;
        }

        //MD 7.1.2013 Dovolená zadávaná do budoucího roku se nedá kontrolovat na přečerpání (ještě není stanoven nárok)
        DateTime konRoku = new DateTime(Globals.AktObdobi.Year, 12, 31);
        if (dat_od > konRoku)
        {
            e.IsValid = false;
            cust.Text = "Dovolenou lze zadat jen do aktuálně zpracovávaného roku " + Globals.AktObdobi.Year.ToString();
            return;
        }

        //PH 23.11.2010, kontroluju jestli si zaměstnanec neřekne o více dovolené než má nárok HELPDESK ID 12300
        //----------------------------
        Dovolena dov = new Dovolena(Globals.OsCislo, cislo_pom, Globals.AktObdobi);
        dov.Obdobi = Globals.AktObdobi;
        StrDovolena str_dov = dov.DovInfo();
        //MD 22.06.2012 neodečítat čerpání z mezd v aktuálním období, HID 18112
        decimal zbyvajici = str_dov.Zbyvajici + str_dov.CerpanaAktualne;

        decimal zadano = 0;
        decimal zadano_nyni = 0;
        //kolid dní si žádá v tomto požadavku

        if (dat_do == dat_od)
        {
            if (b.Checked)
                zadano_nyni = (decimal)0.5;
            else
                zadano_nyni = 1;
        }
        else
        {
            StrPracdnySvatky pr = PracdnySvatky.Get(Globals.OsCislo, cislo_pom, dat_od, dat_do, new DateTime(dat_od.Year, dat_od.Month, 1));
            if (pr.Prac != null)
                zadano_nyni = (decimal)pr.Prac;
        }

        //zjistím kolik dní dovolené má již v požadavcích
        //MD 4.1.2013 zjišťuju jen dovolenou zadanou do aktuálního roku
        string sql2 = "select workfl_body.datum_od, workfl_body.datum_do,pul_den " +
                   " from workfl_hl, workfl_body, workfl_proc " +
                   " where workfl_hl.id_poz=workfl_body.id_poz " +
                   " and workfl_proc.id_poz=workfl_hl.id_poz " +
                   " and (workfl_proc.archiv IS NULL or workfl_proc.archiv='') " +
                   " and (workfl_body.archiv IS NULL or workfl_body.archiv='') " +
                   " and typ='dovol' " +
                   " and stav<>'diskuse'and stav<>'zamitnuty'" +
                   " and workfl_hl.os_cislo=" + Globals.OsCislo.ToString() +
                   " and (workfl_body.datum_od between " + SqlPrikaz.ValueToString(Globals.AktObdobi) + " and " + SqlPrikaz.ValueToString(konRoku)+ ")";
        using (IDataReader reader = SqlPrikaz.ExecuteReader(sql2))
        {
            while (reader.Read())
            {
                DateTime ld_od = GetNullOrData.GetDateTime(reader, 0, new DateTime());
                DateTime ld_do = GetNullOrData.GetDateTime(reader, 1, ld_od);
                string pul_den = GetNullOrData.GetString(reader, 2, "n").Trim();
                if (ld_do == ld_od)
                {
                    if (pul_den == "a")
                        zadano += (decimal)0.5;
                    else
                        zadano += 1;
                }
                else
                {
                    StrPracdnySvatky pr = PracdnySvatky.Get(Globals.OsCislo, cislo_pom, ld_od, ld_do, new DateTime(ld_od.Year, ld_od.Month, 1));
                    if (pr.Prac != null)
                        zadano += (decimal)pr.Prac;
                }
            }
        }
        zbyvajici -= zadano;
        if (zadano_nyni > zbyvajici)
        {
            e.IsValid = false;
            cust.Text = "Váš zbývající nárok je " + zbyvajici.ToString("N1") + " dnů. Zadáváte " + zadano_nyni.ToString("N1");
            return;
        }
        //----------------------------

        e.IsValid = true;
    }

    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }


    //public override void Vlozit()
    //{
    //    FormView1.ChangeMode(FormViewMode.Insert);
    //}

    //public override void Editovat()
    //{
    //    FormView1.ChangeMode(FormViewMode.ReadOnly);
    //}

    protected void BoxPulden_CheckedChanged(object sender, EventArgs e)
    {

        string ls_pom = "";
        if (FormView1.CurrentMode == FormViewMode.Edit)
            ls_pom = "Edit";
        else if (FormView1.CurrentMode == FormViewMode.Insert)
            ls_pom = "Insert";
        else
            return;

        CheckBox check = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPulden" + ls_pom);
        if (check == null)
            return;

        TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDo" + ls_pom);
        if (check.Checked)
            box.Text = "";
        box.Enabled = !(check.Checked);
        ImageButton button = (ImageButton)WebControlHelper.FindControl(this, "ImageButtonDo" + ls_pom);
        button.Enabled = !(check.Checked);
    }

    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        BoxPulden_CheckedChanged(sender, e);
        OnItemRetrieved(new EventArgs());

    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxOdEdit");
        e.InputParameters["datum_od"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDoEdit");
        e.InputParameters["datum_do"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        CheckBox b = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPuldenEdit");
        e.InputParameters["pul_dne"] = (b.Checked ? true : false);

        e.InputParameters["id_poz"] = this.PozId;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void InsertUlozit_Command(object sender, CommandEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddl_absence_i");
        e.InputParameters["id_poz_storno"] = (list.SelectedValue);       
        
        //TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        //e.InputParameters["vyridit_do"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        TRadDatePicker date = (TRadDatePicker)WebControlHelper.FindControl(this, "dat_vyriz");
        e.InputParameters["vyridit_do"] = date.SelectedDate;

        TextBox box = (TextBox)WebControlHelper.FindControl(this, "LabelDuvod");
        e.InputParameters["duvod"] = (box.Text == "" ? String.Empty : box.Text);        
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    public void UzavrenaDochazkaValidator_validate(object sender, ServerValidateEventArgs e)
    {
        if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            e.IsValid = true;
            return;
        }

        if ((Parametry.ParametrCti("DovolSchvaleno").ToLower().Trim() == "d") && /*(Parametry.ParametrCti("Dochazka") == "a")*/ Parametry.ParametrCti("Dochazka")!="n")
        {
            decimal ldc_os_cislo = 0;
            DateTime ld_obdobi = new DateTime();
            WorkflowProces proc = new WorkflowProces();
            if (PozId > 0)
            {
                workfl_hl hl = new workfl_hl();
                Str_workfl_hl str_hl = hl.NaplnStrukturu(PozId);
                workfl_body body = new workfl_body();
                Str_workfl_body str_body = body.NaplnStrukturu(PozId);
                ldc_os_cislo = str_hl.os_cislo;
                ld_obdobi = str_body.obdobi;
            }
            else
            {
                ldc_os_cislo = Globals.OsCisloNeboZastupovany;
                DropDownList list=(DropDownList) WebControlHelper.FindControl(this,"ddl_absence_i");
                if (list!=null)
                {
                    int id_abs=Convert.ToInt32(list.SelectedValue);
                    workfl_body body=new workfl_body();
                    Str_workfl_body str_body=body.NaplnStrukturu(id_abs);
                    ld_obdobi=str_body.obdobi;
                }
            }
            Str_workfl_proc pr = proc.GetStav(ldc_os_cislo, "dochazka", ld_obdobi);
            //e.IsValid = ((pr.sys_stav == "r") || (pr.sys_stav == "n"));
            //PH 10.9.2019
            e.IsValid = ((pr.sys_stav == "r") || (pr.sys_stav == "n") || string.IsNullOrEmpty(pr.sys_stav));
        }
        else if ((Parametry.ParametrCti("DovolSchvaleno").ToLower().Trim() == "e")&&(Pozadavekstabs.ZapisSmenovnice))//PH 7.12.2017 HID:38923
        {

            DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddl_absence_i");
            if (list != null)
            {
                int id_abs = Convert.ToInt32(list.SelectedValue);
                workfl_body body = new workfl_body();
                Str_workfl_body str_body = body.NaplnStrukturu(id_abs);
                DateTime ld_obdobi = str_body.obdobi;
                e.IsValid = (ld_obdobi >= Globals.AktObdobi);
                if (!e.IsValid)
                    ((CustomValidator)sender).Text = WebControlHelper.ZmenaTextu("[%Nelze schvalovat do uzavřeného období%]");
                return;
            }
        }
        else
        {
            //zápis do absencí
            e.IsValid = true;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    //protected void ds_absence_DataBinding(object sender, EventArgs e)
    //{
    //    ds_absence.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUserNeboZastupovany.ToString();

    //}

    protected void FormView1_Load(object sender, EventArgs e)
    {
        ds_absence.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
    }
}
