﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
//using KSProgram.Sluzebky;
using KSProgram.Extensions;
using System.Collections.Specialized;
using KSProgram.Security;
using System.Text;
using Telerik.Web.UI;
using KSProgram.Exceptions;
using KSProgram.Ciselniky;
using System.Text.RegularExpressions;
using KSProgram.Obecne;
using System.Drawing;
using System.Collections.Generic;
using KSProgram.Diagnostics;
using KSProgram.Sluzebky;

namespace KSPortal.Controls
{
    public partial class ZadostOvydaje : UserControlPozadavek
    {
        public List<int> PreSavedBlobs
        {
            set
            {
                ViewState["VdjPreSavedBlobs"] = value;
            }
            get
            {
                object obj = ViewState["VdjPreSavedBlobs"];
                return (obj == null) ? new List<int>() : (List<int>)obj;
            }
        }

        public bool ZalohyEditMode
        {
            set
            {
                ViewState["ZalohyEditMode"] = value;
            }
            get
            {
                object obj = ViewState["ZalohyEditMode"];
                return (obj == null) ? true : (bool)obj;
            }
        }

        public bool VydajeEditMode
        {
            set
            {
                ViewState["VydajeEditMode"] = value;
            }
            get
            {
                object obj = ViewState["VydajeEditMode"];
                return (obj == null) ? true : (bool)obj;
            }
        }

        public string ProjektMode
        {
            set
            {
                ViewState["ProjektMode"] = value;
            }
            get
            {
                object obj = ViewState["ProjektMode"];
                return (obj == null) ? "" : (string)obj;
            }
        }

        public string KurzMode
        {
            set
            {
                ViewState["KurztMode"] = value;
            }
            get
            {
                object obj = ViewState["KurztMode"];
                return (obj == null) ? "" : (string)obj;
            }
        }

        public string ScanMode
        {
            set
            {
                ViewState["ScanMode"] = value;
            }
            get
            {
                object obj = ViewState["ScanMode"];
                return (obj == null) ? "" : (string)obj;
            }
        }

        public bool ObedyEditMode
        {
            set
            {
                ViewState["ObedyEditMode"] = value;
            }
            get
            {
                object obj = ViewState["ObedyEditMode"];
                return (obj == null) ? true : (bool)obj;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            //PR 26.01.2022 již není potřeba, přesměroval jsem to na Prilohy.aspx
            //KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto(); //PR 1.9.2014 
            //NameValueCollection querystr = qsc.DecryptRequestQuery();
            //string ls_DoklId = InputChecker.CeleCislo(querystr["getDokl"], "getDokl");
            //string ls_DoklName = InputChecker.Text(querystr["DoklName"], "DoklName");

            //if (ls_DoklId != null && ls_DoklId.Length > 0)
            //{
            //    GetDokl(ls_DoklId, ls_DoklName);
            //}
        }

        public override void Nacist()
        {
            KSTrace.WriteLine("ZadostOvydaje.Nacist start");
            base.Nacist();

            PreSavedBlobs = null; //PR 07.01.2019 

            short li_pomer = 0;

            //WorkflowMaster wf = new WorkflowMaster(PozId, "vydaje", null);            
            WorkflowMaster wf = WF;//PR 17.04.2020 

            string Form1Mode = wf.Get_UN("", "Form1", "Mode");
            string zalMode = wf.Get_UN("", "Zalohy", "Mode");
            string vydMode = wf.Get_UN("", "Vydaje", "Mode");
            string obdMode = wf.Get_UN("", "Obedy", "Mode");
            string dopMode = wf.Get_UN("", "Doplatek", "Mode");
            //PR 08.04.2020 výpis UN nastavení
            KSTrace.WriteLine("ZadostOvydaje.Form1.Mode=" + Form1Mode);
            KSTrace.WriteLine("ZadostOvydaje.Zalohy.Mode=" + zalMode);
            KSTrace.WriteLine("ZadostOvydaje.Vydaje.Mode=" + vydMode);
            KSTrace.WriteLine("ZadostOvydaje.Obedy.Mode=" + obdMode);
            KSTrace.WriteLine("ZadostOvydaje.Doplatek.Mode=" + dopMode);

            ZalohyEditMode = zalMode.Equals("edit");
            VydajeEditMode = vydMode.Equals("edit");

            //PR 04.01.2019 ---------------------------------------------------
            if (obdMode.Equals(""))
                ObedyEditMode = VydajeEditMode; //aby to u zakazniku fungovalo stejne, pokud si novou vlastnost nenastavi
            else
                ObedyEditMode = obdMode.Equals("edit");


            ProjektMode = wf.Get_UN("Vydaje", "Projekt", "Mode");
            KurzMode = wf.Get_UN("Vydaje", "Kurz", "Mode");
            ScanMode = wf.Get_UN("Vydaje", "Scan", "Mode");
            if (ScanMode == "") ScanMode = "required"; //aby to u zakazniku fungovalo stejne, pokud si novou vlastnost nenastavi
            //-----------------------------------------------------------------

            if (wf.FazeZprac > 1 && Form1Mode == "insert") throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Form1.mode=Insert !");
            if ((Form1Mode == "readonly" || Form1Mode == "") && ZalohyEditMode) throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Pokud je Zalohy.Mode=Edit, pak nemůže být Form1.Mode=ReadOnly !");
            if ((Form1Mode == "readonly" || Form1Mode == "") && VydajeEditMode) throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Pokud je Vydaje.Mode=Edit, pak nemůže být Form1.Mode=ReadOnly !");
            //PR 04.01.2019 
            if ((Form1Mode == "readonly" || Form1Mode == "") && ObedyEditMode) throw new Exception("Nesprávné nastavení workflow - Krok " + wf.FazeZprac + " Pokud je Obedy.Mode=Edit, pak nemůže být Form1.Mode=ReadOnly !");
            
            if (Form1Mode == "insert")
            {
                Vydavatel = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();

                if (false == Prac_pom.Platny_Pomer_Den(Vydavatel, DateTime.Today, out li_pomer))
                    MessageBox.Show(Page, WebControlHelper.ZmenaTextu("[%Zaměstnanec nemá platný pracovní poměr%]!"));
                else
                {
                    VydavatelCisloPom = li_pomer;
                    FormView1.ChangeMode(FormViewMode.Insert);                    
                }
            }
            else if (Form1Mode == "edit")
                FormView1.ChangeMode(FormViewMode.Edit);
            else
                FormView1.ChangeMode(FormViewMode.ReadOnly);

            ObjectDataSource1.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();
            if (Form1Mode != "insert")                
                Vydavatel = (decimal)(FormView1.DataItem as DataRowView).Row["os_cislo"];
            if (Form1Mode == "insert")
            {
                WebControlHelper.SubCtrlSetValue(FormView1, "RDP_obdobi", Globals.AktObdobi);
                WebControlHelper.SubCtrlSetValue(FormView1, "TextBoxDatVyrizeniInsert", DateTime.Today.AddDays(7));
                WebControlHelper.SubCtrlSetValue(FormView1, "zamestnanec_Lab", Pracovnik.OsCisloPrijmeniJmeno(Vydavatel));
                string sql = "select p.prac_str, s.cis_divize from prac_pom p, stred s where p.os_cislo=" + SqlPrikaz.ValueToString(Vydavatel)
                    + " and p.cislo_pom=" + SqlPrikaz.ValueToString(li_pomer) + " and s.str=p.prac_str";
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    if (reader.Read())
                    {
                        string str = GetNullOrData.GetString(reader, 0, "", true);
                        int? div = GetNullOrData.GetInt32(reader, 1);
                        WebControlHelper.SubCtrlSetValue(FormView1, "prac_str_Lab", str);
                        WebControlHelper.SubCtrlSetValue(FormView1, "divize_Lab", div);
                    }
                    reader.Close();
                }
                WebControlHelper.SubCtrlSetValue(FormView1, "bu_Lab", KSProgram.Personal.Platby.GetUcet(Vydavatel, DateTime.Today)); //PR 16.11.2020 HID=52538 Reifka
            }

            ODS_CisStredisko.SelectParameters["datum"].DefaultValue = DateTime.Today.ToString();
            ODS_CisStredisko.SelectParameters["os_cislo"].DefaultValue = Vydavatel.ToString();

            ODS_CisProjekty.SelectParameters["datum"].DefaultValue = DateTime.Today.ToString();
            ODS_CisProjekty.SelectParameters["os_cislo"].DefaultValue = Vydavatel.ToString();

            ODS_cis_bk.SelectParameters["os_cislo"].DefaultValue = Vydavatel.ToString(); //PR 03.07.2020

            LV_zalohy.Visible = zalMode.Equals("hidden")==false; //PR 27.11.2017 HID=39110
            ODS_zalohy.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
            //ODS_zalohy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = zalMode.Equals("edit") ? ((Globals.OsCisloAktUser == Vydavatel) ? "5" : "2") : "0"; //PR 08.04.2020 HID=50906
            ODS_zalohy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = zalMode.Equals("edit") ? ((Globals.OsCisloAktUserNeboZastupovany == Vydavatel) ? "5" : "2") : "0"; //PR 15.02.2021 HID=54613
            LV_zalohy.DataSourceID = "ODS_zalohy";
            LV_zalohy.DataBind();

            ODS_vydaje.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
            //ODS_vydaje.SelectParameters["pocetPrazdnychRadku"].DefaultValue = vydMode.Equals("edit") ? ((Globals.OsCisloAktUser == Vydavatel) ? "25" : "2") : "0"; //PR 08.04.2020 HID=50906
            ODS_vydaje.SelectParameters["pocetPrazdnychRadku"].DefaultValue = vydMode.Equals("edit") ? ((Globals.OsCisloAktUserNeboZastupovany == Vydavatel) ? "25" : "5") : "0"; //PR 15.02.2021 HID=54613
            LV_vydaje.DataSourceID = "ODS_vydaje";
            LV_vydaje.DataBind();

            LV_obedy.Visible = obdMode.Equals("hidden") == false; //PR 04.01.2019 
            ODS_obedy.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
            //ODS_obedy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = obdMode.Equals("edit") ? ((Globals.OsCisloAktUser == Vydavatel) ? "50" : "2") : "0"; //PR 08.04.2020 HID=50906
            ODS_obedy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = obdMode.Equals("edit") ? ((Globals.OsCisloAktUserNeboZastupovany == Vydavatel) ? "50" : "5") : "0"; //PR 15.02.2021 HID=54613
            LV_obedy.DataSourceID = "ODS_obedy";
            LV_obedy.DataBind();

            LV_doplatek.Visible = dopMode.Equals("hidden") == false;//PR 21.12.2020 
            ODS_doplatek.SelectParameters["id_poz"].DefaultValue = PozId.ToString();
            LV_doplatek.DataSourceID = "ODS_doplatek";
            LV_doplatek.DataBind();

            KSTrace.WriteLine("ZadostOvydaje.Nacist end");
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        /// <summary>
        /// Po aktualizaci záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }
                
        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());
            KSTrace.WriteLine("ZadostOvydaje.FormView1_DataBound");

            //PR 05.04.2022 HID=58438            
            if (Parametr_cti.Get("slc_bank_ucet") == "n")
            {
                FormView1.FindControl("bank_ucet_Row").Visible = false;
            }
        }
        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["id_poz"] = this.PozId;

            DateTime d = (DateTime)WebControlHelper.SubCtrlGetValueDate(this, "HF_obdobi");
            e.InputParameters["obdobi"] = d;

            TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
            e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));
        }
        
        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }
        
        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadDatePicker obdobi = (TRadDatePicker)WebControlHelper.FindControl(this, "RDP_obdobi");
            e.InputParameters["obdobi"] = (obdobi.SelectedDate == null ? Globals.AktObdobi : obdobi.SelectedDate);

            TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
            e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

            //PR 17.3.2017 
            //decimal ldc_oscislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
            //short li_pomer = 0;
            //Prac_pom.Platny_Pomer_Den(ldc_oscislo, DateTime.Today, out li_pomer);
            e.InputParameters["os_cislo"] = Vydavatel;//ldc_oscislo;
            e.InputParameters["cislo_pom"] = VydavatelCisloPom;//li_pomer;
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);            
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }

        private bool _SaveCommandIsProcessed { get; set; }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            KSTrace.WriteLine("ZadostOvydaje.CommandRouter(" + e.CommandName.ToString() + ") start");
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                _SaveCommandIsProcessed = true;
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                        if (PozId > 0)
                        {
                            ODS_zalohy.UpdateParameters["original_id_poz"].DefaultValue = PozId.ToString();
                            ODS_zalohy.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
                            for (int r = 0; r < LV_zalohy.Items.Count; r++)
                            {
                                ListViewDataItem item = LV_zalohy.Items[r];

                                int oldrowid = (int)LV_zalohy.DataKeys[r].Values["radek"]; //WebControlHelper.SubCtrlGetValueNumber(item, "orig_radek_HF");
                                int rowid = (int)WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB");
                                if (oldrowid != 0 || rowid != 0)
                                {   //Update obslouzi update, insert i delete
                                    WebControlHelper.SubCtrlSetValue(item, "id_poz_HF", PozId);
                                    LV_zalohy.UpdateItem(item.DataItemIndex, false);
                                } //else PRAZDNY RADEK !!!!                        
                            }

                            ODS_vydaje.UpdateParameters["original_id_poz"].DefaultValue = PozId.ToString();
                            ODS_vydaje.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
                            for (int r = 0; r < LV_vydaje.Items.Count; r++)
                            {
                                ListViewDataItem item = LV_vydaje.Items[r];

                                int oldrowid = (int)LV_vydaje.DataKeys[r].Values["radek"]; //WebControlHelper.SubCtrlGetValueNumber(item, "orig_radek_HF");
                                int rowid = (int)WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB");
                                if (oldrowid != 0 || rowid != 0)
                                {   //Update obslouzi update, insert i delete
                                    WebControlHelper.SubCtrlSetValue(item, "id_poz_HF", PozId);
                                    LV_vydaje.UpdateItem(item.DataItemIndex, false);
                                } //else PRAZDNY RADEK !!!!                        
                            }

                            PreSavedBlobs = null;//PR 07.01.2019 

                            //ODS_obedy.UpdateParameters["original_id_poz"].DefaultValue = PozId.ToString();
                            ODS_obedy.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
                            for (int r = 0; r < LV_obedy.Items.Count; r++)
                            {
                                ListViewDataItem item = LV_obedy.Items[r];

                                int oldrowid = (int)LV_obedy.DataKeys[r].Values["id"]; //WebControlHelper.SubCtrlGetValueNumber(item, "orig_radek_HF");
                                int radek = (int)WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB");
                                if (oldrowid != 0 || radek != 0)
                                {   //Update obslouzi update, insert i delete
                                    WebControlHelper.SubCtrlSetValue(item, "id_poz_HF", PozId);
                                    LV_obedy.UpdateItem(item.DataItemIndex, false);
                                } //else PRAZDNY RADEK !!!!                        
                            }
                        }
                        else
                            throw new Exception("Nepodařilo zjistit id požadavku");
                    }
                }
                _SaveCommandIsProcessed = false;
            }
            else if (e.CommandName.ToString() == "Cancel" || e.CommandName.ToString() == "Storno")
            {
                //PR 07.01.2019 musím smazat nově přidané přílohy, které jsem už při validaci uložil do info_blob
                List<int> lo_preSaved = PreSavedBlobs;
                foreach (int blobid in lo_preSaved)
                {
                    SqlPrikaz.ExecuteNonQuery("DELETE FROM info_blob WHERE pouziti="+vdj_polozky.Info_Blob_Id_Pouziti+" and id=" + blobid);
                }
                PreSavedBlobs = null;
            }

            KSTrace.WriteLine("ZadostOvydaje.CommandRouter(" + e.CommandName.ToString() + ") end");
        }

        //protected Boolean IsInEditMode(Control o)
        //{
        //    Control c;
        //    bool editace = false;

        //    if (o.Visible == false) return false;

        //    if (o == FormView1)
        //    {
        //        editace = (FormView1.CurrentMode != FormViewMode.ReadOnly);
        //    }            
        //    else if (o == LV_zalohy)
        //    {
        //        //c = LV_zalohy.FindControl("AddBtn");
        //        //if (c != null) editace = c.Visible;
        //        string ZalMode = wf.Get_UN("", "Zalohy", "Mode");
        //    }
        //    else if (o == LV_vydaje)
        //    {

        //    }            
        //    return editace;
        //}

        public void LV_zalohy_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;

            if (ZalohyEditMode == false)
            {
                e.IsValid = true;
                return;
            }
            
            bool lb_prazdnyRadek;
            int ll_row = 0;

            foreach (ListViewDataItem item in LV_zalohy.Items)
            {                
                lb_prazdnyRadek = true;
                //INPUT CHECKER je v WebControlHelper.GetValue, ktera je volana vsemi nasledujicimi funkcemi
                int ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB").Value;
                lb_prazdnyRadek = ll_rowId == 0;
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //musim pocitat visible radky
                    decimal? ldc_castka; string ls_mena;
                    try
                    {
                        ldc_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB", true, "Částka");                        
                        ls_mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL", true, "Měna");
                    }
                    catch (NoticeException err1)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + err1.ExceptionTag + "%] !";
                        e.IsValid = false;
                        return;
                    }
                    catch (Exception err2)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Chyba%] - " + err2.Message + " !";
                        e.IsValid = false;
                        return;
                    }

                    //POVINNÉ POLOŽKY
                    if (ldc_castka == null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Částka%] !");
                        e.IsValid = false;
                        return;
                    }
                    if (String.IsNullOrEmpty(ls_mena))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Měna%] !");
                        e.IsValid = false;
                        return;
                    }                    
                }
            }
        }

        /// <summary>
        /// Vrací počet záloh
        /// </summary>
        [WFProperty]
        public int ZalohyPocet
        {//PR 04.02.2019 HID=44092
            get
            {
                int p = 0;
                if (ZalohyEditMode)
                {
                    foreach (ListViewDataItem item in LV_zalohy.Items)
                    {
                        bool lb_prazdnyRadek = true;
                        int ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB").Value;
                        lb_prazdnyRadek = ll_rowId == 0;
                        if (lb_prazdnyRadek == false)
                        {
                            decimal? ldc_castka;
                            try
                            {
                                ldc_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB", true, "Částka");
                                if (ldc_castka.HasValue && ldc_castka.Value > 0)
                                    p++;

                            } catch (Exception) { }
                        }
                    }
                }
                else
                {
                    Pozadavekvydaje poz = new Pozadavekvydaje(PozId);
                    p = poz.ZalohyPocet;                    
                }
                return p;
            }
        }

        /// <summary>
        /// Vrací sumu záloh přepočítaných na tuzemskou měnu
        /// </summary>
        [WFProperty]
        public decimal ZalohySuma
        {//PR 04.02.2019 
            get
            {
                decimal suma = 0;
                if (ZalohyEditMode)
                {
                    foreach (ListViewDataItem item in LV_zalohy.Items)
                    {
                        bool lb_prazdnyRadek = true;
                        int ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB").Value;
                        lb_prazdnyRadek = ll_rowId == 0;
                        if (lb_prazdnyRadek == false)
                        {
                            decimal? ldc_castka; string ls_mena;
                            try
                            {
                                ldc_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB", true, "Částka");
                                ls_mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL", true, "Měna");
                                if (ldc_castka.HasValue && ldc_castka.Value != 0 && !string.IsNullOrEmpty(ls_mena))
                                {
                                    decimal? kurz = null;
                                    decimal nakl_tuz = 0;
                                    if (ls_mena.Equals(Globals.KodMeny))
                                        kurz = 1;
                                    else
                                    {
                                        KurzMeny k = new KurzMeny();
                                        if (k.Nacti(ls_mena, DateTime.Today))
                                        {
                                            kurz = k.idc_kurz / k.il_mnozstvi;
                                        }
                                    }
                                    if (kurz != null)
                                    {
                                        if (Zakaznik.IsSR())
                                            nakl_tuz = TCastka.Round(ldc_castka.Value / (decimal)kurz, 2);
                                        else
                                            nakl_tuz = TCastka.Round(ldc_castka.Value * (decimal)kurz, 2);
                                        suma += nakl_tuz;
                                    }
                                }
                            }
                            catch (Exception) { }
                        }
                    }
                }
                else
                {
                    Pozadavekvydaje poz = new Pozadavekvydaje(PozId);
                    suma = poz.ZalohySuma;
                }
                return suma;
            }
        }

        public void LV_vydaje_nastav_kurz(object sender, EventArgs e)
        {
            Control Changed = sender as Control;
            ListViewItem item = Changed.Parent as ListViewItem;

            DateTime? ld_datum = WebControlHelper.SubCtrlGetValueDate(item, "datum_DP");
            decimal? ldc_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB");
            string ls_Mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");

            //pokud je zaloha, tak datum vyplaceni zalohy ---------------------------------
            DateTime? ld_datum_zal = null;//SqlPrikaz.ExecuteScalarDateTime("Select min(datum) from vdj_polozky where id_poz="+SqlPrikaz.ValueToString(PozId) + " and typ='z' ")
            foreach (ListViewDataItem z in LV_zalohy.Items)
            {
                ld_datum_zal = WebControlHelper.SubCtrlGetValueDate(z, "datum_HF");
                if (ld_datum_zal.HasValue) break;
            }
            if (ld_datum_zal.HasValue)
                ld_datum = ld_datum_zal;
            //-----------------------------------------------------------------------------

            if (ld_datum.HasValue && ldc_castka.HasValue && !string.IsNullOrEmpty(ls_Mena))
            {
                if (ls_Mena.Equals(Globals.KodMeny))
                    WebControlHelper.SubCtrlSetValue(item, "kurz_TB", 1);
                else
                {
                    if (Zakaznik.IsSR()) //PR 22.04.2022 HID=61229
                        ld_datum = ld_datum.Value.AddDays(-1); 
                    KurzMeny k = new KurzMeny();
                    if (k.Nacti(ls_Mena, ld_datum.Value))
                    {
                        decimal ldc_kurz = TMath.Round((decimal)(k.idc_kurz / k.il_mnozstvi), 5);
                        WebControlHelper.SubCtrlSetValue(item, "kurz_TB", ldc_kurz);
                    }
                }
            }
        }

        public void LV_vydaje_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;

            if (VydajeEditMode == false)
            {
                e.IsValid = true;
                return;
            }

            LV_vydaje_PreSaveBlobs(); //PR 07.01.2019 

            bool lb_prazdnyRadek;
            int ll_row = 0;

            validator.ErrorMessage = "";

            List<string> zpus_pl_kartou = SlcCisZpusPlat.ZpusobyPlatbyFirKartou();

            foreach (ListViewDataItem item in LV_vydaje.Items)
            {
                lb_prazdnyRadek = true;
                //INPUT CHECKER je v WebControlHelper.GetValue, ktera je volana vsemi nasledujicimi funkcemi
                int ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB").Value;
                lb_prazdnyRadek = ll_rowId == 0;
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //musim pocitat visible radky
                    DateTime? ld_datum = null;
                    decimal? ldc_castka = null, ldc_kurz = null;
                    string ls_mena = null, ls_druh = null, ls_pozn = null, ls_pl = null, ls_cis_bk = null, ls_str = null, ls_kurz = null;
                    int? ll_id_proj = null;
                    try
                    {
                        ld_datum = WebControlHelper.SubCtrlGetValueDate(item, "datum_DP", true, "Datum");
                        ldc_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB", true, "Částka");
                        ls_mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL", true, "Měna");
                        ls_druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL", true, "Druh výdaje");
                        ls_pozn = WebControlHelper.SubCtrlGetValueString(item, "pozn_TB", true, "Popis výdaje/na co byl použit");
                        ls_pl = WebControlHelper.SubCtrlGetValueString(item, "pl_DDL", true, "Způsob platby");
                        ls_cis_bk = WebControlHelper.SubCtrlGetValueString(item, "cis_bk_DDL", true, "Platební karta");//PR 29.03.2021 
                        ls_str = WebControlHelper.SubCtrlGetValueString(item, "str_DDL", true, "Středisko");
                        ll_id_proj = WebControlHelper.SubCtrlGetValueNumber(item, "id_proj_DDL", true, "Projekt");
                        ls_kurz = WebControlHelper.SubCtrlGetValueString(item, "kurz_TB", false, "Kurz");

                        if (ld_datum.HasValue && ldc_castka.HasValue && !string.IsNullOrEmpty(ls_mena))//PR 04.11.2020 kurz kontroluji až zadá všechna pole dle kterých se kurz odvíjí
                        {
                            //PR 04.11.2020 HID=53390
                            if (ls_kurz == "dle ČNB" || ls_kurz == "dle ECB" || ls_kurz == "")
                            {
                                LV_vydaje_nastav_kurz(WebControlHelper.FindControl(item, "castka_TB"), e);
                                ls_kurz = WebControlHelper.SubCtrlGetValueString(item, "kurz_TB", false, "Kurz");
                            }
                            if (ls_kurz.Contains("=")) //Kurz zadany ve formatu 1000ZAR=27,57CZK prevedu na 0,02757
                            {
                                KurzMeny k = new KurzMeny();
                                //Regex regex = new Regex(@"^([1-9][0-9]*)[A..Z]{3}=([1-9][0-9]*)[A..Z]{3}$");
                                //Regex regex = new Regex(@"^-?(0|[1-9][0-9]*)(\" + CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator + @"[0-9]+)?$");
                                //if (regex.IsMatch(ls_kurz) && k.Set(ls_kurz))
                                //PR 03.03.2022 HID=60191 EN a decimal separator
                                if (k.Set(ls_kurz))
                                {
                                    ldc_kurz = TMath.Round((decimal)(k.idc_kurz / k.il_mnozstvi), 5);
                                    WebControlHelper.SubCtrlSetValue(item, "kurz_TB", ldc_kurz);
                                }
                                else
                                {
                                    validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%Kurz%] !<br/>";
                                    e.IsValid = false;
                                    //return;
                                }
                            }
                            else
                            {
                                //Regex regex = new Regex(@"^(0|[1-9][0-9]*)(,[0-9]+)?$");
                                //if (!regex.IsMatch(ls_kurz))
                                //{
                                //    validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%Kurz%] !<br/>";
                                //    e.IsValid = false;
                                //    //return;
                                //}
                                //else
                                ldc_kurz = WebControlHelper.SubCtrlGetValueDecimal(item, "kurz_TB", true, "Kurz");
                            }
                        }
                    }
                    catch (NoticeException err1)
                    {
                        validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + err1.ExceptionTag + "%] !<br/>";
                        e.IsValid = false;
                        //return;
                    }
                    catch (Exception err2)
                    {
                        validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Chyba%] - " + err2.Message + " !<br/>";
                        e.IsValid = false;
                        //return;
                    }

                    //POVINNÉ POLOŽKY - test vyplnění
                    if (ld_datum == null)
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Datum%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    if (String.IsNullOrEmpty(ls_druh))//PR 23.6.2017 
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Druh výdaje%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    if (ldc_castka == null)
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Částka%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    if (String.IsNullOrEmpty(ls_mena))
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Měna%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    if (String.IsNullOrEmpty(ls_pl))
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Způsob platby%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    else if (Zakaznik.IsCurrent("RAIFFEISENBANK")) //PR 29.03.2021 HID=55858 mělo být již v HID=53633
                    {
                        //pokud je vybrán způsob platby obsahující SPK (firemní platební karta), je číslo karty povinné
                        if (zpus_pl_kartou.Contains(ls_pl) && string.IsNullOrWhiteSpace(ls_cis_bk))
                        {
                            validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Platební karta%] !<br/>");
                            e.IsValid = false;
                        }
                    }

                    if (String.IsNullOrEmpty(ls_str))
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Středisko%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }
                    //kontroly hodnot oproti číselníkům
                    else if (CisStredisko.Exists(ls_str) == false) //kontrola existence střediska
                    {
                        validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Středisko neexistuje%] !<br/>";
                        e.IsValid = false;
                        //return;
                    }

                    if (ll_id_proj != null)
                    {
                        if (CisProjekty.Exists(ll_id_proj.Value) == false) //kontrola existence projektu
                        {
                            validator.ErrorMessage += "[%Chybně vyplněn řádek%] " + ll_row + ": [%Projekt neexistuje%] !<br/>";
                            e.IsValid = false;
                            //return;
                        }
                    }
                    else if (ProjektMode == "required") //PR 04.01.2019 
                    {
                        validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Projekt%] !<br/>");
                        e.IsValid = false;
                        //return;
                    }


                    HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;
                    RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");
                    if (string.IsNullOrEmpty(blobid1_HF.Value) && fu1.UploadedFiles.Count == 0)
                    {
                        if (ScanMode == "required") //PR 04.01.2019 
                        {
                            validator.ErrorMessage += WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                + ": [%Není vyplněna povinná položka%] [%Doklad%] !<br/>");
                            e.IsValid = false;
                            //return;
                        }
                    }

                    if (fu1.UploadedFiles.Count == 1)
                    {
                        string f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
                        if (f1 != null && f1.Length > 50)
                        {
                            validator.ErrorMessage += string.Format(WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Doklad%] - [%Název souboru nesmí být delší než {0} znaků%] !<br/>"), 50);
                            e.IsValid = false;
                            //return;
                        }
                    }
                }
            }
        }

        protected void LV_vydaje_PreSaveBlobs()
        {
            //řešeno zmizení dokladů pokud validace náhrad neprojde
            
            List<int> lo_preSaved = PreSavedBlobs;
            foreach (ListViewDataItem item in LV_vydaje.Items)
            {
                int? blobid1 = null;
                HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;                
                HiddenField blobid1n_HF = item.FindControl("blobid1n_HF") as HiddenField;                
                try
                {
                    if (blobid1_HF.Value.Length > 0) blobid1 = Int32.Parse(blobid1_HF.Value);
                }
                catch (FormatException) { }                
                string f1;

                RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");

                if (fu1.UploadedFiles.Count == 1)
                {
                    //f1 = InputChecker.Text(System.IO.Path.GetFileName(fu1.FileName), "blobid1_FU.FileName");
                    //byte[] data1 = fu1.FileBytes;
                    f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
                    if (f1.Length > 50)
                    {
                        //neukládám nechám zařvat validátor na délku souboru
                    }
                    else if (fu1.UploadedFiles[0].ContentLength > 0) //PR 30.11.2018 nulova velikost souboru
                    {
                        byte[] data1 = new byte[fu1.UploadedFiles[0].ContentLength];
                        fu1.UploadedFiles[0].InputStream.Read(data1, 0, (int)fu1.UploadedFiles[0].ContentLength);
                        SqlPrikaz.SaveByteToInfoBlob(ref blobid1, Vydavatel, 0, vdj_polozky.Info_Blob_Id_Pouziti, null, null, data1, true, null, null, null);
                        blobid1_HF.Value = blobid1 == null ? "" : blobid1.ToString();//nefunguje (do update jde blobid1=null)
                        blobid1n_HF.Value = f1;
                        fu1.UploadedFiles.Clear(); //aby neprobehlo vicekrat (je volano z validace a ta probehne nevim proc 2x)   
                        lo_preSaved.Add(blobid1.Value);
                    }
                    else
                    {
                        blobid1_HF.Value = "";
                        blobid1n_HF.Value = "";
                        fu1.UploadedFiles.Clear();
                    }
                }
                //zviditelním checkbox, aby, kdyz neklapne validace, bylo videt, ze soubor je nahran.
                TRadButton c1 = item.FindControl("SmazB1_RB") as TRadButton;
                c1.Text = "Smaž " + blobid1n_HF.Value;
                c1.Visible = !String.IsNullOrEmpty(blobid1_HF.Value);                
            }
            PreSavedBlobs = lo_preSaved;
        }

        protected int LastVisibleRow(ListView lv)
        {
            int i = -1;
            //musím jít od konce, protoze mezi visible radky mohou byt skryte radky
            for (int r = lv.Items.Count - 1; r >= 0; r--)
            {
                if (lv.Items[r].Visible)
                    return r;
            }
            return i;
        }

        protected int MaxIntValueInListView(ListView lv, string controlName)
        {
            int max = 0;
            int? v;

            for (int r = 0; r < lv.Items.Count; r++)
            {
                v = WebControlHelper.SubCtrlGetValueNumber(lv.Items[r], controlName);
                if (v != null && v > max)
                    max = v.Value;
            }
            return max;
        }


        protected void LV_zalohy_PreRender(object sender, EventArgs e)
        {
            List<string> zpus_pl_kartou = SlcCisZpusPlat.ZpusobyPlatbyFirKartou();
            foreach (ListViewDataItem item in LV_zalohy.Items)
            {
                if (WebControlHelper.SubCtrlGetValueString(item, "radek_TB") == "0")
                {
                    item.Visible = false;
                }

                //PR 01.08.2022 vrazil jsem možnost zadat číslo BK i do záloh (nikdo to nepostrádal, ale v SC to u záloh taky je)
                //---------------------------------------------------------------------------------------------------------------
                RadDropDownList cis_bk_DDL = item.FindControl("cis_bk_DDL") as RadDropDownList;
                RadDropDownList pl_DDL = item.FindControl("pl_DDL") as RadDropDownList;
                
                if (pl_DDL.SelectedValue != null && zpus_pl_kartou.Contains(pl_DDL.SelectedValue))
                    cis_bk_DDL.CssClass = "";
                else
                    cis_bk_DDL.CssClass = "hidden";

                if (Zakaznik.IsCurrent("RAIFFEISENBANK")) 
                    cis_bk_DDL.CssClass += (cis_bk_DDL.CssClass == "" ? "" : " ") + "povinne-pole";
                //---------------------------------------------------------------------------------------------------------------
            }
            Control c = WebControlHelper.FindControl(LV_zalohy, "AddBtn");
            if (c != null)
                c.Visible = ZalohyEditMode;
        }

        protected void LV_zalohy_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            int r, ll_rowid;
            ListViewItem item;
            if (!ZalohyEditMode) return;
            switch (e.CommandName as string)
            {
                case "AddRadek":
                    r = LastVisibleRow(LV_zalohy);

                    if (r < LV_zalohy.Items.Count - 1)
                    {
                        item = LV_zalohy.Items[r + 1];
                        ll_rowid = 1 + Math.Max(MaxIntValueInListView(LV_zalohy, "radek_TB"), MaxIntValueInListView(LV_vydaje, "radek_TB"));
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", ll_rowid);
                        //DateTime? dat = null;
                        if (r >= 0)
                        {
                            //dat = WebControlHelper.SubCtrlGetValueDate(LV_zalohy.Items[r], "datum_TB");
                            //if (dat.HasValue)
                            //    WebControlHelper.SubCtrlSetValue(item, "datum_TB", dat);
                        }
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", Globals.KodMeny);
                        //WebControlHelper.SubCtrlSetValue(item, "kurz_TB", "1");
                        WebControlHelper.SubCtrlSetValue(item, "pl_DDL", "U");
                        item.Visible = true;
                    }
                    else MessageBox.Alert(Page, "Dosaženo maximálního počtu řádků");
                    break;
                case "DelRadek":
                    r = e.Item.DataItemIndex;
                    if (r >= 0)
                    {
                        item = LV_zalohy.Items[r];
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", "0");
                        //WebControlHelper.SubCtrlSetValue(item, "datum_TB", "");
                        //WebControlHelper.SubCtrlSetValue(item, "druh_DDL", "");
                        WebControlHelper.SubCtrlSetValue(item, "castka_TB", "");
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", "");
                        item.Visible = false;
                    }
                    break;
            }
        }

        protected void LV_vydaje_PreRender(object sender, EventArgs e)
        {
            List<string> zpus_pl_kartou = SlcCisZpusPlat.ZpusobyPlatbyFirKartou();
            foreach (ListViewDataItem item in LV_vydaje.Items)
            {
                if (WebControlHelper.SubCtrlGetValueString(item, "radek_TB") == "0")
                {
                    item.Visible = false;
                }

                //PR 03.07.2020 pro Reifku
                RadDropDownList cis_bk_DDL = item.FindControl("cis_bk_DDL") as RadDropDownList;
                RadDropDownList pl_DDL = item.FindControl("pl_DDL") as RadDropDownList;
                //if (pl_DDL.SelectedValue != null && (pl_DDL.SelectedValue == "F" || pl_DDL.SelectedValue == "V"))
                //PR 11.12.2020 HID=53633
                if (pl_DDL.SelectedValue != null && zpus_pl_kartou.Contains(pl_DDL.SelectedValue))
                    cis_bk_DDL.CssClass = "";
                else
                    cis_bk_DDL.CssClass = "hidden";

                if (Zakaznik.IsCurrent("RAIFFEISENBANK")) //PR 29.03.2021 HID=55858 mělo být již v HID=53633
                    cis_bk_DDL.CssClass += (cis_bk_DDL.CssClass == "" ? "" : " ") + "povinne-pole";

                //PR 12.11.2020 HID=53493
                if (Zakaznik.IsCurrent("PHOENIX GROUP"))
                    (item.FindControl("pozn_TB") as TTextBox).MaxLength = 30;
            }
            //PR 08.01.2019 HID=43333 SCS Software
            Control c = WebControlHelper.FindControl(LV_vydaje, "AddBtn");
            if (c != null) //Header a Footer jsou dostupne
            {
                c.Visible = VydajeEditMode;
                WebControlHelper.FindControl(LV_vydaje, "td_id_proj_t").Visible = ProjektMode != "hidden";
                WebControlHelper.FindControl(LV_vydaje, "td_id_kurz_t").Visible = KurzMode != "hidden";
                WebControlHelper.FindControl(LV_vydaje, "td_id_blobid1_t").Visible = ScanMode != "hidden";
                if (Zakaznik.IsCurrent("RAIFFEISENBANK")) //PR 10.12.2020 TID=3564
                    (WebControlHelper.FindControl(LV_vydaje, "id_proj_t_Lab") as TLabel).Text = ReadGlobalResource.ZmenaTextu("[%Zakázka%]");
            }
        }

        protected void LV_vydaje_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            int r, ll_rowid;            
            ListViewItem item;
            if (!VydajeEditMode) return;
            switch (e.CommandName as string)
            {
                case "AddRadek":
                    r = LastVisibleRow(LV_vydaje);

                    if (r < LV_vydaje.Items.Count - 1)
                    {
                        item = LV_vydaje.Items[r + 1];
                        ll_rowid = 1 + Math.Max(MaxIntValueInListView(LV_zalohy, "radek_TB"), MaxIntValueInListView(LV_vydaje, "radek_TB"));
                        //PR 18.7.2016 HID=33523 aby pri pridani radku do vydaju pri jiz existujicim doplatku nevznikla duplicita
                        int? ll_doplatek = WebControlHelper.SubCtrlGetValueNumber(LV_doplatek, "radek_TB");
                        if (ll_doplatek.HasValue && ll_rowid == ll_doplatek.Value) ll_rowid++;
                        //--
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", ll_rowid);
                        DateTime? dat = null;
                        string prac_str = "";
                        string pl = "";
                        if (r >= 0)
                        {
                            dat = WebControlHelper.SubCtrlGetValueDate(LV_vydaje.Items[r], "datum_DP");
                            prac_str = WebControlHelper.SubCtrlGetValueString(LV_vydaje.Items[r], "str_DDL");
                            pl = WebControlHelper.SubCtrlGetValueString(LV_vydaje.Items[r], "pl_DDL");

                            //PR 04.11.2020 HID=53390 teprve ted nastavim kurz u predchoziho radku, zbytek se předvyplní při validaci
                            string ls_kurz = WebControlHelper.SubCtrlGetValueString(LV_vydaje.Items[r], "kurz_TB", false, "Kurz");
                            if (ls_kurz == "dle ČNB" || ls_kurz == "dle ECB" || ls_kurz == "")
                                LV_vydaje_nastav_kurz(WebControlHelper.FindControl(LV_vydaje.Items[r], "castka_TB"), e);
                        }
                        else
                        {
                            short cislo_pom = Prac_pom.Platny_Pomer(Vydavatel, Globals.AktObdobi);
                            if (cislo_pom >= 0)
                            { 
                                //prac_str = Prac_pom.Get_prac_str(Vydavatel, cislo_pom);                                
                                //PR 6.11.2020 TID = 3521 Nákladová střediska pro Raifku, mají je v režijní zakázce
                                object[] polozky;
                                Prac_pom.GetPolozky(Vydavatel, cislo_pom, new string[] { "prac_str", "rez_zakazka" }, Globals.AktObdobi, out polozky);
                                prac_str = ((string)polozky[0]).TrimEnd();
                                if (polozky[1] != null && !DBNull.Value.Equals(polozky[1]) && !String.IsNullOrEmpty((string)polozky[1]))
                                {
                                    string rez_zakazka = ((string)polozky[1]).TrimEnd();
                                    if (CisStredisko.Exists(rez_zakazka))
                                        prac_str = rez_zakazka;
                                }
                            }
                        }
                        if (dat.HasValue)
                            WebControlHelper.SubCtrlSetValue(item, "datum_DP", dat);
                        WebControlHelper.SubCtrlSetValue(item, "str_DDL", prac_str);
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", Globals.KodMeny);
                        //PR 04.11.2020 HID=53390 přednastavení způs. platby dle předchozího řádku
                        if (!string.IsNullOrEmpty(pl))
                            WebControlHelper.SubCtrlSetValue(item, "pl_DDL", pl);
                        //WebControlHelper.SubCtrlSetValue(item, "kurz_TB", "1");
                        //PR 04.11.2020 HID=53390 zrušil jsem postback LV_nastav_kurz, kurz nastavím až při validaci
                        if (Zakaznik.IsSR())
                            WebControlHelper.SubCtrlSetValue(item, "kurz_TB", "dle ECB");
                        else
                            WebControlHelper.SubCtrlSetValue(item, "kurz_TB", "dle ČNB");
                        item.Visible = true;
                    }
                    else MessageBox.Alert(Page, "Dosaženo maximálního počtu řádků");
                    break;
                case "DelRadek":                    
                    r = e.Item.DataItemIndex;
                    if (r >= 0)
                    {
                        item = LV_vydaje.Items[r];
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", "0");
                        WebControlHelper.SubCtrlSetValue(item, "datum_DP", "");
                        WebControlHelper.SubCtrlSetValue(item, "druh_DDL", "");
                        WebControlHelper.SubCtrlSetValue(item, "castka_TB", "");
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", "");
                        item.Visible = false;
                    }
                    break;
                case "DelDoklad":                    
                    int? blobid1 = null;
                    HiddenField blobid1_HF = e.Item.FindControl("blobid1_HF") as HiddenField;
                    HiddenField blobid1n_HF = e.Item.FindControl("blobid1n_HF") as HiddenField;
                    HyperLink HyperLink1 = e.Item.FindControl("HyperLink1") as HyperLink;
                    TRadButton SmazB1_RB = e.Item.FindControl("SmazB1_RB") as TRadButton;
                    RadAsyncUpload fu1 = (RadAsyncUpload)e.Item.FindControl("RadAsyncUpload1");
                    try
                    {
                        if (blobid1_HF.Value.Length > 0) blobid1 = Int32.Parse(blobid1_HF.Value);
                    }
                    catch (FormatException) { }
                    if (blobid1.HasValue && blobid1.Value > 0)
                    {
                        SqlPrikaz.ExecuteNonQuery("DELETE FROM info_blob WHERE pouziti=" + vdj_polozky.Info_Blob_Id_Pouziti + " and id=" + blobid1.Value);
                        blobid1_HF.Value = "";
                        blobid1n_HF.Value = "";
                        HyperLink1.Visible = false;
                        SmazB1_RB.Visible = false;
                        fu1.Visible = true;
                    }
                    break;
            }
        }

        protected string genOpenDoklCode(object idblobu, object DoklName)
        {
            //if (idblobu == null || DBNull.Value.Equals(idblobu) || DoklName == null || DBNull.Value.Equals(DoklName))
            //    return "";
            //else
            //{   //idpoz, aby fungovalo i na stránce pozadavky
            //    NameValueCollection args = new NameValueCollection();
            //    if (PozId>0) args.Add("idpoz", PozId.ToString());
            //    args.Add("getDokl", idblobu.ToString());
            //    args.Add("DoklName", HttpContext.Current.Server.UrlEncode((string)DoklName));
            //    KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();
            //    //PR 29.1.2015 mohlo dojít ke zdvojení ?encq - opraveno
            //    string url = HttpContext.Current.Request.Url.GetLeftPart(UriPartial.Path);

            //    url = qsc.AddEncryptQuery(url, args);
            //    return url;
            //}            
            //PR 26.01.2022 HID=60005 relativní adresa je nejspolehlivější
            return Prilohy.genDownloadUrl(Page, idblobu, DoklName);
        }
        //PR 26.01.2022 již není potřeba, přesměroval jsem to na Prilohy.aspx
        //protected void GetDokl(string docId, string docName)
        //{
        //    if (!String.IsNullOrEmpty(docId))
        //    {
        //        //byte[] data = SqlPrikaz.ExecuteScalarBlob("SELECT informace FROM info_blob WHERE pouziti=" + vdj_polozky.Info_Blob_Id_Pouziti + " and id = " + InputChecker.CeleCislo(docId.ToString(), "blobid"));
        //        int id = Convert.ToInt32(InputChecker.CeleCislo(docId.ToString(), "blobid"));
        //        //byte[] data = SqlPrikaz.LoadBlobFromInfoBlob(vdj_polozky.Info_Blob_Id_Pouziti, id);//PR 18.11.2019 
        //        byte[] data = SqlPrikaz.LoadByteFromInfoBlob(id); //PR 21.01.2020 
        //        if (data == null)//jsem již na jiné stránce (_blank page)
        //        {
        //            docName = "nenalezeno.txt";
        //            data = Encoding.UTF8.GetBytes(WebControlHelper.ZmenaTextu("[%Obsah dokumentu nenalezen v databázi%]"));
        //        }
        //        KSProgram.Attachment.Send(Page, docName, data);
        //    }
        //}

        protected void LV_vydaje_ItemUpdating(object sender, ListViewUpdateEventArgs e)
        {
            //PR 07.01.2019 uložení dáno do LV_vydaje_PreSaveBlobs()

            //ListViewDataItem item = LV_vydaje.Items[e.ItemIndex];

            //int? blobid1 = null;
            //HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;            
            //try
            //{
            //    if (blobid1_HF.Value.Length > 0) blobid1 = Int32.Parse(blobid1_HF.Value);
            //}
            //catch (FormatException) { }            
            //string f1;

            //RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");

            //ODS_vydaje.UpdateParameters["blobid1"].DefaultValue = null;
            //ODS_vydaje.UpdateParameters["blobid1n"].DefaultValue = null;


            //if (fu1.UploadedFiles.Count == 1 && fu1.UploadedFiles[0].ContentLength > 0)
            //{                
            //    f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
            //    byte[] data1 = new byte[fu1.UploadedFiles[0].ContentLength];
            //    fu1.UploadedFiles[0].InputStream.Read(data1, 0, (int)fu1.UploadedFiles[0].ContentLength);
            //    SqlPrikaz.SaveByteToInfoBlob(ref blobid1, Vydavatel, 0, vdj_polozky.Info_Blob_Id_Pouziti, null, null, data1, true, null, null, null);
            //    blobid1_HF.Value = blobid1 == null ? "" : blobid1.ToString();//nefunguje (do update jde blobid1=null)
            //    //zkusim nastavid ODS default value
            //    ODS_vydaje.UpdateParameters["blobid1"].DefaultValue = blobid1_HF.Value;
            //    ODS_vydaje.UpdateParameters["blobid1n"].DefaultValue = f1;
            //}
        }

        protected void LV_obedy_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            int r, ll_rowid;            
            ListViewItem item;
            //if (!VydajeEditMode) return;
            if (!ObedyEditMode) return; //PR 04.01.2019 
            switch (e.CommandName as string)
            {
                case "AddRadek":
                    r = LastVisibleRow(LV_obedy);

                    if (r < LV_obedy.Items.Count - 1)
                    {
                        item = LV_obedy.Items[r + 1];
                        ll_rowid = 1 + MaxIntValueInListView(LV_zalohy, "radek_TB"); //min cislo z vydaju
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", ll_rowid);
                        DateTime? dat = null;
                        if (r >= 0)
                        {
                            dat = WebControlHelper.SubCtrlGetValueDate(LV_obedy.Items[r], "datum_DP");
                            if (dat.HasValue) 
                                WebControlHelper.SubCtrlSetValue(item, "datum_DP", dat);
                        }
                        item.Visible = true;
                    }
                    else MessageBox.Alert(Page, "Dosaženo maximálního počtu řádků");
                    break;
                case "DelRadek":                    
                    r = e.Item.DataItemIndex;
                    if (r >= 0)
                    {
                        item = LV_obedy.Items[r];
                        WebControlHelper.SubCtrlSetValue(item, "radek_TB", "0");
                        WebControlHelper.SubCtrlSetValue(item, "datum_DP", "");
                        WebControlHelper.SubCtrlSetValue(item, "obedy_jmeno_TB", "");
                        WebControlHelper.SubCtrlSetValue(item, "obedy_os_cislo_HF", "");
                        WebControlHelper.SubCtrlSetValue(item, "str_TB", "");
                        WebControlHelper.SubCtrlSetValue(item, "divize_TB", "");
                        item.Visible = false;
                    }
                    break;
            }
        }
        protected void LV_obedy_PreRender(object sender, EventArgs e)
        {
            foreach (ListViewDataItem item in LV_obedy.Items)
            {
                if (WebControlHelper.SubCtrlGetValueString(item, "radek_TB") == "0")
                {
                    item.Visible = false;
                }
            }
            //WebControlHelper.FindControl(LV_obedy, "AddBtn").Visible = VydajeEditMode;
            Control c = WebControlHelper.FindControl(LV_obedy, "AddBtn");
            if (c != null)
                c.Visible = ObedyEditMode; //PR 04.01.2019 
        }
        protected void LV_obedy_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;

            //if (VydajeEditMode == false)
            if (ObedyEditMode == false) //PR 04.01.2019 
            {
                e.IsValid = true;
                return;
            }

            bool lb_prazdnyRadek;
            int ll_row = 0;

            foreach (ListViewDataItem item in LV_obedy.Items)
            {
                lb_prazdnyRadek = true;
                //INPUT CHECKER je v WebControlHelper.GetValue, ktera je volana vsemi nasledujicimi funkcemi
                int? ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_TB");
                lb_prazdnyRadek = ll_rowId == null || ll_rowId == 0;
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //musim pocitat visible radky
                    DateTime? ld_datum;
                    decimal? ldc_oscislo;
                    Boolean lb_ext_os;
                    string ls_jmeno;
                    try
                    {
                        ld_datum = WebControlHelper.SubCtrlGetValueDate(item, "datum_DP", true, "Datum");
                        ldc_oscislo = WebControlHelper.SubCtrlGetValueDecimal(item, "obedy_os_cislo_HF", true, "Příjmení a jméno");
                        ls_jmeno = WebControlHelper.SubCtrlGetValueString(item, "obedy_jmeno_TB", true, "Příjmení a jméno");
                        lb_ext_os = (item.FindControl("ext_os_ChB") as CheckBox).Checked;
                    }
                    catch (NoticeException err1)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + err1.ExceptionTag + "%] !";
                        e.IsValid = false;
                        return;
                    }
                    catch (Exception err2)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Chyba%] - " + err2.Message + " !";
                        e.IsValid = false;
                        return;
                    }

                    //POVINNÉ POLOŽKY - test vyplnění
                    bool row_found = false;
                    if (ll_rowId == null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%ID dokladu%] !");
                        e.IsValid = false;
                        return;
                    }
                    else
                    {
                        foreach (ListViewDataItem v in LV_vydaje.Items)
                        {
                            int? ll_r = WebControlHelper.SubCtrlGetValueNumber(v, "radek_TB");
                            if (ll_r.HasValue && ll_r.Value == ll_rowId)
                            {
                                row_found = true;
                                break;
                            }
                        }
                        if (!row_found)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                + ": [%Chybně vyplněna položka%] [%ID dokladu%] !");
                            e.IsValid = false;
                            return;
                        }
                    }


                    if (ld_datum == null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Datum%] !");
                        e.IsValid = false;
                        return;
                    }
                    if (lb_ext_os)
                    {
                        if (string.IsNullOrEmpty(ls_jmeno))
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Příjmení a jméno%] !");
                            e.IsValid = false;
                            return;
                        }
                    }
                    else if (ldc_oscislo == null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Příjmení a jméno%] !");
                        e.IsValid = false;
                        return;
                    }
                }
            }
        }

        protected void LV_obedy_jmeno_TB_Changed(object sender, EventArgs e)
        {
            Decimal osc = 0;
            string stred = "";
            int? divize = null;
            TTextBox tb = sender as TTextBox;
            string text = InputChecker.Text(tb.Text, tb.ID);
            bool lb_ext_os = (tb.Parent.FindControl("ext_os_ChB") as CheckBox).Checked;
            if (lb_ext_os)
            {
                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "obedy_os_cislo_HF", "");
                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "str_TB", "");
                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "divize_TB", "");
            }
            else
            {

                string prijmeni1 = "", prijmeni2 = "";
                if (text.Length > 0)
                {
                    if (text.ToLower().IndexOf("update") > 0 || text.ToLower().IndexOf("insert") > 0 || text.ToLower().IndexOf("delete") > 0) return;
                    string rok = ""; string podnik = "";
                    int p = text.IndexOf(" {r."); //{r.82}
                    if (p > 0)
                    {
                        rok = text.Substring(p + 4, 2);
                        text = text.Substring(0, p);
                    }
                    p = text.IndexOf(" {podnik "); //{podnik 12 - Název podniku} //PR 3.2.2014 
                    if (p > 0)
                    {
                        podnik = text.Substring(p + 9);
                        podnik = podnik.Substring(0, podnik.IndexOf(" "));
                        text = text.Substring(0, p);
                    }
                    string jmeno1 = "", jmeno2 = "";
                    p = text.LastIndexOf(" ");
                    if (p > 0)
                    {
                        jmeno1 = text.Substring(p + 1);
                        prijmeni1 = text.Substring(0, p);
                    }
                    p = text.IndexOf(" ");
                    if (p > 0)
                    {
                        jmeno2 = text.Substring(p + 1);
                        prijmeni2 = text.Substring(0, p);
                    }

                    string sql = "select pracovnici.os_cislo, pracovnici.kmen_str, stred.cis_divize from pracovnici, stred "
                    + "where pracovnici.kmen_str=stred.str and (";
                    if (!prijmeni1.Equals(prijmeni2)) sql += " (";
                    sql += " (UPPER(jmeno) = UPPER('" + jmeno1 + "')" + " and UPPER(prijmeni) = UPPER('" + prijmeni1 + "')) ";
                    if (!prijmeni1.Equals(prijmeni2))
                        sql += " OR (UPPER(jmeno) = UPPER('" + jmeno2 + "')" + " and UPPER(prijmeni) = UPPER('" + prijmeni2 + "')) )";
                    if (rok.Length > 0) sql += " and rodne_cislo LIKE '" + rok + "%'";
                    if (podnik.Length > 0) sql += " and id_podniku=" + podnik;
                    sql += " and (datum_vystupu is null or datum_vystupu>" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ") ";
                    sql += ")";

                    using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                    {
                        if (reader.Read())
                        {
                            osc = GetNullOrData.GetDecimal(reader, 0, 0);
                            stred = GetNullOrData.GetString(reader, 1);
                            divize = GetNullOrData.GetInt32(reader, 2);
                        }
                        if (reader.Read())
                        {
                            osc = 0; //podminka vratila vice lidi
                        }
                    }

                    if (osc < 1)
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Zaměstnanec se zadaným jménem nebyl nalezen%], [%zadávejte jméno ve tvaru příjmení mezera jméno%]!"));
                        tb.Text = "";
                    }
                }

                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "obedy_os_cislo_HF", osc);
                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "str_TB", stred);
                WebControlHelper.SubCtrlSetValue((sender as Control).Parent, "divize_TB", divize);
            }
        }

        protected void BankUcetValidator_ServerValidate(object source, ServerValidateEventArgs args)
        {
            if (FormView1.CurrentMode != FormViewMode.ReadOnly)
            {
                string ls_zpus_propl = (string.IsNullOrEmpty(Parametr_cti.Get("bv_kod"))) ? "U" : "M";
                if (ls_zpus_propl == "U")
                {
                    args.IsValid = !string.IsNullOrWhiteSpace(KSProgram.Personal.Platby.GetUcet(Vydavatel, DateTime.Today));
                }
            }
        }

        //PR 21.12.2020 zrušeno
        //protected void LV_doplatek_PreRender(object sender, EventArgs e)
        //{
        ////PR 10.12.2020 prý by byli zamci zmatení, oni si myslí, že je to způsob jakým byli výdaje zaplaceny,
        ////ne jakým způsobem bude vyplacen/sražen doplatek
        //if (Zakaznik.IsCurrent("RAIFFEISENBANK"))
        //{
        //    Control c = WebControlHelper.FindControl(LV_doplatek, "pl_Lab");
        //    if (c != null)
        //        (c as TLabel).Text = "Způsob vyrovnání";
        //}
        //}
    }
}