﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Personal;
using KSProgram.Obecne;
using System.Collections.Generic;
using Telerik.Web.UI;
using KSProgram.Ciselniky;
using KSProgram.Exceptions;
using System.Web.UI;
using System.Linq;
using System.Reflection;

public partial class Controls_ZadostOzmosudaju : UserControlPozadavek
{

    private const string css_mazani = "zmena_mazani";
    private const string css_zmena = "zmena";

    /// <summary>
    /// 
    /// </summary>
    protected bool NewPozadavek
    {
        get
        {
            return (ViewState["ZmOsUdajuMode"] == null ? false : Convert.ToBoolean(ViewState["ZmOsUdajuMode"]));
        }
        set
        {
            ViewState["ZmOsUdajuMode"] = value;
        }
    }

    /// <summary>
    /// km 2.11.2016 pridáno pro kontrolu zda byla provedena uprava databaze 
    /// </summary>
    /// <returns></returns>
    public static bool IsUpravaDbProvedena()
    {
        try
        {
            //int pocet = SqlPrikaz.ExecuteScalarInt32("select MAX(id_vzdelani) from vzdelani", 0);PH 21.7.2017 zapoznámkováno
        }
        catch 
        {
            throw new NoticeException("Kontaktujte prosím správce systému, je potřeba provést úpravu databáze.");
        }
        return true;
    }

    public override void Nacist()
    {
        base.Nacist();
        // km 2.11.2016 kontrola databaze jestli v ni jsou nové serial sloupce 
        IsUpravaDbProvedena();

        WorkflowMaster wf = new WorkflowMaster(PozId, PozadavekTyp.zmosudaju.ToString(), null);
        string val = wf.Get_UN("", "Form1", "Mode");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert" || val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        NewPozadavek = (val == "insert");
        //PH 24.1.2020 pro jistotu čistím session
        SessionInfo.RemoveVariable("rod_prisl"); SessionInfo.RemoveVariable("rod_prisl_p");
        SessionInfo.RemoveVariable("vzdelani"); SessionInfo.RemoveVariable("vzdelani_p");
        SessionInfo.RemoveVariable("jazyky"); SessionInfo.RemoveVariable("jazyky_p");
        SessionInfo.RemoveVariable("kontakty"); SessionInfo.RemoveVariable("kontakty_p");

        List <KSProgram.Pozadavky.Pozadavekzmosudaju.StrRodPrisl> rod_prisl = Pozadavekzmosudaju.InitRodPrisl(PozId, false);
        SessionInfo.SetVariable("rod_prisl", rod_prisl);

        List<KSProgram.Pozadavky.Pozadavekzmosudaju.StrVzdelani> vzdel = Pozadavekzmosudaju.InitVzdelani(PozId, false);
        SessionInfo.SetVariable("vzdelani", vzdel);

        List<KSProgram.Pozadavky.Pozadavekzmosudaju.StrJazyky> jazyky = Pozadavekzmosudaju.InitJazyky(PozId, false);
        SessionInfo.SetVariable("jazyky", jazyky);

        /*
        List<KSProgram.Pozadavky.Pozadavekzmosudaju.StrPrubehZam> prubeh = Pozadavekzmosudaju.InitPrubeh(PozId, false);
        SessionInfo.SetVariable("prubeh", prubeh);
        */

        List<StrKontakt> kontakty = Pozadavekzmosudaju.InitKontakty(PozId, false);
        SessionInfo.SetVariable("kontakty", kontakty);


        //PH 18.5.2018 načítám původní hodnoty---------------
        rod_prisl = Pozadavekzmosudaju.InitRodPrisl(PozId, !NewPozadavek);
        SessionInfo.SetVariable("rod_prisl_p", rod_prisl);

        vzdel = Pozadavekzmosudaju.InitVzdelani(PozId, !NewPozadavek);
        SessionInfo.SetVariable("vzdelani_p", vzdel);

        jazyky = Pozadavekzmosudaju.InitJazyky(PozId, !NewPozadavek);
        SessionInfo.SetVariable("jazyky_p", jazyky);

        kontakty = Pozadavekzmosudaju.InitKontakty(PozId, !NewPozadavek);
        SessionInfo.SetVariable("kontakty_p", kontakty);
        /*
        prubeh = Pozadavekzmosudaju.InitPrubeh(PozId, !NewPozadavek);
        SessionInfo.SetVariable("prubeh_p", prubeh);
        */
        //--------------------------------------------------

        KSProgram.Pozadavky.Pozadavekzmosudaju.StrDuchod duchod = Pozadavekzmosudaju.InitDuchod(PozId);
        SessionInfo.SetVariable("duchod", duchod);

        KSProgram.Pozadavky.Pozadavekzmosudaju.StrZps zps = Pozadavekzmosudaju.InitZps(PozId);
        SessionInfo.SetVariable("zps", zps);

      

        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        if (val == "edit")
        {
            object o = DataBinder.Eval(FormView1.DataItem, "stat_adr_new");
            if (o != null)
            {
                RadComboBox box = (RadComboBox)WebControlHelper.FindControl(FormView1, "RCB_stat_adr_new");
                box.SelectedValue = o.ToString();
                box.Text =  DataBinder.Eval(FormView1.DataItem, "stat_adr_new_text")?.ToString();
            }

            o = DataBinder.Eval(FormView1.DataItem, "prech_stat_adr_new");
            if (o != null)
            {
                RadComboBox box = (RadComboBox)WebControlHelper.FindControl(FormView1, "RCB_prech_stat_adr_new");
                box.SelectedValue = o.ToString();
                //box.Text = o.ToString();
                box.Text = DataBinder.Eval(FormView1.DataItem, "prech_stat_adr_new_text")?.ToString();
            }

            
            o = DataBinder.Eval(FormView1.DataItem, "st_prisl_new");
            if (o != null)
            {
                RadComboBox box = (RadComboBox)WebControlHelper.FindControl(FormView1, "ddlbinsert_st_prisl_new");
                box.SelectedValue = o.ToString();
                box.Text =DataBinder.Eval(FormView1.DataItem, "st_prisl_new_cely")?.ToString();
            }

            o = DataBinder.Eval(FormView1.DataItem, "zdrav_poj_new");
            if (o != null)
            {
                RadComboBox box = (RadComboBox)WebControlHelper.FindControl(FormView1, "combo_zdrav_poj_new");
                box.SelectedValue = o.ToString();
                box.Text = DataBinder.Eval(FormView1.DataItem, "zdrav_poj_cely_new")?.ToString();
            }            
        }

        if (FormView1.CurrentMode == FormViewMode.ReadOnly)
        {                   
            _zmenyRodPrisl();
            _zmenyVzdelani();
            _zmenyJazZnal();
            _zmenyKontakty();            
        }
    }

   

    private void _zmenyVzdelani()
    {
        _zmenyVzdelani("grid_vzdel_p", "grid_vzdel");
    }
    private void _zmenyVzdelani(string grid_id_puvodni, string grid_id)
    {
        List<Pozadavekzmosudaju.StrVzdelani> str_vzdelani_puvodni = Pozadavekzmosudaju.GetVzdelani(PozId, true);
        List<Pozadavekzmosudaju.StrVzdelani> str_vzdelani_novy = Pozadavekzmosudaju.GetVzdelani(PozId, false);

        List<Pozadavekzmosudaju.StrVzdelani> novy_bez_puvodnich = str_vzdelani_novy.Except(str_vzdelani_puvodni).ToList();

        RadGrid grp = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id_puvodni);
        foreach (GridDataItem item in grp.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_vzdelani");
            bool contain = str_vzdelani_novy.Exists(aa => aa.id_vzdelani == id && !aa.smazano);
            if (!contain)
                item.CssClass = css_mazani;
        }

        RadGrid gr = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id);
        foreach (GridDataItem item in gr.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_vzdelani");
            bool contain = novy_bez_puvodnich.Exists(aa => aa.id_vzdelani == id);
            if (id == -1)
            {
                item.CssClass = css_zmena;
            }
            else if (contain)
            {
                Pozadavekzmosudaju.StrVzdelani zmena = novy_bez_puvodnich.Find(aa => aa.id_vzdelani == id);
                Pozadavekzmosudaju.StrVzdelani puvodni = str_vzdelani_puvodni.Find(aa => aa.id_vzdelani == id);

                zmena = (Pozadavekzmosudaju.StrVzdelani)_nullChangeToEmptyString(zmena);
                puvodni = (Pozadavekzmosudaju.StrVzdelani)_nullChangeToEmptyString(puvodni);

                //procházím položky, které se změnily
                //-----------------------------------------
                
                _nastavStyl(item, puvodni.stupen, zmena.stupen, "col_stupen");
                if (grid_id_puvodni == "grid_vzdel_puvodni")
                    _nastavStyl(item, puvodni.obor, zmena.obor, "obor");
                else
                    _nastavStyl(item, puvodni.obor, zmena.obor, "combo_obor");
                _nastavStyl(item, puvodni.ved_kval, zmena.ved_kval, "check_ve_kval");
                _nastavStyl(item, puvodni.druh_zkousky, zmena.druh_zkousky, "druh_zkousky");
                _nastavStyl(item, puvodni.rok_ukonc, zmena.rok_ukonc, "rok_ukonc");
                _nastavStyl(item, puvodni.titul, zmena.titul, "titul");
                _nastavStyl(item, puvodni.skola, zmena.skola, "skola");
                _nastavStyl(item, puvodni.zamereni, zmena.zamereni, "zamereni");
                _nastavStyl(item, puvodni.kod_oboru_trex, zmena.kod_oboru_trex, "kod_oboru_trex");
                //-----------------------------------------

            }
        }
    }

    private void _zmenyJazZnal()
    {
        _zmenyJazZnal("grid_jazyky_p", "grid_jazyky");
    }

    private void _zmenyJazZnal(string grid_id_puvodni, string grid_id)
    {
        List<Pozadavekzmosudaju.StrJazyky> str_jazyky_puvodni = Pozadavekzmosudaju.GetJazyky(PozId, true);
        List<Pozadavekzmosudaju.StrJazyky> str_jazyky_novy = Pozadavekzmosudaju.GetJazyky(PozId, false);

        List<Pozadavekzmosudaju.StrJazyky> novy_bez_puvodnich = str_jazyky_novy.Except(str_jazyky_puvodni).ToList();

        RadGrid grp = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id_puvodni);
        foreach (GridDataItem item in grp.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_jaz_znal");
            bool contain = str_jazyky_novy.Exists(aa => aa.id_jaz_znal == id);
            if (!contain)
                item.CssClass = css_mazani;
        }

        RadGrid gr = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id);
        foreach (GridDataItem item in gr.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_jaz_znal");
            bool contain = novy_bez_puvodnich.Exists(aa => aa.id_jaz_znal == id);
            if (id == -1)
            {
                item.CssClass = css_zmena;
            }
            else if (contain)
            {
                Pozadavekzmosudaju.StrJazyky zmena = novy_bez_puvodnich.Find(aa => aa.id_jaz_znal == id);
                Pozadavekzmosudaju.StrJazyky puvodni = str_jazyky_puvodni.Find(aa => aa.id_jaz_znal == id);

                zmena = (Pozadavekzmosudaju.StrJazyky)_nullChangeToEmptyString(zmena);
                puvodni = (Pozadavekzmosudaju.StrJazyky)_nullChangeToEmptyString(puvodni);

                //procházím položky, které se změnily
                //-----------------------------------------
                _nastavStyl(item, puvodni.jazyk, zmena.jazyk, "col_jazyk");
                _nastavStyl(item, puvodni.stupen, zmena.stupen, "combo_stupen");
                _nastavStyl(item, puvodni.druh_zkousky, zmena.druh_zkousky, "druh_zkousky");               
                //-----------------------------------------

            }
        }
    }

    private void _zmenyKontakty()
    {
        List<StrKontakt> str_kontakty_puvodni = Pozadavekzmosudaju.GetKontakty(PozId, true);
        List<StrKontakt> str_kontakty_novy = Pozadavekzmosudaju.GetKontakty(PozId, false);

        //List<StrKontakt> novy_bez_puvodnich = str_kontakty_novy.Except(str_kontakty_puvodni).ToList();

        RadGrid grp = (RadGrid)WebControlHelper.FindControl(FormView1, "grid_kontakty_p");
        foreach (GridDataItem item in grp.Items)
        {
            string tel_kam = (string)item.GetDataKeyValue("tel_kam");
            bool contain = str_kontakty_novy.Exists(aa => aa.tel_kam == tel_kam);
            if (!contain)
                item.CssClass = css_mazani;
        }

        RadGrid gr = (RadGrid)WebControlHelper.FindControl(FormView1, "grid_kontakty");
        foreach (GridDataItem item in gr.Items)
        {
            string tel_kam = (string)item.GetDataKeyValue("tel_kam");
            // bool contain = novy_bez_puvodnich.Exists(aa => aa.tel_kam == tel_kam);
            bool contain=str_kontakty_puvodni.Exists(aa => aa.tel_kam == tel_kam);
            if (!contain)
            {
                item.CssClass = css_zmena;
            }
            else
            {
                //StrKontakt zmena = novy_bez_puvodnich.Find(aa => aa.tel_kam == tel_kam);
                StrKontakt zmena = str_kontakty_novy.Find(aa => aa.tel_kam == tel_kam);
                StrKontakt puvodni = str_kontakty_puvodni.Find(aa => aa.tel_kam == tel_kam);

                zmena = (StrKontakt)_nullChangeToEmptyString(zmena);
                puvodni = (StrKontakt)_nullChangeToEmptyString(puvodni);

                //procházím položky, které se změnily
                //-----------------------------------------
                _nastavStyl(item, puvodni.tel_cislo, zmena.tel_cislo, "tel_cislo");             
                
                //-----------------------------------------

            }
        }
    }

    private void _zmenyRodPrisl()
    {
        _zmenyRodPrisl("grid_rod_prisl_p", "grid_rod_prisl");
    }

    private void _zmenyRodPrisl(string grid_id_p, string grid_id)
    {
        List<Pozadavekzmosudaju.StrRodPrisl> str_rodprisl_puvodni = Pozadavekzmosudaju.GetRodPrisl(PozId, true);
        List<Pozadavekzmosudaju.StrRodPrisl> str_rodprisl_novy = Pozadavekzmosudaju.GetRodPrisl(PozId, false);

        List<Pozadavekzmosudaju.StrRodPrisl> novy_bez_puvodnich = str_rodprisl_novy.Except(str_rodprisl_puvodni).ToList();

        //RadGrid grp = (RadGrid)WebControlHelper.FindControl(FormView1, "grid_rod_prisl_p");
        RadGrid grp = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id_p);
        if (grp == null) return;

        foreach (GridDataItem item in grp.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_rod_prisl");
            bool contain = str_rodprisl_novy.Exists(aa => aa.id_rod_prisl == id && !aa.smazano);
            if (!contain)
                item.CssClass = css_mazani;
        }

        //RadGrid gr = (RadGrid)WebControlHelper.FindControl(FormView1, "grid_rod_prisl");
        RadGrid gr = (RadGrid)WebControlHelper.FindControl(FormView1, grid_id);
        foreach (GridDataItem item in gr.Items)
        {
            int id = (Int32)item.GetDataKeyValue("id_rod_prisl");
            bool contain = novy_bez_puvodnich.Exists(aa => aa.id_rod_prisl == id);
            if (id == -1)
            {
                item.CssClass = css_zmena;
            }
            else if (contain)
            {
                Pozadavekzmosudaju.StrRodPrisl zmena = novy_bez_puvodnich.Find(aa => aa.id_rod_prisl == id);
                Pozadavekzmosudaju.StrRodPrisl puvodni = str_rodprisl_puvodni.Find(aa => aa.id_rod_prisl == id);

                zmena = (Pozadavekzmosudaju.StrRodPrisl)_nullChangeToEmptyString(zmena);
                puvodni = (Pozadavekzmosudaju.StrRodPrisl)_nullChangeToEmptyString(puvodni);

                //procházím položky, které se změnily
                //-----------------------------------------
                _nastavStyl(item, puvodni.jmeno, zmena.jmeno, "jmeno");
                _nastavStyl(item, puvodni.prijmeni, zmena.prijmeni, "prijmeni");

                _nastavStyl(item, puvodni.rodne_cislo, zmena.rodne_cislo, "rodne_cislo");
                _nastavStyl(item, puvodni.rodne_cislo, zmena.rodne_cislo, "datum_narozeni"); //PH 9.6.2020 HID:51634
                _nastavStyl(item, puvodni.rodne_jmeno, zmena.rodne_jmeno, "rodne_jmeno");
                _nastavStyl(item, puvodni.misto_trv, zmena.misto_trv, "bydliste");
                _nastavStyl(item, puvodni.psc_trv, zmena.psc_trv, "bydliste");
                _nastavStyl(item, puvodni.misto_trv, zmena.misto_trv, "bydliste");
                _nastavStyl(item, puvodni.ulice_trv, zmena.ulice_trv, "jmeno");
                _nastavStyl(item, puvodni.vztah, zmena.vztah, "vztah");
                //-----------------------------------------

            }
        }
    }

    private void _nastavStyl(GridDataItem item, object puvodni, object zmena, string itemName )
    {
        if ((zmena == null) && (puvodni == null))
            return;
        else if ((zmena == null) && (puvodni != null))
        {
            item[itemName].CssClass = css_zmena;
            return;
        }

        if (!zmena.Equals(puvodni))
        {
            item[itemName].CssClass = css_zmena;
        }
    }


    private static object _nullChangeToEmptyString(object o)
    {
        FieldInfo[] info = o.GetType().GetFields();
        foreach (var prop in info)
        {
            if (prop.FieldType.Name == typeof(string).Name)
            {
                object val = prop.GetValue(o);
                if (val == null)
                    prop.SetValue(o, "");
            }
        }
        return o;
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }


    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {

        OnItemInserted(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }

    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        OnItemRetrieved(new EventArgs());
        bool lb_pr_ulice = (workfl_hodnoty.GetString(PozId, "pr_ulice_prazdny") == "a");
        bool lb_pr_misto = (workfl_hodnoty.GetString(PozId, "pr_misto_prazdny") == "a");
        bool lb_pr_posta = (workfl_hodnoty.GetString(PozId, "pr_posta_prazdny") == "a");
        bool lb_prech_stat_adr_prazdny = (workfl_hodnoty.GetString(PozId, "prech_stat_adr_prazdny") == "a");

        if (FormView1.CurrentMode == FormViewMode.ReadOnly)
        {
            //osobní údaje
            //--------------------------------------
            _oznacZmenu("lab_prijmeni", "lab_prijmeni_new", "tc_prijmeni_new");
            _oznacZmenu("lab_jmeno", "lab_jmeno_new", "tc_jmeno_new");
            _oznacZmenu("lab_titul", "lab_titul_new", "tc_titul_new");
            _oznacZmenu("lab_titul_za", "lab_titul_za_new", "tc_titul_za_new");
            _oznacZmenu("lab_rodne_jmeno", "lab_rodne_jmeno_new", "tc_rodne_jmeno_new");
            _oznacZmenu("lab_misto_narozeni", "lab_misto_narozeni_new", "tc_misto_narozeni_new");
            _oznacZmenu("lab_rodin_stav_cely", "lab_rodin_stav_new_cely", "tc_rodin_stav_new_cely");
            _oznacZmenu("lab_st_prisl_cely", "lab_st_prisl_new_cely", "tc_st_prisl_new_cely");

            _oznacZmenu("lab_cislo_op", "lab_cislo_op_new", "tc_cislo_op_new");
            _oznacZmenu("lab_cislo_op_platnost", "lab_cislo_op_platnost_new", "tc_cislo_op_platnost_new");


            _oznacZmenu("lab_cislo_pasu", "lab_cislo_pasu_new", "tc_cislo_pasu_new");
            _oznacZmenu("lab_cislo_pasu_platnost", "lab_cislo_pasu_platnost_new", "tc_cislo_pasu_platnost_new");


            _oznacZmenu("lab_tr_ulice", "lab_tr_ulice_new", "tc_tr_ulice_new");
            _oznacZmenu("lab_tr_cislo", "lab_tr_cislo_new", "tc_cislo_new");
            _oznacZmenu("lab_misto_trv", "lab_misto_trv_new", "tc_misto_trv_new");
            _oznacZmenu("lab_psc_trv", "lab_psc_trv_new", "tc_psc_trv_new");
            _oznacZmenu("lab_posta_trv", "lab_posta_trv_new", "tc_posta_trv_new");

            _oznacZmenu("lab_stat_adr", "lab_stat_adr_new", "tc_stat_adr_new");

            _oznacZmenu("lab_pr_ulice", "lab_pr_ulice_new", "tc_pr_ulice_new");
            _oznacZmenu("lab_pr_cislo", "lab_pr_cislo_new", "tc_pr_cislo_new");
            _oznacZmenu("lab_misto_prech", "lab_misto_prech_new", "tc_misto_prech_new");
            _oznacZmenu("lab_psc_prech", "lab_psc_prech_new", "tc_psc_prech_new");
            _oznacZmenu("lab_posta_prech", "lab_posta_prech_new", "tc_posta_prech_new");

            _oznacZmenu("lab_prech_stat_adr", "lab_prech_stat_adr_new", "tc_prech_stat_adr_new");
            //-------------------------------------

            //zdravotní pojišťovna
            //-------------------------------------
            _oznacZmenu("lab_zdrav_poj_old_cely", "lab_zdrav_poj_cely_new", "tc_zdrav_poj_cely_new");
            _oznacZmenu("lab_zdrav_poj_od_old", "lab_zdrav_poj_od", "tc_zdrav_poj_od");
            //-------------------------------------
        }
        else
        {           

            RadButton butt = WebControlHelper.FindControl(this, "TRB_pr_ulice_prazdny") as RadButton;
            if (butt != null)
            {
                butt.Checked = lb_pr_ulice;
                if (butt.Checked)
                {
                    //TRB_pr_misto_prazdny_CheckedChanged
                    if (!Page.ClientScript.IsStartupScriptRegistered("pr_ulice_prazdny"))
                    {
                        string script = "TRB_pr_ulice_prazdny_CheckedChanged();";
                        string script2 = "function pr_ulice_prazdny(){" + script + "; Sys.Application.remove_load(pr_ulice_prazdny);}Sys.Application.add_load(pr_ulice_prazdny);";
                        RadScriptManager.RegisterStartupScript(Page, Page.GetType(), "pr_ulice_startup", script2, true);
                    }
                }
            }

            butt = WebControlHelper.FindControl(this, "TRB_pr_misto_prazdny") as RadButton;
            if (butt != null)
            {
                butt.Checked = lb_pr_misto;
                if (butt.Checked)
                {
                    if (!Page.ClientScript.IsStartupScriptRegistered("pr_misto_prazdny"))
                    {
                        //TRB_pr_misto_prazdny_CheckedChanged
                        string script = "TRB_pr_misto_prazdny_CheckedChanged();";
                        string script2 = "function pr_misto_startup(){" + script + "; Sys.Application.remove_load(pr_misto_startup);}Sys.Application.add_load(pr_misto_startup);";
                        RadScriptManager.RegisterStartupScript(Page, Page.GetType(), "pr_misto_startup", script2, true);
                    }
                }
            }
            butt = WebControlHelper.FindControl(this, "TRB_pr_posta_prazdny") as RadButton;
            if (butt != null)
            {
                butt.Checked = lb_pr_posta;
                if (butt.Checked)
                {
                    if (!Page.ClientScript.IsStartupScriptRegistered("pr_posta_prazdny"))
                    {
                        //TRB_pr_misto_prazdny_CheckedChanged
                        string script = "TRB_pr_posta_prazdny_CheckedChanged();";
                        string script2 = "function pr_posta_startup(){" + script + "; Sys.Application.remove_load(pr_posta_startup);}Sys.Application.add_load(pr_posta_startup);";
                        RadScriptManager.RegisterStartupScript(Page, Page.GetType(), "pr_posta_startup", script2, true);
                    }
                }
            }

            butt = WebControlHelper.FindControl(this, "TRB_prech_stat_adr_prazdny") as RadButton;
            if (butt != null)
            {
                butt.Checked = lb_prech_stat_adr_prazdny;
                if (butt.Checked)
                {
                    if (!Page.ClientScript.IsStartupScriptRegistered("prech_stat_adr_prazdny"))
                    {
                        string script = "TRB_prech_stat_adr_prazdny_CheckedChanged();";
                        string script2 = "function prech_stat_adr_prazdny(){" + script + "; Sys.Application.remove_load(prech_stat_adr_prazdny);}Sys.Application.add_load(prech_stat_adr_prazdny);";
                        RadScriptManager.RegisterStartupScript(Page, Page.GetType(), "prech_stat_adr_prazdny", script2, true);
                    }
                }
            }

        }
       

        if (lb_pr_ulice)
        {
            Label lab = WebControlHelper.FindControl(this, "lab_pr_ulice_prazdny") as Label;
            if (lab != null)
                lab.Visible = true;
        }

        if (lb_pr_misto)
        {
            Label lab = WebControlHelper.FindControl(this, "lab_pr_misto_prazdny") as Label;
            if (lab != null)
                lab.Visible = true;
        }

        if (lb_pr_posta)
        {
            Label lab = WebControlHelper.FindControl(this, "lab_pr_posta_prazdny") as Label;
            if (lab != null)
                lab.Visible = true;
        }

        if (lb_prech_stat_adr_prazdny)
        {
            Label lab = WebControlHelper.FindControl(this, "lab_prech_stat_adr_prazdny") as Label;
            if (lab != null)
                lab.Visible = true;
        }


    }

    private void _oznacZmenu(string lab_1, string lab_2, string cell_name)
    {
        string text1 = ((Label)WebControlHelper.FindControl(FormView1, lab_1)).Text;
        string text2 = ((Label)WebControlHelper.FindControl(FormView1, lab_2)).Text;
        if (!text1.Equals(text2) && (!string.IsNullOrEmpty(text2)))
        {
            TableCell c1 = (TableCell)WebControlHelper.FindControl(FormView1, cell_name);
            c1.CssClass = "zmena";
        }
    }

    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["id_poz"] = this.PozId;
        RadTextBox box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_prijmeni_new");
        e.InputParameters["prijmeni"] = (box.Text == "" ? "" : Convert.ToString(box.Text));
        if (this.PozId > 0)//PH 21.12.2016
        {           
            workfl_hl hl = new workfl_hl();
            Str_workfl_hl str=hl.NaplnStrukturu(this.PozId);           
            e.InputParameters["os_cislo"] = str.os_cislo;
        }
        else
            e.InputParameters["os_cislo"] = Globals.OsCislo.ToString();

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_jmeno_new");
        e.InputParameters["jmeno"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_titul_new");
        e.InputParameters["titul"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_titul_za_new");
        e.InputParameters["titul_za"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_rodne_jmeno_new");
        e.InputParameters["rodne_jmeno"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_misto_narozeni_new");
        e.InputParameters["misto_narozeni"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        TRadComboBox list =(TRadComboBox)WebControlHelper.FindControl(this, "ddlbinsert_rodin_stav_new");
        e.InputParameters["rodin_stav"] = (list.SelectedValue == "" ? "" : Convert.ToString(list.SelectedValue));

        //box=(TextBox)WebControlHelper.FindControl(this, "TextInsert_narodnost_new");
        e.InputParameters["narodnost"] = "";// (box.Text == "" ? "" : Convert.ToString(box.Text));

        list=(TRadComboBox)WebControlHelper.FindControl(this, "ddlbinsert_st_prisl_new");
        e.InputParameters["st_prisl"] = (list.SelectedValue == "" ? "" : Convert.ToString(list.SelectedValue));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_cislo_op_new");
        e.InputParameters["cislo_op"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        RadDatePicker pck = (RadDatePicker)WebControlHelper.FindControl(this, "rdp_cislo_op_platnost");
        if (pck.SelectedDate != null)
            e.InputParameters["cislo_op_platnost"] = Convert.ToDateTime(pck.SelectedDate);

        box =(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_cislo_pasu_new");
        e.InputParameters["cislo_pasu"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        pck = (RadDatePicker)WebControlHelper.FindControl(this, "rdp_cislo_pasu_platnost");
        if (pck.SelectedDate != null)
            e.InputParameters["cislo_pasu_platnost"] = Convert.ToDateTime(pck.SelectedDate);

        box =(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_tr_ulice_new");
        e.InputParameters["tr_ulice"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_tr_cislo_new");
        e.InputParameters["tr_cislo"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_misto_trv_new");
        e.InputParameters["misto_trv"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box = (RadTextBox)WebControlHelper.FindControl(this, "TextInsert_psc_trv_new");
        e.InputParameters["psc_trv"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_posta_trv_new");
        e.InputParameters["posta_trv"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        list = (TRadComboBox)WebControlHelper.FindControl(this, "RCB_stat_adr_new");
        e.InputParameters["stat_adr"] = (list.SelectedValue == "" ? "" : Convert.ToString(list.SelectedValue));        
        
        box =(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_pr_ulice_new");
        e.InputParameters["pr_ulice"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_pr_cislo_new");
        e.InputParameters["pr_cislo"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_misto_prech_new");
        e.InputParameters["misto_prech"] = (box.Text == "" ? "" : Convert.ToString(box.Text));
        
        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_psc_prech_new");
        e.InputParameters["psc_prech"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_posta_prech_new");
        e.InputParameters["posta_prech"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        list = (TRadComboBox)WebControlHelper.FindControl(this, "RCB_prech_stat_adr_new");
        e.InputParameters["prech_stat_adr"] = (list.SelectedValue == "" ? "" : Convert.ToString(list.SelectedValue));

        list = (TRadComboBox)WebControlHelper.FindControl(this, "combo_zdrav_poj_new");
        e.InputParameters["s_zdrav_poj"]= (list.SelectedValue == "" ? "" : Convert.ToString(list.SelectedValue));

        pck = (RadDatePicker)WebControlHelper.FindControl(this, "dtp_zdrav_poj_od_new");
        if (pck.SelectedDate != null)
            e.InputParameters["zdrav_poj_od"] = Convert.ToDateTime(pck.SelectedDate);        

        //box =(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_cislo_pasu_new");
        //e.InputParameters["cislo_pasu"] = (box.Text == "" ? "" : Convert.ToString(box.Text));
        box=(RadTextBox)WebControlHelper.FindControl(this, "TextInsert_duvod");
        e.InputParameters["duvod"] = (box.Text == "" ? "" : Convert.ToString(box.Text));

        RadButton butt = (RadButton)WebControlHelper.FindControl(this, "TRB_pr_ulice_prazdny");
        e.InputParameters["pr_ulice_prazdny"] = butt.Checked;

        butt = (RadButton)WebControlHelper.FindControl(this, "TRB_pr_misto_prazdny");
        e.InputParameters["pr_misto_prazdny"] = butt.Checked;

        butt = (RadButton)WebControlHelper.FindControl(this, "TRB_pr_posta_prazdny");
        e.InputParameters["pr_posta_prazdny"] = butt.Checked;

        butt = (RadButton)WebControlHelper.FindControl(this, "TRB_prech_stat_adr_prazdny");
        e.InputParameters["prech_stat_adr_prazdny"] = butt.Checked;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        /*
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
         * */
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        //PH 25.3.2014 tady uložím další udaje
        Pozadavekzmosudaju.Save(PozId, this.Page, NewPozadavek);
        Nacist();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void InsertUlozit_Command(object sender, CommandEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        
        TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxOdInsert");
        e.InputParameters["datum_od"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDoInsert");
        e.InputParameters["datum_do"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        //box = (TextBox)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        //e.InputParameters["vyridit_do"] = (box.Text == "" ? new DateTime() : Convert.ToDateTime(box.Text));

        box = (TextBox)WebControlHelper.FindControl(this, "TextBox2");
        e.InputParameters["popis"] = (box.Text == "" ? String.Empty : box.Text);

        box = (TextBox)WebControlHelper.FindControl(this, "LabelDuvod");
        e.InputParameters["duvod"] = (box.Text == "" ? String.Empty : box.Text);

        box = (TextBox)WebControlHelper.FindControl(this, "TextBoxprostr");
        e.InputParameters["popis2"] = (box.Text == "" ? String.Empty : box.Text);
        
        e.InputParameters["id_poz"] = this.PozId;
    }

    
    public override void ChangeMode(FormViewMode mode)
    { 
        FormView1.ChangeMode(mode);
    }
     

    public void iban_validace(object sender, ServerValidateEventArgs args)
    {
        Platby pl=new Platby();
        args.IsValid = pl.KontrolaIban(args.Value);
       
    }
    public void ucet_validace(object sender, ServerValidateEventArgs args)
    {
        string chyba = "";
        Platby pl = new Platby();
        args.IsValid = pl.Kont_uctu(args.Value, ref chyba);
        ((CustomValidator)sender).ErrorMessage = chyba;
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }
    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void combo_vztah_ItemsRequested(object sender, EventArgs e)
    {
        TRadComboBox box=sender as TRadComboBox;
        CisRodinVztahy cis=new CisRodinVztahy();
        DataTable table=cis.SeznamRodinVztahu(true);
        for(int i=0;i<table.Rows.Count;i++)
        {
            RadComboBoxItem item=new RadComboBoxItem(table.Rows[i]["vztah_text"].ToString(),table.Rows[i]["vztah_text"].ToString()); 
            box.Items.Add(item);
        }
    }

    protected void check_duchod_CheckedChanged(object sender, EventArgs e)
    {
        CheckBox b=(CheckBox) sender;
        DropDownList lst=WebControlHelper.FindControl(FormView1,"drop_druh_duchodu") as DropDownList;
        lst.Enabled=b.Checked;
        if (lst.Enabled == false)
            lst.SelectedValue = "";

        lst=WebControlHelper.FindControl(FormView1,"drop_platci_duchodu") as DropDownList;
        lst.Enabled=b.Checked;
        if (lst.Enabled == false)
            lst.SelectedValue = "";

        RadTextBox box=WebControlHelper.FindControl(FormView1,"text_duchod_kc") as RadTextBox;
        box.Enabled=b.Checked;
        if (b.Enabled == false)
            b.Text = "";

        TRadDatePicker t = WebControlHelper.FindControl(FormView1, "duchod_od") as TRadDatePicker;
        t.Enabled=b.Checked;
        if (t.Enabled == false)
            t.SelectedDate = null;

    }

    protected void check_zps_CheckedChanged(object sender, EventArgs e)
    {
        CheckBox b=(CheckBox) sender;

        TRadDatePicker t = WebControlHelper.FindControl(FormView1, "zps_od") as TRadDatePicker;
        t.Enabled=b.Checked;
        if (t.Enabled == false)
            t.SelectedDate = null;

        t = WebControlHelper.FindControl(FormView1, "zps_do") as TRadDatePicker;
        t.Enabled=b.Checked;
        if (t.Enabled == false)
            t.SelectedDate = null;

        RadTextBox box = WebControlHelper.FindControl(FormView1, "text_zps_vymer") as RadTextBox;
        box.Enabled=b.Checked;
        if (b.Enabled == false)
            b.Text = "";

    }


    protected string _platciDuchodu(object o)
    {
        if (o==null) return "";
        string ls_cislo=Convert.ToString(o);
        CisPlatcuDuchodu cis = new CisPlatcuDuchodu();
        return cis.Nazev(ls_cislo);
    }

    protected string _druhDuchodu(object o)
    {
        if (o == null) return "";
        string ls_cislo = Convert.ToString(o);
        CisDruhDuchodu cis = new CisDruhDuchodu();
        return cis.Nazev(ls_cislo);
    }

    protected void val_jazyk_ServerValidate(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlbinsert_jazyk_new");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }
     protected void val_jazyk_stupen_ServerValidate_edit(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlbedit_stupen_edit");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }


    protected void val_jazyk_stupen_ServerValidate_insert(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlinsert_stupen_new");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }


    protected void val_jazyk_ServerValidate_edit(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlbedit_jazyk_new");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

     protected void val_jazyk_ServerValidate_insert(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlbinsert_jazyk_new");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

    protected void validace_st_prisl_ServerValidate(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "ddlbinsert_st_prisl_new");
        if (string.IsNullOrEmpty(box.Text))
            args.IsValid = true;
        else
            args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

    protected void validace_zp_ServerValidate(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "combo_zdrav_poj_new");
        if (string.IsNullOrEmpty(box.Text))
            args.IsValid = true;
        else
            args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

    protected void val_obor_ServerValidate_insert(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "combo_obor_insert");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

    protected void val_obor_ServerValidate_edit(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "combo_obor_edit");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }

    protected void val_stupen_ServerValidate_edit(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "combo_stupen_edit");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }
    protected void val_stupen_ServerValidate_insert(object source, ServerValidateEventArgs args)
    {
        RadComboBox box = (RadComboBox)WebControlHelper.FindControl(this, "combo_stupen_insert");
        args.IsValid = (!string.IsNullOrEmpty(box.SelectedValue));
    }



    protected void grid_jazyky_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item.IsInEditMode)
        {
            GridEditableItem item = (GridEditableItem)e.Item;
            if (!(e.Item is IGridInsertItem))
            {
                RadComboBox combo = (RadComboBox)item.FindControl("ddlbedit_jazyk_new");
                RadComboBoxItem selectedItem = new RadComboBoxItem();
                string jazyk=((DataRowView)e.Item.DataItem)["jazyk"].ToString();
                selectedItem.Text = CisJazyku.JazykNazev(jazyk);
                selectedItem.Value = jazyk;
                //selectedItem.Attributes.Add("ContactName", ((DataRowView)e.Item.DataItem)["ContactName"].ToString());
                combo.Items.Add(selectedItem);
                selectedItem.DataBind();
                

                combo = (RadComboBox)item.FindControl("ddlbedit_stupen_edit");
                selectedItem = new RadComboBoxItem();
                string stupen = ((DataRowView)e.Item.DataItem)["stupen"].ToString();
                selectedItem.Text = CisUniv.Nazev(43, stupen);
                selectedItem.Value = stupen;                
                combo.Items.Add(selectedItem);
                selectedItem.DataBind();
            }
        }
    }
    protected void grid_vzdel_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item.IsInEditMode)
        {
            GridEditableItem item = (GridEditableItem)e.Item;
            if (!(e.Item is IGridInsertItem))
            {
                RadComboBox combo = (RadComboBox)item.FindControl("combo_obor_edit");
                RadComboBoxItem selectedItem = new RadComboBoxItem();
                string obor = ((DataRowView)e.Item.DataItem)["obor"].ToString();
                selectedItem.Text = CisVzdelani.OborNazev(obor);
                selectedItem.Value = obor;               
                combo.Items.Add(selectedItem);
                selectedItem.DataBind();

                combo = (RadComboBox)item.FindControl("combo_stupen_edit");
                selectedItem = new RadComboBoxItem();
                string stupen = ((DataRowView)e.Item.DataItem)["stupen"].ToString();
                selectedItem.Text = CisVzdelani.Stupen(stupen);
                selectedItem.Value = stupen;
                combo.Items.Add(selectedItem);
                selectedItem.DataBind();
            }
        }
    }

    protected void grid_rod_prisl_DataBound(object sender, EventArgs e)
    {
        _zmenyRodPrisl("grid_rod_prisl_puvodni", "grid_rod_prisl");
    }

    protected void grid_kontakty_DataBound(object sender, EventArgs e)
    {
        _zmenyKontakty();
    }

    protected void grid_jazyky_DataBound(object sender, EventArgs e)
    {
        _zmenyJazZnal("grid_jazyky_puvodni", "grid_jazyky");
    }

    protected void grid_vzdel_DataBound(object sender, EventArgs e)
    {
        _zmenyVzdelani("grid_vzdel_puvodni", "grid_vzdel");
    }

    protected void text_rodne_cislo_Load(object sender, EventArgs e)
    {
        ((RadTextBox)sender).CssClass = (Globals.RAActive("DANOVKA") ? "povinne-pole" : "");
    }


    protected void val_rodne_cislo_Load(object sender, EventArgs e)
    {
        ((TRequiredValidator)sender).Enabled = Globals.RAActive("DANOVKA");
    }

    protected void text_datum_narozeni_Load(object sender, EventArgs e)
    {
        TRadDatePicker picker = (TRadDatePicker)sender;
        picker.MinDate = new DateTime();
        picker.MaxDate = DateTime.Now.Date;
    }
}
