﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.Obecne;
using System.Collections;
using KSProgram.Data;
using System.Data;

namespace KSPortal.Controls
{
    public partial class ZadostOzmppv : UserControlPozadavek
    {
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool pagIsValid)
        {
            ZmppvInner1.CommandRouter(sender, e, ref pagIsValid);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            ZmppvInner1.ChangeMode(mode);
        }


        /// <summary>
        /// Id pozadavku
        /// </summary>
        public override int PozId
        {
            get
            {
                return ZmppvInner1.PozId;
            }
            set
            {
                ZmppvInner1.PozId = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public int NovaPracDiv
        {
            get
            {
                return getNovaPracDiv() ?? getPracDiv() ?? -1;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public int PracDiv
        {
            get
            {
                return getPracDiv() ?? -1;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public bool JeZmenaPracDiv
        {
            get
            {
                return this.PracDiv != this.NovaPracDiv;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public short NovaPracKateg
        {
            get
            {
                return getNovaPracKateg() ?? getPracKateg() ?? -1;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public short PracKateg
        {
            get
            {
                return getPracKateg() ?? -1;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        [WFProperty]
        public bool JeZmenaPracKateg
        {
            get
            {
                return this.PracKateg != this.NovaPracKateg;
            }
        }
        private int? getNovaPracDiv()
        { 
            string prac_str = null;
            Hashtable objekty = ZmppvInner1.getFormViewObjects();
            if (objekty != null)
            {
                KSProgram.WebControls.TRadComboBox cb = (KSProgram.WebControls.TRadComboBox)objekty["TRCB_prac_str"];
                prac_str = string.IsNullOrEmpty(cb?.SelectedValue) ? null : cb.SelectedValue;

            }
            if (string.IsNullOrEmpty(prac_str))
            {
                return null;
            }
            else
            {
                int? div = KSProgram.Ciselniky.CisStredisko.CisDivize(prac_str);
                return div;
            }
        }
        private int? getPracDiv()
        {
            string prac_str = workfl_hodnoty.GetString(PozId, "old_prac_str");
            if (string.IsNullOrEmpty(prac_str))
            {
                return null;
            }
            else
            {
                KSProgram.Ciselniky.CisStredisko cis = new KSProgram.Ciselniky.CisStredisko();
                string old_k_prac_str = (from str in cis.VsechnaStrediska(DateTime.MinValue, DateTime.MaxValue).AsEnumerable()
                                         where (GetNullOrData.GetString(str["str"], true) + " - " + GetNullOrData.GetString(str["nazev"], true)) == prac_str
                                         select GetNullOrData.GetString(str["str"])).FirstOrDefault() ?? "xxx";
                int? div = KSProgram.Ciselniky.CisStredisko.CisDivize(old_k_prac_str);
                return div;
            }
        }

        private short? getNovaPracKateg()
        {
            short? prac_kateg = null;
            Hashtable objekty = ZmppvInner1.getFormViewObjects();
            if (objekty != null)
            {
                KSProgram.WebControls.TRadComboBox cb = (KSProgram.WebControls.TRadComboBox)objekty["TRCB_prac_kateg"];
                string s_pr_kat = string.IsNullOrEmpty(cb?.SelectedValue) ? null : cb.SelectedValue;
                short pr_kat;
                if (short.TryParse(s_pr_kat, out pr_kat))
                {
                    prac_kateg = pr_kat;
                }
            }

            return prac_kateg;
        }
        private short? getPracKateg()
        {
            string prac_kateg_t = workfl_hodnoty.GetString(PozId, "old_prac_kateg");
            if (string.IsNullOrEmpty(prac_kateg_t))
            {
                return null;
            }
            else
            {
                short? prac_kateg = (from pr in KSProgram.Ciselniky.CisPracKateg.Seznam(false).AsEnumerable()
                                     where GetNullOrData.GetString(pr["cely_nazev"], true) == prac_kateg_t
                                     select GetNullOrData.GetInt16(pr["cislo"])).FirstOrDefault();
                return prac_kateg;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public override void Nacist()
        {
            ZmppvInner1.Nacist();
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return ZmppvInner1.CurrentMode;
            }
        }
        public new void ItemUpdated(object sender, EventArgs e)
        {
            ZmppvInner1.ItemUpdated(sender, e);
        }
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ZmppvInner1.ItemInserted(sender, e);
        }
    }
}