﻿using KSProgram.Data;
using KSProgram.Pozadavky;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Extensions;
using KSProgram.Systemizace;
using KSProgram;

namespace KSPortal.Development
{
    public partial class MiKTest : TPage
    {
        SystemizacniStrom strom
        {
            get
            {
                return (SystemizacniStrom)CacheInfo.GetItemFromCache("sysstrom");
            }
            set
            {
                CacheInfo.AddItemToCache("sysstrom", value, System.Web.Caching.CacheItemPriority.Normal);
            }
        }
        protected override void OnLoad(EventArgs e)
        {
            if (!IsPostBack)//testovací komit
            {
                SystemizacePodniku sys = new SystemizacePodniku();
                strom = sys.SystemizaceStrom(SystemizacePodniku.IdPlatneSystemizace(Globals.AktObdobi), Globals.AktObdobi, new StavStromu() { Zamestnanci = true });
            }
        }

        protected void RadButton1_Click(object sender, EventArgs e)
        {
            int? id_pracmist = (int?)RadNumericTextBox1.Value;
            decimal? os_cislo = (decimal?)RadNumericTextBox2.Value;
            short? cislo_pom = (short?)RadNumericTextBox3.Value;
            
            List<int> mista = null;
            List<decimal> lide = null;
            List<Tuple<decimal, short>> pomery = null;
            if (RadButton4.SelectedToggleState.Value == "podrizeni")
            {
                if (id_pracmist != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = strom.PrimoPodrizenaMista((int)id_pracmist);
                        }
                        else
                        {
                            mista = strom.PodrizenaMista((int)id_pracmist);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoPodrizeniLide((int)id_pracmist);
                        }
                        else
                        {
                            lide = strom.PodrizeniLide((int)id_pracmist);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoPodrizenePomery((int)id_pracmist);
                        }
                        else
                        {
                            pomery = strom.PodrizenePomery((int)id_pracmist);
                            List<decimal> grup = pomery.Select(x => x.Item1).GroupBy(x => x)
                                .Where(g => g.Count() > 1)
                                .Select(y => y.Key)
                                .ToList();
                        }
                    }
                }
                else if (os_cislo != null && cislo_pom != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = strom.PrimoPodrizenaMista((decimal)os_cislo, (short)cislo_pom);
                        }
                        else
                        {
                            mista = strom.PodrizenaMista((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoPodrizeniLide((decimal)os_cislo, (short)cislo_pom);
                        }
                        else
                        {
                            lide = strom.PodrizeniLide((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoPodrizenePomery((decimal)os_cislo, (short)cislo_pom);
                        }
                        else
                        {
                            pomery = strom.PodrizenePomery((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                }
                else if (os_cislo != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = strom.PrimoPodrizenaMista((decimal)os_cislo);
                        }
                        else
                        {
                            mista = strom.PodrizenaMista((decimal)os_cislo);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoPodrizeniLide((decimal)os_cislo);
                        }
                        else
                        {
                            lide = strom.PodrizeniLide((decimal)os_cislo);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoPodrizenePomery((decimal)os_cislo);
                        }
                        else
                        {
                            pomery = strom.PodrizenePomery((decimal)os_cislo);
                        }
                    }
                }
            }
            else
            {
                if (id_pracmist != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = new List<int>() { strom.PrimoNadrizeneMisto((int)id_pracmist) ?? -1 };
                        }
                        else
                        {
                            mista = strom.NadrizenaMista((int)id_pracmist);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoNadrizeniLide((int)id_pracmist);
                        }
                        else
                        {
                            lide = strom.NadrizeniLide((int)id_pracmist);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoNadrizenePomery((int)id_pracmist);
                        }
                        else
                        {
                            pomery = strom.NadrizenePomery((int)id_pracmist);
                        }
                    }
                }
                else if (os_cislo != null && cislo_pom != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = new List<int>() { strom.PrimoNadrizeneMisto((decimal)os_cislo, (short)cislo_pom) ?? -1 };
                        }
                        else
                        {
                            mista = strom.NadrizenaMista((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoNadrizeniLide((decimal)os_cislo, (short)cislo_pom);
                        }
                        else
                        {
                            lide = strom.NadrizeniLide((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoNadrizenePomery((decimal)os_cislo, (short)cislo_pom);
                        }
                        else
                        {
                            pomery = strom.NadrizenePomery((decimal)os_cislo, (short)cislo_pom);
                        }
                    }
                }
                else if (os_cislo != null)
                {
                    if (RadButton3.SelectedToggleState.Value == "mista")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            mista = strom.PrimoNadrizeneMisto((decimal)os_cislo);
                        }
                        else
                        {
                            mista = strom.NadrizenaMista((decimal)os_cislo);
                        }
                    }
                    else if (RadButton3.SelectedToggleState.Value == "lide")
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            lide = strom.PrimoNadrizeniLide((decimal)os_cislo);
                        }
                        else
                        {
                            lide = strom.NadrizeniLide((decimal)os_cislo);
                        }
                    }
                    else
                    {
                        if (RadButton2.SelectedToggleState.Value == "primi")
                        {
                            pomery = strom.PrimoNadrizenePomery((decimal)os_cislo);
                        }
                        else
                        {
                            pomery = strom.NadrizenePomery((decimal)os_cislo);
                        }
                    }
                }
            }

            if (mista != null)
            {
                RadTextBox1.Text = string.Join(", ", mista);
            }
            else if(lide != null)
            {
                RadTextBox1.Text = string.Join(", ", lide);
            }
            else if(pomery != null)
            {
                RadTextBox1.Text = "";
                foreach (Tuple<decimal, short> p in pomery)
                {
                    RadTextBox1.Text += "(" + p.Item1.ToString() + ", " + p.Item2.ToString() + "), ";
                }
            }
            else
            {
                RadTextBox1.Text = "";
            }
        }
    }
}