﻿using KSProgram.Data;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web.UI;
using Telerik.Web.UI;

namespace KSPortal.Development
{
    public partial class Statistika : TPage
    {

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        private static DataTable GetData(DateTime datumOd, DateTime datumDo)
        {
            DataTable table = new DataTable();
            table.Columns.Add("polozka", typeof(string));
            table.Columns.Add("hodnota", typeof(Int32));
            IDataReader reader = null;
            string stranka = null;
            Int32? pocet = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader("Select * from statistiky_pouziti where obdobi >= " + SqlPrikaz.ValueToString(datumOd) + " and obdobi <= " + SqlPrikaz.ValueToString(datumDo) + " and polozka LIKE '%.aspx'");
                while (reader.Read())
                {
                    stranka = GetNullOrData.GetString(reader, "polozka");
                    pocet = GetNullOrData.GetInt32(reader, "hodnota", 0);
                    table.Rows.Add(stranka, pocet);
                }
            }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                    reader.Dispose();
                }
            }
            return table;
        }

        protected void TRgrdStatistika_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            //DataTable table = GetData((DateTime)TRobdInterval.SelectedDateOd, (DateTime)TRobdInterval.SelectedDateDo);
            DataTable table = GetData((DateTime)TRgrdStatistikaMax.Datum.SelectedObdobiOd, (DateTime)TRgrdStatistikaMax.Datum.SelectedObdobiDo);
            ((TRadGrid)sender).DataSource = table;
            return;
            //table.PrimaryKey = new DataColumn[] { table.Columns["polozka"] };
            //List<Tuple<string, string>> list = TMenu.getLastNodeMenu();
            //foreach (Tuple<string, string> tuple in list)
            //{
            //    string text = tuple.Item2;
            //    string pat = @"([a-zA-Z0-9\-])*.aspx$";
            //    Regex r = new Regex(pat, RegexOptions.IgnoreCase);
            //    Match m = r.Match(text);
            //    if (!table.Rows.Contains(m.Value))
            //    {
            //        table.Rows.Add(m.Value, 0);
            //    }
            //}
            //int rCountMax = (int)(table.Rows.Count * 0.5);
            //int rCountMin = table.Rows.Count - rCountMax;
            //DataTable tableMax = new DataTable();
            //DataTable tableMin = new DataTable();
            //tableMax = table.Clone();
            //tableMin = table.Clone();
            //table.AsEnumerable().OrderByDescending(x => x["hodnota"]).Take(rCountMax).CopyToDataTable(tableMax, LoadOption.OverwriteChanges);
            //table.AsEnumerable().OrderBy(x => x["hodnota"]).Take(rCountMin).CopyToDataTable(tableMin, LoadOption.OverwriteChanges);
            //tableMin.DefaultView.Sort = "hodnota desc";

            //if ((TRadGrid)sender == TRgrdStatistikaMax)
            //{
            //    ((TRadGrid)sender).DataSource = tableMax;
            //    TRgrdStatistikaMin.Rebind();
            //}
            //if ((TRadGrid)sender == TRgrdStatistikaMin)
            //    ((TRadGrid)sender).DataSource = tableMin;
        }

        protected void TRbtnNaci_Click(object sender, EventArgs e)
        {
            TRgrdStatistikaMax.Rebind();
            TRgrdStatistikaMin.Rebind();
        }

        protected void TRgrdStatistikaMin_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem && ((int)DataBinder.Eval(e.Item.DataItem, "hodnota") == 0))
            {

                ((GridDataItem)e.Item)["hod"].ForeColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(Color.Red, 65);
                ((GridDataItem)e.Item)["hod"].Font.Bold = true;
                ((GridDataItem)e.Item)["min_hod"].ForeColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(Color.Red, 65);
                ((GridDataItem)e.Item)["min_hod"].Font.Bold = true;
                ((GridDataItem)e.Item)["max_hod"].ForeColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(Color.Red, 65);
                ((GridDataItem)e.Item)["max_hod"].Font.Bold = true;
            }
        }
    }
}