﻿using KSProgram;
using System;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Extensions;
using System.Globalization;
using System.Web.Services;
using static KSProgram.Pozadavky.PozadavekSeznam;
using System.Web.Script.Serialization;
using KSProgram.Ciselniky;
using System.Collections;
using KSProgram.Pozadavky;
using KSProgram.Dochazka;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram.Data;
using System.Data.Common;
using System.Data;

namespace KSProgram.Dochazka
{
    public partial class DchUkoly : TPageZam
    {
        public DchUkoly()
        {
            IdPrava = 292;
        }

        bool updateRunning = false;

        private decimal OsCislo
        {
            get
            {
                return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
            }
            set
            {
                ViewState["OsCislo"] = value;
            }
        }

        private short CisloPom
        {
            get
            {
                return (ViewState["CisloPom"] == null ? (short)-1 : Convert.ToInt16(ViewState["CisloPom"]));
            }
            set
            {
                ViewState["CisloPom"] = value;
            }
        }

        private DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi"] == null ? new DateTime() : Convert.ToDateTime(ViewState["Obdobi"]));
            }
            set
            {
                ViewState["Obdobi"] = value.PrvniDen();
            }
        }

        private bool form_editable
        {
            get
            {
                return (ViewState["form_editable"] == null ? true : Convert.ToBoolean(ViewState["form_editable"]));
            }
            set
            {
                ViewState["form_editable"] = value;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!string.IsNullOrEmpty(this.Request["__EVENTTARGET"]))
            {
                if (this.Request["__EVENTTARGET"].EndsWith("$lb_zmena_stavu"))
                {
                    Nacist();
                    RadGrid1.DataBind();
                }
            }           
        }

        protected void Nacist()
        {
            PanelZmenaStavu.Visible = false;
            Obdobi = ((DateTime)RadGrid1.Datum.SelectedDatum).PrvniDen();
            //if ((!ModelyPdZam.ModelProZamStruct(OsCislo, CisloPom, Obdobi).SchvalNe) && (Parametry.ParametrCti("Dochazka") == "a"))
            //PH 26.3.2019
            if ((!ModelyPdZam.ModelProZamStruct(OsCislo, CisloPom, Obdobi).SchvalNe) && (Parametry.ParametrCti("Dochazka") != "n"))
            {
                int id_poz = Pozadavek.Exists(OsCislo, CisloPom, "dochazka", Obdobi);

                workfl_hl whl = new workfl_hl();
                Str_workfl_hl st = whl.NaplnStrukturu(id_poz);
                WorkflowMaster wf = new WorkflowMaster(id_poz, "dochazka", null);

                string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
                if (zmstavu == "true")
                {
                    dsStavyEdit.SelectParameters[0].DefaultValue = id_poz.ToString();

                    PanelZmenaStavu.Visible = true;
                    ddl_zmena_stavu.DataSourceID = "dsStavyEdit";
                }

                string editable = wf.Get_UN("", "form_editable", "Enabled");

                form_editable = ((editable == "true") || (editable == ""));

            }
            else
                form_editable = ((Dch_Uzaverka.GetAktObdobi(Globals.OsCislo) <= Obdobi) || Dochazka.SuperUser);

            lb_generovat.Visible = form_editable;//PH 16.10.2017 HD 16.10.2017
            ScriptManager.RegisterStartupScript(this.Page, typeof(DchUkoly), "form_editable", "frmEdit=" + (form_editable == true ? "true" : "false") + ";", true);

            nadpis.Text = WebControlHelper.ZmenaTextu("[%Úkolový výkaz práce%]") + " - " + Obdobi.NazevMesice() + " " + Obdobi.Year.ToString();
        }

        protected void lb_zmena_stavu_Command(object sender, CommandEventArgs e)
        {
            DateTime datum = Obdobi;
            int id_poz = Pozadavek.Exists(OsCislo, CisloPom, "dochazka", datum);
            string stav = ddl_zmena_stavu.SelectedValue.ToString();

            WorkflowProces.KrokProcesuTrans(id_poz, stav, "", 0);
            PanelZmenaStavu.DataBind();
        }

        protected override void OnPreRenderComplete(EventArgs e)
        {
            base.OnPreRenderComplete(e);
            if (ddl_zmena_stavu.Items.Count <= 1)
                PanelZmenaStavu.Visible = false;
            else
                PanelZmenaStavu.Visible = true;

            
        }

        protected void RadGrid1_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            int citac = 0;         
            foreach (Telerik.Web.UI.GridBatchEditingCommand command in e.Commands)

                if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Update)
                {                   
                    citac++;

                    Hashtable oldValues = command.OldValues;
                    Hashtable newValues = command.NewValues;

                    string old_projekt = string.Empty;
                    string old_ukol = string.Empty;
                    string old_kod = string.Empty;
                    if (oldValues["projekt"] != null)
                        old_projekt = oldValues["projekt"].ToString();
                    if (oldValues["ukol"] != null)
                        old_ukol = oldValues["ukol"].ToString();
                    if (oldValues["kod"] != null)
                        old_kod = oldValues["kod"].ToString();

                    if ((!string.IsNullOrEmpty(old_projekt)) && (!string.IsNullOrEmpty(old_ukol)) && (!string.IsNullOrEmpty(old_kod)))
                    {
                        dch_poriz_ukolu.Delete(OsCislo, CisloPom, Obdobi, old_projekt, old_ukol, Convert.ToInt32(old_kod));
                    }

                    string projekt = newValues["projekt"].ToString();
                    string ukol = newValues["ukol"].ToString();
                    string kod = newValues["kod"].ToString();
                    /*
                    if ((!string.IsNullOrEmpty(projekt)) && (!string.IsNullOrEmpty(ukol)) && (!string.IsNullOrEmpty(kod)))
                    {
                        List<decimal> lst = new List<decimal>();
                        for (int i = 0; i < 31; i++)
                        {
                            int index = (i + 1);
                            string den = string.Empty;
                            if (newValues["d" + index.ToString()] != null)
                                den = newValues["d" + index.ToString()].ToString();
                            decimal hodiny = 0;
                            decimal d;
                            if (decimal.TryParse(den, out d))
                                hodiny = d;
                            lst.Add(hodiny);
                        }
                        if (lst.Exists(aa => aa != 0))
                            dch_poriz_ukolu.Save(OsCislo, CisloPom, Obdobi, projekt, ukol, Convert.ToInt32(kod), ref lst);
                    }
                    */
                    if ((!string.IsNullOrEmpty(projekt)) && (!string.IsNullOrEmpty(ukol)) && (!string.IsNullOrEmpty(kod)))
                    {
                        List<DateTime> lst = new List<DateTime>();
                        for (int i = 0; i < 31; i++)
                        {
                            int index = (i + 1);
                            DateTime den = new DateTime();
                            if ((newValues["d" + index.ToString()] != null) && (newValues["d" + index.ToString()].ToString() != string.Empty))
                            {
                                //den = Convert.ToDateTime(newValues["d" + index.ToString()]);
                                //den = Obdobi.AddDays(Convert.ToInt32(index - 1)).AddHours(Convert.ToDateTime(newValues["d" + index.ToString()]).Hour);
                                //PH 12.11.2018
                                string val = newValues["d" + index.ToString()].ToString();
                                if (val == "24:00")
                                    val = "23:59:59";
                                DateTime pp = Convert.ToDateTime(val);
                                den = Obdobi.AddDays(Convert.ToInt32(index - 1)).AddMinutes(pp.Hour).AddSeconds(pp.Minute);
                            }
                            if (den != new DateTime())
                                lst.Add(den);
                        }
                        if (lst.Exists(aa => aa != new DateTime()))
                        {
                            /*
                            if (citac == 1)//PH 14.9.2019 HID:46387 musím promazat pro stejný kód projekt úkol, jinak
                                //by to tam uživatel mohl dostal dvakrát
                                dch_poriz_ukolu.Delete(OsCislo, CisloPom, Obdobi, projekt, ukol, Convert.ToInt32(kod));
                             PH 6.8.2019 zapoznámkovávám promazání řeším před uložením ve funkci Save */
                            dch_poriz_ukolu.Save(OsCislo, CisloPom, Obdobi, projekt, ukol, Convert.ToInt32(kod), ref lst, command.Item.DataSetIndex);
                        }

                        RadGrid1.Rebind();
                    }
                    e.Canceled = true;
                }
        }

        protected void RadGrid1_ItemInserted(object source, GridInsertedEventArgs e)
        {
            if (e.Exception != null)
            {
                e.ExceptionHandled = true;
                //NotifyUser("Product cannot be inserted. Reason: " + e.Exception.Message);
            }
            else
            {
                // NotifyUser("New product is inserted!");
            }
        }

        protected void RadGrid1_ItemDeleted(object source, GridDeletedEventArgs e)
        {
            /*
            GridDataItem dataItem = (GridDataItem)e.Item;
            String id = dataItem.GetDataKeyValue("ProductID").ToString();
            if (e.Exception != null)
            {
                e.ExceptionHandled = true;
                //NotifyUser("Product with ID " + id + " cannot be deleted. Reason: " + e.Exception.Message);
            }
            else
            {
                //NotifyUser("Product with ID " + id + " is deleted!");
            }
            */
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            //RadNumericTextBox unitsNumericTextBox = (RadGrid1.MasterTableView.GetBatchColumnEditor("UnitsInStock") as GridNumericColumnEditor).NumericTextBox;
            //unitsNumericTextBox.Width = Unit.Pixel(60);            
            DateTime obdobi = ((DateTime)RadGrid1.Datum.SelectedDatum).PrvniDen();
            DateTime posl = obdobi.PosledniDen();
            DateTime ld_pom = obdobi.PrvniDen();
            GridHeaderItem headerItem = RadGrid1.MasterTableView.GetItems(GridItemType.Header)[0] as GridHeaderItem;
            int citac = 0;
            string df = string.Empty;
            string expr = string.Empty;
            while (ld_pom <= posl)
            {
                string ls_titulek = string.Format("{0}, {1} {2}", DateTimeFormatInfo.CurrentInfo.GetAbbreviatedDayName(ld_pom.DayOfWeek).ToUpper(), ld_pom.Month.ToRoman(), ("0" + ld_pom.Day).Right(2));

                headerItem["d" + ld_pom.Day.ToString()].Text = ls_titulek;

                ld_pom = ld_pom.AddDays(1);
                citac++;

                df += "d" + ld_pom.Day.ToString() + ",";
                expr += "{" + (citac - 1) + "}+";

                GridColumn col = RadGrid1.MasterTableView.GetColumn("d" + ld_pom.Day.ToString());
                col.Display = true;
            }

            //expr = expr.Substring(0, expr.Length - 1);
            //df = df.Substring(0, df.Length - 1);

            for (int i = (citac + 1); i <= 31; i++)
            {
                GridColumn col = RadGrid1.MasterTableView.GetColumn("d" + i.ToString());
                col.Display = false;
            }

            //((GridCalculatedColumn) RadGrid1.MasterTableView.GetColumn("r_suma")).Expression="d1+d2+d3+d4+d5";
            //((GridCalculatedColumn)RadGrid1.MasterTableView.GetColumn("r_suma")).DataFields = df.Split(new char[1] { ','});


            foreach (GridDataItem dataItem in RadGrid1.MasterTableView.Items)
            {
                for (int i = 0; i < dataItem.Controls.Count; i++)
                {
                    Label lab = dataItem["IndikId"].FindControl("lab_indik") as Label;
                    if (lab != null)
                    {
                        if (lab.Text == "w")
                        {
                            WebControl wc = dataItem.Controls[i] as WebControl;
                            if (wc != null)
                                wc.ForeColor = System.Drawing.Color.Blue;
                        }
                    }
                }

                /*
                (dataItem["d1"].FindControl("txt_d1") as TextBox).Attributes.Add("onblur", "update('" + clientID + "'" + "," + "'" + (dataItem["d1"].FindControl("txt_d1") as TextBox).ClientID + "')");
                (dataItem["d1"].FindControl("txt_d1") as TextBox).Attributes.Add("onfocus", "getInitialValue('" + (dataItem["d1"].FindControl("txt_d1") as TextBox).ClientID + "')");
                */
            }
        }

        protected void RadGrid1_DataBinding(object sender, EventArgs e)
        {
            ObjectDataSource1.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.SelectParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
            // ObjectDataSource1.SelectParameters["datum"].DefaultValue = ((DateTime)RadGrid1.Datum.SelectedDatum).ToString();

            if (!IsPostBack)
            {
                RadGrid1.Datum.SelectedDatumOd = ParametryDochazky.OBDOBI_PRO_SESTAVY; //PH 22.1.2018
                RadGrid1.Datum.SelectedDatumDo = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            }

            OsCislo = Globals.OsCisloPomer.OsCislo;
            CisloPom = Globals.OsCisloPomer.CisloPom;
            Obdobi = (DateTime)RadGrid1.Datum.SelectedDatum;
        }

        Int32[] suma = new Int32[31];
        int suma_celk = 0;
        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
            {
                suma = new Int32[31];
                suma_celk = 0;
            }
            else if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;
                for (int i = 1; i <= 31; i++)
                {
                    //if ((i == 6)&&(dataItem.ItemIndex==1))
                    //{
                    //    //dataItem["d"+i.ToString()].AssociatedHeaderCellID
                    //    dataItem.Cells[i].Attributes["style"] = "background-color:SlateGray;";
                    //}

                    if (dataItem["d" + i.ToString()].Text != null)
                    {
                        DateTime ld_den;
                        if (DateTime.TryParse(dataItem["d" + i.ToString()].Text, out ld_den))
                        {
                            //suma[i - 1] += ld_den.Hour * 60 + ld_den.Minute;
                            //PH 12.11.2018
                            suma[i - 1] += ld_den.Minute * 60 + ld_den.Second;
                        }
                    }
                }
                // dat_nastupu = (DateTime)DataBinder.Eval(e.Item, "datum_nastupu");
                object o = DataBinder.Eval(e.Item.DataItem, "suma_min");
                int ss;
                if (Int32.TryParse(o.ToString(), out ss))
                    suma_celk += ss;


            }
            else if (e.Item is GridFooterItem)
            {
                GridFooterItem footer = (GridFooterItem)e.Item;
                for (int i = 1; i <= 31; i++)
                {
                    if (suma[i - 1] > 0)
                        footer.Cells[i + 6].Text = Cas_na_min.GetCasString(suma[i - 1]);
                    else
                        footer.Cells[i + 6].Text = "";
                }

                footer.Cells[footer.Cells.Count - 1].Text = Cas_na_min.GetCasString(suma_celk);
            }

        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            ObjectDataSource1.UpdateParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.UpdateParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            ObjectDataSource1.InsertParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.InsertParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
        }


        protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            // _pre_Update();
        }

        protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            _pre_Update();
        }

        private void _pre_Update()
        {
            if (!updateRunning)
                dch_poriz_ukolu.Delete(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, (DateTime)RadGrid1.Datum.SelectedObdobi);
            updateRunning = true;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="co"></param>
        /// <param name="datum"></param>
        /// <param name="hodnota1"></param>
        /// <param name="hodnota2"></param>
        /// <param name="hodnota3"></param>
        /// <param name="hodnota4"></param>
        /// <returns></returns>
        [WebMethod]
        public static string Testuj(string co, DateTime datum, string hodnota1, string hodnota2, decimal? hodnota3/*, int? hodnota4, string oldHodnota*/)
        {
            bool ret = false;
            //string mess = "";
            if (co == "projekt")
            {
                if (string.IsNullOrEmpty(hodnota1)) return "ok";
                ret = dch_poriz_ukolu.ProjektExist(hodnota1, datum);
            }
            else if (co == "ukol")
            {
                if (string.IsNullOrEmpty(hodnota2)) return "ok";
                ret = dch_poriz_ukolu.UkolProProjektExists(hodnota1, hodnota2, datum);
            }
            else if (co == "kod")
            {
                /*
                if (!string.IsNullOrEmpty(oldHodnota))
                {
                    int kod;
                    if (Int32.TryParse(oldHodnota, out kod))
                    {
                        if (dch_poriz_ukolu.WF_exists(kod, datum))
                            return "wf";
                    }
                }

                if (string.IsNullOrEmpty(hodnota1)) return "ok";
                */
                int pok;
                if (!Int32.TryParse(hodnota1, out pok))
                    ret = false;
                else
                    ret = CisDchKody.Exists(Convert.ToInt32(hodnota1));
            }
            else if (co == "hod")
            {
                //if (hodnota3==null) return "ok";
                ret = dch_poriz_ukolu.UkolProProjektExists(hodnota1, hodnota2, hodnota3, datum);
                /*               
                if (ret)
                {
                    ret=!dch_poriz_ukolu.WF_exists(datum, hodnota3, hodnota4);
                    if (!ret) mess = "wf";
                }
                */
            }

            return (ret == true ? "ok" : "chyba");
            //return (ret == true ? "ok" : (String.IsNullOrEmpty(mess) ? "chyba" : mess));
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static ResultData Testuj(string data)
        {
            decimal? hodnota3 = null;
            ResultData res = new ResultData();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            DateTime datum = Globals.Db.GetDateTime(jsonObject[0]["datum"]);
            string hodnota1 = (string)jsonObject[1]["hodnota1"];
            string hodnota2 = (string)jsonObject[2]["hodnota2"];
            if (!string.IsNullOrEmpty(jsonObject[3]["hodnota3"]))
            {
                //decimal dec;
                // if (decimal.TryParse(jsonObject[3]["hodnota3"], out dec))
                hodnota3 = 1;
            }
            string co = (string)jsonObject[4]["co"];
            /*
            int? hodnota4 = null;                        
            if (jsonObject[5]["hodnota4"]!=null)
            {
                int kod = 0;
                Int32.TryParse((string)jsonObject[5]["hodnota4"], out kod);
                if (kod != 0)
                    hodnota4 = kod;
            }

            string oldHodnota=(string)jsonObject[6]["oldHodnota"];
            */
            res.Count = 1;
            res.Data = new List<object>();
            res.Data.Add(Testuj(co, datum, hodnota1, hodnota2, hodnota3/*, hodnota4, oldHodnota*/));

            return res;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static ResultData NazevKodu(string data)
        {
            ResultData res = new ResultData();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            string kod = (string)jsonObject[0]["kod"];
            short li_kod;
            string nazev = string.Empty;
            if (short.TryParse(kod, out li_kod))
                nazev = CisDchKody.GetNazev(li_kod);

            res.Count = 1;
            res.Data = new List<object>();
            res.Data.Add(nazev);

            return res;
        }

        protected void RadGrid1_DeleteCommand(object sender, GridCommandEventArgs e)
        {

        }

        protected void RadGrid1_DataBound(object sender, EventArgs e)
        {
            Nacist();
        }

        protected void lb_generovat_Command(object sender, CommandEventArgs e)
        {

            StrZam zam = new StrZam();

            DateTime posl = Obdobi.PosledniDen();
            //do struktury doplním údaje nutné pro další zpracování
            DochazkaFunkce df = new DochazkaFunkce();
            df.NaplnStrukturuStrZam(Obdobi, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ref zam);

            //provedu automatické doplnění
            TDataTable data = Dochazka.AutDoplneniNacist(zam, Obdobi, posl);
            using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
            {
                try
                {
                    Dochazka.AutDoplneniUlozit(zam, Obdobi, posl, data, true, "a");
                    SqlPrikaz.Commit();
                }
                catch
                {
                    SqlPrikaz.Rollback();
                    throw;
                }
            }
            RadGrid1.DataBind();
            Nacist();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static RadComboBoxData GetDim1(RadComboBoxContext context)
        {
            int rok = 0;
            int mes = 0;
            if (context.ContainsKey("obdobi"))
            {
                string obd = context["obdobi"].ToString();
                // if (obd.Length != 10) return new RadComboBoxData();

                rok = Convert.ToInt32(obd.Substring(0, 4));
                mes = Convert.ToInt32(obd.Substring(4));
            }
            else
            {
                rok = Globals.AktObdobi.Year;
                mes = Globals.AktObdobi.Month;
            }
            DataTable datatb = dch_poriz_ukolu.Projekty(new DateTime(rok, mes, 1));
            datatb.Columns.Add("cely_nazev", typeof(string), "projekt + ' '+ nazev");

            DataRow[] data = null;
            if (!string.IsNullOrEmpty(context.Text))
            {
                data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "nazev");
            }
            else
            {
                data = datatb.Select("nazev = nazev", "nazev");
            }


            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Length)
                {
                    endOffset = data.Length;
                }
                if (endOffset == data.Length)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    //string nazev=data[i]["nazev"].ToString();
                    //string val = data[i]["projekt"].ToString();

                    itemData.Text = data[i]["projekt"].ToString();
                    itemData.Value = data[i]["projekt"].ToString();
                    itemData.Attributes.Add("nazev", data[i]["nazev"]);


                    result.Add(itemData);
                }

                if (data.Length > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;

        }

        [WebMethod(EnableSession = true)]
        public static RadComboBoxData GetDim2(RadComboBoxContext context)
        {
            string obd = context["obdobi"].ToString();
            int rok = Convert.ToInt32(obd.Substring(0, 4));
            int mes = Convert.ToInt32(obd.Substring(4));
            DateTime obdobi = new DateTime(rok, mes, 1);

            string projekt = context["projekt"].ToString();

            DataTable datatb = dch_poriz_ukolu.Ulohy_pro_projekt(projekt, obdobi);
            //datatb.Columns.Add("cely_nazev", typeof(string), "uloha + ' '+nazev");
            DataRow[] data = null;
            if (!string.IsNullOrEmpty(context.Text))
            {
                data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cely_nazev");
            }
            else
            {
                data = datatb.Select("nazev = nazev", "nazev");
            }


            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Length)
                {
                    endOffset = data.Length;
                }
                if (endOffset == data.Length)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Text = data[i]["uloha"].ToString();
                    itemData.Value = data[i]["uloha"].ToString();
                    itemData.Attributes.Add("nazev", data[i]["nazev"]);

                    /*
                      itemData.Text = data[i]["projekt"].ToString();
                    itemData.Value = data[i]["projekt"].ToString();
                    itemData.Attributes.Add("nazev", data[i]["nazev"]);
                     * */

                    result.Add(itemData);
                }

                if (data.Length > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;

        }

        [WebMethod(EnableSession = true)]
        public static RadComboBoxData GetKody(RadComboBoxContext context)
        {
            //DataTable datatb = CisDchKody.DbSelect();
            DataTable datatb = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("D", Globals.OsCislo, Globals.OsCisloPomer.CisloPom);
            //datatb.Columns.Add("kod_nazev", typeof(string), "kod + ' '+nazev");
           
            DataRow[] data = null;
            if (!string.IsNullOrEmpty(context.Text))
            {
                data = datatb.Select("kod_nazev LIKE '%" + context.Text + "%'", "kod_nazev");
            }
            else
            {
                data = datatb.Select("nazev = nazev", "nazev");
            }


            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Length)
                {
                    endOffset = data.Length;
                }
                if (endOffset == data.Length)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    //itemData.Text = data[i]["vyr_kod"].ToString();
                    //itemData.Value = data[i]["vyr_kod"].ToString();
                    //itemData.Attributes.Add("nazev", data[i]["nazev"]);

                    itemData.Text = data[i]["kod"].ToString();
                    itemData.Value = data[i]["kod"].ToString();
                    itemData.Attributes.Add("nazev", data[i]["nazev"]);

                    /*
                      itemData.Text = data[i]["projekt"].ToString();
                    itemData.Value = data[i]["projekt"].ToString();
                    itemData.Attributes.Add("nazev", data[i]["nazev"]);
                     * */

                    result.Add(itemData);
                }

                if (data.Length > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;

        }

        protected void RadGrid1_ColumnCreating(object sender, GridColumnCreatingEventArgs e)
        {
            if (e.ColumnType== "DateTime")
            {
                
            }
        }
    }
}