﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Specialized;
using KSProgram.Data;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram;
using KSProgram.Dochazka;
using KSProgram.Pozadavky;
using System.Data.Common;
using System.Data;
using KSProgram.Extensions;
using System.Web.Services;
using static KSProgram.Dochazka.PlanovaniSmen;
using System.Web.Script.Serialization;
using KSProgram.Prava;

namespace KSPortal.Dochazka
{
    public partial class DochAutGen : TPageZam
    {
        public DochAutGen()
        {
            IdPrava = 15;

        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                NabidkaObdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;
                NabidkaObdobi.Picker.MinDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;

                Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs calendar_selectonchanged = new Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs(NabidkaObdobi.SelectedDate, NabidkaObdobi.SelectedDate);
                NabidkaObdobi_SelectedDateChanged(NabidkaObdobi, calendar_selectonchanged);
            }
        }

        protected void button_list_SelectedIndexChanged(object sender, EventArgs e)
        {
            //StrSkupDiv1.Enabled = (button_list.SelectedValue == "jednotka");
        }

        protected void NabidkaObdobi_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            DateTime ld_prvni = (DateTime)NabidkaObdobi.SelectedDate;
            DateTime ld_posl = ld_prvni.PosledniDen();
            Calendar1.RangeMinDate = ld_prvni;
            Calendar1.RangeMaxDate = ld_posl;
            Calendar2.RangeMinDate = ld_prvni;
            Calendar2.RangeMaxDate = ld_posl;
            Calendar1.SelectedDate = ld_prvni;
            Calendar2.SelectedDate = ld_posl;

            Calendar1_SelectionChanged(sender, e);
            Calendar2_SelectionChanged(sender, e);
        }

        protected void Calendar1_SelectionChanged(object sender, EventArgs e)
        {
            DateTime dt_od = Calendar1.SelectedDate;
            LabelOd.Text = "[%Od%]: " + dt_od.ToString("d.M.yyyy");
            WebControlHelper.ZmenaTextu(LabelOd);

        }
        protected void Calendar2_SelectionChanged(object sender, EventArgs e)
        {
            DateTime dt_do = Calendar2.SelectedDate;
            DateTime pm = Calendar1.SelectedDate;
            LabelDo.Text = "[%Do%]: " + dt_do.ToString("d.M.yyyy");
            WebControlHelper.ZmenaTextu(LabelDo);

        }

        protected void lnkProvest_Command(object sender, CommandEventArgs e)
        {
            int kod = Convert.ToInt32(Globals.DchKody.KodPrac);
            if (kod == 0)
            {
                lbl_problem.Text = "[%Nelze generovat. U jednoho kódu musí být vyplněna identifikace 'příchod'%]";
                return;
            }
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                lbl_problem.Text = ZamykaniAgend.GeneralZamekLockedMessage;
                return;
            }

            DateTime dt_od = Calendar1.SelectedDate;
            DateTime dt_do = Calendar2.SelectedDate;

            DateTime obd = new DateTime(dt_od.Year, dt_od.Month, 1);
            /*
            StrZam zam = new StrZam();
            if (button_list.SelectedValue=="all")
            {
                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";

                string sql = "select A.os_cislo, B.cislo_pom " +
                                " from pracovnici A, prac_pom B " +
                                " where A.os_cislo=B.os_cislo " +
                                " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                                " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +
                                //" and " + ls_tab + ".doch_karta='a'";
                                //PH 9.3.2015
                                DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                        //if (Globals.RadkovePrava.OsCislo(os_cislo))
                        //PH 26.5.2015
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            DochazkaFunkce df = new DochazkaFunkce();
                            df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), os_cislo, cislo_pom, ref zam);                           
                            if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                            {
                                //do struktury doplním údaje nutné pro další zpracování
                                //DochazkaFunkce df = new DochazkaFunkce();
                                //df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), os_cislo, cislo_pom, ref zam);
                                TDataTable data = KSProgram.Dochazka.Dochazka.AutDoplneniNacist(zam, dt_od, dt_do);

                                using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
                                {
                                    try
                                    {
                                        KSProgram.Dochazka.Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, true, "a");
                                        SqlPrikaz.Commit();
                                    }
                                    catch
                                    {
                                        SqlPrikaz.Rollback();
                                        throw;
                                    }
                                }
                            }
                        }
                    }
                    reader.Close();
                }

               
            }
            else if (button_list.SelectedValue == "jeden")
            {
                DochazkaFunkce df = new DochazkaFunkce();
                df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ref zam);

                //provedu automatické doplnění, pokud docházka není ve stavu kdy to nelze
                //if (DochazkaFunkce.AutomaticGenerationAllowed(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, new DateTime(dt_od.Year, dt_od.Month, 1)))
                //PH 16.12.2014
                if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                {
                    //do struktury doplním údaje nutné pro další zpracování
                    //DochazkaFunkce df = new DochazkaFunkce();
                    //df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ref zam);
                    TDataTable data = KSProgram.Dochazka.Dochazka.AutDoplneniNacist(zam, dt_od, dt_do);

                    using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
                    {
                        try
                        {
                            KSProgram.Dochazka.Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, true, "a");
                            SqlPrikaz.Commit();
                        }
                        catch
                        {
                            SqlPrikaz.Rollback();
                            throw;
                        }
                    }
                }
            }
            else if (button_list.SelectedValue == "jednotka")
            {
                string ls_stred=StrSkupDiv1.GetStred();
                if (string.IsNullOrEmpty(ls_stred)) ls_stred = "'-1'";

                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";

                string sql = "select A.os_cislo, B.cislo_pom " +
                               " from pracovnici A, prac_pom B " +
                               " where A.os_cislo=B.os_cislo " +
                               " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                               " and B.prac_str in("+ls_stred+") "+
                               " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +                    
                               DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);                       
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            DochazkaFunkce df = new DochazkaFunkce();
                            df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), os_cislo, cislo_pom, ref zam);                          
                            if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                            {                                
                                TDataTable data = KSProgram.Dochazka.Dochazka.AutDoplneniNacist(zam, dt_od, dt_do);
                                using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
                                {
                                    try
                                    {
                                        KSProgram.Dochazka.Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, true, "a");
                                        SqlPrikaz.Commit();
                                    }
                                    catch
                                    {
                                        SqlPrikaz.Rollback();
                                        throw;
                                    }
                                }
                            }
                        }
                    }
                    reader.Close();
                }
            }
            */

            StrZam zam = new StrZam();

            List<OSC_POMER> list = new List<OSC_POMER>();
            if (button_list.SelectedValue == "all")
            {
                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";

                string sql = "select A.os_cislo, B.cislo_pom " +
                                " from pracovnici A, prac_pom B " +
                                " where A.os_cislo=B.os_cislo " +
                                " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                                " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +
                                //" and " + ls_tab + ".doch_karta='a'";
                                //PH 9.3.2015
                                DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            //DochazkaFunkce df = new DochazkaFunkce();
                            //df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), os_cislo, cislo_pom, ref zam);
                            //if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                            //{
                                list.Add(new OSC_POMER { Os_cislo = os_cislo, Cislo_pom = cislo_pom });
                            //}
                        }
                    }
                    reader.Close();
                }
            }
            else if (button_list.SelectedValue == "jeden")
            {
                //DochazkaFunkce df = new DochazkaFunkce();
                //df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ref zam);
                //if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                //{
                    list.Add(new OSC_POMER { Os_cislo = Globals.OsCisloPomer.OsCislo, Cislo_pom = Globals.OsCisloPomer.CisloPom });
                //}
            }
            else if (button_list.SelectedValue == "jednotka")
            {
                string ls_stred = StrSkupDiv1.GetStred();
                if (string.IsNullOrEmpty(ls_stred)) ls_stred = "'-1'";

                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";

                string sql = "select A.os_cislo, B.cislo_pom " +
                               " from pracovnici A, prac_pom B " +
                               " where A.os_cislo=B.os_cislo " +
                               " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                               " and B.prac_str in(" + ls_stred + ") " +
                               " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +
                               DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            //DochazkaFunkce df = new DochazkaFunkce();
                            //df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), os_cislo, cislo_pom, ref zam);
                            //if (DochazkaFunkce.AutomaticGenerationAllowed(zam, new DateTime(dt_od.Year, dt_od.Month, 1)))
                            //{
                                list.Add(new OSC_POMER { Os_cislo = os_cislo, Cislo_pom = cislo_pom });
                           // }
                        }
                    }
                    reader.Close();
                }
            }

            string script = "";
            DataTable table = new DataTable();
            table.Columns.Add("oc", typeof(decimal));
            table.Columns.Add("cp", typeof(short));
            foreach (OSC_POMER p in list)
            {
                DataRow row = table.Rows.Add();
                row["oc"] = p.Os_cislo;
                row["cp"] = p.Cislo_pom;
            }
            script = F_Json.Serialize(table);
            script = "message_zpracovani ='" + WebControlHelper.ZmenaTextu("[%Zpracováno pracovních poměrů%]") + "';rok_od=" + dt_od.Year.ToString() + ";mes_od=" + dt_od.Month.ToString()+ ";den_od=" +dt_od.Day.ToString()+ ";rok_do=" + dt_do.Year.ToString() + ";mes_do=" + dt_do.Month.ToString() + ";den_do=" + dt_do.Day.ToString() + "; ADDOCH.autDoplneniDoch(" + script + ");";
            script = "function f(){" + script + "; Sys.Application.remove_load(f) ;}; Sys.Application.add_load (f);";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "seznam_zam_pro_doch", script, true);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static string autDoplneniDoch(string data)
        {
            decimal os_cislo = 0;
            short cislo_pom = -1;
            DateTime ld_od = new DateTime();
            DateTime ld_do = new DateTime();            

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            try
            {
                os_cislo = Convert.ToDecimal(jsonObject[0]["os_cislo"]);
                cislo_pom = Convert.ToInt16(jsonObject[0]["cislo_pom"]);
                string dat_od = (string)jsonObject[0]["dat_od"];
                string dat_do = (string)jsonObject[0]["dat_do"];
                string[] ar = dat_od.Split(new char[] { 'x' });
                if (ar.Length != 3)
                {
                    return "chybný parametr dat_od ve funkci autDoplneniDoch:" + dat_od;
                }
                ld_od = new DateTime(Convert.ToInt32(ar[0]), Convert.ToInt32(ar[1]), Convert.ToInt32(ar[2]));

                string[] ar2 = dat_do.Split(new char[] { 'x' });
                if (ar2.Length != 3)
                {
                    return "chybný parametr dat_do ve funkci autDoplneniDoch:" + dat_do;
                }
                ld_do = new DateTime(Convert.ToInt32(ar2[0]), Convert.ToInt32(ar2[1]), Convert.ToInt32(ar2[2]));
            }
            catch (Exception ex)
            {
                return "Neplatný parametr:" + ex.Message;
            }

            try
            {

                /*
                ParametryDochazky pd = new ParametryDochazky();
                StrParDochazkyPrenos parPrenos = new StrParDochazkyPrenos();
                ParametryDochazky.GetParametryPrenosu(ref parPrenos);
                PrenosDochazky.ZpracujZamestnance(ref pd, os_cislo, cislo_pom, obd, ref parPrenos);
                */
                StrZam zam = new StrZam();
                DateTime obd = ld_od.PrvniDen();
                DochazkaFunkce df = new DochazkaFunkce();
                df.NaplnStrukturuStrZam(obd, os_cislo, cislo_pom, ref zam);
                if (DochazkaFunkce.AutomaticGenerationAllowed(zam, obd))
                {
                    TDataTable data2 = KSProgram.Dochazka.Dochazka.AutDoplneniNacist(zam, ld_od, ld_do);
                    using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
                    {
                        try
                        {
                            KSProgram.Dochazka.Dochazka.AutDoplneniUlozit(zam, ld_od, ld_do, data2, true, "a");
                            SqlPrikaz.Commit();
                        }
                        catch
                        {
                            SqlPrikaz.Rollback();
                            throw;
                        }
                    }
                }
                else
                {
                    return "NEZPRAC";
                }
            }
            catch (Exception ex)
            {
                return $"Chyba při zpracování os. čísla:{os_cislo} a čísla poměru:{cislo_pom}. Detail chyby:" + ex.Message;
            }
            return "OK";
        }
    }
}