﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Ciselniky;
using KSProgram.Dochazka;
using Telerik.Web.UI;
using KSProgram.Obecne;
using System.Web.Services;
using KSProgram.Security;
using System.Web;

public partial class Dochazka_DochRekapitulace : TPage
{
    DataTable _kody;
    DataTable _rekap;
    bool _zprac = false;
    string _uzite = "";
    string _uzite_cast = "";
    string _uz_ost = "";
    const int MAX_POCET_SLOUPCU = 50;
    //const int ODSAZENI = 7;
    //PH 26.2.2020
    //const int ODSAZENI = 8;
    //PH 7.8.2020 HID:51962
    const int ODSAZENI = 9;

    private bool praclist = false;

    public Dochazka_DochRekapitulace()
    {
        ContentHorizontalAlign = HorizontalAlign.Left;
        IdPrava = 94;
        VerzeStranky = "1";
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Sestavy#Rekapitulace_doch.C3.A1zky";
    }

    protected bool pridatPrescasy
    {
        get
        {
            return Zakaznik.IsCurrent("MERCK");
        }
    }

    public bool pridatPracList
    {
        get
        {
            return Zakaznik.IsCurrent("TCHIBO GROUP");
        }
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //TRadObdobi.SelectedDateOd = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            //TRadObdobi.SelectedDateDo = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            TRadGrid_sestava.Datum.SelectedObdobiOd = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            TRadGrid_sestava.Datum.SelectedObdobiDo = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            //Tcheck_prac_list.Visible = pridatPracList;
            //TRadGrid_sestava.Visible = false;
            //zobrazení skrytí tlačítka
            
        }
    }

  
    private void VisibleColumns()
    {
        for (int i = 0; i < TRadGrid_sestava.Columns.Count; i++)
		{
		    TRadGrid_sestava.Columns[i].Visible = true;
		}
    }


    private void InitSestava()
    {
        //_kody = CisDchKody.KodZkratkaNazevPouzity((DateTime)TRadObdobi.SelectedDateOd, (DateTime)TRadObdobi.SelectedDateDo);
        _kody = CisDchKody.KodZkratkaNazevPouzity((DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd, (DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo);

        _rekap = new DataTable();
        for (int i = 0; i < MAX_POCET_SLOUPCU; i++)
        {
            _rekap.Columns.Add("pr" + i.ToString(), typeof(decimal));
            _rekap.Columns.Add("cast" + i.ToString(), typeof(decimal));
        }
        _rekap.Columns.Add("ostatni", typeof(decimal));
    }

   
  

    protected void TRadGrid_sestava_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridHeaderItem)
        {
            _zprac = false;
        }

        if (e.Item is GridDataItem)
        {
            if (!_zprac)
            {
                _uzite = (string)DataBinder.Eval(e.Item.DataItem, "uzite");
                _uzite_cast = (string)DataBinder.Eval(e.Item.DataItem, "uzite_cast");
                _uz_ost = (string)DataBinder.Eval(e.Item.DataItem, "uz_ost");
                _zprac = true;
            }
        }

        if (e.Item is GridFooterItem)
        {
            TRadGrid grid = (TRadGrid)sender;

            for (int i = 0; i < _uzite.Length; i++)
            {
                string s = _uzite.Substring(i, 1);
                int index = i * 2;
                grid.MasterTableView.GetColumn("pr" + i.ToString()).Visible = (s == "0" ? false : true);
            }


            for (int i = 0; i < _uzite_cast.Length; i++)
            {
                string s = _uzite_cast.Substring(i, 1);
                int index = i * 2 + 1;
                grid.MasterTableView.GetColumn("cast" + i.ToString()).Visible = (s == "0" ? false : true);
            }


            grid.Columns[MAX_POCET_SLOUPCU * 2 + ODSAZENI].Visible = (_uz_ost == "0" ? false : true);

            grid.MasterTableView.GetColumn("prescas").Visible = pridatPrescasy;
                        
            if ((pridatPracList == false) || (praclist == false))
            {
                grid.MasterTableView.GetColumn("praclist").Visible = false;
            }
            else
                grid.MasterTableView.GetColumn("praclist").Visible = true;

            grid.MasterTableView.GetColumn("prescasy_pozn").Visible = ParametryDochazky.ROZD_PRESC_POZNAMKA;
            
        }
    }

    protected void TRadGrid_sestava_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable table = new DataTable();
        
        if (IsPostBack)
        {
            InitSestava();
            TRadGrid_sestava.MasterTableView.Caption = WebControlHelper.ZmenaTextu("[%Rekapitulace docházky%]") + " " + ((DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd).Month.ToString() + "/" + ((DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd).Year.ToString() + " - " + ((DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo).Month.ToString() + "/" + ((DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo).Year.ToString();
            praclist = ((TRadButton)TRadGrid_sestava.GetGridCommandItem("Tcheck_prac_list", typeof(TRadButton)))?.Checked ?? false;
            VisibleColumns();
            if (_kody != null)
            {
                for (int i = 0; i < MAX_POCET_SLOUPCU; i++)
                {
                    if (i < _kody.Rows.Count)
                    {
                        int index = i * 2;
                        TRadGrid_sestava.MasterTableView.GetColumn("pr" + i.ToString()).HeaderText = Convert.ToString(_kody.Rows[i]["nazev"]);

                        TRadGrid_sestava.MasterTableView.GetColumn("cast" + i.ToString()).HeaderText = Convert.ToString(_kody.Rows[i]["nazev"] + " (částka)");
                    }
                }
            }
            //table = new KSProgram.Sestavy.DefSestavy_dch004().Retrieve((DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd, (DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo, StrSkupDiv.GetStred(), Tcheck_prac_list.Checked, WebControlHelper.GetRadioButtValue(Page, "stredisko", "prac_str"));
            table = new KSProgram.Sestavy.DefSestavy_dch004().Retrieve((DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd, (DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo, StrSkupDiv.GetStredBezApostrofu(), praclist, TRadGrid_sestava.Strediska.GetValue);
        }
        TRadGrid_sestava.DataSource = table;
    }

    protected void TRadGrid_sestava_DataBinding(object sender, EventArgs e)
    {
        //TRadGrid grid = TRadGrid_sestava;
        //if (_kody == null)
        //{
        //    InitSestava();
        //}
        //for (int i = 0; i < MAX_POCET_SLOUPCU; i++)
        //{
        //    if (i < _kody.Rows.Count)
        //    {
        //        int index = i * 2;
        //        grid.MasterTableView.GetColumn("pr" + i.ToString()).HeaderText = Convert.ToString(_kody.Rows[i]["nazev"]);

        //        grid.MasterTableView.GetColumn("cast" + i.ToString()).HeaderText = Convert.ToString(_kody.Rows[i]["nazev"] + " (částka)");
        //    }
        //}
    }

    protected void trbutton_Click(object sender, EventArgs e)
    {
        TRadGrid_sestava.Visible = true;
        
        
        //před zpracováním radgrid je třeba všechny sloupce zviditelnit, jinak se do nich data nenabinduji pokud je sloupec Visible = false
        
        TRadGrid_sestava.Rebind();
    }

    protected void TRadGrid_sestava_ItemCreated(object sender, GridItemEventArgs e)
    {
        ((TRadButton)TRadGrid_sestava.GetGridCommandItem("Tcheck_prac_list", typeof(TRadButton))).Visible = pridatPracList;
    }

    protected void Tcheck_prac_list_DataBinding(object sender, EventArgs e)
    {
        ((TRadButton)sender).Checked = praclist;
    }

    [WebMethod]
    public static void SaveStateSeznam(string state)
    {
        state = InputChecker.Text(state, "State seznampoz");
        string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";TRadGrid_sestava";
        if (!string.IsNullOrEmpty(state))
        {
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            state =
                "<ControlSetting>" +
                "<Name>DochRekapitulace.TRadGrid_sestava</Name>" +
                "<Value Type=\"System.String\">" +
                "<string>" + state + "</string>" +
                "</Value>" +
                "</ControlSetting>";
            dsp.SaveStateToStorage(cookieName, state);
        }
    }

    [WebMethod]
    public static void DeleteStateSeznam()
    {
        string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";TRadGrid_sestava";
        DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
        dsp.SaveStateToStorage(cookieName, null);
    }

    internal override void On_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
    {
        base.On_LoadCustomSettings(sender, e);

        foreach (ControlSetting setting in e.CustomSettings.ControlSettings)
        {
            if (setting.Name == "DochRekapitulace.TRadGrid_sestava")
            {
                HiddenField HF = (HiddenField)WebControlHelper.FindControl(this.Page, "HF_grid_state");
                if (HF != null)
                    HF.Value = (string)setting.Value;
            }

        }
    }
}
