﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.WebControls;
using KSProgram.Dochazka;
using System.Collections.Generic;
using KSProgram;
using KSProgram.WebControlsAlone;
using KSProgram.Ciselniky;
using System.Drawing;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using KSProgram.Obecne;
using System.Data.Common;
using KSProgram.Extensions;
using KSProgram.Exceptions;
using KSProgram.Prava;

public partial class Dochazka_Kalendar : TPageZam
{
    decimal _sumHod=0;
    decimal _sumDny=0;
    DataTable _data = null;
    StrZam _zam = new StrZam();
    bool _nacteno = false;
    Str_workfl_proc _stavProc;
     
    public Dochazka_Kalendar()
    {
        IdPrava = 79;
    }

    /// <summary>
    /// 
    /// </summary>
    public bool Form_editable
    {
        get
        {
            return (ViewState["Form_editable"] == null ? false : Convert.ToBoolean(ViewState["Form_editable"]));
        }
        set
        {
            ViewState["Form_editable"] = value;
        }
    }

    protected DateTime VybranyMesic
    {
        get
        {
            return (ViewState["VybranyMesic"] == null ? new DateTime(DateTime.Now.Date.Year, DateTime.Now.Month, 1) : Convert.ToDateTime(ViewState["VybranyMesic"]));
        }
        set
        {
            ViewState["VybranyMesic"] = value;
        }
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
    }

    protected override void Page_PreRender(object sender, EventArgs e)
    {
        base.Page_PreRender(sender, e);
        if (!IsPostBack)
        {
            MonthChangedEventArgs me = new MonthChangedEventArgs(new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1), new DateTime());
            Calendar1_VisibleMonthChanged(Calendar1, me);                         
        }
    }

    protected void Calendar1_DayRender(object sender, DayRenderEventArgs e)
    {
        if (Globals.OsCislo == 0) return;
        if (!_nacteno)
        {
            WorkflowProces proc = new WorkflowProces();
            //Prac_pom pp = new Prac_pom();
            DochazkaFunkce df = new DochazkaFunkce();
            df.NaplnStrukturuStrZam(VybranyMesic, Globals.OsCislo, Prac_pom.Platny_Pomer(Globals.OsCislo, VybranyMesic), ref _zam);
            _data = KalendarDen.LoadDne(Globals.OsCislo, VybranyMesic);
            _nacteno = true;
            _stavProc = proc.GetStav(Globals.OsCislo,"dochazka", VybranyMesic);
        }

        e.Cell.Style.Add(HtmlTextWriterStyle.VerticalAlign, "top");
        e.Cell.Attributes.Add("align", "left");
        /*
        e.Day.IsSelectable =
        (
            (PozadavekPrava.KalendarPravoNaDen(Dochazka.SuperUser,
            Convert.ToDateTime(dsRekapitulace.SelectParameters["obdobi"].DefaultValue),
            e.Day.Date) && _stavProc.faze < 2) || Dochazka.SuperUser
         );
         * */
        e.Day.IsSelectable =
        (
            (PozadavekPrava.KalendarPravoNaDen(Dochazka.SuperUser,
            Convert.ToDateTime(dsRekapitulace.SelectParameters["obdobi"].DefaultValue),
            e.Day.Date) && Form_editable)
         );
        Table tabulka=_vytvorTabulku(e.Day.Date);
        e.Cell.Controls.Add(tabulka);        
    }

    private Table _vytvorTabulku(DateTime datum)
    {
        ParametryDochazky pd = new ParametryDochazky();
        //_citac++;
        Table tabulka = new Table();
        //if (_citac > 5) return tabulka;
        tabulka.Style.Add(HtmlTextWriterStyle.BorderCollapse, "collapse");
               
        DataTable data = KalendarDen.NacistDen(ref _zam, datum, ref _data);
        //DataTable data = new DataTable();
        int pocet = data.Rows.Count;
        int pocetx = _data.Rows.Count;
        foreach (DataRow row in data.Rows)
        {
            TableRow tr = new TableRow();

            tabulka.Rows.Add(tr);

            if (row["kod"] != DBNull.Value)
            {
                TableCell cell = new TableCell();
                Label lab1 = new Label();
                int kod = Convert.ToInt16(row["kod"]);

                //lab1.Text = CisDchKody.GetZkratku((short)kod);
                lab1.Text = pd.ZkratkaZKodu(kod);
                cell.Controls.Add(lab1);
                tr.Cells.Add(cell);

                cell = new TableCell();
                Label lab2 = new Label();
                if (row["hodiny"] != DBNull.Value)
                    lab2.Text = row["hodiny"].ToString();
                cell.Controls.Add(lab2);
                tr.Cells.Add(cell);

                if (pd.IsKodAbs(kod))
                {
                    lab1.ForeColor = Color.Red;
                    lab2.ForeColor = Color.Red;
                }
                else
                {
                    lab1.ForeColor = Color.Black;
                    lab2.ForeColor = Color.Black;
                }
            }
        }
        return tabulka;
       // ViewState.Add(datum.ToString(), tabulka);
    }

    protected void TGridViewDen_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        int kod=0;
        if (e.Row.RowType==DataControlRowType.DataRow)
        {
            string oper=DataBinder.Eval(e.Row.DataItem, "operace").ToString();
            object obj=DataBinder.Eval(e.Row.DataItem, "kod");
            if (obj != DBNull.Value)
            {
                kod =(int) GetNullOrData.GetInt16(obj); 
            }
            TImageButton but=(TImageButton)e.Row.Cells[2].FindControl("TImageButtonSmazat");
            but.CommandArgument = e.Row.DataItemIndex.ToString();

            but.Enabled = _isPolozkaPristupna(oper, kod);
            TextBox b=(TextBox)e.Row.Cells[1].FindControl("TextBoxHod");
            b.Enabled = _isPolozkaPristupna(oper, kod);

            DropDownList ddlk = (DropDownList)e.Row.Cells[0].FindControl("DropDownListKod");
            ddlk.Enabled = _isPolozkaPristupna(oper, kod);

            but.Enabled = _isPolozkaPristupna(oper, kod);
           
        }
    }
    protected void ibUlozit_Command(object sender, CommandEventArgs e)
    {
        StrKalendarDen item = new StrKalendarDen();
        List<StrKalendarDen> dny = new List<StrKalendarDen>();
        TGridView view=(TGridView)this.FindControlRecursive("TGridViewDen");

        //provedu kontroly
        //------------------------------------
        int pocet=0;
        int rowCount=0;
        TextBox emptyHod = null;
        decimal celkHod=0;
        foreach (GridViewRow r in view.Rows)
        {
            if (r.RowType == DataControlRowType.DataRow)
            {
                DropDownList ddlKod = (DropDownList)r.Cells[0].FindControl("DropDownListKod");
                if (!(string.IsNullOrEmpty(ddlKod.SelectedValue)))
                {
                    if (ddlKod.SelectedValue != null)
                    {
                        if (ddlKod.SelectedValue == "521")
                        {
                            int p=SqlPrikaz.ExecuteScalarInt16
                                (
                                "select count(*) from dch_casy " +
                                " where os_cislo="+Globals.OsCislo.ToString()+
                                " and cas between '"+F_DateTime.DateTimeToString15(Calendar1.SelectedDate)+"' "+
                                " and '" + F_DateTime.DateTimeToString15(Calendar1.SelectedDate.NasledujiciDen()) + "' " +
                                " and kod=521"
                                , 0);
                            //if (p == 0)&&(Dochazka.SuperUser))
                            //PH 3.12.2009
                            if ((p == 0)&&(!Dochazka.SuperUser))
                            {
                                MessageBox.Alert(Page, "Nelze pokračovat, nelze vkládat kod pro dovolenou.");
                                return;
                            }
                        }
                    }
                    TextBox box1 = (TextBox)r.Cells[1].FindControl("TextBoxHod");
                    if (String.IsNullOrEmpty(box1.Text))
                    {
                        pocet++;
                        emptyHod = box1;
                    }
                    else
                    {
                        celkHod+=Convert.ToDecimal(box1.Text);
                    }
                    rowCount++;
                }
            }
        }
        if ((pocet == 1)&&(rowCount>1))
        { 
            //doplním hodiny k nevyplněné položce
            StrPracdnySvatky pr = PracdnySvatky.Get(Globals.OsCislo, Calendar1.SelectedDate, Calendar1.SelectedDate, new DateTime(Calendar1.SelectedDate.Year, Calendar1.SelectedDate.Month, 1));
            Decimal hod = (decimal)pr.Prhod + (decimal)pr.Svhod;
            emptyHod.Text = (hod - celkHod).ToString();
        }
        else if (pocet > 1)
        {
            MessageBox.Alert(Page, "Nelze pokračovat, jen jeden záznam s vyplněným kódem může mít nevyplněny hodiny.");
            return;
        }
        //------------------------------------

        //odstraním předchozí záznamy
        //-------------------------------------

        //-------------------------------------

        foreach (GridViewRow r in view.Rows)
        {
            if (r.RowType == DataControlRowType.DataRow)
            {
                DropDownList ddlKod = (DropDownList)r.Cells[0].FindControl("DropDownListKod");
                if (ddlKod.Enabled)
                {
                    TextBox box = (TextBox)r.Cells[1].FindControl("TextBoxHod");
                    decimal hod;
                    if (!Decimal.TryParse(box.Text, out hod))
                        hod = -1;
                    if (!string.IsNullOrEmpty(ddlKod.SelectedValue))
                    {
                        item = new StrKalendarDen();
                        item.Kod = Convert.ToInt32(ddlKod.SelectedValue);
                        item.Hodiny = hod;

                        dny.Add(item);
                    }
                }
            }
        }


        using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                if (dny.Count > 0)
                {
                    KalendarDen.UlozitDen(Globals.OsCislo, Calendar1.SelectedDate, dny);
                    DateTime obdobi = new DateTime(Calendar1.SelectedDate.Year, Calendar1.SelectedDate.Month, 1);
                    //zkontroluju jestli pro tento den již požadavek existuje                    
                    //if (Pozadavek.Exists(Globals.OsCislo, "dochazka", obdobi) == 0)
                    //    Pozadavek.CreatePozadavek(Globals.OsCislo, "dochazka", obdobi);
                    //PH 18.7.2013
                    Pozadavekdochazka.TestAndCreate(Globals.OsCislo, obdobi);

                }
                else
                {
                    KalendarDen.SmazatDen(Globals.OsCislo, Calendar1.SelectedDate);
                }

                SqlPrikaz.Commit();
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }


        

        //WebControl ctrl = (WebControl)this.FindControlRecursive("PanelDen");
        //ctrl.Visible = false;
        Calendar1.SelectedDate = new DateTime();
        TGridView v=(TGridView)this.FindControlRecursive("TGridView1");
        v.DataBind();
        ScriptManager.RegisterStartupScript(this, typeof(Page), "SkryjEditPanel", "zobr=false;", true);

    }
    protected void ibUndu_Command(object sender, CommandEventArgs e)
    {
        TGridView view = (TGridView)this.FindControlRecursive("TGridViewDen");
        if (view != null) view.DataBind();
        //WebControl ctrl = (WebControl)this.FindControlRecursive("PanelDen");
        //ctrl.Visible = false;
        ScriptManager.RegisterStartupScript(this, typeof(Page), "SkryjEditPanel", "zobr=false;", true);
        Calendar1.SelectedDate = new DateTime();

        TGridView v = (TGridView)this.FindControlRecursive("TGridView1");
        v.DataBind();
    }
    protected void TGridViewDen_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "smazat")
        {
            int index= Convert.ToInt32(e.CommandArgument);
            TGridView view = (TGridView)this.FindControlRecursive("TGridViewDen");
            DropDownList list=(DropDownList) view.Rows[index].Cells[0].FindControl("DropDownListKod");
            list.SelectedValue = "";

            TextBox box = (TextBox)view.Rows[index].Cells[1].FindControl("TextBoxHod");
            box.Text = "";
        }
    }
    protected void ibSmazatVse_Command(object sender, CommandEventArgs e)
    {
        TGridView view = (TGridView)this.FindControlRecursive("TGridViewDen");

        
        for (int i=0;i<view.Rows.Count;i++)
        {
            if (view.Rows[i].RowType==DataControlRowType.DataRow)
            {
                DropDownList list=(DropDownList) view.Rows[i].Cells[0].FindControl("DropDownListKod");
                if (!(list.Enabled))
                {
                    MessageBox.Alert(Page, "Nelze mazat, obsahuje needitovatelnou položku.");
                    return;
                }
            }
        }

        using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                KalendarDen.SmazatDen(Globals.OsCislo, Calendar1.SelectedDate);
                SqlPrikaz.Commit();
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }
        
        view.DataBind();
    }
    protected void Calendar1_SelectionChanged(object sender, EventArgs e)
    {
        //TitledPanel ctrl = (TitledPanel)this.FindControlRecursive("PanelDen");
        //ctrl.Visible = true;
        ScriptManager.RegisterStartupScript(this, typeof(Page), "ZobrazEditPanel", "zobr=true;", true);
    }

    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {
        StrZam zam = new StrZam();
        DateTime dt_od, dt_do;
        string druh_pom, err;
        short cislo_pom;

        dt_od=Calendar1.VisibleDate;
        dt_do= dt_od.PosledniDen();

        //Prac_pom pp = new Prac_pom();
        Prac_pom.Platny_Pomer(Globals.OsCislo, dt_od, out cislo_pom, out druh_pom, out err);
        //do struktury doplním údaje nutné pro další zpracování
        DochazkaFunkce df = new DochazkaFunkce();
        df.NaplnStrukturuStrZam(new DateTime(dt_od.Year, dt_od.Month, 1), Globals.OsCislo, cislo_pom, ref zam);

        //provedu automatické doplnění
        TDataTable data = Dochazka.AutDoplneniNacist(zam, dt_od, dt_do);
        DataView view = new DataView(data);
        DataTable distinctValues = view.ToTable(true, "kod");
        for (int i=0;i<distinctValues.Rows.Count; i++)
        {
            DataRow row=distinctValues.Rows[i];
            short kod = Convert.ToInt16(row["kod"]);
            TestujPouzityKod(kod);
        }

        using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                //Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, true);
                //PH 12.4.2013
                //Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, false);
                //PH 24.4.2013
                //Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, false);
                //PH 10.6.2013
                Dochazka.AutDoplneniUlozit(zam, dt_od, dt_do, data, true, "a");

                //if (Pozadavek.Exists(Globals.OsCislo, "dochazka", dt_od.Date) == 0)
                //    Pozadavek.CreatePozadavek(Globals.OsCislo, "dochazka", dt_od.Date);
                //PH 18.7.2013
                //Pozadavekdochazka.TestAndCreate(Globals.OsCislo, dt_od.Date);
                //PH 20.6.2019 HID:46663
                Dch_Casy.ZmenaVCase(Globals.OsCislo, dt_od.Date);
                SqlPrikaz.Commit();
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }

        Calendar1.DataBind();
        //MonthChangedEventArgs ea=new MonthChangedEventArgs(VybranyMesic, VybranyMesic);
        //Calendar1_VisibleMonthChanged(sender, ea);
        TGridView1.DataBind();

        _pravaNaTlacitka(dt_od);
        
    }
    protected void Calendar1_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //Calendar1.VisibleDate = new DateTime(DateTime.Now.Year, DateTime.Now.Month, 1);
            Calendar1.VisibleDate = VybranyMesic;

            DateTime datum= Convert.ToDateTime(dsRekapitulace.SelectParameters["obdobi"].DefaultValue);
            TestujPouziteKody(VybranyMesic, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);
        }    

    }
    protected void TGridViewDen_DataBound(object sender, EventArgs e)
    {
        TGridView view = (TGridView)sender;//WebControlHelper.FindControl(ctrl, "TGridViewDen");
        
        TitledPanel ctrl=(TitledPanel)this.FindControlRecursive("PanelDen");
        Label lab = (Label)WebControlHelper.FindControl(ctrl, "LabelPopisek");
        lab.Text = Calendar1.SelectedDate.ToString("dd.MM.yyyy");
       
    }

    protected override void TPage_OsCisloChanged(object sender, OsCisloChangedEventArgs a)
    {
        base.TPage_OsCisloChanged(sender, a);
        MonthChangedEventArgs e=new MonthChangedEventArgs(VybranyMesic, VybranyMesic);
        Calendar1_VisibleMonthChanged(sender, e);
    }

    protected void Calendar1_VisibleMonthChanged(object sender, MonthChangedEventArgs e)
    {
        VybranyMesic = e.NewDate;

        _pravaNaTlacitka(e.NewDate);
        ObjectDataSource ds=(ObjectDataSource) this.FindControlRecursive("dsFond");
        ds.SelectParameters["os_cislo"].DefaultValue = Globals.OsCislo.ToString();
        ds.SelectParameters["obdobi"].DefaultValue = e.NewDate.ToString();

        dsRekapitulace.SelectParameters["os_cislo"].DefaultValue = Globals.OsCislo.ToString();
        dsRekapitulace.SelectParameters["obdobi"].DefaultValue = e.NewDate.ToString();
        dsRekapitulace.DataBind();

        _stavProc = new Str_workfl_proc();

        //if (ddl_zmena_stavu.Items.Count == 0)
        //    PanelZmenaStavu.Visible = false;
       
    }
    protected void TGridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.Header)
        {
            _sumDny = 0;
            _sumHod = 0;
        }
        else if (e.Row.RowType == DataControlRowType.DataRow)
        {
            decimal dny = Convert.ToDecimal(e.Row.Cells[2].Text);
            decimal hod = Convert.ToDecimal(e.Row.Cells[3].Text);

            _sumDny += dny;
            _sumHod += hod;
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[2].Text = _sumDny.ToString("N1");
            e.Row.Cells[3].Text = _sumHod.ToString("N2");
            
        }
    }

    private bool _isPolozkaPristupna(string operace, int kod)
    {
        //return ((operace != "w" ||  Dochazka.SuperUser) && (kod!=521));
        //PH 3.12.2009
        if (Dochazka.SuperUser) return true;
        return (operace != "w");
    }
    protected void TLinkButton2_Command(object sender, CommandEventArgs e)
    {
        //zkontroluju jestli souhlasí plánovaný fond se skutečností
        //--------------------------------------------------
        if (Parametry.ParametrCti("PotvrzFondOK").ToLower().Trim() == "a")
        {
            decimal pom = 0;
            decimal hodFond = 0, hodSkut = 0;
            if (Decimal.TryParse(TGridView1.FooterRow.Cells[3].Text, out pom))
                hodSkut = pom;
            Label lab = (Label)this.FindControlRecursive("FondHodin");
            if (lab != null)
            {
                if (decimal.TryParse(lab.Text, out pom))
                    hodFond = pom;
            }
            if (hodSkut != hodFond)
            {
                MessageBox.Alert(Page, "Nelze pokračovat, plánovaný fond nesouhlasí se skutečností. Rozdíl činí " + (hodFond - hodSkut).ToString() + " hodin.");
                return;
            }
        }
        //--------------------------------------------------

        DateTime datum= Convert.ToDateTime(dsRekapitulace.SelectParameters["obdobi"].DefaultValue);
        //Pozadavek.CreatePozadavek(Globals.OsCisloAktUser, "dochazka", "schvaleny", 1, datum);

        using (DbConnection connection = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                int id_poz = Pozadavek.Exists(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, "dochazka", datum);
                //PozadavekProces.KrokProcesu(id_poz, "potvrzeny", 1, "", null);
                WorkflowProces.KrokProcesu(id_poz, "potvrzeny", 0, "");
                SqlPrikaz.Commit();
                _pravaNaTlacitka(datum);
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }

    }

    private void _pravaNaTlacitka(DateTime obdobi)
    {
        StrukturaOrganizace str_org = new StrukturaOrganizace();
        WorkflowProces proc = new WorkflowProces();
        Str_workfl_proc st = proc.GetStav(Globals.OsCislo,"dochazka", obdobi);
        int id_poz = Pozadavek.Exists(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom,"dochazka", obdobi);
        WorkflowMaster wf = new WorkflowMaster(id_poz, "dochazka", null);
        if (id_poz > 0)
        {
            workfl_hl whl = new workfl_hl();
            Str_workfl_hl st_hl = whl.NaplnStrukturu(id_poz);
            /*
            TLinkButton1.Visible = (st.faze < 2);
            TLinkButton2.Visible = (st.faze < 2);
            TLinkButton3.Visible = (st.faze > 1) && (((st_hl.os_cislo != Globals.OsCisloAktUser) || Dochazka.SuperUser || str_org.PrimyNadrizenyExists(Globals.OsCisloAktUser)==false) && st.stav != "schvaleny" && st.stav != "zamitnuty");
            // StrukturaOrganizace.PrimyNadrizenyExists(Globals.OsCisloAktUser)==false
            TLinkButton4.Visible = TLinkButton3.Visible;
             * */          

            string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
            if (zmstavu == "true")
            {
                dsStavyEdit.SelectParameters[0].DefaultValue = id_poz.ToString();
                //dsZmenaStavu.InsertParameters[0].DefaultValue = id_poz.ToString();                
                ddl_zmena_stavu.DataSourceID = "dsStavyEdit";
            }
            PanelZmenaStavu.Visible = (zmstavu == "true");
            if (PanelZmenaStavu.Visible == false)
                //if ((str_org.PrimyNadrizenyExists(Globals.OsCisloAktUser) == false) && (wf.StavPosl != "schvaleny"))
                //PH 9.12.2013 doplněna org. struktura
                //PH 15.10.2018 1.parametr přetypován z decimal na OSC_POMER 
                if ((str_org.PrimyNadrizenyExists(new OSC_POMER { Os_cislo = Globals.OsCisloAktUser }, st_hl.id_os) == false) && (wf.StavPosl != "schvaleny"))
                    PanelZmenaStavu.Visible = true;
        }
        else
            PanelZmenaStavu.Visible = false;

        string editable = wf.Get_UN("", "form_editable", "Enabled");
        Form_editable = (editable == "true");

        TLinkButton1.Visible = Form_editable;
    }


    protected void lb_zmena_stavu_Command(object sender, CommandEventArgs e)
    {
        //if (Chyba)
        //{
        //    MessageBox.Show(SumaceMesic, "Nelze pokračovat v datech se vyskytuje chyba");
        //    return;
        //}
        ////projdu jestli je ve všech dnech s vyplněnným úvazkem něco vykázáno
        //if (Nevyp)
        //{
        //    MessageBox.Show(SumaceMesic, "Nelze pokračovat, nejsou vyplněny všechny dny");
        //    return;
        //}

        if (Parametry.ParametrCti("PotvrzFondOK").ToLower().Trim() == "a")
        {
            decimal pom = 0;
            decimal hodFond = 0, hodSkut = 0;
            if (Decimal.TryParse(TGridView1.FooterRow.Cells[3].Text, out pom))
                hodSkut = pom;
            Label lab = (Label)this.FindControlRecursive("FondHodin");
            if (lab != null)
            {
                if (decimal.TryParse(lab.Text, out pom))
                    hodFond = pom;
            }
            if (hodSkut != hodFond)
            {
                MessageBox.Alert(Page, "Nelze pokračovat, plánovaný fond nesouhlasí se skutečností. Rozdíl činí " + (hodFond - hodSkut).ToString() + " hodin.");
                return;
            }
        }

        DateTime datum = Convert.ToDateTime(dsRekapitulace.SelectParameters["obdobi"].DefaultValue);

        int id_poz = Pozadavek.Exists(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, "dochazka", datum);
        if (!(id_poz > 0)) //PH 7.9.2012
        {
            MessageBox.Alert(Page, "Nelze pokračovat, nejdříve vyplňte docházku, nebo proveďte automatické generování");
            return;
        }
        string stav = ddl_zmena_stavu.SelectedValue.ToString();
        if (string.IsNullOrEmpty(stav))//PH 7.9.2012
        {
            MessageBox.Alert(Page, "Nelze pokračovat, není vybrán žádný stav");
            return;
        }
        //WorkflowProces.KrokProcesu(id_poz, stav, "");
        //PH 19.2.2013
        WorkflowProces.KrokProcesuTrans(id_poz, stav, "", 0);
        _pravaNaTlacitka(datum);
    }

    protected void Calendar1_DataBinding(object sender, EventArgs e)
    {
        
    }

    protected void TestujPouziteKody(DateTime obdobi, decimal os_cislo, short cislo_pom)
    {
        List<short> lst = new List<short>();

        string sql = String.Format("select distinct kod from dch_casy where os_cislo={0} and cislo_pom={1} and cas between '{2}' and '{3}' and kod in( select vyr_kod from dch_kody where kalendar=0 )",
                                    os_cislo, cislo_pom, F_DateTime.DateTimeToString17(obdobi.PrvniDen()), F_DateTime.DateTimeToString17(obdobi.PosledniDenMinuta()));
        using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
        {           
            while (reader.Read())
                lst.Add(GetNullOrData.GetInt16(reader, 0, 0));
            
            if (reader.IsClosed == false) reader.Close();
        }

        if (lst.Count > 0)       
            throw new NoticeException("Následující docházkové kódy " + string.Join(",", lst.ToArray()) + " jsou v docházce použity, ale nemají v číselníku docházkových kódů nastaveno použití pro kalendář. Prosím doplnit");
    }

    protected void TestujPouzityKod(short kod)
    {
        string sql = " select vyr_kod from dch_kody where vyr_kod="+kod.ToString()+" and kalendar=1 ";
                                   
        short kod2=SqlPrikaz.ExecuteScalarInt16(sql, 0);

        if (kod2 == 0)
            throw new NoticeException("Následující docházkový kód " + kod + " je v docházce použit, ale nemá v číselníku docházkových kódů nastaveno použití pro kalendář. Prosím doplnit.");
    }
}

