﻿using KSProgram;
using KSProgram.Dochazka;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Data;
using System.Linq;
using System.Linq.Dynamic.Core;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using static KSProgram.Dochazka.PlanovaniSmen;

namespace KSPortal.Dochazka
{
    public partial class PlanovaniSmenDetail : TPopUpPage
    {
        public PlanovaniSmenDetail()
        {

        }

        private DateTime? _datumQ
        {
            get
            {
                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection queryString = hh.DecryptRequestQuery();
                int year, month, day;
                if (!int.TryParse(queryString["y"], out year))
                {
                    year = DateTime.Now.Year;
                }
                if (!int.TryParse(queryString["m"], out month))
                {
                    month = DateTime.Now.Month;
                }
                if (!int.TryParse(queryString["d"], out day))
                {
                    day = DateTime.Now.Day;
                }

                return new DateTime(year, month, day);
            }
        }

        private string _filter
        {
            get
            {
                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection queryString = hh.DecryptRequestQuery();
                return queryString["filter"].UnZipFromBase64();
            }
        }

        private List<os_c_key> _os_cisla
        {
            get
            {
                object ses = Session["PalnSmen_list_os_c"];
                if (ses != null)
                {
                    ViewState["PalnSmen_list_os_c"] = ses;
                    Session["PalnSmen_list_os_c"] = null;
                }

                object o = ViewState["PalnSmen_list_os_c"];
                if (o != null)
                {
                    return Newtonsoft.Json.JsonConvert.DeserializeObject<List<os_c_key>>(((string)o).UnZipFromBase64());
                }

                return null;
            }
            set
            {
                ViewState["PalnSmen_list_os_c"] = Newtonsoft.Json.JsonConvert.SerializeObject(value).ZipToBase64();
            }

        }

        private bool _primi
        {
            get
            {
                object o = Globals.JenPrimiPodrizeni;
                if (o == null)
                {
                    o = true;
                    Globals.JenPrimiPodrizeni = (bool)o;
                }
                return (bool)o;
            }
        }
        private List<dch_kod> _dchKody { get; set; }
        private List<dch_kod> dchKody
        {
            get
            {
                if (_dchKody != null)
                    return _dchKody;
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                object o = ViewState["PlanovaniSmen_dochKody"];
                if (o == null)
                {
                    _dchKody = null;
                }
                else
                {
                    _dchKody = serializer.Deserialize<List<PlanovaniSmen.dch_kod>>((string)o);
                }
                return _dchKody;
            }
        }
        private List<dch_kod> _dchKodyPrest;
        private List<dch_kod> dchKodyPrest
        {
            get
            {
                if (_dchKodyPrest == null)
                {
                    _dchKodyPrest = GetDochKody("break");
                }
                return _dchKodyPrest;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            if(!IsPostBack)
            {
                TRadGrid1.Datum.SelectedDatumOd = _datumQ;
                TRadGrid1.Datum.SelectedDatumDo = _datumQ;
            }

            RadClientExportManager1.PdfSettings.Fonts.Add("Arial", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/arial.ttf");
            RadClientExportManager1.PdfSettings.Fonts.Add("Arial Black", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/ariblk.ttf");
        }
        private List<PlanSmenDetail> ret { get; set; }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (ret == null)
            {
                ret = new List<PlanSmenDetail>() { };

                var obdobi = new DateTime(TRadGrid1.Datum.SelectedDatumOd.Value.Year, TRadGrid1.Datum.SelectedDatumOd.Value.Month, 1);

                List<PlanSmen> list = GetPlanySmen(obdobi, _primi, _os_cisla, _filter);

                List<dch_kod> dchKodyAbs = GetDochKody("abs");
                List<dch_kod> dchKodyDov = GetDochKody("dovolena");
                List<dch_kod> dchKodyNem = GetDochKody("nemoc");
                List<dch_kod> dchKody = GetDochKody("all");
                List<dch_kod> dchKodyWork = GetDochKody("work");
                List<dch_kod> dchKodyWorkAndPlan = GetDochKody("work&&plan");
                foreach (PlanSmen plan in list)
                {
                    for (DateTime d = TRadGrid1.Datum.SelectedDatumOd.Value; d <= TRadGrid1.Datum.SelectedDatumDo.Value; d = d.AddDays(1))
                    {
                        PlanSmenDetail nova1 = new Dochazka.PlanovaniSmenDetail.PlanSmenDetail(plan);
                        nova1.datum = d;
                        nova1.dny_kody = OmezitPlanZamce(plan.dny_kody, d, d.AddDays(1), dchKodyPrest, dchKodyWorkAndPlan);

                        int hod = 0;
                        int min = 0;
                        F_DateTime.DobaDecNaHodMin(nova1.hod_uvazek, ref hod, ref min);
                        var pom_zal_values = PlanovaniSmen.getPracPomValues(plan, obdobi);
                        nova1.fond = F_DateTime.TimeSpanToDecimal(GetFondVybraneKody(dchKodyWork, dchKody, nova1.dny_kody, pom_zal_values), "h");
                        nova1.prescas12 = nova1.fond > 12 ? (nova1.fond - 12) : null;
                        nova1.dovolena = F_DateTime.TimeSpanToDecimal(GetFondVybraneKody(dchKodyDov, dchKody, nova1.dny_kody, pom_zal_values), "h");
                        nova1.nemoc = F_DateTime.TimeSpanToDecimal(GetFondVybraneKody(dchKodyNem, dchKody, nova1.dny_kody, pom_zal_values), "h");
                        nova1.absence = F_DateTime.TimeSpanToDecimal(GetFondVybraneKody(dchKodyAbs, dchKody, nova1.dny_kody, pom_zal_values), "h");
                        nova1.absence = nova1.absence - (nova1.dovolena + nova1.nemoc);

                        nova1.fond = nova1.fond == 0 ? null : nova1.fond;
                        nova1.prescas12 = nova1.prescas12 == 0 ? null : nova1.prescas12;
                        nova1.prescas_zkr = nova1.prescas_zkr == 0 ? null : nova1.prescas_zkr;
                        nova1.dovolena = nova1.dovolena == 0 ? null : nova1.dovolena;
                        nova1.nemoc = nova1.nemoc == 0 ? null : nova1.nemoc;
                        nova1.absence = nova1.absence == 0 ? null : nova1.absence;

                        ret.Add(nova1);
                    }
                }
            }
            // odfiltrování
            //if (!string.IsNullOrEmpty(_filterdetail))
            //{
            //    ret = ret.AsQueryable().Where(_filterdetail).Cast<PlanSmenDetail>().ToList();
            //}

            DataTable store = new DataTable("parent");
            store.Columns.Add("datump", typeof(DateTime));
            foreach (DateTime d in ret.Select(x => x.datum).Distinct().ToList())
            {
                DataRow row = store.NewRow();
                row["datump"] = d;
                store.Rows.Add(row);
            }
            TRadGrid1.DataSource = store;
        }


        protected void TRadGrid1_DetailTableDataBind(object sender, GridDetailTableDataBindEventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;

            DateTime datump = (DateTime)dataItem.GetDataKeyValue("datump");
            //omezím zdroj dat na detailní list
            List<PlanSmenDetail> retd = ret.FindAll(x => x.datum == datump);

            string filtr = TRadGrid1.MasterTableView.Items[0].ChildItem.NestedTableViews[0].FilterExpression;
            if(!string.IsNullOrEmpty(filtr))
            {
                ret = ret.AsQueryable().Where(filtr).Cast<PlanSmenDetail>().ToList();
            }

            int h_od = 7;
            int h_do = 31;

            foreach (DateTime? datum in retd.Select(x => x.datum).Distinct().ToArray())
            {
                retd.FindAll(y => y.datum == datum).ForEach(x =>
                {
                    List<dch_zaznam> intervs = SmenaHashToList(x.dny_kody).FindAll(z => z.hod_do != null);
                    DateTime? d_od = intervs.Select(y => y.hod_od).Min();
                    DateTime? d_do = intervs.Select(y => y.hod_do).Max();

                    int min = d_od.HasValue ? (d_od.Value.Date == datum ? (d_od.Value.Hour < 7 ? d_od.Value.Hour : 7) : (7)) : (7);
                    int max = d_do.HasValue ? (d_do.Value.Date == datum ? (31) : (d_do.Value.TimeOfDay > new TimeSpan(7, 0, 0) ? ((int)d_do.Value.TimeOfDay.TotalHours + 24) : 31)) : (31);

                    h_od = h_od < min ? h_od : min;
                    h_do = h_do > max ? h_do : max;
                });

            }

            // vytvoření sloupců

            //promazání cloupců, pokud tam nějaké už vytvořené jsou
            for (int i = e.DetailTableView.Columns.Count - 1; i > 7; i--)
            {
                e.DetailTableView.Columns.RemoveAt(i);
            }
            //grupy se smazou rovnou celé
            e.DetailTableView.ColumnGroups.Clear();
            bool prvni = true;
            for (int h = h_od; h < h_do; h = h + 1)
            {
                for (int m = 0; m < 60; m = m + 30)
                {
                    GridTemplateColumn sloupec = new GridTemplateColumn();
                    e.DetailTableView.Columns.Add(sloupec);

                    sloupec.AllowSorting = false;
                    sloupec.AllowFiltering = false;
                    sloupec.Groupable = false;
                    sloupec.HeaderText = m.ToString().PadLeft(2, '0');
                    sloupec.ColumnGroupName = "group" + h;
                    sloupec.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    sloupec.UniqueName = "d_" + h.ToString() + "_" + m.ToString();
                    sloupec.ItemTemplate = new MyTemplate(h.ToString() + "_" + m.ToString());
                    sloupec.HeaderStyle.CssClass = "smena-r-h";
                    sloupec.ItemStyle.CssClass = "smena-r";

                    if (prvni || (((h % 6) == 0) && m == 0))
                    {
                        sloupec.ItemStyle.CssClass += " sestahodina";
                        sloupec.HeaderStyle.CssClass += " sestahodina";
                    }
                    else if (((h % 3) == 0) && m == 0)
                    {
                        sloupec.ItemStyle.CssClass += " tretihodina";
                        sloupec.HeaderStyle.CssClass += " tretihodina";
                    }

                    if (m == 30)
                    {
                        sloupec.ItemStyle.CssClass += " pulhodina";
                    }

                    prvni = false;
                }
                //Grupa se vytváří až všechny sloupce mají grupu nastavenou
                GridColumnGroup group = new GridColumnGroup();
                e.DetailTableView.ColumnGroups.Add(group);
                group.HeaderText = h < 24 ? h.ToString() : (h - 24).ToString();
                group.Name = "group" + h;
                group.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            }

            e.DetailTableView.DataSource = retd;
        }

        protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "Filter")
            {
                //e.Canceled = true;



                //((TRadGrid)sender).Rebind();
            }

            if (e.CommandName == "Sort")
            {
                e.Canceled = true;
                _sort = new GridSortExpression();
                _sort.FieldName = ((GridSortCommandEventArgs)e).CommandArgument.ToString();
                _sort.SortOrder = ((GridSortCommandEventArgs)e).NewSortOrder;
            }
        }

        GridSortExpression _sort;

        bool notfirst;
        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem && e.Item.DataItem is PlanSmenDetail)
            {
                PlanSmenDetail plan = (PlanSmenDetail)e.Item.DataItem;
                List<dch_zaznam> list = SmenaHashToList(plan.dny_kody);
                List<dch_zaznam> list_rozdelene = new List<dch_zaznam>() { };
                rozdelIntervaly(list, ref list_rozdelene);
                foreach (dch_zaznam zazn in list_rozdelene)
                {
                    TimeSpan ts_od = zazn.hod_od.Value - plan.datum;
                    int m_od = (int)((decimal)(ts_od.TotalMinutes)).MRound(30, 2);

                    TimeSpan ts_do = zazn.hod_do.HasValue ? (zazn.hod_do.Value - plan.datum) : (zazn.hod_od.Value.AddDays(1) - plan.datum);

                    int m_do = (int)((decimal)(ts_do.TotalMinutes)).MRound(30, 1);

                    for (int mi = m_od; mi < m_do; mi += 30)
                    {
                        int h = mi / 60;
                        int m = mi % 60;

                        DochazkaPlanSmena sm = (DochazkaPlanSmena)e.Item.FindControl("DPS_" + h.ToString() + "_" + m.ToString());

                        if (sm != null)
                        {
                            List<dch_zaznam> local = new List<dch_zaznam>() { };
                            if (sm.Data != null)
                                local = (List<dch_zaznam>)sm.Data;

                            local.Add(zazn);
                            sm.Data = local;
                        }
                    }
                }
            }
            if (e.Item.DataItem is PlanSmenDetail && (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem))
            {
                System.Drawing.Color back = e.Item.ItemType == GridItemType.Item ? System.Drawing.Color.FromArgb(246, 246, 246) : System.Drawing.Color.FromArgb(237, 237, 237);

                ((GridDataItem)e.Item)["dovolena"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Green, back);
                ((GridDataItem)e.Item)["nemoc"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Orange, back);
                ((GridDataItem)e.Item)["absence"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);

                Regex r = new Regex("d_\\d+_\\d+");

                foreach (GridColumn coll in e.Item.OwnerTableView.Columns)
                {
                    if (r.IsMatch(coll.UniqueName))
                    {
                        int h;
                        if (int.TryParse(coll.UniqueName.Split('_')[1], out h))
                        {
                            if ((h >= 0 && h < 6) || (h >= 22 && h < 30))
                            {
                                ((GridDataItem)e.Item)[coll].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Magenta, back);
                            }
                            else if ((h >= 6 && h < 14) || (h >= 30 && h < 38))
                            {
                                ((GridDataItem)e.Item)[coll].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                            }
                            else
                            {
                                ((GridDataItem)e.Item)[coll].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Cyan, back);
                            }
                        }
                    }
                }
            }
            if (e.Item.ItemType == GridItemType.FilteringItem && e.Item.OwnerTableView.Name == "Master")
            {
                e.Item.CssClass = "hidden";
            }
            if (e.Item.ItemType == GridItemType.FilteringItem && e.Item.OwnerTableView.Name == "Detail")
            {
                if (notfirst)
                {
                    e.Item.CssClass = "hidden";
                }
                notfirst = true;
            }
            //if(e.Item.ItemType == GridItemType.Header)
            //{
            //    System.Drawing.Color back = System.Drawing.Color.FromArgb(237, 237, 237);
            //    ((GridHeaderItem)e.Item)["dovolena"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Green, back);
            //    ((GridHeaderItem)e.Item)["nemoc"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Orange, back);
            //    ((GridHeaderItem)e.Item)["absence"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);
            //}
        }

        protected void TRadGrid1_DataBound(object sender, EventArgs e)
        {

        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

            //if (TRadGrid1.MasterTableView.GetItems(GridItemType.NestedView).Count() > 1)
            //{
            foreach (GridNestedViewItem nestedViewItem in TRadGrid1.MasterTableView.GetItems(GridItemType.NestedView))
            {
                // you should skip the items if not expanded, or tables not bound
                if (nestedViewItem.NestedTableViews.Length > 0)
                {
                    if (_sort != null)
                    {
                        nestedViewItem.NestedTableViews[0].SortExpressions.Clear();
                        nestedViewItem.NestedTableViews[0].SortExpressions.Add(_sort);
                    }

                    if (nestedViewItem.NestedTableViews[0].Columns.Count < 10 || _sort != null)
                        nestedViewItem.NestedTableViews[0].Rebind();
                }
            }
            //}
        }

        void LoopHierarchyRecursive(GridTableView gridTableView)
        {
            
        }

        protected void TRadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                string uniquename = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).UniqueName;
                if (uniquename.Substring(0, 2) == "d_")
                {
                    Regex reg = new Regex("\\d+");
                    MatchCollection matches = reg.Matches(uniquename);

                    int h, m;
                    if (int.TryParse(matches[0].Value, out h) && int.TryParse(matches[1].Value, out m))
                    {
                        Hashtable dnyKody = ((PlanSmenDetail)((((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem)).dny_kody;
                        if (dnyKody != null)
                        {
                            DateTime datum = ((PlanSmenDetail)((((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem)).datum;

                            List<KSProgram.Dochazka.PlanovaniSmen.dch_zaznam> list = new List<dch_zaznam>() { };
                            rozdelIntervaly(SmenaHashToList(dnyKody), ref list);
                            list = (ZaznamyZasahujiciDoIntervalu(list, datum.AddHours(h).AddMinutes(m), datum.AddHours(h).AddMinutes(m).AddMinutes(30)));

                            if (list.Count > 0)
                            {
                                string html = "<table>{0}</table>";
                                string htmlrow1 = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" colspan=\"2\" align=\"center\"><b>{0}</b></td></tr>";
                                string htmlrow2 = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" colspan=\"2\" align=\"center\">{1}</td></tr>";
                                string htmlrow2i = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" align=\"center\">{4}</td><td style=\"mso-number-format: \\@; font-size: xx-small;\" align=\"center\">{5}</td></tr>";
                                string htmlrows = "";
                                foreach (KSProgram.Dochazka.PlanovaniSmen.dch_zaznam zaznam in list)
                                {
                                    htmlrows += string.Format(htmlrow1 + (zaznam.hodt.Contains('-') ? htmlrow2i : htmlrow2), zaznam.zk, zaznam.hodt, zaznam.bc, zaznam.fc, zaznam.hodt.Contains('-') ? zaznam.hodt.Split('-')[0] : "", zaznam.hodt.Contains('-') ? zaznam.hodt.Split('-')[1] : "");
                                }
                                html = string.Format(html, htmlrows);

                                e.Cell.Text = html;
                            }
                            else
                            {
                                e.Cell.Font.Size = FontUnit.XXSmall;
                            }
                        }
                    }
                }
            }
            e.Cell.Style["border"] = ".5pt solid #808080";
            e.Cell.Style["vertical-align"] = "middle";
        }

        private class MyTemplate : ITemplate
        {
            private string colname;
            public MyTemplate(string cName)
            {
                colname = cName;
            }
            void ITemplate.InstantiateIn(Control container)
            {
                DochazkaPlanSmena smena = new DochazkaPlanSmena();
                
                smena.ID = "DPS_" + colname;
                smena.IsHourDetail = true;
                smena.IsLegenda = false;
                smena.IsFooter = false;
                container.Controls.Add(smena);
            }
        }
        /// <summary>
        /// 
        /// </summary>
        public class PlanSmenDetail : PlanSmen
        {
            public PlanSmenDetail() : base()
            {

            }
            public PlanSmenDetail(PlanSmen plan)
            {
                this.cislo_pom = plan.cislo_pom;
                this.id_pracmist = plan.id_pracmist;
                this.skup_pracujicich = plan.skup_pracujicich;
                this.druh_pom_j = plan.druh_pom_j;
                this.jmeno = plan.jmeno;
                this.kmen_str = plan.kmen_str;
                this.prac_str = plan.prac_str;
                this.skup_str = plan.skup_str;
                this.divize = plan.divize;
                this.nastup = plan.nastup;
                this.datum_ukonc = plan.datum_ukonc;
                this.dny_kody = plan.dny_kody;
                this.konflikty = plan.konflikty;
                this.fond = plan.fond;
                this.mesicni_fond = plan.mesicni_fond;
                this.fond_mzdy = plan.fond_mzdy;
                this.fond_mzdyVO = plan.fond_mzdyVO;
                this.skutecnost = plan.skutecnost;
                this.vyrovnani = plan.vyrovnani;
                this.vyrovnani_fond_mzdy = plan.vyrovnani_fond_mzdy;
                this.konecVO = plan.konecVO;
                this.hod_uvazek = plan.hod_uvazek;
                this.typ_kal = plan.typ_kal;
                this.planVO = plan.planVO;
                this.fondVO = plan.fondVO;
                this.skutecnostVO = plan.skutecnostVO;
                this.zbylyFondVO = plan.zbylyFondVO;

                this.d1 = plan.d1;
                this.d2 = plan.d2;
                this.d3 = plan.d3;
                this.d4 = plan.d4;
                this.d5 = plan.d5;
                this.d6 = plan.d6;
                this.d7 = plan.d7;
                this.d8 = plan.d8;
                this.d9 = plan.d9;
                this.d10 = plan.d10;
                this.d11 = plan.d11;
                this.d12 = plan.d12;
                this.d13 = plan.d13;
                this.d14 = plan.d14;
                this.d15 = plan.d15;
                this.d16 = plan.d16;
                this.d17 = plan.d17;
                this.d18 = plan.d18;
                this.d19 = plan.d19;
                this.d20 = plan.d20;
                this.d21 = plan.d21;
                this.d22 = plan.d22;
                this.d23 = plan.d23;
                this.d24 = plan.d24;
                this.d25 = plan.d25;
                this.d26 = plan.d26;
                this.d27 = plan.d27;
                this.d28 = plan.d28;
                this.d29 = plan.d29;
                this.d30 = plan.d30;
                this.d31 = plan.d31;
            }
            /// <summary>
            /// 
            /// </summary>
            public DateTime datum { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public decimal? prescas12 { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public decimal? prescas_zkr { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public decimal? dovolena { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public decimal? nemoc { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public decimal? absence { get; set; }
        }

    }
}