﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram;
using KSProgram.Dochazka;
using KSProgram.Funkce;
using KSProgram.WebControls;
using KSProgram.Prava;
using Telerik.Web.UI;
using KSProgram.Ciselniky;

public partial class Dochazka_PrescasyPrevod : TPageZam
{
    //int suma = 0;
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //ObdobiText1.SetDefaultObdobi(Globals.AktObdobi);
            //ObdobiText1.SetDefaultObdobi(ParametryDochazky.OBDOBI_PRO_SESTAVY);

            //ObdobiText1.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            RadGrid1.Datum.SelectedObdobi = ParametryDochazky.OBDOBI_PRO_SESTAVY;
        }
    }

    protected override void OnPreRenderComplete(EventArgs e)
    {
        base.OnPreRenderComplete(e);
        int stav = -1;
        if (!PravaAkce.PristupPovolen(89, ref stav))
        {
            /*
            if (TGridView1.FooterRow != null)
            {
                Control c = WebControlHelper.FindControl(TGridView1.FooterRow, "img_vlozit");
                if (c != null)
                {
                    ((ImageButton)c).Enabled = false;
                    ((ImageButton)c).ImageUrl = Globals.IkonaZakazanehoPristupu;
                }
            }
             * */
        }
        
    }

    public DataTable Znamenka()
    {
        DataTable table = new DataTable();
        table.Columns.Add("znamenko", typeof(string));

        DataRow row=table.Rows.Add();
        row["znamenko"]="+";

        row=table.Rows.Add();
        row["znamenko"]="-";

        return table;
    }

    public Dochazka_PrescasyPrevod()
    {
        IdPrava = 88;
        this.HelpURL = "P%C5%99eveden%C3%A9_p%C5%99es%C4%8Dasy";
    }

  

    int minute_celkem = 0;
    protected void RadGrid1_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridHeaderItem)
            minute_celkem = 0;
        else if (e.Item is GridDataItem)
        {
            GridDataItem item = (GridDataItem)e.Item;
            if (item["cas"] != null)
            {
                DateTime datum = Convert.ToDateTime(item["cas"].Text);
                int minute = datum.Hour * 60;
                minute += datum.Minute;

                string znamenko = item["znamenko"].Text;
                if (znamenko == "-")
                    minute *= -1;
                minute_celkem += minute;
            }
            if (item["dny"] != null)
            {
                int dny;
                //int dny=Convert.ToInt32(item["dny"].Text);
                if (Int32.TryParse(item["dny"].Text, out dny))
                {
                    string znamenko = item["znamenko"].Text;
                    if (znamenko == "-")
                        dny *= -1;
                    minute_celkem += dny * 24 * 60;
                }
            }

            // DateTime dat = Convert.ToDateTime(item["datum"].Text);
            DateTime dat = Convert.ToDateTime(((Label)item.FindControl("lab_day")).Text);
            KSProgram.Dochazka.PlanovaciKalendar kal = new KSProgram.Dochazka.PlanovaciKalendar(dat);
            if (kal.JeSvatekVcetneVikendoveho(dat))           
            {
                item["datum"].ForeColor = System.Drawing.Color.Red;
                item["nazev_dne"].ForeColor = System.Drawing.Color.Red;
            }
            else if ((dat.DayOfWeek == DayOfWeek.Saturday) || (dat.DayOfWeek == DayOfWeek.Sunday))
            {
                item["datum"].ForeColor = System.Drawing.Color.Blue;
                item["nazev_dne"].ForeColor = System.Drawing.Color.Blue;
            }
            else
            {
                item["datum"].ForeColor = System.Drawing.Color.Black;
                item["nazev_dne"].ForeColor = System.Drawing.Color.Black;
            }         

        }
        else if (e.Item is GridFooterItem)
        {
            GridFooterItem fi = e.Item as GridFooterItem;

            //zjistím kolik je to dní a hodin
            Int32 dny = minute_celkem / (24 * 60);
            Int32 minuty = minute_celkem % (24 * 60);

            fi["dny"].Text = dny.ToString();
            fi["cas"].Text = Cas_na_min.GetCas(minuty);
        }


        if (e.Item is GridEditableItem && e.Item.IsInEditMode)
        {
            GridEditableItem item = (GridEditableItem)e.Item;
            Session["den_editace"] = null;
            object co = WebControlHelper.FindControlRecursive(item["datum"], "calendar", typeof(TRadDatePicker));
            if (co != null)
            {
                DateTime? ld_dat = ((TRadDatePicker)co).SelectedDate;
                if (ld_dat != null)
                    Session["den_editace"] = ld_dat;              
            }            
        }     
    }

    protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == "PerformInsert")
        {
            GridEditableItem editedItem = e.Item as GridEditableItem;
             
            Hashtable newValues = new Hashtable();
            e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editedItem);
          
            //Prtl_prescasy.InsertPrescasy(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, Convert.ToDateTime(newValues["datum"]), Convert.ToString(newValues["znamenko"]), Convert.ToDateTime(newValues["cas"]), Convert.ToDecimal(newValues["dny"]), (DateTime)ObdobiText1.SelectedDate);
            //KM 29.12.2016
            //Prtl_prescasy.InsertPrescasy(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, Convert.ToDateTime(newValues["datum"]), Convert.ToString(newValues["znamenko"]), Convert.ToDateTime(newValues["cas"]), Convert.ToDecimal(newValues["dny"]), (DateTime)RadGrid1.Datum.SelectedObdobi);
            //PH 10.4.2018 
            string prac_str = null;
            if (newValues["prac_str"] != DBNull.Value)
                prac_str = Convert.ToString(newValues["prac_str"]);
            Prtl_prescasy.InsertPrescasy(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, Convert.ToDateTime(newValues["datum"]), Convert.ToString(newValues["znamenko"]), prac_str, Convert.ToDateTime(newValues["cas"]), Convert.ToDecimal(newValues["dny"]), (DateTime)RadGrid1.Datum.SelectedObdobi);
            //e.Item.OwnerTableView.IsItemInserted = false;
            // e.Canceled = true;
            RadGrid1.MasterTableView.IsItemInserted = true;
            RadGrid1.DataBind();
        }
    }   

    protected void calendar_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        DateTime? ld_dat = null;
        if (e.NewDate != null)
            ld_dat = e.NewDate;
        Session["den_editace"] = ld_dat;
    }

    protected void ddlb_stred_DataBinding(object sender, EventArgs e)
    {
         RadComboBox combo_s = (RadComboBox)sender;
        GridEditFormItem item = (GridEditFormItem)combo_s.NamingContainer;
        string prac_str = Convert.ToString(item.GetDataKeyValue("prac_str").ToString());

        //object o = DataBinder.Eval(this.DataItem, "prac_str");
        /*
        string prac_str = string.Empty;
        foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
        {
            if (item.IsInEditMode)
            {
                prac_str = item.GetDataKeyValue("prac_str").ToString();
            }
        }
        */
        //GridDataItem dataItem = (GridDataItem)RadGrid1.SelectedItems[RadGrid1.SelectedItems.Count - 1];
        //string ID = dataItem.GetDataKeyValue("prac_str").ToString();

        //object o = RadGrid1.SelectedValues["prac_str"];
        if (!string.IsNullOrEmpty(prac_str))
        {
            //if (o.ToString() != "")
            //{
            //string str = o.ToString().Trim();
            prac_str = prac_str.Trim();

                RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "ddlb_stred");
                if (combo != null)
                {
                    RadComboBoxItem selectedItem = new RadComboBoxItem();
                    selectedItem.Text = CisStredisko.CelyNazev(prac_str);
                    selectedItem.Value = prac_str;
                    selectedItem.Attributes.Add("prac_str", prac_str);
                    combo.Items.Add(selectedItem);
                    selectedItem.DataBind();
                    combo.DataBind();
                }
           // }
        }
    }

    protected void CustomValidator_ServerValidate(object source, ServerValidateEventArgs args)
    {
        CustomValidator val = source as CustomValidator;
        DateTime ld_datum = Convert.ToDateTime(args.Value);
        DateTime ld_nastup;
        DateTime? ld_ukonc;
        Prac_pom.Get_datum_nastupu_ukonc(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out ld_nastup, out ld_ukonc);
        if (ld_nastup > ld_datum)
        {
            val.Text = WebControlHelper.ZmenaTextu("[%Zadaný datum je před začátkem pracovního poměru, prosím opravit%]");
            args.IsValid = false;// args.Value.Contains("b");
        }
        if (ZamykaniAgend.GeneralZamekIsLocked())
        {
            val.Text = ZamykaniAgend.GeneralZamekLockedMessage;
            args.IsValid = false;
        }
    }
}
