﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram;
using System.Data;
using KSProgram.Dochazka;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Web.UI.HtmlControls;

namespace KSPortal.Dochazka
{
    public partial class PrideleniModelu : TPage
    {

        private object _dataItem = null;

        protected decimal Os_cislo
        {
            get
            {
                return (ViewState["Os_cislo"] == null ? 0 : (decimal)ViewState["Os_cislo"]);
            }
            set
            {
                ViewState["Os_cislo"] = value;
            }
        }

        protected short Cislo_pom
        {
            get
            {
                return (ViewState["Cislo_pom"] == null ? (short)0 : (short)ViewState["Cislo_pom"]);
            }
            set
            {
                ViewState["Cislo_pom"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>       
        public object DataItem
        {
            get
            {
                return this._dataItem;
            }
            set
            {
                this._dataItem = value;
            }
        }


        public PrideleniModelu()
        {
            //IdPrava = 24;
            //PH 30.10.2014
            IdPrava = 219;
            VisibleSeznamZam = true;
            EnableVisibleSeznamZam = true;

            this.HelpURL = "Modely_pracovn%C3%AD_doby_-_zam%C4%9Bstnanci";
        }
        protected override void Page_Load(object sender, EventArgs e)
        {

        }

   

        protected override void OnLoadComplete(EventArgs e)
        {
            base.OnLoadComplete(e);
            
            if ((!Page.IsPostBack) || (Globals.OsCisloPomer.OsCislo != Os_cislo) || (Globals.OsCisloPomer.CisloPom != Cislo_pom))
            {
                NactiModel();
            }
        }

        protected void NactiModel()
        {
            Os_cislo = Globals.OsCisloPomer.OsCislo;
            Cislo_pom = Globals.OsCisloPomer.CisloPom;

            ds_model.SelectParameters["os_cislo"].DefaultValue = Os_cislo.ToString();
            ds_model.SelectParameters["cislo_pom"].DefaultValue = Cislo_pom.ToString();          
            
            GV_model_zam.DataBind();
        }

        protected void GV_model_zam_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            GV_model_zam.SelectedIndex = 0;
        }

       

        protected void GV_model_zam_RowUpdated(object sender, GridViewUpdatedEventArgs e)
        {
            GV_model_zam.DataBind();
            _obnovDetail();
        }

        private void _obnovDetail()
        {
            gv_polozky.DataBind();
            RadGrid grid = (WebControlHelper.FindControl(this, "gv_polozky") as RadGrid);
            if (grid.MasterTableView.GetItems(GridItemType.Item).Length > 0)
            {
                (grid.MasterTableView.GetItems(GridItemType.Item)[0]).FireCommandEvent(RadGrid.EditCommandName, string.Empty);
                (WebControlHelper.FindControl(this, "command_table") as HtmlTable).Visible = false;
            }
            else
                lab_model_neni.Visible = true;
        }

        public static string GetKonecZacatekSmeny(object container, string ahod, string amin)
        {
            object hod = DataBinder.Eval(container, ahod);
            object min = DataBinder.Eval(container, amin);
            if (!(((hod == null) || (hod == DBNull.Value)) && ((min == null) || (min == DBNull.Value))))
            {
                short? hods = GetNullOrData.GetInt16(hod);
                short? mins = GetNullOrData.GetInt16(min);
                if (hods == null) hods = 0;
                if (mins == null) mins = 0;
                return Cas_na_min.GetCas(hods * 60 + mins);
            }
            return "";
        }

        protected string Doba(object hod, object min)
        {
            if (hod == null)
                hod = 0;
            if (hod == DBNull.Value)
                hod = 0;

            if (min == null)
                min = 0;
            if (min == DBNull.Value)
                min = 0;

            return KSProgram.Funkce.Cas_na_min.GetCas(Convert.ToInt16(hod) * 60 + Convert.ToInt16(min));
        }

        protected void GV_model_zam_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "Delete")
            {
                KSProgram.WebControls.MessageBox.NotifikaceInfoMazani();
            }
            else if (e.CommandName == "Update")
            {
                KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
            }
        }

        protected void DropDownList3_SelectedIndexChanged(object sender, EventArgs e)
        {
          
        }

        protected void GV_model_zam_DataBound(object sender, EventArgs e)
        {
            _obnovDetail();
        }
    }
}