﻿using KSProgram;
using KSProgram.Obecne;
using KSProgram.Sestavy;
using System;
using System.Linq;
using System.Collections.Generic;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using System.Drawing;
using System.IO;

namespace KSPortal.Dochazka
{
    public partial class PruchodySestava : TPage
    {
        public PruchodySestava()
        {
            IdPrava = 298;
        }

        private DateTime datum;
        private bool pruchod_min_un_pouzito = false;
        protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            datum = (DateTime)RadGrid1.Datum.SelectedDatum;
            RadGrid1.DataSource = new KSProgram.Sestavy.DefSestavy_pruchody().Retrieve(datum, ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUserNeboZastupovany));        
        }


        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            /*
            if (e.Item is GridHeaderItem)
            {
                GridHeaderItem it = e.Item as GridHeaderItem;
                it["pruchody_un"].Text = datum.ToString("d");
            }
            else if (e.Item is GridDataItem)
            {
                GridDataItem it = e.Item as GridDataItem;

                GridDataItem dataItem = (GridDataItem)e.Item;
                object obj_pr = DataBinder.Eval(e.Item.DataItem, "pruchody");
                if ((obj_pr != null) && (obj_pr != DBNull.Value))
                {
                    List<StrPruchodyBarva> lst = (List<StrPruchodyBarva>)obj_pr;
                    Table tab = _createTable(lst);
                    it["pruchody_un"].Controls.Add(tab);
                }

                object obj_pr_min = DataBinder.Eval(e.Item.DataItem, "pruchody_min");
                if ((obj_pr_min != null) && (obj_pr_min != DBNull.Value))
                {
                    List<StrPruchodyBarva> lst = (List<StrPruchodyBarva>)obj_pr_min;
                    Table tab = _createTableMin(lst);
                    it["pruchod_min_un"].Controls.Add(tab);
                    pruchod_min_un_pouzito = true;
                }
            }
            */
        }

        private Table _createTableMin(List<StrPruchodyBarva> lst)
        {
            Table table = new Table();
            table.CssClass = "tab_pruchody";
            if (lst.Count == 0) return table;
            foreach (StrPruchodyBarva st in lst.OrderBy(aa => aa.Ident).ThenBy(aa=>aa.Cas))
            {
                _createRowMin(ref table, st);
            }
            return table;
        }
 

        private Table _createTable(List<StrPruchodyBarva> lst)
        {
            ParametryDochazky pd = new ParametryDochazky();

            Table table = new Table();
            table.CssClass = "tab_pruchody";
            if (lst.Count == 0) return table;
            string posl_typ_kodu = "";
            foreach (StrPruchodyBarva st in lst.OrderBy(aa => aa.Ident).ThenBy(aa => aa.Cas))
            {               
                if (!string.IsNullOrEmpty(st.Doba))
                {
                    _createRow(ref table, null, st, false);
                    posl_typ_kodu = "doba";
                }
                else if (pd.IsKodOdchod(st.Kod))
                {
                    if ((posl_typ_kodu != "start"))
                    {
                        if ((posl_typ_kodu == "doba")|| (table.Rows.Count == 0))
                            _createRow(ref table, null, st, true);
                        else
                            _createRow(ref table, table.Rows[table.Rows.Count - 1], st, true);
                    }
                    else
                        _createRow(ref table, table.Rows[table.Rows.Count - 1], st, true);
                    posl_typ_kodu = "odchod";
                }
                else
                {
                    if (posl_typ_kodu != "start")
                    {
                        _createRow(ref table, null, st, false);
                    }
                    posl_typ_kodu = "start";
                }
            }
           
            return table;
        }

        private void _createRow(ref Table table, TableRow rr, StrPruchodyBarva st, bool jenKonec)
        {

            if (!string.IsNullOrEmpty(st.Doba))
            {
                TableRow r = new TableRow();

                r.Cells.Add(_createCellBarva(st.Barva));
                r.Cells.Add(_createCell(/*st.Kod.ToString())*/""));                
                //r.Cells.Add(_createCell("", "pr_cas cas_od")); //čas od
                //r.Cells.Add(_createCell("-"));
                //r.Cells.Add(_createCell("", "pr_cas cas_do")); //čas do
                r.Cells.Add(_createCell("["+st.Doba+"]", "pr_cas pr_doba"));
                r.Cells[r.Cells.Count - 1].ColumnSpan = 4;
                r.Cells.Add(_createCell(st.Zkratka));
                table.Rows.Add(r);             
            }
            else if (jenKonec)
            {
                if (rr == null)
                {
                    rr = new TableRow();
                    rr.Cells.Add(_createCellBarva(st.Barva));
                    rr.Cells.Add(_createCell("")); //
                    rr.Cells.Add(_createCell("", "pr_cas cas_od")); //
                    rr.Cells.Add(_createCell("-"));
                    rr.Cells.Add(_createCell("", "pr_cas cas_do")); //
                    rr.Cells.Add(_createCell("")); //
                    rr.Cells.Add(_createCell("")); //
                    table.Rows.Add(rr);
                }


                //doplním čas do
                Label lab = rr.Cells[4].Controls[0] as Label;
                if (lab != null) lab.Text = st.Cas.ToString("HH:mm");               
            }
            else
            {
                TableRow r = new TableRow();
                r.Cells.Add(_createCellBarva(st.Barva));
                r.Cells.Add(_createCell(/*st.Kod.ToString())*/""));               
                r.Cells.Add(_createCell(st.Cas.ToString("HH:mm"), "pr_cas cas_od")); //čas od
                r.Cells.Add(_createCell("-"));
                r.Cells.Add(_createCell("", "pr_cas cas_do")); //čas do
                r.Cells.Add(_createCell(st.Doba));
                r.Cells.Add(_createCell(st.Zkratka));
                table.Rows.Add(r);
            }
        }

        private void _createRowMin(ref Table table, StrPruchodyBarva st)
        {
            TableRow r = new TableRow();
            r.Cells.Add(_createCellBarva(st.Barva));
            r.Cells.Add(_createCell(st.Cas.ToString("g"), "pr_cas_min"));           
            r.Cells.Add(_createCell(st.Zkratka));
            table.Rows.Add(r);
        }

        private TableCell _createCellBarva(string barva)
        {
            Panel p = new Panel();
            p.CssClass = "pruch_barva";
            p.BackColor = Color.FromName("#"+barva);
            TableCell c = new TableCell();
            c.CssClass = "pr_barva";
            c.Controls.Add(p);
            return c;
        }

        private TableCell _createCell(string text)
        {
            return _createCell(text, "");
        }

        private TableCell _createCell(string text, string css_class)
        {
            TableCell cell = new TableCell();
            cell.CssClass = css_class;
            cell.Controls.Add(new Label() { Text = text });
            return cell;
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            RadGrid1.MasterTableView.GetColumn("pruchod_min_un").Display = pruchod_min_un_pouzito;
        }

        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
            {
                GridHeaderItem it = e.Item as GridHeaderItem;
                it["pruchody_un"].Text = datum.ToString("d");
            }
            else if (e.Item is GridDataItem)
            {
                GridDataItem it = e.Item as GridDataItem;

                GridDataItem dataItem = (GridDataItem)e.Item;
                object obj_pr = DataBinder.Eval(e.Item.DataItem, "pruchody");
                if ((obj_pr != null) && (obj_pr != DBNull.Value))
                {
                    List<StrPruchodyBarva> lst = (List<StrPruchodyBarva>)obj_pr;
                    Table tab = _createTable(lst);
                    it["pruchody_un"].Controls.Add(tab);
                }

                object obj_pr_min = DataBinder.Eval(e.Item.DataItem, "pruchody_min");
                if ((obj_pr_min != null) && (obj_pr_min != DBNull.Value))
                {
                    List<StrPruchodyBarva> lst = (List<StrPruchodyBarva>)obj_pr_min;
                    Table tab = _createTableMin(lst);
                    it["pruchod_min_un"].Controls.Add(tab);
                    pruchod_min_un_pouzito = true;
                }
            }
        }

       

        private void _formatujProExport(object sender, ExportCellFormattingEventArgs e, string sloupec)
        {
            object obj_pr = DataBinder.Eval((((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem, sloupec);
            if ((obj_pr != null) && (obj_pr != DBNull.Value))
            {
                List<StrPruchodyBarva> lst = (List<StrPruchodyBarva>)obj_pr;
                Table tab = _createTable(lst);
                using (StringWriter sw = new StringWriter())
                {
                    tab.RenderControl(new HtmlTextWriter(sw));
                    e.Cell.Text = sw.ToString();
                }
            }
        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
           
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                if ((((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField == "pruchody")|| ((((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField == "pruchody_min")))
                {
                    string sloupec = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField;
                    _formatujProExport(sender, e, sloupec);                   
                }
            }
        }
    }
}