﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram;
using System.Globalization;
using System.Drawing;
using KSProgram.WebControls;
using KSProgram.Dochazka;
using Telerik.Web.UI;

public partial class Dochazka_ReportPoDnech : TPage
{
    private bool hodiny = false;

    public Dochazka_ReportPoDnech()
    {
        IdPrava = 97;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Sestavy#Rekapitulace_doch.C3.A1zky_po_dnech";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)          
            TRadGrid_sestava.Datum.SelectedObdobi = ParametryDochazky.OBDOBI_PRO_SESTAVY;
    }

    protected void TRadGrid_sestava_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridHeaderItem)
        {
            GridHeaderItem headerItem = (GridHeaderItem)e.Item;
            int k = 0;
            DateTimeFormatInfo info = DateTimeFormatInfo.GetInstance(CultureInfo.CurrentUICulture);
            //DateTime ld_pom = (DateTime)obdobi_text.SelectedDate;
            DateTime ld_pom = (DateTime)TRadGrid_sestava.Datum.SelectedObdobi;
            for (int i = 1; i <= 31; i++)
            {
                int lastDay = DateTime.DaysInMonth(ld_pom.Year, ld_pom.Month);
                //if (ld_pom.Month != ((DateTime)obdobi_text.SelectedDate).Month)
                if (ld_pom.Month != ((DateTime)TRadGrid_sestava.Datum.SelectedObdobi).Month)
                    //e.Row.Cells[i].Visible = false;
                    ((TRadGrid)sender).Columns[i + 5].Visible = false;
                else
                {
                    ((TRadGrid)sender).Columns[i + 5].Visible = true;
                    //headerItem["d_"+i.ToString()].Visible = true;
                    headerItem["d_" + i.ToString()].Text = ld_pom.Day.ToString() + "<br/>" + info.GetAbbreviatedDayName(ld_pom.Date.DayOfWeek);
                    if ((ld_pom.DayOfWeek == DayOfWeek.Saturday) || (ld_pom.DayOfWeek == DayOfWeek.Sunday))
                        headerItem["d_" + i.ToString()].ForeColor = Color.Red;
                }
                k++;
                //ld_pom = ((DateTime)obdobi_text.SelectedDate).AddDays(k);
                ld_pom = ((DateTime)TRadGrid_sestava.Datum.SelectedObdobi).AddDays(k);
            }


        }

        if (e.Item is GridDataItem)
        {
            for (int i = 1; i <= 31; i++)
            {
                if (DataBinder.Eval(e.Item.DataItem, "s_" + i.ToString()) == DBNull.Value || DataBinder.Eval(e.Item.DataItem, "s_" + i.ToString()) == null)
                {
                    ((GridDataItem)e.Item)["d_" + i.ToString()].FindControl("i_" + i).Visible = false;
                }

                if (DataBinder.Eval(e.Item.DataItem, "d_" + i.ToString()) != null)
                {
                    //e.Row.Cells[i ].Style.Add(HtmlTextWriterStyle.Padding, "1px"); ;
                    string val = "";
                    val = DataBinder.Eval(e.Item.DataItem, "d_" + i.ToString()).ToString();
                    //string[] ar_val = val.Split(';');
                    ((Label)((GridDataItem)e.Item)["d_" + i.ToString()].FindControl("t_" + i)).Text = val.Replace(';', ' ');
                }
            }
        }
    }

    protected void TRadGrid_sestava_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable table = new DataTable();
        if(IsPostBack)
        {
            // hodiny = ((TRadButton)TRadGrid_sestava.GetGridCommandItem("hodiny", typeof(TRadButton))).Checked;
            //PH 18.3.2021
            TRadButton butt = TRadGrid_sestava.GetGridCommandItem("hodiny", typeof(TRadButton)) as TRadButton;
            if (butt != null)
            {
                hodiny=butt.Checked;
                table = new KSProgram.Sestavy.DefSestavy_dch005().Retrieve((DateTime)TRadGrid_sestava.Datum.SelectedObdobi, hodiny, StrSkupDiv.GetStred(), TRadGrid_sestava.Strediska.GetValue);
            }
        }
        TRadGrid_sestava.DataSource = table;
    }

    protected void hodiny_Click(object sender, EventArgs e)
    {
        hodiny = ((TRadButton)TRadGrid_sestava.GetGridCommandItem("hodiny", typeof(TRadButton))).Checked;
        TRadGrid_sestava.Rebind();
    }

    protected void hodiny_DataBinding(object sender, EventArgs e)
    {
        ((TRadButton)sender).Checked = hodiny;
    }
}
