﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using KSProgram.Funkce;
using System.Drawing;
using KSProgram.Dochazka;

public partial class Dochazka_RozdeleniPrescasu : TPage
{
    DateTime obdobi=new DateTime();
    decimal os_cislo=0;
    short cislo_pom=0;
    int hodinyCelkem = 0;
    int proplatitCelkem = 0;
    bool prac = false;
    bool svat = false;

    public Dochazka_RozdeleniPrescasu()
    {
        EnableChangeLanguage = false; //PH 9.7.2010
    }

    protected override void Page_PreLoad(object sender, EventArgs e)
    {
        base.Page_PreLoad(sender, e);

        obdobi = Convert.ToDateTime(Session["prescasy_obdobi"]);
        os_cislo = Convert.ToDecimal(Session["prescasy_os_cislo"]);
        cislo_pom = Convert.ToInt16(Session["prescasy_cislo_pom"]);
    }

    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            DateTime dat = Convert.ToDateTime(DataBinder.Eval(e.Row.DataItem, "datum"));
            e.Row.Cells[2].Text = dat.ToString("d.M.yyyy");

            int pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "hodiny"));
            e.Row.Cells[4].Text = Cas_na_min.GetCas(pom);
            hodinyCelkem += pom;

            pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "proplatit"));
            e.Row.Cells[5].Text = Cas_na_min.GetCas(pom);
            proplatitCelkem += pom; 

            object objsv = DataBinder.Eval(e.Row.DataItem, "svatek");
            bool svatek = false;
            if (objsv != DBNull.Value)
            {
                svatek = Convert.ToBoolean(DataBinder.Eval(e.Row.DataItem, "svatek"));
            }

            if (svatek)
            {
                e.Row.Cells[1].ForeColor = Color.Red;
                e.Row.Cells[2].ForeColor = e.Row.Cells[1].ForeColor;
            }
            else if ((e.Row.Cells[1].Text == "So") || (e.Row.Cells[1].Text == "Ne"))
            {
                e.Row.Cells[1].ForeColor = Color.Blue;
                e.Row.Cells[2].ForeColor = e.Row.Cells[1].ForeColor;
            }
            if (svatek)
            {
                svat = true;
            }
            else
            {
                prac = true;
            }
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[4].Text = Cas_na_min.GetCas(hodinyCelkem);
            e.Row.Cells[5].Text = Cas_na_min.GetCas(proplatitCelkem);
        }
    }
    protected void LB_rozpocist_Command(object sender, CommandEventArgs e)
    {
        //GridView1.DataSourceID = "ds_rozdeleniPrescasu";
        GridView1.DataSourceID = "ds_rozdelenePrescasy";
        GridView1.DataBind();
    }

    protected void LB_Ulozit_Command(object sender, CommandEventArgs e)
    {
        //GridView1.DataSourceID = "ds_rozdelenePrescasy";
        //GridView1.DataBind();
        ds_rozdelenePrescasy.Update();
        GridView1.DataBind();
       
    }
    protected void GridView1_DataBound(object sender, EventArgs e)
    {
        TB_k_proplac_hodin.Enabled = prac;
        TB_k_proplac_minut.Enabled = TB_k_proplac_hodin.Enabled;

        TB_k_proplac_minut_svatek.Enabled = svat;
        TB_k_proplac_hodin_svatek.Enabled = TB_k_proplac_minut_svatek.Enabled;
    }
}
