﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using KSProgram.Dochazka;
using KSProgram.WebControlsAlone;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System.Globalization;
using KSProgram.Prava;

public partial class Dochazka_Uzaverka : TPage
{
    public Dochazka_Uzaverka()
    {
        IdPrava = 86;
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-M%C4%9Bs%C3%AD%C4%8Dn%C3%AD_z%C3%A1v%C4%9Brka";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!Globals.IsViceIco)
            mv.ActiveViewIndex = 0;
        else
            mv.ActiveViewIndex = 1;

        if (!IsPostBack)
        {
            TRadObdobi Obdobi = (TRadObdobi)TitledPanel1.FindControl("Obdobi");
            Label ObdobiText = (Label)TitledPanel1.FindControl("ObdobiText");
            DateTime max_obdobi=SqlPrikaz.ExecuteScalarDateTime("select max(obdobi) from dch_uzaverka", new DateTime());
            if (max_obdobi == new DateTime())
            {
                /*
                Obdobi.SetMinObdobi(new DateTime(2009,9, 1));
                Obdobi.SetMaxObdobi(new DateTime(2010, 9, 1));
                 * */
                //PH 18.9.2012
                //Obdobi.MinDate=Globals.AktObdobi.AddMonths(-1);
                //Obdobi.MaxDate=Globals.AktObdobi.AddMonths(1);
                Obdobi.SelectedDate = Globals.AktObdobi;
               
                Obdobi.Visible = true;
                ObdobiText.Visible=false;                
            }
            else
            {
                //Obdobi.Visible = false;
                //PH 6.12.2013
                Obdobi.Style.Add(HtmlTextWriterStyle.Display, "none");
                ObdobiText.Visible=true;
                
                DateTime next=max_obdobi.AddMonths(1);
                ObdobiText.Text =  next.ToString("MMMM", CultureInfo.CurrentUICulture)  + " " + next.Year.ToString();
            }
        }
    }
    protected void LinkButton1_Command(object sender, CommandEventArgs e)
    {
        if (ZamykaniAgend.GeneralZamekIsLocked())
        {
            MessageBox.Alert(this, ZamykaniAgend.GeneralZamekLockedMessage, WebControlHelper.ZmenaTextu("[%Uzávěrka%]"));
            return;
        }

        Label Label_mess = (Label)TitledPanel1.FindControl("Label_mess");
        TRadObdobi Obdobi = (TRadObdobi)TitledPanel1.FindControl("Obdobi");
        Label ObdobiText = (Label)TitledPanel1.FindControl("ObdobiText");

        //PH 16.9.2015        
        int[] aa=ViceIco.PlatnePodniky();           
        int id_podniku = aa[0];

        DateTime obdobi =new DateTime();
       string disp_val=Obdobi.Style["display"];
        //if (Obdobi.Visible)
        //PH 27.12.2013
       if (disp_val != "none")
           obdobi = (DateTime)Obdobi.SelectedDate;
       else
           obdobi = Dch_Uzaverka.GetAktObdobi(id_podniku);

        string mess = String.Empty;
        if (Dch_Uzaverka.UzaverkaProved(obdobi, id_podniku))
        {
            mess = "Období " + obdobi.ToString("MMMM", CultureInfo.CurrentUICulture) + " " + obdobi.Year.ToString() + " bylo úspěšně uzavřeno";
            DateTime next = obdobi.AddMonths(1);           
            Obdobi.Style.Add(HtmlTextWriterStyle.Display, "none");
        }
        else
            //Label_mess.Text = "Období " + obdobi.ToString("MMMM", CultureInfo.CurrentUICulture) + "  " + obdobi.Year.ToString() + " již bylo dříve uzavřeno, nelze pokračovat";
            mess = "Období " + obdobi.ToString("MMMM", CultureInfo.CurrentUICulture) + "  " + obdobi.Year.ToString() + " již bylo dříve uzavřeno, nelze pokračovat";


        ObdobiText.Visible = true;
        obdobi = Dch_Uzaverka.GetAktObdobi(id_podniku);
        ObdobiText.Text = obdobi.ToString("MMMM", CultureInfo.CurrentUICulture) + " " + obdobi.Year.ToString();
        //Obdobi.Visible = false;
        Obdobi.Style.Add(HtmlTextWriterStyle.Display, "none");

        ((LinkButton)TitledPanel1.FindControl("LinkButton1")).Enabled=false;

        KSProgram.WebControls.MessageBox.NotifikaceInfo(mess);
    }

    protected void LinkButton2_Command(object sender, CommandEventArgs e)
    {
        if (ZamykaniAgend.GeneralZamekIsLocked())
        {
            MessageBox.Alert(this, ZamykaniAgend.GeneralZamekLockedMessage, WebControlHelper.ZmenaTextu("[%Uzávěrka%]"));
            return;
        }

        foreach (GridDataItem item in vice_ico.Items)
        {
            CheckBox box = (CheckBox)item.FindControl("check_provest");
            if (box.Checked)
            {
                DateTime obdobi=Convert.ToDateTime(item["obdobi"].Text);
                int id_podniku = Convert.ToInt32(item["id"].Text);
                Dch_Uzaverka.UzaverkaProved(obdobi, id_podniku);
            }
        }
        vice_ico.Rebind();
    }

    protected void vice_ico_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DataTable table=Dch_Uzaverka.PodnikyProUzaverku();
        if (table != null)
            vice_ico.DataSource = table;
    }
}
