﻿using System;
using System.Data;
using System.Linq;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Dochazka;
using KSProgram.Data;
using System.Collections.Specialized;
using KSProgram.Funkce;
using System.Drawing;
using System.Security;
using KSProgram.Prava;
using KSProgram.Ciselniky;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Collections.Generic;
using KSProgram;
using KSProgram.Obecne;

public partial class Dochazka_d2 : TPage
{
    public Dochazka_d2()
    {
        IdPrava = 22;
        this.HelpURL = "Polo%C5%BEky";
    }   

    protected Color AplikujBarvu(string name)
    {
        if (name != null) name = name.Trim();
        if (string.IsNullOrEmpty(name)) return Color.White;
        if (name == "#") return new Color();
        return System.Drawing.Color.FromName(name);
    }

    protected void tgv_CisPolozek_InsertCommand(object source, GridCommandEventArgs e)
    {     
        StrDchKody str = new StrDchKody();
        _collectValues(e, ref str, true);        
        CisDchKody.DbInsert(str.vyr_kod.ToString(), str.nazev, str.zkratka, str.mzd_kod1, str.mzd_kod2, str.mzd_kod3, str.sumace, str.ident, str.ident2, str.ident3, str.prenaset, str.kalendar, str.plan_smen, str.prestavka, str.strava, str.barva_back, str.barva_fore, str.term_poradi, str.zpusob, str.terminal, str.podniky, str.druhy_pom, str.ppd);
    }

    protected void tgv_CisPolozek_UpdateCommand(object source, GridCommandEventArgs e)
    {
        StrDchKody str = new StrDchKody();
        _collectValues(e, ref str, false);
        CisDchKody.DbUpdate(str.vyr_kod.ToString(), str.nazev, str.zkratka, str.mzd_kod1, str.mzd_kod2, str.mzd_kod3, str.sumace, str.ident, str.ident2, str.ident3, str.prenaset, str.kalendar, str.plan_smen, str.prestavka, str.strava, str.barva_back, str.barva_fore, str.term_poradi, str.zpusob, str.terminal, str.podniky, str.druhy_pom, str.ppd);
    }

    private void _collectValues(GridCommandEventArgs e, ref StrDchKody str, bool insert)
    {
        GridEditableItem editedItem = e.Item as GridEditableItem;
        UserControl userControl = (UserControl)e.Item.FindControl(GridEditFormItem.EditFormUserControlID);

        str = new StrDchKody();
        if (insert)
            str.vyr_kod = Convert.ToInt32((userControl.FindControl("TextBox2_kod") as RadNumericTextBox).Value);
        else
            str.vyr_kod = Convert.ToInt16(editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["vyr_kod"]);

        str.nazev = (userControl.FindControl("TextBox121") as RadTextBox).Text;
        str.zkratka = (userControl.FindControl("txt_zkratka") as RadTextBox).Text;
        str.mzd_kod1 = null;
        if ((userControl.FindControl("TextBox_mzd_kod1") as RadNumericTextBox).Value != null)
            str.mzd_kod1 = Convert.ToInt32((userControl.FindControl("TextBox_mzd_kod1") as RadNumericTextBox).Value);

        str.mzd_kod2 = null;
        if ((userControl.FindControl("TextBox_mzd_kod2") as RadNumericTextBox).Value != null)
            str.mzd_kod2 = Convert.ToInt32((userControl.FindControl("TextBox_mzd_kod2") as RadNumericTextBox).Value);

        str.mzd_kod3 = null;
        if ((userControl.FindControl("TextBox_mzd_kod3") as RadNumericTextBox).Value != null)
            str.mzd_kod3 = Convert.ToInt32((userControl.FindControl("TextBox_mzd_kod3") as RadNumericTextBox).Value);


        str.sumace = Convert.ToInt32((userControl.FindControl("ddl_sumace2") as TRadComboBox).SelectedValue);

        str.ident = Convert.ToInt32((userControl.FindControl("ddl_ident") as TRadComboBox).SelectedValue);
        str.ident2 = null;
        str.ident3 = null;
        if ((userControl.FindControl("ddl_ident2") as TRadComboBox).SelectedValue != "")
            str.ident2 = Convert.ToInt32((userControl.FindControl("ddl_ident2") as TRadComboBox).SelectedValue);

        if ((userControl.FindControl("ddl_ident3") as TRadComboBox).SelectedValue != "")
            str.ident3 = Convert.ToInt32((userControl.FindControl("ddl_ident3") as TRadComboBox).SelectedValue);

        str.prenaset = Convert.ToInt32((userControl.FindControl("DropDownList2") as TRadComboBox).SelectedValue);
        str.kalendar = Convert.ToInt32((userControl.FindControl("DropDownList1") as TRadComboBox).SelectedValue);

        str.plan_smen = Convert.ToInt32((userControl.FindControl("DropDownList3") as TRadComboBox).SelectedValue);

        str.terminal = Convert.ToInt32((userControl.FindControl("DropDownList_terminal") as TRadComboBox).SelectedValue);

        str.prestavka = Convert.ToInt32((userControl.FindControl("DropDownList4") as TRadComboBox).SelectedValue);
        str.strava = Convert.ToInt32((userControl.FindControl("DropDownList5") as TRadComboBox).SelectedValue);
        str.barva_back = string.Empty;
        str.barva_fore = string.Empty;
        if ((userControl.FindControl("RCP_popredi") as RadColorPicker) != null)
        {
            str.barva_fore = ColorTranslator.ToHtml((userControl.FindControl("RCP_popredi") as RadColorPicker).SelectedColor);
            str.barva_fore=str.barva_fore.Replace("#", "");
        }

        if ((userControl.FindControl("RCP_pozadi") as RadColorPicker) != null)
        {
            str.barva_back = ColorTranslator.ToHtml((userControl.FindControl("RCP_pozadi") as RadColorPicker).SelectedColor);
            str.barva_back=str.barva_back.Replace("#", "");
        }


        str.term_poradi = null;
        if ((userControl.FindControl("TextBox3") as RadNumericTextBox).Value != null)
            str.term_poradi = Convert.ToInt32((userControl.FindControl("TextBox3") as RadNumericTextBox).Value);

        str.zpusob = string.Empty;
        if ((userControl.FindControl("ddlZpusob") as TRadComboBox).SelectedValue != null)
            str.zpusob = (userControl.FindControl("ddlZpusob") as TRadComboBox).SelectedValue;

        str.podniky = string.Empty;
        if ((userControl.FindControl("combo_podniky") as TRadComboBox).CheckedItems.Count > 0)
        {
            str.podniky = null;
            if ((userControl.FindControl("combo_podniky") as TRadComboBox).Visible)
            {
                string val = string.Empty;
                IList<RadComboBoxItem> items = (userControl.FindControl("combo_podniky") as TRadComboBox).CheckedItems;
                foreach (RadComboBoxItem it in items)
                {
                    val += it.Value + ",";
                }
                if (val.EndsWith(",")) val = val.Substring(0, val.Length - 1);

                str.podniky = val;
            }
        }

        str.ppd = Convert.ToInt32((userControl.FindControl("TRadComboBox_ppd") as TRadComboBox).SelectedValue);

        str.druhy_pom = string.Empty;
        if ((userControl.FindControl("comby_druhy_pom") as TRadComboBox).CheckedItems.Count > 0)
        {
            str.druhy_pom = null;
            if ((userControl.FindControl("comby_druhy_pom") as TRadComboBox).Visible)
            {
                string val = string.Empty;
                IList<RadComboBoxItem> items = (userControl.FindControl("comby_druhy_pom") as TRadComboBox).CheckedItems;
                foreach (RadComboBoxItem it in items)
                {
                    val += it.Value + ",";
                }
                if (val.EndsWith(",")) val = val.Substring(0, val.Length - 1);

                str.druhy_pom = val;
            }
        }
    }

    protected string _podnikyText(object val)
    {
        if (val == null) return WebControlHelper.ZmenaTextu("[%Všechny podniky%]");
        string v = val.ToString();
        if (string.IsNullOrEmpty(v)) return WebControlHelper.ZmenaTextu("[%Všechny podniky%]");

        string[] pole=v.Split(new char[] { ',' });
        List<string> lst_str = pole.ToList();
        List<int> lst_int = lst_str.Select(s => int.Parse(s)).ToList();

        int[] vc=ViceIco.PlatnePodniky();
        List<int> lst_int2 = new List<int>(vc);

        
        List<int> dups = lst_int.Intersect(lst_int2).ToList();
        if ((dups.Count==lst_int.Count)&&(dups.Count==lst_int2.Count))
            return WebControlHelper.ZmenaTextu("[%Všechny podniky%]");

        return v;
    }

    protected string _druhyPomText(object val)
    {
        if (val == null) return WebControlHelper.ZmenaTextu("[%Všechny%]");
        string v = val.ToString();
        if (string.IsNullOrEmpty(v)) return WebControlHelper.ZmenaTextu("[%Všechny%]");

        string[] pole = v.Split(new char[] { ',' });
        List<string> lst_str = pole.ToList();

        List<string> lst_str2 = new List<string>();
        CisDruhPom cis = new CisDruhPom();
        DataTable tb = cis.Seznam(false);
        var res = from myRow in tb.AsEnumerable()                      
                      select myRow.Field<string>("uziv_druh");
        if (res!=null)
        {
            lst_str2 = res.ToList<string>();
        }

        List<string> dups = lst_str.Intersect(lst_str2).ToList();
        if ((dups.Count == lst_str.Count) && (dups.Count == lst_str2.Count))
            return WebControlHelper.ZmenaTextu("[%Všechny%]");

        return v;
    }


    protected void tgv_CisPolozek_DeleteCommand(object sender, GridCommandEventArgs e)
    {
        string ls_kod = (e.Item as GridDataItem).OwnerTableView.DataKeyValues[e.Item.ItemIndex]["vyr_kod"].ToString();
        if (!string.IsNullOrEmpty(ls_kod))
        {
            short kod;
            if (Int16.TryParse(ls_kod, out kod))
            {
                //testuju jestli položka existuje
                if (CisDchKody.JePouzita(kod))
                    MessageBox.Alert(this, "Položku nelze odstranit, je již použita.");
                else
                    CisDchKody.DbDelete(kod, kod);
            }
        }
    }

    protected void tgv_CisPolozek_Load(object sender, EventArgs e)
    {
        tgv_CisPolozek.MasterTableView.GetColumn("col_podniky").Visible = Globals.IsViceIco;
        tgv_CisPolozek.MasterTableView.GetColumn("col_druhy_pom").Visible = ParametryDochazky.KODY_PODLE_DRUHU_POM;
    }
}

