﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.WebControls;
using KSProgram.Data;
using System.IO;
using KSProgram.Obecne;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram.Extensions;
using KSProgram.Prava;
using KSProgram;
using KSProgram.Exceptions;
using System.Collections.Generic;
using KSProgram.Dokument;

public partial class Zamestnanec_DokumentyVystavene : TPageZam
{

    public Zamestnanec_DokumentyVystavene()
    {
        IdPrava = 77;
        //PostBackBlocksUI = false;
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        RW_Dokument.Visible = false;

        // zda má být viditelny sloupec s tlacitky Pro inicializaci podpisu - zalo6en9 pozadavku Podpis dokumentu
        TRadGrid1.MasterTableView.GetColumn("sign").Visible = jePravoBezpap() && PravaAkce.PristupPovolen(358);
        TRadGrid1.MasterTableView.GetColumn("stav_podpisu").Visible = jePravoBezpap();
        TRadGrid1.MasterTableView.GetColumn("nahled").Visible = jePravoNahled();
        TRadGrid1.MasterTableView.GetColumn("formaty").Visible = DokumentyVystavene.Povoleneformaty.Count() != 1;

    }

    private bool jePravoBezpap()
    {
        return Globals.RAActive("BEZPAPIROVE_HR") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
    }

    private bool jePravoNahled()
    {
        return Globals.RAActive("DOKUMENTY_VYST_HESLO") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
    }

    private bool jePravoVyveska()
    {
        return Globals.RAActive("VYVESKA") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
    }

    protected void TRadGrid1_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {


        if (e.CommandName == TRadGrid.DownloadAttachmentCommandName)
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
            string filename;
            byte[] data;
            string pripona = "";
            try
            {
                if (getDokumentToSend(id, out filename, out data, ref pripona))
                {
                    KSProgram.Attachment.Send(Page, filename + "." + pripona, data);
                }
                else
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Soubor nelze ze serveru uložit. Formát, ve kterém je soubor uložen, není správcem povolen a konverze do povoleného formátu není možná.%]"), ReadGlobalResource.ZmenaTextu("[%Stažení dokumentu%]"));
                }
            }
            catch (Exception ex)
            {
                string title;
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title);
            }
        }
        else if (e.CommandName == "sign" && PravaAkce.PristupPovolen(358))
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
            string kod_podpisu;
            try
            {
                DokumentyVystavene.ZalozitPozadavekPodpis(id, null, "", out kod_podpisu);
                TRadGrid1.Rebind();
            }
            catch (NoticeException ex)
            {
                MessageBox.Alert(this.Page, ex.Message, ReadGlobalResource.ZmenaTextu("[%Dokument nelze podepsat%]"));
            }
        }
        else if (e.CommandName == "preview")
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;

            string fileName;
            string pripona = "";
            bool podepsany = true;
            int podpisy;
            byte[] data = DokumentyVystavene.GetDokument(id, out fileName, ref pripona, ref podepsany, out podpisy);
            pripona = pripona.ToUpper();
            switch (pripona)
            {
                case "PDF": break;
                case "DOCX": break;
                default: RW_Dokument.Visible = false; return;
            }
            try
            {
                if (pripona == "DOCX")
                {
                    data = SignProcessing.ByteToFixedDocument(data);
                }

                RW_Dokument.Visible = true;
                RPV_PDFViewer.PdfjsProcessingSettings.FileSettings.Data = Convert.ToBase64String(data);
            }
            catch
            {
                RW_Dokument.Visible = false;
            }
        }
    }

    private bool getDokumentToSend(int id, out string fileName, out byte[] data, ref string pozad_pripona)
    {
        data = null;
        //bool preformatovano = true;
        bool podepsany = true;
        bool sifrovany = true;
        bool jen_povolene = true;
        //string pripona = pozad_pripona;
        int podpisy;
        fileName = "";

        data = DokumentyVystavene.GetDokument(id, out fileName, ref pozad_pripona, ref jen_povolene, ref podepsany, ref sifrovany, out podpisy);

        //// zamezení stažení souboru v nrepovoleném formátu
        //if (!povoleneformaty.Exists(x => x.ToUpper() == pripona.ToUpper()))
        //{
        //    preformatovano = false;
        //    foreach (string format in povoleneformaty)
        //    {
        //        fileName = null;
        //        pripona = format;
        //        podepsany = true;
        //        podpisy = 0;

        //        data = DokumentyVystavene.GetDokument(id, out fileName, ref pripona, ref podepsany, out podpisy);
        //        if (povoleneformaty.Exists(x => x.ToUpper() == pripona.ToUpper()))
        //        {
        //            preformatovano = true;
        //            break;
        //        }
        //    }
        //    if (!preformatovano)
        //    {
        //        fileName = "";
        //        pozad_pripona = "";
        //        data = null;
        //        return false;
        //    }
        //}

        ////JO 4.6.2021 zaheslování souboru PDF pokud ja nastaven parametr heslem pro VL
        //try
        //{
        //    data = DokumentyVystavene.Zasifruj(data, fileName, ref pripona);

        //}
        //catch (Exception e)
        //{
        //    string title;
        //    MessageBox.Alert(this.Page, e.HtmlEncode(out title), title);
        //    return false;
        //}
        //pozad_pripona = pripona;
        return data != null;
    }

    protected void R_pripony_DataBinding(object sender, EventArgs e)
    {
        int id = (int)((GridDataItem)((Repeater)sender).BindingContainer).GetDataKeyValue("id");
        List<string> povolene = DokumentyVystavene.Povoleneformaty;
        povolene.ForEach(x => x.ToLower());
        ((Repeater)sender).DataSource = from c in Enum.GetNames(typeof(DokumentyVystavene.zname_exportni_formaty)).ToList().Intersect(povolene)
                                        select new
                                        {
                                            pripona = c,
                                            id = id
                                        };
    }

    protected void TRB_pripona_Click(object sender, EventArgs e)
    {
        string pripona = ((TRadButton)sender).CommandName;
        int id;
        if (int.TryParse(((TRadButton)sender).CommandArgument, out id))
        {
            string fileName;
            byte[] data;
            try
            {
                if (getDokumentToSend(id, out fileName, out data, ref pripona))
                {
                    Attachment.Send(Page, fileName + "." + pripona, data);
                }
                else
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Soubor nelze ze serveru uložit. Konverze do zvoleného formátu není možná.%]"), ReadGlobalResource.ZmenaTextu("[%Stažení dokumentu%]"));
                }
            }
            catch (Exception ex)
            {
                string title;
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title);
            }
        }
    }

    protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            int id_dokumenty = (int)DataBinder.Eval(e.Item.DataItem, "id_dokumenty");
            object o_vazba_blob = DataBinder.Eval(e.Item.DataItem, "vazba_blob");
            int? id_podpisu = GetNullOrData.GetInt32(DataBinder.Eval(e.Item.DataItem, "id_podpisu"));
            if (o_vazba_blob != DBNull.Value || id_dokumenty < 0 || id_podpisu.HasValue)
            {
                (e.Item.FindControl("R_pripony") as Repeater).Visible = false;
            }
            else
            {
                (e.Item.FindControl("R_pripony") as Repeater).Visible = true;
            }

            object oid_poz = DataBinder.Eval(e.Item.DataItem, "id_poz");
            if (oid_poz != DBNull.Value)
            {
                LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                if (b != null)
                {
                    b.Visible = false;
                }
                else
                {
                    b.Visible = true;
                }
            }
            else
            {
                if (id_dokumenty == -3) // Ulozene sestavy se nepodepisuji, neobsahuji {sign}
                {
                    LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    if (b != null)
                    {
                        b.Visible = false;
                    }
                }
                else
                {
                    //JO 30.8.2021 - Odfiltrována možnost předat k podpisu jiný dokument než který obsahuje značky
                    //-----------------------------------------------------------------
                    try
                    {
                        int id_dok = (int)DataBinder.Eval(e.Item.DataItem, "id");
                        byte[] data = DokumentyVystavene.GetDokument(id_dok);
                        data = SignProcessing.ByteToFixedDocument(data);
                        int pocet_podpisu = SignProcessing.SpocitejPodpisPole(data);

                        if (pocet_podpisu > 0)
                        {
                            LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                            if (b != null)
                            {
                                b.Visible = true;
                            }
                        }
                        else
                        {
                            LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                            if (b != null)
                            {
                                b.Visible = false;
                            }
                        }
                    }
                    catch
                    {
                        LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                        if (b != null)
                        {
                            b.Visible = false;
                        }
                    }
                }
            }
        }
    }

    protected void TRB_SelectAll_Click(object sender, EventArgs e)
    {
        if (PravaAkce.PristupPovolen(358))
        {
            TRadGrid1.AllowPaging = false;
            TRadGrid1.Rebind();

            GridItemCollection items = TRadGrid1.MasterTableView.Items;


            foreach (GridDataItem dataItem in items)
            {
                int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
                string kod_podpisu;
                if (!string.IsNullOrEmpty(dataItem["sign"].Text.Replace("&nbsp", string.Empty)))
                {
                    try
                    {
                        DokumentyVystavene.ZalozitPozadavekPodpis(id, null, "", out kod_podpisu);
                    }
                    catch (NoticeException ex)
                    {
                        MessageBox.Alert(this.Page, ex.Message, ReadGlobalResource.ZmenaTextu("[%Dokument nelze předat k podpisu%]"));
                    }
                }
            }

            //odznačení vybraných položek
            foreach (GridDataItem item in TRadGrid1.MasterTableView.Items)
            {
                item.Selected = false;
            }
            TRadGrid1.AllowPaging = true;
            TRadGrid1.Rebind();

        }
    }

    protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        //pokud nemám zapnuté rozšíření tak tlačítko skrývám
        if (e.Item.ItemType == GridItemType.CommandItem)
        {
            GridCommandItem cmd1 = (GridCommandItem)TRadGrid1.MasterTableView.GetItems(GridItemType.CommandItem)[0];
            TRadButton button = cmd1.FindControl("TRB_SelectAll") as TRadButton;
            if (!jePravoBezpap())
            {
                button.Visible = false;
            }
            else
            {
                button.Visible = true;
            }

        }
    }
}