﻿<%@ Application Language="C#" %>

<script RunAt="server">

    void Application_PreRequestHandlerExecute(object sender, EventArgs e)
    {
        KSProgram.Diagnostics.KSTrace.WriteLine("Application_BeginRequest;" + HttpContext.Current.Timestamp.ToString("HH:mm:ss.fffffff") + ";" + HttpContext.Current.Request.HttpMethod + ";" + HttpContext.Current.Request.Path + ";;" + HttpContext.Current.Request.ContentType + ";;" + HttpContext.Current.Request.ContentLength + ";;" + HttpContext.Current.Response.ContentType + ";;");
    }

    void Application_PostRequestHandlerExecute(object sender, EventArgs e)
    {
        KSProgram.Diagnostics.KSTrace.WriteLine(HttpContext.Current.Timestamp.ToString("HH:mm:ss.fffffff") + ";" + DateTime.Now.ToString("HH:mm:ss.fffffff") + ";" + HttpContext.Current.Request.HttpMethod + ";" + HttpContext.Current.Request.Path + ";;" + HttpContext.Current.Request.ContentType + ";;" + HttpContext.Current.Request.ContentLength + ";;" + HttpContext.Current.Response.ContentType + ";;" + "Application_EndRequest");
    }

    void Application_AuthenticateRequest(object sender, EventArgs e)
    {

    }

    //PH 8.1.2014
    void Application_BeginRequest(object sender, EventArgs e)
    {
        HttpContext.Current.Response.AddHeader("x-frame-options", "SAMEORIGIN");
        //"DENY");  MiK 14.1.2014 - Technologii x-frame používá telerik pro zobrazení stránky ve RadWindow, kterou používám v NotifikaceList.aspx

        if (HttpContext.Current.Request.Cookies["Culture"] != null)
        {
            string culture = Request.Cookies.Get("Culture").Value.ToString();
            if ((culture == "cs-CZ") || (culture == "en-US") || (culture == "de-DE") || (culture == "sk-SK"))
            {
                System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo(culture);
            }

            //PR 19.07.2022 HID=62515 oprava chyby InvalidOperationException: Instance is read-only na řádku DateTimeFormat.CalendarWeekRule = ....
            //CurrentUICulture nebo DateTimeFormat je někdy read-only (že by měli v cokině neplatný culture a zůstala nějaká globálně nastavená? např. InvariantCulture?)
            try
            {
                if (System.Threading.Thread.CurrentThread.CurrentUICulture.IsReadOnly || System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.IsReadOnly)
                {
                    var clone = System.Threading.Thread.CurrentThread.CurrentUICulture.Clone() as System.Globalization.CultureInfo;
                    clone.DateTimeFormat = clone.DateTimeFormat.Clone() as System.Globalization.DateTimeFormatInfo;
                    System.Threading.Thread.CurrentThread.CurrentUICulture = clone;
                }
                System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.CalendarWeekRule = System.Globalization.CalendarWeekRule.FirstFourDayWeek;//PH 30.5.2022 vynucuju správné nastavení pravidla pořadí týdnů v roce
            }
            catch (Exception) { }
        }
    }

    protected void Application_EndRequest(Object sender, EventArgs e)
    {
        string authCookie = FormsAuthentication.FormsCookieName;
        foreach (string sCookie in Response.Cookies)
        {
            // Just set the HttpOnly attribute on the Forms 
            // authentication cookie. Skip this check to set the attribute 
            // on all cookies in the collection

            //if (sCookie.Equals(authCookie))
            //{
            // Force HttpOnly to be added to the cookie header
            Response.Cookies[sCookie].Path = System.Web.HttpRuntime.AppDomainAppVirtualPath;
            Response.Cookies[sCookie].HttpOnly = true;
            Response.Cookies[sCookie].Secure = HttpContext.Current.Request.IsSecureConnection;
            //}
        }
    }

    void Application_Start(object sender, EventArgs e)
    {
        // Code that runs on application startup
        //PH 15.12.2022 slovník pro sbírání sessionid
        //použil jsem concurent slovník protože je thread safe
        KSProgram.Globals.SessionList = new System.Collections.Concurrent.ConcurrentDictionary<string, string>();

        if (KSProgram.Funkce.AppConfiguration.GetAppSetting<Int32>("StaticSessionTimerPeriod", 0)>0)
        {
            KSProgram.Obecne.TStaticSessionManagement.LoadTimer();

        }
    }

    void Application_End(object sender, EventArgs e)
    {
        //  Code that runs on application shutdown
        HttpRuntime runtime = (HttpRuntime)typeof(System.Web.HttpRuntime).InvokeMember("_theRuntime",
                                                                                    System.Reflection.BindingFlags.NonPublic
                                                                                    | System.Reflection.BindingFlags.Static
                                                                                    | System.Reflection.BindingFlags.GetField,
                                                                                    null,
                                                                                    null,
                                                                                    null);

        if (runtime == null)
            return;

        string shutDownMessage = (string)runtime.GetType().InvokeMember("_shutDownMessage",
                                                                            System.Reflection.BindingFlags.NonPublic
                                                                            | System.Reflection.BindingFlags.Instance
                                                                            | System.Reflection.BindingFlags.GetField
                                                                            | System.Reflection.BindingFlags.GetProperty,
                                                                            null,
                                                                            runtime,
                                                                            null);

        string shutDownStack = (string)runtime.GetType().InvokeMember("_shutDownStack",
                                                                        System.Reflection.BindingFlags.NonPublic
                                                                        | System.Reflection.BindingFlags.Instance
                                                                        | System.Reflection.BindingFlags.GetField
                                                                        | System.Reflection.BindingFlags.GetProperty,
                                                                        null,
                                                                        runtime,
                                                                        null);

        if ((!string.IsNullOrEmpty(shutDownMessage)) || (!string.IsNullOrEmpty(shutDownStack)))
        {
            KSProgram.KSRuntime.RuntimeEventArgs ev = new KSProgram.KSRuntime.RuntimeEventArgs();

            ev.ShutDownStack = shutDownStack;
            ev.ShutDownMessage = shutDownMessage;

            if (!string.IsNullOrEmpty(shutDownMessage))
            {
                if (shutDownMessage.StartsWith("IIS configuration change"))
                    ev.ShutDown = KSProgram.KSRuntime.ShutDownType.ZmenaWebConfig;
                else if (shutDownMessage.StartsWith("Change in"))
                    ev.ShutDown = KSProgram.KSRuntime.ShutDownType.ZmenaSouboruNeboAdresaru;
                else
                    ev.ShutDown = KSProgram.KSRuntime.ShutDownType.RecyklaceProcesu;

                KSProgram.KSRuntime.Runtime.OnRuntimeChanged(this, ev);
            }
        }
    }

    void Application_Disposed(object sender, EventArgs e)
    {
        //Microsoft.Practices.EnterpriseLibrary.Data.Database DB=KSProgram.Globals.Db;       
    }

    void Application_Error(object sender, EventArgs e)
    {
        // Code that runs when an unhandled error occurs

        //Ochrana proti zacyklení.
        if (Context.Request.Path.Contains("/Public/Error.aspx"))
            return;

        //MD 13.3.2017 Informace o výjimce se předává přes aplikační cache
        Exception ex = Server.GetLastError();
        if (ex != null)
        {
            if (ex is System.Web.HttpUnhandledException && ex.InnerException != null) //PR 25.08.2020
                ex = ex.InnerException;

            string id = Guid.NewGuid().ToString("N");
            HttpContext.Current.Cache.Insert(id, ex, null, DateTime.Now.AddMinutes(5), Cache.NoSlidingExpiration);
            HttpContext.Current.Cache.Insert(id+"_time", DateTime.Now, null, DateTime.Now.AddMinutes(5), Cache.NoSlidingExpiration);//PR 26.03.2021 

            Server.ClearError();

            if ((ex is HttpRequestValidationException || ex is KSProgram.Exceptions.NoticeException) && IsAsyncPostBackRequest(Request))
            {
                //PR 25.08.2020 někdy pokud je to Async Postback a vznikne chyba HttpRequestValidationException, 
                //tak při Response.Redirect vznikne opět HttpRequestValidationException, protože při Web.Handlers.ScriptModule.HttpResponse_Redirecting
                //se šahá na Request.Params, tam se zjistí, že Params není inicializované a zavolá se FillParamsCollection(), kde se zase spustí Validace.
                //Následkem toho Sys.WebForms.PageRequestManager neobdrží (ajax)redirect,
                //(AsyncPostBack nedělá klasický HTTP redirect přes HTTPStatusCode 302, ten zůstává 200, ale do obsahu odpovědi dá ...|pageRedir|http://...|)
                //následně se snaží výsledek rozpársovat a udělat změny ve stránce, následně dojde k nějaké JS chybě teleriku,
                //následně se nezavře BlockUI a neprovede se ani redirect na chybovou stránku. 
                //Takto bez redirectu to již projde do Main.Master do Sys.WebForms.PageRequestManager-RequestEndHandler-u
                //a tam přes args.get_error() zjistím jak httpStatusCode, tak i text chyby, kterou v RadScriptManager1_AsyncPostBackError
                //doplňuji o typ chyby.

                //var errCode = HttpContext.Current.Items["System.Web.UI.PageRequestManager:AsyncPostBackErrorHttpCode"];
                //var errIs = HttpContext.Current.Items["System.Web.UI.PageRequestManager:AsyncPostBackError"];
                //var errMsg = HttpContext.Current.Items["System.Web.UI.PageRequestManager:AsyncPostBackErrorMessage"];
                //var errRedir = HttpContext.Current.Items["System.Web.UI.PageRequestManager:AsyncPostBackRedirectLocation"];

                //PR 01.09.2020 přidal jsem i NoticeException, není zapotřebí tyhle upozornění přesměrovávat na Error.aspx a zase zpátky, ani logovat.
            }
            else
            {
                Response.Redirect("~/Public/Error.aspx?id=" + id);
            }
        }
    }

    public Boolean IsAsyncPostBackRequest(HttpRequest request)
    {
        var values = request.Headers.GetValues("X-MicrosoftAjax");
        if (values != null)
        {
            foreach(string value in values)
            {
                var parts = value.Split(',');
                foreach (string part in parts)
                {
                    if (part.Trim() == "Delta=true")
                        return true;
                }
            }
        }
        return false;
    }

    void Session_Start(object sender, EventArgs e)
    {
        // Code that runs when a new session is started
        //PH 15.12.2022 sbírání session id a času vložení     
        KSProgram.Globals.SessionList.AddOrUpdate(Session.SessionID, DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), (key2, currentValue2) => DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
    }

    void Session_End(object sender, EventArgs e)
    {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.
        //PH 15.12.2022 odebrání session id, když vyprchla
        string val = string.Empty;
        KSProgram.Globals.SessionList.TryRemove(Session.SessionID, out val);
    }

</script>

