﻿using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Hodnoceni;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class Navigace : System.Web.UI.UserControl
    {
        private ParamsH _params = null;
        protected override void OnInit(EventArgs e)
        {
            _params = new ParamsH();
            base.OnInit(e);
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (StatutEditora == 1)
                {
                    TRG_akce.Visible = false;

                    TRG_hlavicky.MasterTableView.GetColumn("os_cislo").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("jmeno").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("prac_str").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("cislo_pom").Visible = false;

                    TRG_hlavicky.CaptionVisible = false;
                    TRG_hlavicky.MasterTableView.Caption = "";
                }
                if (StatutEditora == 2)
                {
                    TRG_hlavicky.MasterTableView.GetColumn("nazev_akce").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("obdobi_od").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("obdobi_do").Visible = false;
                    TRG_hlavicky.MasterTableView.GetColumn("datum").Visible = false;
                }
            }
        }
        private DataTable source;
        private DataTable _data_dt
        {
            get
            {
                if (source == null)
                {
                    source = Hodnoceni.Prehled_hla(Zamknuto, null, StatutEditora);
                }
                return source;
            }
        }


        private DataTable _data_zam
        {
            get
            {
                return _data_dt;
            }
        }

        private object _data_akce
        {
            get
            {
                var ret = _data_dt.ToList(new
                {
                    id_akce = 0,
                    cislo = "",
                    nazev_akce = "",
                    nazev_typu = "",
                    a_obdobi_od = (DateTime?)new DateTime(),
                    a_obdobi_do = (DateTime?)new DateTime(),
                    termin_do = (DateTime?)new DateTime(),
                    bcolor = (Color?)null
                })
                    .Distinct()
                    .OrderByDescending(x => x.termin_do?.Ticks);

                return ret;
            }
        }


        #region Handlers
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public delegate void SelectedHlavickaChangeHandler(object sender, HlavickaChangeEventArgs e);

        // The event
        /// <summary>
        /// 
        /// </summary>
        public event SelectedHlavickaChangeHandler SelectedHlavickaChange;
        // The method which fires the Event
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected virtual void OnSelectedHlavickaChange(object sender, HlavickaChangeEventArgs e)
        {
            if (e.IdHlavicky == null)
            {
                TRG_hlavicky.MasterTableView.ClearSelectedItems();
            }
            SelectedHlavickaChange?.Invoke(sender, e);
        }

        #endregion 

        /// <summary>
        /// Kdo k hodnocení přistupuje
        /// </summary>
        public Int16 StatutEditora
        {
            get
            {
                return (ViewState[this.ID + "StatutEditora"] == null ? (short)0 : Convert.ToInt16(ViewState[this.ID + "StatutEditora"]));
            }
            set
            {
                ViewState[this.ID + "StatutEditora"] = value;
            }
        }

        public Int32? SelectedAkce
        {
            get
            {
                bool suc;
                int? id_akce = GetValue("id_akce").TryParse<Int32?>(out suc) ?? ViewState[this.ID + "id_akce"].TryParse<Int32?>(out suc);

                SelectedAkce = id_akce;
                return id_akce;
            }
            set
            {
                ViewState[this.ID + "id_akce"] = value;
            }
        }

        public Int32? SelectedHlavicka
        {
            get
            {
                return (ViewState[this.ID + "Id_hla"] == null ? (int)0 : Convert.ToInt32(ViewState[this.ID + "Id_hla"]));
            }
            set
            {
                ViewState[this.ID + "Id_hla"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public short Zamknuto
        {
            get
            {
                return (ViewState[this.ID + "Zamknuto"] == null ? (short)0 : (short)ViewState[this.ID + "Zamknuto"]);
            }
            set
            {
                ViewState[this.ID + "Zamknuto"] = value;
            }
        }

        public TRadGrid TableHlavicky
        {
            get
            {
                return this.TRG_hlavicky;
            }
        }

        public TRadGrid TableAkce
        {
            get
            {
                return this.TRG_akce;
            }
        }

        public bool Expanded
        {
            get
            {
                return this.RPB_nav?.Items[0]?.Expanded ?? false;
            }
            set
            {
                this.RPB_nav.Items[0].Expanded = value;
            }
        }

        /// <summary>
        /// True, je li vybráno hodnocení zamestnance
        /// </summary>
        public bool IsSelected {
            get
            {
                return ((TableHlavicky.MasterTableView.Items?.Count ?? 0) > 0) && (TableHlavicky.MasterTableView.GetSelectedItems().FirstOrDefault() != null);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="selectedKey"></param>
        /// <returns></returns>
        public object this[string selectedKey] => GetValue(selectedKey);

        public object GetValue(string key)
        {
            return TableHlavicky.MasterTableView.GetSelectedItems().FirstOrDefault()?.GetDataKeyValue(key);
        }
        public T GetValue<T>(string key)
        {
            bool suc;
            return this.GetValue(key).TryParse<T>(out suc);
        }

        protected void TRG_akce_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRG_akce.DataSource = _data_akce;
        }

        protected void TRG_akce_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = e.Item as GridDataItem;
                if (SelectedAkce != null && (int?)item.GetDataKeyValue("id_akce") == SelectedAkce)
                {
                    item.Selected = true;
                }

                Color? bcolor = GetNullOrData.GetColor(DataBinder.Eval(item.DataItem, "bcolor"));
                if (bcolor != null)
                {
                    item["nazev_akce"].BackColor = ((Color)bcolor).UpravBarvuNaSvetlost(80);
                    item["nazev_akce"].ForeColor = ((Color)bcolor).UpravBarvuNaSvetlost(20);
                }
            }
        }

        protected void TRG_akce_DataBound(object sender, EventArgs e)
        {
            if (!IsPostBack && StatutEditora == 2)
            {
                if (TRG_akce.MasterTableView.Items.Count == 1)
                {
                    TRG_akce.MasterTableView.Items[0].Selected = true;

                    SelectedAkce = (int?)TRG_akce.MasterTableView.Items[0].GetDataKeyValue("id_akce");
                }
            }
        }

        protected void TRG_hlavicky_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (StatutEditora == 1)
            {
                TRG_hlavicky.DataSource = _data_zam;
            }
            else if (StatutEditora == 2)
            {
                int? id_akce = (int?)TRG_akce.MasterTableView.GetSelectedItems().FirstOrDefault()?.GetDataKeyValue("id_akce");

                object dataItem = TRG_akce.MasterTableView.GetSelectedItems().FirstOrDefault()?.DataItem;
                if (id_akce == null && dataItem != null)
                {
                    id_akce = (int?)DataBinder.Eval(dataItem, "id_akce");
                }

                if (id_akce != null)
                {
                    if (_data_zam.Rows.Count > 0)
                    {
                        TRG_hlavicky.DataSource =
                            _data_zam
                            .AsEnumerable()
                            .Where(x => GetNullOrData.GetInt32(x["id_akce"]) == id_akce)
                            .OrderBy(x => GetNullOrData.GetString(x["prac_str"], "", true))
                            .ThenBy(x => GetNullOrData.GetString(x["prac_misto"], "", true))
                            .ThenBy(x => x["os_cislo"])
                            .ThenBy(x => x["cislo_pom"])
                            .CopyToDataTable();//Select("id_akce = " + id_akce, "prac_str, prac_misto, os_cislo, cislo_pom").CopyToDataTable();
                    }
                    else
                    {
                        TRG_hlavicky.DataSource = new List<string>() { };
                    }
                }

                TRG_hlavicky.Visible = id_akce != null;
            }
        }

        protected void TRG_hlavicky_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = e.Item as GridDataItem;
                if (SelectedHlavicka != null && (int?)item.GetDataKeyValue("id") == SelectedHlavicka)
                {
                    item.Selected = true;
                }

                int stav_app = (int)DataBinder.Eval(item.DataItem, "stav_app");
                item["stav_app_text"].BackColor = Hodnoceni.GetStavColor((Hodnoceni.StavHodnoceni)stav_app).UpravBarvuNaSvetlost(80);
                item["stav_app_text"].ForeColor = Hodnoceni.GetStavColor((Hodnoceni.StavHodnoceni)stav_app).UpravBarvuNaSvetlost(20);

                Color? bcolor = GetNullOrData.GetColor(DataBinder.Eval(item.DataItem, "bcolor"));
                if (bcolor != null)
                {
                    item["nazev_akce"].BackColor = ((Color)bcolor).UpravBarvuNaSvetlost(80);
                    item["nazev_akce"].ForeColor = ((Color)bcolor).UpravBarvuNaSvetlost(20);
                }
            }
        }
        protected void TRG_akce_SelectedIndexChanged(object sender, EventArgs e)
        {
            Rebind("zam");
        }
        protected void TRG_akce_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "Select")
            {

                int? newIdAkce = (int?)(e.Item as GridDataItem).GetDataKeyValue("id_akce");
                if (newIdAkce != SelectedAkce)
                {
                    SelectedAkce = newIdAkce;
                }
            }
        }
        HlavickaChangeEventArgs HCHargs = null;
        protected void TRG_hlavicky_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
        {
            if (e.CommandName == "Select")
            {
                RPB_nav.Items[0].Expanded = false;

                int? newId = (int?)(e.Item as GridDataItem).GetDataKeyValue("id");
                if (newId != SelectedHlavicka)
                {
                    SelectedHlavicka = newId;

                    HCHargs = new HlavickaChangeEventArgs()
                    {
                        IdHlavicky = (int?)(e.Item as GridDataItem).GetDataKeyValue("id"),
                        OsCislo = (decimal?)(e.Item as GridDataItem).GetDataKeyValue("os_cislo"),
                        Stav = (string)(e.Item as GridDataItem).GetDataKeyValue("stav"),
                        Zamknuto = (short?)(e.Item as GridDataItem).GetDataKeyValue("zamknuto"),
                        Item = e.Item as GridDataItem
                    };
                }
            }
        }

        protected void TRG_hlavicky_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (HCHargs != null)
                OnSelectedHlavickaChange(TRG_hlavicky, HCHargs);
        }

        protected void TRB_zamknuto_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
        {
            short value;
            if (((TRadButton)sender).SelectedToggleState.Value.TryParse(out value))
            {
                if (Zamknuto != value)
                {
                    TRG_hlavicky.MasterTableView.ClearSelectedItems();
                    Zamknuto = value;
                    SelectedHlavicka = null;
                    Int32? id_akce = SelectedAkce;
                    Rebind("akce");
                    if (id_akce != null)
                    {
                        if (TRadGrid.FindRowByKeyValue(TRG_akce, "id_akce", id_akce.ToString(), true))
                        {
                            SelectedAkce = id_akce;
                        }
                        else
                        {
                            SelectedAkce = null;
                        }
                    }
                    Rebind("zam");
                    if (SelectedHlavicka == 0 || SelectedHlavicka == null)
                        OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs());
                }
            }
        }


        protected void TRB_zamknuto_PreRender(object sender, EventArgs e)
        {
            ((TRadButton)sender).SetSelectedToggleStateByValue(Zamknuto.ToString());

            if(StatutEditora == 2 && ((TRadButton)sender).ID == "TRB_zamknuto2")
            {
                ((TRadButton)sender).Visible = false;
            }
        }
        /// <summary>
        /// Provede rebind na zvolene tabulce
        /// </summary>
        /// <param name="tab">"akce"/"zam" </param>
        public void Rebind(string tab = null, bool invokeEvent = true)
        {
            int? old = SelectedHlavicka;

            if(tab == "akce")
            {
                TRG_akce.Rebind();
            }
            else if (tab == "zam")
            {
                TRG_hlavicky.Rebind();
            }
            else
            {
                TRG_akce.Rebind();
                TRG_hlavicky.Rebind();
            }
            //int? nova = GetValue<Int32?>("id");
            //if (nova == null && nova != old)
            //{
            //    if (invokeEvent)
            //        OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs());
            //}
        }

        public bool NajdiHodnoceniPodleID(int? id)
        {
            bool ret = false;
            if (id != null)
            {
                if (StatutEditora == 2)
                {
                    Int32? id_akce = (int?)_data_dt.AsEnumerable().Where(x => (int)x["id"] == id).FirstOrDefault()?["id_akce"];
                    if (id_akce != null)
                    {
                        if (TRadGrid.FindRowByKeyValue(TRG_akce, "id_akce", id_akce.ToString(), true))
                        {
                            SelectedAkce = id_akce;
                            if (TRadGrid.FindRowByKeyValue(TRG_hlavicky, "id", id.ToString(), true))
                            {
                                ret = true;
                                SelectedHlavicka = id;
                                OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs()
                                {
                                    IdHlavicky = (int?)this["id"],
                                    OsCislo = (decimal?)this["os_cislo"],
                                    Stav = (string)this["stav"],
                                    Zamknuto = (short?)this["zamknuto"],
                                    Item = TRG_hlavicky.MasterTableView.GetSelectedItems().FirstOrDefault() as GridDataItem
                                });
                                RPB_nav.Items[0].Expanded = false;
                            }
                        }
                    }
                }
                else if (StatutEditora == 1)
                {
                    if (TRadGrid.FindRowByKeyValue(TRG_hlavicky, "id", id.ToString(), true))
                    {
                        ret = true;
                        OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs()
                        {
                            IdHlavicky = (int?)this["id"],
                            OsCislo = (decimal?)this["os_cislo"],
                            Stav = (string)this["stav"],
                            Zamknuto = (short?)this["zamknuto"],
                            Item = TRG_hlavicky.MasterTableView.GetSelectedItems().FirstOrDefault() as GridDataItem
                        });
                    }
                }
            }
            if (!ret)
            {
                OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs());
            }
            return ret;
        }

        protected void TRG_hlavicky_DataBound(object sender, EventArgs e)
        {

            if (StatutEditora == 1 && TRG_hlavicky.MasterTableView.Items.Count == 1)
            {
                TRG_hlavicky.MasterTableView.Items[0].Selected = true;
                int? old = SelectedHlavicka;
                SelectedHlavicka = (int?)TRG_hlavicky.MasterTableView.Items[0].GetDataKeyValue("id");
                RPB_nav.Items[0].Expanded = false;

                if (old != SelectedHlavicka)
                {
                    OnSelectedHlavickaChange(TRG_hlavicky, new HlavickaChangeEventArgs()
                    {
                        IdHlavicky = (int?)this["id"],
                        OsCislo = (decimal?)this["os_cislo"],
                        Stav = (string)this["stav"],
                        Zamknuto = (short?)this["zamknuto"],
                        Item = TRG_hlavicky.MasterTableView.GetSelectedItems().FirstOrDefault() as GridDataItem
                    });
                }
            }
        }

        protected void TRG_hlavicky_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridCommandItem)
            {
                if (_params["syst_sezn_pod_v"] == "1" || StatutEditora == 1)
                {
                    GridCommandItemControl c = e.Item.FindControlRecursive<GridCommandItemControl>().FirstOrDefault();
                    if (c != null)
                    {
                        c.PrimiPodrizeniButton.Visible = false;
                    }
                }
            }

        }
    }
    /// 
    /// </summary>
    public class HlavickaChangeEventArgs : EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public GridDataItem Item { get; internal set; }
        /// <summary>
        /// 
        /// </summary>
        public decimal? OsCislo { get; internal set; }
        /// <summary>
        /// 
        /// </summary>
        public string Stav { get; internal set; }
        /// <summary>
        /// 
        /// </summary>
        public int? Zamknuto { get; internal set; }
        /// <summary>
        /// 
        /// </summary>
        public int? IdHlavicky { get; internal set; }
        /// <summary>
        /// 
        /// </summary>
        public int? os_cislo_ { get; internal set; }
        public HlavickaChangeEventArgs()
        {

        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="oldValue"></param>
        /// <param name="newValue"></param>
        public HlavickaChangeEventArgs(int? id, decimal? os_cislo, short? zamknuto, string stav, GridDataItem item)
        {
            this.IdHlavicky = id;
            this.OsCislo = os_cislo;
            this.Zamknuto = zamknuto;
            this.Stav = stav;
            this.Item = item;
        }
    }
}