﻿using KSProgram.Data;
using KSProgram.WebControls;
using KSProgram.Extensions;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Sestavy
{
    public partial class HodnoceniStav : TPage
    {
        /// <summary>
        /// konstruktor
        /// </summary>
        public HodnoceniStav()
        {
            IdPrava = 297;
            VerzeStranky = "6";
            AutomatickyUlozitNastaveni = true;
        }

        string _stavy
        {
            get
            {
                object o = ViewState["HodnoceniStavFilterStavy"];
                if (o == null)
                {
                    return "";
                }
                else
                {
                    return (string)o;
                }
            }
            set
            {
                ViewState["HodnoceniStavFilterStavy"] = value;
            }
        }

        string _stavy_combo
        {
            get
            {
                List<string> li = new List<string>() { };
                GridItem[] fis = TRadGrid1.MasterTableView.GetItems(GridItemType.FilteringItem);
                if (fis.Count() > 0)
                {
                    TRadComboBox combo = (TRadComboBox)fis[0].FindControl("TRCB_stav");
                    if (combo != null)
                    {
                        foreach (RadComboBoxItem item in combo.Items)
                        {
                            if (item.Checked)
                            {
                                li.Add(item.Value);
                            }
                        }
                        return string.Join(",", li);
                    }
                }
                return null;
            }
        }

        string _cisla
        {
            get
            {
                object o = ViewState["HodnoceniStavFilterCislo"];
                if (o == null)
                {
                    return "";
                }
                else
                {
                    return (string)o;
                }
            }
            set
            {
                ViewState["HodnoceniStavFilterCislo"] = value;
            }
        }

        string _cisla_combo
        {
            get
            {
                List<string> li = new List<string>() { };
                GridItem[] fis = TRadGrid1.MasterTableView.GetItems(GridItemType.FilteringItem);
                if (fis.Count() > 0)
                {
                    TRadComboBox combo = (TRadComboBox)fis[0].FindControl("TRCB_cislo");
                    if (combo != null)
                    {
                        foreach (RadComboBoxItem item in combo.Items)
                        {
                            if (item.Checked)
                            {
                                li.Add(item.Value);
                            }
                        }
                        return string.Join(",", li);
                    }
                }
                return null;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string filterExpression = ((TRadGrid)sender).MasterTableView.FilterExpression;

            string[] filters = filterExpression.Split(new string[] { " AND " }, StringSplitOptions.RemoveEmptyEntries);
            filterExpression = "";

            string stavy = "";
            string cisla = "";

            foreach (string fil in filters)
            {
                if (fil.Contains("[stav] = "))
                {
                    stavy = fil.Split('\'')[1];
                    continue;
                }
                else if (fil.Contains("[cislo] = "))
                {
                    cisla = fil.Split('\'')[1];
                    continue;
                }
                filterExpression += (fil + " AND ");
            }
            filterExpression = filterExpression.Length < 5 ? "" : filterExpression.Substring(0, filterExpression.Length - 5);

            ((TRadGrid)sender).MasterTableView.FilterExpression = filterExpression;

            _stavy = string.IsNullOrEmpty(_stavy_combo) ? stavy : _stavy_combo;
            _cisla = string.IsNullOrEmpty(_cisla_combo) ? cisla : _cisla_combo;

            DataTable table = KSProgram.Hodnoceni.Hodnoceni.StavyHodnoceni(string.IsNullOrEmpty(_cisla) ? null : _cisla.Split(',').ToList());

            if (!string.IsNullOrEmpty(_stavy))
            {
                List<string> st = new List<string>() { };
                foreach (string s in _stavy.Split(',').ToList())
                {
                    st.Add(KSProgram.Hodnoceni.Hodnoceni.StavHodnoceniToString((KSProgram.Hodnoceni.Hodnoceni.StavHodnoceni)Convert.ToInt32(s)));
                }

                stavy = "TRIM([stav]) = '" + string.Join("' OR TRIM([stav]) = '", st) + "'";

                DataRow[] rows = table.Select(stavy);

                if (rows.Count() == 0)
                {
                    TRadGrid1.DataSource = rows;
                }
                else
                {
                    TRadGrid1.DataSource = rows.CopyToDataTable();
                }
            }
            else
            {
                TRadGrid1.DataSource = table;
            }
        }

        protected void TRCB_stav_DataBound(object sender, EventArgs e)
        {
            foreach (RadComboBoxItem item in ((TRadComboBox)sender).Items)
            {
                item.Checked = _stavy.Split(',').ToList().Contains(item.Value);
            }
        }

        protected void TRCB_cislo_DataBound(object sender, EventArgs e)
        {
            foreach (RadComboBoxItem item in ((TRadComboBox)sender).Items)
            {
                item.Checked = _cisla.Split(',').ToList().Contains(item.Value);
            }
        }

        protected void TRadGrid1_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (((TRadGrid)sender).DataSource is DataTable)
            {
                DataTable source = (DataTable)((TRadGrid)sender).DataSource;

                DataTable stavy = source.DefaultView.ToTable(true, "stav");

                string result = "";

                foreach (DataRow srow in stavy.Rows)
                {
                    string stav = GetNullOrData.GetString(srow["stav"], true);
                    int count = source.Select("stav = '" + stav + "'").Count();
                    result += (stav + ": " + count.ToString() + "<br />");
                }

                result = string.IsNullOrEmpty(result) ? "" : result.Left(result.Length - 6);

                e.Result = result;
            }
        }

        protected void TRCB_cislo_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            e.Item.Text = GetNullOrData.GetString(((System.Data.DataRowView)e.Item.DataItem).Row["cislo"], true) + " - " + GetNullOrData.GetString(((System.Data.DataRowView)e.Item.DataItem).Row["nazev"], true);
        }

        protected void TRCB_stav_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            int i;
            if(int.TryParse(e.Item.Value, out i))
            {
                e.Item.BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(
                    KSProgram.Hodnoceni.Hodnoceni.GetStavColor((KSProgram.Hodnoceni.Hodnoceni.StavHodnoceni)i), i == 1 ? 100 : 85);
            }
        }

        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                KSProgram.Hodnoceni.Hodnoceni.StavHodnoceni stav = KSProgram.Hodnoceni.Hodnoceni.StringToStavHodnoceni((string)DataBinder.Eval(e.Item.DataItem, "stav"));
                            
                ((GridDataItem)e.Item)["stav"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(
                    KSProgram.Hodnoceni.Hodnoceni.GetStavColor(stav), stav == KSProgram.Hodnoceni.Hodnoceni.StavHodnoceni.Prihlasen ? 100 : 85);
            }
        }

        protected void GCIC_ClearFilter_Click(object sender, EventArgs args)
        {
            _stavy = "";
            _cisla = "";
            GridItem[] fis = TRadGrid1.MasterTableView.GetItems(GridItemType.FilteringItem);
            if (fis.Count() > 0)
            {
                TRadComboBox combo_c = (TRadComboBox)fis[0].FindControl("TRCB_cislo");
                if (combo_c != null)
                {
                    combo_c.ClearCheckedItems();
                }
                TRadComboBox combo_s = (TRadComboBox)fis[0].FindControl("TRCB_stav");
                if (combo_s != null)
                {
                    combo_s.ClearCheckedItems();
                }
            }
        }
    }
}