﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Data;
using KSProgram.Obecne;
using KSProgram.Hodnoceni;
using Telerik.Web.UI;

public partial class Sestavy_HodnoceniVzdelavani : TPage
{
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (CBL_show.Items.Count == 0)
            /*foreach (DataControlField col in TGV_sestava.Columns)
            {
                ListItem item = new ListItem(col.HeaderText);
                item.Value = col.SortExpression;
                item.Selected = true;
                item.Enabled = true;
                CBL_show.Items.Add(item);
            }*/
            foreach (Telerik.Web.UI.GridColumn col in TRadGrid_sestava.Columns)
            {
                ListItem item = new ListItem(col.HeaderText);
                item.Value = col.SortExpression;
                item.Selected = true;
                item.Enabled = true;
                CBL_show.Items.Add(item);
            }
    }
    public Sestavy_HodnoceniVzdelavani()
    {
        IdPrava = 101;
        this.HelpURL = "Hodnocen%C3%AD_PIS_%28KS_port%C3%A1l%29";
    }
    private Telerik.Web.UI.GridColumn column(string SortExp)
    {
        /*foreach (DataControlField col in TGV_sestava.Columns)
            if (col.SortExpression == SortExp)
                return col;
        return null;*/
        foreach (Telerik.Web.UI.GridColumn col in TRadGrid_sestava.Columns)
            if (col.SortExpression == SortExp)
                return col;
        return null;
    }
    protected void lb_nacist_Command(object sender, CommandEventArgs e)
    {
        string columns = "";
        foreach (ListItem item in CBL_show.Items)
        {
            column(item.Value).Visible = item.Selected;
            if (item.Selected)
                columns += item.Value + ",";
        }
        //TGV_sestava.DataSourceID = ODS_sestava.ID;
        TRadGrid_sestava.DataSourceID = ODS_sestava.ID;
        ODS_sestava.SelectParameters["Id_ha"].DefaultValue = TGV_akce.CheckedKeyValuesWhereIn[0];
        ODS_sestava.SelectParameters["cis_divize"].DefaultValue = TDD_divize.SelectedItem.Value;
        ODS_sestava.SelectParameters["skup_str"].DefaultValue = TDD_skupinaStred.SelectedItem.Value;
        ODS_sestava.SelectParameters["str"].DefaultValue = TDD_stredisko.SelectedItem.Value;
        ODS_sestava.SelectParameters["os_cislo"].DefaultValue = TDD_zamestnanec.SelectedItem.Value;
        ODS_sestava.SelectParameters["typ_osvedceni"].DefaultValue = TDD_typy_skoleni.SelectedItem.Value;
        ODS_sestava.SelectParameters["osvedceni"].DefaultValue = TDD_osvedceni.SelectedItem.Value;
        ODS_sestava.SelectParameters["posledni"].DefaultValue = TRBL_skolAkce.SelectedItem.Value;
        ODS_sestava.SelectParameters["columns"].DefaultValue = columns;
        //TGV_sestava.DataBind();
        TRadGrid_sestava.DataBind();
    }

    protected void TRadGrid_sestava_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            object obd_od = ((System.Data.DataRowView)dataItem.DataItem).Row["obdobi_od"];
            DateTime? obdobi_od = (obd_od == null) || (obd_od == DBNull.Value) ? null : (DateTime?)obd_od;
            object dat_ak = ((System.Data.DataRowView)dataItem.DataItem).Row["dat_od"];
            DateTime? datum_akce = (dat_ak == null) || (dat_ak == DBNull.Value) ? null : (DateTime?)dat_ak;
            object ter_od = ((System.Data.DataRowView)dataItem.DataItem).Row["termin_od"];
            DateTime? termin_od = (ter_od == null) || (ter_od == DBNull.Value) ? null : (DateTime?)ter_od;
            object platn = ((System.Data.DataRowView)dataItem.DataItem).Row["plati_do"];
            DateTime? platnost = (platn == null) || (platn == DBNull.Value) ? null : (DateTime?)platn;
            if (datum_akce != null)
            {
                if (DateTime.Now.Date > (DateTime)datum_akce)
                {
                    dataItem.Cells[12].Style.Add(HtmlTextWriterStyle.Color, "#3333FF");//modrá
                    dataItem.Cells[13].Style.Add(HtmlTextWriterStyle.Color, "#3333FF");
                }
                if (termin_od != null)
                    if ((DateTime)termin_od > (DateTime)datum_akce)
                    {
                        dataItem.Cells[12].Style.Add(HtmlTextWriterStyle.Color, "#CC00CC");//fialová
                        dataItem.Cells[13].Style.Add(HtmlTextWriterStyle.Color, "#CC00CC");
                    }
                if (obdobi_od != null)
                    if ((DateTime)obdobi_od > (DateTime)datum_akce)
                    {
                        dataItem.Cells[12].Style.Add(HtmlTextWriterStyle.Color, "#CC0000");//červená
                        dataItem.Cells[13].Style.Add(HtmlTextWriterStyle.Color, "#CC0000");
                    }
            }
        }
    }

    /*protected void TGV_sestava_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        GridViewRow r = e.Row;
        TGridView table = (TGridView)sender;
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            object obd_od = DataBinder.Eval(e.Row.DataItem, "obdobi_od");
            DateTime? obdobi_od = (obd_od == null) || (obd_od == DBNull.Value) ? null : (DateTime?)obd_od;
            object dat_ak = DataBinder.Eval(e.Row.DataItem, "dat_od");
            DateTime? datum_akce = (dat_ak == null) || (dat_ak == DBNull.Value) ? null : (DateTime?)dat_ak;
            object ter_od = DataBinder.Eval(e.Row.DataItem, "termin_od");
            DateTime? termin_od = (ter_od == null) || (ter_od == DBNull.Value) ? null : (DateTime?)ter_od;
            object platn = DataBinder.Eval(e.Row.DataItem, "plati_do");
            DateTime? platnost = (platn == null) || (platn == DBNull.Value) ? null : (DateTime?)platn;
            if (datum_akce != null)
            {
                if (DateTime.Now.Date > (DateTime)datum_akce)
                {
                    r.Cells[10].Style.Add(HtmlTextWriterStyle.Color, "#3333FF");
                    r.Cells[11].Style.Add(HtmlTextWriterStyle.Color, "#3333FF");
                }
                if (termin_od != null)
                    if ((DateTime)termin_od > (DateTime)datum_akce)
                    {
                        r.Cells[10].Style.Add(HtmlTextWriterStyle.Color, "#CC00CC");
                        r.Cells[11].Style.Add(HtmlTextWriterStyle.Color, "#CC00CC");
                    }
                if (obdobi_od != null)
                    if ((DateTime)obdobi_od > (DateTime)datum_akce)
                    {
                        r.Cells[10].Style.Add(HtmlTextWriterStyle.Color, "#CC0000");
                        r.Cells[11].Style.Add(HtmlTextWriterStyle.Color, "#CC0000");
                    }
            }
            if (platnost != null)
                if (DateTime.Now.Date > (DateTime)platnost)
                    r.Cells[12].Style.Add(HtmlTextWriterStyle.Color, "#CC0000");
        }
    }*/
    private void viditelnostPoz()
    {
        if (ParamsH.Get("rozv_poznamka_v") == "0")
        {
            NastavItem("poznamka", false, false);
            NastavItem("zpusob", false, false);
        }
        else
        {
            NastavItem("poznamka", null, true);
            NastavItem("zpusob", null, true);
        }
    }
    private void NastavItem(string item, bool? selected, bool enabled)
    {
        ListItem Item = listItem(item);
        if (Item.Enabled)
            UserSetting.SaveUserSetting(Page.ToString(), CBL_show.ID + "_" + Item.Value, Item.Selected.ToString());
        Item.Enabled = enabled;
        if (selected != null)
            Item.Selected = (bool)selected;
        else if (enabled)
        {
            string hodnota = UserSetting.LoadUserSetting(Page.ToString(), CBL_show.ID + "_" + Item.Value);
            if (!string.IsNullOrEmpty(hodnota))
                Item.Selected = Convert.ToBoolean(hodnota);
        }
    }
    private ListItem listItem(string SortExp)
    {
        foreach (ListItem item in CBL_show.Items)
            if (item.Value == SortExp)
                return item;
        return null;
    }
    protected void CBL_show_PreRender(object sender, EventArgs e)
    {
        viditelnostPoz();
    }

   
}
