﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Hodnoceni;
using KSProgram;

public partial class Sestavy_Sebehodnoceni_KUZK : TPopUpPage
{
    private Int32 Id;
    private List<string> _title = new List<string>();
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        Id = Convert.ToInt32(Session["hodnoceni_id"]);
        Session.Remove("hodnoceni_id");
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        //if (Zakaznik.GetCustomer() == "KU ZLIN")
        //{
            this.ClientScript.RegisterClientScriptBlock(this.GetType(), "print1" + this.Title, "window.print()", true);
            ScriptManager.RegisterStartupScript(this, this.GetType(), "print1" + this.Title, "window.print()", true);
        //}
    }
    public Sestavy_Sebehodnoceni_KUZK()
    {
    }
    protected void FV_hlavicka_DataBinding(object sender, EventArgs e)
    {
        DS_hlavicka.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_typy_kompetenci_DataBinding(object sender, EventArgs e)
    {
        ODS_typy_kompetenci.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_typy_kompetenci_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            string typ = ((System.Data.DataRowView)e.Item.DataItem).Row["typ_kompetenci"].ToString();
            ObjectDataSource ODS = (ObjectDataSource)e.Item.FindControl("ODS_kompetence");
            ODS.SelectParameters["typ_kompetenci"].DefaultValue = typ;
            ODS.SelectParameters["Id"].DefaultValue = Id.ToString();
            TGridView TGV = (TGridView)e.Item.FindControl("TGV_kompetence");
            _title.Add(((System.Data.DataRowView)e.Item.DataItem).Row["nazev_typu"].ToString());
            TGV.DataSourceID = "ODS_kompetence";
        }
    }
    protected void TGV_kompetence_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.Header)
        {
            RepeaterItem RI = (RepeaterItem)(((TGridView)sender).NamingContainer);
            e.Row.Cells[0].Text = (RI.ItemIndex + 1).ToString() + ". KOMPETENCE<br /><br />" + _title[RI.ItemIndex];
        }
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Label L_hodn = (Label)e.Row.FindControl("LabelDbHodnoceni");
            Label L_poz = (Label)e.Row.FindControl("LabelDbPozadavek");
            object poz = DataBinder.Eval(e.Row.DataItem, "body_poz");
            if (poz != DBNull.Value)
                L_poz.Text = Hodnoceni.GetPopisStupneKompetenci((short)poz);
            object obd = DataBinder.Eval(e.Row.DataItem, "body_obd");
            if (obd != DBNull.Value)
                L_hodn.Text = Hodnoceni.GetPopisStupneKompetenci((short)obd);
        }
    }
    protected void REP_slovni_DataBinding(object sender, EventArgs e)
    {
        ODS_slovni.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_slovni_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            Label TB_poznamka = (Label)e.Item.FindControl("TB_poznamka");
            string text = ((System.Data.DataRowView)e.Item.DataItem).Row["poznamka"].ToString();
            if (!string.IsNullOrEmpty(text))
            {
                text = text.Replace("\r\n", "<br>");
                text = text.Replace("\n", "<br>");
                TB_poznamka.Text = text;
            }
        }
    }
}
