﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text.RegularExpressions;

namespace KSPortal.HttpModules
{
    public class UrlCheckModule : IHttpModule
    {
        /// <summary>
        /// You will need to configure this module in the web.config file of your
        /// web and register it with IIS before being able to use it. For more information
        /// see the following link: http://go.microsoft.com/?linkid=8101007
        /// </summary>
        #region IHttpModule Members

        public void Dispose()
        {
            //clean-up code here.
        }

        public void Init(HttpApplication application)
        {
            // Below is an example of how you can handle LogRequest event and provide 
            // custom logging implementation for it
            application.BeginRequest += new EventHandler(application_BeginRequest);
        }

        #endregion

        void application_BeginRequest(object sender, EventArgs e)
        {
            HttpApplication app = (HttpApplication)sender;
            HttpContext context = app.Context;

            if (context.Request.HttpMethod == "GET")
            {
                foreach (string key in context.Request.QueryString.AllKeys)
                {
                    TestParam(key, context.Request.QueryString[key]);
                }
            }
        }

        private void TestParam(string key, string value)
        {
            if (string.IsNullOrEmpty(key)) return;
            if (string.IsNullOrEmpty(value)) return;
            string dValue = HttpUtility.UrlDecode(value);
            string pattern = "\"|'|&|<|>";

            //testovací řetězec
            //value = @"'""--></style></scRipt><scRipt>alert(0x000003)</scRipt>";

            Match match = Regex.Match(value, pattern);
            if (match.Success)
            {
                throw new HttpRequestValidationException("URL parameter " + key + " contains unsave character " + match.Value);
            }

            Match dmatch = Regex.Match(dValue, pattern);
            if (dmatch.Success)
            {
                throw new HttpRequestValidationException("Encoded URL parameter " + key + " contains unsave character " + dmatch.Value);
            }
        }
    }
}
