﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Net;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using CSSZ;
using KSProgram;
using KSProgram.Data;
using KSProgram.Dokument;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using Telerik.Web.UI;

namespace KSPortal.Zamestnanec
{
    public partial class EPodani : TPageZam
    {
        public EPodani()
        {
            IdPrava = 393;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                ////nutné pro fungování visibility dropdownu
                //TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1DD").Display = false;
                //TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2DD").Display = false;
                SubEl.SelectedIndex = 0;
                if (Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM"))
                {
                    Testovaci.Checked = true;
                    //Label3.Text = "(Jen pro KS) Platnost CSSZ šifrovacího certifikátu je do 13.3.2025.";
                    SubEl.Items.Last().Visible = true;
                    TB_VS.Text = "8945104142";
                }
                else
                {
                    string sqlBuffVS = "select c_pole1 as vs from osoby o, osoby_typ t where o.id_osoby = t.id_osoby and typ in ('vl','sh') and c_pole1 is not null";
                    DataTable buffOs = SqlPrikaz.ExecuteCommand(sqlBuffVS);
                    string vs10 = buffOs.Rows[0][0].ToString();
                    TB_VS.Text = vs10;
                }

                Eneshopenka.Visible = Globals.RAActive("EPODANI_CSSZ") || Globals.RAActive("EPODANI_CSSZ_NESCHOPENKA") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");

                Testovaci_CheckedChanged(sender, e);
                CertifikatBylNahran();
            }

            if (!String.IsNullOrEmpty(TB_cislo.Text.Trim()))
            {
                if (!Cssz.zkontrolujCertifikat(TB_cislo.Text))
                {
                    Label1.Text = ReadGlobalResource.ZmenaTextu("[%Nedaří se načíst certifikát z úložiště certifikátu počítače. Kontaktujte prosím vašecho správce IT. Je potřeba nainstalovat certifikát, nebo nastavit práva certifikátu.%]");
                    Label1.ForeColor = System.Drawing.Color.Red;
                    TRB_poslat.Enabled = false;
                    TRadButton5.Enabled = false;
                }
                else
                {
                    Label1.Text = ReadGlobalResource.ZmenaTextu("[%Certifikát je nahrán%]");
                    Label1.ForeColor = System.Drawing.Color.Green;
                    TRB_poslat.Enabled = true;
                    TRadButton5.Enabled = true;
                }
            }

        }


        protected void Submit_Click(object sender, EventArgs e)
        {
            string serialNumber = null;

            Error1.Visible = false;

            if (!String.IsNullOrEmpty(TB_cislo.Text))
            {
                serialNumber = TB_cislo.Text.Trim();
            }
            else
            {
                setErrorText("[%Zadejte číslo certifikátu%]");
                return;
            }

            //if (String.IsNullOrEmpty(SubEl.SelectedValue))
            //{
            //    setErrorText("[%Nebyl vybrán typ podání%]");
            //    return;
            //}

            if (ImportXML.UploadedFiles.Count == 0)
            {
                setErrorText("[%Nebyl nahrán soubor pro odeslání%]");
                return;
            }

            if (!Testovaci.Checked && !RadWindow1.Visible)
            {
                RadWindow1.Visible = true;
                return;
            }
            RadWindow1.Visible = false;

            try
            {
                UploadedFile file = ImportXML.UploadedFiles[0];
                string fileName = file.FileName;
                StreamReader stream = new StreamReader(file.InputStream, Encoding.UTF8);
                string x = stream.ReadToEnd();
                string xml = HttpUtility.UrlDecode(x);

                if (xml.ToUpper().Contains("WINDOWS-1250"))
                {
                    stream = new StreamReader(file.InputStream, Encoding.GetEncoding("windows-1250"));
                    x = stream.ReadToEnd();
                    xml = HttpUtility.UrlDecode(x);
                    xml = xml.Replace("windows-1250", "UTF-8").Replace("WINDOWS-1250", "UTF-8");
                }

                int id_podniku = ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUserNeboZastupovany);
                string vs10 = null;
                string etype = Cssz.eType(xml);

                if (etype.ToUpper().Contains("ELDP")) xml = upravProELDP(xml);

                if (!String.IsNullOrEmpty(TB_VS.Text.Trim())) vs10 = TB_VS.Text.Trim();

                //xml = RemoveDiacritism(xml);

                Cssz main = new Cssz(Testovaci.Checked);
                //Cssz main = new Cssz(true); //JH 24.5.2022 - pojistka
                main.SendNewSubmission(id_podniku, etype, xml, serialNumber, fileName, vs10);
                TRadGrid1.Rebind();
            }
            catch (Exception err)
            {
                setErrorText(err.Message);
            }
        }

        public static string RemoveDiacritism(string Text)
        {
            string stringFormD = Text.Normalize(System.Text.NormalizationForm.FormD);
            System.Text.StringBuilder retVal = new System.Text.StringBuilder();
            for (int index = 0; index < stringFormD.Length; index++)
            {
                if (System.Globalization.CharUnicodeInfo.GetUnicodeCategory(stringFormD[index]) != System.Globalization.UnicodeCategory.NonSpacingMark)
                    retVal.Append(stringFormD[index]);
            }
            return retVal.ToString().Normalize(System.Text.NormalizationForm.FormC);
        }

        private string upravProELDP(string xml)
        {
            int pFrom = xml.IndexOf("cod=\"") + 5;
            string pred = xml.Substring(0, pFrom);
            string po = xml.Substring(pFrom + 3);

            if (po.Contains("cod=\""))
            {
                po = upravProELDP(po); //rekurzivni volani pro vsechny cod
            }

            string kod = xml.Substring(pFrom, 3);
            kod = kod.Replace(" ", "+");
            string novyXml = pred + kod + po;
            return novyXml;
        }

        protected void setErrorText(string text)
        {
            Error1.Text = text;
            Error1.Visible = true;
        }

        protected void Poll_Click(object sender, EventArgs e)
        {
            Window_xml.Visible = false;
            Cssz main = new Cssz(Testovaci.Checked);
            DateTime dat_od = (DateTime)TRadGrid1.Datum.SelectedObdobiOd;
            DateTime dat_do = (DateTime)TRadGrid1.Datum.SelectedObdobiDo;
            main.PollTransactions(dat_od, dat_do);
            TRadGrid1.Rebind();
        }

        //protected void Close_Click(object sender, EventArgs e)
        //{
        //    Cssz main = new Cssz(Testovaci.Checked);
        //    main.CloseTransactions(null);
        //}

        protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DateTime dat_od = (DateTime)TRadGrid1.Datum.SelectedObdobiOd;
            DateTime dat_do = (DateTime)TRadGrid1.Datum.SelectedObdobiDo;

            DataTable table = getPodaniSamostatne(dat_od, dat_do);

            TRadGrid1.DataSource = table;
        }

        public DataTable getPodaniSamostatne(DateTime dat_od, DateTime dat_do)
        {
            int test = 0;
            if (Testovaci.Checked) test = 1;
            string sql = "select * from epodani where datum >= @dat_od AND datum <= @dat_do AND testovaci = " + test;
            if (!Neaktivni.Checked) sql += " AND aktivni = 1";

            sql += " order by datum desc";

            ParametryPrikazu pars = new ParametryPrikazu()
            {
               new KSParameter("dat_od", dat_od, DbType.DateTime),
               new KSParameter("dat_do", dat_do, DbType.DateTime)
            };

            DataTable podani = SqlPrikaz.ExecuteCommand(sql, true, ref pars);

            DataTable tab = new DataTable();
            tab.Columns.Add("id_podani", typeof(String));
            tab.Columns.Add("datum", typeof(DateTime));
            tab.Columns.Add("typ", typeof(String));
            tab.Columns.Add("etype", typeof(String));
            tab.Columns.Add("aktivni", typeof(String));
            tab.Columns.Add("text", typeof(String));
            tab.Columns.Add("soubor", typeof(String));

            foreach (DataRow row in podani.Rows)
            {
                DataRow novy = tab.NewRow();
                novy["id_podani"] = row["id_podani"];
                novy["datum"] = row["datum"];
                novy["typ"] = row["typ"];
                novy["etype"] = row["etype"];
                novy["aktivni"] = "[%ne%]";
                if (int.Parse(row["aktivni"].ToString().Trim()) == 1) novy["aktivni"] = "[%ano%]";

                if (!row["etype"].ToString().ToUpper().Contains("DZDPN")) novy["text"] = Cssz.AktualniStav(row["id_podani"].ToString());
                else novy["text"] = Cssz.AktualniStavNeschopenka(row["id_podani"].ToString());

                novy["soubor"] = row["soubor"];

                tab.Rows.Add(novy);
            }

            return tab;
        }

        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                object aktivni = DataBinder.Eval(e.Item.DataItem, "aktivni");
                LinkButton b = ((GridDataItem)e.Item)["uzavrit"].FindControlRecursive<LinkButton>().FirstOrDefault();
                b.Visible = false;
                if (aktivni != DBNull.Value)
                {
                    if (aktivni.ToString() == "[%ano%]")
                    {
                        b.Visible = true;
                    }
                }

                string typ = DataBinder.Eval(e.Item.DataItem, "typ").ToString().Trim();

                if (!typ.Contains("DZDPN"))
                {
                    LinkButton b2 = ((GridDataItem)e.Item)["stahnout_zprava"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    if (b2 != null) b2.Visible = false;
                }

                LinkButton but = ((GridDataItem)e.Item)["nahled"].FindControlRecursive<LinkButton>().FirstOrDefault();
                GridDataItem dataItem = (GridDataItem)e.Item;
                string soubor = dataItem.GetDataKeyValue("soubor") as string ?? "XML";

                but.Text = soubor;
            }
        }

        protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            Window_xml.Visible = false;
            GridDataItem dataItem;
            try
            {
                dataItem = (GridDataItem)e.Item;
            }
            catch
            {
                return;
            }

            if (dataItem == null) return;

            string id = dataItem.GetDataKeyValue("id_podani") as string ?? null;
            if (id == null)
            {
                return;
            }
            if (e.CommandName == "uzavrit")
            {
                string sql = "update epodani SET aktivni = 0 where id_podani = @id";
                ParametryPrikazu pars = new ParametryPrikazu()
                    {
                       new KSParameter("id", id.ToString(), DbType.String)
                    };
                SqlPrikaz.ExecuteCommand(sql, true, ref pars);

                TRadGrid1.Rebind();
            }

            else if (e.CommandName == "view_xml")
            {
                string sql = "select id_info_blob from epodani where id_podani = '" + id + "'";
                int? ib = SqlPrikaz.ExecuteScalarInt32(sql);
                if (ib != null)
                {
                    Window_xml.Visible = true;
                    byte[] data = SqlPrikaz.LoadByteFromInfoBlob((int)ib);
                    byte[] xml = new Word(data, "txt").SaveTo("html");
                    Xml_text.Text = System.Text.Encoding.UTF8.GetString(xml);
                }
            }
            else if (e.CommandName == "view_resp")
            {
                string etype = dataItem.GetDataKeyValue("etype") as string ?? "";
                string sql = "select id_info_blob from epodani_stavy where typ_zpravy = 'response.decoded' AND  id_podani = '" + id + "' order by datum desc, cas desc";
                int? ib = SqlPrikaz.ExecuteScalarInt32(sql);
                if (ib == null)
                {
                    sql = "select id_info_blob from epodani_stavy where typ_zpravy = 'error' AND  id_podani = '" + id + "' order by datum desc, cas desc";
                    ib = SqlPrikaz.ExecuteScalarInt32(sql);
                }
                if (ib == null)
                {
                    sql = "select id_info_blob from epodani_stavy where typ_zpravy = 'resp' AND  id_podani = '" + id + "' order by datum desc, cas desc";
                    ib = SqlPrikaz.ExecuteScalarInt32(sql);
                }
                if (ib == null)
                {
                    sql = "select id_info_blob from epodani_stavy where id_podani = '" + id + "' order by datum desc, cas desc";
                    ib = SqlPrikaz.ExecuteScalarInt32(sql);
                }
                if (ib != null)
                {
                    Window_xml.Visible = true;
                    byte[] data = SqlPrikaz.LoadByteFromInfoBlob((int)ib);
                    byte[] xml = new Word(data, "txt").SaveTo("html");
                    Xml_text.Text = Cssz.RemoveAllNamespaces(System.Text.Encoding.UTF8.GetString(xml));
                }
            }
            else if (e.CommandName == "download")
            {
                Cssz.ulozNeschopenku(id);
            }
        }

        protected void Neaktivni_CheckedChanged(object sender, EventArgs e)
        {
            TRadGrid1.Rebind();
        }

        protected void Testovaci_CheckedChanged(object sender, EventArgs e)
        {
            if (Testovaci.Checked)
            {
                string clr = "orange";
                System.Drawing.Color color = System.Drawing.Color.FromName(clr);
                Zaslani_cap.InnerText = "[%Zaslání testovacího ePodání%]";
                TRadGrid1.MasterTableView.Caption = "[%Testovací ePodání%]";
                Table_zaslani.Border = 2;
                Table_zaslani.BorderColor = clr;
                Table_eneschopenka.Border = 2;
                Table_eneschopenka.BorderColor = clr;
                //TRadGrid1.MasterTableView.BorderWidth = 5;
                //TRadGrid1.MasterTableView.BorderColor = color;
            }
            else
            {
                Zaslani_cap.InnerText = "[%Zaslání nového ePodání%]";
                TRadGrid1.MasterTableView.Caption = "[%ePodání%]";
                Table_zaslani.Border = 0;
                Table_eneschopenka.Border = 0;
                //TRadGrid1.MasterTableView.BorderWidth = 0;
            }
            if (!String.IsNullOrEmpty(Label3.Text)) Label3.Visible = Testovaci.Checked;
            TRadGrid1.Rebind();
        }

        protected void SubEl_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            //if (SubEl.SelectedValue == "DZDPN")
            //{
            //    TRB_neschopenka.Visible = true;
            //    TRB_poslat.Visible = false;
            //    ImportXML.Enabled = false;
            //}
            //else
            //{
            //    TRB_neschopenka.Visible = false;
            //    TRB_poslat.Visible = true;
            //    ImportXML.Enabled = true;
            //}
        }

        protected void TRB_neschopenka_Click(object sender, EventArgs e)
        {
            string serialNumber = null;

            if (!String.IsNullOrEmpty(TB_cislo.Text) && TRDP_Od.SelectedDate != null && TRDP_Do.SelectedDate != null)
            {
                serialNumber = TB_cislo.Text.Trim();
            }
            else
            {
                return;
            }
            int id_podniku = ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUserNeboZastupovany);
            Cssz cssz = new Cssz(Testovaci.Checked);
            if (Testovaci.Checked) cssz.ENeschopenkaSend(serialNumber, id_podniku, (DateTime)TRDP_Od.SelectedDate, (DateTime)TRDP_Do.SelectedDate, "1182114205");
            else cssz.ENeschopenkaSend(serialNumber, id_podniku, (DateTime)TRDP_Od.SelectedDate, (DateTime)TRDP_Do.SelectedDate, TB_VS.Text.Trim());
            TRadGrid1.Rebind();
        }

        protected void TRB_Nahrat_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(TB_cislo.Text.Trim())) return;

            int id_podniku = ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUserNeboZastupovany);
            Cssz.NahrajCertifikat(id_podniku, TB_cislo.Text.Trim());

            CertifikatBylNahran();
            Error1.Visible = false;
            Page.Response.Redirect(Page.Request.Url.ToString(), true);
        }

        protected void TRB_Zmenit_Click(object sender, EventArgs e)
        {
            TRB_Nahrat.Visible = true;
            TRB_Zmenit.Visible = false;
            TB_cislo.Enabled = true;
            TB_VS.Enabled = true;
            Label1.Visible = false;
            TB_cislo.Text = "";
        }

        protected void CertifikatBylNahran()
        {
            string sqlCommand = "SELECT hodnota FROM e_param  WHERE polozka = 'CSSZ_CERT_SN'" +
                                " AND id_podniku = " + ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUserNeboZastupovany);
            string hodnota = SqlPrikaz.ExecuteScalarString(sqlCommand);
            if (!String.IsNullOrEmpty(hodnota))
            {
                TRB_Nahrat.Visible = false;
                TRB_Zmenit.Visible = true;
                TB_cislo.Enabled = false;
                Label1.Visible = true;
                TB_cislo.Text = hodnota.Trim();
            }
            else
            {
                TRB_Nahrat.Visible = true;
                TRB_Zmenit.Visible = false;
                TB_cislo.Enabled = true;
                Label1.Visible = false;
            }
            if (!String.IsNullOrEmpty(TB_VS.Text.Trim()))
            {
                TB_VS.Enabled = false;
            }
        }

        protected void TRadButton3_Click(object sender, EventArgs e)
        {
            RadWindow1.Visible = false;
        }

        protected void ZobrazEType(object sender, EventArgs e)
        {
            try
            {
                RadAsyncUpload upload = ImportXML;
                var file = upload.UploadedFiles[0];
                StreamReader stream = new StreamReader(file.InputStream);
                string x = stream.ReadToEnd();
                string xml = HttpUtility.UrlDecode(x);
                string etype = Cssz.eType(xml);

                Label_etype.Text = "[%Typ souboru%]: " + etype;
                Label_etype.Visible = true;
            }
            catch { }
        }
    }
}