﻿using KSProgram;
using KSProgram.Data;
using KSProgram.WebControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Zamestnanec
{
    public partial class KarierniPostup : TPage
    {
        private List<Decimal> _osCisla;

        public KarierniPostup()
        {
           IdPrava = 299;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            TRB_tisk.Enabled = false;

            string sqlZamestnanci = " select os_cislo, titul, jmeno, prijmeni " +
                                   " from pracovnici where datum_vystupu is null or datum_vystupu >= " + SqlPrikaz.DateTimeToString(DateTime.Now.Date) +                 // IČ 22.2.2018 jen aktivní zaměstnanci                  
                                   " order by os_cislo ";
            ArrayList zamestAr = new ArrayList();
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sqlZamestnanci))            
            {
                while (reader.Read())
                {
                    RadComboBoxItem item = new RadComboBoxItem();

                    decimal? osC = (decimal?)GetNullOrData.GetDbDecimal(reader, 0);
                    if (osC != null)
                    {
                        if (Globals.RadkovePrava.OsCislo((decimal)osC))
                        {
                            item.Value = osC.ToString();

                            string jmeno = (GetNullOrData.GetString(reader, 1, "").Trim()+ " ").TrimStart(' ');
                            jmeno += GetNullOrData.GetString(reader, 2, "").Trim() + " ";
                            jmeno += GetNullOrData.GetString(reader, 3, "").Trim();

                            item.Text = osC.ToString() + " - " + jmeno;                            
                            zamestAr.Add(item);
                        }
                    }
                }
            }
            if (zamestAr != null)
            {
                RCB_zamestnanci.DataSource = zamestAr;
                RCB_zamestnanci.DataBind();
            }

            
        }


        protected override void Page_LoadComplete(object sender, EventArgs e)
        {
            base.Page_LoadComplete(sender, e);
            karPostupy.Controls.Clear();
            if (_osCisla != null)
            {
                foreach (decimal item in _osCisla)
                {
                    var uc = LoadControlT("~/Controls/KarierniPostup.ascx", item);
                    karPostupy.Controls.Add(uc);
                }

                foreach (RadComboBoxItem item in RCB_zamestnanci.Items)
                {
                    if (item != null)
                        item.Checked = _osCisla.Contains(Convert.ToDecimal(item.Value));
                }

                TRB_tisk.Enabled = _osCisla.Count != 0;
            }
        }
        /// <summary>
        /// Načte kontrolku a zavolá ji se zadanými parametry, pokud k nim existuje konstruktor, z internetu
        /// </summary>
        /// <param name="UserControlPath"></param>
        /// <param name="constructorParameters"></param>
        /// <returns></returns>
        private UserControl LoadControlT( string UserControlPath, params object[] constructorParameters)
        {
            List<Type> constParamTypes = new List<Type>();
            foreach (object constParam in constructorParameters)
            {
                constParamTypes.Add(constParam.GetType());
            }

            UserControl ctl = this.Page.LoadControl(UserControlPath) as UserControl;

            // Find the relevant constructor
            ConstructorInfo constructor = ctl.GetType().BaseType.GetConstructor(constParamTypes.ToArray());

            //And then call the relevant constructor
            if (constructor == null)
            {
                throw new MemberAccessException("The requested constructor was not found on : " + ctl.GetType().BaseType.ToString());
            }
            else
            {
                constructor.Invoke(ctl, constructorParameters);
            }

            // Finally return the fully initialized UC
            return ctl;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

            //karPostupy.Controls.Clear();
            //if (_osCisla != null)
            //{ 
            //    foreach (decimal item in _osCisla)
            //    {
            //        var uc = LoadControlT("~/Controls/KarierniPostup.ascx", item);
            //        karPostupy.Controls.Add(uc);
            //    }

            //    foreach (RadComboBoxItem item in RCB_zamestnanci.Items)
            //    {
            //        if (item != null)
            //            item.Checked = _osCisla.Contains(Convert.ToDecimal(item.Value));
            //    }

            //    TRB_tisk.Enabled = _osCisla.Count != 0;
            //}
        }

        protected void TRB_nacti_Click(object sender, EventArgs e)
        {
            _osCisla = Array.ConvertAll<string, decimal>(((TRadButton)sender).CommandArgument.ToString().Split(new char[1] { ',' }, StringSplitOptions.RemoveEmptyEntries), x => Convert.ToDecimal(x)).ToList();
        }
    }
}