﻿using System;
using System.Data;
using KSProgram.Data;
using KSProgram.Sestavy;
using KSProgram.WebControls;


public partial class Manazer_StatVekStrukt : TSestavaPredek
{
    //slouží pro uložení stavu tláčítka pro Hlavní pracovní poměry
    private bool hlPracPom = false;

    public int SumMuzi
    {
        get
        {
            object o = ViewState["SumMuzi"];
            return (int)(o ?? 0);
        }
        set
        {
            ViewState["SumMuzi"] = value;
        }
    }

    public int SumZeny
    {
        get
        {
            object o = ViewState["SumZeny"];
            return (int)(o ?? 0);
        }
        set
        {
            ViewState["SumZeny"] = value;
        }
    }

    public int SumCelkem
    {
        get
        {
            object o = ViewState["SumCelkem"];
            return (int)(o ?? 0);
        }
        set
        {
            ViewState["SumCelkem"] = value;
        }
    }

    public decimal PrumMuzi
    {
        get
        {
            object o = ViewState["PrumMuzi"];
            return (decimal)(o ?? 0m);
        }
        set
        {
            ViewState["PrumMuzi"] = value;
        }
    }

    public decimal PrumZeny
    {
        get
        {
            object o = ViewState["PrumZeny"];
            return (decimal)(o ?? 0m);
        }
        set
        {
            ViewState["PrumZeny"] = value;
        }
    }

    public decimal PrumCelkem
    {
        get
        {
            object o = ViewState["PrumCelkem"];
            return (decimal)(o ?? 0m);
        }
        set
        {
            ViewState["PrumCelkem"] = value;
        }
    }

    public Manazer_StatVekStrukt()
    {
        IdPrava = 47;
        this.HelpURL = "Eviden%C4%8Dn%C3%AD_grafy_%28KS_port%C3%A1l%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //TRDP_KeDni.SelectedDate = DateTime.Today;
            RChart.Visible = false;
        }
    }

    protected void TRB_Jednotka_CheckedChanged(object sender, EventArgs e)
    {
        Jednotka.Enabled = ((TRadButton)sender).Checked;
    }

    //protected void TRB_Vytvorit_Command(object sender, CommandEventArgs e)
    //{
    //    DateTime datDo = Convert.ToDateTime(TRDP_KeDni.SelectedDate);

    //    TRG_Data.Rebind();
    //}

    protected void TRG_Data_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DataTable data = new DataTable();

        if (IsPostBack)
        {
            string jednotky = "";
            if (TRB_Jednotka.Checked) { jednotky = Jednotka.GetStred(); }
            //DateTime keDni = Convert.ToDateTime(TRDP_KeDni.SelectedDate);
            DateTime keDni = (DateTime)TRG_Data.Datum.SelectedDatum;
            //bool hlavniPP = TRCBX_HPP.Checked;
            bool hlavniPP = ((TRadButton)TRG_Data.GetGridCommandItem("hlPracPom", typeof(TRadButton))).Checked;
            hlPracPom = hlavniPP;
            //bool mimoEvid = TRCBX_BezMe.Checked;
            bool mimoEvid = TRG_Data.GetGridCommandItemControl.BezMESButton.Checked;

            KSProgram.Sestavy.DefSestavy_SI009 dataSest = new DefSestavy_SI009();
            data = dataSest.Retrieve(jednotky, keDni, hlavniPP, mimoEvid);

            // Dopočet průměrů
            // ---------------
            int vekMuziSoucet = 0;
            int vekZenySoucet = 0;
            int muziSoucet = 0;
            int zenySoucet = 0;

            foreach (DataRow row in data.Rows)
            {
                int vek = GetNullOrData.GetInt32(row["vek"], 0);
                int muzi = GetNullOrData.GetInt32(row["muzi"], 0);                
                muziSoucet += muzi;
                vekMuziSoucet += muzi * vek;

                int zeny = GetNullOrData.GetInt32(row["zeny"], 0);
                zenySoucet += zeny;
                vekZenySoucet += zeny * vek;
            }

            SumMuzi = muziSoucet;
            SumZeny = zenySoucet;
            SumCelkem = SumMuzi + SumZeny;

            PrumMuzi = muziSoucet == 0 ? 0m : decimal.Round((decimal)vekMuziSoucet / muziSoucet, 2);
            PrumZeny = zenySoucet == 0 ? 0m : decimal.Round((decimal)vekZenySoucet / zenySoucet, 2);
            PrumCelkem = SumCelkem == 0 ? 0m : decimal.Round((decimal)(vekMuziSoucet + vekZenySoucet) / SumCelkem, 2);
            // ---------------

            // Zobrazení dat v grafu
            RChart.DataSource = data;
            RChart.DataBind();
            RChart.Visible = true;
        }

        TRG_Data.DataSource = data;

        //TRG_Data.Visible = (data != null);
        //RChart.Visible = (data != null);
    }

    protected void RChart_PreRender(object sender, EventArgs e)
    {
        Telerik.Web.UI.RadHtmlChart chart = (Telerik.Web.UI.RadHtmlChart)sender;

        // Překlad popisků v grafu
        //chart.ChartTitle.Text = WebControlHelper.ZmenaTextu(Page, "[%Věková statistika zaměstnanců organizace%]") + " " + WebControlHelper.ZmenaTextu(Page, "[%ke dni%]: ") + ((DateTime)TRDP_KeDni.SelectedDate).ToString("d");
        chart.ChartTitle.Text = WebControlHelper.ZmenaTextu(Page, "[%Věková statistika zaměstnanců organizace%]") + " " + WebControlHelper.ZmenaTextu(Page, "[%ke dni%]: ") + ((DateTime)TRG_Data.Datum.SelectedDatum).ToString("d");
        chart.PlotArea.Series[0].Name = WebControlHelper.ZmenaTextu(Page, "[%Muži%]");
        chart.PlotArea.Series[1].Name = WebControlHelper.ZmenaTextu(Page, "[%Ženy%]");
        chart.PlotArea.XAxis.TitleAppearance.Text = WebControlHelper.ZmenaTextu(Page, "[%Věk%]");
        chart.PlotArea.YAxis.TitleAppearance.Text = WebControlHelper.ZmenaTextu(Page, "[%Počet zaměstnanců%]");
    }

    /// <summary>
    /// Je třeba tlačítku dát jeho původní stav, protože si jej nepamatuje když je v kontejneru
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void hlPracPom_DataBinding(object sender, EventArgs e)
    {
        ((TRadButton)sender).Checked = hlPracPom;
    }

    /// <summary>
    /// při kliknutí se provede rebind
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void hlPracPom_Click(object sender, EventArgs e)
    {
        TRG_Data.Rebind();
    }
}
