﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;

namespace KSPortal.Obecne
{
    /// <summary>
    /// Vrací fotografii zaměstnance, nebo uchazeče pokud je url &source=uchazeci
    /// </summary>
    public partial class EmployeePhoto : System.Web.UI.Page
    {
        //PR 18.8.2017 využil jsem tuto stránku i pro načítání fotografie uchazeče
        private enum ImgSource
        {
            pracovnici,
            uchazeci,
            rozpracvyber
        }
        private Image GetImage(decimal osCislo, ImgSource source)
        {
            string sql = "";
            if (source == ImgSource.pracovnici)
                sql = "select foto from fotografie where os_cislo = " + osCislo.ToString();
            else if (source == ImgSource.uchazeci)
                sql = "select data_obrazku from obrazky where typ_obrazku = 'uchazeč' and os_cislo = " + osCislo.ToString();
            else if (source == ImgSource.rozpracvyber)
                sql = "select informace from info_blob where os_cislo = " + osCislo.ToString() + " and pouziti=105";
            byte[] buffer = KSProgram.Data.SqlPrikaz.ExecuteScalarBlob(sql);
            if (buffer == null)
            {
                //MiK 29.9.2013 poh=kud není foto vrátí defaultní 
                //return null;

                //string sql2 = "SELECT rodne_cislo FROM pracovnici WHERE os_cislo = " + osCislo.ToString();
                //string rc = KSProgram.Data.SqlPrikaz.ExecuteScalarString(sql2, null, true);
                //bool zena = false;
                //if (rc != null)
                //    zena = KSProgram.Funkce.F_RodneCislo.Zena(rc);
                //if (zena)
                //{
                //    return Image.FromFile(System.Web.HttpRuntime.AppDomainAppPath + "ImagesN\\user_female.png");
                //}
                //else
                //{
                //    return Image.FromFile(System.Web.HttpRuntime.AppDomainAppPath + "ImagesN\\user_male.png");
                //}

                //MD 19.5.2017 Zbytečně se načítalo rodné číslo z databáze a pak se použil jen ze dvou stejně vypadajících obrázků
                return Image.FromFile(System.Web.HttpRuntime.AppDomainAppPath + "ImagesN\\user.png");
            }
            else
            {
                //MD 19.5.2017 Fotka v databázi může být chybná.
                //bool isJpeg = Telerik.Web.UI.BinaryImageFormatHelper.IsJpeg(buffer);
                //if (!isJpeg)
                bool isValid = Telerik.Web.UI.BinaryImageFormatHelper.IsJpeg(buffer) 
                    || Telerik.Web.UI.BinaryImageFormatHelper.IsPng(buffer) 
                    || Telerik.Web.UI.BinaryImageFormatHelper.IsGif(buffer) 
                    || Telerik.Web.UI.BinaryImageFormatHelper.IsBmp(buffer) 
                    || Telerik.Web.UI.BinaryImageFormatHelper.IsTiff(buffer);
                if (!isValid)
                {
                    return Image.FromFile(System.Web.HttpRuntime.AppDomainAppPath + "ImagesN\\noImage.png");
                }
            }
            MemoryStream stream = new MemoryStream(buffer);
            return Image.FromStream(stream);
        }

        private Image Resize(Image image, Size newSize)
        {
            if (newSize == image.Size) return image;

            float rationW = (newSize.Width > 0) ? ((float)newSize.Width / (float)image.Size.Width) : 1;
            float ratioH = (newSize.Height > 0) ? ((float)newSize.Height / (float)image.Size.Height) : 1;
            float ratio = (rationW < ratioH) ? rationW : ratioH;
            if (ratio == 1) return image;

            int newWidth = (int)(image.Size.Width * ratio);
            int newHeight = (int)(image.Size.Height * ratio);

            Bitmap newImage = new Bitmap(newWidth, newHeight);
            using (Graphics gr = Graphics.FromImage(newImage))
            {
                gr.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBilinear;
                gr.CompositingQuality = System.Drawing.Drawing2D.CompositingQuality.HighQuality;
                gr.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
                gr.PixelOffsetMode = System.Drawing.Drawing2D.PixelOffsetMode.HighQuality;
                gr.DrawImage(image, new Rectangle(0, 0, newWidth, newHeight));
            }
            return (Image)newImage;
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            Response.Clear();

            if (!String.IsNullOrEmpty(Request.QueryString["os_cislo"]))
            {
                decimal osCislo = Decimal.Parse(Request.QueryString["os_cislo"]);
                ImgSource source = ImgSource.pracovnici;
                //if (Request.QueryString["source"] != null && Request.QueryString["source"] == "uchazeci")
                //PH 28.1.2022 HID:58966
                if (Request.QueryString["source"] != null)
                {
                    if (Request.QueryString["source"] == "uchazeci")
                        source = ImgSource.uchazeci;
                    else if (Request.QueryString["source"] == "rozpracvyber")
                        source = ImgSource.rozpracvyber;
                }
                Image image = GetImage(osCislo, source);
                if (image != null)
                {
                    //resize
                    //------------------------
                    Size newSize = new Size();
                    if (!String.IsNullOrEmpty(Request.QueryString["maxWidth"]))
                    {
                        newSize.Width = int.Parse(Request.QueryString["maxWidth"]);
                    }
                    if (!String.IsNullOrEmpty(Request.QueryString["maxHeight"]))
                    {
                        newSize.Height = int.Parse(Request.QueryString["maxHeight"]);
                    }
                    if (!newSize.IsEmpty)
                    {
                        image = Resize(image, newSize);
                    }
                    //------------------------

                    Response.ContentType = "image/png";
                    image.Save(Response.OutputStream, ImageFormat.Png);
                }
            }
        }
    }
}