﻿using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.InfoBlob;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Obecne
{
    public partial class LostBlob : TPage
    {
        public LostBlob()
        {
            IdPrava = -1;
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        private List<KSProgram.InfoBlob.InfoBlob.InfoBlobRadek> _data
        {
            get
            {
                object o = CacheInfo.GetItemFromCache("LostBlobsData");
                if(o == null)
                {
                    o = KSProgram.InfoBlob.InfoBlob.DejZtracene();
                }
                CacheInfo.AddItemToCache("LostBlobsData", o, 5, System.Web.Caching.CacheItemPriority.Normal);
                return o as List<KSProgram.InfoBlob.InfoBlob.InfoBlobRadek>;
            }
            set
            {
                CacheInfo.AddItemToCache("LostBlobsData", value, 5, System.Web.Caching.CacheItemPriority.Normal);
            }
        }

        protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (IsPostBack)
            {
                RadGrid1.DataSource = _data.GroupBy(x => x.pouziti).Select(x => new
                {
                    pouziti = x.First().pouziti,
                    agenda = x.First().agenda,
                    pocet = x.Count()
                }).ToList();
            }
            else
            {
                RadGrid1.DataSource = (new List<InfoBlob.InfoBlobRadek>() { }).Select(x => new
                {
                    pouziti = x.pouziti,
                    agenda = x.agenda,
                    pocet = 0
                }).ToList();
            }
        }

        protected void RadGrid1_DetailTableDataBind(object sender, Telerik.Web.UI.GridDetailTableDataBindEventArgs e)
        {

            if (e.DetailTableView.Name == "agenda")
            {
                GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
                short pouziti = (short)dataItem.GetDataKeyValue("pouziti");
                e.DetailTableView.DataSource = _data.FindAll(x => x.pouziti == pouziti).GroupBy(x => x.md5).Select(x => new
                {
                    md5 = x.First().md5,
                    md5_short = x.First().md5.Left(5),
                    pocet = x.Count()
                }).ToList();
            }
            else if (e.DetailTableView.Name == "obsah")
            {
                GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
                string md5 = dataItem.GetDataKeyValue("md5")?.ToString();

                GridDataItem dataItem_agenda = (GridDataItem)e.DetailTableView.ParentItem.OwnerTableView.ParentItem;
                short pouziti = (short)dataItem_agenda.GetDataKeyValue("pouziti");

                e.DetailTableView.DataSource = _data.FindAll(x => x.pouziti == pouziti && x.md5 == md5);
            }
            //else if (e.DetailTableView.Name == "blob")
            //{
            //    //GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
            //    //int id = (int)dataItem.GetDataKeyValue("id");

            //    //KSProgram.InfoBlob.InfoBlob.InfoBlobRadek radek;
            //    //if (KSProgram.InfoBlob.InfoBlob.Read(id, out radek))
            //    //{
            //    //    e.DetailTableView.FindControlRecursive<TTextBox>("data").Text = KSProgram.InfoBlob.InfoBlob.ReadString(id);
            //    //}

            //}
        }

        protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.ExpandCollapseCommandName && e.Item is GridDataItem && (e.Item as GridDataItem).OwnerTableView.Name == "obsah")
            {
                int id = (int)((GridDataItem)e.Item).GetDataKeyValue("id");

                ((GridDataItem)e.Item).ChildItem.FindControlRecursive<TTextBox>("data").Text = InfoBlob.ReadString(id);
            }
            else if(e.CommandName == "smazat")
            {
                short pouziti = (short)((GridDataItem)e.Item).GetDataKeyValue("pouziti");

                _data.FindAll(x => x.pouziti == pouziti).ForEach(x => x.Delete());
                _data.RemoveAll(x => x.pouziti == pouziti);
                RadGrid1.Rebind();
            }
        }
    }
}