﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Obecne
{
    public partial class PravaRoleAkce : TPage
    {
        public PravaRoleAkce()
        {
            IdPrava = -1;
        }

        protected void RadComboBoxRole_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            RadTreeListAkce.Visible = true;
            RadTreeListAkce.DataSourceID = "ODS_Akce";
            //<asp:ControlParameter ControlID="RadComboBoxRole" Name="roleId" PropertyName="SelectedValue"

            ODS_Akce.SelectParameters["roleid"].DefaultValue=e.Value;
            RadTreeListAkce.DataBind();
            RadTreeListAkce.ExpandAllItems();

            //RadButtonZakazat.Visible = true;
            //RadButtonPovolit.Visible = true;
            //RadButtonPovolitPrihl.Visible = true;
        }

        private void NastavVybranymStav(int stav)
        {
            TreeListDataItemCollection items = RadTreeListAkce.SelectedItems;
            if (items.Count > 0)
            {
                int idRole = Convert.ToInt32(RadComboBoxRole.SelectedValue);
                foreach (TreeListDataItem item in items)
                {
                    if (item.ChildItems.Count != 0) continue;
                    string akce = item["akce"].Text;
                    if (!string.IsNullOrWhiteSpace(akce) && akce != "&nbsp;")
                    {
                        int pom = Convert.ToInt32(akce);
                        KSProgram.Prava.Prtl_role_akce.UpdateAkce(idRole, pom, stav);
                    }
                }
                RadTreeListAkce.Rebind();
            }
            RadTreeListAkce.ClearSelectedItems();
        }

        protected void RadButtonZakazat_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(RadComboBoxRole.SelectedValue))
                NastavVybranymStav(0);
        }

        protected void RadButtonPovolit_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(RadComboBoxRole.SelectedValue))
                NastavVybranymStav(1);
        }

        protected void RadButtonPovolitPrihl_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(RadComboBoxRole.SelectedValue))
                NastavVybranymStav(2);
        }

        protected void RadTreeListAkce_ItemCreated(object sender, TreeListItemCreatedEventArgs e)
        {
            if (e.Item is TreeListDataItem)
            {
                var dataItem = (TreeListDataItem)e.Item;
                var expandCell = dataItem.Cells[dataItem.HierarchyIndex.NestedLevel];
                if (expandCell.Controls.Count > 0)
                {
                    expandCell.Controls[0].Visible = false;
                }
            }
        }

        private void RecursiveSelection(TreeListDataItem item, bool selected)
        {
            foreach (TreeListDataItem childItem in item.ChildItems)
            {
                childItem.Selected = selected;
                RecursiveSelection(childItem, selected);
            }
        }

        protected void RadTreeListAkce_ItemCommand(object sender, TreeListCommandEventArgs e)
        {
            //if (e.CommandName == "Select")
            //{
            //    if (e.Item is TreeListDataItem)
            //    {
            //        TreeListDataItem item = e.Item as TreeListDataItem;
            //        RecursiveSelection(item, true);
            //   }
            //}
            //else if(e.CommandName == "Deselect")
            //{
            //    if (e.Item is TreeListDataItem)
            //    {
            //        TreeListDataItem item = e.Item as TreeListDataItem;
            //        RecursiveSelection(item, false);
            //    }
            //}
        }

        protected void RadTreeListAkce_ItemDataBound(object sender, TreeListItemDataBoundEventArgs e)
        {
            if (e.Item is TreeListDataItem)
            {
                TreeListDataItem item = (TreeListDataItem)e.Item;
                if (DBNull.Value == DataBinder.Eval(item.DataItem, "stav"))
                {
                    e.Item.CssClass = "rtlR sibl";
                }
            }
        }
    }
}