﻿using KSProgram;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using KSProgram.Prava;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram.Obecne;
using KSProgram.Prenosy.Insolvence.ISIR_CUZK_WS.IsirCuzkWS;
using KSProgram.Ciselniky;
using KSProgram.Dochazka;
using System.IO;
using KSProgram.Data;
using System.Drawing;

namespace KSPortal.Obecne
{
    public partial class UzivPopup : TPage
    {
        
        protected void RadPageLayout1_Load(object sender, EventArgs e)
        {
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            IsMainPage = false;
        }
        protected override void OnLoad(EventArgs e)
        {
            IsMainPage = false;
            base.OnLoad(e);

            RadAjaxManager manager = RadAjaxManager.GetCurrent(Page);            
            manager.AjaxRequest += new RadAjaxControl.AjaxRequestDelegate(manager_AjaxRequest);

            // Image img = (Image)WebControlHelper.FindControl(this, "image_zam");           
            // img.ImageUrl = "~/Obecne/EmployeePhoto.aspx?os_cislo=" + Globals.OsCisloAktUser.ToString() + "&maxHeight=250&maxWidth=150&"+ DateTime.Now;
            _obnovVyberFotky("image_zam");
            _obnovVyberFotky("Thumbnail");

            int vel=Parametry.PovinnyParametrCti<int>("FotoZamMaxVelikost");
            TRB_zmena_foto.Visible = (vel>0);

            if ((!IsPostBack)&&(TRB_zmena_foto.Visible))
            {
                ParametryPrikazu par = new ParametryPrikazu()
                {
                    new KSParameter("os_cislo", DbType.Decimal, Globals.OsCisloAktUser)
                };
                int pocet=SqlPrikaz.ExecuteScalar<Int32>("select count(*) from info_blob where pouziti=105 and os_cislo=@os_cislo", 0, ref par);
                TRB_zmena_foto.Checked = (pocet > 0);
                pan_zmena_foto.Visible = TRB_zmena_foto.Checked;
            }

            if (Globals.DocasneHeslo) //PR 01.02.2019 
            {
                panel1.Visible = false;
            }
            else
            {
                panel1.Visible = true;
                //rbGenerujSlovnik.Visible = (Globals.SuperUser && Globals.PrekladDat);
            }

            //JO 20.11.2019
            if (UzivProfily.ModulProfily())
            {
                uzivProfil.Visible = true;
                //FS_role.Visible = false;
                dl_role.Visible = false;
            }
            else
            {
                uzivProfil.Visible = false;
                // FS_role.Visible = true;
                dl_role.Visible = true;
            }

        }

        private void _obnovVyberFotky(string id)
        {
            System.Web.UI.WebControls.Image img = (System.Web.UI.WebControls.Image)WebControlHelper.FindControl(this, id);
            img.ImageUrl = "~/Obecne/EmployeePhoto.aspx?os_cislo=" + Globals.OsCisloAktUser.ToString() + "&maxHeight=250&maxWidth=150"+(id=="Thumbnail" ? "&source=rozpracvyber&" : "&")+ DateTime.Now;
        }

        protected void manager_AjaxRequest(object sender, AjaxRequestEventArgs e)
        {
            if (telerikUpl.UploadedFiles.Count > 0)
            {
                try
                {
                    UploadedFile upd_file = telerikUpl.UploadedFiles[0];
                    string pripona = upd_file.GetExtension().Replace(".", "");
                    var inputstream = upd_file.InputStream;
                    byte[] soubor_data;
                    using (var memoryStream = new MemoryStream())
                    {
                        inputstream.CopyTo(memoryStream);
                        soubor_data = memoryStream.ToArray();
                        //System.Drawing.Image img = System.Drawing.Image.FromStream(memoryStream);
                        //Rectangle cropRect = new Rectangle(0,0,img.Width,img.Width);
                        //Bitmap src = img as Bitmap;
                        //Bitmap target = new Bitmap(cropRect.Width, cropRect.Height);

                        //using (Graphics g = Graphics.FromImage(target))
                        //{
                        //    g.DrawImage(src, new Rectangle(0, 0, target.Width, target.Height),
                        //                     cropRect,
                        //                     GraphicsUnit.Pixel);
                        //}
                    }                                       

                    int? image_id = 0;
                    ParametryPrikazu par = new ParametryPrikazu()
                    {
                        new KSParameter("os_cislo", DbType.Decimal, Globals.OsCisloAktUser)
                    };
                    SqlPrikaz.ExecuteNonQuery("delete from info_blob where pouziti=105 and os_cislo=@os_cislo", false, par);
                    SqlPrikaz.SaveByteToInfoBlob(ref image_id, Globals.OsCisloAktUser, null, 105, null, null, soubor_data, true, null, null, pripona);
                    telerikUpl.UploadedFiles.RemoveAt(0);                    

                    _obnovVyberFotky("Thumbnail");
                }
                catch(Exception ex)
                {
                    string errorText = ReadGlobalResource.ZmenaTextu("[%Nepodařilo se uploadovat soubor%],[%chyba%]:");
                    throw new Exception(errorText, ex);
                }
            }             
        }

        protected void rbtJenPrimePodrizene_CheckedChanged(object sender, EventArgs e)
        {
            RadButton rb = (RadButton)sender;
            Globals.JenPrimiPodrizeni = rb.Checked;
        }

        protected void rbtVyjmoutMimoevS_CheckedChanged(object sender, EventArgs e)
        {
            RadButton rb = (RadButton)sender;
            Globals.VyjmoutMimoevStav = rb.Checked;
        }

        protected void rbGenerujSlovnik_CheckedChanged(object sender, EventArgs e)
        {
            RadButton rb = (RadButton)sender;
            Globals.PrekladGenerovaniSlovniku = rb.Checked;
        }

        public static DataTable GetRole()
        {
            string[] las_role = PravaAkce.GetUserRoleNames(Globals.User);
            DataTable table = new DataTable();
            table.Columns.Add("role", typeof(string));
            foreach (string s in las_role)
            {
                DataRow r = table.Rows.Add();
                r["role"] = s;
            }

            return table;
        }


        //Obsluha stisku tlačítka pro zvolení profilu
        //JO 20.11.2019
        protected void BtnZvolit_Clicked(object sender, EventArgs e)
        {
            int id = -1;
            int[] roleIDs = new int[] { };
            int druh_rad_prav = -1;
            string uzivatel = Globals.User;
            string ev_udaj = null;
            decimal os_cislo = Globals.OsCisloAktUser;
            OsCisloZmena.Nastavit(Globals.OpenedMainWindow, os_cislo);
            foreach (GridDataItem item in TRadGrid_uziv_ucty.SelectedItems)
            {
                id = Convert.ToInt32(item["id"].Text.ToString()); // vrátí id vybraného profilu
                //role_id = Convert.ToInt32(item["role_id"].Text.ToString());
                druh_rad_prav = Convert.ToInt32(item["druh_rad_prav"].Text.ToString());
                ev_udaj = item.GetDataKeyValue("ev_udaj").ToString().Trim();
            }

            roleIDs = UzivProfily.UzivRole(id);

            if (!string.IsNullOrEmpty(ev_udaj))
            {
                UzivProfily.Evid_udaj = ev_udaj;
            }
            
            if (roleIDs.Length > 0)
            {
                Globals.CreateRadPrava(os_cislo);
                //nastavení rolí v aplikaci - odemyká záložky
                Session["PravaAkce"] = PravaAkce.AkceProRole(roleIDs);
                UzivProfily.NastavProfil((int)os_cislo, druh_rad_prav, roleIDs, id);
                FailureLabel2.Text = "";
                //zavře popup okno
                ScriptManager.RegisterStartupScript(this.Page, Page.GetType(), "closePage", "closeWin()", true);
            }
            else
            {
                FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nebyl vybrán žádný profil%]!");

            }




        }
        //Obsluha stisku tlačítka pro nastavení profilu jako výchozího
        //JO 20.11.2019
        protected void BtnVychozi_Clicked(object sender, EventArgs e)
        {
            int id = 0;
            // int role_id = 0;
            string uzivatel = Globals.User;

            foreach (GridDataItem item in TRadGrid_uziv_ucty.SelectedItems)
            {
                id = Convert.ToInt32(item["id"].Text.ToString()); // vrátí id vybraného profilu
                                                                  //  role_id = Convert.ToInt32(item["role_id"].Text.ToString());
            }
            if (id != 0)
            {
                if (UzivProfily.NastavVychozi(id, uzivatel))
                {
                    TRadGrid_uziv_ucty.Rebind();
                }
            }

        }

        //Obsluha stisku tlačítka pro zrušení profilu jako výchozího
        //JO 20.11.2019
        protected void BtnZrus_Clicked(object sender, EventArgs e)
        {

            string uzivatel = Globals.User;

            if (UzivProfily.ZrusVychozi(uzivatel))
            {
                TRadGrid_uziv_ucty.Rebind();
            }
        }

        protected void TRadGrid_uziv_ucty_DataBound(object sender, EventArgs e)
        {
            //JO 6.2.2020 - označení vybraného profilu
            foreach (GridDataItem item in TRadGrid_uziv_ucty.MasterTableView.Items)
            {
                if (item["ID"].Text == RadkovePrava.Profil_id.ToString())
                {
                    //item.BackColor = System.Drawing.ColorTranslator.FromHtml("var(--kscolor1)");
                    item.BackColor = System.Drawing.Color.LightGreen;
                    item.ForeColor = System.Drawing.Color.White;

                }
            }
        }

        protected void rbtJenPrimePodrizene_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                ((RadButton)sender).Checked = Globals.JenPrimiPodrizeni;
        }

        protected void rbtVyjmoutMimoevS_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                ((RadButton)sender).Checked = Globals.VyjmoutMimoevStav;
        }

        protected void rbGenerujSlovnik_Load(object sender, EventArgs e)
        {
            ((RadButton)sender).Visible = (Globals.SuperUser && Globals.PrekladDat);
            if ((!IsPostBack) && ((RadButton)sender).Visible)
                ((RadButton)sender).Checked = Globals.PrekladGenerovaniSlovniku;
        }

        protected void ddlKod_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                string val = ParametryDochazky.GetImplKod();              
                RadComboBox combo = (RadComboBox)sender;
                combo.SelectedValue = val;
                combo.Text = string.Empty;
                if (!string.IsNullOrEmpty(val))
                {
                    CisDchKody cis = new CisDchKody();
                    combo.Text = cis.CelyNazev(val);
                }
            }
        }

        protected void ddlKod_SelectedIndexChanged(object sender, EventArgs e)
        {
            RadComboBox combo = (RadComboBox)sender;           
            ParametryDochazky.SetImplKod(combo.SelectedValue);
        }

        protected void TRB_zmena_foto_CheckedChanged(object sender, EventArgs e)
        {
            pan_zmena_foto.Visible = ((TRadButton)sender).Checked;
        }

        protected void TRB_foto_save_Click(object sender, EventArgs e)
        {
            string sql = string.Empty;

            ParametryPrikazu par = new ParametryPrikazu()
            {
                new KSParameter("os_cislo", DbType.Decimal, Globals.OsCisloAktUser)
            };
            int pocet = SqlPrikaz.ExecuteScalar<int>("select count(*) from fotografie where os_cislo=@os_cislo", 0, ref par);
            if (pocet == 0)
                sql = "insert into fotografie (os_cislo, foto) values(@os_cislo, (select informace from info_blob where os_cislo=@os_cislo and pouziti=105))";
            else
                sql = "update fotografie set foto=(select informace from info_blob where os_cislo=@os_cislo and pouziti=105) where os_cislo=@os_cislo";

            SqlPrikaz.ExecuteNonQuery(sql, true, par);

            _deleteTempFoto();
            _obnovVyberFotky("Thumbnail");
            _obnovVyberFotky("image_zam");
            pan_zmena_foto.Visible = false;
            TRB_zmena_foto.Checked = false;
        }

        protected void rb_cancel_Click(object sender, EventArgs e)
        {
            _deleteTempFoto();
            _obnovVyberFotky("Thumbnail");
            pan_zmena_foto.Visible = false;
            TRB_zmena_foto.Checked = false;
        }

        private void _deleteTempFoto()
        {
            ParametryPrikazu par = new ParametryPrikazu()
            {
                new KSParameter("os_cislo", DbType.Decimal, Globals.OsCisloAktUser)
            };
            SqlPrikaz.ExecuteNonQuery("delete from info_blob where os_cislo=@os_cislo and pouziti=105", false, par);
        }

        protected void telerikUpl_Load(object sender, EventArgs e)
        {
            int max_vel = KSProgram.Parametry.PovinnyParametrCti<int>("FotoZamMaxVelikost");
            ((RadAsyncUpload)sender).MaxFileSize = max_vel * 1048576;
            ((RadAsyncUpload)sender).Localization.Select = WebControlHelper.ZmenaTextu("jpg [%soubor%], [%max.%] " + max_vel + "MB");
        }
    }
}