﻿using KSProgram;
using KSProgram.Obecne;
using KSProgram.Prava;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Obecne
{
    public partial class Uzivatele : TPage
    {
        public Uzivatele()
        {
            IdPrava = -1;
            this.AutomatickyUlozitNastaveni = true;
            this.VerzeStranky = "2";
        }

        protected void RG_Users_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            //PR 10.05.2021 předělal jsem to do validátorů, zobrazovala se ta hláška vpravo dole "Data byla uložena", 
            //přestože byl command zrušen.

            //GridEditableItem editItem = e.Item as GridEditableItem;
            //System.Collections.Hashtable newValues = new System.Collections.Hashtable();
            //e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editItem);

            ////Kontrola síly hesla
            //string passwd = Convert.ToString(newValues["heslo"]);
            //string errorMessage = KSProgram.SpravaUziv.CheckPasswordStrength(passwd);
            //if (errorMessage != null)
            //{
            //    e.Canceled = true;
            //    errorMessage = KSProgram.WebControls.WebControlHelper.ZmenaTextu(errorMessage);
            //    MessageBox.Alert(this, errorMessage);
            //}
        }

        protected void RG_Users_InsertCommand(object sender, GridCommandEventArgs e)
        {
            //GridEditableItem editItem = e.Item as GridEditableItem;
            //System.Collections.Hashtable newValues = new System.Collections.Hashtable();
            //e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editItem);

            ////Kontrola zadání osobního čísla
            //RadComboBox box = editItem.FindControl("TRCB_insert_os_cislo") as RadComboBox;
            //decimal os_cislo;
            //if (string.IsNullOrEmpty(box.SelectedValue))
            //{
            //    //Pokud je ručně zadané osobní číslo, které není v seznamu (např. pro externího uživatele), je potřeba ho překopírovat do hodnoty.
            //    if (decimal.TryParse(box.Text, out os_cislo))
            //    {
            //        box.SelectedValue = box.Text.Trim();
            //    }
            //    else
            //    {
            //        e.Canceled = true;
            //        return;
            //    }
            //}
            //else
            //    os_cislo = decimal.Parse(box.SelectedValue);

            ////Kontrola síly hesla
            //string passwd = Convert.ToString(newValues["heslo"]);
            //string errorMessage = KSProgram.SpravaUziv.CheckPasswordStrength(passwd);
            //if (errorMessage != null)
            //{
            //    e.Canceled = true;
            //    errorMessage = KSProgram.WebControls.WebControlHelper.ZmenaTextu(errorMessage);
            //    MessageBox.Alert(this, errorMessage);
            //}
        }

        protected void CV_dupl_osc_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator validator = (CustomValidator)source;            
            GridEditableItem editItem = validator.NamingContainer as GridEditableItem;
            System.Collections.Hashtable newValues = new System.Collections.Hashtable();
            RG_Users.MasterTableView.ExtractValuesFromItem(newValues, editItem);

            //Kontrola zadání osobního čísla
            RadComboBox box = editItem.FindControl("TRCB_insert_os_cislo") as RadComboBox;
            decimal os_cislo;
            if (string.IsNullOrEmpty(box.SelectedValue))
            {
                //Pokud je ručně zadané osobní číslo, které není v seznamu (např. pro externího uživatele), je potřeba ho překopírovat do hodnoty.
                if (decimal.TryParse(box.Text, out os_cislo))
                {
                    box.SelectedValue = box.Text.Trim();
                }
                else
                {
                    args.IsValid = false;
                    return;
                }
            }
            else
                os_cislo = decimal.Parse(box.SelectedValue);

            //PR 10.05.2021 kontrola, zda jiz osobni cislo nema zaznam v prtl_users
            string login_in_db = PortalUsers.OsCisloToLogin(os_cislo);
            if (!string.IsNullOrEmpty(login_in_db))
            {
                args.IsValid = false;
                validator.ErrorMessage = ReadGlobalResource.ZmenaTextu("Uživatel s osobním číslem {0} má již účet vytvořen!", os_cislo);
            }            
        }

        protected void CV_dupl_login_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator validator = (CustomValidator)source;
            GridEditableItem editItem = validator.NamingContainer as GridEditableItem;

            //PR 10.05.2021 HID=56615 sql duplicate key   
            
            decimal oc = (editItem.ItemIndex == -1) ? 0 : Convert.ToDecimal(editItem.GetDataKeyValue("osCislo"));
            string login = args.Value; //Convert.ToString(newValues["login"]);
            decimal? dupl_oc = PortalUsers.LoginToOsCislo(login);
            if (dupl_oc.HasValue && dupl_oc.Value != oc)
            {
                args.IsValid = false;
                validator.ErrorMessage = ReadGlobalResource.ZmenaTextu("Uživatel s loginem {0} již existuje!", login);
            }
        }

        protected void CV_heslo_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator validator = (CustomValidator)source;

            //Kontrola síly hesla
            string passwd = args.Value;
            string errorMessage = KSProgram.SpravaUziv.CheckPasswordStrength(passwd);
            if (errorMessage != null)
            {
                args.IsValid = false;
                validator.ErrorMessage = ReadGlobalResource.ZmenaTextu(errorMessage);
            }
        }
    }
}