﻿using KSProgram.Prava;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Obecne
{
    public partial class VypisPrav :TPage
    {
        public VypisPrav()
        {
            IdPrava = 311;
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
                dt_picker.SelectedDate = DateTime.Now;
        }

        private DataTable _menu_Role()
        {                   
            DataTable table = new DataTable();
            table.Columns.Add("akce", typeof(string));
            table.Columns.Add("role", typeof(string));
            table.Columns.Add("pristup", typeof(Int16));
            table.Columns.Add("dat_od", typeof(DateTime));
            table.Columns.Add("dat_do", typeof(DateTime));

            if (dt_picker.SelectedDate == null) return table;

            DateTime datum = (DateTime)dt_picker.SelectedDate;

            DataTable role = PravaAkce.GetAllRoles();
            foreach (DataRow row in role.Rows)
            {
                int role_id = Convert.ToInt32(row["role_id"]);
                string role_name = Convert.ToString(row["roleName"]);

                DataTable role_akce = Prtl_role_akce.AkceProRoli(role_id, datum);                
                foreach (DataRow row2 in role_akce.Rows)
                {
                    int stav = Convert.ToInt32(row2["stav"]);
                    if (((rozsah.SelectedValue.ToString() == "pristup") && (stav > 0))||
                       ((rozsah.SelectedValue.ToString() == "nepristup") && (stav == 0))||
                       (rozsah.SelectedValue.ToString() == "all"))

                    {
                        int akce = Convert.ToInt32(row2["akce"]);
                        string popis = Convert.ToString(row2["popis"]);

                        DateTime? dat_od = null;
                        if (row2["dat_od"] != DBNull.Value)
                            dat_od = Convert.ToDateTime(row2["dat_od"]);
                        DateTime? dat_do = null;
                        if (row2["dat_do"] != DBNull.Value)
                            dat_do = Convert.ToDateTime(row2["dat_do"]);

                        DataRow rnew = table.Rows.Add();
                        rnew["akce"] = popis;
                        rnew["role"] = role_name;
                        if (dat_od != null)
                            rnew["dat_od"] = dat_od;
                        rnew["pristup"] = stav;
                        if (dat_do != null)
                            rnew["dat_do"] = dat_do;
                    }             
                }
            }

            return table;        
        }

        private DataTable _role_uzivatel()
        {
            DataTable table = new DataTable();           
            table.Columns.Add("role", typeof(string));
            table.Columns.Add("login", typeof(string));
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("isMember", typeof(bool));
            table.Columns.Add("dat_od", typeof(DateTime));
            table.Columns.Add("dat_do", typeof(DateTime));

            if (dt_picker.SelectedDate == null) return table;

            DateTime datum = (DateTime)dt_picker.SelectedDate;

            DataTable role = PravaAkce.GetAllRoles();
            foreach (DataRow row in role.Rows)
            {
                int role_id = Convert.ToInt32(row["role_id"]);
                string role_name = Convert.ToString(row["roleName"]);
                PortalUsers portal_users = new PortalUsers();
                DataTable dt_users=portal_users.GetAllUsersWithRoleMark(role_id, datum);
                foreach(DataRow r2 in dt_users.Rows)
                {
                    DateTime? dat_od = null;
                    DateTime? dat_do = null;
                    if (r2["dat_od"] != DBNull.Value)
                        dat_od = Convert.ToDateTime(r2["dat_od"]);
                    if (r2["dat_do"] != DBNull.Value)
                        dat_do = Convert.ToDateTime(r2["dat_do"]);


                    string login = Convert.ToString(r2["login"]);
                    decimal os_cislo= Convert.ToDecimal(r2["osCislo"]);
                    string prijmeni = Convert.ToString(r2["prijmeni"]);
                    string jmeno = Convert.ToString(r2["jmeno"]);
                    bool isMember = Convert.ToBoolean(r2["isMember"]);
                                     
                    if (!isMember) continue;                      

                    DataRow rnew = table.Rows.Add();
                    rnew["login"] = login;
                    rnew["role"] = role_name;
                    rnew["os_cislo"] = os_cislo;
                    rnew["prijmeni"] = prijmeni;
                    rnew["jmeno"] = jmeno;
                    if (dat_od != null)
                        rnew["dat_od"] = dat_od;
                    if (dat_do != null)
                        rnew["dat_do"] =dat_do;
                    rnew["isMember"] = r2["isMember"];
                }
            }
            return table;
        }

        protected void menu_role_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (nabidka.SelectedValue.ToString() == "1")
                menu_role.DataSource = _menu_Role();
           
                
        }

        protected void nacist_Click(object sender, EventArgs e)
        {
            if (nabidka.SelectedValue.ToString() == "1")
            {
                role_uzivatel.Visible = false;
                rg_akce_role_uzivatel.Visible = false;
                menu_role.Visible = true;
                menu_role.Rebind();
                menu_role.MasterTableView.Caption = "[%Akce%]-[%Role%]";
            }
            else if (nabidka.SelectedValue.ToString() == "2")
            {
                menu_role.Visible = false;
                rg_akce_role_uzivatel.Visible = false;
                role_uzivatel.Visible = true;
                role_uzivatel.Rebind();
                role_uzivatel.MasterTableView.Caption = "[%Role%]-[%Uživatel%]";
            }
            else if (nabidka.SelectedValue.ToString() == "3")
            {
                menu_role.Visible = false;
                role_uzivatel.Visible = false;
                rg_akce_role_uzivatel.Visible = true;               
                rg_akce_role_uzivatel.Rebind();
                rg_akce_role_uzivatel.MasterTableView.Caption = "[%Akce%]-[%Role%]-[%Uživatel%]";
            }
        }

        protected void role_uzivatel_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (nabidka.SelectedValue.ToString() == "2")
                role_uzivatel.DataSource = _role_uzivatel();          

        }

        protected void nabidka_SelectedIndexChanged(object sender, EventArgs e)
        {
            //RadRadioButtonList list=(RadRadioButtonList)sender;
            //PH 11.4.2018
            RadioButtonList list = (RadioButtonList)sender;
            combo_akce.Visible = (list.SelectedValue == "3");
            if (combo_akce.Visible)
            {
                combo_akce.DataSourceID = "ds_akce";
                combo_akce.DataBind();
                combo_akce.SelectedIndex = 0;
            }
            else
                combo_akce.DataSourceID = "";

            rozsah.Visible = (list.SelectedValue == "1");

            nacist_Click(sender, e);
        }

        protected void rg_akce_role_uzivatel_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (nabidka.SelectedValue.ToString() == "3")
                rg_akce_role_uzivatel.DataSource = _akce_role_uzivatel();
        }

        private DataTable _akce_role_uzivatel()
        {
            DataTable table = new DataTable();
            table.Columns.Add("akce", typeof(int));
            table.Columns.Add("akce_popis", typeof(string));
            table.Columns.Add("role", typeof(string));
            table.Columns.Add("pristup", typeof(int));
            table.Columns.Add("dat_od", typeof(DateTime));
            table.Columns.Add("dat_do", typeof(DateTime));
            table.Columns.Add("uzivatel", typeof(string));
            table.Columns.Add("uziv_dat_od", typeof(DateTime));
            table.Columns.Add("uziv_dat_do", typeof(DateTime));

            if (string.IsNullOrEmpty(combo_akce.SelectedValue)) return table;
            int akce = Convert.ToInt32(combo_akce.SelectedValue);

            if (dt_picker.SelectedDate == null) return table;
            DateTime datum = (DateTime)dt_picker.SelectedDate;

            

            PortalUsers p = new PortalUsers();
            DataTable role = PravaAkce.GetAllRoles();
           
            foreach (DataRow row in role.Rows)
            {
                int role_id = Convert.ToInt32(row["role_id"]);
                string role_name = Convert.ToString(row["roleName"]);

                DataTable role_akce = Prtl_role_akce.AkceProRoli(role_id, datum);

                DataTable user_roles = p.GetAllUsersWithRoleMark(role_id);

                DataTable tb_users=p.GetAllUsers(true);
                foreach (DataRow ra in tb_users.Rows)
                {
                    string ls_login = Convert.ToString(ra["login"]);
                    DataRow rnew = table.Rows.Add();
                    rnew["akce"] = akce;
                    rnew["akce_popis"] = combo_akce.Text;
                    rnew["role"] = role_name;                  
                    
                    DataRow[] rws=role_akce.Select("akce=" + akce);
                    if (rws.Length>0)
                    {
                        DateTime? dat_od = null;
                        DateTime? dat_do = null;
                        if (rws[0]["dat_od"] != DBNull.Value)
                            dat_od = Convert.ToDateTime(rws[0]["dat_od"]);

                        if (rws[0]["dat_do"] != DBNull.Value)
                            dat_do = Convert.ToDateTime(rws[0]["dat_do"]);

                        rnew["dat_od"] = rws[0]["dat_od"];
                        rnew["dat_do"] = rws[0]["dat_do"];

                        int pr = 0;
                        if (((dat_od <= datum) && (dat_do >= datum || dat_do == null)))
                            pr = 1;
                        rnew["pristup"] = pr;
                    }
                   
                    if (Roles.Provider.Name == "KSRoleProvider")
                    {
                        DataRow[] rws2=user_roles.Select("login='"+ls_login+"'");
                        if (rws2.Length>0)
                        {
                            rnew["uzivatel"] = rws2[0]["login"];
                            rnew["uziv_dat_od"] = rws2[0]["dat_od"];
                            rnew["uziv_dat_do"] = rws2[0]["dat_do"];
                        }
                    }
                    else
                    {
                        List<string> lst_roles = Roles.GetRolesForUser(ls_login).ToList();
                        if (lst_roles.Contains(role_name))
                        {
                            rnew["uzivatel"] = ls_login;
                        }
                    }                                     
                }
                    /*
                    DataRow rnew = table.Rows.Add();
                    rnew["akce"] = akce;
                    rnew["role"] = role_name;

                    DataTable role_akce=Prtl_role_akce.AkceProRoli(akce, datum);
                    foreach(DataRow ra in role_akce.Rows)
                    {
                        rnew["dat_od"] = ra["dat_od"];
                        rnew["dat_do"] = ra["dat_do"];
                        rnew["pristup"] = true;
                    }


                    PortalUsers portal_users = new PortalUsers();
                    DataTable dt_users = portal_users.GetAllUsersWithRoleMark(role_id, datum);
                    foreach (DataRow r2 in dt_users.Rows)
                    {

                        rnew["uzivatel"] = r2["login"];
                        rnew["uziv_dat_od"] = r2["dat_od"];
                        rnew["uziv_dat_do"] = r2["dat_do"];
                    }
                    */

                }

            return table;
        }

        protected void combo_akce_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            rg_akce_role_uzivatel.Rebind();
        }

        protected void rozsah_SelectedIndexChanged(object sender, EventArgs e)
        {
            nacist_Click(sender, e);
        }

        protected void rg_akce_role_uzivatel_PreRender(object sender, EventArgs e)
        {
            rg_akce_role_uzivatel.MasterTableView.GetColumn("uziv_dat_od").Visible=(Roles.Provider.Name== "KSRoleProvider");
            rg_akce_role_uzivatel.MasterTableView.GetColumn("uziv_dat_DO").Visible = rg_akce_role_uzivatel.MasterTableView.GetColumn("uziv_dat_od").Visible;
        }

        protected void rg_akce_role_uzivatel_ItemCreated(object sender, GridItemEventArgs e)
        {            
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem item = (GridFilteringItem)e.Item;
                TextBox txtBox1 = (TextBox)item["akce_popis"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 240;

                txtBox1 = (TextBox)item["role"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 200;               

                txtBox1 = (TextBox)item["dat_od"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["dat_do"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["uzivatel"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["uziv_dat_od"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["uziv_dat_do"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;              
            }            
        }

        protected void menu_role_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem item = (GridFilteringItem)e.Item;
                TextBox txtBox1 = (TextBox)item["akce"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 240;

                txtBox1 = (TextBox)item["role"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 200;

                txtBox1 = (TextBox)item["dat_od"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["dat_do"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;               

            }
        }

        protected void role_uzivatel_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem item = (GridFilteringItem)e.Item;
                TextBox txtBox1 = (TextBox)item["login"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 220;

                txtBox1 = (TextBox)item["role"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 240;

                txtBox1 = (TextBox)item["os_cislo"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["prijmeni"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 220;

                txtBox1 = (TextBox)item["jmeno"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 220;

                txtBox1 = (TextBox)item["dat_od"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;

                txtBox1 = (TextBox)item["dat_do"].Controls[0];
                if (txtBox1 != null) txtBox1.Width = 100;
            }
        }

        protected void menu_role_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                HtmlImage img = (HtmlImage)e.Item.FindControl("img");
                string pristup= item["pristup"].Text;

                var pr = DataBinder.Eval(item.DataItem, "pristup");

                if (pr.ToString() == "0")
                    img.Src = "~/ImagesN/AccessRed.png";
                else if (pr.ToString() == "1")
                    img.Src = "~/ImagesN/AccessAllow.png";
                else if (pr.ToString() == "2")
                    img.Src = "~/ImagesN/AccessCond.png";

                img.Alt = pr.ToString();               
            }
        }

        protected void rg_akce_role_uzivatel_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                HtmlImage img = (HtmlImage)e.Item.FindControl("img");
                string pristup = item["pristup"].Text;

                var pr = DataBinder.Eval(item.DataItem, "pristup");

                if (pr.ToString() == "0")
                    img.Src = "~/ImagesN/AccessRed.png";
                else if (pr.ToString() == "1")
                    img.Src = "~/ImagesN/AccessAllow.png";               

                img.Alt = pr.ToString();
            }
        }
    }
}