﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

/// <summary>
/// Summary description for Tisk
/// </summary>
public class TiskParam
{
    public static string sessionPref = "tisk_";
    PopupParam _popup;
    public TiskParam(Page parentPage, string titulek, string url)
    {
        Popup = new PopupParam(parentPage, titulek, url);
       
    }

    public TiskParam(Page parentPage, string titulek)
    {
        Popup = new PopupParam(parentPage, titulek, @"../sestava.aspx");
    }

    public TiskParam(PopupParam pop)
    {
        _popup = pop;
    }

    /*
    public void Print(object obj)
    {
        string sessid = _createSessionId();
        StrTisk tisk = new StrTisk();
        tisk.Param = _popup;
        tisk.WControl = obj;
        tisk.ResetControls = false;
        _popup.ParentPage.Session[sessid] = tisk;
        _popup.ParamRet = sessid;
        _popup.Show();
    }
    */
    public void Print(object obj, bool resetControls)
    {
        string sessid = _createSessionId();
        StrTisk tisk = new StrTisk();
        tisk.Param = _popup;
        tisk.WControl = obj;
        tisk.ResetControls = resetControls;
        _popup.ParentPage.Session[sessid] = tisk;
        _popup.ParamRet = sessid;
        _popup.Show();
    }


    private string _createSessionId()
    {
        return TiskParam.sessionPref + new Guid().ToString();
    }
#region veřejné vlastnosti
    public PopupParam Popup
    {
        get
        {
            return _popup;
        }
        set
        {
            _popup = (PopupParam)value;
        }
    }

#endregion
}

public struct StrTisk
{
    /// <summary>
    /// Object který se má umístit do popup okna jako sestava
    /// </summary>
    public Object WControl;

    /// <summary>
    /// Parametry popup okna 
    /// </summary>
    public PopupParam Param;

    /// <summary>
    /// Pokud nastaven na ano tak před vložením objektu do stránky odstraní všechny předchozí
    /// </summary>
    public bool ResetControls;

}