﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Dynamic.Core;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram.Hodnoceni;
using KSProgram.Data;

namespace KSPortal.Pis
{
    public partial class SchvalDopVzdel : TPage
    {
        //bool? _zamknuto = null;
        public SchvalDopVzdel()
        {
            IdPrava = 281;
            AutomatickyUlozitNastaveni = true;
            VerzeStranky = "13";
        }

        //private bool Zamknuto
        //{
        //    get
        //    {
        //        if (_zamknuto == null)
        //        {
        //            int id_ha;
        //            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
        //            {
        //                bool zam = Hodnoceni.VzdelavaniAkceZamknuto(id_ha, "hz_akce_plan");
        //                _zamknuto = zam;
        //                return (bool)_zamknuto;
        //            }
        //        }
        //        return _zamknuto == null ? false : (bool)_zamknuto;
        //    }
        //}

        private List<int> ids
        {
            get
            {
                if (string.IsNullOrEmpty(HF_ids.Value))
                    return new List<int>() { };
                else
                    return Newtonsoft.Json.JsonConvert.DeserializeObject<List<int>>(HF_ids.Value);
            }
            set
            {
                HF_ids.Value = Newtonsoft.Json.JsonConvert.SerializeObject(value);
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            List<int> selected_ids = new List<int>();
            foreach (GridDataItem item in TRG_Table.MasterTableView.GetSelectedItems())
            {
                selected_ids.Add((int)item.GetDataKeyValue("id"));
            }
            ids = selected_ids;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
        }

        protected void TRCB_ha_DataBound(object sender, EventArgs e)
        {
            if (TRG_Table.DataSource != null)
            {
                DataTable source = (DataTable)TRG_Table.DataSource;
                if (source.TableName == "empty")
                {
                    TRG_Table.DataSource = null;
                    TRG_Table.Rebind();
                }
            }
        }
        protected void TRCB_ha_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRG_Table.Rebind();
        }

        protected void TRG_Table_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                TRG_Table.DataSource = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(id_ha);
            }
            else
            {
                TRG_Table.DataSource = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(null);
            }
        }

        protected void TRG_Table_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            foreach (GridBatchEditingCommand command in e.Commands)
            {
                if (command.Type == GridBatchEditingCommandType.Update)
                {
                    //List<int> selected_ids = new List<int>();
                    //foreach (GridDataItem item in ((RadGrid)sender).MasterTableView.GetSelectedItems())
                    //{
                    //    selected_ids.Add((int)item.GetDataKeyValue("id"));
                    //}

                    int id = GetNullOrData.GetInt32(command.OldValues["id"], 0);
                    //if (!selected_ids.Contains(id))
                    //    selected_ids.Add(id);

                    int idp = GetNullOrData.GetInt32(command.OldValues["idp"], 0);
                    int id_blobu = GetNullOrData.GetInt32(command.OldValues["id_blobu"], 0);
                    decimal? cena = GetNullOrData.GetDecimal(command.OldValues["cena"]);
                    string cil = GetNullOrData.GetString(command.OldValues["cil"], true);
                    DateTime? termin = GetNullOrData.GetDateTime(command.OldValues["termin"]);
                    string poznamka = GetNullOrData.GetString(command.OldValues["poznamka"], true);
                    string zpusob = GetNullOrData.GetString(command.OldValues["zpusob"], true);
                    short? schvaleno = GetNullOrData.GetInt16(command.OldValues["schvaleno"]);

                    decimal? new_cena = (command.NewValues["cena"] is Decimal?) ? (GetNullOrData.GetDecimal(command.NewValues["cena"])) : null;
                    string new_cil = GetNullOrData.GetString(command.NewValues["nazev"], true);
                    short? new_schvaleno = (command.NewValues["schvaleno"] is Int16?) ? (GetNullOrData.GetInt16(command.NewValues["schvaleno"])) : null;

                    if (cena != new_cena)
                    {
                        //foreach (int fid in selected_ids) // hromadný update
                        //{
                            Hodnoceni.Update_Vzdelavani_Cena(id, new_cena);
                        //}
                    }

                    int upd = 0;
                    if (cil != new_cil)
                    {
                        string err = "";
                        upd = Hodnoceni.Update_Vzdelavani(null, new_cil, termin, poznamka, zpusob, id, idp, cil, poznamka, id_blobu, out err);

                        if(!string.IsNullOrEmpty(err))
                        {
                            MessageBox.Alert(this.Page, err, WebControlHelper.ZmenaTextu("[%Chyba při uložení%]"));
                        }
                    }

                    if ((cil != new_cil && upd == 0 && new_schvaleno == 1) || (new_cil == string.Empty))
                    {
                        Hodnoceni.Update_Vzdelavani_Schvaleno(id, null);
                    }
                    else
                    {
                        if (schvaleno != new_schvaleno)
                        {
                            //foreach (int fid in selected_ids) //hromadný update
                            //{
                                Hodnoceni.Update_Vzdelavani_Schvaleno(id, new_schvaleno);
                            //}
                        }
                    }
                }
            }
        }

        protected void TRB_zamceno_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                Hodnoceni.VzdelavaniAkceZamknuto(id_ha, e.SelectedToggleState.Value == "1");

                TRG_Table.Rebind();
            }
        }

        protected void TRB_pozadavky_Click(object sender, EventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                DataTable table = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(id_ha);
                foreach (DataRow r in table.Rows)
                {
                    int? id = GetNullOrData.GetInt32(r["id"]);
                    int? idp = GetNullOrData.GetInt32(r["idp"]);
                    decimal os_cislo = GetNullOrData.GetDecimal(r["os_cislo"], 0);
                    string cil = GetNullOrData.GetString(r["cil"], true);
                    DateTime? termin = GetNullOrData.GetDateTime(r["termin"]);
                    short? schvaleno = GetNullOrData.GetInt16(r["schvaleno"]);
                    string poznamka = GetNullOrData.GetString(r["poznamka"], true);

                    Hodnoceni.SynchroPozadavky((int)id, (int)idp, os_cislo, cil, termin, schvaleno, poznamka);
                }
            }
        }

        protected void TRG_Table_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                Int32 id_ha;
                if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
                {
                    TRadButton TRB_zamknuto = (TRadButton)e.Item.FindControl("TRB_zamceno");
                    bool zamknuto = Hodnoceni.VzdelavaniAkceZamknuto(id_ha, "hz_akce_plan");
                    TRB_zamknuto.Checked = zamknuto;

                    TRadButton TRB_schvalit = (TRadButton)e.Item.FindControl("TRB_schvalit");
                    TRB_schvalit.Enabled = !zamknuto;

                    TRadButton TRB_zamitnout = (TRadButton)e.Item.FindControl("TRB_zamitnout");
                    TRB_zamitnout.Enabled = !zamknuto;

                    TRadButton TRB_vymazat_stav = (TRadButton)e.Item.FindControl("TRB_vymazat_stav");
                    TRB_vymazat_stav.Enabled = !zamknuto;

                    TRadButton TRadButton1 = (TRadButton)e.Item.FindControl("TRadButton1");
                    TRadButton1.Enabled = !zamknuto;
                }
            }
        }

        protected void TRB_schvalit_Click(object sender, EventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                DataTable table = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(id_ha);
                foreach (DataRow r in table.Rows)
                {
                    string cil = GetNullOrData.GetString(r["cil"], true);
                    int? id = GetNullOrData.GetInt32(r["id"]);
                    short? schvaleno = string.IsNullOrEmpty(cil) ? (short?)null : 1;

                    if (ids.Contains((int)id))
                    {
                        Hodnoceni.Update_Vzdelavani_Schvaleno((int)id, schvaleno);
                    }
                }
                ids = new List<int>();
                TRG_Table.Rebind();
            }
        }

        protected void TRB_zamitnout_Click(object sender, EventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                DataTable table = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(id_ha);
                foreach (DataRow r in table.Rows)
                {
                    string cil = GetNullOrData.GetString(r["cil"], true);
                    int? id = GetNullOrData.GetInt32(r["id"]);
                    short? schvaleno = string.IsNullOrEmpty(cil) ? (short?)null : 0;

                    if (ids.Contains((int)id))
                    {
                        Hodnoceni.Update_Vzdelavani_Schvaleno((int)id, schvaleno);
                    }
                }
                ids = new List<int>();
                TRG_Table.Rebind();
            }
        }

        protected void TRB_vymazat_stav_Click(object sender, EventArgs e)
        {
            Int32 id_ha;
            if (TRCB_ha != null && Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
            {
                DataTable table = KSProgram.Hodnoceni.Hodnoceni.SouhrnVzdelavani(id_ha);
                foreach (DataRow r in table.Rows)
                {
                    string cil = GetNullOrData.GetString(r["cil"], true);
                    int? id = GetNullOrData.GetInt32(r["id"]);
                    short? schvaleno = schvaleno = null;

                    if (ids.Contains((int)id))
                    {
                        Hodnoceni.Update_Vzdelavani_Schvaleno((int)id, schvaleno);
                    }
                }
                ids = new List<int>();
                TRG_Table.Rebind();
            }
        }

        protected void TRG_Table_DataBound(object sender, EventArgs e)
        {
            //((GridTemplateColumn)TRG_Table.MasterTableView.GetColumn("osvedceni")).ReadOnly = Zamknuto;
            //((GridTemplateColumn)TRG_Table.MasterTableView.GetColumn("cena")).ReadOnly = Zamknuto;
            //((GridTemplateColumn)TRG_Table.MasterTableView.GetColumn("schvaleno")).ReadOnly = Zamknuto;
        }

        protected void TRG_Table_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        {
            switch (e.Column.UniqueName)
            {
                case "osvedceni": e.Column.GroupByExpression = "nazev Group By nazev"; break;
                case "schvaleno": e.Column.GroupByExpression = "schvaleno Group By schvaleno"; break;
                case "cena": e.Column.GroupByExpression = "cena Group By cena"; break;
            }
        }

        protected void TRG_Table_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            decimal cena = 0;
            DataTable source = (DataTable)((RadGrid)sender).MasterTableView.DataSource;
            string filtr = ((RadGrid)sender).MasterTableView.FilterExpression;
            if (!string.IsNullOrEmpty(filtr))
            {
                //source = source.AsEnumerable().AsQueryable().Where(filtr).CopyToDataTable();

                IQueryable<DataRow> filter = source.AsEnumerable().AsQueryable().Where(filtr);
                if (filter.Count() > 0)
                    source = filter.CopyToDataTable();
                else
                    source.Rows.Clear();

                filtr = "";
            }
            if (e.Item is GridGroupFooterItem)
            {
                GridGroupHeaderItem ITEM = ((Telerik.Web.UI.GridGroupFooterItem)e.Item).GroupHeaderItem;
                DataRowView groupDataRow = (DataRowView)ITEM.DataItem;

                for (int index = 0; index < ITEM.GroupIndex.Split('_').Count(); index++)
                {
                    GridGroupByExpression exp = ((RadGrid)sender).MasterTableView.GroupByExpressions[index];
                    foreach (GridGroupByField field in exp.SelectFields)
                    {
                        filtr += string.IsNullOrEmpty(filtr) ? "" : " AND ";
                        if (groupDataRow[field.FieldName] == DBNull.Value)
                        {
                            filtr += field.FieldName + " IS NULL";
                        }
                        else if (groupDataRow.DataView.Table.Columns[field.FieldName].DataType == typeof(string) ||
                            groupDataRow.DataView.Table.Columns[field.FieldName].DataType == typeof(DateTime))
                        {
                            filtr += field.FieldName + " = '" + groupDataRow[field.FieldName] + "'";
                        }
                        else if (groupDataRow.DataView.Table.Columns[field.FieldName].DataType == typeof(Decimal))
                        {
                            filtr += field.FieldName + " = " + groupDataRow[field.FieldName].ToString().Replace(',', '.');
                        }
                        else
                        {
                            filtr += field.FieldName + " = " + groupDataRow[field.FieldName];
                        }
                    }
                }
                if (!string.IsNullOrEmpty(filtr))
                {
                    DataRow[] fil = source.Select(filtr);
                    if (fil.Count() > 0)
                    {
                        source = fil.CopyToDataTable();
                    }
                }
            }

            if (source.Rows.Count > 0 && source.TableName != "empty")
            {
                object c = source.Compute("Sum(cena)", "schvaleno = 1");
                cena = c == DBNull.Value ? 0 : (decimal)c;
            }
            e.Result = WebControlHelper.ZmenaTextu("[%Schváleno%]: ") + cena.ToString();
        }

        protected void TRG_Table_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if(e.Item is GridDataItem)
            {
                object id = ((GridDataItem)e.Item).GetDataKeyValue("id");
                if (id != null && id != DBNull.Value && ids.Contains((int)id))
                {
                    e.Item.Selected = true;
                }
            }
        }
    }
}