﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Systemizace;
using System.Collections.Generic;
using System.Drawing;
using KSProgram;
using KSProgram.WebControls;


public partial class Pis_SystemSchema : TPopUpPage
{
    int idVychozihoPM = 0;
    int id_stromu = 0;
    int id_pramista = 0;
    DateTime datum = DateTime.Now.Date;
    short level = 0;

    public Pis_SystemSchema()
    {
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        string vychozipm = Request.Params["vychozipm"];
        string pracmist = Request.Params["pracmist"];
        string dat = Request.Params["datum"];
        string str = Request.Params["id_stromu"];
        string lev = Request.Params["level"];
        if ((!string.IsNullOrEmpty(vychozipm)) && (!string.IsNullOrEmpty(pracmist)) && (!string.IsNullOrEmpty(dat)) && (!string.IsNullOrEmpty(str)) && (!string.IsNullOrEmpty(lev)))
        {
            idVychozihoPM = Convert.ToInt32(vychozipm);
            id_pramista = Convert.ToInt32(pracmist);
            datum = new DateTime(Convert.ToInt32(dat.Substring(0, 4)), 
                Convert.ToInt32(dat.Substring(5, 2)),Convert.ToInt32(dat.Substring(8)));
            id_stromu = Convert.ToInt32(str);
            level = Convert.ToInt16(lev);
        }
        ContentHorizontalAlign = HorizontalAlign.Left;
        MultiView1.ActiveViewIndex=0;

        if (!IsPostBack)
        {
            //if (Zakaznik.Prover("KRALOVEHRADECKY_KRAJ"))
            //PH 3.2.2009
            if (Zakaznik.IsCurrent("KRALOVEHRADECKY_KRAJ"))
            {
                TTextBox2.Text = "20";
                TTextBox2.Enabled = false;
            }
            _naplnDropdown(DropDownList1);
            _naplnDropdown(DropDownList2);
            _naplnDropdown(DropDownList3);
            _naplnDropdown(DropDownList4);
            _naplnDropdown(DropDownList5);
            _naplnDropdown(DropDownList6);
        }
    }

    private void _naplnDropdown(DropDownList ddl)
    {
        ddl.Items.Clear();

        ListItem item = new ListItem("[[%Prázdné%]]", "0");
        ddl.Items.Add(item);

        item=new ListItem("[%Systemizované číslo%];[%Středisko%]", "10");
        ddl.Items.Add(item);
        /*
        item=new ListItem("Systemizované číslo;Středisko;Defin. počet podřízených", "11");
        ddl.Items.Add(item);
         * */

        item=new ListItem("[%Číslo a název pracovního místa%]", "20");
        ddl.Items.Add(item);

        item=new ListItem("[%Tarifní třída%]", "40");
        ddl.Items.Add(item);

        item=new ListItem("[%Požadovaný stupeň vzdělání%]", "15");
        ddl.Items.Add(item);

        item = new ListItem("[%Požadavek na ŘP skupiny B%]", "73");
        ddl.Items.Add(item);

        item=new ListItem("[%Požadavek na jazykové znalosti a jejich úroveň%]", "63");
        ddl.Items.Add(item);
        if (Zakaznik.IsCurrent("MOR SLEZ KRAJ"))
        {
            item = new ListItem("[%Požadavek na ZOZ%]", "44");
            ddl.Items.Add(item);

            item = new ListItem("[%Indikační proužek KÚ-MSK%]", "102");
            ddl.Items.Add(item);
        }
        
        item = new ListItem("[%Zaměstnanci bez MES%]", "32");
        ddl.Items.Add(item);

        item = new ListItem("[%Zaměstnanci v MES%]", "33");
        ddl.Items.Add(item);
         

    }
    protected void LinkButton1_Command(object sender, CommandEventArgs e)
    {
        Control bot = this.FindControlRecursive("PanelBottom");
        if (bot != null) bot.Visible = false;

        bot = this.FindControlRecursive("Master_main_panel");
        if (bot != null)
        {
            ((Panel)bot).CssClass = "";
            ((Panel) bot).Style.Add(HtmlTextWriterStyle.Position, "relative");
            ((Panel)bot).Style.Add(HtmlTextWriterStyle.BorderWidth, "0px");
        }
        

        MultiView1.ActiveViewIndex=1;

        StrSystemSchemaParam param=new StrSystemSchemaParam();
        param.Radky = new List<StrSystemSchemaRadek>();
        param.Datum=datum;
        param.IdPracmista=id_pramista;
        param.PracmistUroven = level;

        if (!string.IsNullOrEmpty(TTextBox2.Text))
            param.PrvkuNa2urovni = Convert.ToInt32(TTextBox2.Text.Trim());
        if (param.PrvkuNa2urovni < 4) param.PrvkuNa2urovni=4;
        
        if (!string.IsNullOrEmpty(TTextBoxSirka.Text))
            param.SirkaChlivku = Convert.ToInt32(TTextBoxSirka.Text.Trim());
        if (param.SirkaChlivku < 160) param.SirkaChlivku = 160;

        short poradi = 0;
        _vlozRadekDoParam(DropDownList1, param, ref poradi);
        _vlozRadekDoParam(DropDownList2, param, ref poradi);
        _vlozRadekDoParam(DropDownList3, param, ref poradi);
        _vlozRadekDoParam(DropDownList4, param, ref poradi);
        _vlozRadekDoParam(DropDownList5, param, ref poradi);
        _vlozRadekDoParam(DropDownList6, param, ref poradi);

        for (int i = 5; i >= 0; i--)
        {
            if (param.Radky[i].Cislo == 0) param.Radky.RemoveAt(i); else break;
        }

        param.Nadpis = Server.HtmlEncode(TextBox_nazev.Text);//PH 10.1.2014
        SystemizSchema schema = new SystemizSchema(id_stromu, idVychozihoPM, id_pramista, datum, param);
        WebControl ctrl = (WebControl)this.FindControlRecursive("PanelSchema");
        ctrl.Style.Add(HtmlTextWriterStyle.ZIndex, "8");
        ctrl.Style.Add(HtmlTextWriterStyle.BackgroundColor, "red");
        if (ctrl != null)
        {
            ctrl.Controls.Add(schema);
        }
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        /*PH 29.11.2013 zapoznámkováno
        HtmlTable table = (HtmlTable)Master.FindControl("TableContent");
        table.Style.Add(HtmlTextWriterStyle.Position, "relative");
         * */
    }

    private void _vlozRadekDoParam(DropDownList dddl, StrSystemSchemaParam param, ref short poradi)
    {
        StrSystemSchemaRadek radek = new StrSystemSchemaRadek();
        radek.Cislo = Convert.ToInt16(dddl.SelectedValue);
        radek.Poradi = poradi;
        param.Radky.Add(radek);

        poradi++;
    }
}
