﻿using KSProgram;
using KSProgram.Ciselniky;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using static KSProgram.Pozadavky.Pozadavekodmenysl;

namespace KSPortal.Pozadavky
{

    public partial class OdmenyPoznamka : TPopUpPage
    {
        private int kod
        {
            get {
                return Convert.ToInt32(ViewState["Kod"]);
            }
            set {
                ViewState["Kod"]=value;
            }
        }

        private int IdPozadavku
        {
            get
            {
                return Convert.ToInt32(ViewState["PozId"]);
                //return Convert.ToInt32(SessionInfo.GetVariable(Pozadavekodmenysl.SessionConstanta));
            } 
            set
            {
                ViewState["PozId"] = value;
            }          
        }

        /// <summary>
        /// Typ požadavku
        /// </summary>
        private string typ
        {
            get
            {
                return Convert.ToString(ViewState["typ"]);                
            }
            set
            {
                ViewState["typ"] = value;
            }
        }

        private string co
        {
            get
            {
                return Convert.ToString(ViewState["Co"]);
            }
            set
            {
                ViewState["Co"] = value;
            }
        }

        private bool _use_budgety
        {
            get
            {
                return Convert.ToBoolean(ViewState["_use_budgety"]);
            }
            set
            {
                ViewState["_use_budgety"] = value;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            
            if (Request.QueryString["kod"] != null)
            {
                IdPozadavku = Convert.ToInt32(Request.QueryString["idpozadavku"]);
                typ = Convert.ToString(Request.QueryString["typ"]);
            }
          
            object o_kod=SessionInfo.GetVariable("kod_pro_nacteni_v_odmenyPoznamka");
            object o_co = SessionInfo.GetVariable("co_pro_nacteni_v_odmenyPoznamka");
           

            if (o_kod != null)
                kod = Convert.ToInt32(o_kod);
            if (o_co != null)
                co = Convert.ToString(o_co);

            string co_text = string.Empty;
            if (co == "castka")
                co_text = WebControlHelper.ZmenaTextu("[%částka%]");
            else if (co == "dny")
                co_text = WebControlHelper.ZmenaTextu("[%dny%]");
            else if (co == "hodiny")
                co_text = WebControlHelper.ZmenaTextu("[%hodiny%]");
            else if (co == "sazba")
                co_text = WebControlHelper.ZmenaTextu("[%sazba%]");

            Label1.Text = "[%Požadavky na odměny%]: " + CisMzdPol.CisloNazev((short)kod) + " " + co_text;

            _use_budgety = false;
            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(typ, IdPozadavku);
            if (odmenyslref.BudgetyEnabled())
            {
                prtl_porizovak poriz = new prtl_porizovak(odmenyslref.Prizn());
                if (poriz.Kody(this.IdPozadavku, true).AsEnumerable()?.Where(aa => aa.Field<int>("kod") == this.kod)?.Count() > 0)
                    _use_budgety = true;
            }
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            
            GridBoundColumn col;
            col = (GridBoundColumn)TRGrid.MasterTableView.GetColumn("hodnota");
            col.DataFormatString = KSProgram.TCastka.Format();

            object o_zakaz = SessionInfo.GetVariable("zakaz_editace_pro_nacteni_v_odmenyPoznamka");
            string ze = "";
            if (o_zakaz!=null)
            {
                bool p = Convert.ToBoolean(SessionInfo.GetVariable("zakaz_editace_pro_nacteni_v_odmenyPoznamka"));
                ze = p.ToString().ToLower();
            }

            string budgety_zapni = $"useBudgety={_use_budgety.ToString().ToLower()};";            

            ScriptManager.RegisterStartupScript(this, this.GetType(), "odmeny_pozn_startup", "co='" + co + "';kod=" + kod + ";idPozadavku=" + IdPozadavku + ";zakazEditace=" + ze+";typ='"+typ+"';"+budgety_zapni, true);

            if (!_use_budgety)
            {
                TRGrid.MasterTableView.GetColumn("budget").Visible = false;
                TRGrid.MasterTableView.GetColumn("budget_count").Visible = false;
            }
        }      

        protected void TRGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {            
            Pozadavekodmenysl.IPozadavekodmenysl odmenyslref = (Pozadavekodmenysl.IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(typ, IdPozadavku);
            DataTable table = odmenyslref.RetrieveKodSPoznamkou(kod, co);
            

            object o= SessionInfo.GetVariable("filter_" + IdPozadavku.ToString());
            if (o != null)
                TRGrid.MasterTableView.FilterExpression=o.ToString();

            o = SessionInfo.GetVariable("sort_" + IdPozadavku.ToString());
            if (o != null)
            {               
                GridSortExpression expression = (GridSortExpression)o;                
                TRGrid.MasterTableView.SortExpressions.Add(expression);
            }

            //if (table.Columns.Contains("budget"))
            if (table.Columns.Contains("budget_count"))
            {
                List<string> dk_names = TRGrid.MasterTableView.ClientDataKeyNames.ToList();
                dk_names.AddRange(new string[2] {"budget_count", "budgety_all" });
                TRGrid.MasterTableView.ClientDataKeyNames = dk_names.ToArray();
            }

            TRGrid.DataSource = table;   
        }

        protected void TRGrid_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;
                object o = dataItem.GetDataKeyValue("povolene_sloupce");
                if (o != null)
                {
                    string ret = o.ToString();
                    int index = ("," + ret + ",").IndexOf(kod.ToString() + "_" + co);
                    if (index > -1)
                    {
                        dataItem["hodnota"].CssClass = "oznBorder";
                    }
                }

                foreach (GridColumn col in ((TRadGrid)sender).MasterTableView.Columns)
                {
                    if (col.UniqueName=="budget_count")
                    {
                        int pocet;
                        if (Int32.TryParse(dataItem[col.UniqueName].Text, out pocet))
                        {
                            if (pocet <= 1)
                                dataItem[col.UniqueName].Text = "";
                        }

                    }
                    else if (col.UniqueName=="budget")
                    {
                        dataItem[col.UniqueName].Attributes.Add("id", col.UniqueName + "_" + dataItem.ItemIndex);
                        dataItem[col.UniqueName].Attributes.Add("onclick", "CellClick('" + dataItem.ItemIndex + "','" + col.UniqueName + "');");
                    }
                    /*
                    else if (col.UniqueName == "castka")
                    {
                        string text = dataItem[col.UniqueName].Text;
                        decimal p;
                        if (decimal.TryParse(text, out p))
                            dataItem[col.UniqueName].Text = string.Format("{0:" + Globals.CastkaFormat + "}", p);
                    }
                    */
                }
            }
        }

        protected void TRGrid_PreRender(object sender, EventArgs e)
        {
            /*
            RadNumericTextBox unitsNumericTextBox = (RadGrid1.MasterTableView.GetBatchColumnEditor("UnitsInStock") as GridNumericColumnEditor).NumericTextBox;
            unitsNumericTextBox.Width = Unit.Pixel(60);
            */
            //TextBox unitsNumericTextBox = (TRGrid.MasterTableView.GetBatchColumnEditor("poznamka") as GridTextBoxColumnEditor).TextBoxControl;
            //unitsNumericTextBox.Width = Unit.Pixel(300);
        }


        [WebMethod(EnableSession = true)]
        public static ResultBudgety GetBudgetyRekap(int id_poz)
        {
            return Pozadavekodmenysl.GetZustatkyBudgetu(id_poz);
        }
    }
}