﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram.Obecne;
using System.Drawing;
using KSProgram.WebControlsAlone;
using KSProgram.Funkce;
using KSProgram.Dochazka;
using KSProgram;
using KSProgram.Vzdelavani;
using KSProgram.Prava;
using System.Collections.Specialized;
using KSProgram.Exceptions;
using Telerik.Web.UI;
using System.Web.Services;
using System.Collections.Generic;
using KSProgram.Security;
using System.Linq;
using System.Web.Script.Serialization;
using KSProgram.Data;
using KSPortal.Controls;
using System.Threading;
using KSProgram.Workflow;
using KSProgram.Extensions;
using static KSProgram.Pozadavky.Pozadavekodmenysl;

namespace KSPortal.Pozadavky
{
    public partial class Pozadavky_PozadavekDetail : TPage
    {
        private const int ItemsPerRequest = 10;

        public int _idPozPar
        {
            get
            {
                return string.IsNullOrEmpty(HF_id_poz.Value) ? 0 : Convert.ToInt32(HF_id_poz.Value);
            }
            set
            {
                HF_id_poz.Value = value.ToString();
            }
        }


        //PR 16.3.2017 PozId si nactu v img_OnCommand po UCP.CommandRouter přímo z UCP
        //public void Set_PozId(int idPoz)
        //{
        //    this.PozId = idPoz;
        //}

        /// <summary>
        /// 
        /// </summary>
        public int PozId
        {
            get
            {
                return (ViewState["PozId"] == null ? 0 : Convert.ToInt32(ViewState["PozId"]));
            }
            set
            {
                ViewState["PozId"] = value;
            }
        }

        /// <summary>
        /// Udržuje info o vybraném typu požadavku
        /// </summary>
        public string Typ
        {
            get
            {
                return (ViewState["Typ"] == null ? "" : Convert.ToString(ViewState["Typ"]));
            }
            set
            {
                ViewState["Typ"] = value;
            }
        }

        private bool SablonyEmailNotifPovoleny
        {
            get
            {
                if (ViewState["SablonyEmailNotif"] == null)
                    ViewState["SablonyEmailNotif"] = (Globals.RAActive("SABLONY_NOTIF_EMAILU") && PravaAkce.PristupPovolen(396));
                return Convert.ToBoolean(ViewState["SablonyEmailNotif"]);
            }            
        }

        public Pozadavky_PozadavekDetail()
        {
            this.ContentHorizontalAlign = HorizontalAlign.Left;
            EnableVisibleSeznamZam = true;
            VisibleVyberSeznamuOsobnichCisel = true;
            this.UpdateHlavniOblastOnOsCisloChanged = false;
            this.RebindHlavniOblastOnOsCisloChanged = false;
            UpdateHlavniOblastOnOsCisloChanged = true;
            //ProgressBar = false;
            IdPrava = 80;
            this.HelpURL = "Po%C5%BEadavky_%28KS_port%C3%A1l%29";
            this.EnableKendo = true; //PR 23.11.2021 otevření popup okna s pokyny přes kendo

            this.OsCisloChanged += new OsCisloChangeEventHandler(Zpracovani_OsCisloChanged);
        }

        void Zpracovani_OsCisloChanged(object sender, OsCisloChangedEventArgs e)
        {
            Prilohy.ResetMem();//PH 13.7.2016
            if (Parametry.ParametrCti("PozadavkyZastup") == "1")
                if ((Request.Params["typ"] != null) && (PozId == 0))
                    Response.Redirect(Request.RawUrl);
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection queryString = hh.DecryptRequestQuery();
                if (queryString.Count > 0)
                {
                    string v = queryString["idpoz"];
                    if (v != null)
                    {
                        _idPozPar = Convert.ToInt32(v);
                        string dbname = queryString["dbname"]; //PH 2.11.2015
                        //dbname = HttpUtility.UrlDecode(dbname) <- tohle tu nesmi byt, protoze to uz probehlo nekde v DecryptRequestQuery() a "plus" by se zmenilo na mezeru
                        //PH 2.11.2015 kontroluju jestli není požadavek z jiné databáze
                        //------------------------------------
                        if (!string.IsNullOrEmpty(dbname))
                        {
                            //if (!(Zakaznik.IsCurrent("SKODA PRAHA") && (_idPozPar <= 127))) //PH 19.1.2016 ve škodovce migrovali databázi z informix na mssql
                            //if (dbname != Globals.DBName && string.IsNullOrEmpty(Parametr_cti.Get("portal_url")))//MiKo 3.5.2016 Pokud je portal_url vyplněn je zřejmé, že se vkládají požadavky přes KS-Ole, dbname a Globals.DBName budou vždy různé. Kontrolu tedy vypnu.
                            //if (dbname != Globals.DBName && dbname != "LocalSqlServer") //PR 21.2.2017 pozadavky vygenerovane z TK maji nesmyslny dbname "LocalSqlServer"
                            //PR 24.02.2020 srovnání i se "starým" názvem DB z URL uložené ve workfl_hl při vzniku požadavku (řeší jak přejmenování DB, tak rozdílné pojmenování v TK a Portále)
                            if (dbname != Globals.DBName)
                            {
                                string old_dbname = Pozadavek.getURLQueryFromDB(_idPozPar)["dbname"];
                                if (old_dbname == null) old_dbname = "";
                                if (dbname != old_dbname)
                                {
                                    _idPozPar = 0;
                                    //MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Požadavek, který se pokoušíte zobrazit se nachází v jiné databázi%]") + ": " + dbname + ". " + WebControlHelper.ZmenaTextu("[%Nelze zobrazit%]") + ".");
                                    //PR 10.12.2019 Alert se nezobrazoval
                                    //throw new KSProgram.Exceptions.NoticeException(WebControlHelper.ZmenaTextu("[%Požadavek, který se pokoušíte zobrazit se nachází v jiné databázi%]") + ": " + dbname + ". " + WebControlHelper.ZmenaTextu("[%Nelze zobrazit%]") + ".");
                                    //PH 24.2.2020 znovu alert, nezobrazoval se kvůli chybě v javascriptu
                                    MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Požadavek, který se pokoušíte zobrazit se nachází v jiné databázi%]") + ": " + dbname + ". " + WebControlHelper.ZmenaTextu("[%Nelze zobrazit%]") + ".");
                                    //lb_nacist_visible = true;
                                }
                            }
                        }
                        if (_idPozPar > 0)
                        {
                            Typ = "";                           
                            PozId = _idPozPar;
                        }
                    }
                    //-------------------------------------                    
                }
                else if (!string.IsNullOrEmpty(Request.Params["typ"]))
                {
                    string ls_typ = Request.Params["typ"];
                    if (PozadavkyTypy.TypyProZakaznika(ls_typ))
                    {
                        PozId = 0;
                        Typ = ls_typ;                       
                        //_NovyPozadavek(this, Typ);
                    }
                    else
                        throw new NoticeException("Nepovolený typ požadavku: " + Server.HtmlEncode(ls_typ));
                }
                Prilohy.ResetMem();
                SessionInfo.SetVariable(Pozadavek.AktualniIdPozKey, PozId);
               
            }
            LoadPozadavekControl();

            //PH 9.8.2022 pomůcka pro zobrazení slučovacích polí použitých v notif emailech
            WebControlHelper.FindControl(this, "RB_sluc_pole").Visible = (SablonyEmailNotifPovoleny && PozId > 0);
        }


        UserControlPozadavek c_user = null;
        private UserControlPozadavek LoadPozadavekControl()
        {
            if (!string.IsNullOrEmpty(UserControlPostBack))
            {
                c_user = (UserControlPozadavek)LoadControl(UserControlPostBack);
                c_user.ID = "UserControl";
                c_user.Page = this.Page;
                // c_user.InitLoad(this, new EventArgs());//PH 26.10.2018 inicializace controlky
                ph_pozadavek.Controls.Clear();
                ph_pozadavek.Controls.Add(c_user);
                if (c_user != null)
                {
                    c_user.ItemInserted += new EventHandler(ctrl_ItemInserted);
                    c_user.ItemExit += new EventHandler(ctrl_ItemExit);
                    c_user.ItemRetrieved += new EventHandler(ctrl_ItemRetrieved);
                }
                UC_ZmenaStavu.UCPozadavek = c_user;//PR 20.3.2017 UC ZmenaStavu 

                return c_user;
            }
            return null;

        }


        protected override void Page_PreRender(object sender, EventArgs e)
        {
            //------------------
            if (!IsPostBack)
            {
                if (_idPozPar > 0)
                {
                    PozId = _idPozPar;
                    Typ = "";                  
                    Nacist();
                }
                else if (!string.IsNullOrEmpty(Typ))
                {
                    //PozId = 0; //PR 15.3.2017 dáno do _NovyPozadavek
                    //Nacist();
                    //_NovyPozadavek(this, Typ);
                    Nacist();
                }
            }
            RB_Pokyny.Visible = !string.IsNullOrWhiteSpace(getPokyny());
            //-------------------

            //PR 03.01.2022 Daňovka pro Tieto - Schovat tabulku pro uložení a změnu stavu, musí nejdříve kliknout na tlačítko "Přejít k podpisu"
            if ((Zakaznik.IsCurrent("TIETO") || Globals.RAActive("DANOVKA_2")))
            {
                if (Typ == "danprohl" || Typ == "zroczuct")
                {
                    if (UC_ZmenaStavu.UCPozadavek.WF.Get_UN("", "Form1", "Visible") != "false" && WebControlHelper.FindControl(ph_pozadavek, "RB_k_podpisu") != null)
                    {
                        div_UC_ZmenaStavu.Attributes.CssStyle[HtmlTextWriterStyle.Display] = "none";//UC_ZmenaStavu.Visible = false;
                        PanelCommand.Attributes.CssStyle[HtmlTextWriterStyle.Display] = "none";//PanelCommand.Visible = false;
                    }
                    else
                    {
                        //string formmode = UC_ZmenaStavu.UCPozadavek.WF.Get_UN("", "Form1", "Mode");
                        //string zmstavu = UC_ZmenaStavu.UCPozadavek.WF.Get_UN("", "PanelZmenaStavu", "Visible");
                        //string diskuse = UC_ZmenaStavu.UCPozadavek.WF.Get_UN("", "Diskuse", "Visible");                        
                        //UC_ZmenaStavu.Visible = zmstavu == "true";
                        //PanelCommand.Visible = ((zmstavu == "true") || (formmode == "insert") || (formmode == "edit") || (diskuse == "true"));
                        div_UC_ZmenaStavu.Attributes.CssStyle[HtmlTextWriterStyle.Display] = "block";
                        PanelCommand.Attributes.CssStyle[HtmlTextWriterStyle.Display] = "block";
                    }
                }
            }

            base.Page_PreRender(sender, e);
        }


        void ctrl_ItemRetrieved(object sender, EventArgs e)
        {
            //
        }

        void ctrl_ItemExit(object sender, EventArgs e)
        {
            //
        }

        void ctrl_ItemUpdated(object sender, EventArgs e)
        {
            //
        }

        void ctrl_ItemInserted(object sender, EventArgs e)
        {
            //
        }

        //private void ZobrazForm(string typ, int id)
        //{
        //    Typ = typ;
        //    UserControlPostBack = @"~/Controls/ZadostO" + typ + ".ascx";

        //    UserControlPozadavek c = LoadPozadavekControl();
        //    c.PozId = id;
        //    c.Nacist();
        //    if (c.RequireFullPostBack) //PR 2.12.2013 
        //    {
        //        //PR 6.8.2014 již není potřeba (Rad)ScriptManager.GetCurrent(Page).RegisterPostBackControl(img_save);
        //    }

        //}

        protected void Nacist()
        {
            _panelProcesVisible(false); //PR 24.02.2020 nemusí dojít k načtení, takže na začátku skryji
            UC_ZmenaStavu.Visible = false;//PR 24.02.2020
            PanelCommand.Visible = false;//PR 24.02.2020

            //string ls_typ = "";
            KSProgram.Diagnostics.KSTrace.WriteLine("PozadavekDetail.Nacist(PozId:" + PozId.ToString() + ")");
            KSProgram.Diagnostics.KSTrace.WriteLine("PozadavekDetail.Nacist(_idPozPar:" + _idPozPar.ToString() + ")");

            //PR 15.04.2020 snažím se eliminovat, aby se tytéž data načítali x krát
            //---------------------------------------------------------------------
            WorkflowMaster wf;
            try
            {
                wf = new WorkflowMaster(PozId, Typ, null);
            }
            catch (Exception exc1)
            {
                MessageBox.Alert(this, exc1.Message); //tady vyskočí "V aktuální databázi " + Globals.DBName + " neexistuje požadavek ID " + PozId.ToString()
                return;
            }
            //---------------------------------------------------------------------

            if (PozId > 0)
            {
                //PR 15.04.2020 zakomentovávám (je řešeno vyjímkou v WorkflowMaster výše)
                //workfl_hl whl = new workfl_hl();
                //Str_workfl_hl st = whl.NaplnStrukturu(PozId);
                //Typ = st.typ;
                //
                ////MD 2.6.2015 Může přijít odkaz na neexistující požadavek v aktuální databázi (byl vytvořen pro jinou databázi), viz. HD 28998
                //if (PozId > 0 && st.id_poz == 0)
                //{
                //    //throw new KSProgram.Exceptions.NoticeException("V aktuální databázi " + Globals.DBName + " neexistuje požadavek ID " + PozId.ToString());
                //    //PR 24.02.2020 měním na Alert, protože při přejití z url v mailu, nedochází k předání NoticeException do horní lišty
                //    MessageBox.Alert(this, "V aktuální databázi " + Globals.DBName + " neexistuje požadavek ID " + PozId.ToString());
                //    return;
                //}

                Typ = wf.Typ;//PR 15.04.2020 

                //PH 4.4.2016 ověřuju jestli je na požadavek přístup, nelámu si moc hlavu s parametry, protože pokud je vyplněno PozId tak ostatní parametry nastavuju až ve funkci.
                //-----------------------------------------------
                if (_idPozPar > 0)
                {
                    //if (!(wf.isVydavatel() || wf.isAdresat()))//PR 15.04.2020 podmínka, tj. pokud jsem Vydavatel nebo Adresat, preskocim kontrolu pristupu pres PozadavekSeznam
                    //PR 20.10.2020 oprava: můžu být adresát, ale nemám právo na typ požadavku, přes odkaz z mailu se tedy daly obejít práva na citlivé požadavky (zjistil Martin).
                    if (!(wf.isVydavatel() || (wf.isAdresat() && !PravaAkce.PravaNaCitlivePozadavky)))
                    {
                        PozadavekSeznam sez = new PozadavekSeznam();
                        DataTable table = sez.Retrieve(PozId, "", "", "", new DateTime(), new DateTime(), new DateTime(), new DateTime(), "", "", "");
                        KSProgram.Diagnostics.KSTrace.WriteLine("PozadavekDetail.Nacist(table.RowCount():" + table.Rows.Count.ToString() + ")");
                        /*                   
                        if (sez.Table.Rows.Count < 1)
                            throw new KSProgram.Exceptions.NoticeException("Na požadavek ID " + PozId.ToString() + " nemáte právo přístupu");
                        */
                        //PH 27.3.2018 HID:38928                   
                        if (sez.Table.Rows.Count < 1)
                        {
                            //pokud nenajde přímo požadavek pro zaměstnance tak zkusím hleda pro zástup
                            //najdu všechny povolené zástupy
                            bool found = false;
                            Prtl_zastup zs = new Prtl_zastup();
                            DataTable tb_zastup = zs.RetrieveZapnuteBezJizZastupovanych(Globals.OsCisloAktUser, DateTime.Now);
                            KSProgram.Diagnostics.KSTrace.WriteLine("PozadavekDetail.Nacist(tb_zastup.RowCount():" + tb_zastup.Rows.Count.ToString() + ")");
                            foreach (DataRow r in tb_zastup.Rows)
                            {
                                decimal ldc_os_cislo = Convert.ToDecimal(r["zastupovany"]);
                                table = sez.Retrieve(PozId, "", "", "", new DateTime(), new DateTime(), new DateTime(), new DateTime(), "", "vsebp", "", "", ldc_os_cislo);
                                if (table.Rows.Count > 0)
                                {
                                    HttpContext.Current.Session["os_cislo_zastupovat"] = ldc_os_cislo;
                                    MessageBox.Confirm(this.Page, WebControlHelper.ZmenaTextu("[%ID požadavku%]") + PozId.ToString() + ". " + WebControlHelper.ZmenaTextu("[%Pro řešení je zapotřebí zapnout zástup za zaměstnance%] ") + Pracovnik.OsCisloPrijmeniJmeno(ldc_os_cislo) + ". " + WebControlHelper.ZmenaTextu("[%Přejete si nyní zapnout zástup?%]"), "Info", 500, null, "zapnuti_zas_confirmCallbackFn");
                                    found = true;
                                    break;
                                }

                            }
                            if (!found)
                            {
                                if (Globals.Zastupovany > 0) //PR 10.12.2019
                                {
                                    //throw new KSProgram.Exceptions.NoticeException("Na požadavek ID " + PozId.ToString() + " aktuálně nemáte právo přístupu, zkuste si vypnout zástup");
                                    //PR 24.02.2020 měním na Alert, protože při přejití z url v mailu, nedochází k předání NoticeException do horní lišty
                                    MessageBox.Alert(this, "Na požadavek ID " + PozId.ToString() + " aktuálně nemáte právo přístupu, zkuste si vypnout zástup");
                                    return;
                                }
                                else
                                {
                                    //throw new KSProgram.Exceptions.NoticeException("Na požadavek ID " + PozId.ToString() + " aktuálně nemáte právo přístupu, zkuste si zapnout zástup");
                                    //PR 24.02.2020 měním na Alert, protože při přejití z url v mailu, nedochází k předání NoticeException do horní lišty
                                    MessageBox.Alert(this, "Na požadavek ID " + PozId.ToString() + " aktuálně nemáte právo přístupu, zkuste si zapnout zástup");
                                    return;
                                }
                            }
                        }
                    }
                }
                //-----------------------------------------------

                /*
                //tady řeším přílohy
                //-----------------------------------------------
                pan_prilohy.Visible = true;
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).IdVlastnika = PozId;
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Vlastnik = "workfl_hl";
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).DataBind();
                //-----------------------------------------------
                 PH 11.6.2016 přemístěno do nastavení * */
            }
            //else
            //    ls_typ = Typ;

            //PanelZmenaStavuTlacitka.Visible = true;       
            // TDataListSeznamStavu.Visible = true;
            //PH 15.3.2019
            //TRadGrid_process.Visible = true;
            //panel_process.Visible = true;

            //PH 30.3.2020 HID:50775 U nového požadavku na změnu os. údajů testuju jestli již existuje a není ukončený
            if ((PozId == 0)&&(Typ=="zmosudaju"))
            {
                if (TestExistenceStejnehoTypu(Typ))
                {
                    UC_ZmenaStavu.Visible = false;
                    PanelCommand.Visible = false;
                    TRadGrid_process.Visible = false;
                    rb_diskuse.Visible = false;
                    rb_odmeny_sestava.Visible = false;
                    RPB_kalendar.Visible = false;
                    return;
                }
            }

            SessionInfo.SetVariable(Pozadavek.AktualniIdPozKey, PozId); //PH 21.5.2019         
            _panelProcesVisible(true);
            UC_ZmenaStavu.Visible = true; //PR 24.02.2020 

            //PR 16.3.2017 UC ZmenaStavu PanelZmenaStavu.Visible = false;
            //PR 16.3.2017 UC ZmenaStavu  _nastavPanelAdresatu(false, 0, "", "");

            //PR 16.3.2017 UC ZmenaStavu 
            /*
            //musím vyčistit obsah polí
            //TextBox b = (TextBox)WebControlHelper.FindControl(PanelAdresat, "TextBoxAdresatOsCislo"); KM 18.4.2016
            RadTextBox b = (RadTextBox)WebControlHelper.FindControl(PanelAdresat, "TextBoxAdresatOsCislo");
            if (b != null) b.Text = "";
            //b = (TextBox)WebControlHelper.FindControl(PanelAdresat, "TextBoxAdresatJmeno");
            //if (b != null) b.Text = "";
            //Mik 12.8.2014 //nahrazen textbox za Tcombobox
            TRadComboBox cb = (TRadComboBox)WebControlHelper.FindControl(PanelAdresat, "TRCB_AdresatJmeno");
            if (cb != null)
            {
                cb.Items.Clear();
                cb.Text = "";
            }
            */

            //if (PozId > 0) //PH 2.9.2013 doplněna podmínka
            //{
            //    //ZobrazForm(st.typ, PozId);
            //    ZobrazForm(ls_typ, PozId);

            //    c.Nacist();
            //}

            //UserControlPostBack = @"~/Controls/ZadostO" + Typ + ".ascx";
            //PH 27.9.2022
            UserControlPostBack = @"~/Controls/ZadostO" + PozadavekZpracovaniAbstract.UpravTyp(Typ) + ".ascx";

            UserControlPozadavek c = LoadPozadavekControl();
            if (c != null)
            {
                c.PozId = PozId;
                c.TypSpecific = Typ; //PH 29.9.2022
                c.WF = wf; //PR 17.04.2020 
                if (PozId == 0)
                {
                    c.ChangeMode(FormViewMode.Insert);
                }

                c.Nacist();
            }

            //WorkflowMaster wf = new WorkflowMaster(PozId, Typ, null);

            //_nastavTlacitkaPodleTypu();
            _nastavTlacitkaPodleTypu(wf); //PR 17.04.2020 

            //PR 16.3.2017 UC ZmenaStavu 
            /*
            //panel diskuse
            string diskuse = wf.Get_UN("", "Diskuse", "Visible");
            PanelDiskuse.Visible = (diskuse == "true");
            if (diskuse == "true")
            {
                dsDiskuse.SelectParameters["id_poz"].DefaultValue = PozId.ToString();

                dsDiskuse.UpdateParameters[0].DefaultValue = PozId.ToString();
                dsDiskuse.UpdateParameters[1].DefaultValue = "diskuse";
                DetailsViewDiskuse.DataBind();
            }
            //konec panel diskuse
            
            //PH 11.7.2016 přílohy
            //---------------------------------------------
            //pan_prilohy.Visible = false;
            //if (PozId > 0)
            //{
                string prilohy = wf.Get_UN("", "Přílohy", "Visible");
                pan_prilohy.Visible = (prilohy == "true");
                if (prilohy == "true")
                {
                    pan_prilohy.Visible = true;
                    ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).IdVlastnika = PozId;
                    ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Vlastnik = "workfl_hl";
                    ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).DataBind();
                }
                else
                    pan_prilohy.Visible = false;
            //}
            //konec přílohy----------------

            //zmena stavu
            string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
            if (zmstavu == "true")
            {
                //if ((Zakaznik.IsCurrent("VALEO_GROUP")) && (Typ == "odmeny") && (ZamykaniAgend.Zamceno(Agenda.Portál__Požadavky_na_odměny)))
                //PR 24.6.2015 zrušeno VALEO_GROUP na žádost petra
                //TODO - přesunout kontrolu na zamknutí agendy do ZadostOodmeny.ascx.ZmenaStavu_ServerValidate()
                if ((Typ == "odmeny") && (ZamykaniAgend.Zamceno(Agenda.Portál__Požadavky_na_odměny)))
                {
                    //PH 15.11.2013 pokud je zamčeno a jedná se o odměny pro valeo tak se nedá stav zpřístupňovat
                }
                else
                {
                    dsZmenaStavu.SelectParameters[0].DefaultValue = this.PozId.ToString();
                    //dsZmenaStavu.InsertParameters[0].DefaultValue = this.PozId.ToString(); //PR 2.3.2016 zakomentováno, probíhá vždy přes Update

                    dsStavyEdit.SelectParameters[0].DefaultValue = this.PozId.ToString(); //PR 2.3.2016
                    dsStavyEdit.SelectParameters["typ"].DefaultValue = this.Typ; //PR 2.3.2016 přidán parametr

                    PanelZmenaStavu.Visible = true;
                    DetailsViewZmenaStavu.DataBind();

                    //dsSeznamStavu.InsertParameters["id_poz"].DefaultValue = this.PozId.ToString(); //PR 2.3.2016 zakomentováno, do procesu řešení se neinsertuje přes dsSeznamstavu
                }
            }
            //konec panel zmenaStavu

            //form1
            string formmode = wf.Get_UN("", "Form1", "Mode");
            //if (formmode == "true")//PR 14.3.2017 zakomentovavam nesmysl
            //{
            //    PanelZmenaStavu.Visible = true;
            //    DetailsViewZmenaStavu.DataBind();
            //}

            string form_adresat = wf.Get_UN("", "PanelAdresat", "Mode");
            _nastavPanelAdresatu(true, PozId, Typ, form_adresat);
            */

            //PR 16.3.2017 UC ZmenaStavu 
            UC_ZmenaStavu.Typ = this.Typ;
            UC_ZmenaStavu.PozId = this.PozId;
            UC_ZmenaStavu.UCPozadavek = c_user;
            UC_ZmenaStavu.Nacist();

            string formmode = wf.Get_UN("", "Form1", "Mode");
            string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
            //string diskuse = wf.Get_UN("", "Diskuse", "Visible");PH 4.11.2022 zapoznámkováno proměnná se nepoužívá
            //panel command
            //PanelCommand.Visible = ((zmstavu == "true") || (formmode == "insert") || (formmode == "edit") || (diskuse == "true"));
            //PH 4.11.2022 diskuse se ukládá v samostatném radwindow
            PanelCommand.Visible = ((zmstavu == "true") || (formmode == "insert") || (formmode == "edit"));

            //panel proces řešení
            /*PH 15.3.2019 ZAPOZNÁMKOVÁNOT
            DataListSeznamStavu.Visible = (this.PozId > 0);
            dsSeznamStavu.SelectParameters[0].DefaultValue = this.PozId.ToString();
            dsSeznamStavu.DataBind();
            */
            //TRadGrid_process.Visible = (this.PozId > 0);
            _panelProcesVisible(this.PozId > 0);
            ds_AktFazeAdresat.SelectParameters[0].DefaultValue = this.PozId.ToString();
            DetailsViewAktFazeAdresat.DataBind();//PR 07.05.2019 nepřekreslilo se//ds_AktFazeAdresat.DataBind();
            //PH 15.3.2019 ZAPOZNÁMKOVÁNO TDataListSeznamStavu.DataBind();//PR 16.3.2017 UC ZmenaStavu při schválení v procesu nepřibude stav
            TRadGrid_process.Rebind();

            //PR 07.11.2018 možnost netisknout process řešení
            string ProcessPrint = wf.Get_UN("", "Proces", "Print");
            if (ProcessPrint == "false")
                div_process.Attributes["class"] = "tiskHide";//TDataListSeznamStavu.CssClass = "theme_datalist tiskHide";

            RadScriptManager.RegisterStartupScript(this, typeof(Page), "KSMaster_id_pozadavku", "KSMaster.idPozadavku=" + this.PozId + ";", true);
        }

        private void _panelProcesVisible(bool visible)
        {
            TRadGrid_process.Visible = visible;
            panel_process.Visible = visible;
        }

        /// <summary>
        /// Použije se pro nastavení zobrazení tlačítek podle typu požadavku
        /// </summary>
        private void _nastavTlacitkaPodleTypu(WorkflowMaster wf)
        {
            //rb_odmeny_sestava.Visible = ((Typ == "odmeny") || (Typ == "odmenysl")); //PH 6.11.2018 doplnil jsem odmenysl
            //PH 4.10.2022
            rb_odmeny_sestava.Visible = ((Typ == "odmeny") || (Typ.SafeSubstring(0, 8) == "odmenysl")); //PH 6.11.2018 doplnil jsem odmenysl
            if (rb_odmeny_sestava.Visible)
                rb_odmeny_sestava.Visible = PravaAkce.PristupPovolen(313);

            //WorkflowMaster wf = new WorkflowMaster(PozId, Typ, null);
            string diskuse = wf.Get_UN("", "Diskuse", "Visible");
            rb_diskuse.Visible = (diskuse == "true");
        }

        //PR 16.3.2017 UC ZmenaStavu 
        //private void _nastavPanelAdresatu(bool panel_visible, int poz_id, string typ, string form_adresat)
        //{
        //    //if (form_adresat == "")
        //    if ((form_adresat == "") || (form_adresat == "hidden"))
        //    {
        //        PanelAdresat.Visible = false;
        //        return;
        //    }
        //    else
        //        PanelAdresat.Visible = panel_visible;
        //    TDetailsView dv_adresati = (TDetailsView)WebControlHelper.FindControl(PanelAdresat, "TDetailsViewAdresati");
        //    dv_adresati.Rows[0].Visible = true;
        //    dv_adresati.Rows[2].Visible = true;
        //    dv_adresati.Rows[3].Visible = true;
        //    dv_adresati.Rows[4].Visible = true;

        //    ObjectDataSource ds_adresati = (ObjectDataSource)WebControlHelper.FindControl(PanelAdresat, "ds_adresati");
        //    ds_adresati.SelectParameters[0].DefaultValue = poz_id.ToString();
        //    ds_adresati.SelectParameters[1].DefaultValue = typ.ToString();

        //    ObjectDataSource ds_resitel_adresat = (ObjectDataSource)WebControlHelper.FindControl(PanelAdresat, "ds_resitel_adresat");
        //    ds_resitel_adresat.SelectParameters[0].DefaultValue = poz_id.ToString();
        //    ds_resitel_adresat.SelectParameters[1].DefaultValue = typ.ToString();

        //    PanelAdresat.DataBind();
        //    if (poz_id == 0)
        //    {
        //        dv_adresati.Rows[0].Visible = false;
        //    }
        //    if (form_adresat == "readonly")
        //    {
        //        dv_adresati.Rows[2].Visible = false;
        //        dv_adresati.Rows[3].Visible = false;
        //        dv_adresati.Rows[4].Visible = false;
        //    }
        //}
        //PR 15.3.2017 nikde není použito
        //private bool _povolenoTlacitka(int id)
        //{
        //    bool ret = false;
        //    workfl_hl whl = new workfl_hl();
        //    WorkflowProces poz_proc = new WorkflowProces();
        //    Str_workfl_proc st = poz_proc.GetStav(id);
        //    Str_workfl_hl st_hl = whl.NaplnStrukturu(id);
        //    StrukturaOrganizace str_org = new StrukturaOrganizace();
        //    if (st_hl.typ == "dovol")
        //    {
        //        ret = ((st_hl.os_cislo != Globals.OsCisloAktUser) || KSProgram.Dochazka.Dochazka.SuperUser || str_org.PrimyNadrizenyExists(Globals.OsCisloAktUser, st_hl.id_os) == false) && st.stav != "schvaleny" && st.stav != "zamitnuty";
        //        //PH 25.1.2010 přidal jsem StrukturaOrganizace.PrimyNadrizenyExists
        //    }
        //    else
        //    {
        //        if (st.faze == 1)
        //            ret = true;
        //        else
        //            ret = ((st_hl.os_cislo != Globals.OsCisloAktUser) || KSProgram.Dochazka.Dochazka.SuperUser || str_org.PrimyNadrizenyExists(Globals.OsCisloAktUser, st_hl.id_os) == false) && st.stav != "schvaleny" && st.stav != "zamitnuty";
        //        //PH 25.1.2010 přidal jsem StrukturaOrganizace.PrimyNadrizenyExists()==false
        //    }
        //    return ret;
        //}

        protected void DetailsViewZmenaStavu_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e)
        {
            UC_ZmenaStavu.Visible = false;//PR 16.3.2017 UC ZmenaStavu PanelZmenaStavu.Visible = false;
            ph_pozadavek.DataBind();
            //TDataListSeznamStavu.DataBind();
            //PH 15.3.2019
            TRadGrid_process.Rebind();
            //int id = Convert.ToInt32(dsZmenaStavu.SelectParameters["id_poz"].DefaultValue);
            //_NastavTlacitka(id);PH 11.3.2011 zapoznámkováno, řeší se až při stisku tlačítka
        }

        protected void DetailsViewZmenaStavu_ItemInserting(object sender, DetailsViewInsertEventArgs e)
        {
            UC_ZmenaStavu.Visible = false;//PR 16.3.2017 UC ZmenaStavu PanelZmenaStavu.Visible = false;
        }

        protected void img_OnCommand(object sender, CommandEventArgs e)
        {
            //if (e.CommandName == "Save")
            //{
            //Control c = ph_pozadavek.Controls[0];
            //ObjectDataSource UCP_ODS1 = (ObjectDataSource)WebControlHelper.FindControl(c, "ObjectDataSource1");
            //bool is_valid = false;
            //decimal ldc_adresat = 0;
            //string ls_novy_stav = "", ls_duvod = "";
            //bool lb_stav_zmenen = false;

            //if (PanelAdresat.Visible)
            //{
            //    //TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxAdresatOsCislo"); km 18.4.2016
            //    RadTextBox box = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxAdresatOsCislo");
            //    if (box != null)
            //    {
            //        if (box.Visible)
            //        {
            //            if (!Decimal.TryParse(box.Text, out ldc_adresat))
            //                ldc_adresat = 0;
            //        }
            //    }
            //}

            //if (PanelZmenaStavu.Visible)
            //{
            //    ls_novy_stav = ((DropDownList)WebControlHelper.FindControl(this, "RCM_ZmenaStavu")).Text;
            //    ls_duvod = ((RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod")).Text;
            //}

            //Nastavení adresáta nebo stavu do UserControlPozadavek.ObjectDataSource1
            //if (UCP_ODS1 != null)
            //{
            //    if (ldc_adresat != 0)
            //    {
            //        if (UCP_ODS1.InsertParameters["adresat"] != null)
            //            UCP_ODS1.InsertParameters["adresat"].DefaultValue = ldc_adresat.ToString();

            //        if (UCP_ODS1.UpdateParameters["adresat"] != null)
            //            UCP_ODS1.UpdateParameters["adresat"].DefaultValue = ldc_adresat.ToString();
            //    }

            //    //Panel změna stavu je zviditelněn v 1.kroku kvůli více stavům v 1. kroku (nebo kvůli poli důvod). 
            //    //pokud ObjectDataSource1 obsahuje parametr novy_stav, změnu stavu provádí ObjectDataSource1, jinak jej provádí dsZmenaStavu.
            //    //Pokud je DB transakční, tak je lepší, když nový stav nastaví ObjectDataSource1, tj. insert workfl_hl, workfl_body a workfl_proc 
            //    //proběhne v transakci, v opačném případě požadavek bez workfl_proc úplně zmizí ze seznamu požadavků.
            //    if (PozId == 0 && !string.IsNullOrEmpty(ls_novy_stav))
            //    {
            //        try
            //        {
            //            UCP_ODS1.InsertParameters["novy_stav"].DefaultValue = ls_novy_stav;
            //            UCP_ODS1.InsertParameters["duvod"].DefaultValue = ls_duvod;
            //            lb_stav_zmenen = true; //aby změnu stavu neprovedl datasource dsZmenaStavu
            //        }
            //        catch (Exception) { }
            //    }
            //}          

            ////Insert/Update UserControlPozadavek.ObjectDataSource1
            //((UserControlPozadavek)c).CommandRouter(this, e, ref is_valid);

            //if (is_valid)
            //{
            //    //PR 2.3.2016 nastaveni PozId, aby se pro 1.fazi spravne nastavil stav
            //    if (PozId == 0)
            //    {
            //        PozId = ((UserControlPozadavek)c).PozId;
            //    }

            //pokud je změna stavu a nezměnil jej již ObjectDataSource1 
            //if (PanelZmenaStavu.Visible && lb_stav_zmenen == false && !string.IsNullOrEmpty(ls_novy_stav))
            //{                                             
            //    dsZmenaStavu.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
            //    dsZmenaStavu.UpdateParameters["adresat"].DefaultValue = ldc_adresat.ToString();
            //    DetailsViewZmenaStavu.UpdateItem(true);
            //    lb_stav_zmenen = true;                            
            //}

            //if (lb_stav_zmenen) //Validace
            //{
            //    //PH 30.8.2016 doplněno chybové hlášení
            //    //-----------------------------------------------------
            //    object o = SessionInfo.GetVariable("ValidationError");
            //    if (o != null)
            //    {
            //        MessageBox.Alert(this, Convert.ToString(o), "Nelze pokračovat.");
            //        SessionInfo.RemoveVariable("ValidationError");
            //    }
            //    //-----------------------------------------------------
            //}

            ////if (PanelDiskuse.Visible)
            //RadTextBox tx_diskuse = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDiskuse");
            //if (PanelDiskuse.Visible && tx_diskuse != null && !string.IsNullOrWhiteSpace(tx_diskuse.Text)) //PR 7.3.2017 
            //{
            //    dsDiskuse.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();//PR 25.11.2016 nefungovalo pro 1.krok
            //    DetailsViewDiskuse.UpdateItem(false);
            //}

            ////PH 13.7.2016 ukládám přílohy dosud uložené v paměti
            ////----------------------------------------------------
            //List<StrPrilohy> lst_prilohy=Prilohy.LoadFromMem();
            //if (lst_prilohy !=null)
            //{
            //    foreach (StrPrilohy pr in lst_prilohy)
            //    {
            //        Byte[] data = pr.Data;
            //        Prilohy.Insert(pr.Vlastnik, PozId, pr.Nazev, pr.Nazev_soubor, ref data);
            //    }

            //    Prilohy.ResetMem();
            //}
            ////----------------------------------------------------

            //Nacist();
            //}
            //else //PR 16.6.2015 UserControlPozadavek vrátil is_valid=false, hláška je ale v jiném validatoru uvnitr UserControl, je o stránku výše a není tedy poznat, 
            //{//že se stav neuložil, proto ještě dám hlášku do CustomValidator1:
            //    if (CustomValidator1.IsValid) //jen pokud CustomValidator1 neobsahuje vlastní chybu
            //    {
            //        CustomValidator1.IsValid = false;
            //        CustomValidator1.Text = "[%NEULOŽENO, chybně vyplněné údaje (podrobnosti výše)%]!";
            //    }
            //}
            //}
            //PR 16.3.2017 UC ZmenaStavu (kód přemístěn do kontrolky WfZmenaStavu)
            if (e.CommandName == "Save")
            {
                if (UC_ZmenaStavu.Visible)
                {
                    if (UC_ZmenaStavu.Ulozit())
                    {
                        PozId = c_user.PozId;
                        Nacist();                       
                    }
                    else //PR 16.6.2015 UserControlPozadavek vrátil is_valid=false, hláška je ale v jiném validatoru uvnitr UserControl, je o stránku výše a není tedy poznat, 
                    {//že se stav neuložil, proto ještě dám hlášku do CustomValidator1:
                        if (CustomValidator1.IsValid) //jen pokud CustomValidator1 neobsahuje vlastní chybu
                        {
                            CustomValidator1.IsValid = false;
                            CustomValidator1.Text = "[%NEULOŽENO, chybně vyplněné údaje (podrobnosti výše)%]!";
                        }
                    }
                }

            }
            else if (e.CommandName == "Cancel")
            {
                if (_idPozPar == 0)
                {
                    SkryjEditPanely();
                    // PanelIndex = 1;
                    //RMP_Havni.SelectedIndex = 1;
                    ph_pozadavek.Controls.Clear();
                    UserControlPostBack = "";
                    UC_ZmenaStavu.Visible = false;//PR 16.3.2017 UC ZmenaStavu  
                }
            }
        }
        //PR 16.3.2017 UC ZmenaStavu 
        //protected void DetailsViewZmenaStavu_ItemCommand(object sender, DetailsViewCommandEventArgs e)
        //{
        //    if (e.CommandName == "Cancel")
        //        PanelZmenaStavu.Visible = false;
        //}

        //protected void DetailsViewDiskuse_ItemCommand(object sender, DetailsViewCommandEventArgs e)
        //{
        //    if (e.CommandName == "Cancel")
        //        PanelDiskuse.Visible = false;
        //}
        //protected void DetailsViewDiskuse_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e)
        //{
        //    PanelDiskuse.Visible = false;
        //    TDataListSeznamStavu.DataBind();
        //}

        protected void SkryjEditPanely()
        {
            //PR 16.3.2017 UC ZmenaStavu ---------------
            //_nastavPanelAdresatu(false, 0, "", "");            
            //PanelZmenaStavu.Visible = false;
            //PanelDiskuse.Visible = false;
            UC_ZmenaStavu.Visible = false;
            //------------------------------------------
            PanelCommand.Visible = false;

        }

        protected void LB_NacistSeznam_Command(object sender, CommandEventArgs e)
        {
            //Response.Redirect(Pozadavek.UrlBase() + "/Pozadavky/Pozadavky2.aspx");
            //PH 29.6.2020 HID:51506
            Response.Redirect("~/Pozadavky/Pozadavky2.aspx");
        }


        /// <summary>
        /// cesta k usercontrolu, který se má načíst
        /// </summary>
        protected string UserControlPostBack
        {
            get
            {
                return (ViewState["UserControlPostBack"] != null ? ViewState["UserControlPostBack"].ToString() : "");
            }
            set
            {
                ViewState["UserControlPostBack"] = value;
            }
        }

        /// <summary>
        /// Pouze volá tu samou funkci v UserControlPozadavek
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void UC_ZmenaStavu_ZmenaStavuServerValidate(object sender, ServerValidateEventArgs e)
        {   //PR 14.3.2017 
            if (ph_pozadavek.Controls == null && ph_pozadavek.Controls.Count == 0) return;
            UserControlPozadavek c = (UserControlPozadavek)ph_pozadavek.Controls[0];
            c.ZmenaStavu_ServerValidate((CustomValidator)sender, e);

            ((CustomValidator)sender).Enabled = !e.IsValid;
        }

        //PR 14.3.2017 přesunuto do ZadostOdochazka.ascx.cs-ZmenaStavuServerValidate()
        /*
        protected void cv_dochazka_ServerValidate(object sender, ServerValidateEventArgs e)
        {
            
            //tohle se může provádět jen pro typ docházka
            workfl_hl hl1 = new workfl_hl();
            Str_workfl_hl st = hl1.NaplnStrukturu(PozId);
            if (st.typ != "dochazka")
            {
                e.IsValid = true;
                return;
            }
            if (e.Value == "potvrzeny")
            {
                if (Parametry.ParametrCti("PotvrzFondOK").ToLower().Trim() == "a")
                {
                    decimal prac = 0, svat = 0, prhod = 0, svhod = 0, celkemHod = 0, celkemDny = 0;
                    //int id_poz = Convert.ToInt32(((DetailsView)this.FindControlRecursive("DetailsViewZmenaStavu")).SelectedValue);
                    //PH 15.6.2016 předchozí řádek přestal fungovat, tak zjišťuju id jinak
                    workfl_hl whl = new workfl_hl();
                    workfl_body wbody = new workfl_body();
                    Str_workfl_hl hl = whl.NaplnStrukturu(PozId);
                    Str_workfl_body body = wbody.NaplnStrukturu(PozId);
                    DSFond f = new DSFond();
                    //Prac_pom pr = new Prac_pom();
                    //short cislo_pom = Prac_pom.Platny_Pomer(hl.os_cislo, body.datum);
                    //f.Retrieve(hl.os_cislo, cislo_pom, body.obdobi, ref prac, ref svat, ref prhod, ref svhod, ref celkemHod, ref celkemDny);
                    //PH 15.6.2016
                    short cislo_pom = -1;
                    if (hl.cislo_pom != null)
                        cislo_pom = (short)hl.cislo_pom;
                    else
                        cislo_pom = Prac_pom.Platny_Pomer(hl.os_cislo, body.datum);

                    f.Retrieve(hl.os_cislo, cislo_pom, body.obdobi, ref prac, ref svat, ref prhod, ref svhod, ref celkemHod, ref celkemDny);
                    SesumujMesic ss = new SesumujMesic();

                    decimal ss_hod = 0;
                    decimal ss_dny = 0;
                    ss.Retrieve(hl.os_cislo, body.obdobi, ref ss_hod, ref ss_dny);
                    e.IsValid = (ss_hod == celkemHod);

                    ((CustomValidator)sender).Enabled = !e.IsValid;
                    return;
                }
            }
            e.IsValid = true;
        }*/

        //PR 16.3.2017 UC ZmenaStavu 
        //protected void cv_platne_os_cislo_validate(object sender, ServerValidateEventArgs e)
        //{
        //    if (string.IsNullOrEmpty(e.Value))
        //    {
        //        e.IsValid = true;
        //        return;
        //    }

        //    decimal ldc_os_cislo;
        //    if (!decimal.TryParse(e.Value, out ldc_os_cislo))
        //    {
        //        e.IsValid = false;
        //        return;
        //    }

        //    e.IsValid = Pracovnici.PlatneOsCislo(ldc_os_cislo, DateTime.Now);
        //}



        public override void Set_UN(string controlName, string vlastnost, string hodnota)
        {

        }

        protected void CustomValidator1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //PR 16.3.2017 UC ZmenaStavu tohle vše je ve validatoru prvku UC_ZmenaStavu
            //    bool is_valid = true;

            //    //TextBox tx_duvod = (TextBox)WebControlHelper.FindControl(this, "TextBoxDuvod"); 18.4.2016
            //    //TextBox tx_diskuse = (TextBox)WebControlHelper.FindControl(this, "TextBoxDiskuse"); 18.4.2016
            //    RadTextBox tx_duvod = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
            //    RadTextBox tx_diskuse = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDiskuse");
            //    //DropDownList dd_novy_stav=(DropDownList)WebControlHelper.FindControl(this, "RCM_ZmenaStavu");
            //    //PH 24.2.2014
            //    //RadComboBox dd_novy_stav = (RadComboBox)WebControlHelper.FindControl(this, "RCM_ZmenaStavu");
            //    //PH 25.5.2016
            //    DropDownList dd_novy_stav = (DropDownList)WebControlHelper.FindControl(this, "RCM_ZmenaStavu");

            //    //if ((tx_duvod != null) && (tx_diskuse != null) && (dd_novy_stav != null))
            //    //{
            //    //    if ((dd_novy_stav.Visible) && (tx_duvod.Visible) && (tx_diskuse.Visible))
            //    //        if (string.IsNullOrEmpty(dd_novy_stav.Text) && (string.IsNullOrEmpty(tx_duvod.Text)) && (string.IsNullOrEmpty(tx_diskuse.Text)))
            //    //        {
            //    //            is_valid = false;
            //    //        }
            //    //}
            //    //else if ((tx_duvod != null) && (dd_novy_stav != null))
            //    //{
            //    //    if ((dd_novy_stav.Visible) && (tx_duvod.Visible))
            //    //        if (string.IsNullOrEmpty(dd_novy_stav.Text) && (string.IsNullOrEmpty(tx_duvod.Text)))
            //    //        {
            //    //            is_valid = false;
            //    //        }
            //    //}
            //    //else if (tx_diskuse != null)
            //    //{
            //    //    if (tx_diskuse.Visible == true)
            //    //        if (string.IsNullOrEmpty(tx_diskuse.Text))
            //    //        {
            //    //            is_valid = false;
            //    //        }
            //    //}
            //    //PR 2.3.2016 neměl jsem vyplněn stav a vůbec to nic nezahlásilo (kvuli schovane diskusi), tak jsem to předělal
            //    //Buď musím mít vyplněn stav nebo diskusi (důvod u stavu není povinný)
            //    //PR 8.6.2016 a sakra, pokud nebyl vyplněn stav a byla schovaná diskuse, tak to nezahlásilo
            //    //is_valid = (dd_novy_stav == null || (dd_novy_stav != null && !dd_novy_stav.Visible) || (dd_novy_stav != null && dd_novy_stav.Visible && !string.IsNullOrEmpty(dd_novy_stav.Text)))
            //    //    || (tx_diskuse == null || (tx_diskuse != null && !tx_diskuse.Visible) || (tx_diskuse != null && tx_diskuse.Visible && !string.IsNullOrEmpty(tx_diskuse.Text)));
            //    if ((dd_novy_stav != null && dd_novy_stav.Visible) && (tx_diskuse != null && tx_diskuse.Visible))
            //        is_valid = !string.IsNullOrEmpty(dd_novy_stav.Text) || !string.IsNullOrEmpty(tx_diskuse.Text);
            //    else if (dd_novy_stav != null && dd_novy_stav.Visible)
            //        is_valid = !string.IsNullOrEmpty(dd_novy_stav.Text);
            //    //PR 3.8.2016 pokud je visible jen diskuse, prý nemusí být vyplněna
            //    //else if (tx_diskuse != null && tx_diskuse.Visible)
            //    //    is_valid = !string.IsNullOrEmpty(tx_diskuse.Text);

            //    //else 
            //    //  neni zobrazen ani stav ani diskuse - asi je zmena stavu resena specialne v pozadavku (nebo je chybne nastaveno workflow)

            //    if (!is_valid && ph_pozadavek.Controls.Count > 0) //PR 11.12.2013 služební cesty umožním ukládat i beze změny stavu
            //    {
            //        Control c = ph_pozadavek.Controls[0];
            //        if (c is Controls_ZadostOsluzc ||
            //            c is KSPortal.Controls.ZadostOdobanaproj ||
            //            c is KSPortal.Controls.ZadostOnastupzam ||
            //            c is KSPortal.Controls.ZadostOzmppv ||
            //            c is KSPortal.Controls.ZadostOpremie ||
            //            c is KSPortal.Controls.ZadostOpremiegum)
            //            is_valid = true;
            //    }

            //    if (!is_valid)
            //    {
            //        //((CustomValidator)source).ErrorMessage = "Není co ukládat, žádná položka není vyplněna";
            //        //PH 15.4.2013
            //        //((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Není co ukládat, žádná položka není vyplněna%]");
            //        //PR 2.3.2016
            //        if ((dd_novy_stav != null && dd_novy_stav.Visible && string.IsNullOrEmpty(dd_novy_stav.Text))
            //            && (tx_diskuse != null && tx_diskuse.Visible && string.IsNullOrEmpty(tx_diskuse.Text)))
            //            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav ani diskusní příspěvek%]!");
            //        else
            //            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav%]!");
            //        args.IsValid = false;
            //        return;
            //    }


            //    string stav = "", vychoziAdresat = "";
            //    WorkflowMaster master = new WorkflowMaster(PozId, Typ, null);
            //    //PR 4.3.2014 kontrola zda stav je v seznamu stavu pro aktualni fazi.
            //    if (dd_novy_stav != null && dd_novy_stav.Visible && !string.IsNullOrEmpty(dd_novy_stav.Text))
            //    {
            //        stav = dd_novy_stav.SelectedValue;

            //        bool stavProFazi = false;
            //        foreach (Str_workfl_stavy st in master.StavyAkt.Stavy)
            //        {
            //            if (st.stav == stav)
            //            {
            //                stavProFazi = true;
            //                vychoziAdresat = st.adresat;
            //            }
            //        }
            //        if (!stavProFazi && stav != "diskuse")
            //        {
            //            is_valid = false;
            //            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Neplatný stav pro aktuální fázi%]");
            //        }
            //    }
            //    else if (PozId == 0 && dd_novy_stav != null && dd_novy_stav.Visible == false)
            //    {
            //        if (master.StavyAkt.Stavy != null && master.StavyAkt.Stavy.Count > 0)
            //            vychoziAdresat = master.StavyAkt.Stavy[0].adresat;
            //    }

            //    //PR 14.11.2016 pokud je v nastaveni Adresat=[oc=0], tak uzivatel musi vzdy zadat adresata (pouzito pro typ dokument)
            //    if (PanelAdresat.Visible)
            //    {
            //        RadTextBox tx_adresat = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxAdresatOsCislo");
            //        if (tx_adresat != null && tx_adresat.Visible && string.IsNullOrEmpty(tx_adresat.Text))
            //        {
            //            if (vychoziAdresat == "[oc=0]")
            //            {
            //                is_valid = false;
            //                ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněn adresát%]");
            //            }
            //        }
            //    }

            //    args.IsValid = is_valid;
        }

        //PR 16.3.2017 UC ZmenaStavu //toto je v něm
        //protected void CustomValidator1_ServerValidate(object source, ServerValidateEventArgs args)
        //{   //PR 25.11.2016 přepsal jsem celou funkci, původní je výše

        //    RadTextBox tx_duvod = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
        //    RadTextBox tx_diskuse = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDiskuse");
        //    //PH 25.5.2016
        //    DropDownList dd_novy_stav = (DropDownList)WebControlHelper.FindControl(this, "RCM_ZmenaStavu");

        //    if (PozId == 0) //1.krok
        //    {
        //        //PR 25.11.2016 pokud je v 1. kroku zobrazen stav, tak musí být vyplněn, tj. nestačí jen diskuse (zařvalo by to kvuli Pozid=0).
        //        //také zde nemůže být ignorování nevyplnění stavu dle typu
        //        if (dd_novy_stav != null && dd_novy_stav.Visible && string.IsNullOrEmpty(dd_novy_stav.Text))
        //        {
        //            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav%]!");
        //            args.IsValid = false;
        //            return;
        //        }
        //    }
        //    else
        //    {
        //        bool lb_ignore = false;
        //        if (ph_pozadavek.Controls.Count > 0) //PR 11.12.2013 služební cesty umožním ukládat i beze změny stavu
        //        {
        //            Control c = ph_pozadavek.Controls[0];
        //            if (c is Controls_ZadostOsluzc ||
        //                c is KSPortal.Controls.ZadostOdobanaproj ||
        //                c is KSPortal.Controls.ZadostOnastupzam ||
        //                c is KSPortal.Controls.ZadostOzmppv ||
        //                c is KSPortal.Controls.ZadostOpremie ||
        //                c is KSPortal.Controls.ZadostOpremiegum)
        //                lb_ignore = true;
        //        }
        //        if (!lb_ignore)
        //        {
        //            if ((dd_novy_stav != null && dd_novy_stav.Visible) && (tx_diskuse != null && tx_diskuse.Visible ))
        //            {
        //                if (string.IsNullOrEmpty(dd_novy_stav.Text) && string.IsNullOrEmpty(tx_diskuse.Text))
        //                {
        //                    ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav ani diskusní příspěvek%]!");
        //                    args.IsValid = false;
        //                    return;
        //                }
        //            }
        //            else if (dd_novy_stav != null && dd_novy_stav.Visible)
        //            {
        //                if (string.IsNullOrEmpty(dd_novy_stav.Text))
        //                {
        //                    ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav%]!");
        //                    args.IsValid = false;
        //                    return;
        //                }
        //            }
        //            //else 
        //            //  neni zobrazen ani stav ani diskuse - asi je zmena stavu resena specialne v pozadavku (nebo je chybne nastaveno workflow)
        //        }                
        //    }

        //    string stav = "", vychoziAdresat = "";
        //    WorkflowMaster master = new WorkflowMaster(PozId, Typ, null);
        //    //PR 4.3.2014 kontrola zda stav je v seznamu stavu pro aktualni fazi.
        //    if (dd_novy_stav != null && dd_novy_stav.Visible && !string.IsNullOrEmpty(dd_novy_stav.Text))
        //    {
        //        stav = dd_novy_stav.SelectedValue;

        //        bool stavProFazi = false;
        //        foreach (Str_workfl_stavy st in master.StavyAkt.Stavy)
        //        {
        //            if (st.stav == stav)
        //            {
        //                stavProFazi = true;
        //                vychoziAdresat = st.adresat;
        //            }
        //        }
        //        if (!stavProFazi && stav != "diskuse")
        //        {
        //            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Neplatný stav pro aktuální fázi%]");
        //            args.IsValid = false;
        //            return;
        //        }
        //    }
        //    else if (PozId == 0 && dd_novy_stav != null && dd_novy_stav.Visible==false)
        //    {
        //        if (master.StavyAkt.Stavy != null && master.StavyAkt.Stavy.Count > 0)
        //            vychoziAdresat = master.StavyAkt.Stavy[0].adresat;
        //    }

        //    //PR 14.11.2016 pokud je v nastaveni Adresat=[oc=0], tak uzivatel musi vzdy zadat adresata (pouzito pro typ dokument)
        //    if (PanelAdresat.Visible)
        //    {
        //        RadTextBox tx_adresat = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxAdresatOsCislo");
        //        if (tx_adresat!=null && tx_adresat.Visible && string.IsNullOrEmpty(tx_adresat.Text))
        //        {
        //            if (vychoziAdresat == "[oc=0]") 
        //            {                        
        //                ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněn adresát%]");
        //                args.IsValid = false;
        //                return;
        //            }
        //        }
        //    }
        //}

        //PR 16.3.2017 UC ZmenaStavu 
        //protected void RCM_ZmenaStavu_OnSelectedIndexChanged(object sender, EventArgs e)
        //{
        //    //DropDownList list = (DropDownList)sender;
        //    //PH 24.2.2014
        //    //RadComboBox list = (RadComboBox)sender;
        //    //PH 25.5.2016
        //    DropDownList list = (DropDownList)sender;
        //    //TextBox tx_duvod = (TextBox)WebControlHelper.FindControl(this, "TextBoxDuvod"); KM 18.4.2016
        //    RadTextBox tx_duvod = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
        //    tx_duvod.Enabled = (!string.IsNullOrEmpty(list.Text));
        //    if (tx_duvod.Enabled == false)
        //    {
        //        tx_duvod.Text = "";
        //    }
        //}

        //PR 16.3.2017 toto je pozustatek z Pozadavky2.aspx 
        //protected void LinkButtonText_Command(object sender, CommandEventArgs e)
        //{
        //    //Label l = (Label)this.FindControlRecursive("lab_id2", ((LinkButton)sender).Parent.Controls);
        //    //PozId = Convert.ToInt32(l.Text);
        //    PozId = Convert.ToInt32(e.CommandArgument);
        //    Typ = "";
        //    Nacist();
        //}

        //PR 16.3.2017 UC ZmenaStavu 
        //protected void TRCB_AdresatJmeno_TextChanged(object sender, EventArgs e)
        //{
        //    TRadComboBox box = (TRadComboBox)sender;
        //    //TextBox text_osc = (TextBox)WebControlHelper.FindControl(PanelAdresat, "TextBoxAdresatOsCislo");  KM 18.4.2016
        //    RadTextBox text_osc = (RadTextBox)WebControlHelper.FindControl(PanelAdresat, "TextBoxAdresatOsCislo");
        //    if (box.Text == "")
        //        text_osc.Text = "";
        //    else
        //    {
        //        string[] arr = box.Text.Split(new char[1] { ',' });
        //        if (arr.Length == 2)
        //        {
        //            decimal os_cislo = Pracovnici.NajdiOsCislo(arr[0], arr[1]);
        //            if (os_cislo > 0)
        //            {
        //                text_osc.Text = os_cislo.ToString();
        //            }
        //        }
        //    }
        //}
        //protected void TextBoxAdresatOsCislo_TextChanged(object sender, EventArgs e)
        //{
        //    // TextBox box = (TextBox)sender; km 18.4.2016
        //    RadTextBox box = (RadTextBox)sender;
        //    decimal os_cislo = 0;
        //    if (!Decimal.TryParse(box.Text, out os_cislo)) return;

        //    TRadComboBox c = (TRadComboBox)WebControlHelper.FindControl(this, "TRCB_AdresatJmeno");
        //    if (c != null)
        //    {
        //        c.Text = Pracovnik.PrijmeniJmeno(os_cislo, ",");
        //    }
        //}

        protected void RCM_new_typy_ItemClick(object sender, RadMenuEventArgs e)
        {
            string selValue = e.Item.Value;
            if (string.IsNullOrEmpty(selValue))
                return;
            Prilohy.ResetMem();//PH 13.7.2016
            Response.Redirect(Pozadavek.BuildURLPozadavkuTypDetail(selValue));
        }

        //PR 15.3.2017 přejmenovávám _form_zobrazit na _NovyPozadavek
        //private void _NovyPozadavek(object sender, string typ)
        //{             
        //    ph_pozadavek.Controls.Clear();
        //    UserControlPostBack = "";           
        //    TDataListSeznamStavu.Visible = false;

        //    UserControlPozadavek ctrl = null;
        //    Typ = typ;
        //    PozId = 0; //PR 15.3.2017 
        //    UserControlPostBack = @"~/Controls/ZadostO" + Typ + ".ascx";

        //    ctrl = LoadPozadavekControl();

        //    if (ctrl != null)
        //    {
        //        ctrl.ChangeMode(FormViewMode.Insert);
        //        if (ctrl != null)
        //            ctrl.PozId = 0;
        //        ctrl.Nacist();
        //    }

        //    Nacist();//PH 2.9.2013

        //    PanelCommand.Visible = true;
        //}

        //protected void combo_ke_schvaleni_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        //{

        //}

        private static DataTable _getData(string kex)
        {
            DataTable table = new DataTable();
            table.Columns.Add("id_poz", typeof(int));
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("cislo_pom", typeof(Int16));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("typ", typeof(string));
            table.Columns.Add("dat_od", typeof(DateTime));
            table.Columns.Add("dat_do", typeof(DateTime));
            table.Columns.Add("typp", typeof(string));
            table.Columns.Add("text", typeof(string));

            PozadavekSeznam seznam = new PozadavekSeznam();
            DataTable tab = seznam.Retrieve(0, "", "", "all", DateTime.MinValue, DateTime.MaxValue, DateTime.MinValue, DateTime.MaxValue, "", "all", "");
            for (int i = 0; i < tab.Rows.Count; i++)
            {
                //asi pořeším práva
                DataRow row = table.Rows.Add();
                foreach (DataColumn col in table.Columns)
                {
                    row[col.ColumnName] = tab.Rows[i][col.ColumnName];
                }
            }

            return table;
        }
        private static string GetStatusMessage(int offset, int total)
        {
            if (total <= 0)
                return "Žádná shoda";

            return String.Format("Položka <strong>1</strong>-<strong>{0}</strong> z <strong>{1}</strong>", offset, total);
        }

        [WebMethod]
        public static RadComboBoxData GetPozadavky(RadComboBoxContext context)
        {
            RadComboBoxData comboData = new RadComboBoxData();

            DataTable data = _getData(context.Text);


            int itemOffset = context.NumberOfItems;
            int endOffset = Math.Min(itemOffset + ItemsPerRequest, data.Rows.Count);
            comboData.EndOfItems = endOffset == data.Rows.Count;

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(endOffset - itemOffset);

            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();

                itemData.Text = Convert.ToString(data.Rows[i]["id_poz"]);
                itemData.Value = data.Rows[i]["id_poz"].ToString();
                itemData.Attributes.Add("Zemestnanec", data.Rows[i]["prijmeni"].ToString() + "-" + data.Rows[i]["jmeno"].ToString());
                //itemData.Attributes.Add("ImageUrl", Pozadavek.UrlBase() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                //PH 29.6.2020 HID:51506
                itemData.Attributes.Add("ImageUrl", Pozadavek.UrlBaseInterni() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                result.Add(itemData);

            }

            comboData.Message = GetStatusMessage(endOffset, data.Rows.Count);

            comboData.Items = result.ToArray();

            return comboData;
        }



        protected void RPB_kalendar_Command(object sender, CommandEventArgs e)
        {
            if (e.CommandName == "open")
            {
                // zjistím všechny osobní čísla která jsou ve stejné organizační jednotce jako žadatel požadavku nebo osobní číslo požadavku
                string sql;
                if (PozId == 0)
                {
                    decimal oscislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                    switch (Parametry.ParametrCti("PozadKalendarOmezit"))
                    {
                        case "prac_mist":
                            sql = "SELECT DISTINCT(p.os_cislo) FROM prac_pom p" +
                                " INNER JOIN prac_pom pp ON ( pp.id_pracmist = p.id_pracmist" +
                                " AND pp.os_cislo = " + SqlPrikaz.ValueToString(oscislo) +
                                " AND pp.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) +
                                " AND ( pp.datum_ukonc >=" + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR pp.datum_ukonc IS NULL ) )" +
                                " WHERE p.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) +
                                " AND ( p.datum_ukonc >= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR p.datum_ukonc IS NULL )";
                            break;
                        case "prac_str":
                            sql = "SELECT DISTINCT(p.os_cislo) FROM prac_pom p" +
                                " INNER JOIN prac_pom pp ON ( pp.prac_str = p.prac_str" +
                                " AND pp.os_cislo = " + SqlPrikaz.ValueToString(oscislo) +
                                " AND pp.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) +
                                " AND ( pp.datum_ukonc >=" + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR pp.datum_ukonc IS NULL ) )" +
                                " WHERE p.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) +
                                " AND ( p.datum_ukonc >= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR p.datum_ukonc IS NULL )";
                            break;
                        case "kmen_str":
                            sql = "SELECT DISTINCT(z.os_cislo) FROM pracovnici z" +
                                " INNER JOIN pracovnici p ON ( p.kmen_str = z.kmen_str" +
                                " AND p.os_cislo = " + SqlPrikaz.ValueToString(oscislo) +
                                " AND ( p.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR p.datum_nastupu IS NULL )" +
                                " AND ( p.datum_vystupu >= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR p.datum_vystupu IS NULL ) )" +
                                " WHERE ( z.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR z.datum_nastupu IS NULL )" +
                                " AND ( z.datum_vystupu >= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " OR z.datum_vystupu IS NULL )";
                            break;
                        case "skup_str":
                        case "divize":
                        default: sql = ""; break;
                    }
                }
                else
                {
                    DateTime obdobi = SqlPrikaz.ExecuteScalarDateTime("SELECT b.obdobi" +
                        " FROM workfl_body b" +
                        " WHERE b.id_poz = " + SqlPrikaz.ValueToString(PozId) +
                        " AND b.verze = ( SELECT MAX(bb.verze) FROM workfl_body bb WHERE bb.id_poz = b.id_poz )", DateTime.Now.Date);
                    switch (Parametry.ParametrCti("PozadKalendarOmezit"))
                    {
                        case "prac_mist":
                            sql = "SELECT DISTINCT(p.os_cislo) FROM prac_pom p" +
                                " INNER JOIN prac_pom pp ON ( pp.id_pracmist = p.id_pracmist" +
                                " AND pp.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) +
                                " AND ( pp.datum_ukonc >=" + SqlPrikaz.ValueToString(obdobi) + " OR pp.datum_ukonc IS NULL ) )" +
                                " INNER JOIN workfl_hl h ON ( h.os_cislo = pp.os_cislo AND h.id_poz = " + SqlPrikaz.ValueToString(PozId) + " )" +
                                " WHERE p.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) +
                                " AND ( p.datum_ukonc >= " + SqlPrikaz.ValueToString(obdobi) + " OR p.datum_ukonc IS NULL )";
                            break;
                        case "prac_str":
                            sql = "SELECT DISTINCT(p.os_cislo) FROM prac_pom p" +
                                " INNER JOIN prac_pom pp ON ( pp.prac_str = p.prac_str" +
                                " AND pp.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) +
                                " AND ( pp.datum_ukonc >=" + SqlPrikaz.ValueToString(obdobi) + " OR pp.datum_ukonc IS NULL ) )" +
                                " INNER JOIN workfl_hl h ON ( h.os_cislo = pp.os_cislo AND h.id_poz = " + SqlPrikaz.ValueToString(PozId) + " )" +
                                " WHERE p.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) +
                                " AND ( p.datum_ukonc >= " + SqlPrikaz.ValueToString(obdobi) + " OR p.datum_ukonc IS NULL )";
                            break;
                        case "kmen_str":
                            sql = "SELECT DISTINCT(z.os_cislo) FROM pracovnici z" +
                                " INNER JOIN pracovnici p ON ( p.kmen_str = z.kmen_str" +
                                " AND ( p.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) + " OR p.datum_nastupu IS NULL )" +
                                " AND ( p.datum_vystupu >= " + SqlPrikaz.ValueToString(obdobi) + " OR p.datum_vystupu IS NULL ) )" +
                                " INNER JOIN workfl_hl h ON ( h.os_cislo = p.os_cislo AND h.id_poz = " + SqlPrikaz.ValueToString(PozId) + " )" +
                                " WHERE ( z.datum_nastupu <= " + SqlPrikaz.ValueToString(obdobi) + " OR z.datum_nastupu IS NULL )" +
                                " AND ( z.datum_vystupu >= " + SqlPrikaz.ValueToString(obdobi) + " OR z.datum_vystupu IS NULL )";
                            break;
                        case "skup_str":
                        case "divize":
                        default: sql = ""; break;
                    }
                }

                if (!string.IsNullOrEmpty(sql))
                {
                    List<decimal> oscisla = SqlPrikaz.ExecuteScalarList<decimal>(sql, 0);

                    if (oscisla.Count > 0)
                    {
                        Globals.ListOsCisloPomer list = new Globals.ListOsCisloPomer() { };
                        foreach (decimal oc in oscisla)
                        {
                            list.Add(new Globals.OsCislo_Pomer(oc));
                        }
                        Globals.OsCisloPomerSeznam.CopyFrom(list);
                        this.reloadSZOnClientLoad = true; // po postbacku se přenačte plovoucí seznam zaměstnanců
                    }
                }

                div_Kalendar.CssClass = "";

                //KSPortal.Controls.KalendarControl kalendar = (KSPortal.Controls.KalendarControl)LoadControl("../Controls/KalendarControl.ascx");
                //kalendar.ID = "UCKC_Kalendar";
                //kalendar.Page = this.Page;
                //kalendar.SelectedPanIndex = 1;
                //PH_Kalendar.Controls.Add(kalendar);
            }

            if (e.CommandName == "close")
            {
                //PH_Kalendar.Controls.Clear();
                div_Kalendar.CssClass = "ks-hideall";
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="arg"></param>
        [WebMethod]
        public static void CompleteTask(object arg)
        {
            if (Convert.ToBoolean(arg))
            {
                if (HttpContext.Current.Session["os_cislo_zastupovat"] != null)
                {
                    decimal os_cislo = Convert.ToDecimal(HttpContext.Current.Session["os_cislo_zastupovat"]);
                    HttpContext.Current.Session["os_cislo_zastupovat"] = null;
                    int? role_id;
                    //zjistím jestli nemá náhodou zapnutý nějaký zástup a pokud ano tak jej ukončím
                    //---------------------------------------------
                    Prtl_zastup zs = new Prtl_zastup();
                    DataTable tb = zs.RetrieveZapnute(Globals.OsCisloAktUser, DateTime.Now, false);
                    if (tb.Rows.Count > 0)
                        Prtl_zastup.UkoncitZapnutiProZastupce(Globals.OsCisloAktUser);
                    //---------------------------------------------
                    if (!Prtl_zastup.InsertZapnuti(os_cislo, out role_id))
                    {
                        SessionInfo.RemoveVariable("os_cislo_zastupovat");
                        //MessageBox.Alert(Page, "Zapnutí zástupu se nepovedlo.");
                        return;
                    }

                    Globals.Zastupovany = os_cislo;
                    Globals.CreateRadPrava(os_cislo);

                    //obnovím práva podle role pro zástup
                    //-------------------------------------                   
                    if (role_id != null)
                    {
                        //Session["PravaAkce"] = PravaAkce.AkceProRole(new int[1] { (int)role_id });
                        SessionInfo.SetVariable("PravaAkce", PravaAkce.AkceProRole(new int[1] { (int)role_id }));
                    }
                    //------------------------------------
                }
            }
            HttpContext.Current.Session["os_cislo_zastupovat"] = null;
        }

        protected void TRadGrid_process_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DataTable table = KSProgram.Pozadavky.WorkflowProces.Retrieve(this.PozId);
            TRadGrid_process.DataSource = table;
        }
        protected virtual bool TestExistenceStejnehoTypu(string typ)
        {
            string sql = "select H.id_poz from workfl_hl H where H.typ=@typ and H.os_cislo=@os_cislo and H.id_poz in " +
                "(" +
                    "select id_poz from workfl_proc where id_poz = H.id_poz " +
                    " and (sys_stav='n' OR sys_stav='r') and (archiv<>'a' OR archiv IS NULL)  " +
                 ")";
            ParametryPrikazu par = new ParametryPrikazu();
            par.Add(new KSParameter("typ", DbType.String, typ));
            par.Add(new KSParameter("os_cislo", DbType.Decimal, PozadavekZpracovaniAbstract.VydavatelProNovyPoz()));
            List<Int32> lst = new List<int>();
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql, ref par))
            {
                while (reader.Read())
                {
                    lst.Add(GetNullOrData.GetInt32(reader, 0, 0));
                }
            }
            if (lst.Count > 0)
            {
                WebControlHelperProxy.Alert(WebControlHelper.ZmenaTextu("[%Nelze založit požadavek dokud máte neuzavřeny požadavky stejného typu s následujícími id požadavku%]")+": "+string.Join(",", lst.ToArray()), "Oznámení");
            }
            return (lst.Count > 0);
        }

        /// <summary>
        /// Uložení diskuse
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static string SaveDiskusi(string data)
        {
            string ret = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            if (jsonObject[0]["co"] == "diskuse")
            {
                string text = Convert.ToString(jsonObject[1]["text"]);
                if (string.IsNullOrEmpty(text)) return "N";
                string str_adr = Convert.ToString(jsonObject[2]["adresat"]);
                //object o = SessionInfo.GetVariable(Pozadavek.AktualniIdPozKey); 
                //PH 19.6.2019  
                object o = jsonObject[3]["PozId"];
                if (o != null)
                {
                    int id_poz = Convert.ToInt32(o);
                    decimal adresat = 0;
                    decimal adr_pom;
                    if (decimal.TryParse(str_adr, out adr_pom))
                        adresat = adr_pom;

                    WorkflowProces.KrokProcesuDiskuseTrans(text, id_poz, adresat, string.Empty);
                }
                return ret;
            }
            else if (jsonObject[0]["co"] == "adresat")
            {
                string prijmeni = Convert.ToString(jsonObject[1]["prijmeni"]);
                string jmeno = Convert.ToString(jsonObject[2]["jmeno"]);

                return Convert.ToString(Pracovnici.NajdiOsCislo(prijmeni, jmeno));
            }
            else if (jsonObject[0]["co"] == "os_cislo")
            {
                decimal os_cislo;
                if (!decimal.TryParse(jsonObject[1]["os_cislo"], out os_cislo))
                    return "";

                string jm_prij = Pracovnik.PrijmeniJmeno(os_cislo, ",");
                return jm_prij;
            }
            else if (jsonObject[0]["co"] == "os_cislo_exists")
            {
                decimal os_cislo;
                if (!decimal.TryParse(jsonObject[1]["os_cislo"], out os_cislo))
                    return "true";

                os_cislo = Convert.ToDecimal(jsonObject[1]["os_cislo"]);
                string jm_prij = Pracovnik.PrijmeniJmeno(os_cislo, ",");
                return (jm_prij.Length > 1).ToString().ToLower();
            }
            return "";
        }

        [WebMethod]
        public static ResultData GetData(int startIndex, int maximumRows, string sortExpressions, string filterExpressions)
        {
            int idpozadavku = Convert.ToInt32(filterExpressions);
            ResultData data = new ResultData();
            //object o = SessionInfo.GetVariable(Pozadavek.AktualniIdPozKey);
            DataTable table = new DataTable();
            int rcount = 0;
            List<object> lst = new List<object>();
            //if (o != null)
            {

                //table = KSProgram.Pozadavky.WorkflowProces.Retrieve(Convert.ToInt32(o));
                table = KSProgram.Pozadavky.WorkflowProces.Retrieve(idpozadavku);
                rcount = table.Rows.Count;
                for (int i = 0; i < table.Rows.Count; i++)
                {
                    var v = new
                    {
                        poradi = table.Rows[i]["poradi"],
                        faze_text = table.Rows[i]["faze_text"],
                        faze = (table.Rows[i]["stav"].ToString().Trim() != "diskuse" ? table.Rows[i]["faze"] : null),
                        stav = table.Rows[i]["stav"],
                        duvod = table.Rows[i]["duvod"],
                        datum = table.Rows[i]["datum"],
                        uziv_a_zastup = table.Rows[i]["uziv_a_zastup"]
                    };
                    lst.Add(v);
                }
            }
            data.Data = lst;
            data.Count = rcount; ;

            return data;
        }
        /// <summary>
        /// Funkce volaná z kontrolky ZmppvInnerForm.ascx ve workflow zmppv a novyzam
        /// </summary>
        /// <param name="typ_tt"></param>
        /// <param name="typ_mzdy"></param>
        /// <param name="typ_mzdy_old"></param>
        /// <param name="trida"></param>
        /// <param name="trida_old"></param>
        /// <param name="mzd_stup"></param>
        /// <param name="mzd_stup_old"></param>
        /// <returns></returns>
        [WebMethod]
        public static object GetTarif(short? typ_tt, short? typ_mzdy, short? typ_mzdy_old, short? trida, short? trida_old, short? mzd_stup, short? mzd_stup_old, bool updateTarif)
        {
            typ_mzdy = typ_mzdy ?? typ_mzdy_old;
            trida = trida ?? trida_old;
            mzd_stup = mzd_stup ?? mzd_stup_old;

            if (typ_tt == null)
                return new
                {
                    MinTarif = (decimal?)null,
                    Tarif = (decimal?)null,
                    MaxTarif = (decimal?)null,
                    UpdateTarif = updateTarif
                };

            ParametryPrikazu pars = new ParametryPrikazu()
            {
                new KSParameter("typ_tt", DbType.Int16, typ_tt),
                new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy),
                new KSParameter("trida", DbType.Int16, trida),
                new KSParameter("mzd_stup", DbType.Int16, mzd_stup)
            };

            var data = SqlPrikaz.ExecuteCommand(
                "SELECT zakl_tarif, max_tarif " +
                "FROM tarify " +
                "WHERE typ_tt = @typ_tt " +
                "AND (typ_mzdy = @typ_mzdy OR @typ_mzdy IS NULL) " +
                "AND (trida = @trida OR @trida IS NULL) " +
                "AND (mzd_stup = @mzd_stup OR @mzd_stup IS NULL) " +
                "ORDER BY mzd_stup", ref pars).AsEnumerable();

            var ret = new
            {
                MinTarif = (typ_mzdy == 0 || typ_mzdy == 1) ? data.Min(x => GetNullOrData.GetDecimal(x["zakl_tarif"])) : null,
                Tarif = data.Max(x => GetNullOrData.GetDecimal(x["zakl_tarif"])),
                MaxTarif = (typ_mzdy == 0 || typ_mzdy == 1) ? (data.Max(x => GetNullOrData.GetDecimal(x["max_tarif"])) ?? data.Max(x => GetNullOrData.GetDecimal(x["zakl_tarif"]))) : null,
                UpdateTarif = updateTarif
            };
            return ret;
        }
        /// <summary>
        /// Funkce volaná z kontrolky ZmppvInnerForm.ascx ve workflow zmppv a novyzam
        /// </summary>
        /// <param name="prac_str"></param>
        /// <param name="prac_str_old"></param>
        /// <returns></returns>
        [WebMethod]
        public static object GetDivize(string prac_str, string prac_str_old)
        {
            string str = prac_str ?? prac_str_old ?? null;

            var ret = Pozadavekzmppv.getDivize(str);

            return ret;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="date"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static string zkontrolujUlozDoPD(string co, string date, int id_poz)
        {          
            if (co!="c" && co!="p" && co !="h" && co != "d")
                return $"Neplatná hodnota argumentu 'co':{co}";
           
            string[] arr=date.Split('_');
            if (arr.Length != 3) return "Neplatné datum";

            DateTime datum = new DateTime(Convert.ToInt32(arr[0]), Convert.ToInt32(arr[1]), Convert.ToInt32(arr[2]));

            return Pozadavekplandovol.ZkontrolujUlozDoPD(co, datum, co, id_poz);
           
        }
        /// <summary>
        /// Vrátí HTML text pokynů z nastavení WF. 
        /// </summary>
        /// <returns></returns>
        public string getPokyny()
        {
            //PR 23.11.2021 (je voláno v aspx - výsledek se uloží do javascriptové proměnné)
            //PR 20.12.2022 HID=64232 po uložení a přejití do dalšího kroku se nezobrazovaly pokyny a
            //              a navíc při ručním vyvolání přes tlačítko Pokyny se zobrazily pokyny z minulého kroku.
            //              Při Partial Postbacku se neaktualizuje JS kód (ani když jeho kód přidám do RadAjaxManageru).
            //              Proto již html text pokynů nedávám do JS proměnné, ale přímo do divu, jež je v panelu jež je 
            //              přes RadAjaxManager nastaven, že se má aktualizovat. Tlačítko OK v dialogu s pokyny po partial
            //              postbacku nefungovalo, musel jsem dát div pro dialog mimo Panel a v panelu jsem nechal jen div s pokyny.
            string pokyny = "";
            if (UC_ZmenaStavu.UCPozadavek != null && UC_ZmenaStavu.UCPozadavek.WF != null)
            {
                string vlastnost = "Pokyny";
                if (Thread.CurrentThread.CurrentCulture.Name == "en-US")
                    vlastnost += "_EN";
                else if (Thread.CurrentThread.CurrentCulture.Name == "sk-SK")
                    vlastnost += "_SK";
                pokyny = "Krok=" + UC_ZmenaStavu.UCPozadavek.WF.FazeZprac + ":" + Server.HtmlDecode(UC_ZmenaStavu.UCPozadavek.WF.Get_UN("", vlastnost, "Html", false));
                //PR 20.12.2022 zakomentováno, toto bylo kvůli uložení do javascript proměnné, což již z výše jmenovaných důvodů nedělám.
                /*pokyny = pokyny.Replace("'", "\\'"); //escapovani apostrofu, aby nebyl konec JS proměnné
                //Hodnota JS proměnné nemůže obsahovat odřádkování, takže z toho udělám součet stringů na jednotlivých řádcích
                pokyny = pokyny.Replace("\r\n", "\n"); //CRLF na LF
                pokyny = pokyny.Replace("\r", "\n"); //CR na LF
                pokyny = pokyny.Replace("\n", " '+\n'"); //LF na mezeru apostrof + LF apostrof
                */
            }

            return pokyny;
        }

        /// <summary>
        /// vrátí slučovací pole a vyplněné hodnoty
        /// </summary>
        /// <param name="id_poz"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static string getSlucovaciPole(int id_poz)
        {
            List<SablonyEmailNotifPolozka> res= KSProgram.Workflow.SablonaEmailu.GetPouziteSlucPole(id_poz, false, true);
            JavaScriptSerializer ser = new JavaScriptSerializer();            
            return ser.Serialize(res);
        }


        [WebMethod(EnableSession = true)]
        public static ResultBudgety GetBudgetyRekap(int id_poz)
        {
            return Pozadavekodmenysl.GetZustatkyBudgetu(id_poz);
        }
    }
}

