﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using KSProgram.Data;
using System.Text.RegularExpressions;
using System.Data;
using KSProgram;
using KSProgram.Obecne;
using KSProgram.Ciselniky;
using KSProgram.Funkce;
using KSProgram.PracovniMista;
using KSProgram.Security;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using System.Linq.Dynamic.Core;
using KSProgram.Prava;
using KSProgram.Pozadavky;
using KSProgram.Systemizace;
using KSProgram.Exceptions;
using System.Web.Script.Services;
using KSProgram.Extensions;
using KSProgram.Dokument;
using KSProgram.WebControls;
using static KSProgram.Pozadavky.Pozadavekbudget;

/// <summary>
/// Summary description for AutoCompleteService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
[System.Web.Script.Services.ScriptService]
public class AutoCompleteService : System.Web.Services.WebService
{

    public AutoCompleteService()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    /// <summary>
    /// Upraví vadné filtry, které vzniknou pri JSON parsovani KM 12.4.2016
    /// </summary>
    /// <param name="str"></param>
    /// <returns></returns>
    private string ReplaceString(string str)
    {
        //prepise vsechny dvojte prazne znaky na jeden 
        str = str.Replace("\"\"\"\"", "\"\"");

        //najde retezce typu """xxxx" a zmeni je na ""
        int i = str.IndexOf("\"\"\"");
        while (i != -1)
        {
            int b = str.IndexOf('"', i + 3) - (i + 3); //pocet znaku za sekci """ k dalsi "
            string st2 = str.Substring(i, b + 4);
            str = str.Replace(st2, "\"\"");
            i = str.IndexOf("\"\"\"", b);
        }

        return str;
    }

    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public KSProgram.Pozadavky.PozadavekSeznam.ResultData GetPozadavky(int startRowIndex, int maximumRows, string sortExpression, string filterExpression)
    {
        try
        {
            //trasovací značka 9.1.2015 MiKo
            KSProgram.Diagnostics.KSTrace.WriteLine("AutoCompleteService.GetPozadavky(startRowIndex:=" + startRowIndex + ", maximumRows:" + maximumRows + ", sortExpression:='" + sortExpression + "', filterExpression:='" + filterExpression + "') start");

            //uprava 13.4.2016
            filterExpression = ReplaceString(filterExpression);

            filterExpression = string.IsNullOrEmpty(filterExpression) ? "id_poz <> 0" : filterExpression;
            sortExpression = string.IsNullOrEmpty(sortExpression) ? "id_poz DESC" : sortExpression;
            string[] filters = filterExpression.Split(new string[] { " AND " }, StringSplitOptions.RemoveEmptyEntries);
            string typ = "vse";
            string stav = "vse";
            string zadatel = "vse";
            string sys_stav = null;
            Int32 poz_id = 0;
            DateTime obdobi = DateTime.Today.AddMonths(-4);

            DateTime pom = new DateTime();
            pom = DateTime.Today.AddMonths(4);

            DateTime PozObdobiOd = obdobi;
            DateTime PozObdobiDo = pom;

            DateTime ObdobiOd = obdobi;
            DateTime ObdobiDo = pom;

            filterExpression = "";
            foreach (string fil in filters)
            {
                if (fil.Contains("id_poz = "))
                {
                    //KM 12.4.2016 kontrola na velikost čisla
                    if (Int32.TryParse(fil.Split(' ')[2], out poz_id))
                        continue;
                    else
                    {
                        if (fil.Split(' ')[2].Contains('-'))
                            poz_id = Int32.MinValue;
                        else
                            poz_id = Int32.MaxValue;
                    }
                    //poz_id = Convert.ToInt32(fil.Split(' ')[2]);
                    continue;
                }
                if (fil.Contains("typ = "))
                {
                    typ = fil.Split('\"')[1];
                    continue;
                }
                if (fil.Contains("sys_stav_t = "))
                {
                    sys_stav = fil.Split('\"')[1];
                    sys_stav = string.IsNullOrEmpty(sys_stav) ? null : sys_stav;
                    continue;
                }
                if (fil.Contains("stav = "))
                {
                    stav = fil.Split('\"')[1];
                    continue;
                }
                if (fil.Contains("zadatel = "))
                {
                    zadatel = fil.Split('\"')[1];
                    continue;
                }
                if (fil.Contains("obdobi >="))
                {
                    ObdobiOd = DateTime.Parse(fil.Split('\"')[1]);
                    continue;
                }
                if (fil.Contains("obdobi <="))
                {
                    ObdobiDo = DateTime.Parse(fil.Split('\"')[1]);
                    continue;
                }
                if (fil.Contains("vyridit_do >="))
                {
                    PozObdobiOd = DateTime.Parse(fil.Split('\"')[1]);
                    continue;
                }
                if (fil.Contains("vyridit_do <="))
                {
                    PozObdobiDo = DateTime.Parse(fil.Split('\"')[1]);
                    continue;
                }
                if (fil.Contains("prijmeni"))
                {//uprava 13.4.2016
                    if (fil.Contains("null"))
                    {
                        filterExpression += "(" + fil + ") AND ";
                    }
                    else
                    {
                        filterExpression += "(" + fil.Replace("prijmeni", "prijmeni.ToLower()").Replace("\"" + fil.Split('\"')[1] + "\"", "(\"" + fil.Split('\"')[1] + "\").ToLower()").Replace(fil.Split('\"').Length > 3 ? ("\"" + fil.Split('\"')[3] + "\"") : ("\"\""), fil.Split('\"').Length > 3 ? ("(\"" + fil.Split('\"')[3] + "\").ToLower()") : ("\"\"")) + ") AND ";
                    }
                    continue;
                }
                if (fil.Contains("jmeno"))
                {//uprava 13.4.2016
                    if (fil.Contains("null"))
                    {
                        filterExpression += "(" + fil + ") AND ";
                    }
                    else
                    {
                        filterExpression += "(" + fil.Replace("jmeno", "jmeno.ToLower()").Replace("\"" + fil.Split('\"')[1] + "\"", "(\"" + fil.Split('\"')[1] + "\").ToLower()").Replace(fil.Split('\"').Length > 3 ? ("\"" + fil.Split('\"')[3] + "\"") : ("\"\""), fil.Split('\"').Length > 3 ? ("(\"" + fil.Split('\"')[3] + "\").ToLower()") : ("\"\"")) + ") AND ";
                    }
                    continue;
                }
                if (fil.Contains("kmen_str"))
                {//uprava 13.4.2016
                    if (fil.Contains("null"))
                    {
                        filterExpression += "(" + fil + ") AND ";
                    }
                    else
                    {
                        filterExpression += "(" + fil.Replace("kmen_str", "kmen_str.ToLower()").Replace("\"" + fil.Split('\"')[1] + "\"", "(\"" + fil.Split('\"')[1] + "\").ToLower()").Replace(fil.Split('\"').Length > 3 ? ("\"" + fil.Split('\"')[3] + "\"") : ("\"\""), fil.Split('\"').Length > 3 ? ("(\"" + fil.Split('\"')[3] + "\").ToLower()") : ("\"\"")) + ") AND ";
                    }
                    continue;
                }
                if (fil.Contains("druh_pom_j"))
                {//uprava 13.4.2016
                    if (fil.Contains("null"))
                    {
                        filterExpression += "(" + fil + ") AND ";
                    }
                    else
                    {
                        filterExpression += "(" + fil.Replace("druh_pom_j", "druh_pom_j.ToLower()").Replace("\"" + fil.Split('\"')[1] + "\"", "(\"" + fil.Split('\"')[1] + "\").ToLower()").Replace(fil.Split('\"').Length > 3 ? ("\"" + fil.Split('\"')[3] + "\"") : ("\"\""), fil.Split('\"').Length > 3 ? ("(\"" + fil.Split('\"')[3] + "\").ToLower()") : ("\"\"")) + ") AND ";
                    }
                    continue;
                }
                if (fil.Contains("vyriz_user"))
                {//uprava 13.4.2016
                    if (fil.Contains("null"))
                    {
                        filterExpression += "(" + fil + ") AND ";
                    }
                    else
                    {
                        filterExpression += "(" + fil.Replace("vyriz_user", "vyriz_user.ToLower()").Replace("\"" + fil.Split('\"')[1] + "\"", "(\"" + fil.Split('\"')[1] + "\").ToLower()").Replace(fil.Split('\"').Length > 3 ? ("\"" + fil.Split('\"')[3] + "\"") : ("\"\""), fil.Split('\"').Length > 3 ? ("(\"" + fil.Split('\"')[3] + "\").ToLower()") : ("\"\"")) + ") AND ";
                    }
                    continue;
                }
                filterExpression += (fil + " AND ");
            }
            filterExpression = filterExpression.Substring(0, filterExpression.Length - 5);

            KSProgram.Pozadavky.PozadavekSeznam pozsez = new KSProgram.Pozadavky.PozadavekSeznam();
            KSProgram.Pozadavky.PozadavekSeznam.ResultData result = new KSProgram.Pozadavky.PozadavekSeznam.ResultData();
            result.Data = new List<object>();
            //DataTable table = pozsez.Retrieve(poz_id, stav, typ, zadatel, PozObdobiOd, PozObdobiDo, ObdobiOd, ObdobiDo, null, null, sys_stav);
            //PH 7.2.2021 doplněno sortování a filtrování
            /*
            DataTable table = pozsez.Retrieve(poz_id, stav, typ, zadatel, PozObdobiOd, PozObdobiDo, ObdobiOd, ObdobiDo, null, null, sys_stav, startRowIndex, maximumRows, sortExpression, filterExpression);

            List<string> sortExpressions = sortExpression.Split(',').ToList();
            List<string> newSortExpressions = new List<string>();
            foreach (string exp in sortExpressions)
            {
                if (!exp.Contains("undefined"))
                {
                    newSortExpressions.Add(exp);
                    if (exp.Contains("vyriz_datum"))
                    {
                        newSortExpressions.Add(exp.Replace("vyriz_datum", "vyriz_cas"));
                    }
                }
            }
            sortExpression = string.Join(",", newSortExpressions);

            table.DefaultView.Sort = sortExpression;
            //trasovací značka 9.1.2015 MiKo
            KSProgram.Diagnostics.KSTrace.WriteLine("SORT result: " + sortExpression);
            table = table.DefaultView.ToTable();
            */

            //------------------------
            bool pristup = false;
            if (Zakaznik.IsCurrent("EUNET"))
                pristup = Globals.SuperUser;
            else
                pristup = PravaAkce.PristupPovolen(81);

            List<string> sortExpressions = sortExpression.Split(',').ToList();
            List<string> newSortExpressions = new List<string>();
            foreach (string exp in sortExpressions)
            {
                if (!exp.Contains("undefined"))
                {
                    newSortExpressions.Add(exp);
                    if (exp.Contains("vyriz_datum"))
                    {
                        newSortExpressions.Add(exp.Replace("vyriz_datum", "vyriz_cas"));
                    }
                }
            }
            sortExpression = string.Join(",", newSortExpressions);

            PozadavekSeznam.ResultData res= pozsez.RetrieveResult(poz_id, stav, typ, zadatel, PozObdobiOd, PozObdobiDo, ObdobiOd, ObdobiDo, null, null, sys_stav, startRowIndex, maximumRows, sortExpression, filterExpression);

            //----------------------------------------------------------

             List<KSProgram.Pozadavky.PozadavekSeznam.Pozad> list = new List<KSProgram.Pozadavky.PozadavekSeznam.Pozad>();


            //foreach (DataRow row in table.Rows)
            foreach (PozadavekSeznam.Pozad poz in res.Data)
            {
                //KSProgram.Pozadavky.PozadavekSeznam.Pozad poz = p1;// new KSProgram.Pozadavky.PozadavekSeznam.Pozad(row);

                //PR 24.4.2014 pokud jsem adresátem následujícího kroku, tak obarvím stav
                poz.stav_color = "Black";
                if (poz.adr_ja != null)
                {
                    if (poz.adr_ja.Trim() == "a" && poz.sys_stav != "o" && poz.sys_stav != "s")
                        poz.stav_color = "Red";
                }

                //viditelnost tlačítka mazání
                poz.can_delete = true;
                if (!pristup)
                    poz.can_delete = false;
                else
                {
                    if ((poz.obdobi != null) && (poz.typp != null) && ((poz.typp == "dovol") || (poz.typp == "nahrv") || (poz.typp == "dochazka") || (poz.typp == "absence") || (poz.typp == "stabs")))
                    {
                        DateTime akt_obd_doch = poz.os_cislo == null ? new DateTime() : Dch_Uzaverka.GetAktObdobi((decimal)poz.os_cislo, 5);
                        if (akt_obd_doch > new DateTime())
                        {
                            //PH 25.10.2010 mazat by se neměly požadavky po ukončení měsíce
                            //PH 13.5.2015 doplněn typ absence a stabs
                            if ((akt_obd_doch > (DateTime)poz.obdobi))
                            {
                                poz.can_delete = false;
                            }
                        }
                    }
                }

                // vytvoření datumu změněno
                DateTime vyriz_cas = new DateTime(1900, 1, 1);
                DateTime.TryParse(poz.vyriz_cas, out vyriz_cas);
                if (vyriz_cas != new DateTime(1900, 1, 1) && poz.vyriz_datum != null)
                {
                    poz.vyriz_datum = new DateTime(poz.vyriz_datum.Value.Year, poz.vyriz_datum.Value.Month, poz.vyriz_datum.Value.Day, vyriz_cas.Hour, vyriz_cas.Minute, vyriz_cas.Second, vyriz_cas.Millisecond);
                }

                poz.text = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu(poz.text);

               // list.Add(poz);
            }

            /*
            System.Linq.IQueryable<KSProgram.Pozadavky.PozadavekSeznam.Pozad> _data = list.AsEnumerable()
                .AsQueryable()
                .Where(filterExpression);
            //trasovací značka 9.1.2015 MiKo
            KSProgram.Diagnostics.KSTrace.WriteLine("FILTER result: " + filterExpression);
            result.Count = _data.Count();
            result.Data = _data.Skip(startRowIndex).Take(maximumRows).ToList<object>();
            */
            //PH 8.2.2021
            result = res;
            foreach (KSProgram.Pozadavky.PozadavekSeznam.Pozad poz in result.Data)
            {
                poz.typ = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu(poz.typ);
            }

            //trasovací značka 9.1.2015 MiKo
            KSProgram.Diagnostics.KSTrace.WriteLine("AutoCompleteService.GetPozadavky() return " + result.Data.Count + " rows");

            return result;
        }
        catch (Exception e)
        {
            //trasovací značka 9.1.2015 MiKo
            KSProgram.Diagnostics.KSTrace.WriteLine("Error: " + ExceptionUtility.HtmlEncode(e));

            KSProgram.Pozadavky.PozadavekSeznam.ResultData result = new KSProgram.Pozadavky.PozadavekSeznam.ResultData();
            result.Data = new List<object> { new KSProgram.Pozadavky.PozadavekSeznam.Pozad() };
            ((KSProgram.Pozadavky.PozadavekSeznam.Pozad)result.Data[0]).error = KSProgram.ExceptionUtility.HtmlEncode(e);
            result.Count = 0;
            return result;
        }
    }
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public RadListBoxItemData[] GetTypyPozadavku(Dictionary<string, object> context)
    {
        List<RadListBoxItemData> ret = new List<RadListBoxItemData>();
        DataTable table = KSProgram.Pozadavky.PozadavkyTypy.GetTypy(true, true, false);

        var columns = table.Columns.Cast<System.Data.DataColumn>();

        EnumerableRowCollection<Dictionary<string, object>> list = table.AsEnumerable()
        .Select(r => columns.Select(c => new { Column = c.ColumnName, Value = r[c] })
        .ToDictionary(i => i.Column, i => i.Value != System.DBNull.Value ? i.Value : null));
        //.ToList<object>();

        foreach (Dictionary<string, object> o in list)
        {
            RadListBoxItemData item = new RadListBoxItemData();
            item.Value = (string)o["typ"];
            item.Text = (string)o["typ_text"];
            ret.Add(item);
        }

        return ret.ToArray();
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="item"></param>
    /// <param name="context"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public RadMenuItemData[] GetTypyPozadavku(RadMenuItemData item, object context)
    {
        List<RadListBoxItemData> ret = new List<RadListBoxItemData>();
        DataTable table = KSProgram.Pozadavky.PozadavkyTypy.GetTypy(true, true, false);
        List<RadMenuItemData> result = new List<RadMenuItemData>();
        foreach (DataRow row in table.Rows)
        {
            RadMenuItemData itemData = new RadMenuItemData();
            itemData.Text = row["typ_text"].ToString();
            itemData.Value = row["typ"].ToString();
            result.Add(itemData);
        }
        return result.ToArray();
    }


    //[System.Web.Services.WebMethod(EnableSession = true)]
    //[System.Web.Script.Services.ScriptMethod]
    //public KSProgram.Dochazka.PlanovaniSmen.ResultData GetPlanySmen(int startRowIndex, int maximumRows, string sortExpression, string filterExpression)
    //{
    //    //trasovací značka 9.1.2015 MiKo
    //    //KSProgram.Diagnostics.KSTrace.WriteLine("AutoCompleteService.GetPozadavky(startRowIndex:=" + startRowIndex + ", maximumRows:" + maximumRows + ", sortExpression:='" + sortExpression + "', filterExpression:='" + filterExpression + "') start");

    //    List<PlanovaniSmen.PlanSmen> _data = PlanovaniSmen.GetPlanySmen(DateTime.Now.Date,

    //    KSProgram.Dochazka.PlanovaniSmen.ResultData result = new PlanovaniSmen.ResultData();
    //    result.Data = new List<object>();

    //    result.Count = _data.Count();
    //    result.Data = _data.Skip(startRowIndex).Take(maximumRows).ToList<object>();

    //    //trasovací značka 9.1.2015 MiKo
    //    //KSProgram.Diagnostics.KSTrace.WriteLine("AutoCompleteService.GetPozadavky() return " + result.Data.Count + " rows");

    //    return result;
    //}

    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] SuggestHodnoceniCile(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        List<string> ret = new List<string>();
        if (Zakaznik.GetCustomer() == "CMSS" || Zakaznik.IsCurrent("AWT_GROUP")) // Vypnutí funkcionality
            return ret.ToArray();
        contextKey = contextKey == null ? "" : contextKey;
        prefixText = prefixText == null ? "" : prefixText;
        Regex rgx = new Regex(@"\d+", RegexOptions.IgnoreCase);
        MatchCollection pars = rgx.Matches(contextKey);
        Regex rgx2 = new Regex(@"\w{2,}", RegexOptions.IgnoreCase);
        MatchCollection txts = rgx2.Matches(prefixText);

        KSProgram.Hodnoceni.ParamsH _params = new KSProgram.Hodnoceni.ParamsH();

        string sql = "SELECT text, COUNT(*) FROM hz_hod_cil GROUP BY text ORDER BY text";

        switch (_params["cile_ciselnik_o"])
        {
            case "1"://omezení na pracovní středisko
                sql = "SELECT text, COUNT(*) " +
                    "FROM hz_hod_cil c INNER JOIN hz_hod_hla h ON h.id = c.idp " +
                    "AND h.prac_str IN (SELECT h2.prac_str FROM hz_hod_hla h2  WHERE h2.id = " + pars[0].Value + ") " +
                    "WHERE c.text IS NOT NULL GROUP BY c.text ORDER BY c.text";
                break;
            case "2"://omezení na pracovní místo
                sql = "SELECT text, COUNT(*) " +
                    "FROM hz_hod_cil c INNER JOIN hz_hod_hla h ON h.id = c.idp " +
                    "AND h.id_pracmista IN (SELECT h2.id_pracmista FROM hz_hod_hla h2  WHERE h2.id = " + pars[0].Value + ") " +
                    "WHERE c.text IS NOT NULL GROUP BY c.text ORDER BY c.text";
                break;
            default: break;
        }

        DataTable store = new DataTable();
        store.Columns.Add("text", typeof(string));
        store.Columns.Add("quantity", typeof(int));
        store.Columns.Add("match", typeof(int));
        store.Columns.Add("matches", typeof(int));
        store.Columns.Add("partialmatches", typeof(int));

        IDataReader reader = null;
        try
        {
            reader = SqlPrikaz.ExecuteReader(sql);
            while (reader.Read())
            {
                string t = GetNullOrData.GetString(reader, 0, "", true);
                if (t.Trim() != "")
                {
                    DataRow row = store.NewRow();
                    row["text"] = t;
                    row["quantity"] = GetNullOrData.GetInt32(reader, 1, 0);
                    Int32 i1 = 0;
                    if (t.Trim().ToLower() == prefixText.Trim().ToLower())
                    {
                        row["match"] = 1;
                        i1 = 1;
                    }
                    else row["match"] = 0;

                    Int32 i2 = 0;
                    foreach (Match m in txts)
                    {
                        Regex rgx3 = new Regex(@"\W" + m.Value + @"\W|^" + m.Value + @"\W|\W" + m.Value + "$|^" + m.Value + "$", RegexOptions.IgnoreCase);
                        MatchCollection matches = rgx3.Matches(t.Trim());
                        i2 += matches.Count;
                    }
                    row["matches"] = i2;

                    Int32 i3 = 0;
                    foreach (Match m in txts)
                    {
                        Regex rgx4 = new Regex(m.Value, RegexOptions.IgnoreCase);
                        MatchCollection matches = rgx4.Matches(t.Trim());
                        i3 += matches.Count;
                    }
                    row["partialmatches"] = i3;
                    if (i1 != 0 || i2 != 0 || i3 != 0)
                        store.Rows.Add(row);
                }
            }
        }
        finally
        {
            if (reader != null)
            {
                if (!reader.IsClosed) reader.Close();
                reader.Dispose();
            }
        }
        store.DefaultView.Sort = "match DESC,matches DESC,partialmatches DESC,quantity DESC";
        store = store.DefaultView.ToTable(true, new string[] { "text" });

        List<string> forbiden = new List<string>();
        if (pars.Count >= 2)
        {
            string sqlf = "SELECT DISTINCT(text) FROM hz_hod_cil WHERE idp = " + pars[0].Value + " AND druh = " + pars[1].Value;
            _selectFromDatabase(sqlf, ref forbiden);
        }

        for (int i = 0; i < store.Rows.Count; i++)
        {
            object obj = store.Rows[i][0];
            if (obj != null && obj != DBNull.Value)
                if (!forbiden.Contains(obj.ToString()))
                    ret.Add(obj.ToString());
        }
        return ret.ToArray();
    }
    private void _selectFromDatabase(string sql, ref List<string> text)
    {
        IDataReader reader = null;
        try
        {
            reader = SqlPrikaz.ExecuteReader(sql);
            while (reader.Read())
            {
                string t = GetNullOrData.GetString(reader, 0, "", true);
                if (t != "")
                    //if (!text.Contains(t))
                    text.Add(t);
            }
        }
        finally
        {
            if (reader != null)
            {
                if (!reader.IsClosed) reader.Close();
                reader.Dispose();
            }
        }
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] JmenoZam(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        bool bez_prav = false;
        if ((contextKey == "konflikt") || (contextKey == "poz_adresat"))
            bez_prav = true;
        List<string> ret = new List<string>();
        //DataTable table=Pracovnici.NajdiZam(prefixText, false);
        //PH 26.6.2013
        DataTable table = Pracovnici.NajdiZam(prefixText, false, bez_prav);
        for (int i = 0; i < table.Rows.Count; i++)
        {
            string ls_os_cislo = "";
            if (contextKey == "konflikt")
                ls_os_cislo = "-" + table.Rows[i]["os_cislo"].ToString();
            ret.Add(table.Rows[i]["prijmeni"].ToString().Trim() + "," + table.Rows[i]["jmeno"].ToString().Trim() + ls_os_cislo);
        }

        return ret.ToArray();
    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData JmenoZam2(RadComboBoxContext context)
    {
        string[] data = JmenoZam(context.Text, 0, context["contextKey"].ToString());

        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i].ToString();
                itemData.Value = data[i].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = String.Format("Items <b>1</b>-<b>{0}</b> out of <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = "No matches";
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] SuggestZamestnantci(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        List<string> ret = new List<string>();

        string sql = "SELECT os_cislo, titul, jmeno, prijmeni, titul_za FROM pracovnici ORDER BY prijmeni";
        IDataReader reader = null;
        try
        {
            reader = SqlPrikaz.ExecuteReader(sql);
            while (reader.Read())
            {
                string ls_celejmeno = "";
                string os_cislo = GetNullOrData.GetDecimal(reader, 0, 0).ToString();
                string ls_prijmeni = GetNullOrData.GetString(reader, 3, string.Empty).Trim();
                string ls_jmeno = GetNullOrData.GetString(reader, 2, string.Empty).Trim();
                string ls_titul = GetNullOrData.GetString(reader, 1, string.Empty).Trim();
                string ls_titul_za = GetNullOrData.GetString(reader, 4, string.Empty).Trim();

                if (ls_jmeno != string.Empty) ls_celejmeno = ls_jmeno;
                if (ls_prijmeni != string.Empty) ls_celejmeno += " " + ls_prijmeni;
                if (ls_titul != string.Empty) ls_celejmeno = ls_titul + " " + ls_celejmeno;
                if (ls_titul_za != string.Empty) ls_celejmeno = ls_celejmeno + ", " + ls_titul_za;
                ls_celejmeno = os_cislo + " - " + ls_celejmeno;

                if (ls_celejmeno.ToUpper().Contains(prefixText.ToUpper()))
                    ret.Add(ls_celejmeno);
            }
        }
        finally
        {
            if (reader != null)
            {
                if (!reader.IsClosed) reader.Close();
                reader.Dispose();
            }
        }

        return ret.ToArray();
    }


    //[System.Web.Services.WebMethodAttribute(), System.Web.Script.Services.ScriptMethodAttribute()]
    ///// <summary>
    ///// Vrací příjmení + jméno a v případě duplicity ještě plus ročník (r.82) (pro CestovniPrikaz.ascx)
    ///// </summary>
    ///// <param name="prefixText"></param>
    ///// <param name="count"></param>
    ///// <param name="contextKey"></param>
    ///// <returns></returns>
    //[System.Web.Services.WebMethod(EnableSession = true)]
    //[System.Web.Script.Services.ScriptMethod]
    //public /*static*/ string[] CompleteJmeno(string prefixText, int count, string contextKey)
    //{
    //    prefixText = InputChecker.Text(prefixText, "Prefix");
    //    int p = prefixText.IndexOf(" ");
    //    if (p > 0)
    //    {
    //        prefixText = prefixText.Substring(0, p);
    //    }
    //    //prefixText = prefixText.Substring(0, 1).ToUpper() + prefixText.Substring(1, prefixText.Length - 1);//PR 20.3.2013 
    //    //PR 24.4.2015 využil jsem v selectu funkci UPPER
    //    //PR 3.2.2014 podnik
    //    //string sql = "SELECT prijmeni, jmeno, rodne_cislo, id_podniku, os_cislo FROM pracovnici WHERE"
    //    //+ " UPPER(prijmeni) LIKE UPPER('" + prefixText + "%')"
    //    //+ " and (datum_vystupu is null or datum_vystupu>" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ")"
    //    //+ " ORDER BY prijmeni, jmeno, rodne_cislo, id_podniku, os_cislo";
    //    //PR 17.06.2019 jen jsem zmenil datum_vystupu> na datum_vystupu>=
    //    //PR 20.02.2020 HID=50010 dal jsem UPPER do ORDER BY;
    //    string sql = "SELECT prijmeni, jmeno, rodne_cislo, id_podniku, os_cislo FROM pracovnici WHERE"
    //    + " UPPER(prijmeni) LIKE UPPER('" + prefixText + "%')"
    //    + " and (datum_vystupu is null or datum_vystupu>=" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ")"
    //    + " ORDER BY UPPER(prijmeni), UPPER(jmeno), rodne_cislo, id_podniku, os_cislo";
    //    List<string> r = new List<string>();
    //    int i = 0;
    //    string add = "", prijmeni_prev = "", jmeno_prev = "", rc_prev = "xx", prijmeni = "", jmeno = "", rc = "";
    //    int id_podniku = 0, id_podniku_prev = 0;
    //    decimal oc = 0, oc_prev = 0;
    //    using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
    //    {
    //        while (reader.Read())
    //        {
    //            prijmeni = GetNullOrData.GetString(reader, 0, "", true);
    //            jmeno = GetNullOrData.GetString(reader, 1, "", true);
    //            rc = GetNullOrData.GetString(reader, 2, "xx", true);
    //            if (rc.Length < 2) rc = "xx";//PR 20.06.2019 HID=46899 nevyplněné RČ u agenturního zaměstnance, zpusobovalo exc a 500 internal server error
    //            id_podniku = GetNullOrData.GetInt32(reader, 3, 1);
    //            oc = GetNullOrData.GetDecimal(reader, 4, 0);
    //            add = prijmeni + " " + jmeno;

    //            //if (prijmeni.Equals(prijmeni_prev) && jmeno.Equals(jmeno_prev))
    //            if (prijmeni.Equals(prijmeni_prev, StringComparison.InvariantCultureIgnoreCase) && jmeno.Equals(jmeno_prev, StringComparison.InvariantCultureIgnoreCase))//PR 20.02.2020 HID=50010
    //            {
    //                if (rc.Equals(rc_prev))
    //                {
    //                    if (id_podniku != id_podniku_prev)
    //                    {
    //                        //vice ICO - zamestanec je vicekrat v tabulce, s jiným os.č., ale s jiným podnikem
    //                        add += " {podnik " + id_podniku + " - " + CisPodniky.Nazev(id_podniku) + "}";
    //                        if (i > 0) r[i - 1] = prijmeni_prev + " " + jmeno_prev + " {podnik " + id_podniku_prev + " - " + CisPodniky.Nazev(id_podniku_prev) + "}";
    //                    }
    //                    else //jeden zamestnanec ma v 1 firme 2 osobni cisla, nestandartni, ale napr viz HID=46048
    //                    {
    //                        add += " {oč " + oc + "}";
    //                        if (i > 0) r[i - 1] = prijmeni_prev + " " + jmeno_prev + " {oč " + oc_prev + "}";
    //                    }
    //                }
    //                else
    //                {
    //                    //if (rc.Substring(0, 2).Equals(rc_prev.Substring(0, 2)))//jeden zamestnanec ma v 1 firme 2 osobni cisla, nestandartni, ale napr viz HID=46048
    //                    if (rc.Substring(0, 2).Equals(rc_prev.Substring(0, 2)) || rc == "xx" || rc_prev == "xx") //PR 20.06.2019 nesmím xx dát do nabídky
    //                    {
    //                        add += " {oč " + oc + "}";
    //                        if (i > 0) r[i - 1] = prijmeni_prev + " " + jmeno_prev + " {oč " + oc_prev + "}";
    //                    }
    //                    else
    //                    {
    //                        add += " {r." + rc.Substring(0, 2) + "}";
    //                        r[i - 1] = prijmeni_prev + " " + jmeno_prev + " {r." + rc_prev.Substring(0, 2) + "}";
    //                    }
    //                }
    //            }
    //            r.Add(add);
    //            prijmeni_prev = prijmeni;
    //            jmeno_prev = jmeno;
    //            rc_prev = rc;
    //            id_podniku_prev = id_podniku;
    //            oc_prev = oc;

    //            i++;
    //            if (i >= count) break;
    //        }
    //        reader.Close();
    //    }

    //    return r.ToArray();
    //}

    /// <summary>
    /// Vrací příjmení + jméno a v případě duplicity ještě plus ročník (r.82) (pro CestovniPrikaz.ascx)
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] CompleteJmeno(string prefixText, int count, string contextKey)
    {
        //PR 22.03.2022 funkce předělána kvůli HID=60325
        List<string> r = new List<string>();
        try
        {
            prefixText = InputChecker.Text(prefixText, "Prefix");
        
            int p = prefixText.IndexOf(" ");
            if (p > 0)
            {
                prefixText = prefixText.Substring(0, p);
            }
        
            string sql = "SELECT prijmeni, jmeno, rodne_cislo, id_podniku, os_cislo FROM pracovnici WHERE"
            + " UPPER(prijmeni) LIKE UPPER('" + prefixText + "%')"
            + " and (datum_vystupu is null or datum_vystupu>=" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ")"
            + " ORDER BY UPPER(prijmeni), UPPER(jmeno), rodne_cislo, id_podniku, os_cislo";
        
            string add = "", prijmeni_tmp = "", jmeno_tmp = "", rok_tmp = "xx", prijmeni = "", jmeno = "", rok = "";
            int id_podniku = 0 , id_podniku_tmp = 0;
            decimal oc = 0;

            DataTable data = new DataTable();
            data.Columns.Add("os_cislo", typeof(decimal));
            data.Columns.Add("prijmeni", typeof(string));
            data.Columns.Add("jmeno", typeof(string));
            data.Columns.Add("rok", typeof(string));
            data.Columns.Add("id_podniku", typeof(int));

            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    DataRow row = data.NewRow();
                    row["prijmeni"] = GetNullOrData.GetString(reader, 0, "", true);
                    row["jmeno"] = GetNullOrData.GetString(reader, 1, "", true);
                    rok = GetNullOrData.GetString(reader, 2, "xx", true);
                    if (rok.Length > 2)
                        rok = rok.Substring(0, 2);
                    else
                        rok = "xx";
                    row["rok"] = rok;
                    row["id_podniku"] = GetNullOrData.GetInt32(reader, 3, 1);
                    row["os_cislo"] = GetNullOrData.GetDecimal(reader, 4, 0);

                    data.Rows.Add(row);
                }
                reader.Close();
            }

            for (int i = 0; i < data.Rows.Count; i++)
            {
                prijmeni = (string)data.Rows[i]["prijmeni"];
                jmeno = (string)data.Rows[i]["jmeno"];
                rok = (string)data.Rows[i]["rok"];
                id_podniku = (int)data.Rows[i]["id_podniku"];
                oc = (decimal)data.Rows[i]["os_cislo"];

                bool shoda_jmenaIprijmeni = false;
                bool ruzne_podniky = false;
                bool shoda_roku_narozeni = false;
                for (int j = 0; j < data.Rows.Count; j++)
                {
                    if (j != i)
                    {
                        prijmeni_tmp = (string)data.Rows[j]["prijmeni"];
                        jmeno_tmp = (string)data.Rows[j]["jmeno"];
                        rok_tmp = (string)data.Rows[j]["rok"];
                        id_podniku_tmp = (int)data.Rows[j]["id_podniku"];
                        //oc_tmp = (decimal)data.Rows[j]["os_cislo"];
                        if (prijmeni.Equals(prijmeni_tmp, StringComparison.InvariantCultureIgnoreCase) && jmeno.Equals(jmeno_tmp, StringComparison.InvariantCultureIgnoreCase))
                            shoda_jmenaIprijmeni = true;
                        if (id_podniku != id_podniku_tmp)
                            ruzne_podniky = true;
                        if (rok.Equals(rok_tmp, StringComparison.InvariantCultureIgnoreCase))
                            shoda_roku_narozeni = true;
                    }
                }
            
                add = prijmeni + " " + jmeno;

                if (shoda_jmenaIprijmeni)
                {
                    if (!shoda_roku_narozeni && rok != "xx")
                        add += " {r." + rok + "}";
                    else
                        add += " {oč " + oc + "}";
                }
                if (ruzne_podniky) //jen pro informaji (jiz ne pro identifikaci)
                    add += " {podnik " + id_podniku + " - " + CisPodniky.Nazev(id_podniku) + "}";
                r.Add(add);

                if (i+1 >= count) break;
            }
        }
        catch (Exception exc)
        {
            r.Add(exc.Message);
            ExceptionUtility.LogProcess(exc);
        }

        return r.ToArray();
    }
    /// <summary>
    /// Reverzní funkce k předchozí, která k jednomu vybranému řádku vrátí osobní číslo
    /// </summary>
    /// <param name="text"></param>
    /// <returns></returns>
    public static decimal CompletedJmeno2OsCislo(string text, ref string error)
    {
        //Následující formát generuje funkce ve PrivateWebServices/AutoCompleteService - CompleteJmeno()
        //prijmeni + " " + jmeno
        //v případě duplicit:
        //prijmeni + " " + jmeno + {r.82}
        //nebo
        //prijmeni + " " + jmeno + {oč 12}
        //a v případě shod mezi podniky ve VíceIčo ještě navíc podnik:
        //prijmeni + " " + jmeno + {oč 12} {podnik 12 - Název podniku}
        Decimal osc = 0;
        string orig_text = text;
        string prijmeni1 = "", prijmeni2 = "", oc = "";
        if (text.Length > 0)
        {
            if (text.ToLower().IndexOf("update") > 0 || text.ToLower().IndexOf("insert") > 0 || text.ToLower().IndexOf("delete") > 0)
            {
                error = "Nebezpečný obsah řetězce";
                return osc;
            }
            string rok = ""; string podnik = "";

            //PR 19.05.2022 oprava chyby "Input string was not in a correct format" na ř. 1018
            //-------------------------------------------------------------------------------------------
            //POZOR: tady se postupně odstřihává text od konce až nakonec zbude jen příjmení a jméno !!!!
            //-------------------------------------------------------------------------------------------
            int p = text.IndexOf(" {podnik "); //{podnik 12 - Název podniku} //PR 3.2.2014 
            if (p > 0)
            {
                podnik = text.Substring(p + 9);
                podnik = podnik.Substring(0, podnik.IndexOf(" "));
                text = text.Substring(0, p);
            }
            p = text.IndexOf(" {oč "); //{oč 12}
            if (p > 0)
            {
                oc = text.Substring(p + 5);
                oc = oc.Substring(0, oc.Length - 1);
                text = text.Substring(0, p);
                osc = Decimal.Parse(oc);
            }
            else
            {
                p = text.IndexOf(" {r."); //{r.82}
                if (p > 0)
                {
                    rok = text.Substring(p + 4, 2);
                    text = text.Substring(0, p);
                }
            }

            string jmeno1 = "", jmeno2 = "";
            p = text.LastIndexOf(" ");
            if (p > 0)
            {
                jmeno1 = text.Substring(p + 1);
                prijmeni1 = text.Substring(0, p);
            }
            p = text.IndexOf(" ");
            if (p > 0)
            {
                jmeno2 = text.Substring(p + 1);
                prijmeni2 = text.Substring(0, p);
            }

            string sql = "select os_cislo from pracovnici where";
            if (!prijmeni1.Equals(prijmeni2)) sql += " (";
            sql += " (UPPER(jmeno) = UPPER('" + jmeno1 + "')" + " and UPPER(prijmeni) = UPPER('" + prijmeni1 + "')) ";
            if (!prijmeni1.Equals(prijmeni2))
                sql += " OR (UPPER(jmeno) = UPPER('" + jmeno2 + "')" + " and UPPER(prijmeni) = UPPER('" + prijmeni2 + "')) )";
            if (rok.Length > 0) sql += " and rodne_cislo LIKE '" + rok + "%'";
            if (podnik.Length > 0) sql += " and id_podniku=" + podnik;
            if (oc.Length > 0) sql += " and os_cislo=" + osc;
            string sql_bez_data_vystupu = sql;
            //sql += " and (datum_vystupu is null or datum_vystupu>" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ") ";
            sql += " and (datum_vystupu is null or datum_vystupu>=" + SqlPrikaz.DateTimeToString(Globals.AktObdobi) + ") ";//PR 17.06.2019 mensi nebo rovno
            osc = 0;
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                if (reader.Read())
                {
                    osc = GetNullOrData.GetDecimal(reader, 0, 0);
                }
                if (reader.Read())
                {
                    //osc = 0; //podminka vratila vice lidi
                    osc = -1; //PR 17.06.2019 
                }
            }

            if (osc == -1) //PR 17.06.2019 
            {
                error = WebControlHelper.ZmenaTextu("[%Zaměstnanců se zadaným jménem je více%]!") + " " + orig_text;
            }
            else if (osc == 0)//if (osc < 1)
            {
                decimal ldc_vystoupivsi = 0;
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql + " and datum_vystupu<" + SqlPrikaz.DateTimeToString(Globals.AktObdobi)))
                {
                    if (reader.Read())
                    {
                        ldc_vystoupivsi = GetNullOrData.GetDecimal(reader, 0, 0);
                    }
                }
                if (ldc_vystoupivsi > 0)
                {
                    error = WebControlHelper.ZmenaTextu("[%Zaměstnanec je vystoupivší%]!");                   
                }
                else
                {
                    error = WebControlHelper.ZmenaTextu("[%Zaměstnanec se zadaným jménem nebyl nalezen%], [%zadávejte jméno ve tvaru příjmení mezera jméno%]!");
                }
            }
        }
        return osc;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] Stredisko(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        List<string> ret = new List<string>();
        DataTable stred = (DataTable)SessionInfo.GetVariable("pristupStred");
        if (stred == null)
        {
            CisStredisko str = new CisStredisko();
            DataTable table = str.VsechnaPracStrediskaProPodnik(DateTime.Now.Date, false);
            SessionInfo.SetVariable("pristupStred", table);
            stred = table;
        }

        DataRow[] rows = stred.Select("str LIKE '" + prefixText + "*'");
        for (int i = 0; i < rows.Length; i++)
            ret.Add(rows[i]["str"].ToString());


        return ret.ToArray();
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] Kod(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        /*
        List<string> ret = new List<string>();
        DataTable stred = (DataTable)SessionInfo.GetVariable("pristupStred");
        if (stred == null)
        {
            CisStredisko str = new CisStredisko();
            DataTable table = str.VsechnaPracStrediskaProPodnik(DateTime.Now.Date, false);
            SessionInfo.SetVariable("pristupStred", table);
            stred = table;
        }

        DataRow[] rows = stred.Select("str LIKE '" + prefixText + "*'");
        for (int i = 0; i < rows.Length; i++)
            ret.Add(rows[i]["str"].ToString());


        return ret.ToArray();
         * */

        List<string> ret = new List<string>();

        DataTable table = KSProgram.Ciselniky.CisDchKody.DbSelect2("XXX");

        DataRow[] rows = table.Select("cely_nazev LIKE '" + prefixText + "*'");
        for (int i = 0; i < rows.Length; i++)
            ret.Add(rows[i]["vyr_kod"].ToString());


        return ret.ToArray();
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="prefixText">mezera DDDW mezera DDDWargument mezera Filtr</param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public string[] CislHodAtribPracMist(string prefixText, int count, string contextKey)
    {
        prefixText = InputChecker.Text(prefixText, "Prefix");
        contextKey = contextKey == null ? "" : contextKey;
        prefixText = prefixText == null ? "" : prefixText;
        Regex rgx = new Regex(@"(?<=\s)\S*", RegexOptions.IgnoreCase);
        MatchCollection pars = rgx.Matches(contextKey);
        Regex rgx2 = new Regex(@"\w{2,}|\*", RegexOptions.IgnoreCase);
        MatchCollection txts = rgx2.Matches(prefixText);

        string dddw = pars[0].Value;
        int? dddw_arg = pars[1].Value == "" ? null : (Int16?)Convert.ToInt32(pars[1].Value);
        string filter = pars[2].Value;

        DataTable store = PracMisto.CiselnikHodAtrH(dddw, dddw_arg, filter);

        String expr = "";
        foreach (Match pref in txts)
        {
            if (pref.Value == "*")
            {
                expr = "text LIKE '*'";
                break;
            }
            else
            {
                if (expr.Length > 0)
                    expr += " AND ";
                expr += "text LIKE '*" + pref + "*'";
            }
        }
        //if (expr != "")
        //    expr = expr.Substring(0, expr.Length - 5);

        DataRow[] rows = store.Select(expr);

        List<string> ret = new List<string>();

        foreach (DataRow row in rows)
        {
            object obj = row[1];
            if (obj != null && obj != DBNull.Value)
            {
                string text = obj.ToString();
                ret.Add(text);
            }
        }

        return ret.ToArray();
    }

    //[System.Web.Services.WebMethodAttribute(), System.Web.Script.Services.ScriptMethodAttribute()]
    /// <summary>
    /// Obec z číselníku PSČ (pro CestovniPrikaz.ascx)
    /// </summary>
    /// <param name="prefixText"></param>
    /// <param name="count"></param>
    /// <param name="contextKey"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    [System.Web.Script.Services.ScriptMethod]
    public /*static*/ string[] GetObecCompletionList(string prefixText, int count, string contextKey)
    {
        List<string> obce = new List<string>();
        try
        {
            prefixText = InputChecker.Text(prefixText, "Prefix");
        }
        catch (NoticeException err)
        {
            return new string[] {err.Message}; //obce.ToArray();
        }
        
        string sql = "SELECT distinct obec FROM psc WHERE obec LIKE '" + prefixText + "%' ORDER BY obec";
        
        int i = 0;

        using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
        {
            while (reader.Read())
            {
                obce.Add(GetNullOrData.GetString(reader, "obec", "", true));
                i++;
                if (i >= count) break;
            }
            reader.Close();
        }

        return obce.ToArray();
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    public RadComboBoxData GetStredDochazka(RadComboBoxContext context)
    {
        RadComboBoxData comboData = null;
        List<RadComboBoxItemData> result = null;
        try
        {
            result = new List<RadComboBoxItemData>(context.NumberOfItems);
            comboData = new RadComboBoxData();

            //decimal? castka=SqlPrikaz.ExecuteScalarCastka("select max(neco) from neco");

            //CisStredisko str = new CisStredisko();
            //DataTable data = str.VsechnaPracStrediska(DateTime.Now.Date, true);  
            //PH 23.5.2014
            DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
            DataTable data = CisOjDochazka.VsechanaOJ(ld_den, true);

            int itemsPerRequest = 50;
            if (ParametryDochazky.ZDROJ_OJ == "VYR_ZAKAZKY") //PH 31.7.2014
                itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                itemData.Value = data.Rows[i]["str"].ToString();
                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
            if (e.InnerException != null)
                if (!string.IsNullOrEmpty(e.InnerException.Message))
                    comboData.Message += e.InnerException.Message;
        }
        comboData.Items = result.ToArray();
        return comboData;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    public RadComboBoxData GetStred(RadComboBoxContext context)
    {
        //PH 3.5.2018 do selectu jsem doplnil id_podniku HID:41050
        //----------------------------------------------------
        int? id_podniku = null;
        string zdroj = null;
        if (context.Keys.Contains("zdroj"))
            zdroj = context["zdroj"].ToString();

        if ((context.Keys.Contains("podnik")) && (context["podnik"] != null))
        {
            decimal ldc_os_cislo = 0;
            if (context["podnik"].ToString() == "jen_akt")
            //id_podniku = ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUser);
            {
                if (zdroj == "odmeny")
                    ldc_os_cislo = Convert.ToDecimal(SessionInfo.GetVariable(Controls_ZadostOodmeny.SelecteOsCisloKey));
                else
                    ldc_os_cislo = Globals.OsCisloAktUser;
            }
            if (ldc_os_cislo == 0) ldc_os_cislo = Globals.OsCisloAktUser;
            id_podniku = ViceIco.GetIdPodnikuZamestnance(ldc_os_cislo);
        }
        //----------------------------------------------------
        bool emptyRow = false;
        //if (context["EmptyRow"] != null)  
        if (context.Keys.Contains("EmptyRow"))
        {
            if (context["EmptyRow"].ToString() == "a")
                emptyRow = true;
        }

        RadComboBoxData comboData = null;
        List<RadComboBoxItemData> result = null;
        try
        {
            result = new List<RadComboBoxItemData>(context.NumberOfItems);
            comboData = new RadComboBoxData();

            CisStredisko cis_str = new CisStredisko();
            DataTable data = cis_str.VsechnaStrediskaAll(Globals.AktObdobi, false, id_podniku);
            if (emptyRow)
            {
                DataRow r = data.NewRow();
                data.Rows.InsertAt(r, 0);
            }

            int itemsPerRequest = 50;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);

            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                itemData.Value = data.Rows[i]["str"].ToString();
                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
            if (e.InnerException != null)
                if (!string.IsNullOrEmpty(e.InnerException.Message))
                    comboData.Message += e.InnerException.Message;
        }
        comboData.Items = result.ToArray();
        return comboData;
    }

    [System.Web.Services.WebMethod(EnableSession = true)]
    public RadComboBoxData GetPorizovakKody(RadComboBoxContext context)
    {
        /*    
        int? id_podniku = null;
        if (context["podnik"] != null)
        {
            if (context["podnik"].ToString() == "jen_akt")
                id_podniku = ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUser);
        }
        */

        RadComboBoxData comboData = null;
        List<RadComboBoxItemData> result = null;
        try
        {
            result = new List<RadComboBoxItemData>(context.NumberOfItems);
            comboData = new RadComboBoxData();

            prtl_porizovak poriz = new prtl_porizovak("prtl"); //PH 27.9.2022 dávám natrvrdo tento příznak, protože toto je využito jen v požadavku na odměny(nikoliv sloupcové)
            DataTable data = poriz.Kody(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);

            int itemsPerRequest = 50;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                itemData.Value = data.Rows[i]["kod"].ToString();
                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
            if (e.InnerException != null)
                if (!string.IsNullOrEmpty(e.InnerException.Message))
                    comboData.Message += e.InnerException.Message;
        }
        comboData.Items = result.ToArray();
        return comboData;
    }

    [System.Web.Services.WebMethod(EnableSession = true)]
    public RadComboBoxData GetKodyDochazka(RadComboBoxContext context)
    {
        RadComboBoxData comboData = null;
        List<RadComboBoxItemData> result = null;
        try
        {
            decimal? os_cislo = null;
            if (context.ContainsKey("os_cislo"))
            {
                os_cislo = Convert.ToDecimal(context["os_cislo"]);
            }

            short? cislo_pom = null;
            if (context.ContainsKey("cislo_pom"))
            {
                cislo_pom = Convert.ToInt16(context["cislo_pom"]);
            }

            if (context.ContainsKey("nefiltruj"))
            {
                if (context["nefiltruj"].ToString() == "true")
                    context["Text"] = "";
            }


            string sender = "XXX";
            if (context.ContainsKey("sender"))
            {
                sender = Convert.ToString(context["sender"]);
            }

            result = new List<RadComboBoxItemData>(context.NumberOfItems);
            comboData = new RadComboBoxData();

            DataTable data = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev(sender, os_cislo, cislo_pom);
            string search=context["Text"].ToString();
            if (!string.IsNullOrEmpty(search))
            {
                DataRow[] rws = data.Select("nazev LIKE '%" + search + "%' or zkratka LIKE '%" + search + "%'");
                if (rws.Length > 0)
                    data = data.Select("nazev LIKE '%" + search + "%' or zkratka LIKE '%" + search + "%'").CopyToDataTable();
            }

            int itemsPerRequest = 15;

            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                itemData.Value = data.Rows[i]["kod"].ToString();
                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
            if (e.InnerException != null)
                if (!string.IsNullOrEmpty(e.InnerException.Message))
                    comboData.Message += e.InnerException.Message;
        }
        comboData.Items = result.ToArray();
        return comboData;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [System.Web.Services.WebMethod(EnableSession = true)]
    public RadComboBoxData GetKodyDochazka2(RadComboBoxContext context)
    {
        RadComboBoxData comboData = null;
        List<RadComboBoxItemData> result = null;
        try
        {
            decimal? os_cislo = null;
            if (context.ContainsKey("os_cislo"))
            {
                os_cislo = Convert.ToDecimal(context["os_cislo"]);
            }
            short? cislo_pom = null;
            if (context.ContainsKey("cislo_pom"))
            {
                cislo_pom = Convert.ToInt16(context["cislo_pom"]);
            }

            string sender = "XXX";
            if (context.ContainsKey("sender"))
            {
                sender = Convert.ToString(context["sender"]);
            }

            result = new List<RadComboBoxItemData>(context.NumberOfItems);
            comboData = new RadComboBoxData();

            DataTable data = KSProgram.Ciselniky.CisDchKody.DbSelect2(sender, os_cislo, cislo_pom);
            DataTable res = data.Clone();
            if (!string.IsNullOrEmpty(context["Text"].ToString()))
            {
                //DataRow[] rows = data.Select("cely_nazev LIKE '*" + context["Text"].ToString() + "*'");
                //PH 2.11.2018 chtějí vidět všechny kody
                DataRow[] rows = data.Select("1=1");
                for (int i = 0; i < rows.Length; i++)
                    res.ImportRow(rows[i]);
            }
            else
                res = data;

            int itemsPerRequest = 30;

            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > res.Rows.Count)
            {
                endOffset = res.Rows.Count;
            }
            if (endOffset == res.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = res.Rows[i]["cely_nazev"].ToString();
                itemData.Value = res.Rows[i]["vyr_kod"].ToString();
                result.Add(itemData);
            }

            if (res.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, res.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
            if (e.InnerException != null)
                if (!string.IsNullOrEmpty(e.InnerException.Message))
                    comboData.Message += e.InnerException.Message;
        }
        comboData.Items = result.ToArray();
        return comboData;
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetObce(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetObce(context);

        //MiKo: Přesunuto do public KSPortal.WebServices
        //string psc = "";
        //if (context.ContainsKey("psc"))
        //    psc = context["psc"] == null ? "" : ((string)context["psc"]).Trim();
        //Regex regex = new Regex(@"[0-9]+");
        //MatchCollection filter_coll = regex.Matches(psc);
        //if (filter_coll.Count > 0)
        //{
        //    psc = filter_coll[0].Value;
        //}
        //else
        //{
        //    psc = "";
        //}
        //string sql = "SELECT distinct obec FROM psc WHERE 1 = 1";
        //sql += string.IsNullOrEmpty(context.Text) ? "" : " AND LOWER(obec) LIKE '" + context.Text.ToLower() + "%'";
        //sql += string.IsNullOrEmpty(psc) ? "" : " AND psc = " + SqlPrikaz.ValueToString(psc);
        //sql += " ORDER BY obec";
        //DataTable data = new DataTable();
        //data.Columns.Add("obec", typeof(string));

        //using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
        //{
        //    while (reader.Read())
        //    {
        //        DataRow row = data.NewRow();

        //        row["obec"] = GetNullOrData.GetString(reader, "obec", "", true);

        //        data.Rows.Add(row);
        //    }
        //}

        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();
        //try
        //{
        //    int itemsPerRequest = 10;
        //    int itemOffset = context.NumberOfItems;
        //    int endOffset = itemOffset + itemsPerRequest;
        //    if (endOffset > data.Rows.Count)
        //    {
        //        endOffset = data.Rows.Count;
        //    }
        //    if (endOffset == data.Rows.Count)
        //    {
        //        comboData.EndOfItems = true;
        //    }
        //    else
        //    {
        //        comboData.EndOfItems = false;
        //    }
        //    result = new List<RadComboBoxItemData>(endOffset - itemOffset);
        //    for (int i = itemOffset; i < endOffset; i++)
        //    {
        //        RadComboBoxItemData itemData = new RadComboBoxItemData();
        //        itemData.Text = data.Rows[i]["obec"].ToString();
        //        itemData.Value = data.Rows[i]["obec"].ToString();

        //        result.Add(itemData);
        //    }

        //    if (data.Rows.Count > 0)
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
        //    }
        //    else
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
        //    }
        //}
        //catch (Exception e)
        //{
        //    comboData.Message = e.Message;
        //}

        //comboData.Items = result.ToArray();
        //return comboData;

    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetPsc(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetPsc(context);

        //string obec = "";
        //if (context.ContainsKey("obec"))
        //    obec = context["obec"] == null ? "" : ((string)context["obec"]).Trim();
        //string sql = "SELECT distinct psc, posta FROM psc WHERE 1 = 1";
        //sql += string.IsNullOrEmpty(context.Text) ? "" : " AND ( LOWER(psc) LIKE '" + context.Text.ToLower() + "%' OR LOWER(posta) LIKE '" + context.Text.ToLower() + "%' )";
        //sql += string.IsNullOrEmpty(obec) ? "" : " AND LOWER(obec) = " + SqlPrikaz.ValueToString(obec.ToLower());
        //sql += " ORDER BY psc";
        //DataTable data = new DataTable();
        //data.Columns.Add("psc", typeof(string));
        //data.Columns.Add("posta", typeof(string));

        //using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
        //{
        //    while (reader.Read())
        //    {
        //        DataRow row = data.NewRow();

        //        row["psc"] = GetNullOrData.GetString(reader, "psc", "", true);
        //        row["posta"] = GetNullOrData.GetString(reader, "posta", "", true);

        //        data.Rows.Add(row);
        //    }
        //}

        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();
        //try
        //{
        //    int itemsPerRequest = 10;
        //    int itemOffset = context.NumberOfItems;
        //    int endOffset = itemOffset + itemsPerRequest;
        //    if (endOffset > data.Rows.Count)
        //    {
        //        endOffset = data.Rows.Count;
        //    }
        //    if (endOffset == data.Rows.Count)
        //    {
        //        comboData.EndOfItems = true;
        //    }
        //    else
        //    {
        //        comboData.EndOfItems = false;
        //    }
        //    result = new List<RadComboBoxItemData>(endOffset - itemOffset);
        //    for (int i = itemOffset; i < endOffset; i++)
        //    {
        //        RadComboBoxItemData itemData = new RadComboBoxItemData();
        //        itemData.Text = data.Rows[i]["psc"].ToString() + " " + data.Rows[i]["posta"].ToString();
        //        itemData.Value = data.Rows[i]["psc"].ToString();

        //        result.Add(itemData);
        //    }

        //    if (data.Rows.Count > 0)
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
        //    }
        //    else
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
        //    }
        //}
        //catch (Exception e)
        //{
        //    comboData.Message = e.Message;
        //}

        //comboData.Items = result.ToArray();
        //return comboData;
    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetTrida(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetTrida(context);

        //short pom_typ_tt, typ_mzdy;
        //short? typ_tt;
        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();

        //if (context.ContainsKey("typ_tt") && short.TryParse(context["typ_tt"].ToString(), out pom_typ_tt))
        //    typ_tt = pom_typ_tt;
        //else
        //    typ_tt = null;

        //if ((context.ContainsKey("typ_mzdy") && short.TryParse(context["typ_mzdy"].ToString(), out typ_mzdy)) ||
        //    (context.ContainsKey("typ_mzdy_old") && short.TryParse(context["typ_mzdy_old"].ToString(), out typ_mzdy)))
        //{
        //    try
        //    {
        //        ParametryPrikazu pars = new ParametryPrikazu()
        //        {
        //            new KSParameter("typ_tt", DbType.Int16, typ_tt),
        //            new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy)
        //        };
        //        DataTable data = SqlPrikaz.ExecuteCommand("SELECT DISTINCT trida FROM tarify WHERE (typ_tt = @typ_tt OR @typ_tt IS NULL) AND typ_mzdy = @typ_mzdy ORDER BY trida", ref pars);

        //        result = (from r in data.AsEnumerable()
        //                  select new RadComboBoxItemData()
        //                  {
        //                      Text = r["trida"].ToString(),
        //                      Value = r["trida"].ToString()
        //                  }).ToList();

        //    }
        //    catch (Exception e)
        //    {
        //        comboData.Message = e.Message;
        //    }
        //}

        //comboData.Items = result.ToArray();
        //comboData.NumberOfItems = result.Count;
        //comboData.Text = result.Count > 0 ? result[0]?.Text : null;
        //comboData.Value = result.Count > 0 ? result[0]?.Value : null;
        //return comboData;
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetSmena(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetSmena(context);

        //short typ_kal;
        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();

        //if ((context.ContainsKey("typ_kal") && short.TryParse(context["typ_kal"].ToString(), out typ_kal)) ||
        //    (context.ContainsKey("typ_kal_old") && short.TryParse(context["typ_kal_old"].ToString(), out typ_kal)))
        //{
        //    try
        //    {
        //        result = (from r in CisPracRozvrh.Rozvrhy(typ_kal).AsEnumerable()
        //                  select new RadComboBoxItemData()
        //                  {
        //                      Text = GetNullOrData.GetString(r["cely_nazev"], true),
        //                      Value = GetNullOrData.GetInt16(r["cislo"]).ToString()
        //                  }).ToList();
        //    }
        //    catch (Exception e)
        //    {
        //        comboData.Message = e.Message;
        //    }
        //}

        //comboData.Items = result.ToArray();
        //comboData.NumberOfItems = result.Count;
        //comboData.Text = result.Count > 0 ? result[0]?.Text : null;
        //comboData.Value = result.Count > 0 ? result[0]?.Value : null;
        //return comboData;
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetMzdStupen(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetMzdStupen(context);

        //short pom_typ_tt, typ_mzdy, pom_trida;
        //short? typ_tt, trida;
        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();

        //if (context.ContainsKey("typ_tt") && short.TryParse(context["typ_tt"].ToString(), out pom_typ_tt))
        //    typ_tt = pom_typ_tt;
        //else
        //    typ_tt = null;

        //if ((context.ContainsKey("trida") && short.TryParse(context["trida"].ToString(), out pom_trida)) ||
        //    (context.ContainsKey("trida_old") && short.TryParse(context["trida_old"].ToString(), out pom_trida)))
        //    trida = pom_trida;
        //else
        //    trida = null;

        //if ((context.ContainsKey("typ_mzdy") && short.TryParse(context["typ_mzdy"].ToString(), out typ_mzdy)) ||
        //    (context.ContainsKey("typ_mzdy_old") && short.TryParse(context["typ_mzdy_old"].ToString(), out typ_mzdy)))
        //{
        //    try
        //    {
        //        ParametryPrikazu pars = new ParametryPrikazu()
        //        {
        //            new KSParameter("typ_tt", DbType.Int16, typ_tt),
        //            new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy),
        //            new KSParameter("trida", DbType.Int16, trida)
        //        };
        //        DataTable data = SqlPrikaz.ExecuteCommand("SELECT DISTINCT mzd_stup FROM tarify WHERE (typ_tt = @typ_tt OR @typ_tt IS NULL) AND typ_mzdy = @typ_mzdy AND (trida = @trida OR @trida IS NULL) ORDER BY mzd_stup", ref pars);

        //        result = (from r in data.AsEnumerable()
        //                  select new RadComboBoxItemData()
        //                  {
        //                      Text = r["mzd_stup"].ToString(),
        //                      Value = r["mzd_stup"].ToString()
        //                  }).ToList();

        //    }
        //    catch (Exception e)
        //    {
        //        comboData.Message = e.Message;
        //    }
        //}

        //comboData.Items = result.ToArray();
        //comboData.NumberOfItems = result.Count;
        //comboData.Text = result.Count > 0 ? result[0]?.Text : null;
        //comboData.Value = result.Count > 0 ? result[0]?.Value : null;
        //return comboData;
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetAllStr(RadComboBoxContext context)
    {
        CisStredisko str = new CisStredisko();
        DataTable data = str.VsechnaPracStrediska(DateTime.Now.Date, true);

        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                itemData.Value = data.Rows[i]["str"].ToString();

                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetStavyPoz(RadComboBoxContext context)
    {
        string typ = "";
        if (context.ContainsKey("typ"))
        {
            typ = context["typ"] == null ? "" : ((string)context["typ"]).Trim();
            typ = typ == "vse" ? "" : typ;
        }
        DataTable data;
        //if (Zakaznik.IsCurrent("SKODA"))
        //{
        data = KSProgram.Pozadavky.WorkflowProces.StavyPozadavkuDistinct(typ);
        //}
        //else
        //{
        //    data = KSProgram.Pozadavky.WorkflowProces.StavyPozadavku(typ);
        //}
        if (data.Rows.Count > 0)
        {
            if (data.Rows[0][0].ToString() != "vse")
            {
                DataTable data2 = data.Copy();
                data2.Rows.Clear();
                DataRow row = data2.NewRow();
                row["stav"] = "vse";
                row["text_stavu"] = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Vše%]");
                data2.Rows.Add(row);
                foreach (DataRow rowo in data.Rows)
                {
                    DataRow nrow = data2.NewRow();
                    nrow.ItemArray = rowo.ItemArray.Clone() as object[];
                    data2.Rows.Add(nrow);
                }
                data = data2.Copy();
            }
        }
        else
        {
            DataRow row = data.NewRow();
            row["stav"] = "vse";
            row["text_stavu"] = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Vše%]");
            data.Rows.Add(row);
        }
        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Rows.Count)
            {
                endOffset = data.Rows.Count;
            }
            if (endOffset == data.Rows.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data.Rows[i]["text_stavu"].ToString();
                itemData.Value = data.Rows[i]["stav"].ToString();

                result.Add(itemData);
            }

            if (data.Rows.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }
    [WebMethod(EnableSession = true)]
    public AutoCompleteBoxData GetZamestanciAutoComplete(RadAutoCompleteContext context)
    {
        List<decimal> used = Newtonsoft.Json.JsonConvert.DeserializeObject<List<decimal>>(context["used"].ToString());

        DataTable datatb = Pracovnici.SeznamZam("p", "p", true);
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = Globals.OsCisloJeCitlivyUdaj
                        ? datatb.Select("jmeno LIKE '%" + context.Text + "%'", "os_cislo")
                        : datatb.Select("os_cislo_jmeno LIKE '%" + context.Text + "%'", "os_cislo");
        }
        else
        {
            data = datatb.Select("os_cislo = os_cislo");
        }


        List<AutoCompleteBoxItemData> result = new List<AutoCompleteBoxItemData>();
        AutoCompleteBoxData dropDownData = new AutoCompleteBoxData();

        result = new List<AutoCompleteBoxItemData>();

        for (int i = 0; i < data.Length; i++)
        {
            decimal os_cislo = GetNullOrData.GetDecimal(data[i]["os_cislo"], 0);
            if (!used.Contains(os_cislo))
            {
                AutoCompleteBoxItemData itemData = new AutoCompleteBoxItemData();
                itemData.Text = Globals.OsCisloJeCitlivyUdaj
                                    ? data[i]["jmeno"].ToString()
                                    : data[i]["os_cislo_jmeno"].ToString();
                itemData.Value = os_cislo.ToString();
                result.Add(itemData);
            }
        }

        dropDownData.Items = result.ToArray();
        return dropDownData;
    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetZamestnanci(RadComboBoxContext context)
    {
        bool use_prava = false;
        if (context.Keys.Contains("UsePrava"))
        {
            use_prava = (bool)context["UsePrava"];
        }
        DataTable datatb = Pracovnici.SeznamZam("p", "p", use_prava);
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("os_cislo_jmeno LIKE '%" + context.Text + "%'", "os_cislo");
        }
        else
        {
            data = datatb.Select("os_cislo = os_cislo");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["os_cislo_jmeno"].ToString();
                itemData.Value = data[i]["os_cislo"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetKZAM(RadComboBoxContext context)
    {
        return new KSPortal.WebServices.AutoCompleteService().GetKZAM(context);

        //DataTable datatb = CisKzam.Seznam(false);
        //DataRow[] data = null;
        //if (!string.IsNullOrEmpty(context.Text))
        //{
        //    data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cislo");
        //}
        //else
        //{
        //    data = datatb.Select("cislo = cislo");
        //}


        //List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        //RadComboBoxData comboData = new RadComboBoxData();
        //try
        //{
        //    int itemsPerRequest = 10;
        //    int itemOffset = context.NumberOfItems;
        //    int endOffset = itemOffset + itemsPerRequest;
        //    if (endOffset > data.Length)
        //    {
        //        endOffset = data.Length;
        //    }
        //    if (endOffset == data.Length)
        //    {
        //        comboData.EndOfItems = true;
        //    }
        //    else
        //    {
        //        comboData.EndOfItems = false;
        //    }
        //    result = new List<RadComboBoxItemData>(endOffset - itemOffset);
        //    for (int i = itemOffset; i < endOffset; i++)
        //    {
        //        RadComboBoxItemData itemData = new RadComboBoxItemData();
        //        itemData.Text = data[i]["cely_nazev"].ToString();
        //        itemData.Value = data[i]["cislo"].ToString();

        //        result.Add(itemData);
        //    }

        //    if (data.Length > 0)
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
        //    }
        //    else
        //    {
        //        comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
        //    }
        //}
        //catch (Exception e)
        //{
        //    comboData.Message = e.Message;
        //}

        //comboData.Items = result.ToArray();
        //return comboData;
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetCinnosti(RadComboBoxContext context)
    {
        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            List<KSProgram.Projekty.Projekty.DobaNaProj> list = KSProgram.Projekty.Projekty.DobaNaProjektech(null, null, null, null, null, null, null, false);
            List<KSProgram.Projekty.Projekty.CinnNaProj> cinn = new List<KSProgram.Projekty.Projekty.CinnNaProj>() { };
            list.ForEach(x => cinn.AddRange(x.Cinn));
            string[] data = cinn.Select(x => x.Nazev).Distinct().ToList().FindAll(y => context == null ? true : y.ToLower().Contains(context.Text.ToLower())).ToArray();

            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i];
                itemData.Value = data[i];

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// metoda pro vyhledávání
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public SearchBoxData SearchOnWeb(SearchBoxContext context)
    {
        try
        {
            string prefixText = InputChecker.Text(context.Text, "Prefix").ToUpper();
            List<Tuple<string, string, string>> ret = PSearch.GetDataSearch(prefixText);
            List<SearchBoxItemData> items = new List<SearchBoxItemData>();
            ret.ForEach(delegate (Tuple<string, string, string> name)
            {
                SearchBoxItemData itemData = new SearchBoxItemData();
                itemData.Text = name.Item1.ToString();
                itemData.Value = name.Item2.ToString();
                itemData.DataItem.Add("sekce", name.Item3);
                items.Add(itemData);
            });
            SearchBoxData result = new SearchBoxData();
            result.Items = items.ToArray();

            return result;
        }
        catch
        {
            SessionInfo.SetVariable("search_enable", "false");
            return new SearchBoxData();
        }
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetStPrisl(RadComboBoxContext context)
    {       
        CisStatniPrisl st_prisl = new CisStatniPrisl();
        DataTable datatb = st_prisl.Seznam();
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cesky LIKE '%" + context.Text + "%'", "cesky");
        }
        else
        {
            data = datatb.Select("kod_ciselny = kod_ciselny", "cesky");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            ////DataTextField="cesky" DataValueField="kod_ciselny"
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["cesky"].ToString();
                itemData.Value = data[i]["kod_ciselny"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetKodyZemi(RadComboBoxContext context)
    {
        CisStatniPrisl st_prisl = new CisStatniPrisl();
        DataTable datatb = st_prisl.Seznam(false, "{kod_znakovy2} - {cesky}", null, false, "kod_znakovy2");
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cely_nazev");
        }
        else
        {
            data = datatb.Select("kod_znakovy2 = kod_znakovy2", "cely_nazev");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["cely_nazev"].ToString();                
                itemData.Value = data[i]["kod_znakovy2"].ToString();                

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetPomeryProZam(RadComboBoxContext context)
    {
        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);

        RadComboBoxData comboData = new RadComboBoxData();
        if (!context.ContainsKey("os_cislo")) return comboData;

        decimal os_cislo = Convert.ToDecimal(context["os_cislo"]);

        //List<prac_pomer> list=Prac_pom.GetPomery(Convert.ToDecimal(context["os_cislo"]));
        DateTime obdobi = ViceIco.ObdobiPodnikuPodleZamestnance(os_cislo);
        List<StrPracPom> list = Prac_pom.GetPomery(os_cislo, obdobi);
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            //int itemOffset = list.Count;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > list.Count)
            {
                endOffset = list.Count;
            }
            if (endOffset == list.Count)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            ////DataTextField="cesky" DataValueField="kod_ciselny"
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = list[i].CisloPom.ToString() + " " + CisDruhPom.GetNazevPom(list[i].UzivDruh);
                itemData.Value = list[i].CisloPom.ToString();

                result.Add(itemData);
            }

            if (list.Count > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, list.Count);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetZdravPoj(RadComboBoxContext context)
    {
        CisZdravPoj cis_zdrav_poj = new CisZdravPoj();
        DataTable datatb = cis_zdrav_poj.Retrieve();
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cely_nazev");
        }
        else
        {
            data = datatb.Select("cislo = cislo", "cely_nazev");
        }

        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 20;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["cely_nazev"].ToString();
                itemData.Value = data[i]["cislo"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }


    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetJazyky(RadComboBoxContext context)
    {
        CisJazyku jazyky = new CisJazyku();
        DataTable datatb = jazyky.JazykySeznam();
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("nazev LIKE '%" + context.Text + "%'", "nazev");
        }
        else
        {
            data = datatb.Select("nazev = nazev", "nazev");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["nazev"].ToString();
                itemData.Value = data[i]["jazyk"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetObory(RadComboBoxContext context)
    {
        DataTable datatb = CisVzdelani.OborSeznam();
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("vyznam LIKE '%" + context.Text + "%'", "vyznam");
        }
        else
        {
            data = datatb.Select("vyznam = vyznam", "vyznam");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["vyznam"].ToString();
                itemData.Value = data[i]["obor"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetOsvedceni(RadComboBoxContext context)
    {

        CisSkoCisl cisl = new CisSkoCisl();
        DataTable datatb = cisl.SkoCislSeznam("text_osve", " AND ( nenabizet = 2 OR nenabizet IS NULL )");

        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "text_osve");
        }
        else
        {
            data = datatb.Select("cely_nazev = cely_nazev", "text_osve");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["text_osve"].ToString();
                itemData.Value = data[i]["cislo"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetStupneVzdelani(RadComboBoxContext context)
    {
        DataTable datatb = CisVzdelani.StupenSeznam();
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("vyznam LIKE '%" + context.Text + "%'", "vyznam");
        }
        else
        {
            data = datatb.Select("vyznam = vyznam", "vyznam");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["vyznam"].ToString();
                itemData.Value = data[i]["stupen"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetCisProjekty(RadComboBoxContext context)
    {
        int rok = 0;
        int mes = 0;
        if (context.ContainsKey("obdobi"))
        {
            string obd = context["obdobi"].ToString();


            rok = Convert.ToInt32(obd.Substring(0, 4));
            mes = Convert.ToInt32(obd.Substring(4));
        }
        else
        {
            rok = Globals.AktObdobi.Year;
            mes = Globals.AktObdobi.Month;
        }
        DataTable datatb = CisProjekty.Select(Globals.AktObdobi);

        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "nazev");
        }
        else
        {
            data = datatb.Select("nazev = nazev", "nazev");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {

            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();

                itemData.Text = data[i]["cely_nazev"].ToString();
                itemData.Value = data[i]["id"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetDim1(RadComboBoxContext context)
    {
        int rok = 0;
        int mes = 0;
        if (context.ContainsKey("obdobi"))
        {
            string obd = context["obdobi"].ToString();
            // if (obd.Length != 10) return new RadComboBoxData();

            rok = Convert.ToInt32(obd.Substring(0, 4));
            mes = Convert.ToInt32(obd.Substring(4));
        }
        else
        {
            rok = Globals.AktObdobi.Year;
            mes = Globals.AktObdobi.Month;
        }

        DataTable datatb = null;
        if (CisZakazky.ZdrojProZakaznika == ZDROJ_ZAKAZEK.CIS_ZAKAZKY)
        {
            datatb = CisZakazky.Select(new DateTime(rok, mes, 1), string.Empty);
            datatb.Columns["cis_zakazky"].ColumnName = "projekt";
        }
        else if(ParametryDochazky.DIMENSION1==DIM_CISELNIK.CisProjektu)
        {
            datatb = CisProjekty.Select(new DateTime(rok, mes, 1), Globals.OsCislo);
            datatb.Columns["cislo"].ColumnName = "projekt";
        }
        else
            datatb = dch_poriz_ukolu.Projekty(new DateTime(rok, mes, 1));

        if (!datatb.Columns.Contains("cely_nazev"))
            datatb.Columns.Add("cely_nazev", typeof(string), "projekt + ' '+ nazev");

        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "nazev");
        }
        else
        {
            data = datatb.Select("nazev = nazev", "nazev");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                //string nazev=data[i]["nazev"].ToString();
                //string val = data[i]["projekt"].ToString();

                itemData.Text = data[i]["cely_nazev"].ToString();
                itemData.Value = data[i]["projekt"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetDim2(RadComboBoxContext context)
    {
        string obd = context["obdobi"].ToString();
        int rok = Convert.ToInt32(obd.Substring(0, 4));
        int mes = Convert.ToInt32(obd.Substring(4));
        DateTime obdobi = new DateTime(rok, mes, 1);

        string projekt = context["projekt"].ToString();
        DataTable datatb = null;
        if (DochazkaFunkce.IsZaloznaInvest(Globals.OsCislo))
        {
            if (context.ContainsKey("os_cislo"))
            {
                decimal ldc_os_cislo = Convert.ToDecimal(context["os_cislo"]);
                short cislo_pom = Convert.ToInt16(context["cislo_pom"]);
                datatb= CisZakazky.ZakazkyProInvest(ldc_os_cislo, cislo_pom, new DateTime(rok, mes, 1));              
            }
        }
        else if (ParametryDochazky.DIMENSION2 == DIM_CISELNIK.CisZakazek)
        {
            datatb = CisZakazky.Retrieve(obdobi);
            datatb.Columns["cis_zakazky"].ColumnName = "uloha";
        }
        else
        {
            datatb = dch_poriz_ukolu.Ulohy_pro_projekt(projekt, obdobi);
        }
        //datatb.Columns.Add("cely_nazev", typeof(string), "uloha + ' '+nazev");
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cely_nazev");
        }
        else
        {
            data = datatb.Select("nazev = nazev", "nazev");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["cely_nazev"].ToString();
                itemData.Value = data[i]["uloha"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;

    }
    [WebMethod(EnableSession = true)]
    public RadMenuItemData[] GetMenu(RadMenuItemData item, object context)
    {
        string appPath = this.Context.Request.ApplicationPath;

        IDictionary<string, object> contextDictionary = (IDictionary<string, object>)context;
        if (contextDictionary.ContainsKey("AppPath"))
        {
            appPath = contextDictionary["AppPath"].ToString();
        }

        string headValue = item == null ? "[%KS Portál%]" : item.Value;

        var menu = TMenu.GetMenu("[%KS Portál%]", -1).AsEnumerable().OrderBy(x => GetNullOrData.GetInt32(x["id"]));
        int headId = item.Attributes.ContainsKey("id") ? (int)item.Attributes["id"] : (from m in menu
                                                                                       where GetNullOrData.GetString(m["value"], true) == headValue
                                                                                       select GetNullOrData.GetInt32(m["id"], 0)).FirstOrDefault();
        var pom = from m in menu
                  where GetNullOrData.GetInt32(m["parent"], 0) == headId
                  select new
                  {
                      id = GetNullOrData.GetInt32(m["id"], 0),
                      parent = GetNullOrData.GetInt32(m["parent"], 0),
                      Text = GetNullOrData.GetString(m["title"], true),
                      NavigateUrl = string.IsNullOrEmpty(GetNullOrData.GetString(m["url"], true)) ? null : (appPath + "/" + GetNullOrData.GetString(m["url"], true)),
                      Value = GetNullOrData.GetString(m["value"], true),
                      Enabled = GetNullOrData.GetString(m["enabled"], true).ToLower() == "true",
                      ImageUrl = GetNullOrData.GetString(m["imageurl"], true),
                      ExpandMode = menu.ToList().Exists(x => GetNullOrData.GetInt32(x["parent"], 0) == GetNullOrData.GetInt32(m["id"], 0)) ? MenuItemExpandMode.WebService : MenuItemExpandMode.ClientSide
                  };

        List<RadMenuItemData> list = new List<RadMenuItemData>() { };
        foreach (var i in pom)
        {
            RadMenuItemData it = new RadMenuItemData();
            it.Attributes["id"] = i.id;
            it.Attributes["parent"] = i.parent;
            it.Text = i.Text;
            it.NavigateUrl = i.NavigateUrl;
            it.Value = i.Value;
            it.Enabled = i.Enabled;
            //it.DisabledImageUrl = HttpContext.Current.Request.UrlReferrer.AbsoluteUri + "ImagesN/AccessDenied.png";
            it.ImageUrl = i.ImageUrl == null ? null : HttpContext.Current.Request.Url.AbsoluteUri.Remove(HttpContext.Current.Request.Url.AbsoluteUri.IndexOf(System.Web.HttpRuntime.AppDomainAppVirtualPath) + System.Web.HttpRuntime.AppDomainAppVirtualPath.Length) + i.ImageUrl?.Replace("~", "");
            it.ExpandMode = i.ExpandMode;
            list.Add(it);
        }
        return list.ToArray();
    }

    /// <summary>
    /// Načtení procesu požadavku
    /// </summary>
    /// <param name="startRowIndex"></param>
    /// <param name="maximumRows"></param>
    /// <param name="sortExpression"></param>
    /// <param name="filterExpression"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public ResultData GetDataAndCounWFProcess(int startRowIndex, int maximumRows, List<GridSortExpression> sortExpression, List<GridFilterExpression> filterExpression)
    {
        ResultData data = new ResultData();
        object o = SessionInfo.GetVariable(Pozadavek.AktualniIdPozKey);
        DataTable table = new DataTable();
        int rcount = 0;
        List<object> lst = new List<object>();
        if (o != null)
        {

            table = KSProgram.Pozadavky.WorkflowProces.Retrieve(Convert.ToInt32(o));
            rcount = table.Rows.Count;
            for (int i = 0; i < table.Rows.Count; i++)
            {
                var v = new
                {
                    poradi = table.Rows[i]["poradi"],
                    faze_text = table.Rows[i]["faze_text"],
                    faze = (table.Rows[i]["stav"].ToString().Trim() != "diskuse" ? table.Rows[i]["faze"] : null),
                    stav = table.Rows[i]["stav"],
                    duvod = table.Rows[i]["duvod"],
                    datum = table.Rows[i]["datum"],
                    uziv_a_zastup = table.Rows[i]["uziv_a_zastup"]
                };
                lst.Add(v);
            }
        }
        data.Data = lst;
        data.Count = rcount; ;

        return data;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetJazykyStupen(RadComboBoxContext context)
    {
        //DataTable datatb = CisKzam.Seznam(false);
        DataTable datatb = CisUniv.Seznam(43);
        DataRow[] data = null;
        if (!string.IsNullOrEmpty(context.Text))
        {
            data = datatb.Select("vyznam LIKE '%" + context.Text + "%'", "cislo");
        }
        else
        {
            data = datatb.Select("cislo = cislo");
        }


        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
        RadComboBoxData comboData = new RadComboBoxData();
        try
        {
            int itemsPerRequest = 10;
            int itemOffset = context.NumberOfItems;
            int endOffset = itemOffset + itemsPerRequest;
            if (endOffset > data.Length)
            {
                endOffset = data.Length;
            }
            if (endOffset == data.Length)
            {
                comboData.EndOfItems = true;
            }
            else
            {
                comboData.EndOfItems = false;
            }
            result = new List<RadComboBoxItemData>(endOffset - itemOffset);
            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = data[i]["vyznam"].ToString();
                itemData.Value = data[i]["cislo"].ToString();

                result.Add(itemData);
            }

            if (data.Length > 0)
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
            }
            else
            {
                comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
            }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;
    }

    /// <summary>
    /// Slouží pro získání stavů požadavků podle id_poz
    /// </summary>
    /// <param name="context"></param>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetStavyPozPodp(RadComboBoxContext context)
    {
        
        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>();
        RadComboBoxData comboData = new RadComboBoxData();
        DataTable stavy = new DataTable("stavy");
        stavy.Columns.Add("nazevStavu", typeof(string));
        stavy.Columns.Add("hodnotaStavu", typeof(string));
        try
        {
            int id_pozadavku = Convert.ToInt32(context["id_poz"]);
        List<KeyValuePair<string, string>> seznamPoz = DokumentyVystavene.GetNasledneStavyPozadavku(id_pozadavku);

        foreach (var item in seznamPoz)
        {
            RadComboBoxItemData itemData = new RadComboBoxItemData();
            itemData.Text = item.Value; 
            itemData.Value = item.Key;

            result.Add(itemData);
        }
        }
        catch (Exception e)
        {
            comboData.Message = e.Message;
        }

        comboData.Items = result.ToArray();
        return comboData;
 
    }

    [WebMethod(EnableSession = true)]
    public RadComboBoxData GetBudgety(RadComboBoxContext context)
    {
        RadComboBoxData comboData = new RadComboBoxData();

        string obd = context["obdobi"].ToString();
        int rok = Convert.ToInt32(obd.Substring(2, 4));
        int mes = Convert.ToInt32(obd.Substring(0, 2));
        DateTime obdobi = new DateTime(rok, mes, 1);

        decimal os_cislo = Convert.ToDecimal(context["os_cislo"]);
        short cislo_pom = Convert.ToInt16(context["cislo_pom"]);
        int kod = Convert.ToInt32(context["kod"]);

        List<RadComboBoxItemData> result = new List<RadComboBoxItemData>();

        List<OSC_POMER> osc = new List<OSC_POMER>();
        osc.Add(new OSC_POMER { Os_cislo = os_cislo, Cislo_pom=cislo_pom });
        List<int> kody = new List<int>();
        kody.Add(kod);
        List<BudgetyProKod> budgety = Pozadavekbudget.getIdBudgetuProZamestnance(osc, kody, obdobi) ?? new List<BudgetyProKod>();
        foreach (BudgetyProKod b in budgety)
        {
            foreach (int b2 in b.budgety)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = b2.ToString() + "-" + Pozadavekbudget.getNazevBudgetu(b2);
                itemData.Value = b2.ToString();
                result.Add(itemData);
            }
        }
        comboData.Items=result.ToArray();
        return comboData;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public  List<CisDivize> GetDivize()
    {
        List<CisDivize> ret = new List<CisDivize>();
        CisDivize cis = new CisDivize();
        DataTable divize=cis.VsechnyDivize();
        ret=divize.ToList<CisDivize>();

        return ret;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public List<CisSkupStred> GetSkupStred()
    {
        List<CisSkupStred> ret = new List<CisSkupStred>();
        CisSkupStred cis = new CisSkupStred();
        DataTable skupiny = cis.VsechnySkupiny();

        ret = skupiny.ToList<CisSkupStred>();
        return ret;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public List<CisStredisko> GetStrediska(bool prava, string typ_stred)
    {
        List<CisStredisko> ret = new List<CisStredisko>();

        CisStredisko cis = new CisStredisko();

        cis.RadkovePrava = true;
        if (!prava)
            cis.RadkovePrava = false;

        DataTable table = new DataTable();
        if (typ_stred=="all")
        {
            table = cis.VsechnaStrediska(Globals.AktObdobi, Globals.AktObdobi);
        }
        else if (typ_stred=="kmenova")
        {
            table = cis.PristupnaKmenStrediska(Globals.AktObdobi, false);
        }
        else if (typ_stred=="pracovni")
        {
            table = cis.PristupnaPracStrediska(Globals.AktObdobi, false);
        }
       
        ret = table.ToList<CisStredisko>();
        //PH musím upravit text ve sloupci cely_nazev, kolem pomlčky musí být mezery, ať je to stejné a taky v strskupdiv to potřebuju abych rozlišil pomlčku, která odděluje středisko od názvu
        //od pomlčky v čísle střediska
        foreach (CisStredisko s in ret)
            s.cely_nazev = s.str.Trim() + " - " + s.nazev.Trim();

        return ret;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    [WebMethod(EnableSession = true)]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
    public List<CisPodniky> GetPodniky()
    {
        List<CisPodniky> ret = new List<CisPodniky>();
        List<int> pp_list = ViceIco.GetPodnikyPristupnych();
        foreach (int p in pp_list)
        {
            CisPodniky it = new CisPodniky();
            it.id_podniku = p;
            it.nazev= CisPodniky.Nazev(p);
            it.cely_nazev = p + " - " + it.nazev;
            ret.Add(it);
        }

        return ret;
    }
}

