﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Script.Services;
using System.Web.SessionState;
using Telerik.Web.UI;
using KSProgram.Reminder;
using System.Runtime.Serialization;
using System.Web.Script.Serialization;
using KSProgram.Funkce;
using KSProgram;

namespace KSPortal.PrivateWebServices
{
    /// <summary>
    /// RadScheduler data service.
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService]
    public class SchedulerWebService : WebService
    {
        public SchedulerWebService()
        {

        }

        private WebServiceAppointmentController _controller;
        //private MySchedulerInfo localSchedulerInfo;
        private KsSchedulerProvider _provider;
        private KsSchedulerProvider Provider
        {
            get
            {
                if (_provider == null)
                {
                    _provider = new KsSchedulerProvider();
                }
                return _provider;
            }
        }

        /// <summary>
        /// The WebServiceAppointmentController class is used as a facade to the SchedulerProvider.
        /// </summary>
        private WebServiceAppointmentController Controller
        {
            get
            {
                if (_controller == null)
                {
                    _controller = new WebServiceAppointmentController(Provider);
                }

                return _controller;
            }
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> GetAppointments(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo)
        {
            return Controller.GetAppointments(schedulerInfo);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> InsertAppointment(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo, AppointmentData appointmentData)
        {
            return Controller.InsertAppointment(schedulerInfo, appointmentData);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> UpdateAppointment(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo, AppointmentData appointmentData)
        {
            return Controller.UpdateAppointment(schedulerInfo, appointmentData);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> CreateRecurrenceException(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo, AppointmentData recurrenceExceptionData)
        {
            return Controller.CreateRecurrenceException(schedulerInfo, recurrenceExceptionData);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> RemoveRecurrenceExceptions(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo, AppointmentData masterAppointmentData)
        {
            return Controller.RemoveRecurrenceExceptions(schedulerInfo, masterAppointmentData);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<AppointmentData> DeleteAppointment(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo, AppointmentData appointmentData, bool deleteSeries)
        {
            return Controller.DeleteAppointment(schedulerInfo, appointmentData, deleteSeries);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public IEnumerable<ResourceData> GetResources(KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo)
        {
            return Controller.GetResources(schedulerInfo);
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        [System.Web.Script.Services.ScriptMethod]
        public ZamKalendar.KalendarZamestnanceResult GetKalendareZamestnancu(int startRowIndex, int maximumRows, string sortExpression, string filterExpression)
        {
            //SchedulerInfo info = new SchedulerInfo();
            //info.ViewStart = F_DateTime.PrvniDen(mesic);
            //info.ViewEnd = F_DateTime.PosledniDenMinuta(mesic);

            //KSProgram.Reminder.ZamKalendar.KsSchedulerInfo schedulerInfo = new ZamKalendar.KsSchedulerInfo(info, kalendare, pozadavky, oscisla);

            //IEnumerable<AppointmentData> list = Controller.GetAppointments(schedulerInfo);

            return ZamKalendar.GetZamestnaneciUdalosti(startRowIndex, maximumRows, sortExpression, filterExpression);
        }
    }
}
