﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Obecne;
using System;
using System.Collections.Specialized;


namespace KSPortal.Public
{
    public partial class ActivateAccount : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            string registrace = AppConfiguration.GetAppSetting<string>("Registrace", null);
            if (registrace != "user")
                throw new System.Security.SecurityException("Přístup byl zamítnut");

            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                QueryStringCrypto qc = new QueryStringCrypto();
                NameValueCollection nvColl = qc.DecryptRequestQuery();
                string login = nvColl["login"];
                RL_Login.Text = login;
            }
        }

        protected void TRB_Confirm_Click(object sender, EventArgs e)
        {
            QueryStringCrypto qc = new QueryStringCrypto();
            NameValueCollection nvColl = qc.DecryptRequestQuery();
            if (nvColl.Count == 0)
            {
                RL_ResultMessage.Text = ReadGlobalResource.ZmenaTextu("[%Aktivační odkaz je neplatný%]");
                return;
            }
            string dbName = nvColl["dbName"];
            string login = nvColl["login"];
            string pKod = nvColl["pKod"];

            string message = string.Empty;

            Globals.Db = DatabasePodleParam.Create(dbName);

            string sqlAktiv = "select aktivovan from prtl_users where login = " + SqlPrikaz.ValueToString(login);
            string aktivovan = SqlPrikaz.ExecuteScalar<string>(sqlAktiv, null);
            if (aktivovan == "a")
            {
                message = ReadGlobalResource.ZmenaTextu("[%Účet byl již aktivován%]");
            }
            else
            {
                string sqlCom = "update prtl_users set p_kod = null, aktivovan = 'a'" +
                " where p_kod = " + SqlPrikaz.ValueToString(pKod);
                int rowsAffected = SqlPrikaz.ExecuteNonQuery(sqlCom);
                if (rowsAffected >= 1) //pokud jsou nastaveny nejake triegry, tak výsledek nemusí být 1, ale více jak jedna
                {
                    message = ReadGlobalResource.ZmenaTextu("[%Aktivace proběhla v pořádku%]");
                }
                else
                {
                    message = ReadGlobalResource.ZmenaTextu("[%Aktivační odkaz je neplatný%]");
                }
            }

            RL_ResultMessage.Text = message;
        }
    }
}