﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Funkce;
using KSProgram.WebControls;
using KSProgram.Data;
using System.Data.Common;
using KSProgram.Security;
using KSProgram.Diagnostics;
using KSProgram.Extensions;
using KSProgram.Uchazeci;

namespace KSPortal.Public
{
    //public partial class CVUchForm : System.Web.UI.Page // TPrePage
    public partial class CVUchForm : TPrePage // MZ 13.10.2015 Musí být zděděno z 'TPrePage', aby se překládaly texty.
    {

        #region Vlastnosti
        protected DataTable dataSkola
        {
            get
            {
                DataTable table = (DataTable)ViewState["skola"];
                return table;
            }
            set
            {
                ViewState["skola"] = value;
            }
        }
        protected DataTable dataOsobniUdaje
        {
            get
            {
                DataTable table = (DataTable)ViewState["uchazec"];
                return table;
            }
            set
            {
                ViewState["uchazec"] = value;
            }
        }
        protected DataTable dataPraxe
        {
            get
            {
                DataTable table = (DataTable)ViewState["praxe"];
                return table;
            }
            set
            {
                ViewState["praxe"] = value;
            }

        }
        protected DataTable dataJazyky
        {
            get
            {
                DataTable table = (DataTable)ViewState["jazyky"];
                return table;
            }
            set
            {
                ViewState["jazyky"] = value;
            }
        }
        protected DataTable dataKontakty
        {
            get
            {
                DataTable table = (DataTable)ViewState["kontakty"];
                return table;
            }
            set
            {
                ViewState["kontakty"] = value;
            }
        }
        protected DataTable dataDokumenty
        {
            get
            {
                DataTable table = (DataTable)ViewState["dokumenty"];
                return table;
            }
            set
            {
                ViewState["dokumenty"] = value;
            }
        }
        protected DataTable dataHledanaPrace
        {
            get
            {
                DataTable table = (DataTable)ViewState["hledanaPrace"];
                return table;
            }
            set
            {
                ViewState["hledanaPrace"] = value;
            }
        }
        protected DataTable dataKurzy
        {
            get
            {
                DataTable table = (DataTable)ViewState["kurzy"];
                return table;
            }
            set
            {
                ViewState["kurzy"] = value;
            }
        }
        #endregion

        private void InitDataTable()
        {
            // OSOBNÍ ÚDAJE
            if (dataOsobniUdaje == null)
            {
                DataTable tableUchazeci = KSProgram.Personal.Uchazec.OsobniUdajeEmpty();
                dataOsobniUdaje = tableUchazeci;
                //BindFVOsobniUdaje();
            }
            else
            {
                dataOsobniUdaje.Clear();
            }
            // ŠKOLA
            if (dataSkola == null)
            {
                DataTable tableSkola = KSProgram.Personal.Uchazec.VzdelaniEmpty();
                dataSkola = tableSkola;
                //BindTGVVzdelani();
            }
            else
            {
                dataSkola.Clear();
            }
            // PRAXE
            if (dataPraxe == null)
            {
                DataTable tablePraxe = KSProgram.Personal.Uchazec.PraxeEmpty();
                dataPraxe = tablePraxe;
                //BindTGVPraxe();
            }
            else
            {
                dataPraxe.Clear();
            }
            // JAZYKY
            if (dataJazyky == null)
            {
                DataTable tableJazyky = KSProgram.Personal.Uchazec.JazykyEmpty();
                dataJazyky = tableJazyky;
                //BindTGVJazyky();
            }
            else
            {
                dataJazyky.Clear();
            }
            // KONTAKTY
            if (dataKontakty == null)
            {
                DataTable tableKontakty = new DataTable("u_telefony");
                tableKontakty.Columns.Add("os_cislo", typeof(decimal));
                tableKontakty.Columns.Add("tel_cislo", typeof(string));
                tableKontakty.Columns.Add("tel_kam", typeof(string));

                dataKontakty = tableKontakty;
            }
            else
            {
                dataKontakty.Clear();
            }
            // HLEDANÁ PRÁCE
            if (dataHledanaPrace == null)
            {
                DataTable tableHledanaPrace = KSProgram.Personal.Uchazec.HledanaPraceEmpty();
                dataHledanaPrace = tableHledanaPrace;
            }
            else
            {
                dataHledanaPrace.Clear(); // MZ 18.2.2014 Doplněno
            }
            // PŘIJATÉ DOKUMENTY
            if (dataDokumenty == null)
            {
                DataTable tableDokumenty = KSProgram.Personal.Uchazec.DokumentyPrijateEmpty();
                //tableDokumenty.Columns.Add("BinaryData", typeof(System.Data.SqlTypes.SqlBinary));
                dataDokumenty = tableDokumenty;
            }
            else
            {
                dataDokumenty.Clear(); // MZ 18.2.2014 Doplněno
            }
            // KURZY
            if (dataKurzy == null)
            {
                DataTable tableKurzy = KSProgram.Personal.Uchazec.KurzyEmpty();
                dataKurzy = tableKurzy;
            }
            else
            {
                dataKurzy.Clear(); // MZ 18.2.2014 Doplněno
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                if (KSProgram.Globals.Db == null)
                {
                    KSProgram.Globals.Db = KSProgram.Data.DatabasePodleParam.Create(null); // MZ 28.4.2017 Doplněno.
                }

                InitDataTable();

                // DataBind - Osobní údaje
                BindFVOsobniUdaje();
                FVOsobniUdaje.ChangeMode(FormViewMode.Insert);
                FVOsobniUdaje.InsertItem(false);
                FVOsobniUdaje.ChangeMode(FormViewMode.Edit);
                BindFVOsobniUdaje();
                ((DropDownList)FVOsobniUdaje.FindControl("ddlStPrisl")).SelectedValue = "203";
                // Databind - ostatní
                BindTGVVzdelani();
                BindTGVPraxe();
                BindTGVJazyky();
                BindTGVHledanaPrace();
                BindTGVDokumenty();
                BindTGVKurzy();

                // Souhlas s evidencí
                if (lSouhlas.Text == "")
                {
                    lSouhlas.Text = Get101Info();
                }
                // Text po odeslání

                //switch (KSProgram.Zakaznik.GetCustomer())
                string zakaznik = KSProgram.Zakaznik.GetCustomer();
                switch (zakaznik)
                {
                    case "MOR SLEZ KRAJ":
                        pas_2.Visible = true;
                        lSendOK.Font.Size = 8;
                        lSendOK.Text = "Děkujeme Vám za vyplnění elektronického formuláře pro uchazeče o přijetí do pracovního poměru. Podmínkou zařazení uchazeče je nutné doložit doklady dle zákona č. 312/2002 Sb., o úřednících územně samosprávných celků a o změně některých zákonů, ve znění pozdějších předpisů; požadované doklady jsou uvedeny také v oznámení o vyhlášení výběrového řízení.";
                        panelOdkazy.Visible = true;
                        break;
                    default:
                        pas_1.Visible = true;
                        L_SendOK_1.Text = "Vaše údaje byly odeslány. Děkujeme za vyplnění.";
                        break;
                }

                RC_captcha.ErrorMessage = WebControlHelper.ZmenaTextu("[%Neopsali jste správně text z obrázku%]");
                l_captcha.Text = WebControlHelper.ZmenaTextu("[%Opište text z obrázku%]");
                RC_captcha.CaptchaLinkButtonText = WebControlHelper.ZmenaTextu("[%Generovat nový obrázek%]");
            }
        }

        protected void RadTabStrip1_TabClick(object sender, Telerik.Web.UI.RadTabStripEventArgs e)
        {
            if (RadTabStrip1.SelectedIndex == 0)
            {
                RadTabStrip1.ValidationGroup = "ValGroupOsUdaje";
            }
            if (RadTabStrip1.SelectedIndex == 1)
            {
                RadTabStrip1.ValidationGroup = "ValGroupSkola";
            }
            if (RadTabStrip1.SelectedIndex == 2)
            {
                RadTabStrip1.ValidationGroup = "ValGroupPraxe";
            }
            if (RadTabStrip1.SelectedIndex == 3)
            {
                RadTabStrip1.ValidationGroup = "";
            }
            if (RadTabStrip1.SelectedIndex == 4)
            {
                RadTabStrip1.ValidationGroup = "ValGroupHledanaPrace";
            }
            if (RadTabStrip1.SelectedIndex == 5)
            {
                RadTabStrip1.ValidationGroup = "ValGroupDokumenty";
            }
        }

        #region DataBind
        private void BindFVOsobniUdaje()
        {
            if (dataOsobniUdaje != null)
            {
                FVOsobniUdaje.DataSource = dataOsobniUdaje;
                FVOsobniUdaje.DataBind();
            }
        }
        private void BindFormViewSkola()
        {
            if (dataSkola != null)
            {
                FVSkola.DataSource = dataSkola;
                FVSkola.DataBind();
            }
        }
        private void BindTGVVzdelani()
        {
            if (dataSkola != null)
            {
                TGVVzdelani.DataSource = dataSkola;
                TGVVzdelani.DataBind();
            }
        }
        private void BindTGVPraxe()
        {
            if (dataPraxe != null)
            {
                TGVPraxe.DataSource = dataPraxe;
                TGVPraxe.DataBind();
            }
        }
        private void BindFVPraxe()
        {
            if (dataPraxe != null)
            {
                FVPraxe.DataSource = dataPraxe;
                FVPraxe.DataBind();
            }
        }
        private void BindTGVJazyky()
        {
            if (dataJazyky != null)
            {
                TGVJazyky.DataSource = dataJazyky;
                TGVJazyky.DataBind();
            }
        }
        private void BindFVJazyk()
        {
            if (dataJazyky != null)
            {
                FVJazyk.DataSource = dataJazyky;
                FVJazyk.DataBind();
            }
        }
        private void BindTGVDokumenty()
        {
            if (dataDokumenty != null)
            {
                TGVDokumenty.DataSource = dataDokumenty;
                TGVDokumenty.DataBind();
            }
        }
        private void BindFVDokumenty()
        {
            if (dataDokumenty != null)
            {
                FVDokumenty.DataSource = dataDokumenty;
                FVDokumenty.DataBind();
            }
        }
        private void BindTGVHledanaPrace()
        {
            if (dataHledanaPrace != null)
            {
                TGVHledanaPrace.DataSource = dataHledanaPrace;
                TGVHledanaPrace.DataBind();
            }
        }
        private void BindFVHledanaPrace()
        {
            if (dataHledanaPrace != null)
            {
                FVHledanaPrace.DataSource = dataHledanaPrace;
                FVHledanaPrace.DataBind();
            }
        }
        private void BindTGVKurzy()
        {
            if (dataKurzy != null)
            {
                TGVKurzy.DataSource = dataKurzy;
                TGVKurzy.DataBind();
            }
        }
        private void BindFVKurzy()
        {
            if (dataKurzy != null)
            {
                FVKurzy.DataSource = dataKurzy;
                FVKurzy.DataBind();
            }
        }
        #endregion

        #region Zobrazení
        private void MVZobrazeni_Vzdelani(string aOblastZobrazeni)
        {
            bool skolaDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "SkolaDetail":
                    skolaDetail = true;
                    break;
            }

            TGVVzdelani.Visible = seznamy;
            FVSkola.Visible = skolaDetail;
            lbtnVzdelani_insert.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        private void MVZobrazeni_Praxe(string aOblastZobrazeni)
        {
            bool praxeDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "PraxeDetail":
                    praxeDetail = true;
                    break;
            }

            TGVPraxe.Visible = seznamy;
            FVPraxe.Visible = praxeDetail;
            lbtnPraxe_insert.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        private void MVZobrazeni_Jazyky(string aOblastZobrazeni)
        {
            bool jazykDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "JazykDetail":
                    jazykDetail = true;
                    break;
            }

            TGVJazyky.Visible = seznamy;
            FVJazyk.Visible = jazykDetail;
            lbtnJazykyInsert.Visible = seznamy;
            //chbRidicB.Visible = seznamy;
            PanelRidicaky.Visible = seznamy;
            TGVKurzy.Visible = seznamy;
            lbtnInsertKurz.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        private void MVZobrazeni_Kurzy(string aOblastZobrazeni)
        {
            bool kurzDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "KurzDetail":
                    kurzDetail = true;
                    break;
            }

            TGVKurzy.Visible = seznamy;
            FVKurzy.Visible = kurzDetail;
            lbtnInsertKurz.Visible = seznamy;
            //chbRidicB.Visible = seznamy;
            PanelRidicaky.Visible = seznamy;
            TGVJazyky.Visible = seznamy;
            lbtnJazykyInsert.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        private void MVZobrazeni_HledanaPrace(string aOblastZobrazeni)
        {
            bool praceDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "HledanaPraceDetail":
                    praceDetail = true;
                    break;
            }

            TGVHledanaPrace.Visible = seznamy;
            FVHledanaPrace.Visible = praceDetail;
            lbtnInsertHledanaPrace.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        private void MVZobrazeni_Dokumenty(string aOblastZobrazeni)
        {
            bool dokumentyDetail = false;
            bool seznamy = false;

            switch (aOblastZobrazeni)
            {
                case "Seznamy":
                    seznamy = true;
                    break;
                case "DokumentyDetail":
                    dokumentyDetail = true;
                    break;
            }

            TGVDokumenty.Visible = seznamy;
            FVDokumenty.Visible = dokumentyDetail;
            lbtnInsertDokumenty.Visible = seznamy;
            RadTabStrip1.Enabled = seznamy;
        }
        #endregion

        #region Osobní údaje
        protected void FVOsobniUdaje_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = (DataTable)ViewState["uchazec"];
            DataRow dr;
            Object obj;
  
            dt.Clear();
            dr = dt.NewRow();

            obj = FVOsobniUdaje.FindControl("tbPrijmeni");
            dr["prijmeni"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 24, "tbPrijmeni");
            obj = FVOsobniUdaje.FindControl("tbJmeno");
            dr["jmeno"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 24, "tbJmeno");
            obj = FVOsobniUdaje.FindControl("tbTitul");
            dr["titul"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 25, "tbTitul");
            obj = FVOsobniUdaje.FindControl("tbTitulZa");
            dr["titul_za"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 15, "tbTitulZa");
            obj = FVOsobniUdaje.FindControl("ddlStPrisl");
            dr["st_prisl"] = (obj == null) ? "203" : InputChecker.Text(((DropDownList)obj).SelectedValue, 3, "ddlStPrisl");
            obj = FVOsobniUdaje.FindControl("dpRodneCislo");
            dr["rodne_cislo"] = (obj == null) ? "" : ((TRadDatePicker)obj).SelectedDate.Value.ToString("dd.MM.yyyy");
            obj = FVOsobniUdaje.FindControl("ddlPohlavi");
            dr["pohlavi"] = (obj == null) ? "m" : InputChecker.Text(((DropDownList)obj).SelectedValue, 1, "ddlPohlavi");
            obj = FVOsobniUdaje.FindControl("ddlRodinStav");
            dr["rodin_stav"] = (obj == null) ? "1" : InputChecker.Text(((DropDownList)obj).SelectedValue, 1, "ddlRodinStav");
            obj = FVOsobniUdaje.FindControl("tbMistoNarozeni");
            dr["misto_narozeni"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 48, "tbMistoNarozeni");
            obj = FVOsobniUdaje.FindControl("tbTelefon");
            dr["telefon"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 50, "tbTelefon");
            obj = FVOsobniUdaje.FindControl("tbEmail");
            dr["email"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 50, "tbEmail");
            obj = FVOsobniUdaje.FindControl("tbTrUlice");
            dr["pr_ulice"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 30, "tbTrUlice");
            obj = FVOsobniUdaje.FindControl("tbTrCislo");
            dr["pr_cislo"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 14, "tbTrCislo");
            obj = FVOsobniUdaje.FindControl("tbMistoTrv");
            dr["misto_prech"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 48, "tbMistoTrv");
            obj = FVOsobniUdaje.FindControl("tbPSCTrv");
            dr["psc_prech"] = (obj == null) ? "" : InputChecker.Text(((TextBox)obj).Text, 5, "tbPSCTrv");
            dr["evid_od"] = DateTime.Today.Date;

            dt.Rows.Add(dr);

            BindFVOsobniUdaje();
        }
        protected void FVOsobniUdaje_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            DataTable dt = dataOsobniUdaje;

            DataRow dr;
            if (dt.Rows.Count > 0)
            {
                dr = dt.Rows[0];

                dr["prijmeni"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbPrijmeni")).Text, 24, "tbPrijmeni");
                dr["jmeno"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbJmeno")).Text, 24, "tbJmeno");
                dr["titul"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbTitul")).Text, 25, "tbTitul");
                dr["titul_za"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbTitulZa")).Text, 15, "tbTitulZa");
                //string pom = ((DropDownList)FVOsobniUdaje.FindControl("ddlStPrisl")).SelectedValue;
                dr["st_prisl"] = InputChecker.Text(((DropDownList)FVOsobniUdaje.FindControl("ddlStPrisl")).SelectedValue, 3, "ddlStPrisl");

                //dr["rodne_cislo"] = InputChecker.Text(((TRadDatePicker)FVOsobniUdaje.FindControl("dpRodneCislo")).SelectedDate.Value.ToString("dd.MM.yyyy"), 10, "dpRodneCislo");
                object oDatNar = ((TRadDatePicker)FVOsobniUdaje.FindControl("dpRodneCislo")).SelectedDate;
                dr["rodne_cislo"] = (oDatNar == null) ? "" : ((DateTime)oDatNar).ToString("dd.MM.yyyy");
                dr["pohlavi"] = InputChecker.Text(((DropDownList)FVOsobniUdaje.FindControl("ddlPohlavi")).SelectedValue, 1, "ddlPohlavi");
                dr["rodin_stav"] = InputChecker.Text(((DropDownList)FVOsobniUdaje.FindControl("ddlRodinStav")).SelectedValue, 1, "ddlRodinStav");
                dr["misto_narozeni"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbMistoNarozeni")).Text, 48, "tbMistoNarozeni");
                dr["telefon"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbTelefon")).Text, 50, "tbTelefon");
                dr["email"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbEmail")).Text, 50, "tbEmail");
                dr["pr_ulice"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbTrUlice")).Text, 30, "tbTrUlice");
                dr["pr_cislo"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbTrCislo")).Text, 14, "tbTrCislo");
                dr["misto_prech"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbMistoTrv")).Text, 48, "tbMistoTrv");
                dr["psc_prech"] = InputChecker.Text(((TextBox)FVOsobniUdaje.FindControl("tbPSCTrv")).Text, 5, "tbPSCTrv");
                dr["evid_od"] = DateTime.Today.Date;
                dt.GetChanges();

                BindFVOsobniUdaje();
            }
        }
        #endregion

        #region Vzdělání
        protected void lbtnVzdelani_insert_Command(object sender, CommandEventArgs e)
        {
            FVSkola.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_Vzdelani("SkolaDetail");
        }
        protected void lbtnCancelSkola_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_Vzdelani("Seznamy");

            BindTGVVzdelani();
        }
        protected void TGVVzdelani_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVSkola.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFormViewSkola(); // Musí se provést DataBind jinak se nezmění Page
        }
        protected void TGVVzdelani_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                // Reference na Edit(2) LinkButton
                LinkButton db = (LinkButton)e.Row.Cells[0].Controls[2];
                db.Attributes.Add("OnClick", "StopSwitch();");
            }
        }
        protected void TGVVzdelani_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_Vzdelani("SkolaDetail");
            FVSkola.ChangeMode(FormViewMode.Edit);

            if (FVSkola.DataItemCount == 0)
            {
                DataTable table = (DataTable)ViewState["skola"];
                FVSkola.DataSource = table;
                FVSkola.DataBind();
            }
        }
        protected void TGVVzdelani_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataSkola.Rows[e.RowIndex];
            dataSkola.Rows.Remove(row);
            BindTGVVzdelani();
        }
        protected void FVSkola_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVOsobniUdaje.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVOsobniUdaje.ChangeMode(e.NewMode);
            }
            else
                FVOsobniUdaje.ChangeMode(e.NewMode);

            BindFormViewSkola();
        }
        protected void FVSkola_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVSkola.DataKey.Value);
            DataTable dt = ViewState["skola"] as DataTable;
            DataRow dr;
            string pom;
            Object dbNull;

            dbNull = DBNull.Value;
            dr = dt.Rows.Find(id);

            dr["stupen"] = InputChecker.Text(((DropDownList)FVSkola.FindControl("ddlStupen")).SelectedValue, 3, "ddlStupen");
            dr["obor"] = InputChecker.Text(((DropDownList)FVSkola.FindControl("ddlObor")).SelectedValue, 8, "ddlObor");
            dr["skola"] = InputChecker.Text(((TextBox)FVSkola.FindControl("tbSkola")).Text, 100, "tbSkola");
            // Rok zahájení
            pom = ((TextBox)FVSkola.FindControl("tbRokZahaj")).Text;
            dr["rok_zahaj"] = (pom.Length > 0) ? Convert.ToInt32(pom) : dbNull;
            // Rok Ukončení
            pom = ((TextBox)FVSkola.FindControl("tbRokUkonc")).Text;
            dr["rok_ukonc"] = (pom.Length > 0) ? Convert.ToInt32(pom) : dbNull;

            //FormView1.ChangeMode(FormViewMode.ReadOnly);
            BindFormViewSkola();
            BindTGVVzdelani();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Vzdelani("Seznamy");
        }
        protected void FVSkola_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = ViewState["skola"] as DataTable;
            DataRow dr;
            Object pom;

            dr = dt.NewRow();
            //dr = dt.Rows.Find(id);

            dr["stupen"] = InputChecker.Text(((DropDownList)FVSkola.FindControl("ddlStupen")).SelectedValue, 3, "ddlStupen");
            dr["obor"] = InputChecker.Text(((DropDownList)FVSkola.FindControl("ddlObor")).SelectedValue, 8, "ddlObor");
            dr["skola"] = InputChecker.Text(((TextBox)FVSkola.FindControl("tbSkola")).Text, 100, "tbSkola");
            // Datum zahájení
            try
            {
                pom = Convert.ToInt16(((TextBox)FVSkola.FindControl("tbRokZahaj")).Text);
            }
            catch
            {
                pom = DBNull.Value;
            }
            dr["rok_zahaj"] = pom;
            // Datum ukončení
            try
            {
                pom = Convert.ToInt16(((TextBox)FVSkola.FindControl("tbRokUkonc")).Text);
            }
            catch
            {
                pom = DBNull.Value;
            }
            dr["rok_ukonc"] = pom;
            dt.Rows.Add(dr);

            //FormView1.ChangeMode(FormViewMode.ReadOnly);
            BindFormViewSkola();
            BindTGVVzdelani();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Vzdelani("Seznamy");
        }
        #endregion

        #region Praxe
        protected void lbtnPraxe_insert_Command(object sender, CommandEventArgs e)
        {
            FVPraxe.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_Praxe("PraxeDetail");
        }
        protected void lbtnCancelPraxe_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_Praxe("Seznamy");

            BindTGVPraxe();
        }
        protected void TGVPraxe_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVPraxe.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFVPraxe(); // Musí se provést DataBind jinak se nezmění Page
        }
        protected void TGVPraxe_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                // Reference na Edit(2) LinkButton
                //LinkButton db = (LinkButton)e.Row.Cells[0].Controls[2];
                //db.Attributes.Add("OnClick", "StopSwitch();");
            }
        }
        protected void TGVPraxe_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_Praxe("PraxeDetail");
            FVPraxe.ChangeMode(FormViewMode.Edit);

            if (FVPraxe.DataItemCount == 0)
            {
                BindFVPraxe();
            }
        }
        protected void TGVPraxe_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataPraxe.Rows[e.RowIndex];
            dataPraxe.Rows.Remove(row);
            BindTGVPraxe();
        }
        protected void TGVPraxe_DataBinding(object sender, EventArgs e)
        {
            TGridView tgv = (TGridView)sender;
            if (KSProgram.Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                tgv.Columns[3].Visible = false; // Profese - zneviditelnění
            }
        }
        protected void FVPraxe_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVPraxe.DataKey.Value);
            DataTable dt = dataPraxe;
            DataRow dr;
            string mes, rok;
            DateTime datum;
            Object nullDate = DBNull.Value;

            dr = dt.Rows.Find(id);

            dr["naz_org"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbNazOrg")).Text, 100, "tbNazOrg");
            dr["pozice"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbPozice")).Text, 100, "tbPozice");
            dr["profese"] = InputChecker.Text(((DropDownList)FVPraxe.FindControl("ddlProfese")).SelectedValue, 5, "ddlProfese");
            // Nástup
            mes = ((TextBox)FVPraxe.FindControl("tbMesicNastupu")).Text;
            rok = ((TextBox)FVPraxe.FindControl("tbRokNastupu")).Text;
            datum = new DateTime(Convert.ToInt32(rok), Convert.ToInt32(mes), 1);
            dr["datum_nastupu"] = datum;
            // Ukončení
            mes = ((TextBox)FVPraxe.FindControl("tbMesicUkonc")).Text;
            rok = ((TextBox)FVPraxe.FindControl("tbRokUkonc")).Text;
            if (mes.Length == 0 || rok.Length == 0)
            {
                dr["datum_ukonc"] = nullDate;
            }
            else
            {
                datum = new DateTime(Convert.ToInt32(rok), Convert.ToInt32(mes), 1);
                datum = datum.PosledniDen();
                dr["datum_ukonc"] = datum;
            }
            dr["mist_vyk_prace"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbMistVykPrace")).Text, 30, "tbMistVykPrace");
            dt.GetChanges();

            BindFVPraxe();
            BindTGVPraxe();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Praxe("Seznamy");
        }
        protected void FVPraxe_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = dataPraxe;
            DataRow dr;
            dr = dt.NewRow();
            string mes, rok;
            DateTime datum;
            //DateTime date = new DateTime();
            Object nullDate = DBNull.Value;

            dr["naz_org"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbNazOrg")).Text, 100, "tbNazOrg");
            dr["pozice"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbPozice")).Text, 100, "tbPozice");
            dr["profese"] = InputChecker.Text(((DropDownList)FVPraxe.FindControl("ddlProfese")).SelectedValue, 5, "ddlProfese");
            // Nástup
            mes = ((TextBox)FVPraxe.FindControl("tbMesicNastupu")).Text;
            rok = ((TextBox)FVPraxe.FindControl("tbRokNastupu")).Text;
            datum = new DateTime(Convert.ToInt32(rok), Convert.ToInt32(mes), 1);
            dr["datum_nastupu"] = datum;
            // Ukončení
            mes = ((TextBox)FVPraxe.FindControl("tbMesicUkonc")).Text;
            rok = ((TextBox)FVPraxe.FindControl("tbRokUkonc")).Text;
            if (mes.Length == 0 || rok.Length == 0)
            {
                dr["datum_ukonc"] = nullDate;
            }
            else
            {
                datum = new DateTime(Convert.ToInt32(rok), Convert.ToInt32(mes), 1);
                datum = datum.PosledniDen();
                dr["datum_ukonc"] = datum;
            }
            dr["mist_vyk_prace"] = InputChecker.Text(((TextBox)FVPraxe.FindControl("tbMistVykPrace")).Text, 30, "tbMistVykPrace");
            dt.Rows.Add(dr);

            BindFVPraxe();
            BindTGVPraxe();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Praxe("Seznamy");
        }
        protected void FVPraxe_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVPraxe.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVPraxe.ChangeMode(e.NewMode);
            }
            else
                FVPraxe.ChangeMode(e.NewMode);

            BindFVPraxe();
        }
        protected void FVPraxe_DataBound(object sender, EventArgs e)
        {
            FormView fv = (FormView)sender;
            if (KSProgram.Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                Control control = fv.FindControl("ddlProfese");
                if (control != null)
                {
                    control.Visible = false; // Profese - zneviditelnění
                }

                control = fv.FindControl("lProfese");
                if (control != null)
                {
                    control.Visible = false; // Profese - zneviditelnění
                }
            }
        }
        #endregion

        #region Znalosti a dovednosti
        protected void lbtnJazykyInsert_Command(object sender, CommandEventArgs e)
        {
            FVJazyk.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_Jazyky("JazykDetail");
        }
        protected void lbtnCancelJazyk_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_Jazyky("Seznamy");

            BindTGVJazyky();
        }
        protected void TGVJazyky_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVJazyk.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFVJazyk(); // Musí se provést DataBind jinak se nezmění Page
        }
        protected void TGVJazyky_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                // Reference na Edit(2) LinkButton
                //LinkButton db = (LinkButton)e.Row.Cells[0].Controls[2];
                //db.Attributes.Add("OnClick", "StopSwitch();");
            }
        }
        protected void TGVJazyky_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_Jazyky("JazykDetail");
            FVJazyk.ChangeMode(FormViewMode.Edit);

            if (FVJazyk.DataItemCount == 0)
            {
                BindFVJazyk();
            }
        }
        protected void TGVJazyky_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataJazyky.Rows[e.RowIndex];
            dataJazyky.Rows.Remove(row);
            BindTGVJazyky();
        }
        protected void FVJazyk_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVJazyk.DataKey.Value);
            DataTable dt = dataJazyky;
            DataRow dr;
            dr = dt.Rows.Find(id);

            dr["jazyk"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlJazyk")).SelectedValue, 10, "ddlJazyk");
            dr["stupen"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlStupen")).SelectedValue, 2, "ddlStupen");
            dr["druh_zkousky"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlDruhZkousky")).SelectedValue, 20, "ddlDruhZkousky");
            dt.GetChanges();

            BindFVJazyk();
            BindTGVJazyky();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Jazyky("Seznamy");
        }
        protected void FVJazyk_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = dataJazyky;
            DataRow dr;
            dr = dt.NewRow();

            dr["jazyk"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlJazyk")).SelectedValue, 10, "ddlJazyk");
            dr["stupen"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlStupen")).SelectedValue, 2, "ddlStupen");
            dr["druh_zkousky"] = InputChecker.Text(((DropDownList)FVJazyk.FindControl("ddlDruhZkousky")).SelectedValue, 20, "ddlDruhZkousky");

            dt.Rows.Add(dr);

            BindFVJazyk();
            BindTGVJazyky();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Jazyky("Seznamy");
        }
        protected void FVJazyk_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVJazyk.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVJazyk.ChangeMode(e.NewMode);
            }
            else
                FVJazyk.ChangeMode(e.NewMode);

            BindFVJazyk();
        }
        protected void TGVKurzy_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVKurzy.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFVKurzy();
        }
        protected void TGVKurzy_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataKurzy.Rows[e.RowIndex];
            dataKurzy.Rows.Remove(row);
            BindTGVKurzy();
        }
        protected void TGVKurzy_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            //if (e.Row.RowType == DataControlRowType.DataRow)
            //{
            //    LinkButton lb = (LinkButton)e.Row.Cells[0].Controls[2];
            //    lb.Attributes.Add("OnClick", "StopSwitch();");
            //}
        }
        protected void TGVKurzy_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_Kurzy("KurzDetail");
            FVKurzy.ChangeMode(FormViewMode.Edit);

            if (FVKurzy.DataItemCount == 0)
            {
                BindFVKurzy();
            }
        }
        protected void FVKurzy_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = dataKurzy;
            DataRow dr;
            Object nullValue = DBNull.Value;
            //string text = "";
            object obj;
            dr = dt.NewRow();

            dr["cis_osve"] = InputChecker.Text(((DropDownList)FVKurzy.FindControl("ddlKurz")).SelectedValue, 10, "ddlKurz");
            obj = FVKurzy.FindControl("dpPlatiDo");
            dr["plati_do"] = ((TRadDatePicker)obj).SelectedDate == null ? nullValue : ((TRadDatePicker)obj).SelectedDate.Value.ToString("dd.MM.yyyy");
            dr["skoleni"] = InputChecker.Text(((TextBox)FVKurzy.FindControl("tbNazevAkce")).Text, 100, "tbNazevAkce");

            dt.Rows.Add(dr);

            BindFVKurzy();
            BindTGVKurzy();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Kurzy("Seznamy");
        }
        protected void FVKurzy_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVKurzy.DataKey.Value);
            DataTable dt = dataKurzy;
            DataRow dr;
            Object nullValue = DBNull.Value;
            object obj;
            dr = dt.Rows.Find(id);

            dr["cis_osve"] = InputChecker.Text(((DropDownList)FVKurzy.FindControl("ddlKurz")).SelectedValue, 10, "ddlKurz");
            //dr["plati_do"] = ((TextBox)FVKurzy.FindControl("tbPlatiDo")).Text;
            obj = FVKurzy.FindControl("dpPlatiDo");
            dr["plati_do"] = ((TRadDatePicker)obj).SelectedDate == null ? nullValue : ((TRadDatePicker)obj).SelectedDate.Value.ToString("dd.MM.yyyy");
            dr["skoleni"] = InputChecker.Text(((TextBox)FVKurzy.FindControl("tbNazevAkce")).Text, 100, "tbNazevAkce");
            dt.GetChanges();

            BindFVKurzy();
            BindTGVKurzy();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Kurzy("Seznamy");
        }
        protected void FVKurzy_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVKurzy.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVKurzy.ChangeMode(e.NewMode);
            }
            else
                FVKurzy.ChangeMode(e.NewMode);

            BindFVKurzy();
        }
        protected void lbtnCancelKurz_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_Kurzy("Seznamy");

            BindTGVKurzy();
        }
        protected void lbtnInsertKurz_Command(object sender, CommandEventArgs e)
        {
            FVKurzy.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_Kurzy("KurzDetail");
        }
        #endregion

        #region Hledaná práce
        protected void lbtnInsertHledanaPrace_Command(object sender, CommandEventArgs e)
        {
            FVHledanaPrace.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_HledanaPrace("HledanaPraceDetail");
        }
        protected void lbtnCancelHledanaPrace_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_HledanaPrace("Seznamy");

            BindTGVHledanaPrace();
        }
        protected void TGVHledanaPrace_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVHledanaPrace.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFVHledanaPrace(); // Musí se provést DataBind jinak se nezmění Page
        }
        protected void TGVHledanaPrace_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            //if (e.Row.RowType == DataControlRowType.DataRow)
            //{
            //    // Reference na Edit(2) LinkButton
            //    LinkButton db = (LinkButton)e.Row.Cells[0].Controls[2];
            //    db.Attributes.Add("OnClick", "StopSwitch();");
            //}
        }
        protected void TGVHledanaPrace_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_HledanaPrace("HledanaPraceDetail");
            FVHledanaPrace.ChangeMode(FormViewMode.Edit);

            if (FVHledanaPrace.DataItemCount == 0)
            {
                DataTable table = (DataTable)ViewState["hledanaPrace"];
                FVHledanaPrace.DataSource = table;
                FVHledanaPrace.DataBind();
            }
        }
        protected void TGVHledanaPrace_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataHledanaPrace.Rows[e.RowIndex];
            dataHledanaPrace.Rows.Remove(row);
            BindTGVHledanaPrace();
        }
        protected void TGVHledanaPrace_DataBinding(object sender, EventArgs e)
        {
            TGridView tgv = (TGridView)sender;
            if (KSProgram.Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                tgv.Columns[2].Visible = false; // Očekávaný plat - zneviditelnění
            }
        }
        protected void FVHledanaPrace_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVHledanaPrace.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVHledanaPrace.ChangeMode(e.NewMode);
            }
            else
                FVHledanaPrace.ChangeMode(e.NewMode);

            BindFVHledanaPrace();
        }
        protected void FVHledanaPrace_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVHledanaPrace.DataKey.Value);
            DataTable dt = ViewState["hledanaPrace"] as DataTable;
            DataRow dr;

            dr = dt.Rows.Find(id);

            dr["profese"] = InputChecker.Text(((DropDownList)FVHledanaPrace.FindControl("ddlProfeseHP")).SelectedValue, 5, "ddlProfeseHP");
            //dr["plat"] = ((TextBox)FVHledanaPrace.FindControl("tbPlat")).Text;
            string str = ((TextBox)FVHledanaPrace.FindControl("tbPlat")).Text;
            if (!string.IsNullOrEmpty(str)) { dr["plat"] = Convert.ToDecimal(str); }

            BindFVHledanaPrace();
            BindTGVHledanaPrace();

            // Nastavení viditelnosti komponent
            MVZobrazeni_HledanaPrace("Seznamy");
        }
        protected void FVHledanaPrace_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = ViewState["hledanaPrace"] as DataTable;
            DataRow dr;
            
            dr = dt.NewRow();

            dr["profese"] = InputChecker.Text(((DropDownList)FVHledanaPrace.FindControl("ddlProfeseHP")).SelectedValue, 5, "ddlProfeseHP");
            string str = ((TextBox)FVHledanaPrace.FindControl("tbPlat")).Text;
            if (!string.IsNullOrEmpty(str)) { dr["plat"] = Convert.ToDecimal(str); }

            dt.Rows.Add(dr);

            BindFVHledanaPrace();
            BindTGVHledanaPrace();

            // Nastavení viditelnosti komponent
            MVZobrazeni_HledanaPrace("Seznamy");
        }
        protected void FVHledanaPrace_DataBound(object sender, EventArgs e)
        {
            FormView fv = (FormView)sender;
            if (KSProgram.Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                Control control = fv.FindControl("tbPlat");
                if (control != null)
                {
                    control.Visible = false; // Očekávaný plat - zneviditelnění
                }

                control = fv.FindControl("lPlat");
                if (control != null)
                {
                    control.Visible = false; // Očekávaný plat - zneviditelnění
                }
            }
        }
        protected void ddlProfeseHP_DataBinding(object sender, EventArgs e)
        {
            if (KSProgram.Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                odsProfese.SelectMethod = "ObsazovaneProfeseVeVR";
            }
        }
        #endregion

        #region Dokumenty přijaté
        protected void lbtnInsertDokumenty_Command(object sender, CommandEventArgs e)
        {
            FVDokumenty.ChangeMode(FormViewMode.Insert);

            // Nastavení viditelnosti komponent
            MVZobrazeni_Dokumenty("DokumentyDetail");
        }
        protected void lbtnCancelDokumenty_Command(object sender, CommandEventArgs e)
        {
            // Nastavení viditelnosti komponent
            MVZobrazeni_Dokumenty("Seznamy");

            BindTGVDokumenty();
        }
        protected void TGVDokumenty_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            FVDokumenty.PageIndex = Convert.ToInt32(e.CommandArgument);
            BindFVDokumenty(); // Musí se provést DataBind jinak se nezmění Page
        }
        //protected void TGVDokumenty_RowDataBound(object sender, GridViewRowEventArgs e)
        //{
        //    if (e.Row.RowType == DataControlRowType.DataRow)
        //    {
        //        // Reference na Edit(2) LinkButton
        //        LinkButton db = (LinkButton)e.Row.Cells[0].Controls[2];
        //        db.Attributes.Add("OnClick", "StopSwitch();");
        //    }
        //}
        protected void TGVDokumenty_SelectedIndexChanged(object sender, EventArgs e)
        {
            MVZobrazeni_Dokumenty("DokumentyDetail");
            FVDokumenty.ChangeMode(FormViewMode.Edit);

            if (FVDokumenty.DataItemCount == 0)
            {
                DataTable table = (DataTable)ViewState["dokumenty"];
                FVDokumenty.DataSource = table;
                FVDokumenty.DataBind();
            }
        }
        protected void TGVDokumenty_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            DataRow row = dataDokumenty.Rows[e.RowIndex];
            dataDokumenty.Rows.Remove(row);
            BindTGVDokumenty();
        }
        protected void FVDokumenty_ModeChanging(object sender, FormViewModeEventArgs e)
        {
            if (e.NewMode.ToString() == "Edit")
            {
                FVDokumenty.ChangeMode(e.NewMode);
            }
            else if (e.NewMode.ToString() == "Insert")
            {
                FVDokumenty.ChangeMode(e.NewMode);
            }
            else
                FVDokumenty.ChangeMode(e.NewMode);

            BindFVDokumenty();
        }
        protected void FVDokumenty_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            Int32 id = Convert.ToInt32(FVSkola.DataKey.Value);
            DataTable dt = ViewState["dokumenty"] as DataTable;
            DataRow dr;

            dr = dt.Rows.Find(id);

            dr["nazev_soubor"] = InputChecker.Text(((TextBox)FVDokumenty.FindControl("tbSoubor")).Text, 50, "tbSoubor");
            dr["typ_dokumentu"] = InputChecker.Text(((TextBox)FVDokumenty.FindControl("tbTypDok")).Text, 7, "tbTypDok");

            BindFVDokumenty();
            BindTGVDokumenty();

            // Nastavení viditelnosti komponent
            MVZobrazeni_Dokumenty("Seznamy");
        }
        protected void FVDokumenty_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            DataTable dt = dataDokumenty; //ViewState["dokumenty"] as DataTable;
            DataRow dr;

            dr = dt.NewRow();

            FileUpload fuControl = (FileUpload)FVDokumenty.FindControl("FileUploadControl");

            if (fuControl.HasFile)
            {
                string fileName = fuControl.FileName;
                dr["nazev_soubor"] = InputChecker.Text(fileName, 50, "nazev_soubor"); // ((TextBox)FVDokumenty.FindControl("tbSoubor")).Text;
                //dr["typ_dokumentu"] = ((TextBox)FVDokumenty.FindControl("tbTypDok")).Text;
                //dr["data"] = fuControl.FileBytes;
                byte[] data = fuControl.FileBytes;
                dr["typ_dokumentu"] = InputChecker.Text(((DropDownList)FVDokumenty.FindControl("ddlTypDok")).SelectedValue, 7, "ddlTypDok");
                dr["data"] = data;

                dt.Rows.Add(dr);

                // Data se uloží do Session
                // ------------------------
                // MZ 26.2.2014 Data se do session ukládat nebudou
                //string infoData = System.IO.Path.GetFileNameWithoutExtension(fileName);
                //Int64 id = Convert.ToInt64(dr["id_int"]);
                //string key = id.ToString() + "_" + infoData;
                //KSProgram.Obecne.SessionInfo.SetVariable(key, data);
                //KSTrace.WriteLine("[CVUchForm] SessionID = " + Session.SessionID);

                //// MZ 18.2.2014 Tes, zda se data správně uložila do session
                //byte[] dataTest = (byte[])KSProgram.Obecne.SessionInfo.GetVariable(key);
                //if (dataTest == null)
                //{
                //    throw new Exception("Dokument se nepodařilo vložit!");
                //}
            }

            BindFVDokumenty();
            BindTGVDokumenty();
            // Nastavení viditelnosti komponent
            MVZobrazeni_Dokumenty("Seznamy");

        }
        #endregion

        protected void Validate101(object source, ServerValidateEventArgs args)
        {
            args.IsValid = (chbSouhlas101.Checked == true);
        }
        protected void FVOsobniUdaje_PreRender(object sender, EventArgs e)
        {
            // MZ 29.9.2015 Změna údajů některých položek.
            if (KSProgram.Zakaznik.IsCurrent("VIADRUS")
                || KSProgram.Zakaznik.IsCurrent("MS_UTILITIES")
                || KSProgram.Zakaznik.IsCurrent("DEMOS_GROUP"))
            {
                Object obj = FVOsobniUdaje.FindControl("LDatNarRequired");
                ((Label)obj).Visible = false;

                obj = FVOsobniUdaje.FindControl("RequiredFieldValidatorDatNar");
                ((RequiredFieldValidator)obj).Enabled = false;

                obj = FVOsobniUdaje.FindControl("lBydlisteNadpis");
                ((Label)obj).Text = "Trvalé bydliště";
            }

            // MZ 12.10.2015 Změna údajů některých položek.
            if (KSProgram.Zakaznik.IsCurrent("DEMOS_GROUP"))
            {
                Object obj = FVOsobniUdaje.FindControl("L_EmailRequired");
                if (obj != null)
                {
                    ((Label)obj).Visible = true;
                }

                obj = FVOsobniUdaje.FindControl("tbEmail");
                if (obj != null)
                {
                    ((TextBox)obj).CssClass = "povinne-pole";
                }

                obj = FVOsobniUdaje.FindControl("RequiredFieldValidator_Email");
                if (obj != null)
                {
                    ((RequiredFieldValidator)obj).Enabled = true;
                }

                obj = FVOsobniUdaje.FindControl("L_TrUliceRequired");
                if (obj != null)
                {
                    ((Label)obj).Visible = true;
                }

                obj = FVOsobniUdaje.FindControl("tbTrUlice");
                if (obj != null)
                {
                    ((TextBox)obj).CssClass = "povinne-pole";
                }

                obj = FVOsobniUdaje.FindControl("RequiredFieldValidator_TrUlice");
                if (obj != null)
                {
                    ((RequiredFieldValidator)obj).Enabled = true;
                }
            }
        }
        protected void RadTabStrip1_PreRender(object sender, EventArgs e)
        {
            // MZ 29.9.2015 Změna údajů některých položek.
            if (KSProgram.Zakaznik.IsCurrent("VIADRUS") || KSProgram.Zakaznik.IsCurrent("MS_UTILITIES"))
            {
                ((Telerik.Web.UI.RadTabStrip)sender).Tabs[5].Text = "Životopis";
            }
        }
        protected void btnOdeslat_Click(object sender, EventArgs e)
        {
            string[] ins;
            string pom;
            bool zena;
            decimal? os_cislo;
            List<string> inserty;
            DataRow row;

            // Uložení osobních údajů
            FVOsobniUdaje.UpdateItem(true);

            // Kontrola zatržení souhlasu se 101
            RC_captcha.Validate();
            CustomValidator101.Validate();
            if (!Page.IsValid) return; // Není souhlas, nepokračuje se

            inserty = new List<string>();

            // Nové osobní číslo
            string sql = "SELECT max(os_cislo) FROM uchazeci";
            os_cislo = SqlPrikaz.ExecuteScalarDecimal(sql);
            // os_cislo = (os_cislo == null) ? 1 : os_cislo + 1;
            os_cislo = (os_cislo == null) ? 1 : os_cislo;

            short li_Pocet = 1;
            while (li_Pocet > 0) // MZ 14.3.2014 Přidán test archivu, stejně jak je to v těžkém klientovi.
            {
                os_cislo = os_cislo + 1;
                sql = "SELECT count(*) FROM u_archiv WHERE os_cislo = " + os_cislo.ToString();
                li_Pocet = SqlPrikaz.ExecuteScalarInt16(sql, 0);
            }

            // Osobní údaje
            // ============

            // Délka souhlasu s evidencí
            // -------------------------
            short delka101 = Uchazeci.GetDelkaSouhlasuSEvidenci();
            DateTime datSouh101 = DateTime.Today.AddMonths(delka101).AddDays(-1);
            dataOsobniUdaje.Rows[0]["dat_souhl101"] = datSouh101;

            // Úprava dat před vytvořením insertů
            // ----------------------------------
            sql = "SELECT id_stav FROM vybriz_stav_uch WHERE sys_kod = 111";
            Object id_stav = SqlPrikaz.ExecuteScalar(sql); // MZ 23.4.2013
            id_stav = id_stav == null ? DBNull.Value : id_stav; // MZ 23.4.2013
            dataOsobniUdaje.Rows[0]["id_stat"] = id_stav;

            string rodne_cislo = (string)dataOsobniUdaje.Rows[0]["rodne_cislo"];
            if (!string.IsNullOrEmpty(rodne_cislo))
            {
                pom = (string)dataOsobniUdaje.Rows[0]["pohlavi"];
                zena = (pom == "z") ? true : false;
                rodne_cislo = F_RodneCislo.RodneCislo(Convert.ToDateTime(rodne_cislo), zena);
            }
            else
            {
                rodne_cislo = " ";
            }
            dataOsobniUdaje.Rows[0]["rodne_cislo"] = rodne_cislo;
            dataOsobniUdaje.Rows[0]["student"] = "n";
            dataOsobniUdaje.Rows[0]["evid_od"] = DateTime.Today;

            // Naplnění položky 'ulice_prech'
            string ulice_prech = ((string)dataOsobniUdaje.Rows[0]["pr_ulice"]).Trim();
            pom = (string)dataOsobniUdaje.Rows[0]["pr_cislo"];
            if (!string.IsNullOrEmpty(ulice_prech) && !string.IsNullOrEmpty(pom))
            {
                ulice_prech += " " + pom.Trim();
            }
            else
            {
                ulice_prech += pom;
            }
            dataOsobniUdaje.Rows[0]["ulice_prech"] = ulice_prech;

            if (KSProgram.Zakaznik.IsCurrent("VIADRUS") || KSProgram.Zakaznik.IsCurrent("MS_UTILITIES") || KSProgram.Zakaznik.IsCurrent("DEMOS_GROUP"))
            {
                KopiePrechAdrDoTrvAdr();
                ins = GetInsertStrings(dataOsobniUdaje, os_cislo, new string[] { "os_cislo", "jmeno", "prijmeni", "titul", "titul_za", "st_prisl", "rodne_cislo", "misto_narozeni", "pohlavi", "rodin_stav", "student", "id_stat", "evid_od", "tr_ulice", "tr_cislo", "ulice_trv", "misto_trv", "psc_trv", "dat_souhl101" });
            }
            else if (KSProgram.Zakaznik.IsCurrent("AWT_GROUP") && KSProgram.Uchazeci.Uchazeci.PravaNaPodnik()) // MZ 18.11.2015 Pro AWT.
            {
                dataOsobniUdaje.Rows[0]["id_podniku"] = 35; // Předán podnik AWT.
                ins = GetInsertStrings(dataOsobniUdaje, os_cislo, new string[] { "os_cislo", "jmeno", "prijmeni", "titul", "titul_za", "st_prisl", "rodne_cislo", "misto_narozeni", "pohlavi", "rodin_stav", "student", "id_stat", "evid_od", "pr_ulice", "pr_cislo", "ulice_prech", "misto_prech", "psc_prech", "dat_souhl101", "id_podniku" });
            }
            else
            {
                ins = GetInsertStrings(dataOsobniUdaje, os_cislo, new string[] { "os_cislo", "jmeno", "prijmeni", "titul", "titul_za", "st_prisl", "rodne_cislo", "misto_narozeni", "pohlavi", "rodin_stav", "student", "id_stat", "evid_od", "pr_ulice", "pr_cislo", "ulice_prech", "misto_prech", "psc_prech", "dat_souhl101" });
            }
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }
            // Obnovení dat na stav před úpravou
            dataOsobniUdaje.Rows[0]["rodne_cislo"] = pom;

            // Kontrola duplicity !!!
            // ----------------------
            string jmeno = (string)dataOsobniUdaje.Rows[0]["jmeno"];
            string prijmeni = (string)dataOsobniUdaje.Rows[0]["prijmeni"];
            string rodCis = (string)dataOsobniUdaje.Rows[0]["rodne_cislo"];
            string dupl_osCis = "";
            dupl_osCis = SqlPrikaz.ExecuteScalarString("SELECT os_cislo FROM uchazeci" +
                " WHERE jmeno = '" + jmeno + "'" +
                " AND prijmeni = '" + prijmeni + "'" +
                " AND rodne_cislo = '" + rodne_cislo + "'" +
                " AND duplicita IS NULL", "");

            if (dupl_osCis != "")
            {
                pom = "UPDATE uchazeci SET duplicita = " + dupl_osCis +
                    " WHERE os_cislo = " + os_cislo; // +";";
                inserty.Add(pom);
            }

            // Kontakty
            // ========
            DataTable dataKontakty = new DataTable("u_telefony");
            dataKontakty.Columns.Add("os_cislo", typeof(decimal));
            dataKontakty.Columns.Add("tel_cislo", typeof(string));
            dataKontakty.Columns.Add("tel_kam", typeof(string));

            string telefon = (string)dataOsobniUdaje.Rows[0]["telefon"];
            string email = (string)dataOsobniUdaje.Rows[0]["email"];

            // Telefon
            if (telefon.Length > 0)
            {
                row = dataKontakty.NewRow();
                row["os_cislo"] = os_cislo;
                row["tel_cislo"] = telefon;
                row["tel_kam"] = "Telefon domů";
                dataKontakty.Rows.Add(row);
            }

            // Email
            if (email.Length > 0)
            {
                row = dataKontakty.NewRow();
                row["os_cislo"] = os_cislo;
                row["tel_cislo"] = email;
                row["tel_kam"] = "E-mail domů";
                dataKontakty.Rows.Add(row);
            }

            ins = GetInsertStrings(dataKontakty, os_cislo, new string[] { "os_cislo", "tel_cislo", "tel_kam" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // Vzdělání
            // ========
            ins = GetInsertStrings(dataSkola, os_cislo, new string[] { "os_cislo", "stupen", "obor", "skola", "rok_zahaj", "rok_ukonc" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // Praxe
            // =====
            ins = GetInsertStrings(dataPraxe, os_cislo, new string[] { "os_cislo", "naz_org", "pozice", "profese", "datum_nastupu", "datum_ukonc", "mist_vyk_prace" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // Znalosti a dovednosti
            // =====================
            // Jazyk
            ins = GetInsertStrings(dataJazyky, os_cislo, new string[] { "os_cislo", "jazyk", "stupen", "druh_zkousky" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // řidičák B
            string ridic = "";
            ridic += chbRidicA.Checked ? "A," : "";
            ridic += chbRidicB.Checked ? "B," : "";
            ridic += chbRidicC.Checked ? "C," : "";
            ridic += chbRidicD.Checked ? "D," : "";
            ridic += chbRidicE.Checked ? "E," : "";
            ridic += chbRidicT.Checked ? "T," : "";

            if (ridic.Length > 0)
            {
                ridic = ridic.Substring(0, ridic.Length - 1); // Odstraní se čárka na konci
                pom = "INSERT INTO u_sleduj(os_cislo, ridic) VALUES(" + os_cislo.ToString() + ", '" + ridic + "')";
                inserty.Add(pom);
            }

            //if (chbRidicB.Checked)
            //{
            //    pom = "INSERT INTO u_sleduj(os_cislo, ridicb) VALUES(" + os_cislo.ToString() + ", 'a')";
            //    inserty.Add(pom);
            //}

            // Hledaná práce
            // =============
            ins = GetInsertStrings(dataHledanaPrace, os_cislo, new string[] { "os_cislo", "profese", "plat" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // Kurzy a osvědčení
            // =================
            ins = GetInsertStrings(dataKurzy, os_cislo, new string[] { "os_cislo", "cis_osve", "skoleni", "plati_do" });
            for (int i = 0; i < ins.Length; i++)
            {
                inserty.Add(ins[i]);
            }

            // ===========================
            // Vložení záznamů do databáze
            // ===========================
            using (DbConnection connection = SqlPrikaz.CreateConnectionWithTrans())
            {
                try
                {
                    for (int i = 0; i < inserty.Count; i++)
                    {
                        SqlPrikaz.ExecuteNonQuery(inserty[i]);
                    }

                    // Dokumenty
                    SaveDokuments((decimal)os_cislo);

                    SqlPrikaz.Commit();
                }
                catch
                {
                    SqlPrikaz.Rollback();
                    throw;
                }
            }

            panelForm.Visible = false;
            panelSendOK.Visible = true;
            //Response.Redirect("~/Public/CVUchForm.aspx");

            //dataOsobniUdaje.Clear();
            //dataSkola.Clear();
            //dataJazyky.Clear();
            //dataPraxe.Clear();
            //dataKontakty.Clear();
        }

        #region Privátní metody
        private string Get101Info()
        {

            string zakaznik = KSProgram.Zakaznik.GetNazev().Trim();
            //string param = Parametr_cti.Get("u_delka_101", DateTime.Today);
            //if (string.IsNullOrEmpty(param)) { param = "6"; } // Defaulní hodnota délky souhlasu, pokud není vyplněn parametr;
            //int delka_101 = Convert.ToInt16(param);
            short delka_101 = Uchazeci.GetDelkaSouhlasuSEvidenci(); // MZ 13.10.2015
            string[] mesic = { "", "měsíc", "měsíce", "měsíce", "měsíce", "měsíců" };
            string mesic_tx = mesic[5];
            if (delka_101 < 5) { mesic_tx = mesic[delka_101]; }

            string souhlas = "Zaškrtnutím pole vyjadřuje uchazeč souhlas se zpracováním osobních údajů uvedených v tomto" +
                " formuláři v souladu se zákonem č. 101/2000 Sb. (zákon o ochraně osobních údajů) a budou v" +
                " tomto rozsahu uloženy v databázi uchazečů o zaměstnání ve společnosti " + zakaznik +
                ", a to po dobu " + delka_101.ToString() + " " + mesic_tx + " ode dne vyjádření souhlasu." +
                " Tyto údaje budou uchovávány a zpracovávány pouze za účelem případného budoucího výběru" +
                " zaměstnance z řad uchazečů o zaměstnání. Zároveň tímto bere uchazeč na vědomí," +
                " že své osobní údaje poskytuje dobrovolně a potvrzuje," +
                " že uvedené osobní údaje jsou pravdivé a přesné.";

            return souhlas;
        }     
        private void SaveDokuments(decimal os_cislo)
        {
            foreach (DataRow r in dataDokumenty.Rows)
            {
                int? idBlob = null;

                // Data ze Session
                // ---------------
                // MZ 26.2.2014 Data nejsou ukládána do session
                //string infoData = System.IO.Path.GetFileNameWithoutExtension(Convert.ToString(r["nazev_soubor"]));
                //Int64 id = Convert.ToInt64(r["id_int"]);
                //string key = id.ToString() + "_" + infoData;
                //KSTrace.WriteLine("[CVUchForm] SaveDokuments -> key = " + key);
                //byte[] data = (byte[])KSProgram.Obecne.SessionInfo.GetVariable(key);

                //KSTrace.WriteLine("[CVUchForm] SessionID = " + Session.SessionID);
                //if (data == null)
                //{
                //    KSTrace.WriteLine("[CVUchForm] SaveDokuments -> data = NULL");
                //}
                //else
                //{
                //    KSTrace.WriteLine("[CVUchForm] SaveDokuments -> data != NULL");
                //}
                //System.Data.SqlTypes.SqlBinary sqlBinaryData = (System.Data.SqlTypes.SqlBinary)r["data"];
                //byte[] data = (byte[])sqlBinaryData;
                byte[] data = (byte[])r["data"];

                //data = null;

                SqlPrikaz.SaveByteToInfoBlob(ref idBlob, os_cislo, 0, 13, null, null, data, true, null, null, null);

                if (idBlob != null)
                {
                    string sql = "SELECT count(*) FROM info_blob WHERE id = " + idBlob.ToString();
                    short pocet = SqlPrikaz.ExecuteScalarInt16(sql, 0);
                    if (pocet == 0)
                    {
                        string err = "CVUchForm.aspx. Přestože bylo vráceno 'info_blob.id', nebyl v tabulce 'info_blob' nalezen odpovídající záznam. " + sql;
                        err += ". Data.Length = " + data.Length + ".";
                        Exception ex = new Exception(err);
                        KSProgram.ExceptionUtility.LogProcess(ex);
                    }
                }

                r["id_blob"] = idBlob;
                r["os_cislo"] = os_cislo;
                r["datum_prijeti"] = DateTime.Today.Date;
                r["id"] = -1;
                r["typ_dokumentu"] = string.IsNullOrEmpty((string)r["typ_dokumentu"]) ? "?" : r["typ_dokumentu"]; // MZ 23.2.2015 Pokud nebude definován typ dokumentu pro uchazeče, uloží se '?'.

                string sql_dok = GetInsertString("u_dok_prijate", r, new string[] { "id", "os_cislo", "typ_dokumentu", "datum_prijeti", "nazev_soubor", "id_blob" });
                sql_dok = sql_dok.Replace("(-1", "({0}");

                SqlPrikaz.InsertWithSerial(sql_dok, "u_dok_prijate", "id");
            }
        }
        private string[] GetInsertStrings(DataTable aDataTable, decimal? aOsCislo, string[] aCol)
        {
            string[] inserty = new string[aDataTable.Rows.Count];

            for (int i = 0; i < aDataTable.Rows.Count; i++)
            {
                string ins = "INSERT INTO " + aDataTable.TableName + " (os_cislo,";
                string col = "";
                string val = "";
                string oddelovac;
                string pom;

                DataRow dr = aDataTable.Rows[i];
                for (int j = 0; j < aCol.Length; j++)
                {
                    oddelovac = "";
                    if (j < (aCol.Length - 1))
                    {
                        oddelovac = ",";
                    }

                    if (aCol[j] == "os_cislo") continue; // Os. číslo se ukládat nebude, už tam je

                    col += aCol[j] + oddelovac;
                    Object obj = dr[aCol[j]];
                    Type type = obj.GetType();
                    if (obj != DBNull.Value)
                    {
                        if (type == typeof(string))
                        {
                            pom = Convert.ToString(obj);
                            if (pom.Length == 0)
                            {
                                val += "NULL" + oddelovac;
                            }
                            else
                            {
                                pom = InputChecker.Text(pom, "InsValue");
                                val += KSProgram.Data.SqlPrikaz.StringToDbString(pom) + oddelovac;
                            }
                        }
                        else if (type == typeof(DateTime))
                        {
                            pom = KSProgram.Data.SqlPrikaz.DateTimeToString((DateTime)obj);
                            val += pom + oddelovac;
                        }
                        else
                        {
                            val += Convert.ToString(obj) + oddelovac;
                        }
                    }
                    else
                    {
                        val += "NULL" + oddelovac;
                    }
                }
                ins += col + ") VALUES (" + aOsCislo.ToString() + "," + val + ")"; //;";
                inserty[i] = ins;
            }
            return inserty;

        }
        private string GetInsertString(string aTableName, DataRow aDataRow, string[] aCol)
        {
            string ins = "INSERT INTO " + aTableName + " (";
            string col = "";
            string val = "";
            string oddelovac;
            string pom;

            DataRow dr = aDataRow;
            for (int j = 0; j < aCol.Length; j++)
            {
                oddelovac = "";
                if (j < (aCol.Length - 1))
                {
                    oddelovac = ",";
                }
                col += aCol[j] + oddelovac;
                Object obj = dr[aCol[j]];
                Type type = obj.GetType();
                if (obj != DBNull.Value)
                {
                    if (type == typeof(string))
                    {
                        pom = Convert.ToString(obj);
                        if (pom.Length == 0)
                        {
                            val += "NULL" + oddelovac;
                        }
                        else
                        {
                            pom = InputChecker.Text(pom, "InsValue");
                            val += KSProgram.Data.SqlPrikaz.StringToDbString(pom) + oddelovac;
                        }
                    }
                    else if (type == typeof(DateTime))
                    {
                        pom = KSProgram.Data.SqlPrikaz.DateTimeToString((DateTime)obj);
                        val += pom + oddelovac;
                    }
                    else
                    {
                        val += Convert.ToString(obj) + oddelovac;
                    }
                }
                else
                {
                    val += "NULL" + oddelovac;
                }
            }
            ins += col + ") VALUES (" + val + ")";

            return ins;
        }
        /// <summary>
        /// Zkopírování adresy přechodného bydliště do trvalého bydliště
        /// </summary>
        private void KopiePrechAdrDoTrvAdr()
        {
            dataOsobniUdaje.Rows[0]["tr_ulice"] = dataOsobniUdaje.Rows[0]["pr_ulice"];
            dataOsobniUdaje.Rows[0]["tr_cislo"] = dataOsobniUdaje.Rows[0]["pr_cislo"];
            dataOsobniUdaje.Rows[0]["ulice_trv"] = dataOsobniUdaje.Rows[0]["ulice_prech"];
            dataOsobniUdaje.Rows[0]["misto_trv"] = dataOsobniUdaje.Rows[0]["misto_prech"];
            dataOsobniUdaje.Rows[0]["psc_trv"] = dataOsobniUdaje.Rows[0]["psc_prech"];
        }
        #endregion



    }
}