﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Exceptions;
using KSProgram.Obecne;
using KSProgram.Prava;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Public
{
    public partial class ExternalLogin : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            //Zda povolit registraci uživatelů
            LB_Registrace.Visible = (KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("Registrace", null) == "user");

            string userName = null;
            string loginType = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("ExternalLogin");

            if (!IsPostBack)
            {

                if (loginType == "Toyota") //PR 23.03.2021 oprava pro Toyotu od 7441D, mohou si ale změnit loginType na "OAUTH2"
                    loginType = "OAUTH2";

                if (loginType == "OAUTH2" || loginType == "SAML2")
                {
                    Odhlasit.Visible = true;
                }

                if (loginType == "ToyotaOld")
                {
                    ToyotaAuthentication auth = new ToyotaAuthentication();
                    auth.ValidateUser();
                    userName = Session[ToyotaAuthentication.SessionKey.UserName].ToString();
                }

                //JO 09.03.2020 - Obecné přihlašování pomocí OAuth2
                // 2.6.2020 JO - Přidáno rozšíření aplikace
                //PR 23.03.2021 kontrola zákazníka přesunuta až za připojení k databázi
                //-------------------------------------------------- 
                //if (((loginType == "OAUTH2" && (Zakaznik.IsCurrent("COLAS_GROUP") || Globals.RAActive("EXTERNI_PRIHLASOVANI"))) || (loginType == "Toyota")) && SessionInfo.GetVariable("oauth_username") == null)
                if (loginType == "OAUTH2" && SessionInfo.GetVariable("oauth_username") == null)
                {
                    string code = Request["code"];
                    bool isAuthenticated = false;
                    if (code != null)
                    {
                        isAuthenticated = true;
                    }

                    if (!isAuthenticated)
                    {
                        //JO 2.7.2020 - Podpora returnURL pro externí login
                        //--------------------------------------------------------------
                        string returnURL = "";
                        try
                        {
                            returnURL = Request["ReturnUrl"];
                            if (!returnURL.ToLower().Contains("login"))
                            {
                                //vytvořím cookies a tu uložím s hodnotou returnURL
                                //-------------------------------------------------
                                HttpCookie cook = new HttpCookie("oauthRetURL");
                                cook.Value = returnURL;
                                Response.Cookies.Add(cook);
                            }
                            else
                            {
                                returnURL = "";
                            }
                        }
                        catch { returnURL = ""; }

                        string url = null;
                        string authentication_endpoint = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("AuthenticationEndpoint");
                        string client_id = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("ClientId");
                        string client_secrete = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("ClientSecret", "");
                        string scope = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("Scope");
                        string state = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("State", "");
                        string redirect_uri = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("RedirectUri");
                        string nonce = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("Nonce", "");
                        string response_type = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("ResponseType", "");
                        string response_mode = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("ResponseMode", "");
                        string client_secrete_display = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("ClientSecretD", "");

                        //sestavení url pro přesměrování - někdy nemusí být vyplněn client_secrete a state
                        url += authentication_endpoint + "?client_id=" + client_id;
                        if (response_type != "") { url += "&response_type=" + response_type; } else { url += "&response_type=code"; };
                        if (response_mode != "") { url += "&response_mode=" + response_mode; } else { url += "&response_mode=query"; };
                        url += "&redirect_uri=" + redirect_uri + "&scope=" + scope;
                        if (string.IsNullOrEmpty(client_secrete_display))
                        {
                            if (client_secrete != "") { url += "&client_secret=" + client_secrete; }
                        }
                        if (state == "1")
                        {
                            state = Guid.NewGuid().ToString().Replace("-", string.Empty).ToLower();
                            url += "&state=" + state;
                        }
                        if (nonce == "1")
                        {
                            nonce = Guid.NewGuid().ToString().Replace("-", string.Empty).ToLower();
                            url += "&nonce=" + nonce;
                        }


                        //odstranění mezer z textu
                        url = url.Replace(" ", "");

                        Response.Redirect(url);

                    }
                    if (isAuthenticated && SessionInfo.GetVariable("oauth_username") == null)
                    {
                        OAuthAutentizace.getUserName(code);
                    }


                };

                //JO 12.10.2020 SAML2.0 Login
                //PR 23.03.2021 kontrola zákazníka přesunuta až za připojení k databázi
                //if (loginType == "SAML2" && (Globals.RAActive("EXTERNI_PRIHLASOVANI") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM")) && SessionInfo.GetVariable("oauth_username") == null)
                if (loginType == "SAML2" && SessionInfo.GetVariable("oauth_username") == null)
                {
                    using (System.IO.StreamWriter file = new System.IO.StreamWriter(TempDirectory.FolderPath + "SAMLTrace.txt", true))
                    {
                        file.WriteLine(DateTime.Now + " Vstup do funkce pro přihlášení SAML");
                        file.Flush();
                    }

                    bool isAuthenticated = false;
                    var dataBase64 = Request.Form["SAMLResponse"];
                    if (!string.IsNullOrEmpty(dataBase64))
                    {

                        using (System.IO.StreamWriter file = new System.IO.StreamWriter(TempDirectory.FolderPath + "SAMLTrace.txt", true))
                        {
                            file.WriteLine(DateTime.Now + " Příchod opovědi");
                            file.Flush();
                        }

                        isAuthenticated = true;
                        string username = null;
                        // 1. TODO: specify the certificate that your SAML provider gave you
                        //string samlCertificate = @"-----BEGIN CERTIFICATE-----
                        //                            MIIC3DCCAcSgAwIBAgIQXo1eA3m29LpAZgoxjYT7pzANBgkqhkiG9w0BAQsFADAq
                        //                            MSgwJgYDVQQDEx9BREZTIFNpZ25pbmcgLSBzc280LXByb2QudGUuY29tMB4XDTIw
                        //                            MDgwNTE5Mzg0OVoXDTMwMDgwMzE5Mzg0OVowKjEoMCYGA1UEAxMfQURGUyBTaWdu
                        //                            aW5nIC0gc3NvNC1wcm9kLnRlLmNvbTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCC
                        //                            AQoCggEBALw+CeXOFcXM06SZcAz3zSS6MoG0PNE1huPxz0iQFSMo5kgHqQxCX4gv
                        //                            5vYndV3X6pEwxN9qBBzxpnCm7lmGkR9UenR5nfNCpu6zAPvB7E87MR96HmWsrNQL
                        //                            85AGtnlj3tcfTmHuljhlqEygaSTqNoEulvwC59fE12QnE53/Lag832nLIsBAkWox
                        //                            emv2Db4gNiYt8RjzbxKoL7KiQLcaVDodDZPmwHBtvpc10YZZQCc7+EDNmlVVOyRX
                        //                            2+bhqViaSbBLb1jD3nJjUY3/m17a1EItG7bYNH2200BRI2aRmCh9qHwcNjiB5Wt+
                        //                            ZuP9fOfyhvG0Iokg2SOx0f1NSzZ0PgkCAwEAATANBgkqhkiG9w0BAQsFAAOCAQEA
                        //                            Mny7j/Q2S7fQZnKt6ApxKf4fH5UNALHmfdAoKY2BNN+VAILXv22ScOM9MasXQor7
                        //                            2vyYJPMLD+lXukOwTDdnJeXXboTZ/246q7GWlVwG1lk1gSkf595ZI5OkZf66aPWV
                        //                            BzHpRcoudgae1wdbZCtepCkCLU7HA/vBq03E2UgdV/WWwGFCUsAviOzbaknX0Wak
                        //                            RfjPeYIvxhCmvTLVJ0Hrvtunh56XW0/nr5UrUZpJWwzgMdy6XzmxEYqgcEVk944h
                        //                            UhLeIlAvKSO6TyYpKy/UkMYZLptTfrjLXcs/xPGK47uEbmp6fQuIlfNiw2ELnVY/
                        //                            CpFkGHSCfZkxLXDS6dMFug==
                        //                            -----END CERTIFICATE-----
                        //                            ";

                        string samlCertificate = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("SAML2Cert");

                        using (System.IO.StreamWriter file = new System.IO.StreamWriter(TempDirectory.FolderPath + "SAMLTrace.txt", true))
                        {
                            file.WriteLine(DateTime.Now + " Načtení certfikátu");
                            file.Flush();
                        }
                        //samlCertificate = samlCertificate.Replace(" ", "").Replace("\r\n", "");
                        //samlCertificate = samlCertificate.Replace("-----BEGINCERTIFICATE-----", "-----BEGIN CERTIFICATE-----").Replace("-----ENDCERTIFICATE-----", "-----END CERTIFICATE-----");
                        // 2. Let's read the data - SAML providers usually POST it into the "SAMLResponse" var
                        KSProgram.Prava.Response samlResponse = new Response(samlCertificate, dataBase64);
                        using (System.IO.StreamWriter file = new System.IO.StreamWriter(TempDirectory.FolderPath + "SAMLTrace.txt", true))
                        {
                            file.WriteLine(DateTime.Now + " SAML Response vytvořena a načtena");
                            file.Flush();
                        }
                        // 3. We're done!
                        if (samlResponse.IsValid())
                        {
                            username = samlResponse.GetNameID();

                            //pokud by nešlo můžu načíst custom attribut
                            string attr = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("SAML2CustomAttr", "");
                            if (!string.IsNullOrEmpty(attr))
                            {
                                username = samlResponse.GetCustomAttribute(attr);
                            }

                        }
                        if (!string.IsNullOrEmpty(username))
                        {
                            SessionInfo.SetVariable("oauth_username", username);
                        }

                        // OAuthAutentizace.EncryptResponseSaml(dataBase64);
                    }

                    if (!isAuthenticated)
                    {

                        try
                        {
                            string authentication_endpointSAML = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("SAML2LoginUrl");
                            if (!string.IsNullOrEmpty(authentication_endpointSAML))
                            {
                                string entityID = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("SAML2EntityID");
                                string redirectURI = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("SAML2RedirectURI");
                                entityID = entityID.Trim();
                                redirectURI = redirectURI.Trim();
                                var request = new AuthRequest(
                                    entityID, //TODO: put your app's "entity ID" here
                                    redirectURI //TODO: put Assertion Consumer URL (where the provider should redirect users after authenticating)
                                    );

                                using (System.IO.StreamWriter file = new System.IO.StreamWriter(TempDirectory.FolderPath + "SAMLTrace.txt", true))
                                {
                                    file.WriteLine(DateTime.Now + " Redirect na login page");
                                    file.Flush();
                                }


                                Response.Redirect(request.GetRedirectUrl(authentication_endpointSAML));
                            }


                        }
                        catch
                        {
                            throw new NoticeException("Není vyplněn povinný udaj SAML 2.0");

                        }
                    }

                }


                if (loginType == "OAUTH2" || loginType == "SAML2")
                {
                    try
                    {
                        userName = SessionInfo.GetVariable("oauth_username").ToString();
                    }
                    catch
                    {
                        throw new Exception("Nepodařilo se získat uživatelské jméno.");
                    }
                }
                if (string.IsNullOrEmpty(userName))
                {
                    throw new Exception("Autentizační služba nevrátila jméno uživatele.");
                }

                ConnectionStringSettingsCollection connectionStrings = DatabaseInfo.GetConnectionStrings();
                if (connectionStrings.Count == 1)
                {
                    TDD_Databaze.Visible = false;
                    TRB_dbSelected.Visible = false;
                    PrihlaseniUzivatele(userName);
                }
                else
                {
                    L_UserName.Text = userName;
                    TDD_Databaze.Visible = true;
                    TRB_dbSelected.Visible = true;
                    byte[] userByte = HashAndCrypto.EncryptToByte(userName);
                    HF_userName.Value = Convert.ToBase64String(userByte);

                    for (int i = 0; i < connectionStrings.Count; i++)
                    {
                        if (connectionStrings[i].Name.Contains("hidden_"))
                        { }
                        else
                        {
                            TDD_Databaze.Items.Add(connectionStrings[i].Name);
                        }
                    }

                }

            }
        }

        private bool ExternalLoginActive(string loginType)
        {
            if (Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM"))
                return true;
            //PR 23.03.2021 oprava pro Toyota, bude až od 7441D

            else if (loginType == "OAUTH2" || loginType == "Toyota" /*Toyota a Oauth2 je stejný algoritmus*/)
            {
                if (Globals.RAActive("EXTERNI_PRIHLASOVANI"))
                    return true;
                if (Zakaznik.IsCurrent("COLAS_GROUP") || Zakaznik.IsCurrent("TOYOTA") || Zakaznik.IsCurrent("TOYOTA_SK"))
                    return true;
            }
            else if (loginType == "SAML2")
            {
                if (Globals.RAActive("EXTERNI_PRIHLASOVANI"))
                    return true;
            }
            return false;
        }

        protected void LB_Registrace_Click(object sender, EventArgs e)
        {
            string dbName = KSProgram.Globals.DBName;
            dbName = Server.UrlEncode(dbName);
            Response.Redirect("~/Public/RegistraceExt.aspx?DBName=" + dbName);
        }

        protected void TRB_dbSelected_Click(object sender, EventArgs e)
        {
            string dbName = TDD_Databaze.SelectedValue;
            string userName = HF_userName.Value.Trim();
            byte[] userNameByte = Convert.FromBase64String(userName);
            userName = HashAndCrypto.DecryptToString(userNameByte);

            PrihlaseniUzivatele(userName, dbName);

        }

        protected void PrihlaseniUzivatele(string userName, string dbName = null)
        {
            string loginType = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("ExternalLogin");

            if (string.IsNullOrEmpty(dbName))
            {
                dbName = KSProgram.Globals.DBName;
            }

            if (string.IsNullOrEmpty(userName))
            {
                userName = SessionInfo.GetVariable("oauth_username").ToString();
            }


            if (!IsPostBack)
            {
                L_UserName.Text = userName;
                L_Database.Text = dbName;
            }

            try
            {
                KSProgram.SpravaUziv.PrihlaseniOverenehoUzivatele(dbName);
                KSProgram.SpravaUziv.InicializaceUzivatele(userName);

                if (!ExternalLoginActive(loginType))//PR 23.03.2021 
                {
                    KSProgram.SpravaUziv.Odhlaseni();
                    throw new Exception("Rozšíření aplikace - Externí přihlašování není aktivováno.");
                }
            }
            catch (Exception ex)
            {
                FailureText.Text = ex.Message;
                KSProgram.WebControls.WebControlHelper.ZmenaTextu(FailureText);
                return;
            }


            // System.Web.Security.FormsAuthentication.RedirectFromLoginPage(userName, false);
            SpravaUziv.RedirectFromLoginPage(userName); //JO 21.2.2020
        }
    }
}