﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Data;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Public
{
    public partial class NovyZamUdaje : TPrePage
    {
        private Int32 poz_id
        {
            get
            {
                object o = ViewState["nzu_id_poz"];
                if (o == null)
                    return 0;
                return (int)o;
            }
            set
            {
                ViewState["nzu_id_poz"] = value;
            }
        }

        private string db_name
        {
            get
            {
                object o = ViewState["nzu_db_name"];
                if (o == null)
                    return null;
                return (string)o;
            }
            set
            {
                ViewState["nzu_db_name"] = value;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            if (!IsPostBack)
            {
                QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection queryString = hh.DecryptRequestQuery();
                string er = ReadGlobalResource.ZmenaTextu("[%Někde se stala chyba. Odkaz na formulář není funkční.%]");
                string ert = ReadGlobalResource.ZmenaTextu("[%Chyba%]");
                if (queryString.Count > 0)
                {
                    if (!string.IsNullOrEmpty(queryString["dbname"]))
                    {
                        db_name = queryString["dbname"];
                        Globals.Db = DatabasePodleParam.Create(db_name);
                        if (Globals.Db != null)
                        {
                            //PH 1.11.2021 testuje rozšíření pro DMZ
                            if (!_testRozsireni_NOVE_NASTUPY_DMZ()) return;

                            int idp;
                            if (int.TryParse(queryString["idpoz"], out idp))
                            {
                                if (KSProgram.Pozadavky.Pozadaveknastupzam.pozadavekExistuje(idp))
                                {
                                    poz_id = idp;
                                    PNZ.PozId = poz_id;
                                }
                                else MessageBox.Alert(this.Page, er + ReadGlobalResource.ZmenaTextu(" [%Požadavek nebyl nalezen%]"), ert);
                            }
                            else MessageBox.Alert(this.Page, er + ReadGlobalResource.ZmenaTextu(" [%Odkaz neobsahuje ID požadavku%]"), ert);
                        }
                        else MessageBox.Alert(this.Page, er + ReadGlobalResource.ZmenaTextu(" [%Databáze neexistuje%]"), ert);
                    }
                    else MessageBox.Alert(this.Page, er + ReadGlobalResource.ZmenaTextu(" [%Odkaz neobsahuje databázi%]"), ert);
                }
                else MessageBox.Alert(this.Page, er + ReadGlobalResource.ZmenaTextu(" [%Odkaz neobsahuje parametry%]"), ert);
            }
            if (IsPostBack)
            {

            }
        }

        protected override void Page_PreRender(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (Globals.IsDbConected) //PR 15.04.2021 
                {
                    PNZ.ChangeMode(FormViewMode.Edit);
                    PNZ.Nacist();
                }
            }
            base.Page_PreRender(sender, e);
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static object rcIsUnique(string data)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            string rc = Convert.ToString(jsonObject[0]["rc"]);
            int id_podniku = Convert.ToInt32(jsonObject[1]["id_podniku"]);
            rc = rc?.Replace(" ", "").Replace("/", "");
            return new
            {
                je_unikatni = (!KSProgram.Funkce.F_RodneCislo.JeVEvidenci(rc, id_podniku)).ToString(),
                posledni_ulice = KSProgram.Pozadavky.Pozadavekzmppv.getPosledniUlice(rc)
            };
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="text"></param>
        /// <returns></returns>
        [WebMethod] 
        public static object removeDiacritics(string text)
        {
            return text?.RemoveDiacritics()?.ToLower() ?? "";
        }

        /// <summary>
        /// Vrací parametry předané v URL.
        /// </summary>
        /// <returns></returns>
        private Dictionary<string, string> _GetParamUrl()
        {
            Dictionary<string, string> param = new Dictionary<string, string>();
            bool isPrihl = false;

            QueryStringCrypto qc = new QueryStringCrypto();
            NameValueCollection coll = qc.DecryptRequestQuery();
            if (coll.Count > 0)
            {
                string value = coll["IdVR"];
                if (!string.IsNullOrEmpty(value))
                {
                    int idVr;
                    if (int.TryParse(value, out idVr))
                    {
                        isPrihl = KSProgram.VyberovaRizeni.VyberovaRizeni.IsVrOtevreneProPrihlaseni(idVr);
                        if (isPrihl) param.Add("IdVr", value);
                    }
                }
                value = coll["doporucil"];
                if (!string.IsNullOrEmpty(value))
                {
                    if (isPrihl) param.Add("doporucil", value);
                }
            }

            return param;
        }

        /// <summary>
        /// testuje zda je zapnuto rozšíření pro případ, že používají osekanou verzi KS portálu pro instalaci v DMZ
        /// </summary>
        /// <returns></returns>
        private bool _testRozsireni_NOVE_NASTUPY_DMZ()
        {
            //PH 1.11.2021 HID:58754
            //do seznamu dám více souborů, vybral jsem bezpečnostně citlivé, aby náhodou nějaký kutil nezjistil,
            //že stačí do omezeného portálu nahrát jeden soubor a může obejít zakoupení rozšíření
            List<string> files = new List<string>();
            files.Add("default.aspx");           
            files.Add("Obecne/PravaRole.aspx");
            files.Add("Obecne/Prava.aspx");
            files.Add("Obecne/PravaRoleUzivatel.aspx");
            files.Add("Obecne/RadPravaVyj.aspx");
            files.Add("Pozadavky/Workflow.aspx");
            files.Add("Obecne/Zastup.aspx");
            files.Add("Pis/ConfiguraceSchemat.aspx");
            if (!Globals.RAActive("NOVE_NASTUPY_DMZ"))
            {
                bool povoleno_pokracovat = true;
                foreach(string file in files)
                {
                   string f= Server.MapPath("~/" + file);
                    if (!File.Exists(f))
                    {
                        povoleno_pokracovat = false;
                        break;
                    }
                }
                if (!povoleno_pokracovat)
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nemáte aktivováno aplikační rozšíření%]:KS portál >> Nástupy zaměstnanců - DMZ. [%Nelze pokračovat%]."));
                    return false;
                }
            }
            return true;
        }

        /// <summary>
        /// Funkce volaná z kontrolky ZmppvInnerForm.ascx ve workflow zmppv a novyzam
        /// </summary>
        /// <param name="typ_tt"></param>
        /// <param name="typ_mzdy"></param>
        /// <param name="typ_mzdy_old"></param>
        /// <param name="trida"></param>
        /// <param name="trida_old"></param>
        /// <param name="mzd_stup"></param>
        /// <param name="mzd_stup_old"></param>
        /// <returns></returns>
        [WebMethod]
        public static object GetTarif(short? typ_tt, short? typ_mzdy, short? typ_mzdy_old, short? trida, short? trida_old, short? mzd_stup, short? mzd_stup_old, bool updateTarif)
        {
            typ_mzdy = typ_mzdy ?? typ_mzdy_old;
            trida = trida ?? trida_old;
            mzd_stup = mzd_stup ?? mzd_stup_old;

            if (typ_tt == null)
                return new
                {
                    MinTarif = (decimal?)null,
                    Tarif = (decimal?)null,
                    MaxTarif = (decimal?)null,
                    UpdateTarif = updateTarif
                };

            ParametryPrikazu pars = new ParametryPrikazu()
            {
                new KSParameter("typ_tt", DbType.Int16, typ_tt),
                new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy),
                new KSParameter("trida", DbType.Int16, trida),
                new KSParameter("mzd_stup", DbType.Int16, mzd_stup)
            };

            var data = SqlPrikaz.ExecuteCommand(
                "SELECT zakl_tarif, max_tarif " +
                "FROM tarify " +
                "WHERE typ_tt = @typ_tt " +
                "AND (typ_mzdy = @typ_mzdy OR @typ_mzdy IS NULL) " +
                "AND (trida = @trida OR @trida IS NULL) " +
                "AND (mzd_stup = @mzd_stup OR @mzd_stup IS NULL) " +
                "ORDER BY mzd_stup", ref pars).AsEnumerable();

            return new
            {
                MinTarif = data.Min(x => GetNullOrData.GetDecimal(x["zakl_tarif"])),
                Tarif = data.Max(x => GetNullOrData.GetDecimal(x["zakl_tarif"])),
                MaxTarif = data.Max(x => GetNullOrData.GetDecimal(x["max_tarif"])) ?? data.Max(x => GetNullOrData.GetDecimal(x["zakl_tarif"])),
                UpdateTarif = updateTarif
            };
        }
        /// <summary>
        /// Funkce volaná z kontrolky ZmppvInnerForm.ascx ve workflow zmppv a novyzam
        /// </summary>
        /// <param name="prac_str"></param>
        /// <param name="prac_str_old"></param>
        /// <returns></returns>
        [WebMethod]
        public static object GetDivize(string prac_str, string prac_str_old)
        {
            string str = prac_str ?? prac_str_old ?? null;
            if (!string.IsNullOrEmpty(str))
            {
                string sql = "SELECT d.cis_divize, d.naz_divize, ss.skup_str, ss.skup_nazev " +
                    "FROM stred s " +
                    "INNER JOIN divize d ON d.cis_divize = s.cis_divize " +
                    "INNER JOIN skup_stred ss ON ss.skup_str = s. skup_str " +
                    "WHERE s.str = @str";
                ParametryPrikazu pars = new ParametryPrikazu() { new KSParameter("str", DbType.String, str) };
                return (from d in SqlPrikaz.ExecuteCommand(sql, true, ref pars).AsEnumerable()
                        select new
                        {
                            d_cislo = GetNullOrData.GetInt32(d["cis_divize"]),
                            d_nazev = GetNullOrData.GetInt32(d["cis_divize"]).ToString() + " - " + GetNullOrData.GetString(d["naz_divize"]),
                            ss_cislo = GetNullOrData.GetInt32(d["skup_str"]),
                            ss_nazev = GetNullOrData.GetInt32(d["skup_str"]).ToString() + " - " + GetNullOrData.GetString(d["skup_nazev"])
                        }).FirstOrDefault();
            }
            return null;
        }
    }
}