﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Obecne;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Security;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Public
{
    public partial class SendActivationEmail : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            //načtu seznam databázových připojení
            ConnectionStringSettingsCollection connectionStrings = DatabaseInfo.GetConnectionStrings();
            for (int i = 0; i < connectionStrings.Count; i++)
            {
                if (!connectionStrings[i].Name.Contains("hidden_"))
                 {
                    DropDownListItem item = new DropDownListItem(connectionStrings[i].Name, connectionStrings[i].Name);
                    ddl_databaze.Items.Add(item);
                }
            }

        }

        protected void TLB_Send_Click(object sender, EventArgs e)
        {
            string dbName = string.Empty;
            if (ddl_databaze.SelectedItem == null)
            {
                RL_RegReturn.Text = ReadGlobalResource.ZmenaTextu("[%Není vybrána databáze%]");
                return;
            }
            else
            {
                dbName = ddl_databaze.SelectedItem.Text;
            }

            string email = RTB_Email.Text;
            decimal osCislo = Convert.ToDecimal(RTB_OsCislo.Value);

            try
            {
                SpravaUziv.SendActivationEmail(dbName, email, osCislo);
            }
            catch (SecurityException exc)
            {
                RL_RegReturn.Text = exc.Message;
                return;
            }

            RL_RegReturn.Text = ReadGlobalResource.ZmenaTextu("[%Aktivační email byl odeslán%]");
        }
    }
}