﻿using KSProgram;
using KSProgram.Exceptions;
using KSProgram.Obecne;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Uzivatele;

namespace KSPortal.Public
{
    public partial class UrlLogin : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            //kontrola parametrů
            string userName = Request.QueryString["username"];
            if (string.IsNullOrWhiteSpace(userName))
            {
                FailureText.Text = "V URL chybí povinný parametr 'username'.";
                return;
            }
            string password = Request.QueryString["password"];
            if (string.IsNullOrWhiteSpace(password))
            {
                FailureText.Text = "V URL chybí povinný parametr 'password'.";
                return;
            }

            string dbName = Request.QueryString["dbname"];

            bool prihlasen = false;
            //ověření uživatele
            try
            {
                //SpravaUziv.FormPrihlaseni(dbName, userName, password);
                userName = SpravaUziv.FormPrihlaseni(dbName, userName, password);//PR 06.02.2019 
                SpravaUziv.InicializaceUzivatele(userName);
                prihlasen = true;
            }
            catch (LoginException exc)
            {
                string message = ReadGlobalResource.ZmenaTextu(exc.Message);
                LogonLogger.WriteLine(userName, message);
                FailureText.Text = message;
            }
            catch (System.Security.SecurityException exc)
            {
                string message = ReadGlobalResource.ZmenaTextu(exc.Message);
                LogonLogger.WriteLine(userName, message);
                FailureText.Text = message;
            }

            //GDPR audit //PR 11.12.2019
            Uzivatel userinfo = new Uzivatel();
            userinfo.Initialize(dbName, userName, Request);
            userinfo.SetGDPRAudit(prihlasen);
            Globals.UzivatelInfo = userinfo;

            if (prihlasen)
            {
                SpravaUziv.RedirectFromLoginPage(userName);
            }
        }
    }
}