﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Obecne;
using KSProgram.Uchazeci;
using KSProgram.VyberovaRizeni;
using Telerik.Web.UI;

namespace KSPortal.Public
{
    public partial class VolnePozicePub : TPrePage
    {
        public VolnePozicePub()
        {
            DefaultDatabase = true; //PR 15.04.2021 
        }
        private int IdVR
        {
            get
            {
                //object IdVR = SessionInfo.GetVariable("IdVR");
                object IdVR = TRG_seznam.SelectedValue;
                if (IdVR == null)
                    return 0;
                else
                    return (int)IdVR;
            }
            //set
            //{
            //    SessionInfo.SetVariable("IdVR", value);
            //}
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                if (Zakaznik.IsCurrent("MOR SLEZ KRAJ"))
                    nadpis.Text = "[%Volné pozice - úřední deska%]"; // MZ 7.10.2019 HD47974. Doplněn zákaznický popisek.

                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection pars = hh.DecryptRequestQuery();
                if (!string.IsNullOrEmpty(pars["IdVR"]))
                {
                    int li_IdVR = int.Parse(pars["IdVR"]);
                    TRG_seznam.DataBind();
                    TRG_seznam.FindRowByKeyValue(li_IdVR.ToString());
                    TRG_seznam_SelectedIndexChanged(sender, e);
                }
            }
        }

        protected void TRG_seznam_SelectedIndexChanged(object sender, EventArgs e)
        {
            string nazev_vr = string.Empty;
            if (IdVR > 0)
            {
                nazev_vr = TRG_seznam.SelectedItems[0].Cells[TRG_seznam.SelectedItems[0].Cells.Count - 1].Text;
                nadpis.Text = nazev_vr;
                TRG_seznam.Visible = false;
                lit_inzerat.Text = VyberovaRizeni.GetInzeratHtml(IdVR);
                lit_inzerat.Visible = true;
                PrihlButton.Visible = true;
                ZpetButton.Visible = true;
            }
            else
            {
                lit_inzerat.Visible = false;
                lit_inzerat.Text = string.Empty;
                PrihlButton.Visible = false;
                ZpetButton.Visible = false;
            }

            //sdilet lze jen publikovane jako externi
            if (IdVR > 0 && VyberovaRizeni.JePublicExternal(IdVR))
            {
                SocShare.Visible = true;
                SocShare.TitleToShare = "Volná pozice - " + nazev_vr;
                string url = "~/Public/VolnePozicePub.aspx"; //jina varianta teto stranky pristupna verejnosti
                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection queryString = new NameValueCollection();
                queryString.Add("IdVR", IdVR.ToString()); //ID VR
                //pokud by prihlaseny zamestnanec lezl na tuto public stranku
                //if (Globals.OsCisloAktUser > 0)
                //    queryString.Add("doporucil", Globals.OsCisloAktUser.ToString());//Pridam os.cislo zamestnance jako refferera (skonci v tabulce vybriz)
                url = hh.AddEncryptQuery(url, queryString);
                SocShare.UrlToShare = url;
                foreach (RadSocialButton b in SocShare.MainButtons)
                {
                    switch (b.SocialNetType)
                    {
                        case Telerik.Web.UI.SocialNetType.ShareOnFacebook:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Sdílet na Facebooku%]");
                            break;
                        case Telerik.Web.UI.SocialNetType.ShareOnTwitter:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Sdílet na Twitteru%]");
                            break;
                        case Telerik.Web.UI.SocialNetType.ShareOnGooglePlus:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Sdílet na Google+%]");
                            break;
                        case Telerik.Web.UI.SocialNetType.LinkedIn:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Sdílet na LinkedIn%]");
                            break;
                        case Telerik.Web.UI.SocialNetType.MailTo:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Poslat odkaz kamarádovi%]");
                            break;
                        case Telerik.Web.UI.SocialNetType.SendEmail:
                            b.ToolTip = ReadGlobalResource.ZmenaTextu("[%Poslat odkaz kamarádovi%]");
                            break;
                    }
                }
            }
            else
                SocShare.Visible = false;
        }

        protected void PrihlButton_Click(object sender, EventArgs e)
        {
            if (IdVR == 0)
                return; //neco je spatne

            //if (Globals.OsCisloAktUser > 0) //pokud by prihlaseny zamestnanec lezl na tuto public stranku
            //{
            //    //jsem přihlášený uživatel -> zkopiruji data zamestnance do uchazecu
            //    //a provedu prihlaseni uchazece na vybrane VR
            //    ev_cislo = Uchazeci.FindZamestnanec(Globals.OsCisloAktUser);
            //    if (ev_cislo == null)
            //        ev_cislo = Uchazeci.EvidovatZamestnance(Globals.OsCisloAktUser);
            //    VyberovaRizeni.ZarazeniUchazeceDoVR(ev_cislo.Value, IdVR);
            //    MessageBox.Show(Page, ReadGlobalResource.ZmenaTextu("[%Byl jste přihlášen do výběrového řízení na zvolenou pozici%]"));
            //}
            //else //externi uzivatel na Public strance -> presmeruji ho na CVUchFormV2 a predam ID VR a OS.Č. zaměstnance, který uchazeče dohodil
            //{
                string url = "~/Public/CVUchFormV2.aspx";
                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                NameValueCollection oldQueryString = hh.DecryptRequestQuery();
                NameValueCollection newQueryString = new NameValueCollection();
                newQueryString.Add("IdVR", IdVR.ToString());
                if (!string.IsNullOrEmpty(oldQueryString["doporucil"]))
                    newQueryString.Add("doporucil", oldQueryString["doporucil"]);
                url = hh.AddEncryptQuery(url, newQueryString);
                Page.Response.Redirect(url);
            //}

        }
        
        protected void ZpetButton_Click(object sender, EventArgs e)
        {
            nadpis.Text = "[%Volné pozice%]";
            TRG_seznam.Visible = true;
            lit_inzerat.Visible = false;
            ZpetButton.Visible = false;
            PrihlButton.Visible = false;
            SocShare.Visible = false;
        }
    }
}