﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Personal;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Drawing;
using KSProgram.Data;

namespace KSPortal.Sestavy
{
    public partial class KontrolaLimitu : TPage
    {
        public KontrolaLimitu()
        {
            IdPrava = 293;
        }
        //protected void Page_Load(object sender, EventArgs e)
        //{

        //}

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                //pokud je proveden výpočet mezd nastavím období na aktuální, jinak na předchozí
                int c = SqlPrikaz.ExecuteScalarInt32("select count(*) from organizer where " +
                    (Globals.IsViceIco && Globals.OsCislo > 0 ? ("os_cislo=" + Globals.OsCislo +" and ") : "") +
                    " obdobi=" + SqlPrikaz.ValueToString(Globals.AktObdobi) + " and (operace='b' or operace='v')", 0);
                if (c > 0)
                    RadMonthYearPicker1.SelectedDate = Globals.AktObdobi;
                else
                    RadMonthYearPicker1.SelectedDate = Globals.AktObdobi.AddMonths(-1);
                RadMonthYearPicker1.MaxDate = Globals.AktObdobi;
            }
        }
        protected void RG_lim_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string caption = "[%Stav limitů k období%] ";
            DateTime? date = RadMonthYearPicker1.SelectedDate;// RG_lim.Datum.SelectedObdobi;// String.IsNullOrEmpty(HF_obdobi.Text) ? (DateTime?)null : Convert.ToDateTime(HF_obdobi.Text);
            if (date == null)
                date = Globals.AktObdobi.AddMonths(-1);
            caption += date.Value.ToString("MM/yyyy");
            string podminka = "";
            caption += " (";
            if (cbx_jen_prekrocene.Checked)
                caption += "[%jen překročené/nesplněné%]";
            if (stredisko != null && stredisko.Checked)
            {
                caption += " [%za vybraná střediska%]";
                string s = strskupdiv.GetStred();
                if (!string.IsNullOrEmpty(s))
                    podminka = " pracovnici.kmen_str in (" + s + ") ";
                else
                    caption += " [%Není vybráno žádné středisko%]!";
            }
            else if (jen_prime.Checked)
            {
                caption += " [%přímí podřízení%]";
                string primi = Globals.RadkovePrava.GetPristupnaOscislaPrimych();
                if (!string.IsNullOrEmpty(primi))
                    podminka = " pracovnici.os_cislo in (" + primi + ") ";
                else
                    caption += " [%Nemáte žádné podřízené%]!";
            }
            else
                caption += " [%Vyberte jednu z voleb%]!";
            caption += " )";
            List<Limity.LimitStav> ds = new List<Limity.LimitStav>();
            if (!string.IsNullOrEmpty(podminka))
            {
                Limity lim = new Limity();
                ds = lim.Sestava((DateTime)date, podminka, cbx_jen_prekrocene.Checked);                
            }
            RadGrid table = (RadGrid)sender;
            table.DataSource = ds;
            RG_lim.MasterTableView.Caption = caption;
        }
        protected void RadMonthYearPicker1_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            //RadMonthYearPicker rmyp = (RadMonthYearPicker)sender;
            //HF_obdobi.Text = rmyp.SelectedDate.ToString();
            RG_lim.Rebind();
        }
        protected void TRB_filter_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_filter = (TRadButton)sender;
            if (TRB_filter.Checked)
            {
                RG_lim.AllowFilteringByColumn = true;
            }
            else
            {
                RG_lim.AllowFilteringByColumn = false;
            }
            //RG_lim.Rebind();
        }
        protected void RG_lim_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                //RadMonthYearPicker rmyp = (RadMonthYearPicker)e.Item.FindControl("RadMonthYearPicker1");
                ////km 23.5.2016 pokud je HF_obdobi.Text spatně tak se nastaví aktuální období -1 tak jako u nastavení data pri NeedDataSource
                //DateTime? date = String.IsNullOrEmpty(HF_obdobi.Text) ? (DateTime?)null : Convert.ToDateTime(HF_obdobi.Text);
                //if (date == null)
                //    date = Globals.AktObdobi.AddMonths(-1);
                //rmyp.SelectedDate = date;


                //TRadButton but = (TRadButton)e.Item.FindControl("TRB_filter");
                //but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;
            }
            if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
            {


                bool splneno = (bool)DataBinder.Eval(e.Item.DataItem, "splneno");
                if (!splneno)
                {
                    GridDataItem dataBoundItem = e.Item as GridDataItem;
                    dataBoundItem["cerpano"].ForeColor = Color.Red;
                    dataBoundItem["cerpano"].Font.Bold = true;
                }
            }
        }

        protected void RG_lim_ItemCreated(object sender, GridItemEventArgs e)
        {
            //if (e.Item.ItemType == GridItemType.CommandItem)
            //{
            //    RadMonthYearPicker RMP = (RadMonthYearPicker)e.Item.FindControl("RadMonthYearPicker1");
            //    RMP.Culture = System.Threading.Thread.CurrentThread.CurrentUICulture;
            //}
        }

        //protected void TRB_rebind_Click(object sender, EventArgs e)
        //{
        //    RG_lim.Rebind();
        //}
    }
}