﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Linq.Dynamic.Core;

namespace KSPortal.Sestavy
{
    public partial class MzdovePolozky : TPage
    {
        private static string stateKey = "Mzdovepolozky.aspx";

        public MzdovePolozky()
        {
            IdPrava = 373;

            AutomatickyUlozitNastaveni = true;

            TitleStranky = "[%Mzdové položky%]";

            VerzeStranky = "18";
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            if (!IsPostBack)
            {
                TRG_mzdove_pozky.Datum.SelectedObdobiOd = Globals.AktObdobi;
                TRG_mzdove_pozky.Datum.SelectedObdobiDo = Globals.AktObdobi;
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
        }

        protected override void OnPreRenderComplete(EventArgs e)
        {
            base.OnPreRenderComplete(e);
        }

        private static T _deserialize<T>(string state)
        {
            return string.IsNullOrEmpty(state) ? default(T) : Newtonsoft.Json.JsonConvert.DeserializeObject<T>(state);
        }

        private static string _serialize(object o)
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(o);
        }

        private string _vcetne_pojmu
        {
            get
            {
                //return ObjSetting.LoadValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_vcetne_pojmu");
                return objSettingGet<string>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_vcetne_pojmu", false);
            }
            set 
            {
                //ObjSetting.SaveValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_vcetne_pojmu", value);
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_vcetne_pojmu", value, false);
            }
        }

        private string _insert_empties
        {
            get
            {
                //return ObjSetting.LoadValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_insert_empties");
                return objSettingGet<string>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_insert_empties", false);
            }
            set
            {
                //ObjSetting.SaveValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_insert_empties", value);
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_insert_empties", value, false);
            }
        }

        private short _agregace
        {
            get
            {
                return objSettingGet<string>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_agregace", false).TryParse<short>();
            }
            set
            {
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_agregace", value.ToString(), false);
            }
        }

        private List<short> _kody
        {
            get
            {
                //List<short> o = _deserialize<List<short>>(ObjSetting.LoadBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody"));
                return objSettingGet<List<short>>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody", true) ?? new List<short>() { };
            }
            set
            {
                //ObjSetting.SaveBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody", _serialize(value));
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody", _serialize(value), true);
            }
        }

        private List<string> _pojmy
        {
            get
            {
                //List<string> o = _deserialize<List<string>>(ObjSetting.LoadBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy"));
                return objSettingGet<List<string>>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy", true) ?? new List<string>() { };
            }
            set
            {
                //ObjSetting.SaveBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy", _serialize(value));
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy", _serialize(value), true);
            }
        }

        protected static List<string> _varianty
        {
            get
            {
                //List<string> o = _deserialize<List<string>>(ObjSetting.LoadBlobValue(0, stateKey, "_varianty"));
                return objSettingGet<List<string>>(0, stateKey, "_varianty", true) ?? new List<string>() { };
            }
            set
            {
                //ObjSetting.SaveBlobValue(0, stateKey, "_varianty", _serialize(value));
                objSettingCacheSave(0, stateKey, "_varianty", _serialize(value), true);
            }
        }

        private string _varianta
        {
            get
            {
                //string o = ObjSetting.LoadValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_varianta");
                return objSettingGet<string>(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_varianta", false);
            }
            set
            {
                //ObjSetting.SaveValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_varianta", value);
                objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_varianta", value, false);
            }
        }

        private DateTime _obdobi_od 
        {
            get
            {
                return TRG_mzdove_pozky.Datum.SelectedObdobiOd ?? TRG_mzdove_pozky.Datum.SelectedObdobiDo ?? Globals.AktObdobi.AddMonths(-1);
            }
        }

        private DateTime _obdobi_do
        {
            get
            {
                return TRG_mzdove_pozky.Datum.SelectedObdobiDo ?? TRG_mzdove_pozky.Datum.SelectedObdobiOd ?? Globals.AktObdobi.AddMonths(-1);
            }
        }

        private string _sql_filter_expression;
        private string _filter_expression;

        private static string _datat_cache_prefix
        {
            get
            {
                return "Mzdove_polozky_" + Globals.OsCisloAktUserNeboZastupovany + "_";
            }
        }

        private string _data_cache_key
        {
            get
            {
                return _datat_cache_prefix + _obdobi_od.ToShortDateString() + "_" + _obdobi_do.ToShortDateString() + "_" + _insert_empties + "_" + _agregace.ToString() + "_f" + _sql_filter_expression?.GetHashCode();
            }
        }

        private List<KSProgram.Sestavy.MzdovePolozky> _data
        {
            get
            {
                TRadObdobiInterval radObdobiInterval = TRG_mzdove_pozky.GetGridCommandItemControl?.TRadObdobiInterval;
                if(radObdobiInterval == null)
                {
                    return new List<KSProgram.Sestavy.MzdovePolozky>() { };
                }
                object o = CacheInfo.GetItemFromCache(_data_cache_key);
                if (o == null)
                {
                    o = KSProgram.Sestavy.MzdovePolozky.GetList(_obdobi_od, _obdobi_do, _kody, _pojmy, _insert_empties == "a", _agregace, _sql_filter_expression);
                    CacheInfo.AddItemToCache(_data_cache_key, o, 15, System.Web.Caching.CacheItemPriority.Normal);
                }
                List<KSProgram.Sestavy.MzdovePolozky> ret = o as List<KSProgram.Sestavy.MzdovePolozky>;
                if (!string.IsNullOrEmpty(_filter_expression))
                {
                    ret = ret.AsQueryable().Where(_filter_expression).Cast<KSProgram.Sestavy.MzdovePolozky>().ToList();
                }
                ret = ret.FindAll(x => (!x.isPojem || _pojmy == null || _pojmy.Count == 0 || _pojmy.Contains(x.vyznam)) && (x.isPojem || _kody == null || _kody.Count == 0 || _kody.Contains((short)x.kod)));
                if(_vcetne_pojmu == "m")
                {
                    ret.RemoveAll(x => x.isPojem);
                }
                else if (_vcetne_pojmu == "p")
                {
                    ret.RemoveAll(x => !x.isPojem);
                }

                return ret;
            }
        }

        private static void ClearCache()
        {
            CacheInfo.RemoveItemStartWithFromCache(_datat_cache_prefix);
        }

        protected void TRG_mzdove_pozky_PreRender(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                nactiNastaveniVarianty(HashAndCrypto.GetHash(_varianta));
            }
        }

        protected void TRG_mzdove_pozky_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            int i = 0;
            foreach (GridGroupByExpression exp in TRG_mzdove_pozky.MasterTableView.GroupByExpressions)
            {
                GridGroupByField oc = exp.SelectFields.FindByName("os_cislo");
                if (oc != null)
                {
                    GridGroupByField jmeno = exp.SelectFields.FindByName("jmeno");
                    GridGroupByField prijmeni = exp.SelectFields.FindByName("prijmeni");
                    if (jmeno == null)
                    {
                        jmeno = new GridGroupByField();
                        jmeno.FieldName = "jmeno";
                        jmeno.HeaderText = ReadGlobalResource.ZmenaTextu("[%Jméno%]");

                        //exp.GroupByFields.Add(jmeno);
                        exp.SelectFields.Add(jmeno);
                        //rebind = true;
                    }
                    if (prijmeni == null)
                    {
                        prijmeni = new GridGroupByField();
                        prijmeni.FieldName = "prijmeni";
                        prijmeni.HeaderText = ReadGlobalResource.ZmenaTextu("[%Příjmení%]");

                        //exp.GroupByFields.Add(prijmeni);
                        exp.SelectFields.Add(prijmeni);
                        //rebind = true;
                    }
                }
                GridGroupByField cp = exp.SelectFields.FindByName("cislo_pom");
                if (cp != null)
                {
                    GridGroupByField druh = exp.SelectFields.FindByName("druh_pom_t");
                    GridGroupByField misto = exp.SelectFields.FindByName("naz_pracmist");
                    if (druh == null)
                    {
                        druh = new GridGroupByField();
                        druh.FieldName = "druh_pom_t";
                        druh.HeaderText = ReadGlobalResource.ZmenaTextu("[%Druh pom.%]");

                        //exp.GroupByFields.Add(druh);
                        exp.SelectFields.Add(druh);
                        //rebind = true;
                    }
                    if (misto == null)
                    {
                        misto = new GridGroupByField();
                        misto.FieldName = "naz_pracmist";
                        misto.HeaderText = ReadGlobalResource.ZmenaTextu("[%Parocovní místo%]");

                        //exp.GroupByFields.Add(misto);
                        exp.SelectFields.Add(misto);
                        //rebind = true;
                    }
                }
                GridGroupByField cm = exp.SelectFields.FindByName("cis_pracmist");
                if (cm != null)
                {
                    GridGroupByField misto = exp.SelectFields.FindByName("naz_pracmist");
                    if (misto == null)
                    {
                        misto = new GridGroupByField();
                        misto.FieldName = "naz_pracmist";
                        misto.HeaderText = ReadGlobalResource.ZmenaTextu("[%Parocovní místo%]");

                        //exp.GroupByFields.Add(misto);
                        exp.SelectFields.Add(misto);
                        //rebind = true;
                    }
                }

                GridGroupByField ps = exp.SelectFields.FindByName("prac_str");
                if (ps != null)
                {
                    GridGroupByField pst = exp.SelectFields.FindByName("prac_str_t");
                    if (pst == null)
                    {
                        pst = new GridGroupByField();
                        pst.FieldName = "prac_str_t";
                        pst.HeaderText = ReadGlobalResource.ZmenaTextu("[%Pracovní středisko%]");
                        exp.SelectFields.Add(pst);
                        //rebind = true;
                    }
                }
                //pokud se agreguje sloupec "castka", "hruba", "cista" pridám i agregace do grup ale jen dve první, pak to blbne
                foreach (string name in new List<string> { "castka", "hruba", "cista" })
                {
                    GridNumericColumn column = (GridNumericColumn)TRG_mzdove_pozky.MasterTableView.GetColumn(name);
                    var agregate = column.Aggregate;
                    GridGroupByField selectField = exp.SelectFields.FindByName(name);
                    if (selectField == null)
                    {
                        if (agregate != GridAggregateFunction.None && i < 2)
                        {
                            selectField = new GridGroupByField();
                            selectField.FieldName = name;
                            selectField.HeaderText = ReadGlobalResource.ZmenaTextu(column.HeaderText);
                            selectField.FieldAlias = name + i;
                            exp.SelectFields.Add(selectField);

                            //rebind = true;
                        }
                    }
                    else if (agregate == GridAggregateFunction.None || i >= 2)
                    {
                        for (int f = 0; exp.SelectFields.Count > f; f++)
                        {
                            if (exp.SelectFields[f] == selectField)
                            {
                                exp.SelectFields.RemoveAt(f);
                                //rebind = true;
                                break;
                            }
                        }
                    }

                    if(selectField != null)
                    {
                        selectField.Aggregate = agregate;
                        selectField.FormatString = agregate.ToString() + " {0:## ### ### ### ##0.00}";
                    }
                }

                i += 1;
            }

            if (isGroupChange || isFilterChange)
            {
                TRG_mzdove_pozky.DataSource = new List<KSProgram.Sestavy.MzdovePolozky>() { };
            }
            else
            {
                //odstraním agregace ze sloupců které jsou v datech zcela prázdné, abych předešel chybě při agregaci
                foreach (string name in new List<string> { "dny", "hodiny", "sazba" })
                {

                    if ((((GridNumericColumn)TRG_mzdove_pozky.MasterTableView.GetColumnSafe(name))?.Aggregate ?? GridAggregateFunction.None) != GridAggregateFunction.None
                        && _vcetne_pojmu != "m")
                    {
                        ((GridNumericColumn)TRG_mzdove_pozky.MasterTableView.GetColumnSafe(name)).Aggregate = GridAggregateFunction.None;
                    }
                }

                foreach (string name in new List<string> { "dny", "hodiny", "sazba", "castka", "hruba", "cista" })
                {
                    GridNumericColumn column = ((GridNumericColumn)TRG_mzdove_pozky.MasterTableView.GetColumnSafe(name));
                    if (column.Aggregate != GridAggregateFunction.None)
                    {
                        column.FooterAggregateFormatString = column.Aggregate.ToString() + ": " + column.DataFormatString;
                    }
                }

                if (_vcetne_pojmu == "p")
                {
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("kod").Display = false;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("dny").Display = false;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("hodiny").Display = false;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("sazba").Display = false;
                    //TRG_mzdove_pozky.MasterTableView.GetColumnSafe("castka").Display = false;
                }
                else
                {
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("kod").Display = true;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("dny").Display = true;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("hodiny").Display = true;
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("sazba").Display = true;
                    //TRG_mzdove_pozky.MasterTableView.GetColumnSafe("castka").Display = true;
                }

                if(_agregace == 2)
                {
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("datum").Display = false;
                }
                else
                {
                    TRG_mzdove_pozky.MasterTableView.GetColumnSafe("datum").Display = true;
                }

                _filter_expression = TRG_mzdove_pozky.MasterTableView.GetSqlFilterExpression();
                _sql_filter_expression = TRG_mzdove_pozky.MasterTableView.GetEntitySqlFilterExpression();
                TRG_mzdove_pozky.DataSource = _data;
            }
        }
        protected void TRB_pojmy_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
        {
            _vcetne_pojmu = e.SelectedToggleState.Value;
        }
        protected void TRB_pojmy_PreRender(object sender, EventArgs e)
        {
            ((TRadButton)sender).SetSelectedToggleStateByValue(_vcetne_pojmu);
        }
        protected void TRB_pojmy_Init(object sender, EventArgs e)
        {
            if (!IsPostBack && string.IsNullOrEmpty(_vcetne_pojmu))
            {
                _vcetne_pojmu = ((TRadButton)sender).SelectedToggleState.Value;
            }
        }

        protected void TRB_insertEmpties_PreRender(object sender, EventArgs e)
        {
            ((TRadButton)sender).SetSelectedToggleStateByValue(_insert_empties);
        }

        protected void TRB_insertEmpties_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
        {
            _insert_empties = e.SelectedToggleState.Value;
        }

        protected void TRB_insertEmpties_Init(object sender, EventArgs e)
        {
            if (!IsPostBack && string.IsNullOrEmpty(_insert_empties))
            {
                _insert_empties = ((TRadButton)sender).SelectedToggleState.Value;
            }
        }

        protected void TRB_agregace_PreRender(object sender, EventArgs e)
        {
            ((TRadButton)sender).SetSelectedToggleStateByValue(_agregace.ToString());
        }

        protected void TRB_agregace_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
        {
            _agregace = e.SelectedToggleState.Value.TryParse<short>();
        }

        protected void TRB_agregace_Init(object sender, EventArgs e)
        {
            if (!IsPostBack && string.IsNullOrEmpty(_insert_empties))
            {
                _agregace = ((TRadButton)sender).SelectedToggleState.Value.TryParse<short>();
            }
        }

        protected void TRCB_polozky_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            int kod = (int)DataBinder.Eval(e.Item.DataItem, "kod");

            if (_kody.Exists(x => x == kod))
            {
                e.Item.Checked = true;
            }
            else
            {
                e.Item.Checked = false;
            }
        }

        protected void TRCB_pojmy_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            KeyValuePair<string, List<short>> pojem = (KeyValuePair<string, List<short>>)e.Item.DataItem;
            
            e.Item.Text = pojem.Key;
            e.Item.Value = pojem.Key;
            e.Item.Attributes.Add("title", ReadGlobalResource.ZmenaTextu("[%Sdružuje položky {0}%]", string.Join(", ", pojem.Value)));

            if (_pojmy.Contains(pojem.Key))
            {
                e.Item.Checked = true;
            }
            else
            {
                e.Item.Checked = false;
            }
        }

        //[WebMethod(EnableSession = true)]
        //public static RadComboBoxData GetPolozky()
        //{
        //    List<short> selected = _deserialize<List<short>>(ObjSetting.LoadBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody"));
        //    return KSProgram.Sestavy.MzdovePolozky.GetCiselnik(selected);
        //}

        [WebMethod(EnableSession = true)]
        public static void SaveVybranePolozky(string json)
        {
            //ObjSetting.SaveBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody", json);
            objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_kody", json, true);
            ClearCache();
        }

        //[WebMethod(EnableSession = true)]
        //public static RadComboBoxData GetPojmy()
        //{
        //    List<string> selected = _deserialize<List<string>>(ObjSetting.LoadBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy"));
        //    return KSProgram.Sestavy.Pojmy.GetComboCiselnik(selected);
        //}

        [WebMethod(EnableSession = true)]
        public static void SaveVybranePojmy(string json)
        {
            //ObjSetting.SaveBlobValue(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy", json);
            objSettingCacheSave(Globals.OsCisloAktUserNeboZastupovany, stateKey, "_pojmy", json, true);
            ClearCache();
        }

        public static void objSettingCacheSave(decimal os_cislo, string obj, string key, string json, bool blob)
        {
            string cacheKey = os_cislo + "_" + obj + "_" + key;
            if (blob)
            {
                ObjSetting.SaveBlobValue(os_cislo, obj, key, json);
            }
            else
            {
                ObjSetting.SaveValue(os_cislo, obj, key, json);
                
            }
            SessionInfo.SetVariable(cacheKey, json);
        }

        public static T objSettingGet<T>(decimal os_cislo, string obj, string key, bool blob)
        {
            T ret = default(T);
            string cacheKey = os_cislo + "_" + obj + "_" + key;
            object o = SessionInfo.GetVariable(cacheKey);
            
            if(o == null)
            {
                if (blob)
                {
                    string json = ObjSetting.LoadBlobValue(os_cislo, obj, key);
                    SessionInfo.SetVariable(cacheKey, json);
                    ret = _deserialize<T>(json);
                }
                else
                {
                    ret = (T)(object)ObjSetting.LoadValue(os_cislo, obj, key);
                    SessionInfo.SetVariable(cacheKey, ret);
                }
            }
            else
            {
                if (blob)
                {
                    ret = _deserialize<T>((string)o);
                }
                else 
                {
                    ret = (T)o;
                }
            }
            return ret;
        }

        bool isGroupChange;
        protected void TRG_mzdove_pozky_GroupsChanging(object sender, GridGroupsChangingEventArgs e)
        {
            isGroupChange = true;
        }

        protected void RCB_setting_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            _varianta = e.Text;
            if (_varianty.Contains(e.Text))
            {
                nactiNastaveniVarianty(HashAndCrypto.GetHash(_varianta));
                TRG_mzdove_pozky.Rebind();
            }
        }

        protected void RCB_setting_PreRender(object sender, EventArgs e)
        {
            ((TRadComboBox)sender).Text = _varianta;
        }

        protected void TRB_save_setting_Click(object sender, EventArgs e)
        {
            TRadButton TRB_save = (TRadButton)sender;
            TRadComboBox RCB_setting = TRB_save.FindParentControl<GridCommandItemControl>()?.FindControlRecursive<TRadComboBox>("RCB_setting");
            if (!_varianty.Contains(RCB_setting.Text))
            {
                List<string> o = _varianty;
                o.Add(RCB_setting.Text);
                _varianty = o;
            }

            _varianta = RCB_setting.Text;

            ulozNastaveniVarianty(HashAndCrypto.GetHash(_varianta));
        }

        protected void TRB_delete_setting_Click(object sender, EventArgs e)
        {
            TRadButton TRB_delete = (TRadButton)sender;
            TRadComboBox RCB_setting = TRB_delete.FindParentControl<GridCommandItemControl>()?.FindControlRecursive<TRadComboBox>("RCB_setting");
            if (_varianty.Contains(RCB_setting.Text))
            {
                List<string> o = _varianty;
                o.Remove(RCB_setting.Text);
                _varianty = o;

                smazNastaveniVarianty(HashAndCrypto.GetHash(RCB_setting.Text));
            }

            _varianta = _varianty.FirstOrDefault();
            nactiNastaveniVarianty(HashAndCrypto.GetHash(_varianta));
        }

        private void ulozNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
            setPersistManager(ref mng);
            mng.StorageProvider = dsp;
            mng.SaveState();
        }

        private void nactiNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
            setPersistManager(ref mng);
            mng.StorageProvider = dsp;
            mng.LoadState();

            short pom;
            bool bpom;
            _kody =
                TRG_mzdove_pozky.GetGridCommandItemControl?
                .FindControlRecursive<TRadComboBox>("TRCB_polozky")?.CheckedItems.ToList()
                .FindAll(x => short.TryParse(x.Value, out pom))
                .Select(x => x.Value.TryParse<short>(out bpom))
                .ToList();

            _pojmy =
                TRG_mzdove_pozky.GetGridCommandItemControl?
                .FindControlRecursive<TRadComboBox>("TRCB_pojmy")?.CheckedItems.ToList()
                .FindAll(x => !string.IsNullOrEmpty(x.Value))
                .Select(x => x.Value.Trim())
                .ToList();

            _vcetne_pojmu =
                TRG_mzdove_pozky.GetGridCommandItemControl?
                .FindControlRecursive<TRadButton>("TRB_pojmy")?.SelectedToggleState.Value;

            _insert_empties =
                TRG_mzdove_pozky.GetGridCommandItemControl?
                .FindControlRecursive<TRadButton>("TRB_insertEmpties")?.SelectedToggleState.Value;

            _agregace =
                TRG_mzdove_pozky.GetGridCommandItemControl?
                .FindControlRecursive<TRadButton>("TRB_agregace")?.SelectedToggleState.Value.TryParse<short>() ?? 1;

            ClearCache();
        }

        private void smazNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            dsp.DeleteStateFromStorage(cookieName);
        }

        private void setPersistManager(ref RadPersistenceManager mng)
        {
            addPersistSetting(TRG_mzdove_pozky, ref mng);
            addPersistSetting(TRG_mzdove_pozky.GetGridCommandItemControl?.FindControlRecursive<TRadComboBox>("TRCB_polozky"), ref mng);
            addPersistSetting(TRG_mzdove_pozky.GetGridCommandItemControl?.FindControlRecursive<TRadComboBox>("TRCB_pojmy"), ref mng);
            addPersistSetting(TRG_mzdove_pozky.GetGridCommandItemControl?.FindControlRecursive<TRadButton>("TRB_pojmy"), ref mng);
            addPersistSetting(TRG_mzdove_pozky.GetGridCommandItemControl?.FindControlRecursive<TRadButton>("TRB_insertEmpties"), ref mng);
            addPersistSetting(TRG_mzdove_pozky.GetGridCommandItemControl?.FindControlRecursive<TRadButton>("TRB_agregace"), ref mng);
        }

        private void addPersistSetting(Control control, ref RadPersistenceManager mng)
        {
            if(control != null)
            {
                PersistenceSetting seting = new PersistenceSetting();
                seting.ControlInstance = control;
                if (!mng.PersistenceSettings.Contains(seting))
                    mng.PersistenceSettings.Add(seting);
            }
        }

        internal override void On_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
        {
            base.On_LoadCustomSettings(sender, e);
        }

        [WebMethod]
        public static RadComboBoxData GetVarianty(RadComboBoxContext context)
        {
            RadComboBoxData comboData = new RadComboBoxData();
            comboData.Items =
                _varianty
                .FindAll(x => _varianty.Contains(context.Text) || x.ToLower().Contains(context.Text?.ToLower()))
                .Select(x => new RadComboBoxItemData()
                {
                    Text = x,
                    Value = HashAndCrypto.GetHash(x)
                })
                .ToArray();

            comboData.EndOfItems = true;
            comboData.NumberOfItems = comboData.Items.Length;

            return comboData;
        }
        bool isFilterChange;
        protected void GCIC_RB_CheckedChanged(object sender, EventArgs e)
        {
            isFilterChange = true;
        }
    }
}