﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Data;
using KSProgram;
using System.Collections.Generic;
using KSProgram.WebControls;
using System.ComponentModel;
using System.Drawing;
using KSProgram.Prava;
using KSProgram.Funkce;
using KSProgram.Obecne;
using Telerik.Web.UI;

public partial class Sestavy_OrganizacniSlozeni : TSestavaPredek
{
    public Sestavy_OrganizacniSlozeni()
    {
        IdPrava = 44;
        this.HelpURL = "Organiza%C4%8Dn%C3%AD_slo%C5%BEen%C3%AD_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }

    private DateTime id_datum = DateTime.Now;
    private List<StrSystZaznam> ia_idStromy = new List<StrSystZaznam>();

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            _nactiStromy();
            TRadComboBox DropDownList1 = WebControlHelper.FindControl(this, "DropDownList1") as TRadComboBox;
            RadComboBoxItem it = new RadComboBoxItem("("+WebControlHelper.ZmenaTextu("[%Vše%]")+")", "vse");
            DropDownList1.Items.Add(it);
        }
    }

    private void _nactiStromy()
    {
        Int32? vychozi;
        int id_pracmist = 0;
        string nazev, orgjednotka;
        DateTime? maxod, maxdo;

        string sql = "";

        List<Int32> prist_podniky = ViceIco.GetPodnikyPristupnych();
        ParametryPrikazu par = new ParametryPrikazu();

        //MD 14.6.2011 nebyla ošetřena řádková práva podle AD
        //PH 15.12.2014 změněn odkaz z Globals.OsCisloAktUser na Globals.OsCisloAktUserNeboZastupovany
        if (Globals.RadkovePrava.TypPrav == RadpravaTyp.SYSTEMIZACE)
        {
            string sqlCommand = "";
           
            if (Zakaznik.IsCurrent("SKODA")) //PH 15.12.2014
            {
                id_pracmist=Prac_pom.Get_id_mista_den(Globals.OsCisloAktUserNeboZastupovany, DateTime.Today.Date);
            }
            else
            {
                //PH 25.6.2015 nemělo by se to vázat na hlavní poměr
                short cislo_pom=-1;
                Prac_pom.Platny_Pomer_Den(Globals.OsCisloAktUserNeboZastupovany, DateTime.Today.Date, out cislo_pom); 
                 sqlCommand = "select id_pracmist" +
                                " from prac_pom" +
                                " where cislo_pom = "+SqlPrikaz.ValueToString(cislo_pom)+" and os_cislo = " + Globals.OsCisloAktUserNeboZastupovany.ToString() +
                                " and datum_nastupu <= " + SqlPrikaz.DateTimeToString(DateTime.Today.Date) +
                                " and ( datum_ukonc is null or datum_ukonc >= " + SqlPrikaz.DateTimeToString(DateTime.Today.Date) + ")";
                 id_pracmist = SqlPrikaz.ExecuteScalarInt32(sqlCommand, 0);
            }

            sql = "select systemizace.id_stromu,naz_stromu, org_jednotka, systemiz_podnik.datum_od, systemiz_podnik.datum_do " +
            " from systemizace, systemiz_podnik, system_stromy " +
            " where id_pracmist=@id_pracmist" +
            " and systemiz_podnik.id_systemizace=systemizace.id_systemizace " +
            " and systemizace.id_stromu=system_stromy.id_stromu " +
            " and systemiz_podnik.navrh=0 " +
            " and typ_polozky=1 " +
            " and (systemizace.datum_od<=@datum or systemizace.datum_od is null) " +
            " and (systemizace.datum_do<=@datum or systemizace.datum_do is null) " +
            " and (systemiz_podnik.datum_od is null or systemiz_podnik.datum_od <= @datum)" +
            " and (systemiz_podnik.datum_do is null or systemiz_podnik.datum_do >=@datum)"+
            " and (system_stromy.id_podniku in(@podniky) or system_stromy.id_podniku is null)";
            par = new ParametryPrikazu
            {
                new KSParameter("id_pracmist", DbType.Int32, id_pracmist),
                new KSParameter("datum", DbType.Date, id_datum),
                new KSParameter("podniky", DbType.Int32, prist_podniky)
            };
        }
        else
        {
          
            sql = "select id_stromu, naz_stromu, org_jednotka, systemiz_podnik.datum_od, systemiz_podnik.datum_do " +
            " from system_stromy, systemiz_podnik " +
            " where system_stromy.id_systemizace = systemiz_podnik.id_systemizace " +
            " and navrh = 0 and zakladni = 1 " +
            " and (systemiz_podnik.datum_od is null or systemiz_podnik.datum_od <= @datum)" +
            " and (systemiz_podnik.datum_do is null or systemiz_podnik.datum_do >= @datum)"+
            " and (system_stromy.id_podniku in(@podniky) or system_stromy.id_podniku is null)";
            par = new ParametryPrikazu
            {
                new KSParameter("datum", DbType.Date, id_datum),
                new KSParameter("podniky", DbType.Int32, prist_podniky)
            };
        }

      

        IDataReader reader = null;
        try
        {
            reader = SqlPrikaz.ExecuteReader(sql,par);
            while (reader.Read())
            {
                vychozi = GetNullOrData.GetInt32(reader, 0);
                nazev = GetNullOrData.GetString(reader, 1);
                orgjednotka = GetNullOrData.GetString(reader, 2);
                maxod = GetNullOrData.GetDateTime(reader, 3);
                maxdo = GetNullOrData.GetDateTime(reader, 4);

                StrSystZaznam zazn = new StrSystZaznam();
                zazn.Cislo = (int)vychozi;
                zazn.Nazev = nazev.Trim();
                if (!ia_idStromy.Contains(zazn))
                    ia_idStromy.Add(zazn);
            }
            if (ia_idStromy.Count == 0)
            {
                throw new KSProgram.Exceptions.NoticeException("Nepodařilo se najít základní strom ke dni: " + id_datum.ToString("d"));
            }
        }
        finally
        {
            if (reader != null)
            {
                reader.Close();
                reader.Dispose();
            }
        }

        if (!IsPostBack)
        {
            //DropDownList1.Items.Add("(Všechny)");
            //PH 22.6.2010
            //ListItem it = new ListItem(WebControlHelper.ZmenaTextu(this.Page, "([%Všechny%])"), "(Všechny)");
            RadComboBoxItem it = new RadComboBoxItem();
            TRadComboBox DropDownList1 = WebControlHelper.FindControl(this, "DropDownList1") as TRadComboBox;
            DropDownList1.Items.Add(it);

            for (int i = 0; i < ia_idStromy.Count; i++)
            {
                RadComboBoxItem item = new RadComboBoxItem(ia_idStromy[i].Nazev, ia_idStromy[i].Cislo.ToString());
                if (DropDownList1.Items.FindItemByValue(item.Value, true) == null)
                    DropDownList1.Items.Add(item);
                _nactiPodStromy(id_pracmist, ia_idStromy[i].Cislo, 1, prist_podniky);
            }
        }
    }

    private void _nactiPodStromy(int id_pracmist, int vychozi, int vychoziLevel, List<Int32> prist_podniky)
    {
        RadComboBox DropDownList1 = WebControlHelper.FindControl(this, "DropDownList1") as RadComboBox;

        Int32? ll_idstromu, ll_id_nadrizeny;
        List<Int32> lal_id = new List<int>();
        List<string> las_jedn = new List<string>();
        String ls_nazev, ls_orgjednotka;
       
        string sql = " select id_pracmist, naz_stromu, org_jednotka, id_nadrizeny " +
                   " from systemizace, system_stromy  " +
                   " where typ_polozky = 4 and systemizace.id_stromu = @vychozi and  " +
                   "     system_stromy.id_stromu = systemizace.id_pracmist and " +
                   "     (systemizace.datum_od is null or systemizace.datum_od <=@datum) and " +
                   "     (systemizace.datum_do is null or systemizace.datum_do >=@datum) and "+
                   "  (system_stromy.id_podniku in(@podniky) or system_stromy.id_podniku is null)"; ;
        ParametryPrikazu par = new ParametryPrikazu();
        par.Add(new KSParameter("vychozi", DbType.Int32, vychozi));
        par.Add(new KSParameter("datum", DbType.Date, id_datum));
        par.Add(new KSParameter("podniky", DbType.Int32, prist_podniky));
        IDataReader reader = null;
        try
        {
            reader = SqlPrikaz.ExecuteReader(sql, par);
            while (reader.Read())
            {
                ll_idstromu = GetNullOrData.GetInt32(reader, 0);
                ls_nazev = GetNullOrData.GetString(reader, 1);
                ls_orgjednotka = GetNullOrData.GetString(reader, 2);
                ll_id_nadrizeny = GetNullOrData.GetInt32(reader, 3);

                if (vychoziLevel > 0)
                {
                    //pokud pod pracovním místem není nic podřízeno tak nenačítám podstromy
                    int pocet = SqlPrikaz.ExecuteScalarInt32("select count(*) from systemizace where id_stromu=" + vychozi.ToString() +
                                                    " and id_nadrizeny=" + id_pracmist.ToString(), 0);
                    if (pocet == 0) continue;
                }

                if (ll_idstromu != null)
                {
                    lal_id.Add((Int32)ll_idstromu);

                    if (ls_nazev == null) { ls_nazev = ""; }
                    las_jedn.Add(ls_nazev);
                }
            }
        }
        finally
        {
            if (reader != null)
            {
                reader.Close();
                reader.Dispose();
            }
        }

        for (int i = 0; i < lal_id.Count; i++)
        {
            RadComboBoxItem it = new RadComboBoxItem(las_jedn[i], lal_id[i].ToString());
            if (DropDownList1.Items.FindItemByValue(it.Value) == null)
                DropDownList1.Items.Add(it);

            StrSystZaznam zazn = new StrSystZaznam();
            zazn.Cislo = lal_id[i];
            zazn.Nazev = las_jedn[i];
            ia_idStromy.Add(zazn);
            _nactiPodStromy(id_pracmist, lal_id[i], 0, prist_podniky);
        }
    }

    /// <summary>
    /// Pro uložení záznamu o stromech
    /// </summary>
    private struct StrSystZaznam
    {
        /// <summary>
        /// Název stromu
        /// </summary>
        public string Nazev;

        /// <summary>
        /// Id stromu
        /// </summary>
        public Int32 Cislo;
    }
    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {   
        TGridView2x.Rebind();
    }


    
    protected void TGridView2_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
        {
            int def_pocet = Convert.ToInt16(DataBinder.Eval(e.Item.DataItem, "def_pocet"));
            int poradi = Convert.ToInt16(DataBinder.Eval(e.Item.DataItem, "poradi"));
            object obj = DataBinder.Eval(e.Item.DataItem, "os_cislo");

            if (def_pocet < poradi)
            {
                e.Item.Cells[12].BackColor = Color.Yellow;
                e.Item.Cells[13].BackColor = Color.Yellow;
            }
           
            if (obj == DBNull.Value)
            {
                e.Item.Cells[15].ForeColor = Color.Red;
                e.Item.Cells[15].Text = "***";

                e.Item.Cells[16].ForeColor = Color.Red;
                e.Item.Cells[16].Text = "***" + WebControlHelper.ZmenaTextu(this.Page, "[%neobsazeno%]") + "***";
            }
        }
    }

    protected void TGridView2x_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
        {
            e.Item.Cells[12].Text = DataBinder.Eval(e.Item.DataItem, "poradi").ToString();
            e.Item.Cells[13].Text = DataBinder.Eval(e.Item.DataItem, "def_pocet").ToString();
            e.Item.Cells[14].Text = "";

            LinkButton c = e.Item.FindControl("LinkButton2") as LinkButton;
            c.CommandArgument= DataBinder.Eval(e.Item.DataItem, "id_pracmist").ToString();
            c.CommandName = "prac_misto";
        }
        else if (e.Item.ItemType == GridItemType.GroupFooter)
        {
           // e.Item.Cells[13].Text = WebControlHelper.ZmenaTextu("[%Nadpočetní%]:");
        }
    }

    protected void TGridView2_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {        

        DataTable table = new DataTable();
        if (IsPostBack)
        {
            //DateTime date = (DateTime)TRGrid.Datum.SelectedObdobi;
            List<int> aid_stromu=new List<int>();
            string co = "";
            string pomery = "";
            //string stred = StrSkupDiv.GetStred();
            

            RadComboBox ddl_pomery = WebControlHelper.FindControl(this, "ddl_pomery") as RadComboBox;
            pomery = ddl_pomery.SelectedValue;

            RadComboBox box_volna = WebControlHelper.FindControl(this, "DropDownList2") as RadComboBox;
            co = box_volna.SelectedValue;

            RadComboBox box= WebControlHelper.FindControl(this, "DropDownList1") as RadComboBox;
            RadComboBox info_sloupec1 = WebControlHelper.FindControl(this, "ddlb_1info_sloupec") as RadComboBox;
            RadComboBox info_sloupec2 = WebControlHelper.FindControl(this, "ddlb_2infosloupec") as RadComboBox;
            string val = box.SelectedValue;

            if (!string.IsNullOrEmpty(val))
            {
                if (val == "vse")
                {
                    //načtu všechny stromy v rozbalovátku
                    for (int li = 0; li < box.Items.Count; li++)
                    {
                        int p = 0;
                        val = box.Items[li].Value;
                        if (int.TryParse(val, out p))
                        {
                            aid_stromu.Add(p);
                        }
                    }                  
                }
                else
                {
                    int p=0;
                    if (int.TryParse(val, out p))
                    {
                        aid_stromu.Add(p);
                    }
                }

                string popisek = info_sloupec1.Text;
                if (!string.IsNullOrEmpty(popisek))
                    ((RadGrid)sender).MasterTableView.GetColumn("info1").HeaderText = popisek;

                popisek = info_sloupec2.Text;
                if (!string.IsNullOrEmpty(popisek))
                    ((RadGrid)sender).MasterTableView.GetColumn("info2").HeaderText = popisek;

                //načtení přístupných pracovních míst
                //------------------------------------------------
                DataTable pristupMista = KSProgram.PracovniMista.PracMista.SeznamPM();
                string pm = ",";
                for (int i = 0; i < pristupMista.Rows.Count; i++)
                {
                    pm += pristupMista.Rows[i]["id"].ToString();
                    pm += ",";
                }
                //------------------------------------
                //pm = "";
                table = new KSProgram.Sestavy.DefSestavy_pp006().Retrieve(aid_stromu.ToArray(), DateTime.Now.Date, co, pm, pomery, info_sloupec1.SelectedValue, info_sloupec2.SelectedValue, check_nahradit.Checked);
                ((RadGrid)sender).DataSource = table;
            }
        }
        ((RadGrid)sender).DataSource = table;
    }

    protected void LinkButton2_Command(object sender, CommandEventArgs e)
    {
        if (e.CommandName == "prac_misto")
        {
            int id_pracmista = Convert.ToInt32(e.CommandArgument);
            Response.Redirect("~/Zamestnanec/PracMistoZam.aspx?pm=" + id_pracmista.ToString());
        }
    }

    protected void TGridView2x_PreRender(object sender, EventArgs e)
    {
        RadGrid grid = ((RadGrid)sender);
       
        GridColumnGroupCollection groups = grid.MasterTableView.ColumnGroups;
        GridColumnGroup gr = groups.FindGroupByName("oj");
        gr.HeaderText  =(check_nahradit.Checked ?WebControlHelper.ZmenaTextu("[%Středisko%]") : WebControlHelper.ZmenaTextu("[%Organizační jednotka%]"));       
 
        grid.MasterTableView.GetColumn("oj_zkratka").Visible = !check_nahradit.Checked;
    }

    protected void TGridView2x_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
    {       
        if (e.FormattedColumn.UniqueName == "naz_pracmist")
        {
            dynamic dataItem = (((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem;
            e.Cell.Text = dataItem["naz_pracmist"].ToString();
        }
    }
}
