﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram;
using Telerik.Web.UI;
using System.Linq;
using System.Collections.Generic;
using static Telerik.Web.UI.GridTableView;

public partial class Sestavy_PomeryMzd : TSestavaPredek
{

    public Sestavy_PomeryMzd()
    {
        IdPrava = 68;
        this.HelpURL = "Pracovn%C3%AD_pom%C4%9Bry_-_mzdov%C3%A9_%C3%BAdaje_%28Zam%C4%9Bstnanci_p%C5%99ehledy%29";
        this.VerzeStranky = "7";
        this.AutomatickyUlozitNastaveni = true;
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            string typOrg = KSProgram.Funkce.Parametr_cti.Get("typ_org");
            bool rozpOrg = (typOrg == "r");
            
            TRadGrid_sestava.MasterTableView.GetColumn("pripl_vedeni").Visible = rozpOrg;
            TRadGrid_sestava.MasterTableView.GetColumn("pripl_zvlastni").Visible = rozpOrg;

            if(!KSProgram.Prava.PravaAkce.PristupPovolen(339))
            {
                TRadGrid_sestava.MasterTableView.GetColumn("typ_premii").Visible = false;
                TRadGrid_sestava.MasterTableView.GetColumn("vyznam").Visible = false;
                TRadGrid_sestava.MasterTableView.GetColumn("prem_cast").Visible = false;
                TRadGrid_sestava.MasterTableView.GetColumn("premie_proc_ind").Visible = false;
            }
            else
            {
                TRadGrid_sestava.MasterTableView.GetColumn("typ_premii").Visible = true;
                TRadGrid_sestava.MasterTableView.GetColumn("vyznam").Visible = true;
                TRadGrid_sestava.MasterTableView.GetColumn("prem_cast").Visible = true;
                TRadGrid_sestava.MasterTableView.GetColumn("premie_proc_ind").Visible = true;
            }

            if(KSProgram.Funkce.Parametr_cti.Get("Datum_plan_odch") == "a")
            {
                TRadGrid_sestava.MasterTableView.GetColumn("datum_plan_odch").Visible = true;
            }
            else
            {
                TRadGrid_sestava.MasterTableView.GetColumn("datum_plan_odch").Visible = false;
            }
        }
    }

    protected void TRadGrid_sestava_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == "selectZam")
        {
            GridDataItem item = (GridDataItem)e.Item;
            if (item != null)
            {
                LinkButton link = (LinkButton)item["os_cislo"].Controls[0];
                OsCisloZmena.Nastavit(this, Convert.ToDecimal(link.Text));
                ObnovAktZam();
                Response.Redirect("~/Zamestnanec/PracPomerMzd.aspx");
            }
        }
    }

    protected void TRadGrid_sestava_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable table = new KSProgram.Sestavy.DefSestavy_mzd001().Retrieve(TRadGrid_sestava.PracovniPomery.GetValue);
        TRadGrid_sestava.DataSource = table;
    }

    internal override void On_LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
    {
        base.On_LoadSettings(sender, e);
        foreach(string name in new List<string>() { "typ_premii", "vyznam", "prem_cast", "premie_proc_ind" })
        { 
            PersistableColumnSetting set = ((List<Telerik.Web.UI.GridTableView.PersistableColumnSetting>)e.Settings.FirstOrDefault(x => x.UniqueId == "ctl00$HlavniOblast$TRadGrid_sestava")?.ControlSettings.FirstOrDefault(x => x.Name == "MasterTableView.ColumnSettings").Value)?.FirstOrDefault(x => x.UniqueName == name);
            if(set != null)
            {
                if (KSProgram.Prava.PravaAkce.PristupPovolen(339))
                {
                    set.Visible = true;
                }
                else
                {
                    set.Visible = false;
                }
            }
        }
    }
}
