﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Zpravy;
using System.Data;
using KSProgram.Data;
using KSProgram.WebControls;
using KSProgram;
using System.Collections.Specialized;
using System.Text.RegularExpressions;
using Telerik.Web.UI;

namespace KSPortal.Sestavy
{
    public partial class Sestavy_PrijatyEmail : TPopUpPage
    {
        private Int32 Id
        {
            get
            {
                Int32 ret = 0;
                QueryStringCrypto ht = new QueryStringCrypto();
                NameValueCollection data = ht.DecryptRequestQuery();
                try { ret = Convert.ToInt32(data["id"]); }
                catch { }
                return ret;
            }
        }
        private List<Priloha> _Prilohy
        {
            get
            {
                object lses = ViewState["prilohy_emailu"];
                return lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;
            }
            set
            {
                ViewState["prilohy_emailu"] = value;
            }
        }

        private string _Telo
        {
            get
            {
                object lses = ViewState["telo_emailu"];
                return lses == null ? "" : (string)lses;
            }
            set
            {
                ViewState["telo_emailu"] = value;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            //zruseni odsazeni v tabulce master page
            System.Web.UI.HtmlControls.HtmlTable tab = (System.Web.UI.HtmlControls.HtmlTable)Master.FindControl("Table1");
            tab.Rows[0].Cells[0].Style.Remove("padding-top");
            tab.Rows[0].Cells[0].Style.Remove("padding-left");
            tab.Rows[0].Cells[0].Style.Remove("padding-right");
            tab.Rows[0].Cells[0].Style.Remove("padding-bottom");

            if (!Page.IsPostBack)
            {
                Int32 id = Id;
                if (id != 0)
                {
                    Zprava zprava = new Zprava((Int32)id);
                   
                    DataTable dt = new DataTable("zprava");
                    Zpravy.AddSloupce(ref dt);
                    zprava.AddToDataRow(ref dt);

                    TFormView1.DataSource = dt;
                    TFormView1.DataBind();

                    base.TitleStranky = "[%Zpráva číslo%] " + id.ToString();
                    
                    Repeater rep = (Repeater)TFormView1.FindControl("Repeater1");

                    if (zprava.Prilohy.Count != 0)
                    {
                        _Prilohy = zprava.Prilohy;
                        DataTable ptable = new DataTable("prilohy");
                        ptable.Columns.Add("nazev", typeof(string));
                        ptable.Columns.Add("argument", typeof(string));
                        ptable.Columns.Add("size", typeof(string));
                        foreach (Priloha priloha in zprava.Prilohy)
                        {
                            DataRow row = ptable.NewRow();
                            row["nazev"] = priloha.Nazev;
                            row["argument"] = priloha.Id_Blob;
                            if (priloha.Obsah == null)
                            {
                                row["size"] = "0 kB";
                            }
                            else
                            {
                                row["size"] = decimal.Round((priloha.Obsah.Length / (decimal)1024), 1).ToString() + " kB";
                            }
                            ptable.Rows.Add(row);
                        }
                        rep.DataSource = ptable;
                        rep.DataBind();
                    }
                    ((TRadButton)TFormView1.FindControl("TLinkButton4")).Visible = zprava.Odesilatel != Globals.OsCisloAktUser;
                    ((TRadButton)TFormView1.FindControl("TLinkButton5")).Visible = zprava.Odesilatel != Globals.OsCisloAktUser;
                    
                    if (zprava.Telo_text != null){
                        if (zprava.Telo_text.IndexOf("<ASmessage><ASbody>") == -1)
                            _Telo = zprava.Telo_text;
                        else
                            _Telo = zprava.Telo_text.Substring(zprava.Telo_text.IndexOf("<ASmessage><ASbody>") + 19, zprava.Telo_text.IndexOf("</ASbody><ASpassword>") - 19);
                    }
                    else //pokud není tělo e-mailu nalezeno tak blob neobsahuje informace se zprávou 
                    {
                        _Telo = "";
                        /*dt.Rows[0]["telo"] = "<p><span style=\"color:#FF0000; font-size:16px;\"><em><strong>" + WebControlHelper.ZmenaTextu("Tělo zprávy nebylo nalezeno") + "!</strong></em></span></p>";
                        TFormView1.DataSource = dt;
                        TFormView1.DataBind();*/
                    }
                }
                

            }
        }

        //tlačítko pro přílohy
        protected void TLinkButton2_Command(object sender, CommandEventArgs e)
        {
            Int32 id_pril = Convert.ToInt32(e.CommandArgument);
            byte[] data = new byte[0];

            foreach (Priloha prl in _Prilohy)
            {
                if (prl.Id_Blob == id_pril)
                {
                    data = prl.Obsah;
                    KSProgram.Attachment.Send(Page, ((TLinkButton)sender).Text, data);
                    break;
                }
            }
        }

        //zavřít
        protected void TLinkButton3_Click(object sender, EventArgs e)
        {
            if (!this.Page.ClientScript.IsClientScriptBlockRegistered("closeWindowclose"))
            {
                this.Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "closeWindowclose", "window.close()", true);
                ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "closeWindowclose", "window.close()", true);
            }
        }

        //smazat
        protected void TLinkButton4_Click(object sender, EventArgs e)
        {
            Int32 id = Id;
            if (id != 0)
            {
                Zpravy.Delete(id);
            }

            if (!this.Page.ClientScript.IsClientScriptBlockRegistered("closeWindow"))
            {
                this.Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "closeWindow", "window.close()", true);
                ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "closeWindow", "window.close()", true);
            }
        }

        //ospovědět
        protected void TLinkButton5_Click(object sender, EventArgs e)
        {
            Label tb = (Label)TFormView1.FindControl("Label10");
            decimal? o_cislo = null;
            if (!string.IsNullOrEmpty(tb.Text))
            {
                Regex rgx = new Regex(@"\d+", RegexOptions.IgnoreCase);
                MatchCollection pars = rgx.Matches(tb.Text);
                if (pars.Count != 0)
                {
                    o_cislo = Convert.ToDecimal(pars[0].Value);
                }
            }
            string predmet = "Re: " + ((Label)TFormView1.FindControl("Label3")).Text;
            string telo = "<br><br>--- " + tb.Text + " - " + ((Label)TFormView1.FindControl("Label5")).Text + " ---<br>" + _Telo;

            if (o_cislo != null)
                Session["adresy_emailu"] = new List<decimal?>() { o_cislo };
            Session["predmet_emailu"] = predmet;
            Session["telo_emailu"] = telo;
            Session["prilohy_emailu"] = _Prilohy; // připojit k odpovědi i zprávy

            string url = "~/Zamestnanec/NovaZprava.aspx";
            Response.Redirect(url);
  
        }

        protected string _celeJmeno(object o_os_cislo)
        {
            string ls_celejmeno = "";
            decimal os_cislo = 0;
            try
            {
                os_cislo = Convert.ToDecimal(o_os_cislo);
            }
            catch
            {
                return o_os_cislo.ToString();
            }
            string sql = "SELECT titul, jmeno, prijmeni, titul_za FROM pracovnici WHERE os_cislo = " + os_cislo + " ORDER BY prijmeni";
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader(sql);
                while (reader.Read())
                {
                    string ls_prijmeni = GetNullOrData.GetString(reader, 2, string.Empty).Trim();
                    string ls_jmeno = GetNullOrData.GetString(reader, 1, string.Empty).Trim();
                    string ls_titul = GetNullOrData.GetString(reader, 0, string.Empty).Trim();
                    string ls_titul_za = GetNullOrData.GetString(reader, 3, string.Empty).Trim();

                    if (ls_jmeno != string.Empty) ls_celejmeno = ls_jmeno;
                    if (ls_prijmeni != string.Empty) ls_celejmeno += " " + ls_prijmeni;
                    if (ls_titul != string.Empty) ls_celejmeno = ls_titul + " " + ls_celejmeno;
                    if (ls_titul_za != string.Empty) ls_celejmeno = ls_celejmeno + ", " + ls_titul_za;
                    ls_celejmeno = os_cislo + " - " + ls_celejmeno;
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }
            return ls_celejmeno.Trim();
        }

    }
}