﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.WebControls;
using System.Globalization;
using System.Drawing;
using System.Collections.Generic;
using KSProgram.Extensions;
using Telerik.Web.UI;
using KSProgram.Sluzebky;
using static Telerik.Web.UI.GridEditFormItem;
using KSProgram.Prava;
using System.Collections;

namespace KSPortal.Sestavy
{
    public partial class ScObsazVozidel : TPage
    {
        public ScObsazVozidel()
        {
            this.IdPrava = 326;
            //this.HelpURL = "";
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
                RadWinEdit.VisibleOnPageLoad = false;
            else if (Request["__EVENTTARGET"] == "reloadRadWinEdit" && PravaAkce.PristupPovolen(338))
            {
                string[] args = Request["__EVENTARGUMENT"].Split(',');
                string spz = args[0];
                string den = args[1];

                DateTime date = (DateTime)TRGrid.Datum.SelectedObdobi;
                date = new DateTime(date.Year, date.Month, Int32.Parse(den));

                //MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] !"));
                if (den == null)
                    MessageBox.Alert(Page, "den je null");
                else
                {
                    HF_spz.Value = spz;
                    ODS_polozky.SelectParameters["spz"].DefaultValue = spz;
                    ODS_polozky.SelectParameters["dat_od"].DefaultValue = date.ToString();
                    ODS_polozky.SelectParameters["dat_do"].DefaultValue = date.AddHours(23).AddMinutes(59).ToString();

                    //foreach(GridItem item in RG_polozky_dne.EditItems)
                    //{
                    //    item.Edit = false;
                    //}
                    RG_polozky_dne.MasterTableView.ClearEditItems();
                    //RG_polozky_dne.MasterTableView.IsItemInserted = false;

                    //(RG_polozky_dne.Columns.FindByUniqueName("spz") as GridBoundColumn).DefaultInsertValue = spz;
                    (RG_polozky_dne.Columns.FindByUniqueName("dat_od") as GridDateTimeColumn).DefaultInsertValue = date.ToString("dd.MM.yyyy HH:mm");
                    (RG_polozky_dne.Columns.FindByUniqueName("dat_do") as GridDateTimeColumn).DefaultInsertValue = date.AddHours(23).AddMinutes(59).ToString("dd.MM.yyyy HH:mm");
                    RG_polozky_dne.DataSourceID = "ODS_polozky";
                    RG_polozky_dne.DataBind();
                    RadWinEdit.Title = "[%Blokace a rezervace vozidla%]: " + spz
                        + " [%termín%]: " + date.ToString("dd.MM.yyyy");
                    RadWinEdit.VisibleOnPageLoad = true;
                }
            }
        }

        protected void TRGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            if (IsPostBack)
            {
                DateTime date = (DateTime)TRGrid.Datum.SelectedObdobi;
                string stred = StrSkupDiv.GetStred();
                //table = KSProgram.Sluzebky.SlcVozidla.ObsazenostVozidel(date, stred);
                //PR 28.06.2021 HID=56005
                table = KSProgram.Sluzebky.SlcVozidla.ObsazenostVozidel(date, stred, cbx_vcetne_pridelenych.Checked);
                TRGrid.DataSource = table;
            }
            TRGrid.DataSource = table;
        }
                
        protected void TRGrid_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
            {
                GridHeaderItem item = e.Item as GridHeaderItem;
                List<DateTime> svatky = PlanovaciKalendar.GetSvatky((DateTime)TRGrid.Datum.SelectedObdobi, ((DateTime)TRGrid.Datum.SelectedObdobi).PosledniDen());

                DateTimeFormatInfo info = DateTimeFormatInfo.GetInstance(CultureInfo.CurrentUICulture);
                DateTime ld_pom = (DateTime)TRGrid.Datum.SelectedObdobi;

                int HiddenCellsCount = item.Cells.Count - TRGrid.Columns.Count;
                int i_1_cell_idx = TRGrid.Columns.FindByUniqueName("i_1").OrderIndex;
                for (int i = 1; i <= 31; i++)
                {
                    int c = i_1_cell_idx + i - 1;
                    if (ld_pom.Month != ((DateTime)TRGrid.Datum.SelectedObdobi).Month)
                    {
                        TRGrid.Columns.FindByUniqueName("i_" + i.ToString()).Visible = false;
                    }
                    else
                    {
                        TRGrid.Columns.FindByUniqueName("i_" + i.ToString()).Visible = true;

                        item.Cells[c].Text = ld_pom.Day.ToString() + "<br/>" + info.GetAbbreviatedDayName(ld_pom.Date.DayOfWeek);
                        if ((ld_pom.DayOfWeek == DayOfWeek.Saturday) || (ld_pom.DayOfWeek == DayOfWeek.Sunday))
                            item.Cells[c].ForeColor = Color.Red;

                        if (svatky.FindIndex(pp => pp.Date == ld_pom.Date) > -1)
                        {
                            item.Cells[c].BorderColor = Color.Red;
                            item.Cells[c].BorderStyle = BorderStyle.Solid;
                            item.Cells[c].BorderWidth = Unit.Pixel(2);
                        }
                    }
                    ld_pom = ld_pom.AddDays(1);
                }
            }
            else if (e.Item is GridDataItem && PravaAkce.PristupPovolen(338)) //Právo na editaci
            {
                GridDataItem item = e.Item as GridDataItem;

                int i_1_cell_idx = TRGrid.Columns.FindByUniqueName("i_1").OrderIndex;
                for (int i = 1; i <= 31; i++)
                {
                    int c = i_1_cell_idx + i - 1;
                    
                    System.Web.UI.WebControls.Image img = item.Cells[c].FindControl("img_" + i) as System.Web.UI.WebControls.Image; //z Template
                    if (img == null && item.Cells[c].Controls.Count > 0 && item.Cells[c].Controls[0] is System.Web.UI.WebControls.Image) //z GridimageColumn
                        img = (System.Web.UI.WebControls.Image)item.Cells[c].Controls[0];
                    if (img != null)
                    { 
                        img.Attributes.Add("onclick", "ImgClick('" + item.GetDataKeyValue("spz") + "','" + i.ToString() + "');");
                        img.Attributes.Add("style", "cursor: pointer;");
                    }
                }
            }
        }

        protected void RG_polozky_dne_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridEditableItem && e.Item.IsInEditMode)
            {
                GridEditableItem item = (GridEditableItem)e.Item;

                //GridDropDownListColumnEditor editor = (GridDropDownListColumnEditor)item.EditManager.GetColumnEditor("duvod");
                //RadComboBox ComboBox = editor.ComboBoxControl;
                RadComboBox ComboBox = (RadComboBox)item["duvod"].Controls[0];
                ComboBox.BackColor = Color.FromArgb(255, 255, 204);

                TextBox textbox = (TextBox)item["poznamka"].Controls[0];
                textbox.Width = 360;

                GridDateTimeColumnEditor dt_editor = (GridDateTimeColumnEditor)item.EditManager.GetColumnEditor("dat_od");
                dt_editor.PickerControl.Width = 120;
                dt_editor.PickerControl.DateInput.BackColor = Color.FromArgb(255, 255, 204);

                dt_editor = (GridDateTimeColumnEditor)item.EditManager.GetColumnEditor("dat_do");
                dt_editor.PickerControl.Width = 120;
                dt_editor.PickerControl.DateInput.BackColor = Color.FromArgb(255, 255, 204);

                TableCell cell = (TableCell)dt_editor.ContainerControl;

                CustomValidator validator = new CustomValidator();
                validator.ForeColor = Color.Red;
                validator.ServerValidate += RG_polozky_dne_validate;
                cell.Controls.Add(validator);
            }
            else if (e.Item is GridDataItem)
            {
                if ((e.Item as GridDataItem).DataItem != null)
                {
                    DateTime dat_od = (DateTime)((e.Item as GridDataItem).DataItem as DataRowView)["dat_od"];
                    DateTime dat_do = (DateTime)((e.Item as GridDataItem).DataItem as DataRowView)["dat_do"];
                    System.Web.UI.Control Btn_Ukonci = e.Item.Cells[RG_polozky_dne.Columns.FindByUniqueName("Btn_Ukonci").OrderIndex].Controls[0];
                    Btn_Ukonci.Visible = dat_od < DateTime.Now && DateTime.Now < dat_do;
                }
            }
        }

        public void RG_polozky_dne_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;
            
            GridEditableItem item = null;
            
            if (validator.BindingContainer is GridEditableItem)
            {
                item = (GridEditableItem)validator.BindingContainer;                
            
                GridDateTimeColumnEditor dat_od_editor = (GridDateTimeColumnEditor)item.EditManager.GetColumnEditor("dat_od");
                DateTime dat_od = dat_od_editor.PickerControl.SelectedDate.Value;

                GridDateTimeColumnEditor dat_do_editor = (GridDateTimeColumnEditor)item.EditManager.GetColumnEditor("dat_do");
                DateTime dat_do = dat_do_editor.PickerControl.SelectedDate.Value;

                if (dat_od > dat_do)
                {
                    e.IsValid = false;
                    validator.ErrorMessage = "[%Datum počátku je větší než datum konce%]";
                    return;
                }

                //kontrola prekryti 
                int? original_id = null;
                if (item.ItemIndex != -1)
                    original_id = (int)item.GetDataKeyValue("id");
                string popis;
                DateTime konflikt_od, konflikt_do;
                if (SlcVozidla.BlokaceExists(HF_spz.Value, original_id, null, null, dat_od, dat_do, out popis, out konflikt_od, out konflikt_do))
                {
                    e.IsValid = false;
                    validator.ErrorMessage = "[%Blokace se překrývá s jinou%]";
                }
            }
        }

        protected void RG_polozky_dne_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "Ukonci")
            {
                SlcVozidla.BlokaceUkonci((int)(e.Item as GridDataItem).GetDataKeyValue("id"));
                RG_polozky_dne.Rebind();
            }
        }
    }
}