﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram.Prava;
using System.Xml.Linq;
using KSProgram.Extensions;

public partial class Personal_SeznamZam : TPage
{
    public Personal_SeznamZam()
    {
        IdPrava = 31;
        VisibleFindZam = false; //2.9.2009 dočasně zakázáno
        this.HelpURL = "Seznam_zam%C4%9Bstnanc%C5%AF_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            TC_Podnik.Visible = (Parametry.ParametrCti("StromStredisek") == "a"); //MD 16.3.2015
        }
        RadGrid1.MasterTableView.GetColumn("foto").Visible = KSProgram.Funkce.Pracovnik.ShowPhoto();
    }

    protected void TC_Podnik_ItemCreated(TreeItem item)
    {
        HyperLink selectLink = new HyperLink();
        selectLink.ApplyStyleSheetSkin(Page);
        selectLink.Text = item.Data["title"].ToString();
        selectLink.NavigateUrl = Page.ClientScript.GetPostBackClientHyperlink(item, "Select");
        item.ItemControls.Add(selectLink);
    }

    protected void TC_Podnik_SelectedItemChanged(TreeItem item)
    {
        ODS_Zamestnanci.SelectParameters.Clear();
        ODS_Zamestnanci.SelectParameters.Add("strediska", item.Data["strediska"].ToString());
    }

    protected void RadGrid1_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem gridDataItem = e.Item as GridDataItem;
            object osCislo = gridDataItem.GetDataKeyValue("os_cislo");

            if (e.CommandName == "Select")
            {
                OsCisloZmena.Nastavit(this, Convert.ToDecimal(osCislo));
            }
            else if (e.CommandName == "ShowContextMenu")
            {
                ViewState["ContextMenuOsCislo"] = osCislo;
            }
        }
    }

    protected void RadContextMenu1_Load(object sender, EventArgs e)
    {
        RadContextMenu menu = sender as RadContextMenu;
        foreach (RadMenuItem item in menu.Items)
        {
            XElement xel = KSProgram.Obecne.TMenu.FindNodeByUrl(item.Value);
            if (xel != null)
            {
                int id_prava = Convert.ToInt32(xel.Attribute("pravo").Value);
                //item.Visible = PravaAkce.PristupPovolen(id_prava);
                //MD 13.1.2016 povolit jen položky přístupné pro všechny, viz. HID 31027
                int stavPrava = -1;
                PravaAkce.PristupPovolen(id_prava, ref stavPrava);
                item.Visible = (stavPrava == 1);
                item.Text = xel.Attribute("title").Value;
            }
        }
    }

    protected void RadContextMenu1_ItemClick(object sender, Telerik.Web.UI.RadMenuEventArgs e)
    {
        object osCislo = ViewState["ContextMenuOsCislo"];
        OsCisloZmena.Nastavit(this, Convert.ToDecimal(osCislo));
        Response.Redirect("~/" + e.Item.Value);
    }

    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if(e.Item is GridFilteringItem)
        {
            NumericValidator numericValidator = new NumericValidator();
            ///numericValidator.Display = ValidatorDisplay.Static;
            var textbox = (e.Item as GridFilteringItem).FindControl("FilterTextBox_os_cislo");
            numericValidator.ControlToValidate = "FilterTextBox_os_cislo";
            numericValidator.ErrorMessage = "";
            textbox.FindParentControl<GridTableCell>()?.Controls.Add(numericValidator);
        }
    }
}
