﻿using KSProgram;
using KSProgram.Ciselniky;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.OboryVzdelani;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Script.Services;
using System.Web.Services;
using Telerik.Web.UI;

namespace KSPortal.WebServices
{
    /// <summary>
    /// Summary description for AutoCompleteService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    [System.Web.Script.Services.ScriptService]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class AutoCompleteService : System.Web.Services.WebService
    {
        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetObce(RadComboBoxContext context)
        {
            string psc = "";
            if (context.ContainsKey("psc"))
                psc = context["psc"] == null ? "" : ((string)context["psc"]).Trim();
            Regex regex = new Regex(@"[0-9]+");
            MatchCollection filter_coll = regex.Matches(psc);
            if (filter_coll.Count > 0)
            {
                psc = filter_coll[0].Value;
            }
            else
            {
                psc = "";
            }
            string sql = "SELECT distinct obec FROM psc WHERE 1 = 1";
            sql += string.IsNullOrEmpty(context.Text) ? "" : " AND LOWER(obec) LIKE '" + context.Text.ToLower() + "%'";
            sql += string.IsNullOrEmpty(psc) ? "" : " AND psc = " + SqlPrikaz.ValueToString(psc);
            sql += " ORDER BY obec";
            DataTable data = new DataTable();
            data.Columns.Add("obec", typeof(string));

            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    DataRow row = data.NewRow();

                    row["obec"] = GetNullOrData.GetString(reader, "obec", "", true);

                    data.Rows.Add(row);
                }
            }

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Rows.Count)
                {
                    endOffset = data.Rows.Count;
                }
                if (endOffset == data.Rows.Count)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Text = data.Rows[i]["obec"].ToString();
                    itemData.Value = data.Rows[i]["obec"].ToString();

                    result.Add(itemData);
                }

                if (data.Rows.Count > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetPsc(RadComboBoxContext context)
        {
            string obec = "";
            if (context.ContainsKey("obec"))
                obec = context["obec"] == null ? "" : ((string)context["obec"]).Trim();
            string sql = "SELECT distinct psc, posta FROM psc WHERE 1 = 1";
            sql += string.IsNullOrEmpty(context.Text) ? "" : " AND ( LOWER(psc) LIKE '" + context.Text.ToLower() + "%' OR LOWER(posta) LIKE '" + context.Text.ToLower() + "%' )";
            sql += string.IsNullOrEmpty(obec) ? "" : " AND LOWER(obec) = " + SqlPrikaz.ValueToString(obec.ToLower());
            sql += " ORDER BY psc";
            DataTable data = new DataTable();
            data.Columns.Add("psc", typeof(string));
            data.Columns.Add("posta", typeof(string));

            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    DataRow row = data.NewRow();

                    row["psc"] = GetNullOrData.GetString(reader, "psc", "", true);
                    row["posta"] = GetNullOrData.GetString(reader, "posta", "", true);

                    data.Rows.Add(row);
                }
            }

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Rows.Count)
                {
                    endOffset = data.Rows.Count;
                }
                if (endOffset == data.Rows.Count)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Text = data.Rows[i]["psc"].ToString() + " " + data.Rows[i]["posta"].ToString();
                    itemData.Value = data.Rows[i]["psc"].ToString();

                    result.Add(itemData);
                }

                if (data.Rows.Count > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;
        }

        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetTrida(RadComboBoxContext context)
        {
            short pom_typ_tt, typ_mzdy;
            short? typ_tt;
            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();

            if (context.ContainsKey("typ_tt") && context["typ_tt"] != null && short.TryParse(context["typ_tt"].ToString(), out pom_typ_tt))
                typ_tt = pom_typ_tt;
            else
                typ_tt = null;

            if ((context.ContainsKey("typ_mzdy") && context["typ_mzdy"] != null && short.TryParse(context["typ_mzdy"].ToString(), out typ_mzdy)) ||
                (context.ContainsKey("typ_mzdy_old") && context["typ_mzdy_old"] != null && short.TryParse(context["typ_mzdy_old"].ToString(), out typ_mzdy)))
            {
                try
                {
                    ParametryPrikazu pars = new ParametryPrikazu()
                {
                    new KSParameter("typ_tt", DbType.Int16, typ_tt),
                    new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy)
                };
                    DataTable data = SqlPrikaz.ExecuteCommand("SELECT DISTINCT trida FROM tarify WHERE (typ_tt = @typ_tt OR @typ_tt IS NULL) AND typ_mzdy = @typ_mzdy ORDER BY trida", ref pars);

                    result = (from r in data.AsEnumerable()
                              select new RadComboBoxItemData()
                              {
                                  Text = r["trida"].ToString(),
                                  Value = r["trida"].ToString()
                              }).ToList();

                }
                catch (Exception e)
                {
                    comboData.Message = e.Message;
                }
            }

            comboData.Items = result.ToArray();
            comboData.NumberOfItems = result.Count;
            comboData.Text = result.Count > 0 ? result[0]?.Text : null;
            comboData.Value = result.Count > 0 ? result[0]?.Value : null;
            return comboData;
        }

        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetSmena(RadComboBoxContext context)
        {
            short typ_kal;
            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();

            if ((context.ContainsKey("typ_kal") && context["typ_kal"] != null && short.TryParse(context["typ_kal"].ToString(), out typ_kal)) ||
                (context.ContainsKey("typ_kal_old") && context["typ_kal_old"] != null && short.TryParse(context["typ_kal_old"].ToString(), out typ_kal)))
            {
                try
                {
                    result = (from r in CisPracRozvrh.Rozvrhy(typ_kal).AsEnumerable()
                              select new RadComboBoxItemData()
                              {
                                  Text = GetNullOrData.GetString(r["cely_nazev"], true),
                                  Value = GetNullOrData.GetInt16(r["cislo"]).ToString()
                              }).ToList();
                }
                catch (Exception e)
                {
                    comboData.Message = e.Message;
                }
            }

            comboData.Items = result.ToArray();
            comboData.NumberOfItems = result.Count;
            comboData.Text = result.Count > 0 ? result[0]?.Text : null;
            comboData.Value = result.Count > 0 ? result[0]?.Value : null;
            return comboData;
        }

        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetMzdStupen(RadComboBoxContext context)
        {
            short pom_typ_tt, typ_mzdy, pom_trida;
            short? typ_tt, trida;
            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();

            if (context.ContainsKey("typ_tt") && context["typ_tt"] != null && short.TryParse(context["typ_tt"].ToString(), out pom_typ_tt))
                typ_tt = pom_typ_tt;
            else
                typ_tt = null;

            if ((context.ContainsKey("trida") && context["trida"] != null && short.TryParse(context["trida"].ToString(), out pom_trida)) ||
                (context.ContainsKey("trida_old") && context["trida_old"] != null && short.TryParse(context["trida_old"].ToString(), out pom_trida)))
                trida = pom_trida;
            else
                trida = null;

            if ((context.ContainsKey("typ_mzdy") && context["typ_mzdy"] != null && short.TryParse(context["typ_mzdy"].ToString(), out typ_mzdy)) ||
                (context.ContainsKey("typ_mzdy_old") && context["typ_mzdy_old"] != null && short.TryParse(context["typ_mzdy_old"].ToString(), out typ_mzdy)))
            {
                try
                {
                    ParametryPrikazu pars = new ParametryPrikazu()
                {
                    new KSParameter("typ_tt", DbType.Int16, typ_tt),
                    new KSParameter("typ_mzdy", DbType.Int16, typ_mzdy),
                    new KSParameter("trida", DbType.Int16, trida)
                };
                    DataTable data = SqlPrikaz.ExecuteCommand("SELECT DISTINCT mzd_stup FROM tarify WHERE (typ_tt = @typ_tt OR @typ_tt IS NULL) AND typ_mzdy = @typ_mzdy AND (trida = @trida OR @trida IS NULL) ORDER BY mzd_stup", ref pars);

                    result = (from r in data.AsEnumerable()
                              select new RadComboBoxItemData()
                              {
                                  Text = r["mzd_stup"].ToString(),
                                  Value = r["mzd_stup"].ToString()
                              }).ToList();

                }
                catch (Exception e)
                {
                    comboData.Message = e.Message;
                }
            }

            comboData.Items = result.ToArray();
            comboData.NumberOfItems = result.Count;
            comboData.Text = result.Count > 0 ? result[0]?.Text : null;
            comboData.Value = result.Count > 0 ? result[0]?.Value : null;
            return comboData;
        }

        [WebMethod(EnableSession = true)]
        public RadComboBoxData GetKZAM(RadComboBoxContext context)
        {
            DataTable datatb = CisKzam.Seznam(false);
            DataRow[] data = null;
            if (!string.IsNullOrEmpty(context.Text))
            {
                data = datatb.Select("cely_nazev LIKE '%" + context.Text + "%'", "cislo");
            }
            else
            {
                data = datatb.Select("cislo = cislo");
            }


            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 10;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Length)
                {
                    endOffset = data.Length;
                }
                if (endOffset == data.Length)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Text = data[i]["cely_nazev"].ToString();
                    itemData.Value = data[i]["cislo"].ToString();

                    result.Add(itemData);
                }

                if (data.Length > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Length);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;

        }

        [WebMethod(EnableSession = true)]
        public RadComboBoxData OboryVzdel_Ciselniky(RadComboBoxContext context)
        {
           
            Dictionary<string, object> par = new Dictionary<string, object>();
            if (context["co"].ToString() == "roky")
            {
            }
            else if (context["co"].ToString() == "typy_skol")
            {
                par.Add("rok", Convert.ToInt32(context["rok"]));
                par.Add("misto_studia", context["misto_studia"].ToString());
            }
            else if (context["co"].ToString() == "mesto")
            {
                int rok = Convert.ToInt32(context["rok"]);
                string misto= context["misto_studia"].ToString();
                string typ = context["typ"].ToString();

                par.Add("rok", rok);
                par.Add("misto_studia", misto);
                par.Add("typ", typ);
                if (OborVzdel.PouzijBaso(misto, rok, typ))
                    return new RadComboBoxData();
            }
            else if (context["co"].ToString() == "skola")
            {
                par.Add("rok", Convert.ToInt32(context["rok"]));
                par.Add("misto_studia", context["misto_studia"].ToString());
                par.Add("typ", context["typ"].ToString());
                par.Add("obec", context["obec"].ToString());
            }
            else if (context["co"].ToString() == "obor")
            {
                par.Add("rok", Convert.ToInt32(context["rok"]));
                par.Add("misto_studia", context["misto_studia"].ToString());
                par.Add("typ", context["typ"].ToString());
                par.Add("obec", context["obec"].ToString());
                par.Add("skola", context["skola"].ToString());
            }


            DataTable data = OborVzdel.DataProCiselnik(context["co"].ToString(), par);

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(context.NumberOfItems);
            RadComboBoxData comboData = new RadComboBoxData();
            try
            {
                int itemsPerRequest = 100;
                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Rows.Count)
                {
                    endOffset = data.Rows.Count;
                }
                if (endOffset == data.Rows.Count)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Text = data.Rows[i]["nazev"].ToString();
                    itemData.Value = data.Rows[i]["cislo"].ToString();
                    if (data.Rows[i]["vysl_kod"]!=DBNull.Value)
                    {
                        itemData.Attributes.Add("vysl_kod", data.Rows[i]["vysl_kod"].ToString());
                    }

                    result.Add(itemData);
                }

                if (data.Rows.Count > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
            }

            comboData.Items = result.ToArray();
            return comboData;

        }
        [WebMethod(EnableSession = true)]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public List<KSProgram.Bulletin.Adresat> GetAdresatsOfBulletins()
        {
            try
            {
                return KSProgram.Bulletin.Adresat.GetAllAdresats();
            }
            catch (Exception e)
            {
                return null;
            }
        }

        [WebMethod(EnableSession = true)]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public object GetCompatibility(string jsonData)
        {
            if (!string.IsNullOrEmpty(jsonData))
            {
                Globals.WebPlatform = Newtonsoft.Json.Linq.JObject.Parse(jsonData);
            }
            BrowserInfo browserInfo = new BrowserInfo();
            var ret = new
            {
                IsSupported = browserInfo.IsSupported(),
                Message = browserInfo.Message,
                ErrorMessage = browserInfo.GetErrorMessage(),
                ParNotSupBrowser = AppConfiguration.GetAppSetting<string>("NotSupBrowser", "1")
            };
            return ret;
        }
    }
}
