﻿using System;
using System.Collections;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Xml.Linq;
using KSProgram.Data;
using System.Text;
using System.IO;
using System.Globalization;
using System.Runtime.Serialization;
using System.Xml;
using KSProgram.Funkce;
using KSProgram;
//using System.Globalization;

/// <summary>
/// Summary description for CAClarityPPM
/// </summary>
[WebService(Namespace = "ksprtl/WebServices")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class CAClarityPPM : System.Web.Services.WebService
{

    public CAClarityPPM()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    #region Metody webové služby
    [WebMethod(EnableSession = true)]
    [SoapHeader("Authentication")]
    public string Test(string text)
    {
        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            return "Chyba - Neplatný zákazník!";
        }
        //string ret = text;

        //AuditLog log = new AuditLog();
        //ret = text;

        //if (text.ToLower() == "caclarityppm_logs")
        //{
        //    string rootDir = AppDomain.CurrentDomain.BaseDirectory;
        //    string logsDir = rootDir + @"Logs\";
        //    string logFile = logsDir + @"CAClarityPPM.log";

        //    ret = "Cesta k log souboru: " + logFile;
        //}

        //log.WriteToAuditFile(" | TEST | text: " + ret);

        string ret = string.Empty;
        if (!string.IsNullOrEmpty(Authentication.Username))
            ret += "UserName:"+Authentication.Username +"|";
        if (!string.IsNullOrEmpty(Authentication.Password))
            ret += "Password:" + Authentication.Password + "|";
        ret += text;
        return ret;
    }

    public Auth Authentication;

    //[SoapHeader("Authentication", Required = true)]
    //[SoapHeader("Authentication")] // MZ 22.8.2011 Autentizace potlačena na žádost p. Ježka. HelpDesk 14996.
    [WebMethod(EnableSession = true)]
    public string InsertProject(string cislo_proj, string nazev, string dat_od, string dat_do,
                                string dat_pripr, string dat_udrz, string faze, string odbor,
                                string finance, string refundace)
    {
        string ls_ret = "OK";
        Project iProject = new Project();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iProject.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iProject.WriteAudit(" | Start | InsertProject");

        // Autentizace
        //if (Authentication.Username == "test" && Authentication.Password == "test") {}
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iProject.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iProject.cislo_proj = cislo_proj;
        iProject.nazev = nazev;
        iProject.dat_od = dat_od;
        iProject.dat_do = dat_do;
        iProject.dat_pripr = dat_pripr;
        iProject.dat_udrz = dat_udrz;
        iProject.faze = faze;
        iProject.odbor = odbor;
        iProject.finance = finance.ToString();
        iProject.refundace = refundace;
        
        // Logování parametů
        iProject.WriteAudit(" | Params | " + iProject.GetParams());

        // INSERT
        if (string.IsNullOrEmpty(iProject.errAll))
        {
            ls_ret = iProject.InsertToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iProject.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iProject.errAll;
        }

        // Logování konce přenosu
        iProject.WriteAudit(" | End | InsertProject");

        return ls_ret;
    }
    //[SoapHeader("Authentication")]
    [WebMethod(EnableSession = true)]
    public string UpdateProject(string cislo_proj, string nazev, string dat_od, string dat_do,
                                string dat_pripr, string dat_udrz, string faze, string odbor,
                                string finance, string refundace)
    {
        string ls_ret = "OK";
        Project iProject = new Project();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iProject.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iProject.WriteAudit(" | Start | UpdateProject");

        // Autentizace
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iProject.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iProject.cislo_proj = cislo_proj;
        iProject.nazev = nazev;
        iProject.dat_od = dat_od;
        iProject.dat_do = dat_do;
        iProject.dat_pripr = dat_pripr;
        iProject.dat_udrz = dat_udrz;
        iProject.faze = faze;
        iProject.odbor = odbor;
        iProject.finance = finance.ToString();
        iProject.refundace = refundace;

        // Logování parametů
        iProject.WriteAudit(" | Params | " + iProject.GetParams());

        // UPDATE
        if (string.IsNullOrEmpty(iProject.errAll))
        {
            ls_ret = iProject.UpdateToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iProject.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iProject.errAll;
        }

        // Logování konce přenosu
        iProject.WriteAudit(" | End | UpdateProject");

        return ls_ret;
    }
    //[SoapHeader("Authentication")]
    [WebMethod(EnableSession = true)]
    public string InsertEmployeeToProject(string os_cislo, string cislo_pom, string cislo_proj,
                                          string prirazen_od, string prirazen_do)
    {
        string ls_ret = "OK";
        EmployeeInProject iEmployee = new EmployeeInProject();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iEmployee.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iEmployee.WriteAudit(" | Start | InsertEmployeeInProject");

        // Autentizace
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iEmployee.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iEmployee.os_cislo = os_cislo;
        iEmployee.cislo_pom = cislo_pom;
        iEmployee.cislo_proj = cislo_proj;
        iEmployee.prirazen_od = prirazen_od;
        iEmployee.prirazen_do = prirazen_do;

        // Logování parametů
        iEmployee.WriteAudit(" | Params | " + iEmployee.GetParams());

        // INSERT
        if (string.IsNullOrEmpty(iEmployee.errAll))
        {
            ls_ret = iEmployee.InsertToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iEmployee.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iEmployee.errAll;
        }

        // Logování konce přenosu
        iEmployee.WriteAudit(" | End | InsertEmployeeInProject");

        return ls_ret;
    }
    //[SoapHeader("Authentication")]
    [WebMethod(EnableSession = true)]
    public string UpdateEmployeeInProject(string os_cislo, string cislo_pom, string cislo_proj,
                                          string prirazen_od_old, string prirazen_od_new, string prirazen_do)
    {
        string ls_ret = "OK";
        EmployeeInProject iEmployee = new EmployeeInProject();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iEmployee.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iEmployee.WriteAudit(" | Start | UpdateEmployeeInProject");

        // Autentizace
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iEmployee.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iEmployee.os_cislo = os_cislo;
        iEmployee.cislo_pom = cislo_pom;
        iEmployee.cislo_proj = cislo_proj;
        iEmployee.prirazen_od_old = prirazen_od_old;
        iEmployee.prirazen_od_new = prirazen_od_new;
        iEmployee.prirazen_do = prirazen_do;

        // Logování parametů
        iEmployee.WriteAudit(" | Params | " + iEmployee.GetParams());

        // UPDATE
        if (string.IsNullOrEmpty(iEmployee.errAll))
        {
            ls_ret = iEmployee.UpdateToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iEmployee.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iEmployee.errAll;
        }

        // Logování konce přenosu
        iEmployee.WriteAudit(" | End | UpdateEmployeeInProject");

        return ls_ret;
    }
    //[SoapHeader("Authentication")]
    [WebMethod(EnableSession = true)]
    public string InsertWorkSheet(string os_cislo, string cislo_pom, string cislo_proj,
                                  string vykaz_obdobi, string odprac_hod)
    {
        string ls_ret = "OK";
        WorkSheet iWorkSheet = new WorkSheet();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iWorkSheet.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iWorkSheet.WriteAudit(" | Start | InsertWorkSheet");

        // Autentizace
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iWorkSheet.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iWorkSheet.os_cislo = os_cislo;
        iWorkSheet.cislo_pom = cislo_pom;
        iWorkSheet.cislo_proj = cislo_proj;
        iWorkSheet.vykaz_obdobi = vykaz_obdobi;
        iWorkSheet.odprac_hod = odprac_hod;

        // Logování parametů
        iWorkSheet.WriteAudit(" | Params | " + iWorkSheet.GetParams());

        // INSERT
        if (string.IsNullOrEmpty(iWorkSheet.errAll))
        {
            ls_ret = iWorkSheet.InsertToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iWorkSheet.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iWorkSheet.errAll;
        }

        // Logování konce přenosu
        iWorkSheet.WriteAudit(" | End | InsertWorkSheet");

        return ls_ret;
    }
    //[SoapHeader("Authentication")]
    [WebMethod(EnableSession = true)]
    public string UpdateWorkSheet(string os_cislo, string cislo_pom, string cislo_proj,
                                  string vykaz_obdobi, string odprac_hod)
    {
        string ls_ret = "OK";
        WorkSheet iWorkSheet = new WorkSheet();

        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            ls_ret = "Exception | Neplatný zákazník!";
            iWorkSheet.WriteAudit(" | " + ls_ret);
            return ls_ret;
        }

        // Logování začátku přenosu
        iWorkSheet.WriteAudit(" | Start | UpdateWorkSheet");

        // Autentizace
        //string aut = Authenticate(Authentication);
        //if (!string.IsNullOrEmpty(aut))
        //{
        //    iWorkSheet.WriteAudit(" | Exception | " + aut);
        //    return aut;
        //}  

        // Naplnění parametrů
        iWorkSheet.os_cislo = os_cislo;
        iWorkSheet.cislo_pom = cislo_pom;
        iWorkSheet.cislo_proj = cislo_proj;
        iWorkSheet.vykaz_obdobi = vykaz_obdobi;
        iWorkSheet.odprac_hod = odprac_hod;

        // Logování parametů
        iWorkSheet.WriteAudit(" | Params | " + iWorkSheet.GetParams());

        // UPDATE
        if (string.IsNullOrEmpty(iWorkSheet.errAll))
        {
            ls_ret = iWorkSheet.UpdateToDB();
            // Logování přenosu
            ls_ret = string.IsNullOrEmpty(ls_ret) ? "OK" : "Exception | " + ls_ret;
            iWorkSheet.WriteAudit(" | " + ls_ret);
        }
        else
        {
            ls_ret = "Exception | " + iWorkSheet.errAll;
        }

        // Logování konce přenosu
        iWorkSheet.WriteAudit(" | End | UpdateWorkSheet");

        return ls_ret;
    }
    

    #endregion

    private string Authenticate(Auth aAuth)
    {
        if (aAuth == null)
        {
            return "Nelze provést autentizaci z důvodu chybějících autentizačních údajů!";
        }

        if (aAuth.Username == "pis" && aAuth.Password == "ksprogram413")
        {
            return "";
        }
        else
        {
            return "Autentizace se nezdařila z důvodu uvedení chybného jména nebo hesla!";
        }
    }
}

public class Auth : SoapHeader
{
    public string Username;
    public string Password;
}

public class Project : Prenos
{
    #region Lokální proměnné
    string _cisloProj;
    string _nazev;
    string _datOd;
    string _datDo;
    string _datPripr;
    string _datUdrz;
    string _faze;
    string _odbor;
    string _finance;
    string _refundace;
    #endregion

    #region Vlastnosti
    public string cislo_proj
    {
        get
        {
            return _cisloProj;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "char(30)", false, out _err);
            _cisloProj = ls_value;
            WriteErr("cislo_proj", _err);
        }
    }
    public string nazev
    {
        get
        {
            return _nazev;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "char(50)", false, out _err);
            _nazev = ls_value;
            WriteErr("nazev", _err);
        }
    }
    public string dat_od
    {
        get
        {
            return _datOd;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "date", false, out _err);
            _datOd = ls_value;
            WriteErr("dat_od", _err);
        }
    }
    public string dat_do
    {
        get
        {
            return _datDo;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "date", true, out _err);
            _datDo = ls_value;
            WriteErr("dat_do", _err);
        }
    }
    public string dat_pripr
    {
        get
        {
            return _datPripr;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "date", true, out _err);
            _datPripr = ls_value;
            WriteErr("dat_pripr", _err);
        }
    }
    public string dat_udrz
    {
        get
        {
            return _datUdrz;
        }
        set
        {
            string ls_value = _iTestData.TestValue(value, "date", true, out _err);
            _datUdrz = ls_value;
            WriteErr("dat_udrz", _err);
        }
    }
    public string faze
    {
        get
        {
            return _faze;
        }
        set
        {
            _faze = _iTestData.TestValue(value, "char(1)", false, out _err);
            WriteErr("faze", _err);
            if (_faze != "'p'" && _faze != "'r'" && _faze != "'u'")
            {
                WriteErr("faze", "Hodnota neodpovídá číselníku: (p, r, u)");
            }
        }
    }
    public string odbor
    {
        get
        {
            return _odbor;
        }
        set
        {
            _odbor = _iTestData.TestValue(value, "char(10)", true, out _err);
            WriteErr("odbor", _err);
        }
    }
    public string finance
    {
        get
        {
            return _finance;
        }
        set
        {
            //_finance = Convert.ToDecimal(_iTestData.TestValue(value.ToString(), "dec(16,2)", true, out _err));
            _finance = _iTestData.TestValue(value, "dec(16,2)", true, out _err);
            WriteErr("finance", _err);
        }
    }
    public string refundace
    {
        get
        {
            return _refundace;
        }
        set
        {
            _refundace = _iTestData.TestValue(value, "char(1)", true, out _err);
            WriteErr("refundace", _err);
        }
    }
    #endregion

    #region Metody
    public string InsertToDB()
    {
        string sqlInsert =  "INSERT INTO cis_projekty (id, cislo, nazev, plati_od, plati_do," +
                                                    " priprava_od, priprava_do, faze, adm_stred," +
                                                    " finance, refundace)" +
                            " VALUES ({0}," + cislo_proj + "," + nazev + "," + dat_od + "," + dat_do + "," +
                                    dat_pripr + "," + dat_udrz + "," + faze + "," + odbor + "," +
                                    finance + "," + refundace + ")";
        try
        {
            //SqlPrikaz.ExecuteNonQuery(sqlInsert);
            SqlPrikaz.InsertWithSerial(sqlInsert, "cis_projekty", "id"); // MZ 24.6.2011 Ošetření serial sloupce
        }
        catch (Exception e)
        {
            return e.Message;
        }
        return "";
    }
    public string UpdateToDB()
    {
        string sqlUpdate = "UPDATE cis_projekty" +
                           " SET nazev = " + nazev + "," +
                           " plati_od = " + dat_od + "," +
                           " plati_do = " + dat_do + "," +
                           " priprava_od = " + dat_pripr + "," +
                           " priprava_do = " + dat_udrz + "," +
                           " faze = " + faze + "," +
                           " adm_stred = " + odbor + "," +
                           " finance = " + finance + "," +
                           " refundace = " + refundace + 
                           " WHERE cislo = " + cislo_proj;
        try
        {
            SqlPrikaz.ExecuteNonQuery(sqlUpdate);
        }
        catch (Exception e)
        {
            return e.Message;
        }
        return "";
    }
    #endregion
}
public class EmployeeInProject : Prenos
{
    #region Lokální proměnné
    string _osCislo;
    string _cisloPom;
    string _cisloProj;
    string _prirazenOd;
    string _prirazenOdOld;
    string _prirazenOdNew;
    string _prirazenDo;
    //string _odpracHod;
    #endregion

    #region Vlastnosti
    public string os_cislo
    {
        get
        {
            return _osCislo;
        }
        set
        {
            _osCislo = iTestData.TestValue(value, "dec(10,0)", false, out _err);
            WriteErr("os_cislo", _err);
        }
    }
    public string cislo_pom
    {
        get
        {
            return _cisloPom;
        }
        set
        {
            _cisloPom = iTestData.TestValue(value, "integer", false, out _err);
            WriteErr("cislo_pom", _err);
        }
    }
    public string cislo_proj
    {
        get
        {
            return _cisloProj;
        }
        set
        {
            _cisloProj = iTestData.TestValue(value, "char(30)", false, out _err);
            WriteErr("cislo_proj", _err);
        }
    }
    public string prirazen_od
    {
        get
        {
            return _prirazenOd;
        }
        set
        {
            _prirazenOd = iTestData.TestValue(value, "date", false, out _err);
            WriteErr("prirazen_od", _err);
        }
    }
    public string prirazen_od_old
    {
        get
        {
            return _prirazenOdOld;
        }
        set
        {
            _prirazenOdOld = iTestData.TestValue(value, "date", false, out _err);
            WriteErr("prirazen_od_old", _err);
        }
    }
    public string prirazen_od_new
    {
        get
        {
            return _prirazenOdNew;
        }
        set
        {
            _prirazenOdNew = iTestData.TestValue(value, "date", false, out _err);
            WriteErr("prirazen_od_new", _err);
        }
    }
    public string prirazen_do
    {
        get
        {
            return _prirazenDo;
        }
        set
        {
            _prirazenDo = iTestData.TestValue(value, "date", true, out _err);
            WriteErr("prirazen_do", _err);
        }
    }
    //public string odprac_hod
    //{
    //    get
    //    {
    //        return _odpracHod;
    //    }
    //    set
    //    {
    //        _odpracHod = iTestData.TestValue(value, "dec(3,2)", false, out _err);
    //        WriteErr("odprac_hod", _err);
    //    }
    //}
    #endregion

    #region Metody
    public string InsertToDB()
    {
        string sql = "SELECT id FROM cis_projekty WHERE cislo = " + cislo_proj;
        Int32? id =  SqlPrikaz.ExecuteScalarInt32(sql);
        if (id == null) return "Nepodařilo se nalézt vazební položku <id> pro <cislo_proj>!";

        string sqlInsert = "INSERT INTO prac_projekty (os_cislo, cislo_pom, id," +
                                                 " prirazen_od, prirazen_do, uvazek_proj)" +
                            " VALUES (" + os_cislo + "," + cislo_pom + "," + id + "," + 
                                        prirazen_od + "," + prirazen_do + ",0)";
        
        try
        {
            SqlPrikaz.ExecuteNonQuery(sqlInsert);
        }
        catch (Exception e)
        {
            return e.Message;
        }
        return "";
    }
    public string UpdateToDB()
    {
        string sql = "SELECT id FROM cis_projekty WHERE cislo = " + cislo_proj;
        Int32? id = SqlPrikaz.ExecuteScalarInt32(sql);
        if (id == null) return "Nepodařilo se nalézt vazební položku <id> pro <cislo_proj>!";

        // Test na existenci záznamu podle klíčových hodnot
        sql = "SELECT count(*) FROM prac_projekty" +
              " WHERE id = " + id +
              " AND os_cislo = " + os_cislo +
              " AND cislo_pom = " + cislo_pom +
              " AND prirazen_od = " + prirazen_od_old;
        if (SqlPrikaz.ExecuteScalarInt16(sql) == 0)
        {
            return "Podle klíčových hodnot se nepodařilo nalést měněný záznam!";
        }
        
        string sqlUpdate = "UPDATE prac_projekty" +
                           " SET prirazen_od = " + prirazen_od_new + "," +
                           " prirazen_do = " + prirazen_do +
                           " WHERE id = " + id +
                           " AND os_cislo = " + os_cislo +
                           " AND cislo_pom = " + cislo_pom +
                           " AND prirazen_od = " + prirazen_od_old;
        try
        {
            SqlPrikaz.ExecuteNonQuery(sqlUpdate);
        }
        catch (Exception e)
        {
            return e.Message;
        }
        return "";
    }
    #endregion
}
public class WorkSheet : Prenos
{
    #region Lokální proměnné
    string _osCislo;
    string _cisloPom;
    string _cisloProj;
    string _vykazObdobi;
    string _odpracHod;
    #endregion

    #region Vlastnosti
    public string os_cislo
    {
        get
        {
            return _osCislo;
        }
        set
        {
            _osCislo = iTestData.TestValue(value, "dec(10,0)", false, out _err);
            WriteErr("os_cislo", _err);
        }
    }
    public string cislo_pom
    {
        get
        {
            return _cisloPom;
        }
        set
        {
            _cisloPom = iTestData.TestValue(value, "integer", false, out _err);
            WriteErr("cislo_pom", _err);
        }
    }
    public string cislo_proj
    {
        get
        {
            return _cisloProj;
        }
        set
        {
            _cisloProj = iTestData.TestValue(value, "char(30)", false, out _err);
            WriteErr("cislo_proj", _err);
        }
    }
    public string vykaz_obdobi
    {
        get
        {
            return _vykazObdobi;
        }
        set
        {
            _vykazObdobi = iTestData.TestValue(value, "date", false, out _err);
            WriteErr("vykaz_obdobi", _err);
        }
    }
    public string odprac_hod
    {
        get
        {
            return _odpracHod;
        }
        set
        {
            _odpracHod = iTestData.TestValue(value, "dec(5,2)", false, out _err);
            WriteErr("odprac_hod", _err);
        }
    }

    #region Metody
    public string InsertToDB()
    {
        string sql = "SELECT id FROM cis_projekty WHERE cislo = " + cislo_proj;
        Int32? id = SqlPrikaz.ExecuteScalarInt32(sql);
        if (id == null) return "Nepodařilo se nalézt vazební položku <id> pro <cislo_proj>!";

        string sqlInsert = "INSERT INTO proj_vykaz (os_cislo, cislo_pom, id," +
                                                 " obdobi, odprac_hod)" +
                            " VALUES (" + os_cislo + "," + cislo_pom + "," + id + "," +
                                        vykaz_obdobi + "," + odprac_hod + ")";

        try
        {
            SqlPrikaz.ExecuteNonQuery(sqlInsert);
        }
        catch (Exception e)
        {
            return e.Message;
        }
        return "";
    }
    public string UpdateToDB()
    {
        string sql = "SELECT id FROM cis_projekty WHERE cislo = " + cislo_proj;
        Int32? id = SqlPrikaz.ExecuteScalarInt32(sql);
        if (id == null) return "Nepodařilo se nalézt vazební položku <id> pro <cislo_proj>!";

        string sqlUpdate = "UPDATE proj_vykaz" +
                           " SET odprac_hod = " + odprac_hod +
                           " WHERE id = " + id +
                           " AND os_cislo = " + os_cislo +
                           " AND cislo_pom = " + cislo_pom +
                           " AND obdobi = " + vykaz_obdobi;
        try
        {
            SqlPrikaz.ExecuteNonQuery(sqlUpdate);
        }
        catch (Exception e)
        {
            return " | Exception | " + e.Message;
        }
        return "";
    }
    #endregion

    #endregion
}
public class Prenos
{
    #region Lokální proměnné
    protected TestData _iTestData;
    protected string _err;
    string _errAll;
    #endregion

    #region Vlastnosti
    public string errAll
    {
        get
        {
            return _errAll;
        }
    }
    protected TestData iTestData
    {
        get
        {
            return _iTestData;
        }
        set
        {
            _iTestData = value;
        }
    }
    #endregion

    #region Konstruktor
    public Prenos()
    {
        iTestData = new TestData();
    }
    #endregion  

    #region Metody
    public string GetParams()
    {
        AuditLog iAuditLog = new AuditLog();
        return iAuditLog.AuditParams(this);
    }
    protected void WriteErr(string aParam, string aErr)
    {
        if (aErr.Length > 0)
        {
            string ls_err = "<" + aParam + "> " + aErr;
            AuditLog iAuditLog = new AuditLog();
            iAuditLog.WriteAudit(" | Exception | " + ls_err);
            if (!string.IsNullOrEmpty(_errAll)) _errAll += " | ";
            _errAll += ls_err;
        }
    }
    public void WriteAudit(string aMessage)
    {
        AuditLog iAuditLog = new AuditLog();
        iAuditLog.WriteAudit(aMessage);
    }
    #endregion

    
}
public class AuditLog
{
    public string AuditParams(Object aObj)
    {
        string log = "";

        // Vytvoření XML z datové struktury
        // --------------------------------
        //System.Runtime.Serialization.DataContractSerializer dcs = new System.Runtime.Serialization.DataContractSerializer(aObj.GetType());
        //StringBuilder sb = new StringBuilder();

        //using (System.Xml.XmlWriter writer = System.Xml.XmlWriter.Create(sb))
        //{
        //    dcs.WriteObject(writer, aObj);
        //}

        //MemoryStream memoryStream = new MemoryStream();
        System.Xml.Serialization.XmlSerializer xs = new System.Xml.Serialization.XmlSerializer(aObj.GetType());
        StringBuilder sb = new StringBuilder();
        //XmlTextWriter xmlTextWriter = new XmlTextWriter(memoryStream, Encoding.UTF8);
        //memoryStream = (MemoryStream)xmlTextWriter.BaseStream;
        //sXML = UTF8ByteArrayToString(memoryStream.ToArray());

        using (System.Xml.XmlWriter writer = System.Xml.XmlWriter.Create(sb))
        {
            xs.Serialize(writer, aObj);
        }

        string strXml = sb.ToString();

        // Převedení XML na řetězec auditu
        // -------------------------------
        //log = PrepareAuditRecord();

        XElement xml = XElement.Parse(strXml);
        foreach (XElement element in xml.Elements())
        {
            string elementName = element.Name.LocalName.ToString();
            log += elementName + ": ";
            string elementData = element.Value.ToString();
            log += elementData + " | ";
        }

        // Zápis do souboru        
        //ArchivZprac.ZapisAudit(log);
        return log;
    }

    private string UTF8ByteArrayToString(byte[] characters)
    {
            UTF8Encoding encoding = new UTF8Encoding();
            String constructedString = encoding.GetString(characters);
            return (constructedString);
    }
    private string PrepareAuditRecord()
    {
        string log = " | CA Clarity PPM";
        return log;
    }
    public void WriteAudit(string aMessage)
    {
        string ls_message = PrepareAuditRecord();
        WriteToAuditFile(ls_message + aMessage);
    }
    public void WriteToAuditFile(string aLog)
    {
        // Logovat?
        // --------
        string ls_logovani = AppConfiguration.GetAppSetting<string>("LogWebServices", string.Empty);
        if (ls_logovani.IndexOf("CAClarityPPM") < 0) return;

        // Kam budu zapisovat
        // ------------------
        string rootDir = AppDomain.CurrentDomain.BaseDirectory;
        string logsDir = rootDir + @"Logs\";
        string logFile = logsDir + @"CAClarityPPM.log";
        if (!Directory.Exists(logsDir))
        {
            Directory.CreateDirectory(logsDir);
        }

        string log = DateTime.Now.ToString() + aLog;
        TextWriter tw = new StreamWriter(logFile, true);
        try
        {
            tw.WriteLine(log);
        }
        catch (Exception ex)
        {
            throw ex;
        }
        finally
        {
            tw.Close();
        }
    }
}
public class TestData
{
    public string TestValue(string aValue, string aType, bool aNull, out string aErr)
    {
        int li_pom;
        long ll_pom;
        DateTime ld_pom;
        decimal ldc_pom;
        string ls_pom;
        string ls_type = "";
        string ls_ret = aValue;

        aErr = "";

        // Pokud hodnota nebude vyplněna (element se nepřenesl) vyplním prázdnou hodnotou
        if (string.IsNullOrEmpty(aValue)) aValue = "";

        // Nastavení NULL hodnoty
        if (aNull && string.IsNullOrEmpty(aValue))
        {
            return "null";
        }
        else if (!aNull && aValue.Length == 0)
        {
            aErr = "Povinný parametr není vyplněn!";
            return ls_ret;
        }
        // Nastavení datového typu
        if (aType.Substring(0, 4) == "char")
        {
            ls_type = "string";
        }
        else if (aType.Substring(0, 3) == "dec")
        {
            ls_type = "decimal";
        }
        else
        { ls_type = aType; }
        
        // Kontrola datových typů
        switch (ls_type)
        {
            case "string":
                string s = aType.Substring(5, (aType.Length - 6));
                li_pom = Convert.ToInt32(s); ;
                if (aValue.Length > li_pom)
                {
                    aErr = "Neplatná délka parametru typu 'char(" + li_pom.ToString() + ")'!";
                }
                else
                {
                    ls_ret = "'" + aValue + "'";
                }
                break;
            case "decimal":
                if (decimal.TryParse(aValue, out ldc_pom))
                    ls_ret = SqlPrikaz.DecimalToDbString(ldc_pom);
                else
                {
                    aErr = "Neplatná hodnota parametru typu 'decimal'";
                    break;
                }

                // zjištění velikosti a přesnosti
                ls_pom = aType.Substring(4, aType.Length - 5);
                int li_sep = ls_pom.IndexOf(",");
                long ll_length = Convert.ToInt64(ls_pom.Substring(0, li_sep));
                short li_precision = Convert.ToInt16(ls_pom.Substring(li_sep + 1));

                // porovnání s hodnotou
                string ls_value = ldc_pom.ToString();
                li_sep = ls_value.IndexOf(NumberFormatInfo.CurrentInfo.NumberDecimalSeparator);
                if (li_sep > -1)
                {
                    ls_pom = ls_value.Substring(0, li_sep);
                    if (ls_pom.Length > ll_length - li_precision)
                    {
                        aErr = "Neplatý rozsah parametru typu '" + aType + "'";
                    }

                    ls_pom = ls_value.Substring(li_sep + 1);
                    if (ls_pom.Length > li_precision)
                    {
                        aErr = "Neplatý rozsah parametru typu '" + aType + "'";
                    }
                }
                else
                {
                    if (ls_value.Length > ll_length - li_precision)
                    {
                        aErr = "Neplatý rozsah parametru typu '" + aType + "'";
                    }
                }

                break;
            case "long":
                if (!long.TryParse(aValue, out ll_pom))
                {
                    aErr = "Neplatná hodnota parametru typu 'long'";
                }
                break;
            case "integer":
                if (!Int32.TryParse(aValue, out li_pom))
                {
                    aErr = "Neplatná hodnota parametru typu 'integer'";
                }
                break;
            case "date":
                if (DateTime.TryParse(aValue, out ld_pom))
                    ls_ret = SqlPrikaz.DateTimeToString(ld_pom);
                else
                    aErr = "Neplatná hodnota parametru typu 'date'";
                break;
        }
       
        return ls_ret;
    }
}

