﻿using System;
using System.Collections;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Xml;
using System.IO;
using System.Collections.Generic;
using KSProgram;

/// <summary>
/// Summary description for Candidate
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class Candidate : System.Web.Services.WebService
{
    #region Struktury
    /// <summary>
    /// Osobní údaje uchazeče
    /// </summary>
    struct strOsUdaje
    {
        public string jmeno;
        public string prijmeni;
        public string dat_narozeni;
        public string telefon;
        public string email;
        public string insertString;
        //public string textErr;
        //public bool err;
    }
    #endregion

    public Candidate()
    {
        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }
    #region Webové metody
    [WebMethod]
    public string Test(string text)
    {
        return text;
    }

    [WebMethod(EnableSession = true)]
    public string ImportCandidate()
    {
        string ret = "";
        try
        {
            ret = ImportCandidateData();
        }
        catch (Exception ex)
        {
            LogToXMLFile("Error", ex.Message);
            return ex.Message;
        }

        return ret;
    }
    private string ImportCandidateData()
    {
        if (Zakaznik.GetCustomer() != "KU ZLIN")
        {
            string ls_ret = "Exception - Neplatný zákazník!";
            LogToXMLFile("Receive", ls_ret);
            return ls_ret;
        }

        string ret = "";
        string os_cislo = "";
        strOsUdaje strOsU;
        string pom;
        List<string> ins = new List<string>();

        // Odchycení requestu a uložení do proměnné
        byte[] data = Context.Request.BinaryRead(Context.Request.ContentLength);
        string xml = System.Text.Encoding.UTF8.GetString(data);
        //HttpContext.Current.Session["DatabazeName"] = "neco";
        //object obj = HttpContext.Current.Session["DatabazeName"];

        LogToXMLFile(); // Zápis do logu - Počáteční informace

        if (xml == null || xml == "")
        {
            LogToXMLFile("Receive", "EMPTY"); //Zápis do logu - Přenos dat
            return "Prázdný XML soubor";
        }
        else LogToXMLFile("Receive", "OK");

        //string xmlDoc =  F_XML.GetXmlString(@"d:\Dokumenty\Uchazec.xml");   // Převod XML na string
        //TextReader xmlReader = new StringReader(xmlDoc);  // string na TextReader
        TextReader xmlReader = new StringReader(xml);  // Pokus přenesení stringu
        //string xsdDoc = F_XML.GetXmlString(@"d:\Dokumenty\Uchazec_2009-05-22.xsd");
        string xsdPath = System.Web.HttpContext.Current.Server.MapPath("~/WebServices");
        xsdPath += "\\Uchazec_2009-05-22.xsd";
        string xsdDoc = F_XML.GetXmlString(xsdPath);
        TextReader xsdReader = new StringReader(xsdDoc);

        // Validace XML dokumentu
        ret = F_XML.ValidateXml(xmlReader, xsdReader);
        string val = "OK";
        if (ret != "" ) {val = ret;}
        LogToXMLFile("Validation", val); // Zápis do logu - Stav validace

        if (ret == "") // Pokud validace byla úspěšná
        {   
            // Nalezení nového evidenčního čísla
            os_cislo  = SqlPrikaz.ExecuteScalarString("SELECT max(os_cislo) FROM uchazeci", "0");
            os_cislo = ((System.Convert.ToDecimal(os_cislo) + 1).ToString());
            
            // Vytvoření insertů z XML
            ret = VytvorInserty(os_cislo, xml, out strOsU, out ins);
            if (ret != "") { return ret; }

            // Kontrola duplicity
            // ------------------
            string dupl_osCis = "";
            dupl_osCis = SqlPrikaz.ExecuteScalarString("SELECT os_cislo FROM uchazeci" +
                " WHERE jmeno = '" + strOsU.jmeno + "'" +
                " AND prijmeni = '" + strOsU.prijmeni + "'" +
                " AND rodne_cislo = " + strOsU.dat_narozeni +
                " AND duplicita IS NULL", "");
            
            if (dupl_osCis != "")
            {
                pom = "UPDATE uchazeci SET duplicita = " + dupl_osCis +
                    " WHERE os_cislo = " + os_cislo;
                ins.Add(pom);
            }
            
            // Archivace nového záznamu
            // ------------------------
            string insArch = "INSERT INTO u_archiv(os_cislo, uzivatel, tabulka, vyznam, datum, cas)" +
                " VALUES (" + os_cislo + ", 'web', 'uchazeci', 'Nový záznam - web', " +
                TDate.Today.ToDbString() + ", '" + DateTime.Now.ToLongTimeString() + "')";
            ins.Add(insArch);

            // Status uchazeče
            // ---------------
            string id_stav = SqlPrikaz.ExecuteScalarString("SELECT id_stav FROM vybriz_stav_uch" +
                " WHERE sys_kod = 111");

            string insStat = "UPDATE uchazeci SET id_stat = " + id_stav + " WHERE os_cislo = " +
                os_cislo;
            ins.Add(insStat);
             
            // =========================
            // Uložení údajů do databáze
            // =========================
            string logRet = "OK";
            try
            {
                for (int i = 0; i < ins.Count; i++)
                {
                    SqlPrikaz.ExecuteNonQuery(ins[i]);
                    ret = "Přenos proběhl úspěšně";
                }
            }
            //catch //(Exception ex)
            catch (Exception ex) // MZ 3.8.2009
            {
                SqlPrikaz.ExecuteNonQuery("DELETE FROM uchazeci WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_vzdelani WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_prubeh_zam_cis WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_jaz_znal WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_sko_sezn WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_bud_zar WHERE os_cislo = " + os_cislo);
                SqlPrikaz.ExecuteNonQuery("DELETE FROM u_telefony WHERE os_cislo = " + os_cislo);
                
                //ret = "Chyba při ukládání do databáze";
                //throw; // MZ 3.8.2009 - zakázal - vyhodila se vyjímka, ale ne návratová hodnota "ret"
                ret = ex.Message; // MZ 3.8.2009
                logRet = ret;

            }
            LogToXMLFile("Save", logRet);
        }

        LogToXMLFile("Response", ret); // MZ 17.6.2010 Přidáno

        //byte[] data2 = System.Text.Encoding.UTF8.GetBytes(ret);
        //string xml2 = System.Text.Encoding.UTF8.GetString(data2);
        //Context.Response.BinaryWrite(data2);

        return ret;
    }
    #endregion

    static string VytvorInserty(string os_cislo, string xml, out strOsUdaje aStrOsU, out List<string> inserty)
    {
        XmlTextReader reader = null; // Deklarace reference na instanci třídy XmlTextReader
        strOsUdaje strOsU;
        string ret = "";
        List<string> ins = new List<string>();

        strOsU.jmeno = "";
        strOsU.prijmeni = "";
        strOsU.dat_narozeni = "";
        strOsU.telefon = "";
        strOsU.email = "";
        strOsU.insertString = "";

        aStrOsU = strOsU;
        
        inserty = ins;
        try
        {
            TextReader xmlReader = new StringReader(xml);
            // Zkusíme vytvořit reader:
            reader = new XmlTextReader(xmlReader);
            //reader = new XmlTextReader(@"d:\Dokumenty\Uchazec.xml");
            // Nastavíme, aby reader ignoroval procházení uzlů s mezerami:
            reader.WhitespaceHandling = WhitespaceHandling.None;
            // A procházím xml dokument pomocí readeru:
            while (reader.Read())
            {
                // Hledám požadované elementy
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "osobniUdaje")
                {
                    // Prohledám vnitřní elementy a vytvořím řetězec insertu
                    strOsU = VytvorInsertOsUdaje(reader, os_cislo);
                    ins.Add(strOsU.insertString);
                    aStrOsU = strOsU;
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "skola")
                {
                    ins.Add(VytvorInsertVzdelani(reader, os_cislo));
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "praxe")
                {
                    ins.Add(VytvorInsertPrace(reader, os_cislo));
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "jazykZnal")
                {
                    ins.Add(VytvorInsertJazyk(reader, os_cislo));
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "ridicOpravneni")
                {
                    ins.Add(VytvorInsertRidicOprav(reader, os_cislo));
                }
                if (reader.NodeType == XmlNodeType.Element && reader.Name == "hledanaPrace")
                {
                    ins.Add(VytvorInsertHledanaPrace(reader, os_cislo));
                }
            }
        }
        catch (Exception ex)
        {
            ret = ex.Message;
            return ret;
        }
        finally
        {
            // Pokud je reader otevřen, zavřu ho:
            if (reader != null)
                reader.Close();
        }

        ins.Add(VytvorInsertKontakt(strOsU.telefon, "Telefon domů", os_cislo));
        if (strOsU.email != "NULL")
        {
            ins.Add(VytvorInsertKontakt(strOsU.email, "E-mail domů", os_cislo));
        }

        inserty = ins;
        return ret;
    }

    private static strOsUdaje VytvorInsertOsUdaje(XmlTextReader reader, string os_cislo)
    {
        strOsUdaje ret;
        string rodCis;
        string datNar;

        reader.ReadStartElement("osobniUdaje");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO uchazeci (os_cislo, jmeno, prijmeni, titul, titul_za, rodne_cislo, " +
                     "misto_narozeni, misto_trv, tr_ulice, tr_cislo, psc_trv, ulice_trv, st_prisl, stat_adr, " +
                     "zmen_prac_sch, evid_od, rodin_stav, narodnost, student, evid_do) " +
                     "VALUES (";
        ins += os_cislo + ", ";
        ret.jmeno = DejHodnotuElementu(reader, "jmeno");
        ins += PridejApostrofy(ret.jmeno) + ", ";
        ret.prijmeni = DejHodnotuElementu(reader, "prijmeni");
        ins += PridejApostrofy(ret.prijmeni) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "titulPred")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "titulZa")) + ", ";
        // Datum narození je potřeba převést na rodné číslo
        datNar = DejHodnotuElementu(reader, "datNarozeni");
        rodCis = datNar.Substring(2, 2) + datNar.Substring(5, 2) + datNar.Substring(8, 2) + "000";
        ret.dat_narozeni = rodCis;
        ins += PridejApostrofy(ret.dat_narozeni) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "mistoNarozeni")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "obec")) + ", ";
        string tr_ulice = DejHodnotuElementu(reader, "ulice");
        ins += PridejApostrofy(tr_ulice) + ", ";
        string tr_cislo = DejHodnotuElementu(reader, "cp");
        ins += PridejApostrofy(tr_cislo) + ", ";
        // PSČ
        string psc = DejHodnotuElementu(reader, "psc");
        if (psc.Length == 6)
        {
            // Pokusím se odstranit prázdnou mezeru
            psc = psc.Replace(" ", "");
            if (psc.Length == 6)
            {
                throw new Exception("Element psc je neplatný. Hodnota " + psc + " neodpovídá povolené délce (5-6 znaků).") ; 
            }
        }
        ins += PridejApostrofy(psc) + ", ";
        string ulice_trv = DejUliceTrv(tr_ulice, tr_cislo);
        ins += PridejApostrofy(ulice_trv) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "statPrisl")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "stat")) + ", ";
        ret.email = DejHodnotuElementu(reader, "email");
        ret.telefon = DejHodnotuElementu(reader, "telefon");
        ins += PridejApostrofy(DejHodnotuElementu(reader, "zps")) + ", ";
        ins += TDate.Today.ToDbString() + ", ";
        ins += "'0', '0', 'n', "; // Doplnění povinných položek
        DateTime evidDo = new DateTime(TDate.Today.AddMonths(12).Ticks); // 29.9.2009 - změna doby evidence z 6 na 12 měsíců. Viz. HelpDesk ID: 8694
        ins += SqlPrikaz.DateTimeToString(evidDo); // Datum "evid_do"
        ins += ")";

        ret.insertString = ins;
        return ret;
    }
    private static string VytvorInsertVzdelani(XmlTextReader reader, string os_cislo)
    {
        reader.ReadStartElement("skola");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO u_vzdelani (os_cislo, stupen, skola, obor, rok_zahaj, rok_ukonc) " +
                     "VALUES (";
        ins += os_cislo + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "stupen")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "nazev")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "obor")) + ", ";
        ins += DejHodnotuElementu(reader, "od") + ", ";
        ins += DejHodnotuElementu(reader, "do") + ")";

        return ins;
    }
    private static string VytvorInsertPrace(XmlTextReader reader, string os_cislo)
    {
        string rok, mes, den, datum;

        reader.ReadStartElement("praxe");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO u_prubeh_zam_cis " +
                     "(os_cislo, naz_org, pozice, datum_nastupu, datum_ukonc, obor, profese, popis) " +
                     "VALUES (";
        ins += os_cislo + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "zamestnavatel")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "pozice")) + ", ";
        //ins += PridejApostrofy(DejHodnotuElementu(reader, "od")) + ", ";
        
        datum = DejHodnotuElementu(reader, "od");
        if (datum != "NULL")
        {
            // Datum musím převést na databázový
            rok = datum.Substring(0, 4);
            mes = datum.Substring(5, 2);
            den = datum.Substring(8, 2);
            DateTime dateOd = new DateTime(int.Parse(rok), int.Parse(mes), int.Parse(den));
            datum = SqlPrikaz.DateTimeToString(dateOd);
        }
        ins += datum + ", ";

        //ins += PridejApostrofy(DejHodnotuElementu(reader, "do")) + ", ";
        datum = DejHodnotuElementu(reader, "do");
        if (datum != "NULL")
        {
            // Datum musím převést na databázový
            rok = datum.Substring(0, 4);
            mes = datum.Substring(5, 2);
            den = datum.Substring(8, 2);
            DateTime dateDo = new DateTime(int.Parse(rok), int.Parse(mes), int.Parse(den));
            datum = SqlPrikaz.DateTimeToString(dateDo);
        }
        ins += datum + ", ";

        ins += DejHodnotuElementu(reader, "skupOboru") + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "profese")) + ", "; // MZ 3.8.2009 - Změna datového typu. Long -> String
        ins += PridejApostrofy(DejHodnotuElementu(reader, "popis")) + ")";
        return ins;
    }
    private static string VytvorInsertJazyk(XmlTextReader reader, string os_cislo)
    {
        reader.ReadStartElement("jazykZnal");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO u_jaz_znal (os_cislo, jazyk, stupen) VALUES (";
        ins += os_cislo + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "jazyk")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "uroven")) + ")";

        return ins;
    }
    private static string VytvorInsertRidicOprav(XmlTextReader reader, string os_cislo)
    {
        reader.ReadStartElement("ridicOpravneni");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO u_sko_sezn (os_cislo, cis_osve) VALUES (";
        ins += os_cislo + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "skupina")) + ")";

        return ins;
    }
    private static string VytvorInsertHledanaPrace(XmlTextReader reader, string os_cislo)
    {
        reader.ReadStartElement("hledanaPrace");
        // Vytvořím nový řádek:
        string ins = "INSERT INTO u_bud_zar (os_cislo, obor, profese, plat, lok_prac) " +
                     "VALUES (";
        ins += os_cislo + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "obor")) + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "profese")) + ", ";
        ins += DejHodnotuElementu(reader, "minPlat") + ", ";
        ins += PridejApostrofy(DejHodnotuElementu(reader, "lokalitaPrac")) + ")";

        return ins;
    }
    private static string VytvorInsertKontakt(string co, string kam, string os_cislo)
    {
        string ins = "INSERT INTO u_telefony (os_cislo, tel_cislo, tel_kam) VALUES (";
        ins += os_cislo + ", '" + co + "', '" + kam + "')";

        return ins;
    }
    private static string DejHodnotuElementu(XmlTextReader reader, string element)
    {
        string ret = "NULL";
        if (reader.Name == element)
        {
            // Zpracuje se element
            reader.ReadStartElement(element);
            // Přidá se hodnota do insertu
            ret = reader.ReadString();
            reader.ReadEndElement();
        }
        return ret;
    }
    /// <summary>
    /// Funkce doplňující apostrofy.
    /// </summary>
    /// <param name="str"></param>
    /// <returns></returns>
    private static string PridejApostrofy(string str)
    {
        string s = str;
        if (str != "NULL") { s = "'" + str + "'"; }
        return s;
    }
    /// <summary>
    /// Zápis logu do XML souboru
    /// </summary>
    /// <param name="element"></param>
    /// <param name="message"></param>
    private static void LogToXMLFile(string element, string message)
    {
        // Logovat?
        // MZ 7.6.2011 Změna ve zjišťování zda logovat
        string ls_logovani = AppConfiguration.GetAppSetting<string>("LogWebServices", string.Empty);
        if (ls_logovani.IndexOf("Candidate") < 0) return;

        //string zpusob = System.Configuration.ConfigurationManager.AppSettings["LogWebServices"];
        //if (zpusob == null || zpusob == "") return;

        // Kam budu zapisovat
        string rootDir = AppDomain.CurrentDomain.BaseDirectory;
        string logsDir = rootDir + @"Logs\";
        string logFile = logsDir + @"ImportCandidate.xml";
        if (!Directory.Exists(logsDir))
        {
            //try
            //{
            //    Directory.CreateDirectory(logsDir);
            //}
            //catch (Exception ex)
            //{
            //    LogException.SmerujChybu(ex, false);
            //    return;
            //}
            Directory.CreateDirectory(logsDir);
        }
        if (!File.Exists(logFile))
        {
            StreamWriter strWriter = null;
            XmlTextWriter xmlWriter = null;
            try
            {
                strWriter = File.CreateText(logFile);
                xmlWriter = new XmlTextWriter(strWriter);
                xmlWriter.WriteStartDocument();
                xmlWriter.WriteStartElement("LogFile");
                xmlWriter.WriteEndDocument();
            }
            catch (Exception ex)
            {
                //LogException.SmerujChybu(ex, false);
                //return;
                throw ex;
            }
            finally
            {
                strWriter.Close();
                strWriter.Dispose();
                xmlWriter.Close();
            }
        }

        XmlDocument lDoc = new XmlDocument();
        lDoc.Load(logFile);
        XmlNode lRoot = lDoc.DocumentElement;

        if (element == "")
        {
            XmlNode exNode = lDoc.CreateElement("Message");
            XmlAttribute attrTime = lDoc.CreateAttribute("Time");
            attrTime.Value = DateTime.Now.ToString();
            exNode.Attributes.Append(attrTime);
            XmlAttribute attrPlatform = lDoc.CreateAttribute("DbPlatform");
            attrPlatform.Value = Globals.DbPlatformaString;
            exNode.Attributes.Append(attrPlatform);

            lRoot.AppendChild(exNode);
        }
        else
        {
            XmlNode xRoot = lDoc.LastChild; // xRoot = <LogFile>
            xRoot = xRoot.LastChild; // xRoot = <Message>

            XmlNode node = lDoc.CreateElement(element);
            node.AppendChild(lDoc.CreateTextNode(message));
            xRoot.AppendChild(node);
        }

        //Nechám jen posledních 100 záznamů
        while (lRoot.ChildNodes.Count > 100)
            lRoot.RemoveChild(lRoot.FirstChild);

        lDoc.Save(logFile);
    }
    private static void LogToXMLFile()
    {
        LogToXMLFile("", "");
    }
    private static string DejUliceTrv(string tr_ulice, string tr_cislo)
    {
        string ret = "NULL";
        if ((tr_ulice == "NULL") && (tr_cislo == "NULL"))
        {
        }
        else
        {
            if (tr_ulice != "NULL") {ret = tr_ulice;}
            if (ret == "NULL") {ret = tr_cislo;} else {ret += " " + tr_cislo;}
        }
        return ret;
    }
	
    private static string JeHodnotaCiselniku(string tabulka, string polozka, string hodnota)
    {
        // MZ - Metoda je připravena, není implementována
        string ret = "";
        string sql = "SELECT count(" + polozka + ") FROM " + tabulka + " WHERE " + polozka + " = " +
                     hodnota;

        string count = SqlPrikaz.ExecuteScalarString(sql);
        if (count == "0")
        {
            ret = "CHYBA - hodnota: " + hodnota + ", položky: " + polozka + ", tabulky: " + tabulka +
                  " nebyla nalezena";
        }

        return ret;
    }

}

