﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Activation;
using KSProgram.Obecne;
using KSProgram.Systemizace;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using Telerik.Web.UI;

namespace KSPortal.WebServices
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "OrgChartDataService" in code, svc and config file together.
    /// <summary>
    /// 
    /// </summary>
    [ServiceContract]
    public interface IOrgChartDataService
    {
        [OperationContract]
        Telerik.Web.UI.OrgChartGroupItemData[] LoadGroupItemData(Telerik.Web.UI.OrgChartNodeData node, IDictionary<string, object> context);

        [OperationContract]
        Telerik.Web.UI.OrgChartNodeData[] LoadNodeData(Telerik.Web.UI.OrgChartNodeData node, IDictionary<string, object> context);
    }

    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class OrgChartDataService : IOrgChartDataService
    {
        // To use HTTP GET, add [WebGet] attribute. (Default ResponseFormat is WebMessageFormat.Json)
        // To create an operation that returns XML,
        //     add [WebGet(ResponseFormat=WebMessageFormat.Xml)],
        //     and include the following line in the operation body:
        //         WebOperationContext.Current.OutgoingResponse.ContentType = "text/xml";



        /// <summary>
        /// Načte data o zaměstnancích
        /// </summary>
        /// <param name="node"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public Telerik.Web.UI.OrgChartGroupItemData[] LoadGroupItemData(Telerik.Web.UI.OrgChartNodeData node, IDictionary<string, object> context)
        {
            DateTime ld_datum = DateTime.Now.Date;

            List<Telerik.Web.UI.OrgChartGroupItemData> res = new List<Telerik.Web.UI.OrgChartGroupItemData>();
            if (!string.IsNullOrEmpty(node.Id))
            {
                int id_mista = Convert.ToInt32(node.Id);
                //int id_schema = Convert.ToInt32(SessionInfo.GetVariable(RadOrgChartLoad.id_schema_session_key));
                Str_schema_init str_sch = new Str_schema_init();
                if (SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key)!=null)
                     str_sch=(Str_schema_init)SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key);

                int id_schema=str_sch.Id_schema;
                KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet schema = RadOrgChartLoad.LoadNastaveni(id_schema);
                List<StrPracPom> pomery = Prac_pom.GetPomeryPodleMista(id_mista, ld_datum);                
                {
                    foreach (StrPracPom p in pomery)
                    {
                        //PH 18.4.2016 řeším případ kdy počáteční místo je vybáno uživatelem a na tomto místě je více lidí, 
                        //můžu zobrazit jen vybraného
                        //------------------------------------------------------------------
                        if ((str_sch.VychoziMistoVyberem)&&(id_mista==str_sch.VychoziMisto))
                            if (str_sch.VychoziOsCislo != p.OsCislo) continue;

                        Telerik.Web.UI.OrgChartGroupItemData d = new Telerik.Web.UI.OrgChartGroupItemData();
                        //d.ImageUrl = Pozadavek.UrlBase() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + p.OsCislo + "&maxHeight=48&maxWidth=48";
                        //PH 29.6.2020 HID:51506
                        d.ImageUrl = Pozadavek.UrlBaseInterni() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + p.OsCislo + "&maxHeight=48&maxWidth=48";

                        foreach (Str_schemata_radky r in schema.radky_vybrane.FindAll(pp => pp.typ == "z"))
                        {
                            if (r.typ == "z")
                            {
                                OrgChartRenderedFieldData fl = new OrgChartRenderedFieldData();
                                fl.Label = "";
                                string text = "";
                                if ((p.OsCislo == 0) && (r.polozka == "100000"))
                                    text = "neobsazeno";
                                else
                                    text = RadOrgChartLoad.GetTextRadku(p.OsCislo, p.CisloPom, ld_datum, r.polozka);
                                fl.Text = text;
                                if ((r.polozka != "100000") && (r.polozka != "100002")) //u jména nedávám label, jinak ano                        
                                    fl.Label = r.polozka_popis.Substring(0, 3) + ".";
                                if (!string.IsNullOrEmpty(fl.Text))
                                    d.RenderedFieldsData.Add(fl);
                            }
                        }
                        res.Add(d);
                    }
                }
            }
            return res.ToArray();
        }


        /// <summary>
        /// Načte data o pracovních místech
        /// </summary>
        /// <param name="node"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        public Telerik.Web.UI.OrgChartNodeData[] LoadNodeData(Telerik.Web.UI.OrgChartNodeData node, IDictionary<string, object> context)
        {
            var items = new List<Telerik.Web.UI.OrgChartNodeData>();
            //int id_schematu = Convert.ToInt32(SessionInfo.GetVariable(RadOrgChartLoad.id_schema_session_key));
            Str_schema_init str = new Str_schema_init();
            if (SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key)!=null)
                str = (Str_schema_init)SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key);
           
            items = RadOrgChartLoad.RenderNodeData(Convert.ToInt32(node.Id), str.Id_schema, DateTime.Now.Date, str.PmVse);
            return items.ToArray();
        }
    }   
}
