﻿using KSProgram.Email;
using KSProgram.Obecne;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;

namespace KSPortal.WebServices
{
    /// <summary>
    /// Summary description for TEmailForm
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    //[System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    [System.Web.Script.Services.ScriptService]
    public class TEmailForm : System.Web.Services.WebService
    {
        [System.Web.Services.WebMethod(EnableSession = true)]
        public string SendEmailMessage(string odesilatel, string prijemce, string predmet, string telo, string captcha)
        {
            KSProgram.WebControls.TEmailForm.TEmailFormSessionInfo tEmailFormSessInf;
            Object obj = SessionInfo.GetVariable("TEmailFormSessInf");
            if (obj != null)
                tEmailFormSessInf = (KSProgram.WebControls.TEmailForm.TEmailFormSessionInfo)obj;
            else //bez objektu nelze nic odeslat, nevi se kam.
                return ToJson(ReadGlobalResource.ZmenaTextu("[%E-mail nelze odeslat, nenalezeno nastavení SMTP serveru.%]"), true);// "{error: true,message: \"E-mail nelze odeslat, nenalezeno nastavení SMTP serveru.\"}";
            string erronMsg;
            if(!tEmailFormSessInf.SetFromWebService(odesilatel, prijemce, predmet, telo, captcha, out erronMsg))
            {//doslo k chybe
                return ToJson(erronMsg, true); // $"{{error: true, message: \"{erronMsg}\"}}";
            }
            else //odesle se e-maile
            {
                try
                {
                    //TMailMessage.SendMessage(string smtp, Int32 port, string user, string pass, bool ssl, string adr_from, string adr_to, string predmet, string telo, string kodovani, byte[][] prilohy, string[] nazvy_priloh, string cesta_certifikatu, string heslo_certifikatu, out string error);
                    TMailMessage.SendMessage(tEmailFormSessInf.SmtpSetting.SMTPAdresa, Int32.Parse(tEmailFormSessInf.SmtpSetting.SMTPPort), tEmailFormSessInf.SmtpSetting.SMTPUzivatel, tEmailFormSessInf.SmtpSetting.SMTPHeslo, tEmailFormSessInf.SmtpSetting.SMTPSSL, tEmailFormSessInf.Odesilatel, tEmailFormSessInf.Prijemce, tEmailFormSessInf.Predmet, tEmailFormSessInf.Telo, null, tEmailFormSessInf.SmtpSetting.Kodovani, new string[] { }, new string[] { }, null, null, (int)KSProgram.Pozadavky.VariantaMailu.Nespecifikovano, out erronMsg);
                    if ( !String.IsNullOrWhiteSpace(erronMsg))
                        return ToJson(erronMsg, true);
                }
                catch(Exception e)
                {
                    return ToJson(e.Message, true);
                }
            }

            return ToJson(ReadGlobalResource.ZmenaTextu("[%E-mail byl úspěšně odeslán%]"), false); //$"{{error: false, message: \"{ReadGlobalResource.ZmenaTextu("[%E-mail byl úspěšně odeslán%]")}\"}}";
            
        }

        /// <summary>
        /// Vygeneruje nový kód pro stránku
        /// </summary>
        /// <param name="codePage"></param>
        /// <returns></returns>
        [System.Web.Services.WebMethod(EnableSession = true)]
        public string GenerateNewCode(string codePage)
        {
            return TCaptcha.GenerateNewCodeForCodePage(codePage);
        }


        private string ToJson(string message, bool error)
        {
            Newtonsoft.Json.Linq.JObject o = Newtonsoft.Json.Linq.JObject.FromObject(new
                {
                    error = error,
                    message = message
                });

            return o.ToString();
        }
    }
}
