﻿using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.ZakSpec
{
    public partial class AnnualSestava :TPage
    {
       public AnnualSestava()
        {
            IdPrava = 388;
            VerzeStranky = "1";
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                TRadRok r = WebControlHelper.FindControl(this, "rok") as TRadRok;
                r.SelectedYear = DateTime.Now.Year;
            }
        }
        protected void TGridView1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRadRok r = WebControlHelper.FindControl(this, "rok") as TRadRok;
            int rok = r.SelectedYear;
            TGridView1.DataSource = this.GetData(rok);
        }

        protected void TGridView1_ItemCommand(object sender, GridCommandEventArgs e)
        {
           if (e.CommandName== "form_redirect")
            {
                string url = e.CommandArgument.ToString();
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", "showWindow('" +url+ "')", true);
            }
        }

        protected void rok_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {          
            TGridView1.Rebind();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rok"></param>
        /// <returns></returns>
        public DataTable GetData(int rok)
        {
            DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("stav", typeof(string));
            /*
            table.Columns.Add("dary", typeof(bool));
            table.Columns.Add("vedl_cinn", typeof(bool));
            table.Columns.Add("obch_spol", typeof(bool));
            table.Columns.Add("vztahy", typeof(bool));
            table.Columns.Add("politika", typeof(bool));
            table.Columns.Add("predvolani", typeof(bool));
            table.Columns.Add("alespon_jeden", typeof(bool));
            */

            table.Columns.Add("b_dary", typeof(string));
            table.Columns.Add("b_vedl_cin", typeof(string));
            table.Columns.Add("b_obch_spol", typeof(string));
            table.Columns.Add("b_vztahy", typeof(string));
            table.Columns.Add("b_politika", typeof(string));
            table.Columns.Add("b_predvolani", typeof(string));
            table.Columns.Add("b_alespon_jeden", typeof(string));

            table.Columns.Add("url", typeof(string));


            List<Str_workfl_stavy> lstr_stavy = workfl_stavy.NactiStavy(33);

            //nabafruju nastavené hodnoty z workfl_hodnoty
            //------------------------------------------------------
            ParametryPrikazu par = new ParametryPrikazu()
            { new KSParameter("rok", DbType.String, rok.ToString()) };

            string sql = "SELECT H.id_poz, V.klic " +
                             " FROM workfl_hl H, workfl_hodnoty V  " +
                             " where H.id_poz = V.id_poz " +                             
                             " and H.typ = 'annual'  " +
                             " and H.id_poz in(select id_poz from workfl_hodnoty HH where HH.klic = 'rok' and HH.hodnota = @rok) " +
                             " and V.klic in('Check_dary', 'Check_vedl_cin', 'Check_obch_spol', 'Check_vztahy', 'Check_politika', 'Check_predvolani')"+
                             " and V.hodnota='a'";

            DataTable wh=SqlPrikaz.ExecuteCommand(sql, ref par);
            //------------------------------------------------------
           


            sql = "SELECT H.os_cislo, H.id_poz, P.prijmeni, P.jmeno, H.url_odkaz,  PP.stav, PP.faze, PP.sys_stav " +
                             " FROM workfl_hl H, workfl_hodnoty V, pracovnici P,workfl_proc PP " +
                             " where H.os_cislo = P.os_cislo " +
                             " and H.id_poz = V.id_poz " +
                             " and H.id_poz=PP.id_poz " +
                             " and (PP.archiv is null or PP.archiv<>'a') " +
                             " and H.typ = 'annual' " +
                             " and V.klic = 'rok'" +
                             " and V.hodnota=@rok";
            
            using (IDataReader reader=SqlPrikaz.ExecuteReader(sql, par))
            {
                while (reader.Read())
                {
                    int id_poz = GetNullOrData.GetInt32(reader, 1, 0);

                    DataRow row = table.Rows.Add();
                    row["os_cislo"] = GetNullOrData.GetDecimal(reader, 0, 0);
                    row["prijmeni"]= GetNullOrData.GetString(reader, 2, "").Trim();
                    row["jmeno"] = GetNullOrData.GetString(reader, 3, "").Trim();
                    row["url"] = GetNullOrData.GetString(reader, 4, "").Trim();
                    string sys_stav= GetNullOrData.GetString(reader, 7, "").Trim();

                    string stav = GetNullOrData.GetString(reader, 5, "").Trim();
                    int faze = GetNullOrData.GetInt32(reader, 6, -1);
                    if (!string.IsNullOrEmpty(stav))
                    {
                        int index = lstr_stavy.FindIndex(aa => aa.faze == faze && aa.stav == stav);
                        if (index>-1) row["stav"] = lstr_stavy[index].popis;                     
                    }

                    if (sys_stav != "n")
                    {
                        List<string> lst = wh.AsEnumerable().Where(aa => aa.Field<int>("id_poz") == id_poz).Select(aa => aa.Field<string>("klic")).ToList<string>();
                        bool dary = false, vedl_cin = false, obch_spol = false, vztahy = false, politika = false, predvolani = false;
                        bool alespon_jeden = false;
                        foreach (string v in lst)
                        {
                            switch (v.SafeTrim())
                            {
                                case "Check_dary":
                                    dary = true;
                                    alespon_jeden = true;
                                    break;
                                case "Check_vedl_cin":
                                    vedl_cin = true;
                                    alespon_jeden = true;
                                    break;
                                case "Check_obch_spol":
                                    obch_spol = true;
                                    alespon_jeden = true;
                                    break;
                                case "Check_vztahy":
                                    vztahy = true;
                                    alespon_jeden = true;
                                    break;
                                case "Check_politika":
                                    politika = true;
                                    alespon_jeden = true;
                                    break;
                                case "Check_predvolani":
                                    predvolani = true;
                                    alespon_jeden = true;
                                    break;
                            }
                        }
                        /*
                        row["dary"] = dary;
                        row["vedl_cinn"] = vedl_cin;
                        row["obch_spol"]=obch_spol;
                        row["vztahy"]=vztahy;
                        row["politika"] = politika;
                        row["predvolani"]=predvolani;
                        row["alespon_jeden"] = alespon_jeden;
                        */


                        row["b_dary"] = _anoNe(dary);
                        row["b_vedl_cin"] = _anoNe(vedl_cin);
                        row["b_obch_spol"] = _anoNe(obch_spol);
                        row["b_vztahy"] = _anoNe(vztahy);
                        row["b_politika"] = _anoNe(politika);
                        row["b_predvolani"] = _anoNe(predvolani);
                        row["b_alespon_jeden"] = _anoNe(alespon_jeden);
                    }
                }
            }
            return table;
        }

        private string _anoNe(bool stav)
        {
            return (stav ? "ano" : "ne");
        }

        protected void TGridView1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType==GridItemType.Item || e.Item.ItemType==GridItemType.AlternatingItem)
            {               
                string url = (string)DataBinder.Eval(e.Item.DataItem, "url");
                GridDataItem dataItem = (GridDataItem)e.Item;
                TableCell cell = dataItem["btn_url"];
                RadButton button = WebControlHelper.FindControl(cell, "btn_img") as RadButton;
                if (button != null)
                    button.CommandArgument = url;              
            }
        }      
    }
}