﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram;
using KSProgram.WebControls;

namespace KSPortal.ZakSpec
{
    public partial class BonusyManazeri : TPage
    {
        public BonusyManazeri()
        {
            IdPrava = 229;
        }

        public string paramProcBonus
        {
            get
            {
                return ViewState["procBonusMng"].ToString();
            }
            set
            {
                ViewState["procBonusMng"] = value;
            }
        }

        public decimal Rozdil
        {
            get
            {
                return Convert.ToDecimal(Session["rozdilBonusMng"]);
            }
            set
            {
                Session["rozdilBonusMng"] = value;
            }
        }
        
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                // Procento bonusu
                // ---------------
                decimal procBonus = KSProgram.ZakSpec.BonusyManazeri.GetProcBonus();
                paramProcBonus = procBonus.ToString();

                // Nastavení grupování podle sloupce 'Nadřízený'
                // ---------------------------------------------
                GridGroupByExpression gex = new GridGroupByExpression();
                GridGroupByField fNadriz = new GridGroupByField();
                fNadriz.FieldName = "nadrizeny";
                fNadriz.HeaderText = WebControlHelper.ZmenaTextu("[%Nadřízený%]");
                gex.GroupByFields.Add(fNadriz);
                gex.SelectFields.Add(fNadriz);
                RadGrid1.MasterTableView.GroupByExpressions.Add(gex);
            }
        }

        protected void lbNacist_Command(object sender, CommandEventArgs e)
        {
            if (paramProcBonus == "0")
            {
                MessageBox.Alert(Page, "V aplikaci KS mzdy, není nastaveno procento bonusu v rozšiřujícím parametru [proc_bonus_mng] (skupina-11)!");
            }

            RadGrid1.Rebind();
        }

        protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable data = null;
            string sStred = "";

            if (IsPostBack)
            {
                sStred = StrSkupDiv.GetStred();
            }

            KSProgram.ZakSpec.BonusyManazeri BonusyMng = new KSProgram.ZakSpec.BonusyManazeri();
            data = BonusyMng.GetDataBonusy(sStred);

            if (data != null)
            {
                RadGrid1.DataSource = data;
            }
            //KSProgram.ZakSpec.BonusyManazeri mng = new KSProgram.ZakSpec.BonusyManazeri();
            //Dictionary<string, decimal> data = mng.GetDictMzdy();
        }

        protected void RNTB_Bonus_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            string prac_str = (string)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("prac_str");
            decimal zakl_mzda = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("zakl_mzda");
            object oBonusOld = (object)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("bonus");
            decimal bonusOld = oBonusOld == DBNull.Value ? 0 : (decimal)oBonusOld;

            // Hodnota bonusu
            // --------------
            RadNumericTextBox RNTB_Bonus = (RadNumericTextBox)sender;
            object oBonus = RNTB_Bonus.DbValue;

            // Uložení změny sloupce 'navyseni' do databáze
            // --------------------------------------------
            decimal? bonus = null;
            if (oBonus != null)
            {
                bonus = Convert.ToDecimal(oBonus);
                decimal bonusMax = Rozdil + bonusOld;
                if (bonus > bonusMax)
                {
                    RNTB_Bonus.Value = (double)bonusMax;
                    bonus = bonusMax;
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Pozor%]! [%Součet přidělených manažerských bonusů překročil stanovený limit%]."));
                }
            }
            KSProgram.ZakSpec.BonusyManazeri BonusMng = new KSProgram.ZakSpec.BonusyManazeri();
            BonusMng.Update(os_cislo, cislo_pom, prac_str, datum, bonus, zakl_mzda);

            RadGrid1.Rebind();
        }

        protected void RNTB_BonusProc_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            string prac_str = (string)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("prac_str");
            decimal zakl_mzda = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("zakl_mzda");
            object oBonusOld = (object)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("bonus");
            decimal bonusOld = oBonusOld == DBNull.Value ? 0 : (decimal)oBonusOld;

            // Procento bonusu
            // ---------------
            object oBonusProc = ((RadNumericTextBox)sender).DbValue;

            decimal? dcBonus = null;
            //object oBonus = ((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("bonus");
            
            decimal dcBonusMax = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("bonus_max");

            if (oBonusProc != null)
            {
                string sBonusProc = oBonusProc.ToString();
                if (!string.IsNullOrEmpty(sBonusProc))
                {
                    dcBonus = Convert.ToDecimal(sBonusProc) * dcBonusMax / 100;
                    dcBonus = Math.Round((decimal)dcBonus, MidpointRounding.AwayFromZero);

                    decimal navyseniMax = Rozdil + bonusOld;
                    if (dcBonus > navyseniMax)
                    {
                        //RNTB_Navyseni.Value = (double)navyseniMax;
                        dcBonus = navyseniMax;
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Pozor%]! [%Součet přidělených manažerských bonusů překročil stanovený limit%]."));
                    }
                }
            }

            KSProgram.ZakSpec.BonusyManazeri BonusMng = new KSProgram.ZakSpec.BonusyManazeri();
            BonusMng.Update(os_cislo, cislo_pom, prac_str, datum, dcBonus, zakl_mzda);

            RadGrid1.Rebind();

            //if (prekrocenaCastka)
            //{
            //    MessageBox.Alert(Page, "Pozor! Součet přidělených manažerských bonusů překročil stanovený limit.");
            //}
        }

        protected void RCB_VykonVedouci_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            string s = e.Text;

            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            object oVykonVedouci = e.Value;

            // Uložení změny sloupce 'vykon_vedouci' do databáze
            // -------------------------------------------------
            string sVykonVedouci = oVykonVedouci.ToString();
            KSProgram.ZakSpec.BonusyManazeri BonusMng = new KSProgram.ZakSpec.BonusyManazeri();
            BonusMng.UpdatePLE(os_cislo, cislo_pom, datum, sVykonVedouci);

            RadGrid1.Rebind();
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            KSProgram.Prava.RadkovePrava prava = Globals.RadkovePrava;

            TRadGrid rg = RadGrid1;
            DateTime aktDate = DateTime.Today; //new DateTime(Globals.AktObdobi.Year, 4, 26); 
            DateTime stopDate = KSProgram.ZakSpec.BonusyManazeri.GetStopDate();

            lbOznameni.Text = "[%Editace záznamů bude umožněna do%]" + ": " + stopDate.ToString("d.M.yyyy") + "!";
            //lbProcento.Text = "[%Procento bonusu%]" + ": " + paramProcBonus; // MZ 18.6.2015 Nechtějí zobrazovat procento pro manažery.

            // MZ 11.7.2016 Doplnění dynamického zobrazováni popisku o základní mzdě.
            GridHeaderItem headerItem = RadGrid1.MasterTableView.GetItems(GridItemType.Header)[0] as GridHeaderItem;
            headerItem["zakl_mzda"].Text = "[%Základní mzda%]" + " 04/" + (Globals.AktObdobi.Year - 1).ToString() + "-03/" + Globals.AktObdobi.Year.ToString();

            decimal ldc_SumBonus = 0;
            decimal ldc_SumBonusMax = 0;

            foreach (GridDataItem item in rg.Items)
            {
                // Načtení údajů z RadGrid
                // -----------------------
                RadNumericTextBox bonus = (RadNumericTextBox)WebControlHelper.FindControl(item, "RNTB_Bonus");
                RadNumericTextBox bonusProc = (RadNumericTextBox)WebControlHelper.FindControl(item, "RNTB_BonusProc");
                RadComboBox oRCB_VykonVedouci = (RadComboBox)WebControlHelper.FindControl(item, "RCB_VykonVedouci");
                decimal os_cislo = Convert.ToDecimal(item["os_cislo"].Text);
                short cislo_pom = Convert.ToInt16(item["cislo_pom"].Text);

                if (bonus == null || bonusProc == null) { continue; } // MZ 19.1.2016

                decimal ldc_BonusMax = Convert.ToDecimal(item["bonus_max"].Text);
                decimal ldc_Bonus = (bonus.DbValue == null) ? 0 : Convert.ToDecimal(bonus.DbValue);

                ldc_SumBonus += ldc_Bonus;
                ldc_SumBonusMax += ldc_BonusMax;

                //if (prava.OsCislo(os_cislo, true))
                if (prava.OsCislo(os_cislo, cislo_pom, true)) // MZ 8.6.2015 Doplněno právo na PPV, viz. HD28970.
                {
                    // Potlačení editace po 25. dnu
                    // ----------------------------
                    if (Globals.AktObdobi == new DateTime(stopDate.Year, stopDate.Month, 1) && aktDate <= stopDate)
                    {
                        bonus.CssClass = "povinne-pole";
                        bonus.ReadOnly = false;

                        bonusProc.CssClass = "povinne-pole";
                        bonusProc.ReadOnly = false;

                        oRCB_VykonVedouci.BackColor = System.Drawing.ColorTranslator.FromHtml("#ffffcc");
                        oRCB_VykonVedouci.Enabled = true;
                    }
                    else
                    {
                        bonus.BackColor = System.Drawing.Color.LightGray;
                        bonus.ReadOnly = true;

                        bonusProc.BackColor = System.Drawing.Color.LightGray;
                        bonusProc.ReadOnly = true;

                        oRCB_VykonVedouci.BackColor = System.Drawing.Color.LightGray;
                        oRCB_VykonVedouci.Enabled = false;
                    }
                }
                else // Editace nepřímých podřízených bude zakázána
                {
                    bonus.BackColor = System.Drawing.Color.White;
                    bonus.ReadOnly = true;

                    bonusProc.BackColor = System.Drawing.Color.White;
                    bonusProc.ReadOnly = true;

                    oRCB_VykonVedouci.BackColor = System.Drawing.Color.White;
                    oRCB_VykonVedouci.Enabled = false;    
                }
            }

            Rozdil = ldc_SumBonusMax - ldc_SumBonus;
        }

        protected void RadGrid1_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (e.Item is GridGroupFooterItem)
            {
                GridGroupFooterItem footer = e.Item as GridGroupFooterItem;
                GridItem[] groups = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
                foreach (GridGroupHeaderItem group in groups)
                {
                    if (group.GroupIndex == footer.GroupIndex)
                    {
                        decimal bonus_max = 0;
                        decimal bonus = 0;
                        decimal bonus_proc = 0;

                        foreach (GridItem item in group.GetChildItems())
                        {
                            if (item is GridDataItem)
                            {
                                bonus_max += Convert.ToDecimal(((GridDataItem)item)["bonus_max"].Text);
                                //RadNumericTextBox val = (RadNumericTextBox)WebControlHelper.FindControl(((GridDataItem)item)["bonus"], "RNTB_Bonus");
                                Label val = (Label)WebControlHelper.FindControl(((GridDataItem)item)["bonus"], "L_Bonus"); // MZ 19.1.2016
                                if (!string.IsNullOrEmpty(val.Text))
                                {
                                    bonus += Convert.ToDecimal(val.Text);
                                }
                            }
                        }

                        if (bonus_max > 0)
                        {
                            bonus_proc = ((bonus / bonus_max) * 100);
                        }

                        e.Result = bonus_proc;
                    }
                }
            }
            if (e.Item is GridFooterItem)
            {
                decimal bonus_max = 0;
                decimal bonus = 0;
                foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
                {
                    bonus_max += Convert.ToDecimal(item["bonus_max"].Text);
                    //RadNumericTextBox val = (RadNumericTextBox)WebControlHelper.FindControl(item["bonus"], "RNTB_Bonus");
                    Label val = (Label)WebControlHelper.FindControl(((GridDataItem)item)["bonus"], "L_Bonus"); // MZ 19.1.2016
                    if (!string.IsNullOrEmpty(val.Text))
                    {
                        bonus += Convert.ToDecimal(val.Text);
                    }
                }
                if (bonus_max > 0)
                {
                    e.Result = ((bonus / bonus_max) * 100);
                }
            }
        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                if (e.FormattedColumn.UniqueName == "bonus")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["bonus"];
                    e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString("#,##0") : "";
                }

                if (e.FormattedColumn.UniqueName == "bonus_proc")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["bonus_proc"];
                    e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString() : "";
                }

                if (e.FormattedColumn.UniqueName == "vykon_vedouci")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    e.Cell.Text = dataRow["vykon_vedouci"].ToString();
                }
            }
        }

        protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            RadGrid1.GroupingEnabled = false;
        }
    }
}