﻿using KSProgram.Data;
using KSProgram.Exceptions;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using KSProgram.PracovniMista;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram;

namespace KSPortal.ZakSpec
{
    public partial class CreateAnnual : TPage
    {
       
        public CreateAnnual()
        {
            IdPrava = 389;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                //rok.MinValue=(DateTime.Now.Year - 1);
                rok.SelectedDate = DateTime.Now.Date;
                datum.MinDate = DateTime.Now.Date;
                datum.SelectedDate = DateTime.Now.Date;
            }
        }

        protected void TGridView1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TGridView1.DataSource = this.GetData();
        }

        protected DataTable GetData()
        {
            System.Data.DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("cislo_pom", typeof(Int16));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("prac_misto", typeof(string));
            table.Columns.Add("kmen_str", typeof(string));
            table.Columns.Add("vedouci", typeof(bool));
            table.Columns.Add("datum", typeof(DateTime));
            table.Columns.Add("pocet", typeof(Int16));
            table.Columns.Add("stav", typeof(string));

            string pom= Parametry.ParametrCti("VlastnostProhlašeni");
            short cis_vl_prohlaseni;
            if ((!Int16.TryParse(pom, out cis_vl_prohlaseni) || (cis_vl_prohlaseni==0)))                
                throw new NoticeException("Prosím vyplňte portálový parametr 'VlastnostProhlašeni' číslem vlastnosti, určující zda má zaměstnanec vyplňovat 'Výroční prohlášení'");

            int r =  ((DateTime)rok.SelectedDate).Year;
            DateTime prvni = new DateTime(r, 1, 1);
            DateTime posledni = new DateTime(r, 12, 31);

            AnnualSestava sestava = new AnnualSestava();
            DataTable dt_sestava=sestava.GetData(r);

            string ls_sql = "select A.os_cislo, A.prijmeni, A.jmeno, A.kmen_str, B.id_pracmist, B.cislo_pom " +
                            " from pracovnici A, prac_pom B" +
                            " where A.os_cislo=B.os_cislo " +
                            " and A.datum_nastupu<=@posledni" +
                            " and (A.datum_vystupu>=@prvni or A.datum_vystupu IS NULL)" +
                             " and B.datum_nastupu<=@posledni" +
                            " and (B.datum_ukonc>=@prvni or B.datum_ukonc IS NULL) "+
                            " and B.id_pracmist is not null";
            ParametryPrikazu par = new ParametryPrikazu();
            par.Add(new KSParameter("posledni", DbType.Date, posledni));
            par.Add(new KSParameter("prvni", DbType.Date, prvni));
            using (IDataReader reader = SqlPrikaz.ExecuteReader(ls_sql, par))
            {
                while (reader.Read())
                {                   
                    decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                    int id_pracmista = GetNullOrData.GetInt32(reader, 4, 0);
                    if (id_pracmista == 0) continue;
                    KSProgram.PracovniMista.PracMistAtrib pma = new KSProgram.PracovniMista.PracMistAtrib(new List<int> { id_pracmista }, new List<short> { cis_vl_prohlaseni }, null, DateTime.Now);

                    if (pma.AtributyList.Count > 0)
                    {
                        string hodnota = pma.AtributyList[0].Hodnota;
                        if ((string.IsNullOrEmpty(hodnota)) || (hodnota.SafeSubstring(0, 1).ToLower() != "a")) continue;
                    }
                    else
                        continue;
                    DataRow row = table.Rows.Add();
                    row["os_cislo"] = ldc_os_cislo;
                    row["prijmeni"] = GetNullOrData.GetString(reader, 1, "").Trim();
                    row["jmeno"] = GetNullOrData.GetString(reader, 2, "").Trim();
                    row["kmen_str"] = GetNullOrData.GetString(reader, 3, "").Trim();
                    row["cislo_pom"] = GetNullOrData.GetInt16(reader, 5, -1);
                   
                    //zjišťuju poslední dotazník
                    //-----------------------------------------------------------
                   
                    string stav = string.Empty;
                    List<string> rr = dt_sestava.AsEnumerable().Where(aa => aa.Field<decimal>("os_cislo") == ldc_os_cislo).Select(aa=>aa.Field<string>("stav")).ToList<string>();
                    if (rr.Count > 0)
                    {
                        if (!string.IsNullOrEmpty(rr[0]))
                            row["stav"] = rr[0];
                    }                   
                }
                reader.Close();
            }

            /*
            TGridView1.MasterTableView.Caption = "Seznam zaměstnanců s posledním datem ověřování v roce " + r.ToString();
            TGridView1.DataSource = table;
            */
            return table;
        }

        protected void create_pozadavky()
        {          
            int r = ((DateTime)rok.SelectedDate).Year;
            DateTime obdobi = new DateTime(r, 1, 1);
            DataTable table = GetData();
            for(int i=0;i<table.Rows.Count;i++)
            {
                if (table.Rows[i]["stav"] == DBNull.Value)
                {
                    decimal ldc_os_cislo = Convert.ToDecimal(table.Rows[i]["os_cislo"]);
                    int id_poz = 0;
                    DateTime vyridit_do = (DateTime)datum.SelectedDate;
                    Pozadavekannual.Insert(ref id_poz, ldc_os_cislo, obdobi, vyridit_do, r, 0);
                }
            }
        }

        
        protected void vytvor_Command(object sender, CommandEventArgs e)
        {
            this.Page.Validate();
            if (!this.Page.IsValid)
                return;

            create_pozadavky();
            TGridView1.Rebind();
            return;
        }
        
        /*
        protected void rok_Click(object sender, EventArgs e)
        {
            TGridView1.Rebind();
        }
        */

        protected void TGridView1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if ((e.CommandName == "SelectAll") || (e.CommandName == "DeselectAll"))
            {
                for (int i = 0; i < TGridView1.Items.Count; i++)
                {
                    TGridView1.Items[i].Selected = (e.CommandName == "SelectAll");
                }
            }
        }

        /*
        protected void _aktualizujPocet()
        {
            Label_vyber.Text = String.Format("Počet vybraných zaměstnanců {0}", TGridView1.SelectedItems.Count);
        }

        protected void TGridView1_PreRender(object sender, EventArgs e)
        {
            _aktualizujPocet();
        }
        */

        protected void rok_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            TGridView1.Rebind();
        }
    }
}