﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
//using Telerik.Web.Design.Common;  //MiKo 01.03.2016 od verze knihovny 2016.1.225.4 není Common obsaženo
using Telerik.Web.UI;
using System.Data;
using KSProgram.Dochazka;

namespace KSPortal.ZakSpec
{
    /// <summary>
    /// Zákaznická specialita pro Škodu Praha Invest, export dat z docházky (TID=937)
    /// </summary>
    public partial class DochExport : TPage
    {
        /// <summary>
        /// Konstruktor
        /// </summary>
        public DochExport()
        {
            IdPrava = 202;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            //_sumaceStr = new StrZaznam();
            //_sumacePodnik = new StrZaznam();

            if (!Page.IsPostBack)
            {
                //DateTime AktObdobi = Globals.AktObdobi;

                //Obdobi.SetDefaultObdobi(ParametryDochazky.OBDOBI_PRO_SESTAVY); //PR 8.9.2014 AktObdobi->ParametryDochazky.OBDOBI_PRO_SESTAVY
                //Obdobi.SetMaxObdobi(AktObdobi); PR 8.9.2014
                TRObdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY; //KM 15.2.2016
            }
            else
            {
                NastavDataSource();
            }
        }

        protected void NastavDataSource()
        {
            TRadGrid1.MasterTableView.CommandItemSettings.ShowExportToExcelButton = false;
            TRadGrid1.MasterTableView.CommandItemSettings.ShowExportToCsvButton = false;
            if (rb_neprit.Checked)
            {
                ObjectDataSource1.SelectMethod = "SPIGetNepritomnosti";
                TRadGrid1.MasterTableView.Caption = "Nepřítomnosti";
                //TRadGrid1.ExportSettings.FileName = "Nepritomnosti-" + Obdobi.SelectedValue.ToString("yyyyMM");
                TRadGrid1.ExportSettings.FileName = "Nepritomnosti-" + ((DateTime)TRObdobi.SelectedDate).ToString("yyyyMM");//KM 15.2.2016
                TRadGrid1.MasterTableView.CommandItemSettings.ShowExportToCsvButton = true;
            }
            else if (rb_pripl.Checked)
            {
                ObjectDataSource1.SelectMethod = "SPIGetPriplatky";
                TRadGrid1.MasterTableView.Caption = "Příplatky";
                //TRadGrid1.ExportSettings.FileName = "Priplatky-" + Obdobi.SelectedValue.ToString("yyyyMM");
                TRadGrid1.ExportSettings.FileName = "Priplatky-" + ((DateTime)TRObdobi.SelectedDate).ToString("yyyyMM");//KM 15.2.2016
                TRadGrid1.MasterTableView.CommandItemSettings.ShowExportToCsvButton = true;
            }
            else if (rb_rozkont.Checked)
            {
                ObjectDataSource1.SelectMethod = "SPIGetRozkont";
                TRadGrid1.MasterTableView.Caption = "Rozkont";
                //TRadGrid1.ExportSettings.FileName = "Rozkont-" + Obdobi.SelectedValue.ToString("yyyyMM");
                TRadGrid1.ExportSettings.FileName = "Rozkont-" + ((DateTime)TRObdobi.SelectedDate).ToString("yyyyMM");//KM 15.2.2016
                TRadGrid1.MasterTableView.CommandItemSettings.ShowExportToExcelButton = true;
            }
            else
                return;

            TRadGrid1.DataSourceID = "ObjectDataSource1";
        }

        protected void TLinkButton1_Command(object sender, CommandEventArgs e)
        {
            NastavDataSource();
            
            TRadGrid1.Visible = true;
            TRadGrid1.DataBind();           

        }

        protected void TRadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            //PR 5.8.2014 odstranění 1.řádku s hlavičkami sloupců
            //PR 23.10.2014 u rozkontu chtějí hlavičky
            /*if (e.ExportType == ExportType.ExcelML)
            {
                string s = e.ExportOutput;
                int b, k;
                b = s.IndexOf("<Row>");
                k = s.IndexOf("</Row>");
                if (b > 0 && k > 0 && s.IndexOf("headerStyle")>0)
                {
                    s = s.Substring(0, b) + s.Substring(k + 6);
                    e.ExportOutput = s;
                }
            } */           
        }

        protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.ExportToCsvCommandName)
            {
                TRadGrid1.ShowHeader = false;
                TRadGrid1.Rebind();
            }
            //if (e.CommandName == RadGrid.ExportToExcelCommandName) NEFUNGUJE
            //{
            //    GridHeaderItem HeaderItem = (GridHeaderItem)TRadGrid1.MasterTableView.GetItems(GridItemType.Header)[0];
            //    HeaderItem.Visible = false;
            //}
        }

        
    }
}