﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Prenosy.ISoSS;
using System.IO;
using System.Data;
using KSProgram;
using KSProgram.Diagnostics;

namespace KSPortal.ZakSpec
{
    public partial class ISoSSExport : TPage
    {
        #region Privátní vlastnosti
        private byte[] ExtData
        {
            get
            {
                object lvs = ViewState["ISoSS_ExtData"];
                return (byte[])lvs;
            }
            set
            {
                ViewState["ISoSS_ExtData"] = value;
            }
        }
        private byte[] ResData
        {
            get
            {
                object lvs = ViewState["ISoSS_Vysledek"];
                return (byte[])lvs; 
            }
            set
            {
                ViewState["ISoSS_Vysledek"] = value;
            }
        }
        private byte[] xmlBin
        {
            get
            {
                object lvs = ViewState["ISoSS_XML"];
                return (byte[])lvs;
            }
            set
            {
                ViewState["ISoSS_XML"] = value;
            }
        }
        private List<ChangeData> _ChangeData
        {
            get
            {
                object lvs = ViewState["ISoSS_ChangeData"];
                return (List<ChangeData>)lvs;
            }
            set
            {
                ViewState["ISoSS_ChangeData"] = value;
            }
        }
        private List<ExportData> _ExportData
        {
            get
            {
                object lvs = ViewState["ISoSS_ExportData"];
                return (List<ExportData>)lvs;
            }
            set
            {
                ViewState["ISoSS_ExportData"] = value;
            }
        }
        private object _ExportXmlData
        {
            get
            {
                return ViewState["ISoSS_ExportXmlData"];
            }
            set
            {
                ViewState["ISoSS_ExportXmlData"] = value;
            }
        }
        private Int32 _IdExterni
        {
            get
            {
                return Convert.ToInt32(ViewState["ISoSS_IdExterni"]);
            }
            set
            {
                ViewState["ISoSS_IdExterni"] = value;
            }
        }
        #endregion

        #region Privátní proměnné
        private List<ErrRecord> _errInfo = null;
        private short _MinPriority = 0;
        #endregion

        private void _LoadData()
        {
            // Zobrazení odkazu na XML
            // -----------------------
            int idExp = ISoSS_Transfer.GetExportIdWithoutResponse();
            if (idExp > 0)
            {
                int idExterni;
                string textXml;
                int? idBlob;
                ISoSS_Data.GetDataISoSSPrenos(TransferType.Export, idExp, out idExterni, out textXml, out idBlob);

                if (idBlob != null)
                {
                    xmlBin = ISoSS_Data.GetXmlFromInfoBlob((int)idBlob);
                    L_TextDavka.Text = "Export dávky č. " + idExterni.ToString() + ":   ";
                    L_TextDavka.Visible = (xmlBin != null);
                    LBTN_XMLSoubor.Text = textXml;
                    LBTN_XMLSoubor.Visible = (xmlBin != null);
                    TRB_SmazatDavku.Visible = (xmlBin != null);
                    TRB_CreateXML.Visible = false;
                }
            }
            else
            {
                LBTN_XMLSoubor.Visible = false;
                L_TextDavka.Visible = false;
                TRB_SmazatDavku.Visible = false;
                xmlBin = null;
                TRB_CreateXML.Visible = true;
            }

            // Vytvoření dat k přenosu
            // -----------------------
            TRG_DataZamIns.Visible = false;
            TRG_DataZamUpdt.Visible = false;

            if (IsPostBack && idExp == 0)
            {
                ISoSS_Data iSoSS_Data = new ISoSS_Data(ExtData);
                _ExportData = iSoSS_Data.GetChangesForExport(_ChangeData);

                if (_ExportData == null)
                {
                    MessageBox.Alert(Page, "Vytvoření tabulky s údaji se nezdařilo! Nebyly načteny data zaměstnanců!", "Info");
                    return;
                }

                object obj = iSoSS_Data.GetEmployeesDataForExport(_ExportData);
                _ExportXmlData = obj;

                // Zobrazení dat
                // -------------
                if (obj is List<ZamestnanecZalozeniData>)
                {
                    TRG_DataZamIns.Rebind();
                    TRG_DataZamIns.Visible = true;
                }
                else if (obj is List<ZamestnanecZmenaData>)
                {
                    TRG_DataZamUpdt.Rebind();
                    TRG_DataZamUpdt.Visible = true;
                }

                // Zobrazení chyb
                // --------------
                _errInfo = iSoSS_Data.ErrList;
                TRG_Error.Rebind();
            }
        }

        public ISoSSExport()
        {
            IdPrava = 237;
            EnableVisibleSeznamZam = true;
            VisibleVyberSeznamuOsobnichCisel = true;
            //UpdateHlavniOblastOnOsCisloChanged = false;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                L_ExtFile.Visible = false;
                L_VyslSoubor.Visible = false;
                //RAU_ExtFile.HideFileInput = false;

                //_ChangeData = ISoSS_Data.GetChangesInDbArch();
                //ISoSS_Data iSoSS_Data = new ISoSS_Data(null);
                //_ExportData = iSoSS_Data.GetChangesForExport(_ChangeData);
                TRG_Prehled.Rebind();
            }
        }

        protected void TRB_Nacist_Click(object sender, EventArgs e)
        {
            // Smazání souboru
            //foreach(UploadedFile file in RAU_ExtFile.UploadedFiles)
            //{
            //    FileStream tmpFile = (FileStream) file.InputStream;
            //    List<string> files = Directory.GetFiles(HttpContext.Current.Server.MapPath("~/Temp")).Where(f => f.Equals(tmpFile.Name)).ToList();

            //    foreach (string f in files)
            //    {
            //        File.Delete(f);
            //    }
            //}

            ISoSS_Data iSoSS_Data = new ISoSS_Data(ExtData);
            _ExportData = iSoSS_Data.GetChangesForExport(_ChangeData);
            _ExportXmlData = iSoSS_Data.GetEmployeesDataForExport(_ExportData);

            if (_ExportData == null)
            {
                MessageBox.Alert(Page, "Vytvoření tabulky s údaji se nezdařilo! Nebyly načteny data zaměstnanců!", "Info");
                return;
            }

            TRG_DataZamIns.Rebind();
        }

        protected void TRB_CreateXML_Click(object sender, EventArgs e)
        {
            LBTN_XMLSoubor.Text = "";

            if (_ExportXmlData == null)
            {
                MessageBox.Alert(Page, "Vytvoření XML se nezdařilo! Nebyly načteny data zaměstnanců!", "Info");
                return;
            }
            
            // Nastavení parametrů hlavičky
            // ----------------------------
            ISoSS_XML.InfoDataType infoData = new ISoSS_XML.InfoDataType();
            infoData.DatumCas = DateTime.Now;
            //infoData.Id = "RSZ_I_" + infoData.DatumCas.ToString("yyMMddHHmmss") + ".XML";
            if (Globals.IsDevelopMode)
            {
                infoData.OsobaOdpovednaEmail = "milan.zamboch@ksprogram.cz";
                infoData.OsobaOdpovednaJmenoPrijmeni = "Milan Žamboch";
                infoData.ZpracovaniNotifikaceEmail = "milan.zamboch@ksprogram.cz";
            }
            else if (Zakaznik.IsCurrent("CSI"))
            {
                infoData.OsobaOdpovednaEmail = "Marie.Pickova@csicr.cz";
                infoData.OsobaOdpovednaJmenoPrijmeni = "Marie Picková";
                infoData.ZpracovaniNotifikaceEmail = "Marie.Pickova@csicr.cz";
            }
            else if (Zakaznik.IsCurrent("SFDI"))
            {
                string jmeno = string.Empty;
                string email = string.Empty;
                string telefon = string.Empty;

                ISoSS_Data.GetOsobaOdpovednaInfo(ref jmeno, ref email, ref telefon);

                infoData.OsobaOdpovednaEmail = email;
                infoData.OsobaOdpovednaJmenoPrijmeni = jmeno;
                infoData.OsobaOdpovednaTelefon = telefon;
                infoData.ZpracovaniNotifikaceEmail = email;
            }

            // Vytvoření dat pro XML
            // ---------------------
            ISoSS_XML isossXml = new ISoSS_XML();
            //KSTrace.WriteLine("XML export", "ISoSS", "Before create XML"); // Trace
            xmlBin = isossXml.GetXMLDataToByte(_ExportXmlData, infoData);
            //KSTrace.WriteLine("XML export", "ISoSS", "After create XML"); // Trace

            if (xmlBin != null && xmlBin.Length > 0)
            {
                LBTN_XMLSoubor.Text = isossXml.GetInfoDataId();
            }

            //KSTrace.WriteLine("XML export - validation", "ISoSS", isossXml.IsValid.ToString()); // Trace
            // Výpis validace XML
            // ------------------
            if (!isossXml.IsValid)
            {
                //MessageBox.Alert(Page, "Byla zjištěna chyba při validaci XML!", "Chyba při validaci XML!");

                //string pom = "Nejsou dostupné informace o chybě při validaci XML";
                //if (isossXml.Errors == null)
                //{
                //    KSTrace.WriteLine("XML export - IsError", "ISoSS", "null"); // Trace
                //    pom = " (isossXml.Errors = null)!";
                //}
                //else if (isossXml.Errors.Length <= 0)
                //{
                //    KSTrace.WriteLine("XML export - ErrorCount", "ISoSS", (isossXml.Errors.Length + 1).ToString()); // Trace
                //    pom += " (isossXml.Errors.Length = " + isossXml.Errors.Length.ToString() + ")!";
                //}
                //else
                //{
                //    string mess = "";
                //    pom = "";
                //    foreach (string err in isossXml.Errors)
                //    {
                //        //mess += "<li>" + err + "</li>";
                //        //mess += "<li type=\"square\">" + err + "</li>";
                //        pom += "</br> - " + err;
                //    }
                //    mess = "<ul>" + mess + "</ul>";
                //    mess = "<b>Vytvořený XML soubor není v pořádku! Byly nalezeny tyto chyby:</b></br>" + mess;
                //    //MessageBox.Alert(Page, mess, "Chyba při validaci XML!");
                //    KSTrace.WriteLine("XML export - Error", "ISoSS", pom); // Trace
                //    MessageBox.Alert(Page, pom, "Chyba při validaci XML!");

                //}

                //MessageBox.Alert(Page, pom, "Chyba při validaci XML!");

                if (isossXml.Errors == null)
                {
                    MessageBox.Alert(Page, "Nejsou dostupné informace o chybě při validaci XML (isossXml.Errors = null)!", "Chyba při validaci Xml!", 800, 500, null);
                }
                else if (isossXml.Errors.Length <= 0)
                {
                    MessageBox.Alert(Page, "Nejsou dostupné informace o chybě při validaci XML (isossXml.Errors.Length = 0)!", "Chyba při validaci Xml!", 800, 500, null);
                }

                if (isossXml.Errors != null && isossXml.Errors.Length > 0)
                {
                    string mess = "";
                    foreach (string err in isossXml.Errors)
                    {
                        //mess += "<li>" + err + "</li>";
                        mess += "<li type=\"square\">" + err + "</li>";
                    }
                    mess = "<ul>" + mess + "</ul>";
                    mess = "<b>Vytvořený XML soubor není v pořádku! Byly nalezeny tyto chyby:</b></br>" + mess;
                    MessageBox.Alert(Page, mess, "Chyba při validaci XML!", 800, 500, null);
                }
            }
            else
            {
                // Výpis oznámení.
                MessageBox.Alert(Page, "Vytvoření XML souboru proběhlo úspěšně!", "Info");

                // Uložení záznamu o exportu do databáze.
                ISoSS_Transfer.SaveExport(Modul.RSZ, isossXml, _ExportData, xmlBin);
                //TRG_Data.Rebind();
                _LoadData();
            }
        }

        protected void TRB_SmazatDavku_Click(object sender, EventArgs e)
        {
            int idExp = ISoSS_Transfer.GetExportIdWithoutResponse();
            ISoSS_Data.DeleteExport(idExp);
            //TRG_Data.Rebind();
            _LoadData();
        }

        protected void TRB_KontrolaVysledku_Click(object sender, EventArgs e)
        {
            if (ResData == null) return;
            ISoSS_Result isossResult = new ISoSS_Result(ResData);

            DavkaZamestnanecVysledek result = (DavkaZamestnanecVysledek)isossResult.GetResult();
            int? id = ISoSS_Transfer.GetId(result.DavkaIdExterni, TransferType.Export);
            if (id == null)
            {
                L_Vysledek.Visible = false;
                TRG_VysledekPrenosu.Visible = false;
                //MessageBox.Alert(Page, "Nebyla nalezena informace o vytvoření dávky s daty: " + result.ReferenceID + "<br/><b>Soubor s výsledky nebyl zpracován!</b>", "Info", 500, null, null);
                string text = "Nebyla nalezena informace o vytvoření dávky: " + result.DavkaIdExterni + ".<br/><b>Opravdu si přejete výsledek zpracovat?</b>";
                MessageBox.Confirm(this.Page, text, "Info", 500, null, "CheckResult");
            }
            else
            {
                TRG_VysledekPrenosu.Rebind();
            }
        }

        protected void TRB_KontrolaVysledkuAkce_Click(object sender, EventArgs e)
        {
            TRG_VysledekPrenosu.Rebind();
        }

        protected void TRG_DataZamIns_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (IsPostBack)
            {
                if (_ExportXmlData != null & _ExportXmlData is List<ZamestnanecZalozeniData>)
                {
                    TRG_DataZamIns.DataSource = _ExportXmlData;
                }
            }
        }

        protected void TRG_DataZamUpdt_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (IsPostBack)
            {
                if (_ExportXmlData != null & _ExportXmlData is List<ZamestnanecZmenaData>)
                {
                    TRG_DataZamUpdt.DataSource = _ExportXmlData;
                }
            }
        }

        protected void TRG_DataZamIns_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;

                if (TRG_DataZamIns.DataSource is List<ZamestnanecZalozeniData>)
                {
                    dataItem["NarozeniDatum"].Text = UpravDatumovyFormat(dataItem["NarozeniDatum"].Text);
                    dataItem["VznikDatum"].Text = UpravDatumovyFormat(dataItem["VznikDatum"].Text);
                    dataItem["TrvaniDoDatum"].Text = UpravDatumovyFormat(dataItem["TrvaniDoDatum"].Text);
                }
            }
        }

        protected void TRG_Error_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (IsPostBack && ExtData != null)
            {
                TRG_Error.DataSource = _errInfo;
                TRG_Error.Visible = !(_errInfo == null);
            }
            else
            {
                TRG_Error.Visible = false;
            }

            TRB_CreateXML.Enabled = !TRG_Error.Visible;
        }

        //private 

        protected void TRG_VysledekPrenosu_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            TRG_VysledekPrenosu.Visible = false;
            L_Vysledek.Visible = false;

            if (IsPostBack && ResData != null)
            {
                ISoSS_Result isossResult = new ISoSS_Result(ResData);
                object result = isossResult.GetResult();
                object dataSource = null;
                DavkaZamestnanecVysledek davka = (DavkaZamestnanecVysledek)result;
                if (davka == null) return;

                int? id = ISoSS_Transfer.GetId(davka.DavkaIdExterni, TransferType.Export);

                if (result is DavkaZamestnanecZalozeniVysledek)
                {
                    DavkaZamestnanecZalozeniVysledek data = (DavkaZamestnanecZalozeniVysledek)result;

                    // Uložení ID zaměstnance z ISoSS do DB
                    // ------------------------------------
                    string err = "";
                    int pocet = ISoSS_Data.SaveZamestnanecIdISoSS(data.ZamestnanecZalozeniVysledek, ref err);

                    if (pocet > 0)
                    {
                        MessageBox.Alert(Page, "Zaměstnancům bylo doplněno evidenční číslo ID z ISoSS.</br>Počet změněných záznamů: " + pocet.ToString(), "Změny v databázi", 500, null, null);
                    }

                    // Uložení záznamu o výsledku do databáze.
                    // ---------------------------------------
                    if (id != null)
                    {
                        id = ISoSS_Transfer.GetId(data.DavkaIdExterni, TransferType.Result);
                        if (id == null)
                        {
                            ISoSS_Transfer.SaveResult(Modul.RSZ, "I", data);
                        }
                    }
                    dataSource = data.ZamestnanecZalozeniVysledek;
                }
                else if (result is DavkaZamestnanecZmenaVysledek)
                {
                    DavkaZamestnanecZmenaVysledek data = (DavkaZamestnanecZmenaVysledek)result;

                    // Uložení záznamu o výsledku do databáze.
                    // ---------------------------------------
                    if (id != null)
                    {
                        id = ISoSS_Transfer.GetId(data.DavkaIdExterni, TransferType.Result);
                        if (id == null)
                        {
                            ISoSS_Transfer.SaveResult(Modul.RSZ, "U", data);
                        }
                    }
                    dataSource = data.ZamestnanecZmenaVysledek;
                }

                //Zobrazení tabulky s výsledky založení zaměstnanců
                // -------------------------------------------------
                TRG_VysledekPrenosu.DataSource = dataSource;
                //TRG_VysledekPrenosu.MasterTableView.Caption = "Výsledek přenosu dávky: " + davka.DavkaIdExterni + " (" + davka.ReferenceID  + ")";
                TRG_VysledekPrenosu.MasterTableView.Caption = "Výsledek přenosu dávky: " + davka.DavkaIdExterni + " (" + L_VyslSoubor.Text + ")";
                TRG_VysledekPrenosu.Visible = true;

                // Zobrazení informačního textu
                // ----------------------------
                string vysledek = "Zpracování dávky proběhlo bez chyby!";
                L_Vysledek.ForeColor = System.Drawing.Color.Green;
                if (davka.Hlaseni.TypMaximum.Value != "I")
                {
                    vysledek = "Zpracování dávky skončilo s chybou!";
                    L_Vysledek.ForeColor = System.Drawing.Color.Red;
                }
                L_Vysledek.Visible = true;
                L_Vysledek.Text = vysledek;
            }
            else
            {
                TRG_VysledekPrenosu.Visible = false;
                L_Vysledek.Visible = false;
                L_VyslSoubor.Text = "";
                L_VyslSoubor.Visible = false;
            }
        }

        /// <summary>
        /// TRG s přehledem změn.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TRG_Prehled_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (true) //if (IsPostBack)
            {
                _ChangeData = ISoSS_Data.GetChangesInDbArch();
                _MinPriority = ISoSS_Data.GetMinPriority(_ChangeData);
                TRG_Prehled.DataSource = ISoSS_Data.GetChanges(_ChangeData);

                System.Drawing.Color color = System.Drawing.Color.Black;
                L_StavPrenosu.Text = ISoSS_Transfer.GetInfoAboutStateOfTransfer(_ChangeData, ref color);
                L_StavPrenosu.ForeColor = color;

                // Nastavení seznamu akcí
                // ----------------------
                if (_ChangeData.Count > 0)
                {
                    ChangeData d = _ChangeData.FindAll(x => x.priorita == _MinPriority).First();
                    _IdExterni = d.e_IdDavky == null ? 0 : (Int32)d.e_IdDavky;
                    RDDL_VyberAkce.Items.Clear();
                    RDDL_VyberAkce.Items.Add(new DropDownListItem("Nový export pro vybrané záznamy", "1"));
                    RDDL_VyberAkce.Items.Add(new DropDownListItem("Vyloučit z exportu vybrané záznamy", "2"));
                    if (_IdExterni > 0)
                    {
                        RDDL_VyberAkce.Items.Add(new DropDownListItem("Zrušit výsledek dávky " + _IdExterni, "3"));
                        RDDL_VyberAkce.Items.Add(new DropDownListItem("Smazat dávku " + _IdExterni, "4"));
                    }
                }
                // ----------------------
            }
        }

        protected void TRG_Prehled_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;

                short priorita = Convert.ToInt16(dataItem["Priorita"].Text);

                // Popis priority
                // --------------
                string prioritaText = priorita.ToString();
                //prioritaText += " - " + ((Priority)priorita).ToString(); // MZ 8.6.2016 Doplněno zobrazení textového popisu.
                Priority priority = (Priority)priorita;
                switch (priority)
                {
                    case Priority.Error: prioritaText += " - Chyba"; break;
                    case Priority.NewDelete: prioritaText += " - Smazat"; break;
                    case Priority.NewInsert: prioritaText += " - Nový zaměstnanec"; break;
                    case Priority.NewUpdate: prioritaText += " - Změna zaměstnance"; break;
                    case Priority.NotResult: prioritaText += " - Nezpracován výsledek"; break;
                    case Priority.Reinclusion: prioritaText += " - Opětovné zařazení"; break;
                    case Priority.Cancel: prioritaText += " - Storno"; break;
                    case Priority.Transferred: prioritaText += " - Přeneseno"; break;
                }

                dataItem["Priorita"].Text = prioritaText;

                if (priorita == (short)Priority.Error)
                {
                    dataItem.ForeColor = System.Drawing.Color.Red;
                }
                else if (priorita == (short)Priority.NotResult)
                {
                    dataItem.ForeColor = System.Drawing.Color.Blue;
                }
                else if (priorita == _MinPriority 
                        && (priorita == (short)Priority.NewInsert || priorita == (short)Priority.NewUpdate || priorita == (short)Priority.NewDelete || priorita == (short)Priority.Reinclusion))
                {
                    dataItem.ForeColor = System.Drawing.Color.Green;
                }
            }
        }

        protected void TRG_VysledekPrenosu_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;

                string typ = dataItem["Typ"].Text;

                if (typ == "E")
                {
                    dataItem.ForeColor = System.Drawing.Color.Red;
                }
            }
        }

        protected void RAU_ExtFile_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            if (IsPostBack)
            {
                if (e.IsValid)
                {
                    L_ExtFile.Text = e.File.FileName;
                    L_ExtFile.Visible = true;
                    //RAU_ExtFile.HideFileInput = true;

                    UploadedFile file = e.File;
                    byte[] bytes = new byte[file.ContentLength];
                    file.InputStream.Read(bytes, 0, (int)file.ContentLength);

                    ExtData = bytes;
                }
            }
        }

        protected void RAU_VyslSoubor_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            if (IsPostBack)
            {
                if (e.IsValid)
                {
                    L_VyslSoubor.Text = e.File.FileName;
                    //L_VyslSoubor.Visible = true;

                    UploadedFile file = e.File;
                    byte[] bytes = new byte[file.ContentLength];
                    file.InputStream.Read(bytes, 0, (int)file.ContentLength);

                    ResData = bytes;
                }
            }
        }

        private string UpravDatumovyFormat(string aDate)
        {
            string date = "";

            if (!string.IsNullOrEmpty(aDate) && aDate != "&nbsp;")
            {
                date = Convert.ToDateTime(aDate).ToString("d.M.yyyy");
            }

            return date;
        }

        protected void LBTN_XMLSoubor_Click(object sender, EventArgs e)
        {
            // Uložení XML
            // -----------
            KSProgram.Attachment.Send(Page, LBTN_XMLSoubor.Text, xmlBin);
        }

        protected void RTS_Prenosy_TabClick(object sender, RadTabStripEventArgs e)
        {
            //string tab = e.Tab.
            //AddPageView(e.Tab.Text);
            //e.Tab.PageView.Selected = true;

            if (e.Tab.PageViewID == "RPV_RSZ_Prehled")
            {
                TRG_Prehled.Rebind();
            }
            else if (e.Tab.PageViewID == "RPV_RSZ_Export")
            {
                _LoadData();
            }
            else if (e.Tab.PageViewID == "RPV_RSZ_Potvrzeni")
            {
                ResData = null;
                TRG_VysledekPrenosu.Rebind();
            }
        }

        protected void RTB_OpatreniDruh_TextChanged(object sender, EventArgs e)
        {
            List<ZamestnanecZmenaData> data = (List<ZamestnanecZmenaData>)_ExportXmlData;

            int id = (int)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("Id");
            RadTextBox RTB_opDruh = (RadTextBox)sender;
            data[id].OpatreniDruh = RTB_opDruh.Text;
            
            string klic = ISoSS_Data.GetKey(data[id].OpatreniDruh, data[id].OpatreniDuvod, data[id].OpatreniUcinnostDatum);
            _ExportData[id].e_Klic = klic;
            
        }

        protected void RTB_OpatreniDuvod_TextChanged(object sender, EventArgs e)
        {
            List<ZamestnanecZmenaData> data = (List<ZamestnanecZmenaData>)_ExportXmlData;

            int id = (int)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("Id");
            RadTextBox RTB_opDuvod = (RadTextBox)sender;
            data[id].OpatreniDuvod = RTB_opDuvod.Text;

            string klic = ISoSS_Data.GetKey(data[id].OpatreniDruh, data[id].OpatreniDuvod, data[id].OpatreniUcinnostDatum);
            _ExportData[id].e_Klic = klic;
        }

        //protected void RTB_OpatreniUcinnostDatum_TextChanged(object sender, EventArgs e)
        //{
        //    List<ZamestnanecZmenaData> data = (List<ZamestnanecZmenaData>)_ExportXmlData;

        //    int id = (int)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("Id");
        //    KSProgram.WebControls.TRadDatePicker TRDP_opUcinnostDatum = (KSProgram.WebControls.TRadDatePicker)sender;
        //    DateTime opUcinnostDatum = (DateTime)TRDP_opUcinnostDatum.DbSelectedDate;
        //    data[id].OpatreniUcinnostDatum = opUcinnostDatum;

        //    string klic = ISoSS_Data.GetKey(data[id].OpatreniDruh, data[id].OpatreniDuvod, data[id].OpatreniUcinnostDatum);
        //    _ExportData[id].e_Klic = klic;
        //}

        protected void TRDP_OpatreniUcinnostDatum_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            List<ZamestnanecZmenaData> data = (List<ZamestnanecZmenaData>)_ExportXmlData;

            int id = (int)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("Id");
            KSProgram.WebControls.TRadDatePicker TRDP_opUcinnostDatum = (KSProgram.WebControls.TRadDatePicker)sender;
            DateTime opUcinnostDatum = (DateTime)TRDP_opUcinnostDatum.DbSelectedDate;
            data[id].OpatreniUcinnostDatum = opUcinnostDatum;

            string klic = ISoSS_Data.GetKey(data[id].OpatreniDruh, data[id].OpatreniDuvod, data[id].OpatreniUcinnostDatum);
            _ExportData[id].e_Klic = klic;
        }

        protected void TRB_VyberAkce_Click(object sender, EventArgs e)
        {
            string text = "Opravdu si přejete";
            string akce = RDDL_VyberAkce.SelectedValue;

            // Nový export pro vybrané záznamy
            if (akce == "1") { text += " zrušit informace o exportu u vybraných záznamů?";               
               // SetNewExport(idZmenySel)
            }
            // Vyloučit vybraný záznam z exportu
            //else if (akce == "2") { text += " smazat vybrané záznamy?";
            else if (akce == "2") { text += " vyloučit z exportu vybrané záznamy?";
                // DeleteSelectedRecord
            }
            // Zrušit výsledek dávky
            else if (akce == "3") { text += " zrušit výsledek dávky č. " + _IdExterni + "?";
                // CancelBatchResult
            }
            // Smazat dávku
            else if (akce == "4") { text += " smazat informace o provedení dávky č. " + _IdExterni + "?";
                // DeleteBatch()
            }

            MessageBox.Confirm(this.Page, text, "Info", 500, null, "PerformAction");
        }

        protected void TRB_VyberAkceProvedeni_Click(object sender, EventArgs e)
        {
            string idZmenySel = string.Empty;
            List<ChangeData> vyberList = new List<ChangeData>();

            foreach (GridDataItem item in TRG_Prehled.SelectedItems)
            {
                int idZmeny = KSProgram.Data.GetNullOrData.GetInt32(item["IdZmeny"].Text, 0);

                string prioritaText = item["priorita"].Text;
                string[] p = prioritaText.Split(new string[] { " - " }, StringSplitOptions.None);
                short priorita = p.Length > 0 ? KSProgram.Data.GetNullOrData.GetInt16(p[0], 0) : (short)0;

                ChangeData vyber = _ChangeData.First(x => x.a_Id == idZmeny && x.priorita == priorita);
                vyberList.Add(vyber);

                //if (idZmenySel.Count() > 0) { idZmenySel += ","; }
                //idZmenySel += idZmeny;
            }

            string akce = RDDL_VyberAkce.SelectedValue;

            // Nový export pro vybrané záznamy
            if (akce == "1")
            {
                //ISoSS_Data.DeleteExportInfo(idZmenySel);
                ISoSS_Data.DeleteExportInfo(vyberList);
            }
            // Vyloučit vybraný záznam z exportu
            else if (akce == "2")
            {
                //ISoSS_Data.ExcludeRecord(idZmenySel, "Zrušeno uživatelem");
                ISoSS_Data.ExcludeRecord(vyberList, "Zrušeno uživatelem");
            }
            // Zrušit výsledek dávky
            else if (akce == "3")
            {
                ISoSS_Data.CancelBatchResult(_IdExterni);
            }
            // Smazat dávku
            else if (akce == "4")
            {
                ISoSS_Data.DeleteBatch(_IdExterni);
            }

            TRG_Prehled.Rebind();
        }
    }
}