﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using KSProgram.Funkce;
using System.Data;
using KSProgram.ZakSpec;
using KSProgram.Pozadavky;
using KSProgram.Data;
using KSProgram.Ciselniky;
using KSProgram.WebControls;
using KSProgram.Obecne;
using KSProgram.WebControlsAlone;
using KSProgram.Extensions;
using System.Collections;
using KSProgram.PracovniMista;
using Telerik.Web.Design;
using System.Collections.Specialized;
using KSProgram.Prava;
using Telerik.Web.UI.ExportInfrastructure;

namespace KSPortal.ZakSpec
{
    public partial class ProjektyHodiny : TPage
    {
        //decimal suma_hodin;

        public ProjektyHodiny()
        {
            IdPrava = 210;
        }

        /// <summary>
        /// Koeficient člověkoměsíc
        /// </summary>
        public decimal Koeficient
        {
            get
            {
                decimal koef=0;
                string pom = Parametry.ParametrCti("ClovekoMesic");
                decimal.TryParse(pom, out koef);                    
                return koef;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public bool UseKoeficient
        {
            get
            {
                return cbx_cloveko_mesic.Checked;             
            }
        }

        public DateTime Obdobi
        {
            set
            {
                ViewState["Obdobi"] = value;
            }
            get
            {
                return (ViewState["Obdobi"] == null ? new DateTime() : Convert.ToDateTime(ViewState["Obdobi"]));
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            //ScriptManager.GetCurrent(Page).RegisterPostBackControl(button_export); 
            if (!IsPostBack)
            {
                //obdobi.SetDefaultObdobi(Globals.AktObdobi);
                obdobi.SelectedDate = Globals.AktObdobi;
                ds_projekty.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUserNeboZastupovany.ToString();
                check_schvalovani.Visible = false;
                ds_zamestnanci.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUserNeboZastupovany.ToString();                
            }
        }

        protected override void Page_PreRender(object sender, EventArgs e)
        {
            base.Page_PreRender(sender, e);

            RadioButtonList1_SelectedIndexChanged(RadioButtonList1, new EventArgs());
        }

        protected void obdobi_Click(object sender, EventArgs e)
        {
            string proj = combo_projekty.SelectedValue;
            string zam=combo_zamestnanci.SelectedValue;

            combo_projekty.DataBind();
            //RadComboBoxItem it=combo_projekty.FindItemByValue(proj);
            //PH 31,5,2016
            ListItem it = combo_projekty.Items.FindByValue(proj);
            if (it != null)
                combo_projekty.SelectedValue = it.Value;
            else
                combo_projekty.SelectedIndex = 0;

            combo_zamestnanci.DataBind();
            //combo_zamestnanci.SelectedIndex = 0;
            //it = combo_zamestnanci.FindItemByValue(zam);
            //PH 31.5.2016
            it = combo_zamestnanci.Items.FindByValue(zam);
            if (it != null)
                combo_zamestnanci.SelectedValue = it.Value;
            else
                combo_zamestnanci.SelectedIndex = 0;
            

            RadGrid1.Rebind();
        }

        protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            //PH 7.11.2014 načtu seznam lidí kteří mohou schvalovat tento projekt
            //-------------------------------------------------------------------
            List<string> list_pomery = ObjSetting.LoadBlobValues(Globals.OsCisloAktUserNeboZastupovany, "seznam_schval", "os_cis_pomer");
            //string pom = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();   
            //-------------------------------------------------------------------
            if (vcetne_dnu.Checked)
            {
                RadGrid1.MasterTableView.Columns.FindByUniqueName("id_datum").Visible = true;
                RadGrid1.MasterTableView.Columns.FindByUniqueName("id_poznamka").Visible = true;
            }
            else
            {
                RadGrid1.MasterTableView.Columns.FindByUniqueName("id_datum").Visible = false;
                RadGrid1.MasterTableView.Columns.FindByUniqueName("id_poznamka").Visible = false;
            }

            //string projekt = combo_projekty.SelectedValue;
            //string nazev_p = Vyr_zakazky.NazevProjektu(projekt);

            bool pristup_na_vse = PravaAkce.PristupPovolen(221); //PH 10.7.2017

            string projekt = "";
            string nazev_p = "";
            bool prava = false;
            if (RadioButtonList1.SelectedValue == "p")
            {
                projekt = combo_projekty.SelectedValue;
                nazev_p = Vyr_zakazky.NazevProjektu(projekt);

                //bool prava = (!Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUser));
                //PH 1.10.2014
                prava = (!Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUserNeboZastupovany));

                //pokud se mají práva aplikovat tak ještě zkontroluju jestli nemá roli pro všechny projekty všech zaměstnanců
                //-------------------------------------------
                if (prava)
                {
                    if (pristup_na_vse)
                        prava = false;
                }
                //-------------------------------------------

                if (string.IsNullOrEmpty(projekt)) return;
            }

            DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("cislo_pom", typeof(int));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("prac_str", typeof(string));
            table.Columns.Add("usek", typeof(string));
            table.Columns.Add("odbor", typeof(string));
            table.Columns.Add("oddeleni", typeof(string));
            table.Columns.Add("projekt", typeof(string));
            table.Columns.Add("nazev_p", typeof(string));
            table.Columns.Add("hodiny", typeof(decimal));
            table.Columns.Add("datum", typeof(DateTime));
            table.Columns.Add("poznamka", typeof(string));
            table.Columns.Add("stav", typeof(string));
            table.Columns.Add("stav_text", typeof(string));
            table.Columns.Add("proj_schvaleno", typeof(bool));
            table.Columns.Add("id_poz", typeof(int));
            table.Columns.Add("povol_schvalovani", typeof(bool));
            table.Columns.Add("pan_visible", typeof(bool));


            //DateTime ld_obdobi = obdobi.SelectedValue;
            DateTime ld_obdobi = (DateTime)obdobi.SelectedDate;
            Obdobi = ld_obdobi;
            DateTime ld_posl = ld_obdobi.PosledniDen();
            DataRow row = null;
            //List<Str_prac_pom> str_pp = Dch_Casy.GetOsCislaProStred(ld_obdobi, ld_posl, combo_projekty.SelectedValue);
            List<OSC_POMER> str_pp = new List<OSC_POMER>();
            decimal ldc_vybr_os_cislo = 0;
            if (RadioButtonList1.SelectedValue == "p")
                str_pp = Dch_Casy.GetOsCislaProStred(ld_obdobi, ld_posl, combo_projekty.SelectedValue);
            else
            {
                OSC_POMER it=new OSC_POMER();
                if (combo_zamestnanci.SelectedValue=="all")
                {
                    for(int i=0;i<combo_zamestnanci.Items.Count;i++)
                    {
                        it=new OSC_POMER();
                        string val=combo_zamestnanci.Items[i].Value;
                        it=_get_os_cislo_from_pole(combo_zamestnanci.Items[i].Value);
                        if (it.Os_cislo != 0)
                            str_pp.Add(it);
                    }
                }
                else
                {
                    it=_get_os_cislo_from_pole(combo_zamestnanci.SelectedValue);
                    if (it.Os_cislo != 0)
                    {
                        str_pp.Add(it);
                        ldc_vybr_os_cislo = it.Os_cislo;
                    }
                }
            }
            foreach (OSC_POMER str in str_pp)
            {
                //PH 1.9.2014 pokud přihlášený manažer není schvalovatel projektu tak se aplikují práva
                if (prava)
                {
                    //if (Globals.RadkovePrava.OsCislo(str.os_cislo) == false)
                    //PH 26.5.2015
                    if (Globals.RadkovePrava.OsCislo(str.Os_cislo,(short) str.Cislo_pom) == false)
                        continue;
                }
               
               // DataTable tb = Dch_Casy.GetProStred(str.os_cislo, str.cislo_pom, ld_obdobi, ld_posl, combo_projekty.SelectedValue);
                DataTable tb =null;
                //if (RadioButtonList1.SelectedValue == "p")
                if ((RadioButtonList1.SelectedValue == "p")&&(combo_projekty.SelectedValue!="all"))
                    tb = Dch_Casy.GetProStred(str.Os_cislo, (short)str.Cislo_pom, ld_obdobi, ld_posl, "'" + combo_projekty.SelectedValue + "'");
                else
                {
                    List<string> aar_proj = _getAllProjekty();
                    if (aar_proj.Count == 0) goto SKOKVlozit;
                    string pr = string.Join(",", aar_proj);
                    tb = Dch_Casy.GetProStred(str.Os_cislo, (short)str.Cislo_pom, ld_obdobi, ld_posl, pr);
                }
               
               

                bool found = false;
                for (int i = 0; i < tb.Rows.Count; i++)
                {
                    StrVlozit s=new StrVlozit();
                    s.os_cislo=str.Os_cislo;
                    s.cislo_pom=(short)str.Cislo_pom;
                    /*
                    if (RadioButtonList1.SelectedValue == "p")                  
                        s.projekt = projekt;
                    else                    
                        s.projekt = tb.Rows[i]["prac_str"].ToString();  
                        */
                    s.projekt = tb.Rows[i]["prac_str"].ToString();

                    s.hodiny=Convert.ToDouble(tb.Rows[i]["delka"]) / 60f;
                    s.datum=Convert.ToDateTime(tb.Rows[i]["datum"]);

                    row=_vlozit(tb.Rows[i], ref table, s, ref found);
                }                
            }
            _zprac_koeficient(ref table);
            _zprac_nazvy_proj_a_jmena(ref table, ld_obdobi, list_pomery);

            _doplnPoznamky(vcetne_dnu.Checked, ref table, ld_obdobi);

            SKOKVlozit:
            RadGrid1.DataSource = table;
            string nadpis = "";
            if (RadioButtonList1.SelectedValue == "p")
                    nadpis = (projekt!="all" ? projekt + " " + nazev_p + " ": "") + ld_obdobi.Month.ToString() + "/ " + ld_obdobi.Year.ToString();
            else
            {
                if (combo_zamestnanci.SelectedValue == "all")
                    nadpis = ld_obdobi.Month.ToString() + "/ " + ld_obdobi.Year.ToString();
                else
                {
                    string pr, jm;
                    nadpis = Pracovnik.PrijmeniJmeno(ldc_vybr_os_cislo, out pr, out jm) + " " + ld_obdobi.Month.ToString() + "/ " + ld_obdobi.Year.ToString();
                }
            }

            RadGrid1.MasterTableView.Caption = nadpis;           
        }

        private void _doplnPoznamky(bool nacitat, ref DataTable tb, DateTime ld_obdobi)
        {
            if (!nacitat) return;

            //nejdříve načtu všechny poznámky
            //---------------------------------         
            ParametryPrikazu par = new ParametryPrikazu
            {
                new KSParameter("cas_od",  F_DateTime.DateTimeToString17(ld_obdobi), 0, DbType.String),
                new KSParameter("cas_do", F_DateTime.DateTimeToString17(ld_obdobi.PosledniDenMinuta()), 0, DbType.String)
            };

            DataTable pozn = new DataTable();
            pozn.Columns.Add("os_cislo", typeof(decimal));
            pozn.Columns.Add("cislo_pom", typeof(short));
            pozn.Columns.Add("datum", typeof(DateTime));
            pozn.Columns.Add("projekt", typeof(string));
            pozn.Columns.Add("poznamka", typeof(string));

            using (IDataReader reader = SqlPrikaz.ExecuteReader("select os_cislo, cislo_pom, prac_str, cas, poznamka " +
                                                                " from dch_casy where poznamka is not null and " +
                                                                " cas between @cas_od and @cas_do", par))
            {
                while (reader.Read())
                {
                    DateTime ld_den = GetNullOrData.GetDateTimeFromString17(reader, 3, new DateTime());
                    if (ld_den != new DateTime())
                    {
                        string projekt= GetNullOrData.GetString(reader, 2, "").Trim();
                        string poznamka= GetNullOrData.GetString(reader, 4, "").Trim();

                        DataRow row = pozn.Rows.Add();
                        row["os_cislo"] = GetNullOrData.GetDbDecimal(reader, 0);
                        row["cislo_pom"] = GetNullOrData.GetDbInt16(reader, 1);
                        row["datum"] = ld_den.Date;
                        row["projekt"] = projekt;
                        row["poznamka"] = poznamka;
                    }
                }                
            }
            //---------------------------------

            for (int i = 0; i < tb.Rows.Count; i++)
            {
                decimal os_cislo = Convert.ToDecimal(tb.Rows[i]["os_cislo"]);
                short cislo_pom = Convert.ToInt16(tb.Rows[i]["cislo_pom"]);
                DateTime ld_den= Convert.ToDateTime(tb.Rows[i]["datum"]);
                string proj = Convert.ToString(tb.Rows[i]["projekt"]);

                string ls_pozn = string.Empty;
                DataRow[] rws= pozn.Select("os_cislo=" + os_cislo.ToString() + " and cislo_pom=" + cislo_pom.ToString() + " and projekt='" + proj + "' and datum=#" + ld_den.ToString("s") + "#");
                foreach(DataRow row in rws)
                {
                    if (row["poznamka"] != DBNull.Value)
                        ls_pozn += rws[0]["poznamka"].ToString() + ",";
                }
                if (!string.IsNullOrEmpty(ls_pozn))
                {
                    ls_pozn = ls_pozn.Substring(0, ls_pozn.Length - 1);
                    tb.Rows[i]["poznamka"] = ls_pozn;
                }
            }
        }

        private void _zprac_nazvy_proj_a_jmena(ref DataTable table, DateTime ld_obdobi, List<string> las_pomery)
        {
            List<Str_workfl_stavy> stavy = new List<Str_workfl_stavy>();
            stavy = workfl_stavy.NactiStavy(3);

            List<StrPrMistoExists> strPM = new List<StrPrMistoExists>();

            List<StrProjektyStavy> proj_buff = new List<StrProjektyStavy>();
            List<StrVlozit> jmeno_buff = new List<StrVlozit>();

            List<StrStavProj> lst_projekty_stavy = new List<StrStavProj>();

            Dictionary<string, string> buff = new Dictionary<string, string>();

            for (int i = 0; i < table.Rows.Count; i++)
            {
                string proj = Convert.ToString(table.Rows[i]["projekt"]);                
                if (table.Rows[i]["projekt"] != DBNull.Value)
                {
                    string proj_name="";
                    //string proj = Convert.ToString(table.Rows[i]["projekt"]);
                    int proj_index=proj_buff.FindIndex(x=> x.Projekt.Contains(proj));
                    if (proj_index>-1)
                        proj_name=proj_buff[proj_index].Nazev;
                    else
                    {
                        proj_name=Vyr_zakazky.NazevProjektu(proj);
                        StrProjektyStavy str=new StrProjektyStavy();
                        str.Projekt=proj;
                        str.Nazev=proj_name;
                        proj_buff.Add(str);
                    }

                    table.Rows[i]["nazev_p"] = proj_name;
                   
                }
                if ((table.Rows[i]["os_cislo"] != DBNull.Value)&&((table.Rows[i]["cislo_pom"] != DBNull.Value)))
                {
                    string jmeno="", prijmeni="";
                    decimal os_cislo = Convert.ToDecimal(table.Rows[i]["os_cislo"]);
                    short cislo_pom = Convert.ToInt16(table.Rows[i]["cislo_pom"]);

                    int id_mista = 0;
                    string cislo_mista = "";
                    string stred = "";
                    string usek = ""; 
                    string odbor = ""; 
                    string oddeleni = "";
                    string stav = "";
                    string proj_stav = "";
                    string stav_text="";
                    int id_poz = 0;
                    bool found = false;
                    bool proj_schvaleno = false;

                    //int os_cislo_index = jmeno_buff.FindIndex(x => x.os_cislo == os_cislo);
                    //PH 20.2.2018 HID:40023
                    int os_cislo_index = jmeno_buff.FindIndex(x => x.os_cislo == os_cislo && x.cislo_pom==cislo_pom);
                    if (os_cislo_index>-1)
                    {
                        jmeno = jmeno_buff[os_cislo_index].jmeno;
                        prijmeni = jmeno_buff[os_cislo_index].prijmeni;
                        stred = jmeno_buff[os_cislo_index].stred;
                        odbor=jmeno_buff[os_cislo_index].odbor;
                        usek=jmeno_buff[os_cislo_index].usek;
                        oddeleni=jmeno_buff[os_cislo_index].oddeleni;
                        stav = jmeno_buff[os_cislo_index].stav;
                        id_poz = jmeno_buff[os_cislo_index].id_poz;
                        stav_text = jmeno_buff[os_cislo_index].stav_text;
                        /*
                        found = jmeno_buff[os_cislo_index].found_workfl_zazn;
                        proj_schvaleno = jmeno_buff[os_cislo_index].proj_schvaleno;
                         * */
                    }
                    else
                    {
                        Pracovnik.PrijmeniJmeno(os_cislo, out prijmeni, out jmeno);
                        StrVlozit it = new StrVlozit();
                        it.os_cislo = os_cislo;
                        it.cislo_pom = cislo_pom;//PH 20.2.2018 HID:40023
                        it.jmeno = jmeno;
                        it.prijmeni = prijmeni;

                        id_mista = 0;
                        cislo_mista = "";
                        stred = "";
                        usek = ""; odbor = ""; oddeleni = "";                       

                        _get_pm_prac_str(ld_obdobi, os_cislo, cislo_pom, ref id_mista, ref cislo_mista, ref stred);
                        Get_usek_odbor_oddeleni(ref buff, ref strPM, id_mista, cislo_mista, DateTime.Now.Date, out usek, out odbor, out oddeleni);
                        it.odbor=odbor;
                        it.usek=usek;
                        it.oddeleni=oddeleni;
                        it.stred = stred;
                        stav = "";
                        id_poz = 0;
                        Pozadavek.Exists(os_cislo, cislo_pom, "dochazka", ld_obdobi, ref stav, ref id_poz);
                        it.stav = stav;
                        it.id_poz = id_poz;

                        Str_workfl_stavy x_stav=stavy.Where(st => st.stav == stav).FirstOrDefault();
                        stav_text = x_stav.popis;
                        it.stav_text = stav_text;
                        /* PH 16.2.2015 zapoznámkováno
                        found = _hledej_workfl_zazn(id_poz, proj, stav, ref proj_stav);
                        it.found_workfl_zazn = found;
                        it.proj_schvaleno = (proj_stav == "schvaleny");
                        proj_schvaleno = it.proj_schvaleno;
                        */
                        jmeno_buff.Add(it);
                    } 
                  
                    //PH 16.2.2015 nové lepší načítání položky o stavu projektu
                    //---------------------------------------------------------
                    int stav_index=lst_projekty_stavy.FindIndex(proj2 => (proj2.os_cislo == os_cislo) && (proj2.cislo_pom == cislo_pom) && (proj2.projekt == proj));
                    if (stav_index > -1)
                    {
                        proj_schvaleno = lst_projekty_stavy[stav_index].proj_schvaleno;
                    }
                    else
                    {
                        //hledám ve struktuře
                        int index_zam = jmeno_buff.FindIndex(zam => zam.os_cislo == os_cislo && zam.cislo_pom == cislo_pom);
                        if (index_zam > -1)
                        {
                            StrStavProj str_proj_stav = new StrStavProj();
                            found = _hledej_workfl_zazn(jmeno_buff[index_zam].id_poz, proj, jmeno_buff[index_zam].stav, ref proj_stav);

                            str_proj_stav.os_cislo = os_cislo;
                            str_proj_stav.cislo_pom = cislo_pom;
                            str_proj_stav.projekt = proj;
                            str_proj_stav.stav = proj_stav;
                            //str_proj_stav.found_workfl_zazn = found;
                            str_proj_stav.proj_schvaleno = (proj_stav == "schvaleny");

                            lst_projekty_stavy.Add(str_proj_stav);

                            proj_schvaleno = str_proj_stav.proj_schvaleno;
                        }
                        else
                        { }
                    }
                    //---------------------------------------------------------

                    table.Rows[i]["jmeno"] = jmeno;
                    table.Rows[i]["prijmeni"] = prijmeni;
                    table.Rows[i]["prac_str"] = stred;
                    table.Rows[i]["odbor"] = odbor;
                    table.Rows[i]["usek"] = usek;
                    table.Rows[i]["oddeleni"] = oddeleni;
                    table.Rows[i]["id_poz"] = id_poz;
                    table.Rows[i]["stav"] = stav;
                    table.Rows[i]["stav_text"] = stav_text;
                    table.Rows[i]["proj_schvaleno"] = proj_schvaleno;

                    /*
                    string stav = "";//PH 10.11.2014
                    int id_poz = 0;//PH 10.11.2014
                    if (vcetne_dnu.Checked == false)
                    {
                        //string stav = "";
                        //int id_poz = 0;
                        Pozadavek.Exists(os_cislo, cislo_pom, "dochazka", ld_obdobi, ref stav, ref id_poz);
                        table.Rows[i]["id_poz"] = id_poz;
                        table.Rows[i]["stav"] = stav;
                    }
                     * */

                    bool povol_schvalovani = false;
                    bool pan_visible=false;
                    if ((check_schvalovani.Checked)&&(!vcetne_dnu.Checked))
                    {
                       // povol_schvalovani = Vyr_zakazky.IsPmob(proj, Globals.OsCisloAktUserNeboZastupovany);
                        //PH 7.11.2014
                        povol_schvalovani=las_pomery.Contains(os_cislo.ToString() + "_" + cislo_pom.ToString());

                        //PH 10.11.2014
                        //------------------------------------------
                        //if ((key["stav"].ToString() == "schvaleny") || (key["stav"].ToString() == "potvrzeny"))
                        if ((stav == "schvaleny") || (stav == "potvrzeny"))
                        {
                            /*
                            Str_workfl_proc str = workfl_proc.NaplnStrukturuPodleIdPoz(id_poz);
                            bool found = _hledej_workfl_zazn(id_poz, str.id, proj, stav);  
                             * */
                            pan_visible=!found;
                            if (pan_visible) //PH 23.2.2018 HID:40042 musím ještě testovat zda je projektovým schvalovatelem
                            {
                                bool isSchvalovatel = Vyr_zakazky.IsPmob(proj, Globals.OsCisloAktUserNeboZastupovany);
                                if (!isSchvalovatel)
                                {
                                    povol_schvalovani = false;
                                    pan_visible = false;
                                }
                            }
                        }
                        else
                        {
                            pan_visible=false;
                        }
                        //------------------------------------------
                    }
                    table.Rows[i]["povol_schvalovani"] = povol_schvalovani;
                    table.Rows[i]["pan_visible"] = pan_visible; //PH 10.11.2014
                   
                }
            }
            proj_buff.Clear();
            jmeno_buff.Clear();
            lst_projekty_stavy.Clear();
        }

        private List<string> _getAllProjekty()
        {
            List<string> list = new List<string>();
            for (int i = 0; i < combo_projekty.Items.Count; i++)
            {
                if ((combo_projekty.Items[i].Value != "") &&(combo_projekty.Items[i].Value != "all"))
                {
                    list.Add("'"+combo_projekty.Items[i].Value+"'");
                }
            }
            return list;
        }

        private OSC_POMER _get_os_cislo_from_pole(string val)
        {
            OSC_POMER ret = new OSC_POMER();
            string[] arr = val.Split('|');
            if (arr.Length == 2)
            {
                ret.Os_cislo = Convert.ToDecimal(arr[0]);
                ret.Cislo_pom = Convert.ToInt16(arr[1]);                
            }
            return ret;
        }

        private void _zprac_koeficient(ref DataTable table)
        {
            if ((UseKoeficient) && (Koeficient != 0))
            {
                for (int i = 0; i < table.Rows.Count; i++)
                {
                    if (table.Rows[i]["hodiny"] != DBNull.Value)
                    {
                        decimal pom = Convert.ToDecimal(table.Rows[i]["hodiny"]);
                        pom = pom / Koeficient;
                        table.Rows[i]["hodiny"] = pom;
                    }
                }
            }
        }

        private DataRow _vlozit(DataRow arow, ref DataTable table, StrVlozit str, ref bool found)
        {
            DataRow row = null;
            found = true;
            if (vcetne_dnu.Checked)
            {
                row = table.Rows.Add();
                row["os_cislo"] = str.os_cislo;
                row["cislo_pom"] = str.cislo_pom;
                row["prijmeni"] = str.prijmeni;
                row["jmeno"] = str.jmeno;
                row["prac_str"] = str.stred;
                row["projekt"] = str.projekt;
                row["nazev_p"] = str.nazev_p;

                row["hodiny"] = 0;
                if (arow["delka"] != DBNull.Value)
                    row["hodiny"] = Convert.ToDouble(arow["delka"]) / 60f;
                row["datum"] = arow["datum"];

                if (str.usek != "0")
                    row["usek"] = str.usek;
                if (str.odbor != "0")
                    row["odbor"] = str.odbor;
                if (str.oddeleni != "0")
                    row["oddeleni"] = str.oddeleni;
            }
            else
            {
               // DataRow[] rws = table.Select("os_cislo=" + str.os_cislo.ToString() + " and cislo_pom=" + str.cislo_pom.ToString());
                //PH 21.10.2014
                string podminka="";
                /*
                if (RadioButtonList1.SelectedValue == "p")
                    podminka = "os_cislo=" + str.os_cislo.ToString() + " and cislo_pom=" + str.cislo_pom.ToString();
                else
                */
                    podminka = "os_cislo=" + str.os_cislo.ToString() + " and cislo_pom=" + str.cislo_pom.ToString() + " and projekt='" + str.projekt+"'" ;
                DataRow[] rws = table.Select(podminka);
                if (rws.Length == 0)
                {
                    row = table.Rows.Add();
                    row["os_cislo"] = str.os_cislo;
                    row["cislo_pom"] = str.cislo_pom;
                    row["prijmeni"] = str.prijmeni;
                    row["jmeno"] = str.jmeno;
                    row["prac_str"] = str.stred;
                    row["projekt"] = str.projekt;
                    row["nazev_p"] = str.nazev_p;

                    row["hodiny"] = 0;
                    if (arow["delka"] != DBNull.Value)
                        row["hodiny"] = Convert.ToDouble(arow["delka"]) / 60f;
                    if (str.usek != "0")
                        row["usek"] = str.usek;
                    if (str.odbor != "0")
                        row["odbor"] = str.odbor;
                    if (str.oddeleni != "0")
                        row["oddeleni"] = str.oddeleni;
                }
                else
                {
                    row = rws[0];
                    decimal hod = Convert.ToDecimal(rws[0]["hodiny"]);
                    rws[0]["hodiny"] = hod + Convert.ToDecimal(Convert.ToDouble(arow["delka"]) / 60f);
                }
            }
            return row;
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            //RadGrid1.MasterTableView.Columns.FindByUniqueName("id_editace").Visible = true;

            //bool group_exists = false;
            foreach (GridGroupHeaderItem item in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
            {
                /*
                group_exists = true;

                GridItem[] it = item.GetChildItems();
                for (int i = 1; i < it.Length; i++)
                {
                    WebControl c = (WebControl)it[i].FindControl("pan_zmena");
                    if (c != null)
                        c.Visible = false;
                }
                */
                //RadGrid1.MasterTableView.Columns.FindByUniqueName("id_editace").Visible = false;                
            }
            /*
            if (group_exists == false)
            {
                RadGrid1.MasterTableView.Columns.FindByUniqueName("id_editace").Visible = false;
            }
            */
            if ((vcetne_dnu.Checked)||(!check_schvalovani.Checked))
            {
                RadGrid1.MasterTableView.GetColumn("ExpandColumn").Display = false;
                RadGrid1.RetainExpandStateOnRebind = false;
                RadGrid1.MasterTableView.HierarchyDefaultExpanded = false;
            }
            else
            {
                RadGrid1.MasterTableView.GetColumn("ExpandColumn").Display = true;
                RadGrid1.RetainExpandStateOnRebind = true;
                RadGrid1.MasterTableView.HierarchyDefaultExpanded = true;
            }


            for(int i=0;i<RadGrid1.Items.Count; i++)
            {
                GridDataItem item = RadGrid1.Items[i];               
                if ((vcetne_dnu.Checked)||(!check_schvalovani.Checked))
                {
                    GridNestedViewItem nesteditem = (GridNestedViewItem)RadGrid1.MasterTableView.GetItems(GridItemType.NestedView)[i];
                    nesteditem.Visible = false;
                    nesteditem.Enabled = false;
                    nesteditem.Display = false;
                }
                 
                //GridNestedViewItem nesteditem = (GridNestedViewItem)RadGrid1.MasterTableView.GetItems(GridItemType.NestedView)[i];
                //nesteditem.Visible = (!vcetne_dnu.Checked);
                //nesteditem.Enabled = (!vcetne_dnu.Checked);
                //nesteditem.Display = (!vcetne_dnu.Checked);
            }
            //doplňování textu do footeru
            //-------------------------------------------------------
            //GridItem[] headerItems = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
            //GridItem[] footerItems = RadGrid1.MasterTableView.GetItems(GridItemType.GroupFooter);

            //for (int i = 0; i < headerItems.Length; i++)
            //{
            //    var text = (headerItems[i] as GridGroupHeaderItem).Cells[1].Text;
            //    (footerItems[i] as GridGroupFooterItem).Cells[3].Text = text + " Celkem:";

            //    for (int j = 4; j < (footerItems[i] as GridGroupFooterItem).Cells.Count; j++)
            //    {
            //        var sumText = (footerItems[i] as GridGroupFooterItem).Cells[j].Text;
            //        //if ((sumText != " ") && (sumText != "&nbsp;"))
            //        if (sumText.Contains(":"))
            //        {
            //            if (sumText.Contains(":"))
            //                sumText += "&nbsp;";
            //            sumText = sumText.Split(new char[] { ':' }, StringSplitOptions.RemoveEmptyEntries)[1];
            //            (footerItems[i] as GridGroupFooterItem).Cells[j].Text = sumText;
            //        }
            //    }
            //}
            //----------------------------------------------------
            /*PH zatím zapoznámkováno
            foreach (GridColumn column in RadGrid1.Columns)
            {
                if (column.UniqueName == "id_hodiny")
                {
                    
                    if ((UseKoeficient)&&(Koeficient!=0))
                        (column as GridBoundColumn).DataFormatString = "{0:N3}";
                    else
                        (column as GridBoundColumn).DataFormatString = "{0:N2}";

                    break;
                }
            }*/
        }

        protected void combo_projekty_SelectedIndexChanged(object sender, EventArgs e)
        {
            string projekt = combo_projekty.SelectedValue;
            if (string.IsNullOrEmpty(projekt)) return;

            RadGrid1.Rebind();
            //if (Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUser))
            //PH 1.10.2014
            if (Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUserNeboZastupovany))
                check_schvalovani.Visible = (!vcetne_dnu.Checked);
            else
                check_schvalovani.Visible = false;       
        }

        protected void vcetne_dnu_CheckedChanged(object sender, EventArgs e)
        {
            //check_schvalovani.Visible=(vcetne_dnu.Checked==false);
            string projekt = combo_projekty.SelectedValue;
            //check_schvalovani.Visible = ((vcetne_dnu.Checked == false) && (Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUser)));
            //PH 1.10.2014
            check_schvalovani.Visible = ((vcetne_dnu.Checked == false) && (Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUserNeboZastupovany)));
            if (vcetne_dnu.Checked == true) check_schvalovani.Checked = false;

            RadGrid1.Rebind();
        }

        protected void schvalovani_CheckedChanged(object sender, EventArgs e)
        {
            if (check_schvalovani.Checked)
                RadGrid1.MasterTableView.HierarchyDefaultExpanded = true;
            else
                RadGrid1.MasterTableView.HierarchyDefaultExpanded = false;
               
            RadGrid1.Rebind();
        }

        protected void rad_schvaleno_NeedDataSource(object sender, GridNeedDataSourceEventArgs e )
        {
            if ((check_schvalovani.Checked)&&(!vcetne_dnu.Checked))
            {
                RadGrid grid = ((RadGrid)sender);
                Control c = grid.NamingContainer;
                GridNestedViewItem nvi = (GridNestedViewItem)c.NamingContainer;
                string projekt = Convert.ToString(DataBinder.Eval(nvi.DataItem, "projekt"));
                    //EI-37-15-58800-3
                //decimal os_cislo = Convert.ToDecimal(DataBinder.Eval(nvi.DataItem, "os_cislo"));
                //if (os_cislo == 37112953)
                //{ }
                bool povol_schvalovani = Convert.ToBoolean(DataBinder.Eval(nvi.DataItem, "povol_schvalovani"));
                if (povol_schvalovani == false)
                {
                    nvi.Visible = false;
                    c.Visible = false;
                    return;
                }

                int id_poz=0;
                if (nvi.DataItem != null)
                    id_poz = (Int32)DataBinder.Eval(nvi.DataItem, "id_poz");
                else
                    id_poz = _id_poz;
                
                //string projekt = combo_projekty.SelectedValue;
                //grid.DataSource = KSPortal.ZakSpec.ProjektyHodiny.SchvalovaniText(0, 0, id_poz, projekt, obdobi.SelectedValue);
                grid.DataSource = KSPortal.ZakSpec.ProjektyHodiny.SchvalovaniText(0, 0, id_poz, projekt, (DateTime)obdobi.SelectedDate);
            }
        }

        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        { 
           if (e.Item is GridNestedViewItem)
            {
                GridNestedViewItem nestedview = (GridNestedViewItem)e.Item;
                WebControl panel = WebControlHelperProxy.FindControl(nestedview, "pan_zmena") as WebControl;
                //TitledPanel hlavni_panel = WebControlHelperProxy.FindControl(nestedview, "schvalovani_hlavni_panel") as TitledPanel;
                Label label_title = WebControlHelperProxy.FindControl(nestedview, "label_title") as Label;
               
                RadGrid rg = WebControlHelperProxy.FindControl(nestedview, "rad_schvaleno") as RadGrid;
                //rg.DataSourceID = "";
                if ((vcetne_dnu.Checked == false)&&(check_schvalovani.Checked))
                {
                    Telerik.Web.UI.DataKey key = RadGrid1.MasterTableView.DataKeyValues[nestedview.ParentItem.ItemIndex];

                    RadButton butt = WebControlHelperProxy.FindControl(nestedview, "button_ulozit") as RadButton;
                    butt.CommandArgument = nestedview.ParentItem.ItemIndex.ToString();
                    /*
                    int id_poz=Convert.ToInt32(key["id_poz"]);
                    
                    //if ((key["stav"].ToString() == "potvrzeny") || (key["stav"].ToString() == "opravitp")|| (key["stav"].ToString() == "opraveny"))
                    //PH 4.11.2014
                    if ((key["stav"].ToString() == "schvaleny") || (key["stav"].ToString() == "potvrzeny"))
                    {
                        Str_workfl_proc str = workfl_proc.NaplnStrukturuPodleIdPoz(Convert.ToInt32(key["id_poz"]));
                        bool found = _hledej_workfl_zazn(Convert.ToInt32(key["id_poz"]), str.id, key["projekt"].ToString(), key["stav"].ToString());
                        if (panel != null)
                            panel.Visible = !found;
                    }
                    else
                    {
                        if (panel != null)
                            panel.Visible = false;
                    }
                     * */
                    //PH 10.11.2014                    
                    panel.Visible = Convert.ToBoolean(key["pan_visible"]);
                    string pom="";
                    string mess="";
                    if (key["stav"]!=null)
                        pom=Convert.ToString(key["stav"]);
                    if (pom=="")
                        mess=" - docházka dosud nepotrzena zaměstnancem";
                    else
                    {
                        //Pozadavek poz=new Pozadavek();
                        //Str_workfl_stavy itst=new Str_workfl_stavy();
                        //WorkflowStavy stavy = new WorkflowStavy(Convert.ToInt32(key["id_poz"]), false);
                        //mess="aktuální stav: "+stavy.GetStavText(pom);
                        mess = "";
                    }
                    label_title.Text = "Schvalování " + mess;            
                }               
            }

            //if (e.Item is GridDataItem)
            //{
            //    GridDataItem item = (GridDataItem)e.Item;
            //    Telerik.Web.UI.GridLinkButton button = item["id_poznamky_detail"].Controls[0] as Telerik.Web.UI.GridLinkButton;
            //    if (button != null)
            //        button = DataBinder.Eval(e.Item, "id_poz").ToString();

            //}

            //--------------------------------------------------
           if (e.Item is GridGroupFooterItem)
           {               
                //get the footer cell:
                var odborNumberCell = (e.Item as GridGroupFooterItem)["odbor"];
                if (odborNumberCell == null) return;
                //find the group header for the current group:
                var headerItem = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader)
                    .Where(i => i.GroupIndex == e.Item.GroupIndex).First() as GridGroupHeaderItem;

                string groupHeaderText = headerItem.DataCell.Text;
                //get just the left part - only group level but not the actual value:                   
                //string groupLevel = groupHeaderText.Substring(0, groupHeaderText.IndexOf(':'));
                //add group level to the text in the footer:
                odborNumberCell.Text = groupHeaderText;               
           }
            //--------------------------------------------------
          
        }

        private void _get_pm_prac_str(DateTime obdobi, decimal os_cislo, short cislo_pom, ref int id_pracmist, ref string cislo_pm, ref string prac_str)
        {
            id_pracmist = 0;
            cislo_pm = "";
            prac_str = "";

            //Prac_pom pp = new Prac_pom();
            object[] ret;
            //pp.GetPolozky(os_cislo, cislo_pom, new String[] { "id_pracmist", "pov_funkce", "prac_str" }, obdobi, out ret);
            //PH 17.2.2015
            Prac_pom.GetPolozky(os_cislo, cislo_pom, new String[] { "id_pracmist", "pov_funkce", "prac_str" }, obdobi, out ret);
            //string stred = "";
            //int id_mista = 0;
            //string cislo_mista = "";
            if (ret.Length == 3)
            {
                id_pracmist = Convert.ToInt32(ret[0]);
                cislo_pm = Convert.ToString(ret[1]);
                prac_str = Convert.ToString(ret[2]);
            }
        }

        private bool _hledej_workfl_zazn(int id_poz, string projekt, string stav_pozadavku, ref string stav_projektu)
        {
            /*
            string sql = "select count(*) from workfl_zazn " +
                        " where id_poz=" + SqlPrikaz.ValueToString(id_poz) +
                        //" and celcislo1=" + SqlPrikaz.ValueToString(id) +
                        " and string10=" + SqlPrikaz.ValueToString(projekt) +
                        " and string3 is null"+
                        " and klic='schvalproj'";
            int pocet=SqlPrikaz.ExecuteScalarInt32(sql, 0);
            if (pocet > 0)
                return true;
            */
            string  sql = "select string1, string2 from workfl_zazn " +
                   "  where id_poz=" + SqlPrikaz.ValueToString(id_poz) +
                   "  and klic='schvalproj'" +
                   "  and string10=" + SqlPrikaz.ValueToString(projekt) +
                   " and string3 is null "+
                   "  order by string2 desc ";
            string val=SqlPrikaz.ExecuteScalarString(sql, "").Trim();
            stav_projektu = val;
            if ((val == "opravit") && (stav_pozadavku == "opravitp"))
                return true;
            if (val == "schvaleny")
                return true;
            //if ((val == "schvaleny") || (val == "opravit"))
               // return true;


            //List<Str_workfl_zazn_tab> list=workfl_zazn.RetrieveProjekt(id_poz, "schvalproj", projekt);
            //if (list.Count==0) return false;

            //Str_workfl_zazn_tab_String2Comparer comparer=new Str_workfl_zazn_tab_String2Comparer();
            //list.Sort(comparer);
            //if (list[list.Count - 1].string1 == "schvaleny")
            //    return true;

            return false;
            //return (pocet>0);
                       
        }

        public static DataTable SchvalovaniText(decimal os_cislo, short cislo_pom, int id_poz, string projekt, DateTime obdobi)
        {
            DataTable table = new DataTable();
            table.Columns.Add("popis", typeof(string));
            table.Columns.Add("datum", typeof(DateTime));
            table.Columns.Add("stav", typeof(string));

            List<Str_workfl_zazn_tab> list= workfl_zazn.RetrieveProjekt(id_poz, "schvalproj", projekt);
            foreach (Str_workfl_zazn_tab str in list)
            {
                DataRow row = table.Rows.Add();                
                row["datum"] = F_DateTime.String15ToDateTime(str.string2);
                row["popis"] = str.string11;
                row["stav"] = str.string1;
            }
            table.DefaultView.Sort = "datum";
            return table.DefaultView.ToTable();
        }

        int _id_poz;
        protected void button_ulozit_Command(object sender, CommandEventArgs e)
        {
            RadButton b = (RadButton)sender;
            Telerik.Web.UI.DataKey key= RadGrid1.MasterTableView.DataKeyValues[Convert.ToInt32(b.CommandArgument)];            
           
           DropDownList list = WebControlHelperProxy.FindControl(b.Parent, "drop_stavy") as DropDownList;
           RadTextBox text_box = WebControlHelperProxy.FindControl(b.Parent, "text_poznamka") as RadTextBox;
           string new_stav = list.SelectedValue;
           string pozn = text_box.Text;
           _ulozit(Convert.ToDecimal(key["os_cislo"]), Convert.ToInt16(key["cislo_pom"]), Obdobi, Convert.ToInt32(key["id_poz"]), key["projekt"].ToString(), pozn, new_stav);

           Panel pan=WebControlHelperProxy.FindControl(b.Parent, "pan_zmena") as Panel;
           pan.Visible = false;

           RadGrid rg = WebControlHelperProxy.FindControl(pan.Parent, "rad_schvaleno") as RadGrid;
           //rg.DataBind();
           //PH 6.10.2014
           _id_poz = Convert.ToInt32(key["id_poz"]);
           rg.Rebind();                         
        }

        private void _ulozit(decimal ldc_os_cislo, short li_cislo_pom, DateTime obdobi, int id_poz, string projekt, string poznamka, string new_stav)
        {           
            Str_workfl_proc str = workfl_proc.NaplnStrukturuPodleIdPoz(id_poz);

            //musím opakovaně provést načtení
            str = workfl_proc.NaplnStrukturuPodleIdPoz(id_poz);

            Str_workfl_zazn_tab str1 = new Str_workfl_zazn_tab();
            str1.id_poz = id_poz;
            str1.klic = "schvalproj";
            str1.datum1 = DateTime.Now.Date;
            str1.string1 = new_stav;
            str1.string2 = F_DateTime.DateTimeToString15(DateTime.Now);
            str1.string10 = projekt;
            str1.string11 = poznamka;
            str1.celcislo1 = str.id;
            str1.celcislo2 =(Int32) Globals.OsCisloAktUserNeboZastupovany; //PH 19.5.2017            

            workfl_zazn.Insert(str1);

            /*
            if (new_stav == "schvaleny")
            {
                //musím zkontrolovat jestli už jsou všechny ostatní projekty schváleny, pokud ano tak pošoupnu stav dále
                if (_jsouVsechnyProjektySchvaleny(obdobi, projekt, ldc_os_cislo, li_cislo_pom))
                    WorkflowProces.KrokProcesu(id_poz, "schvalenyp", 0, "");

            }
            else if (new_stav == "opravit")
            { 
                //zkontroluju v jakém stavu je docházka, pokud je v jiném stavu než "opravit" nastavím stav "opravit"                
                if (str.stav != "opravit")
                {
                    WorkflowProces.KrokProcesu(id_poz, "opravitp", 0, "");
                }
                PozadavekSkodaFunkce.CreateAndSendEmail(obdobi, new_stav, projekt, ldc_os_cislo, 0, poznamka, "zam");
            }  
             * */
            //PH 4.11.2014
            if (new_stav == "schvaleny")
            {
                // WorkflowProces.KrokProcesu(id_poz, "schvalenyp", 0, "");             
                //PH 31.5.2017 HD ID:36033
                //----------------------------------------
                RadGrid grid = WebControlHelper.FindControl(this, "RadGrid1") as RadGrid;
                if (grid!=null)
                {
                    for(int i=0;i<grid.MasterTableView.Items.Count; i++)
                    {
                        if (grid.MasterTableView.Items[i] is GridDataItem)
                        {
                            string projekt1 = grid.MasterTableView.Items[i].GetDataKeyValue("projekt").ToString();
                            string id_poz1 = grid.MasterTableView.Items[i].GetDataKeyValue("id_poz").ToString();
                            if ((projekt == projekt1) && (id_poz.ToString() == id_poz1))
                            {
                                CheckBox box=(CheckBox)grid.MasterTableView.Items[i]["id_proj_schvaleno"].Controls[0];
                                if (box!=null)  box.Checked = true;                      
                            }
                        }
                    }
                }
                //--------------------------------------
            }
            else if (new_stav == "opravit")
            {
                //zkontroluju v jakém stavu je docházka, pokud je v jiném stavu než "opravit" nastavím stav "opravit"                
                if (str.stav != "opravit")
                {
                    WorkflowProces.KrokProcesu(id_poz, "opravitp", 0, "");
                }
                //tohle musím ještě upravit
                //PozadavekSkodaFunkce.CreateAndSendEmail(obdobi, new_stav, projekt, ldc_os_cislo, 0, poznamka, "zam");
            }  

        }

        private static bool _jsouVsechnyProjektySchvaleny(DateTime obdobi, string projekt, decimal adc_os_cislo, short ai_cislo_pom)
        {
            string stav = "";
            int id_poz = 0;
            Pozadavek.Exists(adc_os_cislo, ai_cislo_pom, "dochazka", obdobi, ref stav, ref id_poz);
            Str_workfl_proc str = workfl_proc.NaplnStrukturuPodleIdPoz(id_poz);

            string ls_denod = F_DateTime.DateTimeToString15(obdobi);
            string ls_dendo = F_DateTime.DateTimeToString15(obdobi.PosledniDenMinuta());
            string sql = "select distinct A.prac_str " +
                       " from dch_casy A, vyr_zakazky B " +
                       " where A.prac_str=B.projekt " +
                       " and A.cas between '" + ls_denod + "' and '" + ls_dendo + "' " +
                       /*" and A.prac_str<>" + SqlPrikaz.ValueToString(projekt) +*/
                       " and A.os_cislo="+SqlPrikaz.ValueToString(adc_os_cislo) + 
                       " and A.cislo_pom="+SqlPrikaz.ValueToString(ai_cislo_pom);
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                { 
                    string  ls_prac_str=GetNullOrData.GetString(reader, 0, "").Trim();                                   

                    string stav2 = SqlPrikaz.ExecuteScalarString("select string1 from workfl_zazn " +
                                        " where id_poz=" + SqlPrikaz.ValueToString(id_poz) +
                                        " and klic='schvalproj' " +
                                        " and string10=" + SqlPrikaz.ValueToString(ls_prac_str) +
                                        " and celcislo1=" + SqlPrikaz.ValueToString(str.id), "-1").Trim();
                    if (stav2 == "schvaleny")
                    {
                        continue;
                    }
                    else if (stav2 == "-1")
                    {
                        string sql2 = "select string1, string2 from workfl_zazn " +
                                       "  where id_poz=" + SqlPrikaz.ValueToString(id_poz) +
                                       "  and klic='schvalproj'" +
                                       "  and string10=" + SqlPrikaz.ValueToString(ls_prac_str) +
                                       "  and string3 is null "+
                                       "  order by string2 desc ";
                        string val=SqlPrikaz.ExecuteScalarString(sql2, "").Trim();
                        if (val != "schvaleny")
                        {
                            reader.Close();
                            return false;
                        }
                   }
                }
                reader.Close();
            }
            return true;                         
        }

        /// <summary>
        /// Vrací aktuální stav
        /// </summary>
        /// <param name="id_poz"></param>
        /// <param name="projekt"></param>
        /// <param name="id_akt_stavu"></param>
        /// <returns></returns>
        public static string StavProProjekt(int id_poz, string projekt, int id_akt_stavu)
        {
            return SqlPrikaz.ExecuteScalarString("select string1 from workfl_zazn " +
                                        " where id_poz=" + SqlPrikaz.ValueToString(id_poz) +
                                        " and klic='schvalproj' " +
                                        " and string10=" + SqlPrikaz.ValueToString(projekt)+
                                        " and string3 is null", "").Trim();
                                        //" and celcislo1=" + SqlPrikaz.ValueToString(id_akt_stavu), "").Trim();

        }

        protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "poznamky_detail")
            {
                GridDataItem item = e.Item as GridDataItem;

                string id_poz = item.GetDataKeyValue("id_poz").ToString();
                string projekt = item.GetDataKeyValue("projekt").ToString();

                RadWindow RadWindow1 = new RadWindow();
                NameValueCollection args = new NameValueCollection();
                args.Add("idpoz", id_poz.ToString());
                args.Add("projekt", projekt);
                KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();

                //string url = Pozadavek.UrlBase() + @"/ZakSpec/ProjektyPoznamky.aspx";
                //PH 29.6.2020 HID:51506
                string url = Pozadavek.UrlBaseInterni() + @"/ZakSpec/ProjektyPoznamky.aspx";
                url = qsc.AddEncryptQuery(url, args);
                RadWindow1.NavigateUrl = url;// Pozadavek.UrlBase() + "/ZakSpec/ProjektyPoznamky.aspx?=idpoz" + id_poz;
                                             //RadWindow1.VisibleOnPageLoad = true;
                RadWindow1.DestroyOnClose = true;
                RadWindow1.EnableViewState = false;
                RadWindow1.Width = 700;
                RadWindow1.Height = 300;
                this.radwindowmanager.Windows.Add(RadWindow1);

                string script = "function f(){$find(\"" + RadWindow1.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "window_key", script, true);
            }
        }

        protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            
        }

        protected void RadGrid1_ColumnCreated(object sender, Telerik.Web.UI.GridColumnCreatedEventArgs e)
        {
            //if (e.Column.UniqueName == "id_hodiny")
            //{
            //    GridBoundColumn boundColumn = e.Column as GridBoundColumn;
            //    if (UseKoeficient)
            //        boundColumn.DataFormatString = "{0:N4}";
            //    else
            //        boundColumn.DataFormatString = "{0:N2}";
            //}
        }

        /*
        protected void ulozit_Command(object sender, CommandEventArgs e)
        {
            RadGrid1.Rebind();
            RadGrid1.MasterTableView.HierarchyDefaultExpanded = true;
            RadGrid1.ExportSettings.FileName = "RadGridExportToExcel";
            RadGrid1.ExportSettings.IgnorePaging = true;
            RadGrid1.ExportSettings.ExportOnlyData = true;
            RadGrid1.ExportSettings.OpenInNewWindow = true;

            RadGrid1.MasterTableView.ExportToExcel();
        }
         * */

        //private static string _uprav_cislo_mista(string oj, string cislo)
        //{
        //    return "";
        //}

       

        private static bool _mistoExists(ref List<StrPrMistoExists> mista, string cislo, DateTime datum)
        {
            int index=mista.FindIndex(f => f.cislo == cislo);
            if (index > -1)
                return mista[index].exists;
            else
            {
                int pocet = SqlPrikaz.ExecuteScalarInt16("select count(*) from prac_mist where cis_pracmist=" + SqlPrikaz.ValueToString(cislo) +
                                                        " and (datum_od<=" + SqlPrikaz.ValueToString(datum) + " or datum_od is null) " +
                                                        " and (datum_do>=" + SqlPrikaz.ValueToString(datum) + " or datum_do is null)", 0);
                StrPrMistoExists it = new StrPrMistoExists();
                it.cislo = cislo;
                it.exists = (pocet > 0);
                mista.Add(it);
                return it.exists;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="ai_id_mista"></param>
        /// <param name="cislo_mista"></param>
        /// <param name="datum"></param>
        /// <param name="usek"></param>
        /// <param name="odbor"></param>
        /// <param name="oddeleni"></param>
        public static void Get_usek_odbor_oddeleni(ref Dictionary<string,string> buff, ref List<StrPrMistoExists> mista, int ai_id_mista, string cislo_mista, DateTime datum,out string usek, out string odbor, out string oddeleni)
        {
            usek = "";
            odbor = "";
            oddeleni = "";

            if (Zakaznik.IsCurrent("SKODA PRAHA"))
            {
                //_get_usek_odbor_oddeleni(ref buff, cislo_mista, datum,out usek, out odbor, out oddeleni);
                _get_usek_odbor_oddeleni(ref buff, ai_id_mista, datum, out usek, out odbor, out oddeleni);
                return;
            }

            int? id_systemizace=null;
            int? id_stromu=null;
            string cis_oj;

            bool lb_usek=false;
            bool lb_odbor=false;
            bool lb_oddeleni=false;

            if (string.IsNullOrEmpty(cislo_mista)) return;//PH 18.11.2014
            cislo_mista = cislo_mista.Trim();//PH 18.11.2014
            if (cislo_mista.Length != 9) return;//PH 18.11.2014

            if (cislo_mista.Substring(0, 7) == "9999999")
            {
                lb_oddeleni = false;
                lb_odbor = false;
                lb_usek = true;
            }
            else
            {
                if (cislo_mista.Substring(1, 1) != "0")
                {
                    string cis_mista_nadriz = cislo_mista.Substring(0, 2) + "0000001";
                    bool r = _mistoExists(ref mista, cis_mista_nadriz, datum);
                    lb_usek = r;
                }

                if (cislo_mista.Substring(2, 1) != "0")
                {
                    string cis_mista_nadriz = cislo_mista.Substring(0, 3) + "000001";
                    bool r = _mistoExists(ref mista, cis_mista_nadriz, datum);
                    lb_odbor = r;
                }

                if (cislo_mista.Substring(3, 1) != "0")
                {
                    string cis_mista_nadriz = cislo_mista.Substring(0, 4) + "00001";
                    bool r = _mistoExists(ref mista, cis_mista_nadriz, datum);
                    lb_oddeleni = r;
                }
            }


            string usek_oj = "";
            string odbor_oj = "";
            string oddeleni_oj = "";

            int? id_nadriz_stromu;
            string cis_nadriz_oj;
            bool lb_inicializace = false;
            if (lb_oddeleni)
            {                
                Nadrizeny_strom_oj(ai_id_mista, datum, out id_systemizace, out id_nadriz_stromu, out cis_oj, out oddeleni);
                if ((id_systemizace == null) || (id_nadriz_stromu == null)) return; //PH 15.1.2015
                lb_inicializace=true;

                oddeleni_oj = cis_oj;
                id_stromu = id_nadriz_stromu;
            }

            if (lb_odbor)
            {
                if (!lb_inicializace)
                {
                    Nadrizeny_strom_oj(ai_id_mista, datum, out id_systemizace, out id_nadriz_stromu, out cis_nadriz_oj, out odbor);
                    if ((id_systemizace == null) || (id_nadriz_stromu == null)) return;//PH 15.1.2015
                    lb_inicializace = true;
                }
                else
                    Nadrizeny_strom_oj(datum, (int)id_systemizace, (int)id_stromu, out id_nadriz_stromu, out cis_nadriz_oj, out odbor);
              
                odbor_oj = cis_nadriz_oj;
                id_stromu = id_nadriz_stromu;
            }

            if (lb_usek)
            {
                if (!lb_inicializace)
                {
                    Nadrizeny_strom_oj(ai_id_mista, datum, out id_systemizace, out id_nadriz_stromu, out cis_nadriz_oj, out usek);
                    if ((id_systemizace == null) || (id_nadriz_stromu == null)) return;//PH 15.1.2015
                    lb_inicializace = true;
                }
                else
                    Nadrizeny_strom_oj(datum, (int)id_systemizace, (int)id_stromu, out id_nadriz_stromu, out cis_nadriz_oj, out usek);
                
                usek_oj = cis_nadriz_oj;
            }
        }
        private static void _get_usek_odbor_oddeleni(ref Dictionary<string, string> buff, int id_mista, DateTime datum, out string usek, out string odbor, out string oddeleni)
        {
            string oj;//=string.Empty;
            string oj_nazev;//=string.Empty;
            short oj_typ;//=string.Empty;

            usek = string.Empty;
            odbor = string.Empty;
            oddeleni = string.Empty;


            _oj_pro_misto(id_mista, datum, out oj, out oj_nazev, out oj_typ);           
            _prirazeni_jednotky(oj, oj_nazev, oj_typ, ref usek, ref odbor, ref oddeleni);

            if (oj_typ == 2) return;

            ArrayList anadrizene = new ArrayList();
            KSProgram.Systemizace.NajdiNadrizenaMista.Get(id_mista, datum, ref anadrizene);            
            while (anadrizene.Count > 0)
            {
                _oj_pro_misto(Convert.ToInt32(anadrizene[0]), datum, out oj, out oj_nazev, out oj_typ);           
                _prirazeni_jednotky(oj, oj_nazev, oj_typ, ref usek, ref odbor, ref oddeleni);

                if (oj_typ == 2) return;

                int id_pm=Convert.ToInt32(anadrizene[0]);
                anadrizene.Clear();
                KSProgram.Systemizace.NajdiNadrizenaMista.Get(id_pm, datum, ref anadrizene);          
            }            
        }
        /*
        private static bool _nadriz_a_oj(int id_mista, DateTime datum, string oj_typ, ref string usek, ref string odbor, ref string oddeleni)
        {
            bool lb_res = false;
            if (oj_typ != "2")
            {
                ArrayList anadrizene = new ArrayList();
                KSProgram.Systemizace.NajdiNadrizenaMista.Get(id_mista, datum, ref anadrizene);
                if (anadrizene.Count > 0)
                {
                    _oj_pro_misto(Convert.ToInt32(anadrizene[0]), datum, out oj, out oj_nazev, out oj_typ);
                    _prirazeni_jednotky(oj, oj_nazev, oj_typ, ref usek, ref odbor, ref oddeleni);
                    lb_res = true;
                }
            }
            return lb_res;
        }
        */

        private static void _prirazeni_jednotky(string oj, string oj_nazev, short oj_typ, ref string usek, ref string odbor, ref string oddeleni)
        {
            //if (oj_typ == 2)
            //    usek = oj;
            //else if (oj_typ == 3)
            //    odbor = oj;
            //else if (oj_typ == 4)
            //    oddeleni = oj;

            if (oj_typ == 2)
                usek = oj_nazev;
            else if (oj_typ == 3)
                odbor = oj_nazev;
            else if (oj_typ == 4)
                oddeleni = oj_nazev;

        }

        private static bool _oj_pro_misto(int id_mista, DateTime datum, out string oj, out string oj_nazev, out short oj_typ)
        {
            bool res = false;

            oj = string.Empty;
            oj_nazev = string.Empty;
            oj_typ = 0;

            oj=PracMisto.AtributPM(id_mista, 40, datum);
            if (!string.IsNullOrEmpty(oj)) oj = oj.Trim();

            string sql="SELECT nazev, uroven "+
                " FROM org_utvar A "+
                  "  WHERE ( A.cislo <> '0' ) "+
                  "   and  A.platnost_od<="+SqlPrikaz.ValueToString(datum.PosledniDen())+
                  "   and (A.platnost_do >="+SqlPrikaz.ValueToString(datum)+" or A.platnost_do is null) "+
                  "  and A.cislo="+SqlPrikaz.ValueToString(oj);
            using (IDataReader reader=SqlPrikaz.ExecuteReader(sql))
            {
                if (reader.Read())
                {
                    oj_nazev = GetNullOrData.GetString(reader, 0, "").Trim();
                    oj_typ = GetNullOrData.GetInt16(reader, 1, 0);
                    reader.Close();
                    res = true;
                }
            }

            return res;
        }
      

        /*
                private static void _get_usek_odbor_oddeleni(ref Dictionary<string, string> buff, string cislo_mista, DateTime datum, out string usek, out string odbor, out string oddeleni)
                {
                    usek = odbor = oddeleni = "";

                    if (string.IsNullOrEmpty(cislo_mista)) return;
                    cislo_mista = cislo_mista.Trim();
                    //if (cislo_mista.Length != 9) return;
                    //string ls_upr_cp = cislo_mista.Substring(0, 5);
                    //if (cislo_mista == "10010001")
                    if (cislo_mista == "13003005")
                    { }
                    if (cislo_mista.Substring(1, 1) == "0")
                        cislo_mista = cislo_mista.Substring(0, 1) + "1" + cislo_mista.Substring(2);

                    string ls_usek = cislo_mista.Substring(0, 3)+"00";
                    string ls_odbor = cislo_mista.Substring(3, 1)+"0";
                    string ls_oddeleni = cislo_mista.Substring(4, 1);

                    if (cislo_mista.StartsWith("199"))
                    {
                        odbor = "11010";
                    }
                    else
                    {
                        usek = cislo_mista.Substring(0, 3) + "00";

                        if (cislo_mista.Substring(3, 1) != "0")
                            odbor = cislo_mista.Substring(0, 4) + "0";

                        if (cislo_mista.Substring(4, 1) != "0")
                            oddeleni = cislo_mista.Substring(0, 5);
                    }

                    //převrátím na názvy
                    //------------------------------------
                    if (!string.IsNullOrEmpty(usek))
                        usek = oj_nazev(usek, datum, ref buff);

                    if (!string.IsNullOrEmpty(odbor))
                        odbor = oj_nazev(odbor, datum, ref buff);

                    if (!string.IsNullOrEmpty(oddeleni))
                        oddeleni = oj_nazev(oddeleni, datum, ref buff);
                    //-----------------------------------
                }
                */

        private static string oj_nazev(string cislo, DateTime datum, ref Dictionary<string, string> buff)
        {
            string ls_res=String.Empty;

            if (buff.ContainsKey(cislo))
                ls_res=buff[cislo];
            else
            {
                string ls_sql = " SELECT  A.nazev " +
                               "  FROM org_utvar A   " +
                               " WHERE ( A.cislo <> '0' )  " +
                               " and  A.platnost_od<=" + SqlPrikaz.ValueToString(datum.PosledniDen()) +
                               " and (A.platnost_do >=" + SqlPrikaz.ValueToString(datum) + " or A.platnost_do is null) " +
                               " and A.cislo=" + SqlPrikaz.ValueToString(cislo);
                ls_res = SqlPrikaz.ExecuteScalarString(ls_sql, "", true);
                if (!String.IsNullOrEmpty(ls_res))
                    buff.Add(cislo, ls_res);
            }

            return ls_res;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="ai_id_mista"></param>
        /// <param name="datum"></param>
        /// <param name="id_systemizace"></param>
        /// <param name="id_nadriz_stromu"></param>
        /// <param name="cis_nadriz_oj"></param>
        /// <param name="naz_nadriz_oj"></param>
        public static void Nadrizeny_strom_oj(int ai_id_mista, DateTime datum, out int? id_systemizace, out int? id_nadriz_stromu, out string cis_nadriz_oj, out string naz_nadriz_oj)
        {
            id_systemizace = null;
            id_nadriz_stromu = null;
            cis_nadriz_oj = null;
            naz_nadriz_oj = null;
            string sql = " select systemiz_podnik.id_systemizace, system_stromy.id_stromu, org_jednotka, U.nazev " +
                         "   from system_stromy, systemizace, systemiz_podnik, org_utvar U " +
                         "   where system_stromy.id_stromu=systemizace.id_stromu and typ_polozky=1  " +
                         "   and id_pracmist = " + SqlPrikaz.ValueToString(ai_id_mista) +
                         "   and org_jednotka=U.cislo "+
                         "   and systemizace.id_systemizace = systemiz_podnik.id_systemizace and navrh = 0  " +
                         "   and (systemiz_podnik.datum_od is null or systemiz_podnik.datum_od <=" + SqlPrikaz.ValueToString(datum) + ")  " +
                         "   and (systemiz_podnik.datum_do is null or systemiz_podnik.datum_do >=" + SqlPrikaz.ValueToString(datum) + ")  " +
                         "   and (systemizace.datum_od is null or systemizace.datum_od <=" + SqlPrikaz.ValueToString(datum) + ")  " +
                         "   and (systemizace.datum_do is null or systemizace.datum_do >=" + SqlPrikaz.ValueToString(datum) + ")";

            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                if (reader.Read())
                {
                    id_systemizace = GetNullOrData.GetInt32(reader, 0);
                    id_nadriz_stromu = GetNullOrData.GetInt32(reader, 1);
                    cis_nadriz_oj = GetNullOrData.GetString(reader, 2);
                    naz_nadriz_oj = GetNullOrData.GetString(reader, 3,"").Trim();
                    //string naz_stromu = GetNullOrData.GetString(reader, 4);

                    reader.Close();
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="ad_datum"></param>
        /// <param name="id_systemizace"></param>
        /// <param name="id_stromu"></param>
        /// <param name="id_nadriz_stromu"></param>
        /// <param name="cis_nadriz_oj"></param>
        /// <param name="naz_nadriz_oj"></param>
        public static void Nadrizeny_strom_oj(DateTime ad_datum, int id_systemizace, int id_stromu, out int? id_nadriz_stromu, out string cis_nadriz_oj, out string naz_nadriz_oj)
        {
            id_nadriz_stromu = null;
            cis_nadriz_oj = null;
            naz_nadriz_oj = null;

            string sql = "select system_stromy.id_stromu, org_jednotka,U.nazev" +
                        " from system_stromy, systemizace, org_utvar U  " +
                        " where system_stromy.id_stromu=systemizace.id_stromu and typ_polozky=4  " +
                        " and id_pracmist = " + SqlPrikaz.ValueToString(id_stromu) +
                        " and org_jednotka=U.cislo " +
                        " and systemizace.id_systemizace =  " + SqlPrikaz.ValueToString(id_systemizace) +
                        " and (systemizace.datum_od is null or systemizace.datum_od <=" + SqlPrikaz.ValueToString(ad_datum) + ") " +
                        " and (systemizace.datum_do is null or systemizace.datum_do >=" + SqlPrikaz.ValueToString(ad_datum) + ") ";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                if (reader.Read())
                {
                    id_nadriz_stromu = GetNullOrData.GetInt32(reader, 0);
                    cis_nadriz_oj = GetNullOrData.GetString(reader, 1);
                    naz_nadriz_oj = GetNullOrData.GetString(reader, 2, "").Trim();
                   // string naz_stromu = GetNullOrData.GetString(reader, 3);

                    reader.Close();
                }
            }
        }

        protected void cbx_cloveko_mesic_CheckedChanged(object sender, EventArgs e)
        {
            RadGrid1.Rebind();
        }

        protected void RadioButtonList1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string val=((TRadioButtonList)sender).SelectedValue;
            if (val == "z")
            {
                combo_projekty.SelectedIndex = 0;
                combo_projekty.Enabled = false;
                combo_zamestnanci.Enabled = true;
            }
            else if (val == "p")
            {
                combo_zamestnanci.SelectedIndex = 0;
                combo_projekty.Enabled = true;
                combo_zamestnanci.Enabled = false;
            }
        }

        

        //protected void combo_zamestnanci_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        protected void combo_zamestnanci_SelectedIndexChanged(object sender, EventArgs e)
        {
            check_schvalovani.Visible = false;

            RadGrid1.Rebind();
            if (!vcetne_dnu.Checked)
            {
                for (int i = 0; i < RadGrid1.MasterTableView.Items.Count; i++)
                {
                    //string projekt = RadGrid1.MasterTableView.Items[i]["projekt"].Text;
                    //PH 1.2.2018 HID:39963
                    string projekt = RadGrid1.MasterTableView.Items[i]["col_projekt"].Text;
                    if (Vyr_zakazky.IsPmob(projekt, Globals.OsCisloAktUserNeboZastupovany))
                    {
                        check_schvalovani.Visible = true;
                        break;
                    }
                    //else
                    //    check_schvalovani.Visible = false;
                }
            }
        }

        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridGroupFooterItem)
            {
                if ((check_schvalovani.Checked)&&(!vcetne_dnu.Checked))
                {
                    //-------------------------------------------------------
                    //string group_index = "";
                    GridGroupFooterItem gfi = e.Item as GridGroupFooterItem;

                    

                    foreach (GridGroupHeaderItem ghi in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
                    {
                        string gr_index = gfi.GroupIndex.Split('_').First();

                        //if (ghi.GroupIndex == gfi.GroupIndex)
                        if (ghi.GroupIndex == gr_index)
                        {
                            int citac = 0;
                            GridItem[] children = ghi.GetChildItems();
                            foreach (GridItem ch in children)
                            {
                                if (ch.IsDataBound)
                                {
                                    //GridDataItem parentItem = (GridDataItem)(ch.OwnerTableView.ParentItem);                    
                                    GridDataItem child = ch as GridDataItem;
                                    if (child != null)
                                    {
                                        GridDataItem childItem = child as GridDataItem;
                                        //decimal ldc_os_cislo = Convert.ToDecimal(childItem["os_cislo"].Text);
                                        //short li_cislo_pom = Convert.ToInt16(childItem["cislo_pom"].Text);
                                        //string projekt = Convert.ToString(childItem["projekt"].Text);
                                        bool povol_schvalovani = Convert.ToBoolean(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["povol_schvalovani"]);
                                        bool pan_visible = Convert.ToBoolean(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["pan_visible"]);
                                        //int id_poz = Convert.ToInt32(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["id_poz"]);
                                        if ((pan_visible) && (povol_schvalovani))
                                        {
                                            citac++;
                                            if (citac>=2)                                            
                                                break;
                                        }
                                    }
                                }
                            }

                            if (citac>=2)
                            {
                                var nazev_pCell = (e.Item as GridGroupFooterItem)["nazev_p"];
                                if (nazev_pCell == null) return;

                                TRadButton button = new TRadButton();
                                button.Command += new CommandEventHandler(button_Command);
                                button.Text = "Hrom. schválení";
                                nazev_pCell.Controls.Add(button);
                            }
                        }
                    }
                    //-------------------------------------------------------

                   
                }
            }
        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn.UniqueName == "col_projekt")
                e.Cell.Style["mso-number-format"] = @"\@";
        }

        protected void RadGrid1_ExcelExportCellFormatting(object sender, ExcelExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn.UniqueName == "col_projekt")
                e.Cell.Style["mso-number-format"] = @"\@";
        }

        protected void RadGrid1_InfrastructureExporting(object sender, GridInfrastructureExportingEventArgs e)
        {
            foreach (Cell cell in e.ExportStructure.Tables[0].Columns[9].Cells)
            {
                cell.Format = @"\@";              
            }
        }

        void button_Command(object sender, CommandEventArgs e)
        {
            string group_index = "";
            RadButton box = ((RadButton)sender);            
           
           //musím zjistit ve které groupě se nacházím
            GridGroupFooterItem item = (GridGroupFooterItem)box.NamingContainer;
            group_index = item.GroupIndex;
            group_index = group_index.Split('_').First();
            foreach (GridGroupHeaderItem ghi in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
            {
                if (ghi.GroupIndex == group_index)
                {
                    //MessageBox.Confirm(this, "Přejete si schválit všechny záznamy pro pro", "Hromadné schvalování", null, null, ""

                    GridItem[] children = ghi.GetChildItems();                    
                    foreach (GridItem ch in children)
                    {
                        if (ch.IsDataBound)
                        {
                            //GridDataItem parentItem = (GridDataItem)(ch.OwnerTableView.ParentItem);                    
                            GridDataItem child = ch as GridDataItem;
                            if (child != null)
                            {
                                GridDataItem childItem = child as GridDataItem;                                
                                decimal ldc_os_cislo = Convert.ToDecimal(childItem["os_cislo"].Text);
                                short li_cislo_pom = Convert.ToInt16(childItem["cislo_pom"].Text);
                                string projekt = Convert.ToString(childItem["projekt"].Text);
                                bool povol_schvalovani = Convert.ToBoolean(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["povol_schvalovani"]);
                                bool pan_visible = Convert.ToBoolean(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["pan_visible"]);
                                int id_poz = Convert.ToInt32(RadGrid1.MasterTableView.DataKeyValues[ch.ItemIndex]["id_poz"]);
                                if ((pan_visible) && (povol_schvalovani))
                                {
                                    string pozn = "";
                                    string new_stav = "schvaleny";
                                    _ulozit(ldc_os_cislo, li_cislo_pom, Obdobi, id_poz, projekt, pozn, new_stav);
                                }
                            }
                        }
                    }
                }              
            }

            RadGrid1.Rebind();
        }

        /// <summary>
        /// 
        /// </summary>
        public struct StrPrMistoExists
        {
            /// <summary>
            /// 
            /// </summary>
            public string cislo;

            /// <summary>
            /// 
            /// </summary>
            public bool exists;
        }

      
    }

    /// <summary>
    /// 
    /// </summary>
    public struct StrProjektyStavy
    {
        /// <summary>
        /// 
        /// </summary>
        public string Projekt;

        /// <summary>
        /// 
        /// </summary>
        public string Stav;

        /// <summary>
        /// 
        /// </summary>
        public string Nazev;
    }

    public struct StrVlozit
    {
        public decimal os_cislo;
        public short cislo_pom;
        public string prijmeni;
        public string jmeno;
        public string stred;
        public string projekt;
        public string nazev_p;
        public double hodiny;
        public DateTime datum;
        public string usek;
        public string odbor;
        public string oddeleni;
        public string stav;
        public string stav_text;
        public int id_poz;
        //public bool found_workfl_zazn;
        //public bool proj_schvaleno;
    }

    public struct StrStavProj
    {
        public decimal os_cislo;
        public short cislo_pom;
        public string projekt;
        public string stav;
        public int id_poz;
        //public bool found_workfl_zazn;
        public bool proj_schvaleno;
    }
}