﻿using KSProgram;
using KSProgram.Ciselniky;
using KSProgram.Data;
using KSProgram.Dochazka;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.WebControls;
using KSProgram.ZakSpec;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using static KSProgram.Pozadavky.PozadavekSeznam;

namespace KSPortal.ZakSpec
{
    public partial class Rozkont : TPageZam
    {
        public Rozkont()
        {
            IdPrava = 307;
        }
        private decimal OsCislo
        {
            get
            {
                return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
            }
            set
            {
                ViewState["OsCislo"] = value;
            }
        }

        private short CisloPom
        {
            get
            {
                return (ViewState["CisloPom"] == null ? (short)-1 : Convert.ToInt16(ViewState["CisloPom"]));
            }
            set
            {
                ViewState["CisloPom"] = value;
            }
        }

        private DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi"] == null ? new DateTime() : Convert.ToDateTime(ViewState["Obdobi"]));
            }
            set
            {
                ViewState["Obdobi"] = value.PrvniDen();
            }
        }

        private static PovinnyProjekt Projekt
        {
            get
            {
                string s = Parametry.ParametrCti("PovinnyProjekt");
                switch(s)
                {
                    case "a":
                        return PovinnyProjekt.Ano;

                    case "d":
                        return PovinnyProjekt.AnoProDohodyNe;
                    default:
                        return PovinnyProjekt.Ne;

                }               
            }
        }

        private static bool PovinnyProjektProZam(decimal os_cislo, short cislo_pom)
        {
            if (Projekt == PovinnyProjekt.AnoProDohodyNe)
                return (Prac_pom.IsDohoda(os_cislo, cislo_pom) ? false : true);
            else if (Projekt == PovinnyProjekt.Ano)
                return true;
            else
                return false;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
                RadGrid1.Datum.SelectedObdobi = Globals.AktObdobi;
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            ObjectDataSource1.UpdateParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.UpdateParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            ObjectDataSource1.InsertParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.InsertParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
        }

        protected void RadGrid1_ItemInserted(object source, GridInsertedEventArgs e)
        {
            if (e.Exception != null)
            {
                e.ExceptionHandled = true;
                //NotifyUser("Product cannot be inserted. Reason: " + e.Exception.Message);
            }
            else
            {
                // NotifyUser("New product is inserted!");
            }
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {           
        }

        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {


        }

        protected void RadGrid1_DataBound(object sender, EventArgs e)
        {
            //Nacist();
        }

        protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            _pre_Update();
        }

        private void _pre_Update()
        {
            /*
            if (!updateRunning)
                dch_poriz_ukolu.Delete(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, (DateTime)RadGrid1.Datum.SelectedObdobi);
            updateRunning = true;
            */
        }

        protected void RadGrid1_DataBinding(object sender, EventArgs e)
        {
            ObjectDataSource1.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
            ObjectDataSource1.SelectParameters["cislo_pom"].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
            // ObjectDataSource1.SelectParameters["datum"].DefaultValue = ((DateTime)RadGrid1.Datum.SelectedDatum).ToString();

            if (!IsPostBack)
            {
                RadGrid1.Datum.SelectedDatumOd = ParametryDochazky.OBDOBI_PRO_SESTAVY; //PH 22.1.2018
                RadGrid1.Datum.SelectedDatumDo = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            }

            OsCislo = Globals.OsCisloPomer.OsCislo;
            CisloPom = Globals.OsCisloPomer.CisloPom;
            Obdobi = (DateTime)RadGrid1.Datum.SelectedDatum;
        }

        protected void RadGrid1_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            if (Rozkont.PovinnyProjektProZam(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom))
            {
                foreach (Telerik.Web.UI.GridBatchEditingCommand command in e.Commands)
                {
                    if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Update)
                    {
                        Hashtable newValues = command.NewValues;
                        if (string.IsNullOrEmpty(newValues["id_vazby"].ToString()))
                        {
                            
                            MessageBox.Alert(this, "Položka 'Projekt' je povinná");
                            return;
                        }
                    }
                }
            }

            foreach (Telerik.Web.UI.GridBatchEditingCommand command in e.Commands)
                if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Update)
                {
                    Hashtable oldValues = command.OldValues;
                    Hashtable newValues = command.NewValues;

                    int? old_kod = null;
                    string old_stred = null;
                    int? old_id_vazby = null;
                    decimal? old_hodiny = null;

                    _collectValues(oldValues, out old_kod, out old_stred, out old_id_vazby, out old_hodiny);

                    e.Canceled = true;

                    int? kod = null;
                    string stred = null;
                    int? id_vazby = null;
                    decimal? hodiny = null;

                    string pom = string.Empty;
                    if (newValues["kod"] != DBNull.Value)
                    {
                        pom = newValues["kod"].ToString();

                        pom = _onlyNumbers(pom);
                        if (!string.IsNullOrEmpty(pom))
                            kod = Convert.ToInt32(pom);
                    }
                    if (newValues["str"] != DBNull.Value)
                    {
                        pom = newValues["str"].ToString();
                        pom = _onlyNumbers(pom);
                        if (!string.IsNullOrEmpty(pom))
                            stred = Convert.ToString(pom);
                    }
                    if (newValues["id_vazby"] != DBNull.Value)
                    {
                        pom = newValues["id_vazby"].ToString();
                        pom = _onlyNumbers(pom);
                        int? pom_id = CisProjekty.GetId(pom, Obdobi);
                        id_vazby = Convert.ToInt32(pom_id);
                        if (id_vazby == 0) id_vazby = null;
                    }
                    if (newValues["hodiny"] != DBNull.Value)
                    {
                        pom = newValues["hodiny"].ToString();
                        if (!string.IsNullOrEmpty(pom))
                            hodiny = Convert.ToDecimal(newValues["hodiny"]);
                    }


                    if ((old_kod == null) &&
                       ((kod != null) && (hodiny != null)))
                    {
                        StrVyrobak str = new StrVyrobak();
                        str.os_cislo = Globals.OsCisloPomer.OsCislo;
                        str.cislo_pom = Globals.OsCisloPomer.CisloPom;
                        str.kod = Convert.ToInt32(kod);
                        str.stred = stred;
                        str.id_vazby = id_vazby;
                        str.typ_vazby = "cp";
                        str.datum = Obdobi;
                        str.hodiny = (decimal)hodiny;
                        Vyrobak.Insert(str);
                    }
                    else if ((old_kod != null) && ((kod != null) && (hodiny != null)))//dělám update
                    {
                        string sql = "update vyrobak set kod=@kod," +
                                                       "str=@stred, " +
                                                       "id_vazby=@id_vazby, " +
                                                       "hodiny=@hodiny " +
                                      "where os_cislo=@os_cislo " +
                                       " and cislo_pom=@cislo_pom " +
                                       " and str=@strr_old " +
                                       " and kod=@kood_old " +
                                       " and typ_vazby='cp' " +
                                       " and id_vazby=@id_vaazby_old " +
                                       " and hodiny=@hoodiny_old " +
                                       " and datum=@datum ";
                        ParametryPrikazu par = new ParametryPrikazu
                        {
                            new KSParameter("strr_old", old_stred, DbType.String),
                            new KSParameter("kood_old", old_kod, DbType.Int32),
                            new KSParameter("id_vaazby_old", old_id_vazby, DbType.Int32),
                            new KSParameter("hoodiny_old", old_hodiny, DbType.Decimal),
                            new KSParameter("kod", kod, DbType.Int32),
                            new KSParameter("stred", stred, DbType.String),
                            new KSParameter("id_vazby", id_vazby, DbType.Int32),
                            new KSParameter("hodiny", hodiny,DbType.Decimal),
                            new KSParameter("os_cislo", Globals.OsCisloPomer.OsCislo),
                            new KSParameter("cislo_pom", Globals.OsCisloPomer.CisloPom),
                            new KSParameter("datum", Obdobi)
                        };

                        SqlPrikaz.ExecuteNonQuery(sql, ref par);

                    }
                    else if ((old_kod != null) && ((kod == null) || (hodiny == null)))//mažu záznam
                    {                       
                        _delete(old_kod, old_stred, old_id_vazby, old_hodiny);
                    }
                }
                else if (command.Type == Telerik.Web.UI.GridBatchEditingCommandType.Delete)
                {
                    Hashtable oldValues = command.OldValues;                 
                    int? old_kod = null;
                    string old_stred = null;
                    int? old_id_vazby = null;
                    decimal? old_hodiny = null;
                   
                    _collectValues(oldValues, out old_kod, out old_stred, out old_id_vazby, out old_hodiny);                  
                    _delete(old_kod, old_stred, old_id_vazby, old_hodiny);
                }
            e.Canceled = true;
            RadGrid1.Rebind();
        }

        private void _delete(int? old_kod, string old_stred, int? old_id_vazby, decimal? old_hodiny)
        {
            string sql = "delete from vyrobak " +
                                   "where os_cislo=@os_cislo " +
                                    " and cislo_pom=@cislo_pom " +
                                    " and str=@str_old " +
                                    " and kod=@kod_old " +
                                    " and typ_vazby='cp' " +
                                    " and id_vazby=@id_vazby_old " +
                                    " and hodiny=@hodiny_old " +
                                    " and datum=@datum ";

            ParametryPrikazu par = new ParametryPrikazu
                        {
                            new KSParameter("os_cislo", Globals.OsCisloPomer.OsCislo),
                            new KSParameter("cislo_pom", Globals.OsCisloPomer.CisloPom),
                            new KSParameter("str_old", old_stred, DbType.String),
                            new KSParameter("kod_old", old_kod, DbType.Int32),
                            new KSParameter("id_vazby_old", old_id_vazby, DbType.Int32),
                            new KSParameter("hodiny_old", old_hodiny, DbType.Decimal),
                            new KSParameter("datum", Obdobi)
                        };

            SqlPrikaz.ExecuteNonQuery(sql, ref par);
        }

        private static void _collectValues(Hashtable hash_val, out int? kod,out string stred, out int? id_vazby, out decimal? hodiny)
        {
            kod = null;
            stred = null;
            id_vazby = null;
            hodiny = null;

            if (hash_val["kod"] != DBNull.Value)
                kod = Convert.ToInt32(hash_val["kod"]);
            if (hash_val["str"] != DBNull.Value)
                stred = hash_val["str"].ToString();
            if (hash_val["id_vazby"] != DBNull.Value)
                id_vazby = Convert.ToInt32(hash_val["id_vazby"].ToString());
            if (hash_val["hodiny"] != DBNull.Value)
                hodiny = Convert.ToDecimal(hash_val["hodiny"].ToString());
        }

        private static string _onlyNumbers(string pom)
        {
            List<char> list = new List<char>();
            char[] chars=pom.ToCharArray();
            foreach(char ch in chars)
            {
                //if ((ch == '-')||(ch == ' ')) break;
                if ((ch == '-') || (ch == ' ') ||(ch=='.')) break;
                list.Add(ch);
            }

            string res=string.Join("",list);
            return res;
        }

        protected void rg_k_rozkontaci_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DateTime obdobi=(DateTime)RadGrid1.Datum.SelectedObdobi;
            KSProgram.ZakSpec.Rozkont r = new KSProgram.ZakSpec.Rozkont();
            bool lb_podle_dochazky = false;
            DataTable table=r.K_rozkontu(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom,obdobi.PrvniDen(), ref lb_podle_dochazky);
            rg_k_rozkontaci.DataSource = table;
            string ls_pom = WebControlHelper.ZmenaTextu("[%Hodiny k rozkontaci dle položek%]")+" - " + (lb_podle_dochazky ? WebControlHelper.ZmenaTextu("[%docházka%]") : WebControlHelper.ZmenaTextu("[%mzdy%]"));
            rg_k_rozkontaci.MasterTableView.Caption = ls_pom;
        }

        protected void rg_chyby_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DateTime obdobi = (DateTime)RadGrid1.Datum.SelectedObdobi;
            KSProgram.ZakSpec.Rozkont r = new KSProgram.ZakSpec.Rozkont();
            DataTable table = r.Chyby(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obdobi.PrvniDen());
            rg_chyby.DataSource = table;          
        }

        protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            Obdobi = (DateTime)RadGrid1.Datum.SelectedObdobi;
            Obdobi = Obdobi.PrvniDen();
            bool edit = (Obdobi >= Globals.AktObdobi);
            KSProgram.ZakSpec.Rozkont r = new KSProgram.ZakSpec.Rozkont();
           
            DataTable table = r.Rozkontovano(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, Obdobi);
            int pocet = (edit ? 5 : 1);          
            for (int i = 0; i < pocet; i++)
                table.Rows.Add();               
                           
            RadGrid1.DataSource = table;
            RadGrid1.MasterTableView.Columns[0].Visible = edit;

            string povinny_projekt = $"povinny_projekt={Rozkont.PovinnyProjektProZam(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom).ToString().ToLower()};";

            ScriptManager.RegisterStartupScript(this.Page, typeof(DchUkoly), "form_editable", "frmEdit=" + (edit == true ? "true" : "false") + $";zam_id_podniku={ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloPomer.OsCislo)};"+povinny_projekt, true);
            rg_k_rozkontaci.Rebind();
            rg_chyby.Rebind();
        }

        [System.Web.Services.WebMethod(EnableSession = true)]
        public static RadComboBoxData GetKody(RadComboBoxContext context)
        {
            string obd=Convert.ToString(context["obdobi"]);
            DateTime obdobi = new DateTime(Convert.ToInt32(obd.Substring(0, 4)), Convert.ToInt32(obd.Substring(4, 2)), 1);

            RadComboBoxData comboData = null;
            List<RadComboBoxItemData> result = null;
            try
            {
                result = new List<RadComboBoxItemData>(context.NumberOfItems);
                comboData = new RadComboBoxData();

                KSProgram.ZakSpec.Rozkont r = new KSProgram.ZakSpec.Rozkont();
                DataTable data = r.KodyProRozkont(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obdobi.PrvniDen());               

                int itemsPerRequest = 15;

                int itemOffset = context.NumberOfItems;
                int endOffset = itemOffset + itemsPerRequest;
                if (endOffset > data.Rows.Count)
                {
                    endOffset = data.Rows.Count;
                }
                if (endOffset == data.Rows.Count)
                {
                    comboData.EndOfItems = true;
                }
                else
                {
                    comboData.EndOfItems = false;
                }
                result = new List<RadComboBoxItemData>(endOffset - itemOffset);
                for (int i = itemOffset; i < endOffset; i++)
                {
                    RadComboBoxItemData itemData = new RadComboBoxItemData();
                    itemData.Attributes["nazev"] = data.Rows[i]["nazev"].ToString();
                    itemData.Value = data.Rows[i]["kod"].ToString();
                    itemData.Text = data.Rows[i]["cely_nazev"].ToString();
                    result.Add(itemData);
                }

                if (data.Rows.Count > 0)
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Položky%] <b>1</b>-<b>{0}</b> [%z%] <b>{1}</b>", endOffset, data.Rows.Count);
                }
                else
                {
                    comboData.Message = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Žádné shody%]");
                }
            }
            catch (Exception e)
            {
                comboData.Message = e.Message;
                if (e.InnerException != null)
                    if (!string.IsNullOrEmpty(e.InnerException.Message))
                        comboData.Message += e.InnerException.Message;
            }
            comboData.Items = result.ToArray();
            return comboData;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static ResultData NazevKodu(string data)
        {
            ResultData res = new ResultData();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            string kod = (string)jsonObject[0]["kod"];
            short li_kod;
            string nazev = string.Empty;
            if (short.TryParse(kod, out li_kod))
                //nazev = CisDchKody.GetNazev(li_kod);
                nazev = CisMzdPol.Nazev(li_kod);

            res.Count = 1;
            res.Data = new List<object>();
            res.Data.Add(nazev);

            return res;
        }

        protected string _mzdKodNazev(object val)
        {
            if ((val == null) || (val == DBNull.Value)) return string.Empty;

            return KSProgram.Ciselniky.CisMzdPol.CisloNazev(Convert.ToInt16(val));
        }

        protected string _strKodNazev(object val)
        {
            if ((val == null) || (val == DBNull.Value)) return string.Empty;

            return KSProgram.Ciselniky.CisStredisko.CelyNazev(Convert.ToString(val).Trim());
        }

        protected string _projKodNazev(object val)
        {
            if ((val == null) || (val == DBNull.Value)) return string.Empty;

            return KSProgram.Ciselniky.CisProjekty.CelyNazev(Convert.ToInt32(val));
        }

        [WebMethod]
        public static string Testuj(string co, DateTime datum, string hodnota1, string hodnota2, decimal? hodnota3)
        {
            bool ret = false;
            if (co == "projekt")
            {
                //if (string.IsNullOrEmpty(hodnota1)) return "ok";
                //PH 15.11.2022 HID:3892
                if (Rozkont.PovinnyProjektProZam(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom))
                {
                    if (string.IsNullOrEmpty(hodnota1)) return "chyba";
                }
                else
                {
                    if (string.IsNullOrEmpty(hodnota1)) return "ok";
                }
                hodnota1 = _onlyNumbers(hodnota1);
                ret = CisProjekty.Exists(hodnota1);                
            }
            else if (co == "stred")
            {
                if (string.IsNullOrEmpty(hodnota1)) return "ok";               
                hodnota1 = _onlyNumbers(hodnota1);
                ret = CisStredisko.Exists(hodnota1);
            }
            else if (co == "kod")
            {
                hodnota1 = _onlyNumbers(hodnota1);         
                int pok;
                if (!Int32.TryParse(hodnota1, out pok))
                    ret = false;
                else
                    ret = CisMzdPol.Exists(Convert.ToInt32(hodnota1));
            }
            return (ret == true ? "ok" : "chyba");           
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static ResultData Testuj(string data)
        {
            decimal? hodnota3 = null;
            ResultData res = new ResultData();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            DateTime datum = Globals.Db.GetDateTime(jsonObject[0]["datum"]);
            string hodnota1 = (string)jsonObject[1]["hodnota1"];
            string hodnota2 = (string)jsonObject[2]["hodnota2"];
           
            string co = (string)jsonObject[4]["co"];          
            res.Count = 1;
            res.Data = new List<object>();
            res.Data.Add(Testuj(co, datum, hodnota1, hodnota2, hodnota3));

            return res;
        } 
    }
    enum PovinnyProjekt
    {
        Ano,
        Ne,
        AnoProDohodyNe
    }
}