﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Data;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram;
using KSProgram.WebControls;
using System.Collections;

namespace KSPortal.ZakSpec
{
    /// <summary>
    /// 
    /// </summary>
    public partial class SchvalovatelZamestnanci:TPage
    {
        Hashtable gr_stavy = new Hashtable();
        
        const string OBJEKT = "seznam_schval";
        const string KLIC = "os_cis_pomer";

        /// <summary>
        /// 
        /// </summary>
        public SchvalovatelZamestnanci()
        {
            EnableVisibleSeznamZam = true;
            IdPrava = 218;
        }

        protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DateTime ld_zacatek=DateTime.Now.Date.AddDays(-30);
            DateTime ld_konec=ld_zacatek.AddDays(60);

            List<string> val=ObjSetting.LoadBlobValues(Globals.OsCislo, OBJEKT, KLIC);

            List<KSPortal.ZakSpec.ProjektyHodiny.StrPrMistoExists> strPM = new List<KSPortal.ZakSpec.ProjektyHodiny.StrPrMistoExists>();

            Dictionary<string, string> buff = new Dictionary<string, string>();

            DataTable table = new DataTable();
            table.Columns.Add("pom", typeof(decimal));
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("cislo_pom", typeof(int));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("prac_str", typeof(string));
            table.Columns.Add("usek", typeof(string));
            table.Columns.Add("odbor", typeof(string));
            table.Columns.Add("oddeleni", typeof(string));
            table.Columns.Add("vybrano", typeof(bool));

            string sql = "select A.os_cislo, B.cislo_pom, B.prac_str, A.jmeno, A.prijmeni, B.id_pracmist, B.pov_funkce from pracovnici A, prac_pom B " +
                        " where A.os_cislo=B.os_cislo " +
                        " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(ld_konec) +
                        " and (B.datum_ukonc>=" + SqlPrikaz.ValueToString(ld_zacatek) + " or B.datum_ukonc IS NULL)";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while(reader.Read())
                {
                    decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                    short li_cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                    string ls_prac_str = GetNullOrData.GetString(reader, 2, "").Trim();
                    string ls_jmeno= GetNullOrData.GetString(reader, 3, "").Trim();
                    string ls_prijmeni= GetNullOrData.GetString(reader, 4).Trim();
                    int li_id_pracmist= GetNullOrData.GetInt32(reader, 5, 0);
                    string cislo_pm= GetNullOrData.GetString(reader, 6, "").Trim();

                    DataRow row=table.Rows.Add();
                    row["os_cislo"]=ldc_os_cislo;
                    row["cislo_pom"]=li_cislo_pom;
                    row["prac_str"]=ls_prac_str;
                    row["jmeno"]=ls_jmeno;
                    row["prijmeni"]=ls_prijmeni;

                    string usek, odbor, oddeleni;
                    ProjektyHodiny.Get_usek_odbor_oddeleni(ref buff, ref strPM,li_id_pracmist, cislo_pm, DateTime.Now.Date, out usek, out odbor, out oddeleni);
                    row["usek"] = usek;
                    row["odbor"] = odbor;
                    row["oddeleni"] = oddeleni;

                    string pom = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();                   
                    row["vybrano"] = val.Contains(pom);
                    

                }
                reader.Close();
            }
            RadGrid1.DataSource=table;
            RadGrid1.MasterTableView.Caption = "[%Schvalovatel - zaměstnanci%]: "+ KSProgram.Funkce.Pracovnik.CeleJmeno(Globals.OsCisloPomer.OsCislo);

            buff.Clear();
        }

        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                CheckBox chk_row = (CheckBox)item["vybrano"].Controls[0];
                chk_row.Enabled = true;
                chk_row.AutoPostBack = true;
                chk_row.CheckedChanged += new EventHandler(chk_row_CheckedChanged);
            }
            else if (e.Item is GridGroupFooterItem)
            {/*
                GridGroupFooterItem item = (GridGroupFooterItem)e.Item;

                CheckBox chk = new CheckBox();
                chk.AutoPostBack = true;
                //item.Cells[item.Cells.Count - 1].Controls.Add(chk);
                item.Cells[item.Cells.Count - 2].Controls.Add(chk);
                chk.CheckedChanged += new EventHandler(chk_CheckedChanged);

                if (ViewState["check_"+item.GroupIndex] != null)
                {
                    string val = ViewState["check_" + item.GroupIndex].ToString();
                    if (val.ToLower() == "true")
                        chk.Checked = true;
                }
              * */
                GridGroupFooterItem item = (GridGroupFooterItem)e.Item;

                RadButton butt1 = new RadButton();
                butt1.CommandName = "zakazat";
                butt1.Text = "Zakázat";
                item.Cells[item.Cells.Count - 2].Controls.Add(butt1);
                butt1.Command += new CommandEventHandler(butt_Command);

                RadButton butt2 = new RadButton();
                butt2.CommandName = "povolit";
                butt2.Text = "Povolit";
                item.Cells[item.Cells.Count - 2].Controls.Add(butt2);
                butt2.Command += new CommandEventHandler(butt_Command);                
            }
        }

        void chk_row_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox box = ((CheckBox)sender);
            GridDataItem item = box.NamingContainer as GridDataItem;
            decimal ldc_os_cislo = Convert.ToDecimal(item["os_cislo"].Text);
            short li_cislo_pom = Convert.ToInt16(item["cislo_pom"].Text);
            string value = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();          
            if (box.Checked)
                ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
            else
                ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);

        }
        /*
        void chk_CheckedChanged2(object sender, EventArgs e)
        {
            string group_index = "";

            CheckBox box = ((CheckBox)sender);

            GridGroupFooterItem item = (GridGroupFooterItem)box.NamingContainer;

            var odborNumberCell = item["odbor"];

            string pop = odborNumberCell.Text;
            string[] ar_sl=pop.Split(':');
            if (ar_sl.Length==2)
            {
                string dat_sl="";
                string popisek=ar_sl[0].Trim();
                string hodnota=ar_sl[1].Trim();

                for(int i=0;i< RadGrid1.MasterTableView.Columns.Count;i++)
                {                  
                    if (RadGrid1.MasterTableView.Columns[i].HeaderText==popisek)
                    {
                        dat_sl = ((GridBoundColumn)RadGrid1.MasterTableView.Columns[i]).DataField;
                        break;
                    }
                }

                for (int i=0;i<RadGrid1.Items.Count;i++)
                {
                    if (RadGrid1.Items[i] is GridDataItem)
                    {
                        string v2 = RadGrid1.Items[i][dat_sl].Text;
                        v2 = v2.Trim();
                        if (v2 == "&nbsp;") v2 = "";
                        if (v2 == hodnota)
                        {
                            decimal ldc_os_cislo = Convert.ToDecimal(RadGrid1.Items[i]["os_cislo"].Text);
                            short li_cislo_pom = Convert.ToInt16(RadGrid1.Items[i]["cislo_pom"].Text);
                            string value = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();
                            if (box.Checked)
                                ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
                            else
                                ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
                        }
                    }
                }
            }

            
            group_index = item.GroupIndex;

            group_index = group_index.Split('_').First();
            ViewState["check_" + group_index] = box.Checked;
            RadGrid1.Rebind();
            return;

            foreach (GridGroupHeaderItem ghi in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
            {
                if (ghi.DataCell.Text == odborNumberCell.Text)
                {
                    //GridItem[] children = ghi.GetChildItems();
                    //foreach (GridDataItem child in children)
                    GridItem[] children = ghi.GetChildItems();
                    foreach (GridItem ch in children)
                    {
                        GridDataItem child = ch as GridDataItem;
                        if (child != null)
                        {
                            GridDataItem childItem = child as GridDataItem;
                            decimal ldc_os_cislo = Convert.ToDecimal(childItem["os_cislo"].Text);
                            short li_cislo_pom = Convert.ToInt16(childItem["cislo_pom"].Text);
                            string value = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();
                            if (box.Checked)
                                ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
                            else
                                ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);


                        }
                    }
                }
            }
            RadGrid1.Rebind();
 
        }

       
        
        void chk_CheckedChanged(object sender, EventArgs e)
        {
            chk_CheckedChanged2(sender, e);
            return;

            string group_index = "";

            CheckBox box = ((CheckBox)sender);            

            GridGroupFooterItem item = (GridGroupFooterItem)box.NamingContainer;

            //var odborNumberCell = (e.Item as GridGroupFooterItem)["odbor"];
            var odborNumberCell = item["odbor"];


            group_index = item.GroupIndex;
            
            group_index = group_index.Split('_').First();
            ViewState["check_"+group_index] = box.Checked;

            foreach (GridGroupHeaderItem ghi in RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader))
            {
                if (ghi.GroupIndex == group_index)
                {
                    //GridItem[] children = ghi.GetChildItems();
                    //foreach (GridDataItem child in children)
                    GridItem[] children = ghi.GetChildItems();
                    foreach (GridItem ch in children)
                    {
                        GridDataItem child = ch as GridDataItem;
                        if (child != null)
                        {
                            GridDataItem childItem = child as GridDataItem;
                            decimal ldc_os_cislo = Convert.ToDecimal(childItem["os_cislo"].Text);
                            short li_cislo_pom = Convert.ToInt16(childItem["cislo_pom"].Text);
                            string value = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();
                            if (box.Checked)
                                ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
                            else
                                ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);

                           
                        }
                    }
                }
            }
            RadGrid1.Rebind();
        }
        */
        string group_index = "";
        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            
            if (e.Item is GridGroupHeaderItem)
            {
                if (group_index == "-1")
                    group_index = ((GridGroupHeaderItem)e.Item).GroupIndex;
                else
                    group_index += "," + ((GridGroupHeaderItem)e.Item).GroupIndex;

               
            }
                /*
            else if (e.Item is GridDataItem)
            {
                GridDataItem it = e.Item as GridDataItem;
                TableCell cell = new TableCell();
                Label lab=new Label();
                lab.ID="label_GrouIndex";
                lab.Text=group_index;
                cell.Controls.Add(lab);
                it.Controls.Add(cell);
            }
                 * */
            else if (e.Item is GridGroupFooterItem)
            {
                //get the footer cell:
                var odborNumberCell = (e.Item as GridGroupFooterItem)["odbor"];
                if (odborNumberCell == null) return;
                //find the group header for the current group:
                var headerItem = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader)
                    .Where(i => i.GroupIndex == e.Item.GroupIndex).First() as GridGroupHeaderItem;

                headerItem.DataCell.Font.Bold = true;

                string groupHeaderText = headerItem.DataCell.Text;
                //get just the left part - only group level but not the actual value:                   
                //string groupLevel = groupHeaderText.Substring(0, groupHeaderText.IndexOf(':'));
                //add group level to the text in the footer:
                odborNumberCell.Text = groupHeaderText;
                odborNumberCell.ColumnSpan = 2;
                odborNumberCell.Font.Bold = true;

                var os_cisloNumberCell = (e.Item as GridGroupFooterItem)["pom"];
                os_cisloNumberCell.Text =  group_index;
                if (group_index.Contains(","))
                {
                    //group_index = group_index.Split(",").First();
                    int ix = group_index.LastIndexOf(",");
                    group_index = group_index.Substring(0, ix);
                }
                else
                    group_index = "-1";

            }
        }

        private void _zpracGroup(GridItem item, string CommandName)
        {
            GridItem[] child = null;
            if (item is GridGroupHeaderItem)
            {
                child = ((GridGroupHeaderItem)item).GetChildItems();

                for (int i = 0; i < child.Length; i++)
                {                    
                     _zpracGroup((GridItem)child[i], CommandName);                 
                }
            }
            else if (item is GridDataItem)
            {
                decimal ldc_os_cislo = Convert.ToDecimal(((GridDataItem)item)["os_cislo"].Text);
                short li_cislo_pom = Convert.ToInt16(((GridDataItem)item)["cislo_pom"].Text);
                string value = ldc_os_cislo.ToString() + "_" + li_cislo_pom.ToString();
                if (CommandName == "povolit")
                    ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
                else
                    ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC, value);
            }
        }
        
        void butt_Command(object sender, CommandEventArgs e)
        {            
            RadButton box = ((RadButton)sender);

            GridGroupFooterItem item = (GridGroupFooterItem)box.NamingContainer;
            var os_cisloNumberCell = (item as GridGroupFooterItem)["pom"];
            string text = os_cisloNumberCell.Text;

            string gr_index = text.Split('>').Last();

            string gr_i = gr_index.Split(new char[]{','}, StringSplitOptions.RemoveEmptyEntries).Last();
           
            var headerItem = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader)
                .Where(i => i.GroupIndex == gr_i).First() as GridGroupHeaderItem;


            GridItem[] items = headerItem.GetChildItems();
            for (int i = 0; i < items.Length;i++ )
                _zpracGroup(items[i], e.CommandName);

            _saveGroupState();
            RadGrid1.Rebind();
            _loadGroupState();
            return;
          
        }

        //uloží stavy group
        private void _saveGroupState()
        {
           GridItem[] gr_groups= RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
           foreach (GridGroupHeaderItem gr in gr_groups)
               gr_stavy.Add(gr.GroupIndex, gr.Expanded);             
        }

        private void _loadGroupState()
        {
            GridItem[] gr_groups= RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
            foreach (GridGroupHeaderItem gr in gr_groups)
            {
                if (gr_stavy.ContainsKey(gr.GroupIndex))
                    gr.Expanded = Convert.ToBoolean(gr_stavy[gr.GroupIndex]);               
            }

            /*
            gr_groups = RadGrid1.MasterTableView.GetItems(GridItemType.GroupFooter);
            foreach (GridGroupFooterItem gr in gr_groups)
            {
                if (gr_stavy.ContainsKey(gr.GroupIndex))
                {
                    gr.Expanded = Convert.ToBoolean(gr_stavy[gr.GroupIndex]);
                    gr.Visible = gr.Expanded;
                }
            }
             */
            
        }

        protected void button_rozbalit_Command(object sender, CommandEventArgs e)
        {
            RadGrid1.MasterTableView.GroupsDefaultExpanded = true;
            RadGrid1.Rebind();
        }

        protected void button_sbalit_Command(object sender, CommandEventArgs e)
        {
            RadGrid1.MasterTableView.GroupsDefaultExpanded = false;
            RadGrid1.Rebind();
        }

        protected void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
        {
            //save the expanded/selected state in the session
            //if (e.CommandName == RadGrid.ExpandCollapseCommandName)
            //{
               // GridGroupFooterItem item = RadGrid1.MasterTableView.GetItems(GridItemType.GroupFooter).Where(i => i.GroupIndex == e.Item.GroupIndex).FirstOrDefault() as GridGroupFooterItem;
                //if (item != null)
                //    item.Visible = e.Item.Expanded;
            //}           
        }
    }
}