﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Data;
using KSProgram;
using KSProgram.WebControls;

namespace KSPortal.ZakSpec.UkolyOdmeny
{
    public partial class SestavaNavrhOdmen : TPage
    {
        decimal _SumOdmeny = 0;
        int _sum_radky, _sum_cil = 0;
        DateTime? _schvaleno = new DateTime(1900, 1, 1);
        //List<Int32> _ke_schvaleni = new List<int>();

        bool navrh = false;

        public DateTime? Schvaleno
        {
            get
            {
                return _schvaleno;
            }
            set
            {
                if (_schvaleno != null)
                {
                    if (value == null)
                    {
                        _schvaleno = value;
                    }
                    else
                    {
                        if (value.Value > _schvaleno)
                        {
                            _schvaleno = value;
                        }
                    }
                }
            }
        }
        public List<Int32> Ke_schvaleni
        {
            get
            {
                return ViewState["_ke_schvaleni"] == null ? new List<int>() : (List<int>)ViewState["_ke_schvaleni"];
            }
            set
            {
                ViewState["_ke_schvaleni"] = value;
            }
        }

        private bool cilova => _sum_radky > 0 && _sum_cil > 0;

        private bool mimoradna => _sum_radky > 0 && _sum_cil != _sum_radky;

        public SestavaNavrhOdmen()
        {
            IdPrava = 191;
            EnableVisibleSeznamZam = true;
        }

        protected override void TPage_OsCisloChanged(object sender, OsCisloChangedEventArgs e)
        {
            base.TPage_OsCisloChanged(sender, e);
            //VyberovePrvky_Visible(); // MZ 30.7.2014 Zapoznámkováno
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            navrh = false;

            if (!IsPostBack)
            {
                // MZ 30.7.2014 Zapoznámkováno. Přesunuto do fce 'NastaveniFormulare()'
                //string sql = "SELECT c.skup_nazev FROM prac_pom p, stred s, skup_stred c " +
                //    "WHERE s.str = p.prac_str AND c.skup_str = s.skup_str AND p.os_cislo = " + SqlPrikaz.ValueToString(Globals.OsCisloPomer.OsCislo) + " AND p.cislo_pom = " + SqlPrikaz.ValueToString(Globals.OsCisloPomer.CisloPom);
                //L_odbor.Text = SqlPrikaz.ExecuteScalarString(sql, "", true);

                //KSProgram.ZakSpec.UkolyOdmeny2 uo = new KSProgram.ZakSpec.UkolyOdmeny2();
                //KSProgram.ZakSpec.UkolyOdmeny2.OsobaInfo osoba = uo.GetOsobaInfo();
                //P_Vyber.Visible = (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.Administrator);

                TRDP_datum.SelectedDate = DateTime.Now.Date;
                ODS_Prostredky.SelectParameters["aRok"].DefaultValue = Globals.AktObdobi.Year.ToString();
                //TRCB_Prostredky.DataBind();

                TIB_logo.ImageUrl = Zakaznik.GetLogoUrl(true);

                //VyberovePrvky_Visible(); // MZ 30.7.2014 Zapoznámkováno
                //NastaveniFormulare(); // MZ 30.7.2014 Zapoznámkováno
            }

            //VyberovePrvky_Visible();
            //L_Nadpis1.Text = "[%NÁVRH NA POSKYTNUTÍ ODMĚNY A CÍLOVÉ ODMĚNY%]";
            //L_Nadpis2.Text = "[%v souladu s § 134 a § 134a zákona č. 262/2006 Sb., zákoník práce, v platném znění%]";
            //L_Nadpis3.Text = "[%V souladu s § 134 a § 134a zákona č. 262/2006 Sb., zákoník práce, v platném znění, navrhuji poskytnutí mimořádné a cílové odměny%]";
        }

        protected void DL_sum_DataBinding(object sender, EventArgs e)
        {
            //NastaveniFormulare();
            //Nastaveni(); // MZ 30.7.2014 Doplněno
            _SumOdmeny = 0;
            _sum_radky = 0;
            _sum_cil = 0;
            _schvaleno = new DateTime(1900, 1, 1);

            List<Int32> _ke_schvaleni = Ke_schvaleni;
            _ke_schvaleni.Clear();
            Ke_schvaleni = _ke_schvaleni;
        }

        protected void DL_sum_ItemDataBound(object sender, DataListItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                string os_cislo = ((System.Data.DataRowView)e.Item.DataItem).Row["os_cislo"].ToString();
                ObjectDataSource ODS = (ObjectDataSource)e.Item.FindControl("ODS_odm");
                ODS.SelectParameters["os_cislo"].DefaultValue = os_cislo;

                string prostredky = TRCB_Prostredky.SelectedValue;
                ODS.SelectParameters["prostredky"].DefaultValue = prostredky; // MZ 16.5.2014

                TGridView TGVB = (TGridView)e.Item.FindControl("TGV_odm");
                TGVB.DataSourceID = "ODS_odm";
                Label L_SeznamUkolu = (Label)e.Item.FindControl("L_Nadpis_SeznamUkolu");

                // MZ 17.7.2014 Změna zdůvodnění návrhu, pokud se jedná o důchod nebo jubileum.
                // ---------------------------------------------------------------------------
                string varianta = TRCB_Varianty.SelectedValue;
                ODS.SelectParameters["varianta"].DefaultValue = varianta; // MZ 1.8.2014 Doplněno
                if (P_Vyber.Visible && varianta == "jubileum_50")
                {
                    BindTable bt = (BindTable)e.Item.FindControl("BindTable1");
                    if (bt.Rows.Count == 3)
                    {
                        (bt.Rows[2]).DataValue = "U příležitosti dovršení 50 let věku";
                    }
                    L_SeznamUkolu.Text = "<br />"; //PR 18.12.2019 náhrada </br> za <br />
                }
                else if (P_Vyber.Visible && varianta == "odchod_duchod")
                {
                    BindTable bt = (BindTable)e.Item.FindControl("BindTable1");
                    if (bt.Rows.Count == 3)
                    {
                        (bt.Rows[2]).DataValue = "U příležitosti prvního skončení pracovního poměru po přiznání invalidního důchodu nebo po nabytí nároku na starobní důchod";
                    }
                    L_SeznamUkolu.Text = "<br />"; //PR 18.12.2019 náhrada </br> za <br />
                }

                _SumOdmeny += Convert.ToDecimal(((System.Data.DataRowView)e.Item.DataItem).Row["sum_odm"].ToString());
                _sum_cil += (int)((System.Data.DataRowView)e.Item.DataItem).Row["sum_cil"];
                _sum_radky += (int)((System.Data.DataRowView)e.Item.DataItem).Row["radky"];
            }

            if (e.Item.ItemType == ListItemType.Footer)
            {
                Label L_Sum = (Label)e.Item.FindControl("L_SumOdmeny");
                //L_Sum.Text = (Convert.ToDecimal(L_Sum.Text) + Convert.ToDecimal(castka)).ToString();
                L_Sum.Text = _SumOdmeny.ToString("#,##0");
                Nastaveni();
            }
        }

        protected void TLinkButton1_Click(object sender, EventArgs e)
        {
            DL_sum.DataBind();
        }
        private void Nastaveni()
        {
            VyberovePrvky_Visible();
            NastaveniFormulare();
        }
        private void VyberovePrvky_Visible()
        {
            KSProgram.ZakSpec.UkolyOdmeny2 uo = new KSProgram.ZakSpec.UkolyOdmeny2();
            KSProgram.ZakSpec.UkolyOdmeny2.OsobaInfo osoba = uo.GetOsobaInfo();

            //P_Vyber.Visible = (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.Administrator) ||
            //                  (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.VedouciOdboru);
            P_Vyber.Visible = (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.Administrator); // MZ 31.7.2014 Výběrové prvky uvidí pouze admin.

            // MZ 31.7.2014 Vše zapoznámkováno. Výběrové prvky uvidí pouze admin.
            //if (!P_Vyber.Visible) { return; }

            //bool lb_Odb = false;
            //if (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.VedouciOdboru)
            //{
            //    lb_Odb = true;
            //    if (TRCB_Varianty.Items.Count > 2)
            //    {
            //        TRCB_Varianty.Items.Remove(2); // Vedoucí odboru nemá vidět variantu 'Jubileum 50 let'
            //    }
            //}

            //if (osoba.TypOsoby == KSProgram.ZakSpec.UkolyOdmeny2.TypyOsob.Administrator)
            //{
            //    if (TRCB_Varianty.Items.Count == 2)
            //    {
            //        Telerik.Web.UI.RadComboBoxItem RCBI_varianta = new Telerik.Web.UI.RadComboBoxItem("Jubileum 50 let", "jubileum_50");
            //        TRCB_Varianty.Items.Add(RCBI_varianta);
            //    }
            //}

            //L_Prostredky.Visible = !lb_Odb;
            //TRCB_Prostredky.Visible = !lb_Odb;
            //L_Odbory.Visible = !lb_Odb;
            //TRCB_Odbory.Visible = !lb_Odb;
        }
        private void NastaveniFormulare()
        {
            // MZ 25.6.2014 Doplněna změna odboru na formuláři podle vybraného odboru, pokud je k dispozici výběr.
            if (TRCB_Odbory.Visible)
            {
                string odbor = TRCB_Odbory.SelectedValue;
                if (!string.IsNullOrEmpty(odbor))
                {
                    KSProgram.Ciselniky.CisSkupStred cisSkupStred = new KSProgram.Ciselniky.CisSkupStred();
                    L_odbor.Text = cisSkupStred.Nazev(odbor);
                }
            }
            // MZ 30.7.2014 Doplněno. Doplnění názvu odboru podle vedoucího.
            else
            {
                string sql = "SELECT c.skup_nazev FROM prac_pom p, stred s, skup_stred c " +
                    "WHERE s.str = p.prac_str AND c.skup_str = s.skup_str AND p.os_cislo = " + SqlPrikaz.ValueToString(Globals.OsCisloPomer.OsCislo) + " AND p.cislo_pom = " + SqlPrikaz.ValueToString(Globals.OsCisloPomer.CisloPom);
                L_odbor.Text = SqlPrikaz.ExecuteScalarString(sql, "", true);
            }

            string varianta = TRCB_Varianty.SelectedValue;

            if (!P_Vyber.Visible) // MZ 31.7.2014 Pokud není administrátor (nejsou povoleny výběrové prvky), zobrazují se pouze odměny.
            {
                varianta = "odmeny";
            } 

            if (!navrh)
            {
                L_stanovisko_c.Visible = false;
                L_stanovisko.Visible = false;
                P_prvni_podpis.Visible = false;
                L_druhy_podpis.Text = "[%Ředitel úřadu%]";
            }
            else
            {
                L_stanovisko_c.Visible = true;
                L_stanovisko.Visible = true;
                P_prvni_podpis.Visible = true;
                L_druhy_podpis.Text = "[%Vedoucí odboru%]";
            }

            if (varianta == "odmeny")
            {
                string nadpis = navrh ? "NÁVRH NA POSKYTNUTÍ " : "PŘIZNÁNÍ ";
                string odmeny =
                    mimoradna && cilova
                    ? "MIMOŘÁDNÉ A CÍLOVÉ ODMĚNY"
                    : (mimoradna
                        ? "MIMOŘÁDNÉ ODMĚNY"
                        : (cilova
                            ? "CÍLOVÉ ODMĚNY"
                            : "ODMĚNY"));
                string odmenu =
                    mimoradna && cilova
                    ? "MIMOŘÁDNOU A CÍLOVOU ODMĚNU"
                    : (mimoradna
                        ? "MIMOŘÁDNOU ODMĚNU"
                        : (cilova
                            ? "CÍLOVOU ODMĚNU"
                            : "ODMĚNU"));
                L_Nadpis1.Text = nadpis + odmeny;
                L_Nadpis2.Text = "v souladu s § 134 a § 134a zákona č. 262/2006 Sb., zákoník práce, v platném znění";
                L_Nadpis3.Text = "V souladu s § 134 a § 134a zákona č. 262/2006 Sb., zákoník práce, v platném znění, "
                    + (navrh
                        ? "navrhuji poskytnutí " + odmeny.ToLower()
                        : "přiznávám " + odmenu.ToLower());
                DL_sum.ShowFooter = true;
            }
            else if (varianta == "jubileum_50")
            {
                L_Nadpis1.Text = "PŘIZNÁNÍ ODMĚNY";
                L_Nadpis2.Text = "v souladu s § 224 odst. 2 písm. a) zákona č. 262/2006 Sb., zákoník práce, v platném znění";
                L_Nadpis3.Text = "v souladu s § 224 odst. 2 písm. a) zákona č. 262/2006 Sb., zákoník práce, v platném znění, přiznávám odměnu";
                //DL_sum.ShowFooter = false;
            }
            else if (varianta == "odchod_duchod")
            {
                L_Nadpis1.Text = "PŘIZNÁNÍ ODMĚNY";
                L_Nadpis2.Text = "v souladu s § 224 odst. 2 písm. a) zákona č. 262/2006 Sb., zákoník práce, v platném znění";
                L_Nadpis3.Text = "V souladu s § 224 odst. 2 písm. a) zákona č. 262/2006 Sb., zákoník práce, v platném znění, přiznávám odměnu";
                //DL_sum.ShowFooter = false;
            }
        }

        protected void TRB_schvalit_Click(object sender, EventArgs e)
        {
            Int32 ret = KSProgram.ZakSpec.UkolyOdmeny.SchvaleniOdmeny(Ke_schvaleni);
            if (ret > 0)
            {
                MessageBox.Alert(Page, "Počet schválených záznamů: " + ret, "Schválení odměn");
            }
            DL_sum.DataBind();
        }

        protected void TGV_odm_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                object o_schvaleno = DataBinder.Eval(e.Row.DataItem, "schvaleno");
                DateTime? schvaleno = (DateTime?)(o_schvaleno == DBNull.Value ? null : o_schvaleno);
                Schvaleno = schvaleno;
                if (schvaleno == null)
                {
                    object o_id = DataBinder.Eval(e.Row.DataItem, "id");
                    Int32? id = (Int32?)(o_id == DBNull.Value ? null : o_id);
                    if (id != null)
                    {
                        if (!Ke_schvaleni.Contains((Int32)id))
                        {
                            List<Int32> _ke_schvaleni = Ke_schvaleni;
                            _ke_schvaleni.Add((Int32)id);
                            Ke_schvaleni = _ke_schvaleni;
                        }
                    }
                }
                string varianta = TRCB_Varianty.SelectedValue;
                if (!P_Vyber.Visible) // MZ 31.7.2014 Pokud není administrátor (nejsou povoleny výběrové prvky), zobrazují se pouze odměny.
                {
                    varianta = "odmeny";
                }
                string prostredky = "";
                if (P_Vyber.Visible) // MZ 31.7.2014 Pokud není administrátor (nejsou povoleny výběrové prvky), zobrazují se pouze odměny.
                {
                    prostredky = TRCB_Prostredky.SelectedValue;
                }
                if (string.IsNullOrEmpty(prostredky))
                {
                    prostredky = DataBinder.Eval(e.Row.DataItem, "prostredky").ToString();
                }

                // pokud alespo+n jeden úukol pochází z 003 a není jubileum ani důchod, jedná se o návrh 
                navrh = navrh | (prostredky.Length > 0 ? (prostredky.Substring(4) == "003" && varianta != "jubileum_50" && varianta != "odchod_duchod") : false);

                NastaveniFormulare();
            }
        }
        protected override void OnPreRenderComplete(EventArgs e)
        {
            base.OnPreRenderComplete(e);
            if (Schvaleno == null || Schvaleno == new DateTime(1900, 1, 1))
            {
                TRB_schvalit.CssClass = "";
                //TRB_schvalit.Attributes.Add("display", "block");
                L_schvaleno.Visible = false;
            }
            else
            {
                TRB_schvalit.CssClass = "hidden";
                //TRB_schvalit.Attributes.Add("display", "none");
                L_schvaleno.Visible = true;
                L_schvaleno.Text = "Schváleno dne: " + Schvaleno.Value.ToShortDateString();
            }

            // MZ 1.8.2014 Potlačení viditelnosti seznamu úkolů, pokud se jedná o důchod nebo jubileum
            string varianta = TRCB_Varianty.SelectedValue;
            if (P_Vyber.Visible && (varianta == "odchod_duchod" || varianta == "jubileum_50"))
            {
                foreach (DataListItem item in DL_sum.Items)
                {
                    TGridView TGVOdm = (TGridView)item.FindControl("TGV_odm");
                    TGVOdm.Visible = false;
                }
            }
        }
    }
}