﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using System.Collections.Specialized;
using KSProgram;

namespace KSPortal.ZakSpec.UkolyOdmeny
{
    public partial class UkolyProZamestnance : TPage
    {
        public UkolyProZamestnance()
        {
            IdPrava = 190;
            EnableVisibleSeznamZam = true;
        }

        //protected void Page_Load(object sender, EventArgs e)
        //{

        //}

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = null;
            if (!String.IsNullOrEmpty(TRCB_Zamestnanci.SelectedValue))
            {
                RadComboBoxItem item = TRCB_Zamestnanci.SelectedItem;
                decimal os_cislo = Convert.ToDecimal(item.Attributes["os_cislo"]);
                short cislo_pom = Convert.ToInt16(item.Attributes["cislo_pom"]);

                //decimal ldc_OsCislo = Convert.ToDecimal(TRCB_Zamestnanci.SelectedValue);
                table = KSProgram.ZakSpec.UkolyOdmeny2.UkolyZamestnance(os_cislo, cislo_pom);
            }
            TRadGrid1.DataSource = table;
        }

        protected void RB_prihlasen_ToggleStateChanged(object sender, Telerik.Web.UI.ButtonToggleStateChangedEventArgs e)
        {
            bool _checked = Convert.ToBoolean(e.SelectedToggleState.Value);
            if (_checked) // Přihlášení k úkolu
            {
                if (!String.IsNullOrEmpty(TRCB_Zamestnanci.SelectedValue))
                {
                    RadComboBoxItem item = TRCB_Zamestnanci.SelectedItem;
                    decimal os_cislo = Convert.ToDecimal(item.Attributes["os_cislo"]);
                    short cislo_pom = Convert.ToInt16(item.Attributes["cislo_pom"]);
                    object lo_IdUk = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("id_uk");

                    if (lo_IdUk != DBNull.Value)
                    {
                        Int32 id_ukolu = Convert.ToInt32(lo_IdUk);
                        KSProgram.ZakSpec.UkolyOdmeny.PrihlasitKUkolu(id_ukolu, os_cislo, cislo_pom);
                    }
                }
            }
            else // Odhlášení z úkolu
            {
                // MZ 5.8.2014 Doplněna kontrola zda již nebyla odměna vyplacena.
                object o_kc_vyplaceni = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("kc_vyplaceni");
                decimal kc_vyplaceni = o_kc_vyplaceni == null ? 0 : Convert.ToDecimal(o_kc_vyplaceni);
                if (kc_vyplaceni > 0)
                {
                    MessageBox.Alert(Page, "Nelze zrušit zařazení, pokud již byla vyplacena odměna!");
                }
                else
                {
                    object o_id = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("id_odm");
                    if (o_id != null)
                    {
                        Int32 id = (Int32)o_id;
                        KSProgram.ZakSpec.UkolyOdmeny.OdhlasitKUkolu(id);
                    }
                }

                //object lo_IdOdm = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("id_odm");
                //if (lo_IdOdm != DBNull.Value)
                //{
                //    Int32 id = (Int32)lo_IdOdm;
                //    KSProgram.ZakSpec.UkolyOdmeny.OdhlasitKUkolu(id);
                //}
            }
            TRadGrid1.Rebind();
        }

        protected void RNTB_kc_odm_TextChanged(object sender, EventArgs e)
        {
            object lo_IdOdm = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("id_odm");
            if (lo_IdOdm != DBNull.Value)
            {
                Int32 id_odm = (Int32)lo_IdOdm;
                RadNumericTextBox box = sender as RadNumericTextBox;
                decimal? value = (decimal?)box.DbValue;

                object dat_schvaleni = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("schvaleno");
                if (dat_schvaleni != DBNull.Value)
                {
                    MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
                }
                KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id_odm, value, null, null);
            }
            TRadGrid1.Rebind();
        }

        protected void RNTB_kc_posledni_TextChanged(object sender, EventArgs e)
        {
            object lo_IdOdm = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("id_odm");
            if (lo_IdOdm != DBNull.Value)
            {
                Int32 id_uk = Convert.ToInt32(((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("id_uk"));
                Int16 ind_castec = Convert.ToInt16(((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("ind_castec"));
                //DateTime obd_vyplaceni = Convert.ToDateTime(((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("obd_vyplaceni"));
                
                Int32 id_odm = (Int32)lo_IdOdm;
                RadNumericTextBox box = sender as RadNumericTextBox;
                
                decimal? value = (decimal?)box.DbValue;
                if (value == null || value < 1) { value = 0; } // MZ 4.8.2014 Doplněno

                DateTime? obd_vyplaceni = null;

                //if (value != null && value != 0)
                if (value > 0) // MZ 4.8.2014 Upravena podmínka
                {
                    object obj_ov = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("obd_vyplaceni");
                    obd_vyplaceni = obj_ov == DBNull.Value ? Globals.AktObdobi : Convert.ToDateTime(obj_ov);
                }

                decimal? ldc_celk = null;
                if (ind_castec == 0)
                {
                    object obj = ((GridDataItem)box.Parent.Parent).GetDataKeyValue("kc_vyplaceni");
                    decimal vyplaceni = obj == DBNull.Value ? 0 : (decimal)obj;

                    ldc_celk = vyplaceni + (decimal)value;
                    //KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, celkova, value, obd_vyplaceni);
                }

                object dat_schvaleni = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("schvaleno");
                if (dat_schvaleni != DBNull.Value)
                {
                    MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
                }

                KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id_odm, ldc_celk, value, obd_vyplaceni);
            }
            TRadGrid1.Rebind();
        }

        protected void TRadMonthYearPicker1_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            RadMonthYearPicker RMYP = sender as RadMonthYearPicker;
            Int32 id_odm = (Int32)((GridDataItem)RMYP.Parent.Parent).GetDataKeyValue("id_odm");
            object dat_schvaleni = ((GridDataItem)RMYP.Parent.Parent).GetDataKeyValue("schvaleno");
            if (dat_schvaleni != DBNull.Value)
            {
                MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
            }
            KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id_odm, null, null, RMYP.SelectedDate);
            TRadGrid1.Rebind();
        }

        protected void TRCB_Zamestnanci_DataBound(object sender, EventArgs e)
        {
            TRadGrid1.Rebind();
            if (TRadGrid1.DataSource == null)
            {
                TRadGrid1.DataSource = new DataTable();
            }
        }

        protected void TRCB_Zamestnanci_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRadGrid1.Rebind();
        }

        protected void TRCB_Zamestnanci_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            DataRowView dataSourceRow = (DataRowView)e.Item.DataItem;
            //set custom attributes from the datasource:      
            e.Item.Attributes["os_cislo"] = dataSourceRow["os_cislo"].ToString();
            e.Item.Attributes["cislo_pom"] = dataSourceRow["cislo_pom"].ToString();
        }

        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;

                RadNumericTextBox RNTB_kc_odm = item["kc_odm"].FindControl("RNTB_kc_odm") as RadNumericTextBox;
                RadNumericTextBox RNTB_kc_posledni = item["kc_odm"].FindControl("RNTB_kc_posledni") as RadNumericTextBox;
                //RadButton RB_plneni = item["kc_odm"].FindControl("RB_plneni") as RadButton;
                
                bool prihlasen = (bool)DataBinder.Eval(item.DataItem, "prihlasen");
                bool cil_odm = (bool)DataBinder.Eval(item.DataItem, "ind_cilodm");
                bool cast = (bool)DataBinder.Eval(item.DataItem, "ind_castec");
                //bool plneni = (bool)(RB_plneni.Value); //(bool)(RB_)
                decimal zbyva = (decimal)DataBinder.Eval(item.DataItem, "zbyva_vyplatit");
                decimal zbyv_k_rozdel = (decimal)DataBinder.Eval(item.DataItem, "zbyv_k_rozdel");

                //RNTB_kc_odm.Enabled = (prihlasen && cil_odm);
                RNTB_kc_odm.Enabled = (prihlasen && cast); // MZ Dle MiK, takto.

                if (cast)
                {
                    RNTB_kc_odm.MaxValue = Convert.ToDouble(zbyv_k_rozdel) + (double)(RNTB_kc_odm.Value == null ? 0 : RNTB_kc_odm.Value);
                    RNTB_kc_posledni.MaxValue = Convert.ToDouble(zbyva) + (double)(RNTB_kc_posledni.Value == null ? 0 : RNTB_kc_posledni.Value);
                }
                else
                {
                    RNTB_kc_posledni.MaxValue = Convert.ToDouble(zbyv_k_rozdel) + (double)(RNTB_kc_posledni.Value == null ? 0 : RNTB_kc_posledni.Value);
                }
            }
        }

        protected void RB_print_Click(object sender, EventArgs e)
        {
            if (!String.IsNullOrEmpty(TRCB_Zamestnanci.SelectedValue))
            {
                RadComboBoxItem item = TRCB_Zamestnanci.SelectedItem;
                decimal os_cislo = Convert.ToDecimal(item.Attributes["os_cislo"]);
                short cislo_pom = Convert.ToInt16(item.Attributes["cislo_pom"]);

                string url = "~/ZakSpec/UkolyOdmeny/SestavaZadavaciList.aspx";

                NameValueCollection data = new NameValueCollection();
                data.Add("os_cislo", os_cislo.ToString());
                data.Add("cislo_pom", cislo_pom.ToString());

                QueryStringCrypto ht = new QueryStringCrypto();
                url = ht.AddEncryptQuery(url, data);

                PopupParam popup = new PopupParam(this, "", url);
                popup.Status = false;
                popup.Toolbar = false;
                popup.Location = false;
                popup.Menubar = false;
                popup.Width = 825;
                popup.Height = 768;
                popup.Show();
            }

            
        }
        
    }
}