﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram;

namespace KSPortal.ZakSpec
{
    public partial class ValorizaceMzdyTHP : TPage
    {
        string _paramProcValor = "";
        public ValorizaceMzdyTHP()
        {
            IdPrava = 179;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                // Nastavení grupování podle sloupce 'Nadřízený'
                // ---------------------------------------------
                GridGroupByExpression gex = new GridGroupByExpression();
                GridGroupByField fNadriz = new GridGroupByField();
                fNadriz.FieldName = "nadrizeny";
                fNadriz.HeaderText = WebControlHelper.ZmenaTextu("[%Nadřízený%]");
                gex.GroupByFields.Add(fNadriz);
                gex.SelectFields.Add(fNadriz);
                RadGrid1.MasterTableView.GroupByExpressions.Add(gex);
            }
        }

        protected void lbNacist_Command(object sender, CommandEventArgs e)
        {
            _paramProcValor = KSProgram.Funkce.Parametr_cti.Get("proc_valor_thp");
            _paramProcValor = _paramProcValor.Replace('.', ',');
            decimal procento_val = 0;
            if (!decimal.TryParse(_paramProcValor, out procento_val))
            {
                _paramProcValor = "";
            }
            else
            {
                RadGrid1.Rebind();
            }
        }

        protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable data = null;
            string sStred = "";

            if (IsPostBack)
            {
                sStred = StrSkupDiv.GetStred();
            }
            KSProgram.Sestavy.DefSestavy_ValorizaceMzdyTHP_varroc ValorizaceTHP = new KSProgram.Sestavy.DefSestavy_ValorizaceMzdyTHP_varroc();
            data = ValorizaceTHP.Retrieve(sStred);

            if (data != null)
            {
                RadGrid1.DataSource = data;
            }
        }

        protected void RTB_NavyseniVar_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            string prac_str = (string)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("prac_str");
            decimal navyseni_fix = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("navyseni_fix");
            object oNavyseniVar = ((RadNumericTextBox)sender).DbValue;

            // Uložení změny sloupce 'odmena_var'do databáze
            // ---------------------------------------------
            decimal? navyseni_var = null;
            if (oNavyseniVar != null)
            {
                navyseni_var = Convert.ToDecimal(oNavyseniVar);
            }
            KSProgram.Sestavy.DefSestavy_ValorizaceMzdyTHP_varroc ValorizaceTHP = new KSProgram.Sestavy.DefSestavy_ValorizaceMzdyTHP_varroc();
            string errMsg = ValorizaceTHP.Update(os_cislo, cislo_pom, prac_str.Trim(), datum, navyseni_fix, navyseni_var);
            if (errMsg.Length > 0) { MessageBox.Alert(Page, errMsg); }

            RadGrid1.Rebind(); // MZ 18.6.2014
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            //List<decimal> podrizeni = new List<decimal>();
            //List<string> strediska = new List<string>();
            //KSProgram.Systemizace.NajdiPodrizeneZam.get(Globals.OsCislo, DateTime.Today, ref podrizeni, false, ref strediska, false, true, 0);
            KSProgram.Prava.RadkovePrava prava = Globals.RadkovePrava;

            // Procento valorizace
            // --------------------
            _paramProcValor = KSProgram.Funkce.Parametr_cti.Get("proc_valor_thp");
            _paramProcValor = _paramProcValor.Replace('.', ',');
            decimal procento_val = 0;
            if (!decimal.TryParse(_paramProcValor, out procento_val))
            {
                MessageBox.Alert(Page, "V aplikaci KS mzdy, není nastaveno procento valorizace v rozšiřujícím parametru [proc_valor_thp] (skupina-11)!");
            }

            // Suma sloupců 'navyseni_fix' a 'navyseni_var'
            // --------------------------------------------
            //decimal ldc_NavyseniVyp = 0;
            decimal ldc_NavyseniFix = 0;
            decimal ldc_NavyseniVar = 0;
            //decimal ldc_NavyseniCelk = 0;
            //decimal ldc_NavyseniCelkProc = 0;
            //decimal ldc_TarifVal = 0;
            //decimal ldc_Tarif = 0;
            decimal ldc_SumNavyseniVar = 0;
            decimal ldc_SumNavyseniFix = 0;
            //decimal ldc_SumNavyseniCelk = 0;
            //decimal ldc_SumNavyseniCelkProc = 0;
            //decimal ldc_SumTarifVal = 0;
            int li_Neurceno = 0;

            TRadGrid rg = RadGrid1;
            DateTime aktDate = DateTime.Today; //new DateTime(Globals.AktObdobi.Year, 4, 26); 
            //DateTime stopDate = new DateTime(Globals.AktObdobi.Year, 4, 25);
            DateTime stopDate = KSProgram.Sestavy.DefSestavy_ValorizaceMzdyTHP_varroc.GetStopDate(); // MZ 8.4.2015. HD 28218.

            lbOznameni.Text = "[%Editace záznamů bude umožněna do%]" + ": " + stopDate.ToString("d.M.yyyy") + "!";
            lbProcento.Text = "[%Procento valorizace%]" + ": " + _paramProcValor;

            foreach (GridDataItem item in rg.Items)
            {
                // Načtení údajů z RadGrid
                // -----------------------
                RadNumericTextBox val = (RadNumericTextBox)WebControlHelper.FindControl(item, "RTB_NavyseniVar");

                if (val == null) { continue; }

                ldc_NavyseniVar = (val.DbValue == null) ? 0 : Convert.ToDecimal(val.DbValue);
                //ldc_NavyseniVyp = Convert.ToDecimal(item["navyseni_vyp"].Text);
                ldc_NavyseniFix = Convert.ToDecimal(item["navyseni_fix"].Text);
                //ldc_Tarif = Convert.ToDecimal(item["tarif"].Text);
                //ldc_NavyseniCelk = ldc_NavyseniFix + ldc_NavyseniVar;
                //ldc_NavyseniCelkProc = ((ldc_NavyseniCelk / ldc_NavyseniVyp) * 100);
                //ldc_TarifVal = ldc_Tarif + ldc_NavyseniCelk;

                if (Zakaznik.IsCurrent("VARROC"))
                {
                    if (val.DbValue == null) { li_Neurceno++; }
                }

                ldc_SumNavyseniVar += ldc_NavyseniVar;
                ldc_SumNavyseniFix += ldc_NavyseniFix;
                //ldc_SumNavyseniCelk += ldc_NavyseniCelk;
                //ldc_SumNavyseniCelkProc = ((ldc_SumNavyseniCelk / (ldc_SumNavyseniFix * 2)) * 100);
                //ldc_SumTarifVal += ldc_TarifVal;
                decimal os_cislo = Convert.ToDecimal(item["os_cislo"].Text);
                short cislo_pom = Convert.ToInt16(item["cislo_pom"].Text); // MZ 8.6.2015 Doplněno.

                // Uložení vypočtených údajů do RadGrid
                // ------------------------------------
                //Label lData = (Label)WebControlHelper.FindControl(item, "L_NavyseniCelk");
                //lData.Text = ldc_NavyseniCelk.ToString("#,##0");

                //lData = (Label)WebControlHelper.FindControl(item, "L_NavyseniCelkProc");
                //lData.Text = ldc_NavyseniCelkProc.ToString("0.00");

                //lData = (Label)WebControlHelper.FindControl(item, "L_TarifVal");
                //lData.Text = ldc_TarifVal.ToString("#,##0");

                // Umožnění editace jen přímých podřízených
                // ----------------------------------------
                //if (podrizeni.Contains(os_cislo))
                //if (prava.OsCislo(os_cislo, true)) // MZ 28.3.2014 Použití obecné funkce na zjišťování podřízeného zaměstnance.
                if (prava.OsCislo(os_cislo, cislo_pom, true)) // MZ 8.6.2015 Doplněno právo na PPV, viz. HD28970.
                {
                    //aktDate = stopDate; // MZ jen pro otestování
                    // Potlačení editace po 25. dnu
                    // ----------------------------
                    if (aktDate > stopDate)
                    {
                        val.BackColor = System.Drawing.Color.LightGray;
                        val.ReadOnly = true;
                    }
                    else
                    {
                        //val.BackColor = System.Drawing.Color.Yellow;
                        val.CssClass = "povinne-pole"; // MZ 29.4.2015
                        val.ReadOnly = false;

                        if (!Zakaznik.IsCurrent("VARROC"))
                        {
                            if (val.DbValue == null) { li_Neurceno++; }
                        }
                    }

                }
                else // Editace nepřímých podřízených bude zakázána
                {
                    val.BackColor = System.Drawing.Color.White;
                    val.ReadOnly = true;
                }
            }

            //Label lblSumNavyseniVar = (Label)WebControlHelper.FindControl(rg, "lbSumNavyseniVar");
            //if (lblSumNavyseniVar != null)
            //{
            //    if (rg.Items.Count < 1) // Pokud nejsou data, zobrazí se prázdný řetězec.
            //    {
            //        lblSumNavyseniVar.Text = "";
            //    }
            //    else
            //    {
            //        lblSumNavyseniVar.Text = ldc_NavyseniCelkemVar.ToString("#,##0");
            //    }
            //}
            bool isData = rg.Items.Count > 0;

            //Label lSumNavyseni = (Label)WebControlHelper.FindControl(rg, "L_SumNavyseniVar");
            //lSumNavyseni.Text = isData ? ldc_SumNavyseniVar.ToString("#,##0") : "";

            //lSumNavyseni = (Label)WebControlHelper.FindControl(rg, "L_SumNavyseniCelk");
            //lSumNavyseni.Text = isData ? ldc_SumNavyseniCelk.ToString("#,##0") : "";

            //lSumNavyseni = (Label)WebControlHelper.FindControl(rg, "L_SumNavyseniCelkProc");
            //lSumNavyseni.Text = isData ? ldc_SumNavyseniCelkProc.ToString("0.00") : "";

            //lSumNavyseni = (Label)WebControlHelper.FindControl(rg, "L_SumTarifVal");
            //lSumNavyseni.Text = isData ? ldc_SumTarifVal.ToString("#,##0") : "";

            if (ldc_SumNavyseniVar > ldc_SumNavyseniFix)
            {
                MessageBox.Alert(Page, "Součet variabilní částky navýšení za všechny podřízené zaměstnance překročil součet fixní částky navýšení!");
            }

            if (li_Neurceno > 0)
            {
                lbChybejici.Text = "[%Není stanovena částka u všech zaměstnanců%]! [%Počet chybějících%]: " + li_Neurceno.ToString();
            }
            else
            {
                lbChybejici.Text = "";
            }
        }

        protected void RadGrid1_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (e.Item is GridGroupFooterItem)
            {
                GridGroupFooterItem footer = e.Item as GridGroupFooterItem;
                GridItem[] groups = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
                foreach (GridGroupHeaderItem group in groups)
                {
                    if (group.GroupIndex == footer.GroupIndex)
                    {
                        decimal navyseni_vyp = 0;
                        decimal navyseni_celk = 0;
                        decimal navyseni_proc = 0;

                        foreach (GridItem item in group.GetChildItems())
                        {
                            if (item is GridDataItem)
                            {
                                navyseni_vyp += Convert.ToDecimal(((GridDataItem)item)["navyseni_vyp"].Text);
                                navyseni_celk += Convert.ToDecimal(((GridDataItem)item)["navyseni_celk"].Text);
                            }
                        }

                        if (navyseni_vyp > 0)
                        {
                            navyseni_proc = ((navyseni_celk / navyseni_vyp) * 100);
                        }

                        e.Result = navyseni_proc;
                    }
                }
            }
            if (e.Item is GridFooterItem)
            {
                decimal odmena_100 = 0;
                decimal odmena_celk = 0;
                foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
                {
                    odmena_100 += Convert.ToDecimal(item["navyseni_vyp"].Text);
                    odmena_celk += Convert.ToDecimal(item["navyseni_celk"].Text);
                }
                if (odmena_100 > 0)
                {
                    e.Result = ((odmena_celk / odmena_100) * 100);
                }
            }
        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                if (e.FormattedColumn.UniqueName == "navyseni_var")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    e.Cell.Text = dataRow["navyseni_var"].ToString();
                }
            }
        }

        protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            RadGrid1.GroupingEnabled = false;
        }
    }
}