﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.WebControls;
using KSProgram.Vzdelavani;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Prava;

public partial class Zamestnanec_IndivPlanVzdel : TPageZam
{
    private decimal _dnyTrvani = 0;
    private decimal _dnyPozad = 0;
    private decimal _dnyAkreditovane = 0;

    public Zamestnanec_IndivPlanVzdel()
    {
        IdPrava = 11;
        VisibleSeznamZam = true;
        this.HelpURL = "Vzd%C4%9Bl%C3%A1v%C3%A1n%C3%AD_%28KS_port%C3%A1l%29";
        VerzeStranky = "2";
    }
    //protected void DetailView1_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    GV_Aktivity.Visible = true;
    //    GV_Aktivity.SelectedIndex = -1;
    //    GV_Akce.Visible = false;
    //}
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

    }
    protected void GV_Aktivity_SelectedIndexChanged(object sender, EventArgs e)
    {
        GV_Akce.Visible = true;
    }
    protected void GV_Aktivity_DataBinding(object sender, EventArgs e)
    {
        _dnyTrvani = 0;
        _dnyPozad = 0;
        _dnyAkreditovane = 0;
    }
    protected void GV_Aktivity_DataBound(object sender, EventArgs e)
    {
        viditelnostBtnAktivity(0);
    }
    protected void GV_Aktivity_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            TDropDown tdd = (TDropDown)e.Row.FindControl("TDD_aktivity_skoleni");
            ListItem tddi = tdd.SelectedItem;
            if (tddi.Value == "")
            {
                object nazev_o = DataBinder.Eval(e.Row.DataItem, "nazev");
                object cis_osve_o = DataBinder.Eval(e.Row.DataItem, "cis_osve");
                if (cis_osve_o != DBNull.Value && nazev_o != DBNull.Value)
                {
                    tddi.Value=(string)cis_osve_o;
                    tddi.Text = (string)cis_osve_o + " - " + (string)nazev_o;
                }
            }

            //viditelnost pozad
            TLabel TL_pozad = (TLabel)FV_plan.FindControl("TL_FV_item_pozad");
            TTextBox TB_pozad = (TTextBox)FV_plan.FindControl("TB_FV_edit_pocet");
            if (TL_pozad != null)
                if (TL_pozad.Text.Trim() != "")
                    ((TTextBox)e.Row.FindControl("TB_aktivity_pozad")).Visible = false;
            if (TB_pozad != null)
                if (TB_pozad.Text.Trim() != "")
                    ((TTextBox)e.Row.FindControl("TB_aktivity_pozad")).Visible = false;
            //viditelnost delete butt
            e.Row.FindControl("TIB_aktivity_delete").Visible = !dataPrihlaseneho();

            //editovatelnost řádku
            bool pravo_editace_aktivity = e.Row.FindControl("TIB_aktivity_delete").Visible;
            TDropDown TDD_a_skoleni = (TDropDown)e.Row.FindControl("TDD_aktivity_skoleni");
            DateControl DC_a_termin = (DateControl)e.Row.FindControl("DC_aktivity_termin");
            TTextBox TB_a_pozad = (TTextBox)e.Row.FindControl("TB_aktivity_pozad");
            EditLabel EL_a_poznamka = (EditLabel)e.Row.FindControl("EL_aktivity_poznamka");
            TDD_a_skoleni.Enabled = pravo_editace_aktivity;
            DC_a_termin.Editable = pravo_editace_aktivity;
            TB_a_pozad.Enabled = pravo_editace_aktivity;
            EL_a_poznamka.Editable = pravo_editace_aktivity;

            //sumace údajů
            string pom = DataBinder.Eval(e.Row.DataItem, "dny_trvani").ToString();
            _dnyTrvani += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));

            pom = DataBinder.Eval(e.Row.DataItem, "dny_akreditovane").ToString();
            _dnyAkreditovane += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));

            pom = DataBinder.Eval(e.Row.DataItem, "dny_pozad").ToString();
            _dnyPozad += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            TLabel TL_pozad = (TLabel)FV_plan.FindControl("TL_FV_item_pozad");
            TTextBox TB_pozad = (TTextBox)FV_plan.FindControl("TB_FV_edit_pocet");
            e.Row.Cells[1].Font.Bold = true;
            e.Row.Cells[1].Text = "Celkem";
            if (TL_pozad != null)
            {
                if (TL_pozad.Text.Trim() != "")
                    e.Row.Cells[3].Text = TL_pozad.Text;
                else
                    e.Row.Cells[3].Text = _dnyPozad.ToString();
            }
            if (TB_pozad != null)
            {
                if (TB_pozad.Text.Trim() != "")
                    e.Row.Cells[3].Text = TB_pozad.Text;
                else
                    e.Row.Cells[3].Text = _dnyPozad.ToString();
            }
            e.Row.Cells[4].Text = _dnyTrvani.ToString();
            e.Row.Cells[5].Text = _dnyAkreditovane.ToString();
        }
    }
    protected void TGV_plany_SelectedIndexChanged(object sender, EventArgs e)
    {
        //if (FV_plan.DataSourceID == "")
        //    FV_plan.DataSource = ODS_IndPlan;
        FV_plan.Visible = true;
        DIV_ag.Visible = true;
        //if (FV_plan.CurrentMode != FormViewMode.ReadOnly)
        //    FV_plan.ChangeMode(FormViewMode.ReadOnly);
        GV_Aktivity.Visible = true;
        GV_Aktivity.SelectedIndex = -1;
        GV_Akce.Visible = false;
    }
    protected void FV_plan_ItemInserting(object sender, FormViewInsertEventArgs e)
    {
        FormView FV = (FormView)sender;
        CustomValidator CV = (CustomValidator)FV.FindControl("CV_FV_insertValidator");
        String ErrorMessage;
        DateTime? dat_vzniku = ((string)e.Values["dat_vzniku"] == "" || e.Values["dat_vzniku"] == null) ? null : (DateTime?)Convert.ToDateTime(e.Values["dat_vzniku"]);
        DateTime? obdobi_od = ((string)e.Values["obdobi_od"] == "" || e.Values["obdobi_od"] == null) ? null : (DateTime?)Convert.ToDateTime(e.Values["obdobi_od"]);
        DateTime? obdobi_do = ((string)e.Values["obdobi_do"] == "" || e.Values["obdobi_do"] == null) ? null : (DateTime?)Convert.ToDateTime(e.Values["obdobi_do"]);
        CV.IsValid = IndividualniPlan.IsValidPlanValues(2, Globals.OsCislo, null, dat_vzniku, obdobi_od, obdobi_do, out ErrorMessage);
        CV.ErrorMessage = ErrorMessage;
        if (!Page.IsValid)
            e.Cancel = true;
    }
    protected void ODS_IndPlan_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"] == null ? "" : e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            MessageBox.Alert(Page, errorMessage, "Insert se nezdařil");
        else
        {
            Int32? cis_planu = e.OutputParameters["cis_planu"] == null ? null : (Int32?)Convert.ToInt32(e.OutputParameters["cis_planu"]);
            if (cis_planu != null)
                TGridView.FindRowByKeyValue(TGV_plany, "cis_planu", cis_planu.ToString(), true);
        }
    }
    protected void FV_plan_ItemUpdating(object sender, FormViewUpdateEventArgs e)
    {
        FormView FV = (FormView)sender;
        CustomValidator CV = (CustomValidator)FV.FindControl("CV_FV_updateValidator");
        String ErrorMessage;
        DateTime? dat_vzniku = ((string)e.NewValues["dat_vzniku"] == "" || e.NewValues["dat_vzniku"] == null) ? null : (DateTime?)Convert.ToDateTime(e.NewValues["dat_vzniku"]);
        DateTime? obdobi_od = ((string)e.NewValues["obdobi_od"] == "" || e.NewValues["obdobi_od"] == null) ? null : (DateTime?)Convert.ToDateTime(e.NewValues["obdobi_od"]);
        DateTime? obdobi_do = ((string)e.NewValues["obdobi_do"] == "" || e.NewValues["obdobi_do"] == null) ? null : (DateTime?)Convert.ToDateTime(e.NewValues["obdobi_do"]);
        Int32? cis_planu = ((string)e.NewValues["cis_planu"] == "" || e.NewValues["cis_planu"] == null) ? null : (Int32?)Convert.ToInt32(e.NewValues["cis_planu"]);
        CV.IsValid = IndividualniPlan.IsValidPlanValues(1, Globals.OsCislo, cis_planu, dat_vzniku, obdobi_od, obdobi_do, out ErrorMessage);
        CV.ErrorMessage = ErrorMessage;
        if (!Page.IsValid)
            e.Cancel = true;
    }
    protected void ODS_IndPlan_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"] == null ? "" : e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            MessageBox.Alert(Page, errorMessage, "Update se nezdařil");
        else
        {
            TGV_plany.DataBind();
            GV_Aktivity.DataBind();
        }
    }
    protected void FV_plan_ItemDeleted(object sender, FormViewDeletedEventArgs e)
    {
        int index = TGV_plany.SelectedIndex;
        int page = TGV_plany.PageIndex;
        TGV_plany.DataBind();
        int max = TGV_plany.Rows.Count - 1;
        TGV_plany.SelectedIndex = max < index || TGV_plany.PageIndex < page ? max : index;
    }
   
    protected void TB_akt_insert_Click(object sender, EventArgs e)
    {
        viditelnostBtnAktivity(1);
        DateControl DC_termin = (DateControl)Table1.FindControl("DC_aktivity_termin_i");
        TLabel TL_do = (TLabel)FV_plan.FindControl("TL_FV_item_do");
        DC_termin.Datum = TL_do.Text;
    }
    protected void TB_akt_update_Click(object sender, EventArgs e)
    {
        GV_Aktivity.BulkUpdate(true, "cis_osve", "termin", "dny_pozad", "poznamka");
        object er = ViewState["UpdateMessage"];
        if (er != null)
        {
            MessageBox.Alert(Page, ViewState["UpdateMessage"].ToString(), "Update se nezdařil");
            ViewState["UpdateMessage"] = null;
        }
    }
    protected void TB_akt_insertpozad_Click(object sender, EventArgs e)
    {
        TB_akt_update_Click(TB_akt_update, new EventArgs());
        Int16 cis_planu = Convert.ToInt16(TGV_plany.SelectedDataKey["cis_planu"]);
        Int32 count = IndividualniPlan.InsertAktivityFromPozadavky(Globals.OsCislo, cis_planu);
        if (count != 0)
        {
            GV_Aktivity.DataBind();
            //MessageBox.Alert(Page, F_String.SkloneniPodleCisla(count, "Byl vložen", "Byly vloženy", "Bylo vloženo") + " " + count.ToString() + " " + F_String.SkloneniPodleCisla(count, "řádek", "řádky", "řádků") + ".", "OK");
        }
    }
    protected void TB_akt_cancel_Click(object sender, EventArgs e)
    {
        GV_Aktivity.DataBind();
    }
    protected void TB_akt_insert_i_Click(object sender, EventArgs e)
    {
        decimal os_cislo = Globals.OsCislo;
        Int16 cis_planu = Convert.ToInt16(TGV_plany.SelectedDataKey["cis_planu"]);
        string cis_osve = ((TDropDown)Table1.Rows[1].FindControl("TDD_aktivity_skoleni_i")).SelectedValue.Trim();
        DateTime? termin = ((DateControl)Table1.Rows[1].FindControl("DC_aktivity_termin_i")).SelectedDateTime;
        string dny_pozad_s = ((TTextBox)Table1.Rows[1].FindControl("TB_aktivity_pozad_i")).Text.Trim();
        Int16? dny_pozad = (dny_pozad_s == null || dny_pozad_s == "") ? null : (Int16?)Convert.ToInt16(dny_pozad_s);
        EditLabel El_poz = (EditLabel)Table1.Rows[1].FindControl("EL_aktivity_poznamka_i");
        string poznamka_s = El_poz.Text == null ? null : El_poz.Text.Trim();
        string poznamka = (poznamka_s == null || poznamka_s == "") ? null : poznamka_s;
        string Message = "";
        Int32 ret = IndividualniPlan.InsertAktivity(os_cislo, cis_planu, cis_osve, termin, dny_pozad, poznamka, ref Message);
        if (Message == "")
        {
            clearInsertRow();
            GV_Aktivity.DataBind();
        }
        else
        {
            MessageBox.Alert(Page, Message, "Insert se nezdařil");
        }
    }
    protected void TB_akt_cancel_i_Click(object sender, EventArgs e)
    {
        clearInsertRow();
        viditelnostBtnAktivity(0);
    }

    protected void TGV_plany_DataBound(object sender, EventArgs e)
    {
        viditelnostBtnAktivity(0);
        TGridView table = (TGridView)sender;
        if (table.Rows.Count == 0 && !dataPrihlaseneho())
        {
            FV_plan.Visible = true;
            if (FV_plan.CurrentMode != FormViewMode.Insert)
            {
                FV_plan.ChangeMode(FormViewMode.Insert);
                DIV_ag.Visible = false;
            }
        }
        else
        {
            if (TGV_plany.SelectedIndex == -1)
            {
                FV_plan.Visible = false;
                DIV_ag.Visible = false;
            }
            else
            {
                FV_plan.Visible = true;
                DIV_ag.Visible = true;
            }
            if (FV_plan.CurrentMode != FormViewMode.ReadOnly)
                FV_plan.ChangeMode(FormViewMode.ReadOnly);
        }
            

    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="mode">0 - zaklad, 1 - insert </param>
    private void viditelnostBtnAktivity(short mode)
    {
        if (dataPrihlaseneho() || TGV_plany.SelectedIndex == -1)
        {
            butons_edit.Visible = false;
            butons_insert.Visible = false;
        }
        else
        {
            switch (mode)
            {
                case 0: butons_edit.Visible = true;
                    butons_insert.Visible = false; break;
                case 1: butons_edit.Visible = false;
                    butons_insert.Visible = true; break;
            }
        }
    }
    private bool dataPrihlaseneho()
    {
        return Globals.OsCislo == Globals.OsCisloAktUser;
    }

    private void clearInsertRow()
    {
        ((TDropDown)Table1.Rows[1].FindControl("TDD_aktivity_skoleni_i")).SelectedIndex = 0;
        ((DateControl)Table1.Rows[1].FindControl("DC_aktivity_termin_i")).SelectedDateTime = null;
        ((TTextBox)Table1.Rows[1].FindControl("TB_aktivity_pozad_i")).Text = "";
        ((EditLabel)Table1.Rows[1].FindControl("EL_aktivity_poznamka_i")).Text = "";
    }
    protected void FV_plan_ItemCreated(object sender, EventArgs e)
    {
        HtmlControl div = (HtmlControl)((FormView)sender).FindControl("FV_item_btn");
        if (div != null)
            div.Visible = !dataPrihlaseneho();
        if (FV_plan.CurrentMode == FormViewMode.Insert)
        {
            DateControl DC_vznik = (DateControl)FV_plan.FindControl("DC_FV_insert_vznik");
            if (DC_vznik.SelectedDateTime == null)
                DC_vznik.SelectedDateTime = DateTime.Now.Date;
        }
    }
    protected void ODS_Aktivity_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"] == null ? "" : e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            ViewState["UpdateMessage"] += errorMessage + "<br />";
    }
    protected void ODS_Aktivity_Deleted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"] == null ? "" : e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            MessageBox.Alert(Page, errorMessage, "Delete se nezdařil");
        else
        {
            GV_Aktivity.DataBind();
        }
    }
    protected void FV_plan_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        GV_Aktivity.Visible = true;
        GV_Aktivity.SelectedIndex = -1;
        GV_Akce.Visible = false;
    }

    protected override void Page_PreRenderComplete(object sender, EventArgs e)
    {
        base.Page_PreRenderComplete(sender, e);
        IndividualniPlan.ClearBuff();
    }
    protected void TIB_print_Click(object sender, ImageClickEventArgs e)
    {
        Session["cis_planu"] = TGV_plany.SelectedDataKey["cis_planu"];
        String Title = "Individuální plán vzdělávání";
        String Url = "/Sestavy/IndivPlanVzdelPrint.aspx";

        if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
        {
            Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
        }
        else
        {
            string path = HttpContext.Current.Request.RawUrl;
            Url = path.Substring(0, path.Length - 30) + Url;//upravit
        }

        PopupParam popup = new PopupParam(this.Page, Title, Url);
        popup.Status = true;
        popup.Toolbar = false;
        popup.Location = true;
        popup.Menubar = true;
        popup.Titulek = Title;
        popup.Height = 900;
        popup.Width = 850;
        popup.Show();
    }


    protected void FV_plan_ModeChanged(object sender, EventArgs e)
    {
        FormView FV_pl = (FormView)sender;
        if (FV_pl.CurrentMode == FormViewMode.Insert || FV_pl.CurrentMode == FormViewMode.Edit)
        {
            DIV_ag.Visible = false;
        }
        else
        {
            DIV_ag.Visible = true;
        }
        
    }
    protected void DC_FV_insert_od_TextChanged(object sender, EventArgs e)
    {
        DateControl DC_od = (DateControl)sender;
        DateControl DC_do = (DateControl)FV_plan.FindControl("DC_FV_insert_do");
        DateTime? od = DC_od.SelectedDateTime;
        if (od != null)
        {
            DC_do.SelectedDateTime = ((DateTime)od).AddYears(3).AddDays(-1);
        }
    }
}
