﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Zpravy;
using System.Data;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Data;
using System.Text.RegularExpressions;
using System.Collections.Specialized;
using AjaxControlToolkit;
using Telerik.Web.UI;
using KSProgram.Extensions;

namespace KSPortal.Zamestnanec
{
    public partial class NovaZprava : TPopUpPage
    {
        private Zprava _Zprava = new Zprava();
        private Int32 Id
        {
            get
            {
                Int32 ret = 0;
                QueryStringCrypto ht = new QueryStringCrypto();
                NameValueCollection data = ht.DecryptRequestQuery();
                try { ret = Convert.ToInt32(data["id"]); }
                catch { }
                return ret;
            }
        }
        private List<Priloha> _Prilohy
        {
            get
            {
                object lses = ViewState["prilohy_emailu"];
                return lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;
            }
            set
            {
                ViewState["prilohy_emailu"] = value;
            }
        }
        private List<decimal?> _Adresy
        {
            get
            {
                object lses = ViewState["adresy_emailu"];
                return lses == null ? new List<decimal?>() { null } : (List<decimal?>)lses;
            }
            set
            {
                ViewState["adresy_emailu"] = value;
            }
        }
        private Boolean _Oprava
        {
            get
            {
                object lses = ViewState["oprava"];
                return lses == null ? true : (Boolean)lses;
            }
            set
            {
                ViewState["oprava"] = value;
            }
        }
        private Boolean _VolaniZBase
        {
            get
            {
                object lses = ViewState["VolaniZBase"];
                return lses == null ? true : (Boolean)lses;
            }
            set
            {
                ViewState["VolaniZBase"] = value;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.TitleStranky = "[%Nová zpráva%]";
            base.Page_Load(sender, e);

            //zruseni odsazeni v tabulce master page
            System.Web.UI.HtmlControls.HtmlTable tab = (System.Web.UI.HtmlControls.HtmlTable)Master.FindControl("Table1");
            tab.Rows[0].Cells[0].Style.Remove("padding-top");
            tab.Rows[0].Cells[0].Style.Remove("padding-left");
            tab.Rows[0].Cells[0].Style.Remove("padding-right");
            tab.Rows[0].Cells[0].Style.Remove("padding-bottom");

            if (!Page.IsPostBack)
            {
                object lses = Session["prilohy_emailu"];
                _Prilohy = lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;
                Session["prilohy_emailu"] = null;
                _Oprava = false;

                _Adresy.Clear();

                Int32 id = Id;
                if (id != 0)
                {
                    _Zprava = new Zprava((Int32)id);
                    _Prilohy.AddRange(_Zprava.Prilohy);
                    if (_Zprava.Typ == 0)
                    {
                        _Adresy = new List<decimal?> { Convert.ToDecimal(_Zprava.Adresa) };
                    }
                    _Oprava = true;
                }

                object lses_v = Session["prime_volani"];
                _VolaniZBase = lses_v == null ? false : (bool)lses_v;
                Session["prime_volani"] = null;

                object lses_a = Session["adresy_emailu"];
                if (lses_a != null)
                {
                    List<decimal?> ses_adr = (List<decimal?>)lses_a;
                    _Adresy = ses_adr;
                    Session["adresy_emailu"] = null;
                }
            }
            _Zprava.Prilohy = _Prilohy;
            _Zprava.Odesilatel = Globals.OsCisloAktUser;

            if (!Page.IsPostBack)
            {
                TFormView1.DataBind();

                if (Id != 0)
                {
                    base.TitleStranky = "[%Zpráva číslo%] " + Id.ToString();
                }

                object lses_p = Session["predmet_emailu"];
                if (lses_p != null)
                {
                    TTextBox predmet = (TTextBox)TFormView1.FindControl("TTextBox1");
                    predmet.Text = (string)lses_p;
                    Session["predmet_emailu"] = null;

                    Label label = (Label)TFormView1.FindControl("HidenLabel");
                    label.Text = "RE";
                    
                }
                object lses_t = Session["telo_emailu"];
                if (lses_t != null)
                {
                    TTextBox tt_telo = (TTextBox)TFormView1.FindControl("TTextBox2");
                    RadEditor radEdit = (RadEditor)TFormView1.FindControl("RadEditor1");
                    radEdit.Content = ((string)lses_t).HtmlSanitize();
                    Session["telo_emailu"] = null;
                }
            }

            System.Web.UI.HtmlControls.HtmlTable table_zpusob = (System.Web.UI.HtmlControls.HtmlTable)TFormView1.FindControl("table_zpusob");
            if (Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM"))
            {
                table_zpusob.Style[HtmlTextWriterStyle.Display] = "block";
            }
            else
            {
                table_zpusob.Style[HtmlTextWriterStyle.Display] = "none";
            }
        }

        /// <summary>
        /// Odeslat
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TLinkButton4_Click(object sender, EventArgs e)
        {
            foreach (decimal? adr in _Adresy)
            {
                if (adr != null)
                {
                    //TTextBox TTtelo = (TTextBox)TFormView1.FindControl("TTextBox2");
                    TTextBox TTpredmet = (TTextBox)TFormView1.FindControl("TTextBox1");
                    RadioButtonList RBL_typ = (RadioButtonList)TFormView1.FindControl("RadioButtonList1");
                    RadEditor radEdit = (RadEditor)TFormView1.FindControl("RadEditor1");
                    Zprava novaZP = new Zprava();
                    if (_Oprava)
                        novaZP.CopyFrom(new Zprava(Id));
                    else
                        novaZP.CopyFrom(_Zprava);
                    novaZP.Prilohy = _Prilohy;
                    novaZP.Odesilatel = Globals.OsCisloAktUser;
                    novaZP.Telo_text = radEdit.Content.HtmlSanitize();
                    novaZP.Predmet = TTpredmet.Text;
                    //novaZP.Typ = Convert.ToInt16(RBL_typ.SelectedValue);
                    novaZP.Typ = (Zprava.TypZpravy)(Convert.ToInt16(RBL_typ.SelectedValue));
                    switch (novaZP.Typ)
                    {
                        //case 0:
                        case Zprava.TypZpravy.Portal:
                            {
                                novaZP.Adresa = adr.ToString();
                                break;
                            }
                        //case 1:
                        case Zprava.TypZpravy.Email:
                            {
                                string email = Zpravy.FindEmail(adr);
                                if (string.IsNullOrEmpty(email))
                                {
                                    novaZP.Typ = 0;
                                    novaZP.Adresa = adr.ToString();
                                }
                                else
                                {
                                    novaZP.Adresa = email;
                                }
                                break;
                            }
                    }
                    string errorMessage = "";
                    novaZP.Save(ref errorMessage);
                }
                
            }
            Response.Redirect(Request.RawUrl);
        }

        protected void TFormView1_DataBinding(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            Zpravy.AddSloupce(ref table);
            _Zprava.AddToDataRow(ref table);
            TFormView1.DataSource = table;
        }

        protected void TFormView1_DataBound(object sender, EventArgs e)
        {

            RadioButtonList RBL = (RadioButtonList)((TFormView)sender).FindControl("RadioButtonList1");
            RBL.SelectedIndex = (int)_Zprava.Typ;
        }

        protected void Repeater2_DataBinding(object sender, EventArgs e)
        {
            Repeater rep = (Repeater)sender;
            DataTable table = new DataTable();
            table.Columns.Add("adresa", typeof(string));
            foreach (decimal? adr in _Adresy)
            {
                DataRow row = table.NewRow();
                if (adr != null)
                    row["adresa"] = _celeJmeno((decimal)adr);
                else
                    row["adresa"] = "";
                table.Rows.Add(row);
            }
            rep.DataSource = table;
        }

        /// <summary>
        /// prijemce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Repeater2_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            Repeater rep = (Repeater)sender;

            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                TRadButton butt_add = (TRadButton)e.Item.FindControl("TButton1");
                TRadButton butt_rem = (TRadButton)e.Item.FindControl("TButton2");
                TTextBox ttb = (TTextBox)e.Item.FindControl("TTextBox3");
                ttb.ReadOnly = _Oprava;
                butt_add.CommandArgument = e.Item.ItemIndex.ToString();
                butt_rem.CommandArgument = e.Item.ItemIndex.ToString();
                if (_Adresy.Count == 1)
                    butt_rem.Visible = false;
                else
                    butt_rem.Visible = true;
                if (e.Item.ItemIndex + 1 == _Adresy.Count && !_Oprava)
                    butt_add.Visible = true;
                else
                    butt_add.Visible = false;
            }
        }

        /// <summary>
        /// textbox prijemce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TTextBox3_TextChanged(object sender, EventArgs e)
        {
            Repeater REP_adr = (Repeater)TFormView1.FindControl("Repeater2");
            List<decimal?> list = _Adresy;
            foreach (RepeaterItem item in REP_adr.Items)
            {
                TTextBox tb = (TTextBox)item.FindControl("TTextBox3");
                int index = item.ItemIndex;
                decimal? o_cislo = null;
                if (!string.IsNullOrEmpty(tb.Text))
                {
                    Regex rgx = new Regex(@"\d+", RegexOptions.IgnoreCase);
                    MatchCollection pars = rgx.Matches(tb.Text);
                    if (pars.Count != 0)
                    {
                        o_cislo = Convert.ToDecimal(pars[0].Value);
                    }
                }
                list[index] = o_cislo; 
            }
            _Adresy = list;
            REP_adr.DataBind();
        }

        /// <summary>
        /// pridat prijemce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TButton1_Command(object sender, CommandEventArgs e)
        {
            List<decimal?> list = _Adresy;
            list.Add(null);
            _Adresy = list;
            Repeater REP_adr = (Repeater)TFormView1.FindControl("Repeater2");
            REP_adr.DataBind();
        }

        /// <summary>
        /// odebrat prijemce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TButton2_Command(object sender, CommandEventArgs e)
        {
            int index = Convert.ToInt32(e.CommandArgument);
            List<decimal?> list = _Adresy;
            list.RemoveAt(index);
            _Adresy = list;
            Repeater REP_adr = (Repeater)TFormView1.FindControl("Repeater2");
            REP_adr.DataBind();
        }

        /// <summary>
        /// odebrat prilohu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TB_rem_Command(object sender, CommandEventArgs e)
        {
            int index = Convert.ToInt32(e.CommandArgument);
            List<Priloha> list = _Prilohy;
            list.RemoveAt(index);
            _Prilohy = list;
            Repeater REP_prl = (Repeater)TFormView1.FindControl("Repeater1");
            REP_prl.DataBind();
        }


        private string _celeJmeno(decimal os_cislo)
        {
            string ls_celejmeno = "";

            string sql = "SELECT titul, jmeno, prijmeni, titul_za FROM pracovnici WHERE os_cislo = " + os_cislo + " ORDER BY prijmeni";
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader(sql);
                while (reader.Read())
                {
                    string ls_prijmeni = GetNullOrData.GetString(reader, 2, string.Empty).Trim();
                    string ls_jmeno = GetNullOrData.GetString(reader, 1, string.Empty).Trim();
                    string ls_titul = GetNullOrData.GetString(reader, 0, string.Empty).Trim();
                    string ls_titul_za = GetNullOrData.GetString(reader, 3, string.Empty).Trim();

                    if (ls_jmeno != string.Empty) ls_celejmeno = ls_jmeno;
                    if (ls_prijmeni != string.Empty) ls_celejmeno += " " + ls_prijmeni;
                    if (ls_titul != string.Empty) ls_celejmeno = ls_titul + " " + ls_celejmeno;
                    if (ls_titul_za != string.Empty) ls_celejmeno = ls_celejmeno + ", " + ls_titul_za;
                    ls_celejmeno = os_cislo + " - " + ls_celejmeno;
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }
            return ls_celejmeno.Trim();
        }

        /// <summary>
        /// Přílohy
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Repeater1_DataBinding(object sender, EventArgs e)
        {
            Repeater rep = (Repeater)sender;
            if (_Prilohy.Count != 0)
            {
                DataTable ptable = new DataTable("prilohy");
                ptable.Columns.Add("nazev", typeof(string));
                ptable.Columns.Add("argument", typeof(string));
                ptable.Columns.Add("size", typeof(string));
                foreach (Priloha priloha in _Prilohy)
                {
                    DataRow row = ptable.NewRow();
                    row["nazev"] = priloha.Nazev;
                    row["argument"] = priloha.Id_Blob;
                    row["size"] = decimal.Round((priloha.Obsah.Length / (decimal)1024), 1).ToString() + " kB";
                    ptable.Rows.Add(row);
                }
                rep.DataSource = ptable;
            }
        }

        /// <summary>
        /// nahrané přílohy
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TLinkButton2_Command(object sender, CommandEventArgs e)
        {
            int index = Convert.ToInt32(e.CommandArgument);
            Priloha prl = _Prilohy[index];
            KSProgram.Attachment.Send(Page, ((TLinkButton)sender).Text, prl.Obsah);

        }


        /// <summary>
        /// nahravani priloh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Repeater1_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            Repeater rep = (Repeater)sender;
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                TLinkButton butt_rem = (TLinkButton)e.Item.FindControl("TB_rem");
                butt_rem.CommandArgument = e.Item.ItemIndex.ToString();
                TLinkButton butt_link = (TLinkButton)e.Item.FindControl("TLinkButton2");
                butt_link.CommandArgument = e.Item.ItemIndex.ToString();
            }
        }

        /// <summary>
        /// Vložit přílohy ke zprávě
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Button1_Click(object sender, EventArgs e)
        {
            Repeater REP_prl = (Repeater)TFormView1.FindControl("Repeater1");
            REP_prl.DataBind();
        }


        protected void AsyncFileUpload1_UploadedComplete(object sender, AsyncFileUploadEventArgs e)
        {
            AsyncFileUpload AFU = (AsyncFileUpload)sender;
            if (e.State == AsyncFileUploadState.Success)
            {
                if (AFU.HasFile)
                {
                    Priloha prl_new = new Priloha(AFU.FileBytes, AFU.FileName);
                    Session["nova_priloha"] = prl_new;
                }
            }
            AFU.ClearAllFilesFromPersistedStore();
        }

        protected void RadAsyncUpload1_FileUploaded(object sender, Telerik.Web.UI.FileUploadedEventArgs e)
        {
            if (e.IsValid)
            {
                UploadedFile file = e.File;
                byte[] bytes = new byte[file.ContentLength];
                file.InputStream.Read(bytes, 0, (int)file.ContentLength);
                Priloha prl_new = new Priloha(bytes, file.FileName);
                Int32 lenght =0;
                foreach (Priloha pril in _Prilohy)
                {
                    lenght += pril.Obsah.Length;
                }
                if ((lenght + prl_new.Obsah.Length) < 2097152)
                    _Prilohy.Add(prl_new);
            }
            else
            {
                //isValid = false;
            }
            RadAsyncUpload raupload = (RadAsyncUpload)sender;
            raupload.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
            raupload.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
            raupload.Localization.DropZone = WebControlHelper.ZmenaTextu("[%Přetáhnout soubor sem%]");
            raupload.Localization.Cancel = WebControlHelper.ZmenaTextu("[%Zrušit%]");
        }

    }
}