﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Zamestnanec
{
    public partial class OsobniPozadavky : TPage
    {
        public OsobniPozadavky()
        {
            this.IdPrava = 305;
            this.EnableVisibleSeznamZam = true;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            TRG_osobni_pozadavky.Datum.SelectedDatum = null;
        }

        [WebMethod]
        public static HodnoceniResult GetOsobniPozadavky(DateTime? ke_dni)
        {
            List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> data = KSProgram.Vzdelavani.OsobniPozadavky.GetOsobniPozadavky(KSProgram.Globals.OsCislo, ke_dni);

            HodnoceniResult ret = new HodnoceniResult();
            ret.Data = data;
            ret.Count = data.Count;
            return ret;
        }

        [WebMethod]
        public static void UpdateOsobniPozadavky(List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> pozadavky)
        {
            foreach(KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek poz in pozadavky)
            {
                poz.os_cislo = poz.get_valsFromId().os_cislo;
                KSProgram.Vzdelavani.OsobniPozadavky.UpdatePozadavek(poz);
            }
        }

        [WebMethod]
        public static void InsertOsobniPozadavky(List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> pozadavky)
        {
            foreach (KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek poz in pozadavky)
            {
                poz.os_cislo = KSProgram.Globals.OsCislo;
                KSProgram.Vzdelavani.OsobniPozadavky.InsertPozadavek(poz);
            }
        }

        [WebMethod]
        public static void DeleteOsobniPozadavky(List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> pozadavky)
        {
            foreach (KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek poz in pozadavky)
            {
                KSProgram.Vzdelavani.OsobniPozadavky.DeletePozadavek(poz);
            }
        }

        public class HodnoceniResult
        {
            public List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> Data { get; set; }
            public int Count { get; set; }
        }

        public class HodnoceniEditResult
        {
            public List<KSProgram.Vzdelavani.OsobniPozadavky.osobni_pozadavek> models { get; set; }
        }

        internal override void On_SaveCustomSettings(object sender, PersistenceManagerSaveStateEventArgs e)
        {
            base.On_SaveCustomSettings(sender, e);
        }
        internal override void On_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
        {
            base.On_LoadCustomSettings(sender, e);
        }
    }
}