﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram;
using KSProgram.Obecne;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram.Exceptions;
using KSProgram.Data;
using KSProgram.Extensions;
using System.Linq;

public partial class Zamestnanec_PomuckyInventura : TPageZam
{
    private bool sklady;
    private bool synchronizovano = true;

    public Zamestnanec_PomuckyInventura()
    {
        IdPrava = 398;
        this.HelpURL = "Pracovn%C3%AD_pom%C5%AFcky_%28KS_port%C3%A1l%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            sklady = Parametr_cti.Get("*pomucky_sklady") == "a";
            TRadGrid_pomucky_chybne.Visible = PracovniPomucky.chybneVydane().Rows.Count > 0;
            TRadGrid_sklady.Visible = !TRadGrid_pomucky_chybne.Visible;
            if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY") /*|| Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM")*/)
            {
                TRadGrid_pomucky_chybne.MasterTableView.GetColumn("model").Visible = true;
                TRadGrid_pomucky_chybne.MasterTableView.GetColumn("znacka").Visible = true;
                TRadGrid_pomucky_chybne.MasterTableView.GetColumn("inv_cislo").Visible = true;
                TRadGrid_pomucky_chybne.MasterTableView.GetColumn("vyr_cislo").Visible = true;
                TRadGrid_pomucky_chybne.MasterTableView.GetColumn("pomu_pozn").Visible = true;

                TRadGrid_sklady.MasterTableView.GetColumn("model").Visible = true;
                TRadGrid_sklady.MasterTableView.GetColumn("znacka").Visible = true;
                TRadGrid_sklady.MasterTableView.GetColumn("inv_cislo").Visible = true;
                TRadGrid_sklady.MasterTableView.GetColumn("vyr_cislo").Visible = true;
                TRadGrid_sklady.MasterTableView.GetColumn("pomu_pozn").Visible = true;
            }
        }
        RadWindow1.Visible = false;
        RadWindow2.Visible = false;
    }

    protected void OpravaChybnych_Click(object sender, EventArgs e)
    {
        foreach (GridDataItem item in TRadGrid_pomucky_chybne.MasterTableView.Items)
        {
            DropDownList drop = (DropDownList)item["sklad"].Controls[1];
            string sklad = drop.SelectedValue;
            int id_vyd = item["id_vyd"].Text.ToString() != "&nbsp;" ? int.Parse(item["id_vyd"].Text.ToString().Trim()) : -1;
            int os_cislo = item["os_cislo"].Text.ToString() != "&nbsp;" ? int.Parse(item["os_cislo"].Text.ToString().Trim()) : -1;
            int cislo_pom = item["cislo_pom"].Text.ToString() != "&nbsp;" ? int.Parse(item["cislo_pom"].Text.ToString().Trim()) : -1;
            string cis_pomucky = item["cis_pomucky"].Text.ToString() != "&nbsp;" ? item["cis_pomucky"].Text.ToString().Trim() : "-1";
            string upd = "update pomu_zam set sklad = '" + sklad + "' where id_vyd = " + id_vyd + " and os_cislo = " + os_cislo + " and cislo_pom = " + cislo_pom + " and cis_pomucky = " + cis_pomucky;

            int poc = SqlPrikaz.ExecuteNonQuery(upd);
        }
        TRadGrid_pomucky_chybne.Rebind();
        TRadGrid_pomucky_chybne.Visible = false;
        TRadGrid_sklady.Visible = true;
        TRadGrid_sklady.Rebind();
    }

    protected void TRadGrid_pomucky_chybne_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            DropDownList drop = (DropDownList)((GridDataItem)e.Item)["sklad"].Controls[1];
            PracovniPomucky pom = new PracovniPomucky();
            DataTable sklady = pom.CislaSkladu();

            foreach (DataRow row in sklady.Rows)
            {
                drop.Items.Add(row["sklad"].ToString().Trim());
            }
        }
    }

    protected void TRadGrid_sklady_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem item = (GridDataItem)e.Item;
            float prij_mn = float.Parse(item["prij_mn"].Text.Trim());
            float vyd_mn = float.Parse(item["vyd_mn"].Text.Trim());
            float pocet_vydanych = float.Parse(item["pocet_vydanych"].Text.Trim());

            LinkButton prevest = ((GridDataItem)e.Item)["prevest"].FindControlRecursive<LinkButton>().FirstOrDefault();
            LinkButton zrusit = ((GridDataItem)e.Item)["zrusit"].FindControlRecursive<LinkButton>().FirstOrDefault();
            prevest.Visible = false;
            zrusit.Visible = false;

            if (pocet_vydanych != vyd_mn || vyd_mn > prij_mn || vyd_mn < 0)
            {
                e.Item.Style.Add("background", "#faada2");
                synchronizovano = false;             
                return;
            }

            if (prij_mn == 0)
            {
                e.Item.Style.Add("background", "#ffc96b");                        
                zrusit.Visible = true;
                return;
            }
           
            prevest.Visible = true;
        }        
    }

    protected void RB_Synchronizovat_Click(object sender, EventArgs e)
    {
        foreach (GridDataItem item in TRadGrid_sklady.MasterTableView.Items)
        {
            int cis_pol = item["cis_pol"].Text.ToString() != "&nbsp;" ? int.Parse(item["cis_pol"].Text.ToString().Trim()) : -1;
            string cis_pomucky = item["cis_pomucky"].Text.ToString() != "&nbsp;" ? item["cis_pomucky"].Text.ToString().Trim() : "-1";
            string sklad = item["sklad"].Text.ToString() != "&nbsp;" ? item["sklad"].Text.ToString().Trim() : "X";
            float prij_mn = item["prij_mn"].Text.ToString() != "&nbsp;" ? float.Parse(item["prij_mn"].Text.ToString().Trim()) : -1;
            float vyd_mn = item["vyd_mn"].Text.ToString() != "&nbsp;" ? float.Parse(item["vyd_mn"].Text.ToString().Trim()) : -1;
            float pocet_vydanych = item["pocet_vydanych"].Text.ToString() != "&nbsp;" ? float.Parse(item["pocet_vydanych"].Text.ToString().Trim()) : -1;

            if (pocet_vydanych != vyd_mn || vyd_mn > prij_mn || vyd_mn < 0)
            {
                vyd_mn = pocet_vydanych;
                if (prij_mn < vyd_mn) prij_mn = vyd_mn;

                string upd = "update pomu_sklad set prij_mn = '" + prij_mn + "', vyd_mn = '" + vyd_mn + "' " +
                              "where sklad = '" + sklad + "' and cis_pomucky = '" + cis_pomucky + "' and cis_pol = '" + cis_pol + "'";
                int poc = SqlPrikaz.ExecuteNonQuery(upd);

                if(poc == 0)
                {
                    string selPomu = "select sklad, cis_pomucky, cis_pol, id_cis1, id_pol1, vel1, id_cis2, id_pol2, vel2, znacka, model, inv_cislo, vyr_cislo, pomu_pozn, SUM(pocet) suma, cena" +
                        " from pomu_zam where sklad = '" + sklad + "' and cis_pomucky = '" + cis_pomucky + "' and cis_pol = '" + cis_pol + "'" +
                        "and dat_vrac is null and dat_stor is null " +
                        "group by sklad, cis_pomucky, cis_pol, id_cis1, id_pol1, vel1, id_cis2, id_pol2, vel2, znacka, model, inv_cislo, vyr_cislo, pomu_pozn, cena";
                    DataTable pomu = SqlPrikaz.ExecuteCommand(selPomu);
                    foreach(DataRow row in pomu.Rows)
                    {
                        ParametryPrikazu parms = new ParametryPrikazu();
                        SqlPrikaz.AddInParametr(parms, "sklad", DbType.String, sklad);
                        SqlPrikaz.AddInParametr(parms, "cis_pomucky", DbType.String, cis_pomucky);
                        SqlPrikaz.AddInParametr(parms, "cis_pol", DbType.Int32, cis_pol);
                        SqlPrikaz.AddInParametr(parms, "prij_mn", DbType.Int32, row["suma"]);
                        SqlPrikaz.AddInParametr(parms, "vyd_mn", DbType.Int32, row["suma"]);
                        SqlPrikaz.AddInParametr(parms, "cena", DbType.Int32, row["cena"]);
                        SqlPrikaz.AddInParametr(parms, "id_cis1", DbType.Int32, row["id_cis1"]);
                        SqlPrikaz.AddInParametr(parms, "id_pol1", DbType.Int32, row["id_pol1"]);
                        SqlPrikaz.AddInParametr(parms, "vel1", DbType.Int32, row["vel1"]);
                        SqlPrikaz.AddInParametr(parms, "id_cis2", DbType.Int32, row["id_cis2"]);
                        SqlPrikaz.AddInParametr(parms, "id_pol2", DbType.Int32, row["id_pol2"]);
                        SqlPrikaz.AddInParametr(parms, "vel2", DbType.Int32, row["vel2"]);
                        SqlPrikaz.AddInParametr(parms, "znacka", DbType.String, row["znacka"]);
                        SqlPrikaz.AddInParametr(parms, "model", DbType.String, row["model"]);
                        SqlPrikaz.AddInParametr(parms, "inv_cislo", DbType.String, row["inv_cislo"]);
                        SqlPrikaz.AddInParametr(parms, "vyr_cislo", DbType.String, row["vyr_cislo"]);
                        SqlPrikaz.AddInParametr(parms, "pomu_pozn", DbType.String, row["pomu_pozn"]);
                        string ins = "insert into pomu_sklad values(@sklad,@cis_pomucky,@cis_pol,@prij_mn,@vyd_mn,0,@cena,null,-1,@id_cis1,@id_pol1,@vel1,@id_cis2,@id_pol2,@vel2,@znacka,@model,@inv_cislo,@vyr_cislo,@pomu_pozn,null)";
                        SqlPrikaz.ExecuteNonQuery(ins, true, parms);
                    }
                }
            }
        }
        TRadGrid_sklady.Rebind();
    }

    protected void RB_Edit_Click(object sender, EventArgs e)
    {

    }

    protected void TRadGrid_sklady_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem item = (GridDataItem)e.Item;
            string sklad = item["sklad"].Text.Trim();
            string cis_pomucky = item["cis_pomucky"].Text.Trim();
            int cis_pol = int.Parse(item["cis_pol"].Text.Trim());

            if (e.CommandName == "zrusit")
            {
                smazZaznam(sklad, cis_pomucky, cis_pol);
                TRadGrid_sklady.Rebind();
            }
            else if (e.CommandName == "prevest")
            {
                RadWindow1.Visible = true;
                Label Puvodni_sklad = (Label)Panel1.FindControl("Puvodni_sklad");
                Label Puvodni_cis_pomucky = (Label)Panel1.FindControl("Puvodni_cis_pomucky");
                Label Puvodni_cis_pol = (Label)Panel1.FindControl("Puvodni_cis_pol");
                Label Puvodni_mnozstvi = (Label)Panel1.FindControl("Puvodni_mnozstvi");
                Label Label_nazev = (Label)Panel1.FindControl("Label_nazev");

                float prij_mn = float.Parse(item["prij_mn"].Text.Trim());
                float vyd_mn = float.Parse(item["vyd_mn"].Text.Trim());
                float mnozstvi = prij_mn - vyd_mn; //pouze mnozstvi ktere je mozne prevest
                string nazev = item["pomucka"].Text.Trim();

                Puvodni_sklad.Text = sklad;
                Puvodni_cis_pomucky.Text = cis_pomucky;
                Puvodni_cis_pol.Text = cis_pol.ToString();
                Puvodni_mnozstvi.Text = mnozstvi.ToString();
                Label_nazev.Text = nazev;

                DropDownList drop = (DropDownList)Panel1.FindControl("sklady");
                drop.Items.Clear();
                PracovniPomucky pom = new PracovniPomucky();
                DataTable sklady = pom.CislaSkladu(sklad);

                foreach (DataRow row in sklady.Rows)
                {
                    drop.Items.Add(row["sklad"].ToString().Trim());
                }
                if(drop.Items[0] != null) sklady_SelectedIndexChanged(sender, e);             
            }
            else if(e.CommandName == "editovat")
            {
                RadWindow2.Visible = true;
                Label Editace_sklad = (Label)Panel2.FindControl("Label14");
                Label Editace_cis_pomucky = (Label)Panel2.FindControl("Label16");
                Label Editace_cis_pol = (Label)Panel2.FindControl("Label18");
                Label Editace_mnozstvi = (Label)Panel2.FindControl("Label20");
                Label Editace_nazev = (Label)Panel2.FindControl("Label8");

                float prij_mn = float.Parse(item["prij_mn"].Text.Trim());
                float vyd_mn = float.Parse(item["vyd_mn"].Text.Trim());
                float mnozstvi = prij_mn - vyd_mn; //pouze mnozstvi ktere je mozne prevest
                string nazev = item["pomucka"].Text.Trim();

                Editace_sklad.Text = sklad;
                Editace_cis_pomucky.Text = cis_pomucky;
                Editace_cis_pol.Text = cis_pol.ToString();
                Editace_mnozstvi.Text = mnozstvi.ToString();
                Editace_nazev.Text = nazev;

                RadNumericTextBox TB_mnozstvi = (RadNumericTextBox)Panel2.FindControl("RadNumericTextBox1");
                TB_mnozstvi.Text = mnozstvi.ToString();
            }
        }
    }

    protected void smazZaznam(string sklad, string cis_pomucky, int cis_pol)
    {
        string sql = "delete from pomu_sklad where sklad = '" + sklad + "' and cis_pomucky = '" + cis_pomucky + "' and cis_pol = " + cis_pol;
        SqlPrikaz.ExecuteCommand(sql);
    }

    protected void sklady_SelectedIndexChanged(object sender, EventArgs e)
    {
        DropDownList drop = (DropDownList)Panel1.FindControl("sklady");
        Label Puvodni_cis_pomucky = (Label)Panel1.FindControl("Puvodni_cis_pomucky");
        Label Puvodni_cis_pol = (Label)Panel1.FindControl("Puvodni_cis_pol");
        Label Novy_cis_pomucky = (Label)Panel1.FindControl("Novy_cis_pomucky");
        Label Novy_cis_pol = (Label)Panel1.FindControl("Novy_cis_pol");
        Label Novy_mnozstvi = (Label)Panel1.FindControl("Novy_mnozstvi");
        RadNumericTextBox TB_mnozstvi = (RadNumericTextBox)Panel1.FindControl("TB_mnozstvi");

        string sklad = drop.SelectedValue.Trim();
        string cis_pomucky = Puvodni_cis_pomucky.Text.Trim();
        int cis_pol = int.Parse(Puvodni_cis_pol.Text.Trim());
        float presun_mn = 0;
        if (TB_mnozstvi != null)
        {
            presun_mn = !String.IsNullOrEmpty(TB_mnozstvi.Text.Trim()) ? float.Parse(TB_mnozstvi.Text.Trim()) : 0;
        }      
        float novy_mn = 0;

        Novy_cis_pomucky.Text = cis_pomucky;

        string sqlSel = "select * from pomu_sklad where sklad = '" + Puvodni_sklad.Text + "' and cis_pomucky = '" + cis_pomucky + "' and cis_pol = " + cis_pol;
        DataTable puvodni = SqlPrikaz.ExecuteCommand(sqlSel);

        sqlSel = "select cis_pol, prij_mn from pomu_sklad where sklad = '" + sklad + "' and cis_pomucky = '" + cis_pomucky + "'" +
        " and (id_cis1 = '" + puvodni.Rows[0]["id_cis1"] + "' or id_cis1 is null)" +
        " and (id_pol1 = '" + puvodni.Rows[0]["id_pol1"] + "' or id_pol1 is null)" +
        " and (vel1 = '" + puvodni.Rows[0]["vel1"] + "' or vel1 is null)" +
        " and (id_cis2 = '" + puvodni.Rows[0]["id_cis2"] + "' or id_cis2 is null)" +
        " and (id_pol2 = '" + puvodni.Rows[0]["id_pol2"] + "' or id_pol2 is null)" +
        " and (vel2 = '" + puvodni.Rows[0]["vel2"] + "' or vel2 is null)" +
        " and (znacka = '" + puvodni.Rows[0]["znacka"].ToString().Trim() + "' or znacka is null)" +
        " and (model = '" + puvodni.Rows[0]["model"].ToString().Trim() + "' or model is null)" +
        " and (inv_cislo = '" + puvodni.Rows[0]["inv_cislo"].ToString().Trim() + "' or inv_cislo is null)" +
        " and (vyr_cislo = '" + puvodni.Rows[0]["vyr_cislo"].ToString().Trim() + "' or vyr_cislo is null)" +
        " and (pomu_pozn = '" + puvodni.Rows[0]["pomu_pozn"].ToString().Trim() + "' or pomu_pozn is null)";
        DataTable pomucka = SqlPrikaz.ExecuteCommand(sqlSel);

        if(pomucka.Rows.Count > 0)
        {
            Novy_cis_pol.Text = pomucka.Rows[0]["cis_pol"].ToString().Trim();
            novy_mn = float.Parse(pomucka.Rows[0]["prij_mn"].ToString().Trim());
        }
        else
        {
            Novy_cis_pol.Text = "1";
        }

        float upd_mn = novy_mn + presun_mn;
        Novy_mnozstvi.Text = upd_mn.ToString();
        RadWindow1.Visible = true;
    }

    protected bool zkontrolujPocet()
    {
        Label Puvodni_mnozstvi = (Label)Panel1.FindControl("Puvodni_mnozstvi");
        float puvodni_mn = float.Parse(Puvodni_mnozstvi.Text.Trim());
        float presun_mn = 0;
        if (TB_mnozstvi != null)
        {
            presun_mn = !String.IsNullOrEmpty(TB_mnozstvi.Text.Trim()) ? float.Parse(TB_mnozstvi.Text.Trim()) : 0;
        }
        if (puvodni_mn < presun_mn)
        {
            //TB_mnozstvi.Text = puvodni_mn.ToString();
            Error.Text = "[%Nelze přesunout větší množstí než je na původním skladě volné.%]";
            RadWindow1.Visible = true;
            return false;
        }
        else
        {
            Error.Text = "";
            return true;
        }
    }

    protected void TB_mnozstvi_TextChanged(object sender, EventArgs e)
    {
        if (!zkontrolujPocet()) return;
        sklady_SelectedIndexChanged(sender, e);
    }

    protected void Button_prevest_Click(object sender, EventArgs e)
    {
        TB_mnozstvi_TextChanged(sender, e);
        if (!zkontrolujPocet()) return;
        if (String.IsNullOrEmpty(TB_mnozstvi.Text))
        {
            Error.Text = "[%Zadejte prosím množství.%]";
            return;
        }
        Error.Text = "";

        DropDownList drop = (DropDownList)Panel1.FindControl("sklady");
        string skladZe = Puvodni_sklad.Text;
        string cis_pomucky = Puvodni_cis_pomucky.Text;
        int cis_pol = int.Parse(Puvodni_cis_pol.Text);
        string skladKam = drop.SelectedValue;
        int cis_pol2 = int.Parse(Novy_cis_pol.Text);
        float kolik = float.Parse(TB_mnozstvi.Text.Trim());

        PracovniPomucky.PresunMeziSklady(skladZe,cis_pomucky,cis_pol,skladKam,cis_pol2,kolik);

        RadWindow1.Visible = false;
        TRadGrid_sklady.Rebind();
    }

    protected void Button_editovat_Click(object sender, EventArgs e)
    {
        string sklad = Label14.Text;
        string cis_pomucky = Label16.Text;
        int cis_pol = int.Parse(Label18.Text);
        float kolik = float.Parse(RadNumericTextBox1.Text.Trim());

        PracovniPomucky.zmenMnozstviNaSklade(sklad, cis_pomucky, cis_pol, kolik);

        RadWindow2.Visible = false;
        TRadGrid_sklady.Rebind();
    }
}
