﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram;
using KSProgram.Obecne;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram.Exceptions;
using KSProgram.Data;

public partial class Zamestnanec_PomuckySprava : TPageZam
{


    public Zamestnanec_PomuckySprava()
    {
        //IdPrava = 52;
        IdPrava = 340; //PH 30.9.2019
        this.HelpURL = "Pracovn%C3%AD_pom%C5%AFcky_%28KS_port%C3%A1l%29";

    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        // MZ 16.12.2015 Doplněno formátování podle parametru
        // --------------------------------------------------
        if (!IsPostBack)
        {
            GridDateTimeColumn naslVysl = (GridDateTimeColumn)TRadGrid_pomucky_narok.MasterTableView.GetColumnSafe("nasl_vyd");
            string zpusPer = KSProgram.Personal.PracovniPomucky.GetParametr_ZpusPer();
            if (zpusPer == "m")
            {
                naslVysl.DataFormatString = "{0:M\\/yyyy}";
            }

            var innerGrid = TRadGrid_pomucky_narok.MasterTableView.Items;


            this.DatePicker.SelectedDate = DateTime.Now; //pridavani pomucek
            this.TRadDatePicker1.SelectedDate = DateTime.Now; //storno/vracení ppomůcek 

        }
        bool sklady = Parametr_cti.Get("*pomucky_sklady") == "a";
        if (!sklady)
        {
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("sklad").Visible = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("sklad").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("sklad").Visible = false;
        }
        else
        {
            bool jinySklad = Parametr_cti.Get("pomucky_vr_jskl") == "a";
            if (!jinySklad) TRadButton5.Visible = false;
        }

        if (Zakaznik.HasModul(AppModul.Pomucky))
        {


            PracovniPomucky.Pomucka = "-1";


            if (Parametry.ParametrCti("PomuckyBezNaroku") == "a")
            {
                CheckBox_bezNar.Visible = true;
            }
            else
            {
                CheckBox_bezNar.Visible = false;
                velPomu.Visible = false;

            }
            //JO 5.12.2019
            if (CheckBox_bezNar.Checked)
            {
                velPomu.Visible = true;
                PracovniPomucky.VydejBezNaroku = true;

            }
            else
            {
                velPomu.Visible = false;
                PracovniPomucky.VydejBezNaroku = false;
                CheckBox_bezNar.Checked = false;

            }

            //JO 27.2.2020 HID:48251
            //JO 06.05.2021 HID:56593
            //if (Zakaznik.IsCurrent("PTACEK")) //přepsat na PTACEK
            if (!PracovniPomucky.CenaSchovej())
            {
                TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = true;
                TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("cena").Visible = true;
                TRadGrid_pomucky.MasterTableView.GetColumn("cena").Visible = true;
            }
            else
            {
                TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = false;
                TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = false;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("cena").Visible = false;
                TRadGrid_pomucky.MasterTableView.GetColumn("cena").Visible = false;
            }
        }
        if (HF_opened.Value == "true")
        {
            RadWindowOpen.Visible = true;
        }

        if (KSProgram.Prava.ZamykaniAgend.GeneralZamekIsLocked())
        {
            FailureLabel2.Text = KSProgram.Prava.ZamykaniAgend.GeneralZamekLockedMessage;
            VydejBtn.Enabled = false;
            SestavaBtn.Enabled = false;
            UpravitBtn.Enabled = false;
        }

        //13.5.2022 JH - HID 58637 - pridani novych sloupcu
        if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY") || Zakaznik.IsCurrent("KS-PROGRAM") || Zakaznik.IsCurrent("BLANKYT"))
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("znacka").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("model").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("pomu_pozn").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("EditCommandColumn").Visible = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("znacka").Visible = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("model").Visible = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("pomu_pozn").Visible = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("model").Visible = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("znacka").Visible = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("inv_cislo").Visible = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vyr_cislo").Visible = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("pomu_pozn").Visible = true;

            TDropDown1.Visible = false;
            LabelSklad.Visible = false;
        }
    }
    /// <summary>
    /// Metoda nastavuje proměnnou pro načítání při výdeji bez nároku, provádí se při odchodu ze stránky
    /// </summary>
    /// <param name="e"></param>
    protected override void OnUnload(EventArgs e)
    {
        base.OnUnload(e);
        PracovniPomucky.VydejBezNaroku = false;
        PracovniPomucky.Pomucka = "-1";

    }

    protected void DDL_CisloPomeru_SelectedIndexChanged(object sender, EventArgs e)
    {
        //string cisPom = DDL_CisloPomeru.Text;


        string cisPom = TDropDown.Text;
        ZdrojDatPomuckyNarok.SelectParameters["cisPom"].DefaultValue = cisPom;
        ZdrojDatPomuckyVydane.SelectParameters["cisPom"].DefaultValue = cisPom;
        //TGV_PomuckyNarok.DataBind();
        //TGV_PomuckyVydane.DataBind();

        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();
    }

    protected void CheckBox_CheckedChanged(object sender, EventArgs e)
    {
        if (CheckBox.Checked)
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_vrac").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_stor").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("duv_cis").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("prevod").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("sklad_vrac").Visible = true;
        }
        else
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_vrac").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_stor").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("duv_cis").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("prevod").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("sklad_vrac").Visible = false;
        }
        TRadGrid_pomucky_vydane.Rebind();
        this.RadWindowOpen.Visible = false;

    }
    /**/
    /// <summary>
    /// Metoda pro obsluhu výdeje pomůcky
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Button_Click(object sender, EventArgs e)
    {
        this.FailureLabel4.Visible = false;

        DateTime datum = Convert.ToDateTime(DatePickerStary.SelectedDate);
        bool bez_naroku = CheckBox_bezNarDisabled.Checked;
        // Decimal mnozstvi = Convert.ToDecimal(RadNumericTextBox1.Value);
        Decimal os_cislo = Convert.ToDecimal(KSProgram.Globals.OsCislo);
        String sklad_vychozi = null;
        short cis_pom = Convert.ToInt16(this.TDropDown.Text);

        //načtení ceny z textboxu
        decimal? cena = null;
        decimal mnozstvi = 1;
        string sklad = "";
        // JO 6.5.2021 HD:56593
        //if (Zakaznik.IsCurrent("PTACEK"))//PTACEK
        //if (PracovniPomucky.CenaSchovej())
        //{
        //    if (TBCena.Text != "") { cena = Convert.ToDecimal(TBCena.Value); }
        //}

        string pomucka = null;
        int perioda = 0;
        bool vystup = true;
        string chybovyText = "";
        //JO 29.1.2020
        string vel1 = "-1";
        string vel2 = "-1";
        if (sklad == "") { sklad = "X"; };
        string poznamka = null;
        string znacka = null;
        string model = null;
        string inv_cislo = null;
        string vyr_cislo = null;
        string pomu_pozn = null;
        int cis_pol = 0;

        //if (bezNarFlag)
        //{
        //    if (DropDownVel1.Text == "") { vel1 = "-1"; } else { vel1 = DropDownVel1.Text.Trim(); };
        //    if (DropDownVel2.Text == "") { vel2 = "-1"; } else { vel2 = DropDownVel2.Text.Trim(); };

        //}


        foreach (GridDataItem item in TRadGrid_pomuckyNar.MasterTableView.Items)
        {
            pomucka = item["pomucka"].Text.ToString().Trim(); // vrátí název vybrané pomůcky
            perioda = Convert.ToInt32(item["perioda"].Text);
            if (item["vel1"].Text == "&nbsp;") { vel1 = "-1"; } else { vel1 = item["vel1"].Text.Trim(); };
            if (item["vel2"].Text == "&nbsp;") { vel2 = "-1"; } else { vel2 = item["vel2"].Text.Trim(); };
            if (item["sklad"].Text == "&nbsp;") { sklad = sklad_vychozi; } else { sklad = item["sklad"].Text.Trim(); };
            if (item["mnozstvi"].Text == "&nbsp;") { mnozstvi = 1; } else { mnozstvi = Convert.ToDecimal(item["mnozstvi"].Text); };
            if (item["cis_pol"].Text == "&nbsp;") { cis_pol = 1; } else { cis_pol = Convert.ToInt32(item["cis_pol"].Text.Trim()); };
            if (item["poznamka"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["poznamka"].Text)) poznamka = item["poznamka"].Text.Trim();
            if (item["cena"].Text == "&nbsp;") { cena = null; } else { cena = Convert.ToDecimal(item["cena"].Text.Trim()); };

            if (item["znacka"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["znacka"].Text)) znacka = item["znacka"].Text.Trim();
            if (item["model"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["model"].Text)) model = item["model"].Text.Trim();
            if (item["inv_cislo"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["inv_cislo"].Text)) inv_cislo = item["inv_cislo"].Text.Trim();
            if (item["vyr_cislo"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["vyr_cislo"].Text)) vyr_cislo = item["vyr_cislo"].Text.Trim();
            if (item["pomu_pozn"].Text != "&nbsp;" && !String.IsNullOrEmpty(item["pomu_pozn"].Text)) pomu_pozn = item["pomu_pozn"].Text.Trim();

            if (!(Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY")) && item["sklad"].Text == "&nbsp;")
            {
                sklad = TDropDown1.SelectedValue;
            }

            string narok = item["narok"].Text;

            if (pomucka != null)
            {

                if (!bez_naroku)
                {
                    PracovniPomucky pom = new PracovniPomucky(); //obejiti non static metody
                    DataTable vydane_pomucky = pom.VydaneZamestnanci(Globals.OsCisloPomer.CisloPom, false);
                    decimal vydana_pocet = 0;
                    string pom_pomu = pomucka;
                    pom_pomu = pom_pomu.Substring(pom_pomu.IndexOf("-") + 1).Trim();

                    foreach (DataRow vydana in vydane_pomucky.Rows)
                    {
                        if (pom_pomu == vydana[24].ToString().Trim())
                        {
                            DataTable narok_pomu = pom.NarokZamestnance(Globals.OsCisloPomer.CisloPom);

                            foreach (DataRow row in narok_pomu.Rows)
                            {
                                string pomNazev = (string)row.ItemArray[16];
                                if (pomNazev.Trim() == pom_pomu)
                                {
                                    int count = 0;
                                    foreach (DataRow vydaneRow in vydane_pomucky.Rows)
                                    {
                                        string nazev = (String)vydaneRow.ItemArray[24];
                                        if (nazev.Trim() == pom_pomu) count++;
                                    }
                                    int narokPoc = (int)row.ItemArray[4];
                                    if (narokPoc <= count && String.IsNullOrEmpty(row["nasl_vyd"].ToString().Trim())) vydana_pocet += count;
                                    else if (narokPoc <= count && (DateTime)row["nasl_vyd"] > datum) vydana_pocet += count;
                                }
                            }
                        }
                    }


                    if (mnozstvi + vydana_pocet > int.Parse(narok))
                    {
                        this.FailureLabel2.Visible = true;
                        decimal vyd = int.Parse(narok) - vydana_pocet;
                        this.FailureLabel2.Text = "[%Vydávané množství%] " + pomucka + " [%je větší, než na které má zaměstnanec nárok%]! "
                            + "[%Zaměstnanec má aktuálně nárok nárok na%] " + vyd + ".";
                        RadWindowOpen.Visible = false;
                        TRadGrid_pomucky_narok.Rebind();
                        TRadGrid_pomucky_vydane.Rebind();
                        return;
                    }
                    try
                    {
                        vystup = PracovniPomucky.VydejPomucky(datum, mnozstvi, pomucka, perioda, cis_pom, sklad, cis_pol, cena, null, null, model, znacka, inv_cislo, vyr_cislo, pomu_pozn, poznamka);
                    }
                    catch (Exception exc)
                    {
                        FailureLabel2.Text = ReadGlobalResource.ZmenaTextu(pomucka + ": " + exc.Message);
                        FailureLabel2.Visible = true;
                    }
                }
                else
                {
                    try
                    {
                        vystup = PracovniPomucky.VydejPomuckyBezNar(datum, mnozstvi, pomucka, perioda, -1, cis_pom, sklad, cis_pol, bez_naroku, vel1, vel2, cena, null, null, null, model, znacka, inv_cislo, vyr_cislo, pomu_pozn, poznamka);
                    }
                    catch (Exception exc)
                    {
                        FailureLabel2.Text = ReadGlobalResource.ZmenaTextu(pomucka + ": " + exc.Message);
                        FailureLabel2.Visible = true;
                    }
                }
            }

        }


        if (!string.IsNullOrEmpty(chybovyText))
        {
            // this.FailureText3.Text = ReadGlobalResource.ZmenaTextu("[%Ve skladu není dostatečné množství. Pomůcka nebude vydána%]");
            throw new NoticeException(chybovyText);
            //this.FailureText3.Visible = true;
        }
        else
        {
            this.FailureText3.Text = "";
            this.FailureText3.Visible = false;
        }

        //  this.RadNumericTextBox1.Value = 1;
        this.DatePicker.SelectedDate = DateTime.Now;
        HF_opened.Value = "false";
        //string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
        //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", script, true);
        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();
        RadWindowOpen.Visible = false;
    }

    private bool ExistujePomucka(string sklad, Decimal cis_pomucky, int cis_pol, string znacka, string model, string inv_cis, string vyr_cislo, string pozn, double? cena)
    {
        string sql = "select prij_mn from pomu_sklad where cis_pomucky = " + cis_pomucky + " and cis_pol = " + cis_pol;
        if (!String.IsNullOrEmpty(sklad)) sql += " and sklad = '" + sklad + "'";
        if (!String.IsNullOrEmpty(znacka)) sql += " and znacka = '" + znacka + "'";
        if (!String.IsNullOrEmpty(model)) sql += " and model = '" + model + "'";
        if (!String.IsNullOrEmpty(inv_cis)) sql += " and inv_cislo = '" + inv_cis + "'";
        if (!String.IsNullOrEmpty(vyr_cislo)) sql += " and vyr_cislo = '" + vyr_cislo + "'";
        if (!String.IsNullOrEmpty(pozn)) sql += " and pomu_pozn = '" + pozn + "'";
        if (cena != null) sql += " and cena = '" + cena + "'";

        int? prij_mn = SqlPrikaz.ExecuteScalarInt32(sql);

        return prij_mn != null;
    }

    /**/
    /// <summary>
    /// Metoda pro obsluhu vracení pomůcky
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Vratit_Click(object sender, EventArgs e)
    {
        RW_Mazani_Vraceni.Visible = false;
        DateTime datum = Convert.ToDateTime(TRadDatePicker1.SelectedDate);
        Decimal os_cislo = Convert.ToDecimal(KSProgram.Globals.OsCislo);
        short cis_pom = Convert.ToInt16(this.TDropDown.Text);
        string pomucka = null;
        string sklad = JinySklad.Value;
        DateTime datumVyd = DateTime.Now;
        string datumVrac = null;
        string datumStorno = null;
        Decimal mnozstvi = 1;
        int index = 0;
        string duv_vrac = Convert.ToString(TDropDownDuvod.Text);
        int cis_pol = 1;
        Decimal cis_pomucky = 1;
        string model = null;
        string znacka = null;
        string inv_cislo = null;
        string vyr_cislo = null;
        string pomu_pozn = null;
        double? cena = null;

        foreach (GridDataItem item in TRadGrid_pomucky.MasterTableView.Items)
        {
            pomucka = item["pomucka"].Text.ToString(); // vrátí název vybrané pomůcky
            if(String.IsNullOrEmpty(sklad)) sklad = item["sklad"].Text.ToString();
            datumVyd = Convert.ToDateTime(item["dat_vyd"].Text.ToString());
            datumVrac = item["dat_vrac"].Text.ToString();
            datumStorno = item["dat_stor"].Text.ToString();
            mnozstvi = Convert.ToDecimal(item["pocet"].Text.ToString());
            index = Convert.ToInt32(item["id_vyd"].Text.ToString());
            cis_pol = Convert.ToInt32(item["cis_pol"].Text.ToString());
            cis_pomucky = Convert.ToDecimal(item["cislo_pomu"].Text.ToString());
            model = item["model"].Text.ToString() != "&nbsp;" ? item["model"].Text.ToString() : "";
            znacka = item["znacka"].Text.ToString() != "&nbsp;" ? item["znacka"].Text.ToString() : "";
            inv_cislo = item["inv_cislo"].Text.ToString() != "&nbsp;" ? item["inv_cislo"].Text.ToString() : "";
            vyr_cislo = item["vyr_cislo"].Text.ToString() != "&nbsp;" ? item["vyr_cislo"].Text.ToString() : "";
            pomu_pozn = item["pomu_pozn"].Text.ToString() != "&nbsp;" ? item["pomu_pozn"].Text.ToString() : "";
            cena = item["cena"].Text.ToString() != "&nbsp;" ? double.Parse(item["cena"].Text.ToString().Trim()) : 0;
            if (cena == 0) cena = null;


            if (datumVrac == "&nbsp;" && datumStorno == "&nbsp;") //pokud není již vyplněno dat_vrac a nebo dat_stor
            {
                if (pomucka != null) //pokud je něco vybráno proveď
                {

                    if (datum >= datumVyd)
                    {
                        if (!ExistujePomucka(sklad, cis_pomucky, cis_pol, znacka, model, inv_cislo, vyr_cislo, pomu_pozn, cena) && String.IsNullOrEmpty(Smazat.Value))
                        {
                            RW_Mazani_Vraceni.Visible = true;
                            return;
                        }

                        bool status = PracovniPomucky.Vraceni_pomucky(datum, pomucka, sklad, datumVyd, mnozstvi, index, os_cislo, cis_pom, null, false, duv_vrac, null, null, cis_pol, null, model.Trim(), znacka.Trim(), inv_cislo.Trim(), vyr_cislo.Trim(), pomu_pozn.Trim(), Smazat.Value == "true", cena);
                        if (status)
                        {
                            this.FailureLabel2.Text = "";
                            this.FailureLabel2.Visible = false;

                            TRadGrid_pomucky_vydane.Rebind();
                        }
                    }
                    else
                    {
                        this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Datum vrácení nesmí být nižší než výdeje%]");
                        this.FailureLabel2.Visible = true;
                    }
                }
            }
        }

        TRadGrid_pomucky_vydane.Rebind();
        this.TRadDatePicker1.SelectedDate = DateTime.Now;

        if (Smazat.Value == "true")
        {
            DataTable table = PracovniPomucky.ZkontrolujPomuckyBezPrijatych();
            if (table.Rows.Count > 0)
            {
                RW_Mazani_Prazdnych.Visible = true;
                return;
            }
        }

        string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
        ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", script, true);
    }

    /**/
    /// <summary>
    /// Metoda pro obsluhu storna pomůcky
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Storno_Click(object sender, EventArgs e)
    {
        DateTime datum = Convert.ToDateTime(TRadDatePicker1.SelectedDate);
        Decimal os_cislo = Convert.ToDecimal(KSProgram.Globals.OsCislo);
        short cis_pom = Convert.ToInt16(this.TDropDown.Text);
        string pomucka = null;
        string sklad = "";
        DateTime datumVyd = DateTime.Now;
        string dat_vrac = "";
        Nullable<DateTime> datumVrac = null;
        string datumStorno = null;
        Decimal mnozstvi = 1;
        int index = 0;
        bool status = false;
        int cis_pol = 1;
        string duv_vrac = null;
        string model = null;
        string znacka = null;
        string inv_cislo = null;
        string vyr_cislo = null;
        string pomu_pozn = null;

        //načtení zvolené pomůcky
        foreach (GridDataItem item in TRadGrid_pomucky.MasterTableView.Items)
        {
            pomucka = item["pomucka"].Text.ToString(); // vrátí název vybrané pomůcky
            sklad = item["sklad"].Text.ToString();
            datumVyd = Convert.ToDateTime(item["dat_vyd"].Text.ToString());
            datumStorno = item["dat_stor"].Text.ToString();
            mnozstvi = Convert.ToDecimal(item["pocet"].Text.ToString());
            dat_vrac = item["dat_vrac"].Text.ToString();
            index = Convert.ToInt32(item["id_vyd"].Text.ToString());
            cis_pol = (int)item.GetDataKeyValue("cis_pol");
            model = item["model"].Text.ToString() != "&nbsp;" ? item["model"].Text.ToString() : "";
            znacka = item["znacka"].Text.ToString() != "&nbsp;" ? item["znacka"].Text.ToString() : "";
            inv_cislo = item["inv_cislo"].Text.ToString() != "&nbsp;" ? item["inv_cislo"].Text.ToString() : "";
            vyr_cislo = item["vyr_cislo"].Text.ToString() != "&nbsp;" ? item["vyr_cislo"].Text.ToString() : "";
            pomu_pozn = item["pomu_pozn"].Text.ToString() != "&nbsp;" ? item["pomu_pozn"].Text.ToString() : "";

            if (datumStorno == "&nbsp;") //provede se jen když nemá datum storna již vyplněn
            {
                if (pomucka != null) //pokud je něco vybráno proveď
                {
                    if (dat_vrac == "&nbsp;") { datumVrac = null; } else { datumVrac = Convert.ToDateTime(dat_vrac); }//pokud není vyplněno datum vrácení

                    if (datumVrac != null && datum >= datumVrac)
                    {
                        status = PracovniPomucky.Vraceni_pomucky(datum, pomucka, sklad, datumVyd, mnozstvi, index, os_cislo, cis_pom, datumVrac, true, duv_vrac, null, null, cis_pol, null, model.Trim(), znacka.Trim(), inv_cislo.Trim(), vyr_cislo.Trim(), pomu_pozn.Trim());
                        this.FailureLabel2.Text = "";
                        this.FailureLabel2.Visible = false;
                    }
                    else
                    {
                        this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Datum storna nesmí být nižší než vrácení%]");
                        this.FailureLabel2.Visible = true;
                    }

                    if (datumVrac == null && datum >= DateTime.Now.Date)
                    {
                        status = PracovniPomucky.Vraceni_pomucky(datum, pomucka, sklad, datumVyd, mnozstvi, index, os_cislo, cis_pom, datumVrac, true, duv_vrac, null, null, cis_pol, null, model.Trim(), znacka.Trim(), inv_cislo.Trim(), vyr_cislo.Trim(), pomu_pozn.Trim());
                        this.FailureLabel2.Text = "";
                        this.FailureLabel2.Visible = false;
                    }
                    else
                    {
                        this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Datum storna nesmí být nižší než aktuální datum%]");
                        this.FailureLabel2.Visible = true;
                    }


                    if (status)
                    {
                        RadWindowOpen.Visible = false;
                        TRadGrid_pomucky_vydane.Rebind();
                        this.FailureLabel2.Visible = false;
                    }

                }
            }
        }

        this.TRadDatePicker1.SelectedDate = DateTime.Now;
        //string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
        //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", script, true);
    }
    /// <summary>
    /// Obsluha stisku tlačítka při převodu na jinou osobu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Prevest_Click(object sender, EventArgs e)
    {

        DateTime datum = Convert.ToDateTime(TRadDatePicker1.SelectedDate);
        Decimal os_cislo = Convert.ToDecimal(KSProgram.Globals.OsCislo);
        short cis_pom = Convert.ToInt16(this.TDropDown.Text);
        string pomucka = null;
        string sklad = "";
        DateTime datumVyd = DateTime.Now;
        string datumVrac = null;
        string datumStorno = null;
        Decimal mnozstvi = 1;
        Nullable<Decimal> os_cislo_nove = null;
        Nullable<int> cislo_pom_nove = null;
        int index = 0;
        int perioda = 0;
        string vel1 = "-1";
        string vel2 = "-1";
        int cis_pol = 1;
        decimal? cena = null;
        string model = null;
        string znacka = null;
        string inv_cislo = null;
        string vyr_cislo = null;
        string pomu_pozn = null;

        string duv_vrac = Convert.ToString(TDropDownDuvod.Text);

        foreach (GridDataItem item in VyberZamestnance.SelectedItems)
        {
            os_cislo_nove = Convert.ToDecimal(item["os_cislo"].Text.ToString());
            cislo_pom_nove = Convert.ToInt32(item["cislo_pom"].Text.ToString());
        }

        if (os_cislo_nove != null || cislo_pom_nove != null)
        {

            foreach (GridDataItem item in TRadGrid_pomucky.MasterTableView.Items)
            {
                pomucka = item["pomucka"].Text.ToString(); // vrátí název vybrané pomůcky
                sklad = item["sklad"].Text.ToString();
                datumVyd = Convert.ToDateTime(item["dat_vyd"].Text.ToString());
                datumVrac = item["dat_vrac"].Text.ToString();
                datumStorno = item["dat_stor"].Text.ToString();
                mnozstvi = Convert.ToDecimal(item["pocet"].Text.ToString());
                index = Convert.ToInt32(item["id_vyd"].Text.ToString());
                cis_pol = (int)item.GetDataKeyValue("cis_pol");

                // JO 6.5.2021 HD:56593
                //if (Zakaznik.IsCurrent("PTACEK"))//PTACEK
                if (!PracovniPomucky.CenaSchovej())
                {
                    if (item["cena"].Text.ToString() != "&nbsp;") { cena = Convert.ToDecimal(item["cena"].Text); };
                }
                if (item["perioda"].Text.ToString() == "&nbsp;") { perioda = 0; } else { perioda = Convert.ToInt32(item["perioda"].Text); };
                if (item["vel1"].Text.ToString() == "&nbsp;") { vel1 = "-1"; } else { vel1 = item["vel1"].Text.ToString().Trim(); };
                if (item["vel2"].Text.ToString() == "&nbsp;") { vel2 = "-1"; } else { vel2 = item["vel2"].Text.ToString().Trim(); };
                model = item["model"].Text.ToString() != "&nbsp;" ? item["model"].Text.ToString() : "";
                znacka = item["znacka"].Text.ToString() != "&nbsp;" ? item["znacka"].Text.ToString() : "";
                inv_cislo = item["inv_cislo"].Text.ToString() != "&nbsp;" ? item["inv_cislo"].Text.ToString() : "";
                vyr_cislo = item["vyr_cislo"].Text.ToString() != "&nbsp;" ? item["vyr_cislo"].Text.ToString() : "";
                pomu_pozn = item["pomu_pozn"].Text.ToString() != "&nbsp;" ? item["pomu_pozn"].Text.ToString() : "";

            }

            if (datumVrac == "&nbsp;" && datumStorno == "&nbsp;") //pokud není již vyplněno dat_vrac a nebo dat_stor
            {
                if (pomucka != null) //pokud je něco vybráno proveď
                {

                    if (datum >= datumVyd)
                    {

                        bool status = PracovniPomucky.Vraceni_pomucky(datum, pomucka, sklad, datumVyd, mnozstvi, index, os_cislo, cis_pom, null, false, duv_vrac, os_cislo_nove, (short)cislo_pom_nove, cis_pol, null, model.Trim(), znacka.Trim(), inv_cislo.Trim(), vyr_cislo.Trim(), pomu_pozn.Trim());
                        if (status)
                        {


                            //Zde pokračuji pokud se povedlo vratit, musím teď vydat znovu

                            bool vystup = PracovniPomucky.VydejPomuckyBezNar(datum, mnozstvi, pomucka, perioda, os_cislo_nove, (short)cislo_pom_nove, sklad, cis_pol, true, vel1, vel2, cena, null, -999, -999, model.Trim(), znacka.Trim(), inv_cislo.Trim(), vyr_cislo.Trim(), pomu_pozn.Trim());
                            if (!vystup)
                            {

                                this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Ve skladu není dostatečné množství. Pomůcka nebude vydána%]");
                                this.FailureLabel2.Visible = true;

                            }
                            else
                            {
                                //na konci refresh tabulek
                                this.FailureLabel2.Text = "";
                                this.FailureLabel2.Visible = false;

                                TRadGrid_pomucky_narok.Rebind();
                                TRadGrid_pomucky_vydane.Rebind();

                            }





                        }
                    }
                    else
                    {
                        this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Datum vrácení nesmí být nižší než výdeje%]");
                        this.FailureLabel2.Visible = true;


                    }
                }
            }
            RadWindowOpen.Visible = false;
            TRadGrid_pomucky_vydane.Rebind();
        }
        else
        {
            this.FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nebyl vybrán zaměstnanec pro převod%]!");
            this.FailureLabel2.Visible = true;



        }

        //string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
        //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", script, true);

    }
    /// <summary>
    /// Metoda zajišťuje obsluhu události při změně checkboxu bez nároku
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void CheckBox_BezNaroku_CheckedChanged(object sender, EventArgs e)
    {
        PracovniPomucky.VydejBezNaroku = CheckBox_bezNar.Checked;

        if (CheckBox_bezNar.Checked)
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("narok").Display = false;

        }
        else
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("narok").Display = true;

        }

        TRadGrid_pomucky_narok.Rebind();
        this.RadWindowOpen.Visible = false;
    }

    /// <summary>
    /// Metoda pro obsluhu události kliku na pomůcku a zobrazení detailu
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    protected void TRadGrid_pomucky_narok_ItemCommand(object source, GridCommandEventArgs e)
    {


        if (e.CommandName == "RowClick")
        {
            string pomucka = "-1";


            foreach (GridDataItem item in TRadGrid_pomucky_narok.SelectedItems)
            {
                pomucka = item["pomucka"].Text.ToString(); // vrátí název vybrané pomůcky  
                PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikostí
            }

        }

        // DropDownVel1.DataBind();
        //  DropDownVel2.DataBind();

    }
    private void CollapseAllRows()
    {
        foreach (GridItem item in TRadGrid_pomucky_narok.MasterTableView.Items)
        {
            item.Expanded = false;
        }
    }
    /// <summary>
    /// Metoda, pro přidání inv. čísla a vyr.čisla k vydané pomůcce
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void TRadGrid_pomucky_vydane_ItemCommand(object sender, GridCommandEventArgs e)
    {

        if (e.CommandName == "Update")
        {
            string inv_cislo = "";
            string vyr_cislo = "";
            string pomucka = "";
            string sklad = "";
            string poznamka = "";
            int index = -1;
            double? cena = null;

            foreach (GridDataItem item in TRadGrid_pomucky_vydane.EditItems)
            {
                // InPlace EditMode

                TextBox textBox2 = item["inv_cislo"].Controls[0] as TextBox;
                inv_cislo = textBox2.Text;
                textBox2 = item["vyr_cislo"].Controls[0] as TextBox;
                vyr_cislo = textBox2.Text;
                textBox2 = item["pomucka"].Controls[0] as TextBox;
                pomucka = textBox2.Text;
                textBox2 = item["sklad"].Controls[0] as TextBox;
                sklad = textBox2.Text;
                textBox2 = item["id_vyd"].Controls[0] as TextBox;
                index = Convert.ToInt32(textBox2.Text);
                textBox2 = item["poznamka"].Controls[0] as TextBox;
                poznamka = textBox2.Text;
                textBox2 = item["cena"].Controls[0] as TextBox;
                if (textBox2.Text.Trim() != "" && textBox2.Text.Trim() != "&nbsp;") cena = Convert.ToDouble(textBox2.Text.Trim());
                else cena = null;
            }

            if (vyr_cislo.Length > 30)
            {
                FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Zadané výrobní číslo je příliš dlouhé%]!");
                FailureLabel2.Visible = true;
                e.Canceled = true;
                return;
            }
            if (inv_cislo.Length > 20)
            {
                FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Zadané inventární číslo je příliš dlouhé%]!");
                FailureLabel2.Visible = true;
                e.Canceled = true;
                return;

            }

            FailureLabel2.Text = "";
            Decimal os_cislo = Convert.ToDecimal(KSProgram.Globals.OsCislo);
            short cis_pom = Convert.ToInt16(this.TDropDown.Text);

            if (PracovniPomucky.UlozVyrInvCislo(inv_cislo, vyr_cislo, os_cislo, cis_pom, pomucka, sklad, index, poznamka, cena))
            {
                TRadGrid_pomucky_vydane.Rebind();
            }

        }
        if (e.CommandName == "Cancel")
        {
            FailureLabel2.Text = "";
        }

    }
    /// <summary>
    /// Metoda zajišťuje zobrazování Popupu pro vracení
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void OpenWindow(object sender, EventArgs e)
    {

        VydejPomucek.Visible = false;
        VraceniPomucek.Visible = true;
        VyberZamestnance.Visible = true;
        // ovladaniVydej.Visible = false;
        //if (Zakaznik.IsCurrent("PTACEK")) //PTACEK JO 27.2.2020
        //if (PracovniPomucky.EditaceCeny()) //JO 6.5.2021 HD:56593 //11.5.2021 při vracení nemá cena co dělat
        //{
        //    cenaVydej.Visible = true;
        //}
        //else
        //{
        //    cenaVydej.Visible = false;
        //}

        string pomucka = null;
        string perioda = "";
        string inv_cislo, vyr_cislo, dat_vrac, dat_stor, cena, dat_exp;

        DataTable table = new DataTable();
        table.Columns.Add("id_vyd", typeof(int));
        table.Columns.Add("cis_pol", typeof(int));
        table.Columns.Add("cislo_pomu", typeof(int));
        table.Columns.Add("pomucka", typeof(string));
        table.Columns.Add("jednotka", typeof(string));
        table.Columns.Add("dat_vyd", typeof(string));
        table.Columns.Add("sklad", typeof(string));
        table.Columns.Add("pocet", typeof(decimal));
        table.Columns.Add("vel1", typeof(string));
        table.Columns.Add("vel2", typeof(string));
        table.Columns.Add("inv_cislo", typeof(string)); //JO 20.11.2019 - Doplněno inventární číslo a výrobní číslo do výpisu vydaných pomůcek
        table.Columns.Add("vyr_cislo", typeof(string));
        table.Columns.Add("dat_vrac", typeof(string));
        table.Columns.Add("dat_stor", typeof(string));
        table.Columns.Add("perioda", typeof(string));
        table.Columns.Add("cena", typeof(string));
        table.Columns.Add("dat_exp", typeof(string));
        table.Columns.Add("uziv", typeof(string));
        table.Columns.Add("podpis", typeof(string));
        if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY"))
        {
            table.Columns.Add("znacka", typeof(string)); //JH 13.5.2022 HID:58637
            table.Columns.Add("model", typeof(string)); //JH 13.5.2022 HID:58637
            table.Columns.Add("pomu_pozn", typeof(string)); //JH 13.5.2022 HID:58637
        }


        foreach (GridDataItem item in TRadGrid_pomucky_vydane.SelectedItems)
        {
            DataRow row = table.NewRow();
            row["id_vyd"] = Convert.ToInt32(item["id_vyd"].Text);
            row["cis_pol"] = (int)item.GetDataKeyValue("cis_pol");
            pomucka = item["pomucka"].Text.Trim(); // vrátí název vybrané pomůcky  
            row["pomucka"] = pomucka;
            row["jednotka"] = item["jednotka"].Text;
            row["cislo_pomu"] = item["cislo_pomu"].Text;
            row["dat_vyd"] = item["dat_vyd"].Text;
            row["sklad"] = item["sklad"].Text.Trim();
            row["pocet"] = Convert.ToDecimal(item["pocet"].Text);
            row["vel1"] = item["vel1"].Text;
            row["vel2"] = item["vel2"].Text;
            row["uziv"] = item["uziv"].Text;
            row["podpis"] = "";
            inv_cislo = item["inv_cislo"].Text;
            if (inv_cislo != "&nbsp;") { row["inv_cislo"] = inv_cislo; } else { row["inv_cislo"] = null; };
            vyr_cislo = item["vyr_cislo"].Text;
            if (vyr_cislo != "&nbsp;") { row["vyr_cislo"] = vyr_cislo; } else { row["vyr_cislo"] = null; };
            dat_vrac = item["dat_vrac"].Text;
            if (dat_vrac != "&nbsp;") { row["dat_vrac"] = dat_vrac; } else { row["dat_vrac"] = null; };
            dat_stor = item["dat_stor"].Text;
            if (dat_stor != "&nbsp;") { row["dat_stor"] = dat_stor; } else { row["dat_stor"] = null; };
            perioda = item["perioda"].Text;
            if (perioda != "&nbsp;") { row["perioda"] = perioda; } else { row["perioda"] = "0"; };
            cena = item["cena"].Text;
            if (cena != "&nbsp;") { row["cena"] = cena; } else { row["cena"] = null; };
            dat_exp = item["dat_exp"].Text;
            if (dat_exp != "&nbsp;") { row["dat_exp"] = dat_exp; } else { row["dat_exp"] = null; };
            if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY"))
            {
                row["model"] = item["model"].Text;
                row["znacka"] = item["znacka"].Text;
                row["pomu_pozn"] = item["pomu_pozn"].Text;
            }

            table.Rows.Add(row);
        }
        if (pomucka == null)
        {
            FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nebyla vybrána žádná pomůcka%]!");
            RadWindowOpen.Visible = false;
        }
        else
        {

            string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", script, true);

            FailureLabel2.Text = "";
            RadWindowOpen.Visible = true;
            TRadGrid_pomucky.DataSource = table;
        };

        TRadGrid_pomucky.MasterTableView.GetColumn("znacka").Visible = true;
        TRadGrid_pomucky.MasterTableView.GetColumn("model").Visible = true;
        TRadGrid_pomucky.MasterTableView.GetColumn("pomu_pozn").Visible = true;

        TRadGrid_pomucky.Rebind();
        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();
    }
    /// <summary>
    /// Metoda slouží pro správu otevírání popup okna během výdeje pomůcek
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void OpenWindowVydej(object sender, EventArgs e)
    {
        DateTime datum = Convert.ToDateTime(DatePicker.SelectedDate);

        if (!KSProgram.Funkce.Prac_pom.PlanostPomeru(Globals.OsCisloNeboZastupovany, Globals.OsCisloPomer.CisloPom, datum) || !KSProgram.Funkce.Prac_pom.PlanostPomeru(Globals.OsCisloNeboZastupovany, short.Parse(TDropDown.Text.Trim()), datum))
        {
            FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nelze vydávat po ukončení prac. poměru.%]");
            RadWindowOpen.Visible = false;
            return;
        }

        string pomucka = null;
        string posl_vyd, nasl_vyd, cena;

        VydejPomucek.Visible = true;
        VraceniPomucek.Visible = false;
        // if (Zakaznik.IsCurrent("PTACEK")) //PTACEK JO 27.2.2020
        if (PracovniPomucky.EditaceCeny()) //JO 6.5.2021 HD:56593
        {
            GridBoundColumn cenaSloupec = TRadGrid_pomuckyNar.MasterTableView.GetColumn("cena") as GridBoundColumn;
            cenaSloupec.ReadOnly = false;
            // cenaVydej.Visible = true;
        }
        else
        {
            GridBoundColumn cenaSloupec = TRadGrid_pomuckyNar.MasterTableView.GetColumn("cena") as GridBoundColumn;
            cenaSloupec.ReadOnly = true;
            //cenaVydej.Visible = false;
        }
        // ovladaniVydej.Visible = true;

        DataTable table = new DataTable();
        table.Columns.Add("id", typeof(string));
        table.Columns.Add("cis_pol", typeof(string));
        table.Columns.Add("pomucka", typeof(string));
        table.Columns.Add("mer_jedn", typeof(string));
        table.Columns.Add("narok", typeof(string));
        table.Columns.Add("perioda", typeof(string));
        table.Columns.Add("vel1", typeof(string));
        table.Columns.Add("vel2", typeof(string));
        table.Columns.Add("cena", typeof(string));
        table.Columns.Add("posl_vyd", typeof(string));
        table.Columns.Add("nasl_vyd", typeof(string));
        table.Columns.Add("sklad", typeof(string));
        table.Columns.Add("mnozstvi", typeof(int));
        table.Columns.Add("model", typeof(string)); //JH 20.5.2022 - HID 58637
        table.Columns.Add("znacka", typeof(string)); //JH 20.5.2022 - HID 58637
        table.Columns.Add("inv_cislo", typeof(string)); //JH 20.5.2022 - HID 58637
        table.Columns.Add("vyr_cislo", typeof(string)); //JH 20.5.2022 - HID 58637
        table.Columns.Add("pomu_pozn", typeof(string)); //JH 20.5.2022 - HID 58637
        table.Columns.Add("poznamka", typeof(string)); //JH 20.5.2022 - HID 58637

        foreach (GridDataItem item in TRadGrid_pomucky_narok.SelectedItems)
        {
            pomucka = item["pomucka"].Text.Trim(); // vrátí název vybrané pomůcky  

            if (OverNarok(item["pomucka_nazev"].Text.Trim(), datum)) //JH 17.12.2021 - ověřování nároku HD:58928
            {
                DataRow row = table.NewRow();
                row["id"] = item["id"].Text;
                string cis_pol = item["cis_pol"].Text.Trim();
                if (cis_pol != "&nbsp;") { row["cis_pol"] = cis_pol; } else { row["cis_pol"] = null; };
                row["pomucka"] = pomucka;
                row["mer_jedn"] = item["mer_jedn"].Text;
                row["narok"] = item["narok"].Text;
                row["perioda"] = item["perioda"].Text.Trim();
                row["vel1"] = item["vel1"].Text;
                row["vel2"] = item["vel2"].Text;
                row["poznamka"] = "";
                posl_vyd = item["posl_vyd"].Text;
                if (posl_vyd != "&nbsp;") { row["posl_vyd"] = posl_vyd; } else { row["posl_vyd"] = null; };
                nasl_vyd = item["nasl_vyd"].Text;
                if (nasl_vyd != "&nbsp;") { row["nasl_vyd"] = nasl_vyd; } else { row["nasl_vyd"] = null; };
                cena = item["cena"].Text;
                //nastavování ceny do textboxu
                if (cena != "&nbsp;")
                {
                    row["cena"] = cena;
                    //TBCena.Value = Convert.ToDouble(cena);
                }
                else
                {
                    row["cena"] = "";
                    //TBCena.Value = null;
                };
                row["mnozstvi"] = 1;
                //JH 20.5.2022 - HID 58637
                if (!String.IsNullOrEmpty(item["sklad"].Text)) row["sklad"] = item["sklad"].Text;
                if (!String.IsNullOrEmpty(item["model"].Text)) row["model"] = item["model"].Text;
                if (!String.IsNullOrEmpty(item["znacka"].Text)) row["znacka"] = item["znacka"].Text;
                if (!String.IsNullOrEmpty(item["inv_cislo"].Text)) row["inv_cislo"] = item["inv_cislo"].Text;
                if (!String.IsNullOrEmpty(item["vyr_cislo"].Text)) row["vyr_cislo"] = item["vyr_cislo"].Text;
                if (!String.IsNullOrEmpty(item["pomu_pozn"].Text)) row["pomu_pozn"] = item["pomu_pozn"].Text;

                table.Rows.Add(row);
            }
            else
            {
                FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nemáte nárok na%]" + " " + pomucka + ".");
                FailureLabel2.Visible = true;
                RadWindowOpen.Visible = false;
                return;
            }
        }

        if (pomucka == null)
        {
            FailureLabel2.Text = ReadGlobalResource.ZmenaTextu("[%Nebyla vybrána žádná pomůcka%]!");
            RadWindowOpen.Visible = false;
        }
        else
        {

            //načtení velikostí vybrané pomůcky  
            PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikost
                                               // DropDownVel1.DataBind();
                                               // DropDownVel2.DataBind();

            string script = "function f(){$find(\"" + RadWindowOpen.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", script, true);

            FailureLabel2.Text = "";
            RadWindowOpen.Visible = true;
            TRadGrid_pomuckyNar.DataSource = table;
            SessionInfo.SetVariable("PomuckyVydejDS", table);
            DatePickerStary.SelectedDate = DatePicker.SelectedDate;
            CheckBox_bezNarDisabled.Checked = CheckBox_bezNar.Checked;
            if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY"))
            {
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("model").Visible = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("znacka").Visible = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("inv_cislo").Visible = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("vyr_cislo").Visible = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("pomu_pozn").Visible = true;
            }
        }

        //nutné pro fungování visibility dropdownu
        try
        {
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2DD").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("skladDD").Display = false;
        }
        catch { }
        HF_opened.Value = "true";

        TRadGrid_pomuckyNar.Rebind();
        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();
    }

    private bool OverNarok(string pomucka, DateTime datum)
    {
        if (CheckBox_bezNar.Checked)
        {
            return true;
        }

        PracovniPomucky pracovniPomucky = new PracovniPomucky();
        DataTable narok = pracovniPomucky.NarokZamestnance(Globals.OsCisloPomer.CisloPom);
        DataTable vydane = pracovniPomucky.VydaneZamestnanci(Globals.OsCisloPomer.CisloPom, false);

        foreach (DataRow row in narok.Rows)
        {
            int posun = -1;
            if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY")) posun = 0;
            string pomNazev = row.ItemArray[17 + posun] != System.DBNull.Value ? row.ItemArray[17 + posun].ToString().Trim() : null;
            if (pomNazev == pomucka)
            {
                int count = 0;
                foreach (DataRow vydaneRow in vydane.Rows)
                {
                    string nazev = (String)vydaneRow.ItemArray[24];
                    if (nazev.Trim() == pomucka) count++;
                }
                int narokPoc = (int)row.ItemArray[5 + posun];
                DateTime posledni;
                if (row.ItemArray[7] != DBNull.Value)
                {
                    posledni = (DateTime)row.ItemArray[7];
                }
                else
                {
                    posledni = DateTime.Now.AddYears(-100);
                }
                if (narokPoc > count || posledni < datum) return true;
                else return false;
            }
        }
        return false;
    }

    protected void SestavaZobraz(object sender, EventArgs e)
    {



        //  VydejPomucek.Visible = false;
        // VraceniPomucek.Visible = true;
        //  VyberZamestnance.Visible = false;
        // ovladaniVydej.Visible = false;


        GridColumn sloupec = TRadGrid_pomucky.Columns[10];
        sloupec.Visible = false;
        sloupec = TRadGrid_pomucky.Columns[11];
        sloupec.Visible = false;

        string pomucka = null;
        string perioda = "";
        string inv_cislo, vyr_cislo, dat_vrac, dat_stor, cena, dat_exp, vel1, vel2, model, znacka, pomu_pozn;


        DataTable table = new DataTable();
        table.Columns.Add("id_vyd", typeof(int));
        table.Columns.Add("pomucka", typeof(string));
        table.Columns.Add("jednotka", typeof(string));
        table.Columns.Add("dat_vyd", typeof(string));
        table.Columns.Add("sklad", typeof(string));
        table.Columns.Add("pocet", typeof(decimal));
        table.Columns.Add("vel1", typeof(string));
        table.Columns.Add("vel2", typeof(string));
        table.Columns.Add("inv_cislo", typeof(string)); //JO 20.11.2019 - Doplněno inventární číslo a výrobní číslo do výpisu vydaných pomůcek
        table.Columns.Add("vyr_cislo", typeof(string));
        table.Columns.Add("dat_vrac", typeof(string));
        table.Columns.Add("dat_stor", typeof(string));
        table.Columns.Add("perioda", typeof(string));
        table.Columns.Add("cena", typeof(string));
        table.Columns.Add("dat_exp", typeof(string));
        table.Columns.Add("uziv", typeof(string));
        table.Columns.Add("podpis", typeof(string));

        table.Columns.Add("znacka", typeof(string)); //JH 23.5.2022 HID:58637
        table.Columns.Add("model", typeof(string)); //JH 23.5.2022 HID:58637
        table.Columns.Add("pomu_pozn", typeof(string)); //JH 23.5.2022 HID:58637




        foreach (GridDataItem item in TRadGrid_pomucky_vydane.SelectedItems)
        {
            DataRow row = table.NewRow();
            row["id_vyd"] = Convert.ToInt32(item["id_vyd"].Text);
            pomucka = item["pomucka"].Text.Trim(); // vrátí název vybrané pomůcky  
            row["pomucka"] = pomucka;
            row["jednotka"] = item["jednotka"].Text;
            row["dat_vyd"] = item["dat_vyd"].Text;
            row["sklad"] = item["sklad"].Text.Trim();
            row["pocet"] = Convert.ToDecimal(item["pocet"].Text);
            vel1 = item["vel1"].Text;
            if (vel1 != "&nbsp;") { row["vel1"] = vel1; } else { row["vel1"] = ""; };
            vel2 = item["vel2"].Text;
            if (vel2 != "&nbsp;") { row["vel2"] = vel2; } else { row["vel2"] = ""; };
            row["uziv"] = item["uziv"].Text;
            row["podpis"] = "";
            inv_cislo = item["inv_cislo"].Text;
            if (inv_cislo != "&nbsp;") { row["inv_cislo"] = inv_cislo; } else { row["inv_cislo"] = ""; };
            vyr_cislo = item["vyr_cislo"].Text;
            if (vyr_cislo != "&nbsp;") { row["vyr_cislo"] = vyr_cislo; } else { row["vyr_cislo"] = ""; };
            dat_vrac = item["dat_vrac"].Text;
            if (dat_vrac != "&nbsp;") { row["dat_vrac"] = dat_vrac; } else { row["dat_vrac"] = ""; };
            dat_stor = item["dat_stor"].Text;
            if (dat_stor != "&nbsp;") { row["dat_stor"] = dat_stor; } else { row["dat_stor"] = ""; };
            perioda = item["perioda"].Text;
            if (perioda != "&nbsp;") { row["perioda"] = perioda; } else { row["perioda"] = "0"; };
            cena = item["cena"].Text;
            if (cena != "&nbsp;") { row["cena"] = cena; } else { row["cena"] = ""; };
            dat_exp = item["dat_exp"].Text;
            if (dat_exp != "&nbsp;") { row["dat_exp"] = dat_exp; } else { row["dat_exp"] = ""; };

            model = item["model"].Text;
            if (model != "&nbsp;") { row["model"] = model; } else { row["model"] = ""; };
            znacka = item["znacka"].Text;
            if (znacka != "&nbsp;") { row["znacka"] = znacka; } else { row["znacka"] = ""; };
            pomu_pozn = item["pomu_pozn"].Text;
            if (pomu_pozn != "&nbsp;") { row["pomu_pozn"] = pomu_pozn; } else { row["pomu_pozn"] = ""; };



            table.Rows.Add(row);
        }
        if (pomucka == null) { FailureLabel2.Text = "[%Nebyla vybrána žádná pomůcka%]!"; FailureLabel2.Visible = true; }
        else
        {
            Session["VydejkaPomucky"] = table;
            exportPDF(sender, e);
        };

        TRadGrid_pomucky.Rebind();
        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();


    }

    protected void exportPDF(object sender, EventArgs e)
    {
        string Title = string.Empty;
        string Url = string.Empty;
        Url = "/Sestavy/Pomucky_Vydejka.aspx";
        Title = "[%Výdejka%]";
        int height = 700;
        int width = 900;

        if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
        {
            Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
        }
        else
        {
            string path = HttpContext.Current.Request.RawUrl;
            Url = path.Substring(0, path.Length - 30) + Url;
        }


        PopupParam popup = new PopupParam(this, Title, Url);
        popup.Status = true;
        popup.Toolbar = false;
        popup.Location = true;
        popup.Menubar = true;
        popup.Titulek = Title;
        popup.Height = height;
        popup.Width = width;
        popup.Show();

    }

    protected void TRadGrid_pomucky_vydane_DataBound(object sender, EventArgs e)
    {
        //JO 16.1.2020 Změna barvy položky pokud již byla stornována
        foreach (GridDataItem item in TRadGrid_pomucky_vydane.MasterTableView.Items)
        {
            string dat_stor = item["dat_stor"].Text.ToString(); // vrátí název vybrané pomůcky
            if (dat_stor != "&nbsp;")
            {
                item["pomucka"].ForeColor = System.Drawing.Color.Red;
            }

        }
    }

    protected void TRadGrid_pomucky_narok_ItemDataBound(object sender, GridItemEventArgs e)
    {

    }


    /// <summary>
    /// Metoda pro zpracování eventu na tabulce při úpravě velikostí
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    protected void TRadGrid_pomuckyNar_ItemCommand(object source, GridCommandEventArgs e)
    {

        string pomucka = "-1";
        string pomuckaEdit = "-1";

        if (e.CommandName == "Edit")
        {


            if (CheckBox_bezNar.Checked) //JO 6.5.2021 HD:56593
            {
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1").Display = false;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2").Display = false;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1DD").Display = true;
                TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2DD").Display = true;
            }


            GridItem editItems = e.Item;
            string velikost1 = editItems.Cells[7].Text.Trim();
            string velikost2 = editItems.Cells[8].Text.Trim();

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("sklad").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("skladDD").Display = true;

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("posl_vyd").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("nasl_vyd").Display = false;

            DataTable tab = (DataTable)SessionInfo.GetVariable("PomuckyVydejDS");
            DataRow row = tab.Rows[editItems.ItemIndex];
            try
            {
                row["znacka"] = editItems.Cells[8].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[8].Text;
            }
            catch { }

            try
            {
                row["model"] = editItems.Cells[9].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[9].Text;
            }
            catch { }
            try
            {               
                row["inv_cislo"] = editItems.Cells[11].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[11].Text;
            }
            catch { }

            try
            {
                row["vyr_cislo"] = editItems.Cells[12].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[12].Text;
            }
            catch { }

            //editItems.Cells[10].Text = editItems.Cells[10].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[10].Text;
            //editItems.Cells[11].Text = editItems.Cells[11].Text.ToString() == "&nbsp;" ? String.Empty : editItems.Cells[11].Text;


            pomucka = editItems.Cells[3].Text.ToString(); // vrátí název vybrané pomůcky
            pomuckaEdit = pomucka;
            if (pomucka != "&nbsp;")
            {
                PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikostí
            }
            else
            {
                PracovniPomucky.Pomucka = "-1"; //nastaví aktuálně vybranou pomůcku do velikostí
            }
            TRadGrid_pomuckyNar.DataSource = (DataTable)SessionInfo.GetVariable("PomuckyVydejDS");
            TRadGrid_pomuckyNar.Rebind();
        }

        if (e.CommandName == "Cancel")
        {//změna visibility
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2DD").Display = false;

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("sklad").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("skladDD").Display = false;

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("posl_vyd").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("nasl_vyd").Display = true;

            TRadGrid_pomuckyNar.DataSource = (DataTable)SessionInfo.GetVariable("PomuckyVydejDS");
            TRadGrid_pomuckyNar.Rebind();
        }

        if (e.CommandName == "Update")
        {//změna visibility
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("vel2DD").Display = false;

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("sklad").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("skladDD").Display = false;

            TRadGrid_pomuckyNar.MasterTableView.GetColumn("posl_vyd").Display = true;
            TRadGrid_pomuckyNar.MasterTableView.GetColumn("nasl_vyd").Display = true;

            GridEditableItem item = (GridEditableItem)e.Item;

            //načtení velikostí zvolených v dropdownu
            RadComboBox combo = (RadComboBox)item["vel1DD"].Controls[0];
            var vel1 = (string)combo.Text;
            combo = (RadComboBox)item["vel2DD"].Controls[0];
            var vel2 = (string)combo.Text;
            combo = (RadComboBox)item["skladDD"].Controls[0];
            var sklad = (string)combo.Text;

            if (!CheckBox_bezNar.Checked)
            {

                vel1 = "";
                vel2 = "";
            }
            if (vel1 == "")
            {
                vel1 = null;
            }
            if (vel2 == "")
            {
                vel2 = null;
            }
            if (sklad == "")
            {
                sklad = null;
            }

            DataTable tab = (DataTable)SessionInfo.GetVariable("PomuckyVydejDS");
            DataRow row = tab.Rows[item.ItemIndex];
            //  foreach (DataRow row in tab.Rows)
            //  {
            // if (row["pomucka"] == item["pomucka"])
            //  {
            if (!string.IsNullOrEmpty(vel1))
            {
                row["vel1"] = vel1;
            }
            if (!string.IsNullOrEmpty(vel2))
            {
                row["vel2"] = vel2;
            }
            if (!string.IsNullOrEmpty(sklad))
            {
                row["sklad"] = sklad;
            }

            try
            {
                TextBox mnozstvi = (TextBox)item["mnozstvi"].Controls[0];
                row["mnozstvi"] = Convert.ToInt32(mnozstvi.Text);
            }
            catch { }

            try
            {
                TextBox cena = (TextBox)item["cena"].Controls[0];
                row["cena"] = Convert.ToInt32(cena.Text);
            }
            catch { }

            try
            {
                TextBox znacka = (TextBox)item["znacka"].Controls[0];
                row["znacka"] = znacka.Text != "&nbsp;" ? znacka.Text : "";
            }
            catch { }

            try
            {
                TextBox model = (TextBox)item["model"].Controls[0];
                row["model"] = model.Text != "&nbsp;" ? model.Text : "";
            }
            catch { }

            try
            {
                TextBox poznamka = (TextBox)item["poznamka"].Controls[0];
                row["poznamka"] = poznamka.Text;
            }
            catch { }

            try
            {
                TextBox inv_cislo = (TextBox)item["inv_cislo"].Controls[0];
                row["inv_cislo"] = inv_cislo.Text != "&nbsp;" ? inv_cislo.Text : "";
            }
            catch { }

            try
            {
                TextBox vyr_cislo = (TextBox)item["vyr_cislo"].Controls[0];
                row["vyr_cislo"] = vyr_cislo.Text != "&nbsp;" ? vyr_cislo.Text : "";
            }
            catch { }

            //    }
            // }
            SessionInfo.SetVariable("PomuckyVydejDS", tab);
            TRadGrid_pomuckyNar.DataSource = tab;
            TRadGrid_pomuckyNar.Rebind();
            //int cislo_pomeru = Convert.ToInt32(TDropDown.Text);
            //pokud vrátí false ->zobrazit chybu že se něco nepovedlo
            if (vel1 == null && vel2 == null)
            {
                // MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Pro zvolenou pomůcku nejsou k dispozici žádné velikosti!%]"), WebControlHelper.ZmenaTextu("[%Určení velikostí%]"));
                return;
            }
            pomuckaEdit = PracovniPomucky.Pomucka;
            // if (pomuckaEdit != "-1")
            /*     if (!PracovniPomucky.ZmenaVelikosti(vel1, vel2, pomuckaEdit, cislo_pomeru))
                 {
                     MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Velikost se nepodařilo uložit!%]"), WebControlHelper.ZmenaTextu("[%Určení velikostí%]"));
                 }
           */
        }
    }

    protected void TRadGrid_pomuckyNar_DataBound(object sender, EventArgs e)
    {
        string pomucka = "-1";
        GridItemCollection editItems = TRadGrid_pomuckyNar.EditItems;
        if (editItems.Count > 0)
        {


            foreach (GridEditableItem item in editItems)
            {
                int index = item.ItemIndex;
                GridItem prvek = TRadGrid_pomuckyNar.MasterTableView.Items[index];
                pomucka = prvek.Cells[3].Text.ToString(); // vrátí název vybrané pomůcky  
                PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikostí
            }
        }
    }

    protected void TRB_Nemazat_Vraceni_Click(object sender, EventArgs e)
    {
        Smazat.Value = "false";
        Vratit_Click(sender, e);
    }

    protected void TRB_Smazat_Vraceni_Click(object sender, EventArgs e)
    {
        Smazat.Value = "true";
        Vratit_Click(sender, e);
    }

    protected void TRadButton3_Click(object sender, EventArgs e) //ANO
    {
        PracovniPomucky.ZnaplatniPrazdne();
        RW_Mazani_Prazdnych.Visible = false;
    }

    protected void TRadButton4_Click(object sender, EventArgs e) //NE
    {
        RW_Mazani_Prazdnych.Visible = false;
    }

    protected void VratitJinam_Click(object sender, EventArgs e)
    {
        RW_Jiny_Sklad.Visible = true;
    }

    protected void VratitJinamSklad_Click(object sender, EventArgs e)
    {
        RW_Jiny_Sklad.Visible = false;
        JinySklad.Value = TDropDown2.SelectedValue.Trim();
        Vratit_Click(sender, e);
    }
}
