﻿using KSProgram;
using KSProgram.Personal;
using KSProgram.WebControls;
using System;
using Telerik.Web.UI;


public partial class Zamestnanec_PomuckyVelikosti : TPageZam
{

    public Zamestnanec_PomuckyVelikosti()
    {
        IdPrava = 351;
        this.HelpURL = "Pracovn%C3%AD_pom%C5%AFcky_%28KS_port%C3%A1l%29";

    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        
        if (!IsPostBack)
        {
            //nutné pro fungování visibility dropdownu
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2DD").Display = false;
        }

        //JO 27.2.2020 HID:48251
        //JO 12.3.2021 HD 55734 skrytí sloupce
        //if (Zakaznik.IsCurrent("PTACEK") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM")) 
        if(!PracovniPomucky.CenaSchovej())
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = true;
        }
        else
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = false;
        }

        if (KSProgram.Prava.ZamykaniAgend.GeneralZamekIsLocked())
        {
            TRB_potvrzeniVelikosti.Enabled = false;
            Label_locked.Text = KSProgram.Prava.ZamykaniAgend.GeneralZamekLockedMessage;
        }

        PracovniPomucky.VydejBezNaroku = false;
    }

    protected void DDL_CisloPomeru_SelectedIndexChanged(object sender, EventArgs e)
    {
        string cisPom = TDropDown.Text;
        ZdrojDatPomuckyNarok.SelectParameters["cisPom"].DefaultValue = cisPom;
        TRadGrid_pomucky_narok.Rebind();

    }
    /// <summary>
    /// Globální proměnná pro uchování názvu pomůcky
    /// </summary>
   // public static string pomuckaEdit { get; set; }

    /// <summary>
    /// Metoda pro zpracování eventu na tabulce při úpravě velikostí
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    protected void TRadGrid_pomucky_narok_ItemCommand(object source, GridCommandEventArgs e)
    {

        string pomucka = "-1";
        string pomuckaEdit = "-1";

        if (e.CommandName == "Edit")
        {
            GridItem editItems = e.Item;
            string velikost1 = editItems.Cells[7].Text.Trim();
            string velikost2 = editItems.Cells[8].Text.Trim();

            //změna visibility
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1").Display = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2").Display = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1DD").Display = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2DD").Display = true;

            pomucka = editItems.Cells[5].Text.ToString(); // vrátí název vybrané pomůcky
            pomuckaEdit = pomucka;
            if (pomucka != "&nbsp;")
            {
                PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikostí
            }
            else
            {
                PracovniPomucky.Pomucka = "-1"; //nastaví aktuálně vybranou pomůcku do velikostí
            }
            TRadGrid_pomucky_narok.Rebind();
        }

        if (e.CommandName == "Cancel")
        {//změna visibility
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1").Display = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2").Display = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2DD").Display = false;
        }

        if (e.CommandName == "Update")
        {//změna visibility
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1").Display = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2").Display = true;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel1DD").Display = false;
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("vel2DD").Display = false;
            GridEditableItem item = (GridEditableItem)e.Item;

            //načtení velikostí zvolených v dropdownu
            RadComboBox combo = (RadComboBox)item["vel1DD"].Controls[0];
            var vel1 = (string)combo.Text;
            combo = (RadComboBox)item["vel2DD"].Controls[0];
            var vel2 = (string)combo.Text;

            if (vel1 == "")
            {
                vel1 = null;
            }
            if (vel2 == "")
            {
                vel2 = null;
            }

            int cislo_pomeru = Convert.ToInt32(TDropDown.Text);
            //pokud vrátí false ->zobrazit chybu že se něco nepovedlo
            if (vel1 == null && vel2 == null)
            {
                MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Pro zvolenou pomůcku nejsou k dispozici žádné velikosti!%]"), WebControlHelper.ZmenaTextu("[%Určení velikostí%]"));
                return;
            }
            pomuckaEdit = PracovniPomucky.Pomucka;
            if(pomuckaEdit!="-1")
            if (!PracovniPomucky.ZmenaVelikosti(vel1, vel2, pomuckaEdit,cislo_pomeru))
            {
                MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Velikost se nepodařilo uložit!%]"), WebControlHelper.ZmenaTextu("[%Určení velikostí%]"));
            }
        }
    }

    protected void TRadGrid_pomucky_narok_DataBound(object sender, EventArgs e)
    {
        string pomucka = "-1";
        GridItemCollection editItems = TRadGrid_pomucky_narok.EditItems;
        if (editItems.Count > 0)
        {


            foreach (GridEditableItem item in editItems)
            {
                int index = item.ItemIndex;
                GridItem prvek = TRadGrid_pomucky_narok.MasterTableView.Items[index];
                pomucka = prvek.Cells[3].Text.ToString(); // vrátí název vybrané pomůcky  
                PracovniPomucky.Pomucka = pomucka; //nastaví aktuálně vybranou pomůcku do velikostí
            }
        }
    }

    protected void TRB_potvrzeniVelikosti_Click(object sender, EventArgs e)
    {
        int cisPom = Convert.ToInt32(TDropDown.Text);
        decimal osCislo = Globals.OsCislo;
        PracovniPomucky.PotvrzeniVelikosti(osCislo,cisPom);
        TRadGrid_pomucky_narok.Rebind();
    }
}
