﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram;
using KSProgram.Personal;
using Telerik.Web.UI;
using System.Collections.Generic;
using KSProgram.WebControls;
using System.Drawing;
using KSProgram.Sestavy;
using KSPortal.Obecne;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Linq;

namespace KSPortal.Zamestnanec
{
    public partial class PracPomerMzd : TPageZam
    {
        public PracPomerMzd()
        {
            IdPrava = 164;
            this.HelpURL = "Pracovn%C3%AD_pom%C4%9Bry_-_mzdov%C3%A9_%C3%BAdaje_%28KS_port%C3%A1l%29";
        }

        private bool _pravoPriplatky = false;
        List<short> _priplatkyKody = null;
        List<short> _priplatkyAlgoritmy = null;
        protected string _priplatkyNazev = null;

        protected void BindTable2_Load(object sender, EventArgs e)
        {
            string typOrg = KSProgram.Funkce.Parametr_cti.Get("typ_org");
            if (typOrg != "r")
            {
                //nejedná se o rozpočtovou organizaci
                BindTable bTable = sender as BindTable;
                bTable.Rows[5].Visible = false;
                bTable.Rows[6].Visible = false;
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            if (!Zakaznik.IsCurrent("PHOENIX GROUP"))
            {
                _pravoPriplatky = KSProgram.Prava.PravaAkce.PristupPovolen(360);
                _priplatkyKody = Parametry.ParametrCti("Příplatky_Kódy")?.SplitToList<short>(',');
                _priplatkyAlgoritmy = Parametry.ParametrCti("Příplatky_Algoritmy")?.SplitToList<short>(',');

                _priplatkyKody = _priplatkyKody.Count == 0 ? null : _priplatkyKody;
                _priplatkyAlgoritmy = _priplatkyAlgoritmy.Count == 0 ? null : _priplatkyAlgoritmy;

                string pnazev = Parametry.ParametrCti("Příplatky_Název");

                _priplatkyNazev = string.IsNullOrEmpty(pnazev) ? ReadGlobalResource.ZmenaTextu("[%Příplatky%]") : pnazev;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            //PH 12.5.2020 HID:50312
            //-----------------------------------
            div_premie.Visible = Zakaznik.IsCurrent("PHOENIX GROUP") && (!string.IsNullOrEmpty(Parametry.ParametrCti("OdměnyKódy")));
            TRadGrid_priplatky.Visible = div_premie.Visible;
            if (div_premie.Visible)
                TRadGrid_priplatky.MasterTableView.Caption=KSProgram.Obecne.Slovnik.GetPreklad(Parametry.ParametrCti("OdměnyNázev"));
            //-----------------------------------           
        }

        protected void TRadGrid_priplatky_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (div_premie.Visible)
            {
                List<StrMzdPriplatky> list = DefSestavy_mzd_priplatky.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);
                TRadGrid_priplatky.DataSource = list;
                div_premie.Visible = list.Count > 0;
            }
        }

        //protected void TDataList1_ItemDataBound(object sender, DataListItemEventArgs e)
        //{
        //    if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        //    {
        //        BindTable BT_prem_cast = e.Item.FindControlRecursive<BindTable>("BindTable3");
        //        Decimal? prem_cast = DataBinder.Eval(e.Item.DataItem, "prem_cast") as Decimal?;
        //        if (BT_prem_cast != null)
        //            if (prem_cast.HasValue && prem_cast.Value > 0)
        //            {
        //                BT_prem_cast.Visible = true;
        //            }
        //            else
        //            {
        //                BT_prem_cast.Visible = false;
        //            }

        //        RadListView RLV_priplatky = e.Item.FindControlRecursive<RadListView>("RLV_priplatky");
        //        cislo_pom = DataBinder.Eval(e.Item.DataItem, "cislo_pom") as short?;
        //        if (RLV_priplatky != null)
        //        {
        //            RLV_priplatky.Visible = _pravoPriplatky;
        //            if (_pravoPriplatky)
        //                RLV_priplatky.Rebind();
        //        }
        //    }
        //}

        protected void RLV_pomery_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if(e.Item.ItemType == RadListViewItemType.DataItem || e.Item.ItemType == RadListViewItemType.AlternatingItem)
            {
                BindTable BT_prem_cast = e.Item.FindControlRecursive<BindTable>("BindTable3");
                Decimal? prem_cast = DataBinder.Eval(((RadListViewDataItem)e.Item).DataItem, "prem_cast") as Decimal?;
                if (BT_prem_cast != null)
                    if (prem_cast.HasValue && prem_cast.Value > 0)
                    {
                        BT_prem_cast.Visible = true;
                    }
                    else
                    {
                        BT_prem_cast.Visible = false;
                    }

                RadListView RLV_priplatky = e.Item.FindControlRecursive<RadListView>("RLV_priplatky");
                cislo_pom = DataBinder.Eval(((RadListViewDataItem)e.Item).DataItem, "cislo_pom") as short?;
                if (RLV_priplatky != null)
                {
                    RLV_priplatky.Visible = _pravoPriplatky;
                    if (_pravoPriplatky)
                        RLV_priplatky.Rebind();
                }
            }
        }
        short? cislo_pom = null;
        protected void RLV_priplatky_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            if (cislo_pom != null && _pravoPriplatky)
            {
                RadListView RLV_priplatky = sender as RadListView;
                List<KSProgram.Premie.Priplatek> priplateks = KSProgram.Premie.Priplatky.GetPriplatkyVObdobi(Globals.AktObdobi, Globals.OsCislo, cislo_pom, _priplatkyKody, _priplatkyAlgoritmy);
                RLV_priplatky.DataSource = priplateks;
                RLV_priplatky.Visible = priplateks.Count > 0;
                cislo_pom = null;
            }
        }

        protected void TRB_aktivni_switch_CheckedChanged(object sender, EventArgs e)
        {
            RLV_pomery.Rebind();
        }
    }
}
