﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using System.Data;
using KSProgram.Ciselniky;
using KSProgram.Data;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram.Extensions;

namespace KSPortal.Zamestnanec
{
    public partial class PracovniPostup : TPage
    {
        public PracovniPostup()
        {
            IdPrava = 232;
            EnableVisibleSeznamZam = true;
            this.HelpURL = "Pracovn%C3%AD_postup_%28KS_port%C3%A1l%29";
        }
        /// <summary>
        /// HID:52617 Možná prozatimní řešení zobracení správné měny (EUR) ve slovenských databázích v numeric sloupcích typu Currency
        /// </summary>
        protected override void InitializeCulture()
        {
            base.InitializeCulture();

            if (!IsPostBack && Zakaznik.IsSR())
            {
                this.Culture = "sk-SK";
            }
        }
        private DateTime? rutina_od
        {
            get
            {
                object o = SessionInfo.GetVariable("rutina_od");
                if (o != null)
                {
                    return (DateTime?)o;
                }
                else
                {
                    DateTime? ret = null;
                    DateTime d;
                    if (DateTime.TryParse(Zakaznik.GetProperty("rutina_od"), out d))
                    {
                        ret = d;
                    }
                    else
                    {
                        ret = SqlPrikaz.ExecuteScalar<DateTime?>("select min(datum) from pom_zal");
                    }
                    SessionInfo.SetVariable("rutina_od", ret);
                    return ret;
                }
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            if (!IsPostBack)
            {
                TRG_postup.MasterTableView.GetColumn("poznamka").Visible = KSProgram.Prava.PravaAkce.PristupPovolen(395);
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
        }

        protected void TRG_postup_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {

            DataTable table = KSProgram.Funkce.Prac_postup.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, null);
            if(table == null || table.Rows.Count == 0)
            {
                TRG_postup.DataSource = new DataTable();
                RadHtmlChart1.Visible = false;
                return;
            }

            RadHtmlChart1.Visible = true;

            table.Columns.Add("id", typeof(int));
            table.Columns.Add("naz_str", typeof(string));
            table.Columns.Add("naz_pracmist", typeof(string));
            table.Columns.Add("typ_mzdy_n", typeof(string));
            table.Columns.Add("jkz_n", typeof(string));
            table.Columns.Add("prac_kateg_n", typeof(string));
            table.Columns.Add("typ_kal_n", typeof(string));
            table.Columns.Add("smena_n", typeof(string));

            table.Columns.Add("naz_str_b_", typeof(bool));
            table.Columns.Add("naz_pracmist_b_", typeof(bool));
            table.Columns.Add("trida_b_", typeof(bool));
            table.Columns.Add("mzd_stup_b_", typeof(bool));
            table.Columns.Add("tarif_b_", typeof(bool));
            table.Columns.Add("os_hodn_b_", typeof(bool));
            table.Columns.Add("prem_cast_b_", typeof(bool));
            table.Columns.Add("typ_mzdy_n_b_", typeof(bool));
            table.Columns.Add("hod_uvazek_b_", typeof(bool));
            table.Columns.Add("jkz_n_b_", typeof(bool));
            table.Columns.Add("prac_kateg_n_b_", typeof(bool));
            table.Columns.Add("typ_kal_n_b_", typeof(bool));
            table.Columns.Add("smena_n_b_", typeof(bool));

            CisStredisko c_stred = new CisStredisko();
            TDataTable t_stred = c_stred.VsechnaStrediskaAll(new DateTime(), false);
            DataTable t_pracmist = KSProgram.PracovniMista.PracMista.SeznamPMall(null);
            DataTable t_jkz = CisKzam.Seznam(false);
            DataTable t_prac_kateg = CisPracKateg.Seznam(false);

            DataRow pre = null;
            Int32 id = 0;
            foreach (DataRow row in table.Rows)
            {
                row["id"] = id;
                id++;
                string prac_str = GetNullOrData.GetString(row["prac_str"]);
                DataRow[] f_stred = t_stred.Select("str='" + prac_str + "'");
                row["naz_str"] = f_stred.Length > 0 ? f_stred[0]["nazev"] : DBNull.Value;

                int? id_pracmist = GetNullOrData.GetInt32(row["id_pracmist"]);
                if (id_pracmist != null)
                {
                    DataRow[] f_pracmist = t_pracmist.Select("id=" + id_pracmist.Value.ToString());
                    row["naz_pracmist"] = f_pracmist.Length > 0 ? f_pracmist[0]["nazev"] : DBNull.Value;
                }

                short? typ_mzdy = GetNullOrData.GetInt16(row["typ_mzdy"]);
                if (typ_mzdy != null)
                {
                    row["typ_mzdy_n"] = CisTypMzdy.Nazev((short)typ_mzdy);
                }

                int? jkz = GetNullOrData.GetInt32(row["jkz"]);
                if (jkz != null)
                {
                    DataRow[] f_jkz = t_jkz.Select("cislo=" + jkz.Value.ToString());
                    row["jkz_n"] = f_jkz.Length > 0 ? f_jkz[0]["nazev"] : DBNull.Value;
                }

                short? prac_kateg = GetNullOrData.GetInt16(row["prac_kateg"]);
                if (prac_kateg != null)
                {
                    DataRow[] f_prac_kateg = t_prac_kateg.Select("cislo=" + prac_kateg.Value.ToString());
                    row["prac_kateg_n"] = f_prac_kateg.Length > 0 ? f_prac_kateg[0]["nazev"] : DBNull.Value;
                }

                short? typ_kal = GetNullOrData.GetInt16(row["typ_kal"]);
                if (typ_kal != null)
                {
                    row["typ_kal_n"] = CisPracRozvrh.NazevKalendare((short)typ_kal);

                    short? smena = GetNullOrData.GetInt16(row["smena"]);
                    if (smena != null)
                    {
                        row["smena_n"] = CisPracRozvrh.NazevRozvrhu((short)typ_kal, (short)smena);
                    }
                }

                if (pre != null)
                {
                    foreach (DataColumn coll in table.Columns)
                    {
                        if (table.Columns.Contains(coll.ColumnName + "_b_"))
                        {
                            row[coll.ColumnName + "_b_"] = row[coll].ToString() != pre[coll].ToString();
                        }
                    }
                }

                pre = row;
            }

            // odstraněí zaznamů z postupu před uzivanim KS-mzdy HID:46552
            if (Parametry.ParametrCti("PracPostupOmezeni") == "a")
            {
                DateTime? start = rutina_od;
                if (start != null)
                {
                    for (int i = table.Rows.Count - 1; i >= 0; i--)
                    {
                        DateTime? pl_od = GetNullOrData.GetDateTime(table.Rows[i]["platnost_od"]);
                        DateTime? pl_do = GetNullOrData.GetDateTime(table.Rows[i]["platnost_do"]);
                        if (pl_od < start && start < pl_do)
                        {
                            table.Rows[i]["platnost_od"] = start;
                        }
                        else if (pl_do <= start)
                        {
                            table.Rows.RemoveAt(i);
                        }
                    }
                }
            }

            if (!KSProgram.Prava.PravaAkce.PristupPovolen(407))
            {
                var akt_obdobi_zam = ViceIco.ObdobiPodnikuPodleZamestnance(Globals.OsCislo);
                var odfiltrovano = table
                    .AsEnumerable()
                    .ToList()
                    .FindAll(row => GetNullOrData.GetDateTime(row["platnost_od"]) < akt_obdobi_zam)
                    .OrderBy(row => GetNullOrData.GetDateTime(row["platnost_od"]));

                if (odfiltrovano != null && odfiltrovano.Count() > 0)
                {
                    table = odfiltrovano.CopyToDataTable();
                }
                else
                {
                    table.Rows.Clear();
                }
            }

            TRG_postup.DataSource = table;

            if (table.Rows.Count > 0)
            {
                Decimal max_tarif = table.AsEnumerable().Max(x => GetNullOrData.GetDecimal(x["tarif"], 0));
                Decimal max_os_hodn = table.AsEnumerable().Max(x => GetNullOrData.GetDecimal(x["os_hodn"], 0));
                Decimal max_prem_cast = table.AsEnumerable().Max(x => GetNullOrData.GetDecimal(x["prem_cast"], 0));

                RadHtmlChart1.PlotArea.YAxis.MaxValue = getYAxisMaximum(new List<decimal>() { max_tarif, max_os_hodn, max_prem_cast }.Max());

                //RadHtmlChart1.PlotArea.XAxis.AxisCrossingPoints[1].Value = 10;
                bool oshodnaded = false;
                if ((max_tarif > 0 && max_os_hodn > 0) && (max_tarif > max_os_hodn ? max_os_hodn / max_tarif : max_tarif / max_os_hodn) < 0.05m)
                {
                    AxisY aditional = new AxisY();
                    aditional.Name = "max_os_hodnAxis";
                    aditional.Width = new Unit(3, UnitType.Pixel);

                    RadHtmlChart1.PlotArea.YAxis.MaxValue = getYAxisMaximum(new List<decimal>() { max_tarif, max_prem_cast }.Max());
                    aditional.MaxValue = getYAxisMaximum(max_os_hodn);

                    aditional.LabelsAppearance.DataFormatString = "{0:N0}";
                    RadHtmlChart1.PlotArea.Series[1].AxisName = "max_os_hodnAxis";
                    int i;
                    if (!ContainYAxis(aditional.Name, out i))
                        RadHtmlChart1.PlotArea.AdditionalYAxes.Add(aditional);
                    oshodnaded = true;
                }
                else
                {
                    RadHtmlChart1.PlotArea.Series[1].AxisName = "";
                    int i;
                    if (ContainYAxis("max_os_hodnAxis", out i))
                        RadHtmlChart1.PlotArea.AdditionalYAxes.RemoveAt(i);
                }

                if ((max_tarif > 0 && max_prem_cast > 0) && (max_tarif > max_prem_cast ? max_prem_cast / max_tarif : max_tarif / max_prem_cast) < 0.05m)
                {
                    if (oshodnaded)
                    {
                        RadHtmlChart1.PlotArea.Series[2].AxisName = "max_os_hodnAxis";
                        RadHtmlChart1.PlotArea.YAxis.MaxValue = getYAxisMaximum(max_tarif);
                        RadHtmlChart1.PlotArea.AdditionalYAxes[0].MaxValue = getYAxisMaximum(new List<decimal>() { max_prem_cast, max_os_hodn }.Max());
                    }
                    else
                    {
                        AxisY aditional = new AxisY();
                        aditional.Name = "max_prem_castAxis";
                        aditional.Width = new Unit(3, UnitType.Pixel);

                        RadHtmlChart1.PlotArea.YAxis.MaxValue = getYAxisMaximum(new List<decimal>() { max_tarif, max_os_hodn }.Max());
                        aditional.MaxValue = getYAxisMaximum(max_prem_cast);

                        aditional.LabelsAppearance.DataFormatString = "{0:N0}";
                        RadHtmlChart1.PlotArea.Series[2].AxisName = "max_prem_castAxis";
                        int i;
                        if (!ContainYAxis(aditional.Name, out i))
                            RadHtmlChart1.PlotArea.AdditionalYAxes.Add(aditional);
                    }
                }
                else
                {
                    RadHtmlChart1.PlotArea.Series[2].AxisName = "";
                    int i;
                    if (ContainYAxis("max_prem_castAxis", out i))
                        RadHtmlChart1.PlotArea.AdditionalYAxes.RemoveAt(i);
                }



                DataTable chart_source = table.Copy();

                DateTime? min_platnost_od = chart_source.AsEnumerable().Min(x => GetNullOrData.GetDateTime(x["platnost_od"]));
                DateTime? max_platnost_od = chart_source.AsEnumerable().Max(x => GetNullOrData.GetDateTime(x["platnost_od"]));
                DateTime? max_platnost_do = chart_source.AsEnumerable().Max(x => GetNullOrData.GetDateTime(x["platnost_do"]));

                if (chart_source.Rows.Count > 0 && (!max_platnost_do.HasValue || (max_platnost_do.Value < max_platnost_od.Value && max_platnost_od.Value < DateTime.Now)))
                {
                    DataRow n_row = chart_source.Rows.Add(chart_source.Rows[chart_source.Rows.Count - 1].ItemArray);
                    n_row["platnost_od"] = DateTime.Now.Date;

                    max_platnost_od = chart_source.AsEnumerable().Max(x => GetNullOrData.GetDateTime(x["platnost_od"]));
                }

                RadHtmlChart1.PlotArea.XAxis.LabelsAppearance.Step = (max_platnost_od - min_platnost_od)?.Days <= 365 ? 1 : (((max_platnost_od - min_platnost_od)?.Days / 3658) + 1) * 12 ?? 12;

                RadHtmlChart1.PlotArea.XAxis.AxisCrossingPoints[1].Value = (decimal?)((max_platnost_od?.Month - min_platnost_od?.Month) + 12 * (max_platnost_od?.Year - min_platnost_od?.Year) + 1) ?? 0;

                RadHtmlChart1.DataSource = chart_source;
                RadHtmlChart1.DataBind();

            }
        }

        private decimal getYAxisMaximum(decimal x)
        {
            if (x == 0)
                return 10;

            int r = 0;
            decimal pom = x;
            while (pom >= 1)
            {
                r++;
                pom = pom / 10m;
            }

            decimal multiple = Convert.ToDecimal(Math.Pow(Convert.ToDouble(10), Convert.ToDouble((r - 1))));

            decimal max = x.MRound(multiple, 2);

            while((max / x) <= 1.15m)
            {
                max = max + (multiple / 10);
            }

            return max;
        }

        private bool ContainYAxis(string name, out int i)
        {
            for (i = 0; i < RadHtmlChart1.PlotArea.AdditionalYAxes.Count; i++)
            {
                if (RadHtmlChart1.PlotArea.AdditionalYAxes[i].Name == name)
                {
                    return true;
                }
            }
            i = -1;
            return false;
        }

        protected void TRG_postup_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
            {
                RadGrid table = (RadGrid)sender;
                System.Drawing.Color back = e.Item.ItemType == GridItemType.Item ? System.Drawing.Color.FromArgb(246, 246, 246) : System.Drawing.Color.FromArgb(237, 237, 237);

                foreach (DataColumn coll in ((DataRow)((DataRowView)((GridDataItem)e.Item).DataItem).Row).Table.Columns)
                {
                    if (coll.ColumnName.Contains("_b_"))
                    {
                        if ((string)((object)((DataRow)((DataRowView)((GridDataItem)e.Item).DataItem).Row)[coll.ColumnName]).ToString() == ((object)true).ToString())
                        {
                            ((GridDataItem)e.Item)[coll.ColumnName.Replace("_b_", "")].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);
                        }
                    }
                }
            }
        }

    }
}