﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Data;
using System.IO;
using Telerik.Web.UI;
using KSProgram.Obecne;

public partial class Zamestnanec_PrukazyVzdel : TPageZam
{
    public Zamestnanec_PrukazyVzdel()
    {
        IdPrava = 110;
        this.HelpURL = "Pr%C5%AFkazy_%28KS_port%C3%A1l%29";
    }

    protected void TRadGridPrukazyVzdel_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem item = (GridDataItem)e.Item;
            Int32? lIdBlob = GetNullOrData.GetInt32(item.GetDataKeyValue("id_blob"));
            string lUloziste = GetNullOrData.GetString(item.GetDataKeyValue("sdilene_uloziste"));

            if (lIdBlob == null && lUloziste == null)
            {
                TLinkButton lbl = (TLinkButton)item.FindControl("TLinkButtonDok");//accessing Label
                lbl.Visible = false; // Potlačení textu pro zobrazení dokumentu když neexistuje
            }
        }
    }

    //protected void TRadGridPrukazyVzdel_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    TRadGrid grid = (TRadGrid)sender;
    //    if (grid == null) return;

    //    if ( grid.SelectedIndexes.Count == 1  )
    //    {
    //        string str_id = grid.SelectedIndexes[0];
    //        int int_id;
    //        if (Int32.TryParse(str_id, out int_id))
    //        {
    //            DataTable table = GetData();
    //            DataRow row = table.Rows[int_id];

    //            string docName = row["nazev_soubor"].ToString();
    //            if (string.IsNullOrEmpty(docName))
    //                throw new KSProgram.Exceptions.NoticeException("Neznámý typ souboru.");
    //            docName = docName.Trim();

    //            //Načítán data z blobu
    //            int idBlob = GetNullOrData.GetInt32(row["id_blob"], 0);
    //            if (idBlob > 0)
    //            {
    //                string selectSql = "SELECT informace FROM info_blob WHERE id = " + idBlob.ToString();
    //                byte[] data = SqlPrikaz.ExecuteScalarBlob(selectSql);
    //                if (data == null)
    //                    throw new KSProgram.Exceptions.NoticeException("Obsah dokumentu nenalezen v databázi.");

    //                KSProgram.Attachment.Send(Page, docName, data);
    //                return;
    //            }

    //            //Hledám ve sdíleném uložišti
    //            string filePath = GetNullOrData.GetString(row["sdilene_uloziste"]);
    //            if (!string.IsNullOrWhiteSpace(filePath))
    //            {
    //                filePath = filePath.Trim();
    //                byte[] data = new byte[0];
    //                try
    //                {
    //                    data = File.ReadAllBytes(filePath);
    //                }
    //                catch (Exception exc)
    //                {
    //                    throw new KSProgram.Exceptions.NoticeException("Nepodařilo se načíst. " + exc.Message);
    //                }
    //                KSProgram.Attachment.Send(Page, docName, data);
    //                return;
    //            }
    //        }
    //    }
    //}

    protected void TRadGridPrukazyVzdel_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable table = GetData();
        TRadGridPrukazyVzdel.DataSource = table;
    }


    private static DataTable GetData()
    {
        //return SqlPrikaz.ExecuteCommand("SELECT id, text_osve, cis_prukazu, vydal, dat_vydani, platnost_do, os_cislo, naz_prukazu, vazba_osve, poznamka, typ_prukazu, id_blob, nazev_soubor, sdilene_uloziste FROM prukazy, sko_cisl WHERE os_cislo = " + SqlPrikaz.ValueToString(Globals.OsCislo) + " AND vazba_osve = 1 AND prukazy.cis_osve = sko_cisl.cislo AND portal = 'p'");
        //9.4.2018
        ParametryPrikazu pars = new ParametryPrikazu() { new KSParameter("os_cislo", DbType.Decimal, Globals.OsCislo) };
        DataTable table = SqlPrikaz.ExecuteCommand(
            "SELECT p.id, c.text_osve, p.cis_prukazu, p.vydal, p.dat_vydani, p.platnost_do, p.os_cislo, p.naz_prukazu, p.vazba_osve, p.poznamka, p.typ_prukazu, p.id_blob, p.nazev_soubor, p.sdilene_uloziste " +
            "FROM prukazy p " +
            "LEFT OUTER JOIN sko_cisl c ON c.cislo = p.cis_osve " +
            "WHERE p.os_cislo = @os_cislo " +
            "AND p.vazba_osve = 1 " +
            "AND p.portal = 'p'", true, ref pars);
        foreach(DataRow r in table.Rows)
        {
            if (r["text_osve"]!=DBNull.Value)
            {
                r["text_osve"] = Slovnik.GetPreklad(Convert.ToString(r["text_osve"]));
            }
        }
        return table;
    }

    protected void TRadGridPrukazyVzdel_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if(e.CommandName == "get_file")
        {
            GridDataItem item = (GridDataItem)e.Item;
            Int32? id_blob = GetNullOrData.GetInt32(item.GetDataKeyValue("id_blob"));
            string nazev_soubor = GetNullOrData.GetString(item.GetDataKeyValue("nazev_soubor"));
            nazev_soubor = string.IsNullOrEmpty(nazev_soubor) ? "Doklad" : nazev_soubor;

            //Načítán data z blobu
            if (id_blob.HasValue && id_blob > 0)
            {
                string selectSql = "SELECT informace FROM info_blob WHERE id = " + id_blob.ToString();
                byte[] data = SqlPrikaz.ExecuteScalarBlob(selectSql);
                if (data == null)
                    throw new KSProgram.Exceptions.NoticeException("Obsah dokumentu nenalezen v databázi");

                Attachment.Send(Page, nazev_soubor, data);
                return;
            }

            //Hledám ve sdíleném uložišti
            string sdilene_uloziste = GetNullOrData.GetString(item.GetDataKeyValue("sdilene_uloziste"));
            if (!string.IsNullOrWhiteSpace(sdilene_uloziste))
            {
                sdilene_uloziste = sdilene_uloziste.Trim();
                byte[] data = new byte[0];
                try
                {
                    data = File.ReadAllBytes(sdilene_uloziste);
                }
                catch (Exception exc)
                {
                    throw new KSProgram.Exceptions.NoticeException("Nepodařilo se načíst doklad" + exc.Message);
                }
                Attachment.Send(Page, nazev_soubor, data);
                return;
            }
        }
    }
}
