﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Data;
using KSProgram;
using System.Collections.Generic;
using KSProgram.Funkce;
using KSProgram.WebControlsAlone;
using KSProgram.Pozadavky;
using KSProgram.Dochazka;
using KSProgram.Extensions;

public partial class Zamestnanec_SendMail : TPage
{
    public Zamestnanec_SendMail()
    {
        IdPrava = 95;
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            list_SelectedIndexChanged(new object(), new EventArgs());
            ObdobiText obdobi=(ObdobiText)FindControlRecursive("obdobi", PanelHl.Controls);
            obdobi.SetDefaultObdobi(Globals.AktObdobiDochazka);
        }
    }
    protected void list_SelectedIndexChanged(object sender, EventArgs e)
    {
        RadioButtonList list = (RadioButtonList)FindControlRecursive("list", PanelHl.Controls);
        if (list.SelectedValue == "v")
        {
            ((WebControl)FindControlRecursive("Panel1")).Style.Add(HtmlTextWriterStyle.Display, "block");
            ((WebControl)FindControlRecursive("Panel2")).Style.Add(HtmlTextWriterStyle.Display, "none");
            ((CustomValidator)FindControlRecursive("RequiredFieldValidator3")).Enabled=true;
        }
        else if (list.SelectedValue == "d")
        {
            ((CustomValidator)FindControlRecursive("RequiredFieldValidator3")).Enabled=false;
            ((WebControl)FindControlRecursive("Panel1")).Style.Add(HtmlTextWriterStyle.Display, "none");
            ((WebControl)FindControlRecursive("Panel2")).Style.Add(HtmlTextWriterStyle.Display, "block");
        }
    }
    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {
        Validate();
        if (!Page.IsValid)
            return;
        string typ="";
        //zjistím adresáta
        //MultiView mv = (MultiView)FindControlRecursive("mv");
        RadioButtonList list = (RadioButtonList)FindControlRecursive("list");
        string email="";
        string stav = "";
        List<string> emlist=new List<string>();
        if (list.SelectedValue == "v")
        {
            email = ((TextBox)FindControlRecursive("adresat")).Text;
            if (email==null) email=""; else email=email.Trim();
            if (email.Length > 0)
            {
                string[] ar = email.Split(';');
                emlist.AddRange(ar);
                //if (email.Length > 0) emlist.Add(email);
            }

        }
        else if (list.SelectedValue == "d")
        {
            DateTime obdobi = ((ObdobiText)FindControlRecursive("obdobi")).SelectedValue;
            DateTime posledni = obdobi.PosledniDen();
            typ = "dochazka";
            using (IDataReader reader = SqlPrikaz.ExecuteReader
            (
            "select os_cislo, kmen_str from pracovnici "+
            " where and datum_nastupu<="+SqlPrikaz.ValueToString(posledni)+
            " and (datum_vystupu IS NULL OR datum_vystupu>=" + SqlPrikaz.ValueToString(obdobi) + ")" + DochazkaFunkce.Dch_vse_podminka(" and doch_karta='a' ")
            ))
            {
                while (reader.Read())
                {
                    decimal os_cislo = reader.GetDecimal(0);
                    string kmen_str = reader.GetString(1);
                    if (Globals.RadkovePrava.Pravo(os_cislo, kmen_str))
                    {
                        //zjistím jestli má uzavřenu docházku
                        //Prac_pom pp = new Prac_pom();
                        short cislo_pom = Prac_pom.Platny_Pomer(os_cislo, obdobi);
                        int id_poz = 0;
                        if (Pozadavek.Exists(os_cislo,cislo_pom, typ, obdobi, ref stav, ref id_poz))
                        {
                            if (stav == "novy")
                            {
                                email = Pracovnik.GetEmailDoPrace(os_cislo);
                                emlist.Add(email);
                            }
                        }
                        else
                        {
                            email = Pracovnik.GetEmailDoPrace(os_cislo);
                            emlist.Add(email);
                        }
                    }
                }
            }
        }

        bool chyba = false;
        bool send = false;
        string subject = ((TextBox)FindControlRecursive("predmet")).Text;
        string telo = ((TextBox)FindControlRecursive("telo")).Text;
        if ((subject.Length>0)&&(telo.Length>0))
        foreach (string em in emlist)
        {
            if (!string.IsNullOrEmpty(em))
            {
                KSProgram.Email.TMailMessage mess = new KSProgram.Email.TMailMessage(em, subject, telo, VariantaMailu.Info);
                try
                {
                    mess.Send();
                    send = true;
                }
                catch { chyba = true; }
            }
        }
        if (chyba)
            ((Label)FindControlRecursive("protokol")).Text = "Při odesílání zprávy nastala chyba";
        else
            if (send)
                ((Label)FindControlRecursive("protokol")).Text = "Zpráva byla úspěšně odeslána";
            else
                ((Label)FindControlRecursive("protokol")).Text = "Zpráva nebyla odeslána";

    }
    protected void TLinkButton2_Command(object sender, CommandEventArgs e)
    {
        ((TextBox)FindControlRecursive("adresat")).Text="";
        ((TextBox)FindControlRecursive("telo")).Text="";
        ((TextBox)FindControlRecursive("predmet")).Text="";
        ((Label)FindControlRecursive("protokol")).Text = "";
    }
    protected void RequiredFieldValidator3_ServerValidate(object source, ServerValidateEventArgs args)
    {
        args.IsValid = !string.IsNullOrEmpty(args.Value);
    }
    protected void RequiredFieldValidator1_ServerValidate(object source, ServerValidateEventArgs args)
    {
        args.IsValid= !string.IsNullOrEmpty(args.Value);
    }
    protected void RequiredFieldValidator2_ServerValidate(object source, ServerValidateEventArgs args)
    {
        args.IsValid = !string.IsNullOrEmpty(args.Value);
    }
}
