﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram;
using KSProgram.Vzdelavani;
using Telerik.Web.UI;
using KSProgram.WebControls;

public partial class Zamestnanec_SkolAkcePrihl : TPageZam
{
    public Zamestnanec_SkolAkcePrihl()
    {
        IdPrava = 53;
        this.HelpURL = "Vzd%C4%9Bl%C3%A1v%C3%A1n%C3%AD_%28KS_port%C3%A1l%29";
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
    }

    protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        SkoliciAkce akce = new SkoliciAkce();
        TRadGrid1.DataSource = akce.Prihlasovani();
    }

    protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
    {
        TRadButton TRB_ch = (TRadButton)sender;
        if (TRB_ch.Checked)
        {
            TRadGrid1.AllowFilteringByColumn = true;
        }
        else
        {
            TRadGrid1.AllowFilteringByColumn = false;
        }
        TRadGrid1.Rebind();
    }

    protected void RadButton2_ToggleStateChanged(object sender, ButtonToggleStateChangedEventArgs e)
    {
        string cislo = ((RadButton)sender).CommandArgument;
        int cisloAkce = Convert.ToInt32(cislo);
        bool _checked = Convert.ToBoolean(e.SelectedToggleState.Value);
        if (_checked)
        {
            int ret = SkoliciAkce.Prihlasit(cisloAkce, Globals.OsCislo);
            if (ret != 1)
            {
                string title = WebControlHelper.ZmenaTextu("[%Přihlášení neproběhlo%]");
                string mess = "";
                switch (ret)
                {
                    case 0: mess = String.Format(WebControlHelper.ZmenaTextu("[%Ke školící akci {0} jste již jednou přihlášen/a%]"), cisloAkce); break;
                    case -1: mess = String.Format(WebControlHelper.ZmenaTextu("[%Školící akce {0} je již plně obsazena%]"), cisloAkce); break;
                }
                MessageBox.Alert(this.Page, mess, title, null, null, null);
            }
        }
        else
        {
            SkoliciAkce.Odhlasit(cisloAkce, Globals.OsCislo);
        }
        TRadGrid1.Rebind();
    }

    protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item.ItemType == GridItemType.CommandItem)
        {
            TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
            but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;
        }

    }

    protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.ExpandCollapseCommandName && e.Item is GridDataItem)
        {
            RadGrid grid = (RadGrid)((GridDataItem)e.Item).ChildItem.FindControl("TRadGrid2");
            ObjectDataSource source = (ObjectDataSource)((GridDataItem)e.Item).ChildItem.FindControl("ODS_ObsahAkce");
            if (grid != null)
            {
                if (grid.DataSourceID == "")
                {
                    grid.DataSourceID = "ODS_ObsahAkce";
                    grid.DataBind();
                }
            }
        }
    }

    protected void ODS_dokument_Selected(object sender, ObjectDataSourceStatusEventArgs e)
    {
        if (!string.IsNullOrEmpty((string)e.OutputParameters["error"]))
        {
            MessageBox.Alert(this.Page, (string)e.OutputParameters["error"], (string)e.OutputParameters["errortit"], 600, 400, "");
        }
    }

    //protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    //{
    //    if (e.Item.ItemType == GridItemType.GroupHeader && !IsPostBack)
    //    {
    //        GridGroupHeaderItem item = (GridGroupHeaderItem)e.Item;
    //        if (item.CanExpand)
    //        {
    //            item.Expanded = false;
    //        }
    //    }
    //}

    //protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    //{
    //    if (e.CommandName == RadGrid.ExpandCollapseCommandName && e.Item is GridDataItem)
    //    {
    //        ((GridDataItem)e.Item).ChildItem.FindControl("InnerContainer").Visible =
    //            !e.Item.Expanded;
    //    }
    //}

    //protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    //{
    //    if (e.Item is GridNestedViewItem)
    //    {
    //        e.Item.FindControl("InnerContainer").Visible = ((GridNestedViewItem)e.Item).ParentItem.Expanded;
    //    }
    //}


    //protected void LB_Prihlasit_Click(object sender, EventArgs e)
    //{
    //    string cislo = ((LinkButton)sender).CommandArgument;
    //    int cisloAkce = Convert.ToInt32(cislo);
    //    SkoliciAkce.Prihlasit(cisloAkce, Globals.OsCislo);
    //    TDataList1.DataBind();
    //}
    //protected void LB_Odhlasit_Click(object sender, EventArgs e)
    //{
    //    string cislo = ((LinkButton)sender).CommandArgument;
    //    int cisloAkce = Convert.ToInt32(cislo);
    //    SkoliciAkce.Odhlasit(cisloAkce, Globals.OsCislo);
    //    TDataList1.DataBind();
    //}
    //protected void TDataList1_ItemDataBound(object sender, DataListItemEventArgs e)
    //{
    //    if (e.Item.ItemIndex >= 0)
    //    {
    //        ObjectDataSource ods = (ObjectDataSource)e.Item.FindControl("ODS_ObsahAkce");
    //        if (ods != null)
    //        {
    //            ods.SelectParameters[0].DefaultValue = TDataList1.DataKeys[e.Item.ItemIndex].ToString();
    //        }
    //    }
    //}
}
