﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram;

public partial class Zamestnanec_SprBezneUcty : TPageZam
{
    private decimal _castka = 0;

    public Zamestnanec_SprBezneUcty()
    {
        IdPrava = 104;
        this.HelpURL = "Soci%C3%A1ln%C3%AD_program_%28KS_port%C3%A1l%29";  
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        if (!Zakaznik.HasModul(AppModul.SocialniProgram))
        {
            throw new KSProgram.Exceptions.NoticeException("Nemáte povolen modul 'Sociální program'.");
        }

        base.Page_Load(sender, e);
    }
    protected void TGV_transakce_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        //sumace údajů
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            string pom = DataBinder.Eval(e.Row.DataItem, "castka").ToString();
            _castka += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[1].Font.Bold = true;
            e.Row.Cells[1].Text = "Celkem";
            e.Row.Cells[2].Text = _castka.ToString();
        }
    }
    protected void TGV_ucty_SelectedIndexChanged(object sender, EventArgs e)
    {
        TGV_transakce.Visible = true;
    }
    protected void TGV_ucty_DataBound(object sender, EventArgs e)
    {
        TGV_ucty.SelectedIndex = -1;
        TGV_transakce.Visible = false;
    }
}
