﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.WebControls;
using KSProgram.Data;
using System.Text;
using KSProgram;
using System.IO;
using System.Threading;
using System.Security.Cryptography;
using KSProgram.Obecne;
using Telerik.Web.UI;
using KSProgram.Dokument;
using System.Linq;
using KSProgram.Exceptions;

public partial class Zamestnanec_VyplatniListek : TPageZam
{
    public int iX = 0;
    public int iY = 0;


    public Zamestnanec_VyplatniListek()
    {
        IdPrava = 51;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "V%C3%BDplatn%C3%AD_l%C3%ADstek_%28KS_port%C3%A1l%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        Response.Buffer = true;

        base.Page_Load(sender, e);
        TempDirectory.DeleteOldFiles(20, "*-pdf01.pdf");
        if (!IsPostBack)
        {
            //VyberRoku1.Rok = Globals.AktObdobi.Year;
            tradrok_vyber.SelectedYear = Globals.AktObdobi.Year;
            //TLinkButton1.Visible = false;
            TLinkButton2.Visible = false;
            LinkButton2.Visible = false;

            //49610// bobf 16.3.2020
            //if (Zakaznik.IsCurrent("KRAJ_VYSOCINA") || Zakaznik.IsCurrent("SENAT") || Zakaznik.IsCurrent("BLANKYT_VZOR")) //PR 23.6.2015 HID=29195
            //{
            //    //MultiView1.ActiveViewIndex=1;
            //    Panel1.Visible = false;
            //    Panel_heslo.Visible = true;
            //}         
            if (Zakaznik.IsCurrent("KRAJ_VYSOCINA") || Zakaznik.IsCurrent("SENAT") || Zakaznik.IsCurrent("BLANKYT_VZOR") || Globals.RAActive("PIN_PRO_VYPLATNI_LISTKY")) // bobf 04.05.2020 doplněno rozšíření aplikace HID 51147 //PR 23.6.2015 HID=29195
            {
                //MultiView1.ActiveViewIndex=1;
                Panel1.Visible = false;
                Panel_heslo.Visible = true;
            }
            else
            {
                tgv_SeznamVyplatnichListku.DataSourceID = "ds_SeznamVyplatnichListku";
                tgv_SeznamVyplatnichListku.DataBind();
            }
            //49610//
        }
    }

    protected void tgv_SeznamVyplatnichListku_SelectedIndexChanged(object sender, EventArgs e)
    {
        TGridView grid = (TGridView)sender;
        if (grid == null) return;
        string SCp1250 = NactiRetezec(grid);

        HtmlControl panel = (HtmlControl)this.FindControlRecursive("textpom");
        string chyba = "<pre>" + SCp1250 + "</pre>";
        LiteralControl text = new LiteralControl(chyba);
        panel.Controls.Add(text);
    }

    protected void tgv_SeznamVyplatnichListku_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "zmena")
        {
            int pom = Convert.ToInt32(e.CommandArgument);
            if (pom > -1)
            {
                tgv_SeznamVyplatnichListku.SelectedIndex = pom;
                tgv_SeznamVyplatnichListku_SelectedIndexChanged(tgv_SeznamVyplatnichListku, EventArgs.Empty);
            }
        }
    }

    protected void tgv_SeznamVyplatnichListku_RowCreated(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            LinkButton link = (LinkButton)e.Row.FindControl("LinkButton1");
            link.CommandArgument = e.Row.RowIndex.ToString();
            link.CommandName = "zmena";
        }
    }

    /// <summary>
    /// Vytvoření PDF verze
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {
        TGridView grid = tgv_SeznamVyplatnichListku;

        if (grid.SelectedIndex > -1)
        {

            object zp = grid.SelectedDataKey[2];
            object codepage = grid.SelectedDataKey[1];
            object dk = grid.SelectedDataKey[0];
            int zip = 0;
            if (!((zp == null) || (zp == DBNull.Value))) zip = Convert.ToInt32(zp);
            int id = Convert.ToInt32(dk);
            string fileName = "Výplatní_lístek";

            //u3417//
            //DateTime? obdobi = SqlPrikaz.ExecuteScalarDateTime("select obdobi from archiv_vl where id = " + id);
            DateTime? obdobi = null;
            decimal? osCislo = null;
            IDataReader idrListek = null;
            idrListek = SqlPrikaz.ExecuteReader("select os_cislo,obdobi from archiv_vl where id = " + id);
            if (idrListek.Read())
            {
                osCislo = GetNullOrData.GetDecimal(idrListek, "os_cislo", 0); // MiKo Přepsáno na decimal
                obdobi = GetNullOrData.GetDateTime(idrListek, "obdobi", DateTime.MinValue);
            }
            // Pokud os. číslo není nastaveno nebo je rozdílné od aktuálně nastaveného os. čísla odcházím.
            // Neporovnává se s os. číslem přihlášeného protože může existovat varianta kdy přihlášený může vidět jiné výpl. lístky.
            osCislo = 2;
            if (osCislo < 1 || osCislo != Globals.OsCislo) return;
            //u3417//

            if (obdobi != null)
            {
                fileName = string.Format("Výplatní_lístek_{0:MM}-{0:yyyy}", obdobi);
            }

            if (zip == 1)
            { fileName += ".zip"; }
            else
            {
                if (codepage.ToString().Trim() == "XPS") { fileName += ".xps"; }
                else { fileName += ".pdf"; }
            }

            if (codepage.ToString().Trim() == "PDF" || zip.ToString().Trim() == "1")
            {
                //v archivu je PDF
                byte[] data = KSProgram.Obecne.BlobToPdf.VyplatniListek(id);
                if (data == null) return;
                Attachment.Send(this, fileName, data);
            }
            else if (codepage.ToString().Trim() == "XPS" || zip.ToString().Trim() == "1")
            {
                //v archivu je XPS
                byte[] data = KSProgram.Obecne.BlobToPdf.VyplatniListek(id);
                if (data == null) return;

                Attachment.Send(this, fileName, data);
            }
            else
            {
                // v archivu je textový řetězec
                //*****************************

                //načtu řetězec blobu
                string SCp1250 = NactiRetezec(grid);

                //vytvořím pole jednotlivých řádků
                string[] Oddelovac = new string[1];
                Oddelovac[0] = "\r\n";
                string[] Radkovany = SCp1250.Split(Oddelovac, StringSplitOptions.None);

                ////VYTVOŘENÍ pdf SOUBORU pomoci KSprogram.Dokument
                byte[] data = PDF.GetVyplatniListek(Radkovany.ToList());

                if (Zakaznik.IsCurrent("KRAJ_VYSOCINA") || Zakaznik.IsCurrent("SENAT") || Zakaznik.IsCurrent("BLANKYT_VZOR") || Globals.RAActive("PIN_PRO_VYPLATNI_LISTKY"))// bobf 04.05.2020 doplněno rozšíření aplikace //PR 28.11.2014 
                    KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'R', "Zobrazen výplatní lístek", "os_cislo=" + Globals.OsCislo + " and obdobi=" + SqlPrikaz.ValueToString(obdobi));

                Attachment.Send(this, fileName, data);
            }
        }
    }




    //    namespace TestPdf


    //tomášův pokusný skript z testovacího projektu 



    //{
    //    internal class Program
    //    {
    //        private static string _temp_path = Path.Combine(Path.GetTempPath(), "TestPdf");

    //        private static void Main(string[] args)
    //        {
    //            Program m = new Program();
    //            m.Encrypt();
    //        }

    //        private void EncryptByFile()
    //        {
    //            string dec_heslo = "Heslo";
    //            string inputNazev = "ZdrojTestu.pdf";
    //            string outputNazev = "VysledekFile" + DateTime.Now.Ticks.ToString() + ".pdf";

    //            if (dec_heslo != null)
    //            {
    //                using (
    //                    Stream input =
    //                        new FileStream(Path.Combine(_temp_path, inputNazev),
    //                            FileMode.Open, FileAccess.ReadWrite,
    //                            FileShare.Delete))
    //                using (
    //                    Stream output_s =
    //                        new FileStream(Path.Combine(_temp_path, outputNazev),
    //                            FileMode.Create, FileAccess.Write,
    //                            FileShare.Delete))
    //                {
    //                    PdfReader reader = new PdfReader(input);
    //                    if (dec_heslo != null)
    //                    {
    //                        PdfEncryptor.Encrypt(reader, output_s, true,
    //                            dec_heslo,
    //                            dec_heslo,
    //                            PdfWriter.ALLOW_PRINTING);
    //                        input.Close();
    //                        output_s.Close();
    //                    }
    //                    byte[] prilohaContent = File.ReadAllBytes(Path.Combine(_temp_path, outputNazev));

    //                }
    //            }
    //        }

    //        private void EncryptMemory()
    //        {
    //            string dec_heslo = "Heslo";
    //            string inputNazev = "ZdrojTestu.pdf";
    //            string outputNazev = "VysledekMemory" + DateTime.Now.Ticks.ToString() + ".pdf";
    //            if (dec_heslo != null)
    //            {
    //                using (
    //                    Stream input =
    //                        new FileStream(Path.Combine(_temp_path, inputNazev),
    //                            FileMode.Open, FileAccess.ReadWrite,
    //                            FileShare.Delete))
    //                {
    //                    byte[] prilohaContent = new byte[input.Length];

    //                    using (
    //                        Stream output_s = new MemoryStream(prilohaContent, 0, (int)input.Length))

    //                    {
    //                        PdfReader reader = new PdfReader(input);
    //                        if (dec_heslo != null)
    //                        {
    //                            PdfEncryptor.Encrypt(reader, output_s, true,
    //                                dec_heslo,
    //                                dec_heslo,
    //                                PdfWriter.ALLOW_PRINTING);
    //                            input.Close();
    //                            output_s.Close();
    //                        }

    //                        File.WriteAllBytes(Path.Combine(_temp_path, outputNazev), prilohaContent);

    //                    }
    //                }
    //            }
    //        }


    //        private void Encrypt()
    //        {
    //            string dec_heslo = "Heslo";
    //            string inputNazev = "ZdrojTestu.pdf";
    //            string outputNazev = "VysledekOnlyMemory" + DateTime.Now.Ticks.ToString() + ".pdf";
    //            byte[] inputBytes = File.ReadAllBytes(Path.Combine(_temp_path, inputNazev));

    //            if (dec_heslo != null)
    //            {
    //                {
    //                    byte[] prilohaContent = new byte[inputBytes.Length];

    //                    using (
    //                        Stream output_s = new MemoryStream(prilohaContent, 0, (int)inputBytes.Length))

    //                    {
    //                        PdfReader reader = new PdfReader(inputBytes);
    //                        if (dec_heslo != null)
    //                        {
    //                            PdfEncryptor.Encrypt(reader, output_s, true,
    //                                dec_heslo,
    //                                dec_heslo,
    //                                PdfWriter.ALLOW_PRINTING);
    //                            output_s.Close();
    //                        }

    //                        File.WriteAllBytes(Path.Combine(_temp_path, outputNazev), prilohaContent);

    //                    }
    //                }
    //            }
    //        }
    //    }
    //}







    /// <summary>
    /// Vytvoření řádkovaného řetězce textového výplatního lístku
    /// </summary>
    /// <param name="grid"></param>
    /// <returns></returns>
    protected string NactiRetezec(TGridView grid)
    {
        string SCp1250 = "";
        object dk = grid.SelectedDataKey[0];
        object cp = grid.SelectedDataKey[1];
        object zp = grid.SelectedDataKey[2];
        int id = Convert.ToInt32(dk);

        //u3417//
        //DateTime? obdobi = SqlPrikaz.ExecuteScalarDateTime("select obdobi from archiv_vl where id = " + id);
        DateTime? obdobi = null;
        decimal? osCislo = null;
        IDataReader idrListek = null;
        idrListek = SqlPrikaz.ExecuteReader("select os_cislo,obdobi from archiv_vl where id = " + id);
        if (idrListek.Read())
        {
            //osCislo = GetNullOrData.GetInt16(idrListek, "os_cislo", 0); //MiKo:51956 - Bez znalosti kontextu přepisuji na GetDecimal
            osCislo = GetNullOrData.GetDecimal(idrListek, "os_cislo", 0);
            obdobi = GetNullOrData.GetDateTime(idrListek, "obdobi", DateTime.MinValue);
        }
        // Pokud os. číslo není nastaveno nebo je rozdílné od aktuálně nastaveného os. čísla odcházím.
        // Neporovnává se s os. číslem přihlášeného protože může existovat varianta kdy přihlášený může vidět jiné výpl. lístky.        if (osCislo < 1 || osCislo != Globals.OsCislo) return "chyba: Lístek nenalezen."; ;
        //u3417//
        if (obdobi == null) return "chyba: Lístek nenalezen.";

        TRPV_VyplatniListekViewer.Visible = false;

        if (zp.ToString().Trim() == "1")
        {

            LinkButton2.Visible = false;
            //TLinkButton1.Visible = true;
            //TLinkButton1.Text = WebControlHelper.ZmenaTextu("[%ZIP formát%]");
            TLinkButton2.Visible = true;
            TLinkButton2.Text = WebControlHelper.ZmenaTextu("[%ZIP formát%]");
            //vytvořím pole jednotlivých řádků
            SCp1250 = "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 = ReadGlobalResource.ZmenaTextu("[%Tato položka obsahuje výplatní lístek ve formátu ZIP.%]") + "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%V případě, že výplatní lístek nelze otevřít přímo,%]");
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%uložte jej a teprve potom otevřete.%]");

            return SCp1250;

        }
        if (cp.ToString().Trim() == "PDF")
        {

            LinkButton2.Visible = false;
            //TLinkButton1.Visible = true;
            //TLinkButton1.Text = WebControlHelper.ZmenaTextu("[%PDF Formát%]");
            TLinkButton2.Visible = true;
            TLinkButton2.Text = WebControlHelper.ZmenaTextu("[%PDF Formát%]");
            //vytvořím pole jednotlivých řádků
            SCp1250 = "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 = ReadGlobalResource.ZmenaTextu("[%Tato položka obsahuje výplatní lístek ve formátu PDF.%]");
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%V případě, že výplatní lístek nelze otevřít přímo,%]");
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%uložte jej a teprve potom otevřete.%]");


            try
            {
                ShowPDF(id);
            }
            catch
            {
                TRPV_VyplatniListekViewer.Visible = false;
            }
            
            return SCp1250;

        }
        else if (cp.ToString().Trim() == "XPS")
        {

            LinkButton2.Visible = false;
            //TLinkButton1.Visible = true;
            //TLinkButton1.Text = WebControlHelper.ZmenaTextu("[%XPS Formát%]");
            TLinkButton2.Visible = true;
            TLinkButton2.Text = WebControlHelper.ZmenaTextu("[%XPS Formát%]");
            //vytvořím pole jednotlivých řádků
            SCp1250 = "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 = ReadGlobalResource.ZmenaTextu("[%Tato položka obsahuje výplatní lístek ve formátu XPS.%]") + "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%V případě, že výplatní lístek nelze otevřít přímo,%]");
            SCp1250 += "\r\n";
            SCp1250 += ReadGlobalResource.ZmenaTextu("[%uložte jej a teprve potom otevřete.%]");


            return SCp1250;

        }
        else
        {
            //TLinkButton1.Text = WebControlHelper.ZmenaTextu("[%PDF Formát%]");
            TLinkButton2.Text = WebControlHelper.ZmenaTextu("[%PDF Formát%]");

            //pokud je výplatní lístek zazipovaný, tak ho rozbalím 
            int zip = 0;
            if (!((zp == null) || (zp == DBNull.Value))) zip = Convert.ToInt32(zp);

            LinkButton2.Visible = true;
            //TLinkButton1.Visible = true;
            TLinkButton2.Visible = true;
            string selectSql = "SELECT informace FROM archiv_vl_blob WHERE id_vl = " + dk.ToString();

            byte[] Listek = new byte[1];
            if (zip == 1)
            {

            }
            else
            {
                Listek = SqlPrikaz.ExecuteScalarBlob(selectSql);

            };

            string chyba = "";

            if (Listek == null)
            {
                chyba = ReadGlobalResource.ZmenaTextu("[%Výplatní lístek není archivován nebo data archivovaného souboru jsou narušena!%]");
                //TLinkButton1.Visible = false;
                TLinkButton2.Visible = false;
                LinkButton2.Visible = false;
            }
            else
            {
                if (Listek.Length < 1) chyba = "Počet bytů v Listek je menší než 1";

                Encoding cp1250 = Encoding.GetEncoding(1250);
                Encoding cp852 = Encoding.GetEncoding(852);

                //tímto 
                bool uni = false;
                for (int i = 0; i < Listek.Length; i++)
                {
                    int cislo_znaku = Listek[i];

                    if (cislo_znaku == 0)
                    {
                        uni = true;
                        break;
                    }

                }

                if (uni)
                {
                    Encoding ascii = Encoding.ASCII;
                    Encoding unicode = Encoding.Unicode;

                    SCp1250 = unicode.GetString(Listek);
                    if (Listek == null) chyba = "Listek po konverzi z Unicode je NULL";
                    if (Listek.Length < 1) chyba = "Listek po konverzi z Unicode je < 1";
                }
                else
                {
                    string ppp = cp.ToString();
                    if (ppp.Trim() == "852")
                    {
                        Listek = Encoding.Convert(cp852, cp1250, Listek);
                        if (Listek == null) chyba = "Listek po konverzi z CP852 je NULL";
                        if (Listek.Length < 1) chyba = "Listek po konverzi z CP852 je < 1";
                    }

                    SCp1250 = cp1250.GetString(Listek);
                    if (SCp1250 == "") chyba = "Hodnota konvertovaná z Listek do 1250 je prázdná";
                    if (SCp1250 == null || SCp1250 == "") chyba = "Hodnota konvertovaná z Listek do 1250 je NULL";
                }
                if ((Zakaznik.IsCurrent("KRAJ_VYSOCINA") || Zakaznik.IsCurrent("SENAT")) && String.IsNullOrEmpty(chyba))//PR 28.11.2014 
                    KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'R', "Zobrazen výplatní lístek", "os_cislo=" + Globals.OsCislo + " and obdobi=" + SqlPrikaz.ValueToString(obdobi));

            }
            //chyba = chyba + "";
            if (chyba.Trim() != "") SCp1250 = chyba;
            return SCp1250;
        }
    }

    protected void tgv_SeznamVyplatnichListku_DataBound(object sender, EventArgs e)
    {
        TGridView grid = (TGridView)sender;
        if (grid == null) return;
        if (grid.Rows.Count <= 0 || grid.SelectedRowIndex < 0)
        {
            LinkButton2.Visible = false;
            //TLinkButton1.Visible = false;
            TLinkButton2.Visible = false;
            NeniVybran();
            TRPV_VyplatniListekViewer.Visible = false;
        }
        else
        {
            LinkButton2.Visible = true;
            //TLinkButton1.Visible = true;
            TLinkButton2.Visible = true;
        }
    }

    protected void NeniVybran()
    {
        HtmlControl panel = (HtmlControl)this.FindControlRecursive("textpom");
        string chyba = "<pre>"+ ReadGlobalResource.ZmenaTextu("[%Pro zobrazení nebo tisk výplatního lístku zvolte ze seznamu.%]")+"</pre>";
        LiteralControl text = new LiteralControl(chyba);
        panel.Controls.Clear();
        panel.Controls.Add(text);
    }

    protected void RadButPassOnClick(object sender, EventArgs e)
    {
        //49740// bobf 31.01.2020 string lsHeslo = KSProgram.Personal.Poznamky.Get(Globals.OsCislo, "VYPLLIST", "Heslo");
        string lsHeslo = HashAndCrypto.HesloGet(Globals.OsCislo, 90);

        //id 40731 if ((String.IsNullOrEmpty(lsHeslo) && String.IsNullOrEmpty(VyplListekPass.Text)) || VyplListekPass.Text == HashAndCrypto.CodePassword(lsHeslo, 22))
        //49740// if (VyplListekPass.Text == HashAndCrypto.CodePassword(lsHeslo, 22))
        if (VyplListekPass.Text == lsHeslo)
        {
            PassValidator.IsValid = true;
            PassValidator.Text = "";
            //49610// bobf 16.3.2020 bylo odstraněno přímo ve stránce DataSourceID="ds_SeznamVyplatnichListku" a nahrazeno
            tgv_SeznamVyplatnichListku.DataSourceID = "ds_SeznamVyplatnichListku";
            tgv_SeznamVyplatnichListku.DataBind();
            //49610//
            //MultiView1.ActiveViewIndex = 0;
            Panel1.Visible = true;
            Panel_heslo.Visible = false;
            //ViewState.Add("VyplListP", lsHeslo);
            KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'I', "Zadán správný PIN", "os_cislo=" + Globals.OsCislo);
        }
        else
        {
            if (String.IsNullOrEmpty(VyplListekPass.Text))
            {
                PassValidator.IsValid = false;
                PassValidator.Text = ReadGlobalResource.ZmenaTextu("[%Prázdné heslo není přípustné. Proveďte jeho nastavení.%]");
                KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'I', "Zadán prázdný PIN", "os_cislo=" + Globals.OsCislo);
            }
            else
            {
                PassValidator.IsValid = false;
                PassValidator.Text = ReadGlobalResource.ZmenaTextu("[%Nesprávné heslo%]");
                KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'I', "Zadán nesprávný PIN", "os_cislo=" + Globals.OsCislo);
            }
        }
    }

    protected void vCard_button_Click(object sender, EventArgs e)
    {
        TGridView grid = tgv_SeznamVyplatnichListku;

        // Tady někde by se mělo kontrolovat jestli osobní číslo aktuálně přihlášenho uživatele odpovídá os. číslu které je svázáno se stahovaným ID  


        if (grid.SelectedIndex > -1)
        {

            object zp = grid.SelectedDataKey[2];
            object codepage = grid.SelectedDataKey[1];
            object dk = grid.SelectedDataKey[0];
            int zip = 0;
            if (!((zp == null) || (zp == DBNull.Value))) zip = Convert.ToInt32(zp);
            int id = Convert.ToInt32(dk);
            string fileName = "Výplatní_lístek";

            //u3417//
            //DateTime? obdobi = SqlPrikaz.ExecuteScalarDateTime("select obdobi from archiv_vl where id = " + id);
            DateTime? obdobi = null;
            decimal? osCislo = null;
            IDataReader idrListek = null;
            idrListek = SqlPrikaz.ExecuteReader("select os_cislo,obdobi from archiv_vl where id = " + id);
            if (idrListek.Read())
            {
                osCislo = GetNullOrData.GetDecimal(idrListek, "os_cislo", 0); // MiKo přepsáno na decimal
                obdobi = GetNullOrData.GetDateTime(idrListek, "obdobi", DateTime.MinValue);
            }
            // Pokud os. číslo není nastaveno nebo je rozdílné od aktuálně nastaveného os. čísla odcházím.
            // Neporovnává se s os. číslem přihlášeného protože může existovat varianta kdy přihlášený může vidět jiné výpl. lístky.
            if (osCislo < 1 || osCislo != Globals.OsCislo) return;
            //u3417//

            if (obdobi != null)
            {
                fileName = string.Format("Výplatní_lístek_{0:MM}-{0:yyyy}", obdobi);
            }

            if (zip == 1)
            { fileName += ".zip"; }
            else
            {
                if (codepage.ToString().Trim() == "XPS") { fileName += ".xps"; }
                else { fileName += ".pdf"; }
            }

            if (codepage.ToString().Trim() == "PDF" || zip.ToString().Trim() == "1")
            {
                //v archivu je PDF
                byte[] data = KSProgram.Obecne.BlobToPdf.VyplatniListek(id);
                if (data == null) return;
                Attachment.Send(this, fileName, data);
            }
            else if (codepage.ToString().Trim() == "XPS" || zip.ToString().Trim() == "1")
            {
                //v archivu je XPS
                byte[] data = KSProgram.Obecne.BlobToPdf.VyplatniListek(id);
                if (data == null) return;
                Attachment.Send(this, fileName, data);
            }
            else
            {
                // v archivu je textový řetězec
                //*****************************

                //načtu řetězec blobu
                string SCp1250 = NactiRetezec(grid);

                //vytvořím pole jednotlivých řádků
                string[] Oddelovac = new string[1];
                Oddelovac[0] = "\r\n";
                string[] Radkovany = SCp1250.Split(Oddelovac, StringSplitOptions.None);

                var listek = Radkovany.ToList();
                byte[] data;
                if (listek != null && listek.Count > 0)
                {
                    data = PDF.GetVyplatniListek(listek);
                }
                else
                {
                    data = null;
                    throw new NoticeException("Nelze vytvořt lístek, kolekce řádků je prázdná");
                }

                if (Zakaznik.IsCurrent("KRAJ_VYSOCINA") || Zakaznik.IsCurrent("SENAT"))//PR 28.11.2014 
                    KSProgram.Security.AppAudit.Insert("VyplatniListek.aspx", 'R', "Zobrazen výplatní lístek", "os_cislo=" + Globals.OsCislo + " and obdobi=" + SqlPrikaz.ValueToString(obdobi));

                Attachment.Send(this, fileName, data);
            }
        }
    }

    protected void ShowPDF(int id)
    {

        byte[] data = KSProgram.Obecne.BlobToPdf.VyplatniListek(id);
        if (data == null) return;
        TRPV_VyplatniListekViewer.PdfjsProcessingSettings.FileSettings.Data = Convert.ToBase64String(data);
        TRPV_VyplatniListekViewer.Visible = true;
        


    }

}

//////////////////////////////////////////////
///////////  odkládací prostor ///////////////
//////////////////////////////////////////////

