﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Data;
using KSProgram;
using Telerik.Web.UI;
using System.IO;

namespace KSPortal.Zamestnanec
{
    public partial class ZavazkyZam : TPageZam
    {
        public ZavazkyZam()
        {
            IdPrava = 235;
            this.HelpURL = "Z%C3%A1vazky_%28KS_port%C3%A1l%29";
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string sql =
                "SELECT os_cislo, druh, dat_od, splneno, cesta_soubor, poznamka, datum_do, nazev_soubor, id_blob, sdilene_uloziste, vyrobni_cislo, inventarni_cislo " +
                "FROM zav_zam " +
                "WHERE os_cislo = @os_cislo";
            ParametryPrikazu pars = new ParametryPrikazu()
            {
                new KSParameter("os_cislo", DbType.Decimal, Globals.OsCislo)
            };
            DataTable table = SqlPrikaz.ExecuteCommand(sql, true, ref pars);
            TRadGrid1.DataSource = table;
        }

        protected void TRadGrid1_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.DownloadAttachmentCommandName)
            {
                GridDataItem dataItem = e.Item as GridDataItem;

                string fileName = GetNullOrData.GetString(dataItem.GetDataKeyValue("nazev_soubor"));
                int idBlob = GetNullOrData.GetInt32(dataItem.GetDataKeyValue("id_blob"), 0);
                string uloziste = GetNullOrData.GetString(dataItem.GetDataKeyValue("sdilene_uloziste"));

                byte[] binaryData = new byte[0];
                if (idBlob > 0)
                {
                    binaryData = SqlPrikaz.LoadByteFromInfoBlob(idBlob);
                    if (binaryData == null)
                    {
                        MessageBox.Alert(Page, "Obsah dokumentu nenalezen v databázi");
                        return;
                    }
                }
                else if (!string.IsNullOrWhiteSpace(uloziste))
                {
                    try
                    {
                        binaryData = File.ReadAllBytes(uloziste);
                    }
                    catch (Exception fileException)
                    {
                        MessageBox.Alert(Page, "Obsah dokumentu se nepodařilo načíst ze sdíleného úložiště z důvodu :" + fileException.Message);
                        return;
                    }
                }
                else
                {
                    MessageBox.Alert(Page, "Obsah dokumentu nenalezen");
                    return;
                }

                KSProgram.Attachment.Send(Page, fileName, binaryData);
            }
        }
    }
}